/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/map","fs","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","http","vs/server/node/server.main"],ve=function(ue){for(var e=[],E=0,R=ue.length;E<R;E++)e[E]=be[ue[E]];return e};define(be[95],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class E{static get(){const r=new Map,C=new Map,S=new Map,P=new Map;function w(f,p){f.has(p.detail)||f.set(p.detail,-p.timestamp)}function v(f,p){const c=f.get(p.detail);c&&(c>=0||f.set(p.detail,c+p.timestamp))}let I=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(I=ue.getStats().slice(0).sort((f,p)=>f.timestamp-p.timestamp));for(const f of I)switch(f.type){case 10:w(r,f);break;case 11:case 12:v(r,f);break;case 21:w(C,f);break;case 22:v(C,f);break;case 33:w(S,f);break;case 34:v(S,f);break;case 31:w(P,f);break;case 32:v(P,f);break}let k=0;S.forEach(f=>k+=f);function b(f){const p=[];return f.forEach((c,m)=>p.push([m,c])),p}return{amdLoad:b(r),amdInvoke:b(C),nodeRequire:b(S),nodeEval:b(P),nodeRequireTotal:k}}static toMarkdownTable(r,C){let S="";const P=[];return r.forEach((w,v)=>{P[v]=w.length}),C.forEach(w=>{w.forEach((v,I)=>{typeof v>"u"&&(v=w[I]="-");const k=v.toString().length;P[I]=Math.max(k,P[I])})}),r.forEach((w,v)=>{S+=`| ${w+" ".repeat(P[v]-w.toString().length)} `}),S+=`|
`,r.forEach((w,v)=>{S+=`| ${"-".repeat(P[v])} `}),S+=`|
`,C.forEach(w=>{w.forEach((v,I)=>{typeof v<"u"&&(S+=`| ${v+" ".repeat(P[I]-v.toString().length)} `)}),S+=`|
`}),S}}e.$U=E}),define(be[141],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function E(c,m,u){const d=R(c,m);if(d!==-1)return c[d]}e.$fb=E;function R(c,m,u=c.length-1){for(let d=u;d>=0;d--){const l=c[d];if(m(l))return d}return-1}e.$gb=R;function r(c,m){const u=C(c,m);return u===-1?void 0:c[u]}e.$hb=r;function C(c,m,u=0,d=c.length){let l=u,$=d;for(;l<$;){const h=Math.floor((l+$)/2);m(c[h])?l=h+1:$=h}return l-1}e.$ib=C;function S(c,m){const u=P(c,m);return u===c.length?void 0:c[u]}e.$jb=S;function P(c,m,u=0,d=c.length){let l=u,$=d;for(;l<$;){const h=Math.floor((l+$)/2);m(c[h])?$=h:l=h+1}return l}e.$kb=P;function w(c,m,u=0,d=c.length){const l=P(c,m,u,d);return l===c.length?-1:l}e.$lb=w;class v{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(v.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!m(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const u=C(this.e,m,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=v;function I(c,m){if(c.length===0)return;let u=c[0];for(let d=1;d<c.length;d++){const l=c[d];m(l,u)>0&&(u=l)}return u}e.$nb=I;function k(c,m){if(c.length===0)return;let u=c[0];for(let d=1;d<c.length;d++){const l=c[d];m(l,u)>=0&&(u=l)}return u}e.$ob=k;function b(c,m){return I(c,(u,d)=>-m(u,d))}e.$pb=b;function f(c,m){if(c.length===0)return-1;let u=0;for(let d=1;d<c.length;d++){const l=c[d];m(l,c[u])>0&&(u=d)}return u}e.$qb=f;function p(c,m){for(const u of c){const d=m(u);if(d!==void 0)return d}}e.$rb=p}),define(be[142],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function E(S,P){const w=Object.create(null);for(const v of S){const I=P(v);let k=w[I];k||(k=w[I]=[]),k.push(v)}return w}e.$K=E;function R(S,P){const w=[],v=[];for(const I of S)P.has(I)||w.push(I);for(const I of P)S.has(I)||v.push(I);return{removed:w,added:v}}e.$L=R;function r(S,P){const w=[],v=[];for(const[I,k]of S)P.has(I)||w.push(k);for(const[I,k]of P)S.has(I)||v.push(k);return{removed:w,added:v}}e.$M=r;function C(S,P){const w=new Set;for(const v of P)S.has(v)&&w.add(v);return w}e.$N=C}),define(be[74],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function E(S){return(P,w,v)=>{let I=null,k=null;if(typeof v.value=="function"?(I="value",k=v.value):typeof v.get=="function"&&(I="get",k=v.get),!k)throw new Error("not supported");v[I]=S(k,w)}}function R(S,P,w){let v=null,I=null;if(typeof w.value=="function"?(v="value",I=w.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(v="get",I=w.get),!I)throw new Error("not supported");const k=`$memoize$${P}`;w[v]=function(...b){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,b)}),this[k]}}e.$th=R;function r(S,P,w){return E((v,I)=>{const k=`$debounce$${I}`,b=`$debounce$result$${I}`;return function(...f){this[b]||(this[b]=w?w():void 0),clearTimeout(this[k]),P&&(this[b]=P(this[b],...f),f=[this[b]]),this[k]=setTimeout(()=>{v.apply(this,f),this[b]=w?w():void 0},S)}})}e.$uh=r;function C(S,P,w){return E((v,I)=>{const k=`$throttle$timer$${I}`,b=`$throttle$result$${I}`,f=`$throttle$lastRun$${I}`,p=`$throttle$pending$${I}`;return function(...c){if(this[b]||(this[b]=w?w():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...c)),this[p])return;const m=this[f]+S;m<=Date.now()?(this[f]=Date.now(),v.apply(this,[this[b]]),this[b]=w?w():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[f]=Date.now(),v.apply(this,[this[b]]),this[b]=w?w():void 0},m-Date.now()))}})}e.$vh=C}),define(be[11],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class E{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?l.isErrorNoTelemetry(n)?new l(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=E,e.$X=new E;function R(h){e.$X.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function r(h){if(!h||typeof h!="object")return!1;const n=h;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.$Z=r;function C(h){v(h)||e.$X.onUnexpectedError(h)}e.$1=C;function S(h){v(h)||e.$X.onUnexpectedExternalError(h)}e.$2=S;function P(h){if(h instanceof Error){const{name:n,message:i}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:n,message:i,stack:o,noTelemetry:l.isErrorNoTelemetry(h)}}return h}e.$3=P;const w="Canceled";function v(h){return h instanceof I?!0:h instanceof Error&&h.name===w&&h.message===w}e.$4=v;class I extends Error{constructor(){super(w),this.name=this.message}}e.$5=I;function k(){const h=new Error(w);return h.name=h.message,h}e.$6=k;function b(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$7=b;function f(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$8=f;class p extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=p;function c(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$0=c;class m extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=m;class u extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class l extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof l)return n;const i=new l;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=l;class $ extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(be[18],ve([1,0,11,141]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function r(Y,Z=0){return Y[Y.length-(1+Z)]}e.$sb=r;function C(Y){if(Y.length===0)throw new Error("Invalid tail call");return[Y.slice(0,Y.length-1),Y[Y.length-1]]}e.$tb=C;function S(Y,Z,B=(H,T)=>H===T){if(Y===Z)return!0;if(!Y||!Z||Y.length!==Z.length)return!1;for(let H=0,T=Y.length;H<T;H++)if(!B(Y[H],Z[H]))return!1;return!0}e.$ub=S;function P(Y,Z){const B=Y.length-1;Z<B&&(Y[Z]=Y[B]),Y.pop()}e.$vb=P;function w(Y,Z,B){return v(Y.length,H=>B(Y[H],Z))}e.$wb=w;function v(Y,Z){let B=0,H=Y-1;for(;B<=H;){const T=(B+H)/2|0,W=Z(T);if(W<0)B=T+1;else if(W>0)H=T-1;else return T}return-(B+1)}e.$xb=v;function I(Y,Z,B){if(Y=Y|0,Y>=Z.length)throw new TypeError("invalid index");const H=Z[Math.floor(Z.length*Math.random())],T=[],W=[],x=[];for(const re of Z){const fe=B(re,H);fe<0?T.push(re):fe>0?W.push(re):x.push(re)}return Y<T.length?I(Y,T,B):Y<T.length+x.length?x[0]:I(Y-(T.length+x.length),W,B)}e.$yb=I;function k(Y,Z){const B=[];let H;for(const T of Y.slice(0).sort(Z))!H||Z(H[0],T)!==0?(H=[T],B.push(H)):H.push(T);return B}e.$zb=k;function*b(Y,Z){let B,H;for(const T of Y)H!==void 0&&Z(H,T)?B.push(T):(B&&(yield B),B=[T]),H=T;B&&(yield B)}e.$Ab=b;function f(Y,Z){for(let B=0;B<=Y.length;B++)Z(B===0?void 0:Y[B-1],B===Y.length?void 0:Y[B])}e.$Bb=f;function p(Y,Z){for(let B=0;B<Y.length;B++)Z(B===0?void 0:Y[B-1],Y[B],B+1===Y.length?void 0:Y[B+1])}e.$Cb=p;function c(Y,Z,B){const H=[];function T(re,fe,ce){if(fe===0&&ce.length===0)return;const ge=H[H.length-1];ge&&ge.start+ge.deleteCount===re?(ge.deleteCount+=fe,ge.toInsert.push(...ce)):H.push({start:re,deleteCount:fe,toInsert:ce})}let W=0,x=0;for(;;){if(W===Y.length){T(W,0,Z.slice(x));break}if(x===Z.length){T(W,Y.length-W,[]);break}const re=Y[W],fe=Z[x],ce=B(re,fe);ce===0?(W+=1,x+=1):ce<0?(T(W,1,[]),W+=1):ce>0&&(T(W,0,[fe]),x+=1)}return H}e.$Db=c;function m(Y,Z,B){const H=c(Y,Z,B),T=[],W=[];for(const x of H)T.push(...Y.slice(x.start,x.start+x.deleteCount)),W.push(...x.toInsert);return{removed:T,added:W}}e.$Eb=m;function u(Y,Z,B){if(B===0)return[];const H=Y.slice(0,B).sort(Z);return l(Y,Z,H,B,Y.length),H}e.top=u;function d(Y,Z,B,H,T){return B===0?Promise.resolve([]):new Promise((W,x)=>{(async()=>{const re=Y.length,fe=Y.slice(0,B).sort(Z);for(let ce=B,ge=Math.min(B+H,re);ce<re;ce=ge,ge=Math.min(ge+H,re)){if(ce>B&&await new Promise(ye=>setTimeout(ye)),T&&T.isCancellationRequested)throw new E.$5;l(Y,Z,fe,ce,ge)}return fe})().then(W,x)})}e.$Gb=d;function l(Y,Z,B,H,T){for(const W=B.length;H<T;H++){const x=Y[H];if(Z(x,B[W-1])<0){B.pop();const re=(0,R.$kb)(B,fe=>Z(x,fe)<0);B.splice(re,0,x)}}}function $(Y){return Y.filter(Z=>!!Z)}e.$Hb=$;function h(Y){let Z=0;for(let B=0;B<Y.length;B++)Y[B]&&(Y[Z]=Y[B],Z+=1);Y.length=Z}e.$Ib=h;function n(Y,Z,B){Y.splice(B,0,Y.splice(Z,1)[0])}e.$Jb=n;function i(Y){return!Array.isArray(Y)||Y.length===0}e.$Kb=i;function o(Y){return Array.isArray(Y)&&Y.length>0}e.$Lb=o;function s(Y,Z=B=>B){const B=new Set;return Y.filter(H=>{const T=Z(H);return B.has(T)?!1:(B.add(T),!0)})}e.$Mb=s;function t(Y){const Z=new Set;return B=>{const H=Y(B);return Z.has(H)?!1:(Z.add(H),!0)}}e.$Nb=t;function a(Y,Z){return Y.length>0?Y[0]:Z}e.$Ob=a;function g(Y,Z){return Y.length>0?Y[Y.length-1]:Z}e.$Pb=g;function L(Y,Z,B=(H,T)=>H===T){let H=0;for(let T=0,W=Math.min(Y.length,Z.length);T<W&&B(Y[T],Z[T]);T++)H++;return H}e.$Qb=L;function D(Y){return[].concat(...Y)}e.$Rb=D;function y(Y,Z){let B=typeof Z=="number"?Y:0;typeof Z=="number"?B=Y:(B=0,Z=Y);const H=[];if(B<=Z)for(let T=B;T<Z;T++)H.push(T);else for(let T=B;T>Z;T--)H.push(T);return H}e.$Sb=y;function A(Y,Z,B){return Y.reduce((H,T)=>(H[Z(T)]=B?B(T):T,H),Object.create(null))}e.$Tb=A;function F(Y,Z){return Y.push(Z),()=>X(Y,Z)}e.$Ub=F;function X(Y,Z){const B=Y.indexOf(Z);if(B>-1)return Y.splice(B,1),Z}e.$Vb=X;function te(Y,Z,B){const H=Y.slice(0,Z),T=Y.slice(Z);return H.concat(B,T)}e.$Wb=te;function J(Y,Z){let B;if(typeof Z=="number"){let H=Z;B=()=>{const T=Math.sin(H++)*179426549;return T-Math.floor(T)}}else B=Math.random;for(let H=Y.length-1;H>0;H-=1){const T=Math.floor(B()*(H+1)),W=Y[H];Y[H]=Y[T],Y[T]=W}}e.$Xb=J;function ie(Y,Z){const B=Y.indexOf(Z);B>-1&&(Y.splice(B,1),Y.unshift(Z))}e.$Yb=ie;function ee(Y,Z){const B=Y.indexOf(Z);B>-1&&(Y.splice(B,1),Y.push(Z))}e.$Zb=ee;function U(Y,Z){for(const B of Z)Y.push(B)}e.$1b=U;function he(Y,Z){return Array.isArray(Y)?Y.map(Z):Z(Y)}e.$2b=he;function Q(Y){return Array.isArray(Y)?Y:[Y]}e.$3b=Q;function _(Y){return Y[Math.floor(Math.random()*Y.length)]}e.$4b=_;function V(Y,Z,B){const H=oe(Y,Z),T=Y.length,W=B.length;Y.length=T+W;for(let x=T-1;x>=H;x--)Y[x+W]=Y[x];for(let x=0;x<W;x++)Y[x+H]=B[x]}e.$5b=V;function G(Y,Z,B,H){const T=oe(Y,Z);let W=Y.splice(T,B);return W===void 0&&(W=[]),V(Y,T,H),W}e.$6b=G;function oe(Y,Z){return Z<0?Math.max(Z+Y.length,0):Math.min(Z,Y.length)}var le;(function(Y){function Z(W){return W<0}Y.isLessThan=Z;function B(W){return W<=0}Y.isLessThanOrEqual=B;function H(W){return W>0}Y.isGreaterThan=H;function T(W){return W===0}Y.isNeitherLessOrGreaterThan=T,Y.greaterThan=1,Y.lessThan=-1,Y.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function se(Y,Z){return(B,H)=>Z(Y(B),Y(H))}e.$7b=se;function $e(...Y){return(Z,B)=>{for(const H of Y){const T=H(Z,B);if(!le.isNeitherLessOrGreaterThan(T))return T}return le.neitherLessOrGreaterThan}}e.$8b=$e;const z=(Y,Z)=>Y-Z;e.$9b=z;const q=(Y,Z)=>(0,e.$9b)(Y?1:0,Z?1:0);e.$0b=q;function O(Y){return(Z,B)=>-Y(Z,B)}e.$$b=O;class j{constructor(Z){this.g=Z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let B=this.c;for(;B<this.g.length&&Z(this.g[B]);)B++;const H=B===this.c?null:this.g.slice(this.c,B);return this.c=B,H}takeFromEndWhile(Z){let B=this.d;for(;B>=0&&Z(this.g[B]);)B--;const H=B===this.d?null:this.g.slice(B+1,this.d+1);return this.d=B,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Z=this.g[this.c];return this.c++,Z}removeLast(){const Z=this.g[this.d];return this.d--,Z}takeCount(Z){const B=this.g.slice(this.c,this.c+Z);return this.c+=Z,B}}e.$_b=j;class ne{static{this.empty=new ne(Z=>{})}constructor(Z){this.iterate=Z}forEach(Z){this.iterate(B=>(Z(B),!0))}toArray(){const Z=[];return this.iterate(B=>(Z.push(B),!0)),Z}filter(Z){return new ne(B=>this.iterate(H=>Z(H)?B(H):!0))}map(Z){return new ne(B=>this.iterate(H=>B(Z(H))))}some(Z){let B=!1;return this.iterate(H=>(B=Z(H),!B)),B}findFirst(Z){let B;return this.iterate(H=>Z(H)?(B=H,!1):!0),B}findLast(Z){let B;return this.iterate(H=>(Z(H)&&(B=H),!0)),B}findLastMaxBy(Z){let B,H=!0;return this.iterate(T=>((H||le.isGreaterThan(Z(T,B)))&&(H=!1,B=T),!0)),B}}e.$ac=ne}),define(be[96],ve([1,0,11]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function R(w,v){if(!w)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=R;function r(w,v="Unreachable"){throw new Error(v)}e.$5c=r;function C(w){if(!w)throw new E.$cb("Assertion Failed")}e.$6c=C;function S(w){if(!w()){debugger;w(),(0,E.$1)(new E.$cb("Assertion Failed"))}}e.$7c=S;function P(w,v){let I=0;for(;I<w.length-1;){const k=w[I],b=w[I+1];if(!v(k,b))return!1;I++}return!0}e.$8c=P}),define(be[75],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function E(R,r){const C=this;let S=!1,P;return function(){if(S)return P;if(S=!0,r)try{P=R.apply(C,arguments)}finally{r()}else P=R.apply(C,arguments);return P}}e.$db=E}),define(be[47],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(R){function r(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=r;const C=Object.freeze([]);function S(){return C}R.empty=S;function*P(h){yield h}R.single=P;function w(h){return r(h)?h:P(h)}R.wrap=w;function v(h){return h||C}R.from=v;function*I(h){for(let n=h.length-1;n>=0;n--)yield h[n]}R.reverse=I;function k(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=k;function b(h){return h[Symbol.iterator]().next().value}R.first=b;function f(h,n){for(const i of h)if(n(i))return!0;return!1}R.some=f;function p(h,n){for(const i of h)if(n(i))return i}R.find=p;function*c(h,n){for(const i of h)n(i)&&(yield i)}R.filter=c;function*m(h,n){let i=0;for(const o of h)yield n(o,i++)}R.map=m;function*u(...h){for(const n of h)yield*n}R.concat=u;function d(h,n,i){let o=i;for(const s of h)o=n(o,s);return o}R.reduce=d;function*l(h,n,i=h.length){for(n<0&&(n+=h.length),i<0?i+=h.length:i>h.length&&(i=h.length);n<i;n++)yield h[n]}R.slice=l;function $(h,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,h];const o=h[Symbol.iterator]();for(let s=0;s<n;s++){const t=o.next();if(t.done)return[i,R.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}R.consume=$})(E||(e.Iterable=E={}))}),define(be[76],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var r;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var C;(function(n){n.DEFAULT={allowTrailingComma:!0}})(C||(e.ParseOptions=C={}));function S(n,i=!1){let o=0;const s=n.length;let t="",a=0,g=16,L=0;function D(ie){let ee=0,U=0;for(;ee<ie;){const he=n.charCodeAt(o);if(he>=48&&he<=57)U=U*16+he-48;else if(he>=65&&he<=70)U=U*16+he-65+10;else if(he>=97&&he<=102)U=U*16+he-97+10;else break;o++,ee++}return ee<ie&&(U=-1),U}function y(ie){o=ie,t="",a=0,g=16,L=0}function A(){const ie=o;if(n.charCodeAt(o)===48)o++;else for(o++;o<n.length&&v(n.charCodeAt(o));)o++;if(o<n.length&&n.charCodeAt(o)===46)if(o++,o<n.length&&v(n.charCodeAt(o)))for(o++;o<n.length&&v(n.charCodeAt(o));)o++;else return L=3,n.substring(ie,o);let ee=o;if(o<n.length&&(n.charCodeAt(o)===69||n.charCodeAt(o)===101))if(o++,(o<n.length&&n.charCodeAt(o)===43||n.charCodeAt(o)===45)&&o++,o<n.length&&v(n.charCodeAt(o))){for(o++;o<n.length&&v(n.charCodeAt(o));)o++;ee=o}else L=3;return n.substring(ie,ee)}function F(){let ie="",ee=o;for(;;){if(o>=s){ie+=n.substring(ee,o),L=2;break}const U=n.charCodeAt(o);if(U===34){ie+=n.substring(ee,o),o++;break}if(U===92){if(ie+=n.substring(ee,o),o++,o>=s){L=2;break}switch(n.charCodeAt(o++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const Q=D(4);Q>=0?ie+=String.fromCharCode(Q):L=4;break}default:L=5}ee=o;continue}if(U>=0&&U<=31)if(w(U)){ie+=n.substring(ee,o),L=2;break}else L=6;o++}return ie}function X(){if(t="",L=0,a=o,o>=s)return a=s,g=17;let ie=n.charCodeAt(o);if(P(ie)){do o++,t+=String.fromCharCode(ie),ie=n.charCodeAt(o);while(P(ie));return g=15}if(w(ie))return o++,t+=String.fromCharCode(ie),ie===13&&n.charCodeAt(o)===10&&(o++,t+=`
`),g=14;switch(ie){case 123:return o++,g=1;case 125:return o++,g=2;case 91:return o++,g=3;case 93:return o++,g=4;case 58:return o++,g=6;case 44:return o++,g=5;case 34:return o++,t=F(),g=10;case 47:{const ee=o-1;if(n.charCodeAt(o+1)===47){for(o+=2;o<s&&!w(n.charCodeAt(o));)o++;return t=n.substring(ee,o),g=12}if(n.charCodeAt(o+1)===42){o+=2;const U=s-1;let he=!1;for(;o<U;){if(n.charCodeAt(o)===42&&n.charCodeAt(o+1)===47){o+=2,he=!0;break}o++}return he||(o++,L=1),t=n.substring(ee,o),g=13}return t+=String.fromCharCode(ie),o++,g=16}case 45:if(t+=String.fromCharCode(ie),o++,o===s||!v(n.charCodeAt(o)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=A(),g=11;default:for(;o<s&&te(ie);)o++,ie=n.charCodeAt(o);if(a!==o){switch(t=n.substring(a,o),t){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return t+=String.fromCharCode(ie),o++,g=16}}function te(ie){if(P(ie)||w(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function J(){let ie;do ie=X();while(ie>=12&&ie<=15);return ie}return{setPosition:y,getPosition:()=>o,scan:i?J:X,getToken:()=>g,getTokenValue:()=>t,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>L}}e.$8m=S;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function w(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function k(n,i){const o=[],s=new Object;let t;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function L(D,y,A,F){a.value=D,a.offset=y,a.length=A,a.type=F,a.colonOffset=void 0,t=a}try{l(n,{onObjectBegin:(D,y)=>{if(i<=D)throw s;t=void 0,g=i>D,o.push("")},onObjectProperty:(D,y,A)=>{if(i<y||(L(D,y,A,"property"),o[o.length-1]=D,i<=y+A))throw s},onObjectEnd:(D,y)=>{if(i<=D)throw s;t=void 0,o.pop()},onArrayBegin:(D,y)=>{if(i<=D)throw s;t=void 0,o.push(0)},onArrayEnd:(D,y)=>{if(i<=D)throw s;t=void 0,o.pop()},onLiteralValue:(D,y,A)=>{if(i<y||(L(D,y,A,h(D)),i<=y+A))throw s},onSeparator:(D,y,A)=>{if(i<=y)throw s;if(D===":"&&t&&t.type==="property")t.colonOffset=y,g=!1,t=void 0;else if(D===","){const F=o[o.length-1];typeof F=="number"?o[o.length-1]=F+1:(g=!0,o[o.length-1]=""),t=void 0}}})}catch(D){if(D!==s)throw D}return{path:o,previousNode:t,isAtPropertyKey:g,matches:D=>{let y=0;for(let A=0;y<D.length&&A<o.length;A++)if(D[y]===o[A]||D[y]==="*")y++;else if(D[y]!=="**")return!1;return y===D.length}}}e.$9m=k;function b(n,i=[],o=C.DEFAULT){let s=null,t=[];const a=[];function g(D){Array.isArray(t)?t.push(D):s!==null&&(t[s]=D)}return l(n,{onObjectBegin:()=>{const D={};g(D),a.push(t),t=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{const D=[];g(D),a.push(t),t=D,s=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:g,onError:(D,y,A)=>{i.push({error:D,offset:y,length:A})}},o),t[0]}e.$0m=b;function f(n,i=[],o=C.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(D){s.type==="property"&&(s.length=D-s.offset,s=s.parent)}function a(D){return s.children.push(D),D}l(n,{onObjectBegin:D=>{s=a({type:"object",offset:D,length:-1,parent:s,children:[]})},onObjectProperty:(D,y,A)=>{s=a({type:"property",offset:y,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:D,offset:y,length:A,parent:s})},onObjectEnd:(D,y)=>{s.length=D+y-s.offset,s=s.parent,t(D+y)},onArrayBegin:(D,y)=>{s=a({type:"array",offset:D,length:-1,parent:s,children:[]})},onArrayEnd:(D,y)=>{s.length=D+y-s.offset,s=s.parent,t(D+y)},onLiteralValue:(D,y,A)=>{a({type:h(D),offset:y,length:A,parent:s,value:D}),t(y+A)},onSeparator:(D,y,A)=>{s.type==="property"&&(D===":"?s.colonOffset=y:D===","&&t(y))},onError:(D,y,A)=>{i.push({error:D,offset:y,length:A})}},o);const L=s.children[0];return L&&delete L.parent,L}e.$$m=f;function p(n,i){if(!n)return;let o=n;for(const s of i)if(typeof s=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let t=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===s){o=a.children[1],t=!0;break}if(!t)return}else{const t=s;if(o.type!=="array"||t<0||!Array.isArray(o.children)||t>=o.children.length)return;o=o.children[t]}return o}e.$_m=p;function c(n){if(!n.parent||!n.parent.children)return[];const i=c(n.parent);if(n.parent.type==="property"){const o=n.parent.children[0].value;i.push(o)}else if(n.parent.type==="array"){const o=n.parent.children.indexOf(n);o!==-1&&i.push(o)}return i}e.$an=c;function m(n){switch(n.type){case"array":return n.children.map(m);case"object":{const i=Object.create(null);for(const o of n.children){const s=o.children[1];s&&(i[o.children[0].value]=m(s))}return i}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$bn=m;function u(n,i,o=!1){return i>=n.offset&&i<n.offset+n.length||o&&i===n.offset+n.length}e.$cn=u;function d(n,i,o=!1){if(u(n,i,o)){const s=n.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=i;t++){const a=d(s[t],i,o);if(a)return a}return n}}e.$dn=d;function l(n,i,o=C.DEFAULT){const s=S(n,!1);function t(se){return se?()=>se(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(se){return se?$e=>se($e,s.getTokenOffset(),s.getTokenLength()):()=>!0}const g=t(i.onObjectBegin),L=a(i.onObjectProperty),D=t(i.onObjectEnd),y=t(i.onArrayBegin),A=t(i.onArrayEnd),F=a(i.onLiteralValue),X=a(i.onSeparator),te=t(i.onComment),J=a(i.onError),ie=o&&o.disallowComments,ee=o&&o.allowTrailingComma;function U(){for(;;){const se=s.scan();switch(s.getTokenError()){case 4:he(14);break;case 5:he(15);break;case 3:he(13);break;case 1:ie||he(11);break;case 2:he(12);break;case 6:he(16);break}switch(se){case 12:case 13:ie?he(10):te();break;case 16:he(1);break;case 15:case 14:break;default:return se}}}function he(se,$e=[],z=[]){if(J(se),$e.length+z.length>0){let q=s.getToken();for(;q!==17;){if($e.indexOf(q)!==-1){U();break}else if(z.indexOf(q)!==-1)break;q=U()}}}function Q(se){const $e=s.getTokenValue();return se?F($e):L($e),U(),!0}function _(){switch(s.getToken()){case 11:{let se=0;try{se=JSON.parse(s.getTokenValue()),typeof se!="number"&&(he(2),se=0)}catch{he(2)}F(se);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return U(),!0}function V(){return s.getToken()!==10?(he(3,[],[2,5]),!1):(Q(!1),s.getToken()===6?(X(":"),U(),le()||he(4,[],[2,5])):he(5,[],[2,5]),!0)}function G(){g(),U();let se=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(se||he(4,[],[]),X(","),U(),s.getToken()===2&&ee)break}else se&&he(6,[],[]);V()||he(4,[],[2,5]),se=!0}return D(),s.getToken()!==2?he(7,[2],[]):U(),!0}function oe(){y(),U();let se=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(se||he(4,[],[]),X(","),U(),s.getToken()===4&&ee)break}else se&&he(6,[],[]);le()||he(4,[],[4,5]),se=!0}return A(),s.getToken()!==4?he(8,[4],[]):U(),!0}function le(){switch(s.getToken()){case 3:return oe();case 1:return G();case 10:return Q(!0);default:return _()}}return U(),s.getToken()===17?o.allowEmptyContent?!0:(he(4,[],[]),!1):le()?(s.getToken()!==17&&he(9,[],[]),!0):(he(4,[],[]),!1)}e.$en=l;function $(n,i){const o=S(n),s=[];let t,a=0,g;do switch(g=o.getPosition(),t=o.scan(),t){case 12:case 13:case 17:a!==g&&s.push(n.substring(a,g)),i!==void 0&&s.push(o.getTokenValue().replace(/[^\r\n]/g,i)),a=o.getPosition();break}while(t!==17);return s.join("")}e.$fn=$;function h(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$gn=h}),define(be[59],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class E{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=E}),define(be[97],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class E{static{this.Undefined=new E(void 0)}constructor(C){this.element=C,this.next=E.Undefined,this.prev=E.Undefined}}class R{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let C=this.a;for(;C!==E.Undefined;){const S=C.next;C.prev=E.Undefined,C.next=E.Undefined,C=S}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(C){return this.d(C,!1)}push(C){return this.d(C,!0)}d(C,S){const P=new E(C);if(this.a===E.Undefined)this.a=P,this.b=P;else if(S){const v=this.b;this.b=P,P.prev=v,v.next=P}else{const v=this.a;this.a=P,P.next=v,v.prev=P}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const C=this.a.element;return this.e(this.a),C}}pop(){if(this.b!==E.Undefined){const C=this.b.element;return this.e(this.b),C}}e(C){if(C.prev!==E.Undefined&&C.next!==E.Undefined){const S=C.prev;S.next=C.next,C.next.prev=S}else C.prev===E.Undefined&&C.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):C.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):C.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let C=this.a;for(;C!==E.Undefined;)yield C.element,C=C.next}}e.$3c=R}),define(be[26],ve([1,0]),function(ue,e){"use strict";var E,R,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function C(d,l,$){let h=d.get(l);return h===void 0&&(h=$,d.set(l,h)),h}e.$xc=C;function S(d){const l=[];return d.forEach(($,h)=>{l.push(`${h} => ${$}`)}),`Map(${d.size}) {${l.join(", ")}}`}e.$yc=S;function P(d){const l=[];return d.forEach($=>{l.push($)}),`Set(${d.size}) {${l.join(", ")}}`}e.$zc=P;class w{constructor(l,$){this.uri=l,this.value=$}}function v(d){return Array.isArray(d)}class I{static{this.a=l=>l.toString()}constructor(l,$){if(this[E]="ResourceMap",l instanceof I)this.b=new Map(l.b),this.c=$??I.a;else if(v(l)){this.b=new Map,this.c=$??I.a;for(const[h,n]of l)this.set(h,n)}else this.b=new Map,this.c=l??I.a}set(l,$){return this.b.set(this.c(l),new w(l,$)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,$){typeof $<"u"&&(l=l.bind($));for(const[h,n]of this.b)l(n.value,n.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=I;class k{constructor(l,$){this[R]="ResourceSet",!l||typeof l=="function"?this.a=new I(l):(this.a=new I($),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,$){this.a.forEach((h,n)=>l.call($,n,n,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class f{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,$=0){const h=this.a.get(l);if(h)return $!==0&&this.j(h,$),h.value}set(l,$,h=0){let n=this.a.get(l);if(n)n.value=$,h!==0&&this.j(n,h);else{switch(n={key:l,value:$,next:void 0,previous:void 0},h){case 0:this.h(n);break;case 1:this.g(n);break;case 2:this.h(n);break;default:this.h(n);break}this.a.set(l,n),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const $=this.a.get(l);if($)return this.a.delete(l),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,$){const h=this.e;let n=this.b;for(;n;){if($?l.bind($)(n.value,n.key,this):l(n.value,n.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const l=this,$=this.e;let h=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(h){const i={value:h.key,done:!1};return h=h.next,i}else return{value:void 0,done:!0}}};return n}values(){const l=this,$=this.e;let h=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(h){const i={value:h.value,done:!1};return h=h.next,i}else return{value:void 0,done:!0}}};return n}entries(){const l=this,$=this.e;let h=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(h){const i={value:[h.key,h.value],done:!1};return h=h.next,i}else return{value:void 0,done:!0}}};return n}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let $=this.b,h=this.size;for(;$&&h>l;)this.a.delete($.key),$=$.next,h--;this.b=$,this.d=h,$&&($.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const $=l.next,h=l.previous;if(!$||!h)throw new Error("Invalid list");$.previous=h,h.next=$}l.next=void 0,l.previous=void 0,this.e++}j(l,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(l===this.b)return;const h=l.next,n=l.previous;l===this.c?(n.next=void 0,this.c=n):(h.previous=n,n.next=h),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if($===2){if(l===this.c)return;const h=l.next,n=l.previous;l===this.b?(h.previous=void 0,this.b=h):(h.previous=n,n.next=h),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach(($,h)=>{l.push([h,$])}),l}fromJSON(l){this.clear();for(const[$,h]of l)this.set($,h)}}e.$Cc=f;class p extends f{constructor(l,$=1){super(),this.k=l,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,$=2){return super.get(l,$)}peek(l){return super.get(l,0)}set(l,$){return super.set(l,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=p;class c{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let $=this.a.get(l)||0;return $===0?!1:($--,$===0?this.a.delete(l):this.a.set(l,$),!0)}has(l){return this.a.has(l)}}e.$Ec=c;class m{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[$,h]of l)this.set($,h)}clear(){this.a.clear(),this.b.clear()}set(l,$){this.a.set(l,$),this.b.set($,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const $=this.a.get(l);return $===void 0?!1:(this.a.delete(l),this.b.delete($),!0)}forEach(l,$){this.a.forEach((h,n)=>{l.call($,h,n,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=m;class u{constructor(){this.a=new Map}add(l,$){let h=this.a.get(l);h||(h=new Set,this.a.set(l,h)),h.add($)}delete(l,$){const h=this.a.get(l);h&&(h.delete($),h.size===0&&this.a.delete(l))}forEach(l,$){const h=this.a.get(l);h&&h.forEach($)}get(l){const $=this.a.get(l);return $||new Set}}e.$Gc=u}),define(be[2],ve([1,0,18,142,26,75,47]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const P=!1;let w=null;class v{constructor(){this.b=new Map}static{this.a=0}c(F){let X=this.b.get(F);return X||(X={parent:null,source:null,isSingleton:!1,value:F,idx:v.a++},this.b.set(F,X)),X}trackDisposable(F){const X=this.c(F);X.source||(X.source=new Error().stack)}setParent(F,X){const te=this.c(F);te.parent=X}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,X){const te=X.get(F);if(te)return te;const J=F.parent?this.f(this.c(F.parent),X):F;return X.set(F,J),J}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,F).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(F=10,X){let te;if(X)te=X;else{const he=new Map,Q=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,he).isSingleton);if(Q.length===0)return;const _=new Set(Q.map(V=>V.value));if(te=Q.filter(V=>!(V.parent&&_.has(V.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function J(he){function Q(V,G){for(;V.length>0&&G.some(oe=>typeof oe=="string"?oe===V[0]:V[0].match(oe));)V.shift()}const _=he.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return Q(_,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),_.reverse()}const ie=new r.$Gc;for(const he of te){const Q=J(he);for(let _=0;_<=Q.length;_++)ie.add(Q.slice(0,_).join(`
`),he)}te.sort((0,E.$7b)(he=>he.idx,E.$9b));let ee="",U=0;for(const he of te.slice(0,F)){U++;const Q=J(he),_=[];for(let V=0;V<Q.length;V++){let G=Q[V];G=`(shared with ${ie.get(Q.slice(0,V+1).join(`
`)).size}/${te.length} leaks) at ${G}`;const le=ie.get(Q.slice(0,V).join(`
`)),se=(0,R.$K)([...le].map($e=>J($e)[V]),$e=>$e);delete se[Q[V]];for(const[$e,z]of Object.entries(se))_.unshift(`    - stacktraces of ${z.length} other leaks continue with ${$e}`);_.unshift(G)}ee+=`


==================== Leaking disposable ${U}/${te.length}: ${he.value.constructor.name} ====================
${_.join(`
`)}
============================================================

`}return te.length>F&&(ee+=`


... and ${te.length-F} more leaking disposables

`),{leaks:te,details:ee}}}e.$Hc=v;function I(A){w=A}if(e.$Ic=I,P){const A="__is_disposable_tracked__";I(new class{trackDisposable(F){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[A]||console.log(X)},3e3)}setParent(F,X){if(F&&F!==n.None)try{F[A]=!0}catch{}}markAsDisposed(F){if(F&&F!==n.None)try{F[A]=!0}catch{}}markAsSingleton(F){}})}function k(A){return w?.trackDisposable(A),A}e.$Jc=k;function b(A){w?.markAsDisposed(A)}e.$Kc=b;function f(A,F){w?.setParent(A,F)}function p(A,F){if(w)for(const X of A)w.setParent(X,F)}function c(A){return w?.markAsSingleton(A),A}e.$Lc=c;function m(A){return typeof A.dispose=="function"&&A.dispose.length===0}e.$Mc=m;function u(A){if(S.Iterable.is(A)){const F=[];for(const X of A)if(X)try{X.dispose()}catch(te){F.push(te)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}e.$Nc=u;function d(A){for(const F of A)m(F)&&F.dispose();return[]}e.$Oc=d;function l(...A){const F=$(()=>u(A));return p(A,F),F}e.$Pc=l;function $(A){const F=k({dispose:(0,C.$db)(()=>{b(F),A()})});return F}e.$Qc=$;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return f(F,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),f(F,null))}}e.$Rc=h;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,k(this),f(this.q,this)}dispose(){b(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}e.$Sc=n;class i{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&f(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&f(F,null),F}}e.$Tc=i;class o{constructor(F){this.a=new i,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=o;class s{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(F){let X=F;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,b(this))},this}}e.$Wc=t;class a{constructor(){this.a=new Map}acquire(F,...X){let te=this.a.get(F);te||(te={counter:0,object:this.b(F,...X)},this.a.set(F,te));const{object:J}=te,ie=(0,C.$db)(()=>{--te.counter===0&&(this.c(F,te.object),this.a.delete(F))});return te.counter++,{object:J,dispose:ie}}}e.$Xc=a;class g{constructor(F){this.a=F}async acquire(F,...X){const te=this.a.acquire(F,...X);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(J){throw te.dispose(),J}}}e.$Yc=g;class L{constructor(F){this.object=F}dispose(){}}e.$Zc=L;function D(A){const F=new h;try{A(F)}finally{F.dispose()}}e.$1c=D;class y{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,X,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(F)?.dispose(),this.a.set(F,X)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=y}),function(ue,e){typeof define=="function"&&define.amd?define(be[143],ve([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(Z,B){for(var H=0;H<B.length;H++){var T=B[H];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(Z,T.key,T)}}function E(Z,B,H){return B&&e(Z.prototype,B),H&&e(Z,H),Object.defineProperty(Z,"prototype",{writable:!1}),Z}function R(Z,B){if(Z){if(typeof Z=="string")return r(Z,B);var H=Object.prototype.toString.call(Z).slice(8,-1);if(H==="Object"&&Z.constructor&&(H=Z.constructor.name),H==="Map"||H==="Set")return Array.from(Z);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return r(Z,B)}}function r(Z,B){(B==null||B>Z.length)&&(B=Z.length);for(var H=0,T=new Array(B);H<B;H++)T[H]=Z[H];return T}function C(Z,B){var H=typeof Symbol<"u"&&Z[Symbol.iterator]||Z["@@iterator"];if(H)return(H=H.call(Z)).next.bind(H);if(Array.isArray(Z)||(H=R(Z))||B&&Z&&typeof Z.length=="number"){H&&(Z=H);var T=0;return function(){return T>=Z.length?{done:!0}:{done:!1,value:Z[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=S();function P(Z){ue.defaults=Z}var w=/[&<>"']/,v=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},f=function(B){return b[B]};function p(Z,B){if(B){if(w.test(Z))return Z.replace(v,f)}else if(I.test(Z))return Z.replace(k,f);return Z}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(Z){return Z.replace(c,function(B,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var u=/(^|[^\[])\^/g;function d(Z,B){Z=typeof Z=="string"?Z:Z.source,B=B||"";var H={replace:function(W,x){return x=x.source||x,x=x.replace(u,"$1"),Z=Z.replace(W,x),H},getRegex:function(){return new RegExp(Z,B)}};return H}var l=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Z,B,H){if(Z){var T;try{T=decodeURIComponent(m(H)).replace(l,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}B&&!$.test(H)&&(H=t(B,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var n={},i=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(Z,B){n[" "+Z]||(i.test(Z)?n[" "+Z]=Z+"/":n[" "+Z]=D(Z,"/",!0)),Z=n[" "+Z];var H=Z.indexOf(":")===-1;return B.substring(0,2)==="//"?H?B:Z.replace(o,"$1")+B:B.charAt(0)==="/"?H?B:Z.replace(s,"$1")+B:Z+B}var a={exec:function(){}};function g(Z){for(var B=1,H,T;B<arguments.length;B++){H=arguments[B];for(T in H)Object.prototype.hasOwnProperty.call(H,T)&&(Z[T]=H[T])}return Z}function L(Z,B){var H=Z.replace(/\|/g,function(x,re,fe){for(var ce=!1,ge=re;--ge>=0&&fe[ge]==="\\";)ce=!ce;return ce?"|":" |"}),T=H.split(/ \|/),W=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>B)T.splice(B);else for(;T.length<B;)T.push("");for(;W<T.length;W++)T[W]=T[W].trim().replace(/\\\|/g,"|");return T}function D(Z,B,H){var T=Z.length;if(T===0)return"";for(var W=0;W<T;){var x=Z.charAt(T-W-1);if(x===B&&!H)W++;else if(x!==B&&H)W++;else break}return Z.slice(0,T-W)}function y(Z,B){if(Z.indexOf(B[1])===-1)return-1;for(var H=Z.length,T=0,W=0;W<H;W++)if(Z[W]==="\\")W++;else if(Z[W]===B[0])T++;else if(Z[W]===B[1]&&(T--,T<0))return W;return-1}function A(Z){Z&&Z.sanitize&&!Z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Z,B){if(B<1)return"";for(var H="";B>1;)B&1&&(H+=Z),B>>=1,Z+=Z;return H+Z}function X(Z,B,H,T){var W=B.href,x=B.title?p(B.title):null,re=Z[1].replace(/\\([\[\]])/g,"$1");if(Z[0].charAt(0)!=="!"){T.state.inLink=!0;var fe={type:"link",raw:H,href:W,title:x,text:re,tokens:T.inlineTokens(re)};return T.state.inLink=!1,fe}return{type:"image",raw:H,href:W,title:x,text:p(re)}}function te(Z,B){var H=Z.match(/^(\s+)(?:```)/);if(H===null)return B;var T=H[1];return B.split(`
`).map(function(W){var x=W.match(/^\s+/);if(x===null)return W;var re=x[0];return re.length>=T.length?W.slice(T.length):W}).join(`
`)}var J=function(){function Z(H){this.options=H||ue.defaults}var B=Z.prototype;return B.space=function(T){var W=this.rules.block.newline.exec(T);if(W&&W[0].length>0)return{type:"space",raw:W[0]}},B.code=function(T){var W=this.rules.block.code.exec(T);if(W){var x=W[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:W[0],codeBlockStyle:"indented",text:this.options.pedantic?x:D(x,`
`)}}},B.fences=function(T){var W=this.rules.block.fences.exec(T);if(W){var x=W[0],re=te(x,W[3]||"");return{type:"code",raw:x,lang:W[2]?W[2].trim():W[2],text:re}}},B.heading=function(T){var W=this.rules.block.heading.exec(T);if(W){var x=W[2].trim();if(/#$/.test(x)){var re=D(x,"#");(this.options.pedantic||!re||/ $/.test(re))&&(x=re.trim())}return{type:"heading",raw:W[0],depth:W[1].length,text:x,tokens:this.lexer.inline(x)}}},B.hr=function(T){var W=this.rules.block.hr.exec(T);if(W)return{type:"hr",raw:W[0]}},B.blockquote=function(T){var W=this.rules.block.blockquote.exec(T);if(W){var x=W[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:W[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},B.list=function(T){var W=this.rules.block.list.exec(T);if(W){var x,re,fe,ce,ge,ye,Ie,Re,me,De,Ee,Me,je=W[1].trim(),We=je.length>1,He={type:"list",raw:"",ordered:We,start:We?+je.slice(0,-1):"",loose:!1,items:[]};je=We?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=We?je:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Me=!1,!(!(W=Qe.exec(T))||this.rules.block.hr.test(T)));){if(x=W[0],T=T.substring(x.length),Re=W[2].split(`
`,1)[0],me=T.split(`
`,1)[0],this.options.pedantic?(ce=2,Ee=Re.trimLeft()):(ce=W[2].search(/[^ ]/),ce=ce>4?1:ce,Ee=Re.slice(ce),ce+=W[1].length),ye=!1,!Re&&/^ *$/.test(me)&&(x+=me+`
`,T=T.substring(me.length+1),Me=!0),!Me)for(var Ye=new RegExp("^ {0,"+Math.min(3,ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),pe=new RegExp("^ {0,"+Math.min(3,ce-1)+"}(?:```|~~~)"),Se=new RegExp("^ {0,"+Math.min(3,ce-1)+"}#");T&&(De=T.split(`
`,1)[0],Re=De,this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(pe.test(Re)||Se.test(Re)||Ye.test(Re)||et.test(T)));){if(Re.search(/[^ ]/)>=ce||!Re.trim())Ee+=`
`+Re.slice(ce);else if(!ye)Ee+=`
`+Re;else break;!ye&&!Re.trim()&&(ye=!0),x+=De+`
`,T=T.substring(De.length+1)}He.loose||(Ie?He.loose=!0:/\n *\n *$/.test(x)&&(Ie=!0)),this.options.gfm&&(re=/^\[[ xX]\] /.exec(Ee),re&&(fe=re[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:x,task:!!re,checked:fe,loose:!1,text:Ee}),He.raw+=x}He.items[He.items.length-1].raw=x.trimRight(),He.items[He.items.length-1].text=Ee.trimRight(),He.raw=He.raw.trimRight();var Ae=He.items.length;for(ge=0;ge<Ae;ge++){this.lexer.state.top=!1,He.items[ge].tokens=this.lexer.blockTokens(He.items[ge].text,[]);var Oe=He.items[ge].tokens.filter(function(Te){return Te.type==="space"}),Be=Oe.every(function(Te){for(var qe=Te.raw.split(""),Je=0,Ge=C(qe),Ze;!(Ze=Ge()).done;){var nt=Ze.value;if(nt===`
`&&(Je+=1),Je>1)return!0}return!1});!He.loose&&Oe.length&&Be&&(He.loose=!0,He.items[ge].loose=!0)}return He}},B.html=function(T){var W=this.rules.block.html.exec(T);if(W){var x={type:"html",raw:W[0],pre:!this.options.sanitizer&&(W[1]==="pre"||W[1]==="script"||W[1]==="style"),text:W[0]};if(this.options.sanitize){var re=this.options.sanitizer?this.options.sanitizer(W[0]):p(W[0]);x.type="paragraph",x.text=re,x.tokens=this.lexer.inline(re)}return x}},B.def=function(T){var W=this.rules.block.def.exec(T);if(W){W[3]&&(W[3]=W[3].substring(1,W[3].length-1));var x=W[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:W[0],href:W[2],title:W[3]}}},B.table=function(T){var W=this.rules.block.table.exec(T);if(W){var x={type:"table",header:L(W[1]).map(function(Ie){return{text:Ie}}),align:W[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:W[3]&&W[3].trim()?W[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=W[0];var re=x.align.length,fe,ce,ge,ye;for(fe=0;fe<re;fe++)/^ *-+: *$/.test(x.align[fe])?x.align[fe]="right":/^ *:-+: *$/.test(x.align[fe])?x.align[fe]="center":/^ *:-+ *$/.test(x.align[fe])?x.align[fe]="left":x.align[fe]=null;for(re=x.rows.length,fe=0;fe<re;fe++)x.rows[fe]=L(x.rows[fe],x.header.length).map(function(Ie){return{text:Ie}});for(re=x.header.length,ce=0;ce<re;ce++)x.header[ce].tokens=this.lexer.inline(x.header[ce].text);for(re=x.rows.length,ce=0;ce<re;ce++)for(ye=x.rows[ce],ge=0;ge<ye.length;ge++)ye[ge].tokens=this.lexer.inline(ye[ge].text);return x}}},B.lheading=function(T){var W=this.rules.block.lheading.exec(T);if(W)return{type:"heading",raw:W[0],depth:W[2].charAt(0)==="="?1:2,text:W[1],tokens:this.lexer.inline(W[1])}},B.paragraph=function(T){var W=this.rules.block.paragraph.exec(T);if(W){var x=W[1].charAt(W[1].length-1)===`
`?W[1].slice(0,-1):W[1];return{type:"paragraph",raw:W[0],text:x,tokens:this.lexer.inline(x)}}},B.text=function(T){var W=this.rules.block.text.exec(T);if(W)return{type:"text",raw:W[0],text:W[0],tokens:this.lexer.inline(W[0])}},B.escape=function(T){var W=this.rules.inline.escape.exec(T);if(W)return{type:"escape",raw:W[0],text:p(W[1])}},B.tag=function(T){var W=this.rules.inline.tag.exec(T);if(W)return!this.lexer.state.inLink&&/^<a /i.test(W[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(W[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(W[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(W[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:W[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):p(W[0]):W[0]}},B.link=function(T){var W=this.rules.inline.link.exec(T);if(W){var x=W[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var re=D(x.slice(0,-1),"\\");if((x.length-re.length)%2===0)return}else{var fe=y(W[2],"()");if(fe>-1){var ce=W[0].indexOf("!")===0?5:4,ge=ce+W[1].length+fe;W[2]=W[2].substring(0,fe),W[0]=W[0].substring(0,ge).trim(),W[3]=""}}var ye=W[2],Ie="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ye);Re&&(ye=Re[1],Ie=Re[3])}else Ie=W[3]?W[3].slice(1,-1):"";return ye=ye.trim(),/^</.test(ye)&&(this.options.pedantic&&!/>$/.test(x)?ye=ye.slice(1):ye=ye.slice(1,-1)),X(W,{href:ye&&ye.replace(this.rules.inline._escapes,"$1"),title:Ie&&Ie.replace(this.rules.inline._escapes,"$1")},W[0],this.lexer)}},B.reflink=function(T,W){var x;if((x=this.rules.inline.reflink.exec(T))||(x=this.rules.inline.nolink.exec(T))){var re=(x[2]||x[1]).replace(/\s+/g," ");if(re=W[re.toLowerCase()],!re||!re.href){var fe=x[0].charAt(0);return{type:"text",raw:fe,text:fe}}return X(x,re,x[0],this.lexer)}},B.emStrong=function(T,W,x){x===void 0&&(x="");var re=this.rules.inline.emStrong.lDelim.exec(T);if(re&&!(re[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=re[1]||re[2]||"";if(!fe||fe&&(x===""||this.rules.inline.punctuation.exec(x))){var ce=re[0].length-1,ge,ye,Ie=ce,Re=0,me=re[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,W=W.slice(-1*T.length+ce);(re=me.exec(W))!=null;)if(ge=re[1]||re[2]||re[3]||re[4]||re[5]||re[6],!!ge){if(ye=ge.length,re[3]||re[4]){Ie+=ye;continue}else if((re[5]||re[6])&&ce%3&&!((ce+ye)%3)){Re+=ye;continue}if(Ie-=ye,!(Ie>0)){if(ye=Math.min(ye,ye+Ie+Re),Math.min(ce,ye)%2){var De=T.slice(1,ce+re.index+ye);return{type:"em",raw:T.slice(0,ce+re.index+ye+1),text:De,tokens:this.lexer.inlineTokens(De)}}var Ee=T.slice(2,ce+re.index+ye-1);return{type:"strong",raw:T.slice(0,ce+re.index+ye+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}}}}},B.codespan=function(T){var W=this.rules.inline.code.exec(T);if(W){var x=W[2].replace(/\n/g," "),re=/[^ ]/.test(x),fe=/^ /.test(x)&&/ $/.test(x);return re&&fe&&(x=x.substring(1,x.length-1)),x=p(x,!0),{type:"codespan",raw:W[0],text:x}}},B.br=function(T){var W=this.rules.inline.br.exec(T);if(W)return{type:"br",raw:W[0]}},B.del=function(T){var W=this.rules.inline.del.exec(T);if(W)return{type:"del",raw:W[0],text:W[2],tokens:this.lexer.inlineTokens(W[2])}},B.autolink=function(T,W){var x=this.rules.inline.autolink.exec(T);if(x){var re,fe;return x[2]==="@"?(re=p(this.options.mangle?W(x[1]):x[1]),fe="mailto:"+re):(re=p(x[1]),fe=re),{type:"link",raw:x[0],text:re,href:fe,tokens:[{type:"text",raw:re,text:re}]}}},B.url=function(T,W){var x;if(x=this.rules.inline.url.exec(T)){var re,fe;if(x[2]==="@")re=p(this.options.mangle?W(x[0]):x[0]),fe="mailto:"+re;else{var ce;do ce=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(ce!==x[0]);re=p(x[0]),x[1]==="www."?fe="http://"+re:fe=re}return{type:"link",raw:x[0],text:re,href:fe,tokens:[{type:"text",raw:re,text:re}]}}},B.inlineText=function(T,W){var x=this.rules.inline.text.exec(T);if(x){var re;return this.lexer.state.inRawBlock?re=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]):x[0]:re=p(this.options.smartypants?W(x[0]):x[0]),{type:"text",raw:x[0],text:re}}},Z}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=d(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=d(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=d(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=d(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=d(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=d(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=g({},ie),ie.gfm=g({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=d(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=d(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=g({},ie.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:d(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=d(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=d(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=d(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=d(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=d(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=d(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=d(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=d(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=d(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=d(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=d(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=g({},ee),ee.pedantic=g({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=g({},ee.normal,{escape:d(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=d(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=g({},ee.gfm,{br:d(ee.br).replace("{2,}","*").getRegex(),text:d(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(Z){return Z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function he(Z){var B="",H,T,W=Z.length;for(H=0;H<W;H++)T=Z.charCodeAt(H),Math.random()>.5&&(T="x"+T.toString(16)),B+="&#"+T+";";return B}var Q=function(){function Z(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||ue.defaults,this.options.tokenizer=this.options.tokenizer||new J,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:ie.normal,inline:ee.normal};this.options.pedantic?(T.block=ie.pedantic,T.inline=ee.pedantic):this.options.gfm&&(T.block=ie.gfm,this.options.breaks?T.inline=ee.breaks:T.inline=ee.gfm),this.tokenizer.rules=T}Z.lex=function(T,W){var x=new Z(W);return x.lex(T)},Z.lexInline=function(T,W){var x=new Z(W);return x.inlineTokens(T)};var B=Z.prototype;return B.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var W;W=this.inlineQueue.shift();)this.inlineTokens(W.src,W.tokens);return this.tokens},B.blockTokens=function(T,W){var x=this;W===void 0&&(W=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(Ie,Re,me){return Re+"    ".repeat(me.length)});for(var re,fe,ce,ge;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ie){return(re=Ie.call({lexer:x},T,W))?(T=T.substring(re.raw.length),W.push(re),!0):!1}))){if(re=this.tokenizer.space(T)){T=T.substring(re.raw.length),re.raw.length===1&&W.length>0?W[W.length-1].raw+=`
`:W.push(re);continue}if(re=this.tokenizer.code(T)){T=T.substring(re.raw.length),fe=W[W.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+re.raw,fe.text+=`
`+re.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):W.push(re);continue}if(re=this.tokenizer.fences(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.heading(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.hr(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.blockquote(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.list(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.html(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.def(T)){T=T.substring(re.raw.length),fe=W[W.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+re.raw,fe.text+=`
`+re.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[re.tag]||(this.tokens.links[re.tag]={href:re.href,title:re.title});continue}if(re=this.tokenizer.table(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.lheading(T)){T=T.substring(re.raw.length),W.push(re);continue}if(ce=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ie=1/0,Re=T.slice(1),me=void 0;x.options.extensions.startBlock.forEach(function(De){me=De.call({lexer:this},Re),typeof me=="number"&&me>=0&&(Ie=Math.min(Ie,me))}),Ie<1/0&&Ie>=0&&(ce=T.substring(0,Ie+1))}(),this.state.top&&(re=this.tokenizer.paragraph(ce))){fe=W[W.length-1],ge&&fe.type==="paragraph"?(fe.raw+=`
`+re.raw,fe.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):W.push(re),ge=ce.length!==T.length,T=T.substring(re.raw.length);continue}if(re=this.tokenizer.text(T)){T=T.substring(re.raw.length),fe=W[W.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+re.raw,fe.text+=`
`+re.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):W.push(re);continue}if(T){var ye="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return this.state.top=!0,W},B.inline=function(T,W){return W===void 0&&(W=[]),this.inlineQueue.push({src:T,tokens:W}),W},B.inlineTokens=function(T,W){var x=this;W===void 0&&(W=[]);var re,fe,ce,ge=T,ye,Ie,Re;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(ye=this.tokenizer.rules.inline.reflinkSearch.exec(ge))!=null;)me.includes(ye[0].slice(ye[0].lastIndexOf("[")+1,-1))&&(ge=ge.slice(0,ye.index)+"["+F("a",ye[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ye=this.tokenizer.rules.inline.blockSkip.exec(ge))!=null;)ge=ge.slice(0,ye.index)+"["+F("a",ye[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ye=this.tokenizer.rules.inline.escapedEmSt.exec(ge))!=null;)ge=ge.slice(0,ye.index)+"++"+ge.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(Ie||(Re=""),Ie=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ee){return(re=Ee.call({lexer:x},T,W))?(T=T.substring(re.raw.length),W.push(re),!0):!1}))){if(re=this.tokenizer.escape(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.tag(T)){T=T.substring(re.raw.length),fe=W[W.length-1],fe&&re.type==="text"&&fe.type==="text"?(fe.raw+=re.raw,fe.text+=re.text):W.push(re);continue}if(re=this.tokenizer.link(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(re.raw.length),fe=W[W.length-1],fe&&re.type==="text"&&fe.type==="text"?(fe.raw+=re.raw,fe.text+=re.text):W.push(re);continue}if(re=this.tokenizer.emStrong(T,ge,Re)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.codespan(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.br(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.del(T)){T=T.substring(re.raw.length),W.push(re);continue}if(re=this.tokenizer.autolink(T,he)){T=T.substring(re.raw.length),W.push(re);continue}if(!this.state.inLink&&(re=this.tokenizer.url(T,he))){T=T.substring(re.raw.length),W.push(re);continue}if(ce=T,this.options.extensions&&this.options.extensions.startInline&&function(){var Ee=1/0,Me=T.slice(1),je=void 0;x.options.extensions.startInline.forEach(function(We){je=We.call({lexer:this},Me),typeof je=="number"&&je>=0&&(Ee=Math.min(Ee,je))}),Ee<1/0&&Ee>=0&&(ce=T.substring(0,Ee+1))}(),re=this.tokenizer.inlineText(ce,U)){T=T.substring(re.raw.length),re.raw.slice(-1)!=="_"&&(Re=re.raw.slice(-1)),Ie=!0,fe=W[W.length-1],fe&&fe.type==="text"?(fe.raw+=re.raw,fe.text+=re.text):W.push(re);continue}if(T){var De="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return W},E(Z,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),Z}(),_=function(){function Z(H){this.options=H||ue.defaults}var B=Z.prototype;return B.code=function(T,W,x){var re=(W||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(T,re);fe!=null&&fe!==T&&(x=!0,T=fe)}return T=T.replace(/\n$/,"")+`
`,re?'<pre><code class="'+this.options.langPrefix+p(re,!0)+'">'+(x?T:p(T,!0))+`</code></pre>
`:"<pre><code>"+(x?T:p(T,!0))+`</code></pre>
`},B.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},B.html=function(T){return T},B.heading=function(T,W,x,re){if(this.options.headerIds){var fe=this.options.headerPrefix+re.slug(x);return"<h"+W+' id="'+fe+'">'+T+"</h"+W+`>
`}return"<h"+W+">"+T+"</h"+W+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(T,W,x){var re=W?"ol":"ul",fe=W&&x!==1?' start="'+x+'"':"";return"<"+re+fe+`>
`+T+"</"+re+`>
`},B.listitem=function(T){return"<li>"+T+`</li>
`},B.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(T){return"<p>"+T+`</p>
`},B.table=function(T,W){return W&&(W="<tbody>"+W+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+W+`</table>
`},B.tablerow=function(T){return`<tr>
`+T+`</tr>
`},B.tablecell=function(T,W){var x=W.header?"th":"td",re=W.align?"<"+x+' align="'+W.align+'">':"<"+x+">";return re+T+("</"+x+`>
`)},B.strong=function(T){return"<strong>"+T+"</strong>"},B.em=function(T){return"<em>"+T+"</em>"},B.codespan=function(T){return"<code>"+T+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(T){return"<del>"+T+"</del>"},B.link=function(T,W,x){if(T=h(this.options.sanitize,this.options.baseUrl,T),T===null)return x;var re='<a href="'+p(T)+'"';return W&&(re+=' title="'+W+'"'),re+=">"+x+"</a>",re},B.image=function(T,W,x){if(T=h(this.options.sanitize,this.options.baseUrl,T),T===null)return x;var re='<img src="'+T+'" alt="'+x+'"';return W&&(re+=' title="'+W+'"'),re+=this.options.xhtml?"/>":">",re},B.text=function(T){return T},Z}(),V=function(){function Z(){}var B=Z.prototype;return B.strong=function(T){return T},B.em=function(T){return T},B.codespan=function(T){return T},B.del=function(T){return T},B.html=function(T){return T},B.text=function(T){return T},B.link=function(T,W,x){return""+x},B.image=function(T,W,x){return""+x},B.br=function(){return""},Z}(),G=function(){function Z(){this.seen={}}var B=Z.prototype;return B.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(T,W){var x=T,re=0;if(this.seen.hasOwnProperty(x)){re=this.seen[T];do re++,x=T+"-"+re;while(this.seen.hasOwnProperty(x))}return W||(this.seen[T]=re,this.seen[x]=0),x},B.slug=function(T,W){W===void 0&&(W={});var x=this.serialize(T);return this.getNextSafeSlug(x,W.dryrun)},Z}(),oe=function(){function Z(H){this.options=H||ue.defaults,this.options.renderer=this.options.renderer||new _,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new V,this.slugger=new G}Z.parse=function(T,W){var x=new Z(W);return x.parse(T)},Z.parseInline=function(T,W){var x=new Z(W);return x.parseInline(T)};var B=Z.prototype;return B.parse=function(T,W){W===void 0&&(W=!0);var x="",re,fe,ce,ge,ye,Ie,Re,me,De,Ee,Me,je,We,He,Qe,Ye,et,pe,Se,Ae=T.length;for(re=0;re<Ae;re++){if(Ee=T[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Se=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ee.type))){x+=Se||"";continue}switch(Ee.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(Ee.tokens),Ee.depth,m(this.parseInline(Ee.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(Ee.text,Ee.lang,Ee.escaped);continue}case"table":{for(me="",Re="",ge=Ee.header.length,fe=0;fe<ge;fe++)Re+=this.renderer.tablecell(this.parseInline(Ee.header[fe].tokens),{header:!0,align:Ee.align[fe]});for(me+=this.renderer.tablerow(Re),De="",ge=Ee.rows.length,fe=0;fe<ge;fe++){for(Ie=Ee.rows[fe],Re="",ye=Ie.length,ce=0;ce<ye;ce++)Re+=this.renderer.tablecell(this.parseInline(Ie[ce].tokens),{header:!1,align:Ee.align[ce]});De+=this.renderer.tablerow(Re)}x+=this.renderer.table(me,De);continue}case"blockquote":{De=this.parse(Ee.tokens),x+=this.renderer.blockquote(De);continue}case"list":{for(Me=Ee.ordered,je=Ee.start,We=Ee.loose,ge=Ee.items.length,De="",fe=0;fe<ge;fe++)Qe=Ee.items[fe],Ye=Qe.checked,et=Qe.task,He="",Qe.task&&(pe=this.renderer.checkbox(Ye),We?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=pe+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=pe+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:pe}):He+=pe),He+=this.parse(Qe.tokens,We),De+=this.renderer.listitem(He,et,Ye);x+=this.renderer.list(De,Me,je);continue}case"html":{x+=this.renderer.html(Ee.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(Ee.tokens));continue}case"text":{for(De=Ee.tokens?this.parseInline(Ee.tokens):Ee.text;re+1<Ae&&T[re+1].type==="text";)Ee=T[++re],De+=`
`+(Ee.tokens?this.parseInline(Ee.tokens):Ee.text);x+=W?this.renderer.paragraph(De):De;continue}default:{var Oe='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return x},B.parseInline=function(T,W){W=W||this.renderer;var x="",re,fe,ce,ge=T.length;for(re=0;re<ge;re++){if(fe=T[re],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(ce=this.options.extensions.renderers[fe.type].call({parser:this},fe),ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){x+=ce||"";continue}switch(fe.type){case"escape":{x+=W.text(fe.text);break}case"html":{x+=W.html(fe.text);break}case"link":{x+=W.link(fe.href,fe.title,this.parseInline(fe.tokens,W));break}case"image":{x+=W.image(fe.href,fe.title,fe.text);break}case"strong":{x+=W.strong(this.parseInline(fe.tokens,W));break}case"em":{x+=W.em(this.parseInline(fe.tokens,W));break}case"codespan":{x+=W.codespan(fe.text);break}case"br":{x+=W.br();break}case"del":{x+=W.del(this.parseInline(fe.tokens,W));break}case"text":{x+=W.text(fe.text);break}default:{var ye='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ye);return}else throw new Error(ye)}}}return x},Z}();function le(Z,B,H){if(typeof Z>"u"||Z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");if(typeof B=="function"&&(H=B,B=null),B=g({},le.defaults,B||{}),A(B),H){var T=B.highlight,W;try{W=Q.lex(Z,B)}catch(ge){return H(ge)}var x=function(ye){var Ie;if(!ye)try{B.walkTokens&&le.walkTokens(W,B.walkTokens),Ie=oe.parse(W,B)}catch(Re){ye=Re}return B.highlight=T,ye?H(ye):H(null,Ie)};if(!T||T.length<3||(delete B.highlight,!W.length))return x();var re=0;le.walkTokens(W,function(ge){ge.type==="code"&&(re++,setTimeout(function(){T(ge.text,ge.lang,function(ye,Ie){if(ye)return x(ye);Ie!=null&&Ie!==ge.text&&(ge.text=Ie,ge.escaped=!0),re--,re===0&&x()})},0))}),re===0&&x();return}function fe(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+p(ge.message+"",!0)+"</pre>";throw ge}try{var ce=Q.lex(Z,B);if(B.walkTokens){if(B.async)return Promise.all(le.walkTokens(ce,B.walkTokens)).then(function(){return oe.parse(ce,B)}).catch(fe);le.walkTokens(ce,B.walkTokens)}return oe.parse(ce,B)}catch(ge){fe(ge)}}le.options=le.setOptions=function(Z){return g(le.defaults,Z),P(le.defaults),le},le.getDefaults=S,le.defaults=ue.defaults,le.use=function(){for(var Z=arguments.length,B=new Array(Z),H=0;H<Z;H++)B[H]=arguments[H];var T=g.apply(void 0,[{}].concat(B)),W=le.defaults.extensions||{renderers:{},childTokens:{}},x;B.forEach(function(re){if(re.extensions&&(x=!0,re.extensions.forEach(function(ce){if(!ce.name)throw new Error("extension name required");if(ce.renderer){var ge=W.renderers?W.renderers[ce.name]:null;ge?W.renderers[ce.name]=function(){for(var ye=arguments.length,Ie=new Array(ye),Re=0;Re<ye;Re++)Ie[Re]=arguments[Re];var me=ce.renderer.apply(this,Ie);return me===!1&&(me=ge.apply(this,Ie)),me}:W.renderers[ce.name]=ce.renderer}if(ce.tokenizer){if(!ce.level||ce.level!=="block"&&ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");W[ce.level]?W[ce.level].unshift(ce.tokenizer):W[ce.level]=[ce.tokenizer],ce.start&&(ce.level==="block"?W.startBlock?W.startBlock.push(ce.start):W.startBlock=[ce.start]:ce.level==="inline"&&(W.startInline?W.startInline.push(ce.start):W.startInline=[ce.start]))}ce.childTokens&&(W.childTokens[ce.name]=ce.childTokens)})),re.renderer&&function(){var ce=le.defaults.renderer||new _,ge=function(Re){var me=ce[Re];ce[Re]=function(){for(var De=arguments.length,Ee=new Array(De),Me=0;Me<De;Me++)Ee[Me]=arguments[Me];var je=re.renderer[Re].apply(ce,Ee);return je===!1&&(je=me.apply(ce,Ee)),je}};for(var ye in re.renderer)ge(ye);T.renderer=ce}(),re.tokenizer&&function(){var ce=le.defaults.tokenizer||new J,ge=function(Re){var me=ce[Re];ce[Re]=function(){for(var De=arguments.length,Ee=new Array(De),Me=0;Me<De;Me++)Ee[Me]=arguments[Me];var je=re.tokenizer[Re].apply(ce,Ee);return je===!1&&(je=me.apply(ce,Ee)),je}};for(var ye in re.tokenizer)ge(ye);T.tokenizer=ce}(),re.walkTokens){var fe=le.defaults.walkTokens;T.walkTokens=function(ce){var ge=[];return ge.push(re.walkTokens.call(this,ce)),fe&&(ge=ge.concat(fe.call(this,ce))),ge}}x&&(T.extensions=W),le.setOptions(T)})},le.walkTokens=function(Z,B){for(var H=[],T=function(){var fe=x.value;switch(H=H.concat(B.call(le,fe)),fe.type){case"table":{for(var ce=C(fe.header),ge;!(ge=ce()).done;){var ye=ge.value;H=H.concat(le.walkTokens(ye.tokens,B))}for(var Ie=C(fe.rows),Re;!(Re=Ie()).done;)for(var me=Re.value,De=C(me),Ee;!(Ee=De()).done;){var Me=Ee.value;H=H.concat(le.walkTokens(Me.tokens,B))}break}case"list":{H=H.concat(le.walkTokens(fe.items,B));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[fe.type]?le.defaults.extensions.childTokens[fe.type].forEach(function(je){H=H.concat(le.walkTokens(fe[je],B))}):fe.tokens&&(H=H.concat(le.walkTokens(fe.tokens,B)))}},W=C(Z),x;!(x=W()).done;)T();return H},le.parseInline=function(Z,B){if(typeof Z>"u"||Z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Z)+", string expected");B=g({},le.defaults,B||{}),A(B);try{var H=Q.lexInline(Z,B);return B.walkTokens&&le.walkTokens(H,B.walkTokens),oe.parseInline(H,B)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+p(T.message+"",!0)+"</pre>";throw T}},le.Parser=oe,le.parser=oe.parse,le.Renderer=_,le.TextRenderer=V,le.Lexer=Q,le.lexer=Q.lex,le.Tokenizer=J,le.Slugger=G,le.parse=le;var se=le.options,$e=le.setOptions,z=le.use,q=le.walkTokens,O=le.parseInline,j=le,ne=oe.parse,Y=Q.lex;ue.Lexer=Q,ue.Parser=oe,ue.Renderer=_,ue.Slugger=G,ue.TextRenderer=V,ue.Tokenizer=J,ue.getDefaults=S,ue.lexer=Y,ue.marked=le,ue.options=se,ue.parse=j,ue.parseInline=O,ue.parser=ne,ue.setOptions=$e,ue.use=z,ue.walkTokens=q,Object.defineProperty(ue,"__esModule",{value:!0})}),define(be[144],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function E(c){const m=C(c);if(m&&m.length>0)return new Uint32Array(m)}e.$Nj=E;let R=0;const r=new Uint32Array(10);function C(c){if(R=0,S(c,k,4352),R>0||(S(c,b,4449),R>0)||(S(c,f,4520),R>0)||(S(c,p,12593),R))return r.subarray(0,R);if(c>=44032&&c<=55203){const m=c-44032,u=m%588,d=Math.floor(m/588),l=Math.floor(u/28),$=u%28-1;if(d<k.length?S(d,k,0):4352+d-12593<p.length&&S(4352+d,p,12593),l<b.length?S(l,b,0):4449+l-12593<p.length&&S(4449+l-12593,p,12593),$>=0&&($<f.length?S($,f,0):4520+$-12593<p.length&&S(4520+$-12593,p,12593)),R>0)return r.subarray(0,R)}}function S(c,m,u){c>=u&&c<u+m.length&&P(m[c-u])}function P(c){c!==0&&(r[R++]=c&255,c>>8&&(r[R++]=c>>8&255),c>>16&&(r[R++]=c>>16&255))}var w;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})(w||(w={}));var v;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(v||(v={}));var I;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(I||(I={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),b=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),f=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[98],ve([1,0,26]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=void 0;const R=new E.$Dc(1e4);function r(v){return w(v,"NFC",R)}e.$Bl=r;const C=new E.$Dc(1e4);function S(v){return w(v,"NFD",C)}e.$Cl=S;const P=/[^\u0000-\u0080]/;function w(v,I,k){if(!v)return v;const b=k.get(v);if(b)return b;let f;return P.test(v)?f=v.normalize(I):f=v,k.set(v,f),f}e.$Dl=function(){const v=/[\u0300-\u036f]/g;return function(I){return S(I).replace(v,"")}}()}),define(be[145],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.rot=e.$2l=void 0;function E(P,w,v){return Math.min(Math.max(P,w),v)}e.$2l=E;function R(P,w){return(w+P%w)%w}e.rot=R;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$4l=r;class C{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$5l=C;class S{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const v=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$6l=S}),function(){function ue(r){const C=[];typeof r=="number"&&C.push("code/timeOrigin",r);function S(w){C.push(w,Date.now())}function P(){const w=[];for(let v=0;v<C.length;v+=2)w.push({name:C[v],startTime:C[v+1]});return w}return{mark:S,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const S of performance.getEntriesByType("mark"))C.push({name:S.name,startTime:Math.round(r+S.startTime)});return C}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=E(R))}(),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var R in E)(typeof exports=="object"?exports:ue)[R]=E[R]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function E(R){if(e[R])return e[R].exports;var r=e[R]={i:R,l:!1,exports:{}};return ue[R].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=ue,E.c=e,E.d=function(R,r,C){E.o(R,r)||Object.defineProperty(R,r,{enumerable:!0,get:C})},E.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},E.t=function(R,r){if(1&r&&(R=E(R)),8&r||4&r&&typeof R=="object"&&R&&R.__esModule)return R;var C=Object.create(null);if(E.r(C),Object.defineProperty(C,"default",{enumerable:!0,value:R}),2&r&&typeof R!="string")for(var S in R)E.d(C,S,function(P){return R[P]}.bind(null,S));return C},E.n=function(R){var r=R&&R.__esModule?function(){return R.default}:function(){return R};return E.d(r,"a",r),r},E.o=function(R,r){return Object.prototype.hasOwnProperty.call(R,r)},E.p="",E(E.s=0)}([function(ue,e,E){(function(R){var r;e=ue.exports=z,r=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var C=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],v=0,I=v++;w[I]="0|[1-9]\\d*";var k=v++;w[k]="[0-9]+";var b=v++;w[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=v++;w[f]="("+w[I]+")\\.("+w[I]+")\\.("+w[I]+")";var p=v++;w[p]="("+w[k]+")\\.("+w[k]+")\\.("+w[k]+")";var c=v++;w[c]="(?:"+w[I]+"|"+w[b]+")";var m=v++;w[m]="(?:"+w[k]+"|"+w[b]+")";var u=v++;w[u]="(?:-("+w[c]+"(?:\\."+w[c]+")*))";var d=v++;w[d]="(?:-?("+w[m]+"(?:\\."+w[m]+")*))";var l=v++;w[l]="[0-9A-Za-z-]+";var $=v++;w[$]="(?:\\+("+w[l]+"(?:\\."+w[l]+")*))";var h=v++,n="v?"+w[f]+w[u]+"?"+w[$]+"?";w[h]="^"+n+"$";var i="[v=\\s]*"+w[p]+w[d]+"?"+w[$]+"?",o=v++;w[o]="^"+i+"$";var s=v++;w[s]="((?:<|>)?=?)";var t=v++;w[t]=w[k]+"|x|X|\\*";var a=v++;w[a]=w[I]+"|x|X|\\*";var g=v++;w[g]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[u]+")?"+w[$]+"?)?)?";var L=v++;w[L]="[v=\\s]*("+w[t]+")(?:\\.("+w[t]+")(?:\\.("+w[t]+")(?:"+w[d]+")?"+w[$]+"?)?)?";var D=v++;w[D]="^"+w[s]+"\\s*"+w[g]+"$";var y=v++;w[y]="^"+w[s]+"\\s*"+w[L]+"$";var A=v++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=v++;w[F]="(?:~>?)";var X=v++;w[X]="(\\s*)"+w[F]+"\\s+",P[X]=new RegExp(w[X],"g");var te=v++;w[te]="^"+w[F]+w[g]+"$";var J=v++;w[J]="^"+w[F]+w[L]+"$";var ie=v++;w[ie]="(?:\\^)";var ee=v++;w[ee]="(\\s*)"+w[ie]+"\\s+",P[ee]=new RegExp(w[ee],"g");var U=v++;w[U]="^"+w[ie]+w[g]+"$";var he=v++;w[he]="^"+w[ie]+w[L]+"$";var Q=v++;w[Q]="^"+w[s]+"\\s*("+i+")$|^$";var _=v++;w[_]="^"+w[s]+"\\s*("+n+")$|^$";var V=v++;w[V]="(\\s*)"+w[s]+"\\s*("+i+"|"+w[g]+")",P[V]=new RegExp(w[V],"g");var G=v++;w[G]="^\\s*("+w[g]+")\\s+-\\s+("+w[g]+")\\s*$";var oe=v++;w[oe]="^\\s*("+w[L]+")\\s+-\\s+("+w[L]+")\\s*$";var le=v++;w[le]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)r(se,w[se]),P[se]||(P[se]=new RegExp(w[se]));function $e(me,De){if(me instanceof z)return me;if(typeof me!="string"||me.length>C||!(De?P[o]:P[h]).test(me))return null;try{return new z(me,De)}catch{return null}}function z(me,De){if(me instanceof z){if(me.loose===De)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>C)throw new TypeError("version is longer than "+C+" characters");if(!(this instanceof z))return new z(me,De);r("SemVer",me,De),this.loose=De;var Ee=me.trim().match(De?P[o]:P[h]);if(!Ee)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ee[1],this.minor=+Ee[2],this.patch=+Ee[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");Ee[4]?this.prerelease=Ee[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var je=+Me;if(je>=0&&je<S)return je}return Me}):this.prerelease=[],this.build=Ee[5]?Ee[5].split("."):[],this.format()}e.parse=$e,e.valid=function(me,De){var Ee=$e(me,De);return Ee?Ee.version:null},e.clean=function(me,De){var Ee=$e(me.trim().replace(/^[=v]+/,""),De);return Ee?Ee.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(me){return r("SemVer.compare",this.version,this.loose,me),me instanceof z||(me=new z(me,this.loose)),this.compareMain(me)||this.comparePre(me)},z.prototype.compareMain=function(me){return me instanceof z||(me=new z(me,this.loose)),O(this.major,me.major)||O(this.minor,me.minor)||O(this.patch,me.patch)},z.prototype.comparePre=function(me){if(me instanceof z||(me=new z(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var De=0;do{var Ee=this.prerelease[De],Me=me.prerelease[De];if(r("prerelease compare",De,Ee,Me),Ee===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(Ee===void 0)return-1;if(Ee!==Me)return O(Ee,Me)}while(++De)},z.prototype.inc=function(me,De){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",De);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",De);break;case"prepatch":this.prerelease.length=0,this.inc("patch",De),this.inc("pre",De);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",De),this.inc("pre",De);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ee=this.prerelease.length;--Ee>=0;)typeof this.prerelease[Ee]=="number"&&(this.prerelease[Ee]++,Ee=-2);Ee===-1&&this.prerelease.push(0)}De&&(this.prerelease[0]===De?isNaN(this.prerelease[1])&&(this.prerelease=[De,0]):this.prerelease=[De,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,De,Ee,Me){typeof Ee=="string"&&(Me=Ee,Ee=void 0);try{return new z(me,Ee).inc(De,Me).version}catch{return null}},e.diff=function(me,De){if(Z(me,De))return null;var Ee=$e(me),Me=$e(De);if(Ee.prerelease.length||Me.prerelease.length){for(var je in Ee)if((je==="major"||je==="minor"||je==="patch")&&Ee[je]!==Me[je])return"pre"+je;return"prerelease"}for(var je in Ee)if((je==="major"||je==="minor"||je==="patch")&&Ee[je]!==Me[je])return je},e.compareIdentifiers=O;var q=/^[0-9]+$/;function O(me,De){var Ee=q.test(me),Me=q.test(De);return Ee&&Me&&(me=+me,De=+De),Ee&&!Me?-1:Me&&!Ee?1:me<De?-1:me>De?1:0}function j(me,De,Ee){return new z(me,Ee).compare(new z(De,Ee))}function ne(me,De,Ee){return j(me,De,Ee)>0}function Y(me,De,Ee){return j(me,De,Ee)<0}function Z(me,De,Ee){return j(me,De,Ee)===0}function B(me,De,Ee){return j(me,De,Ee)!==0}function H(me,De,Ee){return j(me,De,Ee)>=0}function T(me,De,Ee){return j(me,De,Ee)<=0}function W(me,De,Ee,Me){var je;switch(De){case"===":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),je=me===Ee;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ee=="object"&&(Ee=Ee.version),je=me!==Ee;break;case"":case"=":case"==":je=Z(me,Ee,Me);break;case"!=":je=B(me,Ee,Me);break;case">":je=ne(me,Ee,Me);break;case">=":je=H(me,Ee,Me);break;case"<":je=Y(me,Ee,Me);break;case"<=":je=T(me,Ee,Me);break;default:throw new TypeError("Invalid operator: "+De)}return je}function x(me,De){if(me instanceof x){if(me.loose===De)return me;me=me.value}if(!(this instanceof x))return new x(me,De);r("comparator",me,De),this.loose=De,this.parse(me),this.semver===re?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(me,De){return O(De,me)},e.major=function(me,De){return new z(me,De).major},e.minor=function(me,De){return new z(me,De).minor},e.patch=function(me,De){return new z(me,De).patch},e.compare=j,e.compareLoose=function(me,De){return j(me,De,!0)},e.rcompare=function(me,De,Ee){return j(De,me,Ee)},e.sort=function(me,De){return me.sort(function(Ee,Me){return e.compare(Ee,Me,De)})},e.rsort=function(me,De){return me.sort(function(Ee,Me){return e.rcompare(Ee,Me,De)})},e.gt=ne,e.lt=Y,e.eq=Z,e.neq=B,e.gte=H,e.lte=T,e.cmp=W,e.Comparator=x;var re={};function fe(me,De){if(me instanceof fe)return me.loose===De?me:new fe(me.raw,De);if(me instanceof x)return new fe(me.value,De);if(!(this instanceof fe))return new fe(me,De);if(this.loose=De,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ee){return this.parseRange(Ee.trim())},this).filter(function(Ee){return Ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function ce(me){return!me||me.toLowerCase()==="x"||me==="*"}function ge(me,De,Ee,Me,je,We,He,Qe,Ye,et,pe,Se,Ae){return((De=ce(Ee)?"":ce(Me)?">="+Ee+".0.0":ce(je)?">="+Ee+"."+Me+".0":">="+De)+" "+(Qe=ce(Ye)?"":ce(et)?"<"+(+Ye+1)+".0.0":ce(pe)?"<"+Ye+"."+(+et+1)+".0":Se?"<="+Ye+"."+et+"."+pe+"-"+Se:"<="+Qe)).trim()}function ye(me,De){for(var Ee=0;Ee<me.length;Ee++)if(!me[Ee].test(De))return!1;if(De.prerelease.length){for(Ee=0;Ee<me.length;Ee++)if(r(me[Ee].semver),me[Ee].semver!==re&&me[Ee].semver.prerelease.length>0){var Me=me[Ee].semver;if(Me.major===De.major&&Me.minor===De.minor&&Me.patch===De.patch)return!0}return!1}return!0}function Ie(me,De,Ee){try{De=new fe(De,Ee)}catch{return!1}return De.test(me)}function Re(me,De,Ee,Me){var je,We,He,Qe,Ye;switch(me=new z(me,Me),De=new fe(De,Me),Ee){case">":je=ne,We=T,He=Y,Qe=">",Ye=">=";break;case"<":je=Y,We=H,He=ne,Qe="<",Ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ie(me,De,Me))return!1;for(var et=0;et<De.set.length;++et){var pe=De.set[et],Se=null,Ae=null;if(pe.forEach(function(Oe){Oe.semver===re&&(Oe=new x(">=0.0.0")),Se=Se||Oe,Ae=Ae||Oe,je(Oe.semver,Se.semver,Me)?Se=Oe:He(Oe.semver,Ae.semver,Me)&&(Ae=Oe)}),Se.operator===Qe||Se.operator===Ye||(!Ae.operator||Ae.operator===Qe)&&We(me,Ae.semver)||Ae.operator===Ye&&He(me,Ae.semver))return!1}return!0}x.prototype.parse=function(me){var De=this.loose?P[Q]:P[_],Ee=me.match(De);if(!Ee)throw new TypeError("Invalid comparator: "+me);this.operator=Ee[1],this.operator==="="&&(this.operator=""),Ee[2]?this.semver=new z(Ee[2],this.loose):this.semver=re},x.prototype.toString=function(){return this.value},x.prototype.test=function(me){return r("Comparator.test",me,this.loose),this.semver===re||(typeof me=="string"&&(me=new z(me,this.loose)),W(me,this.operator,this.semver,this.loose))},x.prototype.intersects=function(me,De){if(!(me instanceof x))throw new TypeError("a Comparator is required");var Ee;if(this.operator==="")return Ee=new fe(me.value,De),Ie(this.value,Ee,De);if(me.operator==="")return Ee=new fe(this.value,De),Ie(me.semver,Ee,De);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),We=this.semver.version===me.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Qe=W(this.semver,"<",me.semver,De)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Ye=W(this.semver,">",me.semver,De)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||je||We&&He||Qe||Ye},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(me){var De=this.loose;me=me.trim(),r("range",me,De);var Ee=De?P[oe]:P[G];me=me.replace(Ee,ge),r("hyphen replace",me),me=me.replace(P[V],"$1$2$3"),r("comparator trim",me,P[V]),me=(me=(me=me.replace(P[X],"$1~")).replace(P[ee],"$1^")).split(/\s+/).join(" ");var Me=De?P[Q]:P[_],je=me.split(" ").map(function(We){return function(He,Qe){return r("comp",He),He=function(Ye,et){return Ye.trim().split(/\s+/).map(function(pe){return function(Se,Ae){r("caret",Se,Ae);var Oe=Ae?P[he]:P[U];return Se.replace(Oe,function(Be,Te,qe,Je,Ge){var Ze;return r("caret",Se,Be,Te,qe,Je,Ge),ce(Te)?Ze="":ce(qe)?Ze=">="+Te+".0.0 <"+(+Te+1)+".0.0":ce(Je)?Ze=Te==="0"?">="+Te+"."+qe+".0 <"+Te+"."+(+qe+1)+".0":">="+Te+"."+qe+".0 <"+(+Te+1)+".0.0":Ge?(r("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=Te==="0"?qe==="0"?">="+Te+"."+qe+"."+Je+Ge+" <"+Te+"."+qe+"."+(+Je+1):">="+Te+"."+qe+"."+Je+Ge+" <"+Te+"."+(+qe+1)+".0":">="+Te+"."+qe+"."+Je+Ge+" <"+(+Te+1)+".0.0"):(r("no pr"),Ze=Te==="0"?qe==="0"?">="+Te+"."+qe+"."+Je+" <"+Te+"."+qe+"."+(+Je+1):">="+Te+"."+qe+"."+Je+" <"+Te+"."+(+qe+1)+".0":">="+Te+"."+qe+"."+Je+" <"+(+Te+1)+".0.0"),r("caret return",Ze),Ze})}(pe,et)}).join(" ")}(He,Qe),r("caret",He),He=function(Ye,et){return Ye.trim().split(/\s+/).map(function(pe){return function(Se,Ae){var Oe=Ae?P[J]:P[te];return Se.replace(Oe,function(Be,Te,qe,Je,Ge){var Ze;return r("tilde",Se,Be,Te,qe,Je,Ge),ce(Te)?Ze="":ce(qe)?Ze=">="+Te+".0.0 <"+(+Te+1)+".0.0":ce(Je)?Ze=">="+Te+"."+qe+".0 <"+Te+"."+(+qe+1)+".0":Ge?(r("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),Ze=">="+Te+"."+qe+"."+Je+Ge+" <"+Te+"."+(+qe+1)+".0"):Ze=">="+Te+"."+qe+"."+Je+" <"+Te+"."+(+qe+1)+".0",r("tilde return",Ze),Ze})}(pe,et)}).join(" ")}(He,Qe),r("tildes",He),He=function(Ye,et){return r("replaceXRanges",Ye,et),Ye.split(/\s+/).map(function(pe){return function(Se,Ae){Se=Se.trim();var Oe=Ae?P[y]:P[D];return Se.replace(Oe,function(Be,Te,qe,Je,Ge,Ze){r("xRange",Se,Be,Te,qe,Je,Ge,Ze);var nt=ce(qe),Xe=nt||ce(Je),it=Xe||ce(Ge);return Te==="="&&it&&(Te=""),nt?Be=Te===">"||Te==="<"?"<0.0.0":"*":Te&&it?(Xe&&(Je=0),it&&(Ge=0),Te===">"?(Te=">=",Xe?(qe=+qe+1,Je=0,Ge=0):it&&(Je=+Je+1,Ge=0)):Te==="<="&&(Te="<",Xe?qe=+qe+1:Je=+Je+1),Be=Te+qe+"."+Je+"."+Ge):Xe?Be=">="+qe+".0.0 <"+(+qe+1)+".0.0":it&&(Be=">="+qe+"."+Je+".0 <"+qe+"."+(+Je+1)+".0"),r("xRange return",Be),Be})}(pe,et)}).join(" ")}(He,Qe),r("xrange",He),He=function(Ye,et){return r("replaceStars",Ye,et),Ye.trim().replace(P[le],"")}(He,Qe),r("stars",He),He}(We,De)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(We){return!!We.match(Me)})),je=je.map(function(We){return new x(We,De)})},fe.prototype.intersects=function(me,De){if(!(me instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(Ee){return Ee.every(function(Me){return me.set.some(function(je){return je.every(function(We){return Me.intersects(We,De)})})})})},e.toComparators=function(me,De){return new fe(me,De).set.map(function(Ee){return Ee.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new z(me,this.loose));for(var De=0;De<this.set.length;De++)if(ye(this.set[De],me))return!0;return!1},e.satisfies=Ie,e.maxSatisfying=function(me,De,Ee){var Me=null,je=null;try{var We=new fe(De,Ee)}catch{return null}return me.forEach(function(He){We.test(He)&&(Me&&je.compare(He)!==-1||(je=new z(Me=He,Ee)))}),Me},e.minSatisfying=function(me,De,Ee){var Me=null,je=null;try{var We=new fe(De,Ee)}catch{return null}return me.forEach(function(He){We.test(He)&&(Me&&je.compare(He)!==1||(je=new z(Me=He,Ee)))}),Me},e.validRange=function(me,De){try{return new fe(me,De).range||"*"}catch{return null}},e.ltr=function(me,De,Ee){return Re(me,De,"<",Ee)},e.gtr=function(me,De,Ee){return Re(me,De,">",Ee)},e.outside=Re,e.prerelease=function(me,De){var Ee=$e(me,De);return Ee&&Ee.prerelease.length?Ee.prerelease:null},e.intersects=function(me,De,Ee){return me=new fe(me,Ee),De=new fe(De,Ee),me.intersects(De)},e.coerce=function(me){if(me instanceof z)return me;if(typeof me!="string")return null;var De=me.match(P[A]);return De==null?null:$e((De[1]||"0")+"."+(De[2]||"0")+"."+(De[3]||"0"))}}).call(this,E(1))},function(ue,e){var E,R,r=ue.exports={};function C(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function P(m){if(E===setTimeout)return setTimeout(m,0);if((E===C||!E)&&setTimeout)return E=setTimeout,setTimeout(m,0);try{return E(m,0)}catch{try{return E.call(null,m,0)}catch{return E.call(this,m,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:C}catch{E=C}try{R=typeof clearTimeout=="function"?clearTimeout:S}catch{R=S}})();var w,v=[],I=!1,k=-1;function b(){I&&w&&(I=!1,w.length?v=w.concat(v):k=-1,v.length&&f())}function f(){if(!I){var m=P(b);I=!0;for(var u=v.length;u;){for(w=v,v=[];++k<u;)w&&w[k].run();k=-1,u=v.length}w=null,I=!1,function(d){if(R===clearTimeout)return clearTimeout(d);if((R===S||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(d);try{R(d)}catch{try{return R.call(null,d)}catch{return R.call(this,d)}}}(m)}}function p(m,u){this.fun=m,this.array=u}function c(){}r.nextTick=function(m){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];v.push(new p(m,u)),v.length!==1||I||P(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=c,r.addListener=c,r.once=c,r.off=c,r.removeListener=c,r.removeAllListeners=c,r.emit=c,r.prependListener=c,r.prependOnceListener=c,r.listeners=function(m){return[]},r.binding=function(m){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(m){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(be[146],ve([1,0]),function(ue,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class R{constructor(P,w,v){this.level=P,this.key=w,this.value=v,this.forward=[]}}const r=void 0;class C{constructor(P,w=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new R(this.c,r,r)}get size(){return this.f}clear(){this.e=new R(this.c,r,r),this.f=0}has(P){return!!C.g(this,P,this.comparator)}get(P){return C.g(this,P,this.comparator)?.value}set(P,w){return C.h(this,P,w,this.comparator)&&(this.f+=1),this}delete(P){const w=C.k(this,P,this.comparator);return w&&(this.f-=1),w}forEach(P,w){let v=this.e.forward[0];for(;v;)P.call(w,v.value,v.key,this),v=v.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this.e.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static g(P,w,v){let I=P.e;for(let k=P.d-1;k>=0;k--)for(;I.forward[k]&&v(I.forward[k].key,w)<0;)I=I.forward[k];if(I=I.forward[0],I&&v(I.key,w)===0)return I}static h(P,w,v,I){const k=[];let b=P.e;for(let f=P.d-1;f>=0;f--){for(;b.forward[f]&&I(b.forward[f].key,w)<0;)b=b.forward[f];k[f]=b}if(b=b.forward[0],b&&I(b.key,w)===0)return b.value=v,!1;{const f=C.j(P);if(f>P.d){for(let p=P.d;p<f;p++)k[p]=P.e;P.d=f}b=new R(f,w,v);for(let p=0;p<f;p++)b.forward[p]=k[p].forward[p],k[p].forward[p]=b;return!0}}static j(P,w=.5){let v=1;for(;Math.random()<w&&v<P.c;)v+=1;return v}static k(P,w,v){const I=[];let k=P.e;for(let b=P.d-1;b>=0;b--){for(;k.forward[b]&&v(k.forward[b].key,w)<0;)k=k.forward[b];I[b]=k}if(k=k.forward[0],!k||v(k.key,w)!==0)return!1;for(let b=0;b<P.d&&I[b].forward[b]===k;b++)I[b].forward[b]=k.forward[b];for(;P.d>0&&P.e.forward[P.d-1]===r;)P.d-=1;return!0}}e.$Lr=C}),define(be[60],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(C){return new R(C)}constructor(C){this.c=E&&C===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=R}),define(be[5],ve([1,0,11,75,2,97,60]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const P=!1,w=!1;var v;(function(D){D.None=()=>r.$Sc.None;function y(W){if(w){const{onDidAddListener:x}=W,re=p.create();let fe=0;W.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),x?.()}}}function A(W,x){return _(W,()=>{},0,void 0,!0,void 0,x)}D.defer=A;function F(W){return(x,re=null,fe)=>{let ce=!1,ge;return ge=W(ye=>{if(!ce)return ge?ge.dispose():ce=!0,x.call(re,ye)},null,fe),ce&&ge.dispose(),ge}}D.once=F;function X(W,x,re){return he((fe,ce=null,ge)=>W(ye=>fe.call(ce,x(ye)),null,ge),re)}D.map=X;function te(W,x,re){return he((fe,ce=null,ge)=>W(ye=>{x(ye),fe.call(ce,ye)},null,ge),re)}D.forEach=te;function J(W,x,re){return he((fe,ce=null,ge)=>W(ye=>x(ye)&&fe.call(ce,ye),null,ge),re)}D.filter=J;function ie(W){return W}D.signal=ie;function ee(...W){return(x,re=null,fe)=>{const ce=(0,r.$Pc)(...W.map(ge=>ge(ye=>x.call(re,ye))));return Q(ce,fe)}}D.any=ee;function U(W,x,re,fe){let ce=re;return X(W,ge=>(ce=x(ce,ge),ce),fe)}D.reduce=U;function he(W,x){let re;const fe={onWillAddFirstListener(){re=W(ce.fire,ce)},onDidRemoveLastListener(){re?.dispose()}};x||y(fe);const ce=new l(fe);return x?.add(ce),ce.event}function Q(W,x){return x instanceof Array?x.push(W):x&&x.add(W),W}function _(W,x,re=100,fe=!1,ce=!1,ge,ye){let Ie,Re,me,De=0,Ee;const Me={leakWarningThreshold:ge,onWillAddFirstListener(){Ie=W(We=>{De++,Re=x(Re,We),fe&&!me&&(je.fire(Re),Re=void 0),Ee=()=>{const He=Re;Re=void 0,me=void 0,(!fe||De>1)&&je.fire(He),De=0},typeof re=="number"?(clearTimeout(me),me=setTimeout(Ee,re)):me===void 0&&(me=0,queueMicrotask(Ee))})},onWillRemoveListener(){ce&&De>0&&Ee?.()},onDidRemoveLastListener(){Ee=void 0,Ie.dispose()}};ye||y(Me);const je=new l(Me);return ye?.add(je),je.event}D.debounce=_;function V(W,x=0,re){return D.debounce(W,(fe,ce)=>fe?(fe.push(ce),fe):[ce],x,void 0,!0,void 0,re)}D.accumulate=V;function G(W,x=(fe,ce)=>fe===ce,re){let fe=!0,ce;return J(W,ge=>{const ye=fe||!x(ge,ce);return fe=!1,ce=ge,ye},re)}D.latch=G;function oe(W,x,re){return[D.filter(W,x,re),D.filter(W,fe=>!x(fe),re)]}D.split=oe;function le(W,x=!1,re=[],fe){let ce=re.slice(),ge=W(Re=>{ce?ce.push(Re):Ie.fire(Re)});fe&&fe.add(ge);const ye=()=>{ce?.forEach(Re=>Ie.fire(Re)),ce=null},Ie=new l({onWillAddFirstListener(){ge||(ge=W(Re=>Ie.fire(Re)),fe&&fe.add(ge))},onDidAddFirstListener(){ce&&(x?setTimeout(ye):ye())},onDidRemoveLastListener(){ge&&ge.dispose(),ge=null}});return fe&&fe.add(Ie),Ie.event}D.buffer=le;function se(W,x){return(fe,ce,ge)=>{const ye=x(new z);return W(function(Ie){const Re=ye.evaluate(Ie);Re!==$e&&fe.call(ce,Re)},void 0,ge)}}D.chain=se;const $e=Symbol("HaltChainable");class z{constructor(){this.f=[]}map(x){return this.f.push(x),this}forEach(x){return this.f.push(re=>(x(re),re)),this}filter(x){return this.f.push(re=>x(re)?re:$e),this}reduce(x,re){let fe=re;return this.f.push(ce=>(fe=x(fe,ce),fe)),this}latch(x=(re,fe)=>re===fe){let re=!0,fe;return this.f.push(ce=>{const ge=re||!x(ce,fe);return re=!1,fe=ce,ge?ce:$e}),this}evaluate(x){for(const re of this.f)if(x=re(x),x===$e)break;return x}}function q(W,x,re=fe=>fe){const fe=(...Ie)=>ye.fire(re(...Ie)),ce=()=>W.on(x,fe),ge=()=>W.removeListener(x,fe),ye=new l({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return ye.event}D.fromNodeEventEmitter=q;function O(W,x,re=fe=>fe){const fe=(...Ie)=>ye.fire(re(...Ie)),ce=()=>W.addEventListener(x,fe),ge=()=>W.removeEventListener(x,fe),ye=new l({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return ye.event}D.fromDOMEventEmitter=O;function j(W){return new Promise(x=>F(W)(x))}D.toPromise=j;function ne(W){const x=new l;return W.then(re=>{x.fire(re)},()=>{x.fire(void 0)}).finally(()=>{x.dispose()}),x.event}D.fromPromise=ne;function Y(W,x,re){return x(re),W(fe=>x(fe))}D.runAndSubscribe=Y;function Z(W,x){let re=null;function fe(ge){re?.dispose(),re=new r.$Rc,x(ge,re)}fe(void 0);const ce=W(ge=>fe(ge));return(0,r.$Qc)(()=>{ce.dispose(),re?.dispose()})}D.runAndSubscribeWithStore=Z;class B{constructor(x,re){this._observable=x,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};re||y(fe),this.emitter=new l(fe),re&&re.add(this.emitter)}beginUpdate(x){this.f++}handlePossibleChange(x){}handleChange(x,re){this.g=!0}endUpdate(x){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function H(W,x){return new B(W,x).emitter.event}D.fromObservable=H;function T(W){return(x,re,fe)=>{let ce=0,ge=!1;const ye={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(W.reportChanges(),ge&&(ge=!1,x.call(re)))},handlePossibleChange(){},handleChange(){ge=!0}};W.addObserver(ye),W.reportChanges();const Ie={dispose(){W.removeObserver(ye)}};return fe instanceof r.$Rc?fe.add(Ie):Array.isArray(fe)&&fe.push(Ie),Ie}}D.fromObservableLight=T})(v||(e.Event=v={}));class I{static{this.all=new Set}static{this.f=0}constructor(y){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${y}_${I.f++}`,I.all.add(this)}start(y){this.g=new S.$Od,this.listenerCount=y}stop(){if(this.g){const y=this.g.elapsed();this.durations.push(y),this.elapsedOverall+=y,this.invocationCount+=1,this.g=void 0}}}e.$Qd=I;let k=-1;function b(D){const y=k;return k=D,{dispose(){k=y}}}e.$Rd=b;class f{constructor(y,A=Math.random().toString(18).slice(2,5)){this.threshold=y,this.name=A,this.g=0}dispose(){this.f?.clear()}check(y,A){const F=this.threshold;if(F<=0||A<F)return;this.f||(this.f=new Map);const X=this.f.get(y.value)||0;if(this.f.set(y.value,X+1),this.g-=1,this.g<=0){this.g=F*.5;let te,J=0;for(const[ie,ee]of this.f)(!te||J<ee)&&(te=ie,J=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${J}):`),console.warn(te)}return()=>{const te=this.f.get(y.value)||0;this.f.set(y.value,te-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(y){this.value=y}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class m{constructor(y){this.value=y,this.id=c++}}const u=2,d=(D,y)=>{if(D instanceof m)y(D);else for(let A=0;A<D.length;A++){const F=D[A];F&&y(F)}};class l{constructor(y){this.w=0,this.f=y,this.g=k>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const y=this.t;queueMicrotask(()=>{d(y,A=>A.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(y,A,F)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Sc.None;if(this.m)return r.$Sc.None;A&&(y=y.bind(A));const X=new m(y);let te,J;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=p.create(),te=this.g.check(X.stack,this.w+1)),P&&(X.stack=J??p.create()),this.t?this.t instanceof m?(this.u??=new h,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const ie=(0,r.$Qc)(()=>{te?.(),this.x(X)});return F instanceof r.$Rc?F.add(ie):Array.isArray(F)&&F.push(ie),ie},this.q}x(y){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const A=this.t,F=A.indexOf(y);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,A[F]=void 0;const X=this.u.current===this;if(this.w*u<=A.length){let te=0;for(let J=0;J<A.length;J++)A[J]?A[te++]=A[J]:X&&(this.u.end--,te<this.u.i&&this.u.i--);A.length=te}}y(y,A){if(!y)return;const F=this.f?.onListenerError||E.$1;if(!F){y.value(A);return}try{y.value(A)}catch(X){F(X)}}z(y){const A=y.current.t;for(;y.i<y.end;)this.y(A[y.i++],y.value);y.reset()}fire(y){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,y);else{const A=this.u;A.enqueue(this,y,this.t.length),this.z(A)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=l;const $=()=>new h;e.$Td=$;class h{constructor(){this.i=-1,this.end=0}enqueue(y,A,F){this.i=0,this.end=F,this.current=y,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends l{async fireAsync(y,A,F){if(this.t)for(this.h||(this.h=new C.$3c),d(this.t,X=>this.h.push([X.value,y]));this.h.size>0&&!A.isCancellationRequested;){const[X,te]=this.h.shift(),J=[],ie={...te,token:A,waitUntil:ee=>{if(Object.isFrozen(J))throw new Error("waitUntil can NOT be called asynchronous");F&&(ee=F(ee,X)),J.push(ee)}};try{X(ie)}catch(ee){(0,E.$1)(ee);continue}Object.freeze(J),await Promise.allSettled(J).then(ee=>{for(const U of ee)U.status==="rejected"&&(0,E.$1)(U.reason)})}}}e.$Ud=n;class i extends l{get isPaused(){return this.h!==0}constructor(y){super(y),this.h=0,this.s=new C.$3c,this.A=y?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const y=Array.from(this.s);this.s.clear(),super.fire(this.A(y))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(y){this.w&&(this.h!==0?this.s.push(y):super.fire(y))}}e.$Vd=i;class o extends i{constructor(y){super(y),this.k=y.delay??100}fire(y){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(y)}}e.$Wd=o;class s extends l{constructor(y){super(y),this.h=[],this.k=y?.merge}fire(y){this.hasListeners()&&(this.h.push(y),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$Xd=s;class t{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(y){const A={event:y,listener:null};this.h.push(A),this.g&&this.m(A);const F=()=>{this.g&&this.o(A);const X=this.h.indexOf(A);this.h.splice(X,1)};return(0,r.$Qc)((0,R.$db)(F))}j(){this.g=!0,this.h.forEach(y=>this.m(y))}k(){this.g=!1,this.h.forEach(y=>this.o(y))}m(y){y.listener=y.event(A=>this.f.fire(A))}o(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.f.dispose()}}e.$Yd=t;class a{constructor(y,A,F,X){this.f=new r.$Rc;const te=this.f.add(new t),J=this.f.add(new r.$2c);function ie(ee){J.set(ee,te.add(X(ee)))}for(const ee of y)ie(ee);this.f.add(A(ee=>{ie(ee)})),this.f.add(F(ee=>{J.deleteAndDispose(ee)})),this.event=te.event}dispose(){this.f.dispose()}}e.$Zd=a;class g{constructor(){this.f=[]}wrapEvent(y){return(A,F,X)=>y(te=>{const J=this.f[this.f.length-1];J?J.push(()=>A.call(F,te)):A.call(F,te)},void 0,X)}bufferEvents(y){const A=[];this.f.push(A);const F=y();return this.f.pop(),A.forEach(X=>X()),F}}e.$1d=g;class L{constructor(){this.f=!1,this.g=v.None,this.h=r.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(y){this.g=y,this.f&&(this.h.dispose(),this.h=y(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=L}),define(be[20],ve([1,0,5]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const R=Object.freeze(function(P,w){const v=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(v)}}});var r;(function(P){function w(v){return v===P.None||v===P.Cancelled||v instanceof C?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(r||(e.CancellationToken=r={}));class C{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new E.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new C),this.f}cancel(){this.f?this.f instanceof C&&this.f.cancel():this.f=r.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof C&&this.f.dispose():this.f=r.None}}e.$3d=S}),define(be[147],ve([1,0,20]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.$3d,w=this.b(P.token);return this.a={promise:w,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Be=R;class r{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const w=JSON.stringify(P);return this.b!==w&&(this.b=w,this.a=this.c(P)),this.a}}e.$Ce=r;class C{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const w=this.b(P);return this.a.set(P,w),w}}e.$De=C}),define(be[48],ve([1,0,11,2]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function r($){const h=$;return h?typeof h.read=="function":!1}e.$4d=r;function C($){const h=$;return h?[h.on,h.pause,h.resume,h.destroy].every(n=>typeof n=="function"):!1}e.$5d=C;function S($){const h=$;return h?C(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=S;function P($,h){return new w($,h)}e.$7d=P;class w{constructor(h,n){this.e=h,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(n=>n(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(n=>n(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,n){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(h,n){if(this.a.destroyed)return;let i;switch(h){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(n);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v($,h){const n=[];let i;for(;(i=$.read())!==null;)n.push(i);return h(n)}e.$8d=v;function I($,h,n){const i=[];let o;for(;(o=$.read())!==null&&i.length<n;)i.push(o);return o===null&&i.length>0?h(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return $.read()}}}e.$9d=I;function k($,h){return new Promise((n,i)=>{const o=[];b($,{onData:s=>{h&&o.push(s)},onError:s=>{h?i(s):n(void 0)},onEnd:()=>{n(h?h(o):void 0)}})})}e.$0d=k;function b($,h,n){$.on("error",i=>{n?.isCancellationRequested||h.onError(i)}),$.on("end",()=>{n?.isCancellationRequested||h.onEnd()}),$.on("data",i=>{n?.isCancellationRequested||h.onData(i)})}e.$$d=b;function f($,h){return new Promise((n,i)=>{const o=new R.$Rc,s=[],t=L=>{if(s.push(L),s.length>h)return o.dispose(),$.pause(),n({stream:$,buffer:s,ended:!1})},a=L=>(o.dispose(),i(L)),g=()=>(o.dispose(),n({stream:$,buffer:s,ended:!0}));o.add((0,R.$Qc)(()=>$.removeListener("error",a))),$.on("error",a),o.add((0,R.$Qc)(()=>$.removeListener("end",g))),$.on("end",g),o.add((0,R.$Qc)(()=>$.removeListener("data",t))),$.on("data",t)})}e.$_d=f;function p($,h){const n=P(h);return n.end($),n}e.$ae=p;function c(){const $=P(()=>{throw new Error("not supported")});return $.end(),$}e.$be=c;function m($){let h=!1;return{read:()=>h?null:(h=!0,$)}}e.$ce=m;function u($,h,n){const i=P(n);return b($,{onData:o=>i.write(h.data(o)),onError:o=>i.error(h.error?h.error(o):o),onEnd:()=>i.end()}),i}e.$de=u;function d($,h,n){let i=!1;return{read:()=>{const o=h.read();return i?o:(i=!0,o!==null?n([$,o]):$)}}}e.$ee=d;function l($,h,n){let i=!1;const o=P(n);return b(h,{onData:s=>i?o.write(s):(i=!0,o.write(n([$,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write($)),o.end()}}),o}e.$fe=l}),define(be[15],ve([1,0,59,48]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const r=typeof Buffer<"u",C=new E.$V(()=>new Uint8Array(256));let S,P;class w{static alloc(A){return r?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return r&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,F){return!(F?.dontUseNodeBuffer||!1)&&r?new w(Buffer.from(A)):(S||(S=new TextEncoder),new w(S.encode(A)))}static fromByteArray(A){const F=w.alloc(A.length);for(let X=0,te=A.length;X<te;X++)F.buffer[X]=A[X];return F}static concat(A,F){if(typeof F>"u"){F=0;for(let J=0,ie=A.length;J<ie;J++)F+=A[J].byteLength}const X=w.alloc(F);let te=0;for(let J=0,ie=A.length;J<ie;J++){const ee=A[J];X.set(ee,te),te+=ee.byteLength}return X}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return r?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(A,F){return new w(this.buffer.subarray(A,F))}set(A,F){if(A instanceof w)this.buffer.set(A.buffer,F);else if(A instanceof Uint8Array)this.buffer.set(A,F);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),F);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return b(this.buffer,A)}writeUInt32BE(A,F){f(this.buffer,A,F)}readUInt32LE(A){return p(this.buffer,A)}writeUInt32LE(A,F){c(this.buffer,A,F)}readUInt8(A){return m(this.buffer,A)}writeUInt8(A,F){u(this.buffer,A,F)}indexOf(A,F=0){return v(this.buffer,A instanceof w?A.buffer:A,F)}}e.$ge=w;function v(y,A,F=0){const X=A.byteLength,te=y.byteLength;if(X===0)return 0;if(X===1)return y.indexOf(A[0]);if(X>te-F)return-1;const J=C.value;J.fill(A.length);for(let he=0;he<A.length;he++)J[A[he]]=A.length-he-1;let ie=F+A.length-1,ee=ie,U=-1;for(;ie<te;)if(y[ie]===A[ee]){if(ee===0){U=ie;break}ie--,ee--}else ie+=Math.max(A.length-ee,J[y[ie]]),ee=A.length-1;return U}e.$he=v;function I(y,A){return y[A+0]<<0>>>0|y[A+1]<<8>>>0}e.$ie=I;function k(y,A,F){y[F+0]=A&255,A=A>>>8,y[F+1]=A&255}e.$je=k;function b(y,A){return y[A]*2**24+y[A+1]*2**16+y[A+2]*2**8+y[A+3]}e.$ke=b;function f(y,A,F){y[F+3]=A,A=A>>>8,y[F+2]=A,A=A>>>8,y[F+1]=A,A=A>>>8,y[F]=A}e.$le=f;function p(y,A){return y[A+0]<<0>>>0|y[A+1]<<8>>>0|y[A+2]<<16>>>0|y[A+3]<<24>>>0}e.$me=p;function c(y,A,F){y[F+0]=A&255,A=A>>>8,y[F+1]=A&255,A=A>>>8,y[F+2]=A&255,A=A>>>8,y[F+3]=A&255}e.$ne=c;function m(y,A){return y[A]}e.$oe=m;function u(y,A,F){y[F]=A}e.$pe=u;function d(y){return R.$8d(y,A=>w.concat(A))}e.$qe=d;function l(y){return R.$ce(y)}e.$re=l;function $(y){return R.$0d(y,A=>w.concat(A))}e.$se=$;async function h(y){return y.ended?w.concat(y.buffer):w.concat([...y.buffer,await $(y.stream)])}e.$te=h;function n(y){return R.$ae(y,A=>w.concat(A))}e.$ue=n;function i(y){return R.$de(y,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}e.$ve=i;function o(y){return R.$7d(A=>w.concat(A),y)}e.$we=o;function s(y,A){return R.$ee(y,A,F=>w.concat(F))}e.$xe=s;function t(y,A){return R.$fe(y,A,F=>w.concat(F))}e.$ye=t;function a(y){let A=0,F=0,X=0;const te=new Uint8Array(Math.floor(y.length/4*3)),J=ee=>{switch(F){case 3:te[X++]=A|ee,F=0;break;case 2:te[X++]=A|ee>>>2,A=ee<<6,F=3;break;case 1:te[X++]=A|ee>>>4,A=ee<<4,F=2;break;default:A=ee<<2,F=1}};for(let ee=0;ee<y.length;ee++){const U=y.charCodeAt(ee);if(U>=65&&U<=90)J(U-65);else if(U>=97&&U<=122)J(U-97+26);else if(U>=48&&U<=57)J(U-48+52);else if(U===43||U===45)J(62);else if(U===47||U===95)J(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${y[ee]}`)}}const ie=X;for(;F>0;)J(0);return w.wrap(te).slice(0,ie)}e.$ze=a;const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:y},A=!0,F=!1){const X=F?L:g;let te="";const J=y.byteLength%3;let ie=0;for(;ie<y.byteLength-J;ie+=3){const ee=y[ie+0],U=y[ie+1],he=y[ie+2];te+=X[ee>>>2],te+=X[(ee<<4|U>>>4)&63],te+=X[(U<<2|he>>>6)&63],te+=X[he&63]}if(J===1){const ee=y[ie+0];te+=X[ee>>>2],te+=X[ee<<4&63],A&&(te+="==")}else if(J===2){const ee=y[ie+0],U=y[ie+1];te+=X[ee>>>2],te+=X[(ee<<4|U>>>4)&63],te+=X[U<<2&63],A&&(te+="=")}return te}e.$Ae=D}),define(be[17],ve([1,0,147,59]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Df=e.$Cf=e.$Bf=e.$Af=e.GraphemeBreakType=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function r(pe){return!pe||typeof pe!="string"?!0:pe.trim().length===0}e.$Ge=r;const C=/{(\d+)}/g;function S(pe,...Se){return Se.length===0?pe:pe.replace(C,function(Ae,Oe){const Be=parseInt(Oe,10);return isNaN(Be)||Be<0||Be>=Se.length?Ae:Se[Be]})}e.$He=S;const P=/{([^}]+)}/g;function w(pe,Se){return Object.keys(Se).length===0?pe:pe.replace(P,(Ae,Oe)=>Se[Oe]??Ae)}e.$Ie=w;function v(pe){return pe.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}e.$Je=v;function I(pe){return pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=I;function k(pe,Se){let Ae=0;const Oe=Se.charCodeAt(0);for(let Be=pe.length-1;Be>=0;Be--)pe.charCodeAt(Be)===Oe&&Ae++;return Ae}e.$Le=k;function b(pe,Se,Ae="\u2026"){return pe.length<=Se?pe:`${pe.substr(0,Se)}${Ae}`}e.$Me=b;function f(pe,Se,Ae="\u2026"){if(pe.length<=Se)return pe;const Oe=Math.ceil(Se/2)-Ae.length/2,Be=Math.floor(Se/2)-Ae.length/2;return`${pe.substr(0,Oe)}${Ae}${pe.substr(pe.length-Be)}`}e.$Ne=f;function p(pe,Se=" "){const Ae=c(pe,Se);return m(Ae,Se)}e.$Oe=p;function c(pe,Se){if(!pe||!Se)return pe;const Ae=Se.length;if(Ae===0||pe.length===0)return pe;let Oe=0;for(;pe.indexOf(Se,Oe)===Oe;)Oe=Oe+Ae;return pe.substring(Oe)}e.$Pe=c;function m(pe,Se){if(!pe||!Se)return pe;const Ae=Se.length,Oe=pe.length;if(Ae===0||Oe===0)return pe;let Be=Oe,Te=-1;for(;Te=pe.lastIndexOf(Se,Be-1),!(Te===-1||Te+Ae!==Be);){if(Te===0)return"";Be=Te}return pe.substring(0,Be)}e.$Qe=m;function u(pe){return pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Re=u;function d(pe){return pe.replace(/\*/g,"")}e.$Se=d;function l(pe,Se,Ae={}){if(!pe)throw new Error("Cannot create regex from empty string");Se||(pe=I(pe)),Ae.wholeWord&&(/\B/.test(pe.charAt(0))||(pe="\\b"+pe),/\B/.test(pe.charAt(pe.length-1))||(pe=pe+"\\b"));let Oe="";return Ae.global&&(Oe+="g"),Ae.matchCase||(Oe+="i"),Ae.multiline&&(Oe+="m"),Ae.unicode&&(Oe+="u"),new RegExp(pe,Oe)}e.$Te=l;function $(pe){return pe.source==="^"||pe.source==="^$"||pe.source==="$"||pe.source==="^\\s*$"?!1:!!(pe.exec("")&&pe.lastIndex===0)}e.$Ue=$;function h(pe){return pe.split(/\r\n|\r|\n/)}e.$Ve=h;function n(pe){for(let Se=0,Ae=pe.length;Se<Ae;Se++){const Oe=pe.charCodeAt(Se);if(Oe!==32&&Oe!==9)return Se}return-1}e.$We=n;function i(pe,Se=0,Ae=pe.length){for(let Oe=Se;Oe<Ae;Oe++){const Be=pe.charCodeAt(Oe);if(Be!==32&&Be!==9)return pe.substring(Se,Oe)}return pe.substring(Se,Ae)}e.$Xe=i;function o(pe,Se=pe.length-1){for(let Ae=Se;Ae>=0;Ae--){const Oe=pe.charCodeAt(Ae);if(Oe!==32&&Oe!==9)return Ae}return-1}e.$Ye=o;function s(pe,Se,Ae){const Oe=[];let Be=0;for(const Te of pe.matchAll(Se)){if(Oe.push(pe.slice(Be,Te.index)),Te.index===void 0)throw new Error("match.index should be defined");Be=Te.index+Te[0].length,Oe.push(Ae(Te[0],...Te.slice(1),Te.index,pe,Te.groups))}return Oe.push(pe.slice(Be)),Promise.all(Oe).then(Te=>Te.join(""))}e.$Ze=s;function t(pe,Se){return pe<Se?-1:pe>Se?1:0}e.$1e=t;function a(pe,Se,Ae=0,Oe=pe.length,Be=0,Te=Se.length){for(;Ae<Oe&&Be<Te;Ae++,Be++){const Ge=pe.charCodeAt(Ae),Ze=Se.charCodeAt(Be);if(Ge<Ze)return-1;if(Ge>Ze)return 1}const qe=Oe-Ae,Je=Te-Be;return qe<Je?-1:qe>Je?1:0}e.$2e=a;function g(pe,Se){return L(pe,Se,0,pe.length,0,Se.length)}e.$3e=g;function L(pe,Se,Ae=0,Oe=pe.length,Be=0,Te=Se.length){for(;Ae<Oe&&Be<Te;Ae++,Be++){let Ge=pe.charCodeAt(Ae),Ze=Se.charCodeAt(Be);if(Ge===Ze)continue;if(Ge>=128||Ze>=128)return a(pe.toLowerCase(),Se.toLowerCase(),Ae,Oe,Be,Te);y(Ge)&&(Ge-=32),y(Ze)&&(Ze-=32);const nt=Ge-Ze;if(nt!==0)return nt}const qe=Oe-Ae,Je=Te-Be;return qe<Je?-1:qe>Je?1:0}e.$4e=L;function D(pe){return pe>=48&&pe<=57}e.$5e=D;function y(pe){return pe>=97&&pe<=122}e.$6e=y;function A(pe){return pe>=65&&pe<=90}e.$7e=A;function F(pe,Se){return pe.length===Se.length&&L(pe,Se)===0}e.$8e=F;function X(pe,Se){const Ae=Se.length;return Se.length>pe.length?!1:L(pe,Se,0,Ae)===0}e.$9e=X;function te(pe,Se){const Ae=Math.min(pe.length,Se.length);let Oe;for(Oe=0;Oe<Ae;Oe++)if(pe.charCodeAt(Oe)!==Se.charCodeAt(Oe))return Oe;return Ae}e.$0e=te;function J(pe,Se){const Ae=Math.min(pe.length,Se.length);let Oe;const Be=pe.length-1,Te=Se.length-1;for(Oe=0;Oe<Ae;Oe++)if(pe.charCodeAt(Be-Oe)!==Se.charCodeAt(Te-Oe))return Oe;return Ae}e.$$e=J;function ie(pe){return 55296<=pe&&pe<=56319}e.$_e=ie;function ee(pe){return 56320<=pe&&pe<=57343}e.$af=ee;function U(pe,Se){return(pe-55296<<10)+(Se-56320)+65536}e.$bf=U;function he(pe,Se,Ae){const Oe=pe.charCodeAt(Ae);if(ie(Oe)&&Ae+1<Se){const Be=pe.charCodeAt(Ae+1);if(ee(Be))return U(Oe,Be)}return Oe}e.$cf=he;function Q(pe,Se){const Ae=pe.charCodeAt(Se-1);if(ee(Ae)&&Se>1){const Oe=pe.charCodeAt(Se-2);if(ie(Oe))return U(Oe,Ae)}return Ae}class _{get offset(){return this.e}constructor(Se,Ae=0){this.c=Se,this.d=Se.length,this.e=Ae}setOffset(Se){this.e=Se}prevCodePoint(){const Se=Q(this.c,this.e);return this.e-=Se>=65536?2:1,Se}nextCodePoint(){const Se=he(this.c,this.d,this.e);return this.e+=Se>=65536?2:1,Se}eol(){return this.e>=this.d}}e.$df=_;class V{get offset(){return this.c.offset}constructor(Se,Ae=0){this.c=new _(Se,Ae)}nextGraphemeLength(){const Se=Ee.getInstance(),Ae=this.c,Oe=Ae.offset;let Be=Se.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const Te=Ae.offset,qe=Se.getGraphemeBreakType(Ae.nextCodePoint());if(me(Be,qe)){Ae.setOffset(Te);break}Be=qe}return Ae.offset-Oe}prevGraphemeLength(){const Se=Ee.getInstance(),Ae=this.c,Oe=Ae.offset;let Be=Se.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const Te=Ae.offset,qe=Se.getGraphemeBreakType(Ae.prevCodePoint());if(me(qe,Be)){Ae.setOffset(Te);break}Be=qe}return Oe-Ae.offset}eol(){return this.c.eol()}}e.$ef=V;function G(pe,Se){return new V(pe,Se).nextGraphemeLength()}e.$ff=G;function oe(pe,Se){return new V(pe,Se).prevGraphemeLength()}e.$gf=oe;function le(pe,Se){Se>0&&ee(pe.charCodeAt(Se))&&Se--;const Ae=Se+G(pe,Se);return[Ae-oe(pe,Ae),Ae]}e.$hf=le;function se(pe){const Se=new V(pe);let Ae=0;for(;!Se.eol();)Ae++,Se.nextGraphemeLength();return Ae}e.$if=se;let $e;function z(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(pe){return $e||($e=z()),$e.test(pe)}e.$jf=q;const O=/^[\t\n\r\x20-\x7E]*$/;function j(pe){return O.test(pe)}e.$kf=j,e.$lf=/[\u2028\u2029]/;function ne(pe){return e.$lf.test(pe)}e.$mf=ne;function Y(pe){return pe>=11904&&pe<=55215||pe>=63744&&pe<=64255||pe>=65281&&pe<=65374}e.$nf=Y;function Z(pe){return pe>=127462&&pe<=127487||pe===8986||pe===8987||pe===9200||pe===9203||pe>=9728&&pe<=10175||pe===11088||pe===11093||pe>=127744&&pe<=128591||pe>=128640&&pe<=128764||pe>=128992&&pe<=129008||pe>=129280&&pe<=129535||pe>=129648&&pe<=129782}e.$of=Z;function B(pe,Se){if(pe.length<Se)return pe;const Ae=/\b/g;let Oe=0;for(;Ae.test(pe)&&!(pe.length-Ae.lastIndex<Se);)Oe=Ae.lastIndex,Ae.lastIndex+=1;return pe.substring(Oe).replace(/^\s/,"")}e.$pf=B;const H=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,T=/\x1b\].*?\x07/g;function W(pe){return pe&&(pe=pe.replace(H,"").replace(T,"")),pe}e.$qf=W,e.$rf=String.fromCharCode(65279);function x(pe){return!!(pe&&pe.length>0&&pe.charCodeAt(0)===65279)}e.$sf=x;function re(pe){return x(pe)?pe.substr(1):pe}e.$tf=re;function fe(pe,Se){if(!pe||!Se||pe.length<Se.length)return!1;const Ae=Se.length,Oe=pe.toLowerCase();let Be=0,Te=-1;for(;Be<Ae;){const qe=Oe.indexOf(Se[Be],Te+1);if(qe<0)return!1;Te=qe,Be++}return!0}e.$uf=fe;function ce(pe,Se=!1){return pe?(Se&&(pe=pe.replace(/\\./g,"")),pe.toLowerCase()!==pe):!1}e.$vf=ce;function ge(pe){return pe.charAt(0).toUpperCase()+pe.slice(1)}e.$wf=ge;function ye(pe,Se=1){if(Se===0)return"";let Ae=-1;do Ae=pe.indexOf(`
`,Ae+1),Se--;while(Se>0&&Ae>=0);return Ae===-1?pe:(pe[Ae-1]==="\r"&&Ae--,pe.substr(0,Ae))}e.$xf=ye;function Ie(pe){return pe=pe%(2*26),pe<26?String.fromCharCode(97+pe):String.fromCharCode(65+pe-26)}e.$yf=Ie;function Re(pe){return Ee.getInstance().getGraphemeBreakType(pe)}e.$zf=Re;function me(pe,Se){return pe===0?Se!==5&&Se!==7:pe===2&&Se===3?!1:pe===4||pe===2||pe===3||Se===4||Se===2||Se===3?!0:!(pe===8&&(Se===8||Se===9||Se===11||Se===12)||(pe===11||pe===9)&&(Se===9||Se===10)||(pe===12||pe===10)&&Se===10||Se===5||Se===13||Se===7||pe===1||pe===13&&Se===14||pe===6&&Se===6)}var De;(function(pe){pe[pe.Other=0]="Other",pe[pe.Prepend=1]="Prepend",pe[pe.CR=2]="CR",pe[pe.LF=3]="LF",pe[pe.Control=4]="Control",pe[pe.Extend=5]="Extend",pe[pe.Regional_Indicator=6]="Regional_Indicator",pe[pe.SpacingMark=7]="SpacingMark",pe[pe.L=8]="L",pe[pe.V=9]="V",pe[pe.T=10]="T",pe[pe.LV=11]="LV",pe[pe.LVT=12]="LVT",pe[pe.ZWJ=13]="ZWJ",pe[pe.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=Me()}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const Ae=this.d,Oe=Ae.length/3;let Be=1;for(;Be<=Oe;)if(Se<Ae[3*Be])Be=2*Be;else if(Se>Ae[3*Be+1])Be=2*Be+1;else return Ae[3*Be+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(pe,Se){if(pe===0)return 0;const Ae=We(pe,Se);if(Ae!==void 0)return Ae;const Oe=new _(Se,pe);return Oe.prevCodePoint(),Oe.offset}e.$Af=je;function We(pe,Se){const Ae=new _(Se,pe);let Oe=Ae.prevCodePoint();for(;He(Oe)||Oe===65039||Oe===8419;){if(Ae.offset===0)return;Oe=Ae.prevCodePoint()}if(!Z(Oe))return;let Be=Ae.offset;return Be>0&&Ae.prevCodePoint()===8205&&(Be=Ae.offset),Be}function He(pe){return 127995<=pe&&pe<=127999}var Qe;(function(pe){pe[pe.zwj=8205]="zwj",pe[pe.emojiVariantSelector=65039]="emojiVariantSelector",pe[pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$Bf="\xA0";class Ye{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new E.$Ce(Se=>{function Ae(nt){const Xe=new Map;for(let it=0;it<nt.length;it+=2)Xe.set(nt[it],nt[it+1]);return Xe}function Oe(nt,Xe){const it=new Map(nt);for(const[ot,ut]of Xe)it.set(ot,ut);return it}function Be(nt,Xe){if(!nt)return Xe;const it=new Map;for(const[ot,ut]of nt)Xe.has(ot)&&it.set(ot,ut);return it}const Te=this.c.value;let qe=Se.filter(nt=>!nt.startsWith("_")&&nt in Te);qe.length===0&&(qe=["_default"]);let Je;for(const nt of qe){const Xe=Ae(Te[nt]);Je=Be(Je,Xe)}const Ge=Ae(Te._common),Ze=Oe(Ge,Je);return new Ye(Ze)})}static getInstance(Se){return Ye.d.get(Array.from(Se))}static{this.e=new R.$V(()=>Object.keys(Ye.c.value).filter(Se=>!Se.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(Se){this.f=Se}isAmbiguous(Se){return this.f.has(Se)}getPrimaryConfusable(Se){return this.f.get(Se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Cf=Ye;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Se){return et.e().has(Se)}static get codePoints(){return et.e()}}e.$Df=et}),define(be[148],ve([1,0,26,144,17]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function C(...ce){return function(ge,ye){for(let Ie=0,Re=ce.length;Ie<Re;Ie++){const me=ce[Ie](ge,ye);if(me)return me}return null}}e.or=C,e.$Pj=S.bind(void 0,!1),e.$Qj=S.bind(void 0,!0);function S(ce,ge,ye){if(!ye||ye.length<ge.length)return null;let Ie;return ce?Ie=r.$9e(ye,ge):Ie=ye.indexOf(ge)===0,Ie?ge.length>0?[{start:0,end:ge.length}]:[]:null}function P(ce,ge){const ye=ge.toLowerCase().indexOf(ce.toLowerCase());return ye===-1?null:[{start:ye,end:ye+ce.length}]}e.$Rj=P;function w(ce,ge){return v(ce.toLowerCase(),ge.toLowerCase(),0,0)}e.$Sj=w;function v(ce,ge,ye,Ie){if(ye===ce.length)return[];if(Ie===ge.length)return null;if(ce[ye]===ge[Ie]){let Re=null;return(Re=v(ce,ge,ye+1,Ie+1))?$({start:Ie,end:Ie+1},Re):null}return v(ce,ge,ye,Ie+1)}function I(ce){return 97<=ce&&ce<=122}function k(ce){return 65<=ce&&ce<=90}e.$Tj=k;function b(ce){return 48<=ce&&ce<=57}function f(ce){return ce===32||ce===9||ce===10||ce===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ce=>p.add(ce.charCodeAt(0)));function c(ce){return f(ce)||p.has(ce)}function m(ce,ge){return ce===ge||c(ce)&&c(ge)}const u=new Map;function d(ce){if(u.has(ce))return u.get(ce);let ge;const ye=(0,R.$Nj)(ce);return ye&&(ge=ye),u.set(ce,ge),ge}function l(ce){return I(ce)||k(ce)||b(ce)}function $(ce,ge){return ge.length===0?ge=[ce]:ce.end===ge[0].start?ge[0].start=ce.start:ge.unshift(ce),ge}function h(ce,ge){for(let ye=ge;ye<ce.length;ye++){const Ie=ce.charCodeAt(ye);if(k(Ie)||b(Ie)||ye>0&&!l(ce.charCodeAt(ye-1)))return ye}return ce.length}function n(ce,ge,ye,Ie){if(ye===ce.length)return[];if(Ie===ge.length)return null;if(ce[ye]!==ge[Ie].toLowerCase())return null;{let Re=null,me=Ie+1;for(Re=n(ce,ge,ye+1,Ie+1);!Re&&(me=h(ge,me))<ge.length;)Re=n(ce,ge,ye+1,me),me++;return Re===null?null:$({start:Ie,end:Ie+1},Re)}}function i(ce){let ge=0,ye=0,Ie=0,Re=0,me=0;for(let We=0;We<ce.length;We++)me=ce.charCodeAt(We),k(me)&&ge++,I(me)&&ye++,l(me)&&Ie++,b(me)&&Re++;const De=ge/ce.length,Ee=ye/ce.length,Me=Ie/ce.length,je=Re/ce.length;return{upperPercent:De,lowerPercent:Ee,alphaPercent:Me,numericPercent:je}}function o(ce){const{upperPercent:ge,lowerPercent:ye}=ce;return ye===0&&ge>.6}function s(ce){const{upperPercent:ge,lowerPercent:ye,alphaPercent:Ie,numericPercent:Re}=ce;return ye>.2&&ge<.8&&Ie>.6&&Re<.2}function t(ce){let ge=0,ye=0,Ie=0,Re=0;for(let me=0;me<ce.length;me++)Ie=ce.charCodeAt(me),k(Ie)&&ge++,I(Ie)&&ye++,f(Ie)&&Re++;return(ge===0||ye===0)&&Re===0?ce.length<=30:ge<=5}function a(ce,ge){if(!ge||(ge=ge.trim(),ge.length===0)||!t(ce)||ge.length>60)return null;const ye=i(ge);if(!s(ye)){if(!o(ye))return null;ge=ge.toLowerCase()}let Ie=null,Re=0;for(ce=ce.toLowerCase();Re<ge.length&&(Ie=n(ce,ge,0,Re))===null;)Re=h(ge,Re+1);return Ie}e.$Uj=a;function g(ce,ge,ye=!1){if(!ge||ge.length===0)return null;let Ie=null,Re=0;for(ce=ce.toLowerCase(),ge=ge.toLowerCase();Re<ge.length&&(Ie=L(ce,ge,0,Re,ye),Ie===null);)Re=D(ge,Re+1);return Ie}e.$Vj=g;function L(ce,ge,ye,Ie,Re){let me=0;if(ye===ce.length)return[];if(Ie===ge.length)return null;if(!m(ce.charCodeAt(ye),ge.charCodeAt(Ie))){const Me=d(ce.charCodeAt(ye));if(!Me)return null;for(let je=0;je<Me.length;je++)if(!m(Me[je],ge.charCodeAt(Ie+je)))return null;me+=Me.length-1}let De=null,Ee=Ie+me+1;if(De=L(ce,ge,ye+1,Ee,Re),!Re)for(;!De&&(Ee=D(ge,Ee))<ge.length;)De=L(ce,ge,ye+1,Ee,Re),Ee++;if(!De)return null;if(ce.charCodeAt(ye)!==ge.charCodeAt(Ie)){const Me=d(ce.charCodeAt(ye));if(!Me)return De;for(let je=0;je<Me.length;je++)if(Me[je]!==ge.charCodeAt(Ie+je))return De}return $({start:Ie,end:Ie+me+1},De)}function D(ce,ge){for(let ye=ge;ye<ce.length;ye++)if(c(ce.charCodeAt(ye))||ye>0&&c(ce.charCodeAt(ye-1)))return ye;return ce.length}const y=C(e.$Qj,a,P),A=C(e.$Qj,a,w),F=new E.$Dc(1e4);function X(ce,ge,ye=!1){if(typeof ce!="string"||typeof ge!="string")return null;let Ie=F.get(ce);Ie||(Ie=new RegExp(r.$Re(ce),"i"),F.set(ce,Ie));const Re=Ie.exec(ge);return Re?[{start:Re.index,end:Re.index+Re[0].length}]:ye?A(ce,ge):y(ce,ge)}e.$Wj=X;function te(ce,ge){const ye=B(ce,ce.toLowerCase(),0,ge,ge.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ye?ie(ye):null}e.$Xj=te;function J(ce,ge,ye,Ie,Re,me){const De=Math.min(13,ce.length);for(;ye<De;ye++){const Ee=B(ce,ge,ye,Ie,Re,me,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,me]}e.$Yj=J;function ie(ce){if(typeof ce>"u")return[];const ge=[],ye=ce[1];for(let Ie=ce.length-1;Ie>1;Ie--){const Re=ce[Ie]+ye,me=ge[ge.length-1];me&&me.end===Re?me.end=Re+1:ge.push({start:Re,end:Re+1})}return ge}e.$Zj=ie;const ee=128;function U(){const ce=[],ge=[];for(let ye=0;ye<=ee;ye++)ge[ye]=0;for(let ye=0;ye<=ee;ye++)ce.push(ge.slice(0));return ce}function he(ce){const ge=[];for(let ye=0;ye<=ce;ye++)ge[ye]=0;return ge}const Q=he(2*ee),_=he(2*ee),V=U(),G=U(),oe=U(),le=!1;function se(ce,ge,ye,Ie,Re){function me(Ee,Me,je=" "){for(;Ee.length<Me;)Ee=je+Ee;return Ee}let De=` |   |${Ie.split("").map(Ee=>me(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=ye;Ee++)Ee===0?De+=" |":De+=`${ge[Ee-1]}|`,De+=ce[Ee].slice(0,Re+1).map(Me=>me(Me.toString(),3)).join("|")+`
`;return De}function $e(ce,ge,ye,Ie){ce=ce.substr(ge),ye=ye.substr(Ie),console.log(se(G,ce,ce.length,ye,ye.length)),console.log(se(oe,ce,ce.length,ye,ye.length)),console.log(se(V,ce,ce.length,ye,ye.length))}function z(ce,ge){if(ge<0||ge>=ce.length)return!1;const ye=ce.codePointAt(ge);switch(ye){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!r.$of(ye)}}function q(ce,ge){if(ge<0||ge>=ce.length)return!1;switch(ce.charCodeAt(ge)){case 32:case 9:return!0;default:return!1}}function O(ce,ge,ye){return ge[ce]!==ye[ce]}function j(ce,ge,ye,Ie,Re,me,De=!1){for(;ge<ye&&Re<me;)ce[ge]===Ie[Re]&&(De&&(Q[ge]=Re),ge+=1),Re+=1;return ge===ye}e.$1j=j;var ne;(function(ce){ce[ce.Diag=1]="Diag",ce[ce.Left=2]="Left",ce[ce.LeftLeft=3]="LeftLeft"})(ne||(ne={}));var Y;(function(ce){ce.Default=[-100,0];function ge(ye){return!ye||ye.length===2&&ye[0]===-100&&ye[1]===0}ce.isDefault=ge})(Y||(e.FuzzyScore=Y={}));class Z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ge,ye){this.firstMatchCanBeWeak=ge,this.boostFullMatch=ye}}e.$2j=Z;function B(ce,ge,ye,Ie,Re,me,De=Z.default){const Ee=ce.length>ee?ee:ce.length,Me=Ie.length>ee?ee:Ie.length;if(ye>=Ee||me>=Me||Ee-ye>Me-me||!j(ge,ye,Ee,Re,me,Me,!0))return;H(Ee,Me,ye,me,ge,Re);let je=1,We=1,He=ye,Qe=me;const Ye=[!1];for(je=1,He=ye;He<Ee;je++,He++){const Oe=Q[He],Be=_[He],Te=He+1<Ee?_[He+1]:Me;for(We=Oe-me+1,Qe=Oe;Qe<Te;We++,Qe++){let qe=Number.MIN_SAFE_INTEGER,Je=!1;Qe<=Be&&(qe=T(ce,ge,He,ye,Ie,Re,Qe,Me,me,V[je-1][We-1]===0,Ye));let Ge=0;qe!==Number.MAX_SAFE_INTEGER&&(Je=!0,Ge=qe+G[je-1][We-1]);const Ze=Qe>Oe,nt=Ze?G[je][We-1]+(V[je][We-1]>0?-5:0):0,Xe=Qe>Oe+1&&V[je][We-1]>0,it=Xe?G[je][We-2]+(V[je][We-2]>0?-5:0):0;if(Xe&&(!Ze||it>=nt)&&(!Je||it>=Ge))G[je][We]=it,oe[je][We]=3,V[je][We]=0;else if(Ze&&(!Je||nt>=Ge))G[je][We]=nt,oe[je][We]=2,V[je][We]=0;else if(Je)G[je][We]=Ge,oe[je][We]=1,V[je][We]=V[je-1][We-1]+1;else throw new Error("not possible")}}if(le&&$e(ce,ye,Ie,me),!Ye[0]&&!De.firstMatchCanBeWeak)return;je--,We--;const et=[G[je][We],me];let pe=0,Se=0;for(;je>=1;){let Oe=We;do{const Be=oe[je][Oe];if(Be===3)Oe=Oe-2;else if(Be===2)Oe=Oe-1;else break}while(Oe>=1);pe>1&&ge[ye+je-1]===Re[me+We-1]&&!O(Oe+me-1,Ie,Re)&&pe+1>V[je][Oe]&&(Oe=We),Oe===We?pe++:pe=1,Se||(Se=Oe),je--,We=Oe-1,et.push(We)}Me===Ee&&De.boostFullMatch&&(et[0]+=2);const Ae=Se-Ee;return et[0]-=Ae,et}e.$3j=B;function H(ce,ge,ye,Ie,Re,me){let De=ce-1,Ee=ge-1;for(;De>=ye&&Ee>=Ie;)Re[De]===me[Ee]&&(_[De]=Ee,De--),Ee--}function T(ce,ge,ye,Ie,Re,me,De,Ee,Me,je,We){if(ge[ye]!==me[De])return Number.MIN_SAFE_INTEGER;let He=1,Qe=!1;return De===ye-Ie?He=ce[ye]===Re[De]?7:5:O(De,Re,me)&&(De===0||!O(De-1,Re,me))?(He=ce[ye]===Re[De]?7:5,Qe=!0):z(me,De)&&(De===0||!z(me,De-1))?He=5:(z(me,De-1)||q(me,De-1))&&(He=5,Qe=!0),He>1&&ye===Ie&&(We[0]=!0),Qe||(Qe=O(De,Re,me)||z(me,De-1)||q(me,De-1)),ye===Ie?De>Me&&(He-=Qe?3:5):je?He+=Qe?2:0:He+=Qe?0:1,De+1===Ee&&(He-=Qe?3:5),He}function W(ce,ge,ye,Ie,Re,me,De){return re(ce,ge,ye,Ie,Re,me,!0,De)}e.$4j=W;function x(ce,ge,ye,Ie,Re,me,De){return re(ce,ge,ye,Ie,Re,me,!1,De)}e.$5j=x;function re(ce,ge,ye,Ie,Re,me,De,Ee){let Me=B(ce,ge,ye,Ie,Re,me,Ee);if(Me&&!De)return Me;if(ce.length>=3){const je=Math.min(7,ce.length-1);for(let We=ye+1;We<je;We++){const He=fe(ce,We);if(He){const Qe=B(He,He.toLowerCase(),ye,Ie,Re,me,Ee);Qe&&(Qe[0]-=3,(!Me||Qe[0]>Me[0])&&(Me=Qe))}}}return Me}function fe(ce,ge){if(ge+1>=ce.length)return;const ye=ce[ge],Ie=ce[ge+1];if(ye!==Ie)return ce.slice(0,ge)+Ie+ye+ce.slice(ge+2)}}),define(be[61],ve([1,0,17]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function R(u){return r(u,0)}e.$Pi=R;function r(u,d){switch(typeof u){case"object":return u===null?C(349,d):Array.isArray(u)?w(u,d):v(u,d);case"string":return P(u,d);case"boolean":return S(u,d);case"number":return C(u,d);case"undefined":return C(937,d);default:return C(617,d)}}e.$Qi=r;function C(u,d){return(d<<5)-d+u|0}e.$Ri=C;function S(u,d){return C(u?433:863,d)}function P(u,d){d=C(149417,d);for(let l=0,$=u.length;l<$;l++)d=C(u.charCodeAt(l),d);return d}e.$Si=P;function w(u,d){return d=C(104579,d),u.reduce((l,$)=>r($,l),d)}function v(u,d){return d=C(181387,d),Object.keys(u).sort().reduce((l,$)=>(l=P($,l),r(u[$],l)),d)}class I{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=r(d,this.g),this.g}}e.$Ti=I;var k;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function b(u,d,l=32){const $=l-d,h=~((1<<$)-1);return(u<<d|(h&u)>>>$)>>>0}function f(u,d=0,l=u.byteLength,$=0){for(let h=0;h<l;h++)u[d+h]=$}function p(u,d,l="0"){for(;u.length<d;)u=l+u;return u}function c(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(l=>l.toString(16).padStart(2,"0")).join(""):p((u>>>0).toString(16),d/4)}e.$Ui=c;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const l=d.length;if(l===0)return;const $=this.p;let h=this.r,n=this.u,i,o;for(n!==0?(i=n,o=-1,n=0):(i=d.charCodeAt(0),o=0);;){let s=i;if(E.$_e(i))if(o+1<l){const t=d.charCodeAt(o+1);E.$af(t)?(o++,s=E.$bf(i,t)):s=65533}else{n=i;break}else E.$af(i)&&(s=65533);if(h=this.w($,h,s),o++,o<l)i=d.charCodeAt(o);else break}this.r=h,this.u=n}w(d,l,$){return $<128?d[l++]=$:$<2048?(d[l++]=192|($&1984)>>>6,d[l++]=128|($&63)>>>0):$<65536?(d[l++]=224|($&61440)>>>12,d[l++]=128|($&4032)>>>6,d[l++]=128|($&63)>>>0):(d[l++]=240|($&1835008)>>>18,d[l++]=128|($&258048)>>>12,d[l++]=128|($&4032)>>>6,d[l++]=128|($&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=m.g,l=this.q;for(let g=0;g<64;g+=4)d.setUint32(g,l.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)d.setUint32(g,b(d.getUint32(g-12,!1)^d.getUint32(g-32,!1)^d.getUint32(g-56,!1)^d.getUint32(g-64,!1),1),!1);let $=this.h,h=this.l,n=this.m,i=this.n,o=this.o,s,t,a;for(let g=0;g<80;g++)g<20?(s=h&n|~h&i,t=1518500249):g<40?(s=h^n^i,t=1859775393):g<60?(s=h&n|h&i|n&i,t=2400959708):(s=h^n^i,t=3395469782),a=b($,5)+s+o+t+d.getUint32(g*4,!1)&4294967295,o=i,i=n,n=b(h,30),h=$,$=a;this.h=this.h+$&4294967295,this.l=this.l+h&4294967295,this.m=this.m+n&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$Vi=m}),define(be[62],ve([1,0,17]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(R||(R={})),function(r){const C="error",S="warning",P="warn",w="info",v="ignore";function I(b){return b?E.$8e(C,b)?r.Error:E.$8e(S,b)||E.$8e(P,b)?r.Warning:E.$8e(w,b)?r.Info:r.Ignore:r.Ignore}r.fromValue=I;function k(b){switch(b){case r.Error:return C;case r.Warning:return S;case r.Info:return w;default:return v}}r.toString=k}(R||(R={})),e.default=R}),define(be[149],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(be[63],ve([1,0,18,17]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class r{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const p=f.charCodeAt(0),c=this.b.charCodeAt(this.c);return p-c}value(){return this.b[this.c]}}e.$4h=r;class C{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,R.$2e)(f,this.b,0,f.length,this.c,this.d):(0,R.$4e)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=C;class S{constructor(f=!0,p=!0){this.f=f,this.g=p}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let p=f.length-1;p>=0;p--,this.c--){const c=this.b.charCodeAt(p);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,R.$2e)(f,this.b,0,f.length,this.d,this.e):(0,R.$4e)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=S;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class w{constructor(f,p){this.f=f,this.g=p,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,R.$3e)(f,this.c.scheme);if(this.d[this.e]===2)return(0,R.$3e)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,R.$1e)(f,this.c.query);if(this.d[this.e]===5)return(0,R.$1e)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=w;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(I||(I={}));class k{static forUris(f=()=>!1,p=()=>!1){return new k(new w(f,p))}static forPaths(f=!1){return new k(new S(void 0,!f))}static forStrings(){return new k(new r)}static forConfigKeys(){return new k(new C)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,p){if(p){const c=p.slice(0);(0,E.$Xb)(c);for(const m of c)this.set(m,f)}else{const c=f.slice(0);(0,E.$Xb)(c);for(const m of c)this.set(m[0],m[1])}}set(f,p){const c=this.b.reset(f);let m;this.c||(this.c=new v,this.c.segment=c.value());const u=[];for(m=this.c;;){const l=c.cmp(m.segment);if(l>0)m.left||(m.left=new v,m.left.segment=c.value()),u.push([-1,m]),m=m.left;else if(l<0)m.right||(m.right=new v,m.right.segment=c.value()),u.push([1,m]),m=m.right;else if(c.hasNext())c.next(),m.mid||(m.mid=new v,m.mid.segment=c.value()),u.push([0,m]),m=m.mid;else break}const d=m.value;m.value=p,m.key=f;for(let l=u.length-1;l>=0;l--){const $=u[l][1];$.updateHeight();const h=$.balanceFactor();if(h<-1||h>1){const n=u[l][0],i=u[l+1][0];if(n===1&&i===1)u[l][1]=$.rotateLeft();else if(n===-1&&i===-1)u[l][1]=$.rotateRight();else if(n===1&&i===-1)$.right=u[l+1][1]=u[l+1][1].rotateRight(),u[l][1]=$.rotateLeft();else if(n===-1&&i===1)$.left=u[l+1][1]=u[l+1][1].rotateLeft(),u[l][1]=$.rotateRight();else throw new Error;if(l>0)switch(u[l-1][0]){case-1:u[l-1][1].left=u[l][1];break;case 1:u[l-1][1].right=u[l][1];break;case 0:u[l-1][1].mid=u[l][1];break}else this.c=u[0][1]}}return d}get(f){return this.d(f)?.value}d(f){const p=this.b.reset(f);let c=this.c;for(;c;){const m=p.cmp(c.segment);if(m>0)c=c.left;else if(m<0)c=c.right;else if(p.hasNext())p.next(),c=c.mid;else break}return c}has(f){const p=this.d(f);return!(p?.value===void 0&&p?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,p){const c=this.b.reset(f),m=[];let u=this.c;for(;u;){const d=c.cmp(u.segment);if(d>0)m.push([-1,u]),u=u.left;else if(d<0)m.push([1,u]),u=u.right;else if(c.hasNext())c.next(),m.push([0,u]),u=u.mid;else break}if(u){if(p?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:l,value:$,segment:h}=d;this.e(d.key,!1),u.key=l,u.value=$,u.segment=h}}else{const d=u.left??u.right;if(m.length>0){const[l,$]=m[m.length-1];switch(l){case-1:$.left=d;break;case 0:$.mid=d;break;case 1:$.right=d;break}}else this.c=d}for(let d=m.length-1;d>=0;d--){const l=m[d][1];l.updateHeight();const $=l.balanceFactor();if($>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),m[d][1]=l.rotateLeft()):$<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),m[d][1]=l.rotateRight()),d>0)switch(m[d-1][0]){case-1:m[d-1][1].left=m[d][1];break;case 1:m[d-1][1].right=m[d][1];break;case 0:m[d-1][1].mid=m[d][1];break}else this.c=m[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const p=this.b.reset(f);let c=this.c,m;for(;c;){const u=p.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(p.hasNext())p.next(),m=c.value||m,c=c.mid;else break}return c&&c.value||m}findSuperstr(f){return this.g(f,!1)}g(f,p){const c=this.b.reset(f);let m=this.c;for(;m;){const u=c.cmp(m.segment);if(u>0)m=m.left;else if(u<0)m=m.right;else if(c.hasNext())c.next(),m=m.mid;else return m.mid?this.h(m.mid):p?m.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[p,c]of this)f(c,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const p=[];return this.j(f,p),p[Symbol.iterator]()}j(f,p){f&&(f.left&&this.j(f.left,p),f.value&&p.push([f.key,f.value]),f.mid&&this.j(f.mid,p),f.right&&this.j(f.right,p))}_isBalanced(){const f=p=>{if(!p)return!0;const c=p.balanceFactor();return c<-1||c>1?!1:f(p.left)&&f(p.right)};return f(this.c)}}e.$8h=k}),define(be[10],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=void 0;function E(h){return typeof h=="string"}e.$Ef=E;function R(h){return Array.isArray(h)&&h.every(n=>E(n))}e.$Ff=R;function r(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$Gf=r;function C(h){const n=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof n}e.$Hf=C;function S(h){return typeof h=="number"&&!isNaN(h)}e.$If=S;function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Jf=P;function w(h){return h===!0||h===!1}e.$Kf=w;function v(h){return typeof h>"u"}e.$Lf=v;function I(h){return!k(h)}e.$Mf=I;function k(h){return v(h)||h===null}e.$Nf=k;function b(h,n){if(!h)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$Of=b;function f(h){if(k(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Pf=f;function p(...h){const n=[];for(let i=0;i<h.length;i++){const o=h[i];if(k(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.$Qf=p;const c=Object.prototype.hasOwnProperty;function m(h){if(!r(h))return!1;for(const n in h)if(c.call(h,n))return!1;return!0}e.$Rf=m;function u(h){return typeof h=="function"}e.$Sf=u;function d(...h){return h.length>0&&h.every(u)}e.$Tf=d;function l(h,n){const i=Math.min(h.length,n.length);for(let o=0;o<i;o++)$(h[o],n[o])}e.$Uf=l;function $(h,n){if(E(n)){if(typeof h!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(u(n)){try{if(h instanceof n)return}catch{}if(!k(h)&&h.constructor===n||n.length===1&&n.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Vf=$}),define(be[49],ve([1,0,10]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=void 0;const R=Object.create(null);function r(P,w){if((0,E.$Ef)(w)){const v=R[w];if(v===void 0)throw new Error(`${P} references an unknown codicon: ${w}`);w=v}return R[P]=w,{id:P}}function C(){return R}e.$6j=C;function S(){return Object.values(e.$8j)}e.$7j=S,e.$8j={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(be[23],ve([1,0,10]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function R(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const d=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([l,$])=>{d[l]=$&&typeof $=="object"?R($):$}),d}e.$hn=R;function r(u){if(!u||typeof u!="object")return u;const d=[u];for(;d.length>0;){const l=d.shift();Object.freeze(l);for(const $ in l)if(C.call(l,$)){const h=l[$];typeof h=="object"&&!Object.isFrozen(h)&&!(0,E.$Hf)(h)&&d.push(h)}}return u}e.$in=r;const C=Object.prototype.hasOwnProperty;function S(u,d){return P(u,d,new Set)}e.$jn=S;function P(u,d,l){if((0,E.$Nf)(u))return u;const $=d(u);if(typeof $<"u")return $;if(Array.isArray(u)){const h=[];for(const n of u)h.push(P(n,d,l));return h}if((0,E.$Gf)(u)){if(l.has(u))throw new Error("Cannot clone recursive data-structure");l.add(u);const h={};for(const n in u)C.call(u,n)&&(h[n]=P(u[n],d,l));return l.delete(u),h}return u}function w(u,d,l=!0){return(0,E.$Gf)(u)?((0,E.$Gf)(d)&&Object.keys(d).forEach($=>{$ in u?l&&((0,E.$Gf)(u[$])&&(0,E.$Gf)(d[$])?w(u[$],d[$],l):u[$]=d[$]):u[$]=d[$]}),u):d}e.$kn=w;function v(u,d){if(u===d)return!0;if(u==null||d===null||d===void 0||typeof u!=typeof d||typeof u!="object"||Array.isArray(u)!==Array.isArray(d))return!1;let l,$;if(Array.isArray(u)){if(u.length!==d.length)return!1;for(l=0;l<u.length;l++)if(!v(u[l],d[l]))return!1}else{const h=[];for($ in u)h.push($);h.sort();const n=[];for($ in d)n.push($);if(n.sort(),!v(h,n))return!1;for(l=0;l<h.length;l++)if(!v(u[h[l]],d[h[l]]))return!1}return!0}e.$ln=v;function I(u){const d=new Set;return JSON.stringify(u,(l,$)=>{if((0,E.$Gf)($)||Array.isArray($)){if(d.has($))return"[Circular]";d.add($)}return $})}e.$mn=I;function k(u,d){const l=Object.create(null);return!u||!d||Object.keys(d).forEach(h=>{const n=u[h],i=d[h];v(n,i)||(l[h]=i)}),l}e.$nn=k;function b(u,d){const l=d.toLowerCase(),$=Object.keys(u).find(h=>h.toLowerCase()===l);return $?u[$]:u[d]}e.$on=b;function f(u,d){const l=Object.create(null);for(const[$,h]of Object.entries(u))d($,h)&&(l[$]=h);return l}e.$pn=f;function p(u){let d=[];for(;Object.prototype!==u;)d=d.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return d}e.$qn=p;function c(u){const d=[];for(const l of p(u))typeof u[l]=="function"&&d.push(l);return d}e.$rn=c;function m(u,d){const l=h=>function(){const n=Array.prototype.slice.call(arguments,0);return d(h,n)},$={};for(const h of u)$[h]=l(h);return $}e.$sn=m}),define(be[99],ve([1,0,49]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var R;(function(S){function P(w){return w&&typeof w=="object"&&typeof w.id=="string"}S.isThemeColor=P})(R||(e.ThemeColor=R={}));function r(S){return{id:S}}e.$9j=r;var C;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function w(d){const l=P.exec(d.id);if(!l)return w(E.$8j.error);const[,$,h]=l,n=["codicon","codicon-"+$];return h&&n.push("codicon-modifier-"+h.substring(1)),n}S.asClassNameArray=w;function v(d){return w(d).join(" ")}S.asClassName=v;function I(d){return"."+w(d).join(".")}S.asCSSSelector=I;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||R.isThemeColor(d.color))}S.isThemeIcon=k;const b=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function f(d){const l=b.exec(d);if(!l)return;const[,$]=l;return{id:$}}S.fromString=f;function p(d){return{id:d}}S.fromId=p;function c(d,l){let $=d.id;const h=$.lastIndexOf("~");return h!==-1&&($=$.substring(0,h)),l&&($=`${$}~${l}`),{id:$}}S.modify=c;function m(d){const l=d.id.lastIndexOf("~");if(l!==-1)return d.id.substring(l+1)}S.getModifier=m;function u(d,l){return d.id===l.id&&d.color?.id===l.color?.id}S.isEqual=u})(C||(e.ThemeIcon=C={}))}),define(be[150],ve([1,0,148,17,99]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const C="$(",S=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${S.source}`,"g");function w(u){return u.replace(P,(d,l)=>l?d:`\\${d}`)}e.$0j=w;const v=new RegExp(`\\\\${S.source}`,"g");function I(u){return u.replace(v,d=>`\\${d}`)}e.$$j=I;const k=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function b(u){return u.indexOf(C)===-1?u:u.replace(k,(d,l,$,h)=>$?d:l||h||"")}e.$_j=b;function f(u){return u?u.replace(/\$\((.*?)\)/g,(d,l)=>` ${l} `).trim():""}e.$ak=f;const p=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(u){p.lastIndex=0;let d="";const l=[];let $=0;for(;;){const h=p.lastIndex,n=p.exec(u),i=u.substring(h,n?.index);if(i.length>0){d+=i;for(let o=0;o<i.length;o++)l.push($)}if(!n)break;$+=n[0].length}return{text:d,iconOffsets:l}}e.$bk=c;function m(u,d,l=!1){const{text:$,iconOffsets:h}=d;if(!h||h.length===0)return(0,E.$Wj)(u,$,l);const n=(0,R.$Pe)($," "),i=$.length-n.length,o=(0,E.$Wj)(u,n,l);if(o)for(const s of o){const t=h[s.start+i]+i;s.start+=t,s.end+=t}return o}e.$ck=m}),define(be[21],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(r){return E.test(r)}e.$lg=R,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const C=new Uint8Array(16),S=[];for(let P=0;P<256;P++)S.push(P.toString(16).padStart(2,"0"));return function(){r(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let w=0,v="";return v+=S[C[w++]],v+=S[C[w++]],v+=S[C[w++]],v+=S[C[w++]],v+="-",v+=S[C[w++]],v+=S[C[w++]],v+="-",v+=S[C[w++]],v+=S[C[w++]],v+="-",v+=S[C[w++]],v+=S[C[w++]],v+="-",v+=S[C[w++]],v+=S[C[w++]],v+=S[C[w++]],v+=S[C[w++]],v+=S[C[w++]],v+=S[C[w++]],v}}()}),define(be[151],ve([1,0,18,47,21]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.$_s=void 0;function C(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$_s=C;function S(k,b,f){const p={id:(0,r.$mg)(),name:k,uri:b,data:f};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$at=S;class P{constructor(){this.a=new Map}get size(){let b=0;for(const f of this.a)b++;return b}has(b){return this.a.has(this.b(b))}matches(b){const f=[...this.a.keys()];return R.Iterable.some(this,([p,c])=>c.asFile())&&f.push("files"),I(w(b),f)}get(b){return this.a.get(this.b(b))?.[0]}append(b,f){const p=this.a.get(b);p?p.push(f):this.a.set(this.b(b),[f])}replace(b,f){this.a.set(this.b(b),[f])}delete(b){this.a.delete(this.b(b))}*[Symbol.iterator](){for(const[b,f]of this.a)for(const p of f)yield[b,p]}b(b){return w(b)}}e.$bt=P;function w(k){return k.toLowerCase()}function v(k,b){return I(w(k),b.map(w))}e.$ct=v;function I(k,b){if(k==="*/*")return b.length>0;if(b.includes(k))return!0;const f=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!f)return!1;const[p,c,m]=f;return m==="*"?b.some(u=>u.startsWith(c+"/")):!1}e.$dt=Object.freeze({create:k=>(0,E.$Mb)(k.map(b=>b.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$dt.split(k).filter(b=>!b.startsWith("#"))})}),function(){"use strict";function ue(e,E,R){function r(f){return new Promise(p=>E.exists(f,p))}function C(f){return new Promise((p,c)=>{const m=new Date;E.utimes(f,m,m,u=>u?c(u):p())})}function S(f){return new Promise((p,c)=>E.mkdir(f,{recursive:!0},m=>m&&m.code!=="EEXIST"?c(m):p(f)))}function P(f){return new Promise((p,c)=>E.rm(f,{recursive:!0,force:!0,maxRetries:3},m=>m?c(m):p()))}function w(f){return new Promise((p,c)=>E.readFile(f,"utf8",(m,u)=>m?c(m):p(u)))}function v(f,p){return new Promise((c,m)=>E.writeFile(f,p,"utf8",u=>u?m(u):c()))}async function I(f){const p=e.join(f,"languagepacks.json");try{return JSON.parse(await w(p))}catch{}}function k(f,p){try{for(;p;){if(f[p])return p;{const c=p.lastIndexOf("-");if(c>0)p=p.substring(0,c);else return}}}catch(c){console.error("Resolving language pack configuration failed.",c)}}function b(f,p,c,m,u){const d=function($){return R.mark("code/didGenerateNls"),Promise.resolve({locale:$,osLocale:u,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),m==="pseudo")return Promise.resolve({locale:m,osLocale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:m,osLocale:u,availableLanguages:{}});if(m&&(m==="en"||m==="en-us"))return Promise.resolve({locale:m,osLocale:u,availableLanguages:{}});const l=m;try{return f?I(p).then($=>{if(!$)return d(l);const h=k($,m);if(!h)return d(l);m=h;const n=$[m];let i;return!n||typeof n.hash!="string"||!n.translations||typeof(i=n.translations.vscode)!="string"?d(l):r(i).then(o=>{if(!o)return d(l);const s=n.hash+"."+m,t=e.join(p,"clp",s),a=e.join(t,f),g=e.join(t,"tcf.json"),L=e.join(t,"corrupted.info"),D={locale:l,osLocale:u,availableLanguages:{"*":m},_languagePackId:s,_translationsConfigFile:g,_cacheRoot:t,_resolvedLanguagePackCoreLocation:a,_corruptedFile:L};return r(L).then(y=>{let A;return y?A=P(t):A=Promise.resolve(void 0),A.then(()=>r(a).then(F=>F?(C(a).catch(()=>{}),R.mark("code/didGenerateNls"),D):S(a).then(()=>Promise.all([w(c),w(i)])).then(X=>{const te=JSON.parse(X[0]),J=JSON.parse(X[1]).contents,ie=Object.keys(te.bundles),ee=[];for(const U of ie){const he=te.bundles[U],Q=Object.create(null);for(const _ of he){const V=te.keys[_],G=te.messages[_],oe=J[_];let le;if(oe){le=[];for(let se=0;se<V.length;se++){const $e=V[se],z=typeof $e=="string"?$e:$e.key;let q=oe[z];q===void 0&&(q=G[se]),le.push(q)}}else le=G;Q[_]=le}ee.push(v(e.join(a,U.replace(/\//g,"!")+".nls.json"),JSON.stringify(Q)))}return ee.push(v(g,JSON.stringify(n.translations))),Promise.all(ee)}).then(()=>(R.mark("code/didGenerateNls"),D)).catch(X=>(console.error("Generating translation files failed.",X),d(m)))))})})}):d(l)}catch($){return console.error("Generating translation files failed.",$),d(m)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(be[152],ve([77,27,41]),function(e,E,R){return ue(e,E,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),R=require("../common/performance");module.exports=ue(e,E,R)}else throw new Error("Unknown context")}(),define(be[153],ve([1,0,28]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(S){const P=S.replace(/\-/g,":").toLowerCase();return!R.has(P)}function C(){const S=(0,E.networkInterfaces)();for(const P in S){const w=S[P];if(w){for(const{mac:v}of w)if(r(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$4m=C}),define(be[154],ve([1,0,78]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=e.$og=void 0;function R(P,w,v,I=1){let k=!1;return new Promise(b=>{const f=setTimeout(()=>{if(!k)return k=!0,b(0)},v);r(P,w,I,p=>{if(!k)return k=!0,clearTimeout(f),b(p)})})}e.$og=R;function r(P,w,v,I){if(w===0)return I(0);const k=new E.Socket;k.once("connect",()=>(S(k),r(P+v,w-1,v,I))),k.once("data",()=>{}),k.once("error",b=>(S(k),b.code!=="ECONNREFUSED"?r(P+v,w-1,v,I):I(P))),k.connect(P,"127.0.0.1")}e.$pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function C(P,w,v,I="127.0.0.1"){let k=!1,b,f=1;const p=E.createServer({pauseOnConnect:!0});function c(m,u){k||(k=!0,p.removeAllListeners(),p.close(),b&&clearTimeout(b),u(m))}return new Promise(m=>{b=setTimeout(()=>{c(0,m)},v),p.on("listening",()=>{c(P,m)}),p.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&f<w?(P++,f++,p.listen(P,I)):c(0,m)}),p.on("close",()=>{c(0,m)}),p.listen(P,I)})}e.$qg=C;function S(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),function(){function ue(){function e(){return process.uncHostAllowlist}function E(w){const v=new Set;if(Array.isArray(w))for(const I of w)typeof I=="string"&&v.add(I);return Array.from(v)}function R(){const w=e();return w?Array.from(w):[]}function r(w){if(process.platform!=="win32")return;const v=e();if(v)if(typeof w=="string")v.add(w.toLowerCase());else for(const I of E(w))r(I)}function C(w){if(typeof w!="string")return;const v=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let I;for(const k of v){if(w.indexOf(k)!==0)continue;const f=w.indexOf("\\",k.length);if(f===-1)continue;const p=w.substring(k.length,f);if(p){I=p;break}}return I}function S(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:r,getUNCHost:C,disableUNCAccessRestrictions:S,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(be[79],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class E{constructor(r,C){this.lineNumber=r,this.column=C}with(r=this.lineNumber,C=this.column){return r===this.lineNumber&&C===this.column?this:new E(r,C)}delta(r=0,C=0){return this.with(this.lineNumber+r,this.column+C)}equals(r){return E.equals(this,r)}static equals(r,C){return!r&&!C?!0:!!r&&!!C&&r.lineNumber===C.lineNumber&&r.column===C.column}isBefore(r){return E.isBefore(this,r)}static isBefore(r,C){return r.lineNumber<C.lineNumber?!0:C.lineNumber<r.lineNumber?!1:r.column<C.column}isBeforeOrEqual(r){return E.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,C){return r.lineNumber<C.lineNumber?!0:C.lineNumber<r.lineNumber?!1:r.column<=C.column}static compare(r,C){const S=r.lineNumber|0,P=C.lineNumber|0;if(S===P){const w=r.column|0,v=C.column|0;return w-v}return S-P}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new E(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Fs=E}),define(be[42],ve([1,0,79]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class R{constructor(C,S,P,w){C>P||C===P&&S>w?(this.startLineNumber=P,this.startColumn=w,this.endLineNumber=C,this.endColumn=S):(this.startLineNumber=C,this.startColumn=S,this.endLineNumber=P,this.endColumn=w)}isEmpty(){return R.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return R.containsPosition(this,C)}static containsPosition(C,S){return!(S.lineNumber<C.startLineNumber||S.lineNumber>C.endLineNumber||S.lineNumber===C.startLineNumber&&S.column<C.startColumn||S.lineNumber===C.endLineNumber&&S.column>C.endColumn)}static strictContainsPosition(C,S){return!(S.lineNumber<C.startLineNumber||S.lineNumber>C.endLineNumber||S.lineNumber===C.startLineNumber&&S.column<=C.startColumn||S.lineNumber===C.endLineNumber&&S.column>=C.endColumn)}containsRange(C){return R.containsRange(this,C)}static containsRange(C,S){return!(S.startLineNumber<C.startLineNumber||S.endLineNumber<C.startLineNumber||S.startLineNumber>C.endLineNumber||S.endLineNumber>C.endLineNumber||S.startLineNumber===C.startLineNumber&&S.startColumn<C.startColumn||S.endLineNumber===C.endLineNumber&&S.endColumn>C.endColumn)}strictContainsRange(C){return R.strictContainsRange(this,C)}static strictContainsRange(C,S){return!(S.startLineNumber<C.startLineNumber||S.endLineNumber<C.startLineNumber||S.startLineNumber>C.endLineNumber||S.endLineNumber>C.endLineNumber||S.startLineNumber===C.startLineNumber&&S.startColumn<=C.startColumn||S.endLineNumber===C.endLineNumber&&S.endColumn>=C.endColumn)}plusRange(C){return R.plusRange(this,C)}static plusRange(C,S){let P,w,v,I;return S.startLineNumber<C.startLineNumber?(P=S.startLineNumber,w=S.startColumn):S.startLineNumber===C.startLineNumber?(P=S.startLineNumber,w=Math.min(S.startColumn,C.startColumn)):(P=C.startLineNumber,w=C.startColumn),S.endLineNumber>C.endLineNumber?(v=S.endLineNumber,I=S.endColumn):S.endLineNumber===C.endLineNumber?(v=S.endLineNumber,I=Math.max(S.endColumn,C.endColumn)):(v=C.endLineNumber,I=C.endColumn),new R(P,w,v,I)}intersectRanges(C){return R.intersectRanges(this,C)}static intersectRanges(C,S){let P=C.startLineNumber,w=C.startColumn,v=C.endLineNumber,I=C.endColumn;const k=S.startLineNumber,b=S.startColumn,f=S.endLineNumber,p=S.endColumn;return P<k?(P=k,w=b):P===k&&(w=Math.max(w,b)),v>f?(v=f,I=p):v===f&&(I=Math.min(I,p)),P>v||P===v&&w>I?null:new R(P,w,v,I)}equalsRange(C){return R.equalsRange(this,C)}static equalsRange(C,S){return!C&&!S?!0:!!C&&!!S&&C.startLineNumber===S.startLineNumber&&C.startColumn===S.startColumn&&C.endLineNumber===S.endLineNumber&&C.endColumn===S.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(C){return new E.$Fs(C.endLineNumber,C.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(C){return new E.$Fs(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,S){return new R(this.startLineNumber,this.startColumn,C,S)}setStartPosition(C,S){return new R(C,S,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(C){return new R(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(C){return new R(C.endLineNumber,C.endColumn,C.endLineNumber,C.endColumn)}delta(C){return new R(this.startLineNumber+C,this.startColumn,this.endLineNumber+C,this.endColumn)}static fromPositions(C,S=C){return new R(C.lineNumber,C.column,S.lineNumber,S.column)}static lift(C){return C?new R(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,S){return!(C.endLineNumber<S.startLineNumber||C.endLineNumber===S.startLineNumber&&C.endColumn<S.startColumn||S.endLineNumber<C.startLineNumber||S.endLineNumber===C.startLineNumber&&S.endColumn<C.startColumn)}static areIntersecting(C,S){return!(C.endLineNumber<S.startLineNumber||C.endLineNumber===S.startLineNumber&&C.endColumn<=S.startColumn||S.endLineNumber<C.startLineNumber||S.endLineNumber===C.startLineNumber&&S.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,S){if(C&&S){const v=C.startLineNumber|0,I=S.startLineNumber|0;if(v===I){const k=C.startColumn|0,b=S.startColumn|0;if(k===b){const f=C.endLineNumber|0,p=S.endLineNumber|0;if(f===p){const c=C.endColumn|0,m=S.endColumn|0;return c-m}return f-p}return k-b}return v-I}return(C?1:0)-(S?1:0)}static compareRangesUsingEnds(C,S){return C.endLineNumber===S.endLineNumber?C.endColumn===S.endColumn?C.startLineNumber===S.startLineNumber?C.startColumn-S.startColumn:C.startLineNumber-S.startLineNumber:C.endColumn-S.endColumn:C.endLineNumber-S.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}toJSON(){return this}}e.$Gs=R}),define(be[155],ve([1,0,42]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class R{static insert(C,S){return{range:new E.$Gs(C.lineNumber,C.column,C.lineNumber,C.column),text:S,forceMoveMarkers:!0}}static delete(C){return{range:C,text:null}}static replace(C,S){return{range:C,text:S}}static replaceMove(C,S){return{range:C,text:S,forceMoveMarkers:!0}}}e.$Hs=R}),define(be[156],ve([1,0,5,2]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new E.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,w){return this.a.set(P,w),this.handleChange([P]),(0,R.$Qc)(()=>{this.a.get(P)===w&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,w){this.b.get(P)?.dispose();const v=new C(this,P,w);return this.b.set(P,v),(0,R.$Qc)(()=>{const I=this.b.get(P);!I||I!==v||(this.b.delete(P),I.dispose())})}async getOrCreate(P){const w=this.get(P);if(w)return w;const v=this.b.get(P);return!v||v.isResolved?null:(await v.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const v=this.b.get(P);return!!(!v||v.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ft=r;class C extends R.$Sc{get isResolved(){return this.c}constructor(P,w,v){super(),this.f=P,this.g=w,this.h=v,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(be[157],ve([8,9]),function(ue,e){return ue.create("vs/base/common/actions",e)}),define(be[158],ve([1,0,5,2,157]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class C extends R.$Sc{constructor(b,f="",p="",c=!0,m){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=f,this.u=p,this.w=c,this.C=m}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,f){this.C&&await this.C(b)}}e.$Gi=C;class S extends R.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(b,f){if(!b.enabled)return;this.f.fire({action:b});let p;try{await this.u(b,f)}catch(c){p=c}this.m.fire({action:b,error:p})}async u(b,f){await b.run(f)}}e.$Hi=S;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let f=[];for(const p of b)p.length&&(f.length?f=[...f,new P,...p]:f=p);return f}static{this.ID="vs.actions.separator"}async run(){}}e.$Ii=P;class w{get actions(){return this.a}constructor(b,f,p,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=f,this.class=c,this.a=p}async run(){}}e.$Ji=w;class v extends C{static{this.ID="vs.actions.empty"}constructor(){super(v.ID,r.localize(0,null),void 0,!1)}}e.$Ki=v;function I(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...b)=>k.run(...b),tooltip:k.label}}e.$Li=I}),define(be[159],ve([8,9]),function(ue,e){return ue.create("vs/base/common/date",e)}),define(be[160],ve([1,0,159]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0;const R=60,r=R*60,C=r*24,S=C*7,P=C*30,w=C*365;function v(k,b,f,p){typeof k!="number"&&(k=k.getTime());const c=Math.round((new Date().getTime()-k)/1e3);if(c<-30)return(0,E.localize)(0,null,v(new Date().getTime()+c*1e3,!1));if(!p&&c<30)return(0,E.localize)(1,null);let m;return c<R?(m=c,b?m===1?f?(0,E.localize)(2,null,m):(0,E.localize)(3,null,m):f?(0,E.localize)(4,null,m):(0,E.localize)(5,null,m):m===1?f?(0,E.localize)(6,null,m):(0,E.localize)(7,null,m):f?(0,E.localize)(8,null,m):(0,E.localize)(9,null,m)):c<r?(m=Math.floor(c/R),b?m===1?f?(0,E.localize)(10,null,m):(0,E.localize)(11,null,m):f?(0,E.localize)(12,null,m):(0,E.localize)(13,null,m):m===1?f?(0,E.localize)(14,null,m):(0,E.localize)(15,null,m):f?(0,E.localize)(16,null,m):(0,E.localize)(17,null,m)):c<C?(m=Math.floor(c/r),b?m===1?f?(0,E.localize)(18,null,m):(0,E.localize)(19,null,m):f?(0,E.localize)(20,null,m):(0,E.localize)(21,null,m):m===1?f?(0,E.localize)(22,null,m):(0,E.localize)(23,null,m):f?(0,E.localize)(24,null,m):(0,E.localize)(25,null,m)):c<S?(m=Math.floor(c/C),b?m===1?(0,E.localize)(26,null,m):(0,E.localize)(27,null,m):m===1?(0,E.localize)(28,null,m):(0,E.localize)(29,null,m)):c<P?(m=Math.floor(c/S),b?m===1?f?(0,E.localize)(30,null,m):(0,E.localize)(31,null,m):f?(0,E.localize)(32,null,m):(0,E.localize)(33,null,m):m===1?f?(0,E.localize)(34,null,m):(0,E.localize)(35,null,m):f?(0,E.localize)(36,null,m):(0,E.localize)(37,null,m)):c<w?(m=Math.floor(c/P),b?m===1?f?(0,E.localize)(38,null,m):(0,E.localize)(39,null,m):f?(0,E.localize)(40,null,m):(0,E.localize)(41,null,m):m===1?f?(0,E.localize)(42,null,m):(0,E.localize)(43,null,m):f?(0,E.localize)(44,null,m):(0,E.localize)(45,null,m)):(m=Math.floor(c/w),b?m===1?f?(0,E.localize)(46,null,m):(0,E.localize)(47,null,m):f?(0,E.localize)(48,null,m):(0,E.localize)(49,null,m):m===1?f?(0,E.localize)(50,null,m):(0,E.localize)(51,null,m):f?(0,E.localize)(52,null,m):(0,E.localize)(53,null,m))}e.$qm=v;function I(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$rm=I}),define(be[161],ve([8,9]),function(ue,e){return ue.create("vs/base/common/errorMessage",e)}),define(be[39],ve([1,0,18,10,161]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function C(k,b){return b&&(k.stack||k.stacktrace)?r.localize(0,null,P(k),S(k.stack)||S(k.stacktrace)):P(k)}function S(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?r.localize(1,null,k.message):k.message||r.localize(2,null)}function w(k=null,b=!1){if(!k)return r.localize(3,null);if(Array.isArray(k)){const f=E.$Hb(k),p=w(f[0],b);return f.length>1?r.localize(4,null,p,f.length):p}if(R.$Ef(k))return k;if(k.detail){const f=k.detail;if(f.error)return C(f.error,b);if(f.exception)return C(f.exception,b)}return k.stack?C(k,b):k.message?k.message:r.localize(5,null)}e.$Mi=w;function v(k){const b=k;return b instanceof Error&&Array.isArray(b.actions)}e.$Ni=v;function I(k,b){let f;return typeof k=="string"?f=new Error(k):f=k,f.actions=b,f}e.$Oi=I}),define(be[162],ve([8,9]),function(ue,e){return ue.create("vs/base/common/jsonErrorMessages",e)}),define(be[163],ve([1,0,162]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;function R(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.$Jp=R}),define(be[164],ve([8,9]),function(ue,e){return ue.create("vs/base/common/platform",e)}),define(be[4],ve([1,0,164]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,r=!1,C=!1,S=!1,P=!1,w=!1,v=!1,I=!1,k=!1,b=!1,f,p=e.$g,c=e.$g,m,u;const d=globalThis;let l;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?l=d.vscode.process:typeof process<"u"&&(l=process);const $=typeof l?.versions?.electron=="string",h=$&&l?.type==="renderer";if(typeof navigator=="object"&&!h)u=navigator.userAgent,R=u.indexOf("Windows")>=0,r=u.indexOf("Macintosh")>=0,I=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=u.indexOf("Linux")>=0,b=u?.indexOf("Mobi")>=0,w=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.$g,p=f,c=navigator.language;else if(typeof l=="object"){R=l.platform==="win32",r=l.platform==="darwin",C=l.platform==="linux",S=C&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,v=$,k=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$g,p=e.$g;const y=l.env.VSCODE_NLS_CONFIG;if(y)try{const A=JSON.parse(y),F=A.availableLanguages["*"];f=A.locale,c=A.osLocale,p=F||e.$g,m=A._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var n;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(n||(e.Platform=n={}));function i(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=i;let o=0;r?o=1:R?o=3:C&&(o=2),e.$i=R,e.$j=r,e.$k=C,e.$l=S,e.$m=P,e.$n=v,e.$o=w,e.$p=w&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=I,e.$s=b,e.$t=k,e.$u=o,e.$v=u,e.$w=p;var s;(function(y){function A(){return e.$w}y.value=A;function F(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}y.isDefaultVariant=F;function X(){return e.$w==="en"}y.isDefault=X})(s||(e.Language=s={})),e.$x=f,e.$y=c,e.$z=m,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const y=[];d.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let X=0,te=y.length;X<te;X++){const J=y[X];if(J.id===F.data.vscodeScheduleAsyncWork){y.splice(X,1),J.callback();return}}});let A=0;return F=>{const X=++A;y.push({id:X,callback:F}),d.postMessage({vscodeScheduleAsyncWork:X},"*")}}return y=>setTimeout(y)})();var t;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=r||I?2:R?1:3;let a=!0,g=!1;function L(){if(!g){g=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,a=new Uint16Array(y.buffer)[0]===(2<<8)+1}return a}e.$D=L,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(y){return parseFloat(y)>=20}e.$J=D}),define(be[29],ve([1,0,4]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const C=r.process;R={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(be[7],ve([1,0,29]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,r=97,C=90,S=122,P=46,w=47,v=92,I=58,k=63;class b extends Error{constructor(i,o,s){let t;typeof o=="string"&&o.indexOf("not ")===0?(t="must not be",o=o.replace(/^not /,"")):t="must be";const a=i.indexOf(".")!==-1?"property":"argument";let g=`The "${i}" ${a} ${t} of type ${o}`;g+=`. Received type ${typeof s}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function f(n,i){if(n===null||typeof n!="object")throw new b(i,"Object",n)}function p(n,i){if(typeof n!="string")throw new b(i,"string",n)}const c=E.$dc==="win32";function m(n){return n===w||n===v}function u(n){return n===w}function d(n){return n>=R&&n<=C||n>=r&&n<=S}function l(n,i,o,s){let t="",a=0,g=-1,L=0,D=0;for(let y=0;y<=n.length;++y){if(y<n.length)D=n.charCodeAt(y);else{if(s(D))break;D=w}if(s(D)){if(!(g===y-1||L===1))if(L===2){if(t.length<2||a!==2||t.charCodeAt(t.length-1)!==P||t.charCodeAt(t.length-2)!==P){if(t.length>2){const A=t.lastIndexOf(o);A===-1?(t="",a=0):(t=t.slice(0,A),a=t.length-1-t.lastIndexOf(o)),g=y,L=0;continue}else if(t.length!==0){t="",a=0,g=y,L=0;continue}}i&&(t+=t.length>0?`${o}..`:"..",a=2)}else t.length>0?t+=`${o}${n.slice(g+1,y)}`:t=n.slice(g+1,y),a=y-g-1;g=y,L=0}else D===P&&L!==-1?++L:L=-1}return t}function $(n,i){f(i,"pathObject");const o=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${s}`:`${o}${n}${s}`:s}e.$fc={resolve(...n){let i="",o="",s=!1;for(let t=n.length-1;t>=-1;t--){let a;if(t>=0){if(a=n[t],p(a,"path"),a.length===0)continue}else i.length===0?a=E.cwd():(a=E.env[`=${i}`]||E.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==i.toLowerCase()&&a.charCodeAt(2)===v)&&(a=`${i}\\`));const g=a.length;let L=0,D="",y=!1;const A=a.charCodeAt(0);if(g===1)m(A)&&(L=1,y=!0);else if(m(A))if(y=!0,m(a.charCodeAt(1))){let F=2,X=F;for(;F<g&&!m(a.charCodeAt(F));)F++;if(F<g&&F!==X){const te=a.slice(X,F);for(X=F;F<g&&m(a.charCodeAt(F));)F++;if(F<g&&F!==X){for(X=F;F<g&&!m(a.charCodeAt(F));)F++;(F===g||F!==X)&&(D=`\\\\${te}\\${a.slice(X,F)}`,L=F)}}}else L=1;else d(A)&&a.charCodeAt(1)===I&&(D=a.slice(0,2),L=2,g>2&&m(a.charCodeAt(2))&&(y=!0,L=3));if(D.length>0)if(i.length>0){if(D.toLowerCase()!==i.toLowerCase())continue}else i=D;if(s){if(i.length>0)break}else if(o=`${a.slice(L)}\\${o}`,s=y,y&&i.length>0)break}return o=l(o,!s,"\\",m),s?`${i}\\${o}`:`${i}${o}`||"."},normalize(n){p(n,"path");const i=n.length;if(i===0)return".";let o=0,s,t=!1;const a=n.charCodeAt(0);if(i===1)return u(a)?"\\":n;if(m(a))if(t=!0,m(n.charCodeAt(1))){let L=2,D=L;for(;L<i&&!m(n.charCodeAt(L));)L++;if(L<i&&L!==D){const y=n.slice(D,L);for(D=L;L<i&&m(n.charCodeAt(L));)L++;if(L<i&&L!==D){for(D=L;L<i&&!m(n.charCodeAt(L));)L++;if(L===i)return`\\\\${y}\\${n.slice(D)}\\`;L!==D&&(s=`\\\\${y}\\${n.slice(D,L)}`,o=L)}}}else o=1;else d(a)&&n.charCodeAt(1)===I&&(s=n.slice(0,2),o=2,i>2&&m(n.charCodeAt(2))&&(t=!0,o=3));let g=o<i?l(n.slice(o),!t,"\\",m):"";return g.length===0&&!t&&(g="."),g.length>0&&m(n.charCodeAt(i-1))&&(g+="\\"),s===void 0?t?`\\${g}`:g:t?`${s}\\${g}`:`${s}${g}`},isAbsolute(n){p(n,"path");const i=n.length;if(i===0)return!1;const o=n.charCodeAt(0);return m(o)||i>2&&d(o)&&n.charCodeAt(1)===I&&m(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,o;for(let a=0;a<n.length;++a){const g=n[a];p(g,"path"),g.length>0&&(i===void 0?i=o=g:i+=`\\${g}`)}if(i===void 0)return".";let s=!0,t=0;if(typeof o=="string"&&m(o.charCodeAt(0))){++t;const a=o.length;a>1&&m(o.charCodeAt(1))&&(++t,a>2&&(m(o.charCodeAt(2))?++t:s=!1))}if(s){for(;t<i.length&&m(i.charCodeAt(t));)t++;t>=2&&(i=`\\${i.slice(t)}`)}return e.$fc.normalize(i)},relative(n,i){if(p(n,"from"),p(i,"to"),n===i)return"";const o=e.$fc.resolve(n),s=e.$fc.resolve(i);if(o===s||(n=o.toLowerCase(),i=s.toLowerCase(),n===i))return"";let t=0;for(;t<n.length&&n.charCodeAt(t)===v;)t++;let a=n.length;for(;a-1>t&&n.charCodeAt(a-1)===v;)a--;const g=a-t;let L=0;for(;L<i.length&&i.charCodeAt(L)===v;)L++;let D=i.length;for(;D-1>L&&i.charCodeAt(D-1)===v;)D--;const y=D-L,A=g<y?g:y;let F=-1,X=0;for(;X<A;X++){const J=n.charCodeAt(t+X);if(J!==i.charCodeAt(L+X))break;J===v&&(F=X)}if(X!==A){if(F===-1)return s}else{if(y>A){if(i.charCodeAt(L+X)===v)return s.slice(L+X+1);if(X===2)return s.slice(L+X)}g>A&&(n.charCodeAt(t+X)===v?F=X:X===2&&(F=3)),F===-1&&(F=0)}let te="";for(X=t+F+1;X<=a;++X)(X===a||n.charCodeAt(X)===v)&&(te+=te.length===0?"..":"\\..");return L+=F,te.length>0?`${te}${s.slice(L,D)}`:(s.charCodeAt(L)===v&&++L,s.slice(L,D))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===v){if(i.charCodeAt(1)===v){const o=i.charCodeAt(2);if(o!==k&&o!==P)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(d(i.charCodeAt(0))&&i.charCodeAt(1)===I&&i.charCodeAt(2)===v)return`\\\\?\\${i}`;return n},dirname(n){p(n,"path");const i=n.length;if(i===0)return".";let o=-1,s=0;const t=n.charCodeAt(0);if(i===1)return m(t)?n:".";if(m(t)){if(o=s=1,m(n.charCodeAt(1))){let L=2,D=L;for(;L<i&&!m(n.charCodeAt(L));)L++;if(L<i&&L!==D){for(D=L;L<i&&m(n.charCodeAt(L));)L++;if(L<i&&L!==D){for(D=L;L<i&&!m(n.charCodeAt(L));)L++;if(L===i)return n;L!==D&&(o=s=L+1)}}}}else d(t)&&n.charCodeAt(1)===I&&(o=i>2&&m(n.charCodeAt(2))?3:2,s=o);let a=-1,g=!0;for(let L=i-1;L>=s;--L)if(m(n.charCodeAt(L))){if(!g){a=L;break}}else g=!1;if(a===-1){if(o===-1)return".";a=o}return n.slice(0,a)},basename(n,i){i!==void 0&&p(i,"ext"),p(n,"path");let o=0,s=-1,t=!0,a;if(n.length>=2&&d(n.charCodeAt(0))&&n.charCodeAt(1)===I&&(o=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let g=i.length-1,L=-1;for(a=n.length-1;a>=o;--a){const D=n.charCodeAt(a);if(m(D)){if(!t){o=a+1;break}}else L===-1&&(t=!1,L=a+1),g>=0&&(D===i.charCodeAt(g)?--g===-1&&(s=a):(g=-1,s=L))}return o===s?s=L:s===-1&&(s=n.length),n.slice(o,s)}for(a=n.length-1;a>=o;--a)if(m(n.charCodeAt(a))){if(!t){o=a+1;break}}else s===-1&&(t=!1,s=a+1);return s===-1?"":n.slice(o,s)},extname(n){p(n,"path");let i=0,o=-1,s=0,t=-1,a=!0,g=0;n.length>=2&&n.charCodeAt(1)===I&&d(n.charCodeAt(0))&&(i=s=2);for(let L=n.length-1;L>=i;--L){const D=n.charCodeAt(L);if(m(D)){if(!a){s=L+1;break}continue}t===-1&&(a=!1,t=L+1),D===P?o===-1?o=L:g!==1&&(g=1):o!==-1&&(g=-1)}return o===-1||t===-1||g===0||g===1&&o===t-1&&o===s+1?"":n.slice(o,t)},format:$.bind(null,"\\"),parse(n){p(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.length;let s=0,t=n.charCodeAt(0);if(o===1)return m(t)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(m(t)){if(s=1,m(n.charCodeAt(1))){let F=2,X=F;for(;F<o&&!m(n.charCodeAt(F));)F++;if(F<o&&F!==X){for(X=F;F<o&&m(n.charCodeAt(F));)F++;if(F<o&&F!==X){for(X=F;F<o&&!m(n.charCodeAt(F));)F++;F===o?s=F:F!==X&&(s=F+1)}}}}else if(d(t)&&n.charCodeAt(1)===I){if(o<=2)return i.root=i.dir=n,i;if(s=2,m(n.charCodeAt(2))){if(o===3)return i.root=i.dir=n,i;s=3}}s>0&&(i.root=n.slice(0,s));let a=-1,g=s,L=-1,D=!0,y=n.length-1,A=0;for(;y>=s;--y){if(t=n.charCodeAt(y),m(t)){if(!D){g=y+1;break}continue}L===-1&&(D=!1,L=y+1),t===P?a===-1?a=y:A!==1&&(A=1):a!==-1&&(A=-1)}return L!==-1&&(a===-1||A===0||A===1&&a===L-1&&a===g+1?i.base=i.name=n.slice(g,L):(i.name=n.slice(g,a),i.base=n.slice(g,L),i.ext=n.slice(a,L))),g>0&&g!==s?i.dir=n.slice(0,g-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(c){const n=/\\/g;return()=>{const i=E.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>E.cwd()})();e.$gc={resolve(...n){let i="",o=!1;for(let s=n.length-1;s>=-1&&!o;s--){const t=s>=0?n[s]:h();p(t,"path"),t.length!==0&&(i=`${t}/${i}`,o=t.charCodeAt(0)===w)}return i=l(i,!o,"/",u),o?`/${i}`:i.length>0?i:"."},normalize(n){if(p(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===w,o=n.charCodeAt(n.length-1)===w;return n=l(n,!i,"/",u),n.length===0?i?"/":o?"./":".":(o&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return p(n,"path"),n.length>0&&n.charCodeAt(0)===w},join(...n){if(n.length===0)return".";let i;for(let o=0;o<n.length;++o){const s=n[o];p(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(p(n,"from"),p(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const o=1,s=n.length,t=s-o,a=1,g=i.length-a,L=t<g?t:g;let D=-1,y=0;for(;y<L;y++){const F=n.charCodeAt(o+y);if(F!==i.charCodeAt(a+y))break;F===w&&(D=y)}if(y===L)if(g>L){if(i.charCodeAt(a+y)===w)return i.slice(a+y+1);if(y===0)return i.slice(a+y)}else t>L&&(n.charCodeAt(o+y)===w?D=y:y===0&&(D=0));let A="";for(y=o+D+1;y<=s;++y)(y===s||n.charCodeAt(y)===w)&&(A+=A.length===0?"..":"/..");return`${A}${i.slice(a+D)}`},toNamespacedPath(n){return n},dirname(n){if(p(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===w;let o=-1,s=!0;for(let t=n.length-1;t>=1;--t)if(n.charCodeAt(t)===w){if(!s){o=t;break}}else s=!1;return o===-1?i?"/":".":i&&o===1?"//":n.slice(0,o)},basename(n,i){i!==void 0&&p(i,"ext"),p(n,"path");let o=0,s=-1,t=!0,a;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let g=i.length-1,L=-1;for(a=n.length-1;a>=0;--a){const D=n.charCodeAt(a);if(D===w){if(!t){o=a+1;break}}else L===-1&&(t=!1,L=a+1),g>=0&&(D===i.charCodeAt(g)?--g===-1&&(s=a):(g=-1,s=L))}return o===s?s=L:s===-1&&(s=n.length),n.slice(o,s)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===w){if(!t){o=a+1;break}}else s===-1&&(t=!1,s=a+1);return s===-1?"":n.slice(o,s)},extname(n){p(n,"path");let i=-1,o=0,s=-1,t=!0,a=0;for(let g=n.length-1;g>=0;--g){const L=n.charCodeAt(g);if(L===w){if(!t){o=g+1;break}continue}s===-1&&(t=!1,s=g+1),L===P?i===-1?i=g:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||s===-1||a===0||a===1&&i===s-1&&i===o+1?"":n.slice(i,s)},format:$.bind(null,"/"),parse(n){p(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.charCodeAt(0)===w;let s;o?(i.root="/",s=1):s=0;let t=-1,a=0,g=-1,L=!0,D=n.length-1,y=0;for(;D>=s;--D){const A=n.charCodeAt(D);if(A===w){if(!L){a=D+1;break}continue}g===-1&&(L=!1,g=D+1),A===P?t===-1?t=D:y!==1&&(y=1):t!==-1&&(y=-1)}if(g!==-1){const A=a===0&&o?1:a;t===-1||y===0||y===1&&t===g-1&&t===a+1?i.base=i.name=n.slice(A,g):(i.name=n.slice(A,t),i.base=n.slice(A,g),i.ext=n.slice(t,g))}return a>0?i.dir=n.slice(0,a-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(be[40],ve([1,0,7,4,17,10]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function S(a){return a===47||a===92}e.$Wf=S;function P(a){return a.replace(/[\\/]/g,E.$gc.sep)}e.$Xf=P;function w(a){return a.indexOf("/")===-1&&(a=P(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Yf=w;function v(a,g=E.$gc.sep){if(!a)return"";const L=a.length,D=a.charCodeAt(0);if(S(D)){if(S(a.charCodeAt(1))&&!S(a.charCodeAt(2))){let A=3;const F=A;for(;A<L&&!S(a.charCodeAt(A));A++);if(F!==A&&!S(a.charCodeAt(A+1))){for(A+=1;A<L;A++)if(S(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,g)}}return g}else if(u(D)&&a.charCodeAt(1)===58)return S(a.charCodeAt(2))?a.slice(0,2)+g:a.slice(0,2);let y=a.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(S(a.charCodeAt(y)))return a.slice(0,y+1)}return""}e.$Zf=v;function I(a){if(!R.$i||!a||a.length<5)return!1;let g=a.charCodeAt(0);if(g!==92||(g=a.charCodeAt(1),g!==92))return!1;let L=2;const D=L;for(;L<a.length&&(g=a.charCodeAt(L),g!==92);L++);return!(D===L||(g=a.charCodeAt(L+1),isNaN(g)||g===92))}e.$1f=I;const k=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(a,g=R.$i){const L=g?k:b;return!(!a||a.length===0||/^\s+$/.test(a)||(L.lastIndex=0,L.test(a))||g&&f.test(a)||a==="."||a===".."||g&&a[a.length-1]==="."||g&&a.length!==a.trim().length||a.length>255)}e.$2f=p;function c(a,g,L){const D=a===g;return!L||D?D:!a||!g?!1:(0,r.$8e)(a,g)}e.$3f=c;function m(a,g,L,D=E.sep){if(a===g)return!0;if(!a||!g||g.length>a.length)return!1;if(L){if(!(0,r.$9e)(a,g))return!1;if(g.length===a.length)return!0;let A=g.length;return g.charAt(g.length-1)===D&&A--,a.charAt(A)===D}return g.charAt(g.length-1)!==D&&(g+=D),a.indexOf(g)===0}e.$4f=m;function u(a){return a>=65&&a<=90||a>=97&&a<=122}e.$5f=u;function d(a,g){return R.$i&&a.endsWith(":")&&(a+=E.sep),(0,E.$ic)(a)||(a=(0,E.$jc)(g,a)),a=(0,E.$hc)(a),R.$i?(a=(0,r.$Qe)(a,E.sep),a.endsWith(":")&&(a+=E.sep)):(a=(0,r.$Qe)(a,E.sep),a||(a=E.sep)),a}e.$6f=d;function l(a){const g=(0,E.$hc)(a);return R.$i?a.length>3?!1:$(g)&&(a.length===2||g.charCodeAt(2)===92):g===E.$gc.sep}e.$7f=l;function $(a,g=R.$i){return g?u(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$8f=$;function h(a,g=R.$i){return $(a,g)?a[0]:void 0}e.$9f=h;function n(a,g,L){return g.length>a.length?-1:a===g?0:(L&&(a=a.toLowerCase(),g=g.toLowerCase()),a.indexOf(g))}e.$0f=n;function i(a){const g=a.split(":");let L,D,y;for(const A of g){const F=Number(A);(0,C.$If)(F)?D===void 0?D=F:y===void 0&&(y=F):L=L?[L,A].join(":"):A}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:D!==void 0?D:void 0,column:y!==void 0?y:D!==void 0?1:void 0}}e.$$f=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(a,g,L=8){let D="";for(let A=0;A<L;A++){let F;A===0&&R.$i&&!g&&(L===3||L===4)?F=s:F=o,D+=F.charAt(Math.floor(Math.random()*F.length))}let y;return g?y=`${g}-${D}`:y=D,a?(0,E.$jc)(a,y):y}e.$_f=t}),define(be[64],ve([1,0,7]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=void 0,e.$3r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(I){const k=(0,E.$oc)(I),b=R[k.toLowerCase()];return b!==void 0?b:S(I)}e.$4r=C;function S(I){const k=(0,E.$oc)(I);return r[k.toLowerCase()]}e.$5r=S;function P(I){for(const k in r)if(r[k]===I)return k}e.$6r=P;const w=/^(.+)\/(.+?)(;.+)?$/;function v(I,k){const b=w.exec(I);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:k?void 0:I}e.$7r=v}),define(be[65],ve([1,0,4]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var r;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function C(P,...w){const v=w.reduce((b,f)=>(b[f]=!0,b),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!v[b]).forEach(b=>{for(let f=0;f<I.length;f++)if(b.search(I[f])!==-1){delete P[b];break}})}e.$Ml=C;function S(P){P&&(delete P.DEBUG,E.$j&&delete P.DYLD_LIBRARY_PATH,E.$k&&delete P.LD_PRELOAD)}e.$Nl=S}),define(be[3],ve([1,0,7,4]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,C=/^\//,S=/^\/\//;function P(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!r.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!C.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,t){return!s&&!t?"file":s}function v(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const I="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(t){return t instanceof f?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,a,g,L,D,y=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=w(t,y),this.authority=a||I,this.path=v(this.scheme,g||I),this.query=L||I,this.fragment=D||I,P(this,y))}get fsPath(){return $(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:g,path:L,query:D,fragment:y}=t;return a===void 0?a=this.scheme:a===null&&(a=I),g===void 0?g=this.authority:g===null&&(g=I),L===void 0?L=this.path:L===null&&(L=I),D===void 0?D=this.query:D===null&&(D=I),y===void 0?y=this.fragment:y===null&&(y=I),a===this.scheme&&g===this.authority&&L===this.path&&D===this.query&&y===this.fragment?this:new m(a,g,L,D,y)}static parse(t,a=!1){const g=b.exec(t);return g?new m(g[2]||I,o(g[4]||I),o(g[5]||I),o(g[7]||I),o(g[9]||I),a):new m(I,I,I,I,I)}static file(t){let a=I;if(R.$i&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const g=t.indexOf(k,2);g===-1?(a=t.substring(2),t=k):(a=t.substring(2,g),t=t.substring(g)||k)}return new m("file",a,t,I,I)}static from(t,a){return new m(t.scheme,t.authority,t.path,t.query,t.fragment,a)}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return R.$i&&t.scheme==="file"?g=f.file(E.$fc.join($(t,!0),...a)).path:g=E.$gc.join(t.path,...a),t.with({path:g})}toString(t=!1){return h(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof f)return t;{const a=new m(t);return a._formatted=t.external??null,a._fsPath=t._sep===c?t.fsPath??null:null,a}}else return t}}e.URI=f;function p(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=p;const c=R.$i?1:void 0;class m extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(t=!1){return t?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=c),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(s,t,a){let g,L=-1;for(let D=0;D<s.length;D++){const y=s.charCodeAt(D);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||t&&y===47||a&&y===91||a&&y===93||a&&y===58)L!==-1&&(g+=encodeURIComponent(s.substring(L,D)),L=-1),g!==void 0&&(g+=s.charAt(D));else{g===void 0&&(g=s.substr(0,D));const A=u[y];A!==void 0?(L!==-1&&(g+=encodeURIComponent(s.substring(L,D)),L=-1),g+=A):L===-1&&(L=D)}}return L!==-1&&(g+=encodeURIComponent(s.substring(L))),g!==void 0?g:s}function l(s){let t;for(let a=0;a<s.length;a++){const g=s.charCodeAt(a);g===35||g===63?(t===void 0&&(t=s.substr(0,a)),t+=u[g]):t!==void 0&&(t+=s[a])}return t!==void 0?t:s}function $(s,t){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,R.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=$;function h(s,t){const a=t?l:d;let g="",{scheme:L,authority:D,path:y,query:A,fragment:F}=s;if(L&&(g+=L,g+=":"),(D||L==="file")&&(g+=k,g+=k),D){let X=D.indexOf("@");if(X!==-1){const te=D.substr(0,X);D=D.substr(X+1),X=te.lastIndexOf(":"),X===-1?g+=a(te,!1,!1):(g+=a(te.substr(0,X),!1,!1),g+=":",g+=a(te.substr(X+1),!1,!0)),g+="@"}D=D.toLowerCase(),X=D.lastIndexOf(":"),X===-1?g+=a(D,!1,!0):(g+=a(D.substr(0,X),!1,!0),g+=D.substr(X))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const X=y.charCodeAt(1);X>=65&&X<=90&&(y=`/${String.fromCharCode(X+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const X=y.charCodeAt(0);X>=65&&X<=90&&(y=`${String.fromCharCode(X+32)}:${y.substr(2)}`)}g+=a(y,!0,!1)}return A&&(g+="?",g+=a(A,!1,!1)),F&&(g+="#",g+=t?F:d(F,!1,!1)),g}function n(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+n(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,t=>n(t)):s}}),define(be[165],ve([1,0,3]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$aq=e.$_p=e.$$p=void 0;function R(v){const I=v;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.$$p=R;function r(v){const I=[];let k;try{const b=JSON.parse(v.arguments),f=b[b.length-1];f&&f.__$stack&&(b.pop(),k=f.__$stack),I.push(...b)}catch{I.push("Unable to log remote console arguments",v.arguments)}return{args:I,stack:k}}e.$_p=r;function C(v){if(typeof v!="string")return C(r(v).stack);const I=v;if(I){const k=S(I),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(b&&b.length===4)return{uri:E.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.$aq=C;function S(v){if(!v)return v;const I=v.indexOf(`
`);return I===-1?v:v.substring(0,I)}function P(v,I){const{args:k,stack:b}=r(v),f=typeof k[0]=="string"&&k.length===1;let p=S(b);p&&(p=`(${p.trim()})`);let c=[];if(typeof k[0]=="string"?p&&f?c=[`%c[${I}] %c${k[0]} %c${p}`,w("blue"),w(""),w("grey")]:c=[`%c[${I}] %c${k[0]}`,w("blue"),w(""),...k.slice(1)]:c=[`%c[${I}]%`,w("blue"),...k],p&&!f&&c.push(p),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,c)}e.log=P;function w(v){return`color: ${v}`}}),define(be[50],ve([1,0,15,3]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function r(w){return JSON.stringify(w,S)}e.$wh=r;function C(w){let v=JSON.parse(w);return v=P(v),v}e.$xh=C;function S(w,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:v.flags}:v}function P(w,v=0){if(!w||v>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return R.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 17:return new Date(w.source)}if(w instanceof E.$ge||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let I=0;I<w.length;++I)w[I]=P(w[I],v+1);else for(const I in w)Object.hasOwnProperty.call(w,I)&&(w[I]=P(w[I],v+1))}return w}e.$yh=P}),define(be[12],ve([1,0,11,4,17,3]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var S;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(S||(e.Schemas=S={}));function P(b,f){return C.URI.isUri(b)?(0,r.$8e)(b.scheme,f):(0,r.$9e)(b,f+":")}e.$ag=P;function w(b,...f){return f.some(p=>P(b,p))}e.$bg=w,e.$cg="vscode-tkn",e.$dg="tkn";class v{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${S.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${S.vscodeRemoteResource}`}set(f,p,c){this.a[f]=p,this.b[f]=c}setConnectionToken(f,p){this.c[f]=p}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return E.$1(l),f}const p=f.authority;let c=this.a[p];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const m=this.b[p],u=this.c[p];let d=`path=${encodeURIComponent(f.path)}`;return typeof u=="string"&&(d+=`&${e.$dg}=${encodeURIComponent(u)}`),C.URI.from({scheme:R.$o?this.d:S.vscodeRemoteResource,authority:`${c}:${m}`,path:this.f,query:d})}}e.$eg=new v,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class I{static{this.a=e.$jg}asBrowserUri(f){const p=this.b(f,ue);return this.uriToBrowserUri(p)}uriToBrowserUri(f){return f.scheme===S.vscodeRemote?e.$eg.rewrite(f):f.scheme===S.file&&(R.$m||R.$q===`${S.vscodeFileResource}://${I.a}`)?f.with({scheme:S.vscodeFileResource,authority:f.authority||I.a,query:null,fragment:null}):f}asFileUri(f){const p=this.b(f,ue);return this.uriToFileUri(p)}uriToFileUri(f){return f.scheme===S.vscodeFileResource?f.with({scheme:S.file,authority:f.authority!==I.a?f.authority:null,query:null,fragment:null}):f}b(f,p){return C.URI.isUri(f)?f:C.URI.parse(p.toUrl(f))}}e.$kg=new I;var k;(function(b){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(f.get("3"));const p="vscode-coi";function c(u){let d;typeof u=="string"?d=new URL(u).searchParams:u instanceof URL?d=u.searchParams:C.URI.isUri(u)&&(d=new URL(u.toString(!0)).searchParams);const l=d?.get(p);if(l)return f.get(l)}b.getHeadersFromQuery=c;function m(u,d,l){if(!globalThis.crossOriginIsolated)return;const $=d&&l?"3":l?"2":"1";u instanceof URLSearchParams?u.set(p,$):u[p]=$}b.addSearchParam=m})(k||(e.COI=k={}))}),define(be[166],ve([1,0,95,12,4,3]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=void 0;class S{constructor(b,f,p){this.id=b,this.dependencies=f,this.callback=p}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,f,p)=>{typeof b!="string"&&(p=f,f=b,b=null),(typeof f!="object"||!Array.isArray(f))&&(p=f,f=null),this.c.push(new S(b,f,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const f=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!f)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(b){return new Promise((f,p)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const m=()=>{c.removeEventListener("load",u),c.removeEventListener("error",d)},u=l=>{m(),f(this.c.pop())},d=l=>{m(),p(l)};c.addEventListener("load",u),c.addEventListener("error",d),this.f&&(b=this.f.createScriptURL(b)),c.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(b){return new Promise((f,p)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),f(this.c.pop())}catch(c){p(c)}})}async j(b){try{const f=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,m=C.URI.parse(b).fsPath,u=f.readFileSync(m).toString(),d=c.wrap(u.replace(/^#!.*/,""));return new p.Script(d).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const w=new Map;let v={};typeof globalThis.require=="object"&&(v=globalThis.require.paths??{});async function I(k,b,f){if(E.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),v[k]&&(k=v[k]);const p=`${k}/${b}`;if(w.has(p))return w.get(p);let c;if(/^\w[\w\d+.-]*:\/\//.test(p))c=p;else{const l=`${f&&!r.$o?R.$hg:R.$gg}/${p}`;c=R.$kg.asBrowserUri(l).toString(!0)}const m=P.INSTANCE.load(c);return w.set(p,m),m}else return await new Promise((p,c)=>{ue([k],p,c)})}e.$YC=I}),define(be[19],ve([1,0,40,12,7,4,17,3]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function w(f){return(0,P.$wc)(f,!0)}e.$rg=w;class v{constructor(p){this.a=p}compare(p,c,m=!1){return p===c?0:(0,S.$1e)(this.getComparisonKey(p,m),this.getComparisonKey(c,m))}isEqual(p,c,m=!1){return p===c?!0:!p||!c?!1:this.getComparisonKey(p,m)===this.getComparisonKey(c,m)}getComparisonKey(p,c=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,c,m=!1){if(p.scheme===c.scheme){if(p.scheme===R.Schemas.file)return E.$4f(w(p),w(c),this.a(p))&&p.query===c.query&&(m||p.fragment===c.fragment);if((0,e.$Ig)(p.authority,c.authority))return E.$4f(p.path,c.path,this.a(p),"/")&&p.query===c.query&&(m||p.fragment===c.fragment)}return!1}joinPath(p,...c){return P.URI.joinPath(p,...c)}basenameOrAuthority(p){return(0,e.$Ag)(p)||p.authority}basename(p){return r.$gc.basename(p.path)}extname(p){return r.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let c;return p.scheme===R.Schemas.file?c=P.URI.file(r.$mc(w(p))).path:(c=r.$gc.dirname(p.path),p.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),c="/")),p.with({path:c})}normalizePath(p){if(!p.path.length)return p;let c;return p.scheme===R.Schemas.file?c=P.URI.file(r.$hc(w(p))).path:c=r.$gc.normalize(p.path),p.with({path:c})}relativePath(p,c){if(p.scheme!==c.scheme||!(0,e.$Ig)(p.authority,c.authority))return;if(p.scheme===R.Schemas.file){const d=r.$lc(w(p),w(c));return C.$i?E.$Xf(d):d}let m=p.path||"/";const u=c.path||"/";if(this.a(p)){let d=0;for(const l=Math.min(m.length,u.length);d<l&&!(m.charCodeAt(d)!==u.charCodeAt(d)&&m.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);m=u.substr(0,d)+m.substr(d)}return r.$gc.relative(m,u)}resolvePath(p,c){if(p.scheme===R.Schemas.file){const m=P.URI.file(r.$kc(w(p),c));return p.with({authority:m.authority,path:m.path})}return c=E.$Yf(c),p.with({path:r.$gc.resolve(p.path,c)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,c){return p===c||p!==void 0&&c!==void 0&&(0,S.$8e)(p,c)}hasTrailingPathSeparator(p,c=r.sep){if(p.scheme===R.Schemas.file){const m=w(p);return m.length>E.$Zf(m).length&&m[m.length-1]===c}else{const m=p.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,c=r.sep){return(0,e.$Jg)(p,c)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,c=r.sep){let m=!1;if(p.scheme===R.Schemas.file){const u=w(p);m=u!==void 0&&u.length===E.$Zf(u).length&&u[u.length-1]===c}else{c="/";const u=p.path;m=u.length===1&&u.charCodeAt(u.length-1)===47}return!m&&!(0,e.$Jg)(p,c)?p.with({path:p.path+"/"}):p}}e.$sg=v,e.$tg=new v(()=>!1),e.$ug=new v(f=>f.scheme===R.Schemas.file?!C.$k:!0),e.$vg=new v(f=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function I(f,p){const c=[];for(let m=0;m<f.length;m++){const u=p(f[m]);f.some((d,l)=>l===m?!1:(0,e.$xg)(u,p(d)))||c.push(f[m])}return c}e.$Mg=I;var k;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function p(c){const m=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(l=>{const[$,h]=l.split(":");$&&h&&m.set($,h)});const d=c.path.substring(0,c.path.indexOf(";"));return d&&m.set(f.META_DATA_MIME,d),m}f.parseMetaData=p})(k||(e.DataUri=k={}));function b(f,p,c){if(p){let m=f.path;return m&&m[0]!==r.$gc.sep&&(m=r.$gc.sep+m),f.with({scheme:c,authority:p,path:m})}return f.with({scheme:c})}e.$Ng=b}),define(be[14],ve([1,0,20,11,5,2,19,4,149,59]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function I(B){return!!B&&typeof B.then=="function"}e.$Og=I;function k(B){const H=new E.$3d,T=B(H.token),W=new Promise((x,re)=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),re(new R.$5)});Promise.resolve(T).then(ce=>{fe.dispose(),H.dispose(),x(ce)},ce=>{fe.dispose(),H.dispose(),re(ce)})});return new class{cancel(){H.cancel()}then(x,re){return W.then(x,re)}catch(x){return this.then(void 0,x)}finally(x){return W.finally(x)}}}e.$Pg=k;function b(B,H,T){return new Promise((W,x)=>{const re=H.onCancellationRequested(()=>{re.dispose(),W(T)});B.then(W,x).finally(()=>re.dispose())})}e.$Qg=b;function f(B,H){return new Promise((T,W)=>{const x=H.onCancellationRequested(()=>{x.dispose(),W(new R.$5)});B.then(T,W).finally(()=>x.dispose())})}e.$Rg=f;async function p(B){let H=-1;const T=B.map((W,x)=>W.then(re=>(H=x,re)));try{return await Promise.race(T)}finally{B.forEach((W,x)=>{x!==H&&W.cancel()})}}e.$Sg=p;function c(B,H,T){let W;const x=setTimeout(()=>{W?.(void 0),T?.()},H);return Promise.race([B.finally(()=>clearTimeout(x)),new Promise(re=>W=re)])}e.$Tg=c;function m(B){return new Promise((H,T)=>{const W=B();I(W)?W.then(H,T):H(W)})}e.$Ug=m;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const T=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(T,T).then(W)})}return new Promise((T,W)=>{this.b.then(T,W)})}return this.a=H(),new Promise((T,W)=>{this.a.then(x=>{this.a=null,T(x)},x=>{this.a=null,W(x)})})}dispose(){this.f=!0}}e.$Vg=u;class d{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Wg=d;class l{constructor(){this.a=new Map}queue(H,T){const x=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.a.get(H)===x&&this.a.delete(H)});return this.a.set(H,x),x}}e.$Xg=l;const $=(B,H)=>{let T=!0;const W=setTimeout(()=>{T=!1,H()},B);return{isTriggered:()=>T,dispose:()=>{clearTimeout(W),T=!1}}},h=B=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,B())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class n{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,T=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((x,re)=>{this.d=x,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=T===w.$Pd?h(W):$(T,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=n;class i{constructor(H){this.a=new n(H),this.b=new u}trigger(H,T){return this.a.trigger(()=>this.b.queue(H),T)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=i;class o{constructor(){this.a=!1,this.b=new Promise((H,T)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=o;class s extends o{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$2g=s;function t(B,H){return H?new Promise((T,W)=>{const x=setTimeout(()=>{re.dispose(),T()},B),re=H.onCancellationRequested(()=>{clearTimeout(x),re.dispose(),W(new R.$5)})}):k(T=>t(B,T))}e.$3g=t;function a(B,H=0,T){const W=setTimeout(()=>{B(),T&&x.dispose()},H),x=(0,C.$Qc)(()=>{clearTimeout(W),T?.deleteAndLeak(x)});return T?.add(x),x}e.$4g=a;function g(B){const H=[];let T=0;const W=B.length;function x(){return T<W?B[T++]():null}function re(fe){fe!=null&&H.push(fe);const ce=x();return ce?ce.then(re):Promise.resolve(H)}return Promise.resolve(null).then(re)}e.$5g=g;function L(B,H=W=>!!W,T=null){let W=0;const x=B.length,re=()=>{if(W>=x)return Promise.resolve(T);const fe=B[W++];return Promise.resolve(fe()).then(ge=>H(ge)?Promise.resolve(ge):re())};return re()}e.$6g=L;function D(B,H=W=>!!W,T=null){if(B.length===0)return Promise.resolve(T);let W=B.length;const x=()=>{W=-1;for(const re of B)re.cancel?.()};return new Promise((re,fe)=>{for(const ce of B)ce.then(ge=>{--W>=0&&H(ge)?(x(),re(ge)):W===0&&re(T)}).catch(ge=>{--W>=0&&(x(),fe(ge))})})}e.$7g=D;class y{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new r.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((T,W)=>{this.f.push({factory:H,c:T,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const T=H.factory();T.then(H.c,H.e),T.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=y;class A extends y{constructor(){super(1)}}e.$9g=A;class F{constructor(){this.a=new G,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$0g=F;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new se;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,T=S.$tg){const W=T.getComparisonKey(H);let x=this.a.get(W);if(!x){x=new A;const re=this.f++,fe=r.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$2c),this.d.set(re,fe),this.a.set(W,x)}return x}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=X;class te{constructor(H,T){this.a=-1,typeof H=="function"&&typeof T=="number"&&this.setIfNotSet(H,T)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,T){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},T)}setIfNotSet(H,T){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},T))}}e.$_g=te;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,T,W=globalThis){this.cancel();const x=W.setInterval(()=>{H()},T);this.d=(0,C.$Qc)(()=>{W.clearInterval(x),this.d=void 0})}dispose(){this.cancel()}}e.$ah=J;class ie{constructor(H,T){this.b=-1,this.a=H,this.d=T,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=ie;class ee{constructor(H,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.a=H,this.b=T,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=ee;class U extends ie{constructor(H,T){super(H,T),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$dh=U;class he extends C.$Sc{constructor(H,T){super(),this.g=H,this.h=T,this.a=[],this.b=this.B(new C.$Tc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const T of H)this.a.push(T);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(B,H)=>{(0,P.$B)(()=>{if(T)return;const W=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$gh=(B,H,T)=>{const W=B.requestIdleCallback(H,typeof T=="number"?{timeout:T}:void 0);let x=!1;return{dispose(){x||(x=!0,B.cancelIdleCallback(W))}}},e.$fh=B=>(0,e.$gh)(globalThis,B)}();class Q{constructor(H,T){this.g=!1,this.d=()=>{try{this.j=T()}catch(W){this.l=W}finally{this.g=!0}},this.f=(0,e.$gh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=Q;class _ extends Q{constructor(H){super(globalThis,H)}}e.$ih=_;async function V(B,H,T){let W;for(let x=0;x<T;x++)try{return await B()}catch(re){W=re,await t(H)}throw W}e.$jh=V;class G{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,T,W){return this.a={taskId:H,cancel:()=>W?.(),promise:T},T.then(()=>this.d(H),()=>this.d(H)),T}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let T,W;const x=new Promise((re,fe)=>{T=re,W=fe});this.b={run:H,promise:x,promiseResolve:T,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=G;class oe{constructor(H,T=()=>Date.now()){this.d=H,this.f=T,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$lh=oe;var le;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(le||(le={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,T)=>{this.a=H,this.b=T})}complete(H){return new Promise(T=>{this.a(H),this.d={outcome:0,value:H},T()})}error(H){return new Promise(T=>{this.b(H),this.d={outcome:1,value:H},T()})}cancel(){return this.error(new R.$5)}}e.$mh=se;var $e;(function(B){async function H(W){let x;const re=await Promise.all(W.map(fe=>fe.then(ce=>ce,ce=>{x||(x=ce)})));if(typeof x<"u")throw x;return re}B.settled=H;function T(W){return new Promise(async(x,re)=>{try{await W(x,re)}catch(fe){re(fe)}})}B.withAsyncBody=T})($e||(e.Promises=$e={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(T=>(this.a=T,this.d=!0,T),T=>{throw this.b=T,this.d=!0,T})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=z;class q{constructor(H){this.b=H,this.a=new v.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=q;var O;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(O||(O={}));class j{static fromArray(H){return new j(T=>{T.emitMany(H)})}static fromPromise(H){return new j(async T=>{T.emitMany(await H)})}static fromPromises(H){return new j(async T=>{await Promise.all(H.map(async W=>T.emitOne(await W)))})}static merge(H){return new j(async T=>{await Promise.all(H.map(async W=>{for await(const x of W)T.emitOne(x)}))})}static{this.EMPTY=j.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new r.$Sd,queueMicrotask(async()=>{const T={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(H(T)),this.j()}catch(W){this.k(W)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(H,T){return new j(async W=>{for await(const x of H)W.emitOne(T(x))})}map(H){return j.map(this,H)}static filter(H,T){return new j(async W=>{for await(const x of H)T(x)&&W.emitOne(x)})}filter(H){return j.filter(this,H)}static coalesce(H){return j.filter(H,T=>!!T)}coalesce(){return j.coalesce(this)}static async toPromise(H){const T=[];for await(const W of H)T.push(W);return T}toPromise(){return j.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$ph=j;class ne extends j{constructor(H,T){super(T),this.l=H}cancel(){this.l.cancel()}}e.$qh=ne;function Y(B){const H=new E.$3d,T=B(H.token);return new ne(H,async W=>{const x=H.token.onCancellationRequested(()=>{x.dispose(),H.dispose(),W.reject(new R.$5)});try{for await(const re of T){if(H.token.isCancellationRequested)return;W.emitOne(re)}x.dispose(),H.dispose()}catch(re){x.dispose(),H.dispose(),W.reject(re)}})}e.$rh=Y;class Z{constructor(){this.a=new se,this.b=new j(W=>{if(H){W.reject(H);return}return T&&W.emitMany(T),this.d=x=>W.reject(x),this.f=x=>W.emitOne(x),this.a.p});let H,T;this.f=W=>{T||(T=[]),T.push(W)},this.d=W=>{H||(H=W)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$sh=Z}),define(be[80],ve([1,0,18,14,40,26,7,4,17]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function v(){return Object.create(null)}e.$Dj=v,e.$Ej="**",e.$Fj="/";const I="[/\\\\]",k="[^/\\\\]",b=/\//g;function f(_,V){switch(_){case 0:return"";case 1:return`${k}*?`;default:return`(?:${I}|${k}+${I}${V?`|${I}${k}+`:""})*?`}}function p(_,V){if(!_)return[];const G=[];let oe=!1,le=!1,se="";for(const $e of _){switch($e){case V:if(!oe&&!le){G.push(se),se="";continue}break;case"{":oe=!0;break;case"}":oe=!1;break;case"[":le=!0;break;case"]":le=!1;break}se+=$e}return se&&G.push(se),G}e.$Gj=p;function c(_){if(!_)return"";let V="";const G=p(_,e.$Fj);if(G.every(oe=>oe===e.$Ej))V=".*";else{let oe=!1;G.forEach((le,se)=>{if(le===e.$Ej){if(oe)return;V+=f(2,se===G.length-1)}else{let $e=!1,z="",q=!1,O="";for(const j of le){if(j!=="}"&&$e){z+=j;continue}if(q&&(j!=="]"||!O)){let ne;j==="-"?ne=j:(j==="^"||j==="!")&&!O?ne="^":j===e.$Fj?ne="":ne=(0,w.$Ke)(j),O+=ne;continue}switch(j){case"{":$e=!0;continue;case"[":q=!0;continue;case"}":{const Y=`(?:${p(z,",").map(Z=>c(Z)).join("|")})`;V+=Y,$e=!1,z="";break}case"]":{V+="["+O+"]",q=!1,O="";break}case"?":V+=k;continue;case"*":V+=f(1);continue;default:V+=(0,w.$Ke)(j)}}se<G.length-1&&(G[se+1]!==e.$Ej||se+2<G.length)&&(V+=I)}oe=le===e.$Ej})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new C.$Dc(1e4),i=function(){return!1},o=function(){return null};function s(_,V){if(!_)return o;let G;typeof _!="string"?G=_.pattern:G=_,G=G.trim();const oe=`${G}_${!!V.trimForExclusions}`;let le=n.get(oe);if(le)return t(le,_);let se;return m.test(G)?le=g(G.substr(4),G):(se=u.exec(a(G,V)))?le=L(se[1],G):(V.trimForExclusions?l:d).test(G)?le=D(G,V):(se=$.exec(a(G,V)))?le=y(se[1].substr(1),G,!0):(se=h.exec(a(G,V)))?le=y(se[1],G,!1):le=A(G),n.set(oe,le),t(le,_)}function t(_,V){if(typeof V=="string")return _;const G=function(oe,le){return(0,r.$4f)(oe,V.base,!P.$k)?_((0,w.$Pe)(oe.substr(V.base.length),S.sep),le):null};return G.allBasenames=_.allBasenames,G.allPaths=_.allPaths,G.basenames=_.basenames,G.patterns=_.patterns,G}function a(_,V){return V.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function g(_,V){return function(G,oe){return typeof G=="string"&&G.endsWith(_)?V:null}}function L(_,V){const G=`/${_}`,oe=`\\${_}`,le=function($e,z){return typeof $e!="string"?null:z?z===_?V:null:$e===_||$e.endsWith(G)||$e.endsWith(oe)?V:null},se=[_];return le.basenames=se,le.patterns=[V],le.allBasenames=se,le}function D(_,V){const G=he(_.slice(1,-1).split(",").map(z=>s(z,V)).filter(z=>z!==o),_),oe=G.length;if(!oe)return o;if(oe===1)return G[0];const le=function(z,q){for(let O=0,j=G.length;O<j;O++)if(G[O](z,q))return _;return null},se=G.find(z=>!!z.allBasenames);se&&(le.allBasenames=se.allBasenames);const $e=G.reduce((z,q)=>q.allPaths?z.concat(q.allPaths):z,[]);return $e.length&&(le.allPaths=$e),le}function y(_,V,G){const oe=S.sep===S.$gc.sep,le=oe?_:_.replace(b,S.sep),se=S.sep+le,$e=S.$gc.sep+_;let z;return G?z=function(q,O){return typeof q=="string"&&(q===le||q.endsWith(se)||!oe&&(q===_||q.endsWith($e)))?V:null}:z=function(q,O){return typeof q=="string"&&(q===le||!oe&&q===_)?V:null},z.allPaths=[(G?"*/":"./")+_],z}function A(_){try{const V=new RegExp(`^${c(_)}$`);return function(G){return V.lastIndex=0,typeof G=="string"&&V.test(G)?_:null}}catch{return o}}function F(_,V,G){return!_||typeof V!="string"?!1:X(_)(V,void 0,G)}e.$Hj=F;function X(_,V={}){if(!_)return i;if(typeof _=="string"||te(_)){const G=s(_,V);if(G===o)return i;const oe=function(le,se){return!!G(le,se)};return G.allBasenames&&(oe.allBasenames=G.allBasenames),G.allPaths&&(oe.allPaths=G.allPaths),oe}return ee(_,V)}e.$Ij=X;function te(_){const V=_;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Jj=te;function J(_){return _.allBasenames||[]}e.$Kj=J;function ie(_){return _.allPaths||[]}e.$Lj=ie;function ee(_,V){const G=he(Object.getOwnPropertyNames(_).map(z=>U(z,_[z],V)).filter(z=>z!==o)),oe=G.length;if(!oe)return o;if(!G.some(z=>!!z.requiresSiblings)){if(oe===1)return G[0];const z=function(j,ne){let Y;for(let Z=0,B=G.length;Z<B;Z++){const H=G[Z](j,ne);if(typeof H=="string")return H;(0,R.$Og)(H)&&(Y||(Y=[]),Y.push(H))}return Y?(async()=>{for(const Z of Y){const B=await Z;if(typeof B=="string")return B}return null})():null},q=G.find(j=>!!j.allBasenames);q&&(z.allBasenames=q.allBasenames);const O=G.reduce((j,ne)=>ne.allPaths?j.concat(ne.allPaths):j,[]);return O.length&&(z.allPaths=O),z}const le=function(z,q,O){let j,ne;for(let Y=0,Z=G.length;Y<Z;Y++){const B=G[Y];B.requiresSiblings&&O&&(q||(q=(0,S.$nc)(z)),j||(j=q.substr(0,q.length-(0,S.$oc)(z).length)));const H=B(z,q,j,O);if(typeof H=="string")return H;(0,R.$Og)(H)&&(ne||(ne=[]),ne.push(H))}return ne?(async()=>{for(const Y of ne){const Z=await Y;if(typeof Z=="string")return Z}return null})():null},se=G.find(z=>!!z.allBasenames);se&&(le.allBasenames=se.allBasenames);const $e=G.reduce((z,q)=>q.allPaths?z.concat(q.allPaths):z,[]);return $e.length&&(le.allPaths=$e),le}function U(_,V,G){if(V===!1)return o;const oe=s(_,G);if(oe===o)return o;if(typeof V=="boolean")return oe;if(V){const le=V.when;if(typeof le=="string"){const se=($e,z,q,O)=>{if(!O||!oe($e,z))return null;const j=le.replace("$(basename)",()=>q),ne=O(j);return(0,R.$Og)(ne)?ne.then(Y=>Y?_:null):ne?_:null};return se.requiresSiblings=!0,se}}return oe}function he(_,V){const G=_.filter(z=>!!z.basenames);if(G.length<2)return _;const oe=G.reduce((z,q)=>{const O=q.basenames;return O?z.concat(O):z},[]);let le;if(V){le=[];for(let z=0,q=oe.length;z<q;z++)le.push(V)}else le=G.reduce((z,q)=>{const O=q.patterns;return O?z.concat(O):z},[]);const se=function(z,q){if(typeof z!="string")return null;if(!q){let j;for(j=z.length;j>0;j--){const ne=z.charCodeAt(j-1);if(ne===47||ne===92)break}q=z.substr(j)}const O=oe.indexOf(q);return O!==-1?le[O]:null};se.basenames=oe,se.patterns=le,se.allBasenames=oe;const $e=_.filter(z=>!z.basenames);return $e.push(se),$e}function Q(_,V){return(0,E.$ub)(_,V,(G,oe)=>typeof G=="string"&&typeof oe=="string"?G===oe:typeof G!="string"&&typeof oe!="string"?G.base===oe.base&&G.pattern===oe.pattern:!1)}e.$Mj=Q}),define(be[100],ve([1,0,11,150,19,17,3]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class w{constructor(u="",d=!1){if(this.value=u,typeof this.value!="string")throw(0,E.$7)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(u,d=0){return this.value+=b(this.supportThemeIcons?(0,R.$0j)(u):u).replace(/([ \t]+)/g,(l,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,d){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(u,d,l){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(u),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(u,d){const l=new RegExp((0,C.$Ke)(d),"g");return u.replace(l,($,h)=>u.charAt(h-1)!=="\\"?`\\${$}`:$)}}e.$dk=w;function v(m){return I(m)?!m.value:Array.isArray(m)?m.every(v):!0}e.$ek=v;function I(m){return m instanceof w?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.$fk=I;function k(m,u){return m===u?!0:!m||!u?!1:m.value===u.value&&m.isTrusted===u.isTrusted&&m.supportThemeIcons===u.supportThemeIcons&&m.supportHtml===u.supportHtml&&(m.baseUri===u.baseUri||!!m.baseUri&&!!u.baseUri&&(0,r.$wg)(S.URI.from(m.baseUri),S.URI.from(u.baseUri)))}e.$gk=k;function b(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=b;function f(m){return m.replace(/"/g,"&quot;")}e.$ik=f;function p(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$jk=p;function c(m){const u=[],d=m.split("|").map($=>$.trim());m=d[0];const l=d[1];if(l){const $=/height=(\d+)/.exec(l),h=/width=(\d+)/.exec(l),n=$?$[1]:"",i=h?h[1]:"",o=isFinite(parseInt(i)),s=isFinite(parseInt(n));o&&u.push(`width="${i}"`),s&&u.push(`height="${n}"`)}return{href:m,dimensions:u}}e.$kk=c}),define(be[167],ve([1,0,18,40,7,4,19,17]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=void 0;function w(s,t){const{os:a,tildify:g,relative:L}=t;if(L){const A=v(s,L,a);if(typeof A=="string")return A}let D=s.fsPath;if(a===1&&!C.$i?D=D.replace(/\//g,"\\"):a!==1&&C.$i&&(D=D.replace(/\\/g,"/")),a!==1&&g?.userHome){const A=g.userHome.fsPath;let F;s.scheme!==g.userHome.scheme&&s.path[0]===r.$gc.sep&&s.path[1]!==r.$gc.sep?F=g.userHome.with({path:s.path}).fsPath:F=D,D=b(F,A,a)}return(a===1?r.$fc:r.$gc).normalize(I(D,a===1))}e.$Gv=w;function v(s,t,a){const g=a===1?r.$fc:r.$gc,L=a===3?S.$tg:S.$vg,D=t.getWorkspace(),y=(0,E.$Ob)(D.folders);if(!y)return;s.scheme!==y.uri.scheme&&s.path[0]===r.$gc.sep&&s.path[1]!==r.$gc.sep&&(s=y.uri.with({path:s.path}));const A=t.getWorkspaceFolder(s);if(!A)return;let F;if(L.isEqual(A.uri,s)?F="":F=L.relativePath(A.uri,s)??"",F&&(F=g.normalize(F)),D.folders.length>1&&!t.noPrefix){const X=A.name?A.name:L.basenameOrAuthority(A.uri);F=F?`${X} \u2022 ${F}`:X}return F}function I(s,t=C.$i){return(0,R.$8f)(s,t)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$Hv=I;let k=Object.create(null);function b(s,t,a=C.OS){if(a===1||!s||!t)return s;let g=k.original===t?k.normalized:void 0;g||(g=t,C.$i&&(g=(0,R.$Xf)(g)),g=`${(0,P.$Qe)(g,r.$gc.sep)}${r.$gc.sep}`,k={original:t,normalized:g});let L=s;return C.$i&&(L=(0,R.$Xf)(L)),(a===3?L.startsWith(g):(0,P.$9e)(L,g))?`~/${L.substr(g.length)}`:s}e.$Iv=b;function f(s,t){return s.replace(/^~($|\/|\\)/,`${t}$1`)}e.$Jv=f;const p="\u2026",c="\\\\",m="~";function u(s,t=r.sep){const a=new Array(s.length);let g=!1;for(let L=0;L<s.length;L++){const D=s[L];if(D===""){a[L]=`.${t}`;continue}if(!D){a[L]=D;continue}g=!0;let y="",A=D;A.indexOf(c)===0?(y=A.substr(0,A.indexOf(c)+c.length),A=A.substr(A.indexOf(c)+c.length)):A.indexOf(t)===0?(y=A.substr(0,A.indexOf(t)+t.length),A=A.substr(A.indexOf(t)+t.length)):A.indexOf(m)===0&&(y=A.substr(0,A.indexOf(m)+m.length),A=A.substr(A.indexOf(m)+m.length));const F=A.split(t);for(let X=1;g&&X<=F.length;X++)for(let te=F.length-X;g&&te>=0;te--){g=!1;let J=F.slice(te,te+X).join(t);for(let ie=0;!g&&ie<s.length;ie++)if(ie!==L&&s[ie]&&s[ie].indexOf(J)>-1){const ee=te+X===F.length,U=te>0&&s[ie].indexOf(t)>-1?t+J:J,he=s[ie].endsWith(U);g=!ee||he}if(!g){let ie="";(F[0].endsWith(":")||y!=="")&&(te===1&&(te=0,X++,J=F[0]+t+J),te>0&&(ie=F[0]+t),ie=y+ie),te>0&&(ie=ie+p+t),ie=ie+J,te+X<F.length&&(ie=ie+t+p),a[L]=ie}}g&&(a[L]=D)}return a}e.$Kv=u;var d;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function l(s,t=Object.create(null)){const a=[];let g=!1,L="";for(const D of s)if(D==="$"||g&&D==="{")L&&a.push({value:L,type:d.TEXT}),L="",g=!0;else if(D==="}"&&g){const y=t[L];if(typeof y=="string")y.length&&a.push({value:y,type:d.VARIABLE});else if(y){const A=a[a.length-1];(!A||A.type!==d.SEPARATOR)&&a.push({value:y.label,type:d.SEPARATOR})}L="",g=!1}else L+=D;return L&&!g&&a.push({value:L,type:d.TEXT}),a.filter((D,y)=>{if(D.type===d.SEPARATOR){const A=a[y-1],F=a[y+1];return[A,F].every(X=>X&&(X.type===d.VARIABLE||X.type===d.TEXT)&&X.value.length>0)}return!0}).map(D=>D.value).join("")}e.$Lv=l;function $(s,t){return C.$j||t?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.$j?"&":"&&"):s.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Mv=$;function h(s,t){return C.$j||t?s.replace(/\(&&\w\)|&&/g,""):C.$i?s.replace(/&&|&/g,a=>a==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$Nv=h;function n(s){return s.replace(/&/g,"&&")}e.$Ov=n;function i(s){if(s.endsWith("]")){const t=s.lastIndexOf(" [",s.length-2);if(t!==-1){const a=o(s.substring(0,t));return{name:a.name,parentPath:a.parentPath+s.substring(t)}}}return o(s)}e.$Pv=i;function o(s){const t=s.indexOf("/")!==-1?r.$gc:r.$fc,a=t.basename(s),g=t.dirname(s);return a.length?{name:a,parentPath:g}:{name:g,parentPath:""}}}),define(be[51],ve([1,0,15,3]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=void 0;function r(k){return k.toJSON()}class C{constructor(b){this.a=b}transformIncoming(b){const f=this.a.transformIncoming(b);return f===b?b:r(R.URI.from(f))}transformOutgoing(b){const f=this.a.transformOutgoing(b);return f===b?b:r(R.URI.from(f))}transformOutgoingURI(b){const f=this.a.transformOutgoing(b);return f===b?b:R.URI.from(f)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.$Ym=C,e.$Zm=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function S(k,b,f){if(!k||f>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return b.transformOutgoing(k);for(const p in k)if(Object.hasOwnProperty.call(k,p)){const c=S(k[p],b,f+1);c!==null&&(k[p]=c)}}return null}function P(k,b){const f=S(k,b,0);return f===null?k:f}e.$1m=P;function w(k,b,f,p){if(!k||p>200)return null;if(typeof k=="object"){if(k.$mid===1)return f?R.URI.revive(b.transformIncoming(k)):b.transformIncoming(k);if(k instanceof E.$ge)return null;for(const c in k)if(Object.hasOwnProperty.call(k,c)){const m=w(k[c],b,f,p+1);m!==null&&(k[c]=m)}}return null}function v(k,b){const f=w(k,b,!1,0);return f===null?k:f}e.$2m=v;function I(k,b){const f=w(k,b,!0,0);return f===null?k:f}e.$3m=I}),define(be[101],ve([1,0,28,63,21,153,4]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=void 0,e.$5m=new class{c(b){return this.a||(this.a=R.$8h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,f=0;const p=(0,E.networkInterfaces)();for(const c in p){const m=p[c];if(m)for(const{mac:u,internal:d}of m)d||(f+=1,this.c(u.toUpperCase())&&(b+=1))}this.b=f>0?b/f:0}return this.b}};let P;async function w(b){return P||(P=(async()=>await v(b)||r.$mg())()),P}e.$6m=w;async function v(b){try{const f=await new Promise((c,m)=>{ue(["crypto"],c,m)}),p=(0,C.$4m)();return f.createHash("sha256").update(p,"utf8").digest("hex")}catch(f){b(f);return}}const I="Software\\Microsoft\\SQMClient";async function k(b){if(S.$i){const f=await new Promise((p,c)=>{ue(["@vscode/windows-registry"],p,c)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",I,"MachineId")||""}catch(p){return b(p),""}}return""}e.$7m=k}),define(be[168],ve([1,0,27,295,296,4]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=void 0;async function S(P){if(C.$j||C.$i)return;let w;for(const v of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{w=await(0,R.open)(v,E.constants.R_OK);break}catch{}if(!w){P("Unable to retrieve release information from known identifier paths.");return}try{const v=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),I={id:"unknown"};for await(const k of(0,r.createInterface)({input:w.createReadStream(),crlfDelay:1/0})){if(!k.includes("="))continue;const b=k.split("=")[0].toUpperCase().trim();if(v.has(b)){const f=k.split("=")[1].replace(/"/g,"").toLowerCase().trim();b==="ID"||b==="DISTRIB_ID"?I.id=f:b==="ID_LIKE"?I.id_like=f:(b==="VERSION_ID"||b==="DISTRIB_RELEASE")&&(I.version_id=f)}}return I}catch(v){P(v)}}e.$ng=S}),define(be[22],ve([1,0,27,28,297,14,40,98,7,4,19,3]),function(ue,e,E,R,r,C,S,P,w,v,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function f(U,he=b.UNLINK,Q){if((0,S.$7f)(U))throw new Error("rimraf - will refuse to recursively delete root");return he===b.UNLINK?c(U):p(U,Q)}async function p(U,he=(0,S.$_f)((0,R.tmpdir)())){try{try{await E.promises.rename(U,he)}catch(Q){return Q.code==="ENOENT"?void 0:c(U)}c(he).catch(Q=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function c(U){return(0,r.promisify)(E.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function m(U){if((0,S.$7f)(U))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function u(U,he){return $(await(he?d(U):(0,r.promisify)(E.readdir)(U)))}async function d(U){try{return await(0,r.promisify)(E.readdir)(U,{withFileTypes:!0})}catch(_){console.warn("[node.js fs] readdir with filetypes failed with error: ",_)}const he=[],Q=await u(U);for(const _ of Q){let V=!1,G=!1,oe=!1;try{const le=await e.Promises.lstat((0,w.$jc)(U,_));V=le.isFile(),G=le.isDirectory(),oe=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}he.push({name:_,isFile:()=>V,isDirectory:()=>G,isSymbolicLink:()=>oe})}return he}function l(U){return $(E.readdirSync(U))}e.readdirSync=l;function $(U){return U.map(he=>typeof he=="string"?v.$j?(0,P.$Bl)(he):he:(he.name=v.$j?(0,P.$Bl)(he.name):he.name,he))}async function h(U){const he=await u(U),Q=[];for(const _ of he)await i.existsDirectory((0,w.$jc)(U,_))&&Q.push(_);return Q}function n(U,he=1e3){return new Promise(Q=>{let _=!1;const V=setInterval(()=>{_||(_=!0,E.access(U,G=>{_=!1,G&&(clearInterval(V),Q(void 0))}))},he)})}e.whenDeleted=n;var i;(function(U){async function he(V){let G;try{if(G=await e.Promises.lstat(V),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(v.$i&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw le}throw oe}}U.stat=he;async function Q(V){try{const{stat:G,symbolicLink:oe}=await U.stat(V);return G.isFile()&&oe?.dangling!==!0}catch{}return!1}U.existsFile=Q;async function _(V){try{const{stat:G,symbolicLink:oe}=await U.stat(V);return G.isDirectory()&&oe?.dangling!==!0}catch{}return!1}U.existsDirectory=_})(i||(e.SymlinkSupport=i={}));const o=new C.$$g;function s(U,he,Q){return o.queueFor(k.URI.file(U),I.$ug).queue(()=>{const _=D(Q);return new Promise((V,G)=>g(U,he,_,oe=>oe?G(oe):V()))})}let t=!0;function a(U){t=U}e.configureFlushOnWrite=a;function g(U,he,Q,_){if(!t)return E.writeFile(U,he,{mode:Q.mode,flag:Q.flag},_);E.open(U,Q.flag,Q.mode,(V,G)=>{if(V)return _(V);E.writeFile(G,he,oe=>{if(oe)return E.close(G,()=>_(oe));E.fdatasync(G,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),a(!1)),E.close(G,se=>_(se))))})})}function L(U,he,Q){const _=D(Q);if(!t)return E.writeFileSync(U,he,{mode:_.mode,flag:_.flag});const V=E.openSync(U,_.flag,_.mode);try{E.writeFileSync(V,he);try{E.fdatasyncSync(V)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),a(!1)}}finally{E.closeSync(V)}}e.writeFileSync=L;function D(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function y(U,he,Q=6e4){if(U!==he)try{v.$i&&typeof Q=="number"?await A(U,he,Date.now(),Q):await(0,r.promisify)(E.rename)(U,he)}catch(_){if(U.toLowerCase()!==he.toLowerCase()&&_.code==="EXDEV"||U.endsWith("."))await F(U,he,{preserveSymlinks:!1}),await f(U,b.MOVE);else throw _}}async function A(U,he,Q,_,V=0){try{return await(0,r.promisify)(E.rename)(U,he)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-Q>=_)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${G}`),G;if(V===0){let oe=!1;try{const{stat:le}=await i.stat(he);le.isFile()||(oe=!0)}catch{}if(oe)throw G}return await(0,C.$3g)(Math.min(100,V*10)),A(U,he,Q,_,V+1)}}async function F(U,he,Q){return te(U,he,{root:{source:U,target:he},options:Q,handledSourcePaths:new Set})}const X=511;async function te(U,he,Q){if(Q.handledSourcePaths.has(U))return;Q.handledSourcePaths.add(U);const{stat:_,symbolicLink:V}=await i.stat(U);if(V){if(Q.options.preserveSymlinks)try{return await ee(U,he,Q)}catch{}if(V.dangling)return}return _.isDirectory()?J(U,he,_.mode&X,Q):ie(U,he,_.mode&X)}async function J(U,he,Q,_){await e.Promises.mkdir(he,{recursive:!0,mode:Q});const V=await u(U);for(const G of V)await te((0,w.$jc)(U,G),(0,w.$jc)(he,G),_)}async function ie(U,he,Q){await e.Promises.copyFile(U,he),await e.Promises.chmod(he,Q)}async function ee(U,he,Q){let _=await e.Promises.readlink(U);(0,S.$4f)(_,Q.root.source,!v.$k)&&(_=(0,w.$jc)(Q.root.target,_.substr(Q.root.source.length+1))),await e.Promises.symlink(_,he)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(U,he,Q,_,V)=>new Promise((G,oe)=>{E.read(U,he,Q,_,V,(le,se,$e)=>le?oe(le):G({bytesRead:se,buffer:$e}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(U,he,Q,_,V)=>new Promise((G,oe)=>{E.write(U,he,Q,_,V,(le,se,$e)=>le?oe(le):G({bytesWritten:se,buffer:$e}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return h}get writeFile(){return s}get rm(){return f}get rename(){return y}get copy(){return F}}}),define(be[169],ve([1,0,27,7,4,17,22]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.$gq=e.$fq=void 0;function P(b){if(r.$k)return b;const f=(0,R.$mc)(b);if(b===f)return b;const p=((0,R.$nc)(b)||b).toLowerCase();try{const m=(0,S.readdirSync)(f).filter(u=>u.toLowerCase()===p);if(m.length===1){const u=P(f);if(u)return(0,R.$jc)(u,m[0])}else if(m.length>1){const u=m.indexOf(p);if(u>=0){const d=P(f);if(d)return(0,R.$jc)(d,m[u])}}}catch{}return null}e.$fq=P;async function w(b){if(r.$k)return b;const f=(0,R.$mc)(b);if(b===f)return b;const p=((0,R.$nc)(b)||b).toLowerCase();try{const m=(await S.Promises.readdir(f)).filter(u=>u.toLowerCase()===p);if(m.length===1){const u=await w(f);if(u)return(0,R.$jc)(u,m[0])}else if(m.length>1){const u=m.indexOf(p);if(u>=0){const d=await w(f);if(d)return(0,R.$jc)(d,m[u])}}}catch{}return null}e.$gq=w;async function v(b){try{return await S.Promises.realpath(b)}catch{const p=k(b);return await S.Promises.access(p,E.constants.R_OK),p}}e.$hq=v;function I(b){try{return E.realpathSync(b)}catch{const p=k(b);return E.accessSync(p,E.constants.R_OK),p}}e.$iq=I;function k(b){return(0,C.$Qe)((0,R.$hc)(b),R.sep)}}),define(be[102],ve([1,0,28,7,22]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=void 0;const C=/^\d+$/,S=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(w||(w={}));let v;switch(process.arch){case"ia32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class k{constructor(h,n,i){this.exePath=h,this.displayName=n,this.a=i}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:$=!1}={}){return $?v===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:$=!1,findPreview:h=!1}={}){const n=b({useAlternateBitness:$});if(!n)return null;const i=R.$jc(n,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const g of await r.Promises.readdir(i)){let L=-1;if(h){const y=g.indexOf("-");if(y<0)continue;const A=g.substring(0,y);if(!C.test(A)||g.substring(y+1)!=="preview")continue;L=parseInt(A,10)}else{if(!C.test(g))continue;L=parseInt(g,10)}if(L<=o)continue;const D=R.$jc(i,g,"pwsh.exe");await r.SymlinkSupport.existsFile(D)&&(s=D,o=L)}if(!s)return null;const t=n.includes("x86")?" (x86)":"",a=h?" Preview":"";return new k(s,`PowerShell${a}${t}`,!0)}async function p({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const h=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:n,pwshMsixName:i}=$?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:S,pwshMsixName:"PowerShell (Store)"};for(const o of await r.Promises.readdir(h))if(n.test(o)){const s=R.$jc(h,o,"pwsh.exe");return new k(s,i)}return null}function c(){const $=R.$jc(E.homedir(),".dotnet","tools","pwsh.exe");return new k($,".NET Core PowerShell Global Tool")}function m(){const $=R.$jc(process.env.windir,v===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k($,"Windows PowerShell",!0)}async function*u(){let $=await f();$&&(yield $),$=await f({useAlternateBitness:!0}),$&&(yield $),$=await p(),$&&(yield $),$=c(),$&&(yield $),$=await f({findPreview:!0}),$&&(yield $),$=await p({findPreview:!0}),$&&(yield $),$=await f({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=m(),$&&(yield $)}async function*d(){for await(const $ of u())await $.exists()&&(yield $)}e.$Kl=d;async function l(){for await(const $ of d())return $;return null}e.$Ll=l}),define(be[103],ve([1,0,7,4,29,65,10,22]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function w(k=r.env){return k.comspec||"cmd.exe"}e.$Ol=w;function v(k){let b=[],f=!1;const p=function(c){if(f){b.push(c);return}(!k.send(c,u=>{if(u&&console.error(u),f=!1,b.length>0){const d=b.slice(0);b=[],d.forEach(l=>p(l))}})||R.$i)&&(f=!0)};return{send:p}}e.$Pl=v;var I;(function(k){async function b(f,p,c){if(E.$ic(f))return f;if(p===void 0&&(p=r.cwd()),E.$mc(f)!=="."||(c===void 0&&S.$Ef(r.env.PATH)&&(c=r.env.PATH.split(E.$tc)),c===void 0||c.length===0))return E.$jc(p,f);async function u(d){if(await P.Promises.exists(d)){let l;try{l=await P.Promises.stat(d)}catch($){$.message.startsWith("EACCES")&&(l=await P.Promises.lstat(d))}return l?!l.isDirectory():!1}return!1}for(const d of c){let l;if(E.$ic(d)?l=E.$jc(d,f):l=E.$jc(p,d,f),await u(l))return l;let $=l+".com";if(await u($)||($=l+".exe",await u($)))return $}return E.$jc(p,f)}k.findExecutable=b})(I||(e.win32=I={}))}),define(be[104],ve([1,0,52,12]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;function r(S){return new Promise((P,w)=>{let v;const I=new Map;function k(f,p,c,m,u){const d=I.get(p);if(f===S||d){const l={name:b(c),cmd:c,pid:f,ppid:p,load:m,mem:u};I.set(f,l),f===S&&(v=l),d&&(d.children||(d.children=[]),d.children.push(l),d.children.length>1&&(d.children=d.children.sort(($,h)=>$.pid-h.pid)))}}function b(f){const p=/--utility-sub-type=network/i,c=/--ms-enable-electron-run-as-node/i,m=/--crashes-directory/i,u=/\\pipe\\winpty-control/i,d=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(m.exec(f))return"electron-crash-reporter";if(u.exec(f))return"winpty-agent";if(d.exec(f))return"conpty-agent";let $=l.exec(f);if($&&$.length===2)return $[1]==="renderer"?"window":$[1]==="utility"?p.exec(f)?"utility-network-service":"utility-process":$[1]==="extensionHost"?"extension-host":$[1];const h=/[a-zA-Z-]+\.js/g;let n="";do $=h.exec(f),$&&(n+=$+" ");while($);return n&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${n})`:c.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substring(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substring(5):p;new Promise((p,c)=>{ue(["@vscode/windows-process-tree"],p,c)}).then(p=>{p.getProcessList(S,c=>{if(!c){w(new Error(`Root process ${S} not found`));return}p.getProcessCpuUsage(c,m=>{const u=new Map;m.forEach(d=>{const l=f(d.commandLine||"");u.set(d.pid,{name:b(l),cmd:l,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),v=u.get(S),v?(u.forEach(d=>{const l=u.get(d.ppid);l&&(l.children||(l.children=[]),l.children.push(d))}),u.forEach(d=>{d.children&&(d.children=d.children.sort((l,$)=>l.pid-$.pid))}),P(v)):w(new Error(`Root process ${S} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let f=function(){let p=[v];const c=[];for(;p.length;){const u=p.shift();u&&(c.push(u.pid),u.children&&(p=p.concat(u.children)))}let m=JSON.stringify(R.$kg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+c.join(" "),(0,E.exec)(m,{},(u,d,l)=>{if(u||l)w(u||new Error(l.toString()));else{const $=d.toString().split(`
`);for(let h=0;h<c.length;h++){const n=I.get(c[h]);n.load=parseFloat($[h])}if(!v){w(new Error(`Root process ${S} not found`));return}P(v)}})};(0,E.exec)("which ps",{},(p,c,m)=>{if(p||m)if(process.platform!=="linux")w(p||new Error(m.toString()));else{const u=JSON.stringify(R.$kg.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(u,{},(d,l,$)=>{d||$?w(d||new Error($.toString())):(C(l,k),f())})}else{const u=c.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${u} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,$,h)=>{l||h&&!h.includes("screen size is bogus")?w(l||new Error(h.toString())):(C($,k),process.platform==="linux"?f():v?P(v):w(new Error(`Root process ${S} not found`)))})}})}})}e.$Pr=r;function C(S,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=S.toString().split(`
`);for(const I of v){const k=w.exec(I.trim());k&&k.length===6&&P(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(be[105],ve([1,0,28,4,102,103]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=void 0;async function S(k,b){return k===1?R.$i?I():C.$Ol(b):w(k,b)}e.$Ql=S;let P=null;function w(k,b){if(R.$k&&k===2||R.$j&&k===3)return"/bin/bash";if(!P){let f;if(R.$i)f="/bin/bash";else{if(f=b.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}P=f}return P}let v=null;async function I(){return v||(v=(await(0,r.$Ll)()).exePath),v}});var Fe=this&&this.__decorate||function(ue,e,E,R){var r=arguments.length,C=r<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,E):R,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(ue,e,E,R);else for(var P=ue.length-1;P>=0;P--)(S=ue[P])&&(C=(r<3?S(C):r>3?S(e,E,C):S(e,E))||C);return r>3&&C&&Object.defineProperty(e,E,C),C};define(be[43],ve([1,0,18,14,15,20,74,11,5,2,50,17,10]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var f;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(f||(f={}));function p(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(c||(c={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function d(V){let G=0;for(let oe=0;;oe+=7){const le=V.read(1);if(G|=(le.buffer[0]&127)<<oe,!(le.buffer[0]&128))return G}}const l=o(0);function $(V,G){if(G===0){V.write(l);return}let oe=0;for(let se=G;se!==0;se=se>>>7)oe++;const le=r.$ge.alloc(oe);for(let se=0;G!==0;se++)le.buffer[se]=G&127,G=G>>>7,G>0&&(le.buffer[se]|=128);V.write(le)}class h{constructor(G){this.b=G,this.a=0}read(G){const oe=this.b.slice(this.a,this.a+G);return this.a+=oe.byteLength,oe}}e.$zh=h;class n{constructor(){this.a=[]}get buffer(){return r.$ge.concat(this.a)}write(G){this.a.push(G)}}e.$Ah=n;var i;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(i||(i={}));function o(V){const G=r.$ge.alloc(1);return G.writeUInt8(V,0),G}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},t=typeof Buffer<"u";function a(V,G){if(typeof G>"u")V.write(s.Undefined);else if(typeof G=="string"){const oe=r.$ge.fromString(G);V.write(s.String),$(V,oe.byteLength),V.write(oe)}else if(t&&Buffer.isBuffer(G)){const oe=r.$ge.wrap(G);V.write(s.Buffer),$(V,oe.byteLength),V.write(oe)}else if(G instanceof r.$ge)V.write(s.VSBuffer),$(V,G.byteLength),V.write(G);else if(Array.isArray(G)){V.write(s.Array),$(V,G.length);for(const oe of G)a(V,oe)}else if(typeof G=="number"&&(G|0)===G)V.write(s.Uint),$(V,G);else{const oe=r.$ge.fromString(JSON.stringify(G));V.write(s.Object),$(V,oe.byteLength),V.write(oe)}}e.$Bh=a;function g(V){switch(V.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return V.read(d(V)).toString();case i.Buffer:return V.read(d(V)).buffer;case i.VSBuffer:return V.read(d(V));case i.Array:{const oe=d(V),le=[];for(let se=0;se<oe;se++)le.push(g(V));return le}case i.Object:return JSON.parse(V.read(d(V)).toString());case i.Int:return d(V)}}e.$Ch=g;class L{constructor(G,oe,le=null,se=1e3){this.h=G,this.j=oe,this.k=le,this.l=se,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(G,oe){this.b.set(G,oe),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case 200:{const oe=this.o([G.type]);this.k?.logOutgoing(oe,0,1,m(G.type));return}case 201:case 202:case 204:case 203:{const oe=this.o([G.type,G.id],G.data);this.k?.logOutgoing(oe,G.id,1,m(G.type),G.data);return}}}o(G,oe=void 0){const le=new n;return a(le,G),a(le,oe),this.p(le.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const oe=new h(G),le=g(oe),se=g(oe),$e=le[0];switch($e){case 100:return this.k?.logIncoming(G.byteLength,le[1],1,`${p($e)}: ${le[2]}.${le[3]}`,se),this.s({type:$e,id:le[1],channelName:le[2],name:le[3],arg:se});case 102:return this.k?.logIncoming(G.byteLength,le[1],1,`${p($e)}: ${le[2]}.${le[3]}`,se),this.t({type:$e,id:le[1],channelName:le[2],name:le[3],arg:se});case 101:return this.k?.logIncoming(G.byteLength,le[1],1,`${p($e)}`),this.u({type:$e,id:le[1]});case 103:return this.k?.logIncoming(G.byteLength,le[1],1,`${p($e)}`),this.u({type:$e,id:le[1]})}}s(G){const oe=this.b.get(G.channelName);if(!oe){this.v(G);return}const le=new C.$3d;let se;try{se=oe.call(this.j,G.name,G.arg,le.token)}catch(q){se=Promise.reject(q)}const $e=G.id;se.then(q=>{this.m({id:$e,data:q,type:201})},q=>{q instanceof Error?this.m({id:$e,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:$e,data:q,type:203})}).finally(()=>{z.dispose(),this.d.delete(G.id)});const z=(0,v.$Qc)(()=>le.cancel());this.d.set(G.id,z)}t(G){const oe=this.b.get(G.channelName);if(!oe){this.v(G);return}const le=G.id,$e=oe.listen(this.j,G.name,G.arg)(z=>this.m({id:le,data:z,type:204}));this.d.set(G.id,$e)}u(G){const oe=this.d.get(G.id);oe&&(oe.dispose(),this.d.delete(G.id))}v(G){let oe=this.g.get(G.channelName);oe||(oe=[],this.g.set(G.channelName,oe));const le=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===100&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);oe.push({request:G,timeoutTimer:le})}w(G){const oe=this.g.get(G);if(oe){for(const le of oe)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=L;var D;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class y{constructor(G,oe=null){this.l=G,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=oe}getChannel(G){const oe=this;return{call(le,se,$e){return oe.a?Promise.reject(new P.$5):oe.m(G,le,se,$e)},listen(le,se){return oe.a?w.Event.None:oe.o(G,le,se)}}}m(G,oe,le,se=C.CancellationToken.None){const $e=this.g++,q={id:$e,type:100,channelName:G,name:oe,arg:le};if(se.isCancellationRequested)return Promise.reject(new P.$5);let O;return new Promise((ne,Y)=>{if(se.isCancellationRequested)return Y(new P.$5);const Z=()=>{const W=x=>{switch(x.type){case 201:this.f.delete($e),ne(x.data);break;case 202:{this.f.delete($e);const re=new Error(x.data.message);re.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,re.name=x.data.name,Y(re);break}case 203:this.f.delete($e),Y(x.data);break}};this.f.set($e,W),this.p(q)};let B=null;this.b===u.Idle?Z():(B=(0,R.$Pg)(W=>this.u()),B.then(()=>{B=null,Z()}));const H=()=>{B?(B.cancel(),B=null):this.p({id:$e,type:101}),Y(new P.$5)},T=se.onCancellationRequested(H);O=(0,v.$Pc)((0,v.$Qc)(H),T),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(G,oe,le){const se=this.g++,z={id:se,type:102,channelName:G,name:oe,arg:le};let q=null;const O=new w.$Sd({onWillAddFirstListener:()=>{q=(0,R.$Pg)(ne=>this.u()),q.then(()=>{q=null,this.d.add(O),this.p(z)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(O),this.p({id:se,type:103}))}}),j=ne=>O.fire(ne.data);return this.f.set(se,j),O.event}p(G){switch(G.type){case 100:case 102:{const oe=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(oe,G.id,0,`${p(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case 101:case 103:{const oe=this.q([G.type,G.id]);this.j?.logOutgoing(oe,G.id,0,p(G.type));return}}}q(G,oe=void 0){const le=new n;return a(le,G),a(le,oe),this.r(le.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const oe=new h(G),le=g(oe),se=g(oe),$e=le[0];switch($e){case 200:return this.j?.logIncoming(G.byteLength,0,0,m($e)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(G.byteLength,le[1],0,m($e),se),this.t({type:le[0],id:le[1],data:se})}}t(G){if(G.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=y,Fe([S.$th],y.prototype,"onDidInitializePromise",null);class A{get connections(){const G=[];return this.f.forEach(oe=>G.push(oe)),G}constructor(G){this.a=new Map,this.f=new Set,this.g=new w.$Sd,this.onDidAddConnection=this.g.event,this.h=new w.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new v.$Rc,this.j.add(G(({protocol:oe,onDidClientDisconnect:le})=>{const se=w.Event.once(oe.onMessage);this.j.add(se($e=>{const z=new h($e),q=g(z),O=new L(oe,q),j=new y(oe);this.a.forEach((Y,Z)=>O.registerChannel(Z,Y));const ne={channelServer:O,channelClient:j,ctx:q};this.f.add(ne),this.g.fire(ne),this.j.add(le(()=>{O.dispose(),j.dispose(),this.f.delete(ne),this.h.fire(ne)}))}))}))}getChannel(G,oe){const le=this;return{call(se,$e,z){let q;if((0,b.$Sf)(oe)){const j=(0,E.$4b)(le.connections.filter(oe));q=j?Promise.resolve(j):w.Event.toPromise(w.Event.filter(le.onDidAddConnection,oe))}else q=oe.routeCall(le,se,$e);const O=q.then(j=>j.channelClient.getChannel(G));return X(O).call(se,$e,z)},listen(se,$e){if((0,b.$Sf)(oe))return le.k(G,oe,se,$e);const z=oe.routeEvent(le,se,$e).then(q=>q.channelClient.getChannel(G));return X(z).listen(se,$e)}}}k(G,oe,le,se){const $e=this;let z;const q=new w.$Sd({onWillAddFirstListener:()=>{z=new v.$Rc;const O=new w.$Yd,j=new Map,ne=Z=>{const H=Z.channelClient.getChannel(G).listen(le,se),T=O.add(H);j.set(Z,T)},Y=Z=>{const B=j.get(Z);B&&(B.dispose(),j.delete(Z))};$e.connections.filter(oe).forEach(ne),w.Event.filter($e.onDidAddConnection,oe)(ne,void 0,z),$e.onDidRemoveConnection(Y,void 0,z),O.event(q.fire,q,z),z.add(O)},onDidRemoveLastListener:()=>{z?.dispose(),z=void 0}});return q.event}registerChannel(G,oe){this.a.set(G,oe);for(const le of this.f)le.channelServer.registerChannel(G,oe)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=A;class F{constructor(G,oe,le=null){const se=new n;a(se,oe),G.send(se.buffer),this.a=new y(G,le),this.d=new L(G,oe,le)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,oe){this.d.registerChannel(G,oe)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=F;function X(V){return{call(G,oe,le){return V.then(se=>se.call(G,oe,le))},listen(G,oe){const le=new w.$2d;return V.then(se=>le.input=se.listen(G,oe)),le.event}}}e.$Hh=X;function te(V){let G=!1;return{call(oe,le,se){return G?V.call(oe,le,se):(0,R.$3g)(0).then(()=>G=!0).then(()=>V.call(oe,le,se))},listen(oe,le){if(G)return V.listen(oe,le);const se=new w.$2d;return(0,R.$3g)(0).then(()=>G=!0).then(()=>se.input=V.listen(oe,le)),se.event}}}e.$Ih=te;class J{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const oe of G.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await w.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$Jh=J;var ie;(function(V){function G($e,z,q){const O=$e,j=q&&q.disableMarshalling,ne=new Map;for(const Y in O)le(Y)&&ne.set(Y,w.Event.buffer(O[Y],!0,void 0,z));return new class{listen(Y,Z,B){const H=ne.get(Z);if(H)return H;if(se(Z)){const T=O[Z];if(typeof T=="function")return T.call(O,B)}throw new P.$bb(`Event not found: ${Z}`)}call(Y,Z,B){const H=O[Z];if(typeof H=="function"){if(!j&&Array.isArray(B))for(let W=0;W<B.length;W++)B[W]=(0,I.$yh)(B[W]);let T=H.apply(O,B);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new P.$bb(`Method not found: ${Z}`)}}}V.fromService=G;function oe($e,z){const q=z&&z.disableMarshalling;return new Proxy({},{get(O,j){if(typeof j=="string")return z?.properties?.has(j)?z.properties.get(j):se(j)?function(ne){return $e.listen(j,ne)}:le(j)?$e.listen(j):async function(...ne){let Y;z&&!(0,b.$Nf)(z.context)?Y=[z.context,...ne]:Y=ne;const Z=await $e.call(j,Y);return q?Z:(0,I.$yh)(Z)};throw new P.$bb(`Property not found: ${String(j)}`)}})}V.toService=oe;function le($e){return $e[0]==="o"&&$e[1]==="n"&&k.$7e($e.charCodeAt(2))}function se($e){return/^onDynamic/.test($e)&&k.$7e($e.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const G=V.toString();if(G!=="[object Object]")return G}return V}function he(V){return Array.isArray(V)?V.map(U):U(V)}function Q(V,G,oe,le,se,$e,z){z=he(z);const q=ee[se],O=q[le%q.length];let j=[`%c[${V}]%c[${String(G).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test($e)?(j=j.concat(z),j.push(")")):j.push(z),console.log.apply(console,j)}class _{constructor(G,oe){this.d=G,this.f=oe,this.a=0,this.b=0}logOutgoing(G,oe,le,se,$e){this.b+=G,Q(this.d,this.b,G,oe,le,se,$e)}logIncoming(G,oe,le,se,$e){this.a+=G,Q(this.f,this.a,G,oe,le,se,$e)}}e.$Kh=_}),define(be[106],ve([1,0,15,5,2,43]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.ProtocolConstants=e.$Lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var S;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(S||(e.SocketDiagnosticsEventType=S={}));var P;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let a=0;function g(D,y){if(!t.has(D)){const A=String(++a);t.set(D,A)}return t.get(D)}function L(D,y,A,F){if(!s.enableDiagnostics)return;const X=g(D,y);if(F instanceof E.$ge||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const te=E.$ge.alloc(F.byteLength);te.set(F),s.records.push({timestamp:Date.now(),id:X,label:y,type:A,buff:te})}else s.records.push({timestamp:Date.now(),id:X,label:y,type:A,data:F})}s.traceSocketEvent=L})(P||(e.SocketDiagnostics=P={}));var w;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let v=null;function I(){return v||(v=E.$ge.alloc(0)),v}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,a){if(t===0)return I();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const y=this.a[0];return a&&(this.a.shift(),this.b-=t),y}if(this.a[0].byteLength>t){const y=this.a[0].slice(0,t);return a&&(this.a[0]=this.a[0].slice(t),this.b-=t),y}const g=E.$ge.alloc(t);let L=0,D=0;for(;t>0;){const y=this.a[D];if(y.byteLength>t){const A=y.slice(0,t);g.set(A,L),L+=t,a&&(this.a[D]=y.slice(t),this.b-=t),t-=t}else g.set(y,L),L+=y.byteLength,a?(this.a.shift(),this.b-=y.byteLength):D++,t-=y.byteLength}return g}}e.$Lh=k;var b;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(b||(b={}));function f(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var p;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(p||(e.ProtocolConstants=p={}));class c{constructor(t,a,g,L){this.type=t,this.id=a,this.ack=g,this.data=L,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends r.$Sc{constructor(t){super(),this.f=this.B(new R.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,L=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new c(g,L,D,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=E.$ge.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(a,t.data)}g(t,a){const g=this.f===0;return this.d.push(t,a),this.f+=t.byteLength+a.byteLength,g}h(){const t=E.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,a){this.g(t,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class d extends r.$Sc{constructor(t){super(),this.f=new R.$Sd,this.onMessage=this.f.event,this.g=new R.$Sd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new u(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new c(1,0,0,t))}}e.$Mh=d;class l extends C.$Gh{static fromSocket(t,a){return new l(new d(t),a)}get onDidDispose(){return this.b.onDidDispose}constructor(t,a,g=null){super(t,a,g),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Nh=l;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Oh=$;class h{constructor(t){this.data=t,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let t=0,a=this.a;for(;a;)a=a.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let a=0,g=this.a;for(;g;)t[a++]=g.data,g=g.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const a=new h(t);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class i{static{this.a=10}static{this.b=null}static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const t=Date.now();for(let a=0;a<i.a;a++)this.c[a]=t-1e3*a;setInterval(()=>{for(let a=i.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),a=(1+i.a)*1e3;let g=0;for(let L=0;L<i.a;L++)t-this.c[L]<=a&&g++;return 1-g/i.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??i.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$Rc,this.o=t.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new c(5,0,0,I());this.p.write(t),this.p.flush()}sendPause(){const t=new c(7,0,0,I());this.p.write(t)}sendResume(){const t=new c(8,0,0,I());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,a){this.a=!0,this.r.dispose(),this.r=new r.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new c(3,0,this.h,I());this.p.write(t);const a=this.b.toArray();for(let g=0,L=a.length;g<L;g++)this.p.write(a[g]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const a=this.b.peek();if(a&&a.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new c(6,0,0,I())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let g=0,L=a.length;g<L;g++)this.p.write(a[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const a=++this.c;this.h=this.g;const g=new c(1,a,this.h,t);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(t){const a=new c(2,0,0,t);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),a=Date.now()-t.writtenTime,g=Date.now()-this.q.lastReadTime,L=Date.now()-this.n;if(a>=2e4&&g>=2e4&&L>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:g});return}const D=Math.max(2e4-a,2e4-g,2e4-L,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new c(3,0,this.h,I());this.p.write(t)}D(){this.h=this.g;const t=new c(9,0,this.h,I());this.p.write(t)}}e.$Ph=o}),define(be[107],ve([1,0,52,14,15,20,165,11,5,2,23,103,65,43]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class p extends f.$Dh{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",d=>r.$ge.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$cq=p;class c{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new w.$Sd,this.onDidProcessExit=this.h.event;const l=d&&d.timeout?d.timeout:6e4;this.b=new R.$Yg(l),this.d=null,this.f=null}getChannel(u){const d=this;return{call(l,$,h){return d.k(u,l,$,h)},listen(l,$){return d.l(u,l,$)}}}k(u,d,l,$=C.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const h=this.n(u),n=(0,R.$Pg)(s=>h.call(d,l,s)),i=$.onCancellationRequested(()=>n.cancel()),o=(0,v.$Qc)(()=>n.cancel());return this.c.add(o),n.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(u,d,l){if(!this.b)return w.Event.None;this.b.cancel();let $;const h=new w.$Sd({onWillAddFirstListener:()=>{$=this.n(u).listen(d,l)(h.fire,h),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,I.$hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,b.$Nl)(d.env),this.d=(0,E.fork)(this.i,u,d);const l=new w.$Sd;w.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,S.$$p)(t)){(0,S.log)(t,`IPC Library: ${this.j.serverName}`);return}l.fire(r.$ge.wrap(Buffer.from(t,"base64")))});const h=this.j.useQueue?(0,k.$Pl)(this.d):this.d,n=t=>this.d&&this.d.connected&&h.send(t.buffer.toString("base64")),i=l.event,o={send:n,onMessage:i};this.f=new f.$Eh(o);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,a)=>{process.removeListener("exit",s),this.c.forEach(g=>(0,v.$Nc)(g)),this.c.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:a})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$dq=c}),define(be[170],ve([1,0,14,5,2,50,10]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.StorageState=e.$bp=e.StorageHint=void 0;var P;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function w(b){const f=b;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$bp=w;var v;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(v||(e.StorageState=v={}));class I extends r.$Sc{static{this.a=100}constructor(f,p=Object.create(null)){super(),this.r=f,this.s=p,this.b=this.B(new R.$Vd),this.onDidChangeStorage=this.b.event,this.c=v.None,this.f=new Map,this.g=this.B(new E.$Zg(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((p,c)=>this.w(c,p)),f.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(f,p){if(this.c===v.Closed)return;let c=!1;(0,S.$Nf)(p)?c=this.f.delete(f):this.f.get(f)!==p&&(this.f.set(f,p),c=!0),c&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===v.None&&(this.c=v.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,p){const c=this.f.get(f);return(0,S.$Nf)(c)?p:c}getBoolean(f,p){const c=this.get(f);return(0,S.$Nf)(c)?p:c==="true"}getNumber(f,p){const c=this.get(f);return(0,S.$Nf)(c)?p:parseInt(c,10)}getObject(f,p){const c=this.get(f);return(0,S.$Nf)(c)?p:(0,C.$xh)(c)}async set(f,p,c=!1){if(this.c===v.Closed)return;if((0,S.$Nf)(p))return this.delete(f,c);const m=(0,S.$Gf)(p)||Array.isArray(p)?(0,C.$wh)(p):String(p);if(this.f.get(f)!==m)return this.f.set(f,m),this.j.set(f,m),this.h.delete(f),this.b.fire({key:f,external:c}),this.D()}async delete(f,p=!1){if(!(this.c===v.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:p}),this.D()}async optimize(){if(this.c!==v.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=v.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$cp=I;class k{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((p,c)=>this.a.set(c,p)),f.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$dp=k}),define(be[171],ve([8,9]),function(ue,e){return ue.create("vs/base/node/zip",e)}),define(be[81],ve([1,0,27,14,7,10,22,171]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=e.$Ap=e.zip=e.$yp=e.$xp=void 0,e.$xp="end of central directory record signature not found";const w=new RegExp(e.$xp);class v extends Error{constructor(h,n){let i=n.message;switch(h){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=h,this.cause=n}}e.$yp=v;function I($){const h=$.externalFileAttributes>>16||33188;return[448,56,7].map(n=>h&n).reduce((n,i)=>n+i,h&61440)}function k($){if($ instanceof v)return $;let h;return w.test($.message)&&(h="CorruptZip"),new v(h,$)}function b($,h,n,i,o,s){const t=r.$mc(h),a=r.$jc(i,t);if(!a.startsWith(i))return Promise.reject(new Error(P.localize(0,null,h)));const g=r.$jc(i,h);let L;return s.onCancellationRequested(()=>{L?.destroy()}),Promise.resolve(S.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((D,y)=>{if(!s.isCancellationRequested)try{L=(0,E.createWriteStream)(g,{mode:n}),L.once("close",()=>D()),L.once("error",y),$.once("error",y),$.pipe(L)}catch(A){y(A)}}))}function f($,h,n,i){let o=(0,R.$Pg)(()=>Promise.resolve()),s=0;const t=i.onCancellationRequested(()=>{o.cancel(),$.close()});return new Promise((a,g)=>{const L=new R.$Wg,D=y=>{y.isCancellationRequested||(s++,$.readEntry())};$.once("error",g),$.once("close",()=>o.then(()=>{i.isCancellationRequested||$.entryCount===s?a():g(new v("Incomplete",new Error(P.localize(1,null,s,$.entryCount))))},g)),$.readEntry(),$.on("entry",y=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(y.fileName)){D(i);return}const A=y.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(A)){const te=r.$jc(h,A);o=(0,R.$Pg)(J=>S.Promises.mkdir(te,{recursive:!0}).then(()=>D(J)).then(void 0,g));return}const F=c($,y),X=I(y);o=(0,R.$Pg)(te=>L.queue(()=>F.then(J=>b(J,A,X,h,n,te).then(()=>D(te)))).then(null,g))})}).finally(()=>t.dispose())}async function p($,h=!1){const{open:n}=await new Promise((i,o)=>{ue(["yauzl"],i,o)});return new Promise((i,o)=>{n($,h?{lazyEntries:!0}:void 0,(s,t)=>{s?o(k(s)):i((0,C.$Pf)(t))})})}function c($,h){return new Promise((n,i)=>{$.openReadStream(h,(o,s)=>{o?i(k(o)):n((0,C.$Pf)(s))})})}async function m($,h){const{ZipFile:n}=await new Promise((i,o)=>{ue(["yazl"],i,o)});return new Promise((i,o)=>{const s=new n;h.forEach(a=>{a.contents?s.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&s.addFile(a.localPath,a.path)}),s.end();const t=(0,E.createWriteStream)($);s.outputStream.pipe(t),s.outputStream.once("error",o),t.once("error",o),t.once("finish",()=>i($))})}e.zip=m;function u($,h,n={},i){const o=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=p($,!0);return n.overwrite&&(s=s.then(t=>S.Promises.rm(h).then(()=>t))),s.then(t=>f(t,h,{sourcePathRegex:o},i))}e.$Ap=u;function d($,h){return p($).then(n=>new Promise((i,o)=>{n.on("entry",s=>{s.fileName===h&&c(n,s).then(t=>i(t),t=>o(t))}),n.once("close",()=>o(new Error(P.localize(2,null,h))))}))}function l($,h){return d($,h).then(n=>new Promise((i,o)=>{const s=[];n.once("error",o),n.on("data",t=>s.push(t)),n.on("end",()=>i(Buffer.concat(s)))}))}e.$Bp=l}),define(be[172],ve([8,9]),function(ue,e){return ue.create("vs/editor/common/languages",e)}),define(be[173],ve([1,0,49,3,155,42,156,172]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$yt=e.$xt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$wt=e.$vt=e.SymbolKinds=e.SymbolTag=e.$ut=e.$tt=e.SymbolKind=e.$st=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$rt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$qt=e.$pt=e.$ot=void 0;class w{constructor(ie,ee,U){this.offset=ie,this.type=ee,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ot=w;class v{constructor(ie,ee){this.tokens=ie,this.endState=ee,this._tokenizationResultBrand=void 0}}e.$pt=v;class I{constructor(ie,ee){this.tokens=ie,this.endState=ee,this._encodedTokenizationResultBrand=void 0}}e.$qt=I;var k;(function(J){J[J.Method=0]="Method",J[J.Function=1]="Function",J[J.Constructor=2]="Constructor",J[J.Field=3]="Field",J[J.Variable=4]="Variable",J[J.Class=5]="Class",J[J.Struct=6]="Struct",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Event=10]="Event",J[J.Operator=11]="Operator",J[J.Unit=12]="Unit",J[J.Value=13]="Value",J[J.Constant=14]="Constant",J[J.Enum=15]="Enum",J[J.EnumMember=16]="EnumMember",J[J.Keyword=17]="Keyword",J[J.Text=18]="Text",J[J.Color=19]="Color",J[J.File=20]="File",J[J.Reference=21]="Reference",J[J.Customcolor=22]="Customcolor",J[J.Folder=23]="Folder",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue",J[J.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var b;(function(J){const ie=new Map;ie.set(0,E.$8j.symbolMethod),ie.set(1,E.$8j.symbolFunction),ie.set(2,E.$8j.symbolConstructor),ie.set(3,E.$8j.symbolField),ie.set(4,E.$8j.symbolVariable),ie.set(5,E.$8j.symbolClass),ie.set(6,E.$8j.symbolStruct),ie.set(7,E.$8j.symbolInterface),ie.set(8,E.$8j.symbolModule),ie.set(9,E.$8j.symbolProperty),ie.set(10,E.$8j.symbolEvent),ie.set(11,E.$8j.symbolOperator),ie.set(12,E.$8j.symbolUnit),ie.set(13,E.$8j.symbolValue),ie.set(15,E.$8j.symbolEnum),ie.set(14,E.$8j.symbolConstant),ie.set(15,E.$8j.symbolEnum),ie.set(16,E.$8j.symbolEnumMember),ie.set(17,E.$8j.symbolKeyword),ie.set(27,E.$8j.symbolSnippet),ie.set(18,E.$8j.symbolText),ie.set(19,E.$8j.symbolColor),ie.set(20,E.$8j.symbolFile),ie.set(21,E.$8j.symbolReference),ie.set(22,E.$8j.symbolCustomColor),ie.set(23,E.$8j.symbolFolder),ie.set(24,E.$8j.symbolTypeParameter),ie.set(25,E.$8j.account),ie.set(26,E.$8j.issues);function ee(Q){let _=ie.get(Q);return _||(console.info("No codicon found for CompletionItemKind "+Q),_=E.$8j.symbolProperty),_}J.toIcon=ee;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function he(Q,_){let V=U.get(Q);return typeof V>"u"&&!_&&(V=9),V}J.fromString=he})(b||(e.CompletionItemKinds=b={}));var f;(function(J){J[J.Deprecated=1]="Deprecated"})(f||(e.CompletionItemTag=f={}));var p;(function(J){J[J.None=0]="None",J[J.KeepWhitespace=1]="KeepWhitespace",J[J.InsertAsSnippet=4]="InsertAsSnippet"})(p||(e.CompletionItemInsertTextRule=p={}));var c;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var m;(function(J){J[J.Automatic=0]="Automatic",J[J.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class u{constructor(ie,ee,U,he){this.range=ie,this.text=ee,this.completionKind=U,this.isSnippetText=he}equals(ie){return C.$Gs.lift(this.range).equalsRange(ie.range)&&this.text===ie.text&&this.completionKind===ie.completionKind&&this.isSnippetText===ie.isSnippetText}}e.$rt=u;var d;(function(J){J[J.Invoke=1]="Invoke",J[J.Auto=2]="Auto"})(d||(e.CodeActionTriggerType=d={}));var l;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var $;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})($||(e.DocumentHighlightKind=$={}));function h(J){return J&&R.URI.isUri(J.uri)&&C.$Gs.isIRange(J.range)&&(C.$Gs.isIRange(J.originSelectionRange)||C.$Gs.isIRange(J.targetSelectionRange))}e.$st=h;var n;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(n||(e.SymbolKind=n={})),e.$tt={[17]:(0,P.localize)(0,null),[16]:(0,P.localize)(1,null),[4]:(0,P.localize)(2,null),[13]:(0,P.localize)(3,null),[8]:(0,P.localize)(4,null),[9]:(0,P.localize)(5,null),[21]:(0,P.localize)(6,null),[23]:(0,P.localize)(7,null),[7]:(0,P.localize)(8,null),[0]:(0,P.localize)(9,null),[11]:(0,P.localize)(10,null),[10]:(0,P.localize)(11,null),[19]:(0,P.localize)(12,null),[5]:(0,P.localize)(13,null),[1]:(0,P.localize)(14,null),[2]:(0,P.localize)(15,null),[20]:(0,P.localize)(16,null),[15]:(0,P.localize)(17,null),[18]:(0,P.localize)(18,null),[24]:(0,P.localize)(19,null),[3]:(0,P.localize)(20,null),[6]:(0,P.localize)(21,null),[14]:(0,P.localize)(22,null),[22]:(0,P.localize)(23,null),[25]:(0,P.localize)(24,null),[12]:(0,P.localize)(25,null)};function i(J,ie){return(0,P.localize)(26,null,J,e.$tt[ie])}e.$ut=i;var o;(function(J){J[J.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var s;(function(J){const ie=new Map;ie.set(0,E.$8j.symbolFile),ie.set(1,E.$8j.symbolModule),ie.set(2,E.$8j.symbolNamespace),ie.set(3,E.$8j.symbolPackage),ie.set(4,E.$8j.symbolClass),ie.set(5,E.$8j.symbolMethod),ie.set(6,E.$8j.symbolProperty),ie.set(7,E.$8j.symbolField),ie.set(8,E.$8j.symbolConstructor),ie.set(9,E.$8j.symbolEnum),ie.set(10,E.$8j.symbolInterface),ie.set(11,E.$8j.symbolFunction),ie.set(12,E.$8j.symbolVariable),ie.set(13,E.$8j.symbolConstant),ie.set(14,E.$8j.symbolString),ie.set(15,E.$8j.symbolNumber),ie.set(16,E.$8j.symbolBoolean),ie.set(17,E.$8j.symbolArray),ie.set(18,E.$8j.symbolObject),ie.set(19,E.$8j.symbolKey),ie.set(20,E.$8j.symbolNull),ie.set(21,E.$8j.symbolEnumMember),ie.set(22,E.$8j.symbolStruct),ie.set(23,E.$8j.symbolEvent),ie.set(24,E.$8j.symbolOperator),ie.set(25,E.$8j.symbolTypeParameter);function ee(U){let he=ie.get(U);return he||(console.info("No codicon found for SymbolKind "+U),he=E.$8j.symbolProperty),he}J.toIcon=ee})(s||(e.SymbolKinds=s={}));class t{static asEditOperation(ie){return r.$Hs.replace(C.$Gs.lift(ie.range),ie.text)}}e.$vt=t;class a{static{this.Comment=new a("comment")}static{this.Imports=new a("imports")}static{this.Region=new a("region")}static fromValue(ie){switch(ie){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(ie)}constructor(ie){this.value=ie}}e.$wt=a;var g;(function(J){function ie(ee){return!ee||typeof ee!="object"?!1:typeof ee.id=="string"&&typeof ee.title=="string"}J.is=ie})(g||(e.Command=g={}));var L;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(L||(e.CommentThreadCollapsibleState=L={}));var D;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var y;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(y||(e.CommentMode=y={}));var A;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(A||(e.CommentState=A={}));var F;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class X{constructor(ie){this.b=ie,this.a=null}dispose(){this.a&&this.a.then(ie=>{ie&&ie.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$xt=X,e.$yt=new S.$ft;var te;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}))}),define(be[174],ve([8,9]),function(ue,e){return ue.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[175],ve([8,9]),function(ue,e){return ue.create("vs/platform/contextkey/common/contextkey",e)}),define(be[176],ve([8,9]),function(ue,e){return ue.create("vs/platform/contextkey/common/scanner",e)}),define(be[177],ve([8,9]),function(ue,e){return ue.create("vs/platform/environment/node/argv",e)}),define(be[178],ve([8,9]),function(ue,e){return ue.create("vs/platform/environment/node/argvHelper",e)}),define(be[179],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[180],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[181],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[182],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[183],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[184],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[185],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[186],ve([8,9]),function(ue,e){return ue.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[187],ve([8,9]),function(ue,e){return ue.create("vs/platform/files/common/fileService",e)}),define(be[188],ve([8,9]),function(ue,e){return ue.create("vs/platform/files/common/files",e)}),define(be[189],ve([8,9]),function(ue,e){return ue.create("vs/platform/files/common/io",e)}),define(be[190],ve([8,9]),function(ue,e){return ue.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[191],ve([8,9]),function(ue,e){return ue.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[192],ve([8,9]),function(ue,e){return ue.create("vs/platform/markers/common/markers",e)}),define(be[193],ve([8,9]),function(ue,e){return ue.create("vs/platform/request/common/request",e)}),define(be[194],ve([8,9]),function(ue,e){return ue.create("vs/platform/shell/node/shellEnv",e)}),define(be[195],ve([8,9]),function(ue,e){return ue.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[196],ve([8,9]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[197],ve([8,9]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[198],ve([8,9]),function(ue,e){return ue.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[199],ve([8,9]),function(ue,e){return ue.create("vs/platform/workspace/common/workspace",e)}),define(be[200],ve([8,9]),function(ue,e){return ue.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(be[201],ve([8,9]),function(ue,e){return ue.create("vs/server/node/serverEnvironmentService",e)}),define(be[202],ve([8,9]),function(ue,e){return ue.create("vs/server/node/serverServices",e)}),define(be[203],ve([8,9]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTelemetry",e)}),define(be[204],ve([8,9]),function(ue,e){return ue.create("vs/workbench/common/editor",e)}),define(be[205],ve([8,9]),function(ue,e){return ue.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[206],ve([8,9]),function(ue,e){return ue.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[207],ve([1,0,11,176]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var r;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(r||(e.TokenType=r={}));function C(...v){switch(v.length){case 1:return(0,R.localize)(0,null,v[0]);case 2:return(0,R.localize)(1,null,v[0],v[1]);case 3:return(0,R.localize)(2,null,v[0],v[1],v[2]);default:return}}const S=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(C("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(C("&&"));break;case 124:this.h(124)?this.k(16):this.l(C("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const k=this.d,b=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:b};this.g.push({offset:k,lexeme:b,additionalInfo:I}),this.f.push(f)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const k=this.c.substring(this.d,this.e),b=w.b.get(k);b?this.k(b):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(S);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,k=!1,b=!1;for(;;){if(I>=this.c.length){this.e=I,this.l(P);return}const p=this.c.charCodeAt(I);if(k)k=!1;else if(p===47&&!b){I++;break}else p===91?b=!0:p===92?k=!0:p===93&&(b=!1);I++}for(;I<this.c.length&&w.a.has(this.c.charCodeAt(I));)I++;this.e=I;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=w}),define(be[208],ve([1,0,5,2]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=void 0;class r{constructor(){this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd}static{this.ChannelName="extensionhostdebugservice"}call(P,w,v){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:v[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:v[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:v[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:v[0],port:v[1],subId:v[2]}))}throw new Error("Method not implemented.")}listen(P,w,v){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Zn=r;class C extends R.$Sc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,w,v){this.b.call("attach",[P,w,v])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,w){this.b.call("terminate",[P,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,w){return this.b.call("openExtensionDevelopmentHostWindow",[P,w])}}e.$1n=C}),define(be[209],ve([1,0,3]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=void 0;class R{constructor(S){this.a=S}listen(S,P,w){throw new Error("Invalid listen")}call(S,P,w){switch(P){case"download":return this.a.download(E.URI.revive(w[0]),E.URI.revive(w[1]))}throw new Error("Invalid call")}}e.$3n=R;class r{constructor(S,P){this.a=S,this.b=P}async download(S,P){const w=this.b();w&&(S=w.transformOutgoingURI(S),P=w.transformOutgoingURI(P)),await this.a.call("download",[S,P])}}e.$4n=r}),define(be[210],ve([1,0,160,74,12,7,29,19,3]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=e.$tm=e.$sm=void 0,e.$sm=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,C.$mc)(r.$kg.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,C.$jc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Dg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Dg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,E.$rm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,C.$jc)(this.userDataPath,"logs",f)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Dg)(w.URI.file((0,C.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Dg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Dg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Dg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=S.env.VSCODE_PORTABLE;return f?w.URI.file((0,C.$jc)(f,"argv.json")):(0,P.$Dg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,C.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,C.$kc)(f):(0,C.$hc)((0,C.$jc)(r.$kg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,C.$kc)(f)):w.URI.file((0,C.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,C.$kc)(f);const p=S.env.VSCODE_EXTENSIONS;if(p)return p;const c=S.env.VSCODE_PORTABLE;return c?(0,C.$jc)(c,"extensions"):(0,P.$Dg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,C.$hc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,C.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$sm.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const c=e.$sm.exec(p);c&&c[1]&&c[2]&&f.push([c[1],c[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.$Dg)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=S.env.VSCODE_PORTABLE;return f?w.URI.file((0,C.$jc)(f,"policy.json")):(0,P.$Dg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,c){this.a=f,this.b=p,this.c=c,this.editSessionId=this.args.editSessionId}}e.$tm=v,Fe([R.$th],v.prototype,"appRoot",null),Fe([R.$th],v.prototype,"userHome",null),Fe([R.$th],v.prototype,"userDataPath",null),Fe([R.$th],v.prototype,"appSettingsHome",null),Fe([R.$th],v.prototype,"tmpDir",null),Fe([R.$th],v.prototype,"cacheHome",null),Fe([R.$th],v.prototype,"stateResource",null),Fe([R.$th],v.prototype,"userRoamingDataHome",null),Fe([R.$th],v.prototype,"userDataSyncHome",null),Fe([R.$th],v.prototype,"sync",null),Fe([R.$th],v.prototype,"machineSettingsResource",null),Fe([R.$th],v.prototype,"workspaceStorageHome",null),Fe([R.$th],v.prototype,"localHistoryHome",null),Fe([R.$th],v.prototype,"keyboardLayoutResource",null),Fe([R.$th],v.prototype,"argvResource",null),Fe([R.$th],v.prototype,"isExtensionDevelopment",null),Fe([R.$th],v.prototype,"untitledWorkspacesHome",null),Fe([R.$th],v.prototype,"builtinExtensionsPath",null),Fe([R.$th],v.prototype,"extensionsPath",null),Fe([R.$th],v.prototype,"extensionDevelopmentLocationURI",null),Fe([R.$th],v.prototype,"extensionDevelopmentKind",null),Fe([R.$th],v.prototype,"extensionTestsLocationURI",null),Fe([R.$th],v.prototype,"debugExtensionHost",null),Fe([R.$th],v.prototype,"logLevel",null),Fe([R.$th],v.prototype,"extensionLogLevel",null),Fe([R.$th],v.prototype,"serviceMachineIdResource",null),Fe([R.$th],v.prototype,"disableTelemetry",null),Fe([R.$th],v.prototype,"disableWorkspaceTrust",null),Fe([R.$th],v.prototype,"useInMemorySecretStorage",null),Fe([R.$th],v.prototype,"policyFile",null);function I(b,f){return k(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId,b.extensionEnvironment)}e.$um=I;function k(b,f,p,c,m,u){const l=Number(f||b)||(c?null:p),$=l?!!f:!1;let h;if(u)try{h=JSON.parse(u)}catch{}return{port:l,break:$,debugId:m,env:h}}e.$vm=k}),define(be[66],ve([1,0,298,4,177]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0;const C={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$Rl=["tunnel","serve-web"],e.$Sl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const S={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(c,m,u=S){const d=c.find(a=>a.length>0&&a[0]!=="-"),l={},$=["_"],h=[],n={};let i;for(const a in m){const g=m[a];g.type==="subcommand"?a===d&&(i=g):(g.alias&&(l[a]=g.alias),g.type==="string"||g.type==="string[]"?($.push(a),g.deprecates&&$.push(...g.deprecates)):g.type==="boolean"&&(h.push(a),g.deprecates&&h.push(...g.deprecates)),g.global&&(n[a]=g))}if(i&&d){const a=n;for(const y in i.options)a[y]=i.options[y];const g=c.filter(y=>y!==d),L=u.getSubcommandReporter?u.getSubcommandReporter(d):void 0,D=P(g,a,L);return{[d]:D,_:[]}}const o=E(c,{string:$,boolean:h,alias:l}),s={},t=o;s._=o._.map(a=>String(a)).filter(a=>a.length>0),delete t._;for(const a in m){const g=m[a];if(g.type==="subcommand")continue;g.alias&&delete t[g.alias];let L=t[a];if(g.deprecates)for(const D of g.deprecates)t.hasOwnProperty(D)&&(L||(L=t[D],L&&u.onDeprecatedOption(D,g.deprecationMessage||(0,r.localize)(37,null,a))),delete t[D]);if(typeof L<"u"){if(g.type==="string[]"){if(Array.isArray(L)||(L=[L]),!g.allowEmptyValue){const D=L.filter(y=>y.length>0);D.length!==L.length&&(u.onEmptyValue(a),L=D.length>0?D:void 0)}}else g.type==="string"&&(Array.isArray(L)?(L=L.pop(),u.onMultipleValues(a,L)):!L&&!g.allowEmptyValue&&(u.onEmptyValue(a),L=void 0));s[a]=L,g.deprecationMessage&&u.onDeprecatedOption(a,g.deprecationMessage)}delete t[a]}for(const a in t)u.onUnknownOption(a);return s}e.$Tl=P;function w(c,m){let u="";return m.args&&(Array.isArray(m.args)?u=` <${m.args.join("> <")}>`:u=` <${m.args}>`),m.alias?`-${m.alias} --${c}${u}`:`--${c}${u}`}function v(c,m){const u=[];for(const d in c){const l=c[d],$=w(d,l);u.push([$,l.description])}return I(u,m)}e.$Ul=v;function I(c,m){const d=c.reduce((h,n)=>Math.max(h,n[0].length),12)+2+1;if(m-d<25)return c.reduce((h,n)=>h.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const l=m-d-1,$=[];for(const h of c){const n=h[0],i=b(h[1],l),o=k(d-n.length-2);$.push("  "+n+o+i[0]);for(let s=1;s<i.length;s++)$.push(k(d)+i[s])}return $}function k(c){return" ".repeat(c)}function b(c,m){const u=[];for(;c.length;){const d=c.length<m?c.length:c.lastIndexOf(" ",m),l=c.slice(0,d).trim();c=c.slice(d),u.push(l)}return u}function f(c,m,u,d,l){const $=process.stdout.isTTY&&process.stdout.columns||80,h=l?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",n=[`${c} ${u}`];n.push(""),n.push(`${(0,r.localize)(39,null)}: ${m} [${(0,r.localize)(40,null)}]${h}`),n.push(""),l?.noPipe!==!0&&(R.$i?n.push((0,r.localize)(41,null,m)):n.push((0,r.localize)(42,null,m)),n.push(""));const i={},o=[];for(const s in d){const t=d[s];if(t.type==="subcommand")t.description&&o.push({command:s,description:t.description});else if(t.description&&t.cat){let a=i[t.cat];a||(i[t.cat]=a={}),a[s]=t}}for(const s in i){const t=s,a=i[t];a&&(n.push(C[t]),n.push(...v(a,$)),n.push(""))}return o.length&&(n.push((0,r.localize)(43,null)),n.push(...I(o.map(s=>[s.command,s.description]),$)),n.push("")),n.join(`
`)}e.$Vl=f;function p(c,m){return`${c||(0,r.localize)(44,null)}
${m||(0,r.localize)(45,null)}
${process.arch}`}e.$Wl=p}),define(be[211],ve([1,0,299,178,66]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=e.$Xl=void 0;function C(k,b){const f=(l,$)=>{console.warn((0,R.localize)(0,null,l,$))},p=l=>{console.warn((0,R.localize)(1,null,l))},c=(l,$)=>{console.warn((0,R.localize)(2,null,l,$))},m=l=>({onUnknownOption:$=>{r.$Rl.includes(l)||console.warn((0,R.localize)(3,null,$,l))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:c,getSubcommandReporter:r.$Rl.includes(l)?m:void 0}),u={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:c,getSubcommandReporter:m},d=(0,r.$Tl)(k,r.$Sl,b?u:void 0);return d.goto&&d._.forEach(l=>E(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),d}function S(k){const b=k.findIndex(f=>!/^-/.test(f));if(b>-1)return[...k.slice(0,b),...k.slice(b+1)]}function P(k){let[,...b]=k;process.env.VSCODE_DEV&&(b=S(b)||[]);const f=!I(process.env);return C(b,f)}e.$Xl=P;function w(k){let[,,...b]=k;return process.env.VSCODE_DEV&&(b=S(b)||[]),C(b,!0)}e.$Yl=w;function v(k,...b){const f=k.indexOf("--");return f===-1?k.push(...b):k.splice(f,0,...b),k}e.$Zl=v;function I(k){return k.VSCODE_CLI==="1"}e.$1l=I}),function(){"use strict";function ue(e,E,R){function r(S,P){const w=C(S,P),v=[w];return e.isAbsolute(w)||v.unshift(R),e.resolve(...v)}function C(S,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,P);const I=S["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(k,"AppData","Roaming")}break;case"darwin":v=e.join(E.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,P)}return{getUserDataPath:r}}if(typeof define=="function")define(be[212],ve([77,28,29]),function(e,E,R){return ue(e,E,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=ue(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[108],ve([1,0,28,210,212]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=void 0;class C extends R.$tm{constructor(v,I){super(v,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(v,I.nameShort)},I)}}e.$wm=C;function S(w,v){return(0,R.$vm)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,v,w.extensionEnvironment)}e.$xm=S;function P(w,v){return(0,R.$vm)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,v,w.extensionEnvironment)}e.$ym=P}),define(be[213],ve([1,0,10,182]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;function r(S,P,w,v){try{C(S,P,w,v)}catch(I){S.error(I?.message??I)}return P}e.$Kp=r;function C(S,P,w,v){const I=(k,b,f)=>{const p=k[b];if((0,E.$Ef)(p)){const c=p,m=c.length;if(m>1&&c[0]==="%"&&c[m-1]==="%"){const u=c.substr(1,m-2);let d=w[u];d===void 0&&v&&(d=v[u]);const l=typeof d=="string"?d:d?.message,$=v?.[u],h=typeof $=="string"?$:$?.message;if(!l){h||S.warn(`[${P.name}]: ${(0,R.localize)(0,null,u)}`);return}if(f&&(b==="title"||b==="category")&&h&&h!==l){const n={value:l,original:h};k[b]=n}else k[b]=l}}else if((0,E.$Gf)(p))for(const c in p)p.hasOwnProperty(c)&&(c==="commands"?I(p,c,!0):I(p,c,f));else if(Array.isArray(p))for(let c=0;c<p.length;c++)I(p,c,f)};for(const k in P)P.hasOwnProperty(k)&&I(P,k)}}),define(be[214],ve([1,0,81,185]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;function r(C){return(0,E.$Bp)(C,"extension/package.json").then(S=>{try{return JSON.parse(S.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$Sp=r}),define(be[82],ve([1,0,19,62,186,53]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(u){return u=u.trim(),u==="*"||S.test(u)}e.$Yo=w;function v(u){if(!w(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(S);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$Zo=v;function I(u){if(!u)return null;const d=u.majorBase,l=u.majorMustEqual,$=u.minorBase;let h=u.minorMustEqual;const n=u.patchBase;let i=u.patchMustEqual;u.hasCaret&&(d===0||(h=!1),i=!1);let o=0;if(u.preRelease){const s=P.exec(u.preRelease);if(s){const[,t,a,g]=s;o=Date.UTC(Number(t),Number(a)-1,Number(g))}}return{majorBase:d,majorMustEqual:l,minorBase:$,minorMustEqual:h,patchBase:n,patchMustEqual:i,isMinimum:u.hasGreaterEquals,notBefore:o}}e.$1o=I;function k(u,d,l){let $;typeof u=="string"?$=I(v(u)):$=u;let h;d instanceof Date?h=d.getTime():typeof d=="string"&&(h=new Date(d).getTime());let n;if(typeof l=="string"?n=I(v(l)):n=l,!$||!n)return!1;const i=$.majorBase,o=$.minorBase,s=$.patchBase;let t=n.majorBase,a=n.minorBase,g=n.patchBase;const L=n.notBefore;let D=n.majorMustEqual,y=n.minorMustEqual,A=n.patchMustEqual;return n.isMinimum?i>t?!0:i<t?!1:o>a?!0:o<a||h&&h<L?!1:s>=g:(i===1&&t===0&&(!D||!y||!A)&&(t=1,a=0,g=0,D=!0,y=!1,A=!1),i<t?!1:i>t?!D:o<a?!1:o>a?!y:s<g?!1:s>g?!A:!(h&&h<L))}e.$2o=k;function b(u,d,l,$,h){const n=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return n.push([R.default.Error,r.localize(0,null)]),n;if(typeof $.name!="string")return n.push([R.default.Error,r.localize(1,null,"name")]),n;if(typeof $.version!="string")return n.push([R.default.Error,r.localize(2,null,"version")]),n;if(!$.engines)return n.push([R.default.Error,r.localize(3,null,"engines")]),n;if(typeof $.engines.vscode!="string")return n.push([R.default.Error,r.localize(4,null,"engines.vscode")]),n;if(typeof $.extensionDependencies<"u"&&!m($.extensionDependencies))return n.push([R.default.Error,r.localize(5,null,"extensionDependencies")]),n;if(typeof $.activationEvents<"u"){if(!m($.activationEvents))return n.push([R.default.Error,r.localize(6,null,"activationEvents")]),n;if(typeof $.main>"u"&&typeof $.browser>"u")return n.push([R.default.Error,r.localize(7,null,"activationEvents","main","browser")]),n}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&n.push([R.default.Warning,r.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return n.push([R.default.Error,r.localize(9,null,"main")]),n;{const s=(0,E.$Dg)(l,$.main);(0,E.$xg)(s,l)||n.push([R.default.Warning,r.localize(10,null,s.path,l.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return n.push([R.default.Error,r.localize(11,null,"browser")]),n;{const s=(0,E.$Dg)(l,$.browser);(0,E.$xg)(s,l)||n.push([R.default.Warning,r.localize(12,null,s.path,l.path)])}}if(!C.valid($.version))return n.push([R.default.Error,r.localize(13,null)]),n;const i=[];if(!f(u,d,$,h,i))for(const s of i)n.push([R.default.Error,s]);return n}e.$3o=b;function f(u,d,l,$,h){return $||typeof l.main>"u"&&typeof l.browser>"u"?!0:c(u,d,l.engines.vscode,h)}e.$4o=f;function p(u,d,l){return u==="*"||c(d,l,u)}e.$5o=p;function c(u,d,l,$=[]){const h=I(v(l));if(!h)return $.push(r.localize(14,null,l)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return $.push(r.localize(15,null,l)),!1}else if(!h.majorMustEqual)return $.push(r.localize(16,null,l)),!1;return k(u,d,h)?!0:($.push(r.localize(17,null,u,l)),!1)}function m(u){if(!Array.isArray(u))return!1;for(let d=0,l=u.length;d<l;d++)if(typeof u[d]!="string")return!1;return!0}}),define(be[215],ve([1,0,15,21]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;async function r(C,S,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const I=(await S.readFile(C.serviceMachineIdResource)).value.toString();w=(0,R.$lg)(I)?I:null}catch{w=null}if(!w){w=(0,R.$mg)();try{await S.writeFile(C.serviceMachineIdResource,E.$ge.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.$mp=r}),define(be[67],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(r,C=[],S=!1){this.ctor=r,this.staticArguments=C,this.supportsDelayedInstantiation=S}}e.$Yh=E}),define(be[216],ve([1,0,67]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.InstantiationType=void 0;const R=[];var r;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function C(P,w,v){w instanceof E.$Yh||(w=new E.$Yh(w,[],!!v)),R.push([P,w])}e.$Jr=C;function S(){return R}e.$Kr=S}),define(be[217],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;class E{constructor(C,S){this.key=C,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.$oq=E;class R{constructor(C){this.b=C,this.a=new Map}roots(){const C=[];for(const S of this.a.values())S.outgoing.size===0&&C.push(S);return C}insertEdge(C,S){const P=this.lookupOrInsertNode(C),w=this.lookupOrInsertNode(S);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(C){const S=this.b(C);this.a.delete(S);for(const P of this.a.values())P.outgoing.delete(S),P.incoming.delete(S)}lookupOrInsertNode(C){const S=this.b(C);let P=this.a.get(S);return P||(P=new E(S,C),this.a.set(S,P)),P}lookup(C){return this.a.get(this.b(C))}isEmpty(){return this.a.size===0}toString(){const C=[];for(const[S,P]of this.a)C.push(`${S}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return C.join(`
`)}findCycleSlow(){for(const[C,S]of this.a){const P=new Set([C]),w=this.c(S,P);if(w)return w}}c(C,S){for(const[P,w]of C.outgoing){if(S.has(P))return[...S,P].join(" -> ");S.add(P);const v=this.c(w,S);if(v)return v;S.delete(P)}}}e.$pq=R}),define(be[6],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var E;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=P})(E||(e._util=E={})),e.$1h=r("instantiationService");function R(S,P,w){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:S,index:w}):(P[E.DI_DEPENDENCIES]=[{id:S,index:w}],P[E.DI_TARGET]=P)}function r(S){if(E.serviceIds.has(S))return E.serviceIds.get(S);const P=function(w,v,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,w,I)};return P.toString=()=>S,E.serviceIds.set(S,P),P}e.$2h=r;function C(S){return S}e.$3h=C}),define(be[24],ve([1,0,10,3,6]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,r.$2h)("configurationService");function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof R.URI)}e.$wi=C;function S(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof R.URI)}e.$xi=S;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=w;function v(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$zi=v;function I(u,d){const l=Object.create(null);for(const $ in u)k(l,$,u[$],d);return l}e.$Ai=I;function k(u,d,l,$){const h=d.split("."),n=h.pop();let i=u;for(let o=0;o<h.length;o++){const s=h[o];let t=i[s];switch(typeof t){case"undefined":t=i[s]=Object.create(null);break;case"object":break;default:$(`Ignoring ${d} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[n]=l}catch{$(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(i)}`)}else $(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(i)}`)}e.$Bi=k;function b(u,d){const l=d.split(".");f(u,l)}e.$Ci=b;function f(u,d){const l=d.shift();if(d.length===0){delete u[l];return}if(Object.keys(u).indexOf(l)!==-1){const $=u[l];typeof $=="object"&&!Array.isArray($)&&(f($,d),Object.keys($).length===0&&delete u[l])}}function p(u,d,l){function $(i,o){let s=i;for(const t of o){if(typeof s!="object"||s===null)return;s=s[t]}return s}const h=d.split("."),n=$(u,h);return typeof n>"u"?l:n}e.$Di=p;function c(u,d,l){Object.keys(d).forEach($=>{$!=="__proto__"&&($ in u?E.$Gf(u[$])&&E.$Gf(d[$])?c(u[$],d[$],l):l&&(u[$]=d[$]):u[$]=d[$])})}e.$Ei=c;function m(u){return u.replace(/[\[\]]/g,"")}e.$Fi=m}),define(be[68],ve([1,0,4,17,207,6,175,11]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",E.$j),w.set("isLinux",E.$k),w.set("isWindows",E.$i),w.set("isWeb",E.$o),w.set("isMacNative",E.$j&&!E.$o),w.set("isEdge",E.$H),w.set("isFirefox",E.$F),w.set("isChrome",E.$E),w.set("isSafari",E.$G);function v(q,O){if(w.get(q)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(q,O)}e.$Xi=v;const I=Object.prototype.hasOwnProperty;var k;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const b={regexParsingWithErrorRecovery:!0},f=(0,S.localize)(0,null),p=(0,S.localize)(1,null),c=(0,S.localize)(2,null),m=(0,S.localize)(3,null),u=(0,S.localize)(4,null),d=(0,S.localize)(5,null),l=(0,S.localize)(6,null),$=(0,S.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=b){this.k=O,this.d=new r.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const ne=this.D(),Y=ne.type===17?d:void 0;throw this.h.push({message:u,offset:ne.offset,lexeme:r.$Wi.getLexeme(ne),additionalInfo:Y}),h.c}return j}catch(j){if(j!==h.c)throw j;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const j=this.o();O.push(j)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const j=this.s();O.push(j)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,m),j?.negate()}case 17:return this.z(),F.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const j=this.l();return this.A(1,m),j}case 17:{const j=O.lexeme;if(this.z(),this.y(9)){const Y=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Y.type!==10)throw this.B("REGEX",Y);const Z=Y.lexeme,B=Z.lastIndexOf("/"),H=B===Z.length-1?void 0:this.w(Z.substring(B+1));let T;try{T=new RegExp(Z.substring(1,B),H)}catch{throw this.B("REGEX",Y)}return U.create(j,T)}switch(Y.type){case 10:case 19:{const Z=[Y.lexeme];this.z();let B=this.D(),H=0;for(let fe=0;fe<Y.lexeme.length;fe++)Y.lexeme.charCodeAt(fe)===40?H++:Y.lexeme.charCodeAt(fe)===41&&H--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let fe=0;fe<B.lexeme.length;fe++)B.lexeme.charCodeAt(fe)===40?H++:Y.lexeme.charCodeAt(fe)===41&&H--}if(H<0)break;Z.push(r.$Wi.getLexeme(B)),this.z(),B=this.D()}const T=Z.join(""),W=T.lastIndexOf("/"),x=W===T.length-1?void 0:this.w(T.substring(W+1));let re;try{re=new RegExp(T.substring(1,W),x)}catch{throw this.B("REGEX",Y)}return n.regex(j,re)}case 18:{const Z=Y.lexeme;this.z();let B=null;if(!(0,R.$Ge)(Z)){const H=Z.indexOf("/"),T=Z.lastIndexOf("/");if(H!==T&&H>=0){const W=Z.slice(H+1,T),x=Z[T+1]==="i"?"i":"";try{B=new RegExp(W,x)}catch{throw this.B("REGEX",Y)}}}if(B===null)throw this.B("REGEX",Y);return U.create(j,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const Y=this.u();return n.notIn(j,Y)}switch(this.D().type){case 3:{this.z();const Y=this.u();if(this.x().type===18)return n.equals(j,Y);switch(Y){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,Y)}}case 4:{this.z();const Y=this.u();if(this.x().type===18)return n.notEquals(j,Y);switch(Y){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,Y)}}case 5:return this.z(),ie.create(j,this.u());case 6:return this.z(),ee.create(j,this.u());case 7:return this.z(),te.create(j,this.u());case 8:return this.z(),J.create(j,this.u());case 13:return this.z(),n.in(j,this.u());default:return n.has(j)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:$}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,j){if(this.C(O))return this.z();throw this.B(j,this.D())}B(O,j,ne){const Y=(0,S.localize)(8,null,O,r.$Wi.getLexeme(j)),Z=j.offset,B=r.$Wi.getLexeme(j);return this.h.push({message:Y,offset:Z,lexeme:B,additionalInfo:ne}),h.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=h;class n{static false(){return t.INSTANCE}static true(){return a.INSTANCE}static has(O){return g.create(O)}static equals(O,j){return L.create(O,j)}static notEquals(O,j){return A.create(O,j)}static regex(O,j){return U.create(O,j)}static in(O,j){return D.create(O,j)}static notIn(O,j){return y.create(O,j)}static not(O){return F.create(O)}static and(...O){return _.create(O,null,!0)}static or(...O){return V.create(O,null,!0)}static greater(O,j){return te.create(O,j)}static greaterEquals(O,j){return J.create(O,j)}static smaller(O,j){return ie.create(O,j)}static smallerEquals(O,j){return ee.create(O,j)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Zi=n;function i(q){const O=new h({regexParsingWithErrorRecovery:!1});return q.map(j=>(O.parse(j),O.lexingErrors.length>0?O.lexingErrors.map(ne=>({errorMessage:ne.additionalInfo?(0,S.localize)(9,null,ne.additionalInfo):(0,S.localize)(10,null),offset:ne.offset,length:ne.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(ne=>({errorMessage:ne.additionalInfo?`${ne.message}. ${ne.additionalInfo}`:ne.message,offset:ne.offset,length:ne.lexeme.length})):[]))}e.$1i=i;function o(q,O){const j=q?q.substituteConstants():void 0,ne=O?O.substituteConstants():void 0;return!j&&!ne?!0:!j||!ne?!1:j.equals(ne)}e.$2i=o;function s(q,O){return q.cmp(O)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$3i=t;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return t.INSTANCE}}e.$4i=a;class g{static create(O,j=null){const ne=w.get(O);return typeof ne=="boolean"?ne?a.INSTANCE:t.INSTANCE:new g(O,j)}constructor(O,j){this.key=O,this.c=j,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:oe(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=w.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:t.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$5i=g;class L{static create(O,j,ne=null){if(typeof j=="boolean")return j?g.create(O,ne):F.create(O,ne);const Y=w.get(O);return typeof Y=="boolean"?j===(Y?"true":"false")?a.INSTANCE:t.INSTANCE:new L(O,j,ne)}constructor(O,j,ne){this.c=O,this.d=j,this.f=ne,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=w.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?a.INSTANCE:t.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$6i=L;class D{static create(O,j){return new D(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:le(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.f),ne=O.getValue(this.d);return Array.isArray(j)?j.includes(ne):typeof ne=="string"&&typeof j=="object"&&j!==null?I.call(j,ne):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$7i=D;class y{static create(O,j){return new y(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=11,this.c=D.create(O,j)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=y;class A{static create(O,j,ne=null){if(typeof j=="boolean")return j?F.create(O,ne):g.create(O,ne);const Y=w.get(O);return typeof Y=="boolean"?j===(Y?"true":"false")?t.INSTANCE:a.INSTANCE:new A(O,j,ne)}constructor(O,j,ne){this.c=O,this.d=j,this.f=ne,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=w.get(this.c);if(typeof O=="boolean"){const j=O?"true":"false";return this.d===j?t.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$9i=A;class F{static create(O,j=null){const ne=w.get(O);return typeof ne=="boolean"?ne?t.INSTANCE:a.INSTANCE:new F(O,j)}constructor(O,j){this.c=O,this.d=j,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:oe(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=w.get(this.c);return typeof O=="boolean"?O?t.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$0i=F;function X(q,O){if(typeof q=="string"){const j=parseFloat(q);isNaN(j)||(q=j)}return typeof q=="string"||typeof q=="number"?O(q):t.INSTANCE}class te{static create(O,j,ne=null){return X(j,Y=>new te(O,Y,ne))}constructor(O,j,ne){this.c=O,this.d=j,this.f=ne,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$$i=te;class J{static create(O,j,ne=null){return X(j,Y=>new J(O,Y,ne))}constructor(O,j,ne){this.c=O,this.d=j,this.f=ne,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$_i=J;class ie{static create(O,j,ne=null){return X(j,Y=>new ie(O,Y,ne))}constructor(O,j,ne){this.c=O,this.d=j,this.f=ne,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$aj=ie;class ee{static create(O,j,ne=null){return X(j,Y=>new ee(O,Y,ne))}constructor(O,j,ne){this.c=O,this.d=j,this.f=ne,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:le(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$bj=ee;class U{static create(O,j){return new U(O,j)}constructor(O,j){this.d=O,this.f=j,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const j=this.f?this.f.source:"",ne=O.f?O.f.source:"";return j<ne?-1:j>ne?1:0}equals(O){if(O.type===this.type){const j=this.f?this.f.source:"",ne=O.f?O.f.source:"";return this.d===O.d&&j===ne}return!1}substituteConstants(){return this}evaluate(O){const j=O.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=he.create(this)),this.c}}e.$cj=U;class he{static create(O){return new he(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new he(this.c.map(O))}negate(){return this.c}}e.$dj=he;function Q(q){let O=null;for(let j=0,ne=q.length;j<ne;j++){const Y=q[j].substituteConstants();if(q[j]!==Y&&O===null){O=[];for(let Z=0;Z<j;Z++)O[Z]=q[Z]}O!==null&&(O[j]=Y)}return O===null?q:O}class _{static create(O,j,ne){return _.d(O,j,ne)}constructor(O,j){this.expr=O,this.c=j,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,ne=this.expr.length;j<ne;j++){const Y=s(this.expr[j],O.expr[j]);if(Y!==0)return Y}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,ne=this.expr.length;j<ne;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:_.create(O,this.c,!1)}evaluate(O){for(let j=0,ne=this.expr.length;j<ne;j++)if(!this.expr[j].evaluate(O))return!1;return!0}static d(O,j,ne){const Y=[];let Z=!1;for(const B of O)if(B){if(B.type===1){Z=!0;continue}if(B.type===0)return t.INSTANCE;if(B.type===6){Y.push(...B.expr);continue}Y.push(B)}if(Y.length===0&&Z)return a.INSTANCE;if(Y.length!==0){if(Y.length===1)return Y[0];Y.sort(s);for(let B=1;B<Y.length;B++)Y[B-1].equals(Y[B])&&(Y.splice(B,1),B--);if(Y.length===1)return Y[0];for(;Y.length>1;){const B=Y[Y.length-1];if(B.type!==9)break;Y.pop();const H=Y.pop(),T=Y.length===0,W=V.create(B.expr.map(x=>_.create([x,H],null,ne)),null,T);W&&(Y.push(W),Y.sort(s))}if(Y.length===1)return Y[0];if(ne){for(let B=0;B<Y.length;B++)for(let H=B+1;H<Y.length;H++)if(Y[B].negate().equals(Y[H]))return t.INSTANCE;if(Y.length===1)return Y[0]}return new _(Y,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new _(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());this.c=V.create(O,this,!0)}return this.c}}e.$ej=_;class V{static create(O,j,ne){return V.d(O,j,ne)}constructor(O,j){this.expr=O,this.c=j,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let j=0,ne=this.expr.length;j<ne;j++){const Y=s(this.expr[j],O.expr[j]);if(Y!==0)return Y}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let j=0,ne=this.expr.length;j<ne;j++)if(!this.expr[j].equals(O.expr[j]))return!1;return!0}return!1}substituteConstants(){const O=Q(this.expr);return O===this.expr?this:V.create(O,this.c,!1)}evaluate(O){for(let j=0,ne=this.expr.length;j<ne;j++)if(this.expr[j].evaluate(O))return!0;return!1}static d(O,j,ne){let Y=[],Z=!1;if(O){for(let B=0,H=O.length;B<H;B++){const T=O[B];if(T){if(T.type===0){Z=!0;continue}if(T.type===1)return a.INSTANCE;if(T.type===9){Y=Y.concat(T.expr);continue}Y.push(T)}}if(Y.length===0&&Z)return t.INSTANCE;Y.sort(s)}if(Y.length!==0){if(Y.length===1)return Y[0];for(let B=1;B<Y.length;B++)Y[B-1].equals(Y[B])&&(Y.splice(B,1),B--);if(Y.length===1)return Y[0];if(ne){for(let B=0;B<Y.length;B++)for(let H=B+1;H<Y.length;H++)if(Y[B].negate().equals(Y[H]))return a.INSTANCE;if(Y.length===1)return Y[0]}return new V(Y,j)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const j of this.expr)O.push(...j.keys());return O}map(O){return new V(this.expr.map(j=>j.map(O)),null)}negate(){if(!this.c){const O=[];for(const j of this.expr)O.push(j.negate());for(;O.length>1;){const j=O.shift(),ne=O.shift(),Y=[];for(const Z of z(j))for(const B of z(ne))Y.push(_.create([Z,B],null,!1));O.unshift(V.create(Y,null,!1))}this.c=V.create(O,this,!0)}return this.c}}e.$fj=V;class G extends g{static{this.d=[]}static all(){return G.d.values()}constructor(O,j,ne){super(O,null),this.f=j,typeof ne=="object"?G.d.push({...ne,key:O}):ne!==!0&&G.d.push({key:O,description:ne,type:j!=null?typeof j:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return L.create(this.key,O)}notEqualsTo(O){return A.create(this.key,O)}}e.$gj=G,e.$hj=(0,C.$2h)("contextKeyService");function oe(q,O){return q<O?-1:q>O?1:0}function le(q,O,j,ne){return q<j?-1:q>j?1:O<ne?-1:O>ne?1:0}function se(q,O){if(q.type===0||O.type===1)return!0;if(q.type===9)return O.type===9?$e(q.expr,O.expr):!1;if(O.type===9){for(const j of O.expr)if(se(q,j))return!0;return!1}if(q.type===6){if(O.type===6)return $e(O.expr,q.expr);for(const j of q.expr)if(se(j,O))return!0;return!1}return q.equals(O)}e.$ij=se;function $e(q,O){let j=0,ne=0;for(;j<q.length&&ne<O.length;){const Y=q[j].cmp(O[ne]);if(Y<0)return!1;Y===0&&j++,ne++}return j===q.length}function z(q){return q.type===9?q.expr:[q]}}),define(be[218],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.ID=void 0,e.ID="diagnosticsService",e.$Dm=(0,E.$2h)(e.ID);function R(C){return!!C.hostName&&!!C.errorMessage}e.$Em=R;class r{async getPerformanceInfo(S,P){return{}}async getSystemInfo(S,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,P){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}e.$Fm=r}),define(be[83],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n=(0,E.$2h)("downloadService")}),define(be[25],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,E.$2h)("environmentService"),e.$0h=(0,E.$3h)(e.$9h)}),define(be[30],ve([1,0,180,6]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0,e.$$n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_n=new RegExp(e.$$n),e.$ao="__web_extension",e.$bo="skipWalkthrough",e.$co="extensionsSync",e.$do="dependecyOrPackExtensionInstall";function r(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$eo=r;function C(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$fo=C;function S(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$go=S;function P(u,d){return d==="web"&&!u.includes("web")}e.$ho=P;function w(u,d,l){return P(d,l)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===l}e.$io=w;function v(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$jo=v;var I;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var k;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var b;(function(u){u.Install="install",u.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$ko=(0,R.$2h)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var c;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class m extends Error{constructor(d,l){super(d),this.code=l,this.name=l}}e.$lo=m,e.$mo=(0,R.$2h)("extensionManagementService"),e.$no="extensionsIdentifiers/disabled",e.$oo="extensionsIdentifiers/enabled",e.$po=(0,R.$2h)("IGlobalExtensionEnablementService"),e.$qo=(0,R.$2h)("IExtensionTipsService"),e.$ro=(0,E.localize)(0,null),e.$so={value:e.$ro,original:"Extensions"},e.$to={value:(0,E.localize)(1,null),original:"Preferences"}}),define(be[219],ve([1,0,5,2,23,3,51,30]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.$up=void 0;function w(m,u){return m?C.URI.revive(u?u.transformIncoming(m):m):void 0}function v(m,u){return u?u.transformOutgoingURI(m):m}function I(m,u){u=u||S.$Zm;const d=m.manifest;return{...(0,S.$3m)({...m,manifest:void 0},u),manifest:d}}function k(m,u){return m?.profileLocation?(0,S.$3m)(m,u??S.$Zm):m}function b(m,u){return u?(0,r.$jn)(m,d=>d instanceof C.URI?u.transformOutgoingURI(d):void 0):m}class f{constructor(u,d){this.a=u,this.b=d,this.onInstallExtension=E.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=E.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=E.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=E.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,d){const l=this.b(u);switch(d){case"onInstallExtension":return E.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?v($.profileLocation,l):$.profileLocation}));case"onDidInstallExtensions":return E.Event.map(this.onDidInstallExtensions,$=>$.map(h=>({...h,local:h.local?b(h.local,l):h.local,profileLocation:h.profileLocation?v(h.profileLocation,l):h.profileLocation})));case"onUninstallExtension":return E.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?v($.profileLocation,l):$.profileLocation}));case"onDidUninstallExtension":return E.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?v($.profileLocation,l):$.profileLocation}));case"onDidUpdateExtensionMetadata":return E.Event.map(this.onDidUpdateExtensionMetadata,$=>b($,l))}throw new Error("Invalid listen")}async call(u,d,l){const $=this.b(u);switch(d){case"zip":{const h=I(l[0],$),n=await this.a.zip(h);return v(n,$)}case"unzip":return this.a.unzip(w(l[0],$));case"install":return this.a.install(w(l[0],$),k(l[1],$));case"installFromLocation":return this.a.installFromLocation(w(l[0],$),w(l[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],w(l[1],$),w(l[2],$));case"getManifest":return this.a.getManifest(w(l[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],k(l[1],$));case"installGalleryExtensions":{const h=l[0];return this.a.installGalleryExtensions(h.map(({extension:n,options:i})=>({extension:n,options:k(i,$)??{}})))}case"uninstall":return this.a.uninstall(I(l[0],$),k(l[1],$));case"reinstallFromGallery":return this.a.reinstallFromGallery(I(l[0],$));case"getInstalled":return(await this.a.getInstalled(l[0],w(l[1],$))).map(n=>b(n,$));case"toggleAppliationScope":{const h=await this.a.toggleAppliationScope(I(l[0],$),w(l[1],$));return b(h,$)}case"copyExtensions":return this.a.copyExtensions(w(l[0],$),w(l[1],$));case"updateMetadata":{const h=await this.a.updateMetadata(I(l[0],$),l[1],w(l[2],$));return b(h,$)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$up=f;class p extends R.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(u){super(),this.m=u,this.c=this.B(new E.$Sd),this.f=this.B(new E.$Sd),this.g=this.B(new E.$Sd),this.h=this.B(new E.$Sd),this.j=this.B(new E.$Sd),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?C.URI.revive(d.source):d.source,profileLocation:C.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(l=>({...l,local:l.local?I(l.local,null):l.local,source:this.r(l.source)?C.URI.revive(l.source):l.source,profileLocation:C.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:C.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:C.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(I(d,null))))}n(u,d){u.fire(d)}r(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(u){const d=await this.getTargetPlatform();return u.allTargetPlatforms.some(l=>(0,P.$io)(l,u.allTargetPlatforms,d))}zip(u){return Promise.resolve(this.m.call("zip",[u]).then(d=>C.URI.revive(d)))}unzip(u){return Promise.resolve(this.m.call("unzip",[u]))}install(u,d){return Promise.resolve(this.m.call("install",[u,d])).then(l=>I(l,null))}installFromLocation(u,d){return Promise.resolve(this.m.call("installFromLocation",[u,d])).then(l=>I(l,null))}async installExtensionsFromProfile(u,d,l){return(await this.m.call("installExtensionsFromProfile",[u,d,l])).map(h=>I(h,null))}getManifest(u){return Promise.resolve(this.m.call("getManifest",[u]))}installFromGallery(u,d){return Promise.resolve(this.m.call("installFromGallery",[u,d])).then(l=>I(l,null))}async installGalleryExtensions(u){return(await this.m.call("installGalleryExtensions",[u])).map(l=>({...l,local:l.local?I(l.local,null):l.local,source:this.r(l.source)?C.URI.revive(l.source):l.source,profileLocation:C.URI.revive(l.profileLocation)}))}uninstall(u,d){return Promise.resolve(this.m.call("uninstall",[u,d]))}reinstallFromGallery(u){return Promise.resolve(this.m.call("reinstallFromGallery",[u])).then(d=>I(d,null))}getInstalled(u=null,d){return Promise.resolve(this.m.call("getInstalled",[u,d])).then(l=>l.map($=>I($,null)))}updateMetadata(u,d,l){return Promise.resolve(this.m.call("updateMetadata",[u,d,l])).then($=>I($,null))}toggleAppliationScope(u,d){return this.m.call("toggleAppliationScope",[u,d]).then(l=>I(l,null))}copyExtensions(u,d){return this.m.call("copyExtensions",[u,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(u,d,l){const $=await this.m.call("download",[u,d,l]);return C.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$vp=p;class c{constructor(u){this.a=u}listen(u,d){throw new Error("Invalid listen")}call(u,d,l){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(C.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$wp=c}),define(be[84],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=void 0,e.$rp=(0,E.$2h)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((C,S)=>ue(["node-vsce-sign"],async P=>C(P),S))),this.a}async verify(C,S,P){let w;try{w=await this.b()}catch{return!1}return w.verify(C,S,P)}}e.$sp=R}),define(be[16],ve([1,0,63,7,17,10,3,188,6,4,12,59]),function(ue,e,E,R,r,C,S,P,w,v,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,w.$2h)("fileService");function b(se){return se.create===!0}e.$mk=b;var f;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(f||(e.FileType=f={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function c(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$nk=c;var m;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function u(se){return!!(se.capabilities&2)}e.$ok=u;function d(se){return!!(se.capabilities&8)}e.$pk=d;function l(se){return!!(se.capabilities&131072)}e.$qk=l;function $(se){return!!(se.capabilities&4)}e.$rk=$;function h(se){return!!(se.capabilities&16)}e.$sk=h;function n(se){return u(se)?!!(se.capabilities&16384):!1}e.$tk=n;function i(se){return u(se)?!!(se.capabilities&32768):!1}e.$uk=i;function o(se){return!!(se.capabilities&65536)}e.$vk=o;function s(se){return!!(se.capabilities&2048)}e.$wk=s;var t;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class a extends Error{static create($e,z){const q=new a($e.toString(),z);return D(q,z),q}constructor($e,z){super($e),this.code=z}}e.$xk=a;function g(se,$e){return a.create(se,$e)}e.$yk=g;function L(se){return se||g((0,P.localize)(0,null),t.Unknown)}e.$zk=L;function D(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Ak=D;function y(se){if(!se)return t.Unknown;if(se instanceof a)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return t.Unknown;switch($e[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Bk=y;function A(se){if(se instanceof ee)return se.fileOperationResult;switch(y(se)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Ck=A;var F;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class X{constructor($e,z,q){this.resource=$e,this.operation=z,this.target=q}isOperation($e){return this.operation===$e}}e.$Dk=X;var te;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(te||(e.FileChangeType=te={}));class J{static{this.a=null}constructor($e,z){this.c=z,this.b=void 0,this.d=new k.$V(()=>{const q=E.$8h.forUris(()=>this.c);return q.fill(this.rawAdded.map(O=>[O,!0])),q}),this.f=new k.$V(()=>{const q=E.$8h.forUris(()=>this.c);return q.fill(this.rawUpdated.map(O=>[O,!0])),q}),this.g=new k.$V(()=>{const q=E.$8h.forUris(()=>this.c);return q.fill(this.rawDeleted.map(O=>[O,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of $e){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==J.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=J.a):this.b!==void 0&&(this.b=J.a))}}contains($e,...z){return this.h($e,{includeChildren:!1},...z)}affects($e,...z){return this.h($e,{includeChildren:!0},...z)}h($e,z,...q){if(!$e)return!1;const O=q.length>0;return!!((!O||q.includes(1))&&(this.d.value.get($e)||z.includeChildren&&this.d.value.findSuperstr($e))||(!O||q.includes(0))&&(this.f.value.get($e)||z.includeChildren&&this.f.value.findSuperstr($e))||(!O||q.includes(2))&&(this.g.value.findSubstr($e)||z.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=J;function ie(se,$e,z){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==R.sep&&($e+=R.sep),z?(0,r.$9e)(se,$e):se.indexOf($e)===0)}e.$Fk=ie;class ee extends Error{constructor($e,z,q){super($e),this.fileOperationResult=z,this.options=q}}e.$Gk=ee;class U extends ee{constructor($e,z,q,O){super($e,z,O),this.fileOperationResult=z,this.size=q}}e.$Hk=U;class he extends ee{constructor($e,z,q){super($e,2,q),this.stat=z}}e.$Ik=he;var Q;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var _;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(_||(e.FileKind=_={})),e.$Qk="";function V(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Rk=V;async function G(se,$e){if(!$e.hasProvider(S.URI.from({scheme:se.scheme})))return new Promise(z=>{const q=$e.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===se.scheme&&O.added&&(q.dispose(),z())})})}e.$Sk=G;class oe{static{this.KB=1024}static{this.MB=oe.KB*oe.KB}static{this.GB=oe.MB*oe.KB}static{this.TB=oe.GB*oe.KB}static formatSize($e){return(0,C.$If)($e)||($e=0),$e<oe.KB?(0,P.localize)(1,null,$e.toFixed(0)):$e<oe.MB?(0,P.localize)(2,null,($e/oe.KB).toFixed(2)):$e<oe.GB?(0,P.localize)(3,null,($e/oe.MB).toFixed(2)):$e<oe.TB?(0,P.localize)(4,null,($e/oe.GB).toFixed(2)):(0,P.localize)(5,null,($e/oe.TB).toFixed(2))}}e.$Tk=oe;function le(se){const $e=typeof se=="string"||se?.scheme===I.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===I.Schemas.file?1024*oe.MB:$e?10*oe.MB:v.$o?50*oe.MB:1024*oe.MB}e.$Uk=le}),define(be[109],ve([1,0,15,11,189,16]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;async function S(I,k,b,f,p,c){let m;try{await P(I,k,b,f,p,c)}catch(u){m=u}finally{m&&p.errorTransformer&&(m=p.errorTransformer(m)),typeof m<"u"&&b.error(m),b.end()}}e.$Zp=S;async function P(I,k,b,f,p,c){w(c);const m=await I.open(k,{create:!1});try{w(c);let u=0,d=0,l=p&&typeof p.length=="number"?p.length:void 0,$=E.$ge.alloc(Math.min(p.bufferSize,typeof l=="number"?l:p.bufferSize)),h=p&&typeof p.position=="number"?p.position:0,n=0;do d=await I.read(m,h,$.buffer,n,$.byteLength-n),h+=d,n+=d,u+=d,typeof l=="number"&&(l-=d),n===$.byteLength&&(await b.write(f($)),$=E.$ge.alloc(Math.min(p.bufferSize,typeof l=="number"?l:p.bufferSize)),n=0);while(d>0&&(typeof l!="number"||l>0)&&w(c)&&v(u,p));if(n>0){let i=n;typeof l=="number"&&(i=Math.min(n,l)),b.write(f($.slice(0,i)))}}catch(u){throw(0,C.$zk)(u)}finally{await I.close(m)}}function w(I){if(I.isCancellationRequested)throw(0,R.$6)();return!0}function v(I,k){if(typeof k?.limits?.size=="number"&&I>k.limits.size)throw(0,C.$yk)((0,r.localize)(0,null),C.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(be[54],ve([1,0,80,2,7,4,3,16]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=void 0;function w(u){return u.recursive===!0}e.$2p=w;class v extends R.$Sc{static{this.a=5}constructor(d,l,$,h){super(),this.h=d,this.j=l,this.m=$,this.n=h,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const d=new R.$Rc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(l=>this.h(l))),d.add(this.b.onDidLogMessage(l=>this.j(l))),d.add(this.b.onDidError(l=>this.t(l)))}t(d){this.n.restartOnError?this.g<v.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3p=v;class I extends v{constructor(d,l,$){super(d,l,$,{type:"node.js",restartOnError:!1})}}e.$4p=I;class k extends v{constructor(d,l,$){super(d,l,$,{type:"universal",restartOnError:!0})}}e.$5p=k;function b(u){return u.map(d=>({type:d.type,resource:S.URI.revive(d.resource),cId:d.cId}))}e.$6p=b;function f(u){const d=new m;for(const l of u)d.processEvent(l);return d.coalesce()}e.$7p=f;function p(u,d){return typeof d=="string"&&!d.startsWith(E.$Ej)&&!(0,r.$ic)(d)?{base:u,pattern:d}:d}e.$8p=p;function c(u,d){const l=[];for(const $ of d)l.push((0,E.$Ij)(p(u,$)));return l}e.$9p=c;class m{constructor(){this.a=new Set,this.b=new Map}c(d){return C.$k?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const l=this.b.get(this.c(d));let $=!1;if(l){const h=l.type,n=d.type;l.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?$=!0:h===1&&n===2?(this.b.delete(this.c(d)),this.a.delete(l)):h===2&&n===1?l.type=0:h===1&&n===0||(l.type=n)}else $=!0;$&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],l=[];return Array.from(this.a).filter($=>$.type!==2?(d.push($),!1):!0).sort(($,h)=>$.resource.fsPath.length-h.resource.fsPath.length).filter($=>l.some(h=>(0,P.$Fk)($.resource.fsPath,h,!C.$k))?!1:(l.push($.resource.fsPath),!0)).concat(d)}}}),define(be[220],ve([1,0,15,39,11,5,2,48,21,16,54]),function(ue,e,E,R,r,C,S,P,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.$VN=void 0,e.$VN="localFilesystem";class k extends S.$Sc{constructor(f,p){super(),this.a=f,this.b=p,this.onDidChangeCapabilities=C.Event.None,this.f=this.B(new C.$Sd),this.onDidChangeFile=this.f.event,this.g=this.B(new C.$Sd),this.onDidWatchError=this.g.event,this.h=(0,w.$mg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,p){const{buffer:c}=await this.a.call("readFile",[f,p]);return c}readFileStream(f,p,c){const m=(0,P.$7d)(d=>E.$ge.concat(d.map(l=>E.$ge.wrap(l))).buffer),u=new S.$Rc;return u.add(this.a.listen("readFileStream",[f,p])(d=>{if(d instanceof E.$ge)m.write(d.buffer);else{if(d==="end")m.end();else{let l;if(d instanceof Error)l=d;else{const $=d;l=(0,v.$yk)($.message??(0,R.$Mi)($),$.code??v.FileSystemProviderErrorCode.Unknown)}m.error(l),m.end()}u.dispose()}})),u.add(c.onCancellationRequested(()=>{m.error((0,r.$6)()),m.end(),u.dispose()})),m}writeFile(f,p,c){return this.a.call("writeFile",[f,E.$ge.wrap(p),c])}open(f,p){return this.a.call("open",[f,p])}close(f){return this.a.call("close",[f])}async read(f,p,c,m,u){const[d,l]=await this.a.call("read",[f,p,u]);return c.set(d.buffer.slice(0,l),m),l}write(f,p,c,m,u){return this.a.call("write",[f,p,E.$ge.wrap(c),m,u])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,p){return this.a.call("delete",[f,p])}rename(f,p,c){return this.a.call("rename",[f,p,c])}copy(f,p,c){return this.a.call("copy",[f,p,c])}cloneFile(f,p){return this.a.call("cloneFile",[f,p])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const p=f;this.f.fire((0,I.$6p)(p))}else{const p=f;this.g.fire(p)}}))}watch(f,p){const c=(0,w.$mg)();return this.a.call("watch",[this.h,c,f,p]),(0,S.$Qc)(()=>this.a.call("unwatch",[this.h,c]))}}e.$WN=k}),define(be[221],ve([1,0,27,14,20,40,2,98,7,4,19,3,169,22,54]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;class c extends S.$Sc{static{this.a=100}static{this.b=75}constructor(d,l,$,h){super(),this.m=d,this.n=l,this.r=$,this.s=h,this.c=this.B(new R.$eh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.n(n))),this.f=this.B(new R.$dh(n=>this.z(n),c.b)),this.g=(0,p.$9p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$9p)(this.m.path,this.m.includes):void 0,this.j=new r.$3d,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await f.Promises.stat(d);this.B(await this.w(d,l.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let l=d.path;try{l=await f.Promises.realpath(d.path),d.path===l&&(l=await(0,b.$gq)(d.path)??d.path),d.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${l})`)}catch{}return l}async w(d,l){if(v.$j&&(0,C.$4f)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.$Sc.None;const $=new r.$3d(this.j.token),h=new S.$Rc;try{const n=k.URI.file(this.m.path),i=(0,w.$nc)(d),o=(0,E.watch)(d);h.add((0,S.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${d}'`);const s=new Set;if(l)try{for(const a of await f.Promises.readdir(d))s.add(a)}catch(a){this.D(a)}const t=new Map;h.add((0,S.$Qc)(()=>{for(const[,a]of t)a.dispose();t.clear()})),o.on("error",(a,g)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${a}, ${g})`),this.dispose()}),o.on("change",(a,g)=>{if($.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${g}`);let L="";if(g&&(L=g.toString(),v.$j&&(L=(0,P.$Bl)(L))),!(!L||a!=="change"&&a!=="rename"))if(l)if(a==="rename"){t.get(L)?.dispose();const D=setTimeout(async()=>{if(t.delete(L),L===i&&!await f.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const y=await this.C((0,w.$jc)(d,L));if($.token.isCancellationRequested)return;let A;y?s.has(L)?A=0:(A=1,s.add(L)):(s.delete(L),A=2),this.y({resource:(0,I.$Dg)(n,L),type:A,cId:this.m.correlationId})},c.a);t.set(L,(0,S.$Qc)(()=>clearTimeout(D)))}else{let D;s.has(L)?D=0:(D=1,s.add(L)),this.y({resource:(0,I.$Dg)(n,L),type:D,cId:this.m.correlationId})}else if(a==="rename"||L!==i){const D=setTimeout(async()=>{const y=await f.Promises.exists(d);$.token.isCancellationRequested||(y?(this.y({resource:n,type:0,cId:this.m.correlationId},!0),h.add(await this.w(d,!1))):(this.y({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);h.clear(),h.add((0,S.$Qc)(()=>clearTimeout(D)))}else this.y({resource:n,type:0,cId:this.m.correlationId},!0)})}catch(n){await f.Promises.exists(d)&&!$.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${n.toString()})`)}return(0,S.$Qc)(()=>{$.dispose(!0),h.dispose()})}y(d,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!l&&this.g.some($=>$(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some($=>$(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const l=(0,p.$7p)(d);if(l.length>0){if(this.s)for(const h of l)this.G(` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(v.$k)return f.Promises.exists(d);try{const l=(0,w.$nc)(d);return(await f.Promises.readdir((0,w.$mc)(d))).some(h=>h===l)}catch(l){return this.G(l),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$jq=c;async function m(u,d,l,$,h=512){const n=await f.Promises.open(u,"r"),i=Buffer.allocUnsafe(h),o=new r.$3d($);let s,t=!1;const a={path:u,excludes:[],recursive:!1},g=new c(a,L=>{(async()=>{for(const{type:D}of L)if(D===0){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:y}=await f.Promises.read(n,i,0,h,null);if(!y||o.token.isCancellationRequested)break;d(i.slice(0,y))}}catch(y){s=new Error(y),o.dispose(!0)}finally{t=!1}}})()});return await g.ready,l(),new Promise((L,D)=>{o.token.onCancellationRequested(async()=>{g.dispose();try{await f.Promises.close(n)}catch(y){s=new Error(y)}s?D(s):L()})})}e.$kq=m}),define(be[222],ve([1,0,5,80,2,4,221]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class P extends r.$Sc{constructor(){super(...arguments),this.a=this.B(new E.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new E.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(v){const I=this.j(v),k=I.filter(f=>{const p=this.c.get(f.path);return p?!(0,R.$Mj)(p.request.excludes,f.excludes)||!(0,R.$Mj)(p.request.includes,f.includes):!0}),b=Array.from(this.c.values()).filter(({request:f})=>!I.find(p=>p.path===f.path&&(0,R.$Mj)(p.excludes,f.excludes)&&(0,R.$Mj)(p.includes,f.includes))).map(({request:f})=>f.path);k.length&&this.m(`Request to start watching: ${k.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),b.length&&this.m(`Request to stop watching: ${b.join(",")}`);for(const f of b)this.h(f);for(const f of k)this.g(f)}g(v){const I=new S.$jq(v,b=>this.a.fire(b),b=>this.b.fire(b),this.f),k={request:v,instance:I};this.c.set(v.path,k)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const I=this.c.get(v);I&&(this.c.delete(v),I.instance.dispose())}j(v){const I=new Map;for(const k of v){const b=C.$k?k.path:k.path.toLowerCase();let f=I.get(k.correlationId);f||(f=new Map,I.set(k.correlationId,f)),f.set(b,k)}return Array.from(I.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(v){this.f=v;for(const[,I]of this.c)I.instance.setVerboseLogging(v)}m(v){this.f&&this.b.fire({type:"trace",message:this.n(v)})}n(v,I){return I?`[File Watcher (node.js)] ${v} (path: ${I.request.path})`:`[File Watcher (node.js)] ${v}`}}e.$lq=P}),define(be[223],ve([1,0,54,222]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class r extends E.$4p{constructor(S,P,w){super(S,P,w),this.s()}r(S){return S.add(new R.$lq)}}e.$mq=r}),define(be[224],ve([1,0,12,43,107,54]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class S extends C.$5p{constructor(w,v,I){super(w,v,I),this.s()}r(w){const v=w.add(new r.$dq(E.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(v.onDidProcessExit(({code:I,signal:k})=>this.t(`terminated by itself with code ${I}, signal: ${k}`))),R.ProxyChannel.toService((0,R.$Ih)(v.getChannel("watcher")))}}e.$eq=S}),define(be[85],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class E{constructor(...r){this.a=new Map;for(const[C,S]of r)this.set(C,S)}set(r,C){const S=this.a.get(r);return this.a.set(r,C),S}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$Zh=E}),define(be[110],ve([1,0,14,11,2,67,217,6,85,97]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;const I=!1;class k extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class b{constructor(m=new w.$Zh,u=!1,d,l=I){this.f=m,this.g=u,this.h=d,this.i=l,this.o=new Set,this.f.set(P.$1h,this),this._globalGraph=l?d?._globalGraph??new S.$pq($=>$):void 0}createChild(m){return new b(m,this.g,this,this.i)}invokeFunction(m,...u){const d=p.traceInvocation(this.i,m);let l=!1;try{return m({get:h=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(h,d);if(!n)throw new Error(`[invokeFunction] unknown service '${h}'`);return n}},...u)}finally{l=!0,d.stop()}}createInstance(m,...u){let d,l;return m instanceof C.$Yh?(d=p.traceCreation(this.i,m.ctor),l=this.j(m.ctor,m.staticArguments.concat(u),d)):(d=p.traceCreation(this.i,m),l=this.j(m,u,d)),d.stop(),l}j(m,u=[],d){const l=P._util.getServiceDependencies(m).sort((n,i)=>n.index-i.index),$=[];for(const n of l){const i=this.m(n.id,d);i||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${n.id}.`,!1),$.push(i)}const h=l.length>0?l[0].index:u.length;if(u.length!==h){console.trace(`[createInstance] First service dependency of ${m.name} at position ${h+1} conflicts with ${u.length} static arguments`);const n=h-u.length;n>0?u=u.concat(new Array(n)):u=u.slice(0,h)}return Reflect.construct(m,u.concat($))}k(m,u){if(this.f.get(m)instanceof C.$Yh)this.f.set(m,u);else if(this.h)this.h.k(m,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const u=this.f.get(m);return!u&&this.h?this.h.l(m):u}m(m,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const d=this.l(m);return d instanceof C.$Yh?this.q(m,d,u.branch(m,!0)):(u.branch(m,!1),d)}q(m,u,d){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,u,d)}finally{this.o.delete(m)}}r(m,u,d){const l=new S.$pq(n=>n.id.toString());let $=0;const h=[{id:m,desc:u,_trace:d}];for(;h.length;){const n=h.pop();if(l.lookupOrInsertNode(n),$++>1e3)throw new k(l);for(const i of P._util.getServiceDependencies(n.desc.ctor)){const o=this.l(i.id);if(o||this.u(`[createInstance] ${m} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(i.id)),o instanceof C.$Yh){const s={id:i.id,desc:o,_trace:n._trace.branch(i.id,!0)};l.insertEdge(n,s),h.push(s)}}}for(;;){const n=l.roots();if(n.length===0){if(!l.isEmpty())throw new k(l);break}for(const{data:i}of n){if(this.l(i.id)instanceof C.$Yh){const s=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,s)}l.removeNode(i)}}return this.l(m)}s(m,u,d=[],l,$){if(this.f.get(m)instanceof C.$Yh)return this.t(m,u,d,l,$);if(this.h)return this.h.s(m,u,d,l,$);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(m,u,d=[],l,$){if(l){const h=new b(void 0,this.g,this,this.i);h.c=String(m);const n=new Map,i=new E.$ih(()=>{const o=h.j(u,d,$);for(const[s,t]of n){const a=o[s];if(typeof a=="function")for(const g of t)a.apply(o,g)}return n.clear(),o});return new Proxy(Object.create(null),{get(o,s){if(!i.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let g=n.get(s);return g||(g=new v.$3c,n.set(s,g)),(D,y,A)=>{const F=g.push([D,y,A]);return(0,r.$Qc)(F)}}if(s in o)return o[s];const t=i.value;let a=t[s];return typeof a!="function"||(a=a.bind(t),o[s]=a),a},set(o,s,t){return i.value[s]=t,!0},getPrototypeOf(o){return u.prototype}})}else return this.j(u,d,$)}u(m,u){if(u&&console.warn(m),this.g)throw new Error(m)}}e.$qq=b;var f;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(f||(f={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,u){return m?new p(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(m,u){return m?new p(1,u.name):p.c}static{this.f=0}constructor(m,u){this.type=m,this.name=u,this.g=Date.now(),this.h=[]}branch(m,u){const d=new p(3,m.toString());return this.h.push([m,u,d]),d}stop(){const m=Date.now()-this.g;p.f+=m;let u=!1;function d($,h){const n=[],i=new Array($+1).join("	");for(const[o,s,t]of h.h)if(s&&t){u=!0,n.push(`${i}CREATES -> ${o}`);const a=d($+1,t);a&&n.push(a)}else n.push(`${i}uses -> ${o}`);return n.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(m>2||u)&&p.all.add(l.join(`
`))}}e.$rq=p}),define(be[225],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$av=void 0,e.$av=(0,E.$2h)("labelService");var R;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(R||(e.Verbosity=R={}))});var Le=this&&this.__param||function(ue,e){return function(E,R){e(E,R,ue)}};define(be[86],ve([1,0,20,2,4,191,30,6]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0;function w(I){return I.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$5q=w,e.$6q=(0,P.$2h)("languagePackService");let v=class extends R.$Sc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new E.$3d;setTimeout(()=>k.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const p=b.firstPage.filter(c=>c.properties.localizedLanguages?.length&&c.tags.some(m=>m.startsWith("lp-"))).map(c=>{const m=c.properties.localizedLanguages?.[0],u=w(c);return{...this.f(u,m,c),extensionId:c.identifier.id,galleryExtension:c}});return p.push(this.f("en","English")),p}f(k,b,f){const p=b??k;let c;if(p!==k&&(c=`(${k})`),k.toLowerCase()===r.$w.toLowerCase()&&(c??="",c+=(0,C.localize)(0,null)),f?.installCount){c??="";const m=f.installCount;let u;m>1e6?u=`${Math.floor(m/1e5)/10}M`:m>1e3?u=`${Math.floor(m/1e3)}K`:u=String(m),c+=` $(cloud-download) ${u}`}return{id:k,label:p,description:c}}};e.$7q=v,e.$7q=v=Fe([Le(0,S.$ko)],v)}),define(be[13],ve([1,0,39,5,61,2,26,4,19,10,3,68,6]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,b.$2h)("logService"),e.$kj=(0,b.$2h)("loggerService");function f(){return new Date().toISOString()}function p(D){return(0,v.$If)(D)}e.$lj=p;var c;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$mj=c.Info;function m(D,y,A){switch(y){case c.Trace:D.trace(A);break;case c.Debug:D.debug(A);break;case c.Info:D.info(A);break;case c.Warning:D.warn(A);break;case c.Error:D.error(A);break;case c.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=m;function u(D,y=!1){let A="";for(let F=0;F<D.length;F++){let X=D[F];if(X instanceof Error&&(X=(0,E.$Mi)(X,y)),typeof X=="object")try{X=JSON.stringify(X)}catch{}A+=(F>0?" ":"")+X}return A}class d extends C.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new R.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==c.Off&&this.b<=y}}e.$oj=d;class l extends d{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...A){this.f(c.Trace)&&this.g(c.Trace,u([y,...A],!0))}debug(y,...A){this.f(c.Debug)&&this.g(c.Debug,u([y,...A]))}info(y,...A){this.f(c.Info)&&this.g(c.Info,u([y,...A]))}warn(y,...A){this.f(c.Warning)&&this.g(c.Warning,u([y,...A]))}error(y,...A){if(this.f(c.Error))if(y instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=y.stack,this.g(c.Error,u(F))}else this.g(c.Error,u([y,...A]))}flush(){}}e.$pj=l;class $ extends d{constructor(y=e.$mj){super(),this.setLevel(y),this.g=!P.$i}trace(y,...A){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,y,...A):console.log(`[main ${f()}]`,y,...A))}debug(y,...A){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,y,...A):console.log(`[main ${f()}]`,y,...A))}info(y,...A){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,y,...A):console.log(`[main ${f()}]`,y,...A))}warn(y,...A){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,y,...A):console.warn(`[main ${f()}]`,y,...A))}error(y,...A){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,y,...A):console.error(`[main ${f()}]`,y,...A))}dispose(){}flush(){}}e.$qj=$;class h extends d{constructor(y=e.$mj,A=!0){super(),this.g=A,this.setLevel(y)}trace(y,...A){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...A):console.log(y,...A))}debug(y,...A){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...A):console.log(y,...A))}info(y,...A){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...A):console.log(y,...A))}warn(y,...A){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...A):console.log(y,...A))}error(y,...A){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...A):console.error(y,...A))}dispose(){}flush(){}}e.$rj=h;class n extends d{constructor(y,A=e.$mj){super(),this.g=y,this.setLevel(A)}trace(y,...A){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(y),...A])}debug(y,...A){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(y),...A])}info(y,...A){this.f(c.Info)&&this.g.log(c.Info,[this.h(y),...A])}warn(y,...A){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(y),...A])}error(y,...A){this.f(c.Error)&&this.g.log(c.Error,[this.h(y),...A])}h(y){return typeof y=="string"?y:(0,E.$Mi)(y,this.f(c.Trace))}dispose(){}flush(){}}e.$sj=n;class i extends d{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const A of this.g)A.setLevel(y);super.setLevel(y)}trace(y,...A){for(const F of this.g)F.trace(y,...A)}debug(y,...A){for(const F of this.g)F.debug(y,...A)}info(y,...A){for(const F of this.g)F.info(y,...A)}warn(y,...A){for(const F of this.g)F.warn(y,...A)}error(y,...A){for(const F of this.g)F.error(y,...A)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$tj=i;class o extends C.$Sc{constructor(y,A,F){if(super(),this.h=y,this.j=A,this.b=new S.$Ac,this.c=this.B(new R.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Sd),this.onDidChangeVisibility=this.g.event,F)for(const X of F)this.b.set(X.resource,{logger:void 0,info:X})}m(y){return(0,v.$Ef)(y)?[...this.b.values()].find(A=>A.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,A){const F=this.n(y),X=(0,v.$Ef)(y)?y:A?.id??(0,r.$Pi)(F.toString()).toString(16);let te=this.b.get(F)?.logger;const J=A?.logLevel==="always"?c.Trace:A?.logLevel;te||(te=this.s(F,J??this.getLogLevel(F)??this.h,{...A,id:X}));const ie={logger:te,info:{resource:F,id:X,logLevel:J,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(ie.info),this.b.set(F,ie),te}n(y){return(0,v.$Ef)(y)?(0,w.$Dg)(this.j,`${y}.log`):y}setLogLevel(y,A){if(I.URI.isUri(y)){const F=y,X=A,te=this.b.get(F);te&&X!==te.info.logLevel&&(te.info.logLevel=X===this.h?void 0:X,te.logger?.setLevel(X),this.b.set(te.info.resource,te),this.f.fire([F,X]))}else{this.h=y;for(const[F,X]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&X.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,A){const F=this.m(y);F&&A!==!F.info.hidden&&(F.info.hidden=!A,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,A]))}getLogLevel(y){let A;return y&&(A=this.b.get(y)?.info.logLevel),A??this.h}registerLogger(y){const A=this.b.get(y.resource);A?A.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const A=this.b.get(y);A&&(A.logger&&A.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=o;class s{constructor(){this.onDidChangeLogLevel=new R.$Sd().event}setLevel(y){}getLevel(){return c.Info}trace(y,...A){}debug(y,...A){}info(y,...A){}warn(y,...A){}error(y,...A){}critical(y,...A){}dispose(){}flush(){}}e.$vj=s;class t extends s{}e.$wj=t;function a(D){if(D.verbose)return c.Trace;if(typeof D.logLevel=="string"){const y=L(D.logLevel.toLowerCase());if(y!==void 0)return y}return e.$mj}e.$xj=a;function g(D){switch(D){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$yj=g;function L(D){switch(D){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$zj=L,e.$Aj=new k.$gj("logLevel",g(c.Info))}),define(be[226],ve([1,0,18,14,11,5,2,7,54,13]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class I extends S.$Sc{constructor(b,f){super(),this.a=b,this.b=f,this.c=this.B(new C.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new C.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Zg(0)),this.w=[],this.y=this.B(new R.$Zg(0))}watch(b,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(b,f):this.z(b,f)}n(b,f){const p={path:this.H(b),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},c=(0,E.$Ub)(this.j,p);return this.r(),(0,S.$Qc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(b=>(0,r.$1)(b))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,w.$6p)(f)),f=>this.G(f),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const f of this.j)(0,w.$2p)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const f of this.j)(0,w.$2p)(f)&&b.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(b,f){const p={path:this.H(b),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},c=(0,E.$Ub)(this.w,p);return this.C(),(0,S.$Qc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(b=>(0,r.$1)(b))}D(){return this.u||(this.u=this.B(this.F(b=>this.c.fire((0,w.$6p)(b)),b=>this.G(b),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.u.watch(this.w)}G(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}H(b){return(0,P.$hc)(b.fsPath)}}e.$0p=I}),define(be[111],ve([1,0,18,14,15,20,5,61,47,2,63,12,41,19,48,187,16,109,13,11]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;let h=class extends v.$Sc{static{$=this}constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new S.$Sd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new S.$Sd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new S.$Sd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new S.$Sd),this.onDidRunOperation=this.r.event,this.X=this.B(new S.$Sd),this.Y=this.B(new S.$Sd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new S.$Sd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$$g)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${i}`);const s=new v.$Rc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(t=>{const a=new m.$Ek(t,!this.S(o));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,v.$Qc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,v.$Nc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await R.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return w.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,f.$Hg)(i))throw new m.$Gk((0,c.localize)(0,null,this.sb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new l.$bb;throw s.message=(0,c.localize)(1,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,m.$rk)(o)||(0,m.$ok)(o)||(0,m.$sk)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,m.$rk)(o)||(0,m.$ok)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,m.$Bk)(s)===m.FileSystemProviderErrorCode.FileNotFound?new m.$Gk((0,c.localize)(2,null,this.sb(i)),1):(0,m.$zk)(s)}}async s(i,o){const s=await this.j(i),t=this.S(s),a=o?.resolveTo,g=o?.resolveSingleChildDescendants,L=o?.resolveMetadata,D=await s.stat(i);let y;return this.t(s,i,D,void 0,!!L,(A,F)=>(y||(y=I.$8h.forUris(()=>!t),y.set(i,!0),a&&y.fill(!0,a)),y.get(A.resource)||y.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&g?F===1:!1))}async t(i,o,s,t,a,g){const{providerExtUri:L}=this.R(i),D={resource:o,name:L.basename(o),isFile:(s.type&m.FileType.File)!==0,isDirectory:(s.type&m.FileType.Directory)!==0,isSymbolicLink:(s.type&m.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&m.FilePermission.Readonly)||!!(i.capabilities&2048),locked:!!((s.permissions??0)&m.FilePermission.Locked),etag:(0,m.$Rk)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&g(D,t)){try{const y=await i.readdir(o),A=await R.Promises.settled(y.map(async([F,X])=>{try{const te=L.joinPath(o,F),J=a?await i.stat(te):{type:X};return await this.t(i,te,J,y.length,a,g)}catch(te){return this.b.trace(te),null}}));D.children=(0,E.$Hb)(A)}catch(y){this.b.trace(y),D.children=[]}return D}return D}async resolveAll(i){return R.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new m.$Gk((0,c.localize)(3,null,this.sb(i)),3,o)}async createFile(i,o=r.$ge.fromString(""),s){await this.u(i,s);const t=await this.writeFile(i,o);return this.r.fire(new m.$Dk(i,0,t)),t}async writeFile(i,o,s){const t=this.qb(await this.n(i),i),{providerExtUri:a}=this.R(t);let g=s;if((0,m.$uk)(t)&&!g?.atomic){const L=t.enforceAtomicWriteFile?.(i);L&&(g={...s,atomic:L})}try{await this.w(t,i,g)||await this.U(t,a.dirname(i));let D;if((0,m.$ok)(t)&&!(o instanceof r.$ge))if((0,p.$5d)(o)){const y=await(0,p.$_d)(o,3);y.ended?D=r.$ge.concat(y.buffer):D=y}else D=(0,p.$9d)(o,y=>r.$ge.concat(y),3);else D=o;!(0,m.$rk)(t)||(0,m.$ok)(t)&&D instanceof r.$ge||(0,m.$ok)(t)&&(0,m.$uk)(t)&&g?.atomic?await this.hb(t,i,g,D):await this.db(t,i,g,D instanceof r.$ge?(0,r.$re)(D):D),this.r.fire(new m.$Dk(i,4))}catch(L){throw new m.$Gk((0,c.localize)(4,null,this.sb(i),(0,m.$zk)(L).toString()),(0,m.$Ck)(L),g)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const t=!!s?.unlock;if(t&&!(i.capabilities&8192))throw new Error((0,c.localize)(5,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&32768))throw new Error((0,c.localize)(6,null,this.sb(o)));if(!(i.capabilities&2))throw new Error((0,c.localize)(7,null,this.sb(o)));if(t)throw new Error((0,c.localize)(8,null,this.sb(o)))}let g;try{g=await i.stat(o)}catch{return}if(g.type&m.FileType.Directory)throw new m.$Gk((0,c.localize)(9,null,this.sb(o)),0,s);if(this.rb(o,g),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==m.$Qk&&typeof g.mtime=="number"&&typeof g.size=="number"&&s.mtime<g.mtime&&s.etag!==(0,m.$Rk)({mtime:s.mtime,size:g.size}))throw new m.$Gk((0,c.localize)(10,null),3,s);return g}async readFile(i,o,s){const t=await this.m(i);return o?.atomic?this.z(t,i,o,s):this.C(t,i,o,s)}async z(i,o,s,t){return new Promise((a,g)=>{this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{try{const L=await this.C(i,o,s,t);a(L)}catch(L){g(L)}})})}async C(i,o,s,t){const a=await this.D(i,o,{...s,preferUnbuffered:!0},t);return{...a,value:await(0,r.$se)(a.value)}}async readFileStream(i,o,s){const t=await this.m(i);return this.D(t,i,o,s)}async D(i,o,s,t){const a=new C.$3d(t);let g=s;(0,m.$tk)(i)&&i.enforceAtomicReadFile?.(o)&&(g={...s,atomic:!0});const L=this.J(o,g).then(y=>y,y=>{throw a.dispose(!0),y});let D;try{return typeof g?.etag=="string"&&g.etag!==m.$Qk&&await L,g?.atomic&&(0,m.$tk)(i)||!((0,m.$rk)(i)||(0,m.$sk)(i))||(0,m.$ok)(i)&&g?.preferUnbuffered?D=this.I(i,o,g):(0,m.$sk)(i)?D=this.G(i,o,a.token,g):D=this.H(i,o,a.token,g),D.on("end",()=>a.dispose()),D.on("error",()=>a.dispose()),{...await L,value:D}}catch(y){throw D&&await(0,p.$0d)(D),this.F(y,o,g)}}F(i,o,s){const t=(0,c.localize)(11,null,this.sb(o),(0,m.$zk)(i).toString());return i instanceof m.$Ik?new m.$Ik(t,i.stat,s):i instanceof m.$Hk?new m.$Hk(t,i.fileOperationResult,i.size,i.options):new m.$Gk(t,(0,m.$Ck)(i),s)}G(i,o,s,t=Object.create(null)){const a=i.readFileStream(o,t,s);return(0,p.$de)(a,{data:g=>g instanceof r.$ge?g:r.$ge.wrap(g),error:g=>this.F(g,o,t)},g=>r.$ge.concat(g))}H(i,o,s,t=Object.create(null)){const a=(0,r.$we)();return(0,u.$Zp)(i,o,a,g=>g,{...t,bufferSize:this.a,errorTransformer:g=>this.F(g,o,t)},s),a}I(i,o,s){const t=(0,p.$7d)(a=>r.$ge.concat(a));return(async()=>{try{let a;s?.atomic&&(0,m.$tk)(i)?a=await i.readFile(o,{atomic:!0}):a=await i.readFile(o),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.L(o,a.byteLength,s),t.end(r.$ge.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new m.$Gk((0,c.localize)(12,null,this.sb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==m.$Qk&&o.etag===s.etag)throw new m.$Ik((0,c.localize)(13,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new m.$Hk((0,c.localize)(14,null,this.sb(i)),7,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,t){if(i.toString()!==o.toString())try{const a=s==="move"?this.qb(await this.n(i),i):await this.m(i),g=this.qb(await this.n(o),o);await this.Q(a,i,g,o,s,t)}catch(a){return a}return!0}async move(i,o,s){const t=this.qb(await this.n(i),i),a=this.qb(await this.n(o),o),g=await this.N(t,i,a,o,"move",!!s),L=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$Dk(i,g==="move"?2:3,L)),L}async copy(i,o,s){const t=await this.m(i),a=this.qb(await this.n(o),o),g=await this.N(t,i,a,o,"copy",!!s),L=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new m.$Dk(i,g==="copy"?3:2,L)),L}async N(i,o,s,t,a,g){if(o.toString()===t.toString())return a;const{exists:L,isSameResourceWithDifferentPathCase:D}=await this.Q(i,o,s,t,a,g);if(L&&!D&&g&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),a==="copy"){if(i===s&&(0,m.$pk)(i))await i.copy(o,t,{overwrite:g});else{const y=await this.resolve(o);y.isDirectory?await this.P(i,y,s,t):await this.O(i,o,s,t)}return a}else return i===s?(await i.rename(o,t,{overwrite:g}),a):(await this.N(i,o,s,t,"copy",g),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,t){if((0,m.$rk)(i)&&(0,m.$rk)(s))return this.jb(i,o,s,t);if((0,m.$rk)(i)&&(0,m.$ok)(s))return this.pb(i,o,s,t);if((0,m.$ok)(i)&&(0,m.$rk)(s))return this.nb(i,o,s,t);if((0,m.$ok)(i)&&(0,m.$ok)(s))return this.lb(i,o,s,t)}async P(i,o,s,t){await s.mkdir(t),Array.isArray(o.children)&&await R.Promises.settled(o.children.map(async a=>{const g=this.R(s).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.P(i,await this.resolve(a.resource),s,g):this.O(i,a.resource,s,g)}))}async Q(i,o,s,t,a,g){let L=!1;if(i===s){const{providerExtUri:y,isPathCaseSensitive:A}=this.R(i);if(A||(L=y.isEqual(o,t)),L&&a==="copy")throw new Error((0,c.localize)(15,null,this.sb(o),this.sb(t)));if(!L&&y.isEqualOrParent(t,o))throw new Error((0,c.localize)(16,null,this.sb(o),this.sb(t)))}const D=await this.exists(t);if(D&&!L){if(!g)throw new m.$Gk((0,c.localize)(17,null,this.sb(o),this.sb(t)),4);if(i===s){const{providerExtUri:y}=this.R(i);if(y.isEqualOrParent(o,t))throw new Error((0,c.localize)(18,null,this.sb(o),this.sb(t)))}}return{exists:D,isSameResourceWithDifferentPathCase:L}}R(i){const o=this.S(i);return{providerExtUri:o?f.$tg:f.$vg,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new m.$Dk(i,0,s)),s}async U(i,o){const s=[],{providerExtUri:t}=this.R(i);for(;!t.isEqual(o,t.dirname(o));)try{if(!((await i.stat(o)).type&m.FileType.Directory))throw new Error((0,c.localize)(19,null,this.sb(o)));break}catch(a){if((0,m.$Bk)(a)!==m.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(t.basename(o)),o=t.dirname(o)}for(let a=s.length-1;a>=0;a--){o=t.joinPath(o,s[a]);try{await i.mkdir(o)}catch(g){if((0,m.$Bk)(g)!==m.FileSystemProviderErrorCode.FileExists)throw g}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),t=!!o?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,c.localize)(20,null,this.sb(i)));const a=o?.atomic;if(a&&!(s.capabilities&65536))throw new Error((0,c.localize)(21,null,this.sb(i)));if(t&&a)throw new Error((0,c.localize)(22,null,this.sb(i)));let g;try{g=await s.stat(i)}catch{}if(g)this.rb(i,g);else throw new m.$Gk((0,c.localize)(23,null,this.sb(i)),1);if(!!!o?.recursive){const D=await this.resolve(i);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,c.localize)(24,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let t=o;if((0,m.$vk)(s)&&!t?.atomic){const D=s.enforceAtomicDelete?.(i);D&&(t={...o,atomic:D})}const a=!!t?.useTrash,g=!!t?.recursive,L=t?.atomic??!1;await s.delete(i,{recursive:g,useTrash:a,atomic:L}),this.r.fire(new m.$Dk(i,1))}async cloneFile(i,o){const s=await this.j(i),t=this.qb(await this.n(o),o);if(s===t&&this.R(s).providerExtUri.isEqual(i,o))return;if(s===t&&(0,m.$qk)(s))return s.cloneFile(i,o);await this.U(t,this.R(t).providerExtUri.dirname(o));const a=this.cb.queueFor(i,this.R(s).providerExtUri);return s===t&&(0,m.$pk)(s)?a.queue(()=>s.copy(i,o,{overwrite:!0})):a.queue(()=>this.O(s,i,t,o))}static{this.ab=0}createWatcher(i,o){return this.watch(i,{...o,correlationId:$.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new v.$Rc;let t=!1,a=()=>{t=!0};s.add((0,v.$Qc)(()=>a())),(async()=>{try{const L=await this.bb(i,o);t?(0,v.$Nc)(L):a=()=>(0,v.$Nc)(L)}catch(L){this.b.error(L)}})();const g=o.correlationId;if(typeof g=="number"){const L=s.add(new S.$Sd);return s.add(this.X.event(y=>{y.correlates(g)&&L.fire(y)})),{onDidChange:L.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),t=(0,P.$Pi)([this.R(s).providerExtUri.getComparisonKey(i),o]);let a=this.$.get(t);return a||(a={count:0,disposable:s.watch(i,o)},this.$.set(t,a)),a.count+=1,(0,v.$Qc)(()=>{a&&(a.count--,a.count===0&&((0,v.$Nc)(a.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,v.$Nc)(i.disposable);this.$.clear()}async db(i,o,s,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{const a=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,p.$5d)(t)||(0,p.$6d)(t)?await this.eb(i,a,t):await this.fb(i,a,t)}catch(g){throw(0,m.$zk)(g)}finally{await i.close(a)}})}async eb(i,o,s){let t=0,a;if((0,p.$6d)(s)){if(s.buffer.length>0){const g=r.$ge.concat(s.buffer);await this.gb(i,o,g,g.byteLength,t,0),t+=g.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((g,L)=>{(0,p.$$d)(a,{onData:async D=>{a.pause();try{await this.gb(i,o,D,D.byteLength,t,0)}catch(y){return L(y)}t+=D.byteLength,setTimeout(()=>a.resume())},onError:D=>L(D),onEnd:()=>g()})})}async fb(i,o,s){let t=0,a;for(;(a=s.read())!==null;)await this.gb(i,o,a,a.byteLength,t,0),t+=a.byteLength}async gb(i,o,s,t,a,g){let L=0;for(;L<t;){const D=await i.write(o,a+L,s.buffer,g+L,t-L);L+=D}}async hb(i,o,s,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(()=>this.ib(i,o,s,t))}async ib(i,o,s,t){let a;t instanceof r.$ge?a=t:(0,p.$5d)(t)?a=await(0,r.$se)(t):(0,p.$6d)(t)?a=await(0,r.$te)(t):a=(0,r.$qe)(t),await i.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.kb(i,o,s,t))}async kb(i,o,s,t){let a,g;try{a=await i.open(o,{create:!1}),g=await s.open(t,{create:!0,unlock:!1});const L=r.$ge.alloc(this.a);let D=0,y=0,A=0;do A=await i.read(a,D,L.buffer,y,L.byteLength-y),await this.gb(s,g,L,A,D,y),D+=A,y+=A,y===L.byteLength&&(y=0);while(A>0)}catch(L){throw(0,m.$zk)(L)}finally{await R.Promises.settled([typeof a=="number"?i.close(a):Promise.resolve(),typeof g=="number"?s.close(g):Promise.resolve()])}}async lb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.mb(i,o,s,t))}async mb(i,o,s,t){return s.writeFile(t,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.ob(i,o,s,t))}async ob(i,o,s,t){const a=await s.open(t,{create:!0,unlock:!1});try{const g=await i.readFile(o);await this.gb(s,a,r.$ge.wrap(g),g.byteLength,0,0)}catch(g){throw(0,m.$zk)(g)}finally{await s.close(a)}}async pb(i,o,s,t){const a=await(0,r.$se)(this.H(i,o,C.CancellationToken.None));await this.hb(s,t,void 0,a)}qb(i,o){if(i.capabilities&2048)throw new m.$Gk((0,c.localize)(25,null,this.sb(o)),6);return i}rb(i,o){if((o.permissions??0)&m.FilePermission.Readonly)throw new m.$Gk((0,c.localize)(26,null,this.sb(i)),6)}sb(i){return i.scheme===k.Schemas.file?i.fsPath:i.toString(!0)}};e.$1p=h,e.$1p=h=$=Fe([Le(0,d.$jj)],h)}),define(be[69],ve([1,0,27,300,14,26,15,5,40,2,7,4,19,48,22,190,16,109,226,39,224,223]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0,(()=>{try{(0,R.gracefulify)(E)}catch(i){console.error(`Error enabling graceful-fs: ${(0,l.$Mi)(i)}`)}})();class n extends d.$0p{static{this.I=!1}constructor(o,s){super(o,s),this.onDidChangeCapabilities=P.Event.None,this.N=new C.$Ac(t=>b.$ug.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(o){try{const{stat:s,symbolicLink:t}=await p.SymlinkSupport.stat(this.H(o));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:m.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const s=await p.Promises.readdir(this.H(o),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async a=>{try{let g;a.isSymbolicLink()?g=(await this.stat((0,b.$Dg)(o,a.name))).type:g=this.M(a),t.push([a.name,g])}catch(g){this.a.trace(g)}})),t}catch(s){throw this.fb(s)}}M(o,s){let t;return s?.dangling?t=m.FileType.Unknown:o.isFile()?t=m.FileType.File:o.isDirectory()?t=m.FileType.Directory:t=m.FileType.Unknown,s&&(t|=m.FileType.SymbolicLink),t}async O(o){const s=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const a=new r.$1g;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,v.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(o,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),t=await this.O(o));const a=this.H(o);return await p.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{t?.dispose()}}P(o){n.I&&this.a.trace(o)}readFileStream(o,s,t){const a=(0,f.$7d)(g=>S.$ge.concat(g.map(L=>S.$ge.wrap(L))).buffer);return(0,u.$Zp)(this,o,a,g=>g.buffer,{...s,bufferSize:256*1024},t),a}async writeFile(o,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,b.$Dg)((0,b.$Cg)(o),`${(0,b.$Ag)(o)}${t.atomic.postfix}`),s,t):this.S(o,s,t)}async Q(o){try{const s=this.H(o),{symbolicLink:t}=await p.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(o,s,t,a){const g=new v.$Rc;try{g.add(await this.O(o)),g.add(await this.O(s)),await this.S(s,t,a,!0);try{await this.rename(s,o,{overwrite:!0})}catch(L){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw L}}finally{g.dispose()}}async S(o,s,t,a){let g;try{const L=this.H(o);if(!t.create||!t.overwrite){if(await p.Promises.exists(L)){if(!t.overwrite)throw(0,m.$yk)((0,c.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,m.$yk)((0,c.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(o,{create:!0,unlock:t.unlock},a),await this.write(g,0,s,0,s.byteLength)}catch(L){throw await this.gb(o,L)}finally{typeof g=="number"&&await this.close(g)}}static{this.Y=!0}static configureFlushOnWrite(o){n.Y=o}async open(o,s,t){const a=this.H(o);let g;(0,m.$mk)(s)&&!t&&(g=await this.O(o));let L;try{if((0,m.$mk)(s)&&s.unlock)try{const{stat:y}=await p.SymlinkSupport.stat(a);y.mode&128||await p.Promises.chmod(a,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let D;if((0,m.$mk)(s)){if(k.$i)try{await p.Promises.truncate(a,0),D="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}D||(D="w")}else D="r";L=await p.Promises.open(a,D)}catch(D){throw g?.dispose(),(0,m.$mk)(s)?await this.gb(o,D):this.fb(D)}if(this.U.set(L,0),(0,m.$mk)(s)&&this.X.set(L,o),g){const D=this.W.get(L);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${L} (${a})`),this.W.set(L,g),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${L} (${a})`),D.dispose())}return L}async close(o){const s=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&n.Y)try{await p.Promises.fdatasync(o)}catch(t){n.configureFlushOnWrite(!1),this.a.error(t)}return await p.Promises.close(o)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(o)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),s.dispose())}}async read(o,s,t,a,g){const L=this.Z(o,s);let D=null;try{D=(await p.Promises.read(o,t,a,g,L)).bytesRead}catch(y){throw this.fb(y)}finally{this.$(o,L,D)}return D}Z(o,s){return s===this.U.get(o)?null:s}$(o,s,t){const a=this.U.get(o);typeof a=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(o,a+t):this.U.delete(o)))}async write(o,s,t,a,g){return(0,r.$jh)(()=>this.ab(o,s,t,a,g),100,3)}async ab(o,s,t,a,g){const L=this.Z(o,s);let D=null;try{D=(await p.Promises.write(o,t,a,g,L)).bytesWritten}catch(y){throw await this.gb(this.X.get(o),y)}finally{this.$(o,L,D)}return D}async mkdir(o){try{await p.Promises.mkdir(this.H(o))}catch(s){throw this.fb(s)}}async delete(o,s){try{const t=this.H(o);if(s.recursive){let a;s?.atomic!==!1&&s.atomic.postfix&&(a=(0,I.$jc)((0,I.$mc)(t),`${(0,I.$nc)(t)}${s.atomic.postfix}`)),await p.Promises.rm(t,p.RimRafMode.MOVE,a)}else try{await p.Promises.unlink(t)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let g=!1;try{const{stat:L,symbolicLink:D}=await p.SymlinkSupport.stat(t);g=L.isDirectory()&&!D}catch{}if(g)await p.Promises.rmdir(t);else throw a}else throw a}}catch(t){throw this.fb(t)}}async rename(o,s,t){const a=this.H(o),g=this.H(s);if(a!==g)try{await this.bb(o,s,"move",t.overwrite),await p.Promises.rename(a,g)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,c.localize)(2,null,(0,I.$nc)(a),(0,I.$nc)((0,I.$mc)(g)),L.toString()))),this.fb(L)}}async copy(o,s,t){const a=this.H(o),g=this.H(s);if(a!==g)try{await this.bb(o,s,"copy",t.overwrite),await p.Promises.copy(a,g,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,c.localize)(3,null,(0,I.$nc)(a),(0,I.$nc)((0,I.$mc)(g)),L.toString()))),this.fb(L)}}async bb(o,s,t,a){const g=this.H(o),L=this.H(s);let D=!1;if(!!(this.capabilities&1024)||(D=(0,w.$3f)(g,L,!0)),D){if(t==="copy")throw(0,m.$yk)((0,c.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const A=await this.L(o);if(!A)throw(0,m.$yk)((0,c.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const F=await this.L(s);if(F){if(!a)throw(0,m.$yk)((0,c.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);A.type&m.FileType.File&&F.type&m.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,s){return this.cb(o,s,!1)}async cb(o,s,t){const a=this.H(o),g=this.H(s),L=!!(this.capabilities&1024);if((0,w.$3f)(a,g,!L))return;const D=new v.$Rc;try{D.add(await this.O(o)),D.add(await this.O(s)),t&&await p.Promises.mkdir((0,I.$mc)(g),{recursive:!0}),await p.Promises.copyFile(a,g)}catch(y){if(y.code==="ENOENT"&&!t)return this.cb(o,s,!0);throw this.fb(y)}finally{D.dispose()}}t(o,s,t){return new $.$eq(a=>o(a),a=>s(a),t)}F(o,s,t){return new h.$mq(a=>o(a),a=>s(a),t)}fb(o){if(o instanceof m.$xk)return o;let s=o,t;switch(o.code){case"ENOENT":t=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=m.FileSystemProviderErrorCode.Unknown;break;default:t=m.FileSystemProviderErrorCode.Unknown}return(0,m.$yk)(s,t)}async gb(o,s){let t=this.fb(s);if(o&&t.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await p.SymlinkSupport.stat(this.H(o));a.mode&128||(t=(0,m.$yk)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return t}}e.$nq=n}),define(be[227],ve([1,0,5,69,2,15,48,20]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=void 0;class w extends r.$Sc{constructor(k,b){super(),this.a=k,this.b=b,this.F=new Map,this.G=new Map}call(k,b,f){const p=this.c(k);switch(b){case"stat":return this.g(p,f[0]);case"readdir":return this.h(p,f[0]);case"open":return this.r(p,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(p,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(p,f[0],f[1],f[2]);case"rename":return this.z(p,f[0],f[1],f[2]);case"copy":return this.C(p,f[0],f[1],f[2]);case"cloneFile":return this.D(p,f[0],f[1]);case"mkdir":return this.w(p,f[0]);case"delete":return this.y(p,f[0],f[1]);case"watch":return this.I(p,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${b} not found`)}listen(k,b,f){const p=this.c(k);switch(b){case"fileChange":return this.H(p,f[0]);case"readFileStream":return this.m(p,f[0],f[1])}throw new Error(`Unknown event ${b}`)}g(k,b){const f=this.f(k,b,!0);return this.a.stat(f)}h(k,b){const f=this.f(k,b);return this.a.readdir(f)}async j(k,b,f){const p=this.f(k,b,!0),c=await this.a.readFile(p,f);return C.$ge.wrap(c)}m(k,b,f){const p=this.f(k,b,!0),c=new P.$3d,m=new E.$Sd({onDidRemoveLastListener:()=>{c.cancel()}}),u=this.a.readFileStream(p,f,c.token);return(0,S.$$d)(u,{onData:d=>m.fire(C.$ge.wrap(d)),onError:d=>m.fire(d),onEnd:()=>{m.fire("end"),m.dispose(),c.dispose()}}),m.event}n(k,b,f,p){const c=this.f(k,b);return this.a.writeFile(c,f.buffer,p)}r(k,b,f){const p=this.f(k,b,!0);return this.a.open(p,f)}s(k){return this.a.close(k)}async t(k,b,f){const p=C.$ge.alloc(f),c=0,m=await this.a.read(k,b,p.buffer,c,f);return[p,m]}u(k,b,f,p,c){return this.a.write(k,b,f.buffer,p,c)}w(k,b){const f=this.f(k,b);return this.a.mkdir(f)}y(k,b,f){const p=this.f(k,b);return this.a.delete(p,f)}z(k,b,f,p){const c=this.f(k,b),m=this.f(k,f);return this.a.rename(c,m,p)}C(k,b,f,p){const c=this.f(k,b),m=this.f(k,f);return this.a.copy(c,m,p)}D(k,b,f){const p=this.f(k,b),c=this.f(k,f);return this.a.cloneFile(p,c)}H(k,b){const f=new E.$Sd({onWillAddFirstListener:()=>{this.F.set(b,this.L(k,f))},onDidRemoveLastListener:()=>{(0,r.$Nc)(this.F.get(b)),this.F.delete(b)}});return f.event}async I(k,b,f,p,c){const m=this.F.get(b);if(m){const u=this.f(k,p),d=m.watch(f,u,c);this.G.set(b+f,d)}}async J(k,b){const f=k+b,p=this.G.get(f);p&&((0,r.$Nc)(p),this.G.delete(f))}dispose(){super.dispose();for(const[,k]of this.G)k.dispose();this.G.clear();for(const[,k]of this.F)k.dispose();this.F.clear()}}e.$Vr=w;class v extends r.$Sc{constructor(k,b,f,p){super(),this.c=k,this.f=f,this.g=p,this.a=new Map,this.b=this.B(new R.$nq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(b)}h(k){const b=this.B(new E.$Sd);this.B(b.event(f=>{k.fire(f.map(p=>({resource:this.c.transformOutgoingURI(p.resource),type:p.type,cId:p.cId})))})),this.B(this.b.onDidChangeFile(f=>b.fire(f))),this.B(this.b.onDidWatchError(f=>k.fire(f)))}j(k){}m(k){}watch(k,b,f){const p=this.m(this.g);return Array.isArray(p)&&(f.excludes=[...f.excludes,...p]),this.a.set(k,this.b.watch(b,f)),(0,r.$Qc)(()=>{(0,r.$Nc)(this.a.get(k)),this.a.delete(k)})}dispose(){for(const[,k]of this.a)k.dispose();this.a.clear(),super.dispose()}}e.$Wr=v}),define(be[112],ve([1,0,3,5,13,2]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=void 0;class S extends r.$uj{constructor(k,b,f,p,c){super(b,f,p),this.r=k,this.t=c,this.B(c.listen("onDidChangeLogLevel",k)(m=>{(0,r.$lj)(m)?super.setLogLevel(m):super.setLogLevel(E.URI.revive(m[0]),m[1])})),this.B(c.listen("onDidChangeVisibility",k)(([m,u])=>super.setVisibility(E.URI.revive(m),u))),this.B(c.listen("onDidChangeLoggers",k)(({added:m,removed:u})=>{for(const d of m)super.registerLogger({...d,resource:E.URI.revive(d.resource)});for(const d of u)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new r.$sj({log:(k,b)=>{this.t.call("consoleLog",[k,b])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,b){super.setLogLevel(k,b),this.t.call("setLogLevel",[k,b])}setVisibility(k,b){super.setVisibility(k,b),this.t.call("setVisibility",[this.n(k),b])}s(k,b,f){return new P(this.t,k,b,f,this.r)}static setLogLevel(k,b,f){return k.call("setLogLevel",[b,f])}}e.$lr=S;class P extends r.$pj{constructor(k,b,f,p,c){super(p?.logLevel==="always"),this.r=k,this.s=b,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[b,p,c]).then(()=>{this.u(this.n),this.m=!0})}g(k,b){const f=[[k,b]];this.m?this.u(f):this.n.push(...f)}u(k){this.r.call("log",[this.s,k])}}class w{constructor(k,b){this.a=k,this.b=b}listen(k,b){const f=this.b(k);switch(b){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(c=>this.c(c,f)),removed:[...p.removed].map(c=>this.c(c,f))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,p=>[f.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,p=>(0,r.$lj)(p)?p:[f.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${b}`)}async call(k,b,f){const p=this.b(k);switch(b){case"setLogLevel":return(0,r.$lj)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(E.URI.revive(p.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(c=>this.c(c,p)))}throw new Error(`Call not found: ${b}`)}c(k,b){return{...k,resource:b.transformOutgoingURI(k.resource)}}}e.$mr=w;class v extends C.$Sc{constructor(k,b){super(),b.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(f=>b.call("setLogLevel",[f]))),b.call("getRegisteredLoggers").then(f=>{for(const p of f)k.registerLogger({...p,resource:E.URI.revive(p.resource)})}),this.B(b.listen("onDidChangeVisibility")(([f,p])=>k.setVisibility(E.URI.revive(f),p))),this.B(b.listen("onDidChangeLoggers")(({added:f,removed:p})=>{for(const c of f)k.registerLogger({...c,resource:E.URI.revive(c.resource)});for(const c of p)k.deregisterLogger(c.resource)}))}}e.$nr=v}),define(be[113],ve([1,0,2,13]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=void 0;class r extends E.$Sc{constructor(S,P=[]){super(),this.a=new R.$tj([S,...P]),this.B(S.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...P){this.a.trace(S,...P)}debug(S,...P){this.a.debug(S,...P)}info(S,...P){this.a.info(S,...P)}warn(S,...P){this.a.warn(S,...P)}error(S,...P){this.a.error(S,...P)}flush(){this.a.flush()}}e.$bO=r}),define(be[228],ve([1,0,16,13]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;var r;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(r||(r={}));async function C(v,I,k,b,f){try{const p=await new Promise((m,u)=>{ue(["@vscode/spdlog"],m,u)});p.setFlushOn(r.Trace);const c=await p.createAsyncRotatingLogger(v,I,k,b);return f?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(p){console.error(p)}return null}function S(v,I,k){switch(I){case R.LogLevel.Trace:v.trace(k);break;case R.LogLevel.Debug:v.debug(k);break;case R.LogLevel.Info:v.info(k);break;case R.LogLevel.Warning:v.warn(k);break;case R.LogLevel.Error:v.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function P(v,I){switch(I){case R.LogLevel.Trace:v.setLevel(r.Trace);break;case R.LogLevel.Debug:v.setLevel(r.Debug);break;case R.LogLevel.Info:v.setLevel(r.Info);break;case R.LogLevel.Warning:v.setLevel(r.Warning);break;case R.LogLevel.Error:v.setLevel(r.Error);break;case R.LogLevel.Off:v.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class w extends R.$pj{constructor(I,k,b,f,p){super(),this.m=[],this.setLevel(p),this.n=this.s(I,k,b,f),this.B(this.onDidChangeLogLevel(c=>{this.r&&P(this.r,c)}))}async s(I,k,b,f){const p=b?6:1,c=30/p*E.$Tk.MB,m=await C(I,k,c,p,f);if(m){this.r=m,P(this.r,this.getLevel());for(const{level:u,message:d}of this.m)S(this.r,u,d);this.m=[]}}g(I,k){this.r?S(this.r,I,k):this.getLevel()<=I&&this.m.push({level:I,message:k})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3N=w}),define(be[114],ve([1,0,21,13,228]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=void 0;class C extends R.$uj{s(P,w,v){return new r.$3N((0,E.$mg)(),P.fsPath,!v?.donotRotate,!!v?.donotUseFormatters,w)}}e.$4N=C}),define(be[229],ve([1,0,62,192,6]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(C||(e.MarkerTag=C={}));var S;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(S||(e.MarkerSeverity=S={})),function(w){function v(p,c){return c-p}w.compare=v;const I=Object.create(null);I[w.Error]=(0,R.localize)(0,null),I[w.Warning]=(0,R.localize)(1,null),I[w.Info]=(0,R.localize)(2,null);function k(p){return I[p]||""}w.toString=k;function b(p){switch(p){case E.default.Error:return w.Error;case E.default.Warning:return w.Warning;case E.default.Info:return w.Info;case E.default.Ignore:return w.Hint}}w.fromSeverity=b;function f(p){switch(p){case w.Error:return E.default.Error;case w.Warning:return E.default.Warning;case w.Info:return E.default.Info;case w.Hint:return E.default.Ignore}}w.toSeverity=f}(S||(e.MarkerSeverity=S={}));var P;(function(w){const v="";function I(b){return k(b,!0)}w.makeKey=I;function k(b,f){const p=[v];return b.source?p.push(b.source.replace("\xA6","\\\xA6")):p.push(v),b.code?typeof b.code=="string"?p.push(b.code.replace("\xA6","\\\xA6")):p.push(b.code.value.replace("\xA6","\\\xA6")):p.push(v),b.severity!==void 0&&b.severity!==null?p.push(S.toString(b.severity)):p.push(v),b.message&&f?p.push(b.message.replace("\xA6","\\\xA6")):p.push(v),b.startLineNumber!==void 0&&b.startLineNumber!==null?p.push(b.startLineNumber.toString()):p.push(v),b.startColumn!==void 0&&b.startColumn!==null?p.push(b.startColumn.toString()):p.push(v),b.endLineNumber!==void 0&&b.endLineNumber!==null?p.push(b.endLineNumber.toString()):p.push(v),b.endColumn!==void 0&&b.endColumn!==null?p.push(b.endColumn.toString()):p.push(v),p.push(v),p.join("\xA6")}w.makeKeyOptionalMessage=k})(P||(e.IMarkerData=P={})),e.$mt=(0,r.$2h)("markerService")}),define(be[70],ve([1,0,5,47,2,6]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0,e.$vn=(0,C.$2h)("policy");class S extends r.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$Sd),this.onDidChange=this.h.event}async updatePolicyDefinitions(v){const I=Object.keys(this.f).length;return this.f={...v,...this.f},I!==Object.keys(this.f).length&&await this.j(v),R.Iterable.reduce(this.g.entries(),(k,[b,f])=>({...k,[b]:f}),{})}getPolicyValue(v){return this.g.get(v)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(v,[I,k])=>({...v,[I]:{definition:k,value:this.g.get(I)}}),{})}}e.$wn=S;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$xn=P}),define(be[55],ve([1,0,29]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.context<"u"){const C=r.context.configuration();if(C)R=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,E.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const C=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:C.version})}}else R={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","registerIssueDataProvider","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","readonlyMessage","treeViewMarkdownMessage","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatVariables","chatAgents2","chatAgents2Additions","defaultChatAgent","readonlyMessage","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","scmInputBoxValueProvider","contribSourceControlInputBoxMenu"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.85.0",sha256:"85a97d373a6f92359f5db7bfc5a2fa6c5763b22c6ad07c962dfe32c84a079f3b",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.85.2",commit:"8b3775030ed1a69b13e4f4c628c612102e30a681",date:"2024-01-18T05:57:14.040Z"},Object.keys(R).length===0&&Object.assign(R,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(be[31],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,E.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"}),define(be[37],ve([1,0,96,10]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0;class r{constructor(){this.a=new Map}add(S,P){E.ok(R.$Ef(S)),E.ok(R.$Gf(P)),E.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,P)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.$tn=new r}),define(be[230],ve([1,0,5,37]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un={JSONContribution:"base.contributions.json"};function r(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class C{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,v){this.a[r(w)]=v,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const S=new C;R.$tn.add(e.$un.JSONContribution,S)}),define(be[56],ve([1,0,18,5,10,174,24,230,37]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.ConfigurationScope=e.$yn=e.EditPresentationTypes=void 0;var v;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.$yn={Configuration:"base.contributions.configuration"};var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn="vscode://schemas/settings/resourceLanguage",e.$Gn="vscode://schemas/settings/configurationDefaults";const k=w.$tn.as(P.$un.JSONContribution);class b{constructor(){this.h=new Set,this.i=new R.$Sd,this.onDidSchemaChange=this.i.event,this.j=new R.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Fn,this.g),this.v()}registerConfiguration(n,i=!0){this.registerConfigurations([n],i)}registerConfigurations(n,i=!0){const o=new Set;this.n(n,i,o),k.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(n){const i=new Set;this.o(n,i),k.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:n,remove:i}){const o=new Set;this.o(i,o),this.n(n,!1,o),k.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(n){const i=new Set;this.k(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(n,i){const o=[];for(const{overrides:s,source:t}of n)for(const a in s)if(i.add(a),e.$In.test(a)){const g=this.a.get(a),L=g?.valuesSources??new Map;if(t)for(const F of Object.keys(s[a]))L.set(F,t);const D={...g?.value||{},...s[a]};this.a.set(a,{source:t,value:D,valuesSources:L});const y=(0,S.$Fi)(a),A={type:"object",default:D,description:C.localize(1,null,y),$ref:e.$Fn,defaultDefaultValue:D,source:r.$Ef(t)?void 0:t,defaultValueSource:t};o.push(...c(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:s[a],source:t});const g=this.d[a];g&&(this.w(a,g),this.r(a,g))}this.m(o)}deregisterDefaultConfigurations(n){const i=new Set;this.l(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(n,i){for(const{overrides:o,source:s}of n)for(const t in o){const a=this.a.get(t),g=r.$Ef(s)?s:s?.id,L=r.$Ef(a?.source)?a?.source:a?.source?.id;if(g===L)if(i.add(t),this.a.delete(t),e.$In.test(t))delete this.d[t],delete this.b.properties[t];else{const D=this.d[t];D&&(this.w(t,D),this.r(t,D))}}this.u()}deltaConfiguration(n){let i=!1;const o=new Set;n.removedDefaults&&(this.l(n.removedDefaults,o),i=!0),n.addedDefaults&&(this.k(n.addedDefaults,o),i=!0),n.removedConfigurations&&this.o(n.removedConfigurations,o),n.addedConfigurations&&this.n(n.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const i of n)this.h.add(i);this.u()}n(n,i,o){n.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,o),this.c.push(s),this.q(s)})}o(n,i){const o=s=>{if(s.properties)for(const t in s.properties){i.add(t);const a=this.d[t];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>o(t))};for(const s of n){o(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(n,i=!0,o,s,t=3,a){t=r.$Nf(n.scope)?t:n.scope;const g=n.properties;if(g)for(const D in g){const y=g[D];if(i&&l(D,y)){delete g[D];continue}if(y.source=o,y.defaultDefaultValue=g[D].default,this.w(D,y),e.$In.test(D)?y.scope=void 0:(y.scope=r.$Nf(y.scope)?t:y.scope,y.restricted=r.$Nf(y.restricted)?!!s?.includes(D):y.restricted),g[D].hasOwnProperty("included")&&!g[D].included){this.f[D]=g[D],delete g[D];continue}else this.d[D]=g[D],g[D].policy?.name&&this.e.set(g[D].policy.name,D);!g[D].deprecationMessage&&g[D].markdownDeprecationMessage&&(g[D].deprecationMessage=g[D].markdownDeprecationMessage),a.add(D)}const L=n.allOf;if(L)for(const D of L)this.p(D,i,o,s,t,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const i=o=>{const s=o.properties;if(s)for(const a in s)this.r(a,s[a]);o.allOf?.forEach(i)};i(n)}r(n,i){switch(e.$zn.properties[n]=i,i.scope){case 1:e.$An.properties[n]=i;break;case 2:e.$Bn.properties[n]=i;break;case 6:e.$Cn.properties[n]=i;break;case 3:e.$Dn.properties[n]=i;break;case 4:e.$En.properties[n]=i;break;case 5:e.$En.properties[n]=i,this.g.properties[n]=i;break}}s(n,i){switch(delete e.$zn.properties[n],i.scope){case 1:delete e.$An.properties[n];break;case 2:delete e.$Bn.properties[n];break;case 6:delete e.$Cn.properties[n];break;case 3:delete e.$Dn.properties[n];break;case 4:case 5:delete e.$En.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const i=`[${n}]`,o={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.$Fn};this.w(i,o),e.$zn.properties[i]=o,e.$An.properties[i]=o,e.$Bn.properties[i]=o,e.$Cn.properties[i]=o,e.$Dn.properties[i]=o,e.$En.properties[i]=o}}v(){const n={type:"object",description:C.localize(4,null),errorMessage:C.localize(5,null),$ref:e.$Fn};e.$zn.patternProperties[e.$Hn]=n,e.$An.patternProperties[e.$Hn]=n,e.$Bn.patternProperties[e.$Hn]=n,e.$Cn.patternProperties[e.$Hn]=n,e.$Dn.patternProperties[e.$Hn]=n,e.$En.patternProperties[e.$Hn]=n,this.i.fire()}w(n,i){const o=this.a.get(n);let s=o?.value,t=o?.source;r.$Lf(s)&&(s=i.defaultDefaultValue,t=void 0),r.$Lf(s)&&(s=u(i.type)),i.default=s,i.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",p=new RegExp(f,"g");e.$Hn=`^(${f})+$`,e.$In=new RegExp(e.$Hn);function c(h){const n=[];if(e.$In.test(h)){let i=p.exec(h);for(;i?.length;){const o=i[1].trim();o&&n.push(o),i=p.exec(h)}}return(0,E.$Mb)(n)}e.$Jn=c;function m(h){return h.reduce((n,i)=>`${n}[${i}]`,"")}e.$Kn=m;function u(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Ln=u;const d=new b;w.$tn.add(e.$yn.Configuration,d);function l(h,n){return h.trim()?e.$In.test(h)?C.localize(7,null,h):d.getConfigurationProperties()[h]!==void 0?C.localize(8,null,h):n.policy?.name&&d.getPolicyConfigurations().get(n.policy?.name)!==void 0?C.localize(9,null,h,n.policy?.name,d.getPolicyConfigurations().get(n.policy?.name)):null:C.localize(6,null)}e.$Mn=l;function $(){const h=[],n=d.getConfigurationProperties();for(const i of Object.keys(n))h.push([i,n[i].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Nn=$}),define(be[115],ve([1,0,18,5,76,2,26,23,10,3,24,56,37]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0;function f(i){return Object.isFrozen(i)?i:P.$in(i)}class p{constructor(o={},s=[],t=[],a){this.b=o,this.c=s,this.d=t,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(s=>{if(s instanceof p)return s;const t=new c("");return t.parseRaw(s),t.configurationModel});this.f=o.reduce((s,t)=>t===s?t:s.merge(t),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,I.$Di)(this.contents,o):this.contents}inspect(o,s){const t=this.rawConfiguration.getValue(o),a=s?this.rawConfiguration.getOverrideValue(o,s):void 0,g=s?this.rawConfiguration.override(s).getValue(o):t;return{value:t,override:a,merged:g}}getOverrideValue(o,s){const t=this.i(s);return t?o?(0,I.$Di)(t,o):t:void 0}getKeysForOverrideIdentifier(o){const s=[];for(const t of this.overrides)t.identifiers.includes(o)&&s.push(...t.keys);return E.$Mb(s)}getAllOverrideIdentifiers(){const o=[];for(const s of this.overrides)o.push(...s.identifiers);return E.$Mb(o)}override(o){let s=this.a.get(o);return s||(s=this.g(o),this.a.set(o,s)),s}merge(...o){const s=P.$hn(this.contents),t=P.$hn(this.overrides),a=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const L of o)if(g.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(s,L.contents);for(const D of L.overrides){const[y]=t.filter(A=>E.$ub(A.identifiers,D.identifiers));y?(this.h(y.contents,D.contents),y.keys.push(...D.keys),y.keys=E.$Mb(y.keys)):t.push(P.$hn(D))}for(const D of L.keys)a.indexOf(D)===-1&&a.push(D)}return new p(s,a,t,g.every(L=>L instanceof p)?void 0:g)}g(o){const s=this.i(o);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const a of E.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let g=this.contents[a];const L=s[a];L&&(typeof g=="object"&&typeof L=="object"?(g=P.$hn(g),this.h(g,L)):g=L),t[a]=g}return new p(t,this.keys,this.overrides)}h(o,s){for(const t of Object.keys(s)){if(t in o&&w.$Gf(o[t])&&w.$Gf(s[t])){this.h(o[t],s[t]);continue}o[t]=P.$hn(s[t])}}i(o){let s=null,t=null;const a=g=>{g&&(t?this.h(t,g):t=P.$hn(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===o?s=g.contents:g.identifiers.includes(o)&&a(g.contents);return a(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,s){this.j(o,s,!0)}setValue(o,s){this.j(o,s,!1)}removeValue(o){const s=this.keys.indexOf(o);s!==-1&&(this.keys.splice(s,1),(0,I.$Ci)(this.contents,o),k.$In.test(o)&&this.overrides.splice(this.overrides.findIndex(t=>E.$ub(t.identifiers,(0,k.$Jn)(o))),1))}j(o,s,t){(0,I.$Bi)(this.contents,o,s,a=>console.error(a)),t=t||this.keys.indexOf(o)===-1,t&&this.keys.push(o),k.$In.test(o)&&this.overrides.push({identifiers:(0,k.$Jn)(o),keys:Object.keys(this.contents[o]),contents:(0,I.$Ai)(this.contents[o],a=>console.error(a))})}}e.$On=p;class c{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,s){if(!w.$Nf(o)){const t=this.g(o);this.parseRaw(t,s)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,s){this.a=o;const{contents:t,keys:a,overrides:g,restricted:L,hasExcludedProperties:D}=this.h(o,s);this.b=new p(t,a,g,D?[o]:void 0),this.c=L||[]}g(o){let s={},t=null,a=[];const g=[],L=[];function D(A){Array.isArray(a)?a.push(A):t!==null&&(a[t]=A)}const y={onObjectBegin:()=>{const A={};D(A),g.push(a),a=A,t=null},onObjectProperty:A=>{t=A},onObjectEnd:()=>{a=g.pop()},onArrayBegin:()=>{const A=[];D(A),g.push(a),a=A,t=null},onArrayEnd:()=>{a=g.pop()},onLiteralValue:D,onError:(A,F,X)=>{L.push({error:A,offset:F,length:X})}};if(o)try{r.$en(o,y),s=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return s}h(o,s){const t=b.$tn.as(k.$yn.Configuration).getConfigurationProperties(),a=this.i(o,t,!0,s);o=a.raw;const g=(0,I.$Ai)(o,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(o),D=this.j(o,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:g,keys:L,overrides:D,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,s,t,a){let g=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:g};const L={},D=[];for(const y in o)if(k.$In.test(y)&&t){const A=this.i(o[y],s,!1,a);L[y]=A.raw,g=g||A.hasExcludedProperties,D.push(...A.restricted)}else{const A=s[y],F=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&D.push(y),!a.exclude?.includes(y)&&(a.include?.includes(y)||(F===void 0||a.scopes===void 0||a.scopes.includes(F))&&!(a.skipRestricted&&A?.restricted))?L[y]=o[y]:g=!0}return{raw:L,restricted:D,hasExcludedProperties:g}}j(o,s){const t=[];for(const a of Object.keys(o))if(k.$In.test(a)){const g={};for(const L in o[a])g[L]=o[a][L];t.push({identifiers:(0,k.$Jn)(a),keys:Object.keys(g),contents:(0,I.$Ai)(g,s)})}return t}}e.$Pn=c;class m extends C.$Sc{constructor(o,s,t,a){super(),this.c=o,this.f=s,this.g=a,this.b=this.B(new R.$Sd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&t.isEqual(g.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qn=m;class u{constructor(o,s,t,a,g,L,D,y,A,F,X,te,J){this.a=o,this.b=s,this.c=t,this.overrideIdentifiers=a,this.d=g,this.f=L,this.g=D,this.h=y,this.i=A,this.j=F,this.k=X,this.l=te,this.m=J}get value(){return f(this.c)}n(o,s,t){const a=o.inspect(s,t);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(o,s,t,a,g=new p,L=new p,D=new S.$Ac,y=new p,A=new S.$Ac){this.c=o,this.d=s,this.f=t,this.g=a,this.h=g,this.i=L,this.j=D,this.l=y,this.m=A,this.a=null,this.b=new S.$Ac,this.n=null}getValue(o,s,t){return this.p(o,s,t).getValue(o)}updateValue(o,s,t={}){let a;t.resource?(a=this.m.get(t.resource),a||(a=new p,this.m.set(t.resource,a))):a=this.l,s===void 0?a.removeValue(o):a.setValue(o,s),t.resource||(this.a=null)}inspect(o,s,t){const a=this.p(o,s,t),g=this.t(s.resource,t),L=s.resource?this.m.get(s.resource)||this.l:this.l,D=new Set;for(const y of a.overrides)for(const A of y.identifiers)a.getOverrideValue(o,A)!==void 0&&D.add(A);return new u(o,s,a.getValue(o),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,g||void 0,L)}keys(o){const s=this.t(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,s){this.j.set(o,s),this.b.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,s){const t=[];if(!s){const{added:a,updated:g,removed:L}=h(this.c,o);s=[...a,...g,...L]}for(const a of s)for(const g of(0,k.$Jn)(a)){const L=this.c.getKeysForOverrideIdentifier(g),D=o.getKeysForOverrideIdentifier(g),y=[...D.filter(A=>L.indexOf(A)===-1),...L.filter(A=>D.indexOf(A)===-1),...L.filter(A=>!P.$ln(this.c.override(g).getValue(A),o.override(g).getValue(A)))];t.push([g,y])}return this.updateDefaultConfiguration(o),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(o){const{added:s,updated:t,removed:a}=h(this.d,o),g=[...s,...t,...a];return g.length&&this.updatePolicyConfiguration(o),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:s,updated:t,removed:a,overrides:g}=h(this.applicationConfiguration,o),L=[...s,...t,...a];return L.length&&this.updateApplicationConfiguration(o),{keys:L,overrides:g}}compareAndUpdateLocalUserConfiguration(o){const{added:s,updated:t,removed:a,overrides:g}=h(this.localUserConfiguration,o),L=[...s,...t,...a];return L.length&&this.updateLocalUserConfiguration(o),{keys:L,overrides:g}}compareAndUpdateRemoteUserConfiguration(o){const{added:s,updated:t,removed:a,overrides:g}=h(this.remoteUserConfiguration,o),L=[...s,...t,...a];return L.length&&this.updateRemoteUserConfiguration(o),{keys:L,overrides:g}}compareAndUpdateWorkspaceConfiguration(o){const{added:s,updated:t,removed:a,overrides:g}=h(this.workspaceConfiguration,o),L=[...s,...t,...a];return L.length&&this.updateWorkspaceConfiguration(o),{keys:L,overrides:g}}compareAndUpdateFolderConfiguration(o,s){const t=this.folderConfigurations.get(o),{added:a,updated:g,removed:L,overrides:D}=h(t,s),y=[...a,...g,...L];return(y.length||!t)&&this.updateFolderConfiguration(o,s),{keys:y,overrides:D}}compareAndDeleteFolderConfiguration(o){const s=this.folderConfigurations.get(o);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:t,updated:a,removed:g,overrides:L}=h(s,void 0);return{keys:[...t,...a,...g],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(o,s,t){let a=this.q(s,t);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}q({resource:o},s){let t=this.r();if(s&&o){const a=s.getFolder(o);a&&(t=this.s(a.uri)||t);const g=this.m.get(o);g&&(t=t.merge(g))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(o){let s=this.b.get(o);if(!s){const t=this.r(),a=this.j.get(o);a?(s=t.merge(a),this.b.set(o,s)):s=t}return s}t(o,s){if(s&&o){const t=s.getFolder(o);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,s)=>{const{contents:t,overrides:a,keys:g}=this.j.get(s);return o.push([s,{contents:t,overrides:a,keys:g}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(s=>o.add(s)),this.userConfiguration.keys.forEach(s=>o.add(s)),this.i.keys.forEach(s=>o.add(s)),this.j.forEach(s=>s.keys.forEach(t=>o.add(t))),[...o.values()]}u(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>o.add(t))),[...o.values()]}v(o){const s=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(o).forEach(a=>s.add(a))),[...s.values()]}static parse(o){const s=this.w(o.defaults),t=this.w(o.policy),a=this.w(o.application),g=this.w(o.user),L=this.w(o.workspace),D=o.folders.reduce((y,A)=>(y.set(v.URI.revive(A[0]),this.w(A[1])),y),new S.$Ac);return new d(s,t,a,g,new p,L,D,new p,new S.$Ac)}static w(o){return new p(o.contents,o.keys,o.overrides)}}e.$Rn=d;function l(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const o=new Set,s=new Map;for(const a of i)a.keys.forEach(g=>o.add(g)),a.overrides.forEach(([g,L])=>{const D=(0,S.$xc)(s,g,new Set);L.forEach(y=>D.add(y))});const t=[];return s.forEach((a,g)=>t.push([g,[...a.values()]])),{keys:[...o.values()],overrides:t}}e.$Sn=l;class ${constructor(o,s,t,a){this.change=o,this.f=s,this.g=t,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const g of o.keys)this.affectedKeys.add(g);for(const[,g]of o.overrides)for(const L of g)this.affectedKeys.add(L);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(o,s){const t=this.a+o,a=this.d.indexOf(t);if(a<0)return!1;const g=a+t.length;if(g>=this.d.length)return!1;const L=this.d.charCodeAt(g);if(L!==this.b&&L!==this.c)return!1;if(s){const D=this.previousConfiguration?this.previousConfiguration.getValue(o,s,this.f?.workspace):void 0,y=this.g.getValue(o,s,this.h);return!P.$ln(D,y)}return!0}}e.$Tn=$;function h(i,o){const{added:s,removed:t,updated:a}=n(o?.rawConfiguration,i?.rawConfiguration),g=[],L=i?.getAllOverrideIdentifiers()||[],D=o?.getAllOverrideIdentifiers()||[];if(o){const y=D.filter(A=>!L.includes(A));for(const A of y)g.push([A,o.getKeysForOverrideIdentifier(A)])}if(i){const y=L.filter(A=>!D.includes(A));for(const A of y)g.push([A,i.getKeysForOverrideIdentifier(A)])}if(o&&i){for(const y of L)if(D.includes(y)){const A=n({contents:i.getOverrideValue(void 0,y)||{},keys:i.getKeysForOverrideIdentifier(y)},{contents:o.getOverrideValue(void 0,y)||{},keys:o.getKeysForOverrideIdentifier(y)});g.push([y,[...A.added,...A.removed,...A.updated]])}}return{added:s,removed:t,updated:a,overrides:g}}function n(i,o){const s=i?o?i.keys.filter(g=>o.keys.indexOf(g)===-1):[...i.keys]:[],t=o?i?o.keys.filter(g=>i.keys.indexOf(g)===-1):[...o.keys]:[],a=[];if(i&&o){for(const g of o.keys)if(i.keys.indexOf(g)!==-1){const L=(0,I.$Di)(o.contents,g),D=(0,I.$Di)(i.contents,g);P.$ln(L,D)||a.push(g)}}return{added:s,removed:t,updated:a}}}),define(be[231],ve([1,0,18,5,2,23,10,115,56,13,70,37]),function(ue,e,E,R,r,C,S,P,w,v,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=void 0;class b extends r.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$On}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$tn.as(w.$yn.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:u})=>this.c(Array.from(m),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,u){this.h(m,k.$tn.as(w.$yn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new P.$On;const m=k.$tn.as(w.$yn.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,u){const d=this.f();for(const l of m){const $=d[l],h=u[l];$!==void 0?this.b.addValue(l,$):h?this.b.addValue(l,h.default):this.b.removeValue(l)}}}e.$Un=b;class f{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new P.$On}async initialize(){return this.configurationModel}}e.$Vn=f;let p=class extends r.$Sc{get configurationModel(){return this.b}constructor(m,u,d){super(),this.c=m,this.f=u,this.g=d,this.a=this.B(new R.$Sd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$On}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const u={},d=[],l=k.$tn.as(w.$yn.Configuration).getConfigurationProperties();for(const $ of m){const h=l[$];if(!h){d.push($);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}d.push($),u[h.policy.name]={type:h.type}}}return(0,S.$Rf)(u)||await this.f.updatePolicyDefinitions(u),d}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const u=k.$tn.as(w.$yn.Configuration).getPolicyConfigurations(),d=(0,E.$Hb)(m.map(l=>u.get(l)));this.m(d,!0)}m(m,u){this.g.trace("PolicyConfiguration#update",m);const d=k.$tn.as(w.$yn.Configuration).getConfigurationProperties(),l=[],$=this.b.isEmpty();for(const h of m){const n=d[h]?.policy?.name;if(n){const i=this.f.getPolicyValue(n);($?i!==void 0:!(0,C.$ln)(this.b.getValue(h),i))&&l.push([h,i])}else this.b.getValue(h)!==void 0&&l.push([h,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const h=this.b;this.b=new P.$On;for(const n of h.keys)this.b.setValue(n,h.getValue(n));for(const[n,i]of l)i===void 0?this.b.removeValue(n):this.b.setValue(n,i);u&&this.a.fire(this.b)}}};e.$Wn=p,e.$Wn=p=Fe([Le(1,I.$vn),Le(2,v.$jj)],p)}),define(be[116],ve([1,0,14,5,2,19,24,115,231,70]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class I extends r.$Sc{constructor(b,f,p,c){super(),this.j=b,this.h=this.B(new R.$Sd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$Un),this.c=p instanceof v.$xn?new w.$Vn:this.B(new w.$Wn(this.b,p,c)),this.f=this.B(new P.$Qn(this.j,{},C.$ug,f)),this.a=new P.$Rn(this.b.configurationModel,this.c.configurationModel,new P.$On,new P.$On),this.g=this.B(new E.$bh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:m,properties:u})=>this.n(m,u))),this.B(this.c.onDidChangeConfiguration(m=>this.r(m))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,f,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.$Rn(b,f,new P.$On,p)}getConfigurationData(){return this.a.toData()}getValue(b,f){const p=typeof b=="string"?b:void 0,c=(0,S.$wi)(b)?b:(0,S.$wi)(f)?f:{};return this.a.getValue(p,c,void 0)}updateValue(b,f,p,c){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.m(b)}m(b){const f=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(b);this.s(p,f,2)}n(b,f){const p=this.a.toData(),c=this.a.compareAndUpdateDefaultConfiguration(b,f);this.s(c,p,7)}r(b){const f=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(b);this.s(p,f,7)}s(b,f,p){const c=new P.$Tn(b,{data:f},this.a);c.source=p,c.sourceConfig=this.t(p),this.h.fire(c)}t(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Xn=I}),define(be[117],ve([1,0,11,6]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,R.$2h)("remoteAuthorityResolverService");var r;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class C{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=C;class S{constructor(k,b){this.host=k,this.port=b,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=S;var P;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class w extends E.$bb{static isNotAvailable(k){return k instanceof w&&k._code===P.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof w&&k._code===P.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof w&&k._code===P.NoResolverFound}static isInvalidAuthority(k){return k instanceof w&&k._code===P.InvalidAuthority}static isHandled(k){return k instanceof w&&k.isHandled}constructor(k,b=P.Unknown,f){super(k),this._message=k,this._code=b,this._detail=f,this.isHandled=b===P.NotAvailable&&f===!0,Object.setPrototypeOf(this,w.prototype)}}e.$6k=w;function v(I){const k=I.indexOf("+");return k===-1?I:I.substring(0,k)}e.$7k=v}),define(be[232],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=e.$dO=void 0,e.$dO=(0,E.$2h)("IRemoteExtensionsScannerService"),e.$eO="remoteExtensionsScanner"}),define(be[57],ve([1,0,12]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function R(v){return v.scheme===E.Schemas.vscodeRemote?v.authority:void 0}e.$8k=R;function r(v){if(!v)return;const I=v.indexOf("+");return I<0?v:v.substr(0,I)}e.$9k=r;function C(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.$0k=C;function S(v){const{host:I,port:k}=w(v);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:k}}e.$$k=S;function P(v,I){let{host:k,port:b}=w(v);return typeof b>"u"&&(b=I),{host:k,port:b}}e.$_k=P;function w(v){const I=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const k=v.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const b=v.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:v,port:void 0}}}),define(be[35],ve([1,0,17,6,57]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.TargetPlatform=e.ExtensionType=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am="extensions.user.cache",e.$bm="extensions.builtin.cache",e.$cm="undefined_publisher",e.$dm=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$em=C,e.$fm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(S||(e.ExtensionType=S={}));var P;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class w{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,u){if(typeof m>"u"||m===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof m=="string"||typeof u=="string"){const d=typeof m=="string"?m:m.value,l=typeof u=="string"?u:u.value;return E.$8e(d,l)}return m._lower===u._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$gm=w;class v{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const u of m)this.add(u)}add(m){this.c.add(w.toKey(m))}delete(m){return this.c.delete(w.toKey(m))}has(m){return this.c.has(w.toKey(m))}}e.$hm=v;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(w.toKey(m))}get(m){return this.c.get(w.toKey(m))}has(m){return this.c.has(w.toKey(m))}set(m,u){this.c.set(w.toKey(m),u)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$im=I;function k(c){return b(c)}e.$jm=k;function b(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$km=b;function f(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$lm=f;function p(c,m){if(m){const u=`onResolveRemoteAuthority:${(0,r.$9k)(m)}`;return!!c.activationEvents?.includes(u)}return!1}e.$mm=p,e.$nm=(0,R.$2h)("IBuiltinExtensionsScannerService")}),define(be[233],ve([1,0,11,35]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2E=e.$1E=void 0;class r{constructor(){this.a=new Map,this.b=new WeakMap}register(S,P){this.a.set(S,P)}readActivationEvents(S){return this.b.has(S)||this.b.set(S,this.c(S)),this.b.get(S)}createActivationEventsMap(S){const P=Object.create(null);for(const w of S){const v=this.readActivationEvents(w);v.length>0&&(P[R.$gm.toKey(w.identifier)]=v)}return P}c(S){if(typeof S.main>"u"&&typeof S.browser>"u")return[];const P=Array.isArray(S.activationEvents)?S.activationEvents.slice(0):[];for(let w=0;w<P.length;w++)P[w]==="onUri"&&(P[w]=`onUri:${R.$gm.toKey(S.identifier)}`);if(!S.contributes)return P;for(const w in S.contributes){const v=this.a.get(w);if(!v)continue;const I=S.contributes[w],k=Array.isArray(I)?I:[I];try{v(k,P)}catch(b){(0,E.$1)(b)}}return P}}e.$1E=r,e.$2E=new r}),define(be[234],ve([1,0,2,35,16]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class C extends E.$Sc{constructor(P,w,v,I,k){super(),this.a=P,this.b=w,this.c=v,this.f=k,this.B(I.onDidInstallExtensions(b=>this.g(b))),this.B(I.onDidUninstallExtension(b=>this.h(b)))}g(P){for(const w of P)w.local&&this.invalidate(w.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,P)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,R.$am))}catch(w){(0,r.$Ck)(w)!==1&&this.f.error(w)}}}e.$Tp=C}),define(be[44],ve([1,0,15,11,2,193,56,6,13,37]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0,e.$6o=(0,P.$2h)("requestService");class I{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?h[n]="*****":h[n]=this.b[n];this.a=h}return this.a}}class k extends r.$Sc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,C.localize)(0,null),when:w.$Aj.isEqualTo((0,w.$yj)(w.LogLevel.Trace)).serialize()})}async c(h,n,i){const o=`${h} #${++this.b}: ${n.url}`;this.a.trace(`${o} - begin`,n.type,new I(n.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,n.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,n.type,(0,R.$0)(s)),s}}}e.$7o=k;function b($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$8o=b;function f($){return $.res.statusCode===204}e.$9o=f;async function p($){return f($)?null:(await(0,E.$se)($.stream)).toString()}e.$0o=p;async function c($){if(!b($))throw new Error("Server returned "+$.res.statusCode);return p($)}e.$$o=c;async function m($){if(!b($))throw new Error("Server returned "+$.res.statusCode);if(f($))return null;const n=(await(0,E.$se)($.stream)).toString();try{return JSON.parse(n)}catch(i){throw i.message+=`:
`+n,i}}e.$_o=m;function u($){l($)}e.$ap=u;let d;function l($){const h=v.$tn.as(S.$yn.Configuration),n=d;d={id:"http",order:15,title:(0,C.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,C.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(6,null),(0,C.localize)(7,null),(0,C.localize)(8,null),(0,C.localize)(9,null)],default:"override",description:(0,C.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,C.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[d],remove:n?[n]:[]})}l(1)}),define(be[235],ve([1,0,20,12,16,44]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0;let S=class{constructor(w,v){this.a=w,this.b=v}async download(w,v,I=E.CancellationToken.None){if(w.scheme===R.Schemas.file||w.scheme===R.Schemas.vscodeRemote){await this.b.copy(w,v);return}const k={type:"GET",url:w.toString(!0)},b=await this.a.request(k,I);if(b.res.statusCode===200)await this.b.writeFile(v,b.stream);else{const f=await(0,C.$$o)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${f}`)}}};e.$qO=S,e.$qO=S=Fe([Le(0,C.$6o),Le(1,r.$lk)],S)}),define(be[236],ve([1,0,15,20]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=void 0;class r{constructor(P){this.a=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,v,I=R.CancellationToken.None){switch(w){case"request":return this.a.request(v[0],I).then(async({res:k,stream:b})=>{const f=await(0,E.$se)(b);return[{statusCode:k.statusCode,headers:k.headers},f]});case"resolveProxy":return this.a.resolveProxy(v[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$9q=r;class C{constructor(P){this.a=P}async request(P,w){const[v,I]=await this.a.call("request",[P],w);return{res:v,stream:(0,E.$ue)(I)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$0q=C}),define(be[237],ve([1,0,87,10]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;function r(S,P){return S.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:S.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function C(S,P,w={}){const v=(0,E.parse)(S),I=w.proxyUrl||r(v,P);if(!I)return null;const k=(0,E.parse)(I);if(!/^https?:$/.test(k.protocol||""))return null;const b={host:k.hostname||"",port:(k.port?+k.port:0)||(k.protocol==="https"?443:80),auth:k.auth,rejectUnauthorized:(0,R.$Kf)(w.strictSSL)?w.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((f,p)=>{ue(["http-proxy-agent"],f,p)})).HttpProxyAgent(I,b):new(await new Promise((f,p)=>{ue(["https-proxy-agent"],f,p)})).HttpsProxyAgent(I,b)}e.$$q=C}),define(be[88],ve([1,0,52,7,194,20,39,11,4,21,105,211,14,145]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=void 0;let p;async function c(u,d,l,$){return l["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$i?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$1l)($)&&!l["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$1l)($)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=b.Promises.withAsyncBody(async(h,n)=>{const i=new C.$3d;let o=1e4;const s=u.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,f.$2l)(s,1,120)*1e3);const t=setTimeout(()=>{i.dispose(!0),n(new Error((0,r.localize)(0,null)))},o);try{h(await m(d,i.token))}catch(a){!(0,P.$4)(a)&&!i.token.isCancellationRequested?n(new Error((0,r.localize)(1,null,(0,S.$Mi)(a)))):h({})}finally{clearTimeout(t),i.dispose()}})),p)}e.$7l=c;async function m(u,d){const l=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",l);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",$);const h=(0,v.$mg)().replace(/-/g,"").substr(0,12),n=new RegExp(h+"({.*})"+h),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",i);const o=await(0,I.$Ql)(w.OS,i);return u.trace("getUnixShellEnvironment#shell",o),new Promise((s,t)=>{if(d.isCancellationRequested)return t(new P.$5);const a=(0,R.$nc)(o);let g,L;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(g=`& '${process.execPath}' ${D} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,L=["-Login","-Command"]):a==="nu"?(g=`^'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,L=["-i","-l","-c"]):(g=`'${process.execPath}' ${D} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,a==="tcsh"||a==="csh"?L=["-ic"]:L=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),g);const y=(0,E.spawn)(o,[...L,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});d.onCancellationRequested(()=>(y.kill(),t(new P.$5))),y.on("error",X=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,S.$Mi)(X)),t(X)});const A=[];y.stdout.on("data",X=>A.push(X));const F=[];y.stderr.on("data",X=>F.push(X)),y.on("close",(X,te)=>{const J=Buffer.concat(A).toString("utf8");u.trace("getUnixShellEnvironment#raw",J);const ie=Buffer.concat(F).toString("utf8");if(ie.trim()&&u.trace("getUnixShellEnvironment#stderr",ie),X||te)return t(new Error((0,r.localize)(2,null,X,te)));const ee=n.exec(J),U=ee?ee[1]:"{}";try{const he=JSON.parse(U);l?he.ELECTRON_RUN_AS_NODE=l:delete he.ELECTRON_RUN_AS_NODE,$?he.ELECTRON_NO_ATTACH_CONSOLE=$:delete he.ELECTRON_NO_ATTACH_CONSOLE,delete he.VSCODE_RESOLVING_ENVIRONMENT,delete he.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",he),s(he)}catch(he){u.error("getUnixShellEnvironment#errorCaught",(0,S.$Mi)(he)),t(he)}})})}}),define(be[238],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=e.$5N=void 0,e.$5N=(0,E.$2h)("stateReadService"),e.$6N=(0,E.$2h)("stateService")}),define(be[239],ve([1,0,14,15,2,10,25,16,13]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=e.$8N=e.$7N=e.SaveStrategy=void 0;var v;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(v||(e.SaveStrategy=v={}));class I extends r.$Sc{constructor(p,c,m,u){super(),this.h=p,this.j=c,this.m=m,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new E.$Zg(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.m.error(p)}}getItem(p,c){const m=this.a[p];return(0,C.$Nf)(m)?c:m}setItem(p,c){this.setItems([{key:p,data:c}])}setItems(p){let c=!1;for(const{key:m,data:u}of p)this.a[m]!==u&&((0,C.$Nf)(u)?(0,C.$Lf)(this.a[m])||(this.a[m]=void 0,c=!0):(this.a[m]=u,c=!0));c&&this.s()}removeItem(p){(0,C.$Lf)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,R.$ge.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(c){this.m.error(c)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$7N=I;let k=class extends r.$Sc{constructor(p,c,m,u){super(),this.a=this.B(new I(c.stateResource,p,m,u))}async init(){await this.a.init()}getItem(p,c){return this.a.getItem(p,c)}};e.$8N=k,e.$8N=k=Fe([Le(1,S.$9h),Le(2,w.$jj),Le(3,P.$lk)],k);class b extends k{setItem(p,c){this.a.setItem(p,c)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$9N=b}),define(be[118],ve([1,0,4,29,21]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;function C(w){if(E.$u===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function S(w,v,I,k,b,f,p,c,m){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=p,u.sessionID=(0,r.$mg)()+Date.now(),u.commitHash=k,u.version=b,u["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,E.$h)(E.$u),u["common.nodePlatform"]=R.$dc,u["common.nodeArch"]=I,u["common.product"]=m||"desktop",c&&(u["common.msftInternal"]=c);let d=0;const l=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),E.$l&&(u["common.snap"]="true");const $=C(v);return $&&(u["common.platformDetail"]=$),u}e.$uo=S;function P(w){const v=R.env.USERDNSDOMAIN;if(!v)return!1;const I=v.toLowerCase();return w.some(k=>I===k)}e.$vo=P}),define(be[240],ve([1,0,18,11,2,23,16]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(v){function I(k,b){return k.callstack<b.callstack?-1:k.callstack>b.callstack?1:0}v.compare=I})(P||(e.ErrorEvent=P={}));class w{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(I,k=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$Rc,this.c=I,this.d=k;const b=R.$X.addListener(f=>this.j(f));this.h.add((0,r.$Qc)(b)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(I){if(!I||I.code||(I.detail&&I.detail.stack&&(I=I.detail),R.$bb.isErrorNoTelemetry(I)||I instanceof S.$Gk||typeof I?.message=="string"&&I.message.includes("Unable to read file")))return;const k=Array.isArray(I.stack)?I.stack.join(`
`):I.stack,b=I.message?I.message:(0,C.$mn)(I);k&&this.k({msg:b,callstack:k})}k(I){const k=(0,E.$wb)(this.g,I,P.compare);k<0?(I.count=1,this.g.splice(~k,0,I)):(this.g[k].count||(this.g[k].count=0),this.g[k].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const I of this.g)this.c.publicLogError2("UnhandledError",I);this.g.length=0}}e.default=w}),define(be[241],ve([1,0,2]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class R extends E.$Sc{constructor(C,S){super(),this.a=C,this.b=S}async call(C,S,P){switch(S){case"updateTelemetryLevel":{const{telemetryLevel:w}=P;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:v}=P;return this.b?this.b.log(w,v):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${S} not found`)}listen(C,S,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$2r=R}),define(be[32],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,E.$2h)("telemetryService"),e.$ql=(0,E.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var R;(function(C){C[C.NONE=0]="NONE",C[C.CRASH=1]="CRASH",C[C.ERROR=2]="ERROR",C[C.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var r;(function(C){C.OFF="off",C.CRASH="crash",C.ERROR="error",C.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(be[242],ve([1,0,28,14,76,12,7,4,3,101,22,104,218,16,31,32]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=void 0;const m=new Map;async function u(n,i){const o=`${n}::${i.join(":")}`,s=m.get(o);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,g=new Map,L=2e4;function D(A,F,X,te){const J=F.substring(A.length+1);return R.Promises.withAsyncBody(async ie=>{let ee;try{ee=await I.Promises.readdir(F,{withFileTypes:!0})}catch{ie();return}if(te.count>=L){te.count+=ee.length,te.maxReached=!0,ie();return}let U=ee.length;if(U===0){ie();return}let he=ee;te.count+ee.length>L&&(te.maxReached=!0,U=L-te.count,he=ee.slice(0,U)),te.count+=ee.length;for(const Q of he)if(Q.isDirectory()){if(X.includes(Q.name)||await D(A,(0,S.$jc)(F,Q.name),X,te),--U===0){ie();return}}else{const _=Q.name.lastIndexOf(".");if(_>=0){const V=Q.name.substring(_+1);V&&a.set(V,(a.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(J)!==!1&&V.filePattern.test(Q.name)&&g.set(V.tag,(g.get(V.tag)??0)+1);if(--U===0){ie();return}}})}const y=R.Promises.withAsyncBody(async A=>{const F={count:0,maxReached:!1};await D(n,n,i,F);const X=await $(n);A({configFiles:d(g),fileTypes:d(a),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:X})});return m.set(o,y),y}e.$Qr=u;function d(n){return Array.from(n.entries(),([i,o])=>({name:i,count:o})).sort((i,o)=>o.count-i.count)}function l(){const n={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.$Tk.GB).toFixed(2)}GB (${(E.freemem()/f.$Tk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.$5m.value()*100)}%`},i=E.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.$Rr=l;async function $(n){try{const i=new Map,o=(0,S.$jc)(n,".vscode","launch.json"),s=await I.Promises.readFile(o),t=[],a=(0,r.$0m)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${o}`),[];if((0,r.$gn)(a)==="object"&&a.configurations)for(const g of a.configurations){const L=g.type;L&&(i.has(L)?i.set(L,i.get(L)+1):i.set(L,1))}return d(i)}catch{return[]}}e.$Sr=$;let h=class{constructor(i,o){this.c=i,this.d=o}f(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}g(i){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const s=E.cpus();return s&&s.length>0&&o.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),o.push(`Memory (System):  ${(E.totalmem()/f.$Tk.GB).toFixed(2)}GB (${(E.freemem()/f.$Tk.GB).toFixed(2)}GB free)`),P.$i||o.push(`Load (avg):       ${E.loadavg().map(t=>Math.round(t)).join(", ")}`),o.push(`VM:               ${Math.round(v.$5m.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,k.$Pr)(i.mainPID),this.k(i)]).then(async s=>{let[t,a]=s,g=this.m(i,t);return o.forEach(L=>{if((0,b.$Em)(L))g+=`
${L.errorMessage}`,a+=`
${L.errorMessage}`;else if(g+=`

Remote: ${L.hostName}`,L.processes&&(g+=`
${this.m(i,L.processes)}`),L.workspaceMetadata){a+=`
|  Remote: ${L.hostName}`;for(const D of Object.keys(L.workspaceMetadata)){const y=L.workspaceMetadata[D];let A=`${y.fileCount} files`;y.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${D}): ${A}`,a+=this.h(y)}}}),{processInfo:g,workspaceInfo:a}})}async getSystemInfo(i,o){const{memory:s,vmHint:t,os:a,cpus:g}=l(),L={os:a,memory:s,cpus:g,vmHint:t,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return P.$i||(L.load=`${E.loadavg().map(D=>Math.round(D)).join(", ")}`),P.$k&&(L.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(L)}async getDiagnostics(i,o){const s=[];return(0,k.$Pr)(i.mainPID).then(async t=>(s.push(""),s.push(this.g(i)),s.push(""),s.push(this.m(i,t)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(i))),o.forEach(a=>{if((0,b.$Em)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.f(a.machineInfo)),a.processes&&s.push(this.m(i,a.processes)),a.workspaceMetadata)for(const g of Object.keys(a.workspaceMetadata)){const L=a.workspaceMetadata[g];let D=`${L.fileCount} files`;L.maxFilesReached&&(D=`more than ${D}`),s.push(`Folder (${g}): ${D}`),s.push(this.h(L))}}),s.push(""),s.push(""),s.join(`
`)))}h(i){const o=[];let t=0;const a=(y,A)=>{const F=` ${y}(${A})`;t+F.length>60?(o.push(g),g="|                 ",t=g.length):t+=F.length,g+=F};let g="|      File types:";const L=10,D=i.fileTypes.length>L?L:i.fileTypes.length;for(let y=0;y<D;y++){const A=i.fileTypes[y];a(A.name,A.count)}if(o.push(g),i.configFiles.length>=0&&(g="|      Conf files:",t=0,i.configFiles.forEach(y=>{a(y.name,y.count)}),o.push(g)),i.launchConfigFiles.length>0){let y="|      Launch Configs:";i.launchConfigFiles.forEach(A=>{const F=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;y+=F}),o.push(y)}return o.join(`
`)}j(i){const o=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(o-s.length)}  ${i[s]}`).join(`
                  `)}k(i){const o=[],s=[];return i.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(o.push(`|  Window (${t.title})`),t.folderURIs.forEach(a=>{const g=w.URI.revive(a);if(g.scheme===C.Schemas.file){const L=g.fsPath;s.push(u(L,["node_modules",".git"]).then(D=>{let y=`${D.fileCount} files`;D.maxFilesReached&&(y=`more than ${y}`),o.push(`|    Folder (${(0,S.$nc)(L)}): ${y}`),o.push(this.h(D))}).catch(D=>{o.push(`|      Error: Unable to collect workspace stats for folder ${L} (${D.toString()})`)}))}else o.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>o.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(i,o){const s=new Map;i.windows.forEach(a=>s.set(a.pid,`window [${a.id}] (${a.title})`)),i.pidToNames.forEach(({pid:a,name:g})=>s.set(a,g));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),o&&this.n(i.mainPID,s,t,o,0),t.join(`
`)}n(i,o,s,t,a){const g=a===0;let L;g?L=t.pid===i?`${this.d.applicationName} main`:"remote agent":o.has(t.pid)?L=o.get(t.pid):L=`${"  ".repeat(a)} ${t.name}`;const D=process.platform==="win32"?t.mem:E.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(D/f.$Tk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${L}`),Array.isArray(t.children)&&t.children.forEach(y=>this.n(i,o,s,y,a+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:s}of i.folders){const t=w.URI.revive(s);if(t.scheme!==C.Schemas.file)continue;const a=t.fsPath;try{(await u(a,["node_modules",".git"])).fileTypes.forEach(L=>o.add(L.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const s=w.URI.revive(o);if(s.scheme!==C.Schemas.file)continue;const t=s.fsPath;try{const a=await u(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(g=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),a.launchConfigFiles.forEach(g=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),a.configFiles.forEach(g=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};e.$Tr=h,e.$Tr=h=Fe([Le(0,c.$pl),Le(1,p.$Bj)],h)}),define(be[38],ve([1,0,23,10,5,24,57,118,32]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;class v{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$wo=v;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xo=I,e.$yo=new I;class k{async publicLog(t,a,g){}async publicLogError(t,a,g){}}e.$zo=k,e.$Ao="telemetry",e.$Bo="extensionTelemetryLog",e.$Co={log:()=>null,flush:()=>Promise.resolve(null)};function b(s,t){return r.Event.debounce(t.onDidChangeConfiguration,(g,L)=>{const D=g?new Set([...g.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:D}},1e3,!0)(g=>{g.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,C.$yi)(g.source),configurationKeys:Array.from(g.affectedKeys)})})}e.$Do=b;function f(s,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!s.enableTelemetry)}e.$Eo=f;function p(s,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$Fo=p;function c(s){const t=s.getValue(w.$xl),a=s.getValue(w.$yl);if(s.getValue(w.$zl)===!1||a===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Go=c;function m(s){const t={},a={},g={};l(s,g);for(let L in g){L=L.length>150?L.substr(L.length-149):L;const D=g[L];typeof D=="number"?a[L]=D:typeof D=="boolean"?a[L]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${D.length}`),t[L]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(t[L]=D)}return{properties:t,measurements:a}}e.$Ho=m;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(s){if(!s)return"none";const t=(0,S.$9k)(s);return u.has(t)?t:"other"}e.$Io=d;function l(s,t,a=0,g){if(s)for(const L of Object.getOwnPropertyNames(s)){const D=s[L],y=g?g+L:L;Array.isArray(D)?t[y]=(0,E.$mn)(D):D instanceof Date?t[y]=D.toISOString():(0,R.$Gf)(D)?a<2?l(D,t,a+1,y+"."):t[y]=(0,E.$mn)(D):t[y]=D}}function $(s,t){const a=s.msftInternalDomains||[],g=t.getValue("telemetry.internalTesting");return(0,P.$vo)(a)||g}e.$Jo=$;function h(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$Ko=h;function n(s,t){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let a=s;const g=[];for(const A of t)for(;;){const F=A.exec(s);if(!F)break;g.push([F.index,A.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(a="";;){const A=D.exec(s);if(!A)break;const F=g.some(([X,te])=>A.index<te&&X<D.lastIndex);!L.test(A[0])&&!F&&(a+=s.substring(y,A.index)+"<REDACTED: user-file-path>",y=D.lastIndex)}return y<s.length&&(a+=s.substr(y)),a}function i(s){if(!s)return s;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(s))return`<REDACTED: ${a.label}>`;return s}function o(s,t){return(0,E.$jn)(s,a=>{if(a instanceof v||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let g=a.replaceAll("%20"," ");g=n(g,t);for(const L of t)g=g.replace(L,"");return g=i(g),g}})}e.$Lo=o}),define(be[36],ve([1,0,17,30,35,4,3,11,29,38]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;function I(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,E.$3e)(o.id,s.id)===0}e.$Mo=I;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(s){const t=s.manifest?s.manifest.version:s.version,a=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new b(s.identifier,t,a)}static parse(s){const t=k.exec(s);return t&&t[1]&&t[2]?new b({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,a="undefined"){this.version=t,this.targetPlatform=a,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof b?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$No=b;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(o){const s=f.exec(o);return s&&s[1]?[m(s[1]),s[2]]:[m(o),void 0]}e.$Oo=p;function c(o,s){return`${o}.${s}`}e.$Po=c;function m(o){return o.toLowerCase()}e.$Qo=m;function u(o,s){return m(c(o??r.$cm,s))}e.$Ro=u;function d(o,s){const t=[],a=g=>{for(const L of t)if(L.some(D=>I(s(D),s(g))))return L;return null};for(const g of o){const L=a(g);L?L.push(g):t.push([g])}return t}e.$So=d;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$To=l;function $(o){return{id:new v.$wo(o.identifier.id),name:new v.$wo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Uo=$,e.$Vo=new r.$gm("pprice.better-merge");function h(o,s){const t=[],a=s.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const g=a.shift();if(g&&t.every(L=>!I(L.identifier,{id:g}))){const L=o.filter(D=>I(D.identifier,{id:g}));L.length===1&&(t.push(L[0]),a.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Wo=h;async function n(o,s){if(!C.$k)return!1;let t;try{t=(await o.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await o.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){s.debug("Error while getting the os-release file.",(0,P.$0)(g))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const t=await n(o,s),a=(0,R.$go)(t?"alpine":C.$u,w.$ec);return s.debug("ComputeTargetPlatform:",a),a}e.$Xo=i}),define(be[119],ve([1,0,20,11,12,19,53,3,181,30,36,35]),function(ue,e,E,R,r,C,S,P,w,v,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;const b=m=>(0,w.localize)(0,null,m),f=(0,w.localize)(1,null,"ms-dotnettools.csharp");function p(m,u){return u?`${m.publisher}.${m.name}@${m.version}`:`${m.publisher}.${m.name}`}let c=class{constructor(u,d,l){this.a=u,this.b=d,this.d=l}get f(){}async listExtensions(u,d,l){let $=await this.b.getInstalled(1,l);const h=k.$fm.map(i=>i.toLowerCase());if(d&&d!==""){if(h.indexOf(d.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(d.toLowerCase())>-1:!1)}else if(d===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,w.localize)(2,null,this.f)),$=$.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let n;for(const i of $)n!==i.identifier.id&&(n=i.identifier.id,this.a.info(p(i.manifest,u)))}async installExtensions(u,d,l,$){const h=[];try{const n=[];u.length&&this.a.info(this.f?(0,w.localize)(3,null,this.f):(0,w.localize)(4,null));const i=[];let o=[];const s=(a,g,L)=>{o.push({id:a,version:g!=="prerelease"?g:void 0,installOptions:{...l,isBuiltin:L,installPreReleaseVersion:g==="prerelease"||l.installPreReleaseVersion}})};for(const a of u)if(a instanceof P.URI)i.push({vsix:a,installOptions:l});else{const[g,L]=(0,I.$Oo)(a);s(g,L,!1)}for(const a of d)if(a instanceof P.URI)i.push({vsix:a,installOptions:{...l,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[g,L]=(0,I.$Oo)(a);s(g,L,!0)}const t=await this.b.getInstalled(1,l.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:a,installOptions:g})=>{try{const L=await this.g(a,g,$,t);L&&n.push(L)}catch(L){this.a.error(L),h.push(a.toString())}})),o.length&&(o=o.filter(({id:a,version:g})=>{const L=t.find(D=>(0,I.$Mo)(D.identifier,{id:a}));if(L){if(!$&&(!g||g==="prerelease"&&L.preRelease))return this.a.info((0,w.localize)(5,null,a,L.manifest.version,a)),!1;if(g&&L.manifest.version===g)return this.a.info((0,w.localize)(6,null,`${a}@${g}`)),!1}return!0}),o.length)){const a=await this.h(o);await Promise.all(o.map(async g=>{const L=a.get(g.id.toLowerCase());if(L)try{const D=await this.j(g,L,t);D&&n.push(D)}catch(D){this.a.error(D.message||D.stack||D),h.push(g.id)}else this.a.error(`${b(g.version?`${g.id}@${g.version}`:g.id)}
${f}`),h.push(g.id)}))}}catch(n){throw this.a.error((0,w.localize)(7,null,(0,R.$0)(n))),n}if(h.length)throw new Error((0,w.localize)(8,null,h.join(", ")))}async g(u,d,l,$){const h=await this.b.getManifest(u);if(!h)throw new Error("Invalid vsix");if(await this.l(h,l,d.profileLocation,$))try{return await this.b.install(u,d),this.a.info((0,w.localize)(9,null,(0,C.$Ag)(u))),h}catch(i){if((0,R.$4)(i))return this.a.info((0,w.localize)(10,null,(0,C.$Ag)(u))),null;throw i}return null}async h(u){const d=new Map,l=u.some(n=>n.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),h=[];for(const n of u)v.$_n.test(n.id)&&h.push({...n,preRelease:l});if(h.length){const n=await this.d.getExtensions(h,{targetPlatform:$},E.CancellationToken.None);for(const i of n)d.set(i.identifier.id.toLowerCase(),i)}return d}async j({id:u,version:d,installOptions:l},$,h){const n=await this.d.getManifest($,E.CancellationToken.None);if(n&&!this.k(n))return null;const i=h.find(o=>(0,I.$Mo)(o.identifier,$.identifier));if(i){if($.version===i.manifest.version)return this.a.info((0,w.localize)(11,null,d?`${u}@${d}`:u)),null;this.a.info((0,w.localize)(12,null,u,$.version))}try{l.isBuiltin?this.a.info(d?(0,w.localize)(13,null,u,d):(0,w.localize)(14,null,u)):this.a.info(d?(0,w.localize)(15,null,u,d):(0,w.localize)(16,null,u));const o=await this.b.installFromGallery($,{...l,installGivenVersion:!!d});return this.a.info((0,w.localize)(17,null,u,o.manifest.version)),n}catch(o){if((0,R.$4)(o))return this.a.info((0,w.localize)(18,null,u)),null;throw o}}k(u){return!0}async l(u,d,l,$){if(!d){const h={id:(0,I.$Ro)(u.publisher,u.name)},n=$.find(i=>(0,I.$Mo)(h,i.identifier)&&(0,S.gt)(i.manifest.version,u.version));if(n)return this.a.info((0,w.localize)(19,null,n.identifier.id,n.manifest.version,u.version)),!1}return this.k(u)}async uninstallExtensions(u,d,l){const $=async n=>{if(n instanceof P.URI){const i=await this.b.getManifest(n);return p(i)}return n},h=[];for(const n of u){const i=await $(n),s=(await this.b.getInstalled(void 0,l)).filter(t=>(0,I.$Mo)(t.identifier,{id:i}));if(!s.length)throw new Error(`${this.m(i)}
${f}`);if(s.some(t=>t.type===0)){this.a.info((0,w.localize)(20,null,i));return}if(!d&&s.some(t=>t.isBuiltin)){this.a.info((0,w.localize)(21,null,i));return}this.a.info((0,w.localize)(22,null,i));for(const t of s)await this.b.uninstall(t,{profileLocation:l}),h.push(t);this.f?this.a.info((0,w.localize)(23,null,i,this.f)):this.a.info((0,w.localize)(24,null,i))}}async locateExtension(u){const d=await this.b.getInstalled();u.forEach(l=>{d.forEach($=>{if($.identifier.id===l&&$.location.scheme===r.Schemas.file){this.a.info($.location.fsPath);return}})})}m(u){return this.f?(0,w.localize)(25,null,u,this.f):(0,w.localize)(26,null,u)}};e.$tp=c,e.$tp=c=Fe([Le(1,v.$mo),Le(2,v.$ko)],c)}),define(be[243],ve([1,0,14,11,2,12,19,53,10,21,22,81,24,25,30,36,84,16,13]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=void 0;let $=class extends r.$Sc{static{l=this}static{this.c=".sigzip"}constructor(n,i,o,s,t,a){super(),this.h=i,this.j=o,this.m=s,this.n=t,this.r=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,i,o){await this.g;const s=(0,S.$Dg)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,s,a=>this.j.download(n,a,i))}catch(a){throw new p.$lo(a.message,p.ExtensionManagementErrorCode.Download)}let t=!1;if(o&&this.t(n)){const a=await this.u(n);try{t=await this.n.verify(s.fsPath,a.fsPath,this.r.getLevel()===d.LogLevel.Trace)}catch(g){const L=g;if(t=L.code,L.output&&this.r.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${L.output}`),t===p.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===p.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(D){this.r.error(D)}throw new p.$lo(k.$xp,p.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(a)}catch(g){this.r.error(g)}}}return t===!0?this.r.info(`Extension signature is verified: ${n.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${n.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${n.identifier.id}`),{location:s,verificationStatus:t}}t(n){if(!n.isSigned)return!1;const i=this.m.getValue("extensions.verifySignature");return(0,w.$Kf)(i)?i:!0}async u(n){await this.g;const i=(0,S.$Dg)(this.extensionsDownloadDir,`${this.z(n)}${l.c}`);return await this.w(n,i,o=>this.j.downloadSignatureArchive(n,o)),i}async w(n,i,o){if(await this.h.exists(i))return;if(i.scheme!==C.Schemas.file){await o(i);return}const s=(0,S.$Dg)(this.extensionsDownloadDir,`.${(0,v.$mg)()}`);await this.h.exists(s)||await o(s);try{await I.Promises.rename(s.fsPath,i.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,i.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const i=[],o=[],s=[];for(const g of n.children)if(g.name.endsWith(l.c))s.push(g.resource);else{const L=c.$No.parse(g.name);L&&o.push([L,g])}const t=(0,c.$So)(o,([g])=>g),a=[];for(const g of t)g.sort((L,D)=>P.rcompare(L[0].version,D[0].version)),i.push(...g.slice(1).map(L=>L[1].resource)),a.push(g[0][1]);a.sort((g,L)=>g.mtime-L.mtime),i.push(...a.slice(0,Math.max(0,a.length-this.f)).map(g=>g.resource)),i.push(...s),await E.Promises.settled(i.map(g=>(this.r.trace("Deleting from cache",g.path),this.h.del(g))))}}catch(n){this.r.error(n)}}z(n){return this.f?c.$No.create(n).toString().toLowerCase():(0,v.$mg)()}};e.$Qp=$,e.$Qp=$=l=Fe([Le(0,f.$0h),Le(1,u.$lk),Le(2,p.$ko),Le(3,b.$vi),Le(4,m.$rp),Le(5,d.$jj)],$)}),define(be[244],ve([1,0,5,2,26,36,35]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class P extends R.$Sc{constructor(v,I,k,b,f,p,c){super(),this.f=v,this.g=I,this.h=k,this.j=b,this.m=f,this.n=p,this.r=c,this.a=this.B(new E.$Sd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$2c),this.s().then(null,m=>c.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(v=>this.u(v.added))),this.B(this.j.onAddExtensions(v=>this.w(v))),this.B(this.j.onDidAddExtensions(v=>this.y(v))),this.B(this.j.onRemoveExtensions(v=>this.z(v))),this.B(this.j.onDidRemoveExtensions(v=>this.C(v))),this.B(this.n.onDidFilesChange(v=>this.D(v)))}async u(v){try{v.length&&await Promise.all(v.map(I=>(this.c.set(I.id,(0,R.$Pc)(this.n.watch(this.m.extUri.dirname(I.extensionsResource)),this.n.watch(I.extensionsResource))),this.G(I.extensionsResource))))}catch(I){throw this.r.error(I),I}}async w(v){for(const I of v.extensions)this.I(this.L(I.identifier,I.version),v.profileLocation)}async y(v){for(const I of v.extensions){const k=this.L(I.identifier,I.version);v.error?this.J(k,v.profileLocation):this.I(k,v.profileLocation)}}async z(v){for(const I of v.extensions)this.J(this.L(I.identifier,I.version),v.profileLocation)}async C(v){const I=[],k=[];for(const b of v.extensions){const f=this.L(b.identifier,b.version);v.error?this.I(f,v.profileLocation):(this.J(f,v.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),k.push(this.f.scanInstalledExtensionAtLocation(b.location).then(p=>{p?I.push(p):this.r.info("Extension not found at the location",b.location.toString())},p=>this.r.error(p)))))}try{await Promise.all(k),I.length&&await this.H(I)}catch(b){this.r.error(b)}}D(v){for(const I of this.h.profiles)v.contains(I.extensionsResource,0,1)&&this.F(I.extensionsResource)}async F(v){const I=[],k=[],b=await this.j.scanProfileExtensions(v),f=new Set,p=new Set;for(const[c,m]of this.b)m.has(v)&&p.add(c);for(const c of b){const m=this.L(c.identifier,c.version);f.add(m),p.has(m)||(I.push(c.identifier),this.I(m,v))}for(const c of p)if(!f.has(c)){const m=this.M(c);m&&(k.push(m.identifier),this.J(c,v))}(I.length||k.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:v}:void 0,removed:k.length?{extensions:k,profileLocation:v}:void 0})}async G(v){const I=await this.j.scanProfileExtensions(v);for(const k of I)this.I(this.L(k.identifier,k.version),v)}async H(v){v||(v=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),v.length&&await this.f.markAsUninstalled(...v)}I(v,I){let k=this.b.get(v);k||this.b.set(v,k=new r.$Bc(b=>this.m.extUri.getComparisonKey(b))),k.add(I)}J(v,I){const k=this.b.get(v);k&&k.delete(I),k?.size||this.b.delete(v)}L(v,I){return`${S.$gm.toKey(v.id)}@${I}`}M(v){const[I,k]=(0,C.$Oo)(v);return k?{identifier:{id:I},version:k}:void 0}}e.$Up=P}),define(be[245],ve([1,0,215,38]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;async function r(C,S,P,w,v,I,k){const b={"X-Market-Client-Id":`VSCode ${C}`,"User-Agent":`VSCode ${C} (${S.nameShort})`};if((0,R.$Eo)(S,P)&&(0,R.$Go)(w)===3){const f=await(0,E.$mp)(P,v,I);b["X-Market-User-Id"]=f,b["VSCode-SessionId"]=k.machineId||f}return b}e.$np=r}),define(be[120],ve([1,0,89,18,14,2,12,7,22,25,30,36,13,86,3]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;let c=class extends f.$7q{constructor(l,$,h,n){super(h),this.h=l,this.j=n,this.g=this.B(new m($,n)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(l,$){const n=(await this.g.getLanguagePacks())[$];if(!n){this.j.warn(`No language pack found for ${$}`);return}const i=n.translations[l];return i?p.URI.file(i):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),$=Object.keys(l).map(h=>{const n=l[h];return{...this.f(h,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return $.push(this.f("en","English")),$.sort((h,n)=>h.label.localeCompare(n.label)),$}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const $=await this.g.getLanguagePacks();Object.keys($).some(h=>$[h]&&$[h].extensions.some(n=>(0,k.$Mo)(n.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,$]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update($);return!(0,R.$ub)(Object.keys(l),Object.keys(h))}};e.$8q=c,e.$8q=c=Fe([Le(0,I.$mo),Le(1,v.$0h),Le(2,I.$ko),Le(3,b.$jj)],c);let m=class extends C.$Sc{constructor(l,$){super(),this.j=$,this.c={},this.f=(0,P.$jc)(l.userDataPath,"languagepacks.json"),this.g=new r.$9g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s($=>{Object.keys($).forEach(h=>delete $[h]),this.m($,...l)}).then(()=>this.c)}m(l,...$){for(const h of $)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(l,h);Object.keys(l).forEach(h=>this.r(l[h]))}n(l,$){const h=$.identifier,n=$.manifest.contributes&&$.manifest.contributes.localizations?$.manifest.contributes.localizations:[];for(const i of n)if($.location.scheme===S.Schemas.file&&u(i)){let o=l[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},l[i.languageId]=o);const s=o.extensions.filter(t=>(0,k.$Mo)(t.extensionIdentifier,h))[0];s?s.version=$.manifest.version:o.extensions.push({extensionIdentifier:h,version:$.manifest.version});for(const t of i.translations)o.translations[t.id]=(0,P.$jc)($.location.fsPath,t.path)}}r(l){if(l){const $=(0,E.createHash)("md5");for(const h of l.extensions)$.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);l.hash=$.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let $=null;return w.Promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>($=l(h),h)).then(h=>{for(const i of Object.keys(h))h[i]||delete h[i];this.c=h,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),w.Promises.writeFile(this.f,n)}).then(()=>$,h=>this.j.error(h))})}};m=Fe([Le(0,v.$0h),Le(1,b.$jj)],m);function u(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const l of d.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(be[246],ve([1,0,166,11,23,38]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1N=void 0;const S="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function w(I,k,b){const f=await(0,E.$YC)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,E.$YC)("@microsoft/1ds-post-js","dist/ms.post.js"),c=new f.AppInsightsCore,m=new p.PostChannel,u={instrumentationKey:I,endpointUrl:S,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(b){u.extensionConfig={};const d={alwaysUseXhrOverride:!0,httpXHROverride:b};u.extensionConfig[m.identifier]=d}return c.initialize(u,[]),c.addTelemetryInitializer(d=>{k&&(d.ext=d.ext??{},d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),c}class v{constructor(k,b,f,p,c){this.e=k,this.f=b,this.g=f,this.h=c,this.c=S,this.d=P,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(b=>{k(b)},b=>{(0,R.$1)(b),console.error(b)})}}log(k,b){if(!this.a)return;b=(0,r.$kn)(b,this.g),b=(0,C.$Ho)(b);const f=this.f+"/"+k;try{this.i(p=>{p.pluginVersionString=b?.properties.version??"Unknown",p.track({name:f,baseData:{name:f,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$1N=v}),define(be[247],ve([1,0,2,23,4,17,195,24,56,55,31,37,32,38]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,d,l){this.k=d,this.l=l,this.d={},this.i=new E.$Rc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,C.$Ke)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,C.$Ke)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(b.$xl)||$.affectsConfiguration(b.$zl)||$.affectsConfiguration(b.$yl))&&this.m()}))}setExperimentProperty(u,d){this.d[u]=d}m(){let u=(0,f.$Go)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const l=d.usage?3:d.error?2:0;u=Math.min(u,l)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,d,l){this.g<d||(l=(0,R.$kn)(l,this.d),l=(0,f.$Lo)(l,this.j),l=(0,R.$kn)(l,this.c),this.b.forEach($=>$.log(u,l)))}publicLog(u,d){this.n(u,3,d)}publicLog2(u,d){this.publicLog(u,d)}publicLogError(u,d){this.h&&this.n(u,2,d)}publicLogError2(u,d){this.publicLogError(u,d)}};e.$br=p,e.$br=p=Fe([Le(1,P.$vi),Le(2,I.$Bj)],p);function c(){const m=(0,S.localize)(0,null,v.default.nameLong),u=v.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=r.$o?"":(0,S.localize)(3,null),l=(0,S.localize)(4,null),$=(0,S.localize)(5,null),h=(0,S.localize)(6,null),n=(0,S.localize)(7,null),i=`
|       | ${l} | ${$} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,S.localize)(8,null);return`
${m} ${u} ${d}

&nbsp;

${n}
${i}

&nbsp;

${o}
`}k.$tn.as(w.$yn.Configuration).registerConfiguration({id:b.$wl,order:1,type:"object",title:(0,S.localize)(9,null),properties:{[b.$xl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:c(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$tn.as(w.$yn.Configuration).registerConfiguration({id:b.$wl,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[b.$zl]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,S.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,S.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${b.$xl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[248],ve([1,0,24,6,31,32,247,38]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=void 0;let w=class extends S.$br{constructor(I,k,b,f){super(I,b,f),this.o=k}publicLog(I,k){if(!(this.o<3))return super.publicLog(I,k)}publicLog2(I,k){return this.publicLog(I,k)}publicLogError(I,k){return this.o<2?Promise.resolve(void 0):super.publicLogError(I,k)}publicLogError2(I,k){return this.publicLogError(I,k)}async updateInjectedTelemetryLevel(I){if(I===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,I):I,this.o===0&&this.dispose()}};e.$Yr=w,e.$Yr=w=Fe([Le(2,E.$vi),Le(3,r.$Bj)],w),e.$Zr=new class extends P.$xo{async updateInjectedTelemetryLevel(){}},e.$1r=(0,R.$3h)(C.$pl)}),define(be[249],ve([1,0,15,20,301,246]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2N=void 0;async function S(I,k){const b=await k.request(I,R.CancellationToken.None),f=(await(0,E.$se)(b.stream)).toString(),p=b.res.statusCode??200;return{headers:b.res.headers,statusCode:p,responseData:f}}async function P(I){const k={method:I.type,headers:I.headers};return new Promise((f,p)=>{const c=r.request(I.url??"",k,m=>{m.on("data",function(u){f({headers:m.headers,statusCode:m.statusCode??200,responseData:u.toString()})}),m.on("error",function(u){p(u)})});c.write(I.data,m=>{m&&p(m)}),c.end()})}async function w(I,k,b){const f=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),p={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:f};try{const c=I?await S(p,I):await P(p);b(c.statusCode,c.headers,c.responseData)}catch{b(0,{})}}class v extends C.$1N{constructor(k,b,f,p,c){const m={sendPOST:(u,d)=>{w(k,u,d)}};super(b,f,p,c,m)}}e.$2N=v}),define(be[250],ve([1,0,11,240]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends R.default{i(){(0,E.setUnexpectedErrorHandler)(P=>console.error(P));const S=[];process.on("unhandledRejection",(P,w)=>{S.push(w),setTimeout(()=>{const v=S.indexOf(w);v>=0&&w.catch(I=>{S.splice(v,1),(0,E.$4)(I)||(console.warn(`rejected promise not handled within 1 second: ${I}`),I.stack&&console.warn(`stack trace: ${I.stack}`),P&&(0,E.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const w=S.indexOf(P);w>=0&&S.splice(w,1)}),process.on("uncaughtException",P=>{(0,E.$Z)(P)||(0,E.$1)(P)})}}e.default=r}),define(be[121],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(be[122],ve([1,0,4,121]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;const r=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class C{constructor(I){this.collections=I,this.a=new Map,this.b=new Map,I.forEach((k,b)=>{this.d(k,b);const f=k.map.entries();let p=f.next();for(;!p.done;){const c=p.value[1],m=p.value[0];let u=this.a.get(m);if(u||(u=[],this.a.set(m,u)),u.length>0&&u[0].type===R.EnvironmentVariableMutatorType.Replace){p=f.next();continue}const d={extensionIdentifier:b,value:c.value,type:c.type,scope:c.scope,variable:c.variable,options:c.options};d.scope||delete d.scope,u.unshift(d),p=f.next()}})}async applyToProcessEnvironment(I,k,b){let f;E.$i&&(f={},Object.keys(I).forEach(p=>f[p.toLowerCase()]=p));for(const[p,c]of this.getVariableMap(k)){const m=E.$i&&f[p.toLowerCase()]||p;for(const u of c){const d=b?await b(u.value):u.value;if(u.options?.applyAtProcessCreation??!0)switch(u.type){case R.EnvironmentVariableMutatorType.Append:I[m]=(I[m]||"")+d;break;case R.EnvironmentVariableMutatorType.Prepend:I[m]=d+(I[m]||"");break;case R.EnvironmentVariableMutatorType.Replace:I[m]=d;break}if(u.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${r.get(u.type)}`;I[l]=(I[l]?I[l]+":":"")+p+"="+this.c(d)}}}}c(I){return I.replaceAll(":","\\x3a")}diff(I,k){const b=new Map,f=new Map,p=new Map;if(I.getVariableMap(k).forEach((c,m)=>{const u=this.getVariableMap(k).get(m),d=P(c,u);d&&b.set(m,d)}),this.getVariableMap(k).forEach((c,m)=>{const u=I.getVariableMap(k).get(m),d=P(c,u);d&&p.set(m,d)}),this.getVariableMap(k).forEach((c,m)=>{const u=I.getVariableMap(k).get(m),d=w(c,u);d&&f.set(m,d)}),!(b.size===0&&f.size===0&&p.size===0))return{added:b,changed:f,removed:p}}getVariableMap(I){const k=new Map;for(const b of this.a.values()){const f=b.filter(p=>S(p,I));f.length>0&&k.set(f[0].variable,f)}return k}getDescriptionMap(I){const k=new Map;for(const b of this.b.values()){const f=b.filter(p=>S(p,I,!0));for(const p of f)k.set(p.extensionIdentifier,p.description)}return k}d(I,k){if(!I.descriptionMap)return;const b=I.descriptionMap.entries();let f=b.next();for(;!f.done;){const p=f.value[1],c=f.value[0];let m=this.b.get(c);m||(m=[],this.b.set(c,m));const u={extensionIdentifier:k,scope:p.scope,description:p.description};u.scope||delete u.scope,m.push(u),f=b.next()}}}e.$Dr=C;function S(v,I,k=!1){return v.scope?!!(v.scope.workspaceFolder&&I?.workspaceFolder&&v.scope.workspaceFolder.index===I.workspaceFolder.index):k?I===v.scope:!0}function P(v,I){if(!I)return v;const k=new Set;I.forEach(f=>k.add(f.extensionIdentifier));const b=[];return v.forEach(f=>{k.has(f.extensionIdentifier)||b.push(f)}),b.length===0?void 0:b}function w(v,I){if(!I)return;const k=new Map;I.forEach(f=>k.set(f.extensionIdentifier,f));const b=[];return v.forEach(f=>{const p=k.get(f.extensionIdentifier);p&&(f.type!==p.type||f.value!==p.value||f.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index)&&b.push(p)}),b.length===0?void 0:b}}),define(be[90],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=void 0;function E(w){return[...w.entries()]}e.$xr=E;function R(w){return w?[...w.entries()]:[]}e.$yr=R;function r(w){return new Map(w)}e.$zr=r;function C(w){return new Map(w??[])}e.$Ar=C;function S(w){return Array.from(w.entries()).map(v=>[v[0],E(v[1].map),R(v[1].descriptionMap)])}e.$Br=S;function P(w){return new Map(w.map(v=>[v[0],{map:r(v[1]),descriptionMap:C(v[2])}]))}e.$Cr=P}),define(be[251],ve([1,0,14,20,5,2,13]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;let P=class extends C.$Sc{constructor(v,I){super(),this.h=I,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$Sd),this.onCreateRequest=this.g.event,this.b=v===void 0?15e3:v,this.B((0,C.$Qc)(()=>{for(const k of this.f.values())(0,C.$Nc)(k)}))}createRequest(v){return new Promise((I,k)=>{const b=++this.a;this.c.set(b,I),this.g.fire({requestId:b,...v});const f=new R.$3d;(0,E.$3g)(this.b,f.token).then(()=>k(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,C.$Qc)(()=>f.cancel())])})}acceptReply(v,I){const k=this.c.get(v);k?(this.c.delete(v),(0,C.$Nc)(this.f.get(v)||[]),this.f.delete(v),k(I)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${v}`)}};e.$or=P,e.$or=P=Fe([Le(1,S.$jj)],P)}),define(be[91],ve([1,0,6,68,37]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$hr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$gr=void 0,e.$gr=new R.$gj("terminalTabFocusMode",!1,!0);var C;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(C||(e.TerminalSettingPrefix=C={}));var S;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",h.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",h.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(S||(e.TerminalSettingId=S={}));var P;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(P||(e.PosixShellType=P={}));var w;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(w||(e.WindowsShellType=w={}));var v;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(v||(e.TitleEventSource=v={}));var I;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var k;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k||(e.ProcessPropertyType=k={})),e.$hr=(0,E.$2h)("ptyService");var b;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var f;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var p;(function(h){h.TerminalView="view",h.Editor="editor"})(p||(e.TerminalLocationString=p={}));var c;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var m;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(m||(e.FlowControlConstants=m={}));var u;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(u||(e.ProfileSource=u={}));var d;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var l;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$ir={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const i=this.b(n.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}r.$tn.add(e.$ir.Backend,new $),e.$jr=(0,E.$2h)("localPtyService"),e.$kr=(0,E.$2h)("terminalLogService")}),define(be[252],ve([1,0,4]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=e.$FN=e.$EN=void 0;function R(S){let P=S;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const w=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(w,""),`'${P}'`}e.$EN=R;function r(S,P,w){if(!S)return"";if(!P)return S;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const v=S.replace(/\\/g,"/").toLowerCase(),I=P.replace(/\\/g,"/").toLowerCase();return v.includes(I)?`~${w}${S.slice(P.length+1)}`:S}e.$FN=r;function C(S){return S.match(/^['"].*['"]$/)&&(S=S.substring(1,S.length-1)),E.OS===1&&S&&S[1]===":"?S[0].toUpperCase()+S.substring(1):S}e.$GN=C}),define(be[253],ve([1,0,49,3,197,99]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=e.$rr=e.$qr=e.$pr=void 0;function S(b,f){const p=[{name:null,description:(0,r.localize)(0,null)}];return p.push(...b.map(c=>({name:c.profileName,description:P(c)}))),f&&p.push(...f.map(c=>({name:c.title,description:w(c)}))),{values:p.map(c=>c.name),markdownDescriptions:p.map(c=>c.description)}}e.$pr=S;function P(b){let f=`$(${C.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:E.$8j.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?f+=`
- args: "${b.args}"`:f+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(f+=`
- overrideName: ${b.overrideName}`),b.color&&(f+=`
- color: ${b.color}`),b.env&&(f+=`
- env: ${JSON.stringify(b.env)}`),f}function w(b){return`$(${C.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:E.$8j.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function v(b,f){if(!b&&!f)return!0;if(typeof b=="string"&&typeof f=="string")return b===f;if(Array.isArray(b)&&Array.isArray(f)){if(b.length!==f.length)return!1;for(let p=0;p<b.length;p++)if(b[p]!==f[p])return!1;return!0}return!1}e.$qr=v;function I(b,f){if(!b&&!f)return!0;if(!b||!f)return!1;if(C.ThemeIcon.isThemeIcon(b)&&C.ThemeIcon.isThemeIcon(f))return b.id===f.id&&b.color===f.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof f=="object"&&"light"in f&&"dark"in f){const p=b,c=f;if((R.URI.isUri(p.light)||k(p.light))&&(R.URI.isUri(p.dark)||k(p.dark))&&(R.URI.isUri(c.light)||k(c.light))&&(R.URI.isUri(c.dark)||k(c.dark)))return p.light.path===c.light.path&&p.dark.path===c.dark.path}if(R.URI.isUri(b)&&R.URI.isUri(f)||k(b)||k(f)){const p=b,c=f;return p.path===c.path&&p.scheme===c.scheme}return!1}e.$rr=I;function k(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.$sr=k}),define(be[254],ve([1,0,49,4,196,56,37,253]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0,e.$tr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$ur={type:"string",enum:Array.from((0,E.$7j)(),m=>m.id),markdownEnumDescriptions:Array.from((0,E.$7j)(),m=>`$(${m.id})`)};const w={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$ur},color:{description:(0,r.localize)(3,null),...e.$tr},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},v={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...w}},I={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...w}};function k(m){const u=m===2?"linux":m===1?"osx":"windows";return(0,r.localize)(7,null,(0,R.$h)(m),'```json\n"terminal.integrated.profile.'+u+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const b={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...w}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...w}},{type:"null"},v]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...w}},{type:"null"},v]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...w}},{type:"null"},v]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){S.$tn.as(C.$yn.Configuration).registerConfiguration(b),c()}e.$vr=f;let p;function c(m,u){const d=S.$tn.as(C.$yn.Configuration);let l;m&&(l=(0,P.$pr)(m?.profiles,u));const $=p;p={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:m?.os===3?l?.values:void 0,markdownEnumDescriptions:m?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:m?.os===2?l?.values:void 0,markdownEnumDescriptions:m?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:m?.os===1?l?.values:void 0,markdownEnumDescriptions:m?.os===1?l?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[p],remove:$?[$]:[]})}e.$wr=c}),define(be[255],ve([1,0,2,12,107,25,108]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;let P=class extends E.$Sc{constructor(v,I){super(),this.a=v,this.b=I}start(){const v={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:R.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},I=(0,S.$xm)(this.b.args,this.b.isBuilt);I&&(I.break&&I.port?v.debugBrk=I.port:!I.break&&I.port&&(v.debug=I.port));const k=new r.$dq(R.$kg.asFileUri("bootstrap-fork").fsPath,v),b=new E.$Rc;return b.add(k),{client:k,store:b,onDidProcessExit:k.onDidProcessExit}}};e.$jO=P,e.$jO=P=Fe([Le(1,C.$9h)],P)}),define(be[256],ve([1,0,28,12,23,7,4,29,17,10,22,121,90,122]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=e.$Er=void 0;function p(){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let t=0;return s&&s.length===4&&(t=parseInt(s[3])),t}e.$Er=p;async function c(s,t,a,g=P.env,L=I.Promises.exists){if(C.$ic(s))return await L(s)?s:void 0;if(t===void 0&&(t=P.cwd()),C.$mc(s)!=="."){const F=C.$jc(t,s);return await L(F)?F:void 0}const y=(0,r.$on)(g,"PATH");if(a===void 0&&(0,v.$Ef)(y)&&(a=y.split(C.$tc)),a===void 0||a.length===0){const F=C.$jc(t,s);return await L(F)?F:void 0}for(const F of a){let X;if(C.$ic(F)?X=C.$jc(F,s):X=C.$jc(t,F,s),await L(X))return X;if(S.$i){let te=X+".com";if(await L(te)||(te=X+".exe",await L(te)))return te}}const A=C.$jc(t,s);return await L(A)?A:void 0}e.$Fr=c;function m(s,t,a,g,L){const D=S.$i&&(!t.windowsEnableConpty||p()<18309);if(!t.shellIntegration.enabled||!s.executable||s.isFeatureTerminal||s.hideFromUser||s.ignoreShellIntegration||D)return;const y=s.args,A=P.$dc==="win32"?C.$nc(s.executable).toLowerCase():C.$nc(s.executable),F=C.$mc(R.$kg.asFileUri("").fsPath);let X;const te={VSCODE_INJECTION:"1"};if(t.shellIntegration.nonce&&(te.VSCODE_NONCE=t.shellIntegration.nonce),S.$i){if(A==="pwsh.exe"||A==="powershell.exe")return!y||i(y)?X=l.get(d.WindowsPwsh):n(y)&&(X=l.get(d.WindowsPwshLogin)),X?(X=[...X],X[X.length-1]=(0,w.$He)(X[X.length-1],F,""),{newArgs:X,envMixin:te}):void 0;g.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args);return}switch(A){case"bash":return!y||y.length===0?X=l.get(d.Bash):o(y)&&(te.VSCODE_SHELL_LOGIN="1",u(t,te),X=l.get(d.Bash)),X?(X=[...X],X[X.length-1]=(0,w.$He)(X[X.length-1],F),{newArgs:X,envMixin:te}):void 0;case"fish":{const J=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ie=C.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return te.XDG_DATA_DIRS=`${J}:${ie}`,u(t,te),{newArgs:void 0,envMixin:te}}case"pwsh":return!y||i(y)?X=l.get(d.Pwsh):n(y)&&(X=l.get(d.PwshLogin)),X?(X=[...X],X[X.length-1]=(0,w.$He)(X[X.length-1],F,""),{newArgs:X,envMixin:te}):void 0;case"zsh":{if(!y||y.length===0?X=l.get(d.Zsh):o(y)?(X=l.get(d.ZshLogin),u(t,te)):(y===l.get(d.Zsh)||y===l.get(d.ZshLogin))&&(X=y),!X)return;X=[...X],X[X.length-1]=(0,w.$He)(X[X.length-1],F);let J;try{J=E.userInfo().username}catch{J="unknown"}const ie=C.$jc(E.tmpdir(),`${J}-${L.applicationName}-zsh`);te.ZDOTDIR=ie;const ee=a?.ZDOTDIR??E.homedir()??"~";te.USER_ZDOTDIR=ee;const U=[];return U.push({source:C.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:C.$jc(ie,".zshrc")}),U.push({source:C.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:C.$jc(ie,".zprofile")}),U.push({source:C.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:C.$jc(ie,".zshenv")}),U.push({source:C.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:C.$jc(ie,".zlogin")}),{newArgs:X,envMixin:te,filesToCopy:U}}}g.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args)}e.$Gr=m;function u(s,t){if(S.$j&&s.environmentVariableCollections){const a=(0,b.$Cr)(s.environmentVariableCollections),L=new f.$Dr(a).getVariableMap({workspaceFolder:s.workspaceFolder}).get("PATH"),D=[];if(L)for(const y of L)y.type===k.EnvironmentVariableMutatorType.Prepend&&D.push(y.value);D.length>0&&(t.VSCODE_PATH_PREFIX=D.join(""))}}var d;(function(s){s.WindowsPwsh="windows-pwsh",s.WindowsPwshLogin="windows-pwsh-login",s.Pwsh="pwsh",s.PwshLogin="pwsh-login",s.Zsh="zsh",s.ZshLogin="zsh-login",s.Bash="bash"})(d||(d={}));const l=new Map;l.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(d.Zsh,["-i"]),l.set(d.ZshLogin,["-il"]),l.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],h=["-nol","-nologo"];function n(s){return typeof s=="string"?$.includes(s.toLowerCase()):s.length===1&&$.includes(s[0].toLowerCase())||s.length===2&&($.includes(s[0].toLowerCase())||$.includes(s[1].toLowerCase()))&&(h.includes(s[0].toLowerCase())||h.includes(s[1].toLowerCase()))}function i(s){return typeof s=="string"?h.includes(s.toLowerCase()):s.length===0||s?.length===1&&h.includes(s[0].toLowerCase())}function o(s){return s==="string"&&$.includes(s.toLowerCase())||typeof s!="string"&&s.length===1&&$.includes(s[0].toLowerCase())}}),define(be[257],ve([1,0,52,49,7,4,10,22,102,256,77]),function(ue,e,E,R,r,C,S,P,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;var k;(function(a){a.UnixShellsPath="/etc/shells"})(k||(k={}));let b,f=!0;function p(a,g,L,D,y=process.env,A,F,X,te){return A=A||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},C.$i?c(L,A,y,F,D.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:D.getValue("terminal.integrated.profiles.windows"),typeof g=="string"?g:D.getValue("terminal.integrated.defaultProfile.windows"),te,X):o(A,F,L,a&&typeof a=="object"?{...a}:D.getValue(C.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof g=="string"?g:D.getValue(C.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),te,X,y)}e.$Hr=p;async function c(a,g,L,D,y,A,F,X,te){const J=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ie=`${process.env.windir}\\${J?"Sysnative":"System32"}`;let ee=!1;(0,v.$Er)()>=16299&&(ee=!0),await l(X);const U=new Map;if(a){U.set("PowerShell",{source:"PowerShell",icon:R.$8j.terminalPowershell,isAutoDetected:!0}),U.set("Windows PowerShell",{path:`${ie}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$8j.terminalPowershell,isAutoDetected:!0}),U.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),U.set("Command Prompt",{path:`${ie}\\cmd.exe`,icon:R.$8j.terminalCmd,isAutoDetected:!0}),U.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),U.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$8j.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;U.set("Cmder",{path:`${ie}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}s(A,U);const he=await m(U.entries(),F,g,L,D,te);if(a&&y)try{const Q=await n(`${ie}\\${ee?"wsl":"bash"}.exe`,F);for(const _ of Q)(!A||!(_.profileName in A))&&he.push(_)}catch{f&&(D?.info("WSL is not installed, so could not detect WSL profiles"),f=!1)}return he}async function m(a,g,L,D=process.env,y,A){const F=[];for(const[X,te]of a)F.push(u(X,te,g,L,D,y,A));return(await Promise.all(F)).filter(X=>!!X)}async function u(a,g,L,D,y=process.env,A,F){if(g===null)return;let X,te,J;if("source"in g&&!("path"in g)){const he=b?.get(g.source);if(!he)return;X=he.paths,te=g.args||he.args,g.icon?J=d(g.icon):he.icon&&(J=he.icon)}else X=Array.isArray(g.path)?g.path:[g.path],te=C.$i||Array.isArray(g.args)?g.args:void 0,J=d(g.icon);let ie;if(F){const he=X.map(_=>typeof _=="string"?_:_.path),Q=await F(he);ie=new Array(X.length);for(let _=0;_<X.length;_++)typeof X[_]=="string"?ie[_]=Q[_]:ie[_]={path:Q[_],isUnsafe:!0}}else ie=X.slice();let ee;if(g.requiresPath){let he;if((0,S.$Ef)(g.requiresPath)?he=g.requiresPath:(he=g.requiresPath.path,g.requiresPath.isUnsafe&&(ee=he)),!await D.existsFile(he))return}const U=await t(a,L,ie,D,y,te,g.env,g.overrideName,g.isAutoDetected,ee);if(!U){A?.debug("Terminal profile not validated",a,X);return}return U.isAutoDetected=g.isAutoDetected,U.icon=J,U.color=g.color,U}function d(a){return typeof a=="string"?{id:a}:a}async function l(a){if(b&&!a)return;const[g,L]=await Promise.all([$(),a||h()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:g,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:L,icon:R.$8j.terminalPowershell})}async function $(){const a=new Set,g=await(0,v.$Fr)("git.exe");if(g){const y=(0,I.dirname)(g);a.add((0,I.resolve)(y,"../.."))}function L(y,A){A&&y.add(A)}L(a,process.env.ProgramW6432),L(a,process.env.ProgramFiles),L(a,process.env["ProgramFiles(X86)"]),L(a,`${process.env.LocalAppData}\\Program`);const D=[];for(const y of a)D.push(`${y}\\Git\\bin\\bash.exe`,`${y}\\Git\\usr\\bin\\bash.exe`,`${y}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function h(){const a=[];for await(const g of(0,w.$Kl)())a.push(g.exePath);return a}async function n(a,g){const L=[],D=await new Promise((F,X)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(te,J)=>{if(te)return X("Problem occurred when getting wsl distros");F(J)})});if(!D)return[];const y=new RegExp(/[\r?\n]/),A=D.split(y).filter(F=>F.trim().length>0&&F!=="");for(const F of A){if(F===""||F.startsWith("docker-desktop"))continue;const X=`${F} (WSL)`,te={profileName:X,path:a,args:["-d",`${F}`],isDefault:X===g,icon:i(F),isAutoDetected:!1};L.push(te)}return L}function i(a){return a.includes("Ubuntu")?R.$8j.terminalUbuntu:a.includes("Debian")?R.$8j.terminalDebian:R.$8j.terminalLinux}async function o(a,g,L,D,y,A,F,X){const te=new Map;if(L&&await a.existsFile("/etc/shells")){const J=(await a.readFile("/etc/shells")).toString(),ie=(A||J.split(`
`)).map(U=>{const he=U.indexOf("#");return he===-1?U:U.substring(0,he)}).filter(U=>U.trim().length>0),ee=new Map;for(const U of ie){let he=(0,r.$nc)(U),Q=ee.get(he)||0;Q++,Q>1&&(he=`${he} (${Q})`),ee.set(he,Q),te.set(he,{path:U,isAutoDetected:!0})}}return s(D,te),await m(te.entries(),y,a,X,g,F)}function s(a,g){if(a)for(const[L,D]of Object.entries(a))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?g.delete(L):(D.icon=D.icon||g.get(L)?.icon,g.set(L,D))}async function t(a,g,L,D,y,A,F,X,te,J){if(L.length===0)return Promise.resolve(void 0);const ie=L.shift();if(ie==="")return t(a,g,L,D,y,A,F,X,te);const ee=typeof ie!="string"&&ie.isUnsafe,U=typeof ie=="string"?ie:ie.path,he={profileName:a,path:U,args:A,env:F,overrideName:X,isAutoDetected:te,isDefault:a===g,isUnsafePath:ee,requiresUnsafePath:J};if((0,r.$nc)(U)===U){const _=y.PATH?y.PATH.split(r.$tc):void 0,V=await(0,v.$Fr)(U,void 0,_,void 0,D.existsFile);return V?(he.path=V,he.isFromPath=!0,he):t(a,g,L,D,y,A)}return await D.existsFile((0,r.$hc)(U))?he:t(a,g,L,D,y,A,F,X,te)}}),define(be[258],ve([1,0,5,2,4,43,24,13,112,88,251,91,254,257,105,60]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ir=void 0;var m;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let u=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,$,h,n){super(),this.M=l,this.N=$,this.O=h,this.P=n,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new E.$Sd),this.onPtyHostExit=this.u.event,this.w=this.B(new E.$Sd),this.onPtyHostStart=this.w.event,this.y=this.B(new E.$Sd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new E.$Sd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new E.$Sd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new E.$Sd),this.onProcessData=this.D.event,this.F=this.B(new E.$Sd),this.onProcessReady=this.F.event,this.G=this.B(new E.$Sd),this.onProcessReplay=this.G.event,this.H=this.B(new E.$Sd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new E.$Sd),this.onDidRequestDetach=this.I.event,this.J=this.B(new E.$Sd),this.onDidChangeProperty=this.J.event,this.L=this.B(new E.$Sd),this.onProcessExit=this.L.event,(0,b.$vr)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new I.$or(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&E.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(r.$i)return process.env;try{return await(0,v.$7l)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),$=l.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),C.ProxyChannel.toService($.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=m.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const n=C.ProxyChannel.toService($.getChannel(k.TerminalIpcChannels.PtyHost));return this.B(n.onProcessData(i=>this.D.fire(i))),this.B(n.onProcessReady(i=>this.F.fire(i))),this.B(n.onProcessExit(i=>this.L.fire(i))),this.B(n.onDidChangeProperty(i=>this.J.fire(i))),this.B(n.onProcessReplay(i=>this.G.fire(i))),this.B(n.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(n.onDidRequestDetach(i=>this.I.fire(i))),this.B(new w.$nr(this.P,$.getChannel(k.TerminalIpcChannels.Logger))),this.a=l,this.b=n,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,n]}async createProcess(l,$,h,n,i,o,s,t,a,g,L){const D=setTimeout(()=>this.$(),k.HeartbeatConstants.CreateProcessTimeout),y=await this.f.createProcess(l,$,h,n,i,o,s,t,a,g,L);return clearTimeout(D),y}updateTitle(l,$,h){return this.f.updateTitle(l,$,h)}updateIcon(l,$,h,n){return this.f.updateIcon(l,$,h,n)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,$){return this.f.detachFromProcess(l,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,$){return this.f.shutdown(l,$)}input(l,$){return this.f.input(l,$)}processBinary(l,$){return this.f.processBinary(l,$)}resize(l,$,h){return this.f.resize(l,$,h)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,$){return this.f.acknowledgeDataEvent(l,$)}setUnicodeVersion(l,$){return this.f.setUnicodeVersion(l,$)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new c.$Od,$=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...$]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,$){return this.f.installAutoReply(l,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,p.$Ql)(l??r.OS,process.env)}async getProfiles(l,$,h,n=!1){const i=await this.S();return(0,f.$Hr)($,h,n,this.N,i,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,$){return this.f.getWslPath(l,$)}getRevivedPtyNewId(l,$){return this.f.getRevivedPtyNewId(l,$)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,$){return this.f.requestDetachInstance(l,$)}async acceptDetachInstanceReply(l,$){return this.f.acceptDetachInstanceReply(l,$)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,$,h){return this.f.reviveTerminalProcesses(l,$,h)}async refreshProperty(l,$){return this.f.refreshProperty(l,$)}async updateProperty(l,$,h){return this.f.updateProperty(l,$,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?k.HeartbeatConstants.ConnectingBeatInterval:k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,$){return this.j.createRequest({workspaceId:l,originalText:$})}async acceptPtyHostResolvedVariables(l,$){this.j.acceptReply(l,$)}};e.$Ir=u,e.$Ir=u=Fe([Le(1,S.$vi),Le(2,P.$jj),Le(3,P.$kj)],u)}),define(be[34],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=void 0,e.$Vk=(0,E.$2h)("IUriIdentityService")}),define(be[123],ve([1,0,34,216,16,19,146,5,2]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;class v{static{this._clock=0}constructor(b){this.uri=b,this.time=v._clock++}touch(){return this.time=v._clock++,this}}let I=class{constructor(b){this.g=b,this.c=new w.$Rc,this.f=2**16;const f=new Map,p=c=>{let m=f.get(c.scheme);return m===void 0&&(m=b.hasProvider(c)&&!this.g.hasCapability(c,1024),f.set(c.scheme,m)),m};this.c.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(c=>{f.delete(c.scheme)})),this.extUri=new C.$sg(p),this.d=new S.$Lr((c,m)=>this.extUri.compare(c,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,C.$Eg)(b));const f=this.d.get(b);return f?f.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new v(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((p,c)=>p[1].time<c[1].time?1:p[1].time>c[1].time?-1:0);v._clock=0,this.d.clear();const f=this.f*.5;for(let p=0;p<f;p++)this.d.set(b[p][0],b[p][1].touch())}};e.$Mr=I,e.$Mr=I=Fe([Le(0,r.$lk)],I),(0,R.$Jr)(E.$Vk,I,1)}),define(be[92],ve([1,0,199,7,63,19,3,6,12]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,P.$2h)("contextService");function v(s){const t=s;return typeof t?.id=="string"&&S.URI.isUri(t.uri)}e.$_h=v;function I(s){return typeof s?.id=="string"&&!v(s)&&!b(s)}e.$ai=I,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function k(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,R.$nc)(s)}:t?e.$bi:e.$ci;const a=s;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$di=k;function b(s){const t=s;return typeof t?.id=="string"&&S.URI.isUri(t.configPath)}e.$ei=b;function f(s){const t=s;if(t?.uri)return{id:t.id,uri:S.URI.revive(t.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:S.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.$fi=f;var p;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$gi=c;function m(s){const t=s;return!!(t&&typeof t=="object"&&S.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$hi=m;class u{constructor(t,a,g,L,D){this.h=t,this.j=g,this.k=L,this.l=D,this.c=r.$8h.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=r.$8h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=u;class d{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,C.$Dg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=d;function l(s){return new d({uri:s,index:0,name:(0,C.$zg)(s)},{uri:s.toString()})}e.$ki=l,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,E.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function $(s,t){return C.$ug.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$pi=$;function h(s){let t;return S.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===w.Schemas.tmp}e.$qi=h,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(s){return s.id===e.$ri}e.$si=n;function i(s,t){return!$(s,t)&&!h(s)}e.$ti=i;function o(s){return(typeof s=="string"?(0,R.$oc)(s):(0,C.$Bg)(s))===e.$mi}e.$ui=o}),define(be[33],ve([1,0,61,5,2,19,3,198,25,16,6,13,92,26,34,14,21,17,10]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.ProfileResourceType=void 0;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function $(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&S.URI.isUri(t.location)&&S.URI.isUri(t.globalStorageHome)&&S.URI.isUri(t.settingsResource)&&S.URI.isUri(t.keybindingsResource)&&S.URI.isUri(t.tasksResource)&&S.URI.isUri(t.snippetsHome)&&S.URI.isUri(t.extensionsResource))}e.$Wk=$,e.$Xk=(0,I.$2h)("IUserDataProfilesService");function h(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:S.URI.revive(s.location).with({scheme:t}),globalStorageHome:S.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:S.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:S.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:S.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:S.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:S.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:S.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Yk=h;function n(s,t,a,g,L,D){return{id:s,name:t,location:a,isDefault:!1,shortName:L?.shortName,icon:L?.icon,globalStorageHome:D&&L?.useDefaultFlags?.globalState?D.globalStorageHome:(0,C.$Dg)(a,"globalStorage"),settingsResource:D&&L?.useDefaultFlags?.settings?D.settingsResource:(0,C.$Dg)(a,"settings.json"),keybindingsResource:D&&L?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,C.$Dg)(a,"keybindings.json"),tasksResource:D&&L?.useDefaultFlags?.tasks?D.tasksResource:(0,C.$Dg)(a,"tasks.json"),snippetsHome:D&&L?.useDefaultFlags?.snippets?D.snippetsHome:(0,C.$Dg)(a,"snippets"),extensionsResource:D&&L?.useDefaultFlags?.extensions?D.extensionsResource:(0,C.$Dg)(a,"extensions.json"),cacheHome:(0,C.$Dg)(g,s),useDefaultFlags:L?.useDefaultFlags,isTransient:L?.transient}}e.$Zk=n;let i=class extends r.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,a,g,L){super(),this.t=t,this.u=a,this.w=g,this.y=L,this.f=!0,this.h=this.B(new R.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,C.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,C.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),a=[t];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,d.$Ef)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}a.push(n((0,C.$Ag)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},t))}}catch(D){this.y.error(D)}const g=new f.$Ac,L=new Map;if(a.length)try{const D=this.Q();if(D.workspaces)for(const[y,A]of Object.entries(D.workspaces)){const F=S.URI.parse(y),X=a.find(te=>te.id===A);X&&g.set(F,X)}if(D.emptyWindows)for(const[y,A]of Object.entries(D.emptyWindows)){const F=a.find(X=>X.id===A);F&&L.set(y,F)}}catch(D){this.y.error(D)}this.z={profiles:a,workspaces:g,emptyWindows:L}}return this.z}D(){const t=n("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const a="Temp",g=new RegExp(`${(0,u.$Ke)(a)}\\s(\\d+)`);let L=0;for(const y of this.profiles){const A=g.exec(y.name),F=A?parseInt(A[1]):0;L=F>L?F:L}const D=`${a} ${L+1}`;return this.createProfile((0,E.$Pi)((0,m.$mg)()).toString(16),D,{transient:!0},t)}async createNamedProfile(t,a,g){return this.createProfile((0,E.$Pi)((0,m.$mg)()).toString(16),t,a,g)}async createProfile(t,a,g,L){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(t,a,g);return L&&await this.setProfileForWorkspace(L,D),D}async F(t,a,g){if(!(0,d.$Ef)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let L=this.r.get(a);return L||(L=(async()=>{try{const D=this.profiles.find(F=>F.name===a||F.id===t);if(D)return D;const y=n(t,a,(0,C.$Dg)(this.profilesHome,t),this.g,g,this.defaultProfile);await this.u.createFolder(y.location);const A=[];return this.j.fire({profile:y,join(F){A.push(F)}}),await c.Promises.settled(A),this.I([y],[],[]),y}finally{this.r.delete(a)}})(),this.r.set(a,L)),L}async updateProfile(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(L=>L.id===t.id);if(!g)throw new Error(`Profile '${t.name}' does not exist`);return g=n(g.id,a.name??g.name,g.location,this.g,{shortName:a.shortName??g.shortName,icon:a.icon===null?void 0:a.icon??g.icon,transient:a.transient??g.isTransient,useDefaultFlags:a.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(L=>L.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const g=[];this.m.fire({profile:a,join(L){g.push(L)}});try{await Promise.allSettled(g)}catch(L){this.y.error(L)}for(const L of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(L)?.id&&this.C.emptyWindows.delete(L);for(const L of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(L)?.id&&this.C.workspaces.delete(L);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(L){(0,v.$Ck)(L)!==1&&this.y.error(L)}}async setProfileForWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(L=>L.id===a.id);if(!g)throw new Error(`Profile '${a.name}' does not exist`);this.L(t,g)}unsetWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}getProfileForWorkspace(t){const a=this.G(t);return S.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(t){return(0,b.$_h)(t)?t.uri:(0,b.$ei)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location)))}I(t,a,g){const L=[...this.profiles,...t],D=[];this.s.profiles=[];for(let y of L)y.isDefault||a.some(A=>y.id===A.id)||(y=g.find(A=>y.id===A.id)??y,y.isTransient?this.s.profiles.push(y):D.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(D),this.z=void 0,this.J(t,a,g)}J(t,a,g){this.h.fire({added:t,removed:a,updated:g,all:this.profiles})}L(t,a,g){g=a?.isTransient?!0:g,g||this.L(t,void 0,!0);const L=this.G(t),D=g?this.s:this.C;S.URI.isUri(L)?(D.workspaces.delete(L),a&&D.workspaces.set(L,a)):(D.emptyWindows.delete(L),a&&D.emptyWindows.set(L,a)),g||this.M()}M(){const t={};for(const[g,L]of this.C.workspaces.entries())t[g.toString()]=L.id;const a={};for(const[g,L]of this.C.emptyWindows.entries())a[g.toString()]=L.id;this.R({workspaces:t,emptyWindows:a}),this.z=void 0}N(t){const a={},g=this.D();if(t.workspaces)for(const[D,y]of Object.entries(t.workspaces)){const A=S.URI.parse(y);a[D]=this.w.extUri.isEqual(A,g.location)?g.id:this.w.extUri.basename(A)}const L={};if(t.emptyWindows)for(const[D,y]of Object.entries(t.emptyWindows)){const A=S.URI.parse(y);L[D]=this.w.extUri.isEqual(A,g.location)?g.id:this.w.extUri.basename(A)}return{workspaces:a,emptyWindows:L}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$1k=i,e.$1k=i=Fe([Le(0,w.$9h),Le(1,v.$lk),Le(2,p.$Vk),Le(3,k.$jj)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$2k=o}),define(be[259],ve([1,0,18,14,20,11,5,2,4,10,3,179,30,36,35,13,31,32,34,33]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=e.$Dp=e.$Cp=void 0;let $=class extends P.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,a,g,L,D,y){super(),this.z=t,this.C=a,this.D=g,this.F=L,this.G=D,this.H=y,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new S.$Sd),this.s=this.B(new S.$Sd),this.t=this.B(new S.$Sd),this.u=this.B(new S.$Sd),this.w=this.B(new S.$Sd),this.y=[],this.B((0,P.$Qc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some(g=>(0,b.$io)(g,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{const L=(await this.installGalleryExtensions([{extension:t,options:a}])).find(({identifier:D})=>(0,f.$Mo)(D,t.identifier));if(L?.local)return L?.local;throw L?.error?L.error:n(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(g){throw n(g)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new b.$lo(k.localize(0,null),b.ExtensionManagementErrorCode.Internal);const a=[],g=[];await Promise.allSettled(t.map(async({extension:L,options:D})=>{try{const y=await this.O(L,!!D?.installGivenVersion,!!D?.installPreReleaseVersion);g.push({...y,options:D})}catch(y){a.push({identifier:L.identifier,operation:2,source:L,error:y})}})),g.length&&a.push(...await this.I(g));for(const L of a)L.error&&(this.F.error("Failed to install extension.",L.identifier.id),this.F.error(L.error),L.source&&!I.URI.isUri(L.source)&&i(this.C,"extensionGallery:install",{extensionData:(0,f.$Uo)(L.source),error:L.error}));return a}async uninstall(t,a={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,a)}async toggleAppliationScope(t,a){if((0,p.$jm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let g=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(g=await this.ab(t,this.H.defaultProfile.extensionsResource,a));for(const L of this.H.profiles){const D=(await this.getInstalled(1,L.extensionsResource)).find(y=>(0,f.$Mo)(y.identifier,t.identifier));D?this.w.fire(D):this.u.fire({identifier:t.identifier,profileLocation:L.extensionsResource})}return g}else{const g=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:g.identifier,operation:2,local:g,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),g}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const a=[];return await Promise.allSettled(t.map(async g=>{try{const L=await this.J(g,(D,y)=>t.some(A=>(0,f.$Qo)(y.identifier.id)===(0,f.$Ro)(A.manifest.publisher,A.manifest.name))?!1:this.L(D,y));a.push(...L)}catch(L){a.push({identifier:{id:(0,f.$Ro)(g.manifest.publisher,g.manifest.name)},operation:2,source:g.extension,error:L})}})),this.s.fire(a),a}async J({manifest:t,extension:a,options:g},L){const D=g.isApplicationScoped||g.isBuiltin||(0,p.$jm)(t),y={...g,installOnlyNewlyAddedFromExtensionPack:I.URI.isUri(a)?g.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:D,profileLocation:D?this.H.defaultProfile.extensionsResource:g.profileLocation??this.Y()},A=ee=>`${f.$No.create(ee).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!I.URI.isUri(a)){const ee=this.j.get(A(a));if(ee)return this.F.info("Extensions is already requested to install",a.identifier.id),await ee.task.waitUntilTaskIsFinished(),[]}const F=[],X=[],te=[],J=this.Z(t,a,y);I.URI.isUri(a)||this.j.set(A(a),{task:J,waitingTasks:[]}),this.n.fire({identifier:J.identifier,source:a,profileLocation:y.profileLocation}),this.F.info("Installing extension:",J.identifier.id),F.push({task:J,manifest:t});let ie=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",J.identifier.id);else try{const U=await this.N(J.identifier,t,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),he=await this.getInstalled(void 0,y.profileLocation),Q={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[b.$do]:!0}};for(const{gallery:_,manifest:V}of(0,E.$Mb)(U,({gallery:G})=>G.identifier.id)){ie=ie||!!V.extensionDependencies?.some(le=>(0,f.$Mo)({id:le},J.identifier));const G=A(_),oe=this.j.get(G);if(oe){if(L(J,oe.task)){const le=oe.task.identifier;this.F.info("Waiting for already requested installing extension",le.id,J.identifier.id),oe.waitingTasks.push(J),X.push(S.Event.toPromise(S.Event.filter(this.onDidInstallExtensions,se=>se.some($e=>(0,f.$Mo)($e.identifier,le)))).then(se=>{if(this.F.info("Finished waiting for already requested installing extension",le.id,J.identifier.id),!se.find(z=>(0,f.$Mo)(z.identifier,le))?.local)throw new Error(`Extension ${le.id} is not installed`)}))}}else if(!he.some(({identifier:le})=>(0,f.$Mo)(le,_.identifier))){const le=this.Z(V,_,Q);this.j.set(G,{task:le,waitingTasks:[J]}),this.n.fire({identifier:le.identifier,source:_,profileLocation:y.profileLocation}),this.F.info("Installing extension:",le.identifier.id,J.identifier.id),F.push({task:le,manifest:V})}}}catch(U){if(I.URI.isUri(J.source))(0,E.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",J.identifier.id,U.message),(0,E.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",J.identifier.id,U.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",J.identifier.id),U}const ee=F.reduce((U,{task:he,manifest:Q})=>(U.set(he.identifier.id.toLowerCase(),{task:he,manifest:Q}),U),new Map);for(;ee.size;){let U;const he=[...ee.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(_=>ee.has(_.toLowerCase())));he.length?U=ee.size===1?he:he.filter(({task:Q})=>!(Q===J&&!ie)):(this.F.info("Found extensions with circular dependencies",he.map(({task:Q})=>Q.identifier.id)),U=[...ee.values()]),await this.M(U.map(async({task:Q})=>{const _=new Date().getTime();try{const V=await Q.run();if(await this.M(this.y.map(G=>G.postInstall(V,Q.source,y,r.CancellationToken.None))),!I.URI.isUri(Q.source)){const G=Q.operation===3,oe=G?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(i(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Uo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-_,durationSinceUpdate:oe}),w.$o&&Q.operation!==3)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}te.push({local:V,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw I.URI.isUri(Q.source)||i(this.C,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Uo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-_,error:V}),this.F.error("Error while installing the extension:",Q.identifier.id),V}finally{ee.delete(Q.identifier.id.toLowerCase())}}))}return X.length&&await this.M(X),te.forEach(({identifier:U})=>this.F.info("Extension installed successfully:",U.id)),te}catch(ee){if(F.forEach(({task:U})=>U.cancel()),te.length)try{const U=await Promise.allSettled(te.map(({local:he})=>this.$(he,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let he=0;he<U.length;he++){const Q=U[he],{identifier:_}=te[he];Q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",_.id):this.F.warn("Rollback: Error while uninstalling extension",_.id,(0,C.$0)(Q.reason))}}catch(U){this.F.warn("Error while rolling back extensions",(0,C.$0)(U),te.map(({identifier:he})=>he.id))}return F.map(({task:U})=>({identifier:U.identifier,operation:2,source:U.source,context:y.context,profileLocation:y.profileLocation,error:ee}))}finally{for(const{task:ee}of F)ee.source&&!I.URI.isUri(ee.source)&&this.j.delete(A(ee.source))}}L(t,a){for(const[,{task:g,waitingTasks:L}]of this.j.entries())if(g===t&&(L.includes(a)||L.some(D=>this.L(D,a)))||g===a&&L[0]&&!this.L(t,L[0]))return!1;return!0}async M(t){const a=[],g=[],L=await Promise.allSettled(t);for(const D of L)D.status==="fulfilled"?a.push(D.value):g.push(D.reason);if(g.length)throw h(g);return a}async N(t,a,g,L,D){if(!this.z.isEnabled())return[];const y=await this.getInstalled(void 0,D),A=[],F=[],X=async(te,J)=>{A.push(te);const ie=J.extensionDependencies||[],ee=[...ie];if(J.extensionPack){const U=g?y.find(he=>(0,f.$Mo)(he.identifier,te)):void 0;for(const he of J.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(Q=>(0,f.$Mo)({id:Q},{id:he}))||ee.every(Q=>!(0,f.$Mo)({id:Q},{id:he}))&&ee.push(he)}if(ee.length){const U=ee.filter(he=>A.every(Q=>!(0,f.$Mo)(Q,{id:he})));if(U.length){const he=await this.z.getExtensions(U.map(Q=>({id:Q,preRelease:L})),r.CancellationToken.None);for(const Q of he){if(A.find(G=>(0,f.$Mo)(G,Q.identifier)))continue;const _=ie.some(G=>(0,f.$Mo)({id:G},Q.identifier));let V;try{V=await this.O(Q,!1,L)}catch(G){if(_)throw G;this.F.info("Skipping the packed extension as it cannot be installed",Q.identifier.id,(0,C.$0)(G));continue}F.push({gallery:V.extension,manifest:V.manifest}),await X(V.extension.identifier,V.manifest)}}}};return await X(t,a),F}async O(t,a,g){let L;const D=await this.getExtensionsControlManifest();if(D.malicious.some(F=>(0,f.$Mo)(t.identifier,F)))throw new b.$lo(k.localize(1,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);const y=D.deprecated[t.identifier.id.toLowerCase()];if(y?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${y.extension.id}' extension instead.`),L=(await this.z.getExtensions([{id:y.extension.id,preRelease:y.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!L)throw new b.$lo(k.localize(2,null,t.identifier.id,y.extension.id),b.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const F=await this.getTargetPlatform();throw new b.$lo(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,b.$eo)(F)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(L=await this.P(t,a,g),!L)throw!g&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],r.CancellationToken.None))[0]?new b.$lo(k.localize(4,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.$lo(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),b.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",L.identifier.id);const A=await this.z.getManifest(L,r.CancellationToken.None);if(A===null)throw new b.$lo(`Missing manifest for extension ${L.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(A.version!==L.version)throw new b.$lo(`Cannot install '${L.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:L,manifest:A}}async P(t,a,g){const L=await this.getTargetPlatform();let D=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==g&&(D=(await this.z.getExtensions([{...t.identifier,preRelease:g}],{targetPlatform:L,compatible:!0},r.CancellationToken.None))[0]||null),!D&&await this.z.isExtensionCompatible(t,g,L)&&(D=t),D||(a?D=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:L,compatible:!0},r.CancellationToken.None))[0]||null:D=await this.z.getCompatibleExtension(t,g,L)),D}async Q(t,a){const g={...a,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},L=te=>`${te.id.toLowerCase()}${g.versionOnly?`-${t.manifest.version}`:""}${g.profileLocation?`@${g.profileLocation.toString()}`:""}`,D=this.m.get(L(t.identifier));if(D)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),D.waitUntilTaskIsFinished();const y=te=>{const J=this.$(te,g);return this.m.set(L(J.extension.identifier),J),g.profileLocation?this.F.info("Uninstalling extension from the profile:",`${te.identifier.id}@${te.manifest.version}`,g.profileLocation.toString()):this.F.info("Uninstalling extension:",`${te.identifier.id}@${te.manifest.version}`),this.t.fire({identifier:te.identifier,profileLocation:g.profileLocation,applicationScoped:te.isApplicationScoped}),J},A=(te,J)=>{J?g.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${te.identifier.id}@${te.manifest.version}`,g.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${te.identifier.id}@${te.manifest.version}`,J.message):g.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${te.identifier.id}@${te.manifest.version}`,g.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${te.identifier.id}@${te.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$To)(te),error:J}),this.u.fire({identifier:te.identifier,error:J?.code,profileLocation:g.profileLocation,applicationScoped:te.isApplicationScoped})},F=[],X=[];try{F.push(y(t));const te=await this.getInstalled(1,g.profileLocation);if(g.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.U(t,te);for(const ie of J)this.m.has(L(ie.identifier))?this.F.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(y(ie))}g.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(F.map(J=>J.extension),te,t),await this.M(F.map(async J=>{try{if(await J.run(),await this.M(this.y.map(ie=>ie.postUninstall(J.extension,g,r.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}A(J.extension)}catch(ie){const ee=ie instanceof b.$lo?ie:new b.$lo((0,C.$0)(ie),b.ExtensionManagementErrorCode.Internal);throw A(J.extension,ee),ee}finally{X.push(J)}}))}catch(te){const J=te instanceof b.$lo?te:new b.$lo((0,C.$0)(te),b.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}X.includes(ie)||A(ie.extension,J)}throw J}finally{for(const te of F)this.m.delete(L(te.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",te.extension.identifier.id)}}R(t,a,g){for(const L of t){const D=this.W(L,a);if(D.length){const y=D.filter(A=>!t.some(F=>(0,f.$Mo)(F.identifier,A.identifier)));if(y.length)throw new Error(this.S(L,y,g))}}}S(t,a,g){return g===t?a.length===1?k.localize(6,null,g.manifest.displayName||g.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?k.localize(7,null,g.manifest.displayName||g.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):k.localize(8,null,g.manifest.displayName||g.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?k.localize(9,null,g.manifest.displayName||g.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?k.localize(10,null,g.manifest.displayName||g.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):k.localize(11,null,g.manifest.displayName||g.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(t,a,g=[]){if(g.indexOf(t)!==-1)return[];g.push(t);const L=t.manifest.extensionPack?t.manifest.extensionPack:[];if(L.length){const D=a.filter(A=>!A.isBuiltin&&L.some(F=>(0,f.$Mo)({id:F},A.identifier))),y=[];for(const A of D)y.push(...this.U(A,a,g));return[...D,...y]}return[]}W(t,a){return a.filter(g=>g.manifest.extensionDependencies&&g.manifest.extensionDependencies.some(L=>(0,f.$Mo)({id:L},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Cp=$,e.$Cp=$=Fe([Le(0,b.$ko),Le(1,u.$pl),Le(2,d.$Vk),Le(3,c.$jj),Le(4,m.$Bj),Le(5,l.$Xk)],$);function h(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,g)=>new Error(`${a.message}${a.message?",":""}${g instanceof Error?g.message:g}`),new Error(""))}e.$Dp=h;function n(s){if(s instanceof b.$lo)return s;const t=new b.$lo(s.message,b.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$Ep=n;function i(s,t,{extensionData:a,verificationStatus:g,duration:L,error:D,durationSinceUpdate:y}){let A,F;(0,v.$Mf)(g)&&(g===!0?g="Verified":(g===!1||(A=b.ExtensionManagementErrorCode.Signature,F=g),g="Unverified")),D&&(D instanceof b.$lo?(A=D.code,D.code===b.ExtensionManagementErrorCode.Signature&&(F=D.message)):A=b.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...a,verificationStatus:g,success:!D,duration:L,errorcode:A,errorcodeDetail:F,durationSinceUpdate:y})}class o{constructor(){this.d=new R.$1g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Pg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Pg)(t=>new Promise((a,g)=>{const L=t.onCancellationRequested(()=>{L.dispose(),g(new C.$5)})})),this.d.open()),this.g.cancel()}}e.$Fp=o}),define(be[45],ve([1,0,14,15,2,5,26,3,30,36,16,6,13,33,34,10,11,32]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class l extends Error{constructor(o,s){super(o),this.code=s}}e.$Gp=l,e.$Hp=(0,k.$2h)("IExtensionsProfileScannerService");let $=class extends r.$Sc{constructor(o,s,t,a,g,L){super(),this.j=o,this.m=s,this.n=t,this.r=a,this.s=g,this.t=L,this.b=this.B(new C.$Sd),this.onAddExtensions=this.b.event,this.c=this.B(new C.$Sd),this.onDidAddExtensions=this.c.event,this.f=this.B(new C.$Sd),this.onRemoveExtensions=this.f.event,this.g=this.B(new C.$Sd),this.onDidRemoveExtensions=this.g.event,this.h=new S.$Ac}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s){const t=[],a=[];try{return await this.u(s,g=>{const L=[];for(const D of g)o.some(([y])=>(0,v.$Mo)(y.identifier,D.identifier)&&y.manifest.version!==D.version)?t.push(D):L.push(D);for(const[D,y]of o){const A=L.findIndex(X=>(0,v.$Mo)(X.identifier,D.identifier)&&X.version===D.manifest.version),F={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:y};A===-1?(a.push(F),L.push(F)):L.splice(A,1,F)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),L}),a.length&&this.c.fire({extensions:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),a}catch(g){throw a.length&&this.c.fire({extensions:a,error:g,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:g,profileLocation:s}),g}}async updateMetadata(o,s){const t=[];return await this.u(s,a=>{const g=[];for(const L of a){const D=o.find(([y])=>(0,v.$Mo)(y.identifier,L.identifier)&&y.manifest.version===L.version);D&&(L.metadata={...L.metadata,...D[1]},t.push(L)),g.push(L)}return g}),t}async removeExtensionFromProfile(o,s){const t=[];try{await this.u(s,a=>{const g=[];for(const L of a)(0,v.$Mo)(L.identifier,o.identifier)?t.push(L):g.push(L);return t.length&&this.f.fire({extensions:t,profileLocation:s}),g}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(a){throw t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async u(o,s,t){return this.F(o).queue(async()=>{let a=[],g;try{const L=await this.m.readFile(o);g=JSON.parse(L.value.toString().trim()||"[]")}catch(L){if((0,I.$Ck)(L)!==1)throw L;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(g=await this.D()),!g&&t?.bailOutWhenFileNotFound)throw new l((0,m.$0)(L),"ERROR_PROFILE_NOT_FOUND")}if(g){Array.isArray(g)||this.w(o);let L=!1;for(const D of g){h(D)||this.w(o);let y;if((0,c.$Ef)(D.relativeLocation)&&D.relativeLocation)y=this.z(D.relativeLocation);else if((0,c.$Ef)(D.location))y=this.z(D.location),L=!0,D.relativeLocation=D.location,D.location=y.toJSON();else{y=P.URI.revive(D.location);const A=this.y(y);A&&(L=!0,D.relativeLocation=A)}a.push({identifier:D.identifier,location:y,version:D.version,metadata:D.metadata})}L&&await this.m.writeFile(o,R.$ge.fromString(JSON.stringify(g)))}if(s){a=s(a);const L=a.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,R.$ge.fromString(JSON.stringify(L)))}return a})}w(o){const s=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(o)).value.toString()}catch(g){if((0,I.$Ck)(g)===1)return;throw g}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const g=JSON.parse(t);Array.isArray(g)&&g.every(L=>h(L))?a=g:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",g)}catch(g){this.t.error(g)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ge.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(g){if((0,I.$Ck)(g)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw g}try{await this.m.del(o)}catch(g){(0,I.$Ck)(g)!==1&&this.t.error(g)}try{await this.m.del(s)}catch(g){(0,I.$Ck)(g)!==1&&this.t.error(g)}return a})()),this.C}F(o){let s=this.h.get(o);return s||(s=new E.$9g,this.h.set(o,s)),s}};e.$Ip=$,e.$Ip=$=Fe([Le(1,I.$lk),Le(2,f.$Xk),Le(3,p.$Vk),Le(4,u.$pl),Le(5,b.$jj)],$);function h(i){return(0,c.$Gf)(i)&&(0,w.$jo)(i.identifier)&&(n(i.location)||(0,c.$Ef)(i.location)&&i.location)&&((0,c.$Lf)(i.relativeLocation)||(0,c.$Ef)(i.relativeLocation))&&i.version&&(0,c.$Ef)(i.version)}function n(i){return i?(0,c.$Ef)(i.path)&&(0,c.$Ef)(i.scheme):!1}}),define(be[58],ve([1,0,18,14,23,15,11,76,163,2,12,7,4,19,53,62,10,3,183,25,36,35,82,16,6,13,31,5,50,45,33,34,213]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i,o,s,t,a,g,L,D,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.$Np=e.$Mp=e.$Lp=e.Translations=void 0;var F;(function(he){function Q(_,V){if(_===V)return!0;const G=Object.keys(_),oe=new Set;for(const le of Object.keys(V))oe.add(le);if(G.length!==oe.size)return!1;for(const le of G){if(_[le]!==V[le])return!1;oe.delete(le)}return oe.size===0}he.equals=Q})(F||(e.Translations=F={})),e.$Lp=(0,o.$2h)("IExtensionsScannerService");let X=class extends v.$Sc{constructor(Q,_,V,G,oe,le,se,$e,z,q,O,j){super(),this.systemExtensionsLocation=Q,this.userExtensionsLocation=_,this.r=V,this.s=G,this.t=oe,this.u=le,this.w=se,this.y=$e,this.z=z,this.C=q,this.D=O,this.F=j,this.g=this.B(new a.$Sd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Dg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(J,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$Xo)(this.w,this.y)),this.G}async scanAllExtensions(Q,_,V){const[G,oe]=await Promise.all([this.scanSystemExtensions(Q),this.scanUserExtensions(_)]),le=V?await this.scanExtensionsUnderDevelopment(Q,[...G,...oe]):[];return this.L(G,oe,le,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Q){const _=[];_.push(this.M(!!Q.useCache,Q.language)),_.push(this.N(Q.language,!!Q.checkControlFile));const[V,G]=await Promise.all(_);return this.J([...V,...G],0,Q,!1)}async scanUserExtensions(Q){const _=Q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const V=this.D.extUri.isEqual(Q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,G=await this.P(_,!!Q.profileLocation,1,!Q.includeUninstalled,Q.language,!0,V),oe=Q.useCache&&!G.devMode&&G.excludeObsolete?this.m:this.n;let le;try{le=await oe.scanExtensions(G)}catch(se){if(se instanceof L.$Gp&&se.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),le=await oe.scanExtensions(G);else throw se}return le=await this.J(le,1,Q,!0),this.y.trace("Scanned user extensions:",le.length),le}async scanExtensionsUnderDevelopment(Q,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(G=>G.scheme===I.Schemas.file).map(async G=>{const oe=await this.P(G,!1,1,!0,Q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(oe)).map(se=>(se.type=_.find($e=>(0,$.$Mo)($e.identifier,se.identifier))?.type??se.type,this.n.validate(se,oe)))}))).flat();return this.J(V,"development",Q,!0)}return[]}async scanExistingExtension(Q,_,V){const G=await this.P(Q,!1,_,!0,V.language,!0,void 0),oe=await this.n.scanExtension(G);return!oe||!V.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(Q,_,V){const G=await this.P(Q,!1,_,!0,V.language,!0,void 0),oe=await this.n.scanOneOrMultipleExtensions(G);return this.J(oe,_,V,!0)}async scanMetadata(Q){const _=(0,f.$Dg)(Q,"package.json"),V=(await this.w.readFile(_)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(Q,_){const V=(0,f.$Dg)(Q,"package.json"),G=(await this.w.readFile(V)).value.toString(),oe=JSON.parse(G);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,oe.__metadata={...oe.__metadata,..._},await this.w.writeFile((0,f.$Dg)(Q,"package.json"),C.$ge.fromString(JSON.stringify(oe,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Q){if(Q instanceof L.$Gp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Q=await this.scanUserExtensions({includeInvalid:!0});if(Q.length)await this.u.addExtensionsToProfile(Q.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,C.$ge.fromString(JSON.stringify([])))}catch(_){(0,i.$Ck)(_)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,S.$0)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Q){this.y.error(Q)}finally{this.H=void 0}})()),this.H}async J(Q,_,V,G){return V.includeAllVersions||(Q=this.L(_===0?Q:void 0,_===1?Q:void 0,_==="development"?Q:void 0,await this.getTargetPlatform(),G)),V.includeInvalid||(Q=Q.filter(oe=>oe.isValid)),Q.sort((oe,le)=>{const se=k.$nc(oe.location.fsPath),$e=k.$nc(le.location.fsPath);return se<$e?-1:se>$e?1:0})}L(Q,_,V,G,oe){const le=($e,z,q)=>{if($e.isValid&&!z.isValid)return!1;if($e.isValid===z.isValid){if(oe&&p.gt($e.manifest.version,z.manifest.version))return this.y.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${$e.location.path} with version ${$e.manifest.version}`),!1;if(p.eq($e.manifest.version,z.manifest.version)){if($e.type===0)return this.y.debug(`Skipping extension ${z.location.path} in favour of system extension ${$e.location.path} with same version`),!1;if($e.targetPlatform===G)return this.y.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${$e.location.path} with ${z.location.path}.`):this.y.debug(`Overwriting user extension ${$e.location.path} with ${z.location.path}.`),!0},se=new h.$im;return Q?.forEach($e=>{const z=se.get($e.identifier.id);(!z||le(z,$e,!1))&&se.set($e.identifier.id,$e)}),_?.forEach($e=>{const z=se.get($e.identifier.id);if(!z&&Q&&$e.type===0){this.y.debug(`Skipping obsolete system extension ${$e.location.path}.`);return}(!z||le(z,$e,!1))&&se.set($e.identifier.id,$e)}),V?.forEach($e=>{const z=se.get($e.identifier.id);(!z||le(z,$e,!0))&&se.set($e.identifier.id,$e),se.set($e.identifier.id,$e)}),[...se.values()]}async M(Q,_){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,_,!0,void 0),oe=await(Q&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",oe.length),oe}async N(Q,_){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const G=_?await this.O():{},oe=[],le=u.URI.file(k.$hc(k.$jc(I.$kg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const $e of V){const z=G[$e.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":oe.push((0,f.$Dg)(le,$e.name));break;default:oe.push(u.URI.file(z));break}}const se=await Promise.all(oe.map(async $e=>this.n.scanExtension(await this.P($e,!1,0,!0,Q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",se.length),(0,E.$Hb)(se)}async O(){try{const Q=await this.w.readFile(this.r);return JSON.parse(Q.value.toString())}catch{return{}}}async P(Q,_,V,G,oe,le,se){const $e=await this.f(oe??b.$w),z=await this.Q(Q),q=_&&!this.D.extUri.isEqual(Q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=q?await this.Q(q):void 0;return new te(Q,z,q,O,_,se,V,G,le,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,oe,$e)}async Q(Q){try{const _=await this.w.stat(Q);if(typeof _.mtime=="number")return _.mtime}catch{}}};e.$Mp=X,e.$Mp=X=Fe([Le(4,D.$Xk),Le(5,L.$Hp),Le(6,i.$lk),Le(7,s.$jj),Le(8,l.$9h),Le(9,t.$Bj),Le(10,y.$Vk),Le(11,o.$1h)],X);class te{constructor(Q,_,V,G,oe,le,se,$e,z,q,O,j,ne,Y,Z){this.location=Q,this.mtime=_,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=G,this.profile=oe,this.profileScanOptions=le,this.type=se,this.excludeObsolete=$e,this.validate=z,this.productVersion=q,this.productDate=O,this.productCommit=j,this.devMode=ne,this.language=Y,this.translations=Z}static createNlsConfiguration(Q){return{language:Q.language,pseudo:Q.language==="pseudo",devMode:Q.devMode,translations:Q.translations}}static equals(Q,_){return(0,f.$wg)(Q.location,_.location)&&Q.mtime===_.mtime&&(0,f.$wg)(Q.applicationExtensionslocation,_.applicationExtensionslocation)&&Q.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&Q.profile===_.profile&&r.$ln(Q.profileScanOptions,_.profileScanOptions)&&Q.type===_.type&&Q.excludeObsolete===_.excludeObsolete&&Q.validate===_.validate&&Q.productVersion===_.productVersion&&Q.productDate===_.productDate&&Q.productCommit===_.productCommit&&Q.devMode===_.devMode&&Q.language===_.language&&F.equals(Q.translations,_.translations)}}e.$Np=te;let J=class extends v.$Sc{constructor(Q,_,V,G,oe){super(),this.f=Q,this.g=_,this.h=V,this.j=G,this.m=oe}async scanExtensions(Q){const _=Q.profile?await this.r(Q):await this.n(Q);let V={};if(Q.excludeObsolete&&Q.type===1)try{const G=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(G)}catch{}return(0,m.$Rf)(V)?_:_.filter(G=>!V[$.$No.create(G).toString()])}async n(Q){const _=await this.j.resolve(Q.location);if(!_.children?.length)return[];const V=await Promise.all(_.children.map(async G=>{if(!G.isDirectory||Q.type===1&&(0,f.$Ag)(G.resource).indexOf(".")===0)return null;const oe=new te(G.resource,Q.mtime,Q.applicationExtensionslocation,Q.applicationExtensionslocationMtime,Q.profile,Q.profileScanOptions,Q.type,Q.excludeObsolete,Q.validate,Q.productVersion,Q.productDate,Q.productCommit,Q.devMode,Q.language,Q.translations);return this.scanExtension(oe)}));return(0,E.$Hb)(V).sort((G,oe)=>G.location.path<oe.location.path?-1:1)}async r(Q){let _=await this.s(Q.location,()=>!0,Q);if(Q.applicationExtensionslocation&&!this.h.extUri.isEqual(Q.location,Q.applicationExtensionslocation)){_=_.filter(G=>!G.metadata?.isApplicationScoped);const V=await this.s(Q.applicationExtensionslocation,G=>!!G.metadata?.isBuiltin||!!G.metadata?.isApplicationScoped,Q);_.push(...V)}return _}async s(Q,_,V){const G=await this.g.scanProfileExtensions(Q,V.profileScanOptions);if(!G.length)return[];const oe=await Promise.all(G.map(async le=>{if(_(le)){const se=new te(le.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(se,le.metadata)}return null}));return(0,E.$Hb)(oe)}async scanOneOrMultipleExtensions(Q){try{if(await this.j.exists((0,f.$Dg)(Q.location,"package.json"))){const _=await this.scanExtension(Q);return _?[_]:[]}else return await this.scanExtensions(Q)}catch(_){return this.m.error(`Error scanning extensions at ${Q.location.path}:`,(0,S.$0)(_)),[]}}async scanExtension(Q,_){try{let V=await this.scanExtensionManifest(Q.location);if(V){V.publisher||(V.publisher=h.$cm),_=_??V.__metadata,delete V.__metadata;const G=(0,$.$Ro)(V.publisher,V.name),oe=_?.id?{id:G,uuid:_.id}:{id:G},le=_?.isSystem?0:Q.type,se=le===0||!!_?.isBuiltin;V=await this.t(Q.location,V,te.createNlsConfiguration(Q));const $e={type:le,identifier:oe,manifest:V,location:Q.location,isBuiltin:se,targetPlatform:_?.targetPlatform??"undefined",metadata:_,isValid:!0,validations:[]};return Q.validate?this.validate($e,Q):$e}}catch(V){Q.type!==0&&this.m.error(V)}return null}validate(Q,_){let V=!0;const G=(0,n.$3o)(_.productVersion,_.productDate,_.location,Q.manifest,Q.isBuiltin);for(const[oe,le]of G)oe===c.default.Error&&(V=!1,this.m.error(this.z(_.location,le)));return Q.isValid=V,Q.validations=G,Q}async scanExtensionManifest(Q){const _=(0,f.$Dg)(Q,"package.json");let V;try{V=(await this.j.readFile(_)).value.toString()}catch(oe){return(0,i.$Ck)(oe)!==1&&this.m.error(this.z(Q,(0,d.localize)(0,null,_.path,oe.message))),null}let G;try{G=JSON.parse(V)}catch{const le=[];(0,P.$0m)(V,le);for(const se of le)this.m.error(this.z(Q,(0,d.localize)(1,null,_.path,se.offset,se.length,(0,w.$Jp)(se.error))));return null}return(0,P.$gn)(G)!=="object"?(this.m.error(this.z(Q,(0,d.localize)(2,null,_.path))),null):G}async t(Q,_,V){const G=await this.u(Q,_,V);if(G)try{const oe=[],le=await this.w(G.default,oe);if(oe.length>0)return oe.forEach($e=>{this.m.error(this.z(Q,(0,d.localize)(3,null,G.default?.path,(0,w.$Jp)($e.error))))}),_;if((0,P.$gn)(G)!=="object")return this.m.error(this.z(Q,(0,d.localize)(4,null,G.default?.path))),_;const se=G.values||Object.create(null);return(0,A.$Kp)(this.m,_,se,le)}catch{}return _}async u(Q,_,V){const G=(0,f.$Dg)(Q,"package.nls.json"),oe=(z,q)=>{q.forEach(O=>{this.m.error(this.z(Q,(0,d.localize)(5,null,z?.path,(0,w.$Jp)(O.error))))})},le=z=>{this.m.error(this.z(Q,(0,d.localize)(6,null,z?.path)))},se=`${_.publisher}.${_.name}`,$e=V.translations[se];if($e)try{const z=u.URI.file($e),q=(await this.j.readFile(z)).value.toString(),O=[],j=(0,P.$0m)(q,O);return O.length>0?(oe(z,O),{values:void 0,default:G}):(0,P.$gn)(j)!=="object"?(le(z),{values:void 0,default:G}):{values:j.contents?j.contents.package:void 0,default:G}}catch{return{values:void 0,default:G}}else{if(!await this.j.exists(G))return;let q;try{q=await this.y(Q,V)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const O=(await this.j.readFile(q.localized)).value.toString(),j=[],ne=(0,P.$0m)(O,j);return j.length>0?(oe(q.localized,j),{values:void 0,default:q.original}):(0,P.$gn)(ne)!=="object"?(le(q.localized),{values:void 0,default:q.original}):{values:ne,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(Q,_){if(Q)try{const V=(await this.j.readFile(Q)).value.toString();return(0,P.$0m)(V,_)}catch{}}y(Q,_){return new Promise((V,G)=>{const oe=le=>{const se=(0,f.$Dg)(Q,`package.nls.${le}.json`);this.j.exists(se).then($e=>{$e&&V({localized:se,original:(0,f.$Dg)(Q,"package.nls.json")});const z=le.lastIndexOf("-");z===-1?V({localized:(0,f.$Dg)(Q,"package.nls.json"),original:null}):(le=le.substring(0,z),oe(le))})};if(_.devMode||_.pseudo||!_.language)return V({localized:(0,f.$Dg)(Q,"package.nls.json"),original:null});oe(_.language)})}z(Q,_){return`[${Q.path}]: ${_}`}};J=Fe([Le(1,L.$Hp),Le(2,y.$Vk),Le(3,i.$lk),Le(4,s.$jj)],J);let ie=class extends J{constructor(Q,_,V,G,oe,le,se){super(_,G,oe,le,se),this.G=Q,this.H=V,this.D=this.B(new R.$Zg(3e3)),this.F=this.B(new a.$Sd),this.onDidChangeCache=this.F.event}async scanExtensions(Q){const _=this.M(Q),V=await this.I(_);if(this.C=Q,V&&V.input&&te.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",Q.location.toString()),this.D.trigger(()=>this.L()),V.result.map(oe=>(oe.location=u.URI.revive(oe.location),oe));const G=await super.scanExtensions(Q);return await this.J(_,{input:Q,result:G}),G}async I(Q){try{const _=await this.j.readFile(Q),V=JSON.parse(_.value.toString());return{result:V.result,input:(0,g.$yh)(V.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",Q.path,(0,S.$0)(_))}return null}async J(Q,_){try{await this.j.writeFile(Q,C.$ge.fromString(JSON.stringify(_)))}catch(V){this.m.debug("Error while writing the extension cache file:",Q.path,(0,S.$0)(V))}}async L(){if(!this.C)return;const Q=this.M(this.C),_=await this.I(Q);if(!_)return;const V=_.result,G=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!r.$ln(G,V))try{this.m.info("Invalidating Cache",V,G),await this.j.del(Q),this.F.fire()}catch(oe){this.m.error(oe)}}M(Q){const _=this.N(Q);return this.h.extUri.joinPath(_.cacheHome,Q.type===0?h.$bm:h.$am)}N(Q){return Q.type===0?this.H.defaultProfile:Q.profile?this.h.extUri.isEqual(Q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(Q.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ie=Fe([Le(2,D.$Xk),Le(3,L.$Hp),Le(4,y.$Vk),Le(5,i.$lk),Le(6,s.$jj)],ie);function ee(he,Q){const _=(0,$.$Po)(he.manifest.publisher,he.manifest.name);return{id:_,identifier:new h.$gm(_),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:Q,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.$Op=ee;class U extends X{constructor(Q,_,V,G,oe,le,se,$e,z,q,O,j){super(Q,_,(0,f.$Dg)(V,".vscode-oss-dev","extensions","control.json"),G,oe,le,se,$e,z,q,O,j),this.R=(async()=>{if(b.$z)try{const ne=await this.w.readFile(u.URI.file(b.$z));return JSON.parse(ne.value.toString())}catch{}return Object.create(null)})()}f(Q){return this.R}}e.$Pp=U}),define(be[260],ve([1,0,52,14,39,5,2,12,7,22,13,33]),function(ue,e,E,R,r,C,S,P,w,v,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;let b=class extends S.$Sc{constructor(p,c){super(),this.b=p,this.f=c,this.a=new R.$8g(5)}async postUninstall(p){const c=this.g(p,"uninstall");c&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(c.script,"uninstall",c.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(m)}}));try{await v.Promises.rm(this.m(p))}catch(m){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(m)}}g(p,c){const m=`vscode:${c}`;if(p.location.scheme===P.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[m]=="string"){const u=p.manifest.scripts[m].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${m} should be a node script`),null):{script:(0,w.$jc)(p.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(p,c,m,u,d){return new Promise((l,$)=>{const h=this.j(p,c,m,d);let n;const i=o=>{n&&(clearTimeout(n),n=null),o?$(o):l(void 0)};h.on("error",o=>{i((0,r.$Mi)(o)||"Unknown")}),h.on("exit",(o,s)=>{i(o?`post-${c} process exited with code ${o}`:void 0)}),u&&(n=setTimeout(()=>{n=null,h.kill(),$("timed out")},5e3))})}j(p,c,m,u){const d={silent:!0,execArgv:void 0},l=(0,E.fork)(p,[`--type=extension-post-${c}`,...m],d);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const $=C.Event.fromNodeEventEmitter(l.stdout,"data"),h=C.Event.fromNodeEventEmitter(l.stderr,"data");$(o=>this.f.info(u.identifier.id,u.manifest.version,`post-${c}`,o)),h(o=>this.f.error(u.identifier.id,u.manifest.version,`post-${c}`,o));const n=C.Event.any(C.Event.map($,o=>({data:`%c${o}`,format:[""]})),C.Event.map(h,o=>({data:`%c${o}`,format:["color: red"]})));return C.Event.debounce(n,(o,s)=>o?{data:o.data+s.data,format:[...o.format,...s.format]}:{data:s.data,format:s.format},100)(o=>{console.group(u.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),l}m(p){return(0,w.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$Rp=b,e.$Rp=b=Fe([Le(0,k.$Xk),Le(1,I.$jj)],b)}),define(be[124],ve([1,0,14,15,20,39,11,5,61,2,26,12,7,19,53,10,3,21,22,81,184,83,25,259,30,36,45,58,243,260,214,234,244,82,16,6,13,31,32,34,33]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i,o,s,t,a,g,L,D,y,A,F,X,te,J,ie,ee,U,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0,e.$Vp=(0,te.$3h)(o.$mo);const Q=".vsctmp";let _=class extends i.$Cp{constructor(z,q,O,j,ne,Y,Z,B,H,T,W,x){super(z,q,W,O,T,x),this.fb=ne,this.gb=Y,this.hb=Z,this.ib=H,this.eb=new Map,this.rb=new I.$Bc;const re=this.B(B.createInstance(L.$Rp));this.bb=this.B(B.createInstance(V,ce=>re.postUninstall(ce))),this.cb=this.B(new y.$Tp(x,H,W,this,this.F)),this.db=this.B(B.createInstance(g.$Qp));const fe=this.B(new A.$Up(this,this.fb,x,Y,W,H,O));this.B(fe.onDidChangeExtensionsByAnotherSource(ce=>this.qb(ce))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Xo)(this.ib,this.F)),this.jb}async zip(z){this.F.trace("ExtensionManagementService#zip",z.identifier.id);const q=await this.pb(z),O=await(0,l.zip)((0,f.$Dg)(this.db.extensionsDownloadDir,(0,u.$mg)()).fsPath,q);return m.URI.file(O)}async unzip(z){return this.F.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:q,cleanup:O}=await this.lb(z),j=b.$kc(q.fsPath);try{return await(0,D.$Sp)(j)}finally{await O()}}getInstalled(z,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(z??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(z){return this.bb.scanUserExtensionAtLocation(z)}async install(z,q={}){this.F.trace("ExtensionManagementService#install",z.toString());const{location:O,cleanup:j}=await this.lb(z);try{const ne=await(0,D.$Sp)(b.$kc(O.fsPath)),Y=(0,s.$Ro)(ne.publisher,ne.name);if(ne.engines&&ne.engines.vscode&&!(0,F.$5o)(ne.engines.vscode,this.G.version,this.G.date))throw new Error($.localize(0,null,Y,this.G.version));const B=(await this.I([{manifest:ne,extension:O,options:q}])).find(({identifier:H})=>(0,s.$Mo)(H,{id:Y}));if(B?.local)return B.local;throw B?.error?B.error:(0,i.$Ep)(new Error(`Unknown error while installing extension ${Y}`))}finally{await j()}}async installFromLocation(z,q){this.F.trace("ExtensionManagementService#installFromLocation",z.toString());const O=await this.bb.scanUserExtensionAtLocation(z);if(!O)throw new Error(`Cannot find a valid extension from the location ${z.toString()}`);return await this.ub([[O,void 0]],q),this.F.info("Successfully installed extension",O.identifier.id,q.toString()),O}async installExtensionsFromProfile(z,q,O){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",z,q.toString(),O.toString());const j=(await this.bb.scanExtensions(1,q)).filter(ne=>z.some(Y=>(0,s.$Mo)(Y,ne.identifier)));if(j.length){const ne=await Promise.all(j.map(Y=>this.bb.scanMetadata(Y,q)));await this.ub(j.map((Y,Z)=>[Y,ne[Z]]),O),this.F.info("Successfully installed extensions",j.map(Y=>Y.identifier.id),O.toString())}return j}async updateMetadata(z,q,O=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",z.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),z=await this.bb.updateMetadata(z,q,O),this.cb.invalidate(O),this.w.fire(z),z}async reinstallFromGallery(z){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",z.identifier.id),!this.z.isEnabled())throw new Error($.localize(1,null));const q=await this.getTargetPlatform(),[O]=await this.z.getExtensions([{...z.identifier,preRelease:z.preRelease}],{targetPlatform:q,compatible:!0},r.CancellationToken.None);if(!O)throw new Error($.localize(2,null));await this.bb.setUninstalled(z);try{await this.bb.removeUninstalledExtension(z)}catch(j){throw new Error($.localize(3,null,(0,C.$Mi)(j)))}return this.installFromGallery(O)}ab(z,q,O,j){return this.bb.copyExtension(z,q,O,j)}copyExtensions(z,q){return this.bb.copyExtensions(z,q)}markAsUninstalled(...z){return this.bb.setUninstalled(...z)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(z){this.F.error(z)}}async download(z,q,O){const{location:j}=await this.db.download(z,q,!O);return j}async lb(z){if(z.scheme===k.Schemas.file)return{location:z,async cleanup(){}};this.F.trace("Downloading extension from",z.toString());const q=(0,f.$Dg)(this.db.extensionsDownloadDir,(0,u.$mg)());return await this.hb.download(z,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(j){this.F.error(j)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(z,q,O){if(m.URI.isUri(q))return new le(z,q,O,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const j=s.$No.create(q).toString();let ne=this.eb.get(j);return ne||(this.eb.set(j,ne=new oe(z,q,O,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),ne.waitUntilTaskIsFinished().finally(()=>this.eb.delete(j))),ne}$(z,q){return new se(z,q.profileLocation,this.gb)}async pb(z){const q=async j=>{let ne=await d.Promises.readdir(j);ne=ne.map(B=>b.$jc(j,B));const Y=await Promise.all(ne.map(B=>d.Promises.stat(B)));let Z=Promise.resolve([]);return Y.forEach((B,H)=>{const T=ne[H];B.isFile()&&(Z=Z.then(W=>[...W,T])),B.isDirectory()&&(Z=Z.then(W=>q(T).then(x=>[...W,...x])))}),Z};return(await q(z.location.fsPath)).map(j=>({path:`extension/${b.$lc(z.location.fsPath,j)}`,localPath:j}))}async qb({added:z,removed:q}){if(q){const O=z&&this.D.extUri.isEqual(q.profileLocation,z.profileLocation)?q.extensions.filter(j=>z.extensions.every(ne=>!(0,s.$Mo)(ne,j))):q.extensions;for(const j of O)this.F.info("Extensions removed from another source",j.id,q.profileLocation.toString()),this.u.fire({identifier:j,profileLocation:q.profileLocation})}if(z){const j=(await this.bb.scanExtensions(1,z.profileLocation)).filter(ne=>z.extensions.some(Y=>(0,s.$Mo)(Y,ne.identifier)));this.s.fire(j.map(ne=>(this.F.info("Extensions added from another source",ne.identifier.id,z.profileLocation.toString()),{identifier:ne.identifier,local:ne,profileLocation:z.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const z=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of z.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(z){if(!z.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const O of z.rawAdded){if(this.rb.has(O)||!this.D.extUri.isEqual(this.D.extUri.dirname(O),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(O,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(O).startsWith(".")||!(await this.ib.stat(O)).isDirectory)continue;const j=await this.bb.scanUserExtensionAtLocation(O);j&&j.installedTimestamp===void 0&&(this.rb.add(O),q.push(j))}q.length&&(await this.ub(q.map(O=>[O,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(O=>O.identifier.id)))}async ub(z,q){const O=z.map(j=>j[0]);await this.vb(O),await this.gb.addExtensionsToProfile(z,q),this.s.fire(O.map(j=>({local:j,identifier:j.identifier,operation:1,profileLocation:q})))}async vb(z){const q=await this.bb.getUninstalledExtensions();for(const O of z){const j=s.$No.create(O);q[j.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",j.id),await this.bb.setInstalled(j),this.F.info("Removed the extension from uninstalled list:",j.id))}}};e.$Wp=_,e.$Wp=_=Fe([Le(0,o.$ko),Le(1,ee.$pl),Le(2,J.$jj),Le(3,n.$0h),Le(4,a.$Lp),Le(5,t.$Hp),Le(6,h.$2n),Le(7,te.$1h),Le(8,X.$lk),Le(9,ie.$Bj),Le(10,U.$Vk),Le(11,he.$Xk)],_);let V=class extends v.$Sc{constructor(z,q,O,j,ne,Y){super(),this.j=z,this.m=q,this.n=O,this.s=j,this.t=ne,this.u=Y,this.h=this.B(new P.$Sd),this.onExtract=this.h.event,this.c=(0,f.$Dg)(this.n.userExtensionsLocation,".obsolete"),this.g=new E.$9g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(z,q){const O={includeInvalid:!0,profileLocation:q};let j=[];return z===null||z===0?j.push(...await this.n.scanAllExtensions({includeInvalid:!0},O,!1)):z===1&&j.push(...await this.n.scanUserExtensions(O)),j=z!==null?j.filter(ne=>ne.type===z):j,Promise.all(j.map(ne=>this.F(ne)))}async scanAllUserExtensions(z){const q=await this.n.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(q.map(O=>this.F(O)))}async scanUserExtensionAtLocation(z){try{const q=await this.n.scanExistingExtension(z,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(z,q,O,j,ne){const Y=z.toString(),Z=m.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$mg)()}`)),B=m.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,Y));let H=await this.m.exists(B);if(H&&j){try{await this.y(z.id,B,"removeExisting")}catch{throw new o.$lo($.localize(4,null,B.fsPath,z.id),o.ExtensionManagementErrorCode.Delete)}H=!1}if(!H)try{try{this.u.trace(`Started extracting the extension from ${q} to ${B.fsPath}`),await(0,l.$Ap)(q,Z.fsPath,{sourcePath:"extension",overwrite:!0},ne),this.u.info(`Extracted extension to ${B}:`,z.id)}catch(T){let W=o.ExtensionManagementErrorCode.Extract;throw T instanceof l.$yp&&(T.type==="CorruptZip"?W=o.ExtensionManagementErrorCode.CorruptZip:T.type==="Incomplete"&&(W=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$lo(T.message,W)}await this.n.updateMetadata(Z,O);try{this.u.trace(`Started renaming the extension from ${Z.fsPath} to ${B.fsPath}`),await this.C(Z.fsPath,B.fsPath),this.u.info("Renamed to",B.fsPath)}catch(T){if(T.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.u.info(`Rename failed because of ${(0,S.$0)(T)}. Deleted from extracted location`,Z),T}this.h.fire(B)}catch(T){try{await this.m.del(Z,{recursive:!0})}catch{}throw T}return this.D(B,1)}async scanMetadata(z,q){return q?(await this.w(z,q))?.metadata:this.n.scanMetadata(z.location)}async w(z,q){return(await this.s.scanProfileExtensions(q)).find(j=>(0,s.$Mo)(j.identifier,z.identifier))}async updateMetadata(z,q,O){return O?await this.s.updateMetadata([[z,q]],O):await this.n.updateMetadata(z.location,q),this.D(z.location,z.type,O)}getUninstalledExtensions(){return this.z()}async setUninstalled(...z){const q=z.map(O=>s.$No.create(O));await this.z(O=>q.forEach(j=>{O[j.toString()]=!0,this.u.info("Marked extension as uninstalled",j.toString())}))}async setInstalled(z){await this.z(q=>delete q[z.toString()])}async removeExtension(z,q){if(this.t.extUri.isEqualOrParent(z.location,this.n.userExtensionsLocation))return this.y(z.identifier.id,z.location,q)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.z(q=>delete q[s.$No.create(z).toString()])}async copyExtension(z,q,O,j){const ne=await this.w(z,q),Y=await this.w(z,O);return j={...ne?.metadata,...j},Y?await this.s.updateMetadata([[z,{...Y.metadata,...j}]],O):await this.s.addExtensionsToProfile([[z,j]],O),this.D(z.location,z.type,O)}async copyExtensions(z,q){const O=await this.scanExtensions(1,z),j=await Promise.all(O.filter(ne=>!ne.isApplicationScoped).map(async ne=>[ne,await this.scanMetadata(ne,z)]));await this.s.addExtensionsToProfile(j,q)}async y(z,q,O){this.u.trace(`Deleting ${O} extension from disk`,z,q.fsPath);const j=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,w.$Pi)((0,u.$mg)()).toString(16)}${Q}`);await this.C(q.fsPath,j.fsPath),await this.m.del(j,{recursive:!0}),this.u.info(`Deleted ${O} extension from disk`,z,q.fsPath)}async z(z){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(j){if((0,X.$Ck)(j)!==1)throw j}let O={};if(q)try{O=JSON.parse(q)}catch{}return z&&(z(O),Object.keys(O).length?await this.m.writeFile(this.c,R.$ge.fromString(JSON.stringify(O))):await this.m.del(this.c)),O})}async C(z,q){try{await d.Promises.rename(z,q,2*60*1e3)}catch(O){throw new o.$lo(O.message||$.localize(5,null,z,q),O.code||o.ExtensionManagementErrorCode.Rename)}}async D(z,q,O){if(O){const ne=(await this.n.scanUserExtensions({profileLocation:O})).find(Y=>this.t.extUri.isEqual(Y.location,z));if(ne)return this.F(ne)}else{const j=await this.n.scanExistingExtension(z,q,{includeInvalid:!0});if(j)return this.F(j)}throw new Error($.localize(6,null,z.path))}async F(z){const q=await this.m.resolve(z.location);let O,j;return q.children&&(O=q.children.find(({name:ne})=>/^readme(\.txt|\.md|)$/i.test(ne))?.resource,j=q.children.find(({name:ne})=>/^changelog(\.txt|\.md|)$/i.test(ne))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:O,changelogUrl:j,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated,pinned:!!z.metadata?.pinned}}async G(){const z=await this.getUninstalledExtensions();if(Object.keys(z).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(z));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const ne of q)z[s.$No.create(ne).toString()]||O.add(ne.identifier.id.toLowerCase());try{const ne=(0,s.$So)(q,Y=>Y.identifier);await E.Promises.settled(ne.map(async Y=>{const Z=Y.sort((B,H)=>p.rcompare(B.manifest.version,H.manifest.version))[0];O.has(Z.identifier.id.toLowerCase())||await this.j(await this.F(Z))}))}catch(ne){this.u.error(ne)}const j=q.filter(ne=>ne.metadata&&z[s.$No.create(ne).toString()]);await Promise.allSettled(j.map(ne=>this.removeUninstalledExtension(ne)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let z;try{z=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,X.$Ck)(q)!==1&&this.u.error(q);return}if(z?.children)try{await Promise.allSettled(z.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(Q))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(O){(0,X.$Ck)(O)!==1&&this.u.error(O)}}}))}catch{}}};e.$Xp=V,e.$Xp=V=Fe([Le(1,X.$lk),Le(2,a.$Lp),Le(3,t.$Hp),Le(4,U.$Vk),Le(5,J.$jj)],V);class G extends i.$Fp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$Lf)(this.options.operation)?this.l:this.options.operation}constructor(z,q,O,j,ne,Y,Z,B,H){super(),this.identifier=z,this.source=q,this.options=O,this.m=j,this.n=ne,this.o=Y,this.p=Z,this.q=B,this.s=H,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(z){const[q,O]=await this.x(z);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,O]],this.j),q}async u({zipPath:z,key:q,metadata:O},j,ne){let Y=await this.v(q);return Y||(this.s.trace("Extracting extension...",q.id),Y=await this.m.extractUserExtension(q,z,O,j,ne),this.s.info("Extracting extension completed.",q.id)),Y}async v(z){return await this.w(z)?(this.s.trace("Removing the extension from uninstalled list:",z.id),await this.m.setInstalled(z),this.s.info("Removed the extension from uninstalled list:",z.id),(await this.m.scanAllUserExtensions(!0)).find(j=>s.$No.create(j).equals(z))):void 0}async w(z){return!!(await this.m.getUninstalledExtensions())[z.toString()]}}class oe extends G{constructor(z,q,O,j,ne,Y,Z,B,H,T){super(q.identifier,q,O,ne,Y,Z,B,H,T),this.y=q,this.z=j}async x(z){const O=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Z=>(0,s.$Mo)(Z.identifier,this.y.identifier));O&&(this.l=3);const j={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??O?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,c.$Kf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.y.version)return[await this.m.updateMetadata(O,j),j];const{location:ne,verificationStatus:Y}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=Y,this.B(ne.fsPath),[await this.u({zipPath:ne.fsPath,key:s.$No.create(this.y),metadata:j},!1,z),j]}catch(Z){try{await this.z.delete(ne)}catch(B){this.s.warn("Error while deleting the downloaded file",ne.toString(),(0,S.$0)(B))}throw Z}}async B(z){try{await(0,D.$Sp)(z)}catch(q){throw new o.$lo((0,i.$Dp)(q).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$Yp=oe;class le extends G{constructor(z,q,O,j,ne,Y,Z,B,H,T){super({id:(0,s.$Ro)(z.publisher,z.name)},q,O,ne,Y,Z,B,H,T),this.y=z,this.z=q,this.A=j}async h(z){const q=await super.h(z);return this.D(q,z),q}async x(z){const q=new s.$No(this.identifier,this.y.version),j=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Z=>(0,s.$Mo)(this.identifier,Z.identifier)),ne={isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned};if(j)if(this.l=3,q.equals(new s.$No(j.identifier,j.manifest.version)))try{await this.m.removeExtension(j,"existing")}catch{throw new Error($.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&p.gt(j.manifest.version,this.y.version)&&await this.m.setUninstalled(j);else{const Z=await this.v(q);if(Z)try{await this.m.removeExtension(Z,"existing")}catch{throw new Error($.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:b.$kc(this.z.fsPath),key:q,metadata:ne},!0,z),ne]}async D(z,q){try{let[O]=await this.A.getExtensions([{id:z.identifier.id,version:z.manifest.version}],q);if(O||([O]=await this.A.getExtensions([{id:z.identifier.id}],q)),O){const j={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(z,j,this.options.profileLocation)}}catch{}}}class se extends i.$Fp{constructor(z,q,O){super(),this.extension=z,this.j=q,this.k=O}async h(z){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[125],ve([1,0,13,33,34,32,45,16,25,3]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=void 0;let I=class extends S.$Ip{constructor(b,f,p,c,m,u){super(v.URI.file(b.extensionsPath),f,p,c,m,u)}};e.$aO=I,e.$aO=I=Fe([Le(0,w.$0h),Le(1,P.$lk),Le(2,R.$Xk),Le(3,r.$Vk),Le(4,C.$pl),Le(5,E.$jj)],I)}),define(be[261],ve([1,0,14,5,2,41,10,170,6,33]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gp=e.$fp=e.$ep=void 0,e.$ep="__$__isNewStorageMarker",e.$fp="__$__targetStorageMarker",e.$gp=(0,w.$2h)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var k;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var b;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function f(d){const l=d.get(e.$fp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$hp=f;class p extends r.$Sc{static{this.a=60*1e3}constructor(l={flushInterval:p.a}){super(),this.m=l,this.b=this.B(new R.$Vd),this.c=this.B(new R.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new E.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new r.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,$,h){return R.Event.filter(this.b.event,n=>n.scope===l&&($===void 0||n.key===$),h)}n(){this.j.value=(0,E.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,r.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,C.mark)("code/willInitStorage");try{await this.O()}finally{(0,C.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,$){const{key:h,external:n}=$;if(h===e.$fp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:h,target:this.J(l)[h],external:n})}w(l){this.f.fire({reason:l})}get(l,$,h){return this.P($)?.get(l,h)}getBoolean(l,$,h){return this.P($)?.getBoolean(l,h)}getNumber(l,$,h){return this.P($)?.getNumber(l,h)}getObject(l,$,h){return this.P($)?.getObject(l,h)}storeAll(l,$){this.y(()=>{for(const h of l)this.store(h.key,h.value,h.scope,h.target,$)})}store(l,$,h,n,i=!1){if((0,S.$Nf)($)){this.remove(l,h,i);return}this.y(()=>{this.z(l,h,n),this.P(h)?.set(l,$,i)})}remove(l,$,h=!1){this.y(()=>{this.z(l,$,void 0),this.P($)?.delete(l,h)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,$){const h=[],n=this.J(l);for(const i of Object.keys(n))n[i]===$&&h.push(i);return h}z(l,$,h,n=!1){const i=this.J($);typeof h=="number"?i[l]!==h&&(i[l]=h,this.P($)?.set(e.$fp,JSON.stringify(i),n)):typeof i[l]=="number"&&(delete i[l],this.P($)?.set(e.$fp,JSON.stringify(i),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const $=this.P(l);return $?f($):Object.create(null)}isNew(l){return this.getBoolean(e.$ep,l)===!0}async flush(l=I.NONE){this.f.fire({reason:l});const $=this.P(-1),h=this.P(0),n=this.P(1);switch(l){case I.NONE:await E.Promises.settled([$?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await E.Promises.settled([$?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return u(l,$,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,$){return this.w(I.NONE),(0,v.$Wk)(l)?this.R(l,$):this.S(l,$)}M(l,$){return!(l.id===$.id||c($)&&c(l))}N(l,$,h){this.y(()=>{const n=new Set;for(const[i,o]of l)n.add(i),$.get(i)!==o&&this.u(h,{key:i,external:!0});for(const[i]of $.items)n.has(i)||this.u(h,{key:i,external:!0})})}}e.$ip=p;function c(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$jp=c;class m extends p{constructor(){super(),this.U=this.B(new P.$cp(new P.$dp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$cp(new P.$dp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$cp(new P.$dp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$kp=m;async function u(d,l,$,h,n,i){const o=F=>{try{return JSON.parse(F)}catch{return F}},s=new Map,t=new Map;d.forEach((F,X)=>{s.set(X,F),t.set(X,o(F))});const a=new Map,g=new Map;l.forEach((F,X)=>{a.set(X,F),g.set(X,o(F))});const L=new Map,D=new Map;$.forEach((F,X)=>{L.set(X,F),D.set(X,o(F))}),console.group(h!==n?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const y=[];if(s.forEach((F,X)=>{y.push({key:X,value:F})}),console.table(y),console.groupEnd(),console.log(t),h!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const F=[];a.forEach((X,te)=>{F.push({key:te,value:X})}),console.table(F),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${i})`);const A=[];L.forEach((F,X)=>{A.push({key:X,value:F})}),console.table(A),console.groupEnd(),console.log(D)}e.$lp=u}),define(be[126],ve([1,0,18,20,11,4,29,10,3,24,25,30,36,82,16,13,31,44,245,261,32,60]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=void 0;const n=C.$o?"web":(0,k.$go)(C.$u,S.$ec),i="X-Market-Search-Activity-Id";var o;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function s(...O){return String(O.reduce((j,ne)=>j|ne,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class y{constructor(j=D){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,ne=this.d.pageSize){return new y({...this.d,pageNumber:j,pageSize:ne})}withFilter(j,...ne){const Y=[...this.d.criteria,...ne.length?ne.map(Z=>({filterType:j,value:Z})):[{filterType:j}]];return new y({...this.d,criteria:Y})}withSortBy(j){return new y({...this.d,sortBy:j})}withSortOrder(j){return new y({...this.d,sortOrder:j})}withFlags(...j){return new y({...this.d,flags:j.reduce((ne,Y)=>ne|Y,0)})}withAssetTypes(...j){return new y({...this.d,assetTypes:j})}withSource(j){return new y({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:ne,pageSize:Y,sortBy:Z,sortOrder:B,flags:H,assetTypes:T}=this.d;return{filters:[{criteria:j,pageNumber:ne,pageSize:Y,sortBy:Z,sortOrder:B}],assetTypes:T,flags:H}}get searchText(){const j=this.d.criteria.filter(ne=>ne.filterType===t.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(O,j){const ne=(O||[]).filter(Y=>Y.statisticName===j)[0];return ne?ne.value:0}function F(O){const j="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(Y=>Y.assetType.indexOf(j)===0).reduce((Y,Z)=>{const B=J(O,Z.assetType);return B&&Y.push([Z.assetType.substring(j.length),B]),Y},[])}function X(O){if(O.properties){const j=O.properties.filter(Z=>Z.key===a.Repository),ne=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Y=j.filter(Z=>ne.test(Z.value))[0];return Y?{uri:Y.value,fallbackUri:Y.value}:null}return J(O,a.Repository)}function te(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function J(O,j){return O.files.filter(Y=>Y.assetType===j)[0]?{uri:`${O.assetUri}/${j}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${j}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function ie(O,j){const ne=O.properties?O.properties.filter(Z=>Z.key===j):[],Y=ne.length>0&&ne[0].value;return Y?Y.split(",").map(Z=>(0,b.$Qo)(Z)):[]}function ee(O){const j=O.properties?O.properties.filter(ne=>ne.key===g.Engine):[];return j.length>0&&j[0].value||""}function U(O){const j=O.properties?O.properties.filter(ne=>ne.key===g.PreRelease):[];return j.length>0&&j[0].value==="true"}function he(O){const j=O.properties?O.properties.filter(Y=>Y.key===g.LocalizedLanguages):[],ne=j.length>0&&j[0].value||"";return ne?ne.split(","):[]}function Q(O){return O.properties?.find(j=>j.key===g.SponsorLink)?.value}function _(O){return O.indexOf("preview")!==-1}function V(O){return O.targetPlatform?(0,k.$fo)(O.targetPlatform):"undefined"}function G(O){const j=(0,E.$Mb)(O.versions.map(V)),ne=!!O.tags?.includes(k.$ao),Y=j.indexOf("web");return ne?Y===-1&&j.push("web"):Y!==-1&&j.splice(Y,1),j}function oe(O,j){for(let ne=0;ne<O.length;ne++){const Y=O[ne];if(Y.version===O[ne-1]?.version){let Z=ne;if(V(Y)===j)for(;Z>0&&O[Z-1].version===Y.version;)Z--;Z!==ne&&(O.splice(ne,1),O.splice(Z,0,Y))}}return O}e.$op=oe;function le(O,j,ne){O.telemetryData={index:j,querySource:ne,queryActivityId:O.queryContext?.[i]}}function se(O,j,ne,Y){const Z=O.versions[0],B={manifest:J(j,a.Manifest),readme:J(j,a.Details),changelog:J(j,a.Changelog),license:J(j,a.License),repository:X(j),download:te(j),icon:J(j,a.Icon),signature:J(j,a.Signature),coreTranslations:F(j)};return{identifier:{id:(0,b.$Ro)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:j.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:Q(Z),description:O.shortDescription||"",installCount:A(O.statistics,"install"),rating:A(O.statistics,"averagerating"),ratingCount:A(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:ne,assets:B,properties:{dependencies:ie(j,g.Dependency),extensionPack:ie(j,g.ExtensionPack),engine:ee(j),localizedLanguages:he(j),targetPlatform:V(j),isPreReleaseVersion:U(j)},hasPreReleaseVersion:U(Z),hasReleaseVersion:!0,preview:_(O.flags),isSigned:!!B.signature,queryContext:Y}}let $e=class{constructor(j,ne,Y,Z,B,H,T,W){this.k=ne,this.l=Y,this.n=Z,this.o=B,this.q=H,this.u=T,this.w=W;const x=T.extensionsGallery,re=x?.servicePPEUrl&&W.getValue("_extensionsGallery.enablePPE");this.d=re?x.servicePPEUrl:x?.serviceUrl,this.g=re?void 0:x?.searchUrl,this.h=x?.controlUrl,this.j=(0,d.$np)(T.version,T,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,ne,Y){const Z=R.CancellationToken.isCancellationToken(ne)?{}:ne,B=R.CancellationToken.isCancellationToken(ne)?ne:Y,H=[],T=[],W=[],x=[];let re=!0;for(const ge of j){ge.uuid?T.push(ge.uuid):H.push(ge.id);const ye=!!(ge.version||ge.preRelease);W.push({id:ge.id,uuid:ge.uuid,includePreRelease:ye}),ge.version&&x.push({id:ge.id,uuid:ge.uuid,version:ge.version}),re=re&&!!ge.hasPreRelease&&!ye}if(!T.length&&!H.length)return[];let fe=new y().withPage(1,j.length);T.length&&(fe=fe.withFilter(t.ExtensionId,...T)),H.length&&(fe=fe.withFilter(t.ExtensionName,...H)),(Z.queryAllVersions||re)&&(fe=fe.withFlags(fe.flags,o.IncludeVersions)),Z.source&&(fe=fe.withSource(Z.source));const{extensions:ce}=await this.z(fe,{targetPlatform:Z.targetPlatform??n,includePreRelease:W,versions:x,compatible:!!Z.compatible},B);return Z.source&&ce.forEach((ge,ye)=>le(ge,ye,Z.source)),ce}async getCompatibleExtension(j,ne,Y){if((0,k.$ho)(j.allTargetPlatforms,Y))return null;if(await this.isExtensionCompatible(j,ne,Y))return j;const Z=new y().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,j.identifier.uuid),{extensions:B}=await this.z(Z,{targetPlatform:Y,compatible:!0,includePreRelease:ne},R.CancellationToken.None);return B[0]||null}async isExtensionCompatible(j,ne,Y){if(!(0,k.$io)(j.properties.targetPlatform,j.allTargetPlatforms,Y)||!ne&&j.properties.isPreReleaseVersion)return!1;let Z=j.properties.engine;if(!Z){const B=await this.getManifest(j,R.CancellationToken.None);if(!B)throw new Error("Manifest was not found");Z=B.engines.vscode}return(0,f.$5o)(Z,this.u.version,this.u.date)}async y(j,ne,Y,Z,B){if(!(0,k.$io)(V(j),Z,B)||ne!=="any"&&U(j)!==(ne==="prerelease"))return!1;if(Y)try{const H=await this.E(j);if(!(0,f.$5o)(H,this.u.version,this.u.date))return!1}catch(H){return this.l.error(`Error while getting the engine for the version ${j.version}.`,(0,r.$0)(H)),!1}return!0}async query(j,ne){let Y=j.text||"";const Z=j.pageSize??50;let B=new y().withPage(1,Z);Y?(Y=Y.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,fe,ce)=>(B=B.withFilter(t.Category,ce||fe),"")),Y=Y.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,fe,ce)=>(B=B.withFilter(t.Tag,ce||fe),"")),Y=Y.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(t.Featured),"")),Y=Y.trim(),Y&&(Y=Y.length<200?Y:Y.substring(0,200),B=B.withFilter(t.SearchText,Y)),B=B.withSortBy(0)):j.ids?B=B.withFilter(t.ExtensionId,...j.ids):j.names?B=B.withFilter(t.ExtensionName,...j.names):B=B.withSortBy(4),typeof j.sortBy=="number"&&(B=B.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(B=B.withSortOrder(j.sortOrder)),j.source&&(B=B.withSource(j.source));const H=async(re,fe)=>{const{extensions:ce,total:ge}=await this.z(re,{targetPlatform:n,compatible:!1,includePreRelease:!!j.includePreRelease},fe);return ce.forEach((ye,Ie)=>le(ye,(re.pageNumber-1)*re.pageSize+Ie,j.source)),{extensions:ce,total:ge}},{extensions:T,total:W}=await H(B,ne),x=async(re,fe)=>{if(fe.isCancellationRequested)throw new r.$5;const{extensions:ce}=await H(B.withPage(re+1),fe);return ce};return{firstPage:T,total:W,pageSize:B.pageSize,getPage:x}}async z(j,ne,Y){const Z=j.flags;j.flags&o.IncludeLatestVersionOnly&&j.flags&o.IncludeVersions&&(j=j.withFlags(j.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(j.flags&o.IncludeLatestVersionOnly)&&!(j.flags&o.IncludeVersions)&&(j=j.withFlags(j.flags,o.IncludeLatestVersionOnly)),ne.versions?.length&&(j=j.withFlags(j.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),j=j.withFlags(j.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:B,total:H,context:T}=await this.B(j,Y);if(!(j.flags&o.IncludeLatestVersionOnly)){const fe=[];for(const ce of B){const ge=await this.A(ce,ne,T);ge&&fe.push(ge)}return{extensions:fe,total:H}}const x=[],re=new Map;for(let fe=0;fe<B.length;fe++){const ce=B[fe],ge={id:(0,b.$Ro)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},ye=(0,P.$Kf)(ne.includePreRelease)?ne.includePreRelease:!!ne.includePreRelease.find(Re=>(0,b.$Mo)(Re,ge))?.includePreRelease;if(ne.compatible&&(0,k.$ho)(G(ce),ne.targetPlatform))continue;const Ie=await this.A(ce,ne,T);!Ie||Ie.properties.isPreReleaseVersion&&(!ye||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==ne.targetPlatform&&Ie.hasPreReleaseVersion?re.set(ce.extensionId,fe):x.push([fe,Ie])}if(re.size){const fe=new h.$Od,ce=new y().withFlags(Z&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,re.size).withFilter(t.ExtensionId,...re.keys()),{extensions:ge}=await this.z(ce,ne,Y);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:re.size});for(const ye of ge){const Ie=re.get(ye.identifier.uuid);x.push([Ie,ye])}}return{extensions:x.sort((fe,ce)=>fe[0]-ce[0]).map(([,fe])=>fe),total:H}}async A(j,ne,Y){const Z={id:(0,b.$Ro)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},B=ne.versions?.find(x=>(0,b.$Mo)(x,Z))?.version,H=(0,P.$Kf)(ne.includePreRelease)?ne.includePreRelease:!!ne.includePreRelease.find(x=>(0,b.$Mo)(x,Z))?.includePreRelease,T=G(j),W=oe(j.versions,ne.targetPlatform);if(ne.compatible&&(0,k.$ho)(T,ne.targetPlatform))return null;for(let x=0;x<W.length;x++){const re=W[x];if(!(B&&re.version!==B)){if(await this.y(re,H?"any":"release",ne.compatible,T,ne.targetPlatform))return se(j,re,T,Y);if(B&&re.version===B)return null}}return B||ne.compatible?null:se(j,j.versions[0],T)}async B(j,ne){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(o.Unpublished));const Y=await this.j,Z=JSON.stringify(j.raw),B={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},H=new h.$Od;let T,W,x=0;try{if(T=await this.k.request({type:"POST",url:this.g&&j.criteria.some(fe=>fe.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:B},ne),T.res.statusCode&&T.res.statusCode>=400&&T.res.statusCode<500)return{galleryExtensions:[],total:x};const re=await(0,u.$_o)(T);if(re){const fe=re.results[0],ce=fe.extensions,ge=fe.resultMetadata&&fe.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return x=ge&&ge.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:x,context:{[i]:T.res.headers.activityid}}}return{galleryExtensions:[],total:x}}catch(re){throw W=re,re}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(Z.length),duration:H.elapsed(),success:!!T&&(0,u.$8o)(T),responseBodySize:T?.res.headers["Content-Length"],statusCode:T?String(T.res.statusCode):void 0,errorCode:W?(0,r.$4)(W)?"canceled":(0,r.$0)(W).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(x)})}}async reportStatistic(j,ne,Y,Z){if(!this.isEnabled())return;const B=C.$o?this.x(`/itemName/${j}.${ne}/version/${Y}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${ne}/${Y}/stats?statType=${Z}`),H=C.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",W={...await this.j,Accept:H};try{await this.k.request({type:"POST",url:B,headers:W},R.CancellationToken.None)}catch{}}async download(j,ne,Y){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const Z=(0,b.$Uo)(j),B=new Date().getTime(),H=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:fe}),T=Y===2?"install":Y===3?"update":"",W=T?{uri:`${j.assets.download.uri}${w.URI.parse(j.assets.download.uri).query?"&":"?"}${T}=true`,fallbackUri:`${j.assets.download.fallbackUri}${w.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${T}=true`}:j.assets.download,x=j.queryContext?.[i]?{[i]:j.queryContext[i]}:void 0,re=await this.D(W,x?{headers:x}:void 0);await this.q.writeFile(ne,re.stream),H(new Date().getTime()-B)}async downloadSignatureArchive(j,ne){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const Y=await this.D(j.assets.signature);await this.q.writeFile(ne,Y.stream)}async getReadme(j,ne){if(j.assets.readme){const Y=await this.D(j.assets.readme,{},ne);return await(0,u.$$o)(Y)||""}return""}async getManifest(j,ne){if(j.assets.manifest){const Y=await this.D(j.assets.manifest,{},ne),Z=await(0,u.$$o)(Y);return Z?JSON.parse(Z):null}return null}async C(j,ne){const Y=J(j,a.Manifest);if(!Y)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},B=await this.D(Y,{headers:Z});return await(0,u.$_o)(B)}async getCoreTranslation(j,ne){const Y=j.assets.coreTranslations.filter(Z=>Z[0]===ne.toUpperCase())[0];if(Y){const Z=await this.D(Y[1]),B=await(0,u.$$o)(Z);return B?JSON.parse(B):null}return null}async getChangelog(j,ne){if(j.assets.changelog){const Y=await this.D(j.assets.changelog,{},ne);return await(0,u.$$o)(Y)||""}return""}async getAllCompatibleVersions(j,ne,Y){let Z=new y().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?Z=Z.withFilter(t.ExtensionId,j.identifier.uuid):Z=Z.withFilter(t.ExtensionName,j.identifier.id);const{galleryExtensions:B}=await this.B(Z,R.CancellationToken.None);if(!B.length)return[];const H=G(B[0]);if((0,k.$ho)(H,Y))return[];const T=[];await Promise.all(B[0].versions.map(async re=>{try{await this.y(re,ne?"any":"release",!0,H,Y)&&T.push(re)}catch{}}));const W=[],x=new Set;for(const re of oe(T,Y))x.has(re.version)||(x.add(re.version),W.push({version:re.version,date:re.lastUpdated,isPreReleaseVersion:U(re)}));return W}async D(j,ne={},Y=R.CancellationToken.None){const Z=await this.j,B={type:"GET"},H={...Z,...ne.headers||{}};ne={...ne,...B,headers:H};const T=j.uri,W=j.fallbackUri,x={...ne,url:T};try{const re=await this.k.request(x,Y);if(re.res.statusCode===200)return re;const fe=await(0,u.$$o)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${fe}`)}catch(re){if((0,r.$4)(re))throw re;const fe=(0,r.$0)(re);this.o.publicLog2("galleryService:cdnFallback",{url:T,message:fe});const ce={...ne,url:W};return this.k.request(ce,Y)}}async E(j){let ne=ee(j);if(!ne){const Y=await this.C(j,R.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");ne=Y.engines.vscode}return ne}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const ne=await(0,u.$_o)(j),Y=[],Z={},B=[];if(ne){for(const H of ne.malicious)Y.push({id:H});if(ne.migrateToPreRelease)for(const[H,T]of Object.entries(ne.migrateToPreRelease))(!T.engine||(0,f.$5o)(T.engine,this.u.version,this.u.date))&&(Z[H.toLowerCase()]={disallowInstall:!0,extension:{id:T.id,displayName:T.displayName,autoMigrate:{storage:!!T.migrateStorage},preRelease:!0}});if(ne.deprecated)for(const[H,T]of Object.entries(ne.deprecated))T&&(Z[H.toLowerCase()]=(0,P.$Kf)(T)?{}:T);if(ne.search)for(const H of ne.search)B.push(H)}return{malicious:Y,deprecated:Z,search:B}}};$e=Fe([Le(1,u.$6o),Le(2,c.$jj),Le(3,I.$9h),Le(4,$.$pl),Le(5,p.$lk),Le(6,m.$Bj),Le(7,v.$vi)],$e);let z=class extends $e{constructor(j,ne,Y,Z,B,H,T,W){super(j,ne,Y,Z,B,H,T,W)}};e.$pp=z,e.$pp=z=Fe([Le(0,l.$gp),Le(1,u.$6o),Le(2,c.$jj),Le(3,I.$9h),Le(4,$.$pl),Le(5,p.$lk),Le(6,m.$Bj),Le(7,v.$vi)],z);let q=class extends $e{constructor(j,ne,Y,Z,B,H,T){super(void 0,j,ne,Y,Z,B,H,T)}};e.$qp=q,e.$qp=q=Fe([Le(0,u.$6o),Le(1,c.$jj),Le(2,I.$9h),Le(3,$.$pl),Le(4,p.$lk),Le(5,m.$Bj),Le(6,v.$vi)],q)}),define(be[262],ve([1,0,5,2,33,51]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=void 0;class S{constructor(v,I){this.a=v,this.b=I}listen(v,I){const k=this.b(v);switch(I){case"onDidChangeProfiles":return E.Event.map(this.a.onDidChangeProfiles,b=>({all:b.all.map(f=>(0,C.$1m)({...f},k)),added:b.added.map(f=>(0,C.$1m)({...f},k)),removed:b.removed.map(f=>(0,C.$1m)({...f},k)),updated:b.updated.map(f=>(0,C.$1m)({...f},k))}))}throw new Error(`Invalid listen ${I}`)}async call(v,I,k){const b=this.b(v);switch(I){case"createProfile":{const f=await this.a.createProfile(k[0],k[1],k[2]);return(0,C.$1m)({...f},b)}case"updateProfile":{let f=(0,r.$Yk)((0,C.$2m)(k[0],b),this.a.profilesHome.scheme);return f=await this.a.updateProfile(f,k[1]),(0,C.$1m)({...f},b)}case"removeProfile":{const f=(0,r.$Yk)((0,C.$2m)(k[0],b),this.a.profilesHome.scheme);return this.a.removeProfile(f)}}throw new Error(`Invalid call ${I}`)}}e.$hO=S;class P extends R.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(v,I,k){super(),this.profilesHome=I,this.f=k,this.a=[],this.b=this.B(new E.$Sd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=v.map(b=>(0,r.$Yk)(b,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(b=>{const f=b.added.map(m=>(0,r.$Yk)(m,this.profilesHome.scheme)),p=b.removed.map(m=>(0,r.$Yk)(m,this.profilesHome.scheme)),c=b.updated.map(m=>(0,r.$Yk)(m,this.profilesHome.scheme));this.a=b.all.map(m=>(0,r.$Yk)(m,this.profilesHome.scheme)),this.b.fire({added:f,removed:p,updated:c,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(v){this.c=v}isEnabled(){return this.c}async createNamedProfile(v,I,k){const b=await this.f.call("createNamedProfile",[v,I,k]);return(0,r.$Yk)(b,this.profilesHome.scheme)}async createProfile(v,I,k,b){const f=await this.f.call("createProfile",[v,I,k,b]);return(0,r.$Yk)(f,this.profilesHome.scheme)}async createTransientProfile(v){const I=await this.f.call("createTransientProfile",[v]);return(0,r.$Yk)(I,this.profilesHome.scheme)}async setProfileForWorkspace(v,I){await this.f.call("setProfileForWorkspace",[v,I])}removeProfile(v){return this.f.call("removeProfile",[v])}async updateProfile(v,I){const k=await this.f.call("updateProfile",[v,I]);return(0,r.$Yk)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$iO=P}),define(be[127],ve([1,0,3,25,16,13,238,34,33,10,239]),function(ue,e,E,R,r,C,S,P,w,v,I){"use strict";var k,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=e.$0N=void 0;let f=class extends w.$1k{static{k=this}static{this.a="profileAssociationsMigration"}constructor(u,d,l,$,h){super(l,$,d,h),this.U=u,this.W=l}O(){return this.U.getItem(k.b,[]).map(d=>({...d,location:(0,v.$Ef)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):E.URI.revive(d.location)}))}Q(){const u=this.U.getItem(k.c,{});return this.U.getItem(k.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(E.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$0N=f,e.$0N=f=k=Fe([Le(0,S.$5N),Le(1,P.$Vk),Le(2,R.$0h),Le(3,r.$lk),Le(4,C.$jj)],f);let p=b=class extends f{constructor(u,d,l,$,h){super(u,d,l,$,h),this.$=u}P(u){u.length?this.$.setItem(b.b,u.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(b.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(b.c,u):this.$.removeItem(b.c)}Q(){const u="workspaceAndProfileInfo",d=this.$.getItem(u,void 0);if(d){this.$.removeItem(u);const $=d.reduce((h,{workspace:n,profile:i})=>(h[E.URI.revive(n).toString()]=E.URI.revive(i).toString(),h),{});this.$.setItem(b.c,{workspaces:$})}const l=super.Q();return this.$.getItem(b.a,!1)||(this.R(l),this.$.setItem(b.a,!0)),l}};e.$$N=p,e.$$N=p=b=Fe([Le(0,S.$6N),Le(1,P.$Vk),Le(2,R.$0h),Le(3,r.$lk),Le(4,C.$jj)],p);let c=class extends p{constructor(u,d,l,$){super(new I.$9N(0,d,$,l),u,d,l,$)}async init(){return await this.$.init(),super.init()}};e.$_N=c,e.$_N=c=Fe([Le(0,P.$Vk),Le(1,R.$0h),Le(2,r.$lk),Le(3,C.$jj)],c)}),define(be[128],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=void 0,e.$Im=(0,E.$2h)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(C,S){this.a.set(C,S)}getExitInfo(C){return this.a.get(C)||null}}e.$Jm=R}),define(be[263],ve([1,0,5,14]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;function r(S){let P=0,w=0,v=0;S>=1e3&&(v=Math.floor(S/1e3),S-=v*1e3),v>=60&&(w=Math.floor(v/60),v-=w*60),w>=60&&(P=Math.floor(w/60),w-=P*60);const I=P?`${P}h`:"",k=w?`${w}m`:"",b=v?`${v}s`:"",f=S?`${S}ms`:"";return`${I}${k}${b}${f}`}class C{constructor(P,w,v,I){this.i=P,this.j=w,this.a=new E.$Sd,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=v,this.protocol=I,this.e=!1,this.f=new R.$ch(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.$ch(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,w,v){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,v),this.protocol.endAcceptReconnection()}}e.$Rm=C}),define(be[129],ve([1,0,27,12,7,152,55]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.$Al=void 0;const P=r.$jc(R.$kg.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function v(b){return new Promise(f=>E.exists(b,f))}function I(b,f){return v(P).then(p=>{if(!p||!S.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const c=`${b}||${f}`;let m=w.get(c);return m||(m=C.getNLSConfiguration(S.default.commit,f,P,b,b).then(u=>(k.is(u)&&(u._languagePackSupport=!0),u)),w.set(c,m)),m})}e.$Al=I;var k;(function(b){function f(p){const c=p;return c&&typeof c._languagePackId=="string"}b.is=f})(k||(e.InternalNLSConfiguration=k={}))}),define(be[130],ve([1,0,19,3,25,45,58,16,6,13,31,34,33,129]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZN=void 0;let p=class extends S.$Mp{constructor(m,u,d,l,$,h,n,i){super(R.URI.file($.builtinExtensionsPath),R.URI.file($.extensionsPath),(0,E.$Dg)($.userHome,".vscode-oss-dev","extensions","control.json"),m.defaultProfile,m,u,d,l,$,h,n,i),this.R=$}async f(m){const u=await(0,f.$Al)(m,this.R.userDataPath);if(f.InternalNLSConfiguration.is(u))try{const d=await this.w.readFile(R.URI.file(u._translationsConfigFile));return JSON.parse(d.value.toString())}catch{}return Object.create(null)}};e.$ZN=p,e.$ZN=p=Fe([Le(0,b.$Xk),Le(1,C.$Hp),Le(2,P.$lk),Le(3,v.$jj),Le(4,r.$0h),Le(5,I.$Bj),Le(6,k.$Vk),Le(7,w.$1h)],p)}),define(be[264],ve([1,0,265,27,7,21,12,22]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.ServerConnectionTokenType=void 0;const w=/^[0-9A-Za-z_-]+$/;var v;(function(m){m[m.None=0]="None",m[m.Optional=1]="Optional",m[m.Mandatory=2]="Mandatory"})(v||(e.ServerConnectionTokenType=v={}));class I{constructor(){this.type=0}validate(u){return!0}}e.$Sm=I;class k{constructor(u){this.value=u,this.type=2}validate(u){return u===this.value}}e.$Tm=k;class b{constructor(u){this.message=u}}e.$Um=b;async function f(m,u){const d=m["without-connection-token"],l=m["connection-token"],$=m["connection-token-file"];if(d)return typeof l<"u"||typeof $<"u"?new b("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new I;if(typeof $<"u"){if(typeof l<"u")return new b("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let h;try{h=R.readFileSync($).toString().replace(/\r?\n$/,"")}catch{return new b(`Unable to read the connection token file at '${$}'.`)}return w.test(h)?new k(h):new b(`The connection token defined in '${$} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof l<"u"?w.test(l)?new k(l):new b(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):new k(await u())}e.$Vm=f;async function p(m){return f(m,async()=>{if(!m["user-data-dir"])return(0,C.$mg)();const d=r.$jc(m["user-data-dir"],"token");try{const h=(await P.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(w.test(h))return h}catch{}const l=(0,C.$mg)();try{await P.Promises.writeFile(d,l,{mode:384})}catch{}return l})}e.$Wm=p;function c(m,u,d){if(m.validate(d.query[S.$dg]))return!0;const l=E.parse(u.headers.cookie||"");return m.validate(l[S.$cg])}e.$Xm=c}),define(be[46],ve([1,0,201,108,66,6,25,74]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=void 0,e.$zm={host:{type:"string",cat:"o",args:"ip-address",description:E.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:E.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:E.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:E.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:E.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:E.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:E.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:E.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:E.localize(8,null)},"user-data-dir":r.$Sl["user-data-dir"],"enable-smoke-test-driver":r.$Sl["enable-smoke-test-driver"],"disable-telemetry":r.$Sl["disable-telemetry"],"disable-workspace-trust":r.$Sl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$Sl.log,logsPath:r.$Sl.logsPath,"force-disable-user-env":r.$Sl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:E.localize(9,null)},"default-workspace":{type:"string",description:E.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$Sl["extensions-dir"],"extensions-download-dir":r.$Sl["extensions-download-dir"],"builtin-extensions-dir":r.$Sl["builtin-extensions-dir"],"install-extension":r.$Sl["install-extension"],"install-builtin-extension":r.$Sl["install-builtin-extension"],"uninstall-extension":r.$Sl["uninstall-extension"],"list-extensions":r.$Sl["list-extensions"],"locate-extension":r.$Sl["locate-extension"],"show-versions":r.$Sl["show-versions"],category:r.$Sl.category,force:r.$Sl.force,"do-not-sync":r.$Sl["do-not-sync"],"pre-release":r.$Sl["pre-release"],"start-server":{type:"boolean",cat:"e",description:E.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$Sl.help,version:r.$Sl.version,"locate-shell-integration-path":r.$Sl["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$Sl._},e.$Am=(0,C.$3h)(S.$9h);class w extends R.$wm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$Bm=w,Fe([P.$th],w.prototype,"userRoamingDataHome",null)}),define(be[266],ve([1,0,27,22,77,87,265,89,40,64,4,13,46,7,12,21,31,44,20,3,15,10,57]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oO=e.$nO=e.CacheControl=e.$mO=void 0;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(L,D,y,A){D.writeHead(y,{"Content-Type":"text/plain"}),D.end(A)}e.$mO=o;var s;(function(L){L[L.NO_CACHING=0]="NO_CACHING",L[L.ETAG=1]="ETAG",L[L.NO_EXPIRY=2]="NO_EXPIRY"})(s||(e.CacheControl=s={}));async function t(L,D,y,A,F,X){try{const te=await R.Promises.stat(L);if(D===1){const J=`W/"${[te.ino,te.size,te.mtime.getTime()].join("-")}"`;if(A.headers["if-none-match"]===J)return F.writeHead(304),void F.end();X.Etag=J}else D===2?X["Cache-Control"]="public, max-age=31536000":D===0&&(X["Cache-Control"]="no-store");X["Content-Type"]=i[(0,f.$oc)(L)]||(0,v.$5r)(L)||"text/plain",F.writeHead(200,X),(0,E.createReadStream)(L).pipe(F)}catch(te){return te.code!=="ENOENT"?(y.error(te),console.error(te.toString())):console.error(`File not found: ${L}`),F.writeHead(404,{"Content-Type":"text/plain"}),void F.end("Not found")}}e.$nO=t;const a=(0,f.$mc)(p.$kg.asFileUri("").fsPath);let g=class{constructor(D,y,A,F,X){this.f=D,this.g=y,this.h=A,this.i=F,this.j=X,this.a=this.j.extensionsGallery?.resourceUrlTemplate?l.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const te=(0,n.$0k)(X);this.b=`${te}/static`,this.c=`${te}/callback`,this.d=`${te}/web-extension-resource`}async handle(D,y,A){try{const F=A.pathname;return F.startsWith(this.b)&&F.charCodeAt(this.b.length)===47?this.k(D,y,A):F==="/"?this.n(D,y,A):F===this.c?this.p(y):F.startsWith(this.d)&&F.charCodeAt(this.d.length)===47?this.m(D,y,A):o(D,y,404,"Not found.")}catch(F){return this.h.error(F),console.error(F.toString()),o(D,y,500,"Internal Server Error.")}}async k(D,y,A){const F=Object.create(null),te=decodeURIComponent(A.pathname).substring(this.b.length+1),J=(0,f.$jc)(a,te);return(0,w.$4f)(J,a,!I.$k)?t(J,this.g.isBuilt?2:1,this.h,D,y,F):o(D,y,400,"Bad request.")}l(D){const y=D.authority.indexOf(".");return y!==-1?D.authority.substring(y+1):void 0}async m(D,y,A){if(!this.a)return o(D,y,500,"No extension gallery service configured.");const F=decodeURIComponent(A.pathname),X=(0,f.$hc)(F.substring(this.d.length+1)),te=l.URI.parse(X).with({scheme:this.a.scheme,authority:X.substring(0,X.indexOf("/")),path:X.substring(X.indexOf("/")+1)});if(this.l(this.a)!==this.l(te))return o(D,y,403,"Request Forbidden");const J={},ie=V=>{const G=D.headers[V];G&&((0,h.$Ef)(G)||G[0])?J[V]=(0,h.$Ef)(G)?G:G[0]:V!==V.toLowerCase()&&ie(V.toLowerCase())};ie("X-Client-Name"),ie("X-Client-Version"),ie("X-Machine-Id"),ie("X-Client-Commit");const ee=await this.i.request({type:"GET",url:te.toString(!0),headers:J},d.CancellationToken.None),U=ee.res.statusCode||500;if(U!==200){let V=null;try{V=await(0,u.$$o)(ee)}catch{}return o(D,y,U,V||`Request failed with status ${U}`)}const he=Object.create(null),Q=V=>{const G=ee.res.headers[V];G?he[V]=G:V!==V.toLowerCase()&&Q(V.toLowerCase())};Q("Cache-Control"),Q("Content-Type"),y.writeHead(200,he);const _=await(0,$.$se)(ee.stream);return void y.end(_.buffer)}async n(D,y,A){const F=A.query[p.$dg];if(typeof F=="string"){const q=Object.create(null);q["Set-Cookie"]=S.serialize(p.$cg,F,{sameSite:"lax",maxAge:60*60*24*7});const O=Object.create(null);for(const ne in A.query)ne!==p.$dg&&(O[ne]=A.query[ne]);const j=C.format({pathname:"/",query:O});return q.Location=j,y.writeHead(302,q),void y.end()}const X=q=>{const O=D.headers[q];return Array.isArray(O)?O[0]:O},te=!this.g.isBuilt&&this.g.args["use-test-resolver"],J=te?"test+test":X("x-original-host")||X("x-forwarded-host")||D.headers.host;if(!J)return o(D,y,400,"Bad request.");function ie(q){return JSON.stringify(q).replace(/"/g,"&quot;")}let ee;this.g.args["enable-smoke-test-driver"]&&(ee=!1);const U=q=>q&&l.URI.file(r.resolve(q)).with({scheme:p.Schemas.vscodeRemote,authority:J}),he=p.$kg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,Q=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,c.$mg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,_={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:J,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const q=JSON.parse((await R.Promises.readFile((0,f.$jc)(a,"product.overrides.json"))).toString());Object.assign(_,q)}catch{}const V={remoteAuthority:J,_wrapWebWorkerExtHostInIframe:ee,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:U(this.g.args["default-folder"]),workspaceUri:U(this.g.args["default-workspace"]),productConfiguration:_,callbackRoute:this.c},G=this.j.extensionsGallery?.nlsBaseUrl,oe={WORKBENCH_WEB_CONFIGURATION:ie(V),WORKBENCH_AUTH_SESSION:Q?ie(Q):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:G?`${G}${G.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};if(te){const q=[];for(const O of["vscode-test-resolver","github-authentication"]){const j=JSON.parse((await R.Promises.readFile(p.$kg.asFileUri(`${p.$fg}/${O}/package.json`).fsPath)).toString());q.push({extensionPath:O,packageJSON:j})}oe.WORKBENCH_BUILTIN_EXTENSIONS=ie(q)}let le;try{le=(await R.Promises.readFile(he)).toString().replace(/\{\{([^}]+)\}\}/g,(O,j)=>oe[j]??"undefined")}catch{return y.writeHead(404,{"Content-Type":"text/plain"}),void y.end("Not found")}const se="sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=",z={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(le).join(" ")} '${se}' ${te?"":`http://${J}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(z["Set-Cookie"]=S.serialize(p.$cg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),y.writeHead(200,z),void y.end(le)}o(D){const y=/<script>([\s\S]+?)<\/script>/img,A=[];let F;for(;F=y.exec(D);){const X=P.createHash("sha256"),te=F[1].replace(/\r\n/g,`
`),J=X.update(Buffer.from(te)).digest().toString("base64");A.push(`'sha256-${J}'`)}return A}async p(D){const y=p.$kg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,A=(await R.Promises.readFile(y)).toString(),F=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(A).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return D.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":F}),void D.end(A)}};e.$oO=g,e.$oO=g=Fe([Le(1,b.$Am),Le(2,k.$jj),Le(3,u.$6o),Le(4,m.$Bj)],g)}),define(be[267],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0,e.$7M=(0,E.$2h)("IExtHostInitDataService")}),define(be[268],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=void 0,e.$QM=(0,E.$2h)("IExtHostRpcService");class R{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.dispose=C.dispose.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.$RM=R}),define(be[71],ve([1,0,51]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=void 0;function R(C){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:C,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function r(C){return new E.$Ym(R(C))}e.$Nr=r}),define(be[269],ve([1,0,4,41,3,71,51,104,242,7,19]),function(ue,e,E,R,r,C,S,P,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=void 0;class k{static{this.a=1}constructor(f,p,c,m){this.b=f,this.c=p,this.d=c,this.e=m}async call(f,p,c){switch(p){case"getEnvironmentData":{const m=c,u=(0,C.$Nr)(m.remoteAuthority);let d=await this.f(m.profile);return d=(0,S.$1m)(d,u),d}case"getExtensionHostExitInfo":{const m=c;return this.e.getExitInfo(m.reconnectionToken)}case"getDiagnosticInfo":{const m=c,u={machineInfo:(0,w.$Rr)()},d=m.includeProcesses?(0,P.$Pr)(process.pid):Promise.resolve();let l=[];const $={};if(m.folders){const h=(0,C.$Nr)("");l=m.folders.map(i=>r.URI.revive(h.transformIncoming(i))).filter(i=>i.scheme==="file").map(i=>(0,w.$Qr)(i.fsPath,["node_modules",".git"]).then(o=>{$[(0,v.$nc)(i.fsPath)]=o}))}return Promise.all([d,...l]).then(([h,n])=>(u.processes=h||void 0,u.workspaceMetadata=m.folders?$:void 0,u))}}throw new Error(`IPC Command ${p} not found`)}listen(f,p,c){throw new Error("Not supported")}async f(f){return f&&!this.d.profiles.some(p=>p.id===f)&&await this.d.createProfile(f,f),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,I.$Dg)(this.c.logsHome,`exthost${k.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:E.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(p=>({...p}))}}}}e.$Ur=k}),define(be[270],ve([1,0,3,71,69,7,227]),function(ue,e,E,R,r,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;class P extends S.$Vr{constructor(I,k){super(new r.$nq(I),I),this.N=k,this.M=new Map,this.B(this.a)}c(I){let k=this.M.get(I.remoteAuthority);return k||(k=(0,R.$Nr)(I.remoteAuthority),this.M.set(I.remoteAuthority,k)),k}f(I,k,b=!1){if(b&&k.path==="/vscode-resource"&&k.query){const f=JSON.parse(k.query).requestResourcePath;return E.URI.from({scheme:"file",path:f})}return E.URI.revive(I.transformIncoming(k))}L(I,k){return new w(I,k,this.b,this.N)}}e.$Xr=P;class w extends S.$Wr{constructor(I,k,b,f){super(I,k,b,f)}j(I){const k=I.args["file-watcher-polling"];if(k){const b=k.split(C.$tc),f=Number(b[0]);if(f>0)return{usePolling:b.length>1?b.slice(1):!0,pollingInterval:f}}}m(I){if(I.extensionsPath)return[C.$gc.join(I.extensionsPath,"**")]}}}),define(be[93],ve([1,0,204,10,3,2,6,37,16,12,39,158,62]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=e.$KE=e.$JE=e.EditorsOrder=e.$IE=e.CloseDirection=e.$HE=e.$GE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.EditorInputCapabilities=e.$xE=e.SaveReason=e.Verbosity=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=void 0,e.$kE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$lE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$mE="workbench.editor.sidebysideEditor",e.$nE="workbench.editors.textDiffEditor",e.$oE="workbench.editors.binaryResourceDiffEditor";var f;(function(z){z[z.PROGRAMMATIC=1]="PROGRAMMATIC",z[z.USER=2]="USER",z[z.EDIT=3]="EDIT",z[z.NAVIGATION=4]="NAVIGATION",z[z.JUMP=5]="JUMP"})(f||(e.EditorPaneSelectionChangeReason=f={}));var p;(function(z){z[z.IDENTICAL=1]="IDENTICAL",z[z.SIMILAR=2]="SIMILAR",z[z.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function c(z){const q=z;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$pE=c;function m(z,q,O){for(const j of O.visibleEditorPanes)if(j.group.id===q&&z.matches(j.input))return j.getViewState()}e.$qE=m;function u(z){if(g(z))return!1;const q=z;return r.URI.isUri(q?.resource)}e.$rE=u;function d(z){if(g(z))return!1;const q=z;return q?.original!==void 0&&q.modified!==void 0}e.$sE=d;function l(z){if(g(z))return!1;const q=z;return Array.isArray(q?.resources)}e.$tE=l;function $(z){if(g(z)||d(z))return!1;const q=z;return q?.primary!==void 0&&q.secondary!==void 0}e.$uE=$;function h(z){if(g(z))return!1;const q=z;return q?q.resource===void 0||q.resource.scheme===v.Schemas.untitled||q.forceUntitled===!0:!1}e.$vE=h;function n(z){if(g(z))return!1;const q=z;return r.URI.isUri(q?.base?.resource)&&r.URI.isUri(q?.input1?.resource)&&r.URI.isUri(q?.input2?.resource)&&r.URI.isUri(q?.result?.resource)}e.$wE=n;var i;(function(z){z[z.SHORT=0]="SHORT",z[z.MEDIUM=1]="MEDIUM",z[z.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var o;(function(z){z[z.EXPLICIT=1]="EXPLICIT",z[z.AUTO=2]="AUTO",z[z.FOCUS_CHANGE=3]="FOCUS_CHANGE",z[z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o||(e.SaveReason=o={}));class s{constructor(){this.a=new Map}registerSource(q,O){let j=this.a.get(q);return j||(j={source:q,label:O},this.a.set(q,j)),j.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$xE=new s;var t;(function(z){z[z.None=0]="None",z[z.Readonly=2]="Readonly",z[z.Untitled=4]="Untitled",z[z.Singleton=8]="Singleton",z[z.RequiresTrust=16]="RequiresTrust",z[z.CanSplitInGroup=32]="CanSplitInGroup",z[z.ForceDescription=64]="ForceDescription",z[z.CanDropIntoEditor=128]="CanDropIntoEditor",z[z.MultipleEditors=256]="MultipleEditors",z[z.Scratchpad=512]="Scratchpad",z[z.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(t||(e.EditorInputCapabilities=t={}));class a extends C.$Sc{}e.$yE=a;function g(z){return z instanceof a}e.$zE=g;function L(z){const q=z;return r.URI.isUri(q?.preferredResource)}function D(z){const q=z;return g(q?.primary)&&g(q?.secondary)}e.$AE=D;function y(z){const q=z;return g(q?.modified)&&g(q?.original)}e.$BE=y;function A(z,q,O,j,ne){return $e(j,[(0,k.$Li)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Y={...O,limits:{size:Number.MAX_VALUE}};z.openEditor(q,Y)}}),(0,k.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>ne.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.$CE=A;function F(z){return g(z?.editor)}e.$DE=F;function X(z){const q=z;return F(z)&&q?.group!==void 0}e.$EE=X;function te(z){const q=z;return typeof q?.groupId=="number"&&g(q.editor)}e.$FE=te;var J;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.REPLACE=1]="REPLACE",z[z.MOVE=2]="MOVE",z[z.UNPIN=3]="UNPIN"})(J||(e.EditorCloseContext=J={}));var ie;(function(z){z[z.GROUP_ACTIVE=0]="GROUP_ACTIVE",z[z.GROUP_INDEX=1]="GROUP_INDEX",z[z.GROUP_LABEL=2]="GROUP_LABEL",z[z.GROUP_LOCKED=3]="GROUP_LOCKED",z[z.EDITOR_OPEN=4]="EDITOR_OPEN",z[z.EDITOR_CLOSE=5]="EDITOR_CLOSE",z[z.EDITOR_MOVE=6]="EDITOR_MOVE",z[z.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",z[z.EDITOR_LABEL=8]="EDITOR_LABEL",z[z.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",z[z.EDITOR_PIN=10]="EDITOR_PIN",z[z.EDITOR_STICKY=11]="EDITOR_STICKY",z[z.EDITOR_DIRTY=12]="EDITOR_DIRTY",z[z.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(ie||(e.GroupModelChangeKind=ie={}));var ee;(function(z){z[z.PRIMARY=1]="PRIMARY",z[z.SECONDARY=2]="SECONDARY",z[z.BOTH=3]="BOTH",z[z.ANY=4]="ANY"})(ee||(e.SideBySideEditor=ee={}));class U{getOriginalUri(q,O){if(!q)return;if(n(q))return e.$HE.getOriginalUri(q.result,O);if(O?.supportSideBySide){const{primary:ne,secondary:Y}=this.a(q);if(ne&&Y){if(O?.supportSideBySide===ee.BOTH)return{primary:this.getOriginalUri(ne,{filterByScheme:O.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===ee.ANY)return this.getOriginalUri(ne,{filterByScheme:O.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:O.filterByScheme});q=O.supportSideBySide===ee.PRIMARY?ne:Y}}if(d(q)||l(q)||$(q)||n(q))return;const j=L(q)?q.preferredResource:q.resource;return!j||!O||!O.filterByScheme?j:this.b(j,O.filterByScheme)}a(q){return D(q)||$(q)?{primary:q.primary,secondary:q.secondary}:y(q)||d(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,O){if(!q)return;if(n(q))return e.$HE.getCanonicalUri(q.result,O);if(O?.supportSideBySide){const{primary:ne,secondary:Y}=this.a(q);if(ne&&Y){if(O?.supportSideBySide===ee.BOTH)return{primary:this.getCanonicalUri(ne,{filterByScheme:O.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:O.filterByScheme})};if(O?.supportSideBySide===ee.ANY)return this.getCanonicalUri(ne,{filterByScheme:O.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:O.filterByScheme});q=O.supportSideBySide===ee.PRIMARY?ne:Y}}if(d(q)||l(q)||$(q)||n(q))return;const j=q.resource;return!j||!O||!O.filterByScheme?j:this.b(j,O.filterByScheme)}b(q,O){if(Array.isArray(O)){if(O.some(j=>q.scheme===j))return q}else if(O===q.scheme)return q}}var he;(function(z){z[z.UNKNOWN=0]="UNKNOWN",z[z.KEYBOARD=1]="KEYBOARD",z[z.MOUSE=2]="MOUSE"})(he||(e.EditorCloseMethod=he={}));function Q(z,q,O,j){if(!z.isSticky(q))return!1;switch(j.preventPinnedEditorClose){case"keyboardAndMouse":return O===he.MOUSE||O===he.KEYBOARD;case"mouse":return O===he.MOUSE;case"keyboard":return O===he.KEYBOARD}return!1}e.$GE=Q,e.$HE=new U;var _;(function(z){z[z.LEFT=0]="LEFT",z[z.RIGHT=1]="RIGHT"})(_||(e.CloseDirection=_={}));class V{constructor(){this.c=new Map,this.d=new Map}start(q){const O=this.a=q.get(S.$1h);for(const[j,ne]of this.c)this.e(j,ne,O);this.c.clear()}e(q,O,j){const ne=j.createInstance(O);this.d.set(q,ne)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,R.$Pf)(this.b)}registerEditorSerializer(q,O){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,O,this.a):this.c.set(q,O),(0,C.$Qc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}P.$tn.add(e.$kE.EditorFactory,new V);async function G(z,q,O){return!z||!z.length?[]:await Promise.all(z.map(async j=>{const ne=r.URI.revive(j.fileUri);if(!ne){O.info("Cannot resolve the path because it is not valid.",j);return}if(!await q.canHandleResource(ne)){O.info("Cannot resolve the path because it cannot be handled",j);return}let Z=j.exists,B=j.type;if(typeof Z!="boolean"||typeof B!="number")try{B=(await q.stat(ne)).isDirectory?w.FileType.Directory:w.FileType.Unknown,Z=!0}catch(T){O.error(T),Z=!1}if(!Z&&j.openOnlyIfExists){O.info("Cannot resolve the path because it does not exist",j);return}if(B===w.FileType.Directory){O.info("Cannot resolve the path because it is a directory",j);return}const H={...j.options,pinned:!0};return Z?{resource:ne,options:H}:{resource:ne,options:H,forceUntitled:!0}}))}e.$IE=G;var oe;(function(z){z[z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",z[z.SEQUENTIAL=1]="SEQUENTIAL"})(oe||(e.EditorsOrder=oe={}));function le(z){const q=z;if(!q)return!1;const O=q;if(O.modified)return le(O.modified);const j=q;return!!(j.contributionsState&&j.viewState&&Array.isArray(j.cursorState))}e.$JE=le;function se(z){return(0,I.$Ni)(z)}e.$KE=se;function $e(z,q,O){const j=(0,I.$Oi)(z,q);return j.forceMessage=O?.forceMessage,j.forceSeverity=O?.forceSeverity,j.allowDialog=O?.allowDialog,j}e.$LE=$e}),define(be[131],ve([1,0,15,80,47,64,12,7,4,68]),function(ue,e,E,R,r,C,S,P,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.$RI=e.$QI=e.$PI=e.CellStatusbarAlignment=e.$OI=e.$NI=e.$MI=e.NotebookEditorPriority=e.$LI=e.$KI=e.$JI=e.$II=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$HI=e.$GI=e.$FI=e.$EI=e.CellKind=e.$DI=e.$CI=e.$BI=void 0,e.$BI="workbench.editor.notebook",e.$CI="workbench.editor.notebookTextDiffEditor",e.$DI="workbench.editor.interactive";var I;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(I||(e.CellKind=I={})),e.$EI=["application/json","application/javascript","text/html","image/svg+xml",C.$3r.latex,C.$3r.markdown,"image/png","image/jpeg",C.$3r.text],e.$FI=[C.$3r.latex,C.$3r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",C.$3r.text],e.$GI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$HI="_notAvailable";var k;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var b;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(b||(e.NotebookCellExecutionState=b={}));var f;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var p;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var c;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var m;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(m||(e.NotebookCellsChangeType=m={}));var u;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var d;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var l;(function(U){U.scheme=S.Schemas.vscodeNotebookCell;const he=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${he.join("")}]+`),_=7;function V(z,q){const O=q.toString(_),ne=`${O.length<he.length?he[O.length-1]:"z"}${O}s${(0,E.$Ae)(E.$ge.fromString(z.scheme),!0,!0)}`;return z.with({scheme:U.scheme,fragment:ne})}U.generate=V;function G(z){if(z.scheme!==U.scheme)return;const q=z.fragment.indexOf("s");if(q<0)return;const O=parseInt(z.fragment.substring(0,q).replace(Q,""),_),j=(0,E.$ze)(z.fragment.substring(q+1)).toString();if(!isNaN(O))return{handle:O,notebook:z.with({scheme:j,fragment:null})}}U.parse=G;function oe(z,q){return z.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${z.scheme!==S.Schemas.file?z.scheme:""}`})}U.generateCellOutputUri=oe;function le(z){if(z.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(z.fragment);if(!q)return;const O=q[1]&&q[1]!==""?q[1]:void 0,j=q[2];return{outputId:O,notebook:z.with({scheme:j||S.Schemas.file,fragment:null})}}U.parseCellOutputUri=le;function se(z,q,O){return U.generate(z,q).with({scheme:O})}U.generateCellPropertyUri=se;function $e(z,q){if(z.scheme===q)return U.parse(z.with({scheme:U.scheme}))}U.parseCellPropertyUri=$e})(l||(e.CellUri=l={}));const $=U=>w.$i?U.replace(/\//g,"\\"):U;class h{constructor(he=[],Q=e.$EI){this.e=Q,this.d=[...new Set(he)].map(_=>({pattern:_,matches:R.$Ij($(_))}))}sort(he){const Q=new Map(r.Iterable.map(he,V=>[V,$(V)]));let _=[];for(const{matches:V}of this.d)for(const[G,oe]of Q)if(V(oe)){_.push(G),Q.delete(G);break}return Q.size&&(_=_.concat([...Q.keys()].sort((V,G)=>this.e.indexOf(V)-this.e.indexOf(G)))),_}prioritize(he,Q){const _=this.f(he);if(_===-1){this.d.unshift({pattern:he,matches:R.$Ij($(he))});return}const V=new Set(Q.map(oe=>this.f(oe,_)));V.delete(-1);const G=Array.from(V).sort();this.d.splice(_+1,0,...G.map(oe=>this.d[oe]));for(let oe=G.length-1;oe>=0;oe--)this.d.splice(G[oe],1)}toArray(){return this.d.map(he=>he.pattern)}f(he,Q=this.d.length){const _=$(he);for(let V=0;V<Q;V++)if(this.d[V].matches(_))return V;return-1}}e.$II=h;function n(U,he,Q,_=(V,G)=>V===G){const V=[];function G(se,$e,z){if($e===0&&z.length===0)return;const q=V[V.length-1];q&&q.start+q.deleteCount===se?(q.deleteCount+=$e,q.toInsert.push(...z)):V.push({start:se,deleteCount:$e,toInsert:z})}let oe=0,le=0;for(;;){if(oe===U.length){G(oe,0,he.slice(le));break}if(le===he.length){G(oe,U.length-oe,[]);break}const se=U[oe],$e=he[le];if(_(se,$e)){oe+=1,le+=1;continue}Q($e)?(G(oe,1,[]),oe+=1):(G(oe,0,[$e]),le+=1)}return V}e.$JI=n,e.$KI=new v.$gj("notebookEditorCursorAtBoundary","none"),e.$LI=new v.$gj("notebookEditorCursorAtLineBoundary","none");var i;(function(U){U.default="default",U.option="option"})(i||(e.NotebookEditorPriority=i={}));function o(U){const he=U;return!!((typeof he.include=="string"||R.$Jj(he.include))&&(typeof he.exclude=="string"||R.$Jj(he.exclude)))}e.$MI=o;function s(U,he,Q){if(Array.isArray(U.viewType)&&U.viewType.indexOf(he)>=0||U.viewType===he)return!0;if(U.filenamePattern){const _=o(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,V=o(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(R.$Hj(_,(0,P.$nc)(Q.fsPath).toLowerCase()))return!(V&&R.$Hj(V,(0,P.$nc)(Q.fsPath).toLowerCase()))}return!1}e.$NI=s,e.$OI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(t||(e.CellStatusbarAlignment=t={}));class a{static{this.d="notebook/"}static create(he){return`${a.d}${he}`}static parse(he){if(he.startsWith(a.d))return he.substring(a.d.length)}}e.$PI=a;function g(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.$QI=g;const L=new TextDecoder;function D(U){const he=[];let Q=!1;for(const oe of U)(he.length===0||Q)&&(he.push(oe),Q=!0);let _=F(he);const V=E.$ge.concat(he.map(oe=>E.$ge.wrap(oe))),G=ee(V);return _=_||G.byteLength!==V.byteLength,{data:G,didCompression:_}}e.$RI=D,e.$SI=`${String.fromCharCode(27)}[A`;const y=e.$SI.split("").map(U=>U.charCodeAt(0)),A=10;function F(U){let he=!1;return U.forEach((Q,_)=>{if(_===0||Q.length<e.$SI.length)return;const V=U[_-1],G=Q.subarray(0,e.$SI.length);if(G[0]===y[0]&&G[1]===y[1]&&G[2]===y[2]){const oe=V.lastIndexOf(A);if(oe===-1)return;he=!0,U[_-1]=V.subarray(0,oe),U[_]=Q.subarray(e.$SI.length)}}),he}function X(U){let he=U;do U=he,he=U.replace(/[^\n]\x08/gm,"");while(he.length<U.length);return U}function te(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const he=U.match(/^(.*)\r+/m)[1];let Q=U.match(/\r+(.*)$/m)[1];Q=Q+he.slice(Q.length,he.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return U}const J="\b".charCodeAt(0),ie="\r".charCodeAt(0);function ee(U){return!U.buffer.includes(J)&&!U.buffer.includes(ie)?U:E.$ge.fromString(te(X(L.decode(U.buffer))))}}),define(be[132],ve([1,0,18,11,100,26,64,17,10,3,21,35,16,117,131]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p){"use strict";var c,m,u,d,l,$,h,n,i,o,s,t,a,g,L,D,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$FM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$EM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.TestRunProfileKind=e.TestResultState=e.$kM=e.$jM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$iM=e.NotebookVariablesRequestKind=e.$hM=e.$gM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$fM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.ColorThemeKind=e.$_L=e.$$L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$0L=e.DebugConsoleMode=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$4L=e.$3L=e.FileChangeType=e.$2L=e.$1L=e.$ZL=e.$YL=e.InlineCompletionTriggerKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.ConfigurationTarget=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$BL=e.ViewBadge=e.ProgressLocation=e.$AL=e.$zL=e.TaskScope=e.ShellQuoting=e.$yL=e.$xL=e.$wL=e.TaskPanelKind=e.TaskRevealKind=e.$vL=e.TerminalLocation=e.$uL=e.$tL=e.$sL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$rL=e.$qL=e.$pL=e.$oL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$nL=e.StatusBarAlignment=e.ViewColumn=e.$mL=e.$lL=e.$kL=e.$jL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$iL=e.$hL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.LanguageStatusSeverity=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.CodeActionTriggerKind=e.$8K=e.$7K=e.SymbolTag=e.SymbolKind=e.$6K=e.$5K=e.DocumentHighlightKind=e.$4K=e.$3K=e.$2K=e.$1K=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZK=e.$YK=e.FileEditType=e.$XK=e.$WK=e.$VK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A(M){return Object.assign(M,{apply:function(...ae){if(ae.length===0)return Reflect.construct(M,[]);{const we=ae.length===1?[]:ae[1];return Reflect.construct(M,we,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(M,[]);{const[we,...Ue]=ae;return Reflect.construct(M,Ue,we.constructor)}}})}var F;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(F||(e.TerminalOutputAnchor=F={}));var X;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(X||(e.TerminalQuickFixType=X={}));let te=c=class{static from(...N){let ae=N;return new c(function(){if(ae){for(const we of ae)we&&typeof we.dispose=="function"&&we.dispose();ae=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$OK=te,e.$OK=te=c=Fe([A],te);let J=m=class{static Min(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let we=1;we<N.length;we++){const Ue=N[we];Ue.isBefore(ae)&&(ae=Ue)}return ae}static Max(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let we=1;we<N.length;we++){const Ue=N[we];Ue.isAfter(ae)&&(ae=Ue)}return ae}static isPosition(N){if(!N)return!1;if(N instanceof m)return!0;const{line:ae,character:we}=N;return typeof ae=="number"&&typeof we=="number"}static of(N){if(N instanceof m)return N;if(this.isPosition(N))return new m(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ae){if(N<0)throw(0,R.$7)("line must be non-negative");if(ae<0)throw(0,R.$7)("character must be non-negative");this.c=N,this.e=ae}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ae=0){if(N===null||ae===null)throw(0,R.$7)();let we;return typeof N>"u"?we=0:typeof N=="number"?we=N:(we=typeof N.lineDelta=="number"?N.lineDelta:0,ae=typeof N.characterDelta=="number"?N.characterDelta:0),we===0&&ae===0?this:new m(this.line+we,this.character+ae)}with(N,ae=this.character){if(N===null||ae===null)throw(0,R.$7)();let we;return typeof N>"u"?we=this.line:typeof N=="number"?we=N:(we=typeof N.line=="number"?N.line:this.line,ae=typeof N.character=="number"?N.character:this.character),we===this.line&&ae===this.character?this:new m(we,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$PK=J,e.$PK=J=m=Fe([A],J);let ie=u=class{static isRange(N){return N instanceof u?!0:N?J.isPosition(N.start)&&J.isPosition(N.end):!1}static of(N){if(N instanceof u)return N;if(this.isRange(N))return new u(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ae,we,Ue){let Ke,_e;if(typeof N=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof Ue=="number"?(Ke=new J(N,ae),_e=new J(we,Ue)):J.isPosition(N)&&J.isPosition(ae)&&(Ke=J.of(N),_e=J.of(ae)),!Ke||!_e)throw new Error("Invalid arguments");Ke.isBefore(_e)?(this.c=Ke,this.e=_e):(this.c=_e,this.e=Ke)}contains(N){return u.isRange(N)?this.contains(N.start)&&this.contains(N.end):J.isPosition(N)?!(J.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ae=J.Max(N.start,this.c),we=J.Min(N.end,this.e);if(!ae.isAfter(we))return new u(ae,we)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ae=J.Min(N.start,this.c),we=J.Max(N.end,this.end);return new u(ae,we)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ae=this.end){if(N===null||ae===null)throw(0,R.$7)();let we;return N?J.isPosition(N)?we=N:(we=N.start||this.start,ae=N.end||this.end):we=this.start,we.isEqual(this.c)&&ae.isEqual(this.end)?this:new u(we,ae)}toJSON(){return[this.start,this.end]}};e.$QK=ie,e.$QK=ie=u=Fe([A],ie);let ee=d=class extends ie{static isSelection(N){return N instanceof d?!0:N?ie.isRange(N)&&J.isPosition(N.anchor)&&J.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ae,we,Ue){let Ke,_e;if(typeof N=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof Ue=="number"?(Ke=new J(N,ae),_e=new J(we,Ue)):J.isPosition(N)&&J.isPosition(ae)&&(Ke=J.of(N),_e=J.of(ae)),!Ke||!_e)throw new Error("Invalid arguments");super(Ke,_e),this.f=Ke,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$RK=ee,e.$RK=ee=d=Fe([A],ee);const U=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,R.$7)("connectionToken")};class he{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae,we){if(typeof N!="string"||N.length===0)throw(0,R.$7)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,R.$7)("port");typeof we<"u"&&U(we),this.host=N,this.port=Math.round(ae),this.connectionToken=we}}e.$SK=he;class Q{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae){this.makeConnection=N,this.connectionToken=ae,typeof ae<"u"&&U(ae)}}e.$TK=Q;class _ extends Error{static NotAvailable(N,ae){return new _(N,f.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(N){return new _(N,f.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ae=f.RemoteAuthorityResolverErrorCode.Unknown,we){super(N),this._message=N,this._code=ae,this._detail=we,Object.setPrototypeOf(this,_.prototype)}}e.$UK=_;var V;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(V||(e.EndOfLine=V={}));var G;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let oe=l=class{static isTextEdit(N){return N instanceof l?!0:N?ie.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ae){return new l(N,ae)}static insert(N,ae){return l.replace(new ie(N,N),ae)}static delete(N){return l.replace(N,"")}static setEndOfLine(N){const ae=new l(new ie(new J(0,0),new J(0,0)),"");return ae.newEol=N,ae}get range(){return this.c}set range(N){if(N&&!ie.isRange(N))throw(0,R.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,R.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,R.$7)("newEol");this.f=N}constructor(N,ae){this.c=N,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VK=oe,e.$VK=oe=l=Fe([A],oe);let le=$=class{static isNotebookCellEdit(N){return N instanceof $?!0:N?Nt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ae){return new $(N,ae)}static insertCells(N,ae){return new $(new Nt(N,N),ae)}static deleteCells(N){return new $(N,[])}static updateCellMetadata(N,ae){const we=new $(new Nt(N,N),[]);return we.newCellMetadata=ae,we}static updateNotebookMetadata(N){const ae=new $(new Nt(0,0),[]);return ae.newNotebookMetadata=N,ae}constructor(N,ae){this.range=N,this.newCells=ae}};e.$WK=le,e.$WK=le=$=Fe([A],le);class se{static isSnippetTextEdit(N){return N instanceof se?!0:N?ie.isRange(N.range)&&q.isSnippetString(N.snippet):!1}static replace(N,ae){return new se(N,ae)}static insert(N,ae){return se.replace(new ie(N,N),ae)}constructor(N,ae){this.range=N,this.snippet=ae}}e.$XK=se;var $e;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ae,we,Ue){this.c.push({_type:1,from:N,to:ae,options:we,metadata:Ue})}createFile(N,ae,we){this.c.push({_type:1,from:void 0,to:N,options:ae,metadata:we})}deleteFile(N,ae,we){this.c.push({_type:1,from:N,to:void 0,options:ae,metadata:we})}e(N,ae,we){this.c.push({_type:3,metadata:we,uri:N,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(N,ae,we,Ue){const Ke=ae.start,_e=ae.end;(Ke!==_e||we.length>0)&&this.c.push({_type:5,uri:N,index:Ke,count:_e-Ke,cells:we,metadata:Ue})}g(N,ae,we,Ue){this.c.push({_type:3,metadata:Ue,uri:N,edit:{editType:3,index:ae,metadata:we}})}replace(N,ae,we,Ue){this.c.push({_type:2,uri:N,edit:new oe(ae,we),metadata:Ue})}insert(N,ae,we,Ue){this.replace(N,new ie(ae,ae),we,Ue)}delete(N,ae,we){this.replace(N,ae,"",we)}has(N){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===N.toString())}set(N,ae){if(ae)for(const we of ae){if(!we)continue;let Ue,Ke;Array.isArray(we)?(Ue=we[0],Ke=we[1]):Ue=we,le.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(N,Ue.range.start,Ue.newCellMetadata,Ke):Ue.newNotebookMetadata?this.e(N,Ue.newNotebookMetadata,Ke):this.f(N,Ue.range,Ue.newCells,Ke):se.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:N,range:Ue.range,edit:Ue.snippet,metadata:Ke}):this.c.push({_type:2,uri:N,edit:Ue,metadata:Ke})}else{for(let we=0;we<this.c.length;we++){const Ue=this.c[we];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===N.toString()&&(this.c[we]=void 0);break}}(0,E.$Ib)(this.c)}}get(N){const ae=[];for(const we of this.c)we._type===2&&we.uri.toString()===N.toString()&&ae.push(we.edit);return ae}entries(){const N=new C.$Ac;for(const ae of this.c)if(ae._type===2){let we=N.get(ae.uri);we||(we=[ae.uri,[]],N.set(ae.uri,we)),we[1].push(ae.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YK=z,e.$YK=z=Fe([A],z);let q=h=class{static isSnippetString(N){return N instanceof h?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=h.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ae=this.e++){if(typeof N=="function"){const we=new h;we.e=this.e,N(we),this.e=we.e,N=we.value}else N=h.c(N);return this.value+="${",this.value+=ae,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ae=this.e++){const we=N.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(N,ae){if(typeof ae=="function"){const we=new h;we.e=this.e,ae(we),this.e=we.e,ae=we.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$ZK=q,e.$ZK=q=h=Fe([A],q);var O;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(O||(e.DiagnosticTag=O={}));var j;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(j||(e.DiagnosticSeverity=j={}));let ne=n=class{static isLocation(N){return N instanceof n?!0:N?ie.isRange(N.range)&&v.URI.isUri(N.uri):!1}constructor(N,ae){if(this.uri=N,ae)if(ie.isRange(ae))this.range=ie.of(ae);else if(J.isPosition(ae))this.range=new ie(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1K=ne,e.$1K=ne=n=Fe([A],ne);let Y=class{static is(N){return N?typeof N.message=="string"&&N.location&&ie.isRange(N.location.range)&&v.URI.isUri(N.location.uri):!1}constructor(N,ae){this.location=N,this.message=ae}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.location.range.isEqual(ae.location.range)&&N.location.uri.toString()===ae.location.uri.toString()}};e.$2K=Y,e.$2K=Y=Fe([A],Y);let Z=class{constructor(N,ae,we=j.Error){if(!ie.isRange(N))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=N,this.message=ae,this.severity=we}toJSON(){return{severity:j[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.severity===ae.severity&&N.code===ae.code&&N.severity===ae.severity&&N.source===ae.source&&N.range.isEqual(ae.range)&&(0,E.$ub)(N.tags,ae.tags)&&(0,E.$ub)(N.relatedInformation,ae.relatedInformation,Y.isEqual)}};e.$3K=Z,e.$3K=Z=Fe([A],Z);let B=class{constructor(N,ae){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ae}};e.$4K=B,e.$4K=B=Fe([A],B);var H;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(H||(e.DocumentHighlightKind=H={}));let T=class{constructor(N,ae=H.Text){this.range=N,this.kind=ae}toJSON(){return{range:this.range,kind:H[this.kind]}}};e.$5K=T,e.$5K=T=Fe([A],T);let W=class{constructor(N,ae){this.uri=N,this.highlights=ae}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$6K=W,e.$6K=W=Fe([A],W);var x;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(x||(e.SymbolKind=x={}));var re;(function(M){M[M.Deprecated=1]="Deprecated"})(re||(e.SymbolTag=re={}));let fe=i=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ae,we,Ue,Ke){this.name=N,this.kind=ae,this.containerName=Ke,typeof we=="string"&&(this.containerName=we),Ue instanceof ne?this.location=Ue:we instanceof ie&&(this.location=new ne(Ue,we)),i.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};e.$7K=fe,e.$7K=fe=i=Fe([A],fe);let ce=o=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(o.validate)}constructor(N,ae,we,Ue,Ke){this.name=N,this.detail=ae,this.kind=we,this.range=Ue,this.selectionRange=Ke,this.children=[],o.validate(this)}};e.$8K=ce,e.$8K=ce=o=Fe([A],ce);var ge;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(ge||(e.CodeActionTriggerKind=ge={}));let ye=class{constructor(N,ae){this.title=N,this.kind=ae}};e.$9K=ye,e.$9K=ye=Fe([A],ye);let Ie=class{static{s=this}static{this.c="."}constructor(N){this.value=N}append(N){return new s(this.value?this.value+s.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+s.c)}};e.$0K=Ie,e.$0K=Ie=s=Fe([A],Ie),Ie.Empty=new Ie(""),Ie.QuickFix=Ie.Empty.append("quickfix"),Ie.Refactor=Ie.Empty.append("refactor"),Ie.RefactorExtract=Ie.Refactor.append("extract"),Ie.RefactorInline=Ie.Refactor.append("inline"),Ie.RefactorMove=Ie.Refactor.append("move"),Ie.RefactorRewrite=Ie.Refactor.append("rewrite"),Ie.Source=Ie.Empty.append("source"),Ie.SourceOrganizeImports=Ie.Source.append("organizeImports"),Ie.SourceFixAll=Ie.Source.append("fixAll"),Ie.Notebook=Ie.Empty.append("notebook");let Re=class{constructor(N,ae){if(this.range=N,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$$K=Re,e.$$K=Re=Fe([A],Re);class me{constructor(N,ae,we,Ue,Ke,_e){this.kind=N,this.name=ae,this.detail=we,this.uri=Ue,this.range=Ke,this.selectionRange=_e}}e.$_K=me;class De{constructor(N,ae){this.fromRanges=ae,this.from=N}}e.$aL=De;class Ee{constructor(N,ae){this.fromRanges=ae,this.to=N}}e.$bL=Ee;var Me;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Me||(e.LanguageStatusSeverity=Me={}));let je=class{constructor(N,ae){this.range=N,this.command=ae}get isResolved(){return!!this.command}};e.$cL=je,e.$cL=je=Fe([A],je);let We=t=class{#e;static isMarkdownString(N){return N instanceof t?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ae=!1){this.#e=new r.$dk(N,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ae){return this.#e.appendCodeblock(ae??"",N),this}};e.$dL=We,e.$dL=We=t=Fe([A],We);let He=class{constructor(N,ae){this.label=N,this.documentation=ae}};e.$eL=He,e.$eL=He=Fe([A],He);let Qe=class{constructor(N,ae){this.label=N,this.documentation=ae,this.parameters=[]}};e.$fL=Qe,e.$fL=Qe=Fe([A],Qe);let Ye=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$gL=Ye,e.$gL=Ye=Fe([A],Ye);var et;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var pe;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(pe||(e.InlayHintKind=pe={}));let Se=class{constructor(N){this.value=N}};e.$hL=Se,e.$hL=Se=Fe([A],Se);let Ae=class{constructor(N,ae,we){this.position=N,this.label=ae,this.kind=we}};e.$iL=Ae,e.$iL=Ae=Fe([A],Ae);var Oe;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Oe||(e.CompletionTriggerKind=Oe={}));var Be;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var Te;(function(M){M[M.Deprecated=1]="Deprecated"})(Te||(e.CompletionItemTag=Te={}));let qe=class{constructor(N,ae){this.label=N,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$jL=qe,e.$jL=qe=Fe([A],qe);let Je=class{constructor(N=[],ae=!1){this.items=N,this.isIncomplete=ae}};e.$kL=Je,e.$kL=Je=Fe([A],Je);let Ge=class{constructor(N,ae,we){this.insertText=N,this.range=ae,this.command=we}};e.$lL=Ge,e.$lL=Ge=Fe([A],Ge);let Ze=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$mL=Ze,e.$mL=Ze=Fe([A],Ze);var nt;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var Xe;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function it(M,N){return`${k.$gm.toKey(M)}.${N}`}e.$nL=it;var ot;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(ot||(e.TextEditorLineNumbersStyle=ot={}));var ut;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(ut||(e.TextDocumentSaveReason=ut={}));var ht;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(ht||(e.TextEditorRevealType=ht={}));var dt;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(dt||(e.TextEditorSelectionChangeKind=dt={}));var Ft;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(Ft||(e.TextDocumentChangeReason=Ft={}));var jt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(jt||(e.DecorationRangeBehavior=jt={})),function(M){function N(ae){switch(ae){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=N}(dt||(e.TextEditorSelectionChangeKind=dt={}));var St;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(St||(e.SyntaxTokenType=St={})),function(M){function N(ae){switch(ae){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=N}(St||(e.SyntaxTokenType=St={}));let It=class{constructor(N,ae){if(ae&&!v.URI.isUri(ae))throw(0,R.$7)("target");if(!ie.isRange(N)||N.isEmpty)throw(0,R.$7)("range");this.range=N,this.target=ae}};e.$oL=It,e.$oL=It=Fe([A],It);let mt=class{constructor(N,ae,we,Ue){this.red=N,this.green=ae,this.blue=we,this.alpha=Ue}};e.$pL=mt,e.$pL=mt=Fe([A],mt);let gt=class{constructor(N,ae){if(ae&&!(ae instanceof mt))throw(0,R.$7)("color");if(!ie.isRange(N)||N.isEmpty)throw(0,R.$7)("range");this.range=N,this.color=ae}};e.$qL=gt,e.$qL=gt=Fe([A],gt);let At=class{constructor(N){if(!N||typeof N!="string")throw(0,R.$7)("label");this.label=N}};e.$rL=At,e.$rL=At=Fe([A],At);var bt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(bt||(e.ColorFormat=bt={}));var Mt;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Mt||(e.SourceControlInputBoxValidationType=Mt={}));var Rt;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(Rt||(e.TerminalExitReason=Rt={}));class st{constructor(N,ae,we){if(this.startIndex=N,this.length=ae,this.tooltip=we,typeof N!="number"||N<0)throw(0,R.$7)("startIndex");if(typeof ae!="number"||ae<1)throw(0,R.$7)("length");if(we!==void 0&&typeof we!="string")throw(0,R.$7)("tooltip")}}e.$sL=st;class $t{constructor(N){this.uri=N}}e.$tL=$t;class ft{constructor(N){this.terminalCommand=N}}e.$uL=ft;var Tt;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Tt||(e.TerminalLocation=Tt={}));class Ut{constructor(N){if(this.options=N,typeof N!="object")throw(0,R.$7)("options")}}e.$vL=Ut;var zt;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(zt||(e.TaskRevealKind=zt={}));var Bt;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Bt||(e.TaskPanelKind=Bt={}));let yt=class{static{a=this}static{this.Clean=new a("clean","Clean")}static{this.Build=new a("build","Build")}static{this.Rebuild=new a("rebuild","Rebuild")}static{this.Test=new a("test","Test")}static from(N){switch(N){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}constructor(N,ae){if(this.label=ae,typeof N!="string"||typeof ae!="string")throw(0,R.$7)("name");this.c=N}get id(){return this.c}};e.$wL=yt,e.$wL=yt=a=Fe([A],yt);function Ot(M){let N="";for(let ae=0;ae<M.length;ae++)N+=M[ae].replace(/,/g,",,")+",";return N}let Et=class{constructor(N,ae,we){if(typeof N!="string")throw(0,R.$7)("process");this.e=[],this.c=N,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=we):this.f=ae)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,R.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)N.push(ae);return Ot(N)}};e.$xL=Et,e.$xL=Et=Fe([A],Et);let kt=class{constructor(N,ae,we){if(this.f=[],Array.isArray(ae)){if(!N)throw(0,R.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,R.$7)("command");this.e=N,this.f=ae,this.g=we}else{if(typeof N!="string")throw(0,R.$7)("commandLine");this.c=N,this.g=ae}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,R.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,R.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)N.push(typeof ae=="string"?ae:ae.value);return Ot(N)}};e.$yL=kt,e.$yL=kt=Fe([A],kt);var Wt;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(Wt||(e.ShellQuoting=Wt={}));var Ht;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(Ht||(e.TaskScope=Ht={}));class Vt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,I.$mg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$zL=Vt;let ke=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ae,we,Ue,Ke,_e){this.k=!1,this.l=this.definition=N;let tt;typeof ae=="string"?(this.n=this.name=ae,this.u=this.source=we,this.execution=Ue,tt=Ke,this.k=!0):ae===Ht.Global||ae===Ht.Workspace?(this.target=ae,this.n=this.name=we,this.u=this.source=Ue,this.execution=Ke,tt=_e):(this.target=ae,this.n=this.name=we,this.u=this.source=Ue,this.execution=Ke,tt=_e),typeof tt=="string"?(this.q=[tt],this.r=!0):Array.isArray(tt)?(this.q=tt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Et?this.l={type:g.e,id:this.o.computeId()}:this.o instanceof kt?this.l={type:g.f,id:this.o.computeId()}:this.o instanceof Vt?this.l={type:g.c,id:this.o.computeId()}:this.l={type:g.g,id:(0,I.$mg)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,R.$7)("Kind can't be undefined or null");this.A(),this.l=N}get scope(){return this.m}set target(N){this.A(),this.m=N}get name(){return this.n}set name(N){if(typeof N!="string")throw(0,R.$7)("name");this.A(),this.n=N}get execution(){return this.o}set execution(N){N===null&&(N=void 0),this.A(),this.o=N;const ae=this.l.type;(g.g===ae||g.e===ae||g.f===ae||g.c===ae)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(N){if(Array.isArray(N))this.A(),this.q=N,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.A(),this.t=N}get source(){return this.u}set source(N){if(typeof N!="string"||N.length===0)throw(0,R.$7)("source must be a string of length > 0");this.A(),this.u=N}get group(){return this.w}set group(N){N===null&&(N=void 0),this.A(),this.w=N}get detail(){return this.z}set detail(N){N===null&&(N=void 0),this.z=N}get presentationOptions(){return this.x}set presentationOptions(N){N==null&&(N=Object.create(null)),this.A(),this.x=N}get runOptions(){return this.y}set runOptions(N){N==null&&(N=Object.create(null)),this.A(),this.y=N}};e.$AL=ke,e.$AL=ke=g=Fe([A],ke);var Ce;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(Ce||(e.ProgressLocation=Ce={}));var de;(function(M){function N(ae){const we=ae;return(0,w.$If)(we.value)?we.tooltip&&!(0,w.$Ef)(we.tooltip)?(console.log("INVALID view badge, invalid tooltip",we.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",we.value),!1)}M.isViewBadge=N})(de||(e.ViewBadge=de={}));let K=L=class{static isTreeItem(N,ae){const we=N;if(we.checkboxState!==void 0){const Ue=(0,w.$If)(we.checkboxState)?we.checkboxState:(0,w.$Gf)(we.checkboxState)&&(0,w.$If)(we.checkboxState.state)?we.checkboxState.state:void 0,Ke=!(0,w.$If)(we.checkboxState)&&(0,w.$Gf)(we.checkboxState)?we.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Ne.Checked&&Ue!==Ne.Unchecked||Ke!==void 0&&!(0,w.$Ef)(Ke))return console.log("INVALID tree item, invalid checkboxState",we.checkboxState),!1}if(N instanceof L)return!0;if(we.label!==void 0&&!(0,w.$Ef)(we.label)&&!we.label?.label)return console.log("INVALID tree item, invalid label",we.label),!1;if(we.id!==void 0&&!(0,w.$Ef)(we.id))return console.log("INVALID tree item, invalid id",we.id),!1;if(we.iconPath!==void 0&&!(0,w.$Ef)(we.iconPath)&&!v.URI.isUri(we.iconPath)&&(!we.iconPath||!(0,w.$Ef)(we.iconPath.id))){const Ue=we.iconPath;if(!Ue||!(0,w.$Ef)(Ue.light)&&!v.URI.isUri(Ue.light)&&!(0,w.$Ef)(Ue.dark)&&!v.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",we.iconPath),!1}return we.description!==void 0&&!(0,w.$Ef)(we.description)&&typeof we.description!="boolean"?(console.log("INVALID tree item, invalid description",we.description),!1):we.resourceUri!==void 0&&!v.URI.isUri(we.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",we.resourceUri),!1):we.tooltip!==void 0&&!(0,w.$Ef)(we.tooltip)&&!(we.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",we.tooltip),!1):we.command!==void 0&&!we.command.command?(console.log("INVALID tree item, invalid command",we.command),!1):we.collapsibleState!==void 0&&we.collapsibleState<Pe.None&&we.collapsibleState>Pe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",we.collapsibleState),!1):we.contextValue!==void 0&&!(0,w.$Ef)(we.contextValue)?(console.log("INVALID tree item, invalid contextValue",we.contextValue),!1):we.accessibilityInformation!==void 0&&!we.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",we.accessibilityInformation),!1):!0}constructor(N,ae=Pe.None){this.collapsibleState=ae,v.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$BL=K,e.$BL=K=L=Fe([A],K);var Pe;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(Pe||(e.TreeItemCollapsibleState=Pe={}));var Ne;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(Ne||(e.TreeItemCheckboxState=Ne={}));let Ve=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$CL=Ve,e.$CL=Ve=Fe([A],Ve);class ze extends Ve{}e.$DL=ze;class xe extends ze{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$EL=xe;class ct{constructor(N,ae,we,Ue){this.name=N,this.uri=ae,this._itemId=we,this.c=Ue}data(){return this.c()}}e.$FL=ct;let wt=class{#e=new Map;constructor(N){for(const[ae,we]of N??[]){const Ue=this.#e.get(this.#t(ae));Ue?Ue.push(we):this.#e.set(this.#t(ae),[we])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ae){this.#e.set(this.#t(N),[ae])}forEach(N,ae){for(const[we,Ue]of this.#e)for(const Ke of Ue)N.call(ae,Ke,we,this)}*[Symbol.iterator](){for(const[N,ae]of this.#e)for(const we of ae)yield[N,we]}#t(N){return N.toLowerCase()}};e.$GL=wt,e.$GL=wt=Fe([A],wt);let pt=class{constructor(N){this.insertText=N}};e.$HL=pt,e.$HL=pt=Fe([A],pt);let at=class{constructor(N,ae){this.label=ae,this.insertText=N}};e.$IL=at,e.$IL=at=Fe([A],at);let rt=class{constructor(N,ae){this.id=N,this.color=ae}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$JL=rt,e.$JL=rt=Fe([A],rt),rt.File=new rt("file"),rt.Folder=new rt("folder");let Zt=class{constructor(N){this.id=N}};e.$KL=Zt,e.$KL=Zt=Fe([A],Zt);var Dn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Dn||(e.ConfigurationTarget=Dn={}));let Xt=class{get base(){return this.c}set base(N){this.c=N,this.e=v.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ae){if(typeof N!="string"&&(!N||!v.URI.isUri(N)&&!v.URI.isUri(N.uri)))throw(0,R.$7)("base");if(typeof ae!="string")throw(0,R.$7)("pattern");typeof N=="string"?this.baseUri=v.URI.file(N):v.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$LL=Xt,e.$LL=Xt=Fe([A],Xt);const Sn=new WeakMap;function ci(M,N){Sn.set(M,N)}e.$ML=ci;let qt=class{constructor(N,ae,we,Ue){this.enabled=typeof N=="boolean"?N:!0,typeof ae=="string"&&(this.condition=ae),typeof we=="string"&&(this.hitCondition=we),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=Sn.get(this)??(0,I.$mg)()),this.c}};e.$NL=qt,e.$NL=qt=Fe([A],qt);let xt=class extends qt{constructor(N,ae,we,Ue,Ke){if(super(ae,we,Ue,Ke),N===null)throw(0,R.$7)("location");this.location=N}};e.$OL=xt,e.$OL=xt=Fe([A],xt);let _t=class extends qt{constructor(N,ae,we,Ue,Ke){super(ae,we,Ue,Ke),this.functionName=N}};e.$PL=_t,e.$PL=_t=Fe([A],_t);let en=class extends qt{constructor(N,ae,we,Ue,Ke,_e,tt){if(super(Ue,Ke,_e,tt),!ae)throw(0,R.$7)("dataId");this.label=N,this.dataId=ae,this.canPersist=we}};e.$QL=en,e.$QL=en=Fe([A],en);let tn=class{constructor(N,ae,we){this.command=N,this.args=ae||[],this.options=we}};e.$RL=tn,e.$RL=tn=Fe([A],tn);let nn=class{constructor(N,ae){this.port=N,this.host=ae}};e.$SL=nn,e.$SL=nn=Fe([A],nn);let sn=class{constructor(N){this.path=N}};e.$TL=sn,e.$TL=sn=Fe([A],sn);let rn=class{constructor(N){this.implementation=N}};e.$UL=rn,e.$UL=rn=Fe([A],rn);let on=class{constructor(N,ae,we){this.session=N,this.threadId=ae,this.frameId=we}};e.$VL=on,e.$VL=on=Fe([A],on);let an=class{constructor(N,ae){this.session=N,this.threadId=ae}};e.$WL=an,e.$WL=an=Fe([A],an);let cn=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$XL=cn,e.$XL=cn=Fe([A],cn);var Pn;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Pn||(e.InlineCompletionTriggerKind=Pn={}));let ln=class{constructor(N,ae){this.range=N,this.text=ae}};e.$YL=ln,e.$YL=ln=Fe([A],ln);let un=class{constructor(N,ae,we=!0){this.range=N,this.variableName=ae,this.caseSensitiveLookup=we}};e.$ZL=un,e.$ZL=un=Fe([A],un);let hn=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$1L=hn,e.$1L=hn=Fe([A],hn);let fn=class{constructor(N,ae){this.frameId=N,this.stoppedLocation=ae}};e.$2L=fn,e.$2L=fn=Fe([A],fn);var Cn;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Cn||(e.FileChangeType=Cn={}));let dn=D=class extends Error{static FileExists(N){return new D(N,b.FileSystemProviderErrorCode.FileExists,D.FileExists)}static FileNotFound(N){return new D(N,b.FileSystemProviderErrorCode.FileNotFound,D.FileNotFound)}static FileNotADirectory(N){return new D(N,b.FileSystemProviderErrorCode.FileNotADirectory,D.FileNotADirectory)}static FileIsADirectory(N){return new D(N,b.FileSystemProviderErrorCode.FileIsADirectory,D.FileIsADirectory)}static NoPermissions(N){return new D(N,b.FileSystemProviderErrorCode.NoPermissions,D.NoPermissions)}static Unavailable(N){return new D(N,b.FileSystemProviderErrorCode.Unavailable,D.Unavailable)}constructor(N,ae=b.FileSystemProviderErrorCode.Unknown,we){super(v.URI.isUri(N)?N.toString(!0):N),this.code=we?.name??"Unknown",(0,b.$Ak)(this,ae),Object.setPrototypeOf(this,D.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}};e.$3L=dn,e.$3L=dn=D=Fe([A],dn);let mn=class{constructor(N,ae,we){this.start=N,this.end=ae,this.kind=we}};e.$4L=mn,e.$4L=mn=Fe([A],mn);var In;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(In||(e.FoldingRangeKind=In={}));var An;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(An||(e.CommentThreadCollapsibleState=An={}));var Ln;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Ln||(e.CommentMode=Ln={}));var Rn;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(Rn||(e.CommentState=Rn={}));var On;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(On||(e.CommentThreadState=On={}));class li{constructor(N,ae=[]){this.tokenTypes=N,this.tokenModifiers=ae}}e.$5L=li;function ui(M){return typeof M>"u"||(0,w.$Ff)(M)}class gn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ae=0,we=N.tokenTypes.length;ae<we;ae++)this.k.set(N.tokenTypes[ae],ae);for(let ae=0,we=N.tokenModifiers.length;ae<we;ae++)this.l.set(N.tokenModifiers[ae],ae)}}push(N,ae,we,Ue,Ke){if(typeof N=="number"&&typeof ae=="number"&&typeof we=="number"&&typeof Ue=="number"&&(typeof Ke=="number"||typeof Ke>"u"))return typeof Ke>"u"&&(Ke=0),this.o(N,ae,we,Ue,Ke);if(ie.isRange(N)&&typeof ae=="string"&&ui(we))return this.n(N,ae,we);throw(0,R.$7)()}n(N,ae,we){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ue=N.start.line,Ke=N.start.character,_e=N.end.character-N.start.character,tt=this.k.get(ae);let lt=0;if(we)for(const vt of we){if(!this.l.has(vt))throw new Error("`tokenModifier` is not in the provided legend");const Dt=this.l.get(vt);lt|=1<<Dt>>>0}this.o(Ue,Ke,_e,tt,lt)}o(N,ae,we,Ue,Ke){if(this.f&&(N<this.c||N===this.c&&ae<this.e)){this.f=!1;const lt=this.g.length/5|0;let vt=0,Dt=0;for(let Ct=0;Ct<lt;Ct++){let Lt=this.g[5*Ct],Gt=this.g[5*Ct+1];Lt===0?(Lt=vt,Gt+=Dt):Lt+=vt,this.g[5*Ct]=Lt,this.g[5*Ct+1]=Gt,vt=Lt,Dt=Gt}}let _e=N,tt=ae;this.f&&this.j>0&&(_e-=this.c,_e===0&&(tt-=this.e)),this.g[this.j++]=_e,this.g[this.j++]=tt,this.g[this.j++]=we,this.g[this.j++]=Ue,this.g[this.j++]=Ke,this.c=N,this.e=ae}static q(N){const ae=[],we=N.length/5|0;for(let tt=0;tt<we;tt++)ae[tt]=tt;ae.sort((tt,lt)=>{const vt=N[5*tt],Dt=N[5*lt];if(vt===Dt){const Ct=N[5*tt+1],Lt=N[5*lt+1];return Ct-Lt}return vt-Dt});const Ue=new Uint32Array(N.length);let Ke=0,_e=0;for(let tt=0;tt<we;tt++){const lt=5*ae[tt],vt=N[lt+0],Dt=N[lt+1],Ct=N[lt+2],Lt=N[lt+3],Gt=N[lt+4],ai=vt-Ke,Mi=ai===0?Dt-_e:Dt,Kt=5*tt;Ue[Kt+0]=ai,Ue[Kt+1]=Mi,Ue[Kt+2]=Ct,Ue[Kt+3]=Lt,Ue[Kt+4]=Gt,Ke=vt,_e=Dt}return Ue}build(N){return this.f?new $n(new Uint32Array(this.g),N):new $n(gn.q(this.g),N)}}e.$6L=gn;class $n{constructor(N,ae){this.resultId=ae,this.data=N}}e.$7L=$n;class hi{constructor(N,ae,we){this.start=N,this.deleteCount=ae,this.data=we}}e.$8L=hi;class fi{constructor(N,ae){this.resultId=ae,this.edits=N}}e.$9L=fi;var Nn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Nn||(e.DebugConsoleMode=Nn={}));let pn=class{static{this.Back={iconPath:new rt("arrow-left")}}constructor(){}};e.$0L=pn,e.$0L=pn=Fe([A],pn);var Fn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Fn||(e.QuickPickItemKind=Fn={}));var jn;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(jn||(e.InputBoxValidationSeverity=jn={}));var Mn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(Mn||(e.ExtensionKind=Mn={}));class di{static validate(N){if(typeof N.badge=="string"){let ae=(0,P.$ff)(N.badge,0);if(ae<N.badge.length&&(ae+=(0,P.$ff)(N.badge,ae)),N.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!rt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ae,we){this.badge=N,this.tooltip=ae,this.color=we}}e.$$L=di;let bn=class{constructor(N){this.kind=N}};e.$_L=bn,e.$_L=bn=Fe([A],bn);var Tn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Tn||(e.ColorThemeKind=Tn={}));class Nt{static isNotebookRange(N){return N instanceof Nt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ae){if(N<0)throw(0,R.$7)("start must be positive");if(ae<0)throw(0,R.$7)("end must be positive");N<=ae?(this.c=N,this.e=ae):(this.c=ae,this.e=N)}with(N){let ae=this.c,we=this.e;return N.start!==void 0&&(ae=N.start),N.end!==void 0&&(we=N.end),ae===this.c&&we===this.e?this:new Nt(ae,we)}}e.$aM=Nt;class Jt{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ae=>Jt.isNotebookCellData(ae))}static isNotebookCellData(N){return!0}constructor(N,ae,we,Ue,Ke,_e,tt){this.kind=N,this.value=ae,this.languageId=we,this.mime=Ue,this.outputs=Ke??[],this.metadata=_e,this.executionSummary=tt,Jt.validate(this)}}e.$bM=Jt;class mi{constructor(N){this.cells=N}}e.$cM=mi;class Pt{static isNotebookCellOutputItem(N){return N instanceof Pt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ae={name:N.name,message:N.message,stack:N.stack};return Pt.json(ae,"application/vnd.code.notebook.error")}static stdout(N){return Pt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Pt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ae="application/octet-stream"){return new Pt(N,ae)}static#e=new TextEncoder;static text(N,ae=S.$3r.text){const we=Pt.#e.encode(String(N));return new Pt(we,ae)}static json(N,ae="text/x-json"){const we=JSON.stringify(N,void 0,"	");return Pt.text(we,ae)}constructor(N,ae){this.data=N,this.mime=ae;const we=(0,S.$7r)(ae,!0);if(!we)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}}e.$dM=Pt;class Qt{static isNotebookCellOutput(N){return N instanceof Qt?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ae=!1){const we=new Set,Ue=new Set;for(let Ke=0;Ke<N.length;Ke++){const _e=N[Ke],tt=(0,S.$7r)(_e.mime);if(!we.has(tt)||(0,p.$QI)(tt)){we.add(tt);continue}Ue.add(Ke),ae&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Ue.size===0?N:N.filter((Ke,_e)=>!Ue.has(_e))}constructor(N,ae,we){this.items=Qt.ensureUniqueMimeTypes(N,!0),typeof ae=="string"?(this.id=ae,this.metadata=we):(this.id=(0,I.$mg)(),this.metadata=ae??we)}}e.$eM=Qt;var Un;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(Un||(e.NotebookCellKind=Un={}));var zn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(zn||(e.NotebookCellExecutionState=zn={}));var Bn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Bn||(e.NotebookCellStatusBarAlignment=Bn={}));var Hn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Hn||(e.NotebookEditorRevealType=Hn={}));class gi{constructor(N,ae){this.text=N,this.alignment=ae}}e.$fM=gi;var qn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(qn||(e.NotebookControllerAffinity=qn={}));var Wn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(Wn||(e.NotebookControllerAffinity2=Wn={}));class $i{constructor(N,ae=[]){this.uri=N,this.provides=(0,E.$3b)(ae)}}e.$gM=$i;class pi{constructor(N){this.label=N}}e.$hM=pi;var Vn;(function(M){M[M.Named=1]="Named",M[M.Indexed=2]="Indexed"})(Vn||(e.NotebookVariablesRequestKind=Vn={}));let wn=class{constructor(N,ae){this.label=N,this.timestamp=ae}};e.$iM=wn,e.$iM=wn=Fe([A],wn);var Gn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Gn||(e.ExtensionMode=Gn={}));var Kn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Kn||(e.ExtensionRuntime=Kn={}));var Jn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(Jn||(e.StandardTokenType=Jn={}));class bi{constructor(N,ae){this.ranges=N,this.wordPattern=ae}}e.$jM=bi;class wi{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$kM=wi;var Qn;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(Qn||(e.TestResultState=Qn={}));var Yn;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(Yn||(e.TestRunProfileKind=Yn={}));let vn=class{constructor(N=void 0,ae=void 0,we=void 0,Ue=!1){this.include=N,this.exclude=ae,this.profile=we,this.continuous=Ue}};e.$lM=vn,e.$lM=vn=Fe([A],vn);let yn=y=class{static diff(N,ae,we){const Ue=new y(N);return Ue.expectedOutput=ae,Ue.actualOutput=we,Ue}constructor(N){this.message=N}};e.$mM=yn,e.$mM=yn=y=Fe([A],yn);let En=class{constructor(N){this.id=N}};e.$nM=En,e.$nM=En=Fe([A],En);class Yt{constructor(N,ae){this.covered=N,this.total=ae}}e.$oM=Yt;class kn{static fromDetails(N,ae){const we=new Yt(0,0),Ue=new Yt(0,0),Ke=new Yt(0,0);for(const tt of ae)if("branches"in tt){we.total+=1,we.covered+=tt.executionCount>0?1:0;for(const lt of tt.branches)Ue.total+=1,Ue.covered+=lt.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=tt.executionCount>0?1:0;const _e=new kn(N,we,Ue.total>0?Ue:void 0,Ke.total>0?Ke:void 0);return _e.detailedCoverage=ae,_e}constructor(N,ae,we,Ue){this.uri=N,this.statementCoverage=ae,this.branchCoverage=we,this.functionCoverage=Ue}}e.$pM=kn;class vi{constructor(N,ae,we=[]){this.executionCount=N,this.location=ae,this.branches=we}}e.$qM=vi;class yi{constructor(N,ae){this.executionCount=N,this.location=ae}}e.$rM=yi;class Ei{constructor(N,ae,we){this.name=N,this.executionCount=ae,this.location=we}}e.$sM=Ei;var Zn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(Zn||(e.ExternalUriOpenerPriority=Zn={}));var Xn;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(Xn||(e.WorkspaceTrustState=Xn={}));var xn;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(xn||(e.PortAutoForwardAction=xn={}));class ki{constructor(N,ae,we,Ue,Ke,_e){this.kind=N,this.name=ae,this.detail=we,this.uri=Ue,this.range=Ke,this.selectionRange=_e}}e.$tM=ki;class Di{constructor(N){this.uri=N}}e.$uM=Di;class Si{constructor(N,ae){this.original=N,this.modified=ae}}e.$vM=Si;class Pi{constructor(N,ae,we,Ue){this.base=N,this.input1=ae,this.input2=we,this.result=Ue}}e.$wM=Pi;class Ci{constructor(N,ae){this.uri=N,this.viewType=ae}}e.$xM=Ci;class Ii{constructor(N){this.viewType=N}}e.$yM=Ii;class Ai{constructor(N,ae){this.uri=N,this.notebookType=ae}}e.$zM=Ai;class Li{constructor(N,ae,we){this.original=N,this.modified=ae,this.notebookType=we}}e.$AM=Li;class Ri{constructor(){}}e.$BM=Ri;class Oi{constructor(N,ae){this.uri=N,this.inputBoxUri=ae}}e.$CM=Oi;class Ni{constructor(N){this.providerId=N}}e.$DM=Ni;var _n;(function(M){M[M.Down=0]="Down",M[M.Up=1]="Up"})(_n||(e.InteractiveSessionVoteDirection=_n={}));var ei;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})(ei||(e.InteractiveSessionCopyKind=ei={}));var ti;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(ti||(e.ChatVariableLevel=ti={}));class Fi{constructor(N,ae){this.label=N,this.values=ae}}e.$EM=Fi;var ni;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted",M[M.Bug=4]="Bug"})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var ii;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.Assistant=2]="Assistant",M[M.Function=3]="Function"})(ii||(e.ChatMessageRole=ii={}));class ji{constructor(N,ae){this.role=N,this.content=ae}}e.$FM=ji;var si;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful"})(si||(e.ChatAgentResultFeedbackKind=si={}));var ri;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(ri||(e.RelatedInformationType=ri={}));var oi;(function(M){M[M.Started=1]="Started",M[M.Recognizing=2]="Recognizing",M[M.Recognized=3]="Recognized",M[M.Stopped=4]="Stopped"})(oi||(e.SpeechToTextStatus=oi={}))}),define(be[271],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0,e.$hN=(0,E.$2h)("environmentVariableService")}),define(be[272],ve([1,0,7,3,65,4,252,10]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=void 0;function w(h,n){if(n)if(C.$i)for(const i in n){let o=i;for(const t in h)if(i.toLowerCase()===t.toLowerCase()){o=t;break}const s=n[i];s!==void 0&&v(h,o,s)}else Object.keys(n).forEach(i=>{const o=n[i];o!==void 0&&v(h,i,o)})}e.$IN=w;function v(h,n,i){typeof i=="string"?h[n]=i:delete h[n]}function I(h,n,i,o){h.TERM_PROGRAM="vscode",n&&(h.TERM_PROGRAM_VERSION=n),f(h,o)&&(h.LANG=p(i)),h.COLORTERM="truecolor"}e.$JN=I;function k(h,n){if(n)for(const i of Object.keys(n)){const o=n[i];o!=null&&(h[i]=o)}}async function b(h,n){return await Promise.all(Object.entries(n).map(async([i,o])=>{if(typeof o=="string")try{n[i]=await h(o)}catch{n[i]=o}})),n}function f(h,n){if(n==="on")return!0;if(n==="auto"){const i=h.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.$KN=f;function p(h){const n=h?h.split("-"):[],i=n.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in o&&n.push(o[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.$LN=p;async function c(h,n,i,o,s,t){if(h.cwd){const g=typeof h.cwd=="object"?h.cwd.fsPath:h.cwd,L=await m(g,i);return(0,S.$GN)(L||g)}let a;return!h.ignoreConfigurationCwd&&s&&(i&&(s=await m(s,i,t)),s&&(E.$ic(s)?a=s:o&&(a=E.$jc(o.fsPath,s)))),a||(a=o?o.fsPath:n||""),(0,S.$GN)(a)}e.$MN=c;async function m(h,n,i){if(n)try{return await n(h)}catch(o){i?.error("Could not resolve terminal cwd",o);return}return h}function u(h,n,i){if(i)return o=>i.resolveWithEnvironment(n,h,o)}e.$NN=u;async function d(h,n,i,o,s,t){const a={};if(h.strictEnv)k(a,h.env);else{k(a,t);const g={...n};i&&(g&&await b(i,g),h.env&&await b(i,h.env)),(0,r.$Ml)(a,"VSCODE_IPC_HOOK_CLI"),w(a,g),w(a,h.env),I(a,o,C.$w,s)}return a}e.$ON=d;async function l(h,n,i,o,s,t,a=C.$i){let g;if((0,P.$Ef)(h)?g=h:(g=h.fsPath,a&&t!==1?g=g.replace(/\\/g,"/"):!a&&t===1&&(g=g.replace(/\//g,"\\"))),!n)return g;const L=g.includes(" "),D=g.includes("(")||g.includes(")"),y=E.$nc(n,".exe"),A=y==="pwsh"||i==="pwsh"||y==="powershell"||i==="powershell";if(A&&(L||g.includes("'")))return`& '${g.replace(/'/g,"''")}'`;if(D&&A)return`& '${g}'`;if(t===1){if(o!==void 0)return o==="gitbash"?(0,S.$EN)(g.replace(/\\/g,"/")):o==="wsl"?s?.getWslPath(g,"win-to-unix")||g:L?`"${g}"`:g;const F=n.toLowerCase();return F.includes("wsl")||F.includes("bash.exe")&&!F.toLowerCase().includes("git")?s?.getWslPath(g,"win-to-unix")||g:L?`"${g}"`:g}return(0,S.$EN)(g)}e.$PN=l;function $(h,n,i){const o=typeof h=="string"?R.URI.parse(h):h;let s=o?n.getWorkspaceFolder(o)??void 0:void 0;if(!s){const t=i.getLastActiveWorkspaceRoot();s=t?n.getWorkspaceFolder(t)??void 0:void 0}return s}e.$QN=$}),define(be[72],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(C){C.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var R;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class r{static fromExtHostTestItem(S,P,w=S.parent){if(S._isRoot)return new r([P]);const v=[S.id];for(let I=w;I&&I.id!==P;I=I.parent)v.push(I.id);return v.push(P),new r(v.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const P=S.indexOf("\0");return P===-1?S:S.slice(0,P)}static fromString(S){return new r(S.split("\0"))}static join(S,P){return new r([...S.path,P])}static joinToString(S,P){return S.toString()+"\0"+P}static parentId(S){const P=S.lastIndexOf("\0");return P===-1?void 0:S.slice(0,P)}static localId(S){const P=S.lastIndexOf("\0");return P===-1?S:S.slice(P+1)}static isChild(S,P){return P.startsWith(S)&&P[S.length]==="\0"}static compare(S,P){return S===P?0:r.isChild(S,P)?2:r.isChild(P,S)?3:1}constructor(S,P=S.length){if(this.path=S,this.d=P,S.length===0||P<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new r(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new r(this.path,S)}compare(S){if(typeof S=="string")return r.compare(this.toString(),S);for(let P=0;P<S.d&&P<this.d;P++)if(S.path[P]!==this.path[P])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.$EJ=r}),define(be[94],ve([1,0,3,79,42,72]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$LJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$KJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$JJ=e.$IJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$HJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$GJ=e.$FJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var S;(function(ee){ee[ee.Unset=0]="Unset",ee[ee.Queued=1]="Queued",ee[ee.Running=2]="Running",ee[ee.Passed=3]="Passed",ee[ee.Failed=4]="Failed",ee[ee.Skipped=5]="Skipped",ee[ee.Errored=6]="Errored"})(S||(e.TestResultState=S={}));var P;(function(ee){ee[ee.Run=1]="Run",ee[ee.Debug=2]="Debug",ee[ee.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var w;(function(ee){ee[ee.Run=2]="Run",ee[ee.Debug=4]="Debug",ee[ee.Coverage=8]="Coverage",ee[ee.HasNonDefaultProfile=16]="HasNonDefaultProfile",ee[ee.HasConfigurable=32]="HasConfigurable",ee[ee.SupportsContinuousRun=64]="SupportsContinuousRun"})(w||(e.TestRunProfileBitset=w={})),e.$FJ=[2,4,8,16,32,64];const v=ee=>"runId"in ee;e.$GJ=v;var I;(function(ee){ee.serialize=U=>({range:U.range.toJSON(),uri:U.uri.toJSON()}),ee.deserialize=U=>({range:r.$Gs.lift(U.range),uri:E.URI.revive(U.uri)})})(I||(e.IRichLocation=I={}));var k;(function(ee){ee[ee.Error=0]="Error",ee[ee.Output=1]="Output"})(k||(e.TestMessageType=k={}));var b;(function(ee){ee.serialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&I.serialize(U.location)}),ee.deserialize=U=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&I.deserialize(U.location)})})(b||(e.ITestErrorMessage=b={}));const f=(ee,U)=>`${U?"s":"e"}${ee}`;e.$HJ=f;var p;(function(ee){ee.serialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&I.serialize(U.location)}),ee.deserialize=U=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&I.deserialize(U.location)})})(p||(e.ITestOutputMessage=p={}));var c;(function(ee){ee.serialize=U=>U.type===0?b.serialize(U):p.serialize(U),ee.deserialize=U=>U.type===0?b.deserialize(U):p.deserialize(U)})(c||(e.ITestMessage=c={}));var m;(function(ee){ee.serializeWithoutMessages=U=>({state:U.state,duration:U.duration,messages:[]}),ee.serialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(c.serialize)}),ee.deserialize=U=>({state:U.state,duration:U.duration,messages:U.messages.map(c.deserialize)})})(m||(e.ITestTaskState=m={}));const u="\0",d=(ee,U)=>ee+u+U;e.$IJ=d;const l=ee=>{const U=ee.indexOf(u);return{ctrlId:ee.slice(0,U),tagId:ee.slice(U+1)}};e.$JJ=l;var $;(function(ee){ee.serialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?.toJSON(),range:U.range?.toJSON()||null,description:U.description,error:U.error,sortText:U.sortText}),ee.deserialize=U=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?E.URI.revive(U.uri):void 0,range:U.range?r.$Gs.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})($||(e.ITestItem=$={}));var h;(function(ee){ee[ee.NotExpandable=0]="NotExpandable",ee[ee.Expandable=1]="Expandable",ee[ee.BusyExpanding=2]="BusyExpanding",ee[ee.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var n;(function(ee){ee.serialize=U=>({expand:U.expand,item:$.serialize(U.item)}),ee.deserialize=U=>({controllerId:C.$EJ.root(U.item.extId),expand:U.expand,item:$.deserialize(U.item)})})(n||(e.InternalTestItem=n={}));var i;(function(ee){ee.serialize=U=>{let he;return U.item&&(he={},U.item.label!==void 0&&(he.label=U.item.label),U.item.tags!==void 0&&(he.tags=U.item.tags),U.item.busy!==void 0&&(he.busy=U.item.busy),U.item.uri!==void 0&&(he.uri=U.item.uri?.toJSON()),U.item.range!==void 0&&(he.range=U.item.range?.toJSON()),U.item.description!==void 0&&(he.description=U.item.description),U.item.error!==void 0&&(he.error=U.item.error),U.item.sortText!==void 0&&(he.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:he}},ee.deserialize=U=>{let he;return U.item&&(he={},U.item.label!==void 0&&(he.label=U.item.label),U.item.tags!==void 0&&(he.tags=U.item.tags),U.item.busy!==void 0&&(he.busy=U.item.busy),U.item.range!==void 0&&(he.range=U.item.range?r.$Gs.lift(U.item.range):null),U.item.description!==void 0&&(he.description=U.item.description),U.item.error!==void 0&&(he.error=U.item.error),U.item.sortText!==void 0&&(he.sortText=U.item.sortText)),{extId:U.extId,expand:U.expand,item:he}}})(i||(e.ITestItemUpdate=i={}));const o=(ee,U)=>{U.expand!==void 0&&(ee.expand=U.expand),U.item!==void 0&&(ee.item=ee.item?Object.assign(ee.item,U.item):U.item)};e.$KJ=o;var s;(function(ee){ee.serializeWithoutMessages=U=>({...n.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(m.serializeWithoutMessages)}),ee.serialize=U=>({...n.serialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(m.serialize)}),ee.deserialize=U=>({...n.deserialize(U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(m.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var t;(function(ee){ee.empty=()=>({covered:0,total:0}),ee.sum=(U,he)=>{U.covered+=he.covered,U.total+=he.total}})(t||(e.ICoveredCount=t={}));var a;(function(ee){ee.serialize=U=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(y.serialize),uri:U.uri.toJSON()}),ee.deserialize=U=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(y.deserialize),uri:E.URI.from(U.uri)})})(a||(e.IFileCoverage=a={}));function g(ee){return{...ee,location:ee.location?.toJSON()}}function L(ee){return ee.location=ee.location?R.$Fs.isIPosition(ee.location)?R.$Fs.lift(ee.location):r.$Gs.lift(ee.location):void 0,ee}e.$LJ=3;var D;(function(ee){ee[ee.Function=0]="Function",ee[ee.Statement=1]="Statement"})(D||(e.DetailType=D={}));var y;(function(ee){ee.serialize=U=>U.type===0?F.serialize(U):X.serialize(U),ee.deserialize=U=>U.type===0?F.deserialize(U):X.deserialize(U)})(y||(e.CoverageDetails=y={}));var A;(function(ee){ee.serialize=g,ee.deserialize=L})(A||(e.IBranchCoverage=A={}));var F;(function(ee){ee.serialize=g,ee.deserialize=L})(F||(e.IFunctionCoverage=F={}));var X;(function(ee){ee.serialize=U=>({...g(U),branches:U.branches?.map(A.serialize)}),ee.deserialize=U=>({...L(U),branches:U.branches?.map(A.deserialize)})})(X||(e.IStatementCoverage=X={}));var te;(function(ee){ee[ee.Add=0]="Add",ee[ee.Update=1]="Update",ee[ee.DocumentSynced=2]="DocumentSynced",ee[ee.Remove=3]="Remove",ee[ee.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",ee[ee.Retire=5]="Retire",ee[ee.AddTag=6]="AddTag",ee[ee.RemoveTag=7]="RemoveTag"})(te||(e.TestDiffOpType=te={}));var J;(function(ee){ee.deserialize=U=>U.op===0?{op:U.op,item:n.deserialize(U.item)}:U.op===1?{op:U.op,item:i.deserialize(U.item)}:U.op===2?{op:U.op,uri:E.URI.revive(U.uri),docv:U.docv}:U,ee.serialize=U=>U.op===0?{op:U.op,item:n.serialize(U.item)}:U.op===1?{op:U.op,item:i.serialize(U.item)}:U})(J||(e.TestsDiffOp=J={}));class ie{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(U){const he=this.o();for(const Q of U)switch(Q.op){case 0:this.j(n.deserialize(Q.item),he);break;case 1:this.k(i.deserialize(Q.item),he);break;case 3:this.l(Q.itemId,he);break;case 5:this.m(Q.itemId);break;case 4:this.updatePendingRoots(Q.amount);break;case 6:this.c.set(Q.tag.id,Q.tag);break;case 7:this.c.delete(Q.id);break}he.complete?.()}j(U,he){const Q=C.$EJ.parentId(U.item.extId)?.toString();let _;if(!Q)_=this.p(U),this.f.add(_),this.d.set(U.item.extId,_);else if(this.d.has(Q)){const V=this.d.get(Q);V.children.add(U.item.extId),_=this.p(U,V),this.d.set(U.item.extId,_)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(U)}`);return}return he.add?.(_),U.expand===2&&this.g++,_}k(U,he){const Q=this.d.get(U.extId);if(Q)return U.expand!==void 0&&(Q.expand===2&&this.g--,U.expand===2&&this.g++),(0,e.$KJ)(Q,U),he.update?.(Q),Q}l(U,he){const Q=this.d.get(U);if(!Q)return;const _=C.$EJ.parentId(Q.item.extId)?.toString();_?this.d.get(_).children.delete(Q.item.extId):this.f.delete(Q);const V=[[U]];for(;V.length;)for(const G of V.pop()){const oe=this.d.get(G);oe&&(V.push(oe.children),this.d.delete(G),he.remove?.(oe,oe!==Q),oe.expand===2&&this.g--)}}m(U){}updatePendingRoots(U){this.h+=U}o(){return{}}}e.$MJ=ie}),define(be[133],ve([1,0,14,5,2,96,94,72]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.TestItemEventOp=void 0;var w;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const v=(d,l)=>d===l,k=Object.entries({range:(d,l)=>d===l?!0:!d||!l?!1:d.equalsRange(l),busy:v,label:v,description:v,error:v,sortText:v,tags:(d,l)=>!(d.length!==l.length||d.some($=>!l.includes($)))}),b=(d,l)=>{let $;for(const[h,n]of k)n(d[h],l[h])||($?$[h]=l[h]:$={[h]:l[h]});return $};class f extends r.$Sc{get root(){return this.s.root}constructor(l){super(),this.s=l,this.f=this.B(new E.$bh(()=>this.flushDiff(),200)),this.g=this.B(new R.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(l){this.h=l;for(const $ of this.tree.values())this.I($)}get resolveHandler(){return this.h}collectDiff(){const l=this.m;return this.m=[],l}pushDiff(l){switch(l.op){case 2:{for(const $ of this.m)if($.op===2&&$.uri===l.uri){$.docv=l.docv;return}break}case 1:{const $=this.m[this.m.length-1];if($){if($.op===1&&$.item.extId===l.item.extId){(0,S.$KJ)($.item,l.item);return}if($.op===0&&$.item.item.extId===l.item.extId){(0,S.$KJ)($.item,l.item);return}}break}}this.m.push(l),this.f.isScheduled()||this.f.schedule()}expand(l,$){const h=this.tree.get(l);if(h){if((h.expandLevels===void 0||$>h.expandLevels)&&(h.expandLevels=$),h.expand===1){const n=this.L(h);return n.isOpen()?this.J(h,$-1):n.wait().then(()=>this.J(h,$-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,$-1)):this.J(h,$-1)}}dispose(){for(const l of this.tree.values())this.s.getApiFor(l.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(l,$){switch($.op){case 3:this.N(P.$EJ.joinToString(l.fullId,$.id));break;case 0:this.y($.item,l);break;case 5:for(const h of $.ops)this.u(l,h);break;case 1:this.z($.new,$.old,l.fullId.toString());break;case 2:this.I(l);break;case 4:this.pushDiff({op:1,item:{extId:l.fullId.toString(),item:$.update}});break;case 6:this.w(l.actual.uri);break;default:(0,C.$5c)($)}}w(l){l&&this.pushDiff({op:2,uri:l,docv:this.s.getDocumentVersion(l)})}y(l,$){const h=P.$EJ.fromExtHostTestItem(l,this.root.id,$?.actual),n=this.s.getApiFor(l);n.parent&&n.parent!==$?.actual&&this.s.getChildren(n.parent).delete(l.id);let i=this.tree.get(h.toString());if(!i){i={fullId:h,actual:l,expandLevels:$?.expandLevels?$.expandLevels-1:void 0,expand:0},l.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(l,$),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(l)}}),this.H(l,i,$);return}if(i.actual===l){this.G(l,i,$);return}if(i.actual.uri?.toString()!==l.uri?.toString())return this.N(h.toString()),this.y(l,$);const o=this.s.getChildren(i.actual),s=i.actual,t=b(this.s.toITestItem(s),this.s.toITestItem(l));this.s.getApiFor(s).listener=void 0,i.actual=l,i.expand=0,t&&(t.hasOwnProperty("tags")&&(this.z(l.tags,s.tags,h.toString()),delete t.tags),this.u(i,{op:4,update:t})),this.H(l,i,$);for(const[a,g]of o)this.s.getChildren(l).get(g.id)||this.N(P.$EJ.joinToString(h,g.id));this.w(i.actual.uri)}z(l,$,h){const n=new Set($.map(i=>i.id));for(const i of l)n.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:h,item:{tags:l.map(i=>(0,S.$IJ)(this.s.controllerId,i.id))}}}),n.forEach(this.D,this)}C(l){const $=this.j.get(l.id);$?$.refCount++:(this.j.set(l.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.$IJ)(this.s.controllerId,l.id)}}))}D(l){const $=this.j.get(l);$&&!--$.refCount&&(this.j.delete(l),this.pushDiff({op:7,id:(0,S.$IJ)(this.s.controllerId,l)}))}F(l,$){this.s.getApiFor(l).parent=$&&$.actual!==this.root?$.actual:void 0}G(l,$,h){this.F(l,h);const n=this.s.getApiFor(l);n.parent=h?.actual,n.listener=i=>this.u($,i),this.I($)}H(l,$,h){this.G(l,$,h);for(const[n,i]of this.s.getChildren(l))this.y(i,$)}I(l){let $;this.h?l.resolveBarrier?$=l.resolveBarrier.isOpen()?3:2:$=l.actual.canResolveChildren?1:0:$=0,$!==l.expand&&(l.expand=$,this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:$}}),$===1&&l.expandLevels!==void 0&&this.L(l))}J(l,$){if($<0)return;const h=[];for(const[n,i]of this.s.getChildren(l.actual)){const o=this.expand(P.$EJ.joinToString(l.fullId,i.id),$);(0,E.$Og)(o)&&h.push(o)}if(h.length)return Promise.all(h).then(()=>{})}L(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this.h){const i=new E.$1g;return i.open(),i}l.expand=2,this.M(l);const $=l.resolveBarrier=new E.$1g,h=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let n;try{n=this.h(l.actual===this.root?void 0:l.actual)}catch(i){h(i)}return(0,E.$Og)(n)?n.catch(h).then(()=>{$.open(),this.I(l)}):($.open(),this.I(l)),l.resolveBarrier}M(l){this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:l.expand}})}N(l){const $=this.tree.get(l);if(!$)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:l});const h=[$];for(;h.length;){const n=h.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const i of n.actual.tags)this.D(i.id);this.tree.delete(n.fullId.toString());for(const[i,o]of this.s.getChildren(n.actual))h.push(this.tree.get(P.$EJ.joinToString(n.fullId,o.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.g.fire(l)}}e.$GM=f;class p extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.$HM=p;class c extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$IM=c;class m extends Error{constructor(l,$,h){super(`TestItem with ID "${l}" is from controller "${$}" and cannot be added as a child of an item from controller "${h}".`)}}e.$JM=m;const u=(d,l,$)=>{let h=new Map;return{get size(){return h.size},forEach(n,i){for(const o of h.values())n.call(i,o,this)},[Symbol.iterator](){return h.entries()},replace(n){const i=new Map,o=new Set(h.keys()),s={op:5,ops:[]};for(const t of n){if(!(t instanceof $))throw new c(t.id);const a=l(t).controllerId;if(a!==d.controllerId)throw new m(t.id,a,d.controllerId);if(i.has(t.id))throw new p(t.id);i.set(t.id,t),o.delete(t.id),s.ops.push({op:0,item:t})}for(const t of o.keys())s.ops.push({op:3,id:t});d.listener?.(s),h=i},add(n){if(!(n instanceof $))throw new c(n.id);h.set(n.id,n),d.listener?.({op:0,item:n})},delete(n){h.delete(n)&&d.listener?.({op:3,id:n})},get(n){return h.get(n)},toJSON(){return Array.from(h.values())}}};e.$KM=u}),define(be[134],ve([1,0,133]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;const R=new WeakMap,r=(S,P)=>{const w={controllerId:P};return R.set(S,w),w};e.$LM=r;const C=S=>{const P=R.get(S);if(!P)throw new E.$IM(S?.id||"<unknown>");return P};e.$MM=C}),define(be[273],ve([1,0,24,6]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=e.$GD=void 0,e.$GD=".vscode",e.$HD="settings",e.$ID=`${e.$GD}/${e.$HD}.json`,e.$JD="vscode://schemas/settings/default",e.$KD="vscode://schemas/settings/user",e.$LD="vscode://schemas/settings/profile",e.$MD="vscode://schemas/settings/machine",e.$ND="vscode://schemas/settings/workspace",e.$OD="vscode://schemas/settings/folder",e.$PD="vscode://schemas/launch",e.$QD="vscode://schemas/tasks",e.$RD=[1],e.$SD=[2,3,4,5,6],e.$TD=[3,4,5],e.$UD=[1,...e.$TD],e.$VD=[2,3,4,5,6],e.$WD=[3,4,5,6],e.$XD=[4,5,6],e.$YD="tasks",e.$ZD="launch",e.$1D=Object.create(null),e.$1D[e.$YD]=`${e.$GD}/${e.$YD}.json`,e.$1D[e.$ZD]=`${e.$GD}/${e.$ZD}.json`,e.$2D=Object.create(null),e.$2D[e.$YD]=`${e.$YD}.json`,e.$3D=(0,R.$3h)(E.$vi),e.$4D=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$5D="workbench.settings.applyToAllProfiles"}),define(be[135],ve([1,0,6]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.VariableKind=e.$CN=void 0,e.$CN=(0,E.$2h)("configurationResolverService");var R;(function(C){C.Unknown="unknown",C.Env="env",C.Config="config",C.Command="command",C.Input="input",C.ExtensionInstallFolder="extensionInstallFolder",C.WorkspaceFolder="workspaceFolder",C.Cwd="cwd",C.WorkspaceFolderBasename="workspaceFolderBasename",C.UserHome="userHome",C.LineNumber="lineNumber",C.SelectedText="selectedText",C.File="file",C.FileWorkspaceFolder="fileWorkspaceFolder",C.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",C.RelativeFile="relativeFile",C.RelativeFileDirname="relativeFileDirname",C.FileDirname="fileDirname",C.FileExtname="fileExtname",C.FileBasename="fileBasename",C.FileBasenameNoExtension="fileBasenameNoExtension",C.FileDirnameBasename="fileDirnameBasename",C.ExecPath="execPath",C.ExecInstallFolder="execInstallFolder",C.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class r extends Error{constructor(S,P){super(P),this.variable=S}}e.$DN=r}),define(be[274],ve([1,0,7,29,10,23,4,167,205,135,17]),function(ue,e,E,R,r,C,S,P,w,v,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(f,p,c,m){this.h=new Map,this.a=f,this.b=p,this.g=c,m&&(this.c=m.then(u=>this.i(u)))}i(f){if(S.$i){const p=Object.create(null);return Object.keys(f).forEach(c=>{p[c.toLowerCase()]=f[c]}),p}return f}resolveWithEnvironment(f,p,c){return this.l({env:this.i(f),userHome:void 0},p?p.uri:void 0,c)}async resolveAsync(f,p){const c={env:await this.c,userHome:await this.g};return this.l(c,f?f.uri:void 0,p)}async j(f,p,c,m){const u=C.$hn(p);S.$i&&u.windows?Object.keys(u.windows).forEach(l=>u[l]=u.windows[l]):S.$j&&u.osx?Object.keys(u.osx).forEach(l=>u[l]=u.osx[l]):S.$k&&u.linux&&Object.keys(u.linux).forEach(l=>u[l]=u.linux[l]),delete u.windows,delete u.osx,delete u.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,f?f.uri:void 0,u,c,m)}async resolveAnyAsync(f,p,c){return this.j(f,p,c)}async resolveAnyMap(f,p,c){const m=new Map;return{newConfig:await this.j(f,p,c,m),resolvedVariables:m}}resolveWithInteractionReplace(f,p,c,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(f,p,c,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(f,p){if(this.h.has(f))throw new Error("Variable "+f+" is contributed twice.");this.h.set(f,p)}async l(f,p,c,m,u){if(r.$Ef(c))return this.m(f,p,c,m,u);if(Array.isArray(c))return Promise.all(c.map(d=>this.l(f,p,d,m,u)));if(r.$Gf(c)){const d=Object.create(null),l=await Promise.all(Object.keys(c).map(async $=>[await this.m(f,p,$,m,u),await this.l(f,p,c[$],m,u)]));for(const[$,h]of l)d[$]=h;return d}return c}m(f,p,c,m,u){return(0,I.$Ze)(c,k.VARIABLE_REGEXP,async(d,l)=>{if(l.includes(k.VARIABLE_LHS))return d;let $=await this.o(f,d,l,p,m);return u?.set(l,$),$!==d&&r.$Ef($)&&$.match(k.VARIABLE_REGEXP)&&($=await this.m(f,p,$,m,u)),$})}n(f){return this.b?this.b.getUriLabel(f,{noPrefix:!0}):f.fsPath}async o(f,p,c,m,u){let d;const l=c.split(":");l.length>1&&(c=l[0],d=l[1]);const $=i=>{const o=this.a.getFilePath();if(o)return(0,P.$Hv)(o);throw new v.$DN(i,(0,w.localize)(0,null,p))},h=i=>{const o=$(i);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,P.$Hv)(s)}throw new v.$DN(i,(0,w.localize)(1,null,p,E.$nc(o)))},n=i=>{if(d){const o=this.a.getFolderUri(d);if(o)return o;throw new v.$DN(i,(0,w.localize)(2,null,p,d))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new v.$DN(i,(0,w.localize)(3,null,p)):new v.$DN(i,(0,w.localize)(4,null,p))};switch(c){case"env":if(d){if(f.env){const i=f.env[S.$i?d.toLowerCase():d];if(r.$Ef(i))return i}return""}throw new v.$DN(v.VariableKind.Env,(0,w.localize)(5,null,p));case"config":if(d){const i=this.a.getConfigurationValue(m,d);if(r.$Nf(i))throw new v.$DN(v.VariableKind.Config,(0,w.localize)(6,null,p,d));if(r.$Gf(i))throw new v.$DN(v.VariableKind.Config,(0,w.localize)(7,null,p,d));return i}throw new v.$DN(v.VariableKind.Config,(0,w.localize)(8,null,p));case"command":return this.p(v.VariableKind.Command,p,d,u,"command");case"input":return this.p(v.VariableKind.Input,p,d,u,"input");case"extensionInstallFolder":if(d){const i=await this.a.getExtension(d);if(!i)throw new v.$DN(v.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,p,d));return this.n(i.extensionLocation)}throw new v.$DN(v.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,p));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,P.$Hv)(this.n(n(v.VariableKind.WorkspaceFolder)));case"cwd":return m||d?(0,P.$Hv)(this.n(n(v.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.$Hv)(E.$nc(this.n(n(v.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(f.userHome)return f.userHome;throw new v.$DN(v.VariableKind.UserHome,(0,w.localize)(11,null,p))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new v.$DN(v.VariableKind.LineNumber,(0,w.localize)(12,null,p))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new v.$DN(v.VariableKind.SelectedText,(0,w.localize)(13,null,p))}case"file":return $(v.VariableKind.File);case"fileWorkspaceFolder":return h(v.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(v.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||d?E.$lc(this.n(n(v.VariableKind.RelativeFile)),$(v.VariableKind.RelativeFile)):$(v.VariableKind.RelativeFile);case"relativeFileDirname":{const i=E.$mc($(v.VariableKind.RelativeFileDirname));if(m||d){const o=E.$lc(this.n(n(v.VariableKind.RelativeFileDirname)),i);return o.length===0?".":o}return i}case"fileDirname":return E.$mc($(v.VariableKind.FileDirname));case"fileExtname":return E.$oc($(v.VariableKind.FileExtname));case"fileBasename":return E.$nc($(v.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=E.$nc($(v.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-E.$oc(i).length)}case"fileDirnameBasename":return E.$nc(E.$mc($(v.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||p}case"execInstallFolder":{const i=this.a.getAppRoot();return i||p}case"pathSeparator":return E.sep;default:try{const i=d?`${c}:${d}`:c;return this.p(v.VariableKind.Unknown,p,i,u,void 0)}catch{return p}}}}p(f,p,c,m,u){if(c&&m){const d=u===void 0?m[c]:m[u+":"+c];if(typeof d=="string")return d;throw new v.$DN(f,(0,w.localize)(14,null,p))}return p}}e.$RN=k}),define(be[275],ve([1,0,6,93]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.OpenEditorContext=e.GroupsOrder=e.$RC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$QC=void 0,e.$QC=(0,E.$2h)("editorGroupsService");var r;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var C;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(C||(e.GroupOrientation=C={}));var S;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(S||(e.GroupLocation=S={}));var P;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(P||(e.GroupsArrangement=P={}));var w;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function v(p){const c=p;return(0,R.$zE)(c?.editor)&&(0,R.$zE)(c?.replacement)}e.$RC=v;var I;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var k;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function b(p){const c=p;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$SC=b;function f(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$TC=f}),define(be[136],ve([1,0,6,275]),function(ue,e,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.$VC=e.$UC=void 0,e.$UC=(0,E.$2h)("editorService"),e.$VC=-1,e.$WC=-2;function r(C){const S=C;return typeof C=="number"||(0,R.$SC)(S)}e.$XC=r}),define(be[276],ve([1,0,273,117,92,90,135,93,136,12,225,271,91]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0,e.$TN="remoteterminal";let f=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,m,u,d,l,$,h,n,i,o){this.a=c,this.b=m,this.c=u,this.d=d,this.e=l,this.f=$,this.g=h,this.h=n,this.i=i,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,m,u,d,l,$,h,n){await this.c.whenRemoteConfigurationLoaded();const i=Object.create(null),o=u?this.d.getWorkspaceFolder(u)??void 0:void 0;let s;try{s=(await this.e.resolveAnyMap(o,{shellLaunchConfig:c,configuration:m})).resolvedVariables}catch(X){this.h.error(X)}if(s)for(const[X,te]of s.entries())(/^config:/.test(X)||X==="selectedText"||X==="lineNumber")&&(i[X]=te);const t=[];for(const[X,te]of this.f.collections.entries())t.push([X,(0,C.$xr)(te.map),(0,C.$yr)(te.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),g=a.options&&a.options.extensionHostEnv,L=this.d.getWorkspace(),D=L.folders,y=u?this.d.getWorkspaceFolder(u):null,A=P.$HE.getOriginalUri(this.i.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[v.Schemas.file,v.Schemas.vscodeUserData,v.Schemas.vscodeRemote]}),F={configuration:m,resolvedVariables:i,envVariableCollections:t,shellLaunchConfig:c,workspaceId:L.id,workspaceName:this.j.getWorkspaceLabel(L),workspaceFolders:D,activeWorkspaceFolder:y,activeFileResource:A,shouldPersistTerminal:l,options:d,cols:$,rows:h,unicodeVersion:n,resolverEnv:g};return await this.b.call("$createProcess",F)}requestDetachInstance(c,m){return this.b.call("$requestDetachInstance",[c,m])}acceptDetachInstanceReply(c,m){return this.b.call("$acceptDetachInstanceReply",[c,m])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,m){return this.b.call("$detachFromProcess",[c,m])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,m){return this.b.call("$processBinary",[c,m])}start(c){return this.b.call("$start",[c])}input(c,m){return this.b.call("$input",[c,m])}acknowledgeDataEvent(c,m){return this.b.call("$acknowledgeDataEvent",[c,m])}setUnicodeVersion(c,m){return this.b.call("$setUnicodeVersion",[c,m])}shutdown(c,m){return this.b.call("$shutdown",[c,m])}resize(c,m,u){return this.b.call("$resize",[c,m,u])}clearBuffer(c){return this.b.call("$clearBuffer",[c])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,m,u){return this.b.call("$sendCommandResult",[c,m,u])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,m){return this.b.call("$installAutoReply",[c,m])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,m,u){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,m,u])}acceptPtyHostResolvedVariables(c,m){return this.b.call("$acceptPtyHostResolvedVariables",[c,m])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,m){return this.b.call("$getWslPath",[c,m])}setTerminalLayoutInfo(c){const u={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",u)}updateTitle(c,m,u){return this.b.call("$updateTitle",[c,m,u])}updateIcon(c,m,u,d){return this.b.call("$updateIcon",[c,m,u,d])}refreshProperty(c,m){return this.b.call("$refreshProperty",[c,m])}updateProperty(c,m,u){return this.b.call("$updateProperty",[c,m,u])}getTerminalLayoutInfo(){const m={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",m)}reviveTerminalProcesses(c,m,u){return this.b.call("$reviveTerminalProcesses",[c,m,u])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};e.$UN=f,e.$UN=f=Fe([Le(2,E.$3D),Le(3,r.$$h),Le(4,S.$CN),Le(5,k.$hN),Le(6,R.$3k),Le(7,b.$kr),Le(8,w.$UC),Le(9,I.$av)],f)}),define(be[277],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.ExtHostConnectionType=void 0;var E;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(E||(e.ExtHostConnectionType=E={}));class R{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(k){this.pipeName=k,this.type=1}serialize(k){k[R.ENV_KEY]=this.pipeName}}e.$Km=R;class r{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(k){k[r.ENV_KEY]="1"}}e.$Lm=r;class C{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(k){k[C.ENV_KEY]="1"}}e.$Mm=C;function S(I){delete I[R.ENV_KEY],delete I[r.ENV_KEY],delete I[C.ENV_KEY]}function P(I,k){S(k),I.serialize(k)}e.$Nm=P;function w(I){if(I[R.ENV_KEY])return v(I,new R(I[R.ENV_KEY]));if(I[r.ENV_KEY])return v(I,new r);if(I[C.ENV_KEY])return v(I,new C);throw new Error("No connection information defined in environment!")}e.$Om=w;function v(I,k){return S(I),k}}),define(be[278],ve([1,0,15]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$pm=e.$om=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(v){v[v.Desktop=1]="Desktop",v[v.Web=2]="Web"})(R||(e.UIKind=R={}));var r;(function(v){v[v.VersionMismatch=55]="VersionMismatch",v[v.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var C;(function(v){v[v.Initialized=0]="Initialized",v[v.Ready=1]="Ready",v[v.Terminate=2]="Terminate"})(C||(e.MessageType=C={}));function S(v){const I=E.$ge.alloc(1);switch(v){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}e.$om=S;function P(v,I){if(v.byteLength!==1)return!1;switch(v.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}e.$pm=P;var w;(function(v){v.Start="START_NATIVE_LOG",v.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(be[279],ve([1,0,6,5,13,267,278,57,38,23,3,2,203]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.$9M=e.$8M=void 0;let f=class extends k.$Sc{constructor(u,d){super(),this.s=u,this.t=d,this.a=this.B(new R.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=I.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:w.$Bo,name:(0,b.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(d.onDidChangeLogLevel(l=>{(0,r.$lj)(l)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,d,l){const $=this.getTelemetryDetails(),h=new p(d,l,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}),n=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...n,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(u,d,l){this.f=u,this.g=d,this.c=l??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const d=Object.create(null);switch(d["common.extname"]=`${u.publisher}.${u.name}`,d["common.extversion"]=u.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case S.UIKind.Web:d["common.uikind"]="web";break;case S.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,P.$9k)((0,w.$Io)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const d=this.getTelemetryDetails();this.r.forEach((l,$)=>{const h=l.filter(n=>!n.isDisposed);h.length===0?this.r.delete($):this.r.set($,h)}),this.r.forEach(l=>{for(const $ of l)$.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,d){const $=this.r.get(u.value)?.filter(n=>!n.isDisposed);if(!$)return this.r.delete(u.value),!1;let h=!1;for(const n of $)n.ignoreUnhandledExtHostErrors||(n.logError(d),h=!0);return h}};e.$8M=f,e.$8M=f=Fe([Le(0,C.$7M),Le(1,r.$kj)],f);class p{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,d,l,$,h,n,i){this.g=l,this.h=$,this.i=h,this.j=n,this.a=new R.$Sd,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(u,d){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let d="properties"in u?u.properties??{}:u;return d=(0,w.$Lo)(d,[]),this.c&&(d=(0,v.$kn)(d,this.c)),this.b||(d=(0,v.$kn)(d,this.j)),"properties"in u?u.properties=d:u=d,u}k(u,d){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(u,d),this.h.trace(u,d))}logUsage(u,d){this.d.isUsageEnabled&&this.k(u,d)}logError(u,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,d);else{const l={name:u.name,message:u.message,stack:u.stack,cause:u.cause},$=(0,w.$Lo)(l,[]),h=new Error($.message,{cause:$.cause});h.stack=$.stack,h.name=$.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(h,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const u=this,d={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$9M=p;function c(m){const u=Date.now()-new Date(m).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$0M=c,e.$$M=(0,E.$2h)("IExtHostTelemetry")}),define(be[280],ve([1,0,5,3,36,233,35,6]),function(ue,e,E,R,r,C,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.$nF=e.ActivationKind=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.ExtensionHostStartup=e.$hF=e.$gF=e.$fF=e.$eF=void 0,e.$eF=Object.freeze({identifier:new S.$gm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$fF="extensions.webWorker",e.$gF=(0,P.$2h)("extensionService");class w{constructor(h){this.dependency=h}}e.$hF=w;var v;(function($){$[$.EagerAutoStart=1]="EagerAutoStart",$[$.EagerManualStart=2]="EagerManualStart",$[$.Lazy=3]="Lazy"})(v||(e.ExtensionHostStartup=v={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,n,i){this.c=h,this.d=n.slice(0),this.e=i.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:C.$2E.createActivationEventsMap(this.d)}}set(h,n,i){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const o=[],s=[],t=[],a=[],g=k(this.d),L=k(n),D=(te,J)=>te.extensionLocation.toString()===J.extensionLocation.toString()||te.isBuiltin===J.isBuiltin||te.isUserBuiltin===J.isUserBuiltin||te.isUnderDevelopment===J.isUnderDevelopment;for(const te of this.d){const J=L.get(te.identifier);if(!J){o.push(te.identifier),g.delete(te.identifier);continue}if(!D(te,J)){o.push(te.identifier),g.delete(te.identifier);continue}}for(const te of n){const J=g.get(te.identifier);if(!J){s.push(te);continue}if(!D(J,te)){o.push(J.identifier),g.delete(J.identifier);continue}}const y=new S.$hm(this.e),A=new S.$hm(i);for(const te of this.e)A.has(te)||t.push(te);for(const te of i)y.has(te)||a.push(te);const F=C.$2E.createActivationEventsMap(s),X={versionId:h,toRemove:o,toAdd:s,addActivationEvents:F,myToRemove:t,myToAdd:a};return this.delta(X),X}delta(h){if(this.c>=h.versionId)return null;const{toRemove:n,toAdd:i,myToRemove:o,myToAdd:s}=h,t=new S.$hm(n),a=new S.$hm(o);for(let g=0;g<this.d.length;g++)t.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)a.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of i)this.d.push(g);for(const g of s)this.e.push(g);return this.f=null,h}containsExtension(h){for(const n of this.e)if(S.$gm.equals(n,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const i=C.$2E.readActivationEvents(n);for(const o of i)h.add(o)}return h}}e.$iF=I;function k($){const h=new S.$im;for(const n of $)h.set(n.identifier,n);return h}function b($,h){return $.enabledApiProposals?$.enabledApiProposals.includes(h):!1}e.$jF=b;function f($,h){if(!b($,h))throw new Error(`Extension '${$.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${$.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${$.identifier.value}`)}e.$kF=f;class p{constructor(h,n,i,o){this.codeLoadingTime=h,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=o}}e.$lF=p;class c{constructor(h,n){this.description=h,this.value=n}}e.$mF=c;var m;(function($){$[$.Normal=0]="Normal",$[$.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function u($){return{type:$.isBuiltin?0:1,isBuiltin:$.isBuiltin||$.isUserBuiltin,identifier:{id:(0,r.$Ro)($.publisher,$.name),uuid:$.uuid},manifest:$,location:$.extensionLocation,targetPlatform:$.targetPlatform,validations:[],isValid:!0}}e.$nF=u;function d($,h){return{identifier:new S.$gm((0,r.$Po)($.manifest.publisher,$.manifest.name)),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:!!h,extensionLocation:$.location,...$.manifest,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform}}e.$oF=d;class l{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,n){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$pF=l}),define(be[137],ve([1,0,18,15,151,75,100,26,143,50,64,23,10,3,42,173,229,134,93,131,72,94,136,132,280]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$PM=e.$OM=e.MarkdownString=e.$NM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ke){function Ce(K){const{selectionStartLineNumber:Pe,selectionStartColumn:Ne,positionLineNumber:Ve,positionColumn:ze}=K,xe=new i.$PK(Pe-1,Ne-1),ct=new i.$PK(Ve-1,ze-1);return new i.$RK(xe,ct)}ke.to=Ce;function de(K){const{anchor:Pe,active:Ne}=K;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Ne.line+1,positionColumn:Ne.character+1}}ke.from=de})(s||(e.Selection=s={}));var t;(function(ke){function Ce(K){if(!K)return;const{start:Pe,end:Ne}=K;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Ne.line+1,endColumn:Ne.character+1}}ke.from=Ce;function de(K){if(!K)return;const{startLineNumber:Pe,startColumn:Ne,endLineNumber:Ve,endColumn:ze}=K;return new i.$QK(Pe-1,Ne-1,Ve-1,ze-1)}ke.to=de})(t||(e.Range=t={}));var a;(function(ke){function Ce(de){switch(de){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}ke.to=Ce})(a||(e.TokenType=a={}));var g;(function(ke){function Ce(K){return new i.$PK(K.lineNumber-1,K.column-1)}ke.to=Ce;function de(K){return{lineNumber:K.line+1,column:K.character+1}}ke.from=de})(g||(e.Position=g={}));var L;(function(ke){function Ce(Pe,Ne,Ve){return(0,E.$Hb)((0,E.$3b)(Pe).map(ze=>de(ze,Ne,Ve)))}ke.from=Ce;function de(Pe,Ne,Ve){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ve?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:K(Pe.scheme,Ne),pattern:Te.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ve?.isBuiltin}}function K(Pe,Ne){return Ne&&typeof Pe=="string"?Ne.transformOutgoingScheme(Pe):Pe}})(L||(e.DocumentSelector=L={}));var D;(function(ke){function Ce(K){switch(K){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}ke.from=Ce;function de(K){switch(K){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}ke.to=de})(D||(e.DiagnosticTag=D={}));var y;(function(ke){function Ce(K){let Pe;return K.code&&((0,b.$Ef)(K.code)||(0,b.$If)(K.code)?Pe=String(K.code):Pe={value:String(K.code.value),target:K.code.target}),{...t.from(K.range),message:K.message,source:K.source,code:Pe,severity:F.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(A.from),tags:Array.isArray(K.tags)?(0,E.$Hb)(K.tags.map(D.from)):void 0}}ke.from=Ce;function de(K){const Pe=new i.$3K(t.to(K),K.message,F.to(K.severity));return Pe.source=K.source,Pe.code=(0,b.$Ef)(K.code)?K.code:K.code?.value,Pe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(A.to),Pe.tags=K.tags&&(0,E.$Hb)(K.tags.map(D.to)),Pe}ke.to=de})(y||(e.Diagnostic=y={}));var A;(function(ke){function Ce(K){return{...t.from(K.location.range),message:K.message,resource:K.location.uri}}ke.from=Ce;function de(K){return new i.$2K(new i.$1K(K.resource,t.to(K)),K.message)}ke.to=de})(A||(e.DiagnosticRelatedInformation=A={}));var F;(function(ke){function Ce(K){switch(K){case i.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ke.from=Ce;function de(K){switch(K){case m.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}ke.to=de})(F||(e.DiagnosticSeverity=F={}));var X;(function(ke){function Ce(K){return typeof K=="number"&&K>=i.ViewColumn.One?K-1:K===i.ViewColumn.Beside?n.$WC:n.$VC}ke.from=Ce;function de(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ke.to=de})(X||(e.ViewColumn=X={}));function te(ke){return typeof ke.range<"u"}function J(ke){return ke.length===0?!0:!!te(ke[0])}e.$NM=J;var ie;(function(ke){function Ce(ze){return ze.map(ke.from)}ke.fromMany=Ce;function de(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function K(ze){let xe;if(de(ze)){const{language:at,value:rt}=ze;xe={value:"```"+at+`
`+rt+"\n```\n"}}else i.$dL.isMarkdownString(ze)?xe={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?xe={value:ze}:xe={value:""};const ct=Object.create(null);xe.uris=ct;const wt=at=>{try{let rt=f.URI.parse(at,!0);rt=rt.with({query:Pe(rt.query,ct)}),ct[at]=rt}catch{}return""},pt=new w.marked.Renderer;return pt.link=wt,pt.image=at=>typeof at=="string"?wt(S.$kk(at).href):"",(0,w.marked)(xe.value,{renderer:pt}),xe}ke.from=K;function Pe(ze,xe){if(!ze)return ze;let ct;try{ct=(0,v.$xh)(ze)}catch{}if(!ct)return ze;let wt=!1;return ct=(0,k.$jn)(ct,pt=>{if(f.URI.isUri(pt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[at]=pt,wt=!0,at}else return}),wt?JSON.stringify(ct):ze}function Ne(ze){const xe=new i.$dL(ze.value,ze.supportThemeIcons);return xe.isTrusted=ze.isTrusted,xe.supportHtml=ze.supportHtml,xe.baseUri=ze.baseUri?f.URI.from(ze.baseUri):void 0,xe}ke.to=Ne;function Ve(ze){if(ze)return typeof ze=="string"?ze:ke.from(ze)}ke.fromStrict=Ve})(ie||(e.MarkdownString=ie={}));function ee(ke){return J(ke)?ke.map(Ce=>({range:t.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?ie.fromMany(Ce.hoverMessage):Ce.hoverMessage?ie.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):ke.map(Ce=>({range:t.from(Ce)}))}e.$OM=ee;function U(ke){return typeof ke>"u"?ke:typeof ke=="string"?f.URI.file(ke):ke}e.$PM=U;var he;(function(ke){function Ce(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?U(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}ke.from=Ce})(he||(e.ThemableDecorationAttachmentRenderOptions=he={}));var Q;(function(ke){function Ce(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?U(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?he.from(de.before):void 0,after:de.after?he.from(de.after):void 0}}ke.from=Ce})(Q||(e.ThemableDecorationRenderOptions=Q={}));var _;(function(ke){function Ce(de){if(typeof de>"u")return de;switch(de){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}ke.from=Ce})(_||(e.DecorationRangeBehavior=_={}));var V;(function(ke){function Ce(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?_.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?Q.from(de.light):void 0,dark:de.dark?Q.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?U(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?he.from(de.before):void 0,after:de.after?he.from(de.after):void 0}}ke.from=Ce})(V||(e.DecorationRenderOptions=V={}));var G;(function(ke){function Ce(K){return{text:K.newText,eol:K.newEol&&pe.from(K.newEol),range:t.from(K.range)}}ke.from=Ce;function de(K){const Pe=new i.$VK(t.to(K.range),K.text);return Pe.newEol=typeof K.eol>"u"?void 0:pe.to(K.eol),Pe}ke.to=de})(G||(e.TextEdit=G={}));var oe;(function(ke){function Ce(K,Pe){const Ne={edits:[]};if(K instanceof i.$YK){const Ve=new P.$Bc;for(const ze of K._allEntries())ze._type===1&&f.URI.isUri(ze.to)&&ze.from===void 0&&Ve.add(ze.to);for(const ze of K._allEntries())if(ze._type===1){let xe;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?xe={type:"base64",value:(0,R.$Ae)(R.$ge.wrap(ze.options.contents))}:xe={type:"dataTransferItem",id:ze.options.contents._itemId}),Ne.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:xe},metadata:ze.metadata})}else ze._type===2?Ne.edits.push({resource:ze.uri,textEdit:G.from(ze.edit),versionId:Ve.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Ne.edits.push({resource:ze.uri,textEdit:{range:t.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ve.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Ne.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Ne.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(ot.from)}})}return Ne}ke.from=Ce;function de(K){const Pe=new i.$YK,Ne=new P.$Ac;for(const Ve of K.edits)if(Ve.textEdit){const ze=Ve,xe=f.URI.revive(ze.resource),ct=t.to(ze.textEdit.range),wt=ze.textEdit.text,pt=ze.textEdit.insertAsSnippet;let at;pt?at=i.$XK.replace(ct,new i.$ZK(wt)):at=i.$VK.replace(ct,wt);const rt=Ne.get(xe);rt?rt.push(at):Ne.set(xe,[at])}else Pe.renameFile(f.URI.revive(Ve.oldResource),f.URI.revive(Ve.newResource),Ve.options);for(const[Ve,ze]of Ne)Pe.set(Ve,ze);return Pe}ke.to=de})(oe||(e.WorkspaceEdit=oe={}));var le;(function(ke){const Ce=Object.create(null);Ce[i.SymbolKind.File]=0,Ce[i.SymbolKind.Module]=1,Ce[i.SymbolKind.Namespace]=2,Ce[i.SymbolKind.Package]=3,Ce[i.SymbolKind.Class]=4,Ce[i.SymbolKind.Method]=5,Ce[i.SymbolKind.Property]=6,Ce[i.SymbolKind.Field]=7,Ce[i.SymbolKind.Constructor]=8,Ce[i.SymbolKind.Enum]=9,Ce[i.SymbolKind.Interface]=10,Ce[i.SymbolKind.Function]=11,Ce[i.SymbolKind.Variable]=12,Ce[i.SymbolKind.Constant]=13,Ce[i.SymbolKind.String]=14,Ce[i.SymbolKind.Number]=15,Ce[i.SymbolKind.Boolean]=16,Ce[i.SymbolKind.Array]=17,Ce[i.SymbolKind.Object]=18,Ce[i.SymbolKind.Key]=19,Ce[i.SymbolKind.Null]=20,Ce[i.SymbolKind.EnumMember]=21,Ce[i.SymbolKind.Struct]=22,Ce[i.SymbolKind.Event]=23,Ce[i.SymbolKind.Operator]=24,Ce[i.SymbolKind.TypeParameter]=25;function de(Pe){return typeof Ce[Pe]=="number"?Ce[Pe]:6}ke.from=de;function K(Pe){for(const Ne in Ce)if(Ce[Ne]===Pe)return Number(Ne);return i.SymbolKind.Property}ke.to=K})(le||(e.SymbolKind=le={}));var se;(function(ke){function Ce(K){switch(K){case i.SymbolTag.Deprecated:return 1}}ke.from=Ce;function de(K){switch(K){case 1:return i.SymbolTag.Deprecated}}ke.to=de})(se||(e.SymbolTag=se={}));var $e;(function(ke){function Ce(K){return{name:K.name,kind:le.from(K.kind),tags:K.tags&&K.tags.map(se.from),containerName:K.containerName,location:ne.from(K.location)}}ke.from=Ce;function de(K){const Pe=new i.$7K(K.name,le.to(K.kind),K.containerName,ne.to(K.location));return Pe.tags=K.tags&&K.tags.map(se.to),Pe}ke.to=de})($e||(e.WorkspaceSymbol=$e={}));var z;(function(ke){function Ce(K){const Pe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:t.from(K.range),selectionRange:t.from(K.selectionRange),kind:le.from(K.kind),tags:K.tags?.map(se.from)??[]};return K.children&&(Pe.children=K.children.map(Ce)),Pe}ke.from=Ce;function de(K){const Pe=new i.$8K(K.name,K.detail,le.to(K.kind),t.to(K.range),t.to(K.selectionRange));return(0,E.$Lb)(K.tags)&&(Pe.tags=K.tags.map(se.to)),K.children&&(Pe.children=K.children.map(de)),Pe}ke.to=de})(z||(e.DocumentSymbol=z={}));var q;(function(ke){function Ce(K){const Pe=new i.$_K(le.to(K.kind),K.name,K.detail||"",f.URI.revive(K.uri),t.to(K.range),t.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}ke.to=Ce;function de(K,Pe,Ne){if(Pe=Pe??K._sessionId,Ne=Ne??K._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,name:K.name,detail:K.detail,kind:le.from(K.kind),uri:K.uri,range:t.from(K.range),selectionRange:t.from(K.selectionRange),tags:K.tags?.map(se.from)}}ke.from=de})(q||(e.CallHierarchyItem=q={}));var O;(function(ke){function Ce(de){return new i.$aL(q.to(de.from),de.fromRanges.map(K=>t.to(K)))}ke.to=Ce})(O||(e.CallHierarchyIncomingCall=O={}));var j;(function(ke){function Ce(de){return new i.$bL(q.to(de.to),de.fromRanges.map(K=>t.to(K)))}ke.to=Ce})(j||(e.CallHierarchyOutgoingCall=j={}));var ne;(function(ke){function Ce(K){return{range:K.range&&t.from(K.range),uri:K.uri}}ke.from=Ce;function de(K){return new i.$1K(f.URI.revive(K.uri),t.to(K.range))}ke.to=de})(ne||(e.location=ne={}));var Y;(function(ke){function Ce(K){const Pe=K,Ne=K;return{originSelectionRange:Pe.originSelectionRange?t.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Ne.uri,range:t.from(Pe.targetRange?Pe.targetRange:Ne.range),targetSelectionRange:Pe.targetSelectionRange?t.from(Pe.targetSelectionRange):void 0}}ke.from=Ce;function de(K){return{targetUri:f.URI.revive(K.uri),targetRange:t.to(K.range),targetSelectionRange:K.targetSelectionRange?t.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?t.to(K.originSelectionRange):void 0}}ke.to=de})(Y||(e.DefinitionLink=Y={}));var Z;(function(ke){function Ce(K){return{range:t.from(K.range),contents:ie.fromMany(K.contents)}}ke.from=Ce;function de(K){return new i.$4K(K.contents.map(ie.to),t.to(K.range))}ke.to=de})(Z||(e.Hover=Z={}));var B;(function(ke){function Ce(K){return{range:t.from(K.range),expression:K.expression}}ke.from=Ce;function de(K){return new i.$XL(t.to(K.range),K.expression)}ke.to=de})(B||(e.EvaluatableExpression=B={}));var H;(function(ke){function Ce(K){if(K instanceof i.$YL)return{type:"text",range:t.from(K.range),text:K.text};if(K instanceof i.$ZL)return{type:"variable",range:t.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof i.$1L)return{type:"expression",range:t.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ke.from=Ce;function de(K){switch(K.type){case"text":return{range:t.to(K.range),text:K.text};case"variable":return{range:t.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:t.to(K.range),expression:K.expression}}}ke.to=de})(H||(e.InlineValue=H={}));var T;(function(ke){function Ce(K){return{frameId:K.frameId,stoppedLocation:t.from(K.stoppedLocation)}}ke.from=Ce;function de(K){return new i.$2L(K.frameId,t.to(K.stoppedLocation))}ke.to=de})(T||(e.InlineValueContext=T={}));var W;(function(ke){function Ce(K){return{range:t.from(K.range),kind:K.kind}}ke.from=Ce;function de(K){return new i.$5K(t.to(K.range),K.kind)}ke.to=de})(W||(e.DocumentHighlight=W={}));var x;(function(ke){function Ce(K){return{uri:K.uri,highlights:K.highlights.map(W.from)}}ke.from=Ce;function de(K){return new i.$6K(f.URI.revive(K.uri),K.highlights.map(W.to))}ke.to=de})(x||(e.MultiDocumentHighlight=x={}));var re;(function(ke){function Ce(de){switch(de){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}ke.to=Ce})(re||(e.CompletionTriggerKind=re={}));var fe;(function(ke){function Ce(de){return{triggerKind:re.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}ke.to=Ce})(fe||(e.CompletionContext=fe={}));var ce;(function(ke){function Ce(K){switch(K){case i.CompletionItemTag.Deprecated:return 1}}ke.from=Ce;function de(K){switch(K){case 1:return i.CompletionItemTag.Deprecated}}ke.to=de})(ce||(e.CompletionItemTag=ce={}));var ge;(function(ke){const Ce=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function de(Ne){return Ce.get(Ne)??9}ke.from=de;const K=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Pe(Ne){return K.get(Ne)??i.CompletionItemKind.Property}ke.to=Pe})(ge||(e.CompletionItemKind=ge={}));var ye;(function(ke){function Ce(de,K){const Pe=new i.$jL(de.label);return Pe.insertText=de.insertText,Pe.kind=ge.to(de.kind),Pe.tags=de.tags?.map(ce.to),Pe.detail=de.detail,Pe.documentation=S.$fk(de.documentation)?ie.to(de.documentation):de.documentation,Pe.sortText=de.sortText,Pe.filterText=de.filterText,Pe.preselect=de.preselect,Pe.commitCharacters=de.commitCharacters,p.$Gs.isIRange(de.range)?Pe.range=t.to(de.range):typeof de.range=="object"&&(Pe.range={inserting:t.to(de.range.insert),replacing:t.to(de.range.replace)}),Pe.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Pe.insertText=new i.$ZK(de.insertText):(Pe.insertText=de.insertText,Pe.textEdit=Pe.range instanceof i.$QK?new i.$VK(Pe.range,Pe.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Pe.additionalTextEdits=de.additionalTextEdits.map(Ne=>G.to(Ne))),Pe.command=K&&de.command?K.fromInternal(de.command):void 0,Pe}ke.to=Ce})(ye||(e.CompletionItem=ye={}));var Ie;(function(ke){function Ce(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ie.fromStrict(K.documentation)}}ke.from=Ce;function de(K){return{label:K.label,documentation:S.$fk(K.documentation)?ie.to(K.documentation):K.documentation}}ke.to=de})(Ie||(e.ParameterInformation=Ie={}));var Re;(function(ke){function Ce(K){return{label:K.label,documentation:ie.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(Ie.from):[],activeParameter:K.activeParameter}}ke.from=Ce;function de(K){return{label:K.label,documentation:S.$fk(K.documentation)?ie.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Ie.to):[],activeParameter:K.activeParameter}}ke.to=de})(Re||(e.SignatureInformation=Re={}));var me;(function(ke){function Ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Re.from):[]}}ke.from=Ce;function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Re.to):[]}}ke.to=de})(me||(e.SignatureHelp=me={}));var De;(function(ke){function Ce(de,K){const Pe=new i.$iL(g.to(K.position),typeof K.label=="string"?K.label:K.label.map(Ee.to.bind(void 0,de)),K.kind&&Me.to(K.kind));return Pe.textEdits=K.textEdits&&K.textEdits.map(G.to),Pe.tooltip=S.$fk(K.tooltip)?ie.to(K.tooltip):K.tooltip,Pe.paddingLeft=K.paddingLeft,Pe.paddingRight=K.paddingRight,Pe}ke.to=Ce})(De||(e.InlayHint=De={}));var Ee;(function(ke){function Ce(de,K){const Pe=new i.$hL(K.label);return Pe.tooltip=S.$fk(K.tooltip)?ie.to(K.tooltip):K.tooltip,c.Command.is(K.command)&&(Pe.command=de.fromInternal(K.command)),K.location&&(Pe.location=ne.to(K.location)),Pe}ke.to=Ce})(Ee||(e.InlayHintLabelPart=Ee={}));var Me;(function(ke){function Ce(K){return K}ke.from=Ce;function de(K){return K}ke.to=de})(Me||(e.InlayHintKind=Me={}));var je;(function(ke){function Ce(K){return{range:t.from(K.range),url:K.target,tooltip:K.tooltip}}ke.from=Ce;function de(K){let Pe;if(K.url)try{Pe=typeof K.url=="string"?f.URI.parse(K.url,!0):f.URI.revive(K.url)}catch{}return new i.$oL(t.to(K.range),Pe)}ke.to=de})(je||(e.DocumentLink=je={}));var We;(function(ke){function Ce(K){const Pe=new i.$rL(K.label);return K.textEdit&&(Pe.textEdit=G.to(K.textEdit)),K.additionalTextEdits&&(Pe.additionalTextEdits=K.additionalTextEdits.map(Ne=>G.to(Ne))),Pe}ke.to=Ce;function de(K){return{label:K.label,textEdit:K.textEdit?G.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Pe=>G.from(Pe)):void 0}}ke.from=de})(We||(e.ColorPresentation=We={}));var He;(function(ke){function Ce(K){return new i.$pL(K[0],K[1],K[2],K[3])}ke.to=Ce;function de(K){return[K.red,K.green,K.blue,K.alpha]}ke.from=de})(He||(e.Color=He={}));var Qe;(function(ke){function Ce(K){return{range:t.from(K.range)}}ke.from=Ce;function de(K){return new i.$$K(t.to(K.range))}ke.to=de})(Qe||(e.SelectionRange=Qe={}));var Ye;(function(ke){function Ce(de){switch(de){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}ke.to=Ce})(Ye||(e.TextDocumentSaveReason=Ye={}));var et;(function(ke){function Ce(K){switch(K){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}ke.from=Ce;function de(K){switch(K){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}ke.to=de})(et||(e.TextEditorLineNumbersStyle=et={}));var pe;(function(ke){function Ce(K){if(K===i.EndOfLine.CRLF)return 1;if(K===i.EndOfLine.LF)return 0}ke.from=Ce;function de(K){if(K===1)return i.EndOfLine.CRLF;if(K===0)return i.EndOfLine.LF}ke.to=de})(pe||(e.EndOfLine=pe={}));var Se;(function(ke){function Ce(de){if(typeof de=="object")return de.viewId;switch(de){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ke.from=Ce})(Se||(e.ProgressLocation=Se={}));var Ae;(function(ke){function Ce(K){const Pe={start:K.start+1,end:K.end+1};return K.kind&&(Pe.kind=Oe.from(K.kind)),Pe}ke.from=Ce;function de(K){const Pe={start:K.start-1,end:K.end-1};return K.kind&&(Pe.kind=Oe.to(K.kind)),Pe}ke.to=de})(Ae||(e.FoldingRange=Ae={}));var Oe;(function(ke){function Ce(K){if(K)switch(K){case i.FoldingRangeKind.Comment:return c.$wt.Comment;case i.FoldingRangeKind.Imports:return c.$wt.Imports;case i.FoldingRangeKind.Region:return c.$wt.Region}}ke.from=Ce;function de(K){if(K)switch(K.value){case c.$wt.Comment.value:return i.FoldingRangeKind.Comment;case c.$wt.Imports.value:return i.FoldingRangeKind.Imports;case c.$wt.Region.value:return i.FoldingRangeKind.Region}}ke.to=de})(Oe||(e.FoldingRangeKind=Oe={}));var Be;(function(ke){function Ce(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?t.from(de.selection):void 0,override:typeof de.override=="boolean"?d.$lE.id:void 0}}ke.from=Ce})(Be||(e.TextEditorOpenOptions=Be={}));var Te;(function(ke){function Ce(Ne){return Ne instanceof i.$LL?Ne.toJSON():typeof Ne=="string"?Ne:de(Ne)||K(Ne)?new i.$LL(Ne.baseUri??Ne.base,Ne.pattern).toJSON():Ne}ke.from=Ce;function de(Ne){const Ve=Ne;return Ve?f.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function K(Ne){const Ve=Ne;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Pe(Ne){return typeof Ne=="string"?Ne:new i.$LL(f.URI.revive(Ne.baseUri),Ne.pattern)}ke.to=Pe})(Te||(e.GlobPattern=Te={}));var qe;(function(ke){function Ce(de){if(de){if(Array.isArray(de))return de.map(Ce);if(typeof de=="string")return de;{const K=de;return{language:K.language,scheme:K.scheme,pattern:Te.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}ke.from=Ce})(qe||(e.LanguageSelector=qe={}));var Je;(function(ke){function Ce(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Ne=>Ne&&typeof Ne=="object"&&"uri"in Ne&&f.URI.isUri(Ne.uri)&&"version"in Ne&&typeof Ne.version=="number"&&"ranges"in Ne&&Array.isArray(Ne.ranges)&&Ne.ranges.every(Ve=>Ve instanceof i.$QK)))}ke.is=Ce;function de(K){return{documents:K.documents.map(Pe=>Pe.map(Ne=>({uri:f.URI.from(Ne.uri),version:Ne.version,ranges:Ne.ranges.map(Ve=>t.from(Ve))})))}}ke.from=de})(Je||(e.MappedEditsContext=Je={}));var Ge;(function(ke){function Ce(K){return{start:K.start,end:K.end}}ke.from=Ce;function de(K){return new i.$aM(K.start,K.end)}ke.to=de})(Ge||(e.NotebookRange=Ge={}));var Ze;(function(ke){function Ce(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ke.to=Ce;function de(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ke.from=de})(Ze||(e.NotebookCellExecutionSummary=Ze={}));var nt;(function(ke){function Ce(de){if(de===l.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(de===l.NotebookCellExecutionState.Pending)return;if(de===l.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}ke.to=Ce})(nt||(e.NotebookCellExecutionState=nt={}));var Xe;(function(ke){function Ce(K){switch(K){case i.NotebookCellKind.Markup:return l.CellKind.Markup;case i.NotebookCellKind.Code:default:return l.CellKind.Code}}ke.from=Ce;function de(K){switch(K){case l.CellKind.Markup:return i.NotebookCellKind.Markup;case l.CellKind.Code:default:return i.NotebookCellKind.Code}}ke.to=de})(Xe||(e.NotebookCellKind=Xe={}));var it;(function(ke){function Ce(K){const Pe={metadata:K.metadata??Object.create(null),cells:[]};for(const Ne of K.cells)i.$bM.validate(Ne),Pe.cells.push(ot.from(Ne));return Pe}ke.from=Ce;function de(K){const Pe=new i.$cM(K.cells.map(ot.to));return(0,b.$Rf)(K.metadata)||(Pe.metadata=K.metadata),Pe}ke.to=de})(it||(e.NotebookData=it={}));var ot;(function(ke){function Ce(K){return{cellKind:Xe.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ze.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(ht.from):[]}}ke.from=Ce;function de(K){return new i.$bM(Xe.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(ht.to):void 0,K.metadata,K.internalMetadata?Ze.to(K.internalMetadata):void 0)}ke.to=de})(ot||(e.NotebookCellData=ot={}));var ut;(function(ke){function Ce(K){return{mime:K.mime,valueBytes:R.$ge.wrap(K.data)}}ke.from=Ce;function de(K){return new i.$dM(K.valueBytes.buffer,K.mime)}ke.to=de})(ut||(e.NotebookCellOutputItem=ut={}));var ht;(function(ke){function Ce(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}ke.from=Ce;function de(K){const Pe=K.items.map(ut.to);return new i.$eM(Pe,K.outputId,K.metadata)}ke.to=de})(ht||(e.NotebookCellOutput=ht={}));var dt;(function(ke){function Ce(Pe){return K(Pe)?{include:Te.from(Pe.include)??void 0,exclude:Te.from(Pe.exclude)??void 0}:Te.from(Pe)??void 0}ke.from=Ce;function de(Pe){return K(Pe)?{include:Te.to(Pe.include),exclude:Te.to(Pe.exclude)}:Te.to(Pe)}ke.to=de;function K(Pe){const Ne=Pe;return Ne?!(0,b.$Nf)(Ne.include)&&!(0,b.$Nf)(Ne.exclude):!1}})(dt||(e.NotebookExclusiveDocumentPattern=dt={}));var Ft;(function(ke){function Ce(de,K,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ne,Pe),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}ke.from=Ce})(Ft||(e.NotebookStatusBarItem=Ft={}));var jt;(function(ke){function Ce(de,K,Pe){const Ne=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:K.toInternal(Ne,Pe),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}ke.from=Ce})(jt||(e.NotebookKernelSourceAction=jt={}));var St;(function(ke){function Ce(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}ke.from=Ce})(St||(e.NotebookDocumentContentOptions=St={}));var It;(function(ke){function Ce(K){return{uri:K.uri,provides:K.provides}}ke.from=Ce;function de(K){return new i.$gM(f.URI.revive(K.uri),K.provides)}ke.to=de})(It||(e.NotebookRendererScript=It={}));var mt;(function(ke){function Ce(K){return{message:ie.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:t.from(K.location.range),uri:K.location.uri}}}ke.from=Ce;function de(K){const Pe=new i.$mM(typeof K.message=="string"?K.message:ie.to(K.message));return Pe.actualOutput=K.actual,Pe.expectedOutput=K.expected,Pe.contextValue=K.contextValue,Pe.location=K.location?ne.to(K.location):void 0,Pe}ke.to=de})(mt||(e.TestMessage=mt={}));var gt;(function(ke){ke.namespace=h.$IJ,ke.denamespace=h.$JJ})(gt||(e.TestTag=gt={}));var At;(function(ke){function Ce(K){const Pe=(0,u.$MM)(K).controllerId;return{extId:$.$EJ.fromExtHostTestItem(K,Pe).toString(),label:K.label,uri:f.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ne=>gt.namespace(Pe,Ne.id)),range:p.$Gs.lift(t.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ie.fromStrict(K.error)||null}}ke.from=Ce;function de(K){return{parent:void 0,error:void 0,id:$.$EJ.fromString(K.extId).localId,label:K.label,uri:f.URI.revive(K.uri),tags:(K.tags||[]).map(Pe=>{const{tagId:Ne}=gt.denamespace(Pe);return new i.$nM(Ne)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}ke.toPlain=de})(At||(e.TestItem=At={})),function(ke){function Ce(K){return{id:K.id}}ke.from=Ce;function de(K){return new i.$nM(K.id)}ke.to=de}(gt||(e.TestTag=gt={}));var bt;(function(ke){const Ce=(K,Pe)=>{const Ne=[];for(const[ze,xe]of Pe)$.$EJ.compare(xe.item.extId,ze)===2&&(Pe.delete(ze),Ne.push(xe));const Ve={...At.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(xe=>xe.type===0).map(mt.to)})),children:Ne.map(ze=>Ce(ze,Pe))};for(const ze of Ve.children)ze.parent=Ve;return Ve};function de(K){const Pe=[],Ne=new Map;for(const Ve of K.items){Ne.set(Ve.item.extId,Ve);const ze=$.$EJ.root(Ve.item.extId);K.request.targets.some(xe=>xe.controllerId===ze&&xe.testIds.includes(Ve.item.extId))&&Pe.push(Ve)}return{completedAt:K.completedAt,results:Pe.map(Ve=>Ce(Ve,Ne))}}ke.to=de})(bt||(e.TestResults=bt={}));var Mt;(function(ke){function Ce(Ne){return{covered:Ne.covered,total:Ne.total}}function de(Ne){return"line"in Ne?g.from(Ne):t.from(Ne)}function K(Ne){return"branches"in Ne?{count:Ne.executionCount,location:de(Ne.location),type:1,branches:Ne.branches.length?Ne.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&de(Ve.location)})):void 0}:{type:0,name:Ne.name,count:Ne.executionCount,location:de(Ne.location)}}ke.fromDetailed=K;function Pe(Ne){return{uri:Ne.uri,statement:Ce(Ne.statementCoverage),branch:Ne.branchCoverage&&Ce(Ne.branchCoverage),function:Ne.functionCoverage&&Ce(Ne.functionCoverage),details:Ne.detailedCoverage?.map(K)}}ke.fromFile=Pe})(Mt||(e.TestCoverage=Mt={}));var Rt;(function(ke){function Ce(de){switch(de){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}ke.to=Ce})(Rt||(e.CodeActionTriggerKind=Rt={}));var st;(function(ke){function Ce(K){const Pe=new i.$tM(le.to(K.kind),K.name,K.detail||"",f.URI.revive(K.uri),t.to(K.range),t.to(K.selectionRange));return Pe._sessionId=K._sessionId,Pe._itemId=K._itemId,Pe}ke.to=Ce;function de(K,Pe,Ne){if(Pe=Pe??K._sessionId,Ne=Ne??K._itemId,Pe===void 0||Ne===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Ne,kind:le.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:t.from(K.range),selectionRange:t.from(K.selectionRange),tags:K.tags?.map(se.from)}}ke.from=de})(st||(e.TypeHierarchyItem=st={}));var $t;(function(ke){function Ce(de){if(de)return{value:de.value,tooltip:de.tooltip}}ke.from=Ce})($t||(e.ViewBadge=$t={}));var ft;(function(ke){function Ce(Ne,Ve,ze){const xe=Ve.fileData;return xe?new i.$EL(new i.$FL(xe.name,f.URI.revive(xe.uri),xe.id,(0,C.$db)(()=>ze(xe.id)))):Ne===I.$3r.uriList&&Ve.uriListData?new i.$DL(Pe(Ve.uriListData)):new i.$DL(Ve.asString)}ke.to=Ce;async function de(Ne,Ve){const ze=await Ve.asString();if(Ne===I.$3r.uriList)return{asString:ze,fileData:void 0,uriListData:K(ze)};const xe=Ve.asFile();return{asString:ze,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}ke.from=de;function K(Ne){return r.$dt.split(Ne).map(Ve=>{if(Ve.startsWith("#"))return Ve;try{return f.URI.parse(Ve)}catch{}return Ve})}function Pe(Ne){return r.$dt.create(Ne.map(Ve=>typeof Ve=="string"?Ve:f.URI.revive(Ve)))}})(ft||(e.DataTransferItem=ft={}));var Tt;(function(ke){function Ce(K,Pe){const Ne=K.items.map(([Ve,ze])=>[Ve,ft.to(Ve,ze,Pe)]);return new i.$GL(Ne)}ke.toDataTransfer=Ce;async function de(K){const Pe={items:[]},Ne=[];for(const[Ve,ze]of K)Ne.push((async()=>{Pe.items.push([Ve,await ft.from(Ve,ze)])})());return await Promise.all(Ne),Pe}ke.from=de})(Tt||(e.DataTransfer=Tt={}));var Ut;(function(ke){function Ce(de){return{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}ke.from=Ce})(Ut||(e.ChatReplyFollowup=Ut={}));var zt;(function(ke){function Ce(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:Ut.from(de)}ke.from=Ce})(zt||(e.ChatFollowup=zt={}));var Bt;(function(ke){function Ce(K){const Pe=new i.$FM(yt.to(K.role),K.content);return Pe.name=K.name,Pe}ke.to=Ce;function de(K){return{role:yt.from(K.role),content:K.content,name:K.name}}ke.from=de})(Bt||(e.ChatMessage=Bt={}));var yt;(function(ke){function Ce(K){switch(K){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}ke.to=Ce;function de(K){switch(K){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}ke.from=de})(yt||(e.ChatMessageRole=yt={}));var Ot;(function(ke){function Ce(Pe){const Ne={};for(const Ve of Object.keys(Pe))Ne[Ve]=Pe[Ve].map(ke.to);return Ne}ke.objectTo=Ce;function de(Pe){return{level:Et.to(Pe.level),kind:Pe.kind,value:(0,v.$yh)(Pe.value),description:Pe.description}}ke.to=de;function K(Pe){return{level:Et.from(Pe.level),kind:Pe.kind,value:Pe.value,description:Pe.description}}ke.from=K})(Ot||(e.ChatVariable=Ot={}));var Et;(function(ke){function Ce(K){switch(K){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}ke.to=Ce;function de(K){switch(K){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}ke.from=de})(Et||(e.ChatVariableLevel=Et={}));var kt;(function(ke){function Ce(de){switch(de){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return i.InteractiveEditorResponseFeedbackKind.Bug}}ke.to=Ce})(kt||(e.InteractiveEditorResponseFeedbackKind=kt={}));var Wt;(function(ke){function Ce(de,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,o.$kF)(de,"chatAgents2Additions"),{content:ie.from(K.markdownContent),kind:"markdownContent"}):"content"in K?"vulnerabilities"in K&&K.vulnerabilities?((0,o.$kF)(de,"chatAgents2Additions"),{content:K.content,vulnerabilities:K.vulnerabilities,kind:"vulnerability"}):typeof K.content=="string"?{content:K.content,kind:"content"}:((0,o.$kF)(de,"chatAgents2Additions"),{content:ie.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Pe=>({uri:Pe.uri,version:Pe.version,ranges:Pe.ranges.map(Ne=>t.from(Ne))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:t.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:t.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,o.$kF)(de,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):"treeData"in K?{treeData:K.treeData,kind:"treeData"}:"message"in K?{content:K.message,kind:"progressMessage"}:void 0}ke.from=Ce})(Wt||(e.ChatResponseProgress=Wt={}));var Ht;(function(ke){function Ce(de){return{label:de.label,values:de.values.map(Ot.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}ke.from=Ce})(Ht||(e.ChatAgentCompletionItem=Ht={}));var Vt;(function(ke){function Ce(de,K,Pe){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:K.toInternal(de,Pe)}ke.from=Ce})(Vt||(e.TerminalQuickFix=Vt={}))}),define(be[281],ve([1,0,42,134,72,133,94,137,3]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.$4M=e.$3M=void 0;const v=(l,$,h,n)=>{let i=$;return{enumerable:!0,configurable:!1,get(){return i},set(o){if(!h(i,o)){const s=i;i=o,l.listener?.(n(o,s))}}}},I=(l,$)=>l===$,k={range:(l,$)=>l===$?!0:!l||!$?!1:l.isEqual($),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(l,$)=>!(l.length!==$.length||l.some(h=>!$.find(n=>h.id===n.id)))},b=l=>$=>({op:4,update:l($)}),f=(l,$)=>({range:(()=>{let h;const n=b(i=>({range:E.$Gs.lift(P.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return h},set(i){l.listener?.({op:6}),k.range(h,i)||(h=i,l.listener?.(n(i)))}}})(),label:v(l,$,k.label,b(h=>({label:h}))),description:v(l,void 0,k.description,b(h=>({description:h}))),sortText:v(l,void 0,k.sortText,b(h=>({sortText:h}))),canResolveChildren:v(l,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:v(l,!1,k.busy,b(h=>({busy:h}))),error:v(l,void 0,k.error,b(h=>({error:P.MarkdownString.fromStrict(h)||null}))),tags:v(l,[],k.tags,(h,n)=>({op:1,new:h.map(P.TestTag.from),old:n.map(P.TestTag.from)}))}),p=l=>{const $=r.$EJ.fromString(l.extId),h=new m($.controllerId,$.localId,l.label,w.URI.revive(l.uri)||void 0);return h.range=P.Range.to(l.range||void 0),h.description=l.description||void 0,h.sortText=l.sortText||void 0,h.tags=l.tags.map(n=>P.TestTag.to({id:(0,S.$JJ)(n).tagId})),h},c=l=>{let $;for(const h of l.tests){const n=p(h.item);(0,R.$MM)(n).parent=$,$=n}return $};e.$3M=c;class m{constructor($,h,n,i){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const o=(0,R.$LM)(this,$);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof u?void 0:o.parent}},children:{value:(0,C.$KM)(o,R.$MM,m),enumerable:!0,writable:!1},...f(o,n)})}}e.$4M=m;class u extends m{constructor($,h){super($,$,h,void 0),this._isRoot=!0}}e.$5M=u;class d extends C.$GM{constructor($,h,n){super({controllerId:$,getDocumentVersion:i=>i&&n.getDocument(i)?.version,getApiFor:R.$MM,getChildren:i=>i.children,root:new u($,h),toITestItem:P.TestItem.from})}}e.$6M=d}),define(be[282],ve([1,0,35,206,53]),function(ue,e,E,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=void 0;function C(S,P,w,v){const I=new E.$im;return S.forEach(k=>{const b=I.get(k.identifier);b&&v.warn((0,R.localize)(0,null,b.extensionLocation.fsPath,k.extensionLocation.fsPath)),I.set(k.identifier,k)}),P.forEach(k=>{const b=I.get(k.identifier);if(b)if(b.isBuiltin){if(r.gte(b.version,k.version)){v.warn(`Skipping extension ${k.extensionLocation.path} in favour of the builtin extension ${b.extensionLocation.path}.`);return}k.isBuiltin=!0}else v.warn((0,R.localize)(1,null,b.extensionLocation.fsPath,k.extensionLocation.fsPath));else if(k.isBuiltin){v.warn(`Skipping obsolete builtin extension ${k.extensionLocation.path}`);return}I.set(k.identifier,k)}),w.forEach(k=>{v.info((0,R.localize)(2,null,k.extensionLocation.fsPath));const b=I.get(k.identifier);b&&b.isBuiltin&&(k.isBuiltin=!0),I.set(k.identifier,k)}),Array.from(I.values())}e.$cO=C}),define(be[283],ve([1,0,7,4,29,3,41,51,68,58,282,12]),function(ue,e,E,R,r,C,S,P,w,v,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0;class b{constructor(c,m,u,d,l,$,h){this.c=c,this.d=u,this.f=d,this.g=l,this.h=$,this.i=h,this.a=Promise.resolve(),this.b=Promise.resolve();const n=m.args["install-builtin-extension"];if(n){l.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"]};S.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(n),o,!!m.args.force).then(()=>{S.mark("code/server/didInstallBuiltinExtensions"),l.trace("Finished installing builtin extensions")},s=>{l.error(s)})}const i=m.args["install-extension"];i&&(l.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(i),[],{isMachineScoped:!!m.args["do-not-sync"],installPreReleaseVersion:!!m.args["pre-release"],isApplicationScoped:!0},!!m.args.force)).then(()=>{l.trace("Finished installing extensions")},o=>{l.error(o)}))}j(c){return c.map(m=>/\.vsix$/i.test(m)?C.URI.file((0,E.$ic)(m)?m:(0,E.$jc)((0,r.cwd)(),m)):m)}whenExtensionsReady(){return this.b}async scanExtensions(c,m,u,d){S.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const l=u?u.filter(h=>h.scheme===k.Schemas.file).map(h=>h.fsPath):void 0;m=m??this.d.defaultProfile.extensionsResource;const $=await this.k(m,c??R.$w,l,d);return this.g.trace("Scanned Extensions",$),this.r($),S.mark("code/server/didScanExtensions"),$}async scanSingleExtension(c,m,u){await this.a;const d=c.scheme===k.Schemas.file?c.fsPath:null;if(!d)return null;const l=await this.o(d,m,u??R.$w);return l?(this.r([l]),l):null}async k(c,m,u,d){await this.q(m,d);const[l,$,h]=await Promise.all([this.m(m),this.n(c,m),this.l(m,u)]);return(0,I.$cO)(l,$,h,this.g)}async l(c,m){return m?(await Promise.all(m.map(u=>this.f.scanOneOrMultipleExtensions(C.URI.file((0,E.$kc)(u)),1,{language:c})))).flat().map(u=>(0,v.$Op)(u,!0)):[]}async m(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(u=>(0,v.$Op)(u,!1))}async n(c,m){return(await this.f.scanUserExtensions({profileLocation:c,language:m,useCache:!0})).map(d=>(0,v.$Op)(d,!1))}async o(c,m,u){const d=C.URI.file((0,E.$kc)(c)),l=m?0:1,$=await this.f.scanExistingExtension(d,l,{language:u});return $?(0,v.$Op)($,!1):null}async q(c,m){if(!(c===R.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(u){this.g.error(u)}if(!m){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${m} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([m],[],{isMachineScoped:!0},!0)}catch(u){this.g.error(u)}}}r(c){const m=(n,i)=>n.replace(/file/g,"vscode-remote"),u=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(m(n.source,!0),i)},d=new class{mapDefined(n){return w.$5i.create(n)}mapNot(n){return w.$0i.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?w.$6i.create(n,m(i,!1)):w.$6i.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?w.$9i.create(n,m(i,!1)):w.$9i.create(n,i)}mapGreater(n,i){return w.$$i.create(n,i)}mapGreaterEquals(n,i){return w.$_i.create(n,i)}mapSmaller(n,i){return w.$aj.create(n,i)}mapSmallerEquals(n,i){return w.$bj.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?w.$cj.create(n,u(i)):w.$cj.create(n,i)}mapIn(n,i){return w.$7i.create(n,i)}mapNotIn(n,i){return w.$8i.create(n,i)}},l=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=w.$Zi.deserialize(n.when);if(!i)return;const o=i.map(d);n.when=o.serialize()},$=n=>{if(Array.isArray(n))for(const i of n)l(i);else l(n)},h=n=>{for(const i in n)$(n[i])};c.forEach(n=>{n.contributes&&(n.contributes.menus&&h(n.contributes.menus),n.contributes.keybindings&&$(n.contributes.keybindings),n.contributes.views&&h(n.contributes.views))})}}e.$fO=b;class f{constructor(c,m){this.a=c,this.b=m}listen(c,m){throw new Error("Invalid listen")}async call(c,m,u){const d=this.b(c);switch(m){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const l=u[0],$=u[1]?C.URI.revive(d.transformIncoming(u[1])):void 0,h=Array.isArray(u[2])?u[2].map(o=>C.URI.revive(d.transformIncoming(o))):void 0,n=u[3];return(await this.a.scanExtensions(l,$,h,n)).map(o=>(0,P.$1m)(o,d))}case"scanSingleExtension":{const l=await this.a.scanSingleExtension(C.URI.revive(d.transformIncoming(u[0])),u[1],u[2]);return l?(0,P.$1m)(l,d):null}}throw new Error("Invalid call")}}e.$gO=f}),define(be[138],ve([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=void 0;class E{static{this.count=0}constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++E.count}}e.$Bv=E;const R=[];function r(P){const w=new E(P);return R[w.nid]=w,w}e.$Cv=r;function C(P){return R[P].sid}e.$Dv=C;class S{constructor(w){this.value=w}}e.$Ev=S}),define(be[284],ve([1,0,138]),function(ue,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$LK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var r;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(r||(e.TabInputKind=r={}));var C;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(C||(e.TabModelOperationKind=C={}));var S;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(S||(e.WebviewEditorCapabilities=S={}));var P;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var w;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var v;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(v||(e.NotebookEditorRevealType=v={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(I||(e.CandidatePortSource=I={}));class k{static{this.a=0}static mixin(m){return m._id=k.a++,m}}e.$LK=k;var b;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(b||(e.ISuggestDataDtoField=b={}));var f;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(f||(e.ISuggestResultDtoField=f={}));var p;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$MK={MainThreadAuthentication:(0,E.$Cv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Cv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Cv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Cv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Cv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Cv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Cv)("MainThreadCommands"),MainThreadComments:(0,E.$Cv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Cv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Cv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Cv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Cv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Cv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Cv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Cv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Cv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Cv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Cv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Cv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Cv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Cv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Cv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Cv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Cv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Cv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Cv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Cv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Cv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Cv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Cv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Cv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Cv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Cv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Cv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Cv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Cv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Cv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Cv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Cv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Cv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Cv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Cv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Cv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Cv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Cv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Cv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Cv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Cv)("MainThreadSCM"),MainThreadSearch:(0,E.$Cv)("MainThreadSearch"),MainThreadShare:(0,E.$Cv)("MainThreadShare"),MainThreadTask:(0,E.$Cv)("MainThreadTask"),MainThreadWindow:(0,E.$Cv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Cv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Cv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Cv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Cv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Cv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Cv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Cv)("MainThreadInteractive"),MainThreadChat:(0,E.$Cv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Cv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Cv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Cv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Cv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Cv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Cv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Cv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Cv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Cv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Cv)("MainThreadIssueReporter")},e.$NK={ExtHostCommands:(0,E.$Cv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Cv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Cv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Cv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Cv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Cv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Cv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Cv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Cv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Cv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Cv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Cv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Cv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Cv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Cv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Cv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Cv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Cv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Cv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Cv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Cv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Cv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Cv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Cv)("ExtHostSCM"),ExtHostSearch:(0,E.$Cv)("ExtHostSearch"),ExtHostTask:(0,E.$Cv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Cv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Cv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Cv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Cv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Cv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Cv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Cv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Cv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Cv)("ExtHostProgress"),ExtHostComments:(0,E.$Cv)("ExtHostComments"),ExtHostSecretState:(0,E.$Cv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Cv)("ExtHostStorage"),ExtHostUrls:(0,E.$Cv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Cv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Cv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Cv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$Cv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Cv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Cv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Cv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Cv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Cv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Cv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Cv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Cv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Cv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Cv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Cv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Cv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Cv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Cv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Cv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Cv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Cv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Cv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Cv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Cv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Cv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Cv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Cv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Cv)("ExtHostIssueReporter")}}),define(be[285],ve([1,0,10,132,137,23,284,18,13,50,42,79,3,2,6,268,281,15,138,39,60,38,279,21]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=void 0;let o=class{#e;#t;#n;constructor(D,y,A){this.b=new Map,this.c=new Map,this.#e=D.getProxy(S.$MK.MainThreadCommands),this.d=y,this.#n=A,this.#t=D.getProxy(S.$MK.MainThreadTelemetry),this.converter=new s(this,F=>{const X=this.c.get(F);return X?.result===a.Void?X:void 0},y),this.f=[{processArgument(F){return(0,v.$yh)(F)}},{processArgument(F){return(0,C.$jn)(F,function(X){if(I.$Gs.isIRange(X))return r.Range.to(X);if(k.$Fs.isIPosition(X))return r.Position.to(X);if(I.$Gs.isIRange(X.range)&&b.URI.isUri(X.uri))return r.location.to(X);if(X instanceof u.$ge)return X.buffer.buffer;if(!Array.isArray(X))return X})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const y=this.registerCommand(!1,D.id,async(...A)=>{const F=D.args.map((te,J)=>{if(!te.validate(A[J]))throw new Error(`Invalid argument '${te.name}' when running '${D.id}', received: ${typeof A[J]=="object"?JSON.stringify(A[J],null,"	"):A[J]} `);return te.convert(A[J])}),X=await this.executeCommand(D.internalId,...F);return D.result.convert(X,A,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new R.$OK(()=>{y.dispose(),this.c.delete(D.id)})}registerCommand(D,y,A,F,X,te){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:A,thisArg:F,metadata:X,extension:te}),D&&this.#e.$registerCommand(y),new R.$OK(()=>{this.b.delete(y)&&D&&this.#e.$unregisterCommand(y)})}executeCommand(D,...y){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,y,!0)}async g(D,y,A){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,y,!1);{let F=!1;const X=(0,C.$jn)(y,function(te){if(te instanceof R.$PK)return r.Position.from(te);if(te instanceof R.$QK)return r.Range.from(te);if(te instanceof R.$1K)return r.location.from(te);if(R.$aM.isNotebookRange(te))return r.NotebookRange.from(te);if(te instanceof ArrayBuffer)return F=!0,u.$ge.wrap(new Uint8Array(te));if(te instanceof Uint8Array)return F=!0,u.$ge.wrap(te);if(te instanceof u.$ge)return F=!0,te;if(!Array.isArray(te))return te});try{const te=await this.#e.$executeCommand(D,F?new d.$Ev(X):X,A);return(0,v.$yh)(te)}catch(te){if(te instanceof Error&&te.message==="$executeCommand:retry")return this.g(D,y,!1);throw te}}}async h(D,y,A){const F=this.b.get(D);if(!F)throw new Error("Unknown command");const{callback:X,thisArg:te,metadata:J}=F;if(J?.args)for(let ee=0;ee<J.args.length;ee++)try{(0,E.$Vf)(y[ee],J.args[ee].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${J.args[ee].name}' - ${J.args[ee].description}`)}const ie=$.$Od.create();try{return await X.apply(te,y)}catch(ee){if(D===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...y);U&&(D=U.command)}if(this.d.error(ee,D,F.extension?.identifier),!A)throw ee;if(F.extension?.identifier){const U=this.#n.onExtensionError(F.extension.identifier,ee);this.d.trace("forwarded error to extension?",U,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,l.$Mi)(ee)),this.id=D,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,D,ie.elapsed())}}j(D,y,A){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new h.$wo(y),duration:A})}$executeContributedCommand(D,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const A=this.b.get(D);return A?(y=y.map(F=>this.f.reduce((X,te)=>te.processArgument(X,A.extension?.identifier),F)),this.h(D,y,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(y=>(D&&(y=y.filter(A=>A[0]!=="_")),y))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[y,A]of this.b){const{metadata:F}=A;F&&(D[y]=F)}return Promise.resolve(D)}};e.$_M=o,e.$_M=o=Fe([Le(0,c.$QM),Le(1,w.$jj),Le(2,n.$$M)],o),e.$aN=(0,p.$2h)("IExtHostCommands");class s{constructor(D,y,A){this.d=D,this.f=y,this.g=A,this.delegatingCommandId=`__vsc${(0,i.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,y){if(!D)return;const A={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return A;const F=this.f(D.command);if(F)A.id=F.internalId,A.arguments=F.args.map((X,te)=>X.convert(D.arguments&&D.arguments[te]));else if((0,P.$Lb)(D.arguments)){const X=`${D.command} /${++this.c}`;this.b.set(X,D),y.add((0,f.$Qc)(()=>{this.b.delete(X),this.g.trace("CommandsConverter#DISPOSE",X)})),A.$ident=X,A.id=this.delegatingCommandId,A.arguments=[X],this.g.trace("CommandsConverter#CREATE",D.command,X)}return A}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const y=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$bN=s;class t{static{this.Uri=new t("uri","Uri of a text document",D=>b.URI.isUri(D),D=>D)}static{this.Position=new t("position","A position in a text document",D=>R.$PK.isPosition(D),r.Position.from)}static{this.Range=new t("range","A range in a text document",D=>R.$QK.isRange(D),r.Range.from)}static{this.Selection=new t("selection","A selection in a text document",D=>R.$RK.isSelection(D),r.Selection.from)}static{this.Number=new t("number","",D=>typeof D=="number",D=>D)}static{this.String=new t("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=t.Arr(t.String)}static Arr(D){return new t(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,y=>Array.isArray(y)&&y.every(A=>D.validate(A)),y=>y.map(A=>D.convert(A)))}static{this.CallHierarchyItem=new t("item","A call hierarchy item",D=>D instanceof R.$_K,r.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new t("item","A type hierarchy item",D=>D instanceof R.$tM,r.TypeHierarchyItem.from)}static{this.TestItem=new t("testItem","A VS Code TestItem",D=>D instanceof m.$4M,r.TestItem.from)}constructor(D,y,A,F){this.name=D,this.description=y,this.validate=A,this.convert=F}optional(){return new t(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,y){return new t(D??this.name,y??this.description,this.validate,this.convert)}}e.$cN=t;class a{static{this.Void=new a("no result",D=>D)}constructor(D,y){this.description=D,this.convert=y}}e.$dN=a;class g{constructor(D,y,A,F,X){this.id=D,this.internalId=y,this.description=A,this.args=F,this.result=X}}e.$eN=g}),define(be[286],ve([1,0,11,2,12,220]),function(ue,e,E,R,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=e.$XN=void 0,e.$XN="remoteFilesystem";class S extends C.$WN{static register(w,v,I){const k=w.getConnection();if(!k)return R.$Sc.None;const b=new R.$Rc,f=(async()=>{try{const p=await w.getRawEnvironment();p?v.registerProvider(r.Schemas.vscodeRemote,b.add(new S(p,k))):I.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(p){I.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,E.$0)(p))}})();return b.add(v.onWillActivateFileSystemProvider(p=>{p.scheme===r.Schemas.vscodeRemote&&p.join(f)})),b}constructor(w,v){super(v.getChannel(e.$XN),{pathCaseSensitive:w.os===3})}}e.$YN=S}),define(be[73],ve([1,0,89,78,28,287,15,11,5,2,7,4,21,43,106]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class c{traceSocketEvent(y,A){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,y,A)}constructor(y,A=""){this.f=!0,this.debugLabel=A,this.socket=y,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,P.$1)(F)}},this.socket.on("error",this.a),this.b=F=>{this.traceSocketEvent("close",{hadError:F}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(y){const A=F=>{this.traceSocketEvent("read",F),y(S.$ge.wrap(F))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(y){const A=F=>{y({type:0,hadError:F,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(y){const A=()=>{y()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(y){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",y),this.socket.write(y.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,P.$1)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,P.$1)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((y,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),y();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),y()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$Qh=c;var m;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var u;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(u||(u={}));class d extends v.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(y,A){this.socket.traceSocketEvent(y,A)}constructor(y,A,F,X){super(),this.f=this.B(new w.$Sd),this.g=this.B(new w.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=y,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:F?.byteLength||0,recordInflateBytes:X}),this.a=this.B(new l(this,A,F,X,this.f,(te,J)=>this.m(te,J))),this.B(this.a.onError(te=>{console.error(te),(0,P.$1)(te),this.g.fire({type:0,hadError:!0,error:te})})),this.b=new p.$Lh,this.B(this.socket.onData(te=>this.n(te))),this.B(this.socket.onClose(async te=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(te)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(y){return this.f.event(y)}onClose(y){return this.g.event(y)}onEnd(y){return this.socket.onEnd(y)}write(y){let A=0;for(;A<y.byteLength;)this.a.writeMessage(y.slice(A,Math.min(A+262144,y.byteLength)),{compressed:!0,opcode:2}),A+=262144}m(y,{compressed:A,opcode:F}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",y);let X=2;y.byteLength<126?X+=0:y.byteLength<2**16?X+=2:X+=8;const te=S.$ge.alloc(X),J=A?64:0,ie=F&15;if(te.writeUInt8(128|J|ie,0),y.byteLength<126)te.writeUInt8(y.byteLength,1);else if(y.byteLength<2**16){te.writeUInt8(126,1);let ee=1;te.writeUInt8(y.byteLength>>>8&255,++ee),te.writeUInt8(y.byteLength>>>0&255,++ee)}else{te.writeUInt8(127,1);let ee=1;te.writeUInt8(0,++ee),te.writeUInt8(0,++ee),te.writeUInt8(0,++ee),te.writeUInt8(0,++ee),te.writeUInt8(y.byteLength>>>24&255,++ee),te.writeUInt8(y.byteLength>>>16&255,++ee),te.writeUInt8(y.byteLength>>>8&255,++ee),te.writeUInt8(y.byteLength>>>0&255,++ee)}this.socket.write(S.$ge.concat([te,y]))}end(){this.h=!0,this.socket.end()}n(y){if(y.byteLength!==0){for(this.b.acceptChunk(y);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),F=A.readUInt8(0),X=(F&128)>>>7,te=(F&64)>>>6,J=F&15,ie=A.readUInt8(1),ee=(ie&128)>>>7,U=ie&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(U===126?2:0)+(U===127?8:0),this.j.fin=X,this.j.firstFrameOfMessage&&(this.j.compressed=!!te),this.j.firstFrameOfMessage=!!X,this.j.mask=0,this.j.opcode=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),F=A.readUInt8(1),X=(F&128)>>>7;let te=F&127,J=1;te===126?te=A.readUInt8(++J)*2**8+A.readUInt8(++J):te===127&&(te=A.readUInt8(++J)*0+A.readUInt8(++J)*0+A.readUInt8(++J)*0+A.readUInt8(++J)*0+A.readUInt8(++J)*2**24+A.readUInt8(++J)*2**16+A.readUInt8(++J)*2**8+A.readUInt8(++J));let ie=0;X&&(ie=A.readUInt8(++J)*2**24+A.readUInt8(++J)*2**16+A.readUInt8(++J)*2**8+A.readUInt8(++J)),this.j.state=3,this.j.readLen=te,this.j.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),n(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Rh=d;class l extends v.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.$ge.alloc(0)}constructor(y,A,F,X,te,J){super(),this.n=y,this.r=te,this.s=J,this.a=this.B(new w.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new w.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new $(this.n,X,F,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(ie=>this.a.fire(ie))),this.B(this.f.onError(ie=>this.a.fire(ie)))):(this.b=null,this.f=null)}writeMessage(y,A){this.g.push({data:y,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:y,options:A}=this.g.shift();if(this.f&&A.compressed){const F=await this.w(this.f,y);this.s(F,A)}else this.s(y,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(y,A){return new Promise((F,X)=>{y.write(A),y.flush(te=>F(te))})}acceptFrame(y,A,F){this.h.push({data:y,isCompressed:A,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const y=this.h.shift();if(this.b&&y.isCompressed){const A=await this.C(this.b,y.data,y.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(y.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(y,A,F){return new Promise((X,te)=>{y.write(A),F&&y.write(S.$ge.fromByteArray([0,0,255,255])),y.flush(J=>X(J))})}}class $ extends v.$Sc{get recordedInflateBytes(){return this.j?S.$ge.concat(this.f):S.$ge.alloc(0)}constructor(y,A,F,X){super(),this.h=y,this.j=A,this.a=this.B(new w.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,C.createInflateRaw)(X),this.b.on("error",te=>{this.h.traceSocketEvent("zlibInflateError",{message:te?.message,code:te?.code}),this.a.fire(te)}),this.b.on("data",te=>{this.h.traceSocketEvent("zlibInflateData",te),this.g.push(S.$ge.wrap(te))}),F&&(this.h.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(y){this.j&&this.f.push(y.clone()),this.h.traceSocketEvent("zlibInflateWrite",y),this.b.write(y.buffer)}flush(y){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=S.$ge.concat(this.g);this.g.length=0,y(A)})}}class h extends v.$Sc{constructor(y,A){super(),this.g=y,this.a=this.B(new w.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,C.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent("zlibDeflateData",F),this.f.push(S.$ge.wrap(F))})}write(y){this.g.traceSocketEvent("zlibDeflateWrite",y.buffer),this.b.write(y.buffer)}flush(y){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=S.$ge.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),y(A)})}}function n(D,y){if(y===0)return;const A=D.byteLength>>>2;for(let ee=0;ee<A;ee++){const U=D.readUInt32BE(ee*4);D.writeUInt32BE(U^y,ee*4)}const F=A*4,X=D.byteLength-F,te=y>>>24&255,J=y>>>16&255,ie=y>>>8&255;X>=1&&D.writeUInt8(D.readUInt8(F)^te,F),X>=2&&D.writeUInt8(D.readUInt8(F+1)^J,F+1),X>=3&&D.writeUInt8(D.readUInt8(F+2)^ie,F+2)}e.$Sh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function o(){const D=(0,b.$mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const y=process.platform!=="darwin"&&e.$Sh?e.$Sh:(0,r.tmpdir)(),A=(0,I.$jc)(y,`vscode-ipc-${D}.sock`);return t(A),A}e.$Th=o;function s(D,y,A){const F=(0,E.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${y}-sock`;const X=A.substr(0,4),te=y.substr(0,6),J=F.substr(0,8);let ie;return process.platform!=="darwin"&&e.$Sh&&!process.env.VSCODE_PORTABLE?ie=(0,I.$jc)(e.$Sh,`vscode-${J}-${X}-${te}.sock`):ie=(0,I.$jc)(D,`${X}-${te}.sock`),t(ie),ie}e.$Uh=s;function t(D){const y=i[k.$u];typeof y=="number"&&D.length>=y&&console.warn(`WARNING: IPC handle "${D}" is longer than ${y} chars, try a shorter --user-data-dir`)}class a extends f.$Fh{static b(y){const A=w.Event.fromNodeEventEmitter(y,"connection");return w.Event.map(A,F=>({protocol:new p.$Mh(new c(F,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(F,"close"))}))}constructor(y){super(a.b(y)),this.d=y}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Vh=a;function g(D){return new Promise((y,A)=>{const F=(0,R.createServer)();F.on("error",A),F.listen(D,()=>{F.removeListener("error",A),y(new a(F))})})}e.$Wh=g;function L(D,y){return new Promise((A,F)=>{const X=(0,R.createConnection)(D,()=>{X.removeListener("error",F),A(p.$Nh.fromSocket(new c(X,`ipc-client${y}`),y))});X.once("error",F)})}e.$Xh=L}),define(be[139],ve([1,0,87,14,15,11,10,24,25,88,13,44,237,287]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;let p=class extends k.$7o{constructor(d,l,$,h){super(h),this.m=d,this.n=l,this.r=$,this.s(),this.B(d.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,l){const{f:$,g:h}=this;let n;try{n=await(0,v.$7l)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,C.$0)(s)))}const i={...process.env,...n},o=d.agent?d.agent:await(0,b.$$q)(d.url||"",i,{proxyUrl:$,strictSSL:h});return d.agent=o,d.strictSSL=h,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>m(d,l))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((l,$)=>{ue(["@vscode/proxy-agent"],l,$)})).loadSystemCertificates({log:this.r})}};e.$_q=p,e.$_q=p=Fe([Le(0,P.$vi),Le(1,w.$0h),Le(2,I.$jj),Le(3,I.$kj)],p);async function c(u){return((0,E.parse)(u.url).protocol==="https:"?await new Promise(($,h)=>{ue(["https"],$,h)}):await new Promise(($,h)=>{ue(["http"],$,h)})).request}async function m(u,d){return R.Promises.withAsyncBody(async(l,$)=>{const h=(0,E.parse)(u.url),n=u.getRawRequest?u.getRawRequest(u):await c(u),i={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,S.$Kf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(i.auth=u.user+":"+u.password);const o=n(i,s=>{const t=(0,S.$If)(u.followRedirects)?u.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&t>0&&s.headers.location)m({...u,url:s.headers.location,followRedirects:t-1},d).then(l,$);else{let a=s;!u.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,f.createGunzip)())),l({res:s,stream:(0,r.$ve)(a)})}});o.on("error",$),u.timeout&&o.setTimeout(u.timeout),u.isChromiumNetwork&&o.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&o.write(u.data),o.end(),d.onCancellationRequested(()=>{o.abort(),$(new C.$5)})})}e.$ar=m}),define(be[140],ve([1,0,52,78,129,12,7,15,5,73,88,13,46,4,65,128,2,277,24]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=void 0;async function l(s={},t,a,g,L,D){const y=await(0,r.$Al)(a,g.userDataPath);let A={};if(t)try{A=await(0,I.$7l)(D,L,g.args,process.env)}catch(ee){L.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ee)}const X={...process.env,...A,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(y,void 0,0),...s},te=g.isBuilt?(0,S.$jc)(g.appRoot,"bin"):(0,S.$jc)(g.appRoot,"resources","server","bin-dev"),J=(0,S.$jc)(te,"remote-cli");let ie=n(X,"PATH");return ie?ie=J+S.$tc+ie:ie=J,i(X,"PATH",ie),g.args["without-browser-env-var"]||(X.BROWSER=(0,S.$jc)(te,"helpers",f.$i?"browser.cmd":"browser.sh")),o(X),X}e.$Pm=l;class ${constructor(t,a){this.socket=t,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let t,a,g;return this.socket instanceof v.$Qh?(t=!0,a=!1,g=P.$ge.alloc(0)):(t=!1,a=this.socket.permessageDeflate,g=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:t,permessageDeflate:a,inflateBytes:g.buffer.toString("base64")}}}let h=class{constructor(t,a,g,L,D,y,A,F){this.i=t,this.j=D,this.l=y,this.m=A,this.n=F,this.b=new w.$Sd,this.onClose=this.b.event,this.c=!f.$i||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new $(g,L),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(t){this.l.info(`${this.o}${t}`)}q(t){this.l.error(`${this.o}${t}`)}async r(t,a){const g=new m.$Rc;g.add(a.socket),g.add((0,m.$Qc)(()=>{t.destroy()}));const L=()=>{g.dispose()};g.add(a.socket.onEnd(L)),g.add(a.socket.onClose(L)),g.add(w.Event.fromNodeEventEmitter(t,"end")(L)),g.add(w.Event.fromNodeEventEmitter(t,"close")(L)),g.add(w.Event.fromNodeEventEmitter(t,"error")(L)),g.add(a.socket.onData(D=>t.write(D.buffer))),g.add(w.Event.fromNodeEventEmitter(t,"data")(D=>{a.socket.write(P.$ge.wrap(D))})),a.initialDataChunk.byteLength>0&&t.write(a.initialDataChunk.buffer)}async s(t,a){await a.socketDrain();const g=a.toIExtHostSocketMessage();let L;a.socket instanceof v.$Qh?L=a.socket.socket:L=a.socket.socket.socket,t.send(g,L)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const t={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(t)}acceptReconnection(t,a,g){this.f=t,this.p("The client has reconnected.");const L=new $(a,g);if(!this.g){this.h=L;return}this.s(this.g,L)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(t){try{let a=process.execArgv?process.execArgv.filter(J=>!/^--inspect(-brk)?=/.test(J)):[];t.port&&!process.pkg&&(a=[`--inspect${t.break?"-brk":""}=${t.port}`]);const g=await l(t.env,!0,t.language,this.j,this.l,this.n);(0,p.$Nl)(g);let L;if(this.c)(0,u.$Nm)(new u.$Lm,g),L=null;else{const{namedPipeServer:J,pipeName:ie}=await this.u();(0,u.$Nm)(new u.$Km(ie),g),L=J}const D={env:g,execArgv:a,silent:!0};D.execArgv.unshift("--dns-result-order=ipv4first");const y=["--type=extensionHost","--transformURIs"],A=this.j.args["use-host-proxy"];y.push(`--useHostProxy=${A?"true":"false"}`),this.g=E.fork(C.$kg.asFileUri("bootstrap-fork").fsPath,y,D);const F=this.g.pid;this.p(`<${F}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const X=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),te=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(X(J=>this.p(`<${F}> ${J}`)),te(J=>this.p(`<${F}><stderr> ${J}`)),this.g.on("error",J=>{this.q(`<${F}> Extension Host Process had an error`),this.l.error(J),this.t()}),this.g.on("exit",(J,ie)=>{this.m.setExitInfo(this.i,{code:J,signal:ie}),this.p(`<${F}> Extension Host Process exited with code: ${J}, signal: ${ie}.`),this.t()}),L)L.on("connection",J=>{L.close(),this.r(J,this.h)});else{const J=ie=>{ie.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",J),this.s(this.g,this.h),this.h=null)};this.g.on("message",J)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((t,a)=>{const g=(0,v.$Th)(),L=R.createServer();L.on("error",a),L.listen(g,()=>{L?.removeListener("error",a),t({pipeName:g,namedPipeServer:L})})})}};e.$Qm=h,e.$Qm=h=Fe([Le(4,b.$Am),Le(5,k.$jj),Le(6,c.$Im),Le(7,d.$vi)],h);function n(s,t){const a=Object.keys(s).filter(L=>L.toLowerCase()===t.toLowerCase()),g=a.length>0?a[0]:t;return s[g]}function i(s,t,a){const g=Object.keys(s).filter(D=>D.toLowerCase()===t.toLowerCase()),L=g.length>0?g[0]:t;s[L]=a}function o(s){for(const t of Object.keys(s))s[t]===null&&delete s[t]}}),define(be[288],ve([1,0,85,13,67,116,24,44,139,38,32,30,126,124,84,110,55,2,111,69,12,16,31,46,119,86,120,11,3,7,29,235,83,34,123,66,4,58,130,33,45,70,127,125,113,114,200,289]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i,o,s,t,a,g,L,D,y,A,F,X,te,J,ie,ee,U,he,Q,_,V,G,oe,le,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class $e extends u.$Sc{constructor(j,ne){super(),this.a=j,this.b=ne,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const j=await this.f();await j.invokeFunction(async ne=>{const Y=ne.get(S.$vi),Z=ne.get(R.$jj);J.$i&&(Y.getValue("security.restrictUNCAccess")===!1?(0,se.disableUNCAccessRestrictions)():(0,se.addUNCHostToAllowlist)(Y.getValue("security.allowedUNCHosts")));try{await this.g(j.createInstance(o.$tp,new R.$rj(Z.getLevel(),!1)))}catch(B){throw Z.error(B),console.error((0,a.$0)(B)),B}})}async f(){const j=new E.$Zh,ne={_serviceBrand:void 0,...m.default};j.set(n.$Bj,ne);const Y=new i.$Bm(this.a,ne);j.set(i.$Am,Y);const Z=new oe.$4N((0,R.$xj)(Y),Y.logsHome);j.set(R.$kj,Z);const B=new G.$bO(this.B(Z.createLogger("remoteCLI",{name:(0,le.localize)(0,null)})));j.set(R.$jj,B),B.trace(`Remote configuration data at ${this.b}`),B.trace("process arguments:",this.a);const H=this.B(new d.$1p(B));j.set(h.$lk,H),H.registerProvider($.Schemas.file,this.B(new l.$nq(B)));const T=new X.$Mr(H);j.set(F.$Vk,T);const W=this.B(new _.$_N(T,Y,H,B));j.set(U.$Xk,W);const x=this.B(new C.$Xn(W.defaultProfile.settingsResource,H,new Q.$xn,B));return j.set(S.$vi,x),await Promise.all([x.initialize(),W.init()]),j.set(P.$6o,new r.$Yh(w.$_q)),j.set(A.$2n,new r.$Yh(y.$qO)),j.set(I.$pl,v.$yo),j.set(k.$ko,new r.$Yh(b.$qp)),j.set(he.$Hp,new r.$Yh(V.$aO)),j.set(ie.$Lp,new r.$Yh(ee.$ZN)),j.set(p.$rp,new r.$Yh(p.$sp)),j.set(f.$Vp,new r.$Yh(f.$Wp)),j.set(s.$6q,new r.$Yh(t.$8q)),new c.$qq(j)}async g(j){if(this.a["list-extensions"])return j.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const ne={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return j.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),ne,!!this.a.force)}else{if(this.a["uninstall-extension"])return j.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return j.locateExtension(this.a["locate-extension"])}}h(j){return j.map(ne=>/\.vsix$/i.test(ne)?g.URI.file((0,L.$ic)(ne)?ne:(0,L.$jc)((0,D.cwd)(),ne)):ne)}}function z(O){setTimeout(()=>process.exit(O),0)}async function q(O,j,ne){if(O.help){const Z=m.default.serverApplicationName+(J.$i?".cmd":"");console.log((0,te.$Vl)(m.default.nameLong,Z,m.default.version,ne,{noInputFiles:!0,noPipe:!0}));return}if(O.version){console.log((0,te.$Wl)(m.default.version,m.default.commit));return}const Y=new $e(O,j);try{await Y.run(),z(0)}catch{z(1)}finally{Y.dispose()}}e.run=q}),define(be[290],ve([1,0,73,302,27,285,3,13,92]),function(ue,e,E,R,r,C,S,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0;class v{constructor(b,f,p){this.b=b,this.c=f,this.f=p,this.a=R.createServer((c,m)=>this.h(c,m)),this.g().catch(c=>(f.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,f){const p=(m,u)=>{f.writeHead(m,{"content-type":"application/json"}),f.end(JSON.stringify(u||null),d=>d&&this.c.error(d))},c=[];b.setEncoding("utf8"),b.on("data",m=>c.push(m)),b.on("end",async()=>{try{const m=JSON.parse(c.join(""));let u;switch(m.type){case"open":u=await this.i(m);break;case"openExternal":u=await this.j(m);break;case"status":u=await this.l(m);break;case"extensionManagement":u=await this.k(m);break;default:p(404,`Unknown message type: ${m.type}`);break}p(200,u)}catch(m){const u=m instanceof Error?m.message:JSON.stringify(m);p(500,u),this.c.error("Error while processing pipe request",m)}})}async i(b){const{fileURIs:f,folderURIs:p,forceNewWindow:c,diffMode:m,mergeMode:u,addMode:d,forceReuseWindow:l,gotoLineMode:$,waitMarkerFilePath:h,remoteAuthority:n}=b,i=[];if(Array.isArray(p))for(const a of p)try{i.push({folderUri:S.URI.parse(a)})}catch{}if(Array.isArray(f))for(const a of f)try{(0,w.$ui)(a)?i.push({workspaceUri:S.URI.parse(a)}):i.push({fileUri:S.URI.parse(a)})}catch{}const o=h?S.URI.file(h):void 0,t={forceNewWindow:c,diffMode:m,mergeMode:u,addMode:d,gotoLineMode:$,forceReuseWindow:l,preferNewWindow:!l&&!o&&!d,waitMarkerFileURI:o,remoteAuthority:n};this.b.executeCommand("_remoteCLI.windowOpen",i,t)}async j(b){for(const f of b.uris){const p=S.URI.parse(f),c=p.scheme==="file"?p:f;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(b){const f=c=>c?.map(m=>/\.vsix$/i.test(m)?S.URI.parse(m):m),p={list:b.list,install:f(b.install),uninstall:f(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",p)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$fN=v;let I=class extends v{constructor(b,f){super(b,f,(0,E.$Th)())}};e.$gN=I,e.$gN=I=Fe([Le(0,C.$aN),Le(1,P.$jj)],I)}),define(be[291],ve([1,0,28,5,23,2,7,4,3,73,71,290,122,90,272,274,140]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=void 0;class u extends c.$RN{constructor($,h,n,i,o){super({getFolderUri:s=>{const t=h.filter(a=>a.name===s);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(s,t)=>i[`config:${t}`],getExecPath:()=>$.VSCODE_EXEC_PATH,getAppRoot:()=>$.VSCODE_CWD,getFilePath:()=>{if(n)return S.$hc(n.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async s=>{const a=(await o.getInstalled()).find(g=>g.identifier.id===s);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(E.homedir()),Promise.resolve($))}}class d extends C.$Sc{constructor($,h,n,i,o,s){super(),this.g=$,this.h=h,this.j=n,this.m=i,this.n=o,this.r=s,this.a=0,this.b=new Map,this.c=this.B(new R.$Sd),this.onExecuteCommand=this.c.event}async call($,h,n){switch(h){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,n);case"$createProcess":{const i=(0,I.$Nr)($.remoteAuthority);return this.s(i,n)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,n);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,n);case"$listProcesses":return this.j.listProcesses.apply(this.j,n);case"$getLatency":return this.j.getLatency.apply(this.j,n);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,n);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,n);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,n);case"$start":return this.j.start.apply(this.j,n);case"$input":return this.j.input.apply(this.j,n);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,n);case"$shutdown":return this.j.shutdown.apply(this.j,n);case"$resize":return this.j.resize.apply(this.j,n);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,n);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,n);case"$getCwd":return this.j.getCwd.apply(this.j,n);case"$processBinary":return this.j.processBinary.apply(this.j,n);case"$sendCommandResult":return this.u(n[0],n[1],n[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,n);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,n);case"$getDefaultSystemShell":return this.w.apply(this,n);case"$getProfiles":return this.y.apply(this,n);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(n[0],n[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,n);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,n);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,n);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,n);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,n);case"$updateTitle":return this.j.updateTitle.apply(this.j,n);case"$updateProperty":return this.j.updateProperty.apply(this.j,n);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,n);case"$requestDetachInstance":return this.j.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,n);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,n)}throw new Error(`IPC Command ${h} not found`)}listen($,h,n){switch(h){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${h} not found`)}async s($,h){const n={name:h.shellLaunchConfig.name,executable:h.shellLaunchConfig.executable,args:h.shellLaunchConfig.args,cwd:typeof h.shellLaunchConfig.cwd=="string"||typeof h.shellLaunchConfig.cwd>"u"?h.shellLaunchConfig.cwd:w.URI.revive($.transformIncoming(h.shellLaunchConfig.cwd)),env:h.shellLaunchConfig.env,useShellEnvironment:h.shellLaunchConfig.useShellEnvironment,reconnectionProperties:h.shellLaunchConfig.reconnectionProperties,type:h.shellLaunchConfig.type,isFeatureTerminal:h.shellLaunchConfig.isFeatureTerminal},i=await(0,m.$Pm)(h.resolverEnv,!!h.shellLaunchConfig.useShellEnvironment,P.$w,this.g,this.h,this.r);this.h.trace("baseEnv",i);const o=ee=>({uri:w.URI.revive($.transformIncoming(ee.uri)),name:ee.name,index:ee.index,toResource:()=>{throw new Error("Not implemented")}}),s=h.workspaceFolders.map(o),t=h.activeWorkspaceFolder?o(h.activeWorkspaceFolder):void 0,a=h.activeFileResource?w.URI.revive($.transformIncoming(h.activeFileResource)):void 0,g=new u(i,s,a,h.resolvedVariables,this.n),L=p.$NN(t,process.env,g),D=await p.$MN(n,E.homedir(),L,t?.uri,h.configuration["terminal.integrated.cwd"],this.h);n.cwd=D;const y=P.$i?"terminal.integrated.env.windows":P.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",A=h.configuration[y],F=await p.$ON(n,A,L,this.m.version,h.configuration["terminal.integrated.detectLocale"],i);if(!n.strictEnv){const ee=[];for(const[_,V,G]of h.envVariableCollections)ee.push([_,{map:(0,f.$zr)(V),descriptionMap:(0,f.$Ar)(G)}]);const U=new Map(ee),he=new b.$Dr(U),Q=t?t??void 0:void 0;await he.applyToProcessEnvironment(F,{workspaceFolder:Q},L)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:D,cols:h.cols,rows:h.rows,env:F});const X=(0,v.$Th)();F.VSCODE_IPC_HOOK_CLI=X;const te=await this.j.createProcess(n,D,h.cols,h.rows,h.unicodeVersion,F,i,h.options,h.shouldPersistTerminal,h.workspaceId,h.workspaceName),J={executeCommand:(ee,...U)=>this.t(te,ee,U,$)},ie=new k.$fN(J,this.h,X);return this.j.onProcessExit(ee=>ee.id===te&&ie.dispose()),{persistentTerminalId:te,resolvedShellLaunchConfig:n}}t($,h,n,i){let o,s;const t=new Promise((L,D)=>{o=L,s=D}),a=++this.a;this.b.set(a,{resolve:o,reject:s,uriTransformer:i});const g=(0,r.$jn)(n,L=>{if(L&&L.$mid===1)return i.transformOutgoing(L);if(L&&L instanceof w.URI)return i.transformOutgoingURI(L)});return this.c.fire({reqId:a,persistentProcessId:$,commandId:h,commandArgs:g}),t}u($,h,n){const i=this.b.get($);if(!i)return;this.b.delete($);const o=(0,r.$jn)(n,s=>{if(s&&s.$mid===1)return i.uriTransformer.transformIncoming(s)});h?i.reject(o):i.resolve(o)}w($){return this.j.getDefaultSystemShell($)}async y($,h,n,i){return this.j.getProfiles($,h,n,i)||[]}z(){return{...process.env}}C($,h){return this.j.getWslPath($,h)}D(){return this.j.reduceConnectionGraceTime()}}e.$SN=d}),define(be[292],ve([1,0,28,5,2,12,7,101,22,43,24,116,208,83,209,25,126,30,84,119,219,124,16,111,69,67,110,85,86,120,13,55,31,44,236,139,118,32,38,250,91,258,34,123,269,270,241,248,291,71,46,276,286,128,58,130,45,33,70,249,114,127,125,113,112,202,283,232,262,255]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i,o,s,t,a,g,L,D,y,A,F,X,te,J,ie,ee,U,he,Q,_,V,G,oe,le,se,$e,z,q,O,j,ne,Y,Z,B,H,T,W,x,re,fe,ce,ge,ye,Ie,Re,me,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;const Ee="monacoworkbench";async function Me(Se,Ae,Oe,Be){const Te=new a.$Zh,qe=new He,Je={_serviceBrand:void 0,...y.default};Te.set(A.$Bj,Je);const Ge=new q.$Bm(Ae,Je);Te.set(c.$9h,Ge),Te.set(c.$0h,Ge);const Ze=new x.$4N((0,D.$xj)(Ge),Ge.logsHome);Te.set(D.$kj,Ze),qe.registerChannel("logger",new ge.$mr(Ze,st=>We(st.remoteAuthority)));const nt=Ze.createLogger("remoteagent",{name:(0,ye.localize)(0,null)}),Xe=new ce.$bO(nt,[new Qe((0,D.$xj)(Ge))]);Te.set(D.$jj,Xe),setTimeout(()=>pe(Ge.logsHome.with({scheme:C.Schemas.file}).fsPath).then(null,st=>Xe.error(st)),1e4),Xe.onDidChangeLogLevel(st=>(0,D.log)(Xe,st,`Log level changed to ${(0,D.$yj)(Xe.getLevel())}`)),Xe.trace(`Remote configuration data at ${Oe}`),Xe.trace("process arguments:",Ge.args),Array.isArray(Je.serverGreeting)&&Xe.info(`

${Je.serverGreeting.join(`
`)}

`),qe.registerChannel(b.$Zn.ChannelName,new b.$Zn);const it=new v.$Jh(st=>st.clientId==="renderer"),ot=Be.add(new i.$1p(Xe));Te.set(n.$lk,ot),ot.registerProvider(C.Schemas.file,Be.add(new o.$nq(Xe)));const ut=new V.$Mr(ot);Te.set(_.$Vk,ut);const ht=new k.$Xn(Ge.machineSettingsResource,ot,new T.$xn,Xe);Te.set(I.$vi,ht);const dt=new re.$_N(ut,Ge,ot,Xe);Te.set(H.$Xk,dt),qe.registerChannel("userDataProfiles",new me.$hO(dt,st=>We(st.remoteAuthority)));const[,,Ft,jt]=await Promise.all([ht.initialize(),dt.init(),(0,P.$6m)(Xe.error.bind(Xe)),(0,P.$7m)(Xe.error.bind(Xe))]),St=new ne.$Jm;Te.set(ne.$Im,St);const It=new te.$_q(ht,Ge,Xe,Ze);Te.set(F.$6o,It);let mt=ee.$Co;const gt=(0,ee.$Jo)(Je,ht);if((0,ee.$Eo)(Je,Ge)){!(0,ee.$Fo)(Je,Ge)&&Je.aiConfig?.ariaKey&&(mt=new W.$2N(It,gt,Ee,null,Je.aiConfig.ariaKey),Be.add((0,r.$Qc)(()=>mt?.flush())));const st={appenders:[mt],commonProperties:(0,J.$uo)((0,E.release)(),(0,E.hostname)(),process.arch,Je.commit,Je.version+"-remote",Ft,jt,gt,"remoteAgent"),piiPaths:(0,ee.$Ko)(Ge)},$t=Ge.args["telemetry-level"];let ft=3;$t==="all"?ft=3:$t==="error"?ft=2:$t==="crash"?ft=1:$t!==void 0&&(ft=0),Te.set(se.$1r,new s.$Yh(se.$Yr,[st,ft]))}else Te.set(se.$1r,se.$Zr);Te.set(u.$ko,new s.$Yh(m.$qp));const At=qe.getChannel("download",it);Te.set(f.$2n,new p.$4n(At,()=>We("renderer"))),Te.set(B.$Hp,new s.$Yh(fe.$aO)),Te.set(Y.$Lp,new s.$Yh(Z.$ZN)),Te.set(d.$rp,new s.$Yh(d.$sp)),Te.set(h.$Vp,new s.$Yh(h.$Wp));const bt=new t.$qq(Te);Te.set(g.$6q,bt.createInstance(L.$8q));const Mt=bt.createInstance(De.$jO,{graceTime:108e5,shortGraceTime:3e5,scrollback:ht.getValue("terminal.integrated.persistentSessionScrollback")??100}),Rt=bt.createInstance(Q.$Ir,Mt);return Te.set(he.$hr,Rt),bt.invokeFunction(st=>{const $t=st.get(h.$Vp),ft=st.get(Y.$Lp),Tt=st.get(u.$ko),Ut=st.get(g.$6q),zt=new G.$Ur(Se,Ge,dt,St);qe.registerChannel("remoteextensionsenvironment",zt);const Bt=new le.$2r(st.get(se.$1r),mt);qe.registerChannel("telemetry",Bt),qe.registerChannel(O.$TN,new $e.$SN(Ge,Xe,Rt,Je,$t,ht));const yt=new Ie.$fO(bt.createInstance(l.$tp,Xe),Ge,dt,ft,Xe,Tt,Ut);qe.registerChannel(Re.$eO,new Ie.$gO(yt,kt=>We(kt.remoteAuthority)));const Ot=new oe.$Xr(Xe,Ge);qe.registerChannel(j.$XN,Ot),qe.registerChannel("request",new X.$9q(st.get(F.$6o)));const Et=new $.$up($t,kt=>We(kt.remoteAuthority));return qe.registerChannel("extensions",Et),yt.whenExtensionsReady().then(()=>$t.cleanUp()),Be.add(new U.default(st.get(ie.$pl))),{telemetryService:st.get(ie.$pl)}}),{socketServer:qe,instantiationService:bt}}e.$kO=Me;const je=Object.create(null);function We(Se){return je[Se]||(je[Se]=(0,z.$Nr)(Se)),je[Se]}class He extends v.$Fh{constructor(){const Ae=new R.$Sd;super(Ae.event),this.b=Ae}acceptConnection(Ae,Oe){this.b.fire({protocol:Ae,onDidClientDisconnect:Oe})}}e.$lO=He;class Qe extends D.$oj{constructor(Ae=D.$mj){super(),this.setLevel(Ae),this.g=!!process.stdout.isTTY}trace(Ae,...Oe){this.f(D.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ye()}]\x1B[0m`,Ae,...Oe):console.log(`[${Ye()}]`,Ae,...Oe))}debug(Ae,...Oe){this.f(D.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ye()}]\x1B[0m`,Ae,...Oe):console.log(`[${Ye()}]`,Ae,...Oe))}info(Ae,...Oe){this.f(D.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ye()}]\x1B[0m`,Ae,...Oe):console.log(`[${Ye()}]`,Ae,...Oe))}warn(Ae,...Oe){this.f(D.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ye()}]\x1B[0m`,Ae,...Oe):console.warn(`[${Ye()}]`,Ae,...Oe))}error(Ae,...Oe){this.f(D.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ye()}]\x1B[0m`,Ae,...Oe):console.error(`[${Ye()}]`,Ae,...Oe))}dispose(){}flush(){}}function Ye(){const Se=new Date;return`${et(Se.getHours())}:${et(Se.getMinutes())}:${et(Se.getSeconds())}`}function et(Se){return Se<10?`0${Se}`:String(Se)}async function pe(Se){const Ae=S.$nc(Se),Oe=S.$mc(Se),qe=(await w.Promises.readdir(Oe)).filter(Ge=>/^\d{8}T\d{6}$/.test(Ge)).sort().filter(Ge=>Ge!==Ae),Je=qe.slice(0,Math.max(0,qe.length-9));await Promise.all(Je.map(Ge=>w.Promises.rm(S.$jc(Oe,Ge))))}}),define(be[293],ve([1,0,89,27,78,294,87,95,15,11,40,2,12,7,41,4,17,3,21,168,154,289,106,73,24,6,13,31,57,32,140,263,264,46,292,266]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b,f,p,c,m,u,d,l,$,h,n,i,o,s,t,a,g,L,D,y,A,F,X,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;const J=5*60*1e3;let ie=class extends k.$Sc{constructor(Q,_,V,G,oe,le,se,$e){super(),this.n=Q,this.r=_,this.s=V,this.t=oe,this.u=le,this.w=se,this.y=$e,this.h=U.create(this.u),this.j=(0,g.$0k)(le),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=G?this.y.createInstance(te.$oO,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(Q,_){if(Q.method!=="GET")return(0,te.$mO)(Q,_,405,`Unsupported method ${Q.method}`);if(!Q.url)return(0,te.$mO)(Q,_,400,"Bad request.");const V=S.parse(Q.url,!0);let G=V.pathname;if(!G)return(0,te.$mO)(Q,_,400,"Bad request.");if(G.startsWith(this.j)&&G.charCodeAt(this.j.length)===47&&(G=G.substring(this.j.length)),G==="/version")return _.writeHead(200,{"Content-Type":"text/plain"}),void _.end(this.u.commit||"");if(G==="/delay-shutdown")return this.N(),_.writeHead(200),void _.end("OK");if(!(0,A.$Xm)(this.r,Q,V))return(0,te.$mO)(Q,_,403,"Forbidden.");if(G==="/vscode-remote-resource"){const oe=V.query.path;if(typeof oe!="string")return(0,te.$mO)(Q,_,400,"Bad request.");let le;try{le=u.URI.from({scheme:b.Schemas.file,path:oe}).fsPath}catch{return(0,te.$mO)(Q,_,400,"Bad request.")}const se=Object.create(null);this.t.isBuilt&&((0,I.$4f)(le,this.t.builtinExtensionsPath,!c.$k)||(0,I.$4f)(le,this.t.extensionsPath,!c.$k))&&(se["Cache-Control"]="public, max-age=31536000"),se.Vary="Origin";const $e=Q.headers.origin;return $e&&this.h.matches($e)&&(se["Access-Control-Allow-Origin"]=$e),(0,te.$nO)(le,1,this.w,Q,_,se)}if(this.g){this.g.handle(Q,_,V);return}return _.writeHead(404,{"Content-Type":"text/plain"}),void _.end("Not found")}handleUpgrade(Q,_){let V=(0,d.$mg)(),G=!1,oe=!1;if(Q.url){const O=S.parse(Q.url,!0).query;typeof O.reconnectionToken=="string"&&(V=O.reconnectionToken),O.reconnection==="true"&&(G=!0),O.skipWebSocketFrames==="true"&&(oe=!0)}if(Q.headers.upgrade===void 0||Q.headers.upgrade.toLowerCase()!=="websocket"){_.end("HTTP/1.1 400 Bad Request");return}const le=Q.headers["sec-websocket-key"],se=E.createHash("sha1");se.update(le+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const z=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${se.digest("base64")}`];let q=!1;if(!oe&&!this.t.args["disable-websocket-compression"]&&Q.headers["sec-websocket-extensions"]){const O=Array.isArray(Q.headers["sec-websocket-extensions"])?Q.headers["sec-websocket-extensions"]:[Q.headers["sec-websocket-extensions"]];for(const j of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(j)){if(/\b(permessage-deflate)\b/.test(j)){q=!0,z.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(j)){q=!0,z.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}_.write(z.join(`\r
`)+`\r
\r
`),_.setTimeout(0),_.setNoDelay(!0),oe?this.D(new i.$Qh(_,`server-connection-${V}`),G,V):this.D(new i.$Rh(new i.$Qh(_,`server-connection-${V}`),q,null,!0),G,V)}handleServerError(Q){this.w.error("Error occurred in server"),this.w.error(Q)}z(Q){let _;return Q instanceof i.$Qh?_=Q.socket:_=Q.socket.socket,_.remoteAddress||"<unknown>"}async C(Q,_,V){const G=_.getSocket();this.w.error(`${Q} ${V}.`);const oe={type:"error",reason:V};_.sendControl(w.$ge.fromString(JSON.stringify(oe))),_.dispose(),await G.drain(),G.dispose()}D(Q,_,V){const G=this.z(Q),oe=`[${G}][${V.substr(0,8)}]`,le=new n.$Ph({socket:Q}),se=this.s?new this.s.validator:null,$e=this.s?new this.s.signer:null;let z;(function(ne){ne[ne.WaitingForAuth=0]="WaitingForAuth",ne[ne.WaitingForConnectionType=1]="WaitingForConnectionType",ne[ne.Done=2]="Done",ne[ne.Error=3]="Error"})(z||(z={}));let q=0;const O=ne=>{q=3,j.dispose(),this.C(oe,le,ne)},j=le.onControlMessage(ne=>{if(q===0){let Y;try{Y=JSON.parse(ne.toString())}catch{return O("Malformed first message")}if(Y.type!=="auth")return O("Invalid first message");if(this.r.type===2&&!this.r.validate(Y.auth))return O("Unauthorized client refused: auth mismatch");let Z=(0,d.$mg)();if($e)try{Z=$e.sign(Y.data)}catch{}let B=(0,d.$mg)();if(se)try{B=se.createNewMessage(B)}catch{}const H={type:"sign",data:B,signedData:Z};le.sendControl(w.$ge.fromString(JSON.stringify(H))),q=1}else if(q===1){let Y;try{Y=JSON.parse(ne.toString())}catch{return O("Malformed second message")}if(Y.type!=="connectionType")return O("Invalid second message");if(typeof Y.signedData!="string")return O("Invalid second message field type");const Z=Y.commit,B=this.u.commit;if(Z&&B&&Z!==B)return O("Client refused: version mismatch");let H=!1;if(!se)H=!0;else if(this.r.validate(Y.signedData))H=!0;else try{H=se.validate(Y.signedData)==="ok"}catch{}if(!H){if(this.t.isBuilt)return O("Unauthorized client refused");this.w.error(`${oe} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const T in this.b)this.b[T].shortenReconnectionGraceTimeIfNecessary();for(const T in this.a)this.a[T].shortenReconnectionGraceTimeIfNecessary();q=2,j.dispose(),this.F(G,oe,le,Q,_,V,Y)}})}async F(Q,_,V,G,oe,le,se){const $e=se.desiredConnectionType===1?`${_}[ManagementConnection]`:se.desiredConnectionType===2?`${_}[ExtensionHostConnection]`:_;if(se.desiredConnectionType===1)if(oe){if(!this.b[le])return this.f.has(le)?this.C($e,V,"Unknown reconnection token (seen before)"):this.C($e,V,"Unknown reconnection token (never seen)");V.sendControl(w.$ge.fromString(JSON.stringify({type:"ok"})));const z=V.readEntireBuffer();V.dispose(),this.b[le].acceptReconnection(Q,G,z)}else{if(this.b[le])return this.C($e,V,"Duplicate reconnection token");V.sendControl(w.$ge.fromString(JSON.stringify({type:"ok"})));const z=new y.$Rm(this.w,le,Q,V);this.n.acceptConnection(z.protocol,z.onClose),this.b[le]=z,this.f.add(le),z.onClose(()=>{delete this.b[le]})}else if(se.desiredConnectionType===2){const z=se.args||{language:"en"},q=await this.I(z);if(q.port&&this.w.trace(`${$e} - startParams debug port ${q.port}`),this.w.trace(`${$e} - startParams language: ${q.language}`),this.w.trace(`${$e} - startParams env: ${JSON.stringify(q.env)}`),oe){if(!this.a[le])return this.f.has(le)?this.C($e,V,"Unknown reconnection token (seen before)"):this.C($e,V,"Unknown reconnection token (never seen)");V.sendPause(),V.sendControl(w.$ge.fromString(JSON.stringify(q.port?{debugPort:q.port}:{})));const O=V.readEntireBuffer();V.dispose(),this.a[le].acceptReconnection(Q,G,O)}else{if(this.a[le])return this.C($e,V,"Duplicate reconnection token");V.sendPause(),V.sendControl(w.$ge.fromString(JSON.stringify(q.port?{debugPort:q.port}:{})));const O=V.readEntireBuffer();V.dispose();const j=this.y.createInstance(D.$Qm,le,Q,G,O);this.a[le]=j,this.f.add(le),j.onClose(()=>{delete this.a[le],this.J()}),j.start(q)}}else if(se.desiredConnectionType===3){const z=se.args;this.G(V,z)}else return this.C($e,V,"Unknown initial data received")}async G(Q,_){const V=Q.getSocket().socket,G=Q.readEntireBuffer();Q.dispose(),V.pause();const oe=await this.H(_.host,_.port);G.byteLength>0&&oe.write(G.buffer),oe.on("end",()=>V.end()),oe.on("close",()=>V.end()),oe.on("error",()=>V.destroy()),V.on("end",()=>oe.end()),V.on("close",()=>oe.end()),V.on("error",()=>oe.destroy()),oe.pipe(V),V.pipe(oe)}H(Q,_){return new Promise((V,G)=>{const oe=r.createConnection({host:Q,port:_,autoSelectFamily:!0},()=>{oe.removeListener("error",G),oe.pause(),V(oe)});oe.once("error",G)})}I(Q){return typeof Q.port=="number"?(0,$.$og)(Q.port,10,5e3).then(_=>(Q.port=_,Q)):(Q.debugId=void 0,Q.port=void 0,Q.break=void 0,Promise.resolve(Q))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(Q=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!Q?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},J))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ie=Fe([Le(4,F.$Am),Le(5,a.$Bj),Le(6,t.$jj),Le(7,s.$1h)],ie);async function ee(he,Q,_){const V=await(0,A.$Wm)(Q);V instanceof A.$Um&&(console.warn(V.message),process.exit(1));function G(H){(0,v.setUnexpectedErrorHandler)(T=>{(0,v.$Z)(T)&&T.stack&&/unexpectedErrorHandler/.test(T.stack)||H(T)})}const oe=[];G(H=>{oe.push(H),console.error(H)});let le=!1;process.on("SIGPIPE",()=>{le||(le=!0,(0,v.$1)(new Error("Unexpected SIGPIPE")))});const se=new k.$Rc,{socketServer:$e,instantiationService:z}=await(0,X.$kO)(V,Q,_,se);z.invokeFunction(H=>{const T=H.get(t.$jj);oe.forEach(W=>T.error(W)),oe.length=0,G(W=>T.error(W))}),z.invokeFunction(H=>{const T=H.get(o.$vi);c.$i&&(T.getValue("security.restrictUNCAccess")===!1?(0,h.disableUNCAccessRestrictions)():(0,h.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")))}),z.invokeFunction(H=>{const T=H.get(t.$jj);if(c.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const W=(0,f.$jc)(process.env.HOMEDRIVE,"node_modules"),x=(0,f.$mc)((0,f.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),re=(0,f.$jc)(x,"node_modules");if(R.existsSync(W)||R.existsSync(re)){const fe=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${W}
* ${re}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;T.warn(fe),console.warn(fe),process.exit(0)}}});const q=z.invokeFunction(H=>{const T=H.get(t.$jj);if(R.existsSync((0,f.$jc)(b.$kg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(x){T.error(x)}return null}),O=R.existsSync(b.$kg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(O&&he&&typeof he!="string"){const H=V.type!==0?`?${b.$dg}=${V.value}`:"";console.log(`Web UI available at http://localhost${he.port===80?"":`:${he.port}`}/${H}`)}const j=z.createInstance(ie,$e,V,q,O);p.mark("code/server/ready");const ne=C.performance.now(),Y=global.vscodeServerStartTime,Z=global.vscodeServerListenTime,B=global.vscodeServerCodeLoadedTime;if(z.invokeFunction(async H=>{const T=H.get(L.$pl);if(T.publicLog2("serverStart",{startTime:Y,startedTime:Z,codeLoadedTime:B,readyTime:ne}),c.$k){const W=H.get(t.$jj),x=await(0,l.$ng)(W.error.bind(W));x&&T.publicLog2("serverPlatformInfo",{platformId:x.id,platformVersionId:x.version_id,platformIdLike:x.id_like})}}),Q["print-startup-performance"]){const H=P.$U.get();let T="";T+=`

### Load AMD-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],H.amdLoad),T+=`

### Load commonjs-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],H.nodeRequire),T+=`

### Invoke AMD-module factory
`,T+=P.$U.toMarkdownTable(["Module","Duration"],H.amdInvoke),T+=`

### Invoke commonjs-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],H.nodeEval),T+=`Start-up time: ${Z-Y}
`,T+=`Code loading time: ${B-Y}
`,T+=`Initialized time: ${ne-Y}
`,T+=`
`,console.log(T)}return j}e.$pO=ee;class U{static create(Q){const _=Q.webEndpointUrlTemplate,V=Q.commit,G=Q.quality;if(!_||!V||!G)return new U(null);const oe=(0,d.$mg)(),se=new URL(_.replace("{{uuid}}",oe).replace("{{commit}}",V).replace("{{quality}}",G)).origin,$e=(0,m.$Ke)(se).replace(oe,"[a-zA-Z0-9\\-]+");try{const z=(0,m.$Te)(`^${$e}$`,!0,{matchCase:!1});return new U(z)}catch{return new U(null)}}constructor(Q){this.a=Q}matches(Q){return this.a?this.a.test(Q):!1}}}),define(be[303],ve([1,0,28,27,12,288,293,66,7,294,46,55,41]),function(ue,e,E,R,r,C,S,P,w,v,I,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,b.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=v.performance.now();const f={onMultipleValues:(s,t)=>{console.error(`Option '${s}' can only be defined once. Using value ${t}.`)},onEmptyValue:s=>{console.error(`Ignoring option '${s}': Value must not be empty.`)},onUnknownOption:s=>{console.error(`Ignoring option '${s}': not supported for server.`)},onDeprecatedOption:(s,t)=>{console.warn(`Option '${s}' is deprecated: ${t}`)}},p=(0,P.$Tl)(process.argv.slice(2),I.$zm,f),c=p["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.$jc)(E.homedir(),k.default.serverDataFolderName||".vscode-remote"),m=(0,w.$jc)(c,"data"),u=(0,w.$jc)(m,"User"),d=(0,w.$jc)(u,"globalStorage"),l=(0,w.$jc)(u,"History"),$=(0,w.$jc)(m,"Machine");p["user-data-dir"]=m;const h=(0,w.$mc)(r.$kg.asFileUri("").fsPath),n=(0,w.$jc)(h,"extensions");p["builtin-extensions-dir"]=n,p["extensions-dir"]=p["extensions-dir"]||(0,w.$jc)(c,"extensions"),[c,p["extensions-dir"],m,u,$,d,l].forEach(s=>{try{R.existsSync(s)||R.mkdirSync(s,{mode:448})}catch(t){console.error(t)}});function i(){(0,C.run)(p,c,I.$zm)}e.spawnCli=i;function o(s){return(0,S.$pO)(s,p,c)}e.createServer=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8b3775030ed1a69b13e4f4c628c612102e30a681/core/vs/server/node/server.main.js.map
