/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],D=0,T=me.length;D<T;D++)e[D]=ke[me[D]];return e};define(ke[157],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const g=new Map,I=new Map,R=new Map,p=new Map;function $(w,S){w.has(S.detail)||w.set(S.detail,-S.timestamp)}function y(w,S){const l=w.get(S.detail);l&&(l>=0||w.set(S.detail,l+S.timestamp))}let M=[];typeof me=="function"&&typeof me.getStats=="function"&&(M=me.getStats().slice(0).sort((w,S)=>w.timestamp-S.timestamp));for(const w of M)switch(w.type){case 10:$(g,w);break;case 11:case 12:y(g,w);break;case 21:$(I,w);break;case 22:y(I,w);break;case 33:$(R,w);break;case 34:y(R,w);break;case 31:$(p,w);break;case 32:y(p,w);break}let C=0;R.forEach(w=>C+=w);function m(w){const S=[];return w.forEach((l,f)=>S.push([f,l])),S}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(R),nodeEval:m(p),nodeRequireTotal:C}}static toMarkdownTable(g,I){let R="";const p=[];return g.forEach(($,y)=>{p[y]=$.length}),I.forEach($=>{$.forEach((y,M)=>{typeof y>"u"&&(y=$[M]="-");const C=y.toString().length;p[M]=Math.max(C,p[M])})}),g.forEach(($,y)=>{R+=`| ${$+" ".repeat(p[y]-$.toString().length)} `}),R+=`|
`,g.forEach(($,y)=>{R+=`| ${"-".repeat(p[y])} `}),R+=`|
`,I.forEach($=>{$.forEach((y,M)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(p[M]-y.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(ke[158],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(l,f,s){const i=T(l,f);if(i!==-1)return l[i]}e.$fb=D;function T(l,f,s=l.length-1){for(let i=s;i>=0;i--){const n=l[i];if(f(n))return i}return-1}e.$gb=T;function g(l,f){const s=I(l,f);return s===-1?void 0:l[s]}e.$hb=g;function I(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);f(l[a])?n=a+1:o=a}return n-1}e.$ib=I;function R(l,f){const s=p(l,f);return s===l.length?void 0:l[s]}e.$jb=R;function p(l,f,s=0,i=l.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);f(l[a])?o=a:n=a+1}return n}e.$kb=p;function $(l,f,s=0,i=l.length){const n=p(l,f,s,i);return n===l.length?-1:n}e.$lb=$;class y{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!f(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const s=I(this.e,f,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=y;function M(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>0&&(s=n)}return s}e.$nb=M;function C(l,f){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];f(n,s)>=0&&(s=n)}return s}e.$ob=C;function m(l,f){return M(l,(s,i)=>-f(s,i))}e.$pb=m;function w(l,f){if(l.length===0)return-1;let s=0;for(let i=1;i<l.length;i++){const n=l[i];f(n,l[s])>0&&(s=i)}return s}e.$qb=w;function S(l,f){for(const s of l){const i=f(s);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(R,p){const $=Object.create(null);for(const y of R){const M=p(y);let C=$[M];C||(C=$[M]=[]),C.push(y)}return $}e.$K=D;function T(R,p){const $=[],y=[];for(const M of R)p.has(M)||$.push(M);for(const M of p)R.has(M)||y.push(M);return{removed:$,added:y}}e.$L=T;function g(R,p){const $=[],y=[];for(const[M,C]of R)p.has(M)||$.push(C);for(const[M,C]of p)R.has(M)||y.push(C);return{removed:$,added:y}}e.$M=g;function I(R,p){const $=new Set;for(const y of p)R.has(y)&&$.add(y);return $}e.$N=I}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function D(R){return(p,$,y)=>{let M=null,C=null;if(typeof y.value=="function"?(M="value",C=y.value):typeof y.get=="function"&&(M="get",C=y.get),!C)throw new Error("not supported");y[M]=R(C,$)}}function T(R,p,$){let y=null,M=null;if(typeof $.value=="function"?(y="value",M=$.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",M=$.get),!M)throw new Error("not supported");const C=`$memoize$${p}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,m)}),this[C]}}e.$th=T;function g(R,p,$){return D((y,M)=>{const C=`$debounce$${M}`,m=`$debounce$result$${M}`;return function(...w){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),p&&(this[m]=p(this[m],...w),w=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,w),this[m]=$?$():void 0},R)}})}e.$uh=g;function I(R,p,$){return D((y,M)=>{const C=`$throttle$timer$${M}`,m=`$throttle$result$${M}`,w=`$throttle$lastRun$${M}`,S=`$throttle$pending$${M}`;return function(...l){if(this[m]||(this[m]=$?$():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),p&&(this[m]=p(this[m],...l)),this[S])return;const f=this[w]+R;f<=Date.now()?(this[w]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[w]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},f-Date.now()))}})}e.$vh=I}),define(ke[8],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function T(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=T;function g(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=g;function I(a){y(a)||e.$X.onUnexpectedError(a)}e.$1=I;function R(a){y(a)||e.$X.onUnexpectedExternalError(a)}e.$2=R;function p(a){if(a instanceof Error){const{name:t,message:r}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$3=p;const $="Canceled";function y(a){return a instanceof M?!0:a instanceof Error&&a.name===$&&a.message===$}e.$4=y;class M extends Error{constructor(){super($),this.name=this.message}}e.$5=M;function C(){const a=new Error($);return a.name=a.message,a}e.$6=C;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=m;function w(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=w;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function l(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=l;class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(ke[19],Se([1,0,8,158]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function g(he,ge=0){return he[he.length-(1+ge)]}e.$sb=g;function I(he){if(he.length===0)throw new Error("Invalid tail call");return[he.slice(0,he.length-1),he[he.length-1]]}e.$tb=I;function R(he,ge,_=(ie,G)=>ie===G){if(he===ge)return!0;if(!he||!ge||he.length!==ge.length)return!1;for(let ie=0,G=he.length;ie<G;ie++)if(!_(he[ie],ge[ie]))return!1;return!0}e.$ub=R;function p(he,ge){const _=he.length-1;ge<_&&(he[ge]=he[_]),he.pop()}e.$vb=p;function $(he,ge,_){return y(he.length,ie=>_(he[ie],ge))}e.$wb=$;function y(he,ge){let _=0,ie=he-1;for(;_<=ie;){const G=(_+ie)/2|0,te=ge(G);if(te<0)_=G+1;else if(te>0)ie=G-1;else return G}return-(_+1)}e.$xb=y;function M(he,ge,_){if(he=he|0,he>=ge.length)throw new TypeError("invalid index");const ie=ge[Math.floor(ge.length*Math.random())],G=[],te=[],fe=[];for(const ve of ge){const Ae=_(ve,ie);Ae<0?G.push(ve):Ae>0?te.push(ve):fe.push(ve)}return he<G.length?M(he,G,_):he<G.length+fe.length?fe[0]:M(he-(G.length+fe.length),te,_)}e.$yb=M;function C(he,ge){const _=[];let ie;for(const G of he.slice(0).sort(ge))!ie||ge(ie[0],G)!==0?(ie=[G],_.push(ie)):ie.push(G);return _}e.$zb=C;function*m(he,ge){let _,ie;for(const G of he)ie!==void 0&&ge(ie,G)?_.push(G):(_&&(yield _),_=[G]),ie=G;_&&(yield _)}e.$Ab=m;function w(he,ge){for(let _=0;_<=he.length;_++)ge(_===0?void 0:he[_-1],_===he.length?void 0:he[_])}e.$Bb=w;function S(he,ge){for(let _=0;_<he.length;_++)ge(_===0?void 0:he[_-1],he[_],_+1===he.length?void 0:he[_+1])}e.$Cb=S;function l(he,ge,_){const ie=[];function G(ve,Ae,pe){if(Ae===0&&pe.length===0)return;const De=ie[ie.length-1];De&&De.start+De.deleteCount===ve?(De.deleteCount+=Ae,De.toInsert.push(...pe)):ie.push({start:ve,deleteCount:Ae,toInsert:pe})}let te=0,fe=0;for(;;){if(te===he.length){G(te,0,ge.slice(fe));break}if(fe===ge.length){G(te,he.length-te,[]);break}const ve=he[te],Ae=ge[fe],pe=_(ve,Ae);pe===0?(te+=1,fe+=1):pe<0?(G(te,1,[]),te+=1):pe>0&&(G(te,0,[Ae]),fe+=1)}return ie}e.$Db=l;function f(he,ge,_){const ie=l(he,ge,_),G=[],te=[];for(const fe of ie)G.push(...he.slice(fe.start,fe.start+fe.deleteCount)),te.push(...fe.toInsert);return{removed:G,added:te}}e.$Eb=f;function s(he,ge,_){if(_===0)return[];const ie=he.slice(0,_).sort(ge);return n(he,ge,ie,_,he.length),ie}e.top=s;function i(he,ge,_,ie,G){return _===0?Promise.resolve([]):new Promise((te,fe)=>{(async()=>{const ve=he.length,Ae=he.slice(0,_).sort(ge);for(let pe=_,De=Math.min(_+ie,ve);pe<ve;pe=De,De=Math.min(De+ie,ve)){if(pe>_&&await new Promise(U=>setTimeout(U)),G&&G.isCancellationRequested)throw new D.$5;n(he,ge,Ae,pe,De)}return Ae})().then(te,fe)})}e.$Gb=i;function n(he,ge,_,ie,G){for(const te=_.length;ie<G;ie++){const fe=he[ie];if(ge(fe,_[te-1])<0){_.pop();const ve=(0,T.$kb)(_,Ae=>ge(fe,Ae)<0);_.splice(ve,0,fe)}}}function o(he){return he.filter(ge=>!!ge)}e.$Hb=o;function a(he){let ge=0;for(let _=0;_<he.length;_++)he[_]&&(he[ge]=he[_],ge+=1);he.length=ge}e.$Ib=a;function t(he,ge,_){he.splice(_,0,he.splice(ge,1)[0])}e.$Jb=t;function r(he){return!Array.isArray(he)||he.length===0}e.$Kb=r;function d(he){return Array.isArray(he)&&he.length>0}e.$Lb=d;function u(he,ge=_=>_){const _=new Set;return he.filter(ie=>{const G=ge(ie);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=u;function c(he){const ge=new Set;return _=>{const ie=he(_);return ge.has(ie)?!1:(ge.add(ie),!0)}}e.$Nb=c;function h(he,ge){return he.length>0?he[0]:ge}e.$Ob=h;function k(he,ge){return he.length>0?he[he.length-1]:ge}e.$Pb=k;function L(he,ge,_=(ie,G)=>ie===G){let ie=0;for(let G=0,te=Math.min(he.length,ge.length);G<te&&_(he[G],ge[G]);G++)ie++;return ie}e.$Qb=L;function v(he){return[].concat(...he)}e.$Rb=v;function b(he,ge){let _=typeof ge=="number"?he:0;typeof ge=="number"?_=he:(_=0,ge=he);const ie=[];if(_<=ge)for(let G=_;G<ge;G++)ie.push(G);else for(let G=_;G>ge;G--)ie.push(G);return ie}e.$Sb=b;function E(he,ge,_){return he.reduce((ie,G)=>(ie[ge(G)]=_?_(G):G,ie),Object.create(null))}e.$Tb=E;function A(he,ge){return he.push(ge),()=>z(he,ge)}e.$Ub=A;function z(he,ge){const _=he.indexOf(ge);if(_>-1)return he.splice(_,1),ge}e.$Vb=z;function O(he,ge,_){const ie=he.slice(0,ge),G=he.slice(ge);return ie.concat(_,G)}e.$Wb=O;function P(he,ge){let _;if(typeof ge=="number"){let ie=ge;_=()=>{const G=Math.sin(ie++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ie=he.length-1;ie>0;ie-=1){const G=Math.floor(_()*(ie+1)),te=he[ie];he[ie]=he[G],he[G]=te}}e.$Xb=P;function j(he,ge){const _=he.indexOf(ge);_>-1&&(he.splice(_,1),he.unshift(ge))}e.$Yb=j;function N(he,ge){const _=he.indexOf(ge);_>-1&&(he.splice(_,1),he.push(ge))}e.$Zb=N;function F(he,ge){for(const _ of ge)he.push(_)}e.$1b=F;function W(he,ge){return Array.isArray(he)?he.map(ge):ge(he)}e.$2b=W;function x(he){return Array.isArray(he)?he:[he]}e.$3b=x;function ce(he){return he[Math.floor(Math.random()*he.length)]}e.$4b=ce;function J(he,ge,_){const ie=X(he,ge),G=he.length,te=_.length;he.length=G+te;for(let fe=G-1;fe>=ie;fe--)he[fe+te]=he[fe];for(let fe=0;fe<te;fe++)he[fe+ie]=_[fe]}e.$5b=J;function Y(he,ge,_,ie){const G=X(he,ge);let te=he.splice(G,_);return te===void 0&&(te=[]),J(he,G,ie),te}e.$6b=Y;function X(he,ge){return ge<0?Math.max(ge+he.length,0):Math.min(ge,he.length)}var se;(function(he){function ge(te){return te<0}he.isLessThan=ge;function _(te){return te<=0}he.isLessThanOrEqual=_;function ie(te){return te>0}he.isGreaterThan=ie;function G(te){return te===0}he.isNeitherLessOrGreaterThan=G,he.greaterThan=1,he.lessThan=-1,he.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function Z(he,ge){return(_,ie)=>ge(he(_),he(ie))}e.$7b=Z;function we(...he){return(ge,_)=>{for(const ie of he){const G=ie(ge,_);if(!se.isNeitherLessOrGreaterThan(G))return G}return se.neitherLessOrGreaterThan}}e.$8b=we;const de=(he,ge)=>he-ge;e.$9b=de;const K=(he,ge)=>(0,e.$9b)(he?1:0,ge?1:0);e.$0b=K;function B(he){return(ge,_)=>-he(ge,_)}e.$$b=B;class ne{constructor(ge){this.g=ge,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ge){let _=this.c;for(;_<this.g.length&&ge(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(ge){let _=this.d;for(;_>=0&&ge(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ge=this.g[this.c];return this.c++,ge}removeLast(){const ge=this.g[this.d];return this.d--,ge}takeCount(ge){const _=this.g.slice(this.c,this.c+ge);return this.c+=ge,_}}e.$_b=ne;class ye{static{this.empty=new ye(ge=>{})}constructor(ge){this.iterate=ge}forEach(ge){this.iterate(_=>(ge(_),!0))}toArray(){const ge=[];return this.iterate(_=>(ge.push(_),!0)),ge}filter(ge){return new ye(_=>this.iterate(ie=>ge(ie)?_(ie):!0))}map(ge){return new ye(_=>this.iterate(ie=>_(ge(ie))))}some(ge){let _=!1;return this.iterate(ie=>(_=ge(ie),!_)),_}findFirst(ge){let _;return this.iterate(ie=>ge(ie)?(_=ie,!1):!0),_}findLast(ge){let _;return this.iterate(ie=>(ge(ie)&&(_=ie),!0)),_}findLastMaxBy(ge){let _,ie=!0;return this.iterate(G=>((ie||se.isGreaterThan(ge(G,_)))&&(ie=!1,_=G),!0)),_}}e.$ac=ye}),define(ke[60],Se([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=e.$7c=e.$6c=e.$5c=e.ok=void 0;function T($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=T;function g($,y="Unreachable"){throw new Error(y)}e.$5c=g;function I($){if(!$)throw new D.$cb("Assertion Failed")}e.$6c=I;function R($){if(!$()){debugger;$(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$7c=R;function p($,y){let M=0;for(;M<$.length-1;){const C=$[M],m=$[M+1];if(!y(C,m))return!1;M++}return!0}e.$8c=p}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(T,g){const I=this;let R=!1,p;return function(){if(R)return p;if(R=!0,g)try{p=T.apply(I,arguments)}finally{g()}else p=T.apply(I,arguments);return p}}e.$db=D}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$VM=D,e.$WM=new D("id#")}),define(ke[52],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(T){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=g;const I=Object.freeze([]);function R(){return I}T.empty=R;function*p(a){yield a}T.single=p;function $(a){return g(a)?a:p(a)}T.wrap=$;function y(a){return a||I}T.from=y;function*M(a){for(let t=a.length-1;t>=0;t--)yield a[t]}T.reverse=M;function C(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=C;function m(a){return a[Symbol.iterator]().next().value}T.first=m;function w(a,t){for(const r of a)if(t(r))return!0;return!1}T.some=w;function S(a,t){for(const r of a)if(t(r))return r}T.find=S;function*l(a,t){for(const r of a)t(r)&&(yield r)}T.filter=l;function*f(a,t){let r=0;for(const d of a)yield t(d,r++)}T.map=f;function*s(...a){for(const t of a)yield*t}T.concat=s;function i(a,t,r){let d=r;for(const u of a)d=t(d,u);return d}T.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}T.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const d=a[Symbol.iterator]();for(let u=0;u<t;u++){const c=d.next();if(c.done)return[r,T.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return d}}]}T.consume=o})(D||(e.Iterable=D={}))}),define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function R(t,r=!1){let d=0;const u=t.length;let c="",h=0,k=16,L=0;function v(j){let N=0,F=0;for(;N<j;){const W=t.charCodeAt(d);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;d++,N++}return N<j&&(F=-1),F}function b(j){d=j,c="",h=0,k=16,L=0}function E(){const j=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&y(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&y(t.charCodeAt(d)))for(d++;d<t.length&&y(t.charCodeAt(d));)d++;else return L=3,t.substring(j,d);let N=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&y(t.charCodeAt(d))){for(d++;d<t.length&&y(t.charCodeAt(d));)d++;N=d}else L=3;return t.substring(j,N)}function A(){let j="",N=d;for(;;){if(d>=u){j+=t.substring(N,d),L=2;break}const F=t.charCodeAt(d);if(F===34){j+=t.substring(N,d),d++;break}if(F===92){if(j+=t.substring(N,d),d++,d>=u){L=2;break}switch(t.charCodeAt(d++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const x=v(4);x>=0?j+=String.fromCharCode(x):L=4;break}default:L=5}N=d;continue}if(F>=0&&F<=31)if($(F)){j+=t.substring(N,d),L=2;break}else L=6;d++}return j}function z(){if(c="",L=0,h=d,d>=u)return h=u,k=17;let j=t.charCodeAt(d);if(p(j)){do d++,c+=String.fromCharCode(j),j=t.charCodeAt(d);while(p(j));return k=15}if($(j))return d++,c+=String.fromCharCode(j),j===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),k=14;switch(j){case 123:return d++,k=1;case 125:return d++,k=2;case 91:return d++,k=3;case 93:return d++,k=4;case 58:return d++,k=6;case 44:return d++,k=5;case 34:return d++,c=A(),k=10;case 47:{const N=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<u&&!$(t.charCodeAt(d));)d++;return c=t.substring(N,d),k=12}if(t.charCodeAt(d+1)===42){d+=2;const F=u-1;let W=!1;for(;d<F;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,L=1),c=t.substring(N,d),k=13}return c+=String.fromCharCode(j),d++,k=16}case 45:if(c+=String.fromCharCode(j),d++,d===u||!y(t.charCodeAt(d)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=E(),k=11;default:for(;d<u&&O(j);)d++,j=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return c+=String.fromCharCode(j),d++,k=16}}function O(j){if(p(j)||$(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let j;do j=z();while(j>=12&&j<=15);return j}return{setPosition:b,getPosition:()=>d,scan:r?P:z,getToken:()=>k,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>L}}e.$8m=R;function p(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function C(t,r){const d=[],u=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function L(v,b,E,A){h.value=v,h.offset=b,h.length=E,h.type=A,h.colonOffset=void 0,c=h}try{n(t,{onObjectBegin:(v,b)=>{if(r<=v)throw u;c=void 0,k=r>v,d.push("")},onObjectProperty:(v,b,E)=>{if(r<b||(L(v,b,E,"property"),d[d.length-1]=v,r<=b+E))throw u},onObjectEnd:(v,b)=>{if(r<=v)throw u;c=void 0,d.pop()},onArrayBegin:(v,b)=>{if(r<=v)throw u;c=void 0,d.push(0)},onArrayEnd:(v,b)=>{if(r<=v)throw u;c=void 0,d.pop()},onLiteralValue:(v,b,E)=>{if(r<b||(L(v,b,E,a(v)),r<=b+E))throw u},onSeparator:(v,b,E)=>{if(r<=b)throw u;if(v===":"&&c&&c.type==="property")c.colonOffset=b,k=!1,c=void 0;else if(v===","){const A=d[d.length-1];typeof A=="number"?d[d.length-1]=A+1:(k=!0,d[d.length-1]=""),c=void 0}}})}catch(v){if(v!==u)throw v}return{path:d,previousNode:c,isAtPropertyKey:k,matches:v=>{let b=0;for(let E=0;b<v.length&&E<d.length;E++)if(v[b]===d[E]||v[b]==="*")b++;else if(v[b]!=="**")return!1;return b===v.length}}}e.$9m=C;function m(t,r=[],d=I.DEFAULT){let u=null,c=[];const h=[];function k(v){Array.isArray(c)?c.push(v):u!==null&&(c[u]=v)}return n(t,{onObjectBegin:()=>{const v={};k(v),h.push(c),c=v,u=null},onObjectProperty:v=>{u=v},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const v=[];k(v),h.push(c),c=v,u=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:k,onError:(v,b,E)=>{r.push({error:v,offset:b,length:E})}},d),c[0]}e.$0m=m;function w(t,r=[],d=I.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(v){u.type==="property"&&(u.length=v-u.offset,u=u.parent)}function h(v){return u.children.push(v),v}n(t,{onObjectBegin:v=>{u=h({type:"object",offset:v,length:-1,parent:u,children:[]})},onObjectProperty:(v,b,E)=>{u=h({type:"property",offset:b,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:v,offset:b,length:E,parent:u})},onObjectEnd:(v,b)=>{u.length=v+b-u.offset,u=u.parent,c(v+b)},onArrayBegin:(v,b)=>{u=h({type:"array",offset:v,length:-1,parent:u,children:[]})},onArrayEnd:(v,b)=>{u.length=v+b-u.offset,u=u.parent,c(v+b)},onLiteralValue:(v,b,E)=>{h({type:a(v),offset:b,length:E,parent:u,value:v}),c(b+E)},onSeparator:(v,b,E)=>{u.type==="property"&&(v===":"?u.colonOffset=b:v===","&&c(b))},onError:(v,b,E)=>{r.push({error:v,offset:b,length:E})}},d);const L=u.children[0];return L&&delete L.parent,L}e.$$m=w;function S(t,r){if(!t)return;let d=t;for(const u of r)if(typeof u=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===u){d=h.children[1],c=!0;break}if(!c)return}else{const c=u;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}e.$_m=S;function l(t){if(!t.parent||!t.parent.children)return[];const r=l(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;r.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&r.push(d)}return r}e.$an=l;function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const r=Object.create(null);for(const d of t.children){const u=d.children[1];u&&(r[d.children[0].value]=f(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$bn=f;function s(t,r,d=!1){return r>=t.offset&&r<t.offset+t.length||d&&r===t.offset+t.length}e.$cn=s;function i(t,r,d=!1){if(s(t,r,d)){const u=t.children;if(Array.isArray(u))for(let c=0;c<u.length&&u[c].offset<=r;c++){const h=i(u[c],r,d);if(h)return h}return t}}e.$dn=i;function n(t,r,d=I.DEFAULT){const u=R(t,!1);function c(Z){return Z?()=>Z(u.getTokenOffset(),u.getTokenLength()):()=>!0}function h(Z){return Z?we=>Z(we,u.getTokenOffset(),u.getTokenLength()):()=>!0}const k=c(r.onObjectBegin),L=h(r.onObjectProperty),v=c(r.onObjectEnd),b=c(r.onArrayBegin),E=c(r.onArrayEnd),A=h(r.onLiteralValue),z=h(r.onSeparator),O=c(r.onComment),P=h(r.onError),j=d&&d.disallowComments,N=d&&d.allowTrailingComma;function F(){for(;;){const Z=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:j||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(Z){case 12:case 13:j?W(10):O();break;case 16:W(1);break;case 15:case 14:break;default:return Z}}}function W(Z,we=[],de=[]){if(P(Z),we.length+de.length>0){let K=u.getToken();for(;K!==17;){if(we.indexOf(K)!==-1){F();break}else if(de.indexOf(K)!==-1)break;K=F()}}}function x(Z){const we=u.getTokenValue();return Z?A(we):L(we),F(),!0}function ce(){switch(u.getToken()){case 11:{let Z=0;try{Z=JSON.parse(u.getTokenValue()),typeof Z!="number"&&(W(2),Z=0)}catch{W(2)}A(Z);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return F(),!0}function J(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(x(!1),u.getToken()===6?(z(":"),F(),se()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Y(){k(),F();let Z=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),z(","),F(),u.getToken()===2&&N)break}else Z&&W(6,[],[]);J()||W(4,[],[2,5]),Z=!0}return v(),u.getToken()!==2?W(7,[2],[]):F(),!0}function X(){b(),F();let Z=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(Z||W(4,[],[]),z(","),F(),u.getToken()===4&&N)break}else Z&&W(6,[],[]);se()||W(4,[],[4,5]),Z=!0}return E(),u.getToken()!==4?W(8,[4],[]):F(),!0}function se(){switch(u.getToken()){case 3:return X();case 1:return Y();case 10:return x(!0);default:return ce()}}return F(),u.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):se()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$en=n;function o(t,r){const d=R(t),u=[];let c,h=0,k;do switch(k=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==k&&u.push(t.substring(h,k)),r!==void 0&&u.push(d.getTokenValue().replace(/[^\r\n]/g,r)),h=d.getPosition();break}while(c!==17);return u.join("")}e.$fn=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$gn=a}),define(ke[43],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class T{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const R=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=R}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,R){const p=new D(I);if(this.a===D.Undefined)this.a=p,this.b=p;else if(R){const y=this.b;this.b=p,p.prev=y,y.next=p}else{const y=this.a;this.a=p,p.next=y,y.prev=p}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(p))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const R=I.prev;R.next=I.next,I.next.prev=R}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$3c=T}),define(ke[28],Se([1,0]),function(me,e){"use strict";var D,T,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function I(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$xc=I;function R(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$yc=R;function p(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$zc=p;class ${constructor(n,o){this.uri=n,this.value=o}}function y(i){return Array.isArray(i)}class M{static{this.a=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof M)this.b=new Map(n.b),this.c=o??M.a;else if(y(n)){this.b=new Map,this.c=o??M.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??M.a}set(n,o){return this.b.set(this.c(n),new $(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$Ac=M;class C{constructor(n,o){this[T]="ResourceSet",!n||typeof n=="function"?this.a=new M(n):(this.a=new M(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class w{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Cc=w;class S extends w{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=S;class l{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Ec=l;class f{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=f;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Gc=s}),define(ke[3],Se([1,0,19,73,28,74,52]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const p=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(A){let z=this.b.get(A);return z||(z={parent:null,source:null,isSingleton:!1,value:A,idx:y.a++},this.b.set(A,z)),z}trackDisposable(A){const z=this.c(A);z.source||(z.source=new Error().stack)}setParent(A,z){const O=this.c(A);O.parent=z}markAsDisposed(A){this.b.delete(A)}markAsSingleton(A){this.c(A).isSingleton=!0}f(A,z){const O=z.get(A);if(O)return O;const P=A.parent?this.f(this.c(A.parent),z):A;return z.set(A,P),P}getTrackedDisposables(){const A=new Map;return[...this.b.entries()].filter(([,O])=>O.source!==null&&!this.f(O,A).isSingleton).flatMap(([O])=>O)}computeLeakingDisposables(A=10,z){let O;if(z)O=z;else{const W=new Map,x=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,W).isSingleton);if(x.length===0)return;const ce=new Set(x.map(J=>J.value));if(O=x.filter(J=>!(J.parent&&ce.has(J.parent))),O.length===0)throw new Error("There are cyclic diposable chains!")}if(!O)return;function P(W){function x(J,Y){for(;J.length>0&&Y.some(X=>typeof X=="string"?X===J[0]:J[0].match(X));)J.shift()}const ce=W.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return x(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const j=new g.$Gc;for(const W of O){const x=P(W);for(let ce=0;ce<=x.length;ce++)j.add(x.slice(0,ce).join(`
`),W)}O.sort((0,D.$7b)(W=>W.idx,D.$9b));let N="",F=0;for(const W of O.slice(0,A)){F++;const x=P(W),ce=[];for(let J=0;J<x.length;J++){let Y=x[J];Y=`(shared with ${j.get(x.slice(0,J+1).join(`
`)).size}/${O.length} leaks) at ${Y}`;const se=j.get(x.slice(0,J).join(`
`)),Z=(0,T.$K)([...se].map(we=>P(we)[J]),we=>we);delete Z[x[J]];for(const[we,de]of Object.entries(Z))ce.unshift(`    - stacktraces of ${de.length} other leaks continue with ${we}`);ce.unshift(Y)}N+=`


==================== Leaking disposable ${F}/${O.length}: ${W.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return O.length>A&&(N+=`


... and ${O.length-A} more leaking disposables

`),{leaks:O,details:N}}}e.$Hc=y;function M(E){$=E}if(e.$Ic=M,p){const E="__is_disposable_tracked__";M(new class{trackDisposable(A){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{A[E]||console.log(z)},3e3)}setParent(A,z){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsDisposed(A){if(A&&A!==t.None)try{A[E]=!0}catch{}}markAsSingleton(A){}})}function C(E){return $?.trackDisposable(E),E}e.$Jc=C;function m(E){$?.markAsDisposed(E)}e.$Kc=m;function w(E,A){$?.setParent(E,A)}function S(E,A){if($)for(const z of E)$.setParent(z,A)}function l(E){return $?.markAsSingleton(E),E}e.$Lc=l;function f(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=f;function s(E){if(R.Iterable.is(E)){const A=[];for(const z of E)if(z)try{z.dispose()}catch(O){A.push(O)}if(A.length===1)throw A[0];if(A.length>1)throw new AggregateError(A,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=s;function i(E){for(const A of E)f(A)&&A.dispose();return[]}e.$Oc=i;function n(...E){const A=o(()=>s(E));return S(E,A),A}e.$Pc=n;function o(E){const A=C({dispose:(0,I.$db)(()=>{m(A),E()})});return A}e.$Qc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(A){if(!A)return A;if(A===this)throw new Error("Cannot register a disposable on itself!");return w(A,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(A),A}delete(A){if(A){if(A===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(A),A.dispose()}}deleteAndLeak(A){A&&this.f.has(A)&&(this.f.delete(A),w(A,null))}}e.$Rc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),w(this.q,this)}dispose(){m(this),this.q.dispose()}B(A){if(A===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(A)}}e.$Sc=t;class r{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(A){this.b||A===this.a||(this.a?.dispose(),A&&w(A,this),this.a=A)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const A=this.a;return this.a=void 0,A&&w(A,null),A}}e.$Tc=r;class d{constructor(A){this.a=new r,this.b=!1,this.a.value=A}get value(){return this.a.value}set value(A){this.b||A===this.a.value||(this.a.value=A)}dispose(){this.b=!0,this.a.dispose()}}e.$Uc=d;class u{constructor(A){this.b=A,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Vc=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(A){let z=A;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,m(this))},this}}e.$Wc=c;class h{constructor(){this.a=new Map}acquire(A,...z){let O=this.a.get(A);O||(O={counter:0,object:this.b(A,...z)},this.a.set(A,O));const{object:P}=O,j=(0,I.$db)(()=>{--O.counter===0&&(this.c(A,O.object),this.a.delete(A))});return O.counter++,{object:P,dispose:j}}}e.$Xc=h;class k{constructor(A){this.a=A}async acquire(A,...z){const O=this.a.acquire(A,...z);try{return{object:await O.object,dispose:()=>O.dispose()}}catch(P){throw O.dispose(),P}}}e.$Yc=k;class L{constructor(A){this.object=A}dispose(){}}e.$Zc=L;function v(E){const A=new a;try{E(A)}finally{A.dispose()}}e.$1c=v;class b{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(A){return this.a.has(A)}get size(){return this.a.size}get(A){return this.a.get(A)}set(A,z,O=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),O||this.a.get(A)?.dispose(),this.a.set(A,z)}deleteAndDispose(A){this.a.get(A)?.dispose(),this.a.delete(A)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$2c=b}),function(me,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ge,_){for(var ie=0;ie<_.length;ie++){var G=_[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(ge,G.key,G)}}function D(ge,_,ie){return _&&e(ge.prototype,_),ie&&e(ge,ie),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function T(ge,_){if(ge){if(typeof ge=="string")return g(ge,_);var ie=Object.prototype.toString.call(ge).slice(8,-1);if(ie==="Object"&&ge.constructor&&(ie=ge.constructor.name),ie==="Map"||ie==="Set")return Array.from(ge);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return g(ge,_)}}function g(ge,_){(_==null||_>ge.length)&&(_=ge.length);for(var ie=0,G=new Array(_);ie<_;ie++)G[ie]=ge[ie];return G}function I(ge,_){var ie=typeof Symbol<"u"&&ge[Symbol.iterator]||ge["@@iterator"];if(ie)return(ie=ie.call(ge)).next.bind(ie);if(Array.isArray(ge)||(ie=T(ge))||_&&ge&&typeof ge.length=="number"){ie&&(ge=ie);var G=0;return function(){return G>=ge.length?{done:!0}:{done:!1,value:ge[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function p(ge){me.defaults=ge}var $=/[&<>"']/,y=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(_){return m[_]};function S(ge,_){if(_){if($.test(ge))return ge.replace(y,w)}else if(M.test(ge))return ge.replace(C,w);return ge}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(ge){return ge.replace(l,function(_,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(ge,_){ge=typeof ge=="string"?ge:ge.source,_=_||"";var ie={replace:function(te,fe){return fe=fe.source||fe,fe=fe.replace(s,"$1"),ge=ge.replace(te,fe),ie},getRegex:function(){return new RegExp(ge,_)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(ge,_,ie){if(ge){var G;try{G=decodeURIComponent(f(ie)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!o.test(ie)&&(ie=c(_,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ge,_){t[" "+ge]||(r.test(ge)?t[" "+ge]=ge+"/":t[" "+ge]=v(ge,"/",!0)),ge=t[" "+ge];var ie=ge.indexOf(":")===-1;return _.substring(0,2)==="//"?ie?_:ge.replace(d,"$1")+_:_.charAt(0)==="/"?ie?_:ge.replace(u,"$1")+_:ge+_}var h={exec:function(){}};function k(ge){for(var _=1,ie,G;_<arguments.length;_++){ie=arguments[_];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(ge[G]=ie[G])}return ge}function L(ge,_){var ie=ge.replace(/\|/g,function(fe,ve,Ae){for(var pe=!1,De=ve;--De>=0&&Ae[De]==="\\";)pe=!pe;return pe?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function v(ge,_,ie){var G=ge.length;if(G===0)return"";for(var te=0;te<G;){var fe=ge.charAt(G-te-1);if(fe===_&&!ie)te++;else if(fe!==_&&ie)te++;else break}return ge.slice(0,G-te)}function b(ge,_){if(ge.indexOf(_[1])===-1)return-1;for(var ie=ge.length,G=0,te=0;te<ie;te++)if(ge[te]==="\\")te++;else if(ge[te]===_[0])G++;else if(ge[te]===_[1]&&(G--,G<0))return te;return-1}function E(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(ge,_){if(_<1)return"";for(var ie="";_>1;)_&1&&(ie+=ge),_>>=1,ge+=ge;return ie+ge}function z(ge,_,ie,G){var te=_.href,fe=_.title?S(_.title):null,ve=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){G.state.inLink=!0;var Ae={type:"link",raw:ie,href:te,title:fe,text:ve,tokens:G.inlineTokens(ve)};return G.state.inLink=!1,Ae}return{type:"image",raw:ie,href:te,title:fe,text:S(ve)}}function O(ge,_){var ie=ge.match(/^(\s+)(?:```)/);if(ie===null)return _;var G=ie[1];return _.split(`
`).map(function(te){var fe=te.match(/^\s+/);if(fe===null)return te;var ve=fe[0];return ve.length>=G.length?te.slice(G.length):te}).join(`
`)}var P=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},_.code=function(G){var te=this.rules.block.code.exec(G);if(te){var fe=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:v(fe,`
`)}}},_.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var fe=te[0],ve=O(fe,te[3]||"");return{type:"code",raw:fe,lang:te[2]?te[2].trim():te[2],text:ve}}},_.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var fe=te[2].trim();if(/#$/.test(fe)){var ve=v(fe,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(fe=ve.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:fe,tokens:this.lexer.inline(fe)}}},_.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},_.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var fe=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},_.list=function(G){var te=this.rules.block.list.exec(G);if(te){var fe,ve,Ae,pe,De,U,Q,ee,V,ae,ue,Le,je=te[1].trim(),Ke=je.length>1,Qe={type:"list",raw:"",ordered:Ke,start:Ke?+je.slice(0,-1):"",loose:!1,items:[]};je=Ke?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ke?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Le=!1,!(!(te=_e.exec(G))||this.rules.block.hr.test(G)));){if(fe=te[0],G=G.substring(fe.length),ee=te[2].split(`
`,1)[0],V=G.split(`
`,1)[0],this.options.pedantic?(pe=2,ue=ee.trimLeft()):(pe=te[2].search(/[^ ]/),pe=pe>4?1:pe,ue=ee.slice(pe),pe+=te[1].length),U=!1,!ee&&/^ *$/.test(V)&&(fe+=V+`
`,G=G.substring(V.length+1),Le=!0),!Le)for(var at=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ot=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ie=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),ze=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");G&&(ae=G.split(`
`,1)[0],ee=ae,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ie.test(ee)||ze.test(ee)||at.test(ee)||ot.test(G)));){if(ee.search(/[^ ]/)>=pe||!ee.trim())ue+=`
`+ee.slice(pe);else if(!U)ue+=`
`+ee;else break;!U&&!ee.trim()&&(U=!0),fe+=ae+`
`,G=G.substring(ae.length+1)}Qe.loose||(Q?Qe.loose=!0:/\n *\n *$/.test(fe)&&(Q=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(ue),ve&&(Ae=ve[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:fe,task:!!ve,checked:Ae,loose:!1,text:ue}),Qe.raw+=fe}Qe.items[Qe.items.length-1].raw=fe.trimRight(),Qe.items[Qe.items.length-1].text=ue.trimRight(),Qe.raw=Qe.raw.trimRight();var qe=Qe.items.length;for(De=0;De<qe;De++){this.lexer.state.top=!1,Qe.items[De].tokens=this.lexer.blockTokens(Qe.items[De].text,[]);var Re=Qe.items[De].tokens.filter(function(oe){return oe.type==="space"}),et=Re.every(function(oe){for(var le=oe.raw.split(""),Pe=0,He=I(le),Ze;!(Ze=He()).done;){var it=Ze.value;if(it===`
`&&(Pe+=1),Pe>1)return!0}return!1});!Qe.loose&&Re.length&&et&&(Qe.loose=!0,Qe.items[De].loose=!0)}return Qe}},_.html=function(G){var te=this.rules.block.html.exec(G);if(te){var fe={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]);fe.type="paragraph",fe.text=ve,fe.tokens=this.lexer.inline(ve)}return fe}},_.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var fe=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:te[0],href:te[2],title:te[3]}}},_.table=function(G){var te=this.rules.block.table.exec(G);if(te){var fe={type:"table",header:L(te[1]).map(function(Q){return{text:Q}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=te[0];var ve=fe.align.length,Ae,pe,De,U;for(Ae=0;Ae<ve;Ae++)/^ *-+: *$/.test(fe.align[Ae])?fe.align[Ae]="right":/^ *:-+: *$/.test(fe.align[Ae])?fe.align[Ae]="center":/^ *:-+ *$/.test(fe.align[Ae])?fe.align[Ae]="left":fe.align[Ae]=null;for(ve=fe.rows.length,Ae=0;Ae<ve;Ae++)fe.rows[Ae]=L(fe.rows[Ae],fe.header.length).map(function(Q){return{text:Q}});for(ve=fe.header.length,pe=0;pe<ve;pe++)fe.header[pe].tokens=this.lexer.inline(fe.header[pe].text);for(ve=fe.rows.length,pe=0;pe<ve;pe++)for(U=fe.rows[pe],De=0;De<U.length;De++)U[De].tokens=this.lexer.inline(U[De].text);return fe}}},_.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},_.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var fe=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:fe,tokens:this.lexer.inline(fe)}}},_.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},_.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:S(te[1])}},_.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]}},_.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var fe=te[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var ve=v(fe.slice(0,-1),"\\");if((fe.length-ve.length)%2===0)return}else{var Ae=b(te[2],"()");if(Ae>-1){var pe=te[0].indexOf("!")===0?5:4,De=pe+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,De).trim(),te[3]=""}}var U=te[2],Q="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(U);ee&&(U=ee[1],Q=ee[3])}else Q=te[3]?te[3].slice(1,-1):"";return U=U.trim(),/^</.test(U)&&(this.options.pedantic&&!/>$/.test(fe)?U=U.slice(1):U=U.slice(1,-1)),z(te,{href:U&&U.replace(this.rules.inline._escapes,"$1"),title:Q&&Q.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},_.reflink=function(G,te){var fe;if((fe=this.rules.inline.reflink.exec(G))||(fe=this.rules.inline.nolink.exec(G))){var ve=(fe[2]||fe[1]).replace(/\s+/g," ");if(ve=te[ve.toLowerCase()],!ve||!ve.href){var Ae=fe[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return z(fe,ve,fe[0],this.lexer)}},_.emStrong=function(G,te,fe){fe===void 0&&(fe="");var ve=this.rules.inline.emStrong.lDelim.exec(G);if(ve&&!(ve[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=ve[1]||ve[2]||"";if(!Ae||Ae&&(fe===""||this.rules.inline.punctuation.exec(fe))){var pe=ve[0].length-1,De,U,Q=pe,ee=0,V=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*G.length+pe);(ve=V.exec(te))!=null;)if(De=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!De){if(U=De.length,ve[3]||ve[4]){Q+=U;continue}else if((ve[5]||ve[6])&&pe%3&&!((pe+U)%3)){ee+=U;continue}if(Q-=U,!(Q>0)){if(U=Math.min(U,U+Q+ee),Math.min(pe,U)%2){var ae=G.slice(1,pe+ve.index+U);return{type:"em",raw:G.slice(0,pe+ve.index+U+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var ue=G.slice(2,pe+ve.index+U-1);return{type:"strong",raw:G.slice(0,pe+ve.index+U+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},_.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var fe=te[2].replace(/\n/g," "),ve=/[^ ]/.test(fe),Ae=/^ /.test(fe)&&/ $/.test(fe);return ve&&Ae&&(fe=fe.substring(1,fe.length-1)),fe=S(fe,!0),{type:"codespan",raw:te[0],text:fe}}},_.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},_.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},_.autolink=function(G,te){var fe=this.rules.inline.autolink.exec(G);if(fe){var ve,Ae;return fe[2]==="@"?(ve=S(this.options.mangle?te(fe[1]):fe[1]),Ae="mailto:"+ve):(ve=S(fe[1]),Ae=ve),{type:"link",raw:fe[0],text:ve,href:Ae,tokens:[{type:"text",raw:ve,text:ve}]}}},_.url=function(G,te){var fe;if(fe=this.rules.inline.url.exec(G)){var ve,Ae;if(fe[2]==="@")ve=S(this.options.mangle?te(fe[0]):fe[0]),Ae="mailto:"+ve;else{var pe;do pe=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(pe!==fe[0]);ve=S(fe[0]),fe[1]==="www."?Ae="http://"+ve:Ae=ve}return{type:"link",raw:fe[0],text:ve,href:Ae,tokens:[{type:"text",raw:ve,text:ve}]}}},_.inlineText=function(G,te){var fe=this.rules.inline.text.exec(G);if(fe){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]:ve=S(this.options.smartypants?te(fe[0]):fe[0]),{type:"text",raw:fe[0],text:ve}}},ge}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=i(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=i(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=i(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=i(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=i(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=k({},j),j.gfm=k({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=i(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=i(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=k({},j.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(j._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",j._label).getRegex(),N.nolink=i(N.nolink).replace("ref",j._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=k({},N),N.pedantic=k({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=k({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=k({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(ge){var _="",ie,G,te=ge.length;for(ie=0;ie<te;ie++)G=ge.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var x=function(){function ge(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||me.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:j.normal,inline:N.normal};this.options.pedantic?(G.block=j.pedantic,G.inline=N.pedantic):this.options.gfm&&(G.block=j.gfm,this.options.breaks?G.inline=N.breaks:G.inline=N.gfm),this.tokenizer.rules=G}ge.lex=function(G,te){var fe=new ge(te);return fe.lex(G)},ge.lexInline=function(G,te){var fe=new ge(te);return fe.inlineTokens(G)};var _=ge.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},_.blockTokens=function(G,te){var fe=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Q,ee,V){return ee+"    ".repeat(V.length)});for(var ve,Ae,pe,De;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Q){return(ve=Q.call({lexer:fe},G,te))?(G=G.substring(ve.raw.length),te.push(ve),!0):!1}))){if(ve=this.tokenizer.space(G)){G=G.substring(ve.raw.length),ve.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(ve);continue}if(ve=this.tokenizer.code(G)){G=G.substring(ve.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(ve);continue}if(ve=this.tokenizer.fences(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.heading(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.hr(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.blockquote(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.list(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.html(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.def(G)){G=G.substring(ve.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.lheading(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(pe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Q=1/0,ee=G.slice(1),V=void 0;fe.options.extensions.startBlock.forEach(function(ae){V=ae.call({lexer:this},ee),typeof V=="number"&&V>=0&&(Q=Math.min(Q,V))}),Q<1/0&&Q>=0&&(pe=G.substring(0,Q+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(pe))){Ae=te[te.length-1],De&&Ae.type==="paragraph"?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(ve),De=pe.length!==G.length,G=G.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(G)){G=G.substring(ve.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+ve.raw,Ae.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(ve);continue}if(G){var U="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(U);break}else throw new Error(U)}}return this.state.top=!0,te},_.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},_.inlineTokens=function(G,te){var fe=this;te===void 0&&(te=[]);var ve,Ae,pe,De=G,U,Q,ee;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(U=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)V.includes(U[0].slice(U[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,U.index)+"["+A("a",U[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(U=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,U.index)+"["+A("a",U[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(U=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,U.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Q||(ee=""),Q=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ve=ue.call({lexer:fe},G,te))?(G=G.substring(ve.raw.length),te.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.tag(G)){G=G.substring(ve.raw.length),Ae=te[te.length-1],Ae&&ve.type==="text"&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):te.push(ve);continue}if(ve=this.tokenizer.link(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ve.raw.length),Ae=te[te.length-1],Ae&&ve.type==="text"&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):te.push(ve);continue}if(ve=this.tokenizer.emStrong(G,De,ee)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.codespan(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.br(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.del(G)){G=G.substring(ve.raw.length),te.push(ve);continue}if(ve=this.tokenizer.autolink(G,W)){G=G.substring(ve.raw.length),te.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(G,W))){G=G.substring(ve.raw.length),te.push(ve);continue}if(pe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Le=G.slice(1),je=void 0;fe.options.extensions.startInline.forEach(function(Ke){je=Ke.call({lexer:this},Le),typeof je=="number"&&je>=0&&(ue=Math.min(ue,je))}),ue<1/0&&ue>=0&&(pe=G.substring(0,ue+1))}(),ve=this.tokenizer.inlineText(pe,F)){G=G.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(ee=ve.raw.slice(-1)),Q=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=ve.raw,Ae.text+=ve.text):te.push(ve);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return te},D(ge,null,[{key:"rules",get:function(){return{block:j,inline:N}}}]),ge}(),ce=function(){function ge(ie){this.options=ie||me.defaults}var _=ge.prototype;return _.code=function(G,te,fe){var ve=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(G,ve);Ae!=null&&Ae!==G&&(fe=!0,G=Ae)}return G=G.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+S(ve,!0)+'">'+(fe?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(fe?G:S(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,te,fe,ve){if(this.options.headerIds){var Ae=this.options.headerPrefix+ve.slug(fe);return"<h"+te+' id="'+Ae+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,te,fe){var ve=te?"ol":"ul",Ae=te&&fe!==1?' start="'+fe+'"':"";return"<"+ve+Ae+`>
`+G+"</"+ve+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,te){var fe=te.header?"th":"td",ve=te.align?"<"+fe+' align="'+te.align+'">':"<"+fe+">";return ve+G+("</"+fe+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,te,fe){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<a href="'+S(G)+'"';return te&&(ve+=' title="'+te+'"'),ve+=">"+fe+"</a>",ve},_.image=function(G,te,fe){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return fe;var ve='<img src="'+G+'" alt="'+fe+'"';return te&&(ve+=' title="'+te+'"'),ve+=this.options.xhtml?"/>":">",ve},_.text=function(G){return G},ge}(),J=function(){function ge(){}var _=ge.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,te,fe){return""+fe},_.image=function(G,te,fe){return""+fe},_.br=function(){return""},ge}(),Y=function(){function ge(){this.seen={}}var _=ge.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,te){var fe=G,ve=0;if(this.seen.hasOwnProperty(fe)){ve=this.seen[G];do ve++,fe=G+"-"+ve;while(this.seen.hasOwnProperty(fe))}return te||(this.seen[G]=ve,this.seen[fe]=0),fe},_.slug=function(G,te){te===void 0&&(te={});var fe=this.serialize(G);return this.getNextSafeSlug(fe,te.dryrun)},ge}(),X=function(){function ge(ie){this.options=ie||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new Y}ge.parse=function(G,te){var fe=new ge(te);return fe.parse(G)},ge.parseInline=function(G,te){var fe=new ge(te);return fe.parseInline(G)};var _=ge.prototype;return _.parse=function(G,te){te===void 0&&(te=!0);var fe="",ve,Ae,pe,De,U,Q,ee,V,ae,ue,Le,je,Ke,Qe,_e,at,ot,Ie,ze,qe=G.length;for(ve=0;ve<qe;ve++){if(ue=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(ze=this.options.extensions.renderers[ue.type].call({parser:this},ue),ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){fe+=ze||"";continue}switch(ue.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,f(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(V="",ee="",De=ue.header.length,Ae=0;Ae<De;Ae++)ee+=this.renderer.tablecell(this.parseInline(ue.header[Ae].tokens),{header:!0,align:ue.align[Ae]});for(V+=this.renderer.tablerow(ee),ae="",De=ue.rows.length,Ae=0;Ae<De;Ae++){for(Q=ue.rows[Ae],ee="",U=Q.length,pe=0;pe<U;pe++)ee+=this.renderer.tablecell(this.parseInline(Q[pe].tokens),{header:!1,align:ue.align[pe]});ae+=this.renderer.tablerow(ee)}fe+=this.renderer.table(V,ae);continue}case"blockquote":{ae=this.parse(ue.tokens),fe+=this.renderer.blockquote(ae);continue}case"list":{for(Le=ue.ordered,je=ue.start,Ke=ue.loose,De=ue.items.length,ae="",Ae=0;Ae<De;Ae++)_e=ue.items[Ae],at=_e.checked,ot=_e.task,Qe="",_e.task&&(Ie=this.renderer.checkbox(at),Ke?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=Ie+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=Ie+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:Ie}):Qe+=Ie),Qe+=this.parse(_e.tokens,Ke),ae+=this.renderer.listitem(Qe,ot,at);fe+=this.renderer.list(ae,Le,je);continue}case"html":{fe+=this.renderer.html(ue.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(ae=ue.tokens?this.parseInline(ue.tokens):ue.text;ve+1<qe&&G[ve+1].type==="text";)ue=G[++ve],ae+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);fe+=te?this.renderer.paragraph(ae):ae;continue}default:{var Re='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return fe},_.parseInline=function(G,te){te=te||this.renderer;var fe="",ve,Ae,pe,De=G.length;for(ve=0;ve<De;ve++){if(Ae=G[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(pe=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){fe+=pe||"";continue}switch(Ae.type){case"escape":{fe+=te.text(Ae.text);break}case"html":{fe+=te.html(Ae.text);break}case"link":{fe+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{fe+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{fe+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{fe+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{fe+=te.codespan(Ae.text);break}case"br":{fe+=te.br();break}case"del":{fe+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{fe+=te.text(Ae.text);break}default:{var U='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(U);return}else throw new Error(U)}}}return fe},ge}();function se(ge,_,ie){if(typeof ge>"u"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof _=="function"&&(ie=_,_=null),_=k({},se.defaults,_||{}),E(_),ie){var G=_.highlight,te;try{te=x.lex(ge,_)}catch(De){return ie(De)}var fe=function(U){var Q;if(!U)try{_.walkTokens&&se.walkTokens(te,_.walkTokens),Q=X.parse(te,_)}catch(ee){U=ee}return _.highlight=G,U?ie(U):ie(null,Q)};if(!G||G.length<3||(delete _.highlight,!te.length))return fe();var ve=0;se.walkTokens(te,function(De){De.type==="code"&&(ve++,setTimeout(function(){G(De.text,De.lang,function(U,Q){if(U)return fe(U);Q!=null&&Q!==De.text&&(De.text=Q,De.escaped=!0),ve--,ve===0&&fe()})},0))}),ve===0&&fe();return}function Ae(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(De.message+"",!0)+"</pre>";throw De}try{var pe=x.lex(ge,_);if(_.walkTokens){if(_.async)return Promise.all(se.walkTokens(pe,_.walkTokens)).then(function(){return X.parse(pe,_)}).catch(Ae);se.walkTokens(pe,_.walkTokens)}return X.parse(pe,_)}catch(De){Ae(De)}}se.options=se.setOptions=function(ge){return k(se.defaults,ge),p(se.defaults),se},se.getDefaults=R,se.defaults=me.defaults,se.use=function(){for(var ge=arguments.length,_=new Array(ge),ie=0;ie<ge;ie++)_[ie]=arguments[ie];var G=k.apply(void 0,[{}].concat(_)),te=se.defaults.extensions||{renderers:{},childTokens:{}},fe;_.forEach(function(ve){if(ve.extensions&&(fe=!0,ve.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var De=te.renderers?te.renderers[pe.name]:null;De?te.renderers[pe.name]=function(){for(var U=arguments.length,Q=new Array(U),ee=0;ee<U;ee++)Q[ee]=arguments[ee];var V=pe.renderer.apply(this,Q);return V===!1&&(V=De.apply(this,Q)),V}:te.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[pe.level]?te[pe.level].unshift(pe.tokenizer):te[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?te.startBlock?te.startBlock.push(pe.start):te.startBlock=[pe.start]:pe.level==="inline"&&(te.startInline?te.startInline.push(pe.start):te.startInline=[pe.start]))}pe.childTokens&&(te.childTokens[pe.name]=pe.childTokens)})),ve.renderer&&function(){var pe=se.defaults.renderer||new ce,De=function(ee){var V=pe[ee];pe[ee]=function(){for(var ae=arguments.length,ue=new Array(ae),Le=0;Le<ae;Le++)ue[Le]=arguments[Le];var je=ve.renderer[ee].apply(pe,ue);return je===!1&&(je=V.apply(pe,ue)),je}};for(var U in ve.renderer)De(U);G.renderer=pe}(),ve.tokenizer&&function(){var pe=se.defaults.tokenizer||new P,De=function(ee){var V=pe[ee];pe[ee]=function(){for(var ae=arguments.length,ue=new Array(ae),Le=0;Le<ae;Le++)ue[Le]=arguments[Le];var je=ve.tokenizer[ee].apply(pe,ue);return je===!1&&(je=V.apply(pe,ue)),je}};for(var U in ve.tokenizer)De(U);G.tokenizer=pe}(),ve.walkTokens){var Ae=se.defaults.walkTokens;G.walkTokens=function(pe){var De=[];return De.push(ve.walkTokens.call(this,pe)),Ae&&(De=De.concat(Ae.call(this,pe))),De}}fe&&(G.extensions=te),se.setOptions(G)})},se.walkTokens=function(ge,_){for(var ie=[],G=function(){var Ae=fe.value;switch(ie=ie.concat(_.call(se,Ae)),Ae.type){case"table":{for(var pe=I(Ae.header),De;!(De=pe()).done;){var U=De.value;ie=ie.concat(se.walkTokens(U.tokens,_))}for(var Q=I(Ae.rows),ee;!(ee=Q()).done;)for(var V=ee.value,ae=I(V),ue;!(ue=ae()).done;){var Le=ue.value;ie=ie.concat(se.walkTokens(Le.tokens,_))}break}case"list":{ie=ie.concat(se.walkTokens(Ae.items,_));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[Ae.type]?se.defaults.extensions.childTokens[Ae.type].forEach(function(je){ie=ie.concat(se.walkTokens(Ae[je],_))}):Ae.tokens&&(ie=ie.concat(se.walkTokens(Ae.tokens,_)))}},te=I(ge),fe;!(fe=te()).done;)G();return ie},se.parseInline=function(ge,_){if(typeof ge>"u"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");_=k({},se.defaults,_||{}),E(_);try{var ie=x.lexInline(ge,_);return _.walkTokens&&se.walkTokens(ie,_.walkTokens),X.parseInline(ie,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},se.Parser=X,se.parser=X.parse,se.Renderer=ce,se.TextRenderer=J,se.Lexer=x,se.lexer=x.lex,se.Tokenizer=P,se.Slugger=Y,se.parse=se;var Z=se.options,we=se.setOptions,de=se.use,K=se.walkTokens,B=se.parseInline,ne=se,ye=X.parse,he=x.lex;me.Lexer=x,me.Parser=X,me.Renderer=ce,me.Slugger=Y,me.TextRenderer=J,me.Tokenizer=P,me.getDefaults=R,me.lexer=he,me.marked=se,me.options=Z,me.parse=ne,me.parseInline=B,me.parser=ye,me.setOptions=we,me.use=de,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function D(l){const f=I(l);if(f&&f.length>0)return new Uint32Array(f)}e.$Nj=D;let T=0;const g=new Uint32Array(10);function I(l){if(T=0,R(l,C,4352),T>0||(R(l,m,4449),T>0)||(R(l,w,4520),T>0)||(R(l,S,12593),T))return g.subarray(0,T);if(l>=44032&&l<=55203){const f=l-44032,s=f%588,i=Math.floor(f/588),n=Math.floor(s/28),o=s%28-1;if(i<C.length?R(i,C,0):4352+i-12593<S.length&&R(4352+i,S,12593),n<m.length?R(n,m,0):4449+n-12593<S.length&&R(4449+n-12593,S,12593),o>=0&&(o<w.length?R(o,w,0):4520+o-12593<S.length&&R(4520+o-12593,S,12593)),T>0)return g.subarray(0,T)}}function R(l,f,s){l>=s&&l<s+f.length&&p(f[l-s])}function p(l){l!==0&&(g[T++]=l&255,l>>8&&(g[T++]=l>>8&255),l>>16&&(g[T++]=l>>16&255))}var $;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(y||(y={}));var M;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(M||(M={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=void 0;const T=new D.$Dc(1e4);function g(y){return $(y,"NFC",T)}e.$Bl=g;const I=new D.$Dc(1e4);function R(y){return $(y,"NFD",I)}e.$Cl=R;const p=/[^\u0000-\u0080]/;function $(y,M,C){if(!y)return y;const m=C.get(y);if(m)return m;let w;return p.test(y)?w=y.normalize(M):w=y,C.set(y,w),w}e.$Dl=function(){const y=/[\u0300-\u036f]/g;return function(M){return R(M).replace(y,"")}}()}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.rot=e.$2l=void 0;function D(p,$,y){return Math.min(Math.max(p,$),y)}e.$2l=D;function T(p,$){return($+p%$)%$}e.rot=T;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$4l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$5l=I;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$6l=R}),function(){function me(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function R($){I.push($,Date.now())}function p(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:R,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(g+R.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=D(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var T in D)(typeof exports=="object"?exports:me)[T]=D[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function D(T){if(e[T])return e[T].exports;var g=e[T]={i:T,l:!1,exports:{}};return me[T].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=me,D.c=e,D.d=function(T,g,I){D.o(T,g)||Object.defineProperty(T,g,{enumerable:!0,get:I})},D.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},D.t=function(T,g){if(1&g&&(T=D(T)),8&g||4&g&&typeof T=="object"&&T&&T.__esModule)return T;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:T}),2&g&&typeof T!="string")for(var R in T)D.d(I,R,function(p){return T[p]}.bind(null,R));return I},D.n=function(T){var g=T&&T.__esModule?function(){return T.default}:function(){return T};return D.d(g,"a",g),g},D.o=function(T,g){return Object.prototype.hasOwnProperty.call(T,g)},D.p="",D(D.s=0)}([function(me,e,D){(function(T){var g;e=me.exports=de,g=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],$=e.src=[],y=0,M=y++;$[M]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=y++;$[w]="("+$[M]+")\\.("+$[M]+")\\.("+$[M]+")";var S=y++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var l=y++;$[l]="(?:"+$[M]+"|"+$[m]+")";var f=y++;$[f]="(?:"+$[C]+"|"+$[m]+")";var s=y++;$[s]="(?:-("+$[l]+"(?:\\."+$[l]+")*))";var i=y++;$[i]="(?:-?("+$[f]+"(?:\\."+$[f]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var o=y++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var a=y++,t="v?"+$[w]+$[s]+"?"+$[o]+"?";$[a]="^"+t+"$";var r="[v=\\s]*"+$[S]+$[i]+"?"+$[o]+"?",d=y++;$[d]="^"+r+"$";var u=y++;$[u]="((?:<|>)?=?)";var c=y++;$[c]=$[C]+"|x|X|\\*";var h=y++;$[h]=$[M]+"|x|X|\\*";var k=y++;$[k]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[s]+")?"+$[o]+"?)?)?";var L=y++;$[L]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[i]+")?"+$[o]+"?)?)?";var v=y++;$[v]="^"+$[u]+"\\s*"+$[k]+"$";var b=y++;$[b]="^"+$[u]+"\\s*"+$[L]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=y++;$[A]="(?:~>?)";var z=y++;$[z]="(\\s*)"+$[A]+"\\s+",p[z]=new RegExp($[z],"g");var O=y++;$[O]="^"+$[A]+$[k]+"$";var P=y++;$[P]="^"+$[A]+$[L]+"$";var j=y++;$[j]="(?:\\^)";var N=y++;$[N]="(\\s*)"+$[j]+"\\s+",p[N]=new RegExp($[N],"g");var F=y++;$[F]="^"+$[j]+$[k]+"$";var W=y++;$[W]="^"+$[j]+$[L]+"$";var x=y++;$[x]="^"+$[u]+"\\s*("+r+")$|^$";var ce=y++;$[ce]="^"+$[u]+"\\s*("+t+")$|^$";var J=y++;$[J]="(\\s*)"+$[u]+"\\s*("+r+"|"+$[k]+")",p[J]=new RegExp($[J],"g");var Y=y++;$[Y]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var X=y++;$[X]="^\\s*("+$[L]+")\\s+-\\s+("+$[L]+")\\s*$";var se=y++;$[se]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)g(Z,$[Z]),p[Z]||(p[Z]=new RegExp($[Z]));function we(V,ae){if(V instanceof de)return V;if(typeof V!="string"||V.length>I||!(ae?p[d]:p[a]).test(V))return null;try{return new de(V,ae)}catch{return null}}function de(V,ae){if(V instanceof de){if(V.loose===ae)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof de))return new de(V,ae);g("SemVer",V,ae),this.loose=ae;var ue=V.trim().match(ae?p[d]:p[a]);if(!ue)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<R)return je}return Le}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=we,e.valid=function(V,ae){var ue=we(V,ae);return ue?ue.version:null},e.clean=function(V,ae){var ue=we(V.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(V){return g("SemVer.compare",this.version,this.loose,V),V instanceof de||(V=new de(V,this.loose)),this.compareMain(V)||this.comparePre(V)},de.prototype.compareMain=function(V){return V instanceof de||(V=new de(V,this.loose)),B(this.major,V.major)||B(this.minor,V.minor)||B(this.patch,V.patch)},de.prototype.comparePre=function(V){if(V instanceof de||(V=new de(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],Le=V.prerelease[ae];if(g("prerelease compare",ae,ue,Le),ue===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ue===void 0)return-1;if(ue!==Le)return B(ue,Le)}while(++ae)},de.prototype.inc=function(V,ae){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,ae,ue,Le){typeof ue=="string"&&(Le=ue,ue=void 0);try{return new de(V,ue).inc(ae,Le).version}catch{return null}},e.diff=function(V,ae){if(ge(V,ae))return null;var ue=we(V),Le=we(ae);if(ue.prerelease.length||Le.prerelease.length){for(var je in ue)if((je==="major"||je==="minor"||je==="patch")&&ue[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in ue)if((je==="major"||je==="minor"||je==="patch")&&ue[je]!==Le[je])return je},e.compareIdentifiers=B;var K=/^[0-9]+$/;function B(V,ae){var ue=K.test(V),Le=K.test(ae);return ue&&Le&&(V=+V,ae=+ae),ue&&!Le?-1:Le&&!ue?1:V<ae?-1:V>ae?1:0}function ne(V,ae,ue){return new de(V,ue).compare(new de(ae,ue))}function ye(V,ae,ue){return ne(V,ae,ue)>0}function he(V,ae,ue){return ne(V,ae,ue)<0}function ge(V,ae,ue){return ne(V,ae,ue)===0}function _(V,ae,ue){return ne(V,ae,ue)!==0}function ie(V,ae,ue){return ne(V,ae,ue)>=0}function G(V,ae,ue){return ne(V,ae,ue)<=0}function te(V,ae,ue,Le){var je;switch(ae){case"===":typeof V=="object"&&(V=V.version),typeof ue=="object"&&(ue=ue.version),je=V===ue;break;case"!==":typeof V=="object"&&(V=V.version),typeof ue=="object"&&(ue=ue.version),je=V!==ue;break;case"":case"=":case"==":je=ge(V,ue,Le);break;case"!=":je=_(V,ue,Le);break;case">":je=ye(V,ue,Le);break;case">=":je=ie(V,ue,Le);break;case"<":je=he(V,ue,Le);break;case"<=":je=G(V,ue,Le);break;default:throw new TypeError("Invalid operator: "+ae)}return je}function fe(V,ae){if(V instanceof fe){if(V.loose===ae)return V;V=V.value}if(!(this instanceof fe))return new fe(V,ae);g("comparator",V,ae),this.loose=ae,this.parse(V),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(V,ae){return B(ae,V)},e.major=function(V,ae){return new de(V,ae).major},e.minor=function(V,ae){return new de(V,ae).minor},e.patch=function(V,ae){return new de(V,ae).patch},e.compare=ne,e.compareLoose=function(V,ae){return ne(V,ae,!0)},e.rcompare=function(V,ae,ue){return ne(ae,V,ue)},e.sort=function(V,ae){return V.sort(function(ue,Le){return e.compare(ue,Le,ae)})},e.rsort=function(V,ae){return V.sort(function(ue,Le){return e.rcompare(ue,Le,ae)})},e.gt=ye,e.lt=he,e.eq=ge,e.neq=_,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=fe;var ve={};function Ae(V,ae){if(V instanceof Ae)return V.loose===ae?V:new Ae(V.raw,ae);if(V instanceof fe)return new Ae(V.value,ae);if(!(this instanceof Ae))return new Ae(V,ae);if(this.loose=ae,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function pe(V){return!V||V.toLowerCase()==="x"||V==="*"}function De(V,ae,ue,Le,je,Ke,Qe,_e,at,ot,Ie,ze,qe){return((ae=pe(ue)?"":pe(Le)?">="+ue+".0.0":pe(je)?">="+ue+"."+Le+".0":">="+ae)+" "+(_e=pe(at)?"":pe(ot)?"<"+(+at+1)+".0.0":pe(Ie)?"<"+at+"."+(+ot+1)+".0":ze?"<="+at+"."+ot+"."+Ie+"-"+ze:"<="+_e)).trim()}function U(V,ae){for(var ue=0;ue<V.length;ue++)if(!V[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<V.length;ue++)if(g(V[ue].semver),V[ue].semver!==ve&&V[ue].semver.prerelease.length>0){var Le=V[ue].semver;if(Le.major===ae.major&&Le.minor===ae.minor&&Le.patch===ae.patch)return!0}return!1}return!0}function Q(V,ae,ue){try{ae=new Ae(ae,ue)}catch{return!1}return ae.test(V)}function ee(V,ae,ue,Le){var je,Ke,Qe,_e,at;switch(V=new de(V,Le),ae=new Ae(ae,Le),ue){case">":je=ye,Ke=G,Qe=he,_e=">",at=">=";break;case"<":je=he,Ke=ie,Qe=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Q(V,ae,Le))return!1;for(var ot=0;ot<ae.set.length;++ot){var Ie=ae.set[ot],ze=null,qe=null;if(Ie.forEach(function(Re){Re.semver===ve&&(Re=new fe(">=0.0.0")),ze=ze||Re,qe=qe||Re,je(Re.semver,ze.semver,Le)?ze=Re:Qe(Re.semver,qe.semver,Le)&&(qe=Re)}),ze.operator===_e||ze.operator===at||(!qe.operator||qe.operator===_e)&&Ke(V,qe.semver)||qe.operator===at&&Qe(V,qe.semver))return!1}return!0}fe.prototype.parse=function(V){var ae=this.loose?p[x]:p[ce],ue=V.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+V);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new de(ue[2],this.loose):this.semver=ve},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(V){return g("Comparator.test",V,this.loose),this.semver===ve||(typeof V=="string"&&(V=new de(V,this.loose)),te(V,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(V,ae){if(!(V instanceof fe))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ae(V.value,ae),Q(this.value,ue,ae);if(V.operator==="")return ue=new Ae(this.value,ae),Q(V.semver,ue,ae);var Le=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ke=this.semver.version===V.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),_e=te(this.semver,"<",V.semver,ae)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),at=te(this.semver,">",V.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return Le||je||Ke&&Qe||_e||at},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var ae=this.loose;V=V.trim(),g("range",V,ae);var ue=ae?p[X]:p[Y];V=V.replace(ue,De),g("hyphen replace",V),V=V.replace(p[J],"$1$2$3"),g("comparator trim",V,p[J]),V=(V=(V=V.replace(p[z],"$1~")).replace(p[N],"$1^")).split(/\s+/).join(" ");var Le=ae?p[x]:p[ce],je=V.split(" ").map(function(Ke){return function(Qe,_e){return g("comp",Qe),Qe=function(at,ot){return at.trim().split(/\s+/).map(function(Ie){return function(ze,qe){g("caret",ze,qe);var Re=qe?p[W]:p[F];return ze.replace(Re,function(et,oe,le,Pe,He){var Ze;return g("caret",ze,et,oe,le,Pe,He),pe(oe)?Ze="":pe(le)?Ze=">="+oe+".0.0 <"+(+oe+1)+".0.0":pe(Pe)?Ze=oe==="0"?">="+oe+"."+le+".0 <"+oe+"."+(+le+1)+".0":">="+oe+"."+le+".0 <"+(+oe+1)+".0.0":He?(g("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ze=oe==="0"?le==="0"?">="+oe+"."+le+"."+Pe+He+" <"+oe+"."+le+"."+(+Pe+1):">="+oe+"."+le+"."+Pe+He+" <"+oe+"."+(+le+1)+".0":">="+oe+"."+le+"."+Pe+He+" <"+(+oe+1)+".0.0"):(g("no pr"),Ze=oe==="0"?le==="0"?">="+oe+"."+le+"."+Pe+" <"+oe+"."+le+"."+(+Pe+1):">="+oe+"."+le+"."+Pe+" <"+oe+"."+(+le+1)+".0":">="+oe+"."+le+"."+Pe+" <"+(+oe+1)+".0.0"),g("caret return",Ze),Ze})}(Ie,ot)}).join(" ")}(Qe,_e),g("caret",Qe),Qe=function(at,ot){return at.trim().split(/\s+/).map(function(Ie){return function(ze,qe){var Re=qe?p[P]:p[O];return ze.replace(Re,function(et,oe,le,Pe,He){var Ze;return g("tilde",ze,et,oe,le,Pe,He),pe(oe)?Ze="":pe(le)?Ze=">="+oe+".0.0 <"+(+oe+1)+".0.0":pe(Pe)?Ze=">="+oe+"."+le+".0 <"+oe+"."+(+le+1)+".0":He?(g("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Ze=">="+oe+"."+le+"."+Pe+He+" <"+oe+"."+(+le+1)+".0"):Ze=">="+oe+"."+le+"."+Pe+" <"+oe+"."+(+le+1)+".0",g("tilde return",Ze),Ze})}(Ie,ot)}).join(" ")}(Qe,_e),g("tildes",Qe),Qe=function(at,ot){return g("replaceXRanges",at,ot),at.split(/\s+/).map(function(Ie){return function(ze,qe){ze=ze.trim();var Re=qe?p[b]:p[v];return ze.replace(Re,function(et,oe,le,Pe,He,Ze){g("xRange",ze,et,oe,le,Pe,He,Ze);var it=pe(le),st=it||pe(Pe),Oe=st||pe(He);return oe==="="&&Oe&&(oe=""),it?et=oe===">"||oe==="<"?"<0.0.0":"*":oe&&Oe?(st&&(Pe=0),Oe&&(He=0),oe===">"?(oe=">=",st?(le=+le+1,Pe=0,He=0):Oe&&(Pe=+Pe+1,He=0)):oe==="<="&&(oe="<",st?le=+le+1:Pe=+Pe+1),et=oe+le+"."+Pe+"."+He):st?et=">="+le+".0.0 <"+(+le+1)+".0.0":Oe&&(et=">="+le+"."+Pe+".0 <"+le+"."+(+Pe+1)+".0"),g("xRange return",et),et})}(Ie,ot)}).join(" ")}(Qe,_e),g("xrange",Qe),Qe=function(at,ot){return g("replaceStars",at,ot),at.trim().replace(p[se],"")}(Qe,_e),g("stars",Qe),Qe}(Ke,ae)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ke){return!!Ke.match(Le)})),je=je.map(function(Ke){return new fe(Ke,ae)})},Ae.prototype.intersects=function(V,ae){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Le){return V.set.some(function(je){return je.every(function(Ke){return Le.intersects(Ke,ae)})})})})},e.toComparators=function(V,ae){return new Ae(V,ae).set.map(function(ue){return ue.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new de(V,this.loose));for(var ae=0;ae<this.set.length;ae++)if(U(this.set[ae],V))return!0;return!1},e.satisfies=Q,e.maxSatisfying=function(V,ae,ue){var Le=null,je=null;try{var Ke=new Ae(ae,ue)}catch{return null}return V.forEach(function(Qe){Ke.test(Qe)&&(Le&&je.compare(Qe)!==-1||(je=new de(Le=Qe,ue)))}),Le},e.minSatisfying=function(V,ae,ue){var Le=null,je=null;try{var Ke=new Ae(ae,ue)}catch{return null}return V.forEach(function(Qe){Ke.test(Qe)&&(Le&&je.compare(Qe)!==1||(je=new de(Le=Qe,ue)))}),Le},e.validRange=function(V,ae){try{return new Ae(V,ae).range||"*"}catch{return null}},e.ltr=function(V,ae,ue){return ee(V,ae,"<",ue)},e.gtr=function(V,ae,ue){return ee(V,ae,">",ue)},e.outside=ee,e.prerelease=function(V,ae){var ue=we(V,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(V,ae,ue){return V=new Ae(V,ue),ae=new Ae(ae,ue),V.intersects(ae)},e.coerce=function(V){if(V instanceof de)return V;if(typeof V!="string")return null;var ae=V.match(p[E]);return ae==null?null:we((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(me,e){var D,T,g=me.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function p(f){if(D===setTimeout)return setTimeout(f,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(f,0);try{return D(f,0)}catch{try{return D.call(null,f,0)}catch{return D.call(this,f,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{T=typeof clearTimeout=="function"?clearTimeout:R}catch{T=R}})();var $,y=[],M=!1,C=-1;function m(){M&&$&&(M=!1,$.length?y=$.concat(y):C=-1,y.length&&w())}function w(){if(!M){var f=p(m);M=!0;for(var s=y.length;s;){for($=y,y=[];++C<s;)$&&$[C].run();C=-1,s=y.length}$=null,M=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===R||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(f)}}function S(f,s){this.fun=f,this.array=s}function l(){}g.nextTick=function(f){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new S(f,s)),y.length!==1||M||p(w)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=l,g.addListener=l,g.once=l,g.off=l,g.removeListener=l,g.removeAllListeners=l,g.emit=l,g.prependListener=l,g.prependOnceListener=l,g.listeners=function(f){return[]},g.binding=function(f){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(f){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(I){return new T(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Od=T}),define(ke[4],Se([1,0,8,74,3,75,38]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.Event=void 0;const p=!1,$=!1;var y;(function(v){v.None=()=>g.$Sc.None;function b(te){if($){const{onDidAddListener:fe}=te,ve=S.create();let Ae=0;te.onDidAddListener=()=>{++Ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ve.print()),fe?.()}}}function E(te,fe){return ce(te,()=>{},0,void 0,!0,void 0,fe)}v.defer=E;function A(te){return(fe,ve=null,Ae)=>{let pe=!1,De;return De=te(U=>{if(!pe)return De?De.dispose():pe=!0,fe.call(ve,U)},null,Ae),pe&&De.dispose(),De}}v.once=A;function z(te,fe,ve){return W((Ae,pe=null,De)=>te(U=>Ae.call(pe,fe(U)),null,De),ve)}v.map=z;function O(te,fe,ve){return W((Ae,pe=null,De)=>te(U=>{fe(U),Ae.call(pe,U)},null,De),ve)}v.forEach=O;function P(te,fe,ve){return W((Ae,pe=null,De)=>te(U=>fe(U)&&Ae.call(pe,U),null,De),ve)}v.filter=P;function j(te){return te}v.signal=j;function N(...te){return(fe,ve=null,Ae)=>{const pe=(0,g.$Pc)(...te.map(De=>De(U=>fe.call(ve,U))));return x(pe,Ae)}}v.any=N;function F(te,fe,ve,Ae){let pe=ve;return z(te,De=>(pe=fe(pe,De),pe),Ae)}v.reduce=F;function W(te,fe){let ve;const Ae={onWillAddFirstListener(){ve=te(pe.fire,pe)},onDidRemoveLastListener(){ve?.dispose()}};fe||b(Ae);const pe=new n(Ae);return fe?.add(pe),pe.event}function x(te,fe){return fe instanceof Array?fe.push(te):fe&&fe.add(te),te}function ce(te,fe,ve=100,Ae=!1,pe=!1,De,U){let Q,ee,V,ae=0,ue;const Le={leakWarningThreshold:De,onWillAddFirstListener(){Q=te(Ke=>{ae++,ee=fe(ee,Ke),Ae&&!V&&(je.fire(ee),ee=void 0),ue=()=>{const Qe=ee;ee=void 0,V=void 0,(!Ae||ae>1)&&je.fire(Qe),ae=0},typeof ve=="number"?(clearTimeout(V),V=setTimeout(ue,ve)):V===void 0&&(V=0,queueMicrotask(ue))})},onWillRemoveListener(){pe&&ae>0&&ue?.()},onDidRemoveLastListener(){ue=void 0,Q.dispose()}};U||b(Le);const je=new n(Le);return U?.add(je),je.event}v.debounce=ce;function J(te,fe=0,ve){return v.debounce(te,(Ae,pe)=>Ae?(Ae.push(pe),Ae):[pe],fe,void 0,!0,void 0,ve)}v.accumulate=J;function Y(te,fe=(Ae,pe)=>Ae===pe,ve){let Ae=!0,pe;return P(te,De=>{const U=Ae||!fe(De,pe);return Ae=!1,pe=De,U},ve)}v.latch=Y;function X(te,fe,ve){return[v.filter(te,fe,ve),v.filter(te,Ae=>!fe(Ae),ve)]}v.split=X;function se(te,fe=!1,ve=[],Ae){let pe=ve.slice(),De=te(ee=>{pe?pe.push(ee):Q.fire(ee)});Ae&&Ae.add(De);const U=()=>{pe?.forEach(ee=>Q.fire(ee)),pe=null},Q=new n({onWillAddFirstListener(){De||(De=te(ee=>Q.fire(ee)),Ae&&Ae.add(De))},onDidAddFirstListener(){pe&&(fe?setTimeout(U):U())},onDidRemoveLastListener(){De&&De.dispose(),De=null}});return Ae&&Ae.add(Q),Q.event}v.buffer=se;function Z(te,fe){return(Ae,pe,De)=>{const U=fe(new de);return te(function(Q){const ee=U.evaluate(Q);ee!==we&&Ae.call(pe,ee)},void 0,De)}}v.chain=Z;const we=Symbol("HaltChainable");class de{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(ve=>(fe(ve),ve)),this}filter(fe){return this.f.push(ve=>fe(ve)?ve:we),this}reduce(fe,ve){let Ae=ve;return this.f.push(pe=>(Ae=fe(Ae,pe),Ae)),this}latch(fe=(ve,Ae)=>ve===Ae){let ve=!0,Ae;return this.f.push(pe=>{const De=ve||!fe(pe,Ae);return ve=!1,Ae=pe,De?pe:we}),this}evaluate(fe){for(const ve of this.f)if(fe=ve(fe),fe===we)break;return fe}}function K(te,fe,ve=Ae=>Ae){const Ae=(...Q)=>U.fire(ve(...Q)),pe=()=>te.on(fe,Ae),De=()=>te.removeListener(fe,Ae),U=new n({onWillAddFirstListener:pe,onDidRemoveLastListener:De});return U.event}v.fromNodeEventEmitter=K;function B(te,fe,ve=Ae=>Ae){const Ae=(...Q)=>U.fire(ve(...Q)),pe=()=>te.addEventListener(fe,Ae),De=()=>te.removeEventListener(fe,Ae),U=new n({onWillAddFirstListener:pe,onDidRemoveLastListener:De});return U.event}v.fromDOMEventEmitter=B;function ne(te){return new Promise(fe=>A(te)(fe))}v.toPromise=ne;function ye(te){const fe=new n;return te.then(ve=>{fe.fire(ve)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}v.fromPromise=ye;function he(te,fe,ve){return fe(ve),te(Ae=>fe(Ae))}v.runAndSubscribe=he;function ge(te,fe){let ve=null;function Ae(De){ve?.dispose(),ve=new g.$Rc,fe(De,ve)}Ae(void 0);const pe=te(De=>Ae(De));return(0,g.$Qc)(()=>{pe.dispose(),ve?.dispose()})}v.runAndSubscribeWithStore=ge;class _{constructor(fe,ve){this._observable=fe,this.f=0,this.g=!1;const Ae={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};ve||b(Ae),this.emitter=new n(Ae),ve&&ve.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,ve){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(te,fe){return new _(te,fe).emitter.event}v.fromObservable=ie;function G(te){return(fe,ve,Ae)=>{let pe=0,De=!1;const U={beginUpdate(){pe++},endUpdate(){pe--,pe===0&&(te.reportChanges(),De&&(De=!1,fe.call(ve)))},handlePossibleChange(){},handleChange(){De=!0}};te.addObserver(U),te.reportChanges();const Q={dispose(){te.removeObserver(U)}};return Ae instanceof g.$Rc?Ae.add(Q):Array.isArray(Ae)&&Ae.push(Q),Q}}v.fromObservableLight=G})(y||(e.Event=y={}));class M{static{this.all=new Set}static{this.f=0}constructor(b){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${b}_${M.f++}`,M.all.add(this)}start(b){this.g=new R.$Od,this.listenerCount=b}stop(){if(this.g){const b=this.g.elapsed();this.durations.push(b),this.elapsedOverall+=b,this.invocationCount+=1,this.g=void 0}}}e.$Qd=M;let C=-1;function m(v){const b=C;return C=v,{dispose(){C=b}}}e.$Rd=m;class w{constructor(b,E=Math.random().toString(18).slice(2,5)){this.threshold=b,this.name=E,this.g=0}dispose(){this.f?.clear()}check(b,E){const A=this.threshold;if(A<=0||E<A)return;this.f||(this.f=new Map);const z=this.f.get(b.value)||0;if(this.f.set(b.value,z+1),this.g-=1,this.g<=0){this.g=A*.5;let O,P=0;for(const[j,N]of this.f)(!O||P<N)&&(O=j,P=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${P}):`),console.warn(O)}return()=>{const O=this.f.get(b.value)||0;this.f.set(b.value,O-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(b){this.value=b}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class f{constructor(b){this.value=b,this.id=l++}}const s=2,i=(v,b)=>{if(v instanceof f)b(v);else for(let E=0;E<v.length;E++){const A=v[E];A&&b(A)}};class n{constructor(b){this.w=0,this.f=b,this.g=C>0||this.f?.leakWarningThreshold?new w(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new M(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const b=this.t;queueMicrotask(()=>{i(b,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(b,E,A)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Sc.None;if(this.m)return g.$Sc.None;E&&(b=b.bind(E));const z=new f(b);let O,P;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=S.create(),O=this.g.check(z.stack,this.w+1)),p&&(z.stack=P??S.create()),this.t?this.t instanceof f?(this.u??=new a,this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const j=(0,g.$Qc)(()=>{O?.(),this.x(z)});return A instanceof g.$Rc?A.add(j):Array.isArray(A)&&A.push(j),j},this.q}x(b){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,A=E.indexOf(b);if(A===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[A]=void 0;const z=this.u.current===this;if(this.w*s<=E.length){let O=0;for(let P=0;P<E.length;P++)E[P]?E[O++]=E[P]:z&&(this.u.end--,O<this.u.i&&this.u.i--);E.length=O}}y(b,E){if(!b)return;const A=this.f?.onListenerError||D.$1;if(!A){b.value(E);return}try{b.value(E)}catch(z){A(z)}}z(b){const E=b.current.t;for(;b.i<b.end;)this.y(E[b.i++],b.value);b.reset()}fire(b){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,b);else{const E=this.u;E.enqueue(this,b,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Sd=n;const o=()=>new a;e.$Td=o;class a{constructor(){this.i=-1,this.end=0}enqueue(b,E,A){this.i=0,this.end=A,this.current=b,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(b,E,A){if(this.t)for(this.h||(this.h=new I.$3c),i(this.t,z=>this.h.push([z.value,b]));this.h.size>0&&!E.isCancellationRequested;){const[z,O]=this.h.shift(),P=[],j={...O,token:E,waitUntil:N=>{if(Object.isFrozen(P))throw new Error("waitUntil can NOT be called asynchronous");A&&(N=A(N,z)),P.push(N)}};try{z(j)}catch(N){(0,D.$1)(N);continue}Object.freeze(P),await Promise.allSettled(P).then(N=>{for(const F of N)F.status==="rejected"&&(0,D.$1)(F.reason)})}}}e.$Ud=t;class r extends n{get isPaused(){return this.h!==0}constructor(b){super(b),this.h=0,this.s=new I.$3c,this.A=b?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const b=Array.from(this.s);this.s.clear(),super.fire(this.A(b))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(b){this.w&&(this.h!==0?this.s.push(b):super.fire(b))}}e.$Vd=r;class d extends r{constructor(b){super(b),this.k=b.delay??100}fire(b){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(b)}}e.$Wd=d;class u extends n{constructor(b){super(b),this.h=[],this.k=b?.merge}fire(b){this.hasListeners()&&(this.h.push(b),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$Xd=u;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(b){const E={event:b,listener:null};this.h.push(E),this.g&&this.m(E);const A=()=>{this.g&&this.o(E);const z=this.h.indexOf(E);this.h.splice(z,1)};return(0,g.$Qc)((0,T.$db)(A))}j(){this.g=!0,this.h.forEach(b=>this.m(b))}k(){this.g=!1,this.h.forEach(b=>this.o(b))}m(b){b.listener=b.event(E=>this.f.fire(E))}o(b){b.listener&&b.listener.dispose(),b.listener=null}dispose(){this.f.dispose()}}e.$Yd=c;class h{constructor(b,E,A,z){this.f=new g.$Rc;const O=this.f.add(new c),P=this.f.add(new g.$2c);function j(N){P.set(N,O.add(z(N)))}for(const N of b)j(N);this.f.add(E(N=>{j(N)})),this.f.add(A(N=>{P.deleteAndDispose(N)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Zd=h;class k{constructor(){this.f=[]}wrapEvent(b){return(E,A,z)=>b(O=>{const P=this.f[this.f.length-1];P?P.push(()=>E.call(A,O)):E.call(A,O)},void 0,z)}bufferEvents(b){const E=[];this.f.push(E);const A=b();return this.f.pop(),E.forEach(z=>z()),A}}e.$1d=k;class L{constructor(){this.f=!1,this.g=y.None,this.h=g.$Sc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(b){this.g=b,this.f&&(this.h.dispose(),this.h=b(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$2d=L}),define(ke[21],Se([1,0,4]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.CancellationToken=void 0;const T=Object.freeze(function(p,$){const y=setTimeout(p.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(p){function $(y){return y===p.None||y===p.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}p.isCancellationToken=$,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new D.$Sd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$3d=R}),define(ke[162],Se([1,0,21]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=void 0;class T{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new D.$3d,$=this.b(p.token);return this.a={promise:$,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$Be=T;class g{constructor(p){this.c=p,this.a=void 0,this.b=void 0}get(p){const $=JSON.stringify(p);return this.b!==$&&(this.b=$,this.a=this.c(p)),this.a}}e.$Ce=g;class I{get cachedValues(){return this.a}constructor(p){this.b=p,this.a=new Map}get(p){if(this.a.has(p))return this.a.get(p);const $=this.b(p);return this.a.set(p,$),$}}e.$De=I}),define(ke[98],Se([1,0,8,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function g(o){const a=o;return a?typeof a.read=="function":!1}e.$4d=g;function I(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$5d=I;function R(o){const a=o;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$6d=R;function p(o,a){return new $(o,a)}e.$7d=p;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const d=r.indexOf(t);d>=0&&r.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$8d=y;function M(o,a,t){const r=[];let d;for(;(d=o.read())!==null&&r.length<t;)r.push(d);return d===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof d<"u"){const u=d;return d=void 0,u}return o.read()}}}e.$9d=M;function C(o,a){return new Promise((t,r)=>{const d=[];m(o,{onData:u=>{a&&d.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$0d=C;function m(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$$d=m;function w(o,a){return new Promise((t,r)=>{const d=new T.$Rc,u=[],c=L=>{if(u.push(L),u.length>a)return d.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},h=L=>(d.dispose(),r(L)),k=()=>(d.dispose(),t({stream:o,buffer:u,ended:!0}));d.add((0,T.$Qc)(()=>o.removeListener("error",h))),o.on("error",h),d.add((0,T.$Qc)(()=>o.removeListener("end",k))),o.on("end",k),d.add((0,T.$Qc)(()=>o.removeListener("data",c))),o.on("data",c)})}e.$_d=w;function S(o,a){const t=p(a);return t.end(o),t}e.$ae=S;function l(){const o=p(()=>{throw new Error("not supported")});return o.end(),o}e.$be=l;function f(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$ce=f;function s(o,a,t){const r=p(t);return m(o,{onData:d=>r.write(a.data(d)),onError:d=>r.error(a.error?a.error(d):d),onEnd:()=>r.end()}),r}e.$de=s;function i(o,a,t){let r=!1;return{read:()=>{const d=a.read();return r?d:(r=!0,d!==null?t([o,d]):o)}}}e.$ee=i;function n(o,a,t){let r=!1;const d=p(t);return m(a,{onData:u=>r?d.write(u):(r=!0,d.write(t([o,u]))),onError:u=>d.error(u),onEnd:()=>{r||(r=!0,d.write(o)),d.end()}}),d}e.$fe=n}),define(ke[22],Se([1,0,43,98]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const g=typeof Buffer<"u",I=new D.$V(()=>new Uint8Array(256));let R,p;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,A){return!(A?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(R||(R=new TextEncoder),new $(R.encode(E)))}static fromByteArray(E){const A=$.alloc(E.length);for(let z=0,O=E.length;z<O;z++)A.buffer[z]=E[z];return A}static concat(E,A){if(typeof A>"u"){A=0;for(let P=0,j=E.length;P<j;P++)A+=E[P].byteLength}const z=$.alloc(A);let O=0;for(let P=0,j=E.length;P<j;P++){const N=E[P];z.set(N,O),O+=N.byteLength}return z}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(E,A){return new $(this.buffer.subarray(E,A))}set(E,A){if(E instanceof $)this.buffer.set(E.buffer,A);else if(E instanceof Uint8Array)this.buffer.set(E,A);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),A);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,A){w(this.buffer,E,A)}readUInt32LE(E){return S(this.buffer,E)}writeUInt32LE(E,A){l(this.buffer,E,A)}readUInt8(E){return f(this.buffer,E)}writeUInt8(E,A){s(this.buffer,E,A)}indexOf(E,A=0){return y(this.buffer,E instanceof $?E.buffer:E,A)}}e.$ge=$;function y(b,E,A=0){const z=E.byteLength,O=b.byteLength;if(z===0)return 0;if(z===1)return b.indexOf(E[0]);if(z>O-A)return-1;const P=I.value;P.fill(E.length);for(let W=0;W<E.length;W++)P[E[W]]=E.length-W-1;let j=A+E.length-1,N=j,F=-1;for(;j<O;)if(b[j]===E[N]){if(N===0){F=j;break}j--,N--}else j+=Math.max(E.length-N,P[b[j]]),N=E.length-1;return F}e.$he=y;function M(b,E){return b[E+0]<<0>>>0|b[E+1]<<8>>>0}e.$ie=M;function C(b,E,A){b[A+0]=E&255,E=E>>>8,b[A+1]=E&255}e.$je=C;function m(b,E){return b[E]*2**24+b[E+1]*2**16+b[E+2]*2**8+b[E+3]}e.$ke=m;function w(b,E,A){b[A+3]=E,E=E>>>8,b[A+2]=E,E=E>>>8,b[A+1]=E,E=E>>>8,b[A]=E}e.$le=w;function S(b,E){return b[E+0]<<0>>>0|b[E+1]<<8>>>0|b[E+2]<<16>>>0|b[E+3]<<24>>>0}e.$me=S;function l(b,E,A){b[A+0]=E&255,E=E>>>8,b[A+1]=E&255,E=E>>>8,b[A+2]=E&255,E=E>>>8,b[A+3]=E&255}e.$ne=l;function f(b,E){return b[E]}e.$oe=f;function s(b,E,A){b[A]=E}e.$pe=s;function i(b){return T.$8d(b,E=>$.concat(E))}e.$qe=i;function n(b){return T.$ce(b)}e.$re=n;function o(b){return T.$0d(b,E=>$.concat(E))}e.$se=o;async function a(b){return b.ended?$.concat(b.buffer):$.concat([...b.buffer,await o(b.stream)])}e.$te=a;function t(b){return T.$ae(b,E=>$.concat(E))}e.$ue=t;function r(b){return T.$de(b,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ve=r;function d(b){return T.$7d(E=>$.concat(E),b)}e.$we=d;function u(b,E){return T.$ee(b,E,A=>$.concat(A))}e.$xe=u;function c(b,E){return T.$fe(b,E,A=>$.concat(A))}e.$ye=c;function h(b){let E=0,A=0,z=0;const O=new Uint8Array(Math.floor(b.length/4*3)),P=N=>{switch(A){case 3:O[z++]=E|N,A=0;break;case 2:O[z++]=E|N>>>2,E=N<<6,A=3;break;case 1:O[z++]=E|N>>>4,E=N<<4,A=2;break;default:E=N<<2,A=1}};for(let N=0;N<b.length;N++){const F=b.charCodeAt(N);if(F>=65&&F<=90)P(F-65);else if(F>=97&&F<=122)P(F-97+26);else if(F>=48&&F<=57)P(F-48+52);else if(F===43||F===45)P(62);else if(F===47||F===95)P(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${b[N]}`)}}const j=z;for(;A>0;)P(0);return $.wrap(O).slice(0,j)}e.$ze=h;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:b},E=!0,A=!1){const z=A?L:k;let O="";const P=b.byteLength%3;let j=0;for(;j<b.byteLength-P;j+=3){const N=b[j+0],F=b[j+1],W=b[j+2];O+=z[N>>>2],O+=z[(N<<4|F>>>4)&63],O+=z[(F<<2|W>>>6)&63],O+=z[W&63]}if(P===1){const N=b[j+0];O+=z[N>>>2],O+=z[N<<4&63],E&&(O+="==")}else if(P===2){const N=b[j+0],F=b[j+1];O+=z[N>>>2],O+=z[(N<<4|F>>>4)&63],O+=z[F<<2&63],E&&(O+="=")}return O}e.$Ae=v}),define(ke[13],Se([1,0,162,43]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Df=e.$Cf=e.$Bf=e.$Af=e.GraphemeBreakType=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=void 0;function g(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}e.$Ge=g;const I=/{(\d+)}/g;function R(Ie,...ze){return ze.length===0?Ie:Ie.replace(I,function(qe,Re){const et=parseInt(Re,10);return isNaN(et)||et<0||et>=ze.length?qe:ze[et]})}e.$He=R;const p=/{([^}]+)}/g;function $(Ie,ze){return Object.keys(ze).length===0?Ie:Ie.replace(p,(qe,Re)=>ze[Re]??qe)}e.$Ie=$;function y(Ie){return Ie.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Je=y;function M(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ke=M;function C(Ie,ze){let qe=0;const Re=ze.charCodeAt(0);for(let et=Ie.length-1;et>=0;et--)Ie.charCodeAt(et)===Re&&qe++;return qe}e.$Le=C;function m(Ie,ze,qe="\u2026"){return Ie.length<=ze?Ie:`${Ie.substr(0,ze)}${qe}`}e.$Me=m;function w(Ie,ze,qe="\u2026"){if(Ie.length<=ze)return Ie;const Re=Math.ceil(ze/2)-qe.length/2,et=Math.floor(ze/2)-qe.length/2;return`${Ie.substr(0,Re)}${qe}${Ie.substr(Ie.length-et)}`}e.$Ne=w;function S(Ie,ze=" "){const qe=l(Ie,ze);return f(qe,ze)}e.$Oe=S;function l(Ie,ze){if(!Ie||!ze)return Ie;const qe=ze.length;if(qe===0||Ie.length===0)return Ie;let Re=0;for(;Ie.indexOf(ze,Re)===Re;)Re=Re+qe;return Ie.substring(Re)}e.$Pe=l;function f(Ie,ze){if(!Ie||!ze)return Ie;const qe=ze.length,Re=Ie.length;if(qe===0||Re===0)return Ie;let et=Re,oe=-1;for(;oe=Ie.lastIndexOf(ze,et-1),!(oe===-1||oe+qe!==et);){if(oe===0)return"";et=oe}return Ie.substring(0,et)}e.$Qe=f;function s(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Re=s;function i(Ie){return Ie.replace(/\*/g,"")}e.$Se=i;function n(Ie,ze,qe={}){if(!Ie)throw new Error("Cannot create regex from empty string");ze||(Ie=M(Ie)),qe.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Re="";return qe.global&&(Re+="g"),qe.matchCase||(Re+="i"),qe.multiline&&(Re+="m"),qe.unicode&&(Re+="u"),new RegExp(Ie,Re)}e.$Te=n;function o(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}e.$Ue=o;function a(Ie){return Ie.split(/\r\n|\r|\n/)}e.$Ve=a;function t(Ie){for(let ze=0,qe=Ie.length;ze<qe;ze++){const Re=Ie.charCodeAt(ze);if(Re!==32&&Re!==9)return ze}return-1}e.$We=t;function r(Ie,ze=0,qe=Ie.length){for(let Re=ze;Re<qe;Re++){const et=Ie.charCodeAt(Re);if(et!==32&&et!==9)return Ie.substring(ze,Re)}return Ie.substring(ze,qe)}e.$Xe=r;function d(Ie,ze=Ie.length-1){for(let qe=ze;qe>=0;qe--){const Re=Ie.charCodeAt(qe);if(Re!==32&&Re!==9)return qe}return-1}e.$Ye=d;function u(Ie,ze,qe){const Re=[];let et=0;for(const oe of Ie.matchAll(ze)){if(Re.push(Ie.slice(et,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");et=oe.index+oe[0].length,Re.push(qe(oe[0],...oe.slice(1),oe.index,Ie,oe.groups))}return Re.push(Ie.slice(et)),Promise.all(Re).then(oe=>oe.join(""))}e.$Ze=u;function c(Ie,ze){return Ie<ze?-1:Ie>ze?1:0}e.$1e=c;function h(Ie,ze,qe=0,Re=Ie.length,et=0,oe=ze.length){for(;qe<Re&&et<oe;qe++,et++){const He=Ie.charCodeAt(qe),Ze=ze.charCodeAt(et);if(He<Ze)return-1;if(He>Ze)return 1}const le=Re-qe,Pe=oe-et;return le<Pe?-1:le>Pe?1:0}e.$2e=h;function k(Ie,ze){return L(Ie,ze,0,Ie.length,0,ze.length)}e.$3e=k;function L(Ie,ze,qe=0,Re=Ie.length,et=0,oe=ze.length){for(;qe<Re&&et<oe;qe++,et++){let He=Ie.charCodeAt(qe),Ze=ze.charCodeAt(et);if(He===Ze)continue;if(He>=128||Ze>=128)return h(Ie.toLowerCase(),ze.toLowerCase(),qe,Re,et,oe);b(He)&&(He-=32),b(Ze)&&(Ze-=32);const it=He-Ze;if(it!==0)return it}const le=Re-qe,Pe=oe-et;return le<Pe?-1:le>Pe?1:0}e.$4e=L;function v(Ie){return Ie>=48&&Ie<=57}e.$5e=v;function b(Ie){return Ie>=97&&Ie<=122}e.$6e=b;function E(Ie){return Ie>=65&&Ie<=90}e.$7e=E;function A(Ie,ze){return Ie.length===ze.length&&L(Ie,ze)===0}e.$8e=A;function z(Ie,ze){const qe=ze.length;return ze.length>Ie.length?!1:L(Ie,ze,0,qe)===0}e.$9e=z;function O(Ie,ze){const qe=Math.min(Ie.length,ze.length);let Re;for(Re=0;Re<qe;Re++)if(Ie.charCodeAt(Re)!==ze.charCodeAt(Re))return Re;return qe}e.$0e=O;function P(Ie,ze){const qe=Math.min(Ie.length,ze.length);let Re;const et=Ie.length-1,oe=ze.length-1;for(Re=0;Re<qe;Re++)if(Ie.charCodeAt(et-Re)!==ze.charCodeAt(oe-Re))return Re;return qe}e.$$e=P;function j(Ie){return 55296<=Ie&&Ie<=56319}e.$_e=j;function N(Ie){return 56320<=Ie&&Ie<=57343}e.$af=N;function F(Ie,ze){return(Ie-55296<<10)+(ze-56320)+65536}e.$bf=F;function W(Ie,ze,qe){const Re=Ie.charCodeAt(qe);if(j(Re)&&qe+1<ze){const et=Ie.charCodeAt(qe+1);if(N(et))return F(Re,et)}return Re}e.$cf=W;function x(Ie,ze){const qe=Ie.charCodeAt(ze-1);if(N(qe)&&ze>1){const Re=Ie.charCodeAt(ze-2);if(j(Re))return F(Re,qe)}return qe}class ce{get offset(){return this.e}constructor(ze,qe=0){this.c=ze,this.d=ze.length,this.e=qe}setOffset(ze){this.e=ze}prevCodePoint(){const ze=x(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=W(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$df=ce;class J{get offset(){return this.c.offset}constructor(ze,qe=0){this.c=new ce(ze,qe)}nextGraphemeLength(){const ze=ue.getInstance(),qe=this.c,Re=qe.offset;let et=ze.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const oe=qe.offset,le=ze.getGraphemeBreakType(qe.nextCodePoint());if(V(et,le)){qe.setOffset(oe);break}et=le}return qe.offset-Re}prevGraphemeLength(){const ze=ue.getInstance(),qe=this.c,Re=qe.offset;let et=ze.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const oe=qe.offset,le=ze.getGraphemeBreakType(qe.prevCodePoint());if(V(le,et)){qe.setOffset(oe);break}et=le}return Re-qe.offset}eol(){return this.c.eol()}}e.$ef=J;function Y(Ie,ze){return new J(Ie,ze).nextGraphemeLength()}e.$ff=Y;function X(Ie,ze){return new J(Ie,ze).prevGraphemeLength()}e.$gf=X;function se(Ie,ze){ze>0&&N(Ie.charCodeAt(ze))&&ze--;const qe=ze+Y(Ie,ze);return[qe-X(Ie,qe),qe]}e.$hf=se;function Z(Ie){const ze=new J(Ie);let qe=0;for(;!ze.eol();)qe++,ze.nextGraphemeLength();return qe}e.$if=Z;let we;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function K(Ie){return we||(we=de()),we.test(Ie)}e.$jf=K;const B=/^[\t\n\r\x20-\x7E]*$/;function ne(Ie){return B.test(Ie)}e.$kf=ne,e.$lf=/[\u2028\u2029]/;function ye(Ie){return e.$lf.test(Ie)}e.$mf=ye;function he(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}e.$nf=he;function ge(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}e.$of=ge;function _(Ie,ze){if(Ie.length<ze)return Ie;const qe=/\b/g;let Re=0;for(;qe.test(Ie)&&!(Ie.length-qe.lastIndex<ze);)Re=qe.lastIndex,qe.lastIndex+=1;return Ie.substring(Re).replace(/^\s/,"")}e.$pf=_;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function te(Ie){return Ie&&(Ie=Ie.replace(ie,"").replace(G,"")),Ie}e.$qf=te,e.$rf=String.fromCharCode(65279);function fe(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}e.$sf=fe;function ve(Ie){return fe(Ie)?Ie.substr(1):Ie}e.$tf=ve;function Ae(Ie,ze){if(!Ie||!ze||Ie.length<ze.length)return!1;const qe=ze.length,Re=Ie.toLowerCase();let et=0,oe=-1;for(;et<qe;){const le=Re.indexOf(ze[et],oe+1);if(le<0)return!1;oe=le,et++}return!0}e.$uf=Ae;function pe(Ie,ze=!1){return Ie?(ze&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}e.$vf=pe;function De(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}e.$wf=De;function U(Ie,ze=1){if(ze===0)return"";let qe=-1;do qe=Ie.indexOf(`
`,qe+1),ze--;while(ze>0&&qe>=0);return qe===-1?Ie:(Ie[qe-1]==="\r"&&qe--,Ie.substr(0,qe))}e.$xf=U;function Q(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}e.$yf=Q;function ee(Ie){return ue.getInstance().getGraphemeBreakType(Ie)}e.$zf=ee;function V(Ie,ze){return Ie===0?ze!==5&&ze!==7:Ie===2&&ze===3?!1:Ie===4||Ie===2||Ie===3||ze===4||ze===2||ze===3?!0:!(Ie===8&&(ze===8||ze===9||ze===11||ze===12)||(Ie===11||Ie===9)&&(ze===9||ze===10)||(Ie===12||Ie===10)&&ze===10||ze===5||ze===13||ze===7||Ie===1||Ie===13&&ze===14||Ie===6&&ze===6)}var ae;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})(ae||(e.GraphemeBreakType=ae={}));class ue{static{this.c=null}static getInstance(){return ue.c||(ue.c=new ue),ue.c}constructor(){this.d=Le()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const qe=this.d,Re=qe.length/3;let et=1;for(;et<=Re;)if(ze<qe[3*et])et=2*et;else if(ze>qe[3*et+1])et=2*et+1;else return qe[3*et+2];return 0}}function Le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Ie,ze){if(Ie===0)return 0;const qe=Ke(Ie,ze);if(qe!==void 0)return qe;const Re=new ce(ze,Ie);return Re.prevCodePoint(),Re.offset}e.$Af=je;function Ke(Ie,ze){const qe=new ce(ze,Ie);let Re=qe.prevCodePoint();for(;Qe(Re)||Re===65039||Re===8419;){if(qe.offset===0)return;Re=qe.prevCodePoint()}if(!ge(Re))return;let et=qe.offset;return et>0&&qe.prevCodePoint()===8205&&(et=qe.offset),et}function Qe(Ie){return 127995<=Ie&&Ie<=127999}var _e;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.$Bf="\xA0";class at{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Ce(ze=>{function qe(it){const st=new Map;for(let Oe=0;Oe<it.length;Oe+=2)st.set(it[Oe],it[Oe+1]);return st}function Re(it,st){const Oe=new Map(it);for(const[wt,Dt]of st)Oe.set(wt,Dt);return Oe}function et(it,st){if(!it)return st;const Oe=new Map;for(const[wt,Dt]of it)st.has(wt)&&Oe.set(wt,Dt);return Oe}const oe=this.c.value;let le=ze.filter(it=>!it.startsWith("_")&&it in oe);le.length===0&&(le=["_default"]);let Pe;for(const it of le){const st=qe(oe[it]);Pe=et(Pe,st)}const He=qe(oe._common),Ze=Re(He,Pe);return new at(Ze)})}static getInstance(ze){return at.d.get(Array.from(ze))}static{this.e=new T.$V(()=>Object.keys(at.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return at.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Cf=at;class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(ze){return ot.e().has(ze)}static get codePoints(){return ot.e()}}e.$Df=ot}),define(ke[123],Se([1,0,28,161,13]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function I(...pe){return function(De,U){for(let Q=0,ee=pe.length;Q<ee;Q++){const V=pe[Q](De,U);if(V)return V}return null}}e.or=I,e.$Pj=R.bind(void 0,!1),e.$Qj=R.bind(void 0,!0);function R(pe,De,U){if(!U||U.length<De.length)return null;let Q;return pe?Q=g.$9e(U,De):Q=U.indexOf(De)===0,Q?De.length>0?[{start:0,end:De.length}]:[]:null}function p(pe,De){const U=De.toLowerCase().indexOf(pe.toLowerCase());return U===-1?null:[{start:U,end:U+pe.length}]}e.$Rj=p;function $(pe,De){return y(pe.toLowerCase(),De.toLowerCase(),0,0)}e.$Sj=$;function y(pe,De,U,Q){if(U===pe.length)return[];if(Q===De.length)return null;if(pe[U]===De[Q]){let ee=null;return(ee=y(pe,De,U+1,Q+1))?o({start:Q,end:Q+1},ee):null}return y(pe,De,U,Q+1)}function M(pe){return 97<=pe&&pe<=122}function C(pe){return 65<=pe&&pe<=90}e.$Tj=C;function m(pe){return 48<=pe&&pe<=57}function w(pe){return pe===32||pe===9||pe===10||pe===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>S.add(pe.charCodeAt(0)));function l(pe){return w(pe)||S.has(pe)}function f(pe,De){return pe===De||l(pe)&&l(De)}const s=new Map;function i(pe){if(s.has(pe))return s.get(pe);let De;const U=(0,T.$Nj)(pe);return U&&(De=U),s.set(pe,De),De}function n(pe){return M(pe)||C(pe)||m(pe)}function o(pe,De){return De.length===0?De=[pe]:pe.end===De[0].start?De[0].start=pe.start:De.unshift(pe),De}function a(pe,De){for(let U=De;U<pe.length;U++){const Q=pe.charCodeAt(U);if(C(Q)||m(Q)||U>0&&!n(pe.charCodeAt(U-1)))return U}return pe.length}function t(pe,De,U,Q){if(U===pe.length)return[];if(Q===De.length)return null;if(pe[U]!==De[Q].toLowerCase())return null;{let ee=null,V=Q+1;for(ee=t(pe,De,U+1,Q+1);!ee&&(V=a(De,V))<De.length;)ee=t(pe,De,U+1,V),V++;return ee===null?null:o({start:Q,end:Q+1},ee)}}function r(pe){let De=0,U=0,Q=0,ee=0,V=0;for(let Ke=0;Ke<pe.length;Ke++)V=pe.charCodeAt(Ke),C(V)&&De++,M(V)&&U++,n(V)&&Q++,m(V)&&ee++;const ae=De/pe.length,ue=U/pe.length,Le=Q/pe.length,je=ee/pe.length;return{upperPercent:ae,lowerPercent:ue,alphaPercent:Le,numericPercent:je}}function d(pe){const{upperPercent:De,lowerPercent:U}=pe;return U===0&&De>.6}function u(pe){const{upperPercent:De,lowerPercent:U,alphaPercent:Q,numericPercent:ee}=pe;return U>.2&&De<.8&&Q>.6&&ee<.2}function c(pe){let De=0,U=0,Q=0,ee=0;for(let V=0;V<pe.length;V++)Q=pe.charCodeAt(V),C(Q)&&De++,M(Q)&&U++,w(Q)&&ee++;return(De===0||U===0)&&ee===0?pe.length<=30:De<=5}function h(pe,De){if(!De||(De=De.trim(),De.length===0)||!c(pe)||De.length>60)return null;const U=r(De);if(!u(U)){if(!d(U))return null;De=De.toLowerCase()}let Q=null,ee=0;for(pe=pe.toLowerCase();ee<De.length&&(Q=t(pe,De,0,ee))===null;)ee=a(De,ee+1);return Q}e.$Uj=h;function k(pe,De,U=!1){if(!De||De.length===0)return null;let Q=null,ee=0;for(pe=pe.toLowerCase(),De=De.toLowerCase();ee<De.length&&(Q=L(pe,De,0,ee,U),Q===null);)ee=v(De,ee+1);return Q}e.$Vj=k;function L(pe,De,U,Q,ee){let V=0;if(U===pe.length)return[];if(Q===De.length)return null;if(!f(pe.charCodeAt(U),De.charCodeAt(Q))){const Le=i(pe.charCodeAt(U));if(!Le)return null;for(let je=0;je<Le.length;je++)if(!f(Le[je],De.charCodeAt(Q+je)))return null;V+=Le.length-1}let ae=null,ue=Q+V+1;if(ae=L(pe,De,U+1,ue,ee),!ee)for(;!ae&&(ue=v(De,ue))<De.length;)ae=L(pe,De,U+1,ue,ee),ue++;if(!ae)return null;if(pe.charCodeAt(U)!==De.charCodeAt(Q)){const Le=i(pe.charCodeAt(U));if(!Le)return ae;for(let je=0;je<Le.length;je++)if(Le[je]!==De.charCodeAt(Q+je))return ae}return o({start:Q,end:Q+V+1},ae)}function v(pe,De){for(let U=De;U<pe.length;U++)if(l(pe.charCodeAt(U))||U>0&&l(pe.charCodeAt(U-1)))return U;return pe.length}const b=I(e.$Qj,h,p),E=I(e.$Qj,h,$),A=new D.$Dc(1e4);function z(pe,De,U=!1){if(typeof pe!="string"||typeof De!="string")return null;let Q=A.get(pe);Q||(Q=new RegExp(g.$Re(pe),"i"),A.set(pe,Q));const ee=Q.exec(De);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:U?E(pe,De):b(pe,De)}e.$Wj=z;function O(pe,De){const U=_(pe,pe.toLowerCase(),0,De,De.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return U?j(U):null}e.$Xj=O;function P(pe,De,U,Q,ee,V){const ae=Math.min(13,pe.length);for(;U<ae;U++){const ue=_(pe,De,U,Q,ee,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ue)return ue}return[0,V]}e.$Yj=P;function j(pe){if(typeof pe>"u")return[];const De=[],U=pe[1];for(let Q=pe.length-1;Q>1;Q--){const ee=pe[Q]+U,V=De[De.length-1];V&&V.end===ee?V.end=ee+1:De.push({start:ee,end:ee+1})}return De}e.$Zj=j;const N=128;function F(){const pe=[],De=[];for(let U=0;U<=N;U++)De[U]=0;for(let U=0;U<=N;U++)pe.push(De.slice(0));return pe}function W(pe){const De=[];for(let U=0;U<=pe;U++)De[U]=0;return De}const x=W(2*N),ce=W(2*N),J=F(),Y=F(),X=F(),se=!1;function Z(pe,De,U,Q,ee){function V(ue,Le,je=" "){for(;ue.length<Le;)ue=je+ue;return ue}let ae=` |   |${Q.split("").map(ue=>V(ue,3)).join("|")}
`;for(let ue=0;ue<=U;ue++)ue===0?ae+=" |":ae+=`${De[ue-1]}|`,ae+=pe[ue].slice(0,ee+1).map(Le=>V(Le.toString(),3)).join("|")+`
`;return ae}function we(pe,De,U,Q){pe=pe.substr(De),U=U.substr(Q),console.log(Z(Y,pe,pe.length,U,U.length)),console.log(Z(X,pe,pe.length,U,U.length)),console.log(Z(J,pe,pe.length,U,U.length))}function de(pe,De){if(De<0||De>=pe.length)return!1;const U=pe.codePointAt(De);switch(U){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!g.$of(U)}}function K(pe,De){if(De<0||De>=pe.length)return!1;switch(pe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function B(pe,De,U){return De[pe]!==U[pe]}function ne(pe,De,U,Q,ee,V,ae=!1){for(;De<U&&ee<V;)pe[De]===Q[ee]&&(ae&&(x[De]=ee),De+=1),ee+=1;return De===U}e.$1j=ne;var ye;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var he;(function(pe){pe.Default=[-100,0];function De(U){return!U||U.length===2&&U[0]===-100&&U[1]===0}pe.isDefault=De})(he||(e.FuzzyScore=he={}));class ge{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(De,U){this.firstMatchCanBeWeak=De,this.boostFullMatch=U}}e.$2j=ge;function _(pe,De,U,Q,ee,V,ae=ge.default){const ue=pe.length>N?N:pe.length,Le=Q.length>N?N:Q.length;if(U>=ue||V>=Le||ue-U>Le-V||!ne(De,U,ue,ee,V,Le,!0))return;ie(ue,Le,U,V,De,ee);let je=1,Ke=1,Qe=U,_e=V;const at=[!1];for(je=1,Qe=U;Qe<ue;je++,Qe++){const Re=x[Qe],et=ce[Qe],oe=Qe+1<ue?ce[Qe+1]:Le;for(Ke=Re-V+1,_e=Re;_e<oe;Ke++,_e++){let le=Number.MIN_SAFE_INTEGER,Pe=!1;_e<=et&&(le=G(pe,De,Qe,U,Q,ee,_e,Le,V,J[je-1][Ke-1]===0,at));let He=0;le!==Number.MAX_SAFE_INTEGER&&(Pe=!0,He=le+Y[je-1][Ke-1]);const Ze=_e>Re,it=Ze?Y[je][Ke-1]+(J[je][Ke-1]>0?-5:0):0,st=_e>Re+1&&J[je][Ke-1]>0,Oe=st?Y[je][Ke-2]+(J[je][Ke-2]>0?-5:0):0;if(st&&(!Ze||Oe>=it)&&(!Pe||Oe>=He))Y[je][Ke]=Oe,X[je][Ke]=3,J[je][Ke]=0;else if(Ze&&(!Pe||it>=He))Y[je][Ke]=it,X[je][Ke]=2,J[je][Ke]=0;else if(Pe)Y[je][Ke]=He,X[je][Ke]=1,J[je][Ke]=J[je-1][Ke-1]+1;else throw new Error("not possible")}}if(se&&we(pe,U,Q,V),!at[0]&&!ae.firstMatchCanBeWeak)return;je--,Ke--;const ot=[Y[je][Ke],V];let Ie=0,ze=0;for(;je>=1;){let Re=Ke;do{const et=X[je][Re];if(et===3)Re=Re-2;else if(et===2)Re=Re-1;else break}while(Re>=1);Ie>1&&De[U+je-1]===ee[V+Ke-1]&&!B(Re+V-1,Q,ee)&&Ie+1>J[je][Re]&&(Re=Ke),Re===Ke?Ie++:Ie=1,ze||(ze=Re),je--,Ke=Re-1,ot.push(Ke)}Le===ue&&ae.boostFullMatch&&(ot[0]+=2);const qe=ze-ue;return ot[0]-=qe,ot}e.$3j=_;function ie(pe,De,U,Q,ee,V){let ae=pe-1,ue=De-1;for(;ae>=U&&ue>=Q;)ee[ae]===V[ue]&&(ce[ae]=ue,ae--),ue--}function G(pe,De,U,Q,ee,V,ae,ue,Le,je,Ke){if(De[U]!==V[ae])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return ae===U-Q?Qe=pe[U]===ee[ae]?7:5:B(ae,ee,V)&&(ae===0||!B(ae-1,ee,V))?(Qe=pe[U]===ee[ae]?7:5,_e=!0):de(V,ae)&&(ae===0||!de(V,ae-1))?Qe=5:(de(V,ae-1)||K(V,ae-1))&&(Qe=5,_e=!0),Qe>1&&U===Q&&(Ke[0]=!0),_e||(_e=B(ae,ee,V)||de(V,ae-1)||K(V,ae-1)),U===Q?ae>Le&&(Qe-=_e?3:5):je?Qe+=_e?2:0:Qe+=_e?0:1,ae+1===ue&&(Qe-=_e?3:5),Qe}function te(pe,De,U,Q,ee,V,ae){return ve(pe,De,U,Q,ee,V,!0,ae)}e.$4j=te;function fe(pe,De,U,Q,ee,V,ae){return ve(pe,De,U,Q,ee,V,!1,ae)}e.$5j=fe;function ve(pe,De,U,Q,ee,V,ae,ue){let Le=_(pe,De,U,Q,ee,V,ue);if(Le&&!ae)return Le;if(pe.length>=3){const je=Math.min(7,pe.length-1);for(let Ke=U+1;Ke<je;Ke++){const Qe=Ae(pe,Ke);if(Qe){const _e=_(Qe,Qe.toLowerCase(),U,Q,ee,V,ue);_e&&(_e[0]-=3,(!Le||_e[0]>Le[0])&&(Le=_e))}}}return Le}function Ae(pe,De){if(De+1>=pe.length)return;const U=pe[De],Q=pe[De+1];if(U!==Q)return pe.slice(0,De)+Q+U+pe.slice(De+2)}}),define(ke[53],Se([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;function T(s){return g(s,0)}e.$Pi=T;function g(s,i){switch(typeof s){case"object":return s===null?I(349,i):Array.isArray(s)?$(s,i):y(s,i);case"string":return p(s,i);case"boolean":return R(s,i);case"number":return I(s,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Qi=g;function I(s,i){return(i<<5)-i+s|0}e.$Ri=I;function R(s,i){return I(s?433:863,i)}function p(s,i){i=I(149417,i);for(let n=0,o=s.length;n<o;n++)i=I(s.charCodeAt(n),i);return i}e.$Si=p;function $(s,i){return i=I(104579,i),s.reduce((n,o)=>g(o,n),i)}function y(s,i){return i=I(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=p(o,n),g(s[o],n)),i)}class M{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Ti=M;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function w(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function S(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function l(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),i/4)}e.$Ui=l;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,d;for(t!==0?(r=t,d=-1,t=0):(r=i.charCodeAt(0),d=0);;){let u=r;if(D.$_e(r))if(d+1<n){const c=i.charCodeAt(d+1);D.$af(c)?(d++,u=D.$bf(r,c)):u=65533}else{t=r;break}else D.$af(r)&&(u=65533);if(a=this.w(o,a,u),d++,d<n)r=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=f.g,n=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,m(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,d=this.o,u,c,h;for(let k=0;k<80;k++)k<20?(u=a&t|~a&r,c=1518500249):k<40?(u=a^t^r,c=1859775393):k<60?(u=a&t|a&r|t&r,c=2400959708):(u=a^t^r,c=3395469782),h=m(o,5)+u+d+c+i.getUint32(k*4,!1)&4294967295,d=r,r=t,t=m(a,30),a=o,o=h;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+d&4294967295}}e.$Vi=f}),define(ke[39],Se([1,0,13]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(T||(T={})),function(g){const I="error",R="warning",p="warn",$="info",y="ignore";function M(m){return m?D.$8e(I,m)?g.Error:D.$8e(R,m)||D.$8e(p,m)?g.Warning:D.$8e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=M;function C(m){switch(m){case g.Error:return I;case g.Warning:return R;case g.Info:return $;default:return y}}g.toString=C}(T||(T={})),e.default=T}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,13]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class g{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const S=w.charCodeAt(0),l=this.b.charCodeAt(this.c);return S-l}value(){return this.b[this.c]}}e.$4h=g;class I{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,T.$2e)(w,this.b,0,w.length,this.c,this.d):(0,T.$4e)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=I;class R{constructor(w=!0,S=!0){this.f=w,this.g=S}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let S=w.length-1;S>=0;S--,this.c--){const l=this.b.charCodeAt(S);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,T.$2e)(w,this.b,0,w.length,this.d,this.e):(0,T.$4e)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=R;var p;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(p||(p={}));class ${constructor(w,S){this.f=w,this.g=S,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,T.$3e)(w,this.c.scheme);if(this.d[this.e]===2)return(0,T.$3e)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,T.$1e)(w,this.c.query);if(this.d[this.e]===5)return(0,T.$1e)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(M||(M={}));class C{static forUris(w=()=>!1,S=()=>!1){return new C(new $(w,S))}static forPaths(w=!1){return new C(new R(void 0,!w))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,S){if(S){const l=S.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f,w)}else{const l=w.slice(0);(0,D.$Xb)(l);for(const f of l)this.set(f[0],f[1])}}set(w,S){const l=this.b.reset(w);let f;this.c||(this.c=new y,this.c.segment=l.value());const s=[];for(f=this.c;;){const n=l.cmp(f.segment);if(n>0)f.left||(f.left=new y,f.left.segment=l.value()),s.push([-1,f]),f=f.left;else if(n<0)f.right||(f.right=new y,f.right.segment=l.value()),s.push([1,f]),f=f.right;else if(l.hasNext())l.next(),f.mid||(f.mid=new y,f.mid.segment=l.value()),s.push([0,f]),f=f.mid;else break}const i=f.value;f.value=S,f.key=w;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const S=this.b.reset(w);let l=this.c;for(;l;){const f=S.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(S.hasNext())S.next(),l=l.mid;else break}return l}has(w){const S=this.d(w);return!(S?.value===void 0&&S?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,S){const l=this.b.reset(w),f=[];let s=this.c;for(;s;){const i=l.cmp(s.segment);if(i>0)f.push([-1,s]),s=s.left;else if(i<0)f.push([1,s]),s=s.right;else if(l.hasNext())l.next(),f.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(f.length>0){const[n,o]=f[f.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=f.length-1;i>=0;i--){const n=f[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),f[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),f[i][1]=n.rotateRight()),i>0)switch(f[i-1][0]){case-1:f[i-1][1].left=f[i][1];break;case 1:f[i-1][1].right=f[i][1];break;case 0:f[i-1][1].mid=f[i][1];break}else this.c=f[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const S=this.b.reset(w);let l=this.c,f;for(;l;){const s=S.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(S.hasNext())S.next(),f=l.value||f,l=l.mid;else break}return l&&l.value||f}findSuperstr(w){return this.g(w,!1)}g(w,S){const l=this.b.reset(w);let f=this.c;for(;f;){const s=l.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(l.hasNext())l.next(),f=f.mid;else return f.mid?this.h(f.mid):S?f.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[S,l]of this)w(l,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const S=[];return this.j(w,S),S[Symbol.iterator]()}j(w,S){w&&(w.left&&this.j(w.left,S),w.value&&S.push([w.key,w.value]),w.mid&&this.j(w.mid,S),w.right&&this.j(w.right,S))}_isBalanced(){const w=S=>{if(!S)return!0;const l=S.balanceFactor();return l<-1||l>1?!1:w(S.left)&&w(S.right)};return w(this.c)}}e.$8h=C}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=void 0;function D(a){return typeof a=="string"}e.$Ef=D;function T(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Ff=T;function g(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Gf=g;function I(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Hf=I;function R(a){return typeof a=="number"&&!isNaN(a)}e.$If=R;function p(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Jf=p;function $(a){return a===!0||a===!1}e.$Kf=$;function y(a){return typeof a>"u"}e.$Lf=y;function M(a){return!C(a)}e.$Mf=M;function C(a){return y(a)||a===null}e.$Nf=C;function m(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Of=m;function w(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Pf=w;function S(...a){const t=[];for(let r=0;r<a.length;r++){const d=a[r];if(C(d))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(d)}return t}e.$Qf=S;const l=Object.prototype.hasOwnProperty;function f(a){if(!g(a))return!1;for(const t in a)if(l.call(a,t))return!1;return!0}e.$Rf=f;function s(a){return typeof a=="function"}e.$Sf=s;function i(...a){return a.length>0&&a.every(s)}e.$Tf=i;function n(a,t){const r=Math.min(a.length,t.length);for(let d=0;d<r;d++)o(a[d],t[d])}e.$Uf=n;function o(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Vf=o}),define(ke[78],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=void 0;const T=Object.create(null);function g(p,$){if((0,D.$Ef)($)){const y=T[$];if(y===void 0)throw new Error(`${p} references an unknown codicon: ${$}`);$=y}return T[p]=$,{id:p}}function I(){return T}e.$6j=I;function R(){return Object.values(e.$8j)}e.$7j=R,e.$8j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),lightbulbSparkleAutofix:g("lightbulb-sparkle-autofix",60447),robot:g("robot",60448),sparkleFilled:g("sparkle-filled",60449),diffSingle:g("diff-single",60450),diffMultiple:g("diff-multiple",60451),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function T(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?T(o):o}),i}e.$hn=T;function g(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(I.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Hf)(a)&&i.push(a)}}return s}e.$in=g;const I=Object.prototype.hasOwnProperty;function R(s,i){return p(s,i,new Set)}e.$jn=R;function p(s,i,n){if((0,D.$Nf)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(p(t,i,n));return a}if((0,D.$Gf)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)I.call(s,t)&&(a[t]=p(s[t],i,n));return n.delete(s),a}return s}function $(s,i,n=!0){return(0,D.$Gf)(s)?((0,D.$Gf)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.$Gf)(s[o])&&(0,D.$Gf)(i[o])?$(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$kn=$;function y(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!y(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!y(a,t))return!1;for(n=0;n<a.length;n++)if(!y(s[a[n]],i[a[n]]))return!1}return!0}e.$ln=y;function M(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.$Gf)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$mn=M;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];y(t,r)||(n[a]=r)}),n}e.$nn=C;function m(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$on=m;function w(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$pn=w;function S(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$qn=S;function l(s){const i=[];for(const n of S(s))typeof s[n]=="function"&&i.push(n);return i}e.$rn=l;function f(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$sn=f}),define(ke[61],Se([1,0,78]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var T;(function(R){function p($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=p})(T||(e.ThemeColor=T={}));function g(R){return{id:R}}e.$9j=g;var I;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const n=p.exec(i.id);if(!n)return $(D.$8j.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=$;function y(i){return $(i).join(" ")}R.asClassName=y;function M(i){return"."+$(i).join(".")}R.asCSSSelector=M;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}R.isThemeIcon=C;const m=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(i){const n=m.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=w;function S(i){return{id:i}}R.fromId=S;function l(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}R.modify=l;function f(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=f;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=s})(I||(e.ThemeIcon=I={}))}),define(ke[164],Se([1,0,123,13,61]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const I="$(",R=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${R.source}`,"g");function $(s){return s.replace(p,(i,n)=>n?i:`\\${i}`)}e.$0j=$;const y=new RegExp(`\\\\${R.source}`,"g");function M(s){return s.replace(y,i=>`\\${i}`)}e.$$j=M;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function m(s){return s.indexOf(I)===-1?s:s.replace(C,(i,n,o,a)=>o?i:n||a||"")}e.$_j=m;function w(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$ak=w;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(s){S.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=S.lastIndex,t=S.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let d=0;d<r.length;d++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$bk=l;function f(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$Wj)(s,o,n);const t=(0,T.$Pe)(o," "),r=o.length-t.length,d=(0,D.$Wj)(s,t,n);if(d)for(const u of d){const c=a[u.start+r]+r;u.start+=c,u.end+=c}return d}e.$ck=f}),define(ke[124],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=e.$Ee=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function T(I){return I<0?0:I>255?255:I|0}e.$Ee=T;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Fe=g}),define(ke[30],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(g){return D.test(g)}e.$lg=T,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(p){for(let $=0;$<p.length;$++)p[$]=Math.floor(Math.random()*256);return p};const I=new Uint8Array(16),R=[];for(let p=0;p<256;p++)R.push(p.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+="-",y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y+=R[I[$++]],y}}()}),define(ke[165],Se([1,0,19,52,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=e.$at=e.$_s=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$_s=I;function R(C,m,w){const S={id:(0,g.$mg)(),name:C,uri:m,data:w};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$at=R;class p{constructor(){this.a=new Map}get size(){let m=0;for(const w of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const w=[...this.a.keys()];return T.Iterable.some(this,([S,l])=>l.asFile())&&w.push("files"),M($(m),w)}get(m){return this.a.get(this.b(m))?.[0]}append(m,w){const S=this.a.get(m);S?S.push(w):this.a.set(this.b(m),[w])}replace(m,w){this.a.set(this.b(m),[w])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,w]of this.a)for(const S of w)yield[m,S]}b(m){return $(m)}}e.$bt=p;function $(C){return C.toLowerCase()}function y(C,m){return M($(C),m.map($))}e.$ct=y;function M(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const w=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[S,l,f]=w;return f==="*"?m.some(s=>s.startsWith(l+"/")):!1}e.$dt=Object.freeze({create:C=>(0,D.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$dt.split(C).filter(m=>!m.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=e.$og=void 0;function T(p,$,y,M=1){let C=!1;return new Promise(m=>{const w=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(p,$,M,S=>{if(!C)return C=!0,clearTimeout(w),m(S)})})}e.$og=T;function g(p,$,y,M){if($===0)return M(0);const C=new D.Socket;C.once("connect",()=>(R(C),g(p+y,$-1,y,M))),C.once("data",()=>{}),C.once("error",m=>(R(C),m.code!=="ECONNREFUSED"?g(p+y,$-1,y,M):M(p))),C.connect(p,"127.0.0.1")}e.$pg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(p,$,y,M="127.0.0.1"){let C=!1,m,w=1;const S=D.createServer({pauseOnConnect:!0});function l(f,s){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),s(f))}return new Promise(f=>{m=setTimeout(()=>{l(0,f)},y),S.on("listening",()=>{l(p,f)}),S.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&w<$?(p++,w++,S.listen(p,M)):l(0,f)}),S.on("close",()=>{l(0,f)}),S.listen(p,M)})}e.$qg=I;function R(p){try{p.removeAllListeners("connect"),p.removeAllListeners("error"),p.end(),p.destroy(),p.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=e.$4s=void 0;class T{constructor(p){const $=(0,D.$Ee)(p);this.c=$,this.a=T.d($),this.b=new Map}static d(p){const $=new Uint8Array(256);return $.fill(p),$}set(p,$){const y=(0,D.$Ee)($);p>=0&&p<256?this.a[p]=y:this.b.set(p,y)}get(p){return p>=0&&p<256?this.a[p]:this.b.get(p)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$4s=T;var g;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new T(0)}add(p){this.a.set(p,1)}has(p){return this.a.get(p)===1}clear(){return this.a.clear()}}e.$5s=I}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function T(g){let I=0,R=0,p=0,$=0;for(let y=0,M=g.length;y<M;y++){const C=g.charCodeAt(y);C===13?(I===0&&(R=y),I++,y+1<M&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,p=y+1):C===10&&($|=1,I===0&&(R=y),I++,p=y+1)}return I===0&&(R=g.length),[I,R,g.length-p,$]}e.$gt=T}),define(ke[49],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const R=g.lineNumber|0,p=I.lineNumber|0;if(R===p){const $=g.column|0,y=I.column|0;return $-y}return R-p}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Fs=D}),define(ke[29],Se([1,0,49]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0;class T{constructor(I,R,p,$){I>p||I===p&&R>$?(this.startLineNumber=p,this.startColumn=$,this.endLineNumber=I,this.endColumn=R):(this.startLineNumber=I,this.startColumn=R,this.endLineNumber=p,this.endColumn=$)}isEmpty(){return T.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return T.containsPosition(this,I)}static containsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<I.startColumn||R.lineNumber===I.endLineNumber&&R.column>I.endColumn)}static strictContainsPosition(I,R){return!(R.lineNumber<I.startLineNumber||R.lineNumber>I.endLineNumber||R.lineNumber===I.startLineNumber&&R.column<=I.startColumn||R.lineNumber===I.endLineNumber&&R.column>=I.endColumn)}containsRange(I){return T.containsRange(this,I)}static containsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>I.endColumn)}strictContainsRange(I){return T.strictContainsRange(this,I)}static strictContainsRange(I,R){return!(R.startLineNumber<I.startLineNumber||R.endLineNumber<I.startLineNumber||R.startLineNumber>I.endLineNumber||R.endLineNumber>I.endLineNumber||R.startLineNumber===I.startLineNumber&&R.startColumn<=I.startColumn||R.endLineNumber===I.endLineNumber&&R.endColumn>=I.endColumn)}plusRange(I){return T.plusRange(this,I)}static plusRange(I,R){let p,$,y,M;return R.startLineNumber<I.startLineNumber?(p=R.startLineNumber,$=R.startColumn):R.startLineNumber===I.startLineNumber?(p=R.startLineNumber,$=Math.min(R.startColumn,I.startColumn)):(p=I.startLineNumber,$=I.startColumn),R.endLineNumber>I.endLineNumber?(y=R.endLineNumber,M=R.endColumn):R.endLineNumber===I.endLineNumber?(y=R.endLineNumber,M=Math.max(R.endColumn,I.endColumn)):(y=I.endLineNumber,M=I.endColumn),new T(p,$,y,M)}intersectRanges(I){return T.intersectRanges(this,I)}static intersectRanges(I,R){let p=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,M=I.endColumn;const C=R.startLineNumber,m=R.startColumn,w=R.endLineNumber,S=R.endColumn;return p<C?(p=C,$=m):p===C&&($=Math.max($,m)),y>w?(y=w,M=S):y===w&&(M=Math.min(M,S)),p>y||p===y&&$>M?null:new T(p,$,y,M)}equalsRange(I){return T.equalsRange(this,I)}static equalsRange(I,R){return!I&&!R?!0:!!I&&!!R&&I.startLineNumber===R.startLineNumber&&I.startColumn===R.startColumn&&I.endLineNumber===R.endLineNumber&&I.endColumn===R.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(I){return new D.$Fs(I.endLineNumber,I.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(I){return new D.$Fs(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,R){return new T(this.startLineNumber,this.startColumn,I,R)}setStartPosition(I,R){return new T(I,R,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(I){return new T(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(I){return new T(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new T(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,R=I){return new T(I.lineNumber,I.column,R.lineNumber,R.column)}static lift(I){return I?new T(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<I.startColumn)}static areIntersecting(I,R){return!(I.endLineNumber<R.startLineNumber||I.endLineNumber===R.startLineNumber&&I.endColumn<=R.startColumn||R.endLineNumber<I.startLineNumber||R.endLineNumber===I.startLineNumber&&R.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,R){if(I&&R){const y=I.startLineNumber|0,M=R.startLineNumber|0;if(y===M){const C=I.startColumn|0,m=R.startColumn|0;if(C===m){const w=I.endLineNumber|0,S=R.endLineNumber|0;if(w===S){const l=I.endColumn|0,f=R.endColumn|0;return l-f}return w-S}return C-m}return y-M}return(I?1:0)-(R?1:0)}static compareRangesUsingEnds(I,R){return I.endLineNumber===R.endLineNumber?I.endColumn===R.endColumn?I.startLineNumber===R.startLineNumber?I.startColumn-R.startColumn:I.startLineNumber-R.startLineNumber:I.endColumn-R.endColumn:I.endLineNumber-R.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Gs=T}),define(ke[168],Se([1,0,29]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0;class T{static insert(I,R){return{range:new D.$Gs(I.lineNumber,I.column,I.lineNumber,I.column),text:R,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,R){return{range:I,text:R}}static replaceMove(I,R){return{range:I,text:R,forceMoveMarkers:!0}}}e.$Hs=T}),define(ke[169],Se([1,0,49,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.SelectionDirection=void 0;var g;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends T.$Gs{constructor(p,$,y,M){super(p,$,y,M),this.selectionStartLineNumber=p,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=M}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(p){return I.selectionsEqual(this,p)}static selectionsEqual(p,$){return p.selectionStartLineNumber===$.selectionStartLineNumber&&p.selectionStartColumn===$.selectionStartColumn&&p.positionLineNumber===$.positionLineNumber&&p.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(p,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,p,$):new I(p,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Fs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Fs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(p,$){return this.getDirection()===0?new I(p,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,p,$)}static fromPositions(p,$=p){return new I(p.lineNumber,p.column,$.lineNumber,$.column)}static fromRange(p,$){return $===0?new I(p.startLineNumber,p.startColumn,p.endLineNumber,p.endColumn):new I(p.endLineNumber,p.endColumn,p.startLineNumber,p.startColumn)}static liftSelection(p){return new I(p.selectionStartLineNumber,p.selectionStartColumn,p.positionLineNumber,p.positionColumn)}static selectionsArrEqual(p,$){if(p&&!$||!p&&$)return!1;if(!p&&!$)return!0;if(p.length!==$.length)return!1;for(let y=0,M=p.length;y<M;y++)if(!this.selectionsEqual(p[y],$[y]))return!1;return!0}static isISelection(p){return p&&typeof p.selectionStartLineNumber=="number"&&typeof p.selectionStartColumn=="number"&&typeof p.positionLineNumber=="number"&&typeof p.positionColumn=="number"}static createWithDirection(p,$,y,M,C){return C===0?new I(p,$,y,M):new I(y,M,p,$)}}e.$Is=I}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=void 0,e.$ds={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7s=e.$6s=e.WordCharacterClass=void 0;var T;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class g extends D.$4s{constructor(p){super(0);for(let $=0,y=p.length;$<y;$++)this.set(p.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$6s=g;function I(R){const p={};return $=>(p.hasOwnProperty($)||(p[$]=R($)),p[$])}e.$7s=I(R=>new g(R))}),define(ke[126],Se([1,0,52,3,75]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0,e.$es="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const w of e.$es)C.indexOf(w)>=0||(m+="\\"+w);return m+="\\s]+)",new RegExp(m,"g")}e.$fs=I();function R(C){let m=e.$fs;if(C&&C instanceof RegExp)if(C.global)m=C;else{let w="g";C.ignoreCase&&(w+="i"),C.multiline&&(w+="m"),C.unicode&&(w+="u"),m=new RegExp(C.source,w)}return m.lastIndex=0,m}e.$gs=R;const p=new g.$3c;p.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=p.unshift(C);return(0,T.$Qc)(m)}e.$hs=$;function y(C,m,w,S,l){if(m=R(m),l||(l=D.Iterable.first(p)),w.length>l.maxLen){let o=C-l.maxLen/2;return o<0?o=0:S+=o,w=w.substring(o,C+l.maxLen/2),y(C,m,w,S,l)}const f=Date.now(),s=C-1-S;let i=-1,n=null;for(let o=1;!(Date.now()-f>=l.timeBudget);o++){const a=s-l.windowSize*o;m.lastIndex=Math.max(0,a);const t=M(m,w,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return m.lastIndex=0,o}return null}e.$is=y;function M(C,m,w,S){let l;for(;l=C.exec(m);){const f=l.index||0;if(f<=w&&C.lastIndex>=w)return l;if(S>0&&f>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Dt=e.IndentAction=void 0;var D;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class T{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let $=0,y=p.notIn.length;$<y;$++)switch(p.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,$){if(p.getTokenCount()===0)return!0;const y=p.findTokenIndexAtOffset($-2),M=p.getStandardTokenType(y);return this.isOK(M)}g(p,$){for(let y=p;y<=$;y++){const M=String.fromCharCode(y);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Dt=T;class g{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of p)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Et=g;function I(R,p,$){R.has(p)?R.get(p).push($):R.set(p,[$])}}),define(ke[173],Se([1,0,125]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lZ=e.$kZ=e.$jZ=e.State=void 0;var T;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class g{constructor(S,l,f){const s=new Uint8Array(S*l);for(let i=0,n=S*l;i<n;i++)s[i]=f;this.a=s,this.rows=S,this.cols=l}get(S,l){return this.a[S*this.cols+l]}set(S,l,f){this.a[S*this.cols+l]=f}}class I{constructor(S){let l=0,f=0;for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];a>l&&(l=a),o>f&&(f=o),t>f&&(f=t)}l++,f++;const s=new g(f,l,0);for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];s.set(o,a,t)}this.a=s,this.b=l}nextState(S,l){return l<0||l>=this.b?0:this.a.get(S,l)}}e.$jZ=I;let R=null;function p(){return R===null&&(R=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function M(){if(y===null){y=new D.$4s(0);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<w.length;l++)y.set(w.charCodeAt(l),1);const S=".,;:";for(let l=0;l<S.length;l++)y.set(S.charCodeAt(l),2)}return y}class C{static a(S,l,f,s,i){let n=i-1;do{const o=l.charCodeAt(n);if(S.get(o)!==2)break;n--}while(n>s);if(s>0){const o=l.charCodeAt(s-1),a=l.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:f,startColumn:s+1,endLineNumber:f,endColumn:n+2},url:l.substring(s,n+1)}}static computeLinks(S,l=p()){const f=M(),s=[];for(let i=1,n=S.getLineCount();i<=n;i++){const o=S.getLineContent(i),a=o.length;let t=0,r=0,d=0,u=1,c=!1,h=!1,k=!1,L=!1;for(;t<a;){let v=!1;const b=o.charCodeAt(t);if(u===13){let E;switch(b){case 40:c=!0,E=0;break;case 41:E=c?0:1;break;case 91:k=!0,h=!0,E=0;break;case 93:k=!1,E=h?0:1;break;case 123:L=!0,E=0;break;case 125:E=L?0:1;break;case 39:case 34:case 96:d===b?E=1:d===39||d===34||d===96?E=0:E=1;break;case 42:E=d===42?1:0;break;case 124:E=d===124?1:0;break;case 32:E=k?0:1;break;default:E=f.get(b)}E===1&&(s.push(C.a(f,o,i,r,t)),v=!0)}else if(u===12){let E;b===91?(h=!0,E=0):E=f.get(b),E===1?v=!0:u=13}else u=l.nextState(u,b),u===0&&(v=!0);v&&(u=1,c=!1,h=!1,L=!1,r=t+1,d=b),t++}u===13&&s.push(C.a(f,o,i,r,a))}return s}}e.$kZ=C;function m(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:C.computeLinks(w)}e.$lZ=m}),define(ke[79],Se([1,0,24]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.ModelConstants=e.PositionAffinity=e.$Zu=e.TrackedRangeStickiness=e.$Yu=e.$Xu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var g;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var R;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var $;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class M{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$ln)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Xu=M;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Yu=C;var m;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function w(o){return o&&typeof o.read=="function"}e.$Zu=w;var S;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var l;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class f{constructor(a,t,r,d,u,c){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.$1u=f;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$2u=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$3u=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$4u=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.NodeColor=e.$AB=void 0;class D{constructor(f,s){this.piece=f,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$BB)return g(this.right);let f=this;for(;f.parent!==e.$BB&&f.parent.left!==f;)f=f.parent;return f.parent===e.$BB?e.$BB:f.parent}prev(){if(this.left!==e.$BB)return I(this.left);let f=this;for(;f.parent!==e.$BB&&f.parent.right!==f;)f=f.parent;return f.parent===e.$BB?e.$BB:f.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$AB=D;var T;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$BB=new D(null,0),e.$BB.parent=e.$BB,e.$BB.left=e.$BB,e.$BB.right=e.$BB,e.$BB.color=0;function g(l){for(;l.left!==e.$BB;)l=l.left;return l}e.$CB=g;function I(l){for(;l.right!==e.$BB;)l=l.right;return l}e.$DB=I;function R(l){return l===e.$BB?0:l.size_left+l.piece.length+R(l.right)}function p(l){return l===e.$BB?0:l.lf_left+l.piece.lineFeedCnt+p(l.right)}function $(){e.$BB.parent=e.$BB}function y(l,f){const s=f.right;s.size_left+=f.size_left+(f.piece?f.piece.length:0),s.lf_left+=f.lf_left+(f.piece?f.piece.lineFeedCnt:0),f.right=s.left,s.left!==e.$BB&&(s.left.parent=f),s.parent=f.parent,f.parent===e.$BB?l.root=s:f.parent.left===f?f.parent.left=s:f.parent.right=s,s.left=f,f.parent=s}e.$EB=y;function M(l,f){const s=f.left;f.left=s.right,s.right!==e.$BB&&(s.right.parent=f),s.parent=f.parent,f.size_left-=s.size_left+(s.piece?s.piece.length:0),f.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),f.parent===e.$BB?l.root=s:f===f.parent.right?f.parent.right=s:f.parent.left=s,s.right=f,f.parent=s}e.$FB=M;function C(l,f){let s,i;if(f.left===e.$BB?(i=f,s=i.right):f.right===e.$BB?(i=f,s=i.left):(i=g(f.right),s=i.right),i===l.root){l.root=s,s.color=0,f.detach(),$(),l.root.parent=e.$BB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===f?(s.parent=i.parent,S(l,s)):(i.parent===f?s.parent=i:s.parent=i.parent,S(l,s),i.left=f.left,i.right=f.right,i.parent=f.parent,i.color=f.color,f===l.root?l.root=i:f===f.parent.left?f.parent.left=i:f.parent.right=i,i.left!==e.$BB&&(i.left.parent=i),i.right!==e.$BB&&(i.right.parent=i),i.size_left=f.size_left,i.lf_left=f.lf_left,S(l,i)),f.detach(),s.parent.left===s){const a=R(s),t=p(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,d=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,w(l,s.parent,r,d)}}if(S(l,s.parent),n){$();return}let o;for(;s!==l.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,y(l,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,M(l,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,y(l,s.parent),s=l.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,M(l,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,y(l,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,M(l,s.parent),s=l.root));s.color=0,$()}e.$GB=C;function m(l,f){for(S(l,f);f!==l.root&&f.parent.color===1;)if(f.parent===f.parent.parent.left){const s=f.parent.parent.right;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.right&&(f=f.parent,y(l,f)),f.parent.color=0,f.parent.parent.color=1,M(l,f.parent.parent))}else{const s=f.parent.parent.left;s.color===1?(f.parent.color=0,s.color=0,f.parent.parent.color=1,f=f.parent.parent):(f===f.parent.left&&(f=f.parent,M(l,f)),f.parent.color=0,f.parent.parent.color=1,y(l,f.parent.parent))}l.root.color=0}e.$HB=m;function w(l,f,s,i){for(;f!==l.root&&f!==e.$BB;)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}e.$IB=w;function S(l,f){let s=0,i=0;if(f!==l.root){for(;f!==l.root&&f===f.parent.right;)f=f.parent;if(f!==l.root)for(f=f.parent,s=R(f.left)-f.size_left,i=p(f.left)-f.lf_left,f.size_left+=s,f.lf_left+=i;f!==l.root&&(s!==0||i!==0);)f.parent.left===f&&(f.parent.size_left+=s,f.parent.lf_left+=i),f=f.parent}}e.$JB=S}),define(ke[175],Se([1,0,19,124]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9u=e.$8u=e.$7u=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,T.$Fe)($);const M=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(M.length+m),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,T.$Fe)($),y=(0,T.$Fe)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,T.$Fe)($),y=(0,T.$Fe)(y);const M=this.a,C=this.b;if($>=M.length)return!1;const m=M.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(M.length-y),this.a.set(M.subarray(0,$),0),this.a.set(M.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,T.$Fe)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let M=y;M<=$;M++)this.b[M]=this.b[M-1]+this.a[M];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,M=this.a.length-1,C=0,m=0,w=0;for(;y<=M;)if(C=y+(M-y)/2|0,m=this.b[C],w=m-this.a[C],$<w)M=C-1;else if($>=m)y=C+1;else break;return new R(C,$-w)}}e.$7u=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],M=y>0?this.d[y-1]:0;return new R(y,$-M)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const M=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+M;for(let m=0;m<M;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$8u=I;class R{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$9u=R}),define(ke[176],Se([1,0,13,49,175]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=void 0;class I{constructor(p,$,y,M){this.d=p,this.f=$,this.g=y,this.h=M,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(p){p.eol&&p.eol!==this.g&&(this.g=p.eol,this.j=null);const $=p.changes;for(const y of $)this.o(y.range),this.p(new T.$Fs(y.range.startLineNumber,y.range.startColumn),y.text);this.h=p.versionId,this.k=null}l(){if(!this.j){const p=this.g.length,$=this.f.length,y=new Uint32Array($);for(let M=0;M<$;M++)y[M]=this.f[M].length+p;this.j=new g.$7u(y)}}n(p,$){this.f[p]=$,this.j&&this.j.setValue(p,this.f[p].length+this.g.length)}o(p){if(p.startLineNumber===p.endLineNumber){if(p.startColumn===p.endColumn)return;this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.startLineNumber-1].substring(p.endColumn-1));return}this.n(p.startLineNumber-1,this.f[p.startLineNumber-1].substring(0,p.startColumn-1)+this.f[p.endLineNumber-1].substring(p.endColumn-1)),this.f.splice(p.startLineNumber,p.endLineNumber-p.startLineNumber),this.j&&this.j.removeValues(p.startLineNumber,p.endLineNumber-p.startLineNumber)}p(p,$){if($.length===0)return;const y=(0,D.$Ve)($);if(y.length===1){this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+y[0]+this.f[p.lineNumber-1].substring(p.column-1));return}y[y.length-1]+=this.f[p.lineNumber-1].substring(p.column-1),this.n(p.lineNumber-1,this.f[p.lineNumber-1].substring(0,p.column-1)+y[0]);const M=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(p.lineNumber+C-1,0,y[C]),M[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(p.lineNumber,M)}}e.$0u=I}),define(ke[99],Se([1,0,13,171,49,29,79]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PB=e.$OB=e.$NB=e.$MB=e.$LB=e.$KB=void 0;const p=999;class ${constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Te(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new R.$2u(n,this.wordSeparators?(0,T.$7s)(this.wordSeparators):null,o?this.searchString:null)}}e.$KB=$;function y(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$LB=y;function M(s,i,n){if(!n)return new R.$Yu(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new R.$Yu(s,o)}e.$MB=M;class C{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class m{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new f(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let d,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),d=n+t+u):d=n+t;let c;if(a){const v=a.findLineFeedCountBeforeOffset(t+r.length)-u;c=d+r.length+v}else c=d+r.length;const h=i.getPositionAt(d),k=i.getPositionAt(c);return new I.$Gs(h.lineNumber,h.column,k.lineNumber,k.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new C(d):null,c=[];let h=0,k;for(o.reset(0);k=o.next(d);)if(c[h++]=M(this.a(i,r,d,u,k.index,k[0]),k,a),h>=t)return c;return c}static c(i,n,o,a,t){const r=[];let d=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(o,c,n.startLineNumber,n.startColumn-1,d,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(o,u,n.startLineNumber,n.startColumn-1,d,r,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&d<t;c++)d=this.d(o,i.getLineContent(c),c,0,d,r,a,t);if(d<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(o,c,n.endLineNumber,0,d,r,a,t)}return r}static d(i,n,o,a,t,r,d,u){const c=i.wordSeparators;if(!d&&i.simpleSearch){const L=i.simpleSearch,v=L.length,b=n.length;let E=-v;for(;(E=n.indexOf(L,E+v))!==-1;)if((!c||l(c,n,b,E,v))&&(r[t++]=new R.$Yu(new I.$Gs(o,E+1+a,o,E+1+v+a),null),t>=u))return t;return t}const h=new f(i.wordSeparators,i.regex);let k;h.reset(0);do if(k=h.next(n),k&&(r[t++]=M(new I.$Gs(o,k.index+1+a,o,k.index+1+k[0].length+a),k,d),t>=u))return t;while(k);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new g.$Fs(n.lineNumber,1),r=i.getOffsetAt(t),d=i.getLineCount(),u=i.getValueInRange(new I.$Gs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),c=i.getEOL()===`\r
`?new C(u):null;o.reset(n.column-1);const h=o.next(u);return h?M(this.a(i,r,u,c,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new g.$Fs(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r),u=this.g(o,d,r,n.column,a);if(u)return u;for(let c=1;c<=t;c++){const h=(r+c-1)%t,k=i.getLineContent(h+1),L=this.g(o,k,h+1,1,a);if(L)return L}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?M(new I.$Gs(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new f(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new I.$Gs(1,1,n.lineNumber,n.column),o,a,10*p);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new g.$Fs(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,d=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,d,r,a);if(u)return u;for(let c=1;c<=t;c++){const h=(t+r-c-1)%t,k=i.getLineContent(h+1),L=this.k(o,k,h+1,a);if(L)return L}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=M(new I.$Gs(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$NB=m;function w(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function S(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function l(s,i,n,o,a){return w(s,i,n,o,a)&&S(s,i,n,o,a)}e.$OB=l;class f{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){D.$cf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||l(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$PB=f}),define(ke[127],Se([1,0,49,29,79,174,99]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UB=e.$TB=e.$SB=e.$RB=e.$QB=void 0;const p=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function M(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?$(n):n}e.$QB=M;function C(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,c=i.length;u<c;u++){const h=i.charCodeAt(u);h===13?u+1<c&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):h===10?(a++,s[n++]=u+1):r&&h!==9&&(h<32||h>126)&&(r=!1)}const d=new y($(s),o,a,t,r);return s.length=0,d}e.$RB=C;class m{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$SB=m;class w{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$TB=w;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==I.$BB&&i.iterate(i.root,o=>(o!==I.$BB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class f{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=I.$BB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=M(i[t].buffer));const d=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const d=[];if(this.iterate(this.root,u=>{const c=this.R(u),h=c.length;if(r<=o||r+h<a)return t+=c,r+=h,!0;const k=t.replace(/\r\n|\r|\n/g,i);return d.push(new w(k,M(k))),t=c,r=h,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);d.push(new w(u,M(u)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===I.$BB)return!0;const t=this.R(a),r=t.length,d=i.G(n),u=i.G(n+r),c=i.getValueInRange2(d,u);return n+=r,t===c})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==I.$BB;)if(a.left!==I.$BB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==I.$BB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),d=a-r;return new D.$Fs(o+1,d+1)}return new D.$Fs(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===I.$BB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new D.$Fs(o+1,r+1)}else n=n.right;return new D.$Fs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,u=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return u.substring(c+i.remainder,c+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==I.$BB;){const d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=d.substring(u,u+n.remainder);break}else r+=d.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===I.$BB)return!0;const r=t.piece;let d=r.length;if(d===0)return!0;const u=this.a[r.bufferIndex].buffer,c=this.a[r.bufferIndex].lineStarts,h=r.start.line,k=r.end.line;let L=c[h]+r.start.column;if(a&&(u.charCodeAt(L)===10&&(L++,d--),i[n++]=o,o="",a=!1,d===0))return!0;if(h===k)return!this.f&&u.charCodeAt(L+d-1)===13?(a=!0,o+=u.substr(L,d-1)):o+=u.substr(L,d),!0;o+=this.f?u.substring(L,Math.max(L,c[h+1]-this.e)):u.substring(L,c[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let v=h+1;v<k;v++)o=this.f?u.substring(c[v],c[v+1]-this.e):u.substring(c[v],c[v+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(c[k]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(c[k],r.end.column-1)):o=u.substr(c[k],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,d,u,c,h,k){const L=this.a[i.piece.bufferIndex],v=this.u(i.piece.bufferIndex,i.piece.start),b=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,r);let A;const z={line:0,column:0};let O,P;n._wordSeparators?(O=L.buffer.substring(b,E),P=j=>j+b,n.reset(0)):(O=L.buffer,P=j=>j,n.reset(b));do if(A=n.next(O),A){if(P(A.index)>=E)return h;this.s(i,P(A.index)-v,z);const j=this.t(i.piece.bufferIndex,t,z),N=z.line===t.line?z.column-t.column+a:z.column+1,F=N+A[0].length;if(k[h++]=(0,R.$MB)(new T.$Gs(o+j,N,o+j,F),A,u),P(A.index)+A[0].length>=E||h>=c)return h}while(A);return h}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const d=new R.$PB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let h=this.s(u.node,u.remainder);const k=this.s(c.node,c.remainder);if(u.node===c.node)return this.findMatchesInNode(u.node,d,i.startLineNumber,i.startColumn,h,k,n,o,a,r,t),t;let L=i.startLineNumber,v=u.node;for(;v!==c.node;){const E=this.t(v.piece.bufferIndex,h,v.piece.end);if(E>=1){const z=this.a[v.piece.bufferIndex].lineStarts,O=this.u(v.piece.bufferIndex,v.piece.start),P=z[h.line+E],j=L===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(v,d,L,j,h,this.s(v,P-O),n,o,a,r,t),r>=a)return t;L+=E}const A=L===i.startLineNumber?i.startColumn-1:0;if(L===i.endLineNumber){const z=this.getLineContent(L).substring(A,i.endColumn-1);return r=this.n(n,d,z,i.endLineNumber,A,r,t,o,a),t}if(r=this.n(n,d,this.getLineContent(L).substr(A),L,A,r,t,o,a),r>=a)return t;L++,u=this.H(L,1),v=u.node,h=this.s(u.node,u.remainder)}if(L===i.endLineNumber){const E=L===i.startLineNumber?i.startColumn-1:0,A=this.getLineContent(L).substring(E,i.endColumn-1);return r=this.n(n,d,A,i.endLineNumber,E,r,t,o,a),t}const b=L===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(c.node,d,L,b,h,k,n,o,a,r,t),t}n(i,n,o,a,t,r,d,u,c){const h=i.wordSeparators;if(!u&&i.simpleSearch){const L=i.simpleSearch,v=L.length,b=o.length;let E=-v;for(;(E=o.indexOf(L,E+v))!==-1;)if((!h||(0,R.$OB)(h,o,b,E,v))&&(d[r++]=new g.$Yu(new T.$Gs(a,E+1+t,a,E+1+v+t),null),r>=c))return r;return r}let k;n.reset(0);do if(k=n.next(o),k&&(d[r++]=(0,R.$MB)(new T.$Gs(a,k.index+1+t,a,k.index+1+k[0].length+t),k,u),r>=c))return r;while(k);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==I.$BB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),d=a.piece,u=d.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&r+d.length===i&&n.length<p){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const h=[];let k=new m(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(u,d.end)-this.u(u,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const E={line:k.start.line+1,column:0};k=new m(k.bufferIndex,E,k.end,this.t(k.bufferIndex,E,k.end),k.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const E=this.s(a,t-1);this.C(a,E),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,c);else this.C(a,c);const L=this.w(n);k.length>0&&this.S(a,k);let v=a;for(let b=0;b<L.length;b++)v=this.S(v,L[b]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===I.$BB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const L=this.s(t,o.remainder),v=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const b=t.next();(0,I.$GB)(this,t),this.N(b),this.y();return}this.D(t,v),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,L),this.O(t),this.y();return}this.E(t,L,v),this.y();return}const d=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&d.push(t);const c=this.s(r,a.remainder);this.D(r,c),r.piece.length===0&&d.push(r);const h=t.next();for(let L=h;L!==I.$BB&&L!==r;L=L.next())d.push(L);const k=t.piece.length===0?t.prev():t;this.v(d),this.O(k),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,d={line:r.start.line+1,column:0},u=new m(r.bufferIndex,d,r.end,this.t(r.bufferIndex,d,r.end),r.length-1);n.piece=u,i+=`
`,(0,I.$IB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let c=a.start.line,h=a.end.line,k=0,L=0,v=0;for(;c<=h&&(k=c+(h-c)/2|0,v=r[k],k!==h);)if(L=r[k+1],u<v)h=k-1;else if(u>=L)c=k+1;else break;return o?(o.line=k,o.column=u-v,null):{line:k,column:u-v}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const d=r-1;return this.a[i].buffer.charCodeAt(d)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,I.$GB)(this,i[n])}w(i){if(i.length>p){const h=[];for(;i.length>p;){const L=i.charCodeAt(p-1);let v;L===13||L>=55296&&L<=56319?(v=i.substring(0,p-1),i=i.substring(p-1)):(v=i.substring(0,p),i=i.substring(p));const b=M(v);h.push(new m(this.a.length,{line:0,column:0},{line:b.length-1,column:v.length-b[b.length-1]},b.length-1,v.length)),this.a.push(new w(v,b))}const k=M(i);return h.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new w(i,k)),h}let n=this.a[0].buffer.length;const o=M(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<o.length;h++)o[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<o.length;h++)o[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[r],u={line:r,column:d},c=new m(0,a,u,this.t(0,a,u),t-n);return this.g=u,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),d=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=d.substring(u+r,u+o.piece.length);else{const c=this.B(o,i-t.nodeStartLineNumber);return d.substring(u+r,u+c-n)}}else{let r=0;const d=i;for(;o!==I.$BB;)if(o.left!==I.$BB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),c=this.B(o,i-o.lf_left-1),h=this.a[o.piece.bufferIndex].buffer,k=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:d-(i-1-o.lf_left)}),h.substring(k+u,k+c-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),c=this.a[o.piece.bufferIndex].buffer,h=this.u(o.piece.bufferIndex,o.piece.start);a=c.substring(h+u,h+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==I.$BB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const d=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+d-n),a}else{const d=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(d,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==I.$BB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,d=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),c=u-a,h=d-t,k=o.length+h;i.piece=new m(o.bufferIndex,o.start,r,u,k),(0,I.$IB)(this,i,h,c)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,d=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),c=d-a,h=t-u,k=o.length+h;i.piece=new m(o.bufferIndex,r,o.end,d,k),(0,I.$IB)(this,i,h,c)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,d=a.length,u=a.lineFeedCnt,c=n,h=this.t(a.bufferIndex,a.start,c),k=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new m(a.bufferIndex,a.start,c,h,k),(0,I.$IB)(this,i,k-d,h-u);const L=new m(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),v=this.S(i,L);this.N(v)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=M(n,!1);for(let v=0;v<t.length;v++)t[v]+=a;if(o){const v=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-v}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:d},c=i.piece.length+n.length,h=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,u),L=k-h;i.piece=new m(i.piece.bufferIndex,i.piece.start,u,k,c),this.g=u,(0,I.$IB)(this,i,n.length,L)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==I.$BB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==I.$BB;)if(o.left!==I.$BB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==I.$BB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$BB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$BB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,d,r),(0,I.$IB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},c=n.piece.length-1,h=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new m(n.piece.bufferIndex,u,n.piece.end,h,c),(0,I.$IB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const k=this.w(`\r
`);this.S(i,k[0]);for(let L=0;L<o.length;L++)(0,I.$GB)(this,o[L])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,I.$GB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,d=this.t(a.bufferIndex,t,a.end);o.piece=new m(a.bufferIndex,t,a.end,d,r),(0,I.$IB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===I.$BB)return n(I.$BB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===I.$BB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new I.$AB(n,1);if(o.left=I.$BB,o.right=I.$BB,o.parent=I.$BB,o.size_left=0,o.lf_left=0,this.root===I.$BB)this.root=o,o.color=0;else if(i.right===I.$BB)i.right=o,o.parent=i;else{const t=(0,I.$CB)(i.right);t.left=o,o.parent=t}return(0,I.$HB)(this,o),o}T(i,n){const o=new I.$AB(n,1);if(o.left=I.$BB,o.right=I.$BB,o.parent=I.$BB,o.size_left=0,o.lf_left=0,this.root===I.$BB)this.root=o,o.color=0;else if(i.left===I.$BB)i.left=o,o.parent=i;else{const a=(0,I.$DB)(i.left);a.right=o,o.parent=a}return(0,I.$HB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$UB=f}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7=e.$07=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const R=this.a.get(I);return this.a.delete(I),R}}addDragOperationTransfer(I,R){this.a.set(I,R)}}e.$07=D;class T{constructor(I){this.identifier=I}}e.$$7=T}),define(ke[178],Se([1,0,4,3]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Sd,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,$){return this.a.set(p,$),this.handleChange([p]),(0,T.$Qc)(()=>{this.a.get(p)===$&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,$){this.b.get(p)?.dispose();const y=new I(this,p,$);return this.b.set(p,y),(0,T.$Qc)(()=>{const M=this.b.get(p);!M||M!==y||(this.b.delete(p),M.dispose())})}async getOrCreate(p){const $=this.get(p);if($)return $;const y=this.b.get(p);return!y||y.isResolved?null:(await y.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const y=this.b.get(p);return!!(!y||y.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ft=g;class I extends T.$Sc{get isResolved(){return this.c}constructor(p,$,y){super(),this.f=p,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(ke[179],Se([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class I extends T.$Sc{constructor(m,w="",S="",l=!0,f){super(),this.h=this.B(new D.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=w,this.u=S,this.w=l,this.C=f}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,w){this.C&&await this.C(m)}}e.$Gi=I;class R extends T.$Sc{constructor(){super(...arguments),this.f=this.B(new D.$Sd),this.onWillRun=this.f.event,this.m=this.B(new D.$Sd),this.onDidRun=this.m.event}async run(m,w){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,w)}catch(l){S=l}this.m.fire({action:m,error:S})}async u(m,w){await m.run(w)}}e.$Hi=R;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let w=[];for(const S of m)S.length&&(w.length?w=[...w,new p,...S]:w=S);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$Ii=p;class ${get actions(){return this.a}constructor(m,w,S,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=w,this.class=l,this.a=S}async run(){}}e.$Ji=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Ki=y;function M(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Li=M}),define(ke[181],Se([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0;const T=60,g=T*60,I=g*24,R=I*7,p=I*30,$=I*365;function y(C,m,w,S){typeof C!="number"&&(C=C.getTime());const l=Math.round((new Date().getTime()-C)/1e3);if(l<-30)return(0,D.localize)(0,null,y(new Date().getTime()+l*1e3,!1));if(!S&&l<30)return(0,D.localize)(1,null);let f;return l<T?(f=l,m?f===1?w?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):w?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?w?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):w?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):l<g?(f=Math.floor(l/T),m?f===1?w?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):w?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?w?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):w?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):l<I?(f=Math.floor(l/g),m?f===1?w?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):w?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?w?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):w?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):l<R?(f=Math.floor(l/I),m?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):l<p?(f=Math.floor(l/R),m?f===1?w?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):w?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?w?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):w?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):l<$?(f=Math.floor(l/p),m?f===1?w?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):w?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?w?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):w?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(l/$),m?f===1?w?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):w?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?w?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):w?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}e.$qm=y;function M(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$rm=M}),define(ke[183],Se([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,p(C),R(C.stack)||R(C.stacktrace)):p(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function p(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const w=D.$Hb(C),S=$(w[0],m);return w.length>1?g.localize(4,null,S,w.length):S}if(T.$Ef(C))return C;if(C.detail){const w=C.detail;if(w.error)return I(w.error,m);if(w.exception)return I(w.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Mi=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Ni=y;function M(C,m){let w;return typeof C=="string"?w=new Error(C):w=C,w.actions=m,w}e.$Oi=M}),define(ke[184],Se([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,184]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,g=!1,I=!1,R=!1,p=!1,$=!1,y=!1,M=!1,C=!1,m=!1,w,S=e.$g,l=e.$g,f,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,T=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,M=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,$=!0,w=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=w,l=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",g=n.platform==="darwin",I=n.platform==="linux",R=I&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=o,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,w=e.$g,S=e.$g;const b=n.env.VSCODE_NLS_CONFIG;if(b)try{const E=JSON.parse(b),A=E.availableLanguages["*"];w=E.locale,l=E.osLocale,S=A||e.$g,f=E._translationsConfigFile}catch{}p=!0}else console.error("Unable to resolve platform.");var t;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let d=0;g?d=1:T?d=3:I&&(d=2),e.$i=T,e.$j=g,e.$k=I,e.$l=R,e.$m=p,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=M,e.$s=m,e.$t=C,e.$u=d,e.$v=s,e.$w=S;var u;(function(b){function E(){return e.$w}b.value=E;function A(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}b.isDefaultVariant=A;function z(){return e.$w==="en"}b.isDefault=z})(u||(e.Language=u={})),e.$x=w,e.$y=l,e.$z=f,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const b=[];i.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let z=0,O=b.length;z<O;z++){const P=b[z];if(P.id===A.data.vscodeScheduleAsyncWork){b.splice(z,1),P.callback();return}}});let E=0;return A=>{const z=++E;b.push({id:z,callback:A}),i.postMessage({vscodeScheduleAsyncWork:z},"*")}}return b=>setTimeout(b)})();var c;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=g||M?2:T?1:3;let h=!0,k=!1;function L(){if(!k){k=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,h=new Uint16Array(b.buffer)[0]===(2<<8)+1}return h}e.$D=L,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function v(b){return parseFloat(b)>=20}e.$J=v}),define(ke[50],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;T={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$dc=T.platform,e.$ec=T.arch}),define(ke[16],Se([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const T=65,g=97,I=90,R=122,p=46,$=47,y=92,M=58,C=63;class m extends Error{constructor(r,d,u){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=r.indexOf(".")!==-1?"property":"argument";let k=`The "${r}" ${h} ${c} of type ${d}`;k+=`. Received type ${typeof u}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,r){if(t===null||typeof t!="object")throw new m(r,"Object",t)}function S(t,r){if(typeof t!="string")throw new m(r,"string",t)}const l=D.$dc==="win32";function f(t){return t===$||t===y}function s(t){return t===$}function i(t){return t>=T&&t<=I||t>=g&&t<=R}function n(t,r,d,u){let c="",h=0,k=-1,L=0,v=0;for(let b=0;b<=t.length;++b){if(b<t.length)v=t.charCodeAt(b);else{if(u(v))break;v=$}if(u(v)){if(!(k===b-1||L===1))if(L===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==p||c.charCodeAt(c.length-2)!==p){if(c.length>2){const E=c.lastIndexOf(d);E===-1?(c="",h=0):(c=c.slice(0,E),h=c.length-1-c.lastIndexOf(d)),k=b,L=0;continue}else if(c.length!==0){c="",h=0,k=b,L=0;continue}}r&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(k+1,b)}`:c=t.slice(k+1,b),h=b-k-1;k=b,L=0}else v===p&&L!==-1?++L:L=-1}return c}function o(t,r){w(r,"pathObject");const d=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return d?d===r.root?`${d}${u}`:`${d}${t}${u}`:u}e.$fc={resolve(...t){let r="",d="",u=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],S(h,"path"),h.length===0)continue}else r.length===0?h=D.cwd():(h=D.env[`=${r}`]||D.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==r.toLowerCase()&&h.charCodeAt(2)===y)&&(h=`${r}\\`));const k=h.length;let L=0,v="",b=!1;const E=h.charCodeAt(0);if(k===1)f(E)&&(L=1,b=!0);else if(f(E))if(b=!0,f(h.charCodeAt(1))){let A=2,z=A;for(;A<k&&!f(h.charCodeAt(A));)A++;if(A<k&&A!==z){const O=h.slice(z,A);for(z=A;A<k&&f(h.charCodeAt(A));)A++;if(A<k&&A!==z){for(z=A;A<k&&!f(h.charCodeAt(A));)A++;(A===k||A!==z)&&(v=`\\\\${O}\\${h.slice(z,A)}`,L=A)}}}else L=1;else i(E)&&h.charCodeAt(1)===M&&(v=h.slice(0,2),L=2,k>2&&f(h.charCodeAt(2))&&(b=!0,L=3));if(v.length>0)if(r.length>0){if(v.toLowerCase()!==r.toLowerCase())continue}else r=v;if(u){if(r.length>0)break}else if(d=`${h.slice(L)}\\${d}`,u=b,b&&r.length>0)break}return d=n(d,!u,"\\",f),u?`${r}\\${d}`:`${r}${d}`||"."},normalize(t){S(t,"path");const r=t.length;if(r===0)return".";let d=0,u,c=!1;const h=t.charCodeAt(0);if(r===1)return s(h)?"\\":t;if(f(h))if(c=!0,f(t.charCodeAt(1))){let L=2,v=L;for(;L<r&&!f(t.charCodeAt(L));)L++;if(L<r&&L!==v){const b=t.slice(v,L);for(v=L;L<r&&f(t.charCodeAt(L));)L++;if(L<r&&L!==v){for(v=L;L<r&&!f(t.charCodeAt(L));)L++;if(L===r)return`\\\\${b}\\${t.slice(v)}\\`;L!==v&&(u=`\\\\${b}\\${t.slice(v,L)}`,d=L)}}}else d=1;else i(h)&&t.charCodeAt(1)===M&&(u=t.slice(0,2),d=2,r>2&&f(t.charCodeAt(2))&&(c=!0,d=3));let k=d<r?n(t.slice(d),!c,"\\",f):"";return k.length===0&&!c&&(k="."),k.length>0&&f(t.charCodeAt(r-1))&&(k+="\\"),u===void 0?c?`\\${k}`:k:c?`${u}\\${k}`:`${u}${k}`},isAbsolute(t){S(t,"path");const r=t.length;if(r===0)return!1;const d=t.charCodeAt(0);return f(d)||r>2&&i(d)&&t.charCodeAt(1)===M&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,d;for(let h=0;h<t.length;++h){const k=t[h];S(k,"path"),k.length>0&&(r===void 0?r=d=k:r+=`\\${k}`)}if(r===void 0)return".";let u=!0,c=0;if(typeof d=="string"&&f(d.charCodeAt(0))){++c;const h=d.length;h>1&&f(d.charCodeAt(1))&&(++c,h>2&&(f(d.charCodeAt(2))?++c:u=!1))}if(u){for(;c<r.length&&f(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$fc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r)return"";const d=e.$fc.resolve(t),u=e.$fc.resolve(r);if(d===u||(t=d.toLowerCase(),r=u.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===y;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===y;)h--;const k=h-c;let L=0;for(;L<r.length&&r.charCodeAt(L)===y;)L++;let v=r.length;for(;v-1>L&&r.charCodeAt(v-1)===y;)v--;const b=v-L,E=k<b?k:b;let A=-1,z=0;for(;z<E;z++){const P=t.charCodeAt(c+z);if(P!==r.charCodeAt(L+z))break;P===y&&(A=z)}if(z!==E){if(A===-1)return u}else{if(b>E){if(r.charCodeAt(L+z)===y)return u.slice(L+z+1);if(z===2)return u.slice(L+z)}k>E&&(t.charCodeAt(c+z)===y?A=z:z===2&&(A=3)),A===-1&&(A=0)}let O="";for(z=c+A+1;z<=h;++z)(z===h||t.charCodeAt(z)===y)&&(O+=O.length===0?"..":"\\..");return L+=A,O.length>0?`${O}${u.slice(L,v)}`:(u.charCodeAt(L)===y&&++L,u.slice(L,v))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const d=r.charCodeAt(2);if(d!==C&&d!==p)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===M&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){S(t,"path");const r=t.length;if(r===0)return".";let d=-1,u=0;const c=t.charCodeAt(0);if(r===1)return f(c)?t:".";if(f(c)){if(d=u=1,f(t.charCodeAt(1))){let L=2,v=L;for(;L<r&&!f(t.charCodeAt(L));)L++;if(L<r&&L!==v){for(v=L;L<r&&f(t.charCodeAt(L));)L++;if(L<r&&L!==v){for(v=L;L<r&&!f(t.charCodeAt(L));)L++;if(L===r)return t;L!==v&&(d=u=L+1)}}}}else i(c)&&t.charCodeAt(1)===M&&(d=r>2&&f(t.charCodeAt(2))?3:2,u=d);let h=-1,k=!0;for(let L=r-1;L>=u;--L)if(f(t.charCodeAt(L))){if(!k){h=L;break}}else k=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,c=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===M&&(d=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,L=-1;for(h=t.length-1;h>=d;--h){const v=t.charCodeAt(h);if(f(v)){if(!c){d=h+1;break}}else L===-1&&(c=!1,L=h+1),k>=0&&(v===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=L))}return d===u?u=L:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=d;--h)if(f(t.charCodeAt(h))){if(!c){d=h+1;break}}else u===-1&&(c=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=0,d=-1,u=0,c=-1,h=!0,k=0;t.length>=2&&t.charCodeAt(1)===M&&i(t.charCodeAt(0))&&(r=u=2);for(let L=t.length-1;L>=r;--L){const v=t.charCodeAt(L);if(f(v)){if(!h){u=L+1;break}continue}c===-1&&(h=!1,c=L+1),v===p?d===-1?d=L:k!==1&&(k=1):d!==-1&&(k=-1)}return d===-1||c===-1||k===0||k===1&&d===c-1&&d===u+1?"":t.slice(d,c)},format:o.bind(null,"\\"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.length;let u=0,c=t.charCodeAt(0);if(d===1)return f(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(f(c)){if(u=1,f(t.charCodeAt(1))){let A=2,z=A;for(;A<d&&!f(t.charCodeAt(A));)A++;if(A<d&&A!==z){for(z=A;A<d&&f(t.charCodeAt(A));)A++;if(A<d&&A!==z){for(z=A;A<d&&!f(t.charCodeAt(A));)A++;A===d?u=A:A!==z&&(u=A+1)}}}}else if(i(c)&&t.charCodeAt(1)===M){if(d<=2)return r.root=r.dir=t,r;if(u=2,f(t.charCodeAt(2))){if(d===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let h=-1,k=u,L=-1,v=!0,b=t.length-1,E=0;for(;b>=u;--b){if(c=t.charCodeAt(b),f(c)){if(!v){k=b+1;break}continue}L===-1&&(v=!1,L=b+1),c===p?h===-1?h=b:E!==1&&(E=1):h!==-1&&(E=-1)}return L!==-1&&(h===-1||E===0||E===1&&h===L-1&&h===k+1?r.base=r.name=t.slice(k,L):(r.name=t.slice(k,h),r.base=t.slice(k,L),r.ext=t.slice(h,L))),k>0&&k!==u?r.dir=t.slice(0,k-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(l){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",d=!1;for(let u=t.length-1;u>=-1&&!d;u--){const c=u>=0?t[u]:a();S(c,"path"),c.length!==0&&(r=`${c}/${r}`,d=c.charCodeAt(0)===$)}return r=n(r,!d,"/",s),d?`/${r}`:r.length>0?r:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=n(t,!r,"/",s),t.length===0?r?"/":d?"./":".":(d&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let r;for(let d=0;d<t.length;++d){const u=t[d];S(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const d=1,u=t.length,c=u-d,h=1,k=r.length-h,L=c<k?c:k;let v=-1,b=0;for(;b<L;b++){const A=t.charCodeAt(d+b);if(A!==r.charCodeAt(h+b))break;A===$&&(v=b)}if(b===L)if(k>L){if(r.charCodeAt(h+b)===$)return r.slice(h+b+1);if(b===0)return r.slice(h+b)}else c>L&&(t.charCodeAt(d+b)===$?v=b:b===0&&(v=0));let E="";for(b=d+v+1;b<=u;++b)(b===u||t.charCodeAt(b)===$)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(h+v)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$;let d=-1,u=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!u){d=c;break}}else u=!1;return d===-1?r?"/":".":r&&d===1?"//":t.slice(0,d)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let d=0,u=-1,c=!0,h;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,L=-1;for(h=t.length-1;h>=0;--h){const v=t.charCodeAt(h);if(v===$){if(!c){d=h+1;break}}else L===-1&&(c=!1,L=h+1),k>=0&&(v===r.charCodeAt(k)?--k===-1&&(u=h):(k=-1,u=L))}return d===u?u=L:u===-1&&(u=t.length),t.slice(d,u)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!c){d=h+1;break}}else u===-1&&(c=!1,u=h+1);return u===-1?"":t.slice(d,u)},extname(t){S(t,"path");let r=-1,d=0,u=-1,c=!0,h=0;for(let k=t.length-1;k>=0;--k){const L=t.charCodeAt(k);if(L===$){if(!c){d=k+1;break}continue}u===-1&&(c=!1,u=k+1),L===p?r===-1?r=k:h!==1&&(h=1):r!==-1&&(h=-1)}return r===-1||u===-1||h===0||h===1&&r===u-1&&r===d+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const d=t.charCodeAt(0)===$;let u;d?(r.root="/",u=1):u=0;let c=-1,h=0,k=-1,L=!0,v=t.length-1,b=0;for(;v>=u;--v){const E=t.charCodeAt(v);if(E===$){if(!L){h=v+1;break}continue}k===-1&&(L=!1,k=v+1),E===p?c===-1?c=v:b!==1&&(b=1):c!==-1&&(b=-1)}if(k!==-1){const E=h===0&&d?1:h;c===-1||b===0||b===1&&c===k-1&&c===h+1?r.base=r.name=t.slice(E,k):(r.name=t.slice(E,c),r.base=t.slice(E,k),r.ext=t.slice(c,k))}return h>0?r.dir=t.slice(0,h-1):d&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,16]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=void 0;const g=new D.$V(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),I=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new D.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(L,v,b=!1){const E=L||"",A=v||"",z=g.value.collator.compare(E,A);return g.value.collatorIsNumeric&&z===0&&E!==A?E<A?-1:1:z}e.$uq=p;function $(L,v){const b=I.value.collator;return L=L||"",v=v||"",o(b,L,v)}e.$vq=$;function y(L,v){const b=I.value.collator;return L=L||"",v=v||"",d(L,v)||o(b,L,v)}e.$wq=y;function M(L,v){const b=I.value.collator;return L=L||"",v=v||"",r(L,v)||o(b,L,v)}e.$xq=M;function C(L,v){return L=L||"",v=v||"",L===v?0:L<v?-1:1}e.$yq=C;function m(L,v){const[b,E]=i(L),[A,z]=i(v);let O=g.value.collator.compare(E,z);if(O===0){if(g.value.collatorIsNumeric&&E!==z)return E<z?-1:1;if(O=g.value.collator.compare(b,A),g.value.collatorIsNumeric&&O===0&&b!==A)return b<A?-1:1}return O}e.$zq=m;function w(L,v){L=L||"",v=v||"";const b=n(L),E=n(v),A=I.value.collator,z=R.value.collator;return o(z,b,E)||o(A,L,v)}e.$Aq=w;function S(L,v){L=L||"",v=v||"";const b=n(L),E=n(v),A=I.value.collator,z=R.value.collator;return o(z,b,E)||d(L,v)||o(A,L,v)}e.$Bq=S;function l(L,v){L=L||"",v=v||"";const b=n(L),E=n(v),A=I.value.collator,z=R.value.collator;return o(z,b,E)||r(L,v)||o(A,L,v)}e.$Cq=l;function f(L,v){L=L||"",v=v||"";const b=n(L).toLowerCase(),E=n(v).toLowerCase();return b!==E?b<E?-1:1:L!==v?L<v?-1:1:0}e.$Dq=f;const s=/^(.*?)(\.([^.]*))?$/;function i(L,v=!1){const b=L?s.exec(L):[];let E=[b&&b[1]||"",b&&b[3]||""];return v&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(L){const v=L?s.exec(L):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function o(L,v,b){const E=L.compare(v,b);return E!==0?E:v.length!==b.length?v.length<b.length?-1:1:0}function a(L){const v=L.charAt(0);return v.toLocaleUpperCase()!==v}function t(L){const v=L.charAt(0);return v.toLocaleLowerCase()!==v}function r(L,v){return a(L)&&t(v)?-1:t(L)&&a(v)?1:0}function d(L,v){return t(L)&&a(v)?-1:a(L)&&t(v)?1:0}function u(L,v,b=!1){return b||(L=L&&L.toLowerCase(),v=v&&v.toLowerCase()),L===v?0:L<v?-1:1}function c(L,v,b=!1){const E=L.split(T.sep),A=v.split(T.sep),z=E.length-1,O=A.length-1;let P,j;for(let N=0;;N++){if(P=z===N,j=O===N,P&&j)return p(E[N],A[N],b);if(P)return-1;if(j)return 1;const F=u(E[N],A[N],b);if(F!==0)return F}}e.$Eq=c;function h(L,v,b){const E=L.toLowerCase(),A=v.toLowerCase(),z=k(L,v,b);if(z)return z;const O=E.endsWith(b),P=A.endsWith(b);if(O!==P)return O?-1:1;const j=p(E,A);return j!==0?j:E.localeCompare(A)}e.$Fq=h;function k(L,v,b){const E=L.toLowerCase(),A=v.toLowerCase(),z=E.startsWith(b),O=A.startsWith(b);if(z!==O)return z?-1:1;if(z&&O){if(E.length<A.length)return-1;if(E.length>A.length)return 1}return 0}e.$Gq=k}),define(ke[33],Se([1,0,16,11,13,18]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function R(h){return h===47||h===92}e.$Wf=R;function p(h){return h.replace(/[\\/]/g,D.$gc.sep)}e.$Xf=p;function $(h){return h.indexOf("/")===-1&&(h=p(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Yf=$;function y(h,k=D.$gc.sep){if(!h)return"";const L=h.length,v=h.charCodeAt(0);if(R(v)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let E=3;const A=E;for(;E<L&&!R(h.charCodeAt(E));E++);if(A!==E&&!R(h.charCodeAt(E+1))){for(E+=1;E<L;E++)if(R(h.charCodeAt(E)))return h.slice(0,E+1).replace(/[\\/]/g,k)}}return k}else if(s(v)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+k:h.slice(0,2);let b=h.indexOf("://");if(b!==-1){for(b+=3;b<L;b++)if(R(h.charCodeAt(b)))return h.slice(0,b+1)}return""}e.$Zf=y;function M(h){if(!T.$i||!h||h.length<5)return!1;let k=h.charCodeAt(0);if(k!==92||(k=h.charCodeAt(1),k!==92))return!1;let L=2;const v=L;for(;L<h.length&&(k=h.charCodeAt(L),k!==92);L++);return!(v===L||(k=h.charCodeAt(L+1),isNaN(k)||k===92))}e.$1f=M;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,k=T.$i){const L=k?C:m;return!(!h||h.length===0||/^\s+$/.test(h)||(L.lastIndex=0,L.test(h))||k&&w.test(h)||h==="."||h===".."||k&&h[h.length-1]==="."||k&&h.length!==h.trim().length||h.length>255)}e.$2f=S;function l(h,k,L){const v=h===k;return!L||v?v:!h||!k?!1:(0,g.$8e)(h,k)}e.$3f=l;function f(h,k,L,v=D.sep){if(h===k)return!0;if(!h||!k||k.length>h.length)return!1;if(L){if(!(0,g.$9e)(h,k))return!1;if(k.length===h.length)return!0;let E=k.length;return k.charAt(k.length-1)===v&&E--,h.charAt(E)===v}return k.charAt(k.length-1)!==v&&(k+=v),h.indexOf(k)===0}e.$4f=f;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$5f=s;function i(h,k){return T.$i&&h.endsWith(":")&&(h+=D.sep),(0,D.$ic)(h)||(h=(0,D.$jc)(k,h)),h=(0,D.$hc)(h),T.$i?(h=(0,g.$Qe)(h,D.sep),h.endsWith(":")&&(h+=D.sep)):(h=(0,g.$Qe)(h,D.sep),h||(h=D.sep)),h}e.$6f=i;function n(h){const k=(0,D.$hc)(h);return T.$i?h.length>3?!1:o(k)&&(h.length===2||k.charCodeAt(2)===92):k===D.$gc.sep}e.$7f=n;function o(h,k=T.$i){return k?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$8f=o;function a(h,k=T.$i){return o(h,k)?h[0]:void 0}e.$9f=a;function t(h,k,L){return k.length>h.length?-1:h===k?0:(L&&(h=h.toLowerCase(),k=k.toLowerCase()),h.indexOf(k))}e.$0f=t;function r(h){const k=h.split(":");let L,v,b;for(const E of k){const A=Number(E);(0,I.$If)(A)?v===void 0?v=A:b===void 0&&(b=A):L=L?[L,E].join(":"):E}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:v!==void 0?v:void 0,column:b!==void 0?b:v!==void 0?1:void 0}}e.$$f=r;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,k,L=8){let v="";for(let E=0;E<L;E++){let A;E===0&&T.$i&&!k&&(L===3||L===4)?A=u:A=d,v+=A.charAt(Math.floor(Math.random()*A.length))}let b;return k?b=`${k}-${v}`:b=v,h?(0,D.$jc)(h,b):b}e.$_f=c}),define(ke[129],Se([1,0,128,123,53,16,11,13]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0;const $=0,y=[$,[]];function M(W,x,ce,J){if(!W||!x)return y;const Y=W.length,X=x.length;if(Y<X)return y;const se=W.toLowerCase();return C(x,ce,X,W,se,Y,J)}e.$Hq=M;function C(W,x,ce,J,Y,X,se){const Z=[],we=[];for(let ne=0;ne<ce;ne++){const ye=ne*X,he=ye-X,ge=ne>0,_=W[ne],ie=x[ne];for(let G=0;G<X;G++){const te=G>0,fe=ye+G,ve=fe-1,Ae=he+G-1,pe=te?Z[ve]:0,De=ge&&te?Z[Ae]:0,U=ge&&te?we[Ae]:0;let Q;!De&&ge?Q=0:Q=m(_,ie,J,Y,G,U),Q&&De+Q>=pe&&(se||ge||Y.startsWith(x,G))?(we[fe]=U+1,Z[fe]=De+Q):(we[fe]=$,Z[fe]=pe)}}const de=[];let K=ce-1,B=X-1;for(;K>=0&&B>=0;){const ne=K*X+B;we[ne]===$||(de.push(B),K--),B--}return[Z[ce*X-1],de.reverse()]}function m(W,x,ce,J,Y,X){let se=0;if(!w(x,J[Y]))return se;if(se+=1,X>0&&(se+=X*5),W===ce[Y]&&(se+=1),Y===0)se+=8;else{const Z=S(ce.charCodeAt(Y-1));Z?se+=Z:(0,T.$Tj)(ce.charCodeAt(Y))&&X===0&&(se+=2)}return se}function w(W,x){return W===x?!0:W==="/"||W==="\\"?x==="/"||x==="\\":!1}function S(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(W,x,ce=0,J=0){const Y=x;return Y.values&&Y.values.length>1?s(W,Y.values,ce,J):i(W,x,ce,J)}e.$Iq=f;function s(W,x,ce,J){let Y=0;const X=[];for(const se of x){const[Z,we]=i(W,se,ce,J);if(typeof Z!="number")return l;Y+=Z,X.push(...we)}return[Y,L(X)]}function i(W,x,ce,J){const Y=(0,T.$3j)(x.original,x.originalLowercase,ce,W,W.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Y?[Y[0],(0,T.$Zj)(Y)]:l}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(W,x,ce,J){const Y=J.values?J.values:[J];return(0,g.$Pi)({[J.normalized]:{values:Y.map(se=>({value:se.normalized,expectContiguousMatch:se.expectContiguousMatch})),label:W,description:x,allowNonContiguousMatches:ce}})}function d(W,x,ce,J,Y){if(!W||!x.normalized)return n;const X=J.getItemLabel(W);if(!X)return n;const se=J.getItemDescription(W),Z=r(X,se,ce,x),we=Y[Z];if(we)return we;const de=u(X,se,J.getItemPath(W),x,ce);return Y[Z]=de,de}e.$Jq=d;function u(W,x,ce,J,Y){const X=!ce||!J.containsPathSeparator;return ce&&(R.$k?J.pathNormalized===ce:(0,p.$8e)(J.pathNormalized,ce))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:J.values&&J.values.length>1?c(W,x,ce,J.values,X,Y):h(W,x,ce,J,X,Y)}function c(W,x,ce,J,Y,X){let se=0;const Z=[],we=[];for(const de of J){const{score:K,labelMatch:B,descriptionMatch:ne}=h(W,x,ce,de,Y,X);if(K===$)return n;se+=K,B&&Z.push(...B),ne&&we.push(...ne)}return{score:se,labelMatch:L(Z),descriptionMatch:L(we)}}function h(W,x,ce,J,Y,X){if(Y||!x){const[se,Z]=M(W,J.normalized,J.normalizedLowercase,X&&!J.expectContiguousMatch);if(se){const we=(0,T.$Qj)(J.normalized,W);let de;if(we){de=a;const K=Math.round(J.normalized.length/W.length*100);de+=K}else de=t;return{score:de+se,labelMatch:we||k(Z)}}}if(x){let se=x;ce&&(se=`${x}${I.sep}`);const Z=se.length,we=`${se}${W}`,[de,K]=M(we,J.normalized,J.normalizedLowercase,X&&!J.expectContiguousMatch);if(de){const B=k(K),ne=[],ye=[];return B.forEach(he=>{he.start<Z&&he.end>Z?(ne.push({start:0,end:he.end-Z}),ye.push({start:he.start,end:Z})):he.start>=Z?ne.push({start:he.start-Z,end:he.end-Z}):ye.push(he)}),{score:de,labelMatch:ne,descriptionMatch:ye}}}return n}function k(W){const x=[];if(!W)return x;let ce;for(const J of W)ce&&ce.end===J?ce.end+=1:(ce={start:J,end:J+1},x.push(ce));return x}function L(W){const x=W.sort((Y,X)=>Y.start-X.start),ce=[];let J;for(const Y of x)!J||!v(J,Y)?(J=Y,ce.push(Y)):(J.start=Math.min(J.start,Y.start),J.end=Math.max(J.end,Y.end));return ce}function v(W,x){return!(W.end<x.start||x.end<W.start)}function b(W,x,ce,J,Y,X){const se=d(W,ce,J,Y,X),Z=d(x,ce,J,Y,X),we=se.score,de=Z.score;if((we===o||de===o)&&we!==de)return we===o?-1:1;if(we>t||de>t){if(we!==de)return we>de?-1:1;if(we<a&&de<a){const _=A(se.labelMatch,Z.labelMatch);if(_!==0)return _}const he=Y.getItemLabel(W)||"",ge=Y.getItemLabel(x)||"";if(he.length!==ge.length)return he.length-ge.length}if(we!==de)return we>de?-1:1;const K=Array.isArray(se.labelMatch)&&se.labelMatch.length>0,B=Array.isArray(Z.labelMatch)&&Z.labelMatch.length>0;if(K&&!B)return-1;if(B&&!K)return 1;const ne=E(W,se,Y),ye=E(x,Z,Y);return ne&&ye&&ne!==ye?ye>ne?-1:1:z(W,x,ce,Y)}e.$Kq=b;function E(W,x,ce){let J=-1,Y=-1;if(x.descriptionMatch&&x.descriptionMatch.length?J=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(J=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(Y=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const X=ce.getItemDescription(W);X&&(Y+=X.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(Y=x.descriptionMatch[x.descriptionMatch.length-1].end);return Y-J}function A(W,x){if(!W&&!x||(!W||!W.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!W||!W.length)return 1;const ce=W[0].start,Y=W[W.length-1].end-ce,X=x[0].start,Z=x[x.length-1].end-X;return Y===Z?0:Z<Y?1:-1}function z(W,x,ce,J){const Y=J.getItemLabel(W)||"",X=J.getItemLabel(x)||"",se=J.getItemDescription(W),Z=J.getItemDescription(x),we=Y.length+(se?se.length:0),de=X.length+(Z?Z.length:0);if(we!==de)return we-de;const K=J.getItemPath(W),B=J.getItemPath(x);return K&&B&&K.length!==B.length?K.length-B.length:Y!==X?(0,D.$Fq)(Y,X,ce.normalized):se&&Z&&se!==Z?(0,D.$Fq)(se,Z,ce.normalized):K&&B&&K!==B?(0,D.$Fq)(K,B,ce.normalized):0}function O(W){return W.startsWith('"')&&W.endsWith('"')}const P=" ";function j(W){typeof W!="string"&&(W="");const x=W.toLowerCase(),{pathNormalized:ce,normalized:J,normalizedLowercase:Y}=N(W),X=ce.indexOf(I.sep)>=0,se=O(W);let Z;const we=W.split(P);if(we.length>1)for(const de of we){const K=O(de),{pathNormalized:B,normalized:ne,normalizedLowercase:ye}=N(de);ne&&(Z||(Z=[]),Z.push({original:de,originalLowercase:de.toLowerCase(),pathNormalized:B,normalized:ne,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:W,originalLowercase:x,pathNormalized:ce,normalized:J,normalizedLowercase:Y,values:Z,containsPathSeparator:X,expectContiguousMatch:se}}e.$Lq=j;function N(W){let x;R.$i?x=W.replace(/\//g,I.sep):x=W.replace(/\\/g,I.sep);const ce=(0,p.$Se)(x).replace(/\s|"/g,"");return{pathNormalized:x,normalized:ce,normalizedLowercase:ce.toLowerCase()}}function F(W){return Array.isArray(W)?j(W.map(x=>x.original).join(P)):j(W.original)}e.$Mq=F}),define(ke[100],Se([1,0,16]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=void 0,e.$3r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(M){const C=(0,D.$oc)(M),m=T[C.toLowerCase()];return m!==void 0?m:R(M)}e.$4r=I;function R(M){const C=(0,D.$oc)(M);return g[C.toLowerCase()]}e.$5r=R;function p(M){for(const C in g)if(g[C]===M)return C}e.$6r=p;const $=/^(.+)\/(.+?)(;.+)?$/;function y(M,C){const m=$.exec(M);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:M}e.$7r=y}),define(ke[101],Se([1,0,11]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.TerminateResponseCode=e.Source=void 0;var T;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(T||(e.Source=T={}));var g;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(p,...$){const y=$.reduce((m,w)=>(m[w]=!0,m),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(m=>!y[m]).forEach(m=>{for(let w=0;w<M.length;w++)if(m.search(M[w])!==-1){delete p[m];break}})}e.$Ml=I;function R(p){p&&(delete p.DEBUG,D.$j&&delete p.DYLD_LIBRARY_PATH,D.$k&&delete p.LD_PRELOAD)}e.$Nl=R}),define(ke[2],Se([1,0,16,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,R=/^\/\//;function p(u,c){if(!u.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!g.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!I.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(u,c){return!u&&!c?"file":u}function y(u,c){switch(u){case"https":case"http":case"file":c?c[0]!==C&&(c=C+c):c=C;break}return c}const M="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{static isUri(c){return c instanceof w?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,k,L,v,b=!1){typeof c=="object"?(this.scheme=c.scheme||M,this.authority=c.authority||M,this.path=c.path||M,this.query=c.query||M,this.fragment=c.fragment||M):(this.scheme=$(c,b),this.authority=h||M,this.path=y(this.scheme,k||M),this.query=L||M,this.fragment=v||M,p(this,b))}get fsPath(){return o(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:k,path:L,query:v,fragment:b}=c;return h===void 0?h=this.scheme:h===null&&(h=M),k===void 0?k=this.authority:k===null&&(k=M),L===void 0?L=this.path:L===null&&(L=M),v===void 0?v=this.query:v===null&&(v=M),b===void 0?b=this.fragment:b===null&&(b=M),h===this.scheme&&k===this.authority&&L===this.path&&v===this.query&&b===this.fragment?this:new f(h,k,L,v,b)}static parse(c,h=!1){const k=m.exec(c);return k?new f(k[2]||M,d(k[4]||M),d(k[5]||M),d(k[7]||M),d(k[9]||M),h):new f(M,M,M,M,M)}static file(c){let h=M;if(T.$i&&(c=c.replace(/\\/g,C)),c[0]===C&&c[1]===C){const k=c.indexOf(C,2);k===-1?(h=c.substring(2),c=C):(h=c.substring(2,k),c=c.substring(k)||C)}return new f("file",h,c,M,M)}static from(c,h){return new f(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return T.$i&&c.scheme==="file"?k=w.file(D.$fc.join(o(c,!0),...h)).path:k=D.$gc.join(c.path,...h),c.with({path:k})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof w)return c;{const h=new f(c);return h._formatted=c.external??null,h._fsPath=c._sep===l?c.fsPath??null:null,h}}else return c}}e.URI=w;function S(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$vc=S;const l=T.$i?1:void 0;class f extends w{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=l),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,c,h){let k,L=-1;for(let v=0;v<u.length;v++){const b=u.charCodeAt(v);if(b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57||b===45||b===46||b===95||b===126||c&&b===47||h&&b===91||h&&b===93||h&&b===58)L!==-1&&(k+=encodeURIComponent(u.substring(L,v)),L=-1),k!==void 0&&(k+=u.charAt(v));else{k===void 0&&(k=u.substr(0,v));const E=s[b];E!==void 0?(L!==-1&&(k+=encodeURIComponent(u.substring(L,v)),L=-1),k+=E):L===-1&&(L=v)}}return L!==-1&&(k+=encodeURIComponent(u.substring(L))),k!==void 0?k:u}function n(u){let c;for(let h=0;h<u.length;h++){const k=u.charCodeAt(h);k===35||k===63?(c===void 0&&(c=u.substr(0,h)),c+=s[k]):c!==void 0&&(c+=u[h])}return c!==void 0?c:u}function o(u,c){let h;return u.authority&&u.path.length>1&&u.scheme==="file"?h=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?c?h=u.path.substr(1):h=u.path[1].toLowerCase()+u.path.substr(2):h=u.path,T.$i&&(h=h.replace(/\//g,"\\")),h}e.$wc=o;function a(u,c){const h=c?n:i;let k="",{scheme:L,authority:v,path:b,query:E,fragment:A}=u;if(L&&(k+=L,k+=":"),(v||L==="file")&&(k+=C,k+=C),v){let z=v.indexOf("@");if(z!==-1){const O=v.substr(0,z);v=v.substr(z+1),z=O.lastIndexOf(":"),z===-1?k+=h(O,!1,!1):(k+=h(O.substr(0,z),!1,!1),k+=":",k+=h(O.substr(z+1),!1,!0)),k+="@"}v=v.toLowerCase(),z=v.lastIndexOf(":"),z===-1?k+=h(v,!1,!0):(k+=h(v.substr(0,z),!1,!0),k+=v.substr(z))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const z=b.charCodeAt(1);z>=65&&z<=90&&(b=`/${String.fromCharCode(z+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const z=b.charCodeAt(0);z>=65&&z<=90&&(b=`${String.fromCharCode(z+32)}:${b.substr(2)}`)}k+=h(b,!0,!1)}return E&&(k+="?",k+=h(E,!1,!1)),A&&(k+="#",k+=c?A:i(A,!1,!1)),k}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(u){return u.match(r)?u.replace(r,c=>t(c)):u}}),define(ke[185],Se([1,0,2]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$aq=e.$_p=e.$$p=void 0;function T(y){const M=y;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.$$p=T;function g(y){const M=[];let C;try{const m=JSON.parse(y.arguments),w=m[m.length-1];w&&w.__$stack&&(m.pop(),C=w.__$stack),M.push(...m)}catch{M.push("Unable to log remote console arguments",y.arguments)}return{args:M,stack:C}}e.$_p=g;function I(y){if(typeof y!="string")return I(g(y).stack);const M=y;if(M){const C=R(M),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$aq=I;function R(y){if(!y)return y;const M=y.indexOf(`
`);return M===-1?y:y.substring(0,M)}function p(y,M){const{args:C,stack:m}=g(y),w=typeof C[0]=="string"&&C.length===1;let S=R(m);S&&(S=`(${S.trim()})`);let l=[];if(typeof C[0]=="string"?S&&w?l=[`%c[${M}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:l=[`%c[${M}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:l=[`%c[${M}]%`,$("blue"),...C],S&&!w&&l.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,l)}e.log=p;function $(y){return`color: ${y}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function g($){return JSON.stringify($,R)}e.$wh=g;function I($){let y=JSON.parse($);return y=p(y),y}e.$xh=I;function R($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function p($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return T.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$ge||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let M=0;M<$.length;++M)$[M]=p($[M],y+1);else for(const M in $)Object.hasOwnProperty.call($,M)&&($[M]=p($[M],y+1))}return $}e.$yh=p}),define(ke[17],Se([1,0,8,11,13,2]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var R;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function p(m,w){return I.URI.isUri(m)?(0,g.$8e)(m.scheme,w):(0,g.$9e)(m,w+":")}e.$ag=p;function $(m,...w){return w.some(S=>p(m,S))}e.$bg=$,e.$cg="vscode-tkn",e.$dg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(w){this.d=w}setDelegate(w){this.e=w}setServerRootPath(w){this.f=`${w}/${R.vscodeRemoteResource}`}set(w,S,l){this.a[w]=S,this.b[w]=l}setConnectionToken(w,S){this.c[w]=S}getPreferredWebSchema(){return this.d}rewrite(w){if(this.e)try{return this.e(w)}catch(n){return D.$1(n),w}const S=w.authority;let l=this.a[S];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[S],s=this.c[S];let i=`path=${encodeURIComponent(w.path)}`;return typeof s=="string"&&(i+=`&${e.$dg}=${encodeURIComponent(s)}`),I.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${l}:${f}`,path:this.f,query:i})}}e.$eg=new y,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class M{static{this.a=e.$jg}asBrowserUri(w){const S=this.b(w,me);return this.uriToBrowserUri(S)}uriToBrowserUri(w){return w.scheme===R.vscodeRemote?e.$eg.rewrite(w):w.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${M.a}`)?w.with({scheme:R.vscodeFileResource,authority:w.authority||M.a,query:null,fragment:null}):w}asFileUri(w){const S=this.b(w,me);return this.uriToFileUri(S)}uriToFileUri(w){return w.scheme===R.vscodeFileResource?w.with({scheme:R.file,authority:w.authority!==M.a?w.authority:null,query:null,fragment:null}):w}b(w,S){return I.URI.isUri(w)?w:I.URI.parse(S.toUrl(w))}}e.$kg=new M;var C;(function(m){const w=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(w.get("3"));const S="vscode-coi";function l(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:I.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(S);if(n)return w.get(n)}m.getHeadersFromQuery=l;function f(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(S,o):s[S]=o}m.addSearchParam=f})(C||(e.COI=C={}))}),define(ke[186],Se([1,0,157,17,11,2]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=void 0;class R{constructor(m,w,S){this.id=m,this.dependencies=w,this.callback=S}}class p{static{this.INSTANCE=new p}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,w,S)=>{typeof m!="string"&&(S=w,w=m,m=null),(typeof w!="object"||!Array.isArray(w))&&(S=w,w=null),this.c.push(new R(m,w,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const w=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!w)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(m){return new Promise((w,S)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const f=()=>{l.removeEventListener("load",s),l.removeEventListener("error",i)},s=n=>{f(),w(this.c.pop())},i=n=>{f(),S(n)};l.addEventListener("load",s),l.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((w,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),w(this.c.pop())}catch(l){S(l)}})}async j(m){try{const w=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,f=I.URI.parse(m).fsPath,s=w.readFileSync(f).toString(),i=l.wrap(s.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function M(C,m,w){if(D.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const S=`${C}/${m}`;if($.has(S))return $.get(S);let l;if(/^\w[\w\d+.-]*:\/\//.test(S))l=S;else{const n=`${w&&!g.$o?T.$hg:T.$gg}/${S}`;l=T.$kg.asBrowserUri(n).toString(!0)}const f=p.INSTANCE.load(l);return $.set(S,f),f}else return await new Promise((S,l)=>{me([C],S,l)})}e.$YC=M}),define(ke[23],Se([1,0,33,17,16,11,13,2]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function $(w){return(0,p.$wc)(w,!0)}e.$rg=$;class y{constructor(S){this.a=S}compare(S,l,f=!1){return S===l?0:(0,R.$1e)(this.getComparisonKey(S,f),this.getComparisonKey(l,f))}isEqual(S,l,f=!1){return S===l?!0:!S||!l?!1:this.getComparisonKey(S,f)===this.getComparisonKey(l,f)}getComparisonKey(S,l=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,l,f=!1){if(S.scheme===l.scheme){if(S.scheme===T.Schemas.file)return D.$4f($(S),$(l),this.a(S))&&S.query===l.query&&(f||S.fragment===l.fragment);if((0,e.$Ig)(S.authority,l.authority))return D.$4f(S.path,l.path,this.a(S),"/")&&S.query===l.query&&(f||S.fragment===l.fragment)}return!1}joinPath(S,...l){return p.URI.joinPath(S,...l)}basenameOrAuthority(S){return(0,e.$Ag)(S)||S.authority}basename(S){return g.$gc.basename(S.path)}extname(S){return g.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let l;return S.scheme===T.Schemas.file?l=p.URI.file(g.$mc($(S))).path:(l=g.$gc.dirname(S.path),S.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),l="/")),S.with({path:l})}normalizePath(S){if(!S.path.length)return S;let l;return S.scheme===T.Schemas.file?l=p.URI.file(g.$hc($(S))).path:l=g.$gc.normalize(S.path),S.with({path:l})}relativePath(S,l){if(S.scheme!==l.scheme||!(0,e.$Ig)(S.authority,l.authority))return;if(S.scheme===T.Schemas.file){const i=g.$lc($(S),$(l));return I.$i?D.$Xf(i):i}let f=S.path||"/";const s=l.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(f.length,s.length);i<n&&!(f.charCodeAt(i)!==s.charCodeAt(i)&&f.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);f=s.substr(0,i)+f.substr(i)}return g.$gc.relative(f,s)}resolvePath(S,l){if(S.scheme===T.Schemas.file){const f=p.URI.file(g.$kc($(S),l));return S.with({authority:f.authority,path:f.path})}return l=D.$Yf(l),S.with({path:g.$gc.resolve(S.path,l)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,l){return S===l||S!==void 0&&l!==void 0&&(0,R.$8e)(S,l)}hasTrailingPathSeparator(S,l=g.sep){if(S.scheme===T.Schemas.file){const f=$(S);return f.length>D.$Zf(f).length&&f[f.length-1]===l}else{const f=S.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,l=g.sep){return(0,e.$Jg)(S,l)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,l=g.sep){let f=!1;if(S.scheme===T.Schemas.file){const s=$(S);f=s!==void 0&&s.length===D.$Zf(s).length&&s[s.length-1]===l}else{l="/";const s=S.path;f=s.length===1&&s.charCodeAt(s.length-1)===47}return!f&&!(0,e.$Jg)(S,l)?S.with({path:S.path+"/"}):S}}e.$sg=y,e.$tg=new y(()=>!1),e.$ug=new y(w=>w.scheme===T.Schemas.file?!I.$k:!0),e.$vg=new y(w=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function M(w,S){const l=[];for(let f=0;f<w.length;f++){const s=S(w[f]);w.some((i,n)=>n===f?!1:(0,e.$xg)(s,S(i)))||l.push(w[f])}return l}e.$Mg=M;var C;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function S(l){const f=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&f.set(o,a)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&f.set(w.META_DATA_MIME,i),f}w.parseMetaData=S})(C||(e.DataUri=C={}));function m(w,S,l){if(S){let f=w.path;return f&&f[0]!==g.$gc.sep&&(f=g.$gc.sep+f),w.with({scheme:l,authority:S,path:f})}return w.with({scheme:l})}e.$Ng=m}),define(ke[12],Se([1,0,21,8,4,3,23,11,163,43]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function M(_){return!!_&&typeof _.then=="function"}e.$Og=M;function C(_){const ie=new D.$3d,G=_(ie.token),te=new Promise((fe,ve)=>{const Ae=ie.token.onCancellationRequested(()=>{Ae.dispose(),ie.dispose(),ve(new T.$5)});Promise.resolve(G).then(pe=>{Ae.dispose(),ie.dispose(),fe(pe)},pe=>{Ae.dispose(),ie.dispose(),ve(pe)})});return new class{cancel(){ie.cancel()}then(fe,ve){return te.then(fe,ve)}catch(fe){return this.then(void 0,fe)}finally(fe){return te.finally(fe)}}}e.$Pg=C;function m(_,ie,G){return new Promise((te,fe)=>{const ve=ie.onCancellationRequested(()=>{ve.dispose(),te(G)});_.then(te,fe).finally(()=>ve.dispose())})}e.$Qg=m;function w(_,ie){return new Promise((G,te)=>{const fe=ie.onCancellationRequested(()=>{fe.dispose(),te(new T.$5)});_.then(G,te).finally(()=>fe.dispose())})}e.$Rg=w;async function S(_){let ie=-1;const G=_.map((te,fe)=>te.then(ve=>(ie=fe,ve)));try{return await Promise.race(G)}finally{_.forEach((te,fe)=>{fe!==ie&&te.cancel()})}}e.$Sg=S;function l(_,ie,G){let te;const fe=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([_.finally(()=>clearTimeout(fe)),new Promise(ve=>te=ve)])}e.$Tg=l;function f(_){return new Promise((ie,G)=>{const te=_();M(te)?te.then(ie,G):ie(te)})}e.$Ug=f;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,te(fe)})})}dispose(){this.f=!0}}e.$Vg=s;class i{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Wg=i;class n{constructor(){this.a=new Map}queue(ie,G){const fe=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===fe&&this.a.delete(ie)});return this.a.set(ie,fe),fe}}e.$Xg=n;const o=(_,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},a=_=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,_())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((fe,ve)=>{this.d=fe,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Pd?a(te):o(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=t;class r{constructor(ie){this.a=new t(ie),this.b=new s}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=r;class d{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=d;class u extends d{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$2g=u;function c(_,ie){return ie?new Promise((G,te)=>{const fe=setTimeout(()=>{ve.dispose(),G()},_),ve=ie.onCancellationRequested(()=>{clearTimeout(fe),ve.dispose(),te(new T.$5)})}):C(G=>c(_,G))}e.$3g=c;function h(_,ie=0,G){const te=setTimeout(()=>{_(),G&&fe.dispose()},ie),fe=(0,I.$Qc)(()=>{clearTimeout(te),G?.deleteAndLeak(fe)});return G?.add(fe),fe}e.$4g=h;function k(_){const ie=[];let G=0;const te=_.length;function fe(){return G<te?_[G++]():null}function ve(Ae){Ae!=null&&ie.push(Ae);const pe=fe();return pe?pe.then(ve):Promise.resolve(ie)}return Promise.resolve(null).then(ve)}e.$5g=k;function L(_,ie=te=>!!te,G=null){let te=0;const fe=_.length,ve=()=>{if(te>=fe)return Promise.resolve(G);const Ae=_[te++];return Promise.resolve(Ae()).then(De=>ie(De)?Promise.resolve(De):ve())};return ve()}e.$6g=L;function v(_,ie=te=>!!te,G=null){if(_.length===0)return Promise.resolve(G);let te=_.length;const fe=()=>{te=-1;for(const ve of _)ve.cancel?.()};return new Promise((ve,Ae)=>{for(const pe of _)pe.then(De=>{--te>=0&&ie(De)?(fe(),ve(De)):te===0&&ve(G)}).catch(De=>{--te>=0&&(fe(),Ae(De))})})}e.$7g=v;class b{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new g.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=b;class E extends b{constructor(){super(1)}}e.$9g=E;class A{constructor(){this.a=new Y,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$0g=A;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new Z;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=R.$tg){const te=G.getComparisonKey(ie);let fe=this.a.get(te);if(!fe){fe=new E;const ve=this.f++,Ae=g.Event.once(fe.onDrained)(()=>{fe?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$2c),this.d.set(ve,Ae),this.a.set(te,fe)}return fe}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=z;class O{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$_g=O;class P{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const fe=te.setInterval(()=>{ie()},G);this.d=(0,I.$Qc)(()=>{te.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$ah=P;class j{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=j;class N{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=N;class F extends j{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$dh=F;class W extends I.$Sc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new I.$Tc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(_,ie)=>{(0,p.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$gh=(_,ie,G)=>{const te=_.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,_.cancelIdleCallback(te))}}},e.$fh=_=>(0,e.$gh)(globalThis,_)}();class x{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$gh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=x;class ce extends x{constructor(ie){super(globalThis,ie)}}e.$ih=ce;async function J(_,ie,G){let te;for(let fe=0;fe<G;fe++)try{return await _()}catch(ve){te=ve,await c(ie)}throw te}e.$jh=J;class Y{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const fe=new Promise((ve,Ae)=>{G=ve,te=Ae});this.b={run:ie,promise:fe,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=Y;class X{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$lh=X;var se;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(se||(se={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new T.$5)}}e.$mh=Z;var we;(function(_){async function ie(te){let fe;const ve=await Promise.all(te.map(Ae=>Ae.then(pe=>pe,pe=>{fe||(fe=pe)})));if(typeof fe<"u")throw fe;return ve}_.settled=ie;function G(te){return new Promise(async(fe,ve)=>{try{await te(fe,ve)}catch(Ae){ve(Ae)}})}_.withAsyncBody=G})(we||(e.Promises=we={}));class de{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=de;class K{constructor(ie){this.b=ie,this.a=new y.$V(()=>new de(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=K;var B;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(B||(B={}));class ne{static fromArray(ie){return new ne(G=>{G.emitMany(ie)})}static fromPromise(ie){return new ne(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>{for await(const fe of te)G.emitOne(fe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new g.$Sd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new ne(async te=>{for await(const fe of ie)te.emitOne(G(fe))})}map(ie){return ne.map(this,ie)}static filter(ie,G){return new ne(async te=>{for await(const fe of ie)G(fe)&&te.emitOne(fe)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,G=>!!G)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$ph=ne;class ye extends ne{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$qh=ye;function he(_){const ie=new D.$3d,G=_(ie.token);return new ye(ie,async te=>{const fe=ie.token.onCancellationRequested(()=>{fe.dispose(),ie.dispose(),te.reject(new T.$5)});try{for await(const ve of G){if(ie.token.isCancellationRequested)return;te.emitOne(ve)}fe.dispose(),ie.dispose()}catch(ve){fe.dispose(),ie.dispose(),te.reject(ve)}})}e.$rh=he;class ge{constructor(){this.a=new Z,this.b=new ne(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=fe=>te.reject(fe),this.f=fe=>te.emitOne(fe),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$sh=ge}),define(ke[34],Se([1,0,19,12,33,28,16,11,13]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function y(){return Object.create(null)}e.$Dj=y,e.$Ej="**",e.$Fj="/";const M="[/\\\\]",C="[^/\\\\]",m=/\//g;function w(ce,J){switch(ce){case 0:return"";case 1:return`${C}*?`;default:return`(?:${M}|${C}+${M}${J?`|${M}${C}+`:""})*?`}}function S(ce,J){if(!ce)return[];const Y=[];let X=!1,se=!1,Z="";for(const we of ce){switch(we){case J:if(!X&&!se){Y.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":se=!0;break;case"]":se=!1;break}Z+=we}return Z&&Y.push(Z),Y}e.$Gj=S;function l(ce){if(!ce)return"";let J="";const Y=S(ce,e.$Fj);if(Y.every(X=>X===e.$Ej))J=".*";else{let X=!1;Y.forEach((se,Z)=>{if(se===e.$Ej){if(X)return;J+=w(2,Z===Y.length-1)}else{let we=!1,de="",K=!1,B="";for(const ne of se){if(ne!=="}"&&we){de+=ne;continue}if(K&&(ne!=="]"||!B)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!B?ye="^":ne===e.$Fj?ye="":ye=(0,$.$Ke)(ne),B+=ye;continue}switch(ne){case"{":we=!0;continue;case"[":K=!0;continue;case"}":{const he=`(?:${S(de,",").map(ge=>l(ge)).join("|")})`;J+=he,we=!1,de="";break}case"]":{J+="["+B+"]",K=!1,B="";break}case"?":J+=C;continue;case"*":J+=w(1);continue;default:J+=(0,$.$Ke)(ne)}}Z<Y.length-1&&(Y[Z+1]!==e.$Ej||Z+2<Y.length)&&(J+=M)}X=se===e.$Ej})}return J}const f=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Dc(1e4),r=function(){return!1},d=function(){return null};function u(ce,J){if(!ce)return d;let Y;typeof ce!="string"?Y=ce.pattern:Y=ce,Y=Y.trim();const X=`${Y}_${!!J.trimForExclusions}`;let se=t.get(X);if(se)return c(se,ce);let Z;return f.test(Y)?se=k(Y.substr(4),Y):(Z=s.exec(h(Y,J)))?se=L(Z[1],Y):(J.trimForExclusions?n:i).test(Y)?se=v(Y,J):(Z=o.exec(h(Y,J)))?se=b(Z[1].substr(1),Y,!0):(Z=a.exec(h(Y,J)))?se=b(Z[1],Y,!1):se=E(Y),t.set(X,se),c(se,ce)}function c(ce,J){if(typeof J=="string")return ce;const Y=function(X,se){return(0,g.$4f)(X,J.base,!p.$k)?ce((0,$.$Pe)(X.substr(J.base.length),R.sep),se):null};return Y.allBasenames=ce.allBasenames,Y.allPaths=ce.allPaths,Y.basenames=ce.basenames,Y.patterns=ce.patterns,Y}function h(ce,J){return J.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function k(ce,J){return function(Y,X){return typeof Y=="string"&&Y.endsWith(ce)?J:null}}function L(ce,J){const Y=`/${ce}`,X=`\\${ce}`,se=function(we,de){return typeof we!="string"?null:de?de===ce?J:null:we===ce||we.endsWith(Y)||we.endsWith(X)?J:null},Z=[ce];return se.basenames=Z,se.patterns=[J],se.allBasenames=Z,se}function v(ce,J){const Y=W(ce.slice(1,-1).split(",").map(de=>u(de,J)).filter(de=>de!==d),ce),X=Y.length;if(!X)return d;if(X===1)return Y[0];const se=function(de,K){for(let B=0,ne=Y.length;B<ne;B++)if(Y[B](de,K))return ce;return null},Z=Y.find(de=>!!de.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const we=Y.reduce((de,K)=>K.allPaths?de.concat(K.allPaths):de,[]);return we.length&&(se.allPaths=we),se}function b(ce,J,Y){const X=R.sep===R.$gc.sep,se=X?ce:ce.replace(m,R.sep),Z=R.sep+se,we=R.$gc.sep+ce;let de;return Y?de=function(K,B){return typeof K=="string"&&(K===se||K.endsWith(Z)||!X&&(K===ce||K.endsWith(we)))?J:null}:de=function(K,B){return typeof K=="string"&&(K===se||!X&&K===ce)?J:null},de.allPaths=[(Y?"*/":"./")+ce],de}function E(ce){try{const J=new RegExp(`^${l(ce)}$`);return function(Y){return J.lastIndex=0,typeof Y=="string"&&J.test(Y)?ce:null}}catch{return d}}function A(ce,J,Y){return!ce||typeof J!="string"?!1:z(ce)(J,void 0,Y)}e.$Hj=A;function z(ce,J={}){if(!ce)return r;if(typeof ce=="string"||O(ce)){const Y=u(ce,J);if(Y===d)return r;const X=function(se,Z){return!!Y(se,Z)};return Y.allBasenames&&(X.allBasenames=Y.allBasenames),Y.allPaths&&(X.allPaths=Y.allPaths),X}return N(ce,J)}e.$Ij=z;function O(ce){const J=ce;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Jj=O;function P(ce){return ce.allBasenames||[]}e.$Kj=P;function j(ce){return ce.allPaths||[]}e.$Lj=j;function N(ce,J){const Y=W(Object.getOwnPropertyNames(ce).map(de=>F(de,ce[de],J)).filter(de=>de!==d)),X=Y.length;if(!X)return d;if(!Y.some(de=>!!de.requiresSiblings)){if(X===1)return Y[0];const de=function(ne,ye){let he;for(let ge=0,_=Y.length;ge<_;ge++){const ie=Y[ge](ne,ye);if(typeof ie=="string")return ie;(0,T.$Og)(ie)&&(he||(he=[]),he.push(ie))}return he?(async()=>{for(const ge of he){const _=await ge;if(typeof _=="string")return _}return null})():null},K=Y.find(ne=>!!ne.allBasenames);K&&(de.allBasenames=K.allBasenames);const B=Y.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return B.length&&(de.allPaths=B),de}const se=function(de,K,B){let ne,ye;for(let he=0,ge=Y.length;he<ge;he++){const _=Y[he];_.requiresSiblings&&B&&(K||(K=(0,R.$nc)(de)),ne||(ne=K.substr(0,K.length-(0,R.$oc)(de).length)));const ie=_(de,K,ne,B);if(typeof ie=="string")return ie;(0,T.$Og)(ie)&&(ye||(ye=[]),ye.push(ie))}return ye?(async()=>{for(const he of ye){const ge=await he;if(typeof ge=="string")return ge}return null})():null},Z=Y.find(de=>!!de.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const we=Y.reduce((de,K)=>K.allPaths?de.concat(K.allPaths):de,[]);return we.length&&(se.allPaths=we),se}function F(ce,J,Y){if(J===!1)return d;const X=u(ce,Y);if(X===d)return d;if(typeof J=="boolean")return X;if(J){const se=J.when;if(typeof se=="string"){const Z=(we,de,K,B)=>{if(!B||!X(we,de))return null;const ne=se.replace("$(basename)",()=>K),ye=B(ne);return(0,T.$Og)(ye)?ye.then(he=>he?ce:null):ye?ce:null};return Z.requiresSiblings=!0,Z}}return X}function W(ce,J){const Y=ce.filter(de=>!!de.basenames);if(Y.length<2)return ce;const X=Y.reduce((de,K)=>{const B=K.basenames;return B?de.concat(B):de},[]);let se;if(J){se=[];for(let de=0,K=X.length;de<K;de++)se.push(J)}else se=Y.reduce((de,K)=>{const B=K.patterns;return B?de.concat(B):de},[]);const Z=function(de,K){if(typeof de!="string")return null;if(!K){let ne;for(ne=de.length;ne>0;ne--){const ye=de.charCodeAt(ne-1);if(ye===47||ye===92)break}K=de.substr(ne)}const B=X.indexOf(K);return B!==-1?se[B]:null};Z.basenames=X,Z.patterns=se,Z.allBasenames=X;const we=ce.filter(de=>!de.basenames);return we.push(Z),we}function x(ce,J){return(0,D.$ub)(ce,J,(Y,X)=>typeof Y=="string"&&typeof X=="string"?Y===X:typeof Y!="string"&&typeof X!="string"?Y.base===X.base&&Y.pattern===X.pattern:!1)}e.$Mj=x}),define(ke[80],Se([1,0,8,164,23,13,2]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(f){f[f.Paragraph=0]="Paragraph",f[f.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class ${constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,D.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=m(this.supportThemeIcons?(0,T.$0j)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,I.$Ke)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$dk=$;function y(f){return M(f)?!f.value:Array.isArray(f)?f.every(y):!0}e.$ek=y;function M(f){return f instanceof $?!0:f&&typeof f=="object"?typeof f.value=="string"&&(typeof f.isTrusted=="boolean"||typeof f.isTrusted=="object"||f.isTrusted===void 0)&&(typeof f.supportThemeIcons=="boolean"||f.supportThemeIcons===void 0):!1}e.$fk=M;function C(f,s){return f===s?!0:!f||!s?!1:f.value===s.value&&f.isTrusted===s.isTrusted&&f.supportThemeIcons===s.supportThemeIcons&&f.supportHtml===s.supportHtml&&(f.baseUri===s.baseUri||!!f.baseUri&&!!s.baseUri&&(0,g.$wg)(R.URI.from(f.baseUri),R.URI.from(s.baseUri)))}e.$gk=C;function m(f){return f.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=m;function w(f){return f.replace(/"/g,"&quot;")}e.$ik=w;function S(f){return f&&f.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$jk=S;function l(f){const s=[],i=f.split("|").map(o=>o.trim());f=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",d=isFinite(parseInt(r)),u=isFinite(parseInt(t));d&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:f,dimensions:s}}e.$kk=l}),define(ke[102],Se([1,0,19,33,16,11,23,13]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=void 0;function $(u,c){const{os:h,tildify:k,relative:L}=c;if(L){const E=y(u,L,h);if(typeof E=="string")return E}let v=u.fsPath;if(h===1&&!I.$i?v=v.replace(/\//g,"\\"):h!==1&&I.$i&&(v=v.replace(/\\/g,"/")),h!==1&&k?.userHome){const E=k.userHome.fsPath;let A;u.scheme!==k.userHome.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep?A=k.userHome.with({path:u.path}).fsPath:A=v,v=m(A,E,h)}return(h===1?g.$fc:g.$gc).normalize(M(v,h===1))}e.$Gv=$;function y(u,c,h){const k=h===1?g.$fc:g.$gc,L=h===3?R.$tg:R.$vg,v=c.getWorkspace(),b=(0,D.$Ob)(v.folders);if(!b)return;u.scheme!==b.uri.scheme&&u.path[0]===g.$gc.sep&&u.path[1]!==g.$gc.sep&&(u=b.uri.with({path:u.path}));const E=c.getWorkspaceFolder(u);if(!E)return;let A;if(L.isEqual(E.uri,u)?A="":A=L.relativePath(E.uri,u)??"",A&&(A=k.normalize(A)),v.folders.length>1&&!c.noPrefix){const z=E.name?E.name:L.basenameOrAuthority(E.uri);A=A?`${z} \u2022 ${A}`:z}return A}function M(u,c=I.$i){return(0,T.$8f)(u,c)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$Hv=M;let C=Object.create(null);function m(u,c,h=I.OS){if(h===1||!u||!c)return u;let k=C.original===c?C.normalized:void 0;k||(k=c,I.$i&&(k=(0,T.$Xf)(k)),k=`${(0,p.$Qe)(k,g.$gc.sep)}${g.$gc.sep}`,C={original:c,normalized:k});let L=u;return I.$i&&(L=(0,T.$Xf)(L)),(h===3?L.startsWith(k):(0,p.$9e)(L,k))?`~/${L.substr(k.length)}`:u}e.$Iv=m;function w(u,c){return u.replace(/^~($|\/|\\)/,`${c}$1`)}e.$Jv=w;const S="\u2026",l="\\\\",f="~";function s(u,c=g.sep){const h=new Array(u.length);let k=!1;for(let L=0;L<u.length;L++){const v=u[L];if(v===""){h[L]=`.${c}`;continue}if(!v){h[L]=v;continue}k=!0;let b="",E=v;E.indexOf(l)===0?(b=E.substr(0,E.indexOf(l)+l.length),E=E.substr(E.indexOf(l)+l.length)):E.indexOf(c)===0?(b=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(f)===0&&(b=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length));const A=E.split(c);for(let z=1;k&&z<=A.length;z++)for(let O=A.length-z;k&&O>=0;O--){k=!1;let P=A.slice(O,O+z).join(c);for(let j=0;!k&&j<u.length;j++)if(j!==L&&u[j]&&u[j].indexOf(P)>-1){const N=O+z===A.length,F=O>0&&u[j].indexOf(c)>-1?c+P:P,W=u[j].endsWith(F);k=!N||W}if(!k){let j="";(A[0].endsWith(":")||b!=="")&&(O===1&&(O=0,z++,P=A[0]+c+P),O>0&&(j=A[0]+c),j=b+j),O>0&&(j=j+S+c),j=j+P,O+z<A.length&&(j=j+c+S),h[L]=j}}k&&(h[L]=v)}return h}e.$Kv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,c=Object.create(null)){const h=[];let k=!1,L="";for(const v of u)if(v==="$"||k&&v==="{")L&&h.push({value:L,type:i.TEXT}),L="",k=!0;else if(v==="}"&&k){const b=c[L];if(typeof b=="string")b.length&&h.push({value:b,type:i.VARIABLE});else if(b){const E=h[h.length-1];(!E||E.type!==i.SEPARATOR)&&h.push({value:b.label,type:i.SEPARATOR})}L="",k=!1}else L+=v;return L&&!k&&h.push({value:L,type:i.TEXT}),h.filter((v,b)=>{if(v.type===i.SEPARATOR){const E=h[b-1],A=h[b+1];return[E,A].every(z=>z&&(z.type===i.VARIABLE||z.type===i.TEXT)&&z.value.length>0)}return!0}).map(v=>v.value).join("")}e.$Lv=n;function o(u,c){return I.$j||c?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):u.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Mv=o;function a(u,c){return I.$j||c?u.replace(/\(&&\w\)|&&/g,""):I.$i?u.replace(/&&|&/g,h=>h==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Nv=a;function t(u){return u.replace(/&/g,"&&")}e.$Ov=t;function r(u){if(u.endsWith("]")){const c=u.lastIndexOf(" [",u.length-2);if(c!==-1){const h=d(u.substring(0,c));return{name:h.name,parentPath:h.parentPath+u.substring(c)}}}return d(u)}e.$Pv=r;function d(u){const c=u.indexOf("/")!==-1?g.$gc:g.$fc,h=c.basename(u),k=c.dirname(u);return h.length?{name:h,parentPath:k}:{name:k,parentPath:""}}}),define(ke[130],Se([1,0,22,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const w=this.a.transformIncoming(m);return w===m?m:g(T.URI.from(w))}transformOutgoing(m){const w=this.a.transformOutgoing(m);return w===m?m:g(T.URI.from(w))}transformOutgoingURI(m){const w=this.a.transformOutgoing(m);return w===m?m:T.URI.from(w)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$Ym=I,e.$Zm=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,m,w){if(!C||w>200)return null;if(typeof C=="object"){if(C instanceof T.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const l=R(C[S],m,w+1);l!==null&&(C[S]=l)}}return null}function p(C,m){const w=R(C,m,0);return w===null?C:w}e.$1m=p;function $(C,m,w,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return w?T.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$ge)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const f=$(C[l],m,w,S+1);f!==null&&(C[l]=f)}}return null}function y(C,m){const w=$(C,m,!1,0);return w===null?C:w}e.$2m=y;function M(C,m){const w=$(C,m,!0,0);return w===null?C:w}e.$3m=M}),define(ke[31],Se([1,0,55,63,385,12,33,76,16,11,23,2]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function w(F,W=m.UNLINK,x){if((0,R.$7f)(F))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?l(F):S(F,x)}async function S(F,W=(0,R.$_f)((0,T.tmpdir)())){try{try{await D.promises.rename(F,W)}catch(x){return x.code==="ENOENT"?void 0:l(F)}l(W).catch(x=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function l(F){return(0,g.promisify)(D.rm)(F,{recursive:!0,force:!0,maxRetries:3})}function f(F){if((0,R.$7f)(F))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function s(F,W){return o(await(W?i(F):(0,g.promisify)(D.readdir)(F)))}async function i(F){try{return await(0,g.promisify)(D.readdir)(F,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const W=[],x=await s(F);for(const ce of x){let J=!1,Y=!1,X=!1;try{const se=await e.Promises.lstat((0,$.$jc)(F,ce));J=se.isFile(),Y=se.isDirectory(),X=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}W.push({name:ce,isFile:()=>J,isDirectory:()=>Y,isSymbolicLink:()=>X})}return W}function n(F){return o(D.readdirSync(F))}e.readdirSync=n;function o(F){return F.map(W=>typeof W=="string"?y.$j?(0,p.$Bl)(W):W:(W.name=y.$j?(0,p.$Bl)(W.name):W.name,W))}async function a(F){const W=await s(F),x=[];for(const ce of W)await r.existsDirectory((0,$.$jc)(F,ce))&&x.push(ce);return x}function t(F,W=1e3){return new Promise(x=>{let ce=!1;const J=setInterval(()=>{ce||(ce=!0,D.access(F,Y=>{ce=!1,Y&&(clearInterval(J),x(void 0))}))},W)})}e.whenDeleted=t;var r;(function(F){async function W(J){let Y;try{if(Y=await e.Promises.lstat(J),!Y.isSymbolicLink())return{stat:Y}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:Y?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};if(y.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&Y)return{stat:Y,symbolicLink:{dangling:!0}};throw se}throw X}}F.stat=W;async function x(J){try{const{stat:Y,symbolicLink:X}=await F.stat(J);return Y.isFile()&&X?.dangling!==!0}catch{}return!1}F.existsFile=x;async function ce(J){try{const{stat:Y,symbolicLink:X}=await F.stat(J);return Y.isDirectory()&&X?.dangling!==!0}catch{}return!1}F.existsDirectory=ce})(r||(e.SymlinkSupport=r={}));const d=new I.$$g;function u(F,W,x){return d.queueFor(C.URI.file(F),M.$ug).queue(()=>{const ce=v(x);return new Promise((J,Y)=>k(F,W,ce,X=>X?Y(X):J()))})}let c=!0;function h(F){c=F}e.configureFlushOnWrite=h;function k(F,W,x,ce){if(!c)return D.writeFile(F,W,{mode:x.mode,flag:x.flag},ce);D.open(F,x.flag,x.mode,(J,Y)=>{if(J)return ce(J);D.writeFile(Y,W,X=>{if(X)return D.close(Y,()=>ce(X));D.fdatasync(Y,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),h(!1)),D.close(Y,Z=>ce(Z))))})})}function L(F,W,x){const ce=v(x);if(!c)return D.writeFileSync(F,W,{mode:ce.mode,flag:ce.flag});const J=D.openSync(F,ce.flag,ce.mode);try{D.writeFileSync(J,W);try{D.fdatasyncSync(J)}catch(Y){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Y),h(!1)}}finally{D.closeSync(J)}}e.writeFileSync=L;function v(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function b(F,W,x=6e4){if(F!==W)try{y.$i&&typeof x=="number"?await E(F,W,Date.now(),x):await(0,g.promisify)(D.rename)(F,W)}catch(ce){if(F.toLowerCase()!==W.toLowerCase()&&ce.code==="EXDEV"||F.endsWith("."))await A(F,W,{preserveSymlinks:!1}),await w(F,m.MOVE);else throw ce}}async function E(F,W,x,ce,J=0){try{return await(0,g.promisify)(D.rename)(F,W)}catch(Y){if(Y.code!=="EACCES"&&Y.code!=="EPERM"&&Y.code!=="EBUSY")throw Y;if(Date.now()-x>=ce)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${Y}`),Y;if(J===0){let X=!1;try{const{stat:se}=await r.stat(W);se.isFile()||(X=!0)}catch{}if(X)throw Y}return await(0,I.$3g)(Math.min(100,J*10)),E(F,W,x,ce,J+1)}}async function A(F,W,x){return O(F,W,{root:{source:F,target:W},options:x,handledSourcePaths:new Set})}const z=511;async function O(F,W,x){if(x.handledSourcePaths.has(F))return;x.handledSourcePaths.add(F);const{stat:ce,symbolicLink:J}=await r.stat(F);if(J){if(x.options.preserveSymlinks)try{return await N(F,W,x)}catch{}if(J.dangling)return}return ce.isDirectory()?P(F,W,ce.mode&z,x):j(F,W,ce.mode&z)}async function P(F,W,x,ce){await e.Promises.mkdir(W,{recursive:!0,mode:x});const J=await s(F);for(const Y of J)await O((0,$.$jc)(F,Y),(0,$.$jc)(W,Y),ce)}async function j(F,W,x){await e.Promises.copyFile(F,W),await e.Promises.chmod(W,x)}async function N(F,W,x){let ce=await e.Promises.readlink(F);(0,R.$4f)(ce,x.root.source,!y.$k)&&(ce=(0,$.$jc)(x.root.target,ce.substr(x.root.source.length+1))),await e.Promises.symlink(ce,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(F,W,x,ce,J)=>new Promise((Y,X)=>{D.read(F,W,x,ce,J,(se,Z,we)=>se?X(se):Y({bytesRead:Z,buffer:we}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(F,W,x,ce,J)=>new Promise((Y,X)=>{D.write(F,W,x,ce,J,(se,Z,we)=>se?X(se):Y({bytesWritten:Z,buffer:we}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return w}get rename(){return b}get copy(){return A}}}),define(ke[103],Se([1,0,55,16,11,13,31]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.$gq=e.$fq=void 0;function p(m){if(g.$k)return m;const w=(0,T.$mc)(m);if(m===w)return m;const S=((0,T.$nc)(m)||m).toLowerCase();try{const f=(0,R.readdirSync)(w).filter(s=>s.toLowerCase()===S);if(f.length===1){const s=p(w);if(s)return(0,T.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(S);if(s>=0){const i=p(w);if(i)return(0,T.$jc)(i,f[s])}}}catch{}return null}e.$fq=p;async function $(m){if(g.$k)return m;const w=(0,T.$mc)(m);if(m===w)return m;const S=((0,T.$nc)(m)||m).toLowerCase();try{const f=(await R.Promises.readdir(w)).filter(s=>s.toLowerCase()===S);if(f.length===1){const s=await $(w);if(s)return(0,T.$jc)(s,f[0])}else if(f.length>1){const s=f.indexOf(S);if(s>=0){const i=await $(w);if(i)return(0,T.$jc)(i,f[s])}}}catch{}return null}e.$gq=$;async function y(m){try{return await R.Promises.realpath(m)}catch{const S=C(m);return await R.Promises.access(S,D.constants.R_OK),S}}e.$hq=y;function M(m){try{return D.realpathSync(m)}catch{const S=C(m);return D.accessSync(S,D.constants.R_OK),S}}e.$iq=M;function C(m){return(0,I.$Qe)((0,T.$hc)(m),T.sep)}}),define(ke[104],Se([1,0,16,11,50,101,18,31]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Pl=e.$Ol=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Ol=$;function y(C){let m=[],w=!1;const S=function(l){if(w){m.push(l);return}(!C.send(l,s=>{if(s&&console.error(s),w=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>S(n))}})||T.$i)&&(w=!0)};return{send:S}}e.$Pl=y;var M;(function(C){async function m(w,S,l){if(D.$ic(w))return w;if(S===void 0&&(S=g.cwd()),D.$mc(w)!=="."||(l===void 0&&R.$Ef(g.env.PATH)&&(l=g.env.PATH.split(D.$tc)),l===void 0||l.length===0))return D.$jc(S,w);async function s(i){if(await p.Promises.exists(i)){let n;try{n=await p.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await p.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of l){let n;if(D.$ic(i)?n=D.$jc(i,w):n=D.$jc(S,i,w),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.$jc(S,w)}C.findExecutable=m})(M||(e.win32=M={}))});var Je=this&&this.__decorate||function(me,e,D,T){var g=arguments.length,I=g<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,D):T,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(me,e,D,T);else for(var p=me.length-1;p>=0;p--)(R=me[p])&&(I=(g<3?R(I):g>3?R(e,D,I):R(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(ke[81],Se([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=e.ProxyChannel=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.RequestInitiator=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0;var w;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(w||(w={}));function S(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(l||(l={}));function f(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(s||(s={}));function i(J){let Y=0;for(let X=0;;X+=7){const se=J.read(1);if(Y|=(se.buffer[0]&127)<<X,!(se.buffer[0]&128))return Y}}const n=d(0);function o(J,Y){if(Y===0){J.write(n);return}let X=0;for(let Z=Y;Z!==0;Z=Z>>>7)X++;const se=g.$ge.alloc(X);for(let Z=0;Y!==0;Z++)se.buffer[Z]=Y&127,Y=Y>>>7,Y>0&&(se.buffer[Z]|=128);J.write(se)}class a{constructor(Y){this.b=Y,this.a=0}read(Y){const X=this.b.slice(this.a,this.a+Y);return this.a+=X.byteLength,X}}e.$zh=a;class t{constructor(){this.a=[]}get buffer(){return g.$ge.concat(this.a)}write(Y){this.a.push(Y)}}e.$Ah=t;var r;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(r||(r={}));function d(J){const Y=g.$ge.alloc(1);return Y.writeUInt8(J,0),Y}const u={Undefined:d(r.Undefined),String:d(r.String),Buffer:d(r.Buffer),VSBuffer:d(r.VSBuffer),Array:d(r.Array),Object:d(r.Object),Uint:d(r.Int)},c=typeof Buffer<"u";function h(J,Y){if(typeof Y>"u")J.write(u.Undefined);else if(typeof Y=="string"){const X=g.$ge.fromString(Y);J.write(u.String),o(J,X.byteLength),J.write(X)}else if(c&&Buffer.isBuffer(Y)){const X=g.$ge.wrap(Y);J.write(u.Buffer),o(J,X.byteLength),J.write(X)}else if(Y instanceof g.$ge)J.write(u.VSBuffer),o(J,Y.byteLength),J.write(Y);else if(Array.isArray(Y)){J.write(u.Array),o(J,Y.length);for(const X of Y)h(J,X)}else if(typeof Y=="number"&&(Y|0)===Y)J.write(u.Uint),o(J,Y);else{const X=g.$ge.fromString(JSON.stringify(Y));J.write(u.Object),o(J,X.byteLength),J.write(X)}}e.$Bh=h;function k(J){switch(J.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return J.read(i(J)).toString();case r.Buffer:return J.read(i(J)).buffer;case r.VSBuffer:return J.read(i(J));case r.Array:{const X=i(J),se=[];for(let Z=0;Z<X;Z++)se.push(k(J));return se}case r.Object:return JSON.parse(J.read(i(J)).toString());case r.Int:return i(J)}}e.$Ch=k;class L{constructor(Y,X,se=null,Z=1e3){this.h=Y,this.j=X,this.k=se,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(we=>this.q(we)),this.m({type:200})}registerChannel(Y,X){this.b.set(Y,X),setTimeout(()=>this.w(Y),0)}m(Y){switch(Y.type){case 200:{const X=this.o([Y.type]);this.k?.logOutgoing(X,0,1,f(Y.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Y.type,Y.id],Y.data);this.k?.logOutgoing(X,Y.id,1,f(Y.type),Y.data);return}}}o(Y,X=void 0){const se=new t;return h(se,Y),h(se,X),this.p(se.buffer)}p(Y){try{return this.h.send(Y),Y.byteLength}catch{return 0}}q(Y){const X=new a(Y),se=k(X),Z=k(X),we=se[0];switch(we){case 100:return this.k?.logIncoming(Y.byteLength,se[1],1,`${S(we)}: ${se[2]}.${se[3]}`,Z),this.s({type:we,id:se[1],channelName:se[2],name:se[3],arg:Z});case 102:return this.k?.logIncoming(Y.byteLength,se[1],1,`${S(we)}: ${se[2]}.${se[3]}`,Z),this.t({type:we,id:se[1],channelName:se[2],name:se[3],arg:Z});case 101:return this.k?.logIncoming(Y.byteLength,se[1],1,`${S(we)}`),this.u({type:we,id:se[1]});case 103:return this.k?.logIncoming(Y.byteLength,se[1],1,`${S(we)}`),this.u({type:we,id:se[1]})}}s(Y){const X=this.b.get(Y.channelName);if(!X){this.v(Y);return}const se=new I.$3d;let Z;try{Z=X.call(this.j,Y.name,Y.arg,se.token)}catch(K){Z=Promise.reject(K)}const we=Y.id;Z.then(K=>{this.m({id:we,data:K,type:201})},K=>{K instanceof Error?this.m({id:we,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:we,data:K,type:203})}).finally(()=>{de.dispose(),this.d.delete(Y.id)});const de=(0,y.$Qc)(()=>se.cancel());this.d.set(Y.id,de)}t(Y){const X=this.b.get(Y.channelName);if(!X){this.v(Y);return}const se=Y.id,we=X.listen(this.j,Y.name,Y.arg)(de=>this.m({id:se,data:de,type:204}));this.d.set(Y.id,we)}u(Y){const X=this.d.get(Y.id);X&&(X.dispose(),this.d.delete(Y.id))}v(Y){let X=this.g.get(Y.channelName);X||(X=[],this.g.set(Y.channelName,X));const se=setTimeout(()=>{console.error(`Unknown channel: ${Y.channelName}`),Y.type===100&&this.m({id:Y.id,data:{name:"Unknown channel",message:`Channel name '${Y.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Y,timeoutTimer:se})}w(Y){const X=this.g.get(Y);if(X){for(const se of X)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(Y)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Dh=L;var v;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class b{constructor(Y,X=null){this.l=Y,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Sd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=X}getChannel(Y){const X=this;return{call(se,Z,we){return X.a?Promise.reject(new p.$5):X.m(Y,se,Z,we)},listen(se,Z){return X.a?$.Event.None:X.o(Y,se,Z)}}}m(Y,X,se,Z=I.CancellationToken.None){const we=this.g++,K={id:we,type:100,channelName:Y,name:X,arg:se};if(Z.isCancellationRequested)return Promise.reject(new p.$5);let B;return new Promise((ye,he)=>{if(Z.isCancellationRequested)return he(new p.$5);const ge=()=>{const te=fe=>{switch(fe.type){case 201:this.f.delete(we),ye(fe.data);break;case 202:{this.f.delete(we);const ve=new Error(fe.data.message);ve.stack=Array.isArray(fe.data.stack)?fe.data.stack.join(`
`):fe.data.stack,ve.name=fe.data.name,he(ve);break}case 203:this.f.delete(we),he(fe.data);break}};this.f.set(we,te),this.p(K)};let _=null;this.b===s.Idle?ge():(_=(0,T.$Pg)(te=>this.u()),_.then(()=>{_=null,ge()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:we,type:101}),he(new p.$5)},G=Z.onCancellationRequested(ie);B=(0,y.$Pc)((0,y.$Qc)(ie),G),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Y,X,se){const Z=this.g++,de={id:Z,type:102,channelName:Y,name:X,arg:se};let K=null;const B=new $.$Sd({onWillAddFirstListener:()=>{K=(0,T.$Pg)(ye=>this.u()),K.then(()=>{K=null,this.d.add(B),this.p(de)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(B),this.p({id:Z,type:103}))}}),ne=ye=>B.fire(ye.data);return this.f.set(Z,ne),B.event}p(Y){switch(Y.type){case 100:case 102:{const X=this.q([Y.type,Y.id,Y.channelName,Y.name],Y.arg);this.j?.logOutgoing(X,Y.id,0,`${S(Y.type)}: ${Y.channelName}.${Y.name}`,Y.arg);return}case 101:case 103:{const X=this.q([Y.type,Y.id]);this.j?.logOutgoing(X,Y.id,0,S(Y.type));return}}}q(Y,X=void 0){const se=new t;return h(se,Y),h(se,X),this.r(se.buffer)}r(Y){try{return this.l.send(Y),Y.byteLength}catch{return 0}}s(Y){const X=new a(Y),se=k(X),Z=k(X),we=se[0];switch(we){case 200:return this.j?.logIncoming(Y.byteLength,0,0,f(we)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Y.byteLength,se[1],0,f(we),Z),this.t({type:se[0],id:se[1],data:Z})}}t(Y){if(Y.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Y.id)?.(Y)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Nc)(this.d.values()),this.d.clear()}}e.$Eh=b,Je([R.$th],b.prototype,"onDidInitializePromise",null);class E{get connections(){const Y=[];return this.f.forEach(X=>Y.push(X)),Y}constructor(Y){this.a=new Map,this.f=new Set,this.g=new $.$Sd,this.onDidAddConnection=this.g.event,this.h=new $.$Sd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Rc,this.j.add(Y(({protocol:X,onDidClientDisconnect:se})=>{const Z=$.Event.once(X.onMessage);this.j.add(Z(we=>{const de=new a(we),K=k(de),B=new L(X,K),ne=new b(X);this.a.forEach((he,ge)=>B.registerChannel(ge,he));const ye={channelServer:B,channelClient:ne,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(se(()=>{B.dispose(),ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Y,X){const se=this;return{call(Z,we,de){let K;if((0,m.$Sf)(X)){const ne=(0,D.$4b)(se.connections.filter(X));K=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(se.onDidAddConnection,X))}else K=X.routeCall(se,Z,we);const B=K.then(ne=>ne.channelClient.getChannel(Y));return z(B).call(Z,we,de)},listen(Z,we){if((0,m.$Sf)(X))return se.k(Y,X,Z,we);const de=X.routeEvent(se,Z,we).then(K=>K.channelClient.getChannel(Y));return z(de).listen(Z,we)}}}k(Y,X,se,Z){const we=this;let de;const K=new $.$Sd({onWillAddFirstListener:()=>{de=new y.$Rc;const B=new $.$Yd,ne=new Map,ye=ge=>{const ie=ge.channelClient.getChannel(Y).listen(se,Z),G=B.add(ie);ne.set(ge,G)},he=ge=>{const _=ne.get(ge);_&&(_.dispose(),ne.delete(ge))};we.connections.filter(X).forEach(ye),$.Event.filter(we.onDidAddConnection,X)(ye,void 0,de),we.onDidRemoveConnection(he,void 0,de),B.event(K.fire,K,de),de.add(B)},onDidRemoveLastListener:()=>{de?.dispose(),de=void 0}});return K.event}registerChannel(Y,X){this.a.set(Y,X);for(const se of this.f)se.channelServer.registerChannel(Y,X)}dispose(){this.j.dispose();for(const Y of this.f)Y.channelClient.dispose(),Y.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Fh=E;class A{constructor(Y,X,se=null){const Z=new t;h(Z,X),Y.send(Z.buffer),this.a=new b(Y,se),this.d=new L(Y,X,se)}getChannel(Y){return this.a.getChannel(Y)}registerChannel(Y,X){this.d.registerChannel(Y,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Gh=A;function z(J){return{call(Y,X,se){return J.then(Z=>Z.call(Y,X,se))},listen(Y,X){const se=new $.$2d;return J.then(Z=>se.input=Z.listen(Y,X)),se.event}}}e.$Hh=z;function O(J){let Y=!1;return{call(X,se,Z){return Y?J.call(X,se,Z):(0,T.$3g)(0).then(()=>Y=!0).then(()=>J.call(X,se,Z))},listen(X,se){if(Y)return J.listen(X,se);const Z=new $.$2d;return(0,T.$3g)(0).then(()=>Y=!0).then(()=>Z.input=J.listen(X,se)),Z.event}}}e.$Ih=O;class P{constructor(Y){this.a=Y}routeCall(Y){return this.b(Y)}routeEvent(Y){return this.b(Y)}async b(Y){for(const X of Y.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await $.Event.toPromise(Y.onDidAddConnection),await this.b(Y)}}e.$Jh=P;var j;(function(J){function Y(we,de,K){const B=we,ne=K&&K.disableMarshalling,ye=new Map;for(const he in B)se(he)&&ye.set(he,$.Event.buffer(B[he],!0,void 0,de));return new class{listen(he,ge,_){const ie=ye.get(ge);if(ie)return ie;if(Z(ge)){const G=B[ge];if(typeof G=="function")return G.call(B,_)}throw new p.$bb(`Event not found: ${ge}`)}call(he,ge,_){const ie=B[ge];if(typeof ie=="function"){if(!ne&&Array.isArray(_))for(let te=0;te<_.length;te++)_[te]=(0,M.$yh)(_[te]);let G=ie.apply(B,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new p.$bb(`Method not found: ${ge}`)}}}J.fromService=Y;function X(we,de){const K=de&&de.disableMarshalling;return new Proxy({},{get(B,ne){if(typeof ne=="string")return de?.properties?.has(ne)?de.properties.get(ne):Z(ne)?function(ye){return we.listen(ne,ye)}:se(ne)?we.listen(ne):async function(...ye){let he;de&&!(0,m.$Nf)(de.context)?he=[de.context,...ye]:he=ye;const ge=await we.call(ne,he);return K?ge:(0,M.$yh)(ge)};throw new p.$bb(`Property not found: ${String(ne)}`)}})}J.toService=X;function se(we){return we[0]==="o"&&we[1]==="n"&&C.$7e(we.charCodeAt(2))}function Z(we){return/^onDynamic/.test(we)&&C.$7e(we.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const Y=J.toString();if(Y!=="[object Object]")return Y}return J}function W(J){return Array.isArray(J)?J.map(F):F(J)}function x(J,Y,X,se,Z,we,de){de=W(de);const K=N[Z],B=K[se%K.length];let ne=[`%c[${J}]%c[${String(Y).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${we}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(we)?(ne=ne.concat(de),ne.push(")")):ne.push(de),console.log.apply(console,ne)}class ce{constructor(Y,X){this.d=Y,this.f=X,this.a=0,this.b=0}logOutgoing(Y,X,se,Z,we){this.b+=Y,x(this.d,this.b,Y,X,se,Z,we)}logIncoming(Y,X,se,Z,we){this.a+=Y,x(this.f,this.a,Y,X,se,Z,we)}}e.$Kh=ce}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.ProtocolConstants=e.$Lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var p;(function(u){u.enableDiagnostics=!1,u.records=[];const c=new WeakMap;let h=0;function k(v,b){if(!c.has(v)){const E=String(++h);c.set(v,E)}return c.get(v)}function L(v,b,E,A){if(!u.enableDiagnostics)return;const z=k(v,b);if(A instanceof D.$ge||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const O=D.$ge.alloc(A.byteLength);O.set(A),u.records.push({timestamp:Date.now(),id:z,label:b,type:E,buff:O})}else u.records.push({timestamp:Date.now(),id:z,label:b,type:E,data:A})}u.traceSocketEvent=L})(p||(e.SocketDiagnostics=p={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function M(){return y||(y=D.$ge.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return M();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const b=this.a[0];return h&&(this.a.shift(),this.b-=c),b}if(this.a[0].byteLength>c){const b=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),b}const k=D.$ge.alloc(c);let L=0,v=0;for(;c>0;){const b=this.a[v];if(b.byteLength>c){const E=b.slice(0,c);k.set(E,L),L+=c,h&&(this.a[v]=b.slice(c),this.b-=c),c-=c}else k.set(b,L),L+=b.byteLength,h?(this.a.shift(),this.b-=b.byteLength):v++,c-=b.byteLength}return k}}e.$Lh=C;var m;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(m||(m={}));function w(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class l{constructor(c,h,k,L){this.type=c,this.id=h,this.ack=k,this.data=L,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends g.$Sc{constructor(c){super(),this.f=this.B(new T.$Sd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,L=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new l(k,L,v,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=D.$ge.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const k=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,k}h(){const c=D.$ge.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends g.$Sc{constructor(c){super(),this.f=new T.$Sd,this.onMessage=this.f.event,this.g=new T.$Sd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new s(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new l(1,0,0,c))}}e.$Mh=i;class n extends I.$Gh{static fromSocket(c,h){return new n(new i(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,k=null){super(c,h,k),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$Nh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Sd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Oh=o;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,k=this.a;for(;k;)c[h++]=k.data,k=k.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new a(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<r.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=r.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+r.a)*1e3;let k=0;for(let L=0;L<r.a;L++)c-this.c[L]<=h&&k++;return 1-k/r.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Rc,this.o=c.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new l(5,0,0,M());this.p.write(c),this.p.flush()}sendPause(){const c=new l(7,0,0,M());this.p.write(c)}sendResume(){const c=new l(8,0,0,M());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new g.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new l(3,0,this.h,M());this.p.write(c);const h=this.b.toArray();for(let k=0,L=h.length;k<L;k++)this.p.write(h[k]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new l(6,0,0,M())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let k=0,L=h.length;k<L;k++)this.p.write(h[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const k=new l(1,h,this.h,c);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(c){const h=new l(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,k=Date.now()-this.q.lastReadTime,L=Date.now()-this.n;if(h>=2e4&&k>=2e4&&L>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:k});return}const v=Math.max(2e4-h,2e4-k,2e4-L,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new l(3,0,this.h,M());this.p.write(c)}D(){this.h=this.g;const c=new l(9,0,this.h,M());this.p.write(c)}}e.$Ph=d}),define(ke[187],Se([1,0,51,12,22,21,185,8,4,3,24,104,101,81]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class S extends w.$Dh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$ge.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$cq=S;class l{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Sd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new T.$Yg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(p.$6());this.b.cancel();const a=this.n(s),t=(0,T.$Pg)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),d=(0,y.$Qc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{r.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const a=new $.$Sd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,M.$hn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,m.$Nl)(i.env),this.d=(0,D.fork)(this.i,s,i);const n=new $.$Sd;$.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,R.$$p)(c)){(0,R.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$ge.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,C.$Pl)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),r=n.event,d={send:t,onMessage:r};this.f=new w.$Eh(d);const u=()=>this.o();process.once("exit",u),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,h)=>{process.removeListener("exit",u),this.c.forEach(k=>(0,y.$Nc)(k)),this.c.clear(),c!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:h})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$dq=l}),define(ke[188],Se([1,0,12,4,3,54,18]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.StorageState=e.$bp=e.StorageHint=void 0;var p;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function $(m){const w=m;return w?.changed instanceof Map||w?.deleted instanceof Set}e.$bp=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class M extends g.$Sc{static{this.a=100}constructor(w,S=Object.create(null)){super(),this.r=w,this.s=S,this.b=this.B(new T.$Vd),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$Zg(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((S,l)=>this.w(l,S)),w.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(w,S){if(this.c===y.Closed)return;let l=!1;(0,R.$Nf)(S)?l=this.f.delete(w):this.f.get(w)!==S&&(this.f.set(w,S),l=!0),l&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,S){const l=this.f.get(w);return(0,R.$Nf)(l)?S:l}getBoolean(w,S){const l=this.get(w);return(0,R.$Nf)(l)?S:l==="true"}getNumber(w,S){const l=this.get(w);return(0,R.$Nf)(l)?S:parseInt(l,10)}getObject(w,S){const l=this.get(w);return(0,R.$Nf)(l)?S:(0,I.$xh)(l)}async set(w,S,l=!1){if(this.c===y.Closed)return;if((0,R.$Nf)(S))return this.delete(w,l);const f=(0,R.$Gf)(S)||Array.isArray(S)?(0,I.$wh)(S):String(S);if(this.f.get(w)!==f)return this.f.set(w,f),this.j.set(w,f),this.h.delete(w),this.b.fire({key:w,external:l}),this.D()}async delete(w,S=!1){if(!(this.c===y.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(this.z)return this.D(w)}async D(w){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$cp=M;class C{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((S,l)=>this.a.set(l,S)),w.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$dp=C}),define(ke[189],Se([1,0,13,11,22]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=e.$Zs=e.$Ys=void 0;let I;function R(){return I||(I=new TextDecoder("UTF-16LE")),I}let p;function $(){return p||(p=new TextDecoder("UTF-16BE")),p}let y;function M(){return y||(y=T.$D()?R():$()),y}e.$Ys=M;function C(S,l,f){const s=new Uint16Array(S.buffer,l,f);return f>0&&(s[0]===65279||s[0]===65534)?m(S,l,f):R().decode(s)}e.$Zs=C;function m(S,l,f){const s=[];let i=0;for(let n=0;n<f;n++){const o=g.$ie(S,l);l+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class w{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return M().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const f=this.a-this.d;f<=1&&(f===0||D.$_e(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const f=l.length;if(this.d+f>=this.a){this.f(),this.c[this.c.length]=l;return}for(let s=0;s<f;s++)this.b[this.d++]=l.charCodeAt(s)}}e.$1s=w}),define(ke[190],Se([1,0,22,189]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=e.$2s=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,M,C,m){this.oldPosition=y,this.oldText=M,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,M,C){const m=M.length;D.$le(y,m,C),C+=4;for(let w=0;w<m;w++)D.$je(y,M.charCodeAt(w),C),C+=2;return C}static d(y,M){const C=D.$ke(y,M);return M+=4,(0,T.$Zs)(y,M,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,M){return D.$le(y,this.oldPosition,M),M+=4,D.$le(y,this.newPosition,M),M+=4,M=I.c(y,this.oldText,M),M=I.c(y,this.newText,M),M}static read(y,M,C){const m=D.$ke(y,M);M+=4;const w=D.$ke(y,M);M+=4;const S=I.d(y,M);M+=I.a(S);const l=I.d(y,M);return M+=I.a(l),C.push(new I(m,S,w,l)),M}}e.$2s=I;function R($,y){return $===null||$.length===0?y:new p($,y).compress()}e.$3s=R;class p{constructor(y,M){this.a=y,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,M=0,C=this.n(y),m=this.l(M);for(;y<this.f||M<this.h;){if(C===null){this.k(m),m=this.l(++M);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++M);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[s,i]=p.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=p.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let l,f;if(m.oldEnd===C.newEnd)l=C,f=m,C=this.n(++y),m=this.l(++M);else if(m.oldEnd<C.newEnd){const[s,i]=p.q(C,m.oldLength);l=s,f=m,C=i,m=this.l(++M)}else{const[s,i]=p.r(m,C.newLength);l=C,f=s,C=this.n(++y),m=i}this.d[this.e++]=new I(l.oldPosition,l.oldText,f.newPosition,f.newText),this.g+=l.newLength-l.oldLength,this.j+=f.newLength-f.oldLength}const w=p.s(this.d);return p.t(w)}k(y){this.d[this.e++]=p.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=p.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,M){return new I(M.oldPosition-y,M.oldText,M.newPosition,M.newText)}static p(y,M){return new I(M.oldPosition,M.oldText,M.newPosition+y,M.newText)}static q(y,M){const C=y.newText.substr(0,M),m=y.newText.substr(M);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+M,m)]}static r(y,M){const C=y.oldText.substr(0,M),m=y.oldText.substr(M);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+M,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const M=[];let C=0,m=y[0];for(let w=1;w<y.length;w++){const S=y[w];m.oldEnd===S.oldPosition?m=new I(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(M[C++]=m,m=S)}return M[C++]=m,M}static t(y){if(y.length===0)return y;const M=[];let C=0;for(let m=0;m<y.length;m++){const w=y[m];w.oldText!==w.newText&&(M[C++]=w)}return M}}}),define(ke[191],Se([1,0,34,16]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=void 0;function g(I,R,p,$,y,M){if(Array.isArray(I)){let C=0;for(const m of I){const w=g(m,R,p,$,y,M);if(w===10)return w;w>C&&(C=w)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===p?10:0:0;if(I){const{language:C,pattern:m,scheme:w,hasAccessToAllModels:S,notebookType:l}=I;if(!$&&!S)return 0;l&&y&&(R=y);let f=0;if(w)if(w===R.scheme)f=10;else if(w==="*")f=5;else return 0;if(C)if(C===p)f=10;else if(C==="*")f=Math.max(f,5);else return 0;if(l)if(l===M)f=10;else if(l==="*"&&M!==void 0)f=Math.max(f,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,T.$hc)(m.base)},s===R.fsPath||(0,D.$Hj)(s,R.fsPath))f=10;else return 0}return f}else return 0}}e.$nt=g}),define(ke[192],Se([1,0,4,13,29,79,127,167,190,3]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=void 0;class M extends y.$Sc{constructor(m,w,S,l,f,s,i){super(),this.m=this.B(new D.$Sd),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=l,this.h=f,this.c=new R.$UB(m,S,i)}equals(m){return!(m instanceof M)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,w){return this.c.getOffsetAt(m,w)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,w){const S=m+w,l=this.getPositionAt(m),f=this.getPositionAt(S);return new g.$Gs(l.lineNumber,l.column,f.lineNumber,f.column)}getValueInRange(m,w=0){if(m.isEmpty())return"";const S=this.n(w);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,w=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let f=0;const s=this.n(w),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=m.endLineNumber-m.startLineNumber;f=n*o}return l-S+f}getCharacterCountInRange(m,w=0){if(this.j){let S=0;const l=m.startLineNumber,f=m.endLineNumber;for(let s=l;s<=f;s++){const i=this.getLineContent(s),n=s===l?m.startColumn-1:0,o=s===f?m.endColumn-1:i.length;for(let a=n;a<o;a++)T.$_e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(w).length*(f-l),S}return this.getValueLengthInRange(m,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,w){return this.c.getLineCharCode(m,w)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const w=T.$We(this.getLineContent(m));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(m){const w=T.$Ye(this.getLineContent(m));return w===-1?0:w+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,w,S){let l=this.g,f=this.h,s=this.j,i=!0,n=[];for(let c=0;c<m.length;c++){const h=m[c];i&&h._isTracked&&(i=!1);const k=h.range;if(h.text){let A=!0;s||(A=!T.$kf(h.text),s=A),!l&&A&&(l=T.$jf(h.text)),!f&&A&&(f=T.$mf(h.text))}let L="",v=0,b=0,E=0;if(h.text){let A;[v,b,E,A]=(0,p.$gt)(h.text);const z=this.getEOL();A===0||A===(z===`\r
`?2:1)?L=h.text:L=h.text.replace(/\r\n|\r|\n/g,z)}n[c]={sortIndex:c,identifier:h.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:L,eolCount:v,firstLineLength:b,lastLineLength:E,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(M.u);let o=!1;for(let c=0,h=n.length-1;c<h;c++){const k=n[c].range.getEndPosition(),L=n[c+1].range.getStartPosition();if(L.isBeforeOrEqual(k)){if(L.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=S||w?M._getInverseEditRanges(n):[],t=[];if(w)for(let c=0;c<n.length;c++){const h=n[c],k=a[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let L=k.startLineNumber;L<=k.endLineNumber;L++){let v="";L===k.startLineNumber&&(v=this.getLineContent(h.range.startLineNumber),T.$We(v)!==-1)||t.push({lineNumber:L,oldContent:v})}}let r=null;if(S){let c=0;r=[];for(let h=0;h<n.length;h++){const k=n[h],L=a[h],v=this.getValueInRange(k.range),b=k.rangeOffset+c;c+=k.text.length-v.length,r[h]={sortIndex:k.sortIndex,identifier:k.identifier,range:L,text:v,textChange:new $.$2s(k.rangeOffset,v,b,k.text)}}o||r.sort((h,k)=>h.sortIndex-k.sortIndex)}this.g=l,this.h=f,this.j=s;const d=this.t(n);let u=null;if(w&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),u=[];for(let c=0,h=t.length;c<h;c++){const k=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===k)continue;const L=t[c].oldContent,v=this.getLineContent(k);v.length===0||v===L||T.$We(v)!==-1||u.push(k)}}return this.m.fire(),new I.$3u(r,d,u)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let w=!1;const S=m[0].range,l=m[m.length-1].range,f=new g.$Gs(S.startLineNumber,S.startColumn,l.endLineNumber,l.endColumn);let s=S.startLineNumber,i=S.startColumn;const n=[];for(let d=0,u=m.length;d<u;d++){const c=m[d],h=c.range;w=w||c.forceMoveMarkers,n.push(this.getValueInRange(new g.$Gs(s,i,h.startLineNumber,h.startColumn))),c.text.length>0&&n.push(c.text),s=h.endLineNumber,i=h.endColumn}const o=n.join(""),[a,t,r]=(0,p.$gt)(o);return{sortIndex:0,identifier:m[0].identifier,range:f,rangeOffset:this.getOffsetAt(f.startLineNumber,f.startColumn),rangeLength:this.getValueLengthInRange(f,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(m){m.sort(M.w);const w=[];for(let S=0;S<m.length;S++){const l=m[S],f=l.range.startLineNumber,s=l.range.startColumn,i=l.range.endLineNumber,n=l.range.endColumn;if(f===i&&s===n&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const o=new g.$Gs(f,s,i,n);w.push({range:o,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return w}findMatchesLineByLine(m,w,S,l){return this.c.findMatchesLineByLine(m,w,S,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,w){const S=m.startLineNumber,l=m.startColumn,[f,s,i]=(0,p.$gt)(w);let n;if(w.length>0){const o=f+1;o===1?n=new g.$Gs(S,l,S,l+s):n=new g.$Gs(S,l,S+o-1,i+1)}else n=new g.$Gs(S,l,S,l);return n}static _getInverseEditRanges(m){const w=[];let S=0,l=0,f=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let o,a;f?f.range.endLineNumber===n.range.startLineNumber?(o=S,a=l+(n.range.startColumn-f.range.endColumn)):(o=S+(n.range.startLineNumber-f.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new g.$Gs(o,a,o,a+n.firstLineLength):t=new g.$Gs(o,a,o+r-1,n.lastLineLength+1)}else t=new g.$Gs(o,a,o,a);S=t.endLineNumber,l=t.endColumn,w.push(t),f=n}return w}static u(m,w){const S=g.$Gs.compareRangesUsingEnds(m.range,w.range);return S===0?m.sortIndex-w.sortIndex:S}static w(m,w){const S=g.$Gs.compareRangesUsingEnds(m.range,w.range);return S===0?w.sortIndex-m.sortIndex:-S}}e.$VB=M}),define(ke[193],Se([1,0,13,127,192]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=void 0;class I{constructor($,y,M,C,m,w,S,l,f){this.a=$,this.b=y,this.c=M,this.d=C,this.e=m,this.f=w,this.g=S,this.h=l,this.j=f}k($){const y=this.c+this.d+this.e,M=this.c+this.e;return y===0?$===1?`
`:`\r
`:M>y/2?`\r
`:`
`}create($){const y=this.k($),M=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,w=M.length;m<w;m++){const S=M[m].buffer.replace(/\r\n|\r|\n/g,y),l=(0,T.$QB)(S);M[m]=new T.$TB(S,l)}const C=new g.$VB(M,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$sf($)&&(this.b=D.$rf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,T.$RB)(this.e,$);this.a.push(new T.$TB($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$jf($)),this.k||(this.k=D.$mf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,T.$QB)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$WB=R}),define(ke[131],Se([1,0,22,11]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$=e.$g$=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,w=C.length;m<w;m+=4){const S=C[m+0],l=C[m+1],f=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=f,C[m+2]=l,C[m+3]=S}}function R(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return T.$D()||I(m),D.$ge.wrap(m)}function p(C){const m=C.buffer;if(T.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const w=new Uint8Array(m.byteLength);return w.set(m),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function $(C){const m=new Uint32Array(y(C));let w=0;if(m[w++]=C.id,C.type==="full")m[w++]=1,m[w++]=C.data.length,m.set(C.data,w),w+=C.data.length;else{m[w++]=2,m[w++]=C.deltas.length;for(const S of C.deltas)m[w++]=S.start,m[w++]=S.deleteCount,S.data?(m[w++]=S.data.length,m.set(S.data,w),w+=S.data.length):m[w++]=0}return R(m)}e.$g$=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const w of C.deltas)w.data&&(m+=w.data.length)}return m}function M(C){const m=p(C);let w=0;const S=m[w++];if(m[w++]===1){const i=m[w++],n=m.subarray(w,w+i);return w+=i,{id:S,type:"full",data:n}}const f=m[w++],s=[];for(let i=0;i<f;i++){const n=m[w++],o=m[w++],a=m[w++];let t;a>0&&(t=m.subarray(w,w+a),w+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:S,type:"delta",deltas:s}}e.$h$=M}),define(ke[194],Se([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,11,170,126,194]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(le){this.c=le}hasChanged(le){return this.c[le]}}e.ConfigurationChangedEvent=y;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class C{constructor(le,Pe,He,Ze){this.id=le,this.name=Pe,this.defaultValue=He,this.schema=Ze}applyUpdate(le,Pe){return w(le,Pe)}compute(le,Pe,He){return He}}class m{constructor(le,Pe){this.newValue=le,this.didChange=Pe}}e.ApplyUpdateResult=m;function w(oe,le){if(typeof oe!="object"||typeof le!="object"||!oe||!le)return new m(le,oe!==le);if(Array.isArray(oe)||Array.isArray(le)){const He=Array.isArray(oe)&&Array.isArray(le)&&D.$ub(oe,le);return new m(le,!He)}let Pe=!1;for(const He in le)if(le.hasOwnProperty(He)){const Ze=w(oe[He],le[He]);Ze.didChange&&(oe[He]=Ze.newValue,Pe=!0)}return new m(oe,Pe)}class S{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,Pe){return w(le,Pe)}validate(le){return this.defaultValue}}class l{constructor(le,Pe,He,Ze){this.id=le,this.name=Pe,this.defaultValue=He,this.schema=Ze}applyUpdate(le,Pe){return w(le,Pe)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,Pe,He){return He}}function f(oe,le){return typeof oe>"u"?le:oe==="false"?!1:!!oe}e.boolean=f;class s extends l{constructor(le,Pe,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=He),super(le,Pe,He,Ze)}validate(le){return f(le,this.defaultValue)}}function i(oe,le,Pe,He){if(typeof oe>"u")return le;let Ze=parseInt(oe,10);return isNaN(Ze)?le:(Ze=Math.max(Pe,Ze),Ze=Math.min(He,Ze),Ze|0)}e.clampedInt=i;class n extends l{static clampedInt(le,Pe,He,Ze){return i(le,Pe,He,Ze)}constructor(le,Pe,He,Ze,it,st=void 0){typeof st<"u"&&(st.type="integer",st.default=He,st.minimum=Ze,st.maximum=it),super(le,Pe,He,st),this.minimum=Ze,this.maximum=it}validate(le){return n.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function o(oe,le,Pe,He){if(typeof oe>"u")return le;const Ze=a.float(oe,le);return a.clamp(Ze,Pe,He)}e.clampedFloat=o;class a extends l{static clamp(le,Pe,He){return le<Pe?Pe:le>He?He:le}static float(le,Pe){if(typeof le=="number")return le;if(typeof le>"u")return Pe;const He=parseFloat(le);return isNaN(He)?Pe:He}constructor(le,Pe,He,Ze,it){typeof it<"u"&&(it.type="number",it.default=He),super(le,Pe,He,it),this.validationFn=Ze}validate(le){return this.validationFn(a.float(le,this.defaultValue))}}class t extends l{static string(le,Pe){return typeof le!="string"?Pe:le}constructor(le,Pe,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=He),super(le,Pe,He,Ze)}validate(le){return t.string(le,this.defaultValue)}}function r(oe,le,Pe,He){return typeof oe!="string"?le:He&&oe in He?He[oe]:Pe.indexOf(oe)===-1?le:oe}e.stringSet=r;class d extends l{constructor(le,Pe,He,Ze,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ze,it.default=He),super(le,Pe,He,it),this.c=Ze}validate(le){return r(le,this.defaultValue,this.c)}}class u extends C{constructor(le,Pe,He,Ze,it,st,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Ze),super(le,Pe,He,Oe),this.c=it,this.d=st}validate(le){return typeof le!="string"?this.defaultValue:this.c.indexOf(le)===-1?this.defaultValue:this.d(le)}}function c(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,Pe,He){return He===0?le.accessibilitySupport:He}}class k extends C{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:p.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{insertSpace:f(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:f(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function v(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function E(oe){switch(oe){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function A(oe){switch(oe){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class z extends S{constructor(){super(140)}compute(le,Pe,He){const Ze=["monaco-editor"];return Pe.get(39)&&Ze.push(Pe.get(39)),le.extraEditorClassName&&Ze.push(le.extraEditorClassName),Pe.get(73)==="default"?Ze.push("mouse-default"):Pe.get(73)==="copy"&&Ze.push("mouse-copy"),Pe.get(110)&&Ze.push("showUnused"),Pe.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class O extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(le,Pe,He){return He&&le.emptySelectionClipboard}}class P extends C{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:p.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:p.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{cursorMoveOnType:f(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":r(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":r(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:f(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:f(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:f(Pe.loop,this.defaultValue.loop)}}}class j extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?j.OFF:le==="true"?j.ON:le:le?j.ON:j.OFF}}e.EditorFontLigatures=j;class N extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?N.OFF:le==="true"?N.TRANSLATE:le:le?N.TRANSLATE:N.OFF}compute(le,Pe,He){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class F extends S{constructor(){super(50)}compute(le,Pe,He){return le.fontInfo}}class W extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(le){const Pe=a.float(le,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Pe,6,100)}compute(le,Pe,He){return le.fontInfo.fontSize}}class x extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.d,maximum:x.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(n.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,x.d,x.e))}}class ce extends C{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{multiple:r(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??r(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??r(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??r(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??r(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??r(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends C{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:p.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:f(Pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:f(Pe.above,this.defaultValue.above)}}}var Y;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(Y||(e.RenderMinimap=Y={}));class X extends S{constructor(){super(143)}compute(le,Pe,He){return X.computeLayout(Pe,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const Pe=le.height/le.lineHeight,He=Math.floor(le.paddingTop/le.lineHeight);let Ze=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(Ze=Math.max(Ze,Pe-1));const it=(He+le.viewLineCount+Ze)/(le.pixelRatio*le.height),st=Math.floor(le.viewLineCount/it);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:Ze,desiredRatio:it,minimapLineCount:st}}static c(le,Pe){const He=le.outerWidth,Ze=le.outerHeight,it=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const st=Pe.stableMinimapLayoutInput,Oe=st&&le.outerHeight===st.outerHeight&&le.lineHeight===st.lineHeight&&le.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&le.pixelRatio===st.pixelRatio&&le.scrollBeyondLastLine===st.scrollBeyondLastLine&&le.paddingTop===st.paddingTop&&le.paddingBottom===st.paddingBottom&&le.minimap.enabled===st.minimap.enabled&&le.minimap.side===st.minimap.side&&le.minimap.size===st.minimap.size&&le.minimap.showSlider===st.minimap.showSlider&&le.minimap.renderCharacters===st.minimap.renderCharacters&&le.minimap.maxColumn===st.minimap.maxColumn&&le.minimap.scale===st.minimap.scale&&le.verticalScrollbarWidth===st.verticalScrollbarWidth&&le.isViewportWrapping===st.isViewportWrapping,wt=le.lineHeight,Dt=le.typicalHalfwidthCharacterWidth,Ht=le.scrollBeyondLastLine,Ut=le.minimap.renderCharacters;let yt=it>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const Vt=le.minimap.maxColumn,Ft=le.minimap.size,Qt=le.minimap.side,Ot=le.verticalScrollbarWidth,Pt=le.viewLineCount,tt=le.remainingWidth,Kt=le.isViewportWrapping,Gt=Ut?2:3;let ut=Math.floor(it*Ze);const $t=ut/it;let jt=!1,Bt=!1,kt=Gt*yt,dt=yt/it,At=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Mt,extraLinesBeyondLastLine:Me,desiredRatio:Te,minimapLineCount:Ce}=X.computeContainedMinimapLineCount({viewLineCount:Pt,scrollBeyondLastLine:Ht,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:Ze,lineHeight:wt,pixelRatio:it});if(Pt/Ce>1)jt=!0,Bt=!0,yt=1,kt=1,dt=yt/it;else{let Ne=!1,Ve=yt+1;if(Ft==="fit"){const xe=Math.ceil((Mt+Pt+Me)*kt);Kt&&Oe&&tt<=Pe.stableFitRemainingWidth?(Ne=!0,Ve=Pe.stableFitMaxMinimapScale):Ne=xe>ut}if(Ft==="fill"||Ne){jt=!0;const xe=yt;kt=Math.min(wt*it,Math.max(1,Math.floor(1/Te))),Kt&&Oe&&tt<=Pe.stableFitRemainingWidth&&(Ve=Pe.stableFitMaxMinimapScale),yt=Math.min(Ve,Math.max(1,Math.floor(kt/Gt))),yt>xe&&(At=Math.min(2,yt/xe)),dt=yt/it/At,ut=Math.ceil(Math.max(gt,Mt+Pt+Me)*kt),Kt?(Pe.stableMinimapLayoutInput=le,Pe.stableFitRemainingWidth=tt,Pe.stableFitMaxMinimapScale=yt):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Xt=Math.floor(Vt*dt),St=Math.min(Xt,Math.max(0,Math.floor((tt-Ot-2)*dt/(Dt+dt)))+e.MINIMAP_GUTTER_WIDTH);let Ye=Math.floor(it*St);const Rt=Ye/it;Ye=Math.floor(Ye*At);const Wt=Ut?1:2,Jt=Qt==="left"?0:He-St-Ot;return{renderMinimap:Wt,minimapLeft:Jt,minimapWidth:St,minimapHeightIsEditorHeight:jt,minimapIsSampling:Bt,minimapScale:yt,minimapLineHeight:kt,minimapCanvasInnerWidth:Ye,minimapCanvasInnerHeight:ut,minimapCanvasOuterWidth:Rt,minimapCanvasOuterHeight:$t}}static computeLayout(le,Pe){const He=Pe.outerWidth|0,Ze=Pe.outerHeight|0,it=Pe.lineHeight|0,st=Pe.lineNumbersDigitCount|0,Oe=Pe.typicalHalfwidthCharacterWidth,wt=Pe.maxDigitWidth,Dt=Pe.pixelRatio,Ht=Pe.viewLineCount,Ut=le.get(135),yt=Ut==="inherit"?le.get(134):Ut,Vt=yt==="inherit"?le.get(130):yt,Ft=le.get(133),Qt=Pe.isDominatedByLongLines,Ot=le.get(57),Pt=le.get(67).renderType!==0,tt=le.get(68),Kt=le.get(104),Gt=le.get(83),ut=le.get(72),$t=le.get(102),jt=$t.verticalScrollbarSize,Bt=$t.verticalHasArrows,kt=$t.arrowSize,dt=$t.horizontalScrollbarSize,At=le.get(43),Xt=le.get(109)!=="never";let St=le.get(65);At&&Xt&&(St+=16);let Ye=0;if(Pt){const rt=Math.max(st,tt);Ye=Math.round(rt*wt)}let Rt=0;Ot&&(Rt=it*Pe.glyphMarginDecorationLaneCount);let Wt=0,Jt=Wt+Rt,gt=Jt+Ye,Mt=gt+St;const Me=He-Rt-Ye-St;let Te=!1,Ce=!1,re=-1;yt==="inherit"&&Qt?(Te=!0,Ce=!0):Vt==="on"||Vt==="bounded"?Ce=!0:Vt==="wordWrapColumn"&&(re=Ft);const Ne=X.c({outerWidth:He,outerHeight:Ze,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Dt,scrollBeyondLastLine:Kt,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:ut,verticalScrollbarWidth:jt,viewLineCount:Ht,remainingWidth:Me,isViewportWrapping:Ce},Pe.memory||new M);Ne.renderMinimap!==0&&Ne.minimapLeft===0&&(Wt+=Ne.minimapWidth,Jt+=Ne.minimapWidth,gt+=Ne.minimapWidth,Mt+=Ne.minimapWidth);const Ve=Me-Ne.minimapWidth,xe=Math.max(1,Math.floor((Ve-jt-2)/Oe)),Ge=Bt?kt:0;return Ce&&(re=Math.max(1,xe),Vt==="bounded"&&(re=Math.min(re,Ft))),{width:He,height:Ze,glyphMarginLeft:Wt,glyphMarginWidth:Rt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Jt,lineNumbersWidth:Ye,decorationsLeft:gt,decorationsWidth:St,contentLeft:Mt,contentWidth:Ve,minimap:Ne,viewportColumn:xe,isWordWrapMinified:Te,isViewportWrapping:Ce,wrappingColumn:re,verticalScrollbarWidth:jt,horizontalScrollbarHeight:dt,overviewRuler:{top:Ge,width:jt,height:Ze-2*Ge,right:0}}}}e.EditorLayoutInfoComputer=X;class se extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(le){return r(le,"simple",["simple","advanced"])}compute(le,Pe,He){return Pe.get(2)===2?"advanced":He}}var Z;(function(oe){oe.Off="off",oe.OnCode="onCode",oe.On="on"})(Z||(e.ShowAiIconMode=Z={}));class we extends C{constructor(){const le={enabled:!0,experimental:{showAiIcon:Z.Off}};super(64,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:p.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[Z.Off,Z.OnCode,Z.On],default:le.experimental.showAiIcon,enumDescriptions:[p.localize(51,null),p.localize(52,null),p.localize(53,null)],description:p.localize(54,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),experimental:{showAiIcon:r(Pe.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[Z.Off,Z.OnCode,Z.On])}}}}class de extends C{constructor(){const le={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:p.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:10,description:p.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:p.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:p.localize(58,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:f(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:p.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(60,null),p.localize(61,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:p.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:p.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:p.localize(66,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:r(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:f(Pe.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):n.clampedInt(le,this.defaultValue,0,1e3)}compute(le,Pe,He){return He<0?n.clampedInt(-He*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class ne extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>a.clamp(le,0,150),{markdownDescription:p.localize(67,null)})}compute(le,Pe,He){return le.fontInfo.lineHeight}}class ye extends C{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:p.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:p.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(70,null),p.localize(71,null),p.localize(72,null)],default:le.size,description:p.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:p.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:p.localize(75,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:p.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:p.localize(78,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),autohide:f(Pe.autohide,this.defaultValue.autohide),size:r(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Pe.side,this.defaultValue.side,["right","left"]),showSlider:r(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:f(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Pe.scale,1,1,3),maxColumn:n.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function he(oe){return oe==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class ge extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(80,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{top:n.clampedInt(Pe.top,0,0,1e3),bottom:n.clampedInt(Pe.bottom,0,0,1e3)}}}class _ extends C{constructor(){const le={enabled:!0,cycle:!0};super(85,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:p.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:p.localize(82,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),cycle:f(Pe.cycle,this.defaultValue.cycle)}}}class ie extends S{constructor(){super(141)}compute(le,Pe,He){return le.pixelRatio}}class G extends C{constructor(){const le={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(83,null),p.localize(84,null),p.localize(85,null)]}];super(88,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:le.strings,description:p.localize(86,null)},comments:{anyOf:Pe,default:le.comments,description:p.localize(87,null)},other:{anyOf:Pe,default:le.other,description:p.localize(88,null)}},default:le,markdownDescription:p.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const Dt=le?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!le||typeof le!="object")return this.defaultValue;const{other:Pe,comments:He,strings:Ze}=le,it=["on","inline","off"];let st,Oe,wt;return typeof Pe=="boolean"?st=Pe?"on":"off":st=r(Pe,this.defaultValue.other,it),typeof He=="boolean"?Oe=He?"on":"off":Oe=r(He,this.defaultValue.comments,it),typeof Ze=="boolean"?wt=Ze?"on":"off":wt=r(Ze,this.defaultValue.strings,it),{other:st,comments:Oe,strings:wt}}}var te;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class fe extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(90,null),p.localize(91,null),p.localize(92,null),p.localize(93,null)],default:"on",description:p.localize(94,null)})}validate(le){let Pe=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(Pe=4,He=le):le==="interval"?Pe=3:le==="relative"?Pe=2:le==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:He}}}function ve(oe){const le=oe.get(97);return le==="editable"?oe.get(90):le!=="on"}e.filterValidationDecorations=ve;class Ae extends C{constructor(){const le=[],Pe={type:"number",description:p.localize(95,null)};super(101,"rulers",le,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:p.localize(96,null),format:"color-hex"}}}]},default:le,description:p.localize(97,null)})}validate(le){if(Array.isArray(le)){const Pe=[];for(const He of le)if(typeof He=="number")Pe.push({column:n.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const Ze=He;Pe.push({column:n.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Pe.sort((He,Ze)=>He.column-Ze.column),Pe}return this.defaultValue}}class pe extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function De(oe,le){if(typeof oe!="string")return le;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends C{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(98,null),p.localize(99,null),p.localize(100,null)],default:"auto",description:p.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(102,null),p.localize(103,null),p.localize(104,null)],default:"auto",description:p.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:p.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:p.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:p.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:le.ignoreHorizontalScrollbarInContentHeight,description:p.localize(109,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le,He=n.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=n.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:De(Pe.vertical,this.defaultValue.vertical),horizontal:De(Pe.horizontal,this.defaultValue.horizontal),useShadows:f(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:f(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:f(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:f(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:f(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:n.clampedInt(Pe.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:n.clampedInt(Pe.verticalSliderSize,Ze,0,1e3),scrollByPage:f(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:f(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends C{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:p.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:p.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:p.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:p.localize(116,null)}})}applyUpdate(le,Pe){let He=!1;Pe.allowedCharacters&&le&&(T.$ln(le.allowedCharacters,Pe.allowedCharacters)||(le={...le,allowedCharacters:Pe.allowedCharacters},He=!0)),Pe.allowedLocales&&le&&(T.$ln(le.allowedLocales,Pe.allowedLocales)||(le={...le,allowedLocales:Pe.allowedLocales},He=!0));const Ze=super.applyUpdate(le,Pe);return He?new m(Ze.newValue,!0):Ze}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{nonBasicASCII:ue(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:f(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:f(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ue(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ue(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(le.allowedLocales,this.defaultValue.allowedLocales)}}c(le,Pe){if(typeof le!="object"||!le)return Pe;const He={};for(const[Ze,it]of Object.entries(le))it===!0&&(He[Ze]=!0);return He}}class ee extends C{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:p.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(118,null),p.localize(119,null),p.localize(120,null)],description:p.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:p.localize(122,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),mode:r(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:f(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:f(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class V extends C{constructor(){const le={enabled:I.$ds.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$ds.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:p.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:p.localize(124,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:f(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends C{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(125,null),p.localize(126,null),p.localize(127,null)],default:le.bracketPairs,description:p.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(129,null),p.localize(130,null),p.localize(131,null)],default:le.bracketPairsHorizontal,description:p.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:p.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:p.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:le.highlightActiveIndentation,description:p.localize(138,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{bracketPairs:ue(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ue(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:f(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:f(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ue(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ue(oe,le,Pe){const He=Pe.indexOf(oe);return He===-1?le:Pe[He]}class Le extends C{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(139,null),p.localize(140,null)],default:le.insertMode,description:p.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:p.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:p.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:p.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null),p.localize(148,null)],default:le.selectionMode,markdownDescription:p.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:p.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:p.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:p.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:p.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:p.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{insertMode:r(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:f(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:f(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:f(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:f(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:f(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:f(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:f(Pe.preview,this.defaultValue.preview),previewMode:r(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:f(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:f(Pe.showMethods,this.defaultValue.showMethods),showFunctions:f(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:f(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:f(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:f(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:f(Pe.showFields,this.defaultValue.showFields),showVariables:f(Pe.showVariables,this.defaultValue.showVariables),showClasses:f(Pe.showClasses,this.defaultValue.showClasses),showStructs:f(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:f(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:f(Pe.showModules,this.defaultValue.showModules),showProperties:f(Pe.showProperties,this.defaultValue.showProperties),showEvents:f(Pe.showEvents,this.defaultValue.showEvents),showOperators:f(Pe.showOperators,this.defaultValue.showOperators),showUnits:f(Pe.showUnits,this.defaultValue.showUnits),showValues:f(Pe.showValues,this.defaultValue.showValues),showConstants:f(Pe.showConstants,this.defaultValue.showConstants),showEnums:f(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:f(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:f(Pe.showKeywords,this.defaultValue.showKeywords),showWords:f(Pe.showWords,this.defaultValue.showWords),showColors:f(Pe.showColors,this.defaultValue.showColors),showFiles:f(Pe.showFiles,this.defaultValue.showFiles),showReferences:f(Pe.showReferences,this.defaultValue.showReferences),showFolders:f(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:f(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:f(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:f(Pe.showUsers,this.defaultValue.showUsers),showIssues:f(Pe.showIssues,this.defaultValue.showIssues)}}}class je extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(188,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:f(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:f(le.selectSubwords,this.defaultValue.selectSubwords)}}}var Ke;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(Ke||(e.WrappingIndent=Ke={}));class Qe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(189,null),p.localize(190,null),p.localize(191,null),p.localize(192,null)],description:p.localize(193,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,Pe,He){return Pe.get(2)===2?0:He}}class _e extends S{constructor(){super(144)}compute(le,Pe,He){const Ze=Pe.get(143);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class at extends C{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:p.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(196,null),p.localize(197,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showDropSelector:r(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends C{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:p.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(200,null),p.localize(201,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Pe=le;return{enabled:f(Pe.enabled,this.defaultValue.enabled),showPasteSelector:r(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ie="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?ze:g.$k?qe:Ie,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var et;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.ariaRequired=5]="ariaRequired",oe[oe.autoClosingBrackets=6]="autoClosingBrackets",oe[oe.autoClosingComments=7]="autoClosingComments",oe[oe.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",oe[oe.autoClosingDelete=9]="autoClosingDelete",oe[oe.autoClosingOvertype=10]="autoClosingOvertype",oe[oe.autoClosingQuotes=11]="autoClosingQuotes",oe[oe.autoIndent=12]="autoIndent",oe[oe.automaticLayout=13]="automaticLayout",oe[oe.autoSurround=14]="autoSurround",oe[oe.bracketPairColorization=15]="bracketPairColorization",oe[oe.guides=16]="guides",oe[oe.codeLens=17]="codeLens",oe[oe.codeLensFontFamily=18]="codeLensFontFamily",oe[oe.codeLensFontSize=19]="codeLensFontSize",oe[oe.colorDecorators=20]="colorDecorators",oe[oe.colorDecoratorsLimit=21]="colorDecoratorsLimit",oe[oe.columnSelection=22]="columnSelection",oe[oe.comments=23]="comments",oe[oe.contextmenu=24]="contextmenu",oe[oe.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=26]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=28]="cursorStyle",oe[oe.cursorSurroundingLines=29]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=31]="cursorWidth",oe[oe.disableLayerHinting=32]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",oe[oe.domReadOnly=34]="domReadOnly",oe[oe.dragAndDrop=35]="dragAndDrop",oe[oe.dropIntoEditor=36]="dropIntoEditor",oe[oe.emptySelectionClipboard=37]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=39]="extraEditorClassName",oe[oe.fastScrollSensitivity=40]="fastScrollSensitivity",oe[oe.find=41]="find",oe[oe.fixedOverflowWidgets=42]="fixedOverflowWidgets",oe[oe.folding=43]="folding",oe[oe.foldingStrategy=44]="foldingStrategy",oe[oe.foldingHighlight=45]="foldingHighlight",oe[oe.foldingImportsByDefault=46]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=47]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=49]="fontFamily",oe[oe.fontInfo=50]="fontInfo",oe[oe.fontLigatures=51]="fontLigatures",oe[oe.fontSize=52]="fontSize",oe[oe.fontWeight=53]="fontWeight",oe[oe.fontVariations=54]="fontVariations",oe[oe.formatOnPaste=55]="formatOnPaste",oe[oe.formatOnType=56]="formatOnType",oe[oe.glyphMargin=57]="glyphMargin",oe[oe.gotoLocation=58]="gotoLocation",oe[oe.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",oe[oe.hover=60]="hover",oe[oe.inDiffEditor=61]="inDiffEditor",oe[oe.inlineSuggest=62]="inlineSuggest",oe[oe.letterSpacing=63]="letterSpacing",oe[oe.lightbulb=64]="lightbulb",oe[oe.lineDecorationsWidth=65]="lineDecorationsWidth",oe[oe.lineHeight=66]="lineHeight",oe[oe.lineNumbers=67]="lineNumbers",oe[oe.lineNumbersMinChars=68]="lineNumbersMinChars",oe[oe.linkedEditing=69]="linkedEditing",oe[oe.links=70]="links",oe[oe.matchBrackets=71]="matchBrackets",oe[oe.minimap=72]="minimap",oe[oe.mouseStyle=73]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=75]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=77]="multiCursorModifier",oe[oe.multiCursorPaste=78]="multiCursorPaste",oe[oe.multiCursorLimit=79]="multiCursorLimit",oe[oe.occurrencesHighlight=80]="occurrencesHighlight",oe[oe.overviewRulerBorder=81]="overviewRulerBorder",oe[oe.overviewRulerLanes=82]="overviewRulerLanes",oe[oe.padding=83]="padding",oe[oe.pasteAs=84]="pasteAs",oe[oe.parameterHints=85]="parameterHints",oe[oe.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=88]="quickSuggestions",oe[oe.quickSuggestionsDelay=89]="quickSuggestionsDelay",oe[oe.readOnly=90]="readOnly",oe[oe.readOnlyMessage=91]="readOnlyMessage",oe[oe.renameOnType=92]="renameOnType",oe[oe.renderControlCharacters=93]="renderControlCharacters",oe[oe.renderFinalNewline=94]="renderFinalNewline",oe[oe.renderLineHighlight=95]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=97]="renderValidationDecorations",oe[oe.renderWhitespace=98]="renderWhitespace",oe[oe.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",oe[oe.roundedSelection=100]="roundedSelection",oe[oe.rulers=101]="rulers",oe[oe.scrollbar=102]="scrollbar",oe[oe.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=104]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=105]="scrollPredominantAxis",oe[oe.selectionClipboard=106]="selectionClipboard",oe[oe.selectionHighlight=107]="selectionHighlight",oe[oe.selectOnLineNumbers=108]="selectOnLineNumbers",oe[oe.showFoldingControls=109]="showFoldingControls",oe[oe.showUnused=110]="showUnused",oe[oe.snippetSuggestions=111]="snippetSuggestions",oe[oe.smartSelect=112]="smartSelect",oe[oe.smoothScrolling=113]="smoothScrolling",oe[oe.stickyScroll=114]="stickyScroll",oe[oe.stickyTabStops=115]="stickyTabStops",oe[oe.stopRenderingLineAfter=116]="stopRenderingLineAfter",oe[oe.suggest=117]="suggest",oe[oe.suggestFontSize=118]="suggestFontSize",oe[oe.suggestLineHeight=119]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",oe[oe.suggestSelection=121]="suggestSelection",oe[oe.tabCompletion=122]="tabCompletion",oe[oe.tabIndex=123]="tabIndex",oe[oe.unicodeHighlighting=124]="unicodeHighlighting",oe[oe.unusualLineTerminators=125]="unusualLineTerminators",oe[oe.useShadowDOM=126]="useShadowDOM",oe[oe.useTabStops=127]="useTabStops",oe[oe.wordBreak=128]="wordBreak",oe[oe.wordSeparators=129]="wordSeparators",oe[oe.wordWrap=130]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=133]="wordWrapColumn",oe[oe.wordWrapOverride1=134]="wordWrapOverride1",oe[oe.wordWrapOverride2=135]="wordWrapOverride2",oe[oe.wrappingIndent=136]="wrappingIndent",oe[oe.wrappingStrategy=137]="wrappingStrategy",oe[oe.showDeprecated=138]="showDeprecated",oe[oe.inlayHints=139]="inlayHints",oe[oe.editorClassName=140]="editorClassName",oe[oe.pixelRatio=141]="pixelRatio",oe[oe.tabFocusMode=142]="tabFocusMode",oe[oe.layoutInfo=143]="layoutInfo",oe[oe.wrappingInfo=144]="wrappingInfo",oe[oe.defaultColorDecorators=145]="defaultColorDecorators",oe[oe.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",oe[oe.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(202,null)})),acceptSuggestionOnEnter:Re(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(203,null),""],markdownDescription:p.localize(204,null)})),accessibilitySupport:Re(new h),accessibilityPageSize:Re(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(205,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",p.localize(206,null))),ariaRequired:Re(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Re(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(208,null),p.localize(209,null),""],description:p.localize(210,null)})),autoClosingComments:Re(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(211,null),p.localize(212,null),""],description:p.localize(213,null)})),autoClosingDelete:Re(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(214,null),""],description:p.localize(215,null)})),autoClosingOvertype:Re(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(216,null),""],description:p.localize(217,null)})),autoClosingQuotes:Re(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(218,null),p.localize(219,null),""],description:p.localize(220,null)})),autoIndent:Re(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[p.localize(221,null),p.localize(222,null),p.localize(223,null),p.localize(224,null),p.localize(225,null)],description:p.localize(226,null)})),automaticLayout:Re(new s(13,"automaticLayout",!1)),autoSurround:Re(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(227,null),p.localize(228,null),p.localize(229,null),""],description:p.localize(230,null)})),bracketPairColorization:Re(new V),bracketPairGuides:Re(new ae),stickyTabStops:Re(new s(115,"stickyTabStops",!1,{description:p.localize(231,null)})),codeLens:Re(new s(17,"codeLens",!0,{description:p.localize(232,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:p.localize(233,null)})),codeLensFontSize:Re(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(234,null)})),colorDecorators:Re(new s(20,"colorDecorators",!0,{description:p.localize(235,null)})),colorDecoratorActivatedOn:Re(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(236,null),p.localize(237,null),p.localize(238,null)],description:p.localize(239,null)})),colorDecoratorsLimit:Re(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(240,null)})),columnSelection:Re(new s(22,"columnSelection",!1,{description:p.localize(241,null)})),comments:Re(new k),contextmenu:Re(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new s(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(242,null)})),cursorBlinking:Re(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:p.localize(243,null)})),cursorSmoothCaretAnimation:Re(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(244,null),p.localize(245,null),p.localize(246,null)],description:p.localize(247,null)})),cursorStyle:Re(new u(28,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:p.localize(248,null)})),cursorSurroundingLines:Re(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(249,null)})),cursorSurroundingLinesStyle:Re(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(250,null),p.localize(251,null)],markdownDescription:p.localize(252,null)})),cursorWidth:Re(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(253,null)})),disableLayerHinting:Re(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new s(34,"domReadOnly",!1)),dragAndDrop:Re(new s(35,"dragAndDrop",!0,{description:p.localize(254,null)})),emptySelectionClipboard:Re(new O),dropIntoEditor:Re(new at),stickyScroll:Re(new de),experimentalWhitespaceRendering:Re(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(255,null),p.localize(256,null),p.localize(257,null)],description:p.localize(258,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:p.localize(259,null)})),find:Re(new P),fixedOverflowWidgets:Re(new s(42,"fixedOverflowWidgets",!1)),folding:Re(new s(43,"folding",!0,{description:p.localize(260,null)})),foldingStrategy:Re(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(261,null),p.localize(262,null)],description:p.localize(263,null)})),foldingHighlight:Re(new s(45,"foldingHighlight",!0,{description:p.localize(264,null)})),foldingImportsByDefault:Re(new s(46,"foldingImportsByDefault",!1,{description:p.localize(265,null)})),foldingMaximumRegions:Re(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(266,null)})),unfoldOnClickAfterEndOfLine:Re(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(267,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(268,null)})),fontInfo:Re(new F),fontLigatures2:Re(new j),fontSize:Re(new W),fontWeight:Re(new x),fontVariations:Re(new N),formatOnPaste:Re(new s(55,"formatOnPaste",!1,{description:p.localize(269,null)})),formatOnType:Re(new s(56,"formatOnType",!1,{description:p.localize(270,null)})),glyphMargin:Re(new s(57,"glyphMargin",!0,{description:p.localize(271,null)})),gotoLocation:Re(new ce),hideCursorInOverviewRuler:Re(new s(59,"hideCursorInOverviewRuler",!1,{description:p.localize(272,null)})),hover:Re(new J),inDiffEditor:Re(new s(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>a.clamp(oe,-5,20),{description:p.localize(273,null)})),lightbulb:Re(new we),lineDecorationsWidth:Re(new B),lineHeight:Re(new ne),lineNumbers:Re(new fe),lineNumbersMinChars:Re(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new s(69,"linkedEditing",!1,{description:p.localize(274,null)})),links:Re(new s(70,"links",!0,{description:p.localize(275,null)})),matchBrackets:Re(new d(71,"matchBrackets","always",["always","near","never"],{description:p.localize(276,null)})),minimap:Re(new ye),mouseStyle:Re(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:p.localize(277,null)})),mouseWheelZoom:Re(new s(75,"mouseWheelZoom",!1,{markdownDescription:p.localize(278,null)})),multiCursorMergeOverlapping:Re(new s(76,"multiCursorMergeOverlapping",!0,{description:p.localize(279,null)})),multiCursorModifier:Re(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[p.localize(280,null),p.localize(281,null)],markdownDescription:p.localize(282,null)})),multiCursorPaste:Re(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(283,null),p.localize(284,null)],markdownDescription:p.localize(285,null)})),multiCursorLimit:Re(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(286,null)})),occurrencesHighlight:Re(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(287,null),p.localize(288,null),p.localize(289,null)],markdownDescription:p.localize(290,null)})),overviewRulerBorder:Re(new s(81,"overviewRulerBorder",!0,{description:p.localize(291,null)})),overviewRulerLanes:Re(new n(82,"overviewRulerLanes",3,0,3)),padding:Re(new ge),pasteAs:Re(new ot),parameterHints:Re(new _),peekWidgetDefaultFocus:Re(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(292,null),p.localize(293,null)],description:p.localize(294,null)})),definitionLinkOpensInPeek:Re(new s(87,"definitionLinkOpensInPeek",!1,{description:p.localize(295,null)})),quickSuggestions:Re(new G),quickSuggestionsDelay:Re(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(296,null)})),readOnly:Re(new s(90,"readOnly",!1)),readOnlyMessage:Re(new pe),renameOnType:Re(new s(92,"renameOnType",!1,{description:p.localize(297,null),markdownDeprecationMessage:p.localize(298,null)})),renderControlCharacters:Re(new s(93,"renderControlCharacters",!0,{description:p.localize(299,null),restricted:!0})),renderFinalNewline:Re(new d(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(300,null)})),renderLineHighlight:Re(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(301,null)],description:p.localize(302,null)})),renderLineHighlightOnlyWhenFocus:Re(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(303,null)})),renderValidationDecorations:Re(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(304,null),p.localize(305,null),p.localize(306,null),""],description:p.localize(307,null)})),revealHorizontalRightPadding:Re(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new s(100,"roundedSelection",!0,{description:p.localize(308,null)})),rulers:Re(new Ae),scrollbar:Re(new U),scrollBeyondLastColumn:Re(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(309,null)})),scrollBeyondLastLine:Re(new s(104,"scrollBeyondLastLine",!0,{description:p.localize(310,null)})),scrollPredominantAxis:Re(new s(105,"scrollPredominantAxis",!0,{description:p.localize(311,null)})),selectionClipboard:Re(new s(106,"selectionClipboard",!0,{description:p.localize(312,null),included:g.$k})),selectionHighlight:Re(new s(107,"selectionHighlight",!0,{description:p.localize(313,null)})),selectOnLineNumbers:Re(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Re(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(314,null),p.localize(315,null),p.localize(316,null)],description:p.localize(317,null)})),showUnused:Re(new s(110,"showUnused",!0,{description:p.localize(318,null)})),showDeprecated:Re(new s(138,"showDeprecated",!0,{description:p.localize(319,null)})),inlayHints:Re(new K),snippetSuggestions:Re(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(320,null),p.localize(321,null),p.localize(322,null),p.localize(323,null)],description:p.localize(324,null)})),smartSelect:Re(new je),smoothScrolling:Re(new s(113,"smoothScrolling",!1,{description:p.localize(325,null)})),stopRenderingLineAfter:Re(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new Le),inlineSuggest:Re(new ee),inlineCompletionsAccessibilityVerbose:Re(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(326,null)})),suggestFontSize:Re(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new s(120,"suggestOnTriggerCharacters",!0,{description:p.localize(329,null)})),suggestSelection:Re(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(330,null),p.localize(331,null),p.localize(332,null)],description:p.localize(333,null)})),tabCompletion:Re(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),tabIndex:Re(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new Q),unusualLineTerminators:Re(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(338,null),p.localize(339,null),p.localize(340,null)],description:p.localize(341,null)})),useShadowDOM:Re(new s(126,"useShadowDOM",!0)),useTabStops:Re(new s(127,"useTabStops",!0,{description:p.localize(342,null)})),wordBreak:Re(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null)],description:p.localize(345,null)})),wordSeparators:Re(new t(129,"wordSeparators",R.$es,{description:p.localize(346,null)})),wordWrap:Re(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null),p.localize(350,null)],description:p.localize(351,null)})),wordWrapBreakAfterCharacters:Re(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(352,null)})),wordWrapOverride1:Re(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new z),defaultColorDecorators:Re(new s(145,"defaultColorDecorators",!1,{markdownDescription:p.localize(353,null)})),pixelRatio:Re(new ie),tabFocusMode:Re(new s(142,"tabFocusMode",!1,{markdownDescription:p.localize(354,null)})),layoutInfo:Re(new X),wrappingInfo:Re(new _e),wrappingIndent:Re(new Qe),wrappingStrategy:Re(new se)}}),define(ke[195],Se([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$yt=e.$xt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$wt=e.$vt=e.SymbolKinds=e.SymbolTag=e.$ut=e.$tt=e.SymbolKind=e.$st=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$rt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$qt=e.$pt=e.$ot=void 0;class ${constructor(j,N,F){this.offset=j,this.type=N,this.language=F,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ot=$;class y{constructor(j,N){this.tokens=j,this.endState=N,this._tokenizationResultBrand=void 0}}e.$pt=y;class M{constructor(j,N){this.tokens=j,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$qt=M;var C;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(P){const j=new Map;j.set(0,D.$8j.symbolMethod),j.set(1,D.$8j.symbolFunction),j.set(2,D.$8j.symbolConstructor),j.set(3,D.$8j.symbolField),j.set(4,D.$8j.symbolVariable),j.set(5,D.$8j.symbolClass),j.set(6,D.$8j.symbolStruct),j.set(7,D.$8j.symbolInterface),j.set(8,D.$8j.symbolModule),j.set(9,D.$8j.symbolProperty),j.set(10,D.$8j.symbolEvent),j.set(11,D.$8j.symbolOperator),j.set(12,D.$8j.symbolUnit),j.set(13,D.$8j.symbolValue),j.set(15,D.$8j.symbolEnum),j.set(14,D.$8j.symbolConstant),j.set(15,D.$8j.symbolEnum),j.set(16,D.$8j.symbolEnumMember),j.set(17,D.$8j.symbolKeyword),j.set(27,D.$8j.symbolSnippet),j.set(18,D.$8j.symbolText),j.set(19,D.$8j.symbolColor),j.set(20,D.$8j.symbolFile),j.set(21,D.$8j.symbolReference),j.set(22,D.$8j.symbolCustomColor),j.set(23,D.$8j.symbolFolder),j.set(24,D.$8j.symbolTypeParameter),j.set(25,D.$8j.account),j.set(26,D.$8j.issues);function N(x){let ce=j.get(x);return ce||(console.info("No codicon found for CompletionItemKind "+x),ce=D.$8j.symbolProperty),ce}P.toIcon=N;const F=new Map;F.set("method",0),F.set("function",1),F.set("constructor",2),F.set("field",3),F.set("variable",4),F.set("class",5),F.set("struct",6),F.set("interface",7),F.set("module",8),F.set("property",9),F.set("event",10),F.set("operator",11),F.set("unit",12),F.set("value",13),F.set("constant",14),F.set("enum",15),F.set("enum-member",16),F.set("enumMember",16),F.set("keyword",17),F.set("snippet",27),F.set("text",18),F.set("color",19),F.set("file",20),F.set("reference",21),F.set("customcolor",22),F.set("folder",23),F.set("type-parameter",24),F.set("typeParameter",24),F.set("account",25),F.set("issue",26);function W(x,ce){let J=F.get(x);return typeof J>"u"&&!ce&&(J=9),J}P.fromString=W})(m||(e.CompletionItemKinds=m={}));var w;(function(P){P[P.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var S;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var l;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var f;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(f||(e.InlineCompletionTriggerKind=f={}));class s{constructor(j,N,F,W){this.range=j,this.text=N,this.completionKind=F,this.isSnippetText=W}equals(j){return I.$Gs.lift(this.range).equalsRange(j.range)&&this.text===j.text&&this.completionKind===j.completionKind&&this.isSnippetText===j.isSnippetText}}e.$rt=s;var i;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(P){return P&&T.URI.isUri(P.uri)&&I.$Gs.isIRange(P.range)&&(I.$Gs.isIRange(P.originSelectionRange)||I.$Gs.isIRange(P.targetSelectionRange))}e.$st=a;var t;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$tt={[17]:(0,p.localize)(0,null),[16]:(0,p.localize)(1,null),[4]:(0,p.localize)(2,null),[13]:(0,p.localize)(3,null),[8]:(0,p.localize)(4,null),[9]:(0,p.localize)(5,null),[21]:(0,p.localize)(6,null),[23]:(0,p.localize)(7,null),[7]:(0,p.localize)(8,null),[0]:(0,p.localize)(9,null),[11]:(0,p.localize)(10,null),[10]:(0,p.localize)(11,null),[19]:(0,p.localize)(12,null),[5]:(0,p.localize)(13,null),[1]:(0,p.localize)(14,null),[2]:(0,p.localize)(15,null),[20]:(0,p.localize)(16,null),[15]:(0,p.localize)(17,null),[18]:(0,p.localize)(18,null),[24]:(0,p.localize)(19,null),[3]:(0,p.localize)(20,null),[6]:(0,p.localize)(21,null),[14]:(0,p.localize)(22,null),[22]:(0,p.localize)(23,null),[25]:(0,p.localize)(24,null),[12]:(0,p.localize)(25,null)};function r(P,j){return(0,p.localize)(26,null,P,e.$tt[j])}e.$ut=r;var d;(function(P){P[P.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var u;(function(P){const j=new Map;j.set(0,D.$8j.symbolFile),j.set(1,D.$8j.symbolModule),j.set(2,D.$8j.symbolNamespace),j.set(3,D.$8j.symbolPackage),j.set(4,D.$8j.symbolClass),j.set(5,D.$8j.symbolMethod),j.set(6,D.$8j.symbolProperty),j.set(7,D.$8j.symbolField),j.set(8,D.$8j.symbolConstructor),j.set(9,D.$8j.symbolEnum),j.set(10,D.$8j.symbolInterface),j.set(11,D.$8j.symbolFunction),j.set(12,D.$8j.symbolVariable),j.set(13,D.$8j.symbolConstant),j.set(14,D.$8j.symbolString),j.set(15,D.$8j.symbolNumber),j.set(16,D.$8j.symbolBoolean),j.set(17,D.$8j.symbolArray),j.set(18,D.$8j.symbolObject),j.set(19,D.$8j.symbolKey),j.set(20,D.$8j.symbolNull),j.set(21,D.$8j.symbolEnumMember),j.set(22,D.$8j.symbolStruct),j.set(23,D.$8j.symbolEvent),j.set(24,D.$8j.symbolOperator),j.set(25,D.$8j.symbolTypeParameter);function N(F){let W=j.get(F);return W||(console.info("No codicon found for SymbolKind "+F),W=D.$8j.symbolProperty),W}P.toIcon=N})(u||(e.SymbolKinds=u={}));class c{static asEditOperation(j){return g.$Hs.replace(I.$Gs.lift(j.range),j.text)}}e.$vt=c;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(j){switch(j){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(j)}constructor(j){this.value=j}}e.$wt=h;var k;(function(P){function j(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}P.is=j})(k||(e.Command=k={}));var L;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(L||(e.CommentThreadCollapsibleState=L={}));var v;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var b;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(b||(e.CommentMode=b={}));var E;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(E||(e.CommentState=E={}));var A;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})(A||(e.InlayHintKind=A={}));class z{constructor(j){this.b=j,this.a=null}dispose(){this.a&&this.a.then(j=>{j&&j.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$xt=z,e.$yt=new R.$ft;var O;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(ke[196],Se([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[217],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[218],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[219],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[220],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[221],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[222],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[223],Se([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[224],Se([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[225],Se([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[226],Se([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[227],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[228],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[229],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[230],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[231],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[232],Se([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[233],Se([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[234],Se([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[235],Se([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[236],Se([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[237],Se([1,0,8,198]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,T.localize)(0,null,y[0]);case 2:return(0,T.localize)(1,null,y[0],y[1]);case 3:return(0,T.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,T.localize)(3,null),p=(0,T.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(M=>M.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const C=this.d,m=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:M}),this.f.push(w)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,C=!1,m=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(p);return}const S=this.c.charCodeAt(M);if(C)C=!1;else if(S===47&&!m){M++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);M++}for(;M<this.c.length&&$.a.has(this.c.charCodeAt(M));)M++;this.e=M;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=$}),define(ke[238],Se([1,0,23,39,201,386]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||R.test(s)}e.$Yo=$;function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Zo=y;function M(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let d=0;if(s.preRelease){const u=p.exec(s.preRelease);if(u){const[,c,h,k]=u;d=Date.UTC(Number(c),Number(h)-1,Number(k))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:d}}e.$1o=M;function C(s,i,n){let o;typeof s=="string"?o=M(y(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=M(y(n)):t=n,!o||!t)return!1;const r=o.majorBase,d=o.minorBase,u=o.patchBase;let c=t.majorBase,h=t.minorBase,k=t.patchBase;const L=t.notBefore;let v=t.majorMustEqual,b=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:d>h?!0:d<h||a&&a<L?!1:u>=k:(r===1&&c===0&&(!v||!b||!E)&&(c=1,h=0,k=0,v=!0,b=!1,E=!1),r<c?!1:r>c?!v:d<h?!1:d>h?!b:u<k?!1:u>k?!E:!(a&&a<L))}e.$2o=C;function m(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([T.default.Error,g.localize(0,null)]),t;if(typeof o.name!="string")return t.push([T.default.Error,g.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([T.default.Error,g.localize(2,null,"version")]),t;if(!o.engines)return t.push([T.default.Error,g.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([T.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!f(o.extensionDependencies))return t.push([T.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!f(o.activationEvents))return t.push([T.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([T.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([T.default.Warning,g.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([T.default.Error,g.localize(9,null,"main")]),t;{const u=(0,D.$Dg)(n,o.main);(0,D.$xg)(u,n)||t.push([T.default.Warning,g.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([T.default.Error,g.localize(11,null,"browser")]),t;{const u=(0,D.$Dg)(n,o.browser);(0,D.$xg)(u,n)||t.push([T.default.Warning,g.localize(12,null,u.path,n.path)])}}if(!I.valid(o.version))return t.push([T.default.Error,g.localize(13,null)]),t;const r=[];if(!w(s,i,o,a,r))for(const u of r)t.push([T.default.Error,u]);return t}e.$3o=m;function w(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:l(s,i,n.engines.vscode,a)}e.$4o=w;function S(s,i,n){return s==="*"||l(i,n,s)}e.$5o=S;function l(s,i,n,o=[]){const a=M(y(n));if(!a)return o.push(g.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(g.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(g.localize(16,null,n)),!1;return C(s,i,a)?!0:(o.push(g.localize(17,null,s,n)),!1)}function f(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class D{constructor(g,I=[],R=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=R}}e.$Yh=D}),define(ke[106],Se([1,0,105]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.InstantiationType=void 0;const T=[];var g;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(p,$,y){$ instanceof D.$Yh||($=new D.$Yh($,[],!!y)),T.push([p,$])}e.$Jr=I;function R(){return T}e.$Kr=R}),define(ke[239],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=void 0;class D{constructor(I,R){this.key=I,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$oq=D;class T{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const R of this.a.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const p=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(R);p.outgoing.set($.key,$),$.incoming.set(p.key,p)}removeNode(I){const R=this.b(I);this.a.delete(R);for(const p of this.a.values())p.outgoing.delete(R),p.incoming.delete(R)}lookupOrInsertNode(I){const R=this.b(I);let p=this.a.get(R);return p||(p=new D(R,I),this.a.set(R,p)),p}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[R,p]of this.a)I.push(`${R}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,R]of this.a){const p=new Set([I]),$=this.c(R,p);if($)return $}}c(I,R){for(const[p,$]of I.outgoing){if(R.has(p))return[...R,p].join(" -> ");R.add(p);const y=this.c($,R);if(y)return y;R.delete(p)}}}e.$pq=T}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var D;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function p($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=p})(D||(e._util=D={})),e.$1h=g("instantiationService");function T(R,p,$){p[D.DI_TARGET]===p?p[D.DI_DEPENDENCIES].push({id:R,index:$}):(p[D.DI_DEPENDENCIES]=[{id:R,index:$}],p[D.DI_TARGET]=p)}function g(R){if(D.serviceIds.has(R))return D.serviceIds.get(R);const p=function($,y,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(p,$,M)};return p.toString=()=>R,D.serviceIds.set(R,p),p}e.$2h=g;function I(R){return R}e.$3h=I}),define(ke[45],Se([1,0,18,2,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,g.$2h)("configurationService");function I(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof T.URI)}e.$wi=I;function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof T.URI)}e.$xi=R;var p;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=$;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$zi=y;function M(s,i){const n=Object.create(null);for(const o in s)C(n,o,s[o],i);return n}e.$Ai=M;function C(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let d=0;d<a.length;d++){const u=a[d];let c=r[u];switch(typeof c){case"undefined":c=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$Bi=C;function m(s,i){const n=i.split(".");w(s,n)}e.$Ci=m;function w(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(w(o,i),Object.keys(o).length===0&&delete s[n])}}function S(s,i,n){function o(r,d){let u=r;for(const c of d){if(typeof u!="object"||u===null)return;u=u[c]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$Di=S;function l(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.$Gf(s[o])&&D.$Gf(i[o])?l(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$Ei=l;function f(s){return s.replace(/[\[\]]/g,"")}e.$Fi=f}),define(ke[46],Se([1,0,11,13,237,5,197,8]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(K,B){if($.get(K)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(K,B)}e.$Xi=y;const M=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),S=(0,R.localize)(1,null),l=(0,R.localize)(2,null),f=(0,R.localize)(3,null),s=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=m){this.k=B,this.d=new g.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),he=ye.type===17?i:void 0;throw this.h.push({message:s,offset:ye.offset,lexeme:g.$Wi.getLexeme(ye),additionalInfo:he}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ne=this.o();B.push(ne)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ne=this.s();B.push(ne)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,f),ne?.negate()}case 17:return this.z(),A.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,f),ne}case 17:{const ne=B.lexeme;if(this.z(),this.y(9)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==10)throw this.B("REGEX",he);const ge=he.lexeme,_=ge.lastIndexOf("/"),ie=_===ge.length-1?void 0:this.w(ge.substring(_+1));let G;try{G=new RegExp(ge.substring(1,_),ie)}catch{throw this.B("REGEX",he)}return F.create(ne,G)}switch(he.type){case 10:case 19:{const ge=[he.lexeme];this.z();let _=this.D(),ie=0;for(let Ae=0;Ae<he.lexeme.length;Ae++)he.lexeme.charCodeAt(Ae)===40?ie++:he.lexeme.charCodeAt(Ae)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let Ae=0;Ae<_.lexeme.length;Ae++)_.lexeme.charCodeAt(Ae)===40?ie++:he.lexeme.charCodeAt(Ae)===41&&ie--}if(ie<0)break;ge.push(g.$Wi.getLexeme(_)),this.z(),_=this.D()}const G=ge.join(""),te=G.lastIndexOf("/"),fe=te===G.length-1?void 0:this.w(G.substring(te+1));let ve;try{ve=new RegExp(G.substring(1,te),fe)}catch{throw this.B("REGEX",he)}return t.regex(ne,ve)}case 18:{const ge=he.lexeme;this.z();let _=null;if(!(0,T.$Ge)(ge)){const ie=ge.indexOf("/"),G=ge.lastIndexOf("/");if(ie!==G&&ie>=0){const te=ge.slice(ie+1,G),fe=ge[G+1]==="i"?"i":"";try{_=new RegExp(te,fe)}catch{throw this.B("REGEX",he)}}}if(_===null)throw this.B("REGEX",he);return F.create(ne,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const he=this.u();return t.notIn(ne,he)}switch(this.D().type){case 3:{this.z();const he=this.u();if(this.x().type===18)return t.equals(ne,he);switch(he){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,he)}}case 4:{this.z();const he=this.u();if(this.x().type===18)return t.notEquals(ne,he);switch(he){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,he)}}case 5:return this.z(),j.create(ne,this.u());case 6:return this.z(),N.create(ne,this.u());case 7:return this.z(),O.create(ne,this.u());case 8:return this.z(),P.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ne){if(this.C(B))return this.z();throw this.B(ne,this.D())}B(B,ne,ye){const he=(0,R.localize)(8,null,B,g.$Wi.getLexeme(ne)),ge=ne.offset,_=g.$Wi.getLexeme(ne);return this.h.push({message:he,offset:ge,lexeme:_,additionalInfo:ye}),a.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=a;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(B){return k.create(B)}static equals(B,ne){return L.create(B,ne)}static notEquals(B,ne){return E.create(B,ne)}static regex(B,ne){return F.create(B,ne)}static in(B,ne){return v.create(B,ne)}static notIn(B,ne){return b.create(B,ne)}static not(B){return A.create(B)}static and(...B){return ce.create(B,null,!0)}static or(...B){return J.create(B,null,!0)}static greater(B,ne){return O.create(B,ne)}static greaterEquals(B,ne){return P.create(B,ne)}static smaller(B,ne){return j.create(B,ne)}static smallerEquals(B,ne){return N.create(B,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Zi=t;function r(K){const B=new a({regexParsingWithErrorRecovery:!1});return K.map(ne=>(B.parse(ne),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$1i=r;function d(K,B){const ne=K?K.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}e.$2i=d;function u(K,B){return K.cmp(B)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return h.INSTANCE}}e.$3i=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return c.INSTANCE}}e.$4i=h;class k{static create(B,ne=null){const ye=$.get(B);return typeof ye=="boolean"?ye?h.INSTANCE:c.INSTANCE:new k(B,ne)}constructor(B,ne){this.key=B,this.c=ne,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:X(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=$.get(this.key);return typeof B=="boolean"?B?h.INSTANCE:c.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$5i=k;class L{static create(B,ne,ye=null){if(typeof ne=="boolean")return ne?k.create(B,ye):A.create(B,ye);const he=$.get(B);return typeof he=="boolean"?ne===(he?"true":"false")?h.INSTANCE:c.INSTANCE:new L(B,ne,ye)}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:se(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?h.INSTANCE:c.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$6i=L;class v{static create(B,ne){return new v(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:se(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.f),ye=B.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?M.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.$7i=v;class b{static create(B,ne){return new b(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=11,this.c=v.create(B,ne)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=b;class E{static create(B,ne,ye=null){if(typeof ne=="boolean")return ne?A.create(B,ye):k.create(B,ye);const he=$.get(B);return typeof he=="boolean"?ne===(he?"true":"false")?c.INSTANCE:h.INSTANCE:new E(B,ne,ye)}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:se(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=$.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?c.INSTANCE:h.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$9i=E;class A{static create(B,ne=null){const ye=$.get(B);return typeof ye=="boolean"?ye?c.INSTANCE:h.INSTANCE:new A(B,ne)}constructor(B,ne){this.c=B,this.d=ne,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:X(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=$.get(this.c);return typeof B=="boolean"?B?c.INSTANCE:h.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$0i=A;function z(K,B){if(typeof K=="string"){const ne=parseFloat(K);isNaN(ne)||(K=ne)}return typeof K=="string"||typeof K=="number"?B(K):c.INSTANCE}class O{static create(B,ne,ye=null){return z(ne,he=>new O(B,he,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:se(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$$i=O;class P{static create(B,ne,ye=null){return z(ne,he=>new P(B,he,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:se(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$_i=P;class j{static create(B,ne,ye=null){return z(ne,he=>new j(B,he,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:se(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$aj=j;class N{static create(B,ne,ye=null){return z(ne,he=>new N(B,he,ye))}constructor(B,ne,ye){this.c=B,this.d=ne,this.f=ye,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:se(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$bj=N;class F{static create(B,ne){return new F(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ne=this.f?this.f.source:"",ye=B.f?B.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(B){if(B.type===this.type){const ne=this.f?this.f.source:"",ye=B.f?B.f.source:"";return this.d===B.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$cj=F;class W{static create(B){return new W(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new W(this.c.map(B))}negate(){return this.c}}e.$dj=W;function x(K){let B=null;for(let ne=0,ye=K.length;ne<ye;ne++){const he=K[ne].substituteConstants();if(K[ne]!==he&&B===null){B=[];for(let ge=0;ge<ne;ge++)B[ge]=K[ge]}B!==null&&(B[ne]=he)}return B===null?K:B}class ce{static create(B,ne,ye){return ce.d(B,ne,ye)}constructor(B,ne){this.expr=B,this.c=ne,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const he=u(this.expr[ne],B.expr[ne]);if(he!==0)return he}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=x(this.expr);return B===this.expr?this:ce.create(B,this.c,!1)}evaluate(B){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(B))return!1;return!0}static d(B,ne,ye){const he=[];let ge=!1;for(const _ of B)if(_){if(_.type===1){ge=!0;continue}if(_.type===0)return c.INSTANCE;if(_.type===6){he.push(..._.expr);continue}he.push(_)}if(he.length===0&&ge)return h.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(u);for(let _=1;_<he.length;_++)he[_-1].equals(he[_])&&(he.splice(_,1),_--);if(he.length===1)return he[0];for(;he.length>1;){const _=he[he.length-1];if(_.type!==9)break;he.pop();const ie=he.pop(),G=he.length===0,te=J.create(_.expr.map(fe=>ce.create([fe,ie],null,ye)),null,G);te&&(he.push(te),he.sort(u))}if(he.length===1)return he[0];if(ye){for(let _=0;_<he.length;_++)for(let ie=_+1;ie<he.length;ie++)if(he[_].negate().equals(he[ie]))return c.INSTANCE;if(he.length===1)return he[0]}return new ce(he,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new ce(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());this.c=J.create(B,this,!0)}return this.c}}e.$ej=ce;class J{static create(B,ne,ye){return J.d(B,ne,ye)}constructor(B,ne){this.expr=B,this.c=ne,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const he=u(this.expr[ne],B.expr[ne]);if(he!==0)return he}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=x(this.expr);return B===this.expr?this:J.create(B,this.c,!1)}evaluate(B){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(B))return!0;return!1}static d(B,ne,ye){let he=[],ge=!1;if(B){for(let _=0,ie=B.length;_<ie;_++){const G=B[_];if(G){if(G.type===0){ge=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){he=he.concat(G.expr);continue}he.push(G)}}if(he.length===0&&ge)return c.INSTANCE;he.sort(u)}if(he.length!==0){if(he.length===1)return he[0];for(let _=1;_<he.length;_++)he[_-1].equals(he[_])&&(he.splice(_,1),_--);if(he.length===1)return he[0];if(ye){for(let _=0;_<he.length;_++)for(let ie=_+1;ie<he.length;ie++)if(he[_].negate().equals(he[ie]))return h.INSTANCE;if(he.length===1)return he[0]}return new J(he,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new J(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());for(;B.length>1;){const ne=B.shift(),ye=B.shift(),he=[];for(const ge of de(ne))for(const _ of de(ye))he.push(ce.create([ge,_],null,!1));B.unshift(J.create(he,null,!1))}this.c=J.create(B,this,!0)}return this.c}}e.$fj=J;class Y extends k{static{this.d=[]}static all(){return Y.d.values()}constructor(B,ne,ye){super(B,null),this.f=ne,typeof ye=="object"?Y.d.push({...ye,key:B}):ye!==!0&&Y.d.push({key:B,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return L.create(this.key,B)}notEqualsTo(B){return E.create(this.key,B)}}e.$gj=Y,e.$hj=(0,I.$2h)("contextKeyService");function X(K,B){return K<B?-1:K>B?1:0}function se(K,B,ne,ye){return K<ne?-1:K>ne?1:B<ye?-1:B>ye?1:0}function Z(K,B){if(K.type===0||B.type===1)return!0;if(K.type===9)return B.type===9?we(K.expr,B.expr):!1;if(B.type===9){for(const ne of B.expr)if(Z(K,ne))return!0;return!1}if(K.type===6){if(B.type===6)return we(B.expr,K.expr);for(const ne of K.expr)if(Z(ne,B))return!0;return!1}return K.equals(B)}e.$ij=Z;function we(K,B){let ne=0,ye=0;for(;ne<K.length&&ye<B.length;){const he=K[ne].cmp(B[ye]);if(he<0)return!1;he===0&&ne++,ye++}return ne===K.length}function de(K){return K.type===9?K.expr:[K]}}),define(ke[240],Se([1,0,23,39,199,5,102,11,24]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=e.ConfirmResult=e.$Sv=e.$Rv=e.$Qv=void 0,e.$Qv=(0,I.$2h)("dialogService");var y;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(y||(y={}));class M{a(f){return this.d(f,y.Confirmation)}b(f){return this.d(f,y.Prompt)}c(f){return this.d(f,y.Input)}d(f,s){const i=[];switch(s){case y.Confirmation:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const n=f;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const n=f;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(f){if(typeof f=="string")return f;if(typeof f=="number")return f===T.default.Info?"info":f===T.default.Error?"error":f===T.default.Warning?"warning":"none"}f(f,s,i){const n=[...f.buttons??[]];f.cancelButton&&typeof f.cancelButton!="string"&&typeof f.cancelButton!="boolean"&&n.push(f.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Rv=M,e.$Sv=(0,I.$2h)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function w(l){const f=[];return f.push(...l.slice(0,m).map(s=>typeof s=="string"?s:(0,D.$Ag)(s))),l.length>m&&(l.length-m===1?f.push((0,g.localize)(7,null)):f.push((0,g.localize)(8,null,l.length-m))),f.push(""),f.join(`
`)}e.$Tv=w;function S(l,f){const s=(0,$.$hn)(l);let i=(s.buttons??[]).map(t=>(0,R.$Nv)(t)),n=(l.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(p.$k||p.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}p.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(p.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||f.nameLong,{options:s,buttonIndeces:n}}e.$Uv=S}),define(ke[133],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,D.$2h)("environmentService"),e.$0h=(0,D.$3h)(e.$9h)}),define(ke[134],Se([1,0,200,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ko=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0,e.$$n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$_n=new RegExp(e.$$n),e.$ao="__web_extension",e.$bo="skipWalkthrough",e.$co="extensionsSync",e.$do="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$eo=g;function I(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$fo=I;function R(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$go=R;function p(s,i){return i==="web"&&!s.includes("web")}e.$ho=p;function $(s,i,n){return p(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$io=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$jo=y;var M;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var w;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$ko=(0,T.$2h)("extensionGalleryService");var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var l;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$lo=f,e.$mo=(0,T.$2h)("extensionManagementService"),e.$no="extensionsIdentifiers/disabled",e.$oo="extensionsIdentifiers/enabled",e.$po=(0,T.$2h)("IGlobalExtensionEnablementService"),e.$qo=(0,T.$2h)("IExtensionTipsService"),e.$ro=(0,D.localize)(0,null),e.$so={value:e.$ro,original:"Extensions"},e.$to={value:(0,D.localize)(1,null),original:"Preferences"}}),define(ke[241],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$31b=e.$21b=void 0,e.$21b=(0,D.$2h)("externalTerminal"),e.$31b="Terminal.app"}),define(ke[242],Se([1,0,51,17,16,11,101,31,104,202,241]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=e.$Y9b=e.$X9b=void 0;const C=y.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await l.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends m{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(D,o,$.$Ol(),a)}spawnTerminal(o,a,t,r){const d=a.windowsExec||w.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=g.$nc(d,".exe").toLowerCase();if(u==="cmder")return o.spawn(d,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return d.indexOf(" ")>=0&&c.push('""'),c.push(d),u==="wt"&&c.push("-d ."),new Promise((h,k)=>{const L=f(process),v=o.spawn(t,c,{cwd:r,env:L});v.on("error",k),v.on("exit",()=>h())})}runInTerminal(o,a,t,r,d){const u="windowsExec"in d&&d.windowsExec?d.windowsExec:w.getDefaultTerminalWindows();return new Promise((c,h)=>{const k=`"${a} - ${C}"`,L=`""${t.join('" "')}" & pause"`,v=Object.assign({},f(process),r);Object.keys(v).filter(O=>v[O]===null).forEach(O=>delete v[O]);const b={cwd:a,env:v,windowsVerbatimArguments:!0};let E,A;g.$nc(u,".exe")==="wt"?(E=u,A=["-d",".",w.b,"/c",L]):(E=w.b,A=["/c","start",k,"/wait",u,"/c",L]),D.spawn(E,A,b).on("error",O=>{h(s(O))}),c(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return w.d}}e.$X9b=w;class S extends m{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,d){const u=d.osxExec||M.$31b;return new Promise((c,h)=>{if(u===M.$31b||u==="iTerm.app"){const k=u===M.$31b?"TerminalHelper":"iTermHelper",v=[T.$kg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",o||C,"-w",a];for(const A of t)v.push("-a"),v.push(A);if(r){const A=Object.assign({},f(process),r);for(const z in A){const O=A[z];O===null?(v.push("-u"),v.push(z)):(v.push("-e"),v.push(`${z}=${O}`))}}let b="";const E=D.spawn(S.b,v);E.on("error",A=>{h(s(A))}),E.stderr.on("data",A=>{b+=A.toString()}),E.on("exit",A=>{if(A===0)c(void 0);else if(b){const z=b.split(`
`,1);h(new Error(z[0]))}else h(new Error(y.localize(1,null,k,A)))})}else h(new Error(y.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||M.$31b;return new Promise((d,u)=>{const c=["-a",r];t&&c.push(t);const h=f(process),k=o.spawn("/usr/bin/open",c,{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})}}e.$Y9b=S;class l extends m{static{this.b=y.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,d){const u=d.linuxExec?Promise.resolve(d.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((c,h)=>{const k=[];u.then(L=>{L.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const v=`${i(t)}; echo; read -p "${l.b}" -n1;`;k.push(`''${v}''`);const b=Object.assign({},f(process),r);Object.keys(b).filter(O=>b[O]===null).forEach(O=>delete b[O]);const E={cwd:a,env:b};let A="";const z=D.spawn(L,k,E);z.on("error",O=>{h(s(O))}),z.stderr.on("data",O=>{A+=O.toString()}),z.on("exit",O=>{if(O===0)c(void 0);else if(A){const P=A.split(`
`,1);h(new Error(P[0]))}else h(new Error(y.localize(4,null,L,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!l.d)if(!I.$k)l.d=Promise.resolve("xterm");else{const o=await p.Promises.exists("/etc/debian_version");l.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return l.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):l.getDefaultTerminalLinuxReady();return new Promise((d,u)=>{r.then(c=>{const h=f(process),k=o.spawn(c,[],{cwd:t,env:h});k.on("error",u),k.on("exit",()=>d())})})}}e.$Z9b=l;function f(n){const o={...n.env};return(0,R.$Ml)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(y.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(ke[32],Se([1,0,77,16,13,18,2,203,5,11,17,43]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileKind=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileOperationResult=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileChangeType=e.$Dk=e.FileOperation=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileSystemProviderErrorCode=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.FileSystemProviderCapabilities=e.$nk=e.FilePermission=e.FileType=e.$mk=e.$lk=void 0,e.$lk=(0,$.$2h)("fileService");function m(Z){return Z.create===!0}e.$mk=m;var w;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var S;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function l(Z){const we=Z;return!!we&&typeof we.onDidChange=="function"}e.$nk=l;var f;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function s(Z){return!!(Z.capabilities&2)}e.$ok=s;function i(Z){return!!(Z.capabilities&8)}e.$pk=i;function n(Z){return!!(Z.capabilities&131072)}e.$qk=n;function o(Z){return!!(Z.capabilities&4)}e.$rk=o;function a(Z){return!!(Z.capabilities&16)}e.$sk=a;function t(Z){return s(Z)?!!(Z.capabilities&16384):!1}e.$tk=t;function r(Z){return s(Z)?!!(Z.capabilities&32768):!1}e.$uk=r;function d(Z){return!!(Z.capabilities&65536)}e.$vk=d;function u(Z){return!!(Z.capabilities&2048)}e.$wk=u;var c;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(we,de){const K=new h(we.toString(),de);return v(K,de),K}constructor(we,de){super(we),this.code=de}}e.$xk=h;function k(Z,we){return h.create(Z,we)}e.$yk=k;function L(Z){return Z||k((0,p.localize)(0,null),c.Unknown)}e.$zk=L;function v(Z,we){return Z.name=we?`${we} (FileSystemError)`:"FileSystemError",Z}e.$Ak=v;function b(Z){if(!Z)return c.Unknown;if(Z instanceof h)return Z.code;const we=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!we)return c.Unknown;switch(we[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$Bk=b;function E(Z){if(Z instanceof N)return Z.fileOperationResult;switch(b(Z)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$Ck=E;var A;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class z{constructor(we,de,K){this.resource=we,this.operation=de,this.target=K}isOperation(we){return this.operation===we}}e.$Dk=z;var O;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class P{static{this.a=null}constructor(we,de){this.c=de,this.b=void 0,this.d=new C.$V(()=>{const K=D.$8h.forUris(()=>this.c);return K.fill(this.rawAdded.map(B=>[B,!0])),K}),this.f=new C.$V(()=>{const K=D.$8h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(B=>[B,!0])),K}),this.g=new C.$V(()=>{const K=D.$8h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(B=>[B,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of we){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==P.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=P.a):this.b!==void 0&&(this.b=P.a))}}contains(we,...de){return this.h(we,{includeChildren:!1},...de)}affects(we,...de){return this.h(we,{includeChildren:!0},...de)}h(we,de,...K){if(!we)return!1;const B=K.length>0;return!!((!B||K.includes(1))&&(this.d.value.get(we)||de.includeChildren&&this.d.value.findSuperstr(we))||(!B||K.includes(0))&&(this.f.value.get(we)||de.includeChildren&&this.f.value.findSuperstr(we))||(!B||K.includes(2))&&(this.g.value.findSubstr(we)||de.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$Ek=P;function j(Z,we,de){return!Z||!we||Z===we||we.length>Z.length?!1:(we.charAt(we.length-1)!==T.sep&&(we+=T.sep),de?(0,g.$9e)(Z,we):Z.indexOf(we)===0)}e.$Fk=j;class N extends Error{constructor(we,de,K){super(we),this.fileOperationResult=de,this.options=K}}e.$Gk=N;class F extends N{constructor(we,de,K,B){super(we,de,B),this.fileOperationResult=de,this.size=K}}e.$Hk=F;class W extends N{constructor(we,de,K){super(we,2,K),this.stat=de}}e.$Ik=W;var x;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(x||(e.FileOperationResult=x={})),e.$Jk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Kk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Lk="files.associations",e.$Mk="files.exclude",e.$Nk="files.readonlyInclude",e.$Ok="files.readonlyExclude",e.$Pk="files.readonlyFromPermissions";var ce;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$Qk="";function J(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$Rk=J;async function Y(Z,we){if(!we.hasProvider(R.URI.from({scheme:Z.scheme})))return new Promise(de=>{const K=we.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===Z.scheme&&B.added&&(K.dispose(),de())})})}e.$Sk=Y;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(we){return(0,I.$If)(we)||(we=0),we<X.KB?(0,p.localize)(1,null,we.toFixed(0)):we<X.MB?(0,p.localize)(2,null,(we/X.KB).toFixed(2)):we<X.GB?(0,p.localize)(3,null,(we/X.MB).toFixed(2)):we<X.TB?(0,p.localize)(4,null,(we/X.GB).toFixed(2)):(0,p.localize)(5,null,(we/X.TB).toFixed(2))}}e.$Tk=X;function se(Z){const we=typeof Z=="string"||Z?.scheme===M.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===M.Schemas.file?1024*X.MB:we?10*X.MB:y.$o?50*X.MB:1024*X.MB}e.$Uk=se}),define(ke[243],Se([1,0,22,8,204,32]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;async function R(M,C,m,w,S,l){let f;try{await p(M,C,m,w,S,l)}catch(s){f=s}finally{f&&S.errorTransformer&&(f=S.errorTransformer(f)),typeof f<"u"&&m.error(f),m.end()}}e.$Zp=R;async function p(M,C,m,w,S,l){$(l);const f=await M.open(C,{create:!1});try{$(l);let s=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,o=D.$ge.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await M.read(f,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await m.write(w(o)),o=D.$ge.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(l)&&y(s,S));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),m.write(w(o.slice(0,r)))}}catch(s){throw(0,I.$zk)(s)}finally{await M.close(f)}}function $(M){if(M.isCancellationRequested)throw(0,T.$6)();return!0}function y(M,C){if(typeof C?.limits?.size=="number"&&M>C.limits.size)throw(0,I.$yk)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,11,2,32]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=void 0;function $(s){return s.recursive===!0}e.$2p=$;class y extends T.$Sc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new T.$Tc),this.f=void 0,this.g=0}s(){const i=new T.$Rc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$3p=y;class M extends y{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$4p=M;class C extends y{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$5p=C;function m(s){return s.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$6p=m;function w(s){const i=new f;for(const n of s)i.processEvent(n);return i.coalesce()}e.$7p=w;function S(s,i){return typeof i=="string"&&!i.startsWith(D.$Ej)&&!(0,g.$ic)(i)?{base:s,pattern:i}:i}e.$8p=S;function l(s,i){const n=[];for(const o of i)n.push((0,D.$Ij)(S(s,o)));return n}e.$9p=l;class f{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,p.$Fk)(o.resource.fsPath,a,!I.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(ke[244],Se([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;class l extends R.$Sc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new T.$eh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$dh(t=>this.z(t),l.b)),this.g=(0,S.$9p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$9p)(this.m.path,this.m.includes):void 0,this.j=new g.$3d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await w.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await w.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$gq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,I.$4f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Sc.None;const o=new g.$3d(this.j.token),a=new R.$Rc;try{const t=C.URI.file(this.m.path),r=(0,$.$nc)(i),d=(0,D.watch)(i);a.add((0,R.$Qc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const h of await w.Promises.readdir(i))u.add(h)}catch(h){this.D(h)}const c=new Map;a.add((0,R.$Qc)(()=>{for(const[,h]of c)h.dispose();c.clear()})),d.on("error",(h,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${k})`),this.dispose()}),d.on("change",(h,k)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${k}`);let L="";if(k&&(L=k.toString(),y.$j&&(L=(0,p.$Bl)(L))),!(!L||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){c.get(L)?.dispose();const v=setTimeout(async()=>{if(c.delete(L),L===r&&!await w.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.C((0,$.$jc)(i,L));if(o.token.isCancellationRequested)return;let E;b?u.has(L)?E=0:(E=1,u.add(L)):(u.delete(L),E=2),this.y({resource:(0,M.$Dg)(t,L),type:E,cId:this.m.correlationId})},l.a);c.set(L,(0,R.$Qc)(()=>clearTimeout(v)))}else{let v;u.has(L)?v=0:(v=1,u.add(L)),this.y({resource:(0,M.$Dg)(t,L),type:v,cId:this.m.correlationId})}else if(h==="rename"||L!==r){const v=setTimeout(async()=>{const b=await w.Promises.exists(i);o.token.isCancellationRequested||(b?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},l.a);a.clear(),a.add((0,R.$Qc)(()=>clearTimeout(v)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await w.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Qc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$7p)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return w.Promises.exists(i);try{const n=(0,$.$nc)(i);return(await w.Promises.readdir((0,$.$mc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$jq=l;async function f(s,i,n,o,a=512){const t=await w.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),d=new g.$3d(o);let u,c=!1;const h={path:s,excludes:[],recursive:!1},k=new l(h,L=>{(async()=>{for(const{type:v}of L)if(v===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:b}=await w.Promises.read(t,r,0,a,null);if(!b||d.token.isCancellationRequested)break;i(r.slice(0,b))}}catch(b){u=new Error(b),d.dispose(!0)}finally{c=!1}}})()});return await k.ready,n(),new Promise((L,v)=>{d.token.onCancellationRequested(async()=>{k.dispose();try{await w.Promises.close(t)}catch(b){u=new Error(b)}u?v(u):L()})})}e.$kq=f}),define(ke[245],Se([1,0,4,34,3,11,244]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class p extends g.$Sc{constructor(){super(...arguments),this.a=this.B(new D.$Sd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Sd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const M=this.j(y),C=M.filter(w=>{const S=this.c.get(w.path);return S?!(0,T.$Mj)(S.request.excludes,w.excludes)||!(0,T.$Mj)(S.request.includes,w.includes):!0}),m=Array.from(this.c.values()).filter(({request:w})=>!M.find(S=>S.path===w.path&&(0,T.$Mj)(S.excludes,w.excludes)&&(0,T.$Mj)(S.includes,w.includes))).map(({request:w})=>w.path);C.length&&this.m(`Request to start watching: ${C.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const w of m)this.h(w);for(const w of C)this.g(w)}g(y){const M=new R.$jq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:M};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const M=this.c.get(y);M&&(this.c.delete(y),M.instance.dispose())}j(y){const M=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let w=M.get(C.correlationId);w||(w=new Map,M.set(C.correlationId,w)),w.set(m,C)}return Array.from(M.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,M]of this.c)M.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,M){return M?`[File Watcher (node.js)] ${y} (path: ${M.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$lq=p}),define(ke[246],Se([1,0,84,245]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=void 0;class g extends D.$4p{constructor(R,p,$){super(R,p,$),this.s()}r(R){return R.add(new T.$lq)}}e.$mq=g}),define(ke[247],Se([1,0,17,81,187,84]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class R extends I.$5p{constructor($,y,M){super($,y,M),this.s()}r($){const y=$.add(new g.$dq(D.$kg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:M,signal:C})=>this.t(`terminated by itself with code ${M}, signal: ${C}`))),T.ProxyChannel.toService((0,T.$Ih)(y.getChannel("watcher")))}}e.$eq=R}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class D{constructor(...g){this.a=new Map;for(const[I,R]of g)this.set(I,R)}set(g,I){const R=this.a.get(g);return this.a.set(g,I),R}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Zh=D}),define(ke[248],Se([1,0,12,8,3,105,239,5,107,75]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;const M=!1;class C extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class m{constructor(f=new $.$Zh,s=!1,i,n=M){this.f=f,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(p.$1h,this),this._globalGraph=n?i?._globalGraph??new R.$pq(o=>o):void 0}createChild(f){return new m(f,this.g,this,this.i)}invokeFunction(f,...s){const i=S.traceInvocation(this.i,f);let n=!1;try{return f({get:a=>{if(n)throw(0,T.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(f,...s){let i,n;return f instanceof I.$Yh?(i=S.traceCreation(this.i,f.ctor),n=this.j(f.ctor,f.staticArguments.concat(s),i)):(i=S.traceCreation(this.i,f),n=this.j(f,s,i)),i.stop(),n}j(f,s=[],i){const n=p._util.getServiceDependencies(f).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${f.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(f,s.concat(o))}k(f,s){if(this.f.get(f)instanceof I.$Yh)this.f.set(f,s);else if(this.h)this.h.k(f,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const s=this.f.get(f);return!s&&this.h?this.h.l(f):s}m(f,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const i=this.l(f);return i instanceof I.$Yh?this.q(f,i,s.branch(f,!0)):(s.branch(f,!1),i)}q(f,s,i){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,s,i)}finally{this.o.delete(f)}}r(f,s,i){const n=new R.$pq(t=>t.id.toString());let o=0;const a=[{id:f,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new C(n);for(const r of p._util.getServiceDependencies(t.desc.ctor)){const d=this.l(r.id);if(d||this.u(`[createInstance] ${f} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),d instanceof I.$Yh){const u={id:r.id,desc:d,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof I.$Yh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(f)}s(f,s,i=[],n,o){if(this.f.get(f)instanceof I.$Yh)return this.t(f,s,i,n,o);if(this.h)return this.h.s(f,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(f,s,i=[],n,o){if(n){const a=new m(void 0,this.g,this,this.i);a.c=String(f);const t=new Map,r=new D.$ih(()=>{const d=a.j(s,i,o);for(const[u,c]of t){const h=d[u];if(typeof h=="function")for(const k of c)h.apply(d,k)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let k=t.get(u);return k||(k=new y.$3c,t.set(u,k)),(v,b,E)=>{const A=k.push([v,b,E]);return(0,g.$Qc)(A)}}if(u in d)return d[u];const c=r.value;let h=c[u];return typeof h!="function"||(h=h.bind(c),d[u]=h),h},set(d,u,c){return r.value[u]=c,!0},getPrototypeOf(d){return s.prototype}})}else return this.j(s,i,o)}u(f,s){if(s&&console.warn(f),this.g)throw new Error(f)}}e.$qq=m;var w;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(w||(w={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,s){return f?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(f,s){return f?new S(1,s.name):S.c}static{this.f=0}constructor(f,s){this.type=f,this.name=s,this.g=Date.now(),this.h=[]}branch(f,s){const i=new S(3,f.toString());return this.h.push([f,s,i]),i}stop(){const f=Date.now()-this.g;S.f+=f;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[d,u,c]of a.h)if(u&&c){s=!0,t.push(`${r}CREATES -> ${d}`);const h=i(o+1,c);h&&t.push(h)}else t.push(`${r}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(f>2||s)&&S.all.add(n.join(`
`))}}e.$rq=S}),define(ke[14],Se([1,0,44,4,53,3,28,11,23,18,2,46,5]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,m.$2h)("logService"),e.$kj=(0,m.$2h)("loggerService");function w(){return new Date().toISOString()}function S(v){return(0,y.$If)(v)}e.$lj=S;var l;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$mj=l.Info;function f(v,b,E){switch(b){case l.Trace:v.trace(E);break;case l.Debug:v.debug(E);break;case l.Info:v.info(E);break;case l.Warning:v.warn(E);break;case l.Error:v.error(E);break;case l.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=f;function s(v,b=!1){let E="";for(let A=0;A<v.length;A++){let z=v[A];if(z instanceof Error&&(z=(0,D.$Mi)(z,b)),typeof z=="object")try{z=JSON.stringify(z)}catch{}E+=(A>0?" ":"")+z}return E}class i extends I.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new T.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==l.Off&&this.b<=b}}e.$oj=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...E){this.f(l.Trace)&&this.g(l.Trace,s([b,...E],!0))}debug(b,...E){this.f(l.Debug)&&this.g(l.Debug,s([b,...E]))}info(b,...E){this.f(l.Info)&&this.g(l.Info,s([b,...E]))}warn(b,...E){this.f(l.Warning)&&this.g(l.Warning,s([b,...E]))}error(b,...E){if(this.f(l.Error))if(b instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=b.stack,this.g(l.Error,s(A))}else this.g(l.Error,s([b,...E]))}flush(){}}e.$pj=n;class o extends i{constructor(b=e.$mj){super(),this.setLevel(b),this.g=!p.$i}trace(b,...E){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,...E):console.log(`[main ${w()}]`,b,...E))}debug(b,...E){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,...E):console.log(`[main ${w()}]`,b,...E))}info(b,...E){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,...E):console.log(`[main ${w()}]`,b,...E))}warn(b,...E){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,b,...E):console.warn(`[main ${w()}]`,b,...E))}error(b,...E){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,b,...E):console.error(`[main ${w()}]`,b,...E))}dispose(){}flush(){}}e.$qj=o;class a extends i{constructor(b=e.$mj,E=!0){super(),this.g=E,this.setLevel(b)}trace(b,...E){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...E):console.log(b,...E))}debug(b,...E){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...E):console.log(b,...E))}info(b,...E){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...E):console.log(b,...E))}warn(b,...E){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...E):console.log(b,...E))}error(b,...E){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...E):console.error(b,...E))}dispose(){}flush(){}}e.$rj=a;class t extends i{constructor(b,E=e.$mj){super(),this.g=b,this.setLevel(E)}trace(b,...E){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(b),...E])}debug(b,...E){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(b),...E])}info(b,...E){this.f(l.Info)&&this.g.log(l.Info,[this.h(b),...E])}warn(b,...E){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(b),...E])}error(b,...E){this.f(l.Error)&&this.g.log(l.Error,[this.h(b),...E])}h(b){return typeof b=="string"?b:(0,D.$Mi)(b,this.f(l.Trace))}dispose(){}flush(){}}e.$sj=t;class r extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const E of this.g)E.setLevel(b);super.setLevel(b)}trace(b,...E){for(const A of this.g)A.trace(b,...E)}debug(b,...E){for(const A of this.g)A.debug(b,...E)}info(b,...E){for(const A of this.g)A.info(b,...E)}warn(b,...E){for(const A of this.g)A.warn(b,...E)}error(b,...E){for(const A of this.g)A.error(b,...E)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.$tj=r;class d extends I.$Sc{constructor(b,E,A){if(super(),this.h=b,this.j=E,this.b=new R.$Ac,this.c=this.B(new T.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Sd),this.onDidChangeVisibility=this.g.event,A)for(const z of A)this.b.set(z.resource,{logger:void 0,info:z})}m(b){return(0,y.$Ef)(b)?[...this.b.values()].find(E=>E.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,E){const A=this.n(b),z=(0,y.$Ef)(b)?b:E?.id??(0,g.$Pi)(A.toString()).toString(16);let O=this.b.get(A)?.logger;const P=E?.logLevel==="always"?l.Trace:E?.logLevel;O||(O=this.s(A,P??this.getLogLevel(A)??this.h,{...E,id:z}));const j={logger:O,info:{resource:A,id:z,logLevel:P,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(j.info),this.b.set(A,j),O}n(b){return(0,y.$Ef)(b)?(0,$.$Dg)(this.j,`${b}.log`):b}setLogLevel(b,E){if(M.URI.isUri(b)){const A=b,z=E,O=this.b.get(A);O&&z!==O.info.logLevel&&(O.info.logLevel=z===this.h?void 0:z,O.logger?.setLevel(z),this.b.set(O.info.resource,O),this.f.fire([A,z]))}else{this.h=b;for(const[A,z]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,E){const A=this.m(b);A&&E!==!A.info.hidden&&(A.info.hidden=!E,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,E]))}getLogLevel(b){let E;return b&&(E=this.b.get(b)?.info.logLevel),E??this.h}registerLogger(b){const E=this.b.get(b.resource);E?E.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const E=this.b.get(b);E&&(E.logger&&E.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=d;class u{constructor(){this.onDidChangeLogLevel=new T.$Sd().event}setLevel(b){}getLevel(){return l.Info}trace(b,...E){}debug(b,...E){}info(b,...E){}warn(b,...E){}error(b,...E){}critical(b,...E){}dispose(){}flush(){}}e.$vj=u;class c extends u{}e.$wj=c;function h(v){if(v.verbose)return l.Trace;if(typeof v.logLevel=="string"){const b=L(v.logLevel.toLowerCase());if(b!==void 0)return b}return e.$mj}e.$xj=h;function k(v){switch(v){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$yj=k;function L(v){switch(v){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$zj=L,e.$Aj=new C.$gj("logLevel",k(l.Info))}),define(ke[249],Se([1,0,19,12,8,4,3,16,84,14]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class M extends R.$Sc{constructor(m,w){super(),this.a=m,this.b=w,this.c=this.B(new I.$Sd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Sd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Zg(0)),this.w=[],this.y=this.B(new T.$Zg(0))}watch(m,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(m,w):this.z(m,w)}n(m,w){const S={path:this.H(m),excludes:w.excludes,includes:w.includes,recursive:w.recursive,correlationId:w.correlationId},l=(0,D.$Ub)(this.j,S);return this.r(),(0,R.$Qc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$1)(m))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,$.$6p)(w)),w=>this.G(w),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const w of this.j)(0,$.$2p)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const w of this.j)(0,$.$2p)(w)&&m.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,w){const S={path:this.H(m),excludes:w.excludes,includes:w.includes,recursive:!1,correlationId:w.correlationId},l=(0,D.$Ub)(this.w,S);return this.C(),(0,R.$Qc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$6p)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,p.$hc)(m.fsPath)}}e.$0p=M}),define(ke[250],Se([1,0,55,387,12,28,22,4,33,3,16,11,23,98,31,205,32,243,249,44,247,246]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0,(()=>{try{(0,T.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Mi)(r)}`)}})();class t extends i.$0p{static{this.I=!1}constructor(d,u){super(d,u),this.onDidChangeCapabilities=p.Event.None,this.N=new I.$Ac(c=>m.$ug.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:u,symbolicLink:c}=await S.SymlinkSupport.stat(this.H(d));return{type:this.M(u,c),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:f.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const u=await S.Promises.readdir(this.H(d),{withFileTypes:!0}),c=[];return await Promise.all(u.map(async h=>{try{let k;h.isSymbolicLink()?k=(await this.stat((0,m.$Dg)(d,h.name))).type:k=this.M(h),c.push([h.name,k])}catch(k){this.a.trace(k)}})),c}catch(u){throw this.fb(u)}}M(d,u){let c;return u?.dangling?c=f.FileType.Unknown:d.isFile()?c=f.FileType.File:d.isDirectory()?c=f.FileType.Directory:c=f.FileType.Unknown,u&&(c|=f.FileType.SymbolicLink),c}async O(d){const u=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let c;for(;c=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await c.wait();const h=new g.$1g;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,y.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),h.open()})}async readFile(d,u){let c;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),c=await this.O(d));const h=this.H(d);return await S.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{c?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,u,c){const h=(0,w.$7d)(k=>R.$ge.concat(k.map(L=>R.$ge.wrap(L))).buffer);return(0,s.$Zp)(this,d,h,k=>k.buffer,{...u,bufferSize:256*1024},c),h}async writeFile(d,u,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,m.$Dg)((0,m.$Cg)(d),`${(0,m.$Ag)(d)}${c.atomic.postfix}`),u,c):this.S(d,u,c)}async Q(d){try{const u=this.H(d),{symbolicLink:c}=await S.SymlinkSupport.stat(u);if(c)return!1}catch{}return!0}async R(d,u,c,h){const k=new y.$Rc;try{k.add(await this.O(d)),k.add(await this.O(u)),await this.S(u,c,h,!0);try{await this.rename(u,d,{overwrite:!0})}catch(L){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw L}}finally{k.dispose()}}async S(d,u,c,h){let k;try{const L=this.H(d);if(!c.create||!c.overwrite){if(await S.Promises.exists(L)){if(!c.overwrite)throw(0,f.$yk)((0,l.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,f.$yk)((0,l.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(k,0,u,0,u.byteLength)}catch(L){throw await this.gb(d,L)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,u,c){const h=this.H(d);let k;(0,f.$mk)(u)&&!c&&(k=await this.O(d));let L;try{if((0,f.$mk)(u)&&u.unlock)try{const{stat:b}=await S.SymlinkSupport.stat(h);b.mode&128||await S.Promises.chmod(h,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let v;if((0,f.$mk)(u)){if(C.$i)try{await S.Promises.truncate(h,0),v="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}v||(v="w")}else v="r";L=await S.Promises.open(h,v)}catch(v){throw k?.dispose(),(0,f.$mk)(u)?await this.gb(d,v):this.fb(v)}if(this.U.set(L,0),(0,f.$mk)(u)&&this.X.set(L,d),k){const v=this.W.get(L);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${L} (${h})`),this.W.set(L,k),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${L} (${h})`),v.dispose())}return L}async close(d){const u=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await S.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await S.Promises.close(d)}catch(c){throw this.fb(c)}finally{u&&(this.W.get(d)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),u.dispose())}}async read(d,u,c,h,k){const L=this.Z(d,u);let v=null;try{v=(await S.Promises.read(d,c,h,k,L)).bytesRead}catch(b){throw this.fb(b)}finally{this.$(d,L,v)}return v}Z(d,u){return u===this.U.get(d)?null:u}$(d,u,c){const h=this.U.get(d);typeof h=="number"&&(typeof u=="number"||(typeof c=="number"?this.U.set(d,h+c):this.U.delete(d)))}async write(d,u,c,h,k){return(0,g.$jh)(()=>this.ab(d,u,c,h,k),100,3)}async ab(d,u,c,h,k){const L=this.Z(d,u);let v=null;try{v=(await S.Promises.write(d,c,h,k,L)).bytesWritten}catch(b){throw await this.gb(this.X.get(d),b)}finally{this.$(d,L,v)}return v}async mkdir(d){try{await S.Promises.mkdir(this.H(d))}catch(u){throw this.fb(u)}}async delete(d,u){try{const c=this.H(d);if(u.recursive){let h;u?.atomic!==!1&&u.atomic.postfix&&(h=(0,M.$jc)((0,M.$mc)(c),`${(0,M.$nc)(c)}${u.atomic.postfix}`)),await S.Promises.rm(c,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let k=!1;try{const{stat:L,symbolicLink:v}=await S.SymlinkSupport.stat(c);k=L.isDirectory()&&!v}catch{}if(k)await S.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.fb(c)}}async rename(d,u,c){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"move",c.overwrite),await S.Promises.rename(h,k)}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,l.localize)(2,null,(0,M.$nc)(h),(0,M.$nc)((0,M.$mc)(k)),L.toString()))),this.fb(L)}}async copy(d,u,c){const h=this.H(d),k=this.H(u);if(h!==k)try{await this.bb(d,u,"copy",c.overwrite),await S.Promises.copy(h,k,{preserveSymlinks:!0})}catch(L){throw(L.code==="EINVAL"||L.code==="EBUSY"||L.code==="ENAMETOOLONG")&&(L=new Error((0,l.localize)(3,null,(0,M.$nc)(h),(0,M.$nc)((0,M.$mc)(k)),L.toString()))),this.fb(L)}}async bb(d,u,c,h){const k=this.H(d),L=this.H(u);let v=!1;if(!!(this.capabilities&1024)||(v=(0,$.$3f)(k,L,!0)),v){if(c==="copy")throw(0,f.$yk)((0,l.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const E=await this.L(d);if(!E)throw(0,f.$yk)((0,l.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const A=await this.L(u);if(A){if(!h)throw(0,f.$yk)((0,l.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);E.type&f.FileType.File&&A.type&f.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,u){return this.cb(d,u,!1)}async cb(d,u,c){const h=this.H(d),k=this.H(u),L=!!(this.capabilities&1024);if((0,$.$3f)(h,k,!L))return;const v=new y.$Rc;try{v.add(await this.O(d)),v.add(await this.O(u)),c&&await S.Promises.mkdir((0,M.$mc)(k),{recursive:!0}),await S.Promises.copyFile(h,k)}catch(b){if(b.code==="ENOENT"&&!c)return this.cb(d,u,!0);throw this.fb(b)}finally{v.dispose()}}t(d,u,c){return new o.$eq(h=>d(h),h=>u(h),c)}F(d,u,c){return new a.$mq(h=>d(h),h=>u(h),c)}fb(d){if(d instanceof f.$xk)return d;let u=d,c;switch(d.code){case"ENOENT":c=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=f.FileSystemProviderErrorCode.Unknown;break;default:c=f.FileSystemProviderErrorCode.Unknown}return(0,f.$yk)(u,c)}async gb(d,u){let c=this.fb(u);if(d&&c.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(d));h.mode&128||(c=(0,f.$yk)(u,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$nq=t}),define(ke[251],Se([1,0,3,14]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=void 0;class g extends D.$Sc{constructor(R,p=[]){super(),this.a=new T.$tj([R,...p]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...p){this.a.trace(R,...p)}debug(R,...p){this.a.debug(R,...p)}info(R,...p){this.a.info(R,...p)}warn(R,...p){this.a.warn(R,...p)}error(R,...p){this.a.error(R,...p)}flush(){this.a.flush()}}e.$bO=g}),define(ke[252],Se([1,0,32,14]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3N=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,M,C,m,w){try{const S=await new Promise((f,s)=>{me(["@vscode/spdlog"],f,s)});S.setFlushOn(g.Trace);const l=await S.createAsyncRotatingLogger(y,M,C,m);return w?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(S){console.error(S)}return null}function R(y,M,C){switch(M){case T.LogLevel.Trace:y.trace(C);break;case T.LogLevel.Debug:y.debug(C);break;case T.LogLevel.Info:y.info(C);break;case T.LogLevel.Warning:y.warn(C);break;case T.LogLevel.Error:y.error(C);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function p(y,M){switch(M){case T.LogLevel.Trace:y.setLevel(g.Trace);break;case T.LogLevel.Debug:y.setLevel(g.Debug);break;case T.LogLevel.Info:y.setLevel(g.Info);break;case T.LogLevel.Warning:y.setLevel(g.Warning);break;case T.LogLevel.Error:y.setLevel(g.Error);break;case T.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${M}`)}}class $ extends T.$pj{constructor(M,C,m,w,S){super(),this.m=[],this.setLevel(S),this.n=this.s(M,C,m,w),this.B(this.onDidChangeLogLevel(l=>{this.r&&p(this.r,l)}))}async s(M,C,m,w){const S=m?6:1,l=30/S*D.$Tk.MB,f=await I(M,C,l,S,w);if(f){this.r=f,p(this.r,this.getLevel());for(const{level:s,message:i}of this.m)R(this.r,s,i);this.m=[]}}g(M,C){this.r?R(this.r,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3N=$}),define(ke[135],Se([1,0,39,206,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function y(S,l){return l-S}$.compare=y;const M=Object.create(null);M[$.Error]=(0,T.localize)(0,null),M[$.Warning]=(0,T.localize)(1,null),M[$.Info]=(0,T.localize)(2,null);function C(S){return M[S]||""}$.toString=C;function m(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function w(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=w}(R||(e.MarkerSeverity=R={}));var p;(function($){const y="";function M(m){return C(m,!0)}$.makeKey=M;function C(m,w){const S=[y];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(y),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(y),m.severity!==void 0&&m.severity!==null?S.push(R.toString(m.severity)):S.push(y),m.message&&w?S.push(m.message.replace("\xA6","\\\xA6")):S.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(y),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(y),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}$.makeKeyOptionalMessage=C})(p||(e.IMarkerData=p={})),e.$mt=(0,g.$2h)("markerService")}),define(ke[253],Se([1,0,4,39,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$bv=e.Severity=void 0,e.Severity=T.default,e.$bv=(0,g.$2h)("notificationService");var I;(function(M){M[M.DEFAULT=0]="DEFAULT",M[M.SILENT=1]="SILENT",M[M.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var R;(function(M){M[M.WORKSPACE=0]="WORKSPACE",M[M.PROFILE=1]="PROFILE",M[M.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var p;(function(M){M[M.OFF=0]="OFF",M[M.SILENT=1]="SILENT",M[M.ERROR=2]="ERROR"})(p||(e.NotificationsFilter=p={}));class ${constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$cv=$;class y{infinite(){}done(){}total(C){}worked(C){}}e.$dv=y}),define(ke[254],Se([1,0,50]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)T=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:I.version})}}else T={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","registerIssueDataProvider","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","readonlyMessage","treeViewMarkdownMessage","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatVariables","chatAgents2","chatAgents2Additions","defaultChatAgent","readonlyMessage","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","scmInputBoxValueProvider","contribSourceControlInputBoxMenu"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.85.0",sha256:"85a97d373a6f92359f5db7bfc5a2fa6c5763b22c6ad07c962dfe32c84a079f3b",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.8",sha256:"ca30069e21fbf576b49638ff8ff7c316b028c2faca924c23526737c65b8762bf",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.85.2",commit:"8b3775030ed1a69b13e4f4c628c612102e30a681",date:"2024-01-18T05:57:14.040Z"},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ke[136],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,D.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(D,T){e(D,T,me)}};define(ke[85],Se([1,0,12,21,3,5]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.ProgressLocation=e.$ev=void 0,e.$ev=(0,I.$2h)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$fv=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$gv=p;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const w=this.d;this.d=()=>{w?.(),m()}}):Promise.resolve()}}e.$hv=$;let y=class extends g.$Sc{constructor(m,w){super(),this.a=new D.$mh,w.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Qc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$iv=y,e.$iv=y=Je([We(1,e.$ev)],y);class M extends g.$Sc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Rc)}start(m){this.stop();const w=++this.a,S=new T.$3d;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Qc)(()=>S.cancel())),this.b.add((0,g.$Qc)(()=>this.c?this.c.done():void 0)),{id:w,token:S.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$jv=M,e.$kv=(0,I.$2h)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tn=void 0;class g{constructor(){this.a=new Map}add(R,p){D.ok(T.$Ef(R)),D.ok(T.$Gf(p)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,p)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$tn=new g}),define(ke[108],Se([1,0,4,37]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0,e.$un={JSONContribution:"base.contributions.json"};function g(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class I{constructor(){this.b=new D.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new I;T.$tn.add(e.$un.JSONContribution,R)}),define(ke[86],Se([1,0,19,4,18,196,45,108,37]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.ConfigurationScope=e.$yn=e.EditPresentationTypes=void 0;var y;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$yn={Configuration:"base.contributions.configuration"};var M;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn="vscode://schemas/settings/resourceLanguage",e.$Gn="vscode://schemas/settings/configurationDefaults";const C=$.$tn.as(p.$un.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.$Sd,this.onDidSchemaChange=this.i.event,this.j=new T.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Fn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const d=new Set;this.n(t,r,d),C.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const d=new Set;this.o(r,d),this.n(t,!1,d),C.registerSchema(e.$Fn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const d=[];for(const{overrides:u,source:c}of t)for(const h in u)if(r.add(h),e.$In.test(h)){const k=this.a.get(h),L=k?.valuesSources??new Map;if(c)for(const A of Object.keys(u[h]))L.set(A,c);const v={...k?.value||{},...u[h]};this.a.set(h,{source:c,value:v,valuesSources:L});const b=(0,R.$Fi)(h),E={type:"object",default:v,description:I.localize(1,null,b),$ref:e.$Fn,defaultDefaultValue:v,source:g.$Ef(c)?void 0:c,defaultValueSource:c};d.push(...l(h)),this.d[h]=E,this.b.properties[h]=E}else{this.a.set(h,{value:u[h],source:c});const k=this.d[h];k&&(this.w(h,k),this.r(h,k))}this.m(d)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:d,source:u}of t)for(const c in d){const h=this.a.get(c),k=g.$Ef(u)?u:u?.id,L=g.$Ef(h?.source)?h?.source:h?.source?.id;if(k===L)if(r.add(c),this.a.delete(c),e.$In.test(c))delete this.d[c],delete this.b.properties[c];else{const v=this.d[c];v&&(this.w(c,v),this.r(c,v))}}this.u()}deltaConfiguration(t){let r=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,d){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,d),this.c.push(u),this.q(u)})}o(t,r){const d=u=>{if(u.properties)for(const c in u.properties){r.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,u.properties[c])}u.allOf?.forEach(c=>d(c))};for(const u of t){d(u);const c=this.c.indexOf(u);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,d,u,c=3,h){c=g.$Nf(t.scope)?c:t.scope;const k=t.properties;if(k)for(const v in k){const b=k[v];if(r&&n(v,b)){delete k[v];continue}if(b.source=d,b.defaultDefaultValue=k[v].default,this.w(v,b),e.$In.test(v)?b.scope=void 0:(b.scope=g.$Nf(b.scope)?c:b.scope,b.restricted=g.$Nf(b.restricted)?!!u?.includes(v):b.restricted),k[v].hasOwnProperty("included")&&!k[v].included){this.f[v]=k[v],delete k[v];continue}else this.d[v]=k[v],k[v].policy?.name&&this.e.set(k[v].policy.name,v);!k[v].deprecationMessage&&k[v].markdownDeprecationMessage&&(k[v].deprecationMessage=k[v].markdownDeprecationMessage),h.add(v)}const L=t.allOf;if(L)for(const v of L)this.p(v,r,d,u,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=d=>{const u=d.properties;if(u)for(const h in u)this.r(h,u[h]);d.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$zn.properties[t]=r,r.scope){case 1:e.$An.properties[t]=r;break;case 2:e.$Bn.properties[t]=r;break;case 6:e.$Cn.properties[t]=r;break;case 3:e.$Dn.properties[t]=r;break;case 4:e.$En.properties[t]=r;break;case 5:e.$En.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$zn.properties[t],r.scope){case 1:delete e.$An.properties[t];break;case 2:delete e.$Bn.properties[t];break;case 6:delete e.$Cn.properties[t];break;case 3:delete e.$Dn.properties[t];break;case 4:case 5:delete e.$En.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,d={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Fn};this.w(r,d),e.$zn.properties[r]=d,e.$An.properties[r]=d,e.$Bn.properties[r]=d,e.$Cn.properties[r]=d,e.$Dn.properties[r]=d,e.$En.properties[r]=d}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Fn};e.$zn.patternProperties[e.$Hn]=t,e.$An.patternProperties[e.$Hn]=t,e.$Bn.patternProperties[e.$Hn]=t,e.$Cn.patternProperties[e.$Hn]=t,e.$Dn.patternProperties[e.$Hn]=t,e.$En.patternProperties[e.$Hn]=t,this.i.fire()}w(t,r){const d=this.a.get(t);let u=d?.value,c=d?.source;g.$Lf(u)&&(u=r.defaultDefaultValue,c=void 0),g.$Lf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=c}}const w="\\[([^\\]]+)\\]",S=new RegExp(w,"g");e.$Hn=`^(${w})+$`,e.$In=new RegExp(e.$Hn);function l(a){const t=[];if(e.$In.test(a)){let r=S.exec(a);for(;r?.length;){const d=r[1].trim();d&&t.push(d),r=S.exec(a)}}return(0,D.$Mb)(t)}e.$Jn=l;function f(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Kn=f;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Ln=s;const i=new m;$.$tn.add(e.$yn.Configuration,i);function n(a,t){return a.trim()?e.$In.test(a)?I.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?I.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$Mn=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Nn=o}),define(ke[255],Se([1,0,19,4,159,3,28,24,18,2,45,86,37]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=void 0;function w(r){return Object.isFrozen(r)?r:p.$in(r)}class S{constructor(d={},u=[],c=[],h){this.b=d,this.c=u,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(u=>{if(u instanceof S)return u;const c=new l("");return c.parseRaw(u),c.configurationModel});this.f=d.reduce((u,c)=>c===u?c:u.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,M.$Di)(this.contents,d):this.contents}inspect(d,u){const c=this.rawConfiguration.getValue(d),h=u?this.rawConfiguration.getOverrideValue(d,u):void 0,k=u?this.rawConfiguration.override(u).getValue(d):c;return{value:c,override:h,merged:k}}getOverrideValue(d,u){const c=this.i(u);return c?d?(0,M.$Di)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const u=[];for(const c of this.overrides)c.identifiers.includes(d)&&u.push(...c.keys);return D.$Mb(u)}getAllOverrideIdentifiers(){const d=[];for(const u of this.overrides)d.push(...u.identifiers);return D.$Mb(d)}override(d){let u=this.a.get(d);return u||(u=this.g(d),this.a.set(d,u)),u}merge(...d){const u=p.$hn(this.contents),c=p.$hn(this.overrides),h=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const L of d)if(k.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(u,L.contents);for(const v of L.overrides){const[b]=c.filter(E=>D.$ub(E.identifiers,v.identifiers));b?(this.h(b.contents,v.contents),b.keys.push(...v.keys),b.keys=D.$Mb(b.keys)):c.push(p.$hn(v))}for(const v of L.keys)h.indexOf(v)===-1&&h.push(v)}return new S(u,h,c,k.every(L=>L instanceof S)?void 0:k)}g(d){const u=this.i(d);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const c={};for(const h of D.$Mb([...Object.keys(this.contents),...Object.keys(u)])){let k=this.contents[h];const L=u[h];L&&(typeof k=="object"&&typeof L=="object"?(k=p.$hn(k),this.h(k,L)):k=L),c[h]=k}return new S(c,this.keys,this.overrides)}h(d,u){for(const c of Object.keys(u)){if(c in d&&$.$Gf(d[c])&&$.$Gf(u[c])){this.h(d[c],u[c]);continue}d[c]=p.$hn(u[c])}}i(d){let u=null,c=null;const h=k=>{k&&(c?this.h(c,k):c=p.$hn(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===d?u=k.contents:k.identifiers.includes(d)&&h(k.contents);return h(u),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,u){this.j(d,u,!0)}setValue(d,u){this.j(d,u,!1)}removeValue(d){const u=this.keys.indexOf(d);u!==-1&&(this.keys.splice(u,1),(0,M.$Ci)(this.contents,d),C.$In.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>D.$ub(c.identifiers,(0,C.$Jn)(d))),1))}j(d,u,c){(0,M.$Bi)(this.contents,d,u,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),C.$In.test(d)&&this.overrides.push({identifiers:(0,C.$Jn)(d),keys:Object.keys(this.contents[d]),contents:(0,M.$Ai)(this.contents[d],h=>console.error(h))})}}e.$On=S;class l{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,u){if(!$.$Nf(d)){const c=this.g(d);this.parseRaw(c,u)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,u){this.a=d;const{contents:c,keys:h,overrides:k,restricted:L,hasExcludedProperties:v}=this.h(d,u);this.b=new S(c,h,k,v?[d]:void 0),this.c=L||[]}g(d){let u={},c=null,h=[];const k=[],L=[];function v(E){Array.isArray(h)?h.push(E):c!==null&&(h[c]=E)}const b={onObjectBegin:()=>{const E={};v(E),k.push(h),h=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{h=k.pop()},onArrayBegin:()=>{const E=[];v(E),k.push(h),h=E,c=null},onArrayEnd:()=>{h=k.pop()},onLiteralValue:v,onError:(E,A,z)=>{L.push({error:E,offset:A,length:z})}};if(d)try{g.$en(d,b),u=h[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return u}h(d,u){const c=m.$tn.as(C.$yn.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,u);d=h.raw;const k=(0,M.$Ai)(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),L=Object.keys(d),v=this.j(d,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:k,keys:L,overrides:v,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,u,c,h){let k=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:k};const L={},v=[];for(const b in d)if(C.$In.test(b)&&c){const E=this.i(d[b],u,!1,h);L[b]=E.raw,k=k||E.hasExcludedProperties,v.push(...E.restricted)}else{const E=u[b],A=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&v.push(b),!h.exclude?.includes(b)&&(h.include?.includes(b)||(A===void 0||h.scopes===void 0||h.scopes.includes(A))&&!(h.skipRestricted&&E?.restricted))?L[b]=d[b]:k=!0}return{raw:L,restricted:v,hasExcludedProperties:k}}j(d,u){const c=[];for(const h of Object.keys(d))if(C.$In.test(h)){const k={};for(const L in d[h])k[L]=d[h][L];c.push({identifiers:(0,C.$Jn)(h),keys:Object.keys(k),contents:(0,M.$Ai)(k,u)})}return c}}e.$Pn=l;class f extends I.$Sc{constructor(d,u,c,h){super(),this.c=d,this.f=u,this.g=h,this.b=this.B(new T.$Sd),this.onDidChange=this.b.event,this.a=new l(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&c.isEqual(k.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Qn=f;class s{constructor(d,u,c,h,k,L,v,b,E,A,z,O,P){this.a=d,this.b=u,this.c=c,this.overrideIdentifiers=h,this.d=k,this.f=L,this.g=v,this.h=b,this.i=E,this.j=A,this.k=z,this.l=O,this.m=P}get value(){return w(this.c)}n(d,u,c){const h=d.inspect(u,c);return{get value(){return w(h.value)},get override(){return w(h.override)},get merged(){return w(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,u,c,h,k=new S,L=new S,v=new R.$Ac,b=new S,E=new R.$Ac){this.c=d,this.d=u,this.f=c,this.g=h,this.h=k,this.i=L,this.j=v,this.l=b,this.m=E,this.a=null,this.b=new R.$Ac,this.n=null}getValue(d,u,c){return this.p(d,u,c).getValue(d)}updateValue(d,u,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new S,this.m.set(c.resource,h))):h=this.l,u===void 0?h.removeValue(d):h.setValue(d,u),c.resource||(this.a=null)}inspect(d,u,c){const h=this.p(d,u,c),k=this.t(u.resource,c),L=u.resource?this.m.get(u.resource)||this.l:this.l,v=new Set;for(const b of h.overrides)for(const E of b.identifiers)h.getOverrideValue(d,E)!==void 0&&v.add(E);return new s(d,u,h.getValue(d),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,k||void 0,L)}keys(d){const u=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,u){this.j.set(d,u),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,u){const c=[];if(!u){const{added:h,updated:k,removed:L}=a(this.c,d);u=[...h,...k,...L]}for(const h of u)for(const k of(0,C.$Jn)(h)){const L=this.c.getKeysForOverrideIdentifier(k),v=d.getKeysForOverrideIdentifier(k),b=[...v.filter(E=>L.indexOf(E)===-1),...L.filter(E=>v.indexOf(E)===-1),...L.filter(E=>!p.$ln(this.c.override(k).getValue(E),d.override(k).getValue(E)))];c.push([k,b])}return this.updateDefaultConfiguration(d),{keys:u,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:u,updated:c,removed:h}=a(this.d,d),k=[...u,...c,...h];return k.length&&this.updatePolicyConfiguration(d),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:u,updated:c,removed:h,overrides:k}=a(this.applicationConfiguration,d),L=[...u,...c,...h];return L.length&&this.updateApplicationConfiguration(d),{keys:L,overrides:k}}compareAndUpdateLocalUserConfiguration(d){const{added:u,updated:c,removed:h,overrides:k}=a(this.localUserConfiguration,d),L=[...u,...c,...h];return L.length&&this.updateLocalUserConfiguration(d),{keys:L,overrides:k}}compareAndUpdateRemoteUserConfiguration(d){const{added:u,updated:c,removed:h,overrides:k}=a(this.remoteUserConfiguration,d),L=[...u,...c,...h];return L.length&&this.updateRemoteUserConfiguration(d),{keys:L,overrides:k}}compareAndUpdateWorkspaceConfiguration(d){const{added:u,updated:c,removed:h,overrides:k}=a(this.workspaceConfiguration,d),L=[...u,...c,...h];return L.length&&this.updateWorkspaceConfiguration(d),{keys:L,overrides:k}}compareAndUpdateFolderConfiguration(d,u){const c=this.folderConfigurations.get(d),{added:h,updated:k,removed:L,overrides:v}=a(c,u),b=[...h,...k,...L];return(b.length||!c)&&this.updateFolderConfiguration(d,u),{keys:b,overrides:v}}compareAndDeleteFolderConfiguration(d){const u=this.folderConfigurations.get(d);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:k,overrides:L}=a(u,void 0);return{keys:[...c,...h,...k],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,u,c){let h=this.q(u,c);return u.overrideIdentifier&&(h=h.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},u){let c=this.r();if(u&&d){const h=u.getFolder(d);h&&(c=this.s(h.uri)||c);const k=this.m.get(d);k&&(c=c.merge(k))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let u=this.b.get(d);if(!u){const c=this.r(),h=this.j.get(d);h?(u=c.merge(h),this.b.set(d,u)):u=c}return u}t(d,u){if(u&&d){const c=u.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,u)=>{const{contents:c,overrides:h,keys:k}=this.j.get(u);return d.push([u,{contents:c,overrides:h,keys:k}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(u=>d.add(u)),this.userConfiguration.keys.forEach(u=>d.add(u)),this.i.keys.forEach(u=>d.add(u)),this.j.forEach(u=>u.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>d.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const u=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>u.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>u.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>u.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>u.add(h))),[...u.values()]}static parse(d){const u=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),k=this.w(d.user),L=this.w(d.workspace),v=d.folders.reduce((b,E)=>(b.set(y.URI.revive(E[0]),this.w(E[1])),b),new R.$Ac);return new i(u,c,h,k,new S,L,v,new S,new R.$Ac)}static w(d){return new S(d.contents,d.keys,d.overrides)}}e.$Rn=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const d=new Set,u=new Map;for(const h of r)h.keys.forEach(k=>d.add(k)),h.overrides.forEach(([k,L])=>{const v=(0,R.$xc)(u,k,new Set);L.forEach(b=>v.add(b))});const c=[];return u.forEach((h,k)=>c.push([k,[...h.values()]])),{keys:[...d.values()],overrides:c}}e.$Sn=n;class o{constructor(d,u,c,h){this.change=d,this.f=u,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of d.keys)this.affectedKeys.add(k);for(const[,k]of d.overrides)for(const L of k)this.affectedKeys.add(L);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,u){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const k=h+c.length;if(k>=this.d.length)return!1;const L=this.d.charCodeAt(k);if(L!==this.b&&L!==this.c)return!1;if(u){const v=this.previousConfiguration?this.previousConfiguration.getValue(d,u,this.f?.workspace):void 0,b=this.g.getValue(d,u,this.h);return!p.$ln(v,b)}return!0}}e.$Tn=o;function a(r,d){const{added:u,removed:c,updated:h}=t(d?.rawConfiguration,r?.rawConfiguration),k=[],L=r?.getAllOverrideIdentifiers()||[],v=d?.getAllOverrideIdentifiers()||[];if(d){const b=v.filter(E=>!L.includes(E));for(const E of b)k.push([E,d.getKeysForOverrideIdentifier(E)])}if(r){const b=L.filter(E=>!v.includes(E));for(const E of b)k.push([E,r.getKeysForOverrideIdentifier(E)])}if(d&&r){for(const b of L)if(v.includes(b)){const E=t({contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)},{contents:d.getOverrideValue(void 0,b)||{},keys:d.getKeysForOverrideIdentifier(b)});k.push([b,[...E.added,...E.removed,...E.updated]])}}return{added:u,removed:c,updated:h,overrides:k}}function t(r,d){const u=r?d?r.keys.filter(k=>d.keys.indexOf(k)===-1):[...r.keys]:[],c=d?r?d.keys.filter(k=>r.keys.indexOf(k)===-1):[...d.keys]:[],h=[];if(r&&d){for(const k of d.keys)if(r.keys.indexOf(k)!==-1){const L=(0,M.$Di)(d.contents,k),v=(0,M.$Di)(r.contents,k);p.$ln(L,v)||h.push(k)}}return{added:u,removed:c,updated:h}}}),define(ke[256],Se([1,0,22,4,3,82]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$crb=e.$brb=e.$arb=e.$_qb=void 0;const R=(y,M,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const w=(0,D.$Ae)(D.$ge.wrap(m));return[`GET ws://localhost${y}?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${w}`].join(`\r
`)+`\r
\r
`};e.$_qb=R,e.$arb=D.$ge.fromString(`\r
\r
`);async function p(y,M,C,m,w){y.write(D.$ge.fromString((0,e.$_qb)(M,C,m)));const S=new g.$Rc;try{return await new Promise((l,f)=>{let s;S.add(y.onData(i=>{s?s=D.$ge.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$arb);if(n===-1)return;l(y),y.pauseData();const o=s.slice(n+e.$arb.byteLength);o.byteLength&&w.onData.fire(o)})),S.add(y.onClose(i=>f(i??new Error("socket closed")))),S.add(y.onEnd(()=>f(new Error("socket ended"))))})}catch(l){throw y.dispose(),l}finally{S.dispose()}}e.$brb=p;class $ extends g.$Sc{constructor(M,C){super(),this.g=M,this.a=this.B(new T.$Vd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new T.$Sd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(M,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,M,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$crb=$}),define(ke[64],Se([1,0,8,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.RemoteAuthorityResolverErrorCode=e.$5k=e.$4k=e.RemoteConnectionType=e.$3k=void 0,e.$3k=(0,T.$2h)("remoteAuthorityResolverService");var g;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$4k=I;class R{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$5k=R;var p;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class $ extends D.$bb{static isNotAvailable(C){return C instanceof $&&C._code===p.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===p.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===p.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===p.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=p.Unknown,w){super(C),this._message=C,this._code=m,this._detail=w,this.isHandled=m===p.NotAvailable&&w===!0,Object.setPrototypeOf(this,$.prototype)}}e.$6k=$;function y(M){const C=M.indexOf("+");return C===-1?M:M.substring(0,C)}e.$7k=y}),define(ke[65],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0;function T(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$8k=T;function g(y){if(!y)return;const M=y.indexOf("+");return M<0?y:y.substr(0,M)}e.$9k=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$0k=I;function R(y){const{host:M,port:C}=$(y);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:M,port:C}}e.$$k=R;function p(y,M){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=M),{host:C,port:m}}e.$_k=p;function $(y){const M=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(M)return{host:M[1],port:parseInt(M[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(ke[26],Se([1,0,13,5,65]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.TargetPlatform=e.ExtensionType=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=void 0,e.$am="extensions.user.cache",e.$bm="extensions.builtin.cache",e.$cm="undefined_publisher",e.$dm=["ui","workspace","web"];function I(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$em=I,e.$fm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var p;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class ${constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,s){if(typeof f>"u"||f===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof f=="string"||typeof s=="string"){const i=typeof f=="string"?f:f.value,n=typeof s=="string"?s:s.value;return D.$8e(i,n)}return f._lower===s._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$gm=$;class y{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const s of f)this.add(s)}add(f){this.c.add($.toKey(f))}delete(f){return this.c.delete($.toKey(f))}has(f){return this.c.has($.toKey(f))}}e.$hm=y;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete($.toKey(f))}get(f){return this.c.get($.toKey(f))}has(f){return this.c.has($.toKey(f))}set(f,s){this.c.set($.toKey(f),s)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$im=M;function C(l){return m(l)}e.$jm=C;function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.$km=m;function w(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.$lm=w;function S(l,f){if(f){const s=`onResolveRemoteAuthority:${(0,g.$9k)(f)}`;return!!l.activationEvents?.includes(s)}return!1}e.$mm=S,e.$nm=(0,T.$2h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,8,26]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2E=e.$1E=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(R,p){this.a.set(R,p)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const p=Object.create(null);for(const $ of R){const y=this.readActivationEvents($);y.length>0&&(p[T.$gm.toKey($.identifier)]=y)}return p}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const p=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<p.length;$++)p[$]==="onUri"&&(p[$]=`onUri:${T.$gm.toKey(R.identifier)}`);if(!R.contributes)return p;for(const $ in R.contributes){const y=this.a.get($);if(!y)continue;const M=R.contributes[$],C=Array.isArray(M)?M:[M];try{y(C,p)}catch(m){(0,D.$1)(m)}}return p}}e.$1E=g,e.$2E=new g}),define(ke[257],Se([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.PersistentConnectionEventType=e.$gl=e.$fl=e.$el=e.ConnectionType=void 0;const S=30*1e3;var l;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function f(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(K){const B=new g.$3d;return setTimeout(()=>B.cancel(),K),B.token}function i(K,B){if(K.isCancellationRequested||B.isCancellationRequested)return g.CancellationToken.Cancelled;const ne=new g.$3d;return K.onCancellationRequested(()=>ne.cancel()),B.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new p.$Rc,this.promise=new Promise((ne,ye)=>{this.f=ne,this.g=ye}),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function o(K,B){const ne=new n(B);return ne.registerDisposable(K.onControlMessage(ye=>{const he=JSON.parse(ye.toString()),ge=Y(he);ge?ne.reject(ge):ne.resolve(he)})),ne.promise}function a(K,B,ne,ye,he,ge,_,ie){const G=new n(ie),te=y.$Od.create(!1);return K.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${ge}`),B.connect(ne,ye,he,_).then(fe=>{G.didTimeout?($.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),fe?.dispose()):($.mark(`code/didCreateSocketOK/${ge}`),K.info(`Creating a socket (${_}) was successful after ${te.elapsed()} ms.`),G.resolve(fe))},fe=>{$.mark(`code/didCreateSocketError/${ge}`),K.info(`Creating a socket (${_}) returned an error after ${te.elapsed()} ms.`),K.error(fe),G.reject(fe)}),G.promise}function t(K,B){const ne=new n(B);return K.then(ye=>{ne.didTimeout||ne.resolve(ye)},ye=>{ne.didTimeout||ne.reject(ye)}),ne.promise}async function r(K,B,ne,ye){const he=we(K,B);K.logService.trace(`${he} 1/6. invoking socketFactory.connect().`);let ge;try{ge=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,w.$0k)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,f(B),`renderer-${f(B)}-${K.reconnectionToken}`,ye)}catch(fe){throw K.logService.error(`${he} socketFactory.connect() failed or timed out. Error:`),K.logService.error(fe),fe}K.logService.trace(`${he} 2/6. socketFactory.connect() was successful.`);let _,ie;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(ge,null),_=K.reconnectionProtocol,ie=!1):(_=new C.$Ph({socket:ge}),ie=!0),K.logService.trace(`${he} 3/6. sending AuthRequest control message.`);const G=await t(K.signService.createNewMessage((0,M.$mg)()),ye),te={type:"auth",auth:K.connectionToken||"00000000000000000000",data:G.data};_.sendControl(T.$ge.fromString(JSON.stringify(te)));try{const fe=await o(_,i(ye,s(1e4)));if(fe.type!=="sign"||typeof fe.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(K.logService.trace(`${he} 4/6. received SignRequest control message.`),!await t(K.signService.validate(G,fe.signedData),ye)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Ae=await t(K.signService.sign(fe.data),ye),pe={type:"connectionType",commit:K.commit,signedData:Ae,desiredConnectionType:B};return ne&&(pe.args=ne),K.logService.trace(`${he} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(T.$ge.fromString(JSON.stringify(pe))),{protocol:_,ownsProtocol:ie}}catch(fe){throw fe&&fe.code==="ETIMEDOUT"&&(K.logService.error(`${he} the handshake timed out. Error:`),K.logService.error(fe)),fe&&fe.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${he} received error control message when negotiating connection. Error:`),K.logService.error(fe)),ie&&J(_),fe}}async function d(K,B,ne,ye){const he=Date.now(),ge=we(K,B),{protocol:_,ownsProtocol:ie}=await r(K,B,ne,ye),G=new n(ye);return G.registerDisposable(_.onControlMessage(te=>{const fe=JSON.parse(te.toString()),ve=Y(fe);ve?(K.logService.error(`${ge} received error control message when negotiating connection. Error:`),K.logService.error(ve),ie&&J(_),G.reject(ve)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${ge} 6/6. handshake finished, connection is up and running after ${de(he)}!`),G.resolve({protocol:_,firstMessage:fe}))})),G.promise}async function u(K,B){const{protocol:ne}=await d(K,1,void 0,B);return{protocol:ne}}async function c(K,B,ne){const{protocol:ye,firstMessage:he}=await d(K,2,B,ne),ge=he&&he.debugPort;return{protocol:ye,debugPort:ge}}async function h(K,B,ne){const ye=Date.now(),he=we(K,3),{protocol:ge}=await r(K,3,B,ne);return K.logService.trace(`${he} 6/6. handshake finished, connection is up and running after ${de(ye)}!`),ge}async function k(K,B,ne){const{connectTo:ye,connectionToken:he}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:he,reconnectionToken:B,reconnectionProtocol:ne,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function L(K,B,ne){return b(K,async ye=>{const{protocol:he}=await u(ye,g.CancellationToken.None);return new x(K,B,ne,ye.reconnectionToken,he)})}e.$el=L;async function v(K,B){return b(K,async ne=>{const{protocol:ye,debugPort:he}=await c(ne,B,g.CancellationToken.None);return new ce(K,B,ne.reconnectionToken,ye,he)})}e.$fl=v;async function b(K,B){for(let ye=1;;ye++)try{const he=(0,M.$mg)(),ge=await k(K,he,null);return await B(ge)}catch(he){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(he);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(he),W.triggerPermanentFailure(0,0,m.$6k.isHandled(he)),he}}async function E(K,B,ne){const ye=await k(K,(0,M.$mg)(),null);return await h(ye,{host:B,port:ne},g.CancellationToken.None)}e.$gl=E;function A(K){return(0,D.$Pg)(B=>new Promise((ne,ye)=>{const he=setTimeout(ne,K*1e3);B.onCancellationRequested(()=>{clearTimeout(he),ne()})}))}var z;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class O{constructor(B,ne){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.type=0}}e.$hl=O;class P{constructor(B,ne,ye,he){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.durationSeconds=ye,this.c=he,this.type=1}skipWait(){this.c.cancel()}}e.$il=P;class j{constructor(B,ne,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=2}}e.$jl=j;class N{constructor(B,ne,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=4}}e.$kl=N;class F{constructor(B,ne,ye,he){this.reconnectionToken=B,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.handled=he,this.type=3}}e.$ll=F;class W extends p.$Sc{static triggerPermanentFailure(B,ne,ye){this._permanentFailure=!0,this.f=B,this.g=ne,this.h=ye,this.j.forEach(he=>he.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(B,ne,ye,he,ge){super(),this.t=B,this.u=ne,this.reconnectionToken=ye,this.protocol=he,this.w=ge,this.m=this.B(new R.$Sd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(he.onSocketClose(_=>{const ie=Z(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(he.onSocketTimeout(_=>{const ie=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,p.$Qc)(()=>{const _=W.j.indexOf(this);_>=0&&W.j.splice(_,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=Z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const he=ye<ne.length?ne[ye]:ne[ne.length-1];try{if(he>0){const _=A(he);this.m.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),he,_)),this.u.logService.info(`${B} waiting for ${he} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${B} resolving connection...`);const ge=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ge.connectTo}...`),await this.G(ge,s(S)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(ge){if(ge.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$6k.isTemporarilyNotAvailable(ge)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((ge.code==="ETIMEDOUT"||ge.code==="ENETUNREACH"||ge.code==="ECONNREFUSED"||ge.code==="ECONNRESET")&&ge.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if((0,I.$4)(ge)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ge);continue}if(ge instanceof m.$6k){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$6k.isHandled(ge));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ge),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(B,ne,ye){this.w?W.triggerPermanentFailure(B,ne,ye):this.D(B,ne,ye)}D(B,ne,ye){this.m.fire(new F(this.reconnectionToken,B,ne,ye)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$ml=W;class x extends W{constructor(B,ne,ye,he,ge){super(1,B,he,ge,!0),this.client=this.B(new C.$Nh(ge,{remoteAuthority:ne,clientId:ye},B.ipcLogger))}async G(B,ne){await u(B,ne)}}e.$nl=x;class ce extends W{constructor(B,ne,ye,he,ge){super(2,B,ye,he,!1),this.H=ne,this.debugPort=ge}async G(B,ne){await c(B,this.H,ne)}}e.$ol=ce;function J(K){try{K.acceptDisconnect();const B=K.getSocket();K.dispose(),B.dispose()}catch(B){(0,I.$1)(B)}}function Y(K){if(K&&K.type==="error"){const B=new Error(`Connection error: ${K.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function X(K,B){for(;K.length<B;)K+=" ";return K}function se(K,B){return`[remote-connection][${X(f(K),13)}][${B.substr(0,5)}\u2026]`}function Z(K,B,ne){return`${se(K,B)}[${ne?"reconnect":"initial"}]`}function we(K,B){return`${Z(B,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function de(K){return`${Date.now()-K} ms`}}),define(ke[258],Se([1,0,3,5]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=void 0,e.$al=(0,T.$2h)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(R,p){return this.a[R]??=[],this.a[R].push(p),(0,D.$Qc)(()=>{const $=this.a[R]?.indexOf(p);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,p,$,y){const M=this.b(R);if(!M)throw new Error(`No socket factory found for ${R}`);return M.connect(R,p,$,y)}}e.$bl=g}),define(ke[259],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const R=String(D.a++);return this.b.set(R,I),{id:R,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const R=this.b.get(g.id);if(!R)return!1;this.b.delete(g.id);try{return R.validate(I)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$e6b=D}),define(ke[109],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=void 0,e.$cl="signService",e.$dl=(0,D.$2h)(e.$cl)}),define(ke[138],Se([1,0,259]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0b=void 0;class T extends D.$e6b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(R=>new R.signer().sign(I))}h(){return new Promise((I,R)=>me(["vsda"],I,R))}}e.$_0b=T}),define(ke[260],Se([1,0,11,50,30]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,y,M,C,m,w,S,l,f){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=S,s.sessionID=(0,g.$mg)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$u),s["common.nodePlatform"]=T.$dc,s["common.nodeArch"]=M,s["common.product"]=f||"desktop",l&&(s["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const o=I(y);return o&&(s["common.platformDetail"]=o),s}e.$uo=R;function p($){const y=T.env.USERDNSDOMAIN;if(!y)return!1;const M=y.toLowerCase();return $.some(C=>M===C)}e.$vo=p}),define(ke[261],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=void 0,e.$pl=(0,D.$2h)("telemetryService"),e.$ql=(0,D.$2h)("customEndpointTelemetryService"),e.$rl="telemetry.currentSessionDate",e.$sl="telemetry.firstSessionDate",e.$tl="telemetry.lastSessionDate",e.$ul="telemetry.machineId",e.$vl="telemetry.sqmId",e.$wl="telemetry",e.$xl="telemetry.telemetryLevel",e.$yl="telemetry.enableCrashReporter",e.$zl="telemetry.enableTelemetry";var T;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(ke[87],Se([1,0,24,18,4,45,65,260,261]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;class y{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$wo=y;class M{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xo=M,e.$yo=new M;class C{async publicLog(c,h,k){}async publicLogError(c,h,k){}}e.$zo=C,e.$Ao="telemetry",e.$Bo="extensionTelemetryLog",e.$Co={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,c){return g.Event.debounce(c.onDidChangeConfiguration,(k,L)=>{const v=k?new Set([...k.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:v}},1e3,!0)(k=>{k.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,I.$yi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$Do=m;function w(u,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!u.enableTelemetry)}e.$Eo=w;function S(u,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$Fo=S;function l(u){const c=u.getValue($.$xl),h=u.getValue($.$yl);if(u.getValue($.$zl)===!1||h===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Go=l;function f(u){const c={},h={},k={};n(u,k);for(let L in k){L=L.length>150?L.substr(L.length-149):L;const v=k[L];typeof v=="number"?h[L]=v:typeof v=="boolean"?h[L]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${v.length}`),c[L]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(c[L]=v)}return{properties:c,measurements:h}}e.$Ho=f;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const c=(0,R.$9k)(u);return s.has(c)?c:"other"}e.$Io=i;function n(u,c,h=0,k){if(u)for(const L of Object.getOwnPropertyNames(u)){const v=u[L],b=k?k+L:L;Array.isArray(v)?c[b]=(0,D.$mn)(v):v instanceof Date?c[b]=v.toISOString():(0,T.$Gf)(v)?h<2?n(v,c,h+1,b+"."):c[b]=(0,D.$mn)(v):c[b]=v}}function o(u,c){const h=u.msftInternalDomains||[],k=c.getValue("telemetry.internalTesting");return(0,p.$vo)(h)||k}e.$Jo=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Ko=a;function t(u,c){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let h=u;const k=[];for(const E of c)for(;;){const A=E.exec(u);if(!A)break;k.push([A.index,E.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(h="";;){const E=v.exec(u);if(!E)break;const A=k.some(([z,O])=>E.index<O&&z<v.lastIndex);!L.test(E[0])&&!A&&(h+=u.substring(b,E.index)+"<REDACTED: user-file-path>",b=v.lastIndex)}return b<u.length&&(h+=u.substr(b)),h}function r(u){if(!u)return u;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return u}function d(u,c){return(0,D.$jn)(u,h=>{if(h instanceof y||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let k=h.replaceAll("%20"," ");k=t(k,c);for(const L of c)k=k.replace(L,"");return k=r(k),k}})}e.$Lo=d}),define(ke[262],Se([1,0,13,134,26,11,2,8,50,87]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=void 0;function M(d,u){return d.uuid&&u.uuid?d.uuid===u.uuid:d.id===u.id?!0:(0,D.$3e)(d.id,u.id)===0}e.$Mo=M;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(u){const c=u.manifest?u.manifest.version:u.version,h=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new m(u.identifier,c,h)}static parse(u){const c=C.exec(u);return c&&c[1]&&c[2]?new m({id:c[1]},c[2],c[4]||void 0):null}constructor(u,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof m?M(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$No=m;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const u=w.exec(d);return u&&u[1]?[f(u[1]),u[2]]:[f(d),void 0]}e.$Oo=S;function l(d,u){return`${d}.${u}`}e.$Po=l;function f(d){return d.toLowerCase()}e.$Qo=f;function s(d,u){return f(l(d??g.$cm,u))}e.$Ro=s;function i(d,u){const c=[],h=k=>{for(const L of c)if(L.some(v=>M(u(v),u(k))))return L;return null};for(const k of d){const L=h(k);L?L.push(k):c.push([k])}return c}e.$So=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$To=n;function o(d){return{id:new y.$wo(d.identifier.id),name:new y.$wo(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Uo=o,e.$Vo=new g.$gm("pprice.better-merge");function a(d,u){const c=[],h=u.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const k=h.shift();if(k&&c.every(L=>!M(L.identifier,{id:k}))){const L=d.filter(v=>M(v.identifier,{id:k}));L.length===1&&(c.push(L[0]),h.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$Wo=a;async function t(d,u){if(!I.$k)return!1;let c;try{c=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){u.debug("Error while getting the os-release file.",(0,p.$0)(k))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(d,u){const c=await t(d,u),h=(0,T.$go)(c?"alpine":I.$u,$.$ec);return u.debug("ComputeTargetPlatform:",h),h}e.$Xo=r}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=e.$xr=void 0;function D($){return[...$.entries()]}e.$xr=D;function T($){return $?[...$.entries()]:[]}e.$yr=T;function g($){return new Map($)}e.$zr=g;function I($){return new Map($??[])}e.$Ar=I;function R($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),T(y[1].descriptionMap)])}e.$Br=R;function p($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$Cr=p}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,R=5){const p=I($=>{const y=typeof $=="string"?$:$.data;let M=this.a.get(g);if(M){M.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),R);M={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),p.dispose()}},this.a.set(g,M)});return p}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$trb=D}),define(ke[265],Se([1,0,12,78,61,4,18,2,207,108,37]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.IconFontDefinition=e.IconContribution=e.$hw=void 0,e.$hw={IconContribution:"base.contributions.icons"};var C;(function(o){function a(t,r){let d=t.defaults;for(;g.ThemeIcon.isThemeIcon(d);){const u=S.getIcon(d.id);if(!u)return;d=u.defaults}return d}o.getDefinition=a})(C||(e.IconContribution=C={}));var m;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(d=>({format:d.format,location:d.location.toString()}))}}o.toJSONObject=a;function t(r){const d=u=>(0,R.$Ef)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,R.$Ef)(u.format)&&(0,R.$Ef)(u.location)))return{weight:d(r.weight),style:d(r.style),src:r.src.map(u=>({format:u.format,location:p.URI.parse(u.location)}))}}o.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class w{constructor(){this.a=new I.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,d){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return u}const c={id:a,description:r,defaults:t,deprecationMessage:d};this.b[a]=c;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),r&&(h.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,c)=>u.id.localeCompare(c.id),t=u=>{for(;g.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(u=>this.b[u]);for(const u of d.filter(c=>!!c.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${g.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of d.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const S=new w;M.$tn.add(e.$hw.IconContribution,S);function l(o,a,t,r){return S.registerIcon(o,a,t,r)}e.$iw=l;function f(){return S}e.$jw=f;function s(){const o=(0,T.$6j)();for(const a in o){const t="\\"+o[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}s(),e.$kw="vscode://schemas/icons";const i=M.$tn.as(y.$un.JSONContribution);i.registerSchema(e.$kw,S.getIconSchema());const n=new D.$bh(()=>i.notifySchemaChanged(e.$kw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$lw=l("widget-close",T.$8j.close,(0,$.localize)(2,null)),e.$mw=l("goto-previous-location",T.$8j.arrowUp,(0,$.localize)(3,null)),e.$nw=l("goto-next-location",T.$8j.arrowDown,(0,$.localize)(4,null)),e.$ow=g.ThemeIcon.modify(T.$8j.sync,"spin"),e.$pw=g.ThemeIcon.modify(T.$8j.loading,"spin")}),define(ke[88],Se([1,0,4,45,5,14]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.ProvidedOnAutoForward=e.$nv=e.TunnelPrivacyId=e.TunnelProtocol=e.$mv=e.$lv=void 0,e.$lv=(0,g.$2h)("tunnelService"),e.$mv=(0,g.$2h)("sharedTunnelsService");var R;(function(f){f.Http="http",f.Https="https"})(R||(e.TunnelProtocol=R={}));var p;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(p||(e.TunnelPrivacyId=p={}));function $(f){return!!f.forwardPort}e.$nv=$;var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function M(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(s)return{address:s[1],port:+s[2]}}e.$ov=M,e.$pv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(f){return e.$pv.indexOf(f)>=0}e.$qv=C,e.$rv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$rv.indexOf(f)>=0}e.$sv=m;function w(f,s,i,n){if(i===1)return!1;if(i===2&&m(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return f<1024}e.$tv=w;class S{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new D.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$uv=S;let l=class{constructor(s,i){this.j=s,this.k=i,this.a=new D.$Sd,this.onTunnelOpened=this.a.event,this.b=new D.$Sd,this.onTunnelClosed=this.b.event,this.c=new D.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(m(s)||C(s))&&(s=e.$pv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(u,i,n,o,a,t,r,d);return c?c.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&h.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];C(s)?(n.push(...e.$pv),n.push(...e.$rv)):m(s)&&n.push(...e.$rv);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!M(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const d=n;this.i.add(d);const u=o===void 0?n:o,c={elevationRequired:a?this.isPortPrivileged(u):!1},h={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==p.Private:void 0,protocol:r},k=s.forwardPort(h,c);return k?(this.p(i,n,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),k}};e.$vv=l,e.$vv=l=Je([We(0,I.$jj),We(1,T.$vi)],l)}),define(ke[266],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=void 0,e.$Vk=(0,D.$2h)("IUriIdentityService")}),define(ke[267],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$wv=void 0,e.$wv=(0,D.$2h)("editSessionIdentityService");var T;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[268],Se([1,0,17]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=void 0;function T($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$jK=T;function g($){if($.folders.length)return $.folders.every(y=>T(y.uri))?$.folders[0].uri:void 0;if($.configuration&&T($.configuration))return $.configuration}e.$kK=g;function I($){return g($)?.scheme}e.$lK=I;function R($){return g($)?.authority}e.$mK=R;function p($){return g($)!==void 0}e.$nK=p}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,p.$2h)("contextService");function y(u){const c=u;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}e.$_h=y;function M(u){return typeof u?.id=="string"&&!y(u)&&!m(u)}e.$ai=M,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function C(u,c){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,T.$nc)(u)}:c?e.$bi:e.$ci;const h=u;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$di=C;function m(u){const c=u;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}e.$ei=m;function w(u){const c=u;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const h=u;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(u?.id)return{id:u.id}}e.$fi=w;var S;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function l(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$gi=l;function f(u){const c=u;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$hi=f;class s{constructor(c,h,k,L,v){this.h=c,this.j=k,this.k=L,this.l=v,this.c=g.$8h.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$8h.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=s;class i{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,I.$Dg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=i;function n(u){return new i({uri:u,index:0,name:(0,I.$zg)(u)},{uri:u.toString()})}e.$ki=n,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,D.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function o(u,c){return I.$ug.isEqualOrParent(u,c.untitledWorkspacesHome)}e.$pi=o;function a(u){let c;return R.URI.isUri(u)?c=u:c=u.configuration,c?.scheme===$.Schemas.tmp}e.$qi=a,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$ri}e.$si=t;function r(u,c){return!o(u,c)&&!a(u)}e.$ti=r;function d(u){return(typeof u=="string"?(0,T.$oc)(u):(0,I.$Bg)(u))===e.$mi}e.$ui=d}),define(ke[269],Se([1,0,53,4,3,23,2,208,133,32,5,14,40,28,266,12,30,13,18]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$Wk=o,e.$Xk=(0,M.$2h)("IUserDataProfilesService");function a(u,c){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:R.URI.revive(u.location).with({scheme:c}),globalStorageHome:R.URI.revive(u.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(u.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(u.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(u.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(u.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(u.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(u.cacheHome).with({scheme:c}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Yk=a;function t(u,c,h,k,L,v){return{id:u,name:c,location:h,isDefault:!1,shortName:L?.shortName,icon:L?.icon,globalStorageHome:v&&L?.useDefaultFlags?.globalState?v.globalStorageHome:(0,I.$Dg)(h,"globalStorage"),settingsResource:v&&L?.useDefaultFlags?.settings?v.settingsResource:(0,I.$Dg)(h,"settings.json"),keybindingsResource:v&&L?.useDefaultFlags?.keybindings?v.keybindingsResource:(0,I.$Dg)(h,"keybindings.json"),tasksResource:v&&L?.useDefaultFlags?.tasks?v.tasksResource:(0,I.$Dg)(h,"tasks.json"),snippetsHome:v&&L?.useDefaultFlags?.snippets?v.snippetsHome:(0,I.$Dg)(h,"snippets"),extensionsResource:v&&L?.useDefaultFlags?.extensions?v.extensionsResource:(0,I.$Dg)(h,"extensions.json"),cacheHome:(0,I.$Dg)(k,u),useDefaultFlags:L?.useDefaultFlags,isTransient:L?.transient}}e.$Zk=t;let r=class extends g.$Sc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,k,L){super(),this.t=c,this.u=h,this.w=k,this.y=L,this.f=!0,this.h=this.B(new T.$Sd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Sd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Sd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Sd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,I.$Dg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Dg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const v of this.O()){if(!v.name||!(0,i.$Ef)(v.name)||!v.location){this.y.warn("Skipping the invalid stored profile",v.location||v.name);continue}h.push(t((0,I.$Ag)(v.location),v.name,v.location,this.g,{shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags},c))}}catch(v){this.y.error(v)}const k=new w.$Ac,L=new Map;if(h.length)try{const v=this.Q();if(v.workspaces)for(const[b,E]of Object.entries(v.workspaces)){const A=R.URI.parse(b),z=h.find(O=>O.id===E);z&&k.set(A,z)}if(v.emptyWindows)for(const[b,E]of Object.entries(v.emptyWindows)){const A=h.find(z=>z.id===E);A&&L.set(b,A)}}catch(v){this.y.error(v)}this.z={profiles:h,workspaces:k,emptyWindows:L}}return this.z}D(){const c=t("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",k=new RegExp(`${(0,s.$Ke)(h)}\\s(\\d+)`);let L=0;for(const b of this.profiles){const E=k.exec(b.name),A=E?parseInt(E[1]):0;L=A>L?A:L}const v=`${h} ${L+1}`;return this.createProfile((0,D.$Pi)((0,f.$mg)()).toString(16),v,{transient:!0},c)}async createNamedProfile(c,h,k){return this.createProfile((0,D.$Pi)((0,f.$mg)()).toString(16),c,h,k)}async createProfile(c,h,k,L){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=await this.F(c,h,k);return L&&await this.setProfileForWorkspace(L,v),v}async F(c,h,k){if(!(0,i.$Ef)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let L=this.r.get(h);return L||(L=(async()=>{try{const v=this.profiles.find(A=>A.name===h||A.id===c);if(v)return v;const b=t(c,h,(0,I.$Dg)(this.profilesHome,c),this.g,k,this.defaultProfile);await this.u.createFolder(b.location);const E=[];return this.j.fire({profile:b,join(A){E.push(A)}}),await l.Promises.settled(E),this.I([b],[],[]),b}finally{this.r.delete(h)}})(),this.r.set(h,L)),L}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(L=>L.id===c.id);if(!k)throw new Error(`Profile '${c.name}' does not exist`);return k=t(k.id,h.name??k.name,k.location,this.g,{shortName:h.shortName??k.shortName,icon:h.icon===null?void 0:h.icon??k.icon,transient:h.transient??k.isTransient,useDefaultFlags:h.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(L=>L.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const k=[];this.m.fire({profile:h,join(L){k.push(L)}});try{await Promise.allSettled(k)}catch(L){this.y.error(L)}for(const L of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(L)?.id&&this.C.emptyWindows.delete(L);for(const L of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(L)?.id&&this.C.workspaces.delete(L);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(L){(0,y.$Ck)(L)!==1&&this.y.error(L)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(L=>L.id===h.id);if(!k)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,k)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,m.$_h)(c)?c.uri:(0,m.$ei)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,k){const L=[...this.profiles,...c],v=[];this.s.profiles=[];for(let b of L)b.isDefault||h.some(E=>b.id===E.id)||(b=k.find(E=>b.id===E.id)??b,b.isTransient?this.s.profiles.push(b):v.push({location:b.location,name:b.name,shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags}));this.P(v),this.z=void 0,this.J(c,h,k)}J(c,h,k){this.h.fire({added:c,removed:h,updated:k,all:this.profiles})}L(c,h,k){k=h?.isTransient?!0:k,k||this.L(c,void 0,!0);const L=this.G(c),v=k?this.s:this.C;R.URI.isUri(L)?(v.workspaces.delete(L),h&&v.workspaces.set(L,h)):(v.emptyWindows.delete(L),h&&v.emptyWindows.set(L,h)),k||this.M()}M(){const c={};for(const[k,L]of this.C.workspaces.entries())c[k.toString()]=L.id;const h={};for(const[k,L]of this.C.emptyWindows.entries())h[k.toString()]=L.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},k=this.D();if(c.workspaces)for(const[v,b]of Object.entries(c.workspaces)){const E=R.URI.parse(b);h[v]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}const L={};if(c.emptyWindows)for(const[v,b]of Object.entries(c.emptyWindows)){const E=R.URI.parse(b);L[v]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}return{workspaces:h,emptyWindows:L}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$1k=r,e.$1k=r=Je([We(0,$.$9h),We(1,y.$lk),We(2,S.$Vk),We(3,C.$jj)],r);class d extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$2k=d}),define(ke[270],Se([1,0,12,4,3,56,18,188,5,269]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$gp=e.$fp=e.$ep=void 0,e.$ep="__$__isNewStorageMarker",e.$fp="__$__targetStorageMarker",e.$gp=(0,$.$2h)("storageService");var M;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function w(i){const n=i.get(e.$fp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$hp=w;class S extends g.$Sc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new T.$Vd),this.c=this.B(new T.$Vd),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Sd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$bh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return T.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,D.$fh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$fp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,R.$Nf)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$fp,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$fp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?w(o):Object.create(null)}isNew(n){return this.getBoolean(e.$ep,n)===!0}async flush(n=M.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case M.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(M.NONE),(0,y.$Wk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||l(o)&&l(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,d]of n)t.add(r),o.get(r)!==d&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$ip=S;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$jp=l;class f extends S{constructor(){super(),this.U=this.B(new p.$cp(new p.$dp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$cp(new p.$dp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$cp(new p.$dp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$kp=f;async function s(i,n,o,a,t,r){const d=A=>{try{return JSON.parse(A)}catch{return A}},u=new Map,c=new Map;i.forEach((A,z)=>{u.set(z,A),c.set(z,d(A))});const h=new Map,k=new Map;n.forEach((A,z)=>{h.set(z,A),k.set(z,d(A))});const L=new Map,v=new Map;o.forEach((A,z)=>{L.set(z,A),v.set(z,d(A))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const b=[];if(u.forEach((A,z)=>{b.push({key:z,value:A})}),console.table(b),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const A=[];h.forEach((z,O)=>{A.push({key:O,value:z})}),console.table(A),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${r})`);const E=[];L.forEach((A,z)=>{E.push({key:z,value:A})}),console.table(E),console.groupEnd(),console.log(v)}e.$lp=s}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$5ec=D}),define(ke[57],Se([1,0,17,23,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new T.$sg(p=>{const $=this.b.get(p.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(p,$){$===null?this.b.delete(p.scheme):this.b.set(p.scheme,$)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$8ec=I,e.$9ec=(0,g.$2h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0,e.$7M=(0,D.$2h)("IExtHostInitDataService")}),define(ke[271],Se([1,0,214,14,251,27]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;let R=class extends g.$bO{constructor($,y,M){const C=M.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=M.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$chc=R,e.$chc=R=Je([We(1,T.$kj),We(2,I.$7M)],R)}),define(ke[272],Se([1,0,12]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=e.$Qfc=void 0;class T{constructor(R,p,$){this.h=new Map,this.a=R,this.b=p,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$bh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of y.values())M.complete()}catch(M){for(const C of y.values())C.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,p){let $=this.f[R];return typeof $>"u"&&($=p),$}update(R,p){this.f[R]=p;const $=this.h.get(R);if($!==void 0)return $.p;const y=new D.$mh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Qfc=T;class g extends T{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,p){super(R.identifier.value,!0,p),this.j=R}}e.$Rfc=g}),define(ke[273],Se([1,0,4,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class g{constructor(R){this.c=R,this.a=new D.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,p,$,y){const C=this.c.getNotebookDocument(T.URI.revive(R)).acceptModelChanged(p.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(R,p){this.c.getNotebookDocument(T.URI.revive(R)).acceptDirty(p)}$acceptModelSaved(R){const p=this.c.getNotebookDocument(T.URI.revive(R));this.a.fire(p.apiNotebook)}}e.$Egc=g}),define(ke[20],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=void 0,e.$QM=(0,D.$2h)("IExtHostRpcService");class T{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$RM=T}),define(ke[274],Se([1,0,26,4]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;class g{#e;constructor(R,p){this.b=new T.$Sd,this.onDidChange=this.b.event,this.a=D.$gm.toKey(R.identifier),this.#e=p,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,p){return this.#e.store(this.a,R,p)}delete(R){return this.#e.delete(this.a,R)}}e.$Yfc=g}),define(ke[66],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=void 0,e.$ofc=(0,D.$2h)("IURITransformerService");class T{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$pfc=T}),define(ke[275],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkb=e.$Wkb=void 0;class T{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(p,$){if($.serializeBuffersForPostMessage){const y=new T,C=JSON.stringify(p,(w,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const l=I(S);if(l)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:l,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=y.buffers.map(w=>{const S=new Uint8Array(w);return D.$ge.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(p),buffers:[]}}e.$Wkb=g;function I(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(p,$){const y=$.map(m=>{const w=new ArrayBuffer(m.byteLength);return new Uint8Array(w).set(m.buffer),w}),M=$.length?(m,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const S=w,{index:l}=S,f=y[l];if(S.view)switch(S.view.type){case 1:return new Int8Array(f,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(f,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(f,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(f,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(f,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(f,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(f,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(f,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(f,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(f,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(f,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return f}return w}:void 0;return{message:JSON.parse(p,M),arrayBuffers:y}}e.$Xkb=R}),define(ke[276],Se([1,0,277,388,389,62,2,14,390]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Khc=void 0;const y=!1;function M(n,o,a,t,r,d){const u=d.environment.useHostProxy,c=typeof u=="boolean"?u:!d.remote.isRemote,h={resolveProxy:v=>n.resolveProxy(v),lookupProxyAuthorization:f.bind(void 0,t,r,o,{},d.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(o),addCertificatesV2:()=>w(o),log:t,getLogLevel:()=>{const v=t.getLevel();switch(v){case p.LogLevel.Trace:return $.LogLevel.Trace;case p.LogLevel.Debug:return $.LogLevel.Debug;case p.LogLevel.Info:return $.LogLevel.Info;case p.LogLevel.Warning:return $.LogLevel.Warning;case p.LogLevel.Error:return $.LogLevel.Error;case p.LogLevel.Off:return $.LogLevel.Off;default:return b(v)}function b(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const v=[];if(d.remote.isRemote&&v.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const b=n.loadCertificates();b.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),v.push(b)}return(await Promise.all(v)).flat()},env:process.env},k=(0,$.createProxyResolver)(h),L=C(h,k);return l(a,L)}e.$Khc=M;function C(n,o){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,o)),https:Object.assign(T,(0,$.createHttpPatch)(n,T,o)),net:Object.assign(I,(0,$.createNetPatch)(n,I)),tls:Object.assign(g,(0,$.createTlsPatch)(n,g))}}function m(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}function w(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}const S=new Map;function l(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,c,h){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const k=a.findSubstr(R.URI.file(c.filename));let L=S.get(k);if(L||S.set(k,L={}),!L[u]){const v=o[u];L[u]={...v}}return L[u]}})}async function f(n,o,a,t,r,d,u,c){const h=t[d];u&&(t[d]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${h}`);const k=u||h,L=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(o,L,r),L.some(v=>/^(Negotiate|Kerberos)( |$)/i.test(v))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const v=await new Promise((O,P)=>{me(["kerberos"],O,P)}),b=new URL(d),E=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${b.hostname}`:`HTTP@${b.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${E}`),"Negotiate "+await(await v.initializeClient(E)).step("")}catch(v){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",v)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[278],Se([1,0,130]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nr=void 0;function T(I){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:I,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function g(I){return new D.$Ym(T(I))}e.$Nr=g}),define(ke[139],Se([1,0,225,18,2,3,5,37,32,17,44,180,39]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=e.$KE=e.$JE=e.EditorsOrder=e.$IE=e.CloseDirection=e.$HE=e.$GE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.$zE=e.$yE=e.EditorInputCapabilities=e.$xE=e.SaveReason=e.Verbosity=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$oE=e.$nE=e.$mE=e.$lE=e.$kE=void 0,e.$kE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$lE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$mE="workbench.editor.sidebysideEditor",e.$nE="workbench.editors.textDiffEditor",e.$oE="workbench.editors.binaryResourceDiffEditor";var w;(function(de){de[de.PROGRAMMATIC=1]="PROGRAMMATIC",de[de.USER=2]="USER",de[de.EDIT=3]="EDIT",de[de.NAVIGATION=4]="NAVIGATION",de[de.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var S;(function(de){de[de.IDENTICAL=1]="IDENTICAL",de[de.SIMILAR=2]="SIMILAR",de[de.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function l(de){const K=de;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$pE=l;function f(de,K,B){for(const ne of B.visibleEditorPanes)if(ne.group.id===K&&de.matches(ne.input))return ne.getViewState()}e.$qE=f;function s(de){if(k(de))return!1;const K=de;return g.URI.isUri(K?.resource)}e.$rE=s;function i(de){if(k(de))return!1;const K=de;return K?.original!==void 0&&K.modified!==void 0}e.$sE=i;function n(de){if(k(de))return!1;const K=de;return Array.isArray(K?.resources)}e.$tE=n;function o(de){if(k(de)||i(de))return!1;const K=de;return K?.primary!==void 0&&K.secondary!==void 0}e.$uE=o;function a(de){if(k(de))return!1;const K=de;return K?K.resource===void 0||K.resource.scheme===y.Schemas.untitled||K.forceUntitled===!0:!1}e.$vE=a;function t(de){if(k(de))return!1;const K=de;return g.URI.isUri(K?.base?.resource)&&g.URI.isUri(K?.input1?.resource)&&g.URI.isUri(K?.input2?.resource)&&g.URI.isUri(K?.result?.resource)}e.$wE=t;var r;(function(de){de[de.SHORT=0]="SHORT",de[de.MEDIUM=1]="MEDIUM",de[de.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var d;(function(de){de[de.EXPLICIT=1]="EXPLICIT",de[de.AUTO=2]="AUTO",de[de.FOCUS_CHANGE=3]="FOCUS_CHANGE",de[de.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class u{constructor(){this.a=new Map}registerSource(K,B){let ne=this.a.get(K);return ne||(ne={source:K,label:B},this.a.set(K,ne)),ne.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$xE=new u;var c;(function(de){de[de.None=0]="None",de[de.Readonly=2]="Readonly",de[de.Untitled=4]="Untitled",de[de.Singleton=8]="Singleton",de[de.RequiresTrust=16]="RequiresTrust",de[de.CanSplitInGroup=32]="CanSplitInGroup",de[de.ForceDescription=64]="ForceDescription",de[de.CanDropIntoEditor=128]="CanDropIntoEditor",de[de.MultipleEditors=256]="MultipleEditors",de[de.Scratchpad=512]="Scratchpad",de[de.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class h extends I.$Sc{}e.$yE=h;function k(de){return de instanceof h}e.$zE=k;function L(de){const K=de;return g.URI.isUri(K?.preferredResource)}function v(de){const K=de;return k(K?.primary)&&k(K?.secondary)}e.$AE=v;function b(de){const K=de;return k(K?.modified)&&k(K?.original)}e.$BE=b;function E(de,K,B,ne,ye){return we(ne,[(0,C.$Li)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const he={...B,limits:{size:Number.MAX_VALUE}};de.openEditor(K,he)}}),(0,C.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$CE=E;function A(de){return k(de?.editor)}e.$DE=A;function z(de){const K=de;return A(de)&&K?.group!==void 0}e.$EE=z;function O(de){const K=de;return typeof K?.groupId=="number"&&k(K.editor)}e.$FE=O;var P;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.REPLACE=1]="REPLACE",de[de.MOVE=2]="MOVE",de[de.UNPIN=3]="UNPIN"})(P||(e.EditorCloseContext=P={}));var j;(function(de){de[de.GROUP_ACTIVE=0]="GROUP_ACTIVE",de[de.GROUP_INDEX=1]="GROUP_INDEX",de[de.GROUP_LABEL=2]="GROUP_LABEL",de[de.GROUP_LOCKED=3]="GROUP_LOCKED",de[de.EDITOR_OPEN=4]="EDITOR_OPEN",de[de.EDITOR_CLOSE=5]="EDITOR_CLOSE",de[de.EDITOR_MOVE=6]="EDITOR_MOVE",de[de.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",de[de.EDITOR_LABEL=8]="EDITOR_LABEL",de[de.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",de[de.EDITOR_PIN=10]="EDITOR_PIN",de[de.EDITOR_STICKY=11]="EDITOR_STICKY",de[de.EDITOR_DIRTY=12]="EDITOR_DIRTY",de[de.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var N;(function(de){de[de.PRIMARY=1]="PRIMARY",de[de.SECONDARY=2]="SECONDARY",de[de.BOTH=3]="BOTH",de[de.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class F{getOriginalUri(K,B){if(!K)return;if(t(K))return e.$HE.getOriginalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:he}=this.a(K);if(ye&&he){if(B?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(he,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===N.ANY)return this.getOriginalUri(ye,{filterByScheme:B.filterByScheme})??this.getOriginalUri(he,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===N.PRIMARY?ye:he}}if(i(K)||n(K)||o(K)||t(K))return;const ne=L(K)?K.preferredResource:K.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}a(K){return v(K)||o(K)?{primary:K.primary,secondary:K.secondary}:b(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,B){if(!K)return;if(t(K))return e.$HE.getCanonicalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:he}=this.a(K);if(ye&&he){if(B?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(he,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===N.ANY)return this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(he,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===N.PRIMARY?ye:he}}if(i(K)||n(K)||o(K)||t(K))return;const ne=K.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}b(K,B){if(Array.isArray(B)){if(B.some(ne=>K.scheme===ne))return K}else if(B===K.scheme)return K}}var W;(function(de){de[de.UNKNOWN=0]="UNKNOWN",de[de.KEYBOARD=1]="KEYBOARD",de[de.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function x(de,K,B,ne){if(!de.isSticky(K))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return B===W.MOUSE||B===W.KEYBOARD;case"mouse":return B===W.MOUSE;case"keyboard":return B===W.KEYBOARD}return!1}e.$GE=x,e.$HE=new F;var ce;(function(de){de[de.LEFT=0]="LEFT",de[de.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class J{constructor(){this.c=new Map,this.d=new Map}start(K){const B=this.a=K.get(R.$1h);for(const[ne,ye]of this.c)this.e(ne,ye,B);this.c.clear()}e(K,B,ne){const ye=ne.createInstance(B);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,T.$Pf)(this.b)}registerEditorSerializer(K,B){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,B,this.a):this.c.set(K,B),(0,I.$Qc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}p.$tn.add(e.$kE.EditorFactory,new J);async function Y(de,K,B){return!de||!de.length?[]:await Promise.all(de.map(async ne=>{const ye=g.URI.revive(ne.fileUri);if(!ye){B.info("Cannot resolve the path because it is not valid.",ne);return}if(!await K.canHandleResource(ye)){B.info("Cannot resolve the path because it cannot be handled",ne);return}let ge=ne.exists,_=ne.type;if(typeof ge!="boolean"||typeof _!="number")try{_=(await K.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ge=!0}catch(G){B.error(G),ge=!1}if(!ge&&ne.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ne);return}if(_===$.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return ge?{resource:ye,options:ie}:{resource:ye,options:ie,forceUntitled:!0}}))}e.$IE=Y;var X;(function(de){de[de.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",de[de.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function se(de){const K=de;if(!K)return!1;const B=K;if(B.modified)return se(B.modified);const ne=K;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$JE=se;function Z(de){return(0,M.$Ni)(de)}e.$KE=Z;function we(de,K,B){const ne=(0,M.$Oi)(de,K);return ne.forceMessage=B?.forceMessage,ne.forceSeverity=B?.forceSeverity,ne.allowDialog=B?.allowDialog,ne}e.$LE=we}),define(ke[279],Se([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.$TE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$SE=e.$RE=e.ViewContentGroups=e.$QE=e.$PE=e.ViewContainerLocation=e.Extensions=e.$OE=e.$NE=e.$ME=void 0,e.$ME="views",e.$NE=(0,T.localize)(0,null),e.$OE=(0,C.$iw)("default-view-icon",M.$8j.window,(0,T.localize)(1,null));var m;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var w;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$PE=[0,1,2];function S(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$QE=S;class l extends I.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,u,c){const h=this.get(d.id);if(h)return h;const k=d;return k.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,R.$xc)(this.g,u,[]).push(k),c?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:u}),k}deregisterViewContainer(d){for(const u of this.g.keys()){const c=this.g.get(u),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(u),this.f.fire({viewContainer:d,viewContainerLocation:u});return}}}get(d){return this.all.filter(u=>u.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(u=>this.getViewContainerLocation(u)===d)}}p.$tn.add(m.ViewContainersRegistry,new l);var f;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(f||(e.ViewContentGroups=f={}));function s(r,d){const u=r.group??f.More,c=d.group??f.More;return u!==c?u.localeCompare(c):(r.order??5)-(d.order??5)}class i extends I.$Sc{constructor(){super(...arguments),this.c=this.B(new D.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(d,u){this.registerViews2([{views:d,viewContainer:u}])}registerViews2(d){d.forEach(({views:u,viewContainer:c})=>this.r(u,c)),this.c.fire(d)}deregisterViews(d,u){const c=this.s(d,u);c.length&&this.f.fire({views:c,viewContainer:u})}moveViews(d,u){for(const c of this.m.keys())if(c!==u){const h=this.s(d,c);h.length&&(this.r(h,u),this.g.fire({views:h,from:c,to:u}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const u of this.j){const c=(this.m.get(u)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const u of this.j)if((this.m.get(u)||[]).filter(h=>h.id===d)[0])return u;return null}registerViewWelcomeContent(d,u){return this.n.add(d,u),this.h.fire(d),(0,I.$Qc)(()=>{this.n.delete(d,u),this.h.fire(d)})}registerViewWelcomeContent2(d,u){const c=new Map;for(const[h,k]of u)this.n.add(d,k),c.set(h,(0,I.$Qc)(()=>{this.n.delete(d,k),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const u=[];return this.n.forEach(d,c=>u.push(c)),u.sort(s)}r(d,u){let c=this.m.get(u);c||(c=[],this.m.set(u,c),this.j.push(u));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(2,null,h.id));c.push(h)}}s(d,u){const c=this.m.get(u);if(!c)return[];const h=[],k=[];for(const L of c)d.includes(L)?h.push(L):k.push(L);return h.length&&(k.length?this.m.set(u,k):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),h}}p.$tn.add(m.ViewsRegistry,new i),e.$RE=(0,g.$2h)("viewsService"),e.$SE=(0,g.$2h)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(d,u){this.c=!1,this.d=!1,(0,y.$kn)(this,d),this.d=!!u,this.resolve=async c=>{if(u&&!this.c){const h=await u(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$TE=a;class t extends Error{constructor(d){super((0,T.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$UE=t}),define(ke[280],Se([1,0,2,29,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$LF=e.$KF=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(T.$Gs.isIRange)}e.$KF=I;function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$LF=R;var p;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.InteractiveSessionCopyKind=$={})),e.$MF=(0,g.$2h)("IChatService")}),define(ke[140],Se([1,0,4,12,227]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Sd,this.n=new D.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(p){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=p}onEvent(p){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=p}onRequest(p){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.s("response",p)}sendRequest(p,$,y,M){const C={command:p};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof M=="number"){const m=setTimeout(()=>{clearTimeout(m);const w=this.f.get(C.seq);if(w){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:p,message:(0,g.localize)(0,null,M,p)};w(S)}},M)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(p){this.j?this.j(p):(this.k.push(p),this.k.length===1&&this.q())}o(p,$){return p.type!=="event"||$.type!=="event"}async q(){let p;for(;this.k.length;){if((!p||this.o(this.k[0],p))&&await(0,T.$3g)(0),p=this.k.shift(),!p)return;switch(p.type){case"event":this.i?.(p);break;case"request":this.g?.(p);break;case"response":{const $=p,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(p,$){$.type=p,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach(($,y)=>p.set(y,$)),await(0,T.$3g)(500),p.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$qlb=I}),define(ke[281],Se([1,0,228,46,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$vH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$uH=e.MemoryRangeType=e.$tH=e.State=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=void 0,e.$qG="workbench.view.debug",e.$rG="workbench.debug.variablesView",e.$sG="workbench.debug.watchExpressionsView",e.$tG="workbench.debug.callStackView",e.$uG="workbench.debug.loadedScriptsView",e.$vG="workbench.debug.breakPointsView",e.$wG="workbench.debug.disassemblyView",e.$xG="workbench.panel.repl",e.$yG="workbench.panel.repl.view",e.$zG=new T.$gj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$AG=new T.$gj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$BG=new T.$gj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$CG="debugUx",e.$DG=new T.$gj(e.$CG,"default",{type:"string",description:D.localize(3,null)}),e.$EG=new T.$gj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$FG=new T.$gj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$GG=new T.$gj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$HG=new T.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$IG=new T.$gj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$JG=new T.$gj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$KG=new T.$gj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$LG=new T.$gj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$MG=new T.$gj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$NG=new T.$gj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$OG=new T.$gj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$PG=new T.$gj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$QG=new T.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$RG=new T.$gj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$SG=new T.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$TG=new T.$gj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$UG=new T.$gj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$VG=new T.$gj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$WG=new T.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$XG=new T.$gj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$YG=new T.$gj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$ZG=new T.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$1G=new T.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$2G=new T.$gj("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$3G=new T.$gj("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$4G=new T.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$5G=new T.$gj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$6G=new T.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$7G=new T.$gj("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$8G=new T.$gj("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$9G=new T.$gj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$0G=new T.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$$G=new T.$gj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$_G=new T.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$aH=new T.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$bH=new T.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$cH=new T.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$dH=new T.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$eH=new T.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$fH=new T.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$gH=new T.$gj("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$hH=new T.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$iH=new T.$gj("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$jH=new T.$gj("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$kH=new T.$gj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$lH=new T.$gj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$mH=new T.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$nH=new T.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$oH=I,e.$pH="editor.contrib.debug",e.$qH="editor.contrib.breakpoint",e.$rH="debug",e.$sH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var R;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(R||(e.State=R={}));function p(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$tH=p;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$uH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var M;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(M||(e.DebuggerString=M={})),e.$vH=(0,g.$2h)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(ke[282],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.$RF=void 0;const M=/{([^}]+)}/g;function C(L,v,b){return L.replace(M,function(E,A){return v&&A.length>0&&A[0]!=="_"?E:b&&b.hasOwnProperty(A)?b[A]:E})}e.$RF=C;function m(L){const v={};for(const b of Object.keys(L))b.startsWith("!")||(v[b]=L[b]);return v}e.$SF=m;function w(L){return L.configuration.request==="attach"&&!S(L)&&(!L.parentSession||w(L.parentSession))}e.$TF=w;function S(L){let v=L.configuration.type;if(v)return v==="vslsShare"&&(v=L.configuration.adapterProxy.configuration.type),(0,D.$8e)(v,"extensionhost")||(0,D.$8e)(v,"pwa-extensionhost")?L:L.parentSession?S(L.parentSession):void 0}e.$UF=S;function l(L){return L.type&&(L.label||L.program||L.runtime)}e.$VF=l;function f(L,v,b){let E,A=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=z.exec(L);){const P=O.index+1,j=P+O[0].length;if(P<=v&&j>=b){E=O[0],A=P;break}}if(E){const P=/\w+/g;let j=null;for(;(j=P.exec(E))&&!(j.index+1+A+j[0].length>=b););j&&(E=E.substring(0,P.lastIndex))}return E?{start:A,end:A+E.length-1}:{start:0,end:0}}e.$WF=f;async function s(L,v,b,E){if(L.evaluatableExpressionProvider.has(v)){const A=L.evaluatableExpressionProvider.ordered(v),z=(0,y.$Hb)(await Promise.all(A.map(async O=>{try{return await O.provideEvaluatableExpression(v,b,E??$.CancellationToken.None)}catch{return}})));if(z.length>0){let O=z[0].expression;const P=z[0].range;return O||(O=v.getLineContent(b.lineNumber).substring(P.startColumn-1,P.endColumn-1)),{range:P,matchingExpression:O}}}else{const A=v.getLineContent(b.lineNumber),{start:z,end:O}=f(A,b.column,b.column),P=A.substring(z-1,O);return{matchingExpression:P,range:new p.$Gs(b.lineNumber,z,b.lineNumber,z+P.length)}}return null}e.$XF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(L){return!!(L&&L.match(i))}e.$YF=n;function o(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(n(L.path))return T.URI.parse(L.path);if((0,g.$ic)(L.path))return T.URI.file(L.path)}return L.path}function a(L){if(typeof L.path=="object"){const v=T.URI.revive(L.path);if(v)return v.scheme===R.Schemas.file?v.fsPath:v.toString()}return L.path}function t(L,v){const b=v?o:a,E=(0,I.$hn)(L);return d(E,(A,z)=>{A&&z&&(z.path=b(z))}),E}e.$ZF=t;function r(L,v){const b=v?o:a,E=(0,I.$hn)(L);return d(E,(A,z)=>{!A&&z&&(z.path=b(z))}),E}e.$1F=r;function d(L,v){switch(L.type){case"event":{const b=L;switch(b.event){case"output":v(!1,b.body.source);break;case"loadedSource":v(!1,b.body.source);break;case"breakpoint":v(!1,b.body.breakpoint.source);break;default:break}break}case"request":{const b=L;switch(b.command){case"setBreakpoints":v(!0,b.arguments.source);break;case"breakpointLocations":v(!0,b.arguments.source);break;case"source":v(!0,b.arguments.source);break;case"gotoTargets":v(!0,b.arguments.source);break;case"launchVSCode":b.arguments.args.forEach(E=>v(!1,E));break;default:break}break}case"response":{const b=L;if(b.success&&b.body)switch(b.command){case"stackTrace":b.body.stackFrames.forEach(E=>v(!1,E.source));break;case"loadedSources":b.body.sources.forEach(E=>v(!1,E));break;case"scopes":b.body.scopes.forEach(E=>v(!1,E.source));break;case"setFunctionBreakpoints":b.body.breakpoints.forEach(E=>v(!1,E.source));break;case"setBreakpoints":b.body.breakpoints.forEach(E=>v(!1,E.source));break;case"disassemble":b.body?.instructions.forEach(A=>v(!1,A.location));break;default:break}break}}}function u(L){return L.filter(v=>!v.presentation?.hidden).sort((v,b)=>v.presentation?b.presentation?v.presentation.group?b.presentation.group?v.presentation.group!==b.presentation.group?v.presentation.group.localeCompare(b.presentation.group):c(v.presentation.order,b.presentation.order):-1:b.presentation.group?1:c(v.presentation.order,b.presentation.order):-1:b.presentation?1:0)}e.$2F=u;function c(L,v){return typeof L!="number"?typeof v!="number"?0:1:typeof v!="number"?-1:L-v}async function h(L,v){const b=L.getValue("debug.saveBeforeStart",{overrideIdentifier:v.activeTextEditorLanguageId});if(b!=="none"&&(await v.saveAll(),b==="allEditorsInActiveGroup")){const E=v.activeEditorPane;E&&E.input.resource?.scheme===R.Schemas.untitled&&await v.save({editor:E.input,groupId:E.group.id})}await L.reloadConfiguration()}e.$3F=h;const k=(L,v)=>!L||!v?L===v:L.name===v.name&&L.path===v.path&&L.sourceReference===v.sourceReference;e.$4F=k}),define(ke[283],Se([1,0,51,62,24,16,11,13,31,229,140]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=e.$khc=e.$jhc=e.$ihc=void 0;class C extends M.$qlb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(C.b);for(const a of o){const t=a.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$ihc=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$jhc=m;class w extends m{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$khc=w;class S extends m{constructor(s){super(),this.z=s}y(s){return T.createConnection(this.z.path,s)}}e.$lhc=S;class l extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(I.$ic(s)){if(!await $.Promises.exists(s))throw new Error(y.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=g.$kn(g.$hn(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=I.$jc(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(I.$ic(s.program)?n.program=s.program:n.program=I.$jc(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=l.A(o.win,i)),o.winx86&&(n.winx86=l.A(o.winx86,i)),o.windows&&(n.windows=l.A(o.windows,i)),o.osx&&(n.osx=l.A(o.osx,i)),o.linux&&(n.linux=l.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const c=u.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&p.$8e(h.type,i)).forEach(h=>{const k=l.A(h,u.extensionLocation.fsPath);n=g.$kn(n,k,u.isBuiltin)})}let o;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:R.$i?o=n.win||n.windows:R.$j?o=n.osx:R.$k&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,d=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$mhc=l}),define(ke[284],Se([1,0,51,33,11]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=void 0;function I(y,M){return new Promise((C,m)=>{let w="";const S=D.spawn(y,M);S.pid&&S.stdout.on("data",l=>{w+=l.toString()}),S.on("error",l=>{m(l)}),S.on("close",l=>{C(w)})})}async function R(y){if(y)if(g.$i){const M=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{M.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(M=>{const C=M.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},M=>!0);return Promise.resolve(!0)}e.$nhc=R;var p;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(p||(p={}));function $(y,M,C,m,w){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let l,f=" ";switch(S){case 1:if(l=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,T.$9f)(m);s&&(f+=`${s}:; `),f+=`cd ${l(m)}; `}if(w)for(const s in w){const i=w[s];i===null?f+=`Remove-Item env:${s}; `:f+=`\${env:${s}}='${i}'; `}if(M.length>0){const s=M.shift(),i=C?s:l(s);f+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of M)f+=n==="<"||n===">"||C?n:l(n),f+=" "}break;case 0:if(l=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,T.$9f)(m);s&&(f+=`${s}: && `),f+=`cd ${l(m)} && `}if(w){f+='cmd /C "';for(const s in w){let i=w[s];i===null?f+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),f+=`set "${s}=${i}" && `)}}for(const s of M)f+=s==="<"||s===">"||C?s:l(s),f+=" ";w&&(f+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(f+=`cd ${l(m)} ; `),w){f+="/usr/bin/env";for(const i in w){const n=w[i];n===null?f+=` -u ${s(i)}`:f+=` ${s(`${i}=${n}`)}`}f+=" "}for(const i of M)f+=i==="<"||i===">"||C?i:l(i),f+=" ";break}}return f}e.$ohc=$}),define(ke[111],Se([1,0,22,34,52,100,17,16,11,46]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.$RI=e.$QI=e.$PI=e.CellStatusbarAlignment=e.$OI=e.$NI=e.$MI=e.NotebookEditorPriority=e.$LI=e.$KI=e.$JI=e.$II=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$HI=e.$GI=e.$FI=e.$EI=e.CellKind=e.$DI=e.$CI=e.$BI=void 0,e.$BI="workbench.editor.notebook",e.$CI="workbench.editor.notebookTextDiffEditor",e.$DI="workbench.editor.interactive";var M;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(M||(e.CellKind=M={})),e.$EI=["application/json","application/javascript","text/html","image/svg+xml",I.$3r.latex,I.$3r.markdown,"image/png","image/jpeg",I.$3r.text],e.$FI=[I.$3r.latex,I.$3r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$3r.text],e.$GI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$HI="_notAvailable";var C;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var w;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var S;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var l;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var f;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(f||(e.NotebookCellsChangeType=f={}));var s;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(F){F.scheme=R.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],x=new RegExp(`^[${W.join("")}]+`),ce=7;function J(de,K){const B=K.toString(ce),ye=`${B.length<W.length?W[B.length-1]:"z"}${B}s${(0,D.$Ae)(D.$ge.fromString(de.scheme),!0,!0)}`;return de.with({scheme:F.scheme,fragment:ye})}F.generate=J;function Y(de){if(de.scheme!==F.scheme)return;const K=de.fragment.indexOf("s");if(K<0)return;const B=parseInt(de.fragment.substring(0,K).replace(x,""),ce),ne=(0,D.$ze)(de.fragment.substring(K+1)).toString();if(!isNaN(B))return{handle:B,notebook:de.with({scheme:ne,fragment:null})}}F.parse=Y;function X(de,K){return de.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${de.scheme!==R.Schemas.file?de.scheme:""}`})}F.generateCellOutputUri=X;function se(de){if(de.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!K)return;const B=K[1]&&K[1]!==""?K[1]:void 0,ne=K[2];return{outputId:B,notebook:de.with({scheme:ne||R.Schemas.file,fragment:null})}}F.parseCellOutputUri=se;function Z(de,K,B){return F.generate(de,K).with({scheme:B})}F.generateCellPropertyUri=Z;function we(de,K){if(de.scheme===K)return F.parse(de.with({scheme:F.scheme}))}F.parseCellPropertyUri=we})(n||(e.CellUri=n={}));const o=F=>$.$i?F.replace(/\//g,"\\"):F;class a{constructor(W=[],x=e.$EI){this.e=x,this.d=[...new Set(W)].map(ce=>({pattern:ce,matches:T.$Ij(o(ce))}))}sort(W){const x=new Map(g.Iterable.map(W,J=>[J,o(J)]));let ce=[];for(const{matches:J}of this.d)for(const[Y,X]of x)if(J(X)){ce.push(Y),x.delete(Y);break}return x.size&&(ce=ce.concat([...x.keys()].sort((J,Y)=>this.e.indexOf(J)-this.e.indexOf(Y)))),ce}prioritize(W,x){const ce=this.f(W);if(ce===-1){this.d.unshift({pattern:W,matches:T.$Ij(o(W))});return}const J=new Set(x.map(X=>this.f(X,ce)));J.delete(-1);const Y=Array.from(J).sort();this.d.splice(ce+1,0,...Y.map(X=>this.d[X]));for(let X=Y.length-1;X>=0;X--)this.d.splice(Y[X],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,x=this.d.length){const ce=o(W);for(let J=0;J<x;J++)if(this.d[J].matches(ce))return J;return-1}}e.$II=a;function t(F,W,x,ce=(J,Y)=>J===Y){const J=[];function Y(Z,we,de){if(we===0&&de.length===0)return;const K=J[J.length-1];K&&K.start+K.deleteCount===Z?(K.deleteCount+=we,K.toInsert.push(...de)):J.push({start:Z,deleteCount:we,toInsert:de})}let X=0,se=0;for(;;){if(X===F.length){Y(X,0,W.slice(se));break}if(se===W.length){Y(X,F.length-X,[]);break}const Z=F[X],we=W[se];if(ce(Z,we)){X+=1,se+=1;continue}x(we)?(Y(X,1,[]),X+=1):(Y(X,0,[we]),se+=1)}return J}e.$JI=t,e.$KI=new y.$gj("notebookEditorCursorAtBoundary","none"),e.$LI=new y.$gj("notebookEditorCursorAtLineBoundary","none");var r;(function(F){F.default="default",F.option="option"})(r||(e.NotebookEditorPriority=r={}));function d(F){const W=F;return!!((typeof W.include=="string"||T.$Jj(W.include))&&(typeof W.exclude=="string"||T.$Jj(W.exclude)))}e.$MI=d;function u(F,W,x){if(Array.isArray(F.viewType)&&F.viewType.indexOf(W)>=0||F.viewType===W)return!0;if(F.filenamePattern){const ce=d(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,J=d(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(T.$Hj(ce,(0,p.$nc)(x.fsPath).toLowerCase()))return!(J&&T.$Hj(J,(0,p.$nc)(x.fsPath).toLowerCase()))}return!1}e.$NI=u,e.$OI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$PI=h;function k(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.$QI=k;const L=new TextDecoder;function v(F){const W=[];let x=!1;for(const X of F)(W.length===0||x)&&(W.push(X),x=!0);let ce=A(W);const J=D.$ge.concat(W.map(X=>D.$ge.wrap(X))),Y=N(J);return ce=ce||Y.byteLength!==J.byteLength,{data:Y,didCompression:ce}}e.$RI=v,e.$SI=`${String.fromCharCode(27)}[A`;const b=e.$SI.split("").map(F=>F.charCodeAt(0)),E=10;function A(F){let W=!1;return F.forEach((x,ce)=>{if(ce===0||x.length<e.$SI.length)return;const J=F[ce-1],Y=x.subarray(0,e.$SI.length);if(Y[0]===b[0]&&Y[1]===b[1]&&Y[2]===b[2]){const X=J.lastIndexOf(E);if(X===-1)return;W=!0,F[ce-1]=J.subarray(0,X),F[ce]=x.subarray(e.$SI.length)}}),W}function z(F){let W=F;do F=W,W=F.replace(/[^\n]\x08/gm,"");while(W.length<F.length);return F}function O(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const W=F.match(/^(.*)\r+/m)[1];let x=F.match(/\r+(.*)$/m)[1];x=x+W.slice(x.length,W.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,x)}return F}const P="\b".charCodeAt(0),j="\r".charCodeAt(0);function N(F){return!F.buffer.includes(P)&&!F.buffer.includes(j)?F:D.$ge.fromString(O(z(L.decode(F.buffer))))}}),define(ke[7],Se([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S){"use strict";var l,f,s,i,n,o,a,t,r,d,u,c,h,k,L,v,b;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$FM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$EM=e.ChatVariableLevel=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.TestRunProfileKind=e.TestResultState=e.$kM=e.$jM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$iM=e.NotebookVariablesRequestKind=e.$hM=e.$gM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$fM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.ColorThemeKind=e.$_L=e.$$L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$0L=e.DebugConsoleMode=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$4L=e.$3L=e.FileChangeType=e.$2L=e.$1L=e.$ZL=e.$YL=e.InlineCompletionTriggerKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.ConfigurationTarget=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$BL=e.ViewBadge=e.ProgressLocation=e.$AL=e.$zL=e.TaskScope=e.ShellQuoting=e.$yL=e.$xL=e.$wL=e.TaskPanelKind=e.TaskRevealKind=e.$vL=e.TerminalLocation=e.$uL=e.$tL=e.$sL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$rL=e.$qL=e.$pL=e.$oL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$nL=e.StatusBarAlignment=e.ViewColumn=e.$mL=e.$lL=e.$kL=e.$jL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$iL=e.$hL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.LanguageStatusSeverity=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.CodeActionTriggerKind=e.$8K=e.$7K=e.SymbolTag=e.SymbolKind=e.$6K=e.$5K=e.DocumentHighlightKind=e.$4K=e.$3K=e.$2K=e.$1K=e.DiagnosticSeverity=e.DiagnosticTag=e.$ZK=e.$YK=e.FileEditType=e.$XK=e.$WK=e.$VK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...be){if(be.length===0)return Reflect.construct(H,[]);{const Fe=be.length===1?[]:be[1];return Reflect.construct(H,Fe,be[0].constructor)}},call:function(...be){if(be.length===0)return Reflect.construct(H,[]);{const[Fe,...Xe]=be;return Reflect.construct(H,Xe,Fe.constructor)}}})}var A;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var z;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let O=l=class{static from(...q){let be=q;return new l(function(){if(be){for(const Fe of be)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();be=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$OK=O,e.$OK=O=l=Je([E],O);let P=f=class{static Min(...q){if(q.length===0)throw new TypeError;let be=q[0];for(let Fe=1;Fe<q.length;Fe++){const Xe=q[Fe];Xe.isBefore(be)&&(be=Xe)}return be}static Max(...q){if(q.length===0)throw new TypeError;let be=q[0];for(let Fe=1;Fe<q.length;Fe++){const Xe=q[Fe];Xe.isAfter(be)&&(be=Xe)}return be}static isPosition(q){if(!q)return!1;if(q instanceof f)return!0;const{line:be,character:Fe}=q;return typeof be=="number"&&typeof Fe=="number"}static of(q){if(q instanceof f)return q;if(this.isPosition(q))return new f(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,be){if(q<0)throw(0,T.$7)("line must be non-negative");if(be<0)throw(0,T.$7)("character must be non-negative");this.c=q,this.e=be}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,be=0){if(q===null||be===null)throw(0,T.$7)();let Fe;return typeof q>"u"?Fe=0:typeof q=="number"?Fe=q:(Fe=typeof q.lineDelta=="number"?q.lineDelta:0,be=typeof q.characterDelta=="number"?q.characterDelta:0),Fe===0&&be===0?this:new f(this.line+Fe,this.character+be)}with(q,be=this.character){if(q===null||be===null)throw(0,T.$7)();let Fe;return typeof q>"u"?Fe=this.line:typeof q=="number"?Fe=q:(Fe=typeof q.line=="number"?q.line:this.line,be=typeof q.character=="number"?q.character:this.character),Fe===this.line&&be===this.character?this:new f(Fe,be)}toJSON(){return{line:this.line,character:this.character}}};e.$PK=P,e.$PK=P=f=Je([E],P);let j=s=class{static isRange(q){return q instanceof s?!0:q?P.isPosition(q.start)&&P.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,be,Fe,Xe){let nt,lt;if(typeof q=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Xe=="number"?(nt=new P(q,be),lt=new P(Fe,Xe)):P.isPosition(q)&&P.isPosition(be)&&(nt=P.of(q),lt=P.of(be)),!nt||!lt)throw new Error("Invalid arguments");nt.isBefore(lt)?(this.c=nt,this.e=lt):(this.c=lt,this.e=nt)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):P.isPosition(q)?!(P.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const be=P.Max(q.start,this.c),Fe=P.Min(q.end,this.e);if(!be.isAfter(Fe))return new s(be,Fe)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const be=P.Min(q.start,this.c),Fe=P.Max(q.end,this.end);return new s(be,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,be=this.end){if(q===null||be===null)throw(0,T.$7)();let Fe;return q?P.isPosition(q)?Fe=q:(Fe=q.start||this.start,be=q.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&be.isEqual(this.end)?this:new s(Fe,be)}toJSON(){return[this.start,this.end]}};e.$QK=j,e.$QK=j=s=Je([E],j);let N=i=class extends j{static isSelection(q){return q instanceof i?!0:q?j.isRange(q)&&P.isPosition(q.anchor)&&P.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,be,Fe,Xe){let nt,lt;if(typeof q=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Xe=="number"?(nt=new P(q,be),lt=new P(Fe,Xe)):P.isPosition(q)&&P.isPosition(be)&&(nt=P.of(q),lt=P.of(be)),!nt||!lt)throw new Error("Invalid arguments");super(nt,lt),this.f=nt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$RK=N,e.$RK=N=i=Je([E],N);const F=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,T.$7)("connectionToken")};class W{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,be,Fe){if(typeof q!="string"||q.length===0)throw(0,T.$7)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,T.$7)("port");typeof Fe<"u"&&F(Fe),this.host=q,this.port=Math.round(be),this.connectionToken=Fe}}e.$SK=W;class x{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,be){this.makeConnection=q,this.connectionToken=be,typeof be<"u"&&F(be)}}e.$TK=x;class ce extends Error{static NotAvailable(q,be){return new ce(q,w.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(q){return new ce(q,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,be=w.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(q),this._message=q,this._code=be,this._detail=Fe,Object.setPrototypeOf(this,ce.prototype)}}e.$UK=ce;var J;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(J||(e.EndOfLine=J={}));var Y;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Y||(e.EnvironmentVariableMutatorType=Y={}));let X=n=class{static isTextEdit(q){return q instanceof n?!0:q?j.isRange(q)&&typeof q.newText=="string":!1}static replace(q,be){return new n(q,be)}static insert(q,be){return n.replace(new j(q,q),be)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const be=new n(new j(new P(0,0),new P(0,0)),"");return be.newEol=q,be}get range(){return this.c}set range(q){if(q&&!j.isRange(q))throw(0,T.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,T.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,T.$7)("newEol");this.f=q}constructor(q,be){this.c=q,this.e=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$VK=X,e.$VK=X=n=Je([E],X);let se=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?_t.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,be){return new o(q,be)}static insertCells(q,be){return new o(new _t(q,q),be)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,be){const Fe=new o(new _t(q,q),[]);return Fe.newCellMetadata=be,Fe}static updateNotebookMetadata(q){const be=new o(new _t(0,0),[]);return be.newNotebookMetadata=q,be}constructor(q,be){this.range=q,this.newCells=be}};e.$WK=se,e.$WK=se=o=Je([E],se);class Z{static isSnippetTextEdit(q){return q instanceof Z?!0:q?j.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,be){return new Z(q,be)}static insert(q,be){return Z.replace(new j(q,q),be)}constructor(q,be){this.range=q,this.snippet=be}}e.$XK=Z;var we;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(we||(e.FileEditType=we={}));let de=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,be,Fe,Xe){this.c.push({_type:1,from:q,to:be,options:Fe,metadata:Xe})}createFile(q,be,Fe){this.c.push({_type:1,from:void 0,to:q,options:be,metadata:Fe})}deleteFile(q,be,Fe){this.c.push({_type:1,from:q,to:void 0,options:be,metadata:Fe})}e(q,be,Fe){this.c.push({_type:3,metadata:Fe,uri:q,edit:{editType:5,metadata:be},notebookMetadata:be})}f(q,be,Fe,Xe){const nt=be.start,lt=be.end;(nt!==lt||Fe.length>0)&&this.c.push({_type:5,uri:q,index:nt,count:lt-nt,cells:Fe,metadata:Xe})}g(q,be,Fe,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:be,metadata:Fe}})}replace(q,be,Fe,Xe){this.c.push({_type:2,uri:q,edit:new X(be,Fe),metadata:Xe})}insert(q,be,Fe,Xe){this.replace(q,new j(be,be),Fe,Xe)}delete(q,be,Fe){this.replace(q,be,"",Fe)}has(q){return this.c.some(be=>be._type===2&&be.uri.toString()===q.toString())}set(q,be){if(be)for(const Fe of be){if(!Fe)continue;let Xe,nt;Array.isArray(Fe)?(Xe=Fe[0],nt=Fe[1]):Xe=Fe,se.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,nt):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,nt):this.f(q,Xe.range,Xe.newCells,nt):Z.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:nt}):this.c.push({_type:2,uri:q,edit:Xe,metadata:nt})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Xe=this.c[Fe];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Fe]=void 0);break}}(0,D.$Ib)(this.c)}}get(q){const be=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===q.toString()&&be.push(Fe.edit);return be}entries(){const q=new I.$Ac;for(const be of this.c)if(be._type===2){let Fe=q.get(be.uri);Fe||(Fe=[be.uri,[]],q.set(be.uri,Fe)),Fe[1].push(be.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$YK=de,e.$YK=de=Je([E],de);let K=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,be=this.e++){if(typeof q=="function"){const Fe=new a;Fe.e=this.e,q(Fe),this.e=Fe.e,q=Fe.value}else q=a.c(q);return this.value+="${",this.value+=be,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,be=this.e++){const Fe=q.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(q,be){if(typeof be=="function"){const Fe=new a;Fe.e=this.e,be(Fe),this.e=Fe.e,be=Fe.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.$ZK=K,e.$ZK=K=a=Je([E],K);var B;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ne;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?j.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,be){if(this.uri=q,be)if(j.isRange(be))this.range=j.of(be);else if(P.isPosition(be))this.range=new j(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$1K=ye,e.$1K=ye=t=Je([E],ye);let he=class{static is(q){return q?typeof q.message=="string"&&q.location&&j.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,be){this.location=q,this.message=be}static isEqual(q,be){return q===be?!0:!q||!be?!1:q.message===be.message&&q.location.range.isEqual(be.location.range)&&q.location.uri.toString()===be.location.uri.toString()}};e.$2K=he,e.$2K=he=Je([E],he);let ge=class{constructor(q,be,Fe=ne.Error){if(!j.isRange(q))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=q,this.message=be,this.severity=Fe}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,be){return q===be?!0:!q||!be?!1:q.message===be.message&&q.severity===be.severity&&q.code===be.code&&q.severity===be.severity&&q.source===be.source&&q.range.isEqual(be.range)&&(0,D.$ub)(q.tags,be.tags)&&(0,D.$ub)(q.relatedInformation,be.relatedInformation,he.isEqual)}};e.$3K=ge,e.$3K=ge=Je([E],ge);let _=class{constructor(q,be){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=be}};e.$4K=_,e.$4K=_=Je([E],_);var ie;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(q,be=ie.Text){this.range=q,this.kind=be}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$5K=G,e.$5K=G=Je([E],G);let te=class{constructor(q,be){this.uri=q,this.highlights=be}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$6K=te,e.$6K=te=Je([E],te);var fe;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(fe||(e.SymbolKind=fe={}));var ve;(function(H){H[H.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Ae=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,be,Fe,Xe,nt){this.name=q,this.kind=be,this.containerName=nt,typeof Fe=="string"&&(this.containerName=Fe),Xe instanceof ye?this.location=Xe:Fe instanceof j&&(this.location=new ye(Xe,Fe)),r.validate(this)}toJSON(){return{name:this.name,kind:fe[this.kind],location:this.location,containerName:this.containerName}}};e.$7K=Ae,e.$7K=Ae=r=Je([E],Ae);let pe=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(d.validate)}constructor(q,be,Fe,Xe,nt){this.name=q,this.detail=be,this.kind=Fe,this.range=Xe,this.selectionRange=nt,this.children=[],d.validate(this)}};e.$8K=pe,e.$8K=pe=d=Je([E],pe);var De;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(De||(e.CodeActionTriggerKind=De={}));let U=class{constructor(q,be){this.title=q,this.kind=be}};e.$9K=U,e.$9K=U=Je([E],U);let Q=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$0K=Q,e.$0K=Q=u=Je([E],Q),Q.Empty=new Q(""),Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorMove=Q.Refactor.append("move"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll"),Q.Notebook=Q.Empty.append("notebook");let ee=class{constructor(q,be){if(this.range=q,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$$K=ee,e.$$K=ee=Je([E],ee);class V{constructor(q,be,Fe,Xe,nt,lt){this.kind=q,this.name=be,this.detail=Fe,this.uri=Xe,this.range=nt,this.selectionRange=lt}}e.$_K=V;class ae{constructor(q,be){this.fromRanges=be,this.from=q}}e.$aL=ae;class ue{constructor(q,be){this.fromRanges=be,this.to=q}}e.$bL=ue;var Le;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(q,be){this.range=q,this.command=be}get isResolved(){return!!this.command}};e.$cL=je,e.$cL=je=Je([E],je);let Ke=c=class{#e;static isMarkdownString(q){return q instanceof c?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,be=!1){this.#e=new g.$dk(q,{supportThemeIcons:be})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,be){return this.#e.appendCodeblock(be??"",q),this}};e.$dL=Ke,e.$dL=Ke=c=Je([E],Ke);let Qe=class{constructor(q,be){this.label=q,this.documentation=be}};e.$eL=Qe,e.$eL=Qe=Je([E],Qe);let _e=class{constructor(q,be){this.label=q,this.documentation=be,this.parameters=[]}};e.$fL=_e,e.$fL=_e=Je([E],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$gL=at,e.$gL=at=Je([E],at);var ot;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(ot||(e.SignatureHelpTriggerKind=ot={}));var Ie;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Ie||(e.InlayHintKind=Ie={}));let ze=class{constructor(q){this.value=q}};e.$hL=ze,e.$hL=ze=Je([E],ze);let qe=class{constructor(q,be,Fe){this.position=q,this.label=be,this.kind=Fe}};e.$iL=qe,e.$iL=qe=Je([E],qe);var Re;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Re||(e.CompletionTriggerKind=Re={}));var et;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(et||(e.CompletionItemKind=et={}));var oe;(function(H){H[H.Deprecated=1]="Deprecated"})(oe||(e.CompletionItemTag=oe={}));let le=class{constructor(q,be){this.label=q,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&et[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$jL=le,e.$jL=le=Je([E],le);let Pe=class{constructor(q=[],be=!1){this.items=q,this.isIncomplete=be}};e.$kL=Pe,e.$kL=Pe=Je([E],Pe);let He=class{constructor(q,be,Fe){this.insertText=q,this.range=be,this.command=Fe}};e.$lL=He,e.$lL=He=Je([E],He);let Ze=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$mL=Ze,e.$mL=Ze=Je([E],Ze);var it;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var st;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Oe(H,q){return`${C.$gm.toKey(H)}.${q}`}e.$nL=Oe;var wt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var Dt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Ht;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Ut;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var yt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var Vt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Vt||(e.DecorationRangeBehavior=Vt={})),function(H){function q(be){switch(be){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Ft;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ft||(e.SyntaxTokenType=Ft={})),function(H){function q(be){switch(be){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Ft||(e.SyntaxTokenType=Ft={}));let Qt=class{constructor(q,be){if(be&&!y.URI.isUri(be))throw(0,T.$7)("target");if(!j.isRange(q)||q.isEmpty)throw(0,T.$7)("range");this.range=q,this.target=be}};e.$oL=Qt,e.$oL=Qt=Je([E],Qt);let Ot=class{constructor(q,be,Fe,Xe){this.red=q,this.green=be,this.blue=Fe,this.alpha=Xe}};e.$pL=Ot,e.$pL=Ot=Je([E],Ot);let Pt=class{constructor(q,be){if(be&&!(be instanceof Ot))throw(0,T.$7)("color");if(!j.isRange(q)||q.isEmpty)throw(0,T.$7)("range");this.range=q,this.color=be}};e.$qL=Pt,e.$qL=Pt=Je([E],Pt);let tt=class{constructor(q){if(!q||typeof q!="string")throw(0,T.$7)("label");this.label=q}};e.$rL=tt,e.$rL=tt=Je([E],tt);var Kt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Kt||(e.ColorFormat=Kt={}));var Gt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var ut;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class $t{constructor(q,be,Fe){if(this.startIndex=q,this.length=be,this.tooltip=Fe,typeof q!="number"||q<0)throw(0,T.$7)("startIndex");if(typeof be!="number"||be<1)throw(0,T.$7)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,T.$7)("tooltip")}}e.$sL=$t;class jt{constructor(q){this.uri=q}}e.$tL=jt;class Bt{constructor(q){this.terminalCommand=q}}e.$uL=Bt;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(q){if(this.options=q,typeof q!="object")throw(0,T.$7)("options")}}e.$vL=dt;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var Xt;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Xt||(e.TaskPanelKind=Xt={}));let St=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,be){if(this.label=be,typeof q!="string"||typeof be!="string")throw(0,T.$7)("name");this.c=q}get id(){return this.c}};e.$wL=St,e.$wL=St=h=Je([E],St);function Ye(H){let q="";for(let be=0;be<H.length;be++)q+=H[be].replace(/,/g,",,")+",";return q}let Rt=class{constructor(q,be,Fe){if(typeof q!="string")throw(0,T.$7)("process");this.e=[],this.c=q,be!==void 0&&(Array.isArray(be)?(this.e=be,this.f=Fe):this.f=be)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,T.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const be of this.e)q.push(be);return Ye(q)}};e.$xL=Rt,e.$xL=Rt=Je([E],Rt);let Wt=class{constructor(q,be,Fe){if(this.f=[],Array.isArray(be)){if(!q)throw(0,T.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,T.$7)("command");this.e=q,this.f=be,this.g=Fe}else{if(typeof q!="string")throw(0,T.$7)("commandLine");this.c=q,this.g=be}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,T.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,T.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const be of this.f)q.push(typeof be=="string"?be:be.value);return Ye(q)}};e.$yL=Wt,e.$yL=Wt=Je([E],Wt);var Jt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Mt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,M.$mg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$zL=Mt;let Me=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,be,Fe,Xe,nt,lt){this.k=!1,this.l=this.definition=q;let ft;typeof be=="string"?(this.n=this.name=be,this.u=this.source=Fe,this.execution=Xe,ft=nt,this.k=!0):be===gt.Global||be===gt.Workspace?(this.target=be,this.n=this.name=Fe,this.u=this.source=Xe,this.execution=nt,ft=lt):(this.target=be,this.n=this.name=Fe,this.u=this.source=Xe,this.execution=nt,ft=lt),typeof ft=="string"?(this.q=[ft],this.r=!0):Array.isArray(ft)?(this.q=ft,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Rt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Mt?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,M.$mg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,T.$7)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,T.$7)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const be=this.l.type;(k.g===be||k.e===be||k.f===be||k.c===be)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,T.$7)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$AL=Me,e.$AL=Me=k=Je([E],Me);var Te;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Te||(e.ProgressLocation=Te={}));var Ce;(function(H){function q(be){const Fe=be;return(0,$.$If)(Fe.value)?Fe.tooltip&&!(0,$.$Ef)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}H.isViewBadge=q})(Ce||(e.ViewBadge=Ce={}));let re=L=class{static isTreeItem(q,be){const Fe=q;if(Fe.checkboxState!==void 0){const Xe=(0,$.$If)(Fe.checkboxState)?Fe.checkboxState:(0,$.$Gf)(Fe.checkboxState)&&(0,$.$If)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,nt=!(0,$.$If)(Fe.checkboxState)&&(0,$.$Gf)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Ve.Checked&&Xe!==Ve.Unchecked||nt!==void 0&&!(0,$.$Ef)(nt))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(q instanceof L)return!0;if(Fe.label!==void 0&&!(0,$.$Ef)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,$.$Ef)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,$.$Ef)(Fe.iconPath)&&!y.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,$.$Ef)(Fe.iconPath.id))){const Xe=Fe.iconPath;if(!Xe||!(0,$.$Ef)(Xe.light)&&!y.URI.isUri(Xe.light)&&!(0,$.$Ef)(Xe.dark)&&!y.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,$.$Ef)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!y.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,$.$Ef)(Fe.tooltip)&&!(Fe.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<Ne.None&&Fe.collapsibleState>Ne.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,$.$Ef)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(q,be=Ne.None){this.collapsibleState=be,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$BL=re,e.$BL=re=L=Je([E],re);var Ne;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(Ne||(e.TreeItemCollapsibleState=Ne={}));var Ve;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(Ve||(e.TreeItemCheckboxState=Ve={}));let xe=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$CL=xe,e.$CL=xe=Je([E],xe);class Ge extends xe{}e.$DL=Ge;class rt extends Ge{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$EL=rt;class mt{constructor(q,be,Fe,Xe){this.name=q,this.uri=be,this._itemId=Fe,this.c=Xe}data(){return this.c()}}e.$FL=mt;let zt=class{#e=new Map;constructor(q){for(const[be,Fe]of q??[]){const Xe=this.#e.get(this.#t(be));Xe?Xe.push(Fe):this.#e.set(this.#t(be),[Fe])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,be){this.#e.set(this.#t(q),[be])}forEach(q,be){for(const[Fe,Xe]of this.#e)for(const nt of Xe)q.call(be,nt,Fe,this)}*[Symbol.iterator](){for(const[q,be]of this.#e)for(const Fe of be)yield[q,Fe]}#t(q){return q.toLowerCase()}};e.$GL=zt,e.$GL=zt=Je([E],zt);let Et=class{constructor(q){this.insertText=q}};e.$HL=Et,e.$HL=Et=Je([E],Et);let Ct=class{constructor(q,be){this.label=be,this.insertText=q}};e.$IL=Ct,e.$IL=Ct=Je([E],Ct);let vt=class{constructor(q,be){this.id=q,this.color=be}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$JL=vt,e.$JL=vt=Je([E],vt),vt.File=new vt("file"),vt.Folder=new vt("folder");let mi=class{constructor(q){this.id=q}};e.$KL=mi,e.$KL=mi=Je([E],mi);var Lt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Lt||(e.ConfigurationTarget=Lt={}));let Si=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,be){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,T.$7)("base");if(typeof be!="string")throw(0,T.$7)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$LL=Si,e.$LL=Si=Je([E],Si);const qi=new WeakMap;function It(H,q){qi.set(H,q)}e.$ML=It;let ni=class{constructor(q,be,Fe,Xe){this.enabled=typeof q=="boolean"?q:!0,typeof be=="string"&&(this.condition=be),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=qi.get(this)??(0,M.$mg)()),this.c}};e.$NL=ni,e.$NL=ni=Je([E],ni);let $i=class extends ni{constructor(q,be,Fe,Xe,nt){if(super(be,Fe,Xe,nt),q===null)throw(0,T.$7)("location");this.location=q}};e.$OL=$i,e.$OL=$i=Je([E],$i);let ai=class extends ni{constructor(q,be,Fe,Xe,nt){super(be,Fe,Xe,nt),this.functionName=q}};e.$PL=ai,e.$PL=ai=Je([E],ai);let Di=class extends ni{constructor(q,be,Fe,Xe,nt,lt,ft){if(super(Xe,nt,lt,ft),!be)throw(0,T.$7)("dataId");this.label=q,this.dataId=be,this.canPersist=Fe}};e.$QL=Di,e.$QL=Di=Je([E],Di);let Ci=class{constructor(q,be,Fe){this.command=q,this.args=be||[],this.options=Fe}};e.$RL=Ci,e.$RL=Ci=Je([E],Ci);let Nt=class{constructor(q,be){this.port=q,this.host=be}};e.$SL=Nt,e.$SL=Nt=Je([E],Nt);let pi=class{constructor(q){this.path=q}};e.$TL=pi,e.$TL=pi=Je([E],pi);let Ii=class{constructor(q){this.implementation=q}};e.$UL=Ii,e.$UL=Ii=Je([E],Ii);let ci=class{constructor(q,be,Fe){this.session=q,this.threadId=be,this.frameId=Fe}};e.$VL=ci,e.$VL=ci=Je([E],ci);let li=class{constructor(q,be){this.session=q,this.threadId=be}};e.$WL=li,e.$WL=li=Je([E],li);let ht=class{constructor(q,be){this.range=q,this.expression=be}};e.$XL=ht,e.$XL=ht=Je([E],ht);var Vi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let xt=class{constructor(q,be){this.range=q,this.text=be}};e.$YL=xt,e.$YL=xt=Je([E],xt);let ri=class{constructor(q,be,Fe=!0){this.range=q,this.variableName=be,this.caseSensitiveLookup=Fe}};e.$ZL=ri,e.$ZL=ri=Je([E],ri);let di=class{constructor(q,be){this.range=q,this.expression=be}};e.$1L=di,e.$1L=di=Je([E],di);let Pi=class{constructor(q,be){this.frameId=q,this.stoppedLocation=be}};e.$2L=Pi,e.$2L=Pi=Je([E],Pi);var Hi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Ai=v=class extends Error{static FileExists(q){return new v(q,m.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(q){return new v(q,m.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(q){return new v(q,m.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(q){return new v(q,m.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(q){return new v(q,m.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(q){return new v(q,m.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(q,be=m.FileSystemProviderErrorCode.Unknown,Fe){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Fe?.name??"Unknown",(0,m.$Ak)(this,be),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$3L=Ai,e.$3L=Ai=v=Je([E],Ai);let bi=class{constructor(q,be,Fe){this.start=q,this.end=be,this.kind=Fe}};e.$4L=bi,e.$4L=bi=Je([E],bi);var Ki;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var Li;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Li||(e.CommentThreadCollapsibleState=Li={}));var ui;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Gi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ri{constructor(q,be=[]){this.tokenTypes=q,this.tokenModifiers=be}}e.$5L=Ri;function cn(H){return typeof H>"u"||(0,$.$Ff)(H)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let be=0,Fe=q.tokenTypes.length;be<Fe;be++)this.k.set(q.tokenTypes[be],be);for(let be=0,Fe=q.tokenModifiers.length;be<Fe;be++)this.l.set(q.tokenModifiers[be],be)}}push(q,be,Fe,Xe,nt){if(typeof q=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Xe=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.o(q,be,Fe,Xe,nt);if(j.isRange(q)&&typeof be=="string"&&cn(Fe))return this.n(q,be,Fe);throw(0,T.$7)()}n(q,be,Fe){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(be))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,nt=q.start.character,lt=q.end.character-q.start.character,ft=this.k.get(be);let qt=0;if(Fe)for(const Zt of Fe){if(!this.l.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Zt);qt|=1<<ti>>>0}this.o(Xe,nt,lt,ft,qt)}o(q,be,Fe,Xe,nt){if(this.f&&(q<this.c||q===this.c&&be<this.e)){this.f=!1;const qt=this.g.length/5|0;let Zt=0,ti=0;for(let ii=0;ii<qt;ii++){let oi=this.g[5*ii],Bi=this.g[5*ii+1];oi===0?(oi=Zt,Bi+=ti):oi+=Zt,this.g[5*ii]=oi,this.g[5*ii+1]=Bi,Zt=oi,ti=Bi}}let lt=q,ft=be;this.f&&this.j>0&&(lt-=this.c,lt===0&&(ft-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=ft,this.g[this.j++]=Fe,this.g[this.j++]=Xe,this.g[this.j++]=nt,this.c=q,this.e=be}static q(q){const be=[],Fe=q.length/5|0;for(let ft=0;ft<Fe;ft++)be[ft]=ft;be.sort((ft,qt)=>{const Zt=q[5*ft],ti=q[5*qt];if(Zt===ti){const ii=q[5*ft+1],oi=q[5*qt+1];return ii-oi}return Zt-ti});const Xe=new Uint32Array(q.length);let nt=0,lt=0;for(let ft=0;ft<Fe;ft++){const qt=5*be[ft],Zt=q[qt+0],ti=q[qt+1],ii=q[qt+2],oi=q[qt+3],Bi=q[qt+4],Sn=Zt-nt,On=Sn===0?ti-lt:ti,Wi=5*ft;Xe[Wi+0]=Sn,Xe[Wi+1]=On,Xe[Wi+2]=ii,Xe[Wi+3]=oi,Xe[Wi+4]=Bi,nt=Zt,lt=ti}return Xe}build(q){return this.f?new si(new Uint32Array(this.g),q):new si(Mi.q(this.g),q)}}e.$6L=Mi;class si{constructor(q,be){this.resultId=be,this.data=q}}e.$7L=si;class ln{constructor(q,be,Fe){this.start=q,this.deleteCount=be,this.data=Fe}}e.$8L=ln;class un{constructor(q,be){this.resultId=be,this.edits=q}}e.$9L=un;var Ji;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new vt("arrow-left")}}constructor(){}};e.$0L=fi,e.$0L=fi=Je([E],fi);var Qi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Yi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var gi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Zi{static validate(q){if(typeof q.badge=="string"){let be=(0,p.$ff)(q.badge,0);if(be<q.badge.length&&(be+=(0,p.$ff)(q.badge,be)),q.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!vt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,be,Fe){this.badge=q,this.tooltip=be,this.color=Fe}}e.$$L=Zi;let Fi=class{constructor(q){this.kind=q}};e.$_L=Fi,e.$_L=Fi=Je([E],Fi);var Ni;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ni||(e.ColorThemeKind=Ni={}));class _t{static isNotebookRange(q){return q instanceof _t?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,be){if(q<0)throw(0,T.$7)("start must be positive");if(be<0)throw(0,T.$7)("end must be positive");q<=be?(this.c=q,this.e=be):(this.c=be,this.e=q)}with(q){let be=this.c,Fe=this.e;return q.start!==void 0&&(be=q.start),q.end!==void 0&&(Fe=q.end),be===this.c&&Fe===this.e?this:new _t(be,Fe)}}e.$aM=_t;class wi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(be=>wi.isNotebookCellData(be))}static isNotebookCellData(q){return!0}constructor(q,be,Fe,Xe,nt,lt,ft){this.kind=q,this.value=be,this.languageId=Fe,this.mime=Xe,this.outputs=nt??[],this.metadata=lt,this.executionSummary=ft,wi.validate(this)}}e.$bM=wi;class hn{constructor(q){this.cells=q}}e.$cM=hn;class Yt{static isNotebookCellOutputItem(q){return q instanceof Yt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const be={name:q.name,message:q.message,stack:q.stack};return Yt.json(be,"application/vnd.code.notebook.error")}static stdout(q){return Yt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Yt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,be="application/octet-stream"){return new Yt(q,be)}static#e=new TextEncoder;static text(q,be=R.$3r.text){const Fe=Yt.#e.encode(String(q));return new Yt(Fe,be)}static json(q,be="text/x-json"){const Fe=JSON.stringify(q,void 0,"	");return Yt.text(Fe,be)}constructor(q,be){this.data=q,this.mime=be;const Fe=(0,R.$7r)(be,!0);if(!Fe)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$dM=Yt;class yi{static isNotebookCellOutput(q){return q instanceof yi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,be=!1){const Fe=new Set,Xe=new Set;for(let nt=0;nt<q.length;nt++){const lt=q[nt],ft=(0,R.$7r)(lt.mime);if(!Fe.has(ft)||(0,S.$QI)(ft)){Fe.add(ft);continue}Xe.add(nt),be&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Xe.size===0?q:q.filter((nt,lt)=>!Xe.has(lt))}constructor(q,be,Fe){this.items=yi.ensureUniqueMimeTypes(q,!0),typeof be=="string"?(this.id=be,this.metadata=Fe):(this.id=(0,M.$mg)(),this.metadata=be??Fe)}}e.$eM=yi;var Ei;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Ti;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ti||(e.NotebookCellExecutionState=Ti={}));var Be;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Be||(e.NotebookCellStatusBarAlignment=Be={}));var ei;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Xi{constructor(q,be){this.text=q,this.alignment=be}}e.$fM=Xi;var pt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(pt||(e.NotebookControllerAffinity=pt={}));var xi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(q,be=[]){this.uri=q,this.provides=(0,D.$3b)(be)}}e.$gM=dn;class _i{constructor(q){this.label=q}}e.$hM=_i;var en;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(q,be){this.label=q,this.timestamp=be}};e.$iM=hi,e.$iM=hi=Je([E],hi);var tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(q,be){this.ranges=q,this.wordPattern=be}}e.$jM=sn;class fn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$kM=fn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(q=void 0,be=void 0,Fe=void 0,Xe=!1){this.include=q,this.exclude=be,this.profile=Fe,this.continuous=Xe}};e.$lM=Oi,e.$lM=Oi=Je([E],Oi);let ji=b=class{static diff(q,be,Fe){const Xe=new b(q);return Xe.expectedOutput=be,Xe.actualOutput=Fe,Xe}constructor(q){this.message=q}};e.$mM=ji,e.$mM=ji=b=Je([E],ji);let zi=class{constructor(q){this.id=q}};e.$nM=zi,e.$nM=zi=Je([E],zi);class ki{constructor(q,be){this.covered=q,this.total=be}}e.$oM=ki;class Ui{static fromDetails(q,be){const Fe=new ki(0,0),Xe=new ki(0,0),nt=new ki(0,0);for(const ft of be)if("branches"in ft){Fe.total+=1,Fe.covered+=ft.executionCount>0?1:0;for(const qt of ft.branches)Xe.total+=1,Xe.covered+=qt.executionCount>0?1:0}else nt.total+=1,nt.covered+=ft.executionCount>0?1:0;const lt=new Ui(q,Fe,Xe.total>0?Xe:void 0,nt.total>0?nt:void 0);return lt.detailedCoverage=be,lt}constructor(q,be,Fe,Xe){this.uri=q,this.statementCoverage=be,this.branchCoverage=Fe,this.functionCoverage=Xe}}e.$pM=Ui;class gn{constructor(q,be,Fe=[]){this.executionCount=q,this.location=be,this.branches=Fe}}e.$qM=gn;class mn{constructor(q,be){this.executionCount=q,this.location=be}}e.$rM=mn;class $e{constructor(q,be,Fe){this.name=q,this.executionCount=be,this.location=Fe}}e.$sM=$e;var Ee;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ee||(e.ExternalUriOpenerPriority=Ee={}));var Ue;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(Ue||(e.WorkspaceTrustState=Ue={}));var ct;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(ct||(e.PortAutoForwardAction=ct={}));class bt{constructor(q,be,Fe,Xe,nt,lt){this.kind=q,this.name=be,this.detail=Fe,this.uri=Xe,this.range=nt,this.selectionRange=lt}}e.$tM=bt;class Tt{constructor(q){this.uri=q}}e.$uM=Tt;class Dn{constructor(q,be){this.original=q,this.modified=be}}e.$vM=Dn;class Cn{constructor(q,be,Fe,Xe){this.base=q,this.input1=be,this.input2=Fe,this.result=Xe}}e.$wM=Cn;class In{constructor(q,be){this.uri=q,this.viewType=be}}e.$xM=In;class Pn{constructor(q){this.viewType=q}}e.$yM=Pn;class An{constructor(q,be){this.uri=q,this.notebookType=be}}e.$zM=An;class Ln{constructor(q,be,Fe){this.original=q,this.modified=be,this.notebookType=Fe}}e.$AM=Ln;class Rn{constructor(){}}e.$BM=Rn;class Mn{constructor(q,be){this.uri=q,this.inputBoxUri=be}}e.$CM=Mn;class Fn{constructor(q){this.providerId=q}}e.$DM=Fn;var $n;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var bn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Nn{constructor(q,be){this.label=q,this.values=be}}e.$EM=Nn;var vn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}));var wn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class Tn{constructor(q,be){this.role=q,this.content=be}}e.$FM=Tn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var kn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(ke[141],Se([1,0,60,17,13,176,126,7,19]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=void 0;const y=new Map;function M(S,l){l?y.set(S,l):y.delete(S)}e.$SM=M;function C(S){return y.get(S)}class m extends I.$0u{constructor(l,f,s,i,n,o,a,t){super(f,s,i,n),this.c=l,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,$.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===T.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(f){return f?l.s(f):l.getText()},get eol(){return l.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(f){return l.t(f)},offsetAt(f){return l.u(f)},positionAt(f){return l.v(f)},validateRange(f){return l.w(f)},validatePosition(f){return l.x(f)},getWordRangeAtPosition(f,s){return l.y(f,s)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,D.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,D.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const f=this.w(l);if(f.isEmpty)return"";if(f.isSingleLine)return this.f[f.start.line].substring(f.start.character,f.end.character);const s=this.g,i=f.start.line,n=f.end.line,o=[];o.push(this.f[i].substring(f.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,f.end.character)),o.join(s)}t(l){let f;if(l instanceof p.$PK?f=l.line:typeof l=="number"&&(f=l),typeof f!="number"||f<0||f>=this.f.length||Math.floor(f)!==f)throw new Error("Illegal value for `line`");return new w(f,this.f[f],f===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const f=this.j.getIndexOf(l),s=this.f[f.index].length;return new p.$PK(f.index,Math.min(f.remainder,s))}w(l){if(!(l instanceof p.$QK))throw new Error("Invalid argument");const f=this.x(l.start),s=this.x(l.end);return f===l.start&&s===l.end?l:new p.$QK(f.line,f.character,s.line,s.character)}x(l){if(!(l instanceof p.$PK))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:f,character:s}=l,i=!1;if(f<0)f=0,s=0,i=!0;else if(f>=this.f.length)f=this.f.length-1,s=this.f[f].length,i=!0;else{const n=this.f[f].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new p.$PK(f,s):l}y(l,f){const s=this.x(l);if(!f)f=C(this.m);else if((0,g.$Ue)(f))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${f.source}' because it matches the empty string.`);const i=(0,R.$is)(s.character+1,(0,R.$gs)(f),this.f[s.line],0);if(i)return new p.$QK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$TM=m;class w{constructor(l,f,s){this.a=l,this.b=f,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$QK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$QK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$UM=w}),define(ke[285],Se([1,0,7,20,4]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;let I=class{constructor(p){this.a=new D.$_L(D.ColorThemeKind.Dark),this.b=new g.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(p){let $;switch(p){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$_L($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$3gc=I,e.$3gc=I=Je([We(0,T.$QM)],I)}),define(ke[286],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.CellExecutionUpdateType=void 0;var T;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$UI=(0,D.$2h)("INotebookExecutionService")}),define(ke[287],Se([1,0,3,29,193,99]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Pb=void 0;class R extends D.$Sc{constructor($,y,M){super(),this._source=$,this.b=y,this.c=M,this.a=void 0}f($){const y=$.getLineCount();return new T.$Gs(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$WB;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:M,disposable:C}=y.create(1);this.b=M,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$WB;y.acceptChunk($);const M=y.finish(!0),{textBuffer:C,disposable:m}=M.create(1);return this.B(m),C})),this.a}findInInputs($){const M=new I.$KB($,!1,!1,null).parseSearchRequest();if(!M)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,M,!0,5e3)}findInOutputs($){const M=new I.$KB($,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),M,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$4Pb=R}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var T;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class g{static fromExtHostTestItem(R,p,$=R.parent){if(R._isRoot)return new g([p]);const y=[R.id];for(let M=$;M&&M.id!==p;M=M.parent)y.push(M.id);return y.push(p),new g(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const p=R.indexOf("\0");return p===-1?R:R.slice(0,p)}static fromString(R){return new g(R.split("\0"))}static join(R,p){return new g([...R.path,p])}static joinToString(R,p){return R.toString()+"\0"+p}static parentId(R){const p=R.lastIndexOf("\0");return p===-1?void 0:R.slice(0,p)}static localId(R){const p=R.lastIndexOf("\0");return p===-1?R:R.slice(p+1)}static isChild(R,p){return p.startsWith(R)&&p[R.length]==="\0"}static compare(R,p){return R===p?0:g.isChild(R,p)?2:g.isChild(p,R)?3:1}constructor(R,p=R.length){if(this.path=R,this.d=p,R.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new g(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new g(this.path,R)}compare(R){if(typeof R=="string")return g.compare(this.toString(),R);for(let p=0;p<R.d&&p<this.d;p++)if(R.path[p]!==this.path[p])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$EJ=g}),define(ke[89],Se([1,0,2,49,29,67]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$LJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$KJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$JJ=e.$IJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$HJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$GJ=e.$FJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var p;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var $;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$FJ=[2,4,8,16,32,64];const y=N=>"runId"in N;e.$GJ=y;var M;(function(N){N.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),N.deserialize=F=>({range:g.$Gs.lift(F.range),uri:D.URI.revive(F.uri)})})(M||(e.IRichLocation=M={}));var C;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(N){N.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&M.serialize(F.location)}),N.deserialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&M.deserialize(F.location)})})(m||(e.ITestErrorMessage=m={}));const w=(N,F)=>`${F?"s":"e"}${N}`;e.$HJ=w;var S;(function(N){N.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&M.serialize(F.location)}),N.deserialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&M.deserialize(F.location)})})(S||(e.ITestOutputMessage=S={}));var l;(function(N){N.serialize=F=>F.type===0?m.serialize(F):S.serialize(F),N.deserialize=F=>F.type===0?m.deserialize(F):S.deserialize(F)})(l||(e.ITestMessage=l={}));var f;(function(N){N.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),N.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(l.serialize)}),N.deserialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(l.deserialize)})})(f||(e.ITestTaskState=f={}));const s="\0",i=(N,F)=>N+s+F;e.$IJ=i;const n=N=>{const F=N.indexOf(s);return{ctrlId:N.slice(0,F),tagId:N.slice(F+1)}};e.$JJ=n;var o;(function(N){N.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),N.deserialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?D.URI.revive(F.uri):void 0,range:F.range?g.$Gs.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(o||(e.ITestItem=o={}));var a;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(N){N.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),N.deserialize=F=>({controllerId:I.$EJ.root(F.item.extId),expand:F.expand,item:o.deserialize(F.item)})})(t||(e.InternalTestItem=t={}));var r;(function(N){N.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},N.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?g.$Gs.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const d=(N,F)=>{F.expand!==void 0&&(N.expand=F.expand),F.item!==void 0&&(N.item=N.item?Object.assign(N.item,F.item):F.item)};e.$KJ=d;var u;(function(N){N.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serializeWithoutMessages)}),N.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.serialize)}),N.deserialize=F=>({...t.deserialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(f.deserialize),retired:!0})})(u||(e.TestResultItem=u={}));var c;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(c||(e.ICoveredCount=c={}));var h;(function(N){N.serialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(b.serialize),uri:F.uri.toJSON()}),N.deserialize=F=>({statement:F.statement,branch:F.branch,function:F.function,details:F.details?.map(b.deserialize),uri:D.URI.from(F.uri)})})(h||(e.IFileCoverage=h={}));function k(N){return{...N,location:N.location?.toJSON()}}function L(N){return N.location=N.location?T.$Fs.isIPosition(N.location)?T.$Fs.lift(N.location):g.$Gs.lift(N.location):void 0,N}e.$LJ=3;var v;(function(N){N[N.Function=0]="Function",N[N.Statement=1]="Statement"})(v||(e.DetailType=v={}));var b;(function(N){N.serialize=F=>F.type===0?A.serialize(F):z.serialize(F),N.deserialize=F=>F.type===0?A.deserialize(F):z.deserialize(F)})(b||(e.CoverageDetails=b={}));var E;(function(N){N.serialize=k,N.deserialize=L})(E||(e.IBranchCoverage=E={}));var A;(function(N){N.serialize=k,N.deserialize=L})(A||(e.IFunctionCoverage=A={}));var z;(function(N){N.serialize=F=>({...k(F),branches:F.branches?.map(E.serialize)}),N.deserialize=F=>({...L(F),branches:F.branches?.map(E.deserialize)})})(z||(e.IStatementCoverage=z={}));var O;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var P;(function(N){N.deserialize=F=>F.op===0?{op:F.op,item:t.deserialize(F.item)}:F.op===1?{op:F.op,item:r.deserialize(F.item)}:F.op===2?{op:F.op,uri:D.URI.revive(F.uri),docv:F.docv}:F,N.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:r.serialize(F.item)}:F})(P||(e.TestsDiffOp=P={}));class j{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(F){const W=this.o();for(const x of F)switch(x.op){case 0:this.j(t.deserialize(x.item),W);break;case 1:this.k(r.deserialize(x.item),W);break;case 3:this.l(x.itemId,W);break;case 5:this.m(x.itemId);break;case 4:this.updatePendingRoots(x.amount);break;case 6:this.c.set(x.tag.id,x.tag);break;case 7:this.c.delete(x.id);break}W.complete?.()}j(F,W){const x=I.$EJ.parentId(F.item.extId)?.toString();let ce;if(!x)ce=this.p(F),this.f.add(ce),this.d.set(F.item.extId,ce);else if(this.d.has(x)){const J=this.d.get(x);J.children.add(F.item.extId),ce=this.p(F,J),this.d.set(F.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(ce),F.expand===2&&this.g++,ce}k(F,W){const x=this.d.get(F.extId);if(x)return F.expand!==void 0&&(x.expand===2&&this.g--,F.expand===2&&this.g++),(0,e.$KJ)(x,F),W.update?.(x),x}l(F,W){const x=this.d.get(F);if(!x)return;const ce=I.$EJ.parentId(x.item.extId)?.toString();ce?this.d.get(ce).children.delete(x.item.extId):this.f.delete(x);const J=[[F]];for(;J.length;)for(const Y of J.pop()){const X=this.d.get(Y);X&&(J.push(X.children),this.d.delete(Y),W.remove?.(X,X!==x),X.expand===2&&this.g--)}}m(F){}updatePendingRoots(F){this.h+=F}o(){return{}}}e.$MJ=j}),define(ke[112],Se([1,0,12,4,3,60,89,67]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),m=(i,n)=>{let o;for(const[a,t]of C)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class w extends g.$Sc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$bh(()=>this.flushDiff(),200)),this.g=this.B(new T.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$KJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$KJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(p.$EJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,I.$5c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=p.$EJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const d=this.s.getChildren(r.actual),u=r.actual,c=m(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(n,r,o);for(const[h,k]of d)this.s.getChildren(n).get(k.id)||this.N(p.$EJ.joinToString(a,k.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,R.$IJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$IJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$IJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const d=this.expand(p.$EJ.joinToString(n.fullId,r.id),o);(0,D.$Og)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$1g;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new D.$1g,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,D.$Og)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,d]of this.s.getChildren(t.actual))a.push(this.tree.get(p.$EJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$GM=w;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$HM=S;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$IM=l;class f extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$JM=f;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const d of a.values())t.call(r,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,d=new Set(a.keys()),u={op:5,ops:[]};for(const c of t){if(!(c instanceof o))throw new l(c.id);const h=n(c).controllerId;if(h!==i.controllerId)throw new f(c.id,h,i.controllerId);if(r.has(c.id))throw new S(c.id);r.set(c.id,c),d.delete(c.id),u.ops.push({op:0,item:c})}for(const c of d.keys())u.ops.push({op:3,id:c});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new l(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$KM=s}),define(ke[142],Se([1,0,112]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;const T=new WeakMap,g=(R,p)=>{const $={controllerId:p};return T.set(R,$),$};e.$LM=g;const I=R=>{const p=T.get(R);if(!p)throw new D.$IM(R?.id||"<unknown>");return p};e.$MM=I}),define(ke[113],Se([1,0,17,2]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gvb=e.$fvb=e.$evb=e.$dvb=e.$cvb=void 0,e.$cvb="vscode-cdn.net",e.$dvb=`vscode-resource.${e.$cvb}`,e.$evb=`'self' https://*.${e.$cvb}`;function g(p,$){return p.scheme===D.Schemas.http||p.scheme===D.Schemas.https?p:($&&$.authority&&$.isRemote&&p.scheme===D.Schemas.file&&(p=T.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:p.path})),T.URI.from({scheme:D.Schemas.https,authority:`${p.scheme}+${I(p.authority)}.${e.$dvb}`,path:p.path,fragment:p.fragment,query:p.query}))}e.$fvb=g;function I(p){return p.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$gvb=R}),define(ke[288],Se([1,0,4,3,113]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;class I{constructor(p,$,y){this.d=p,this.e=$,this.f=y,this.a=0,this.b=new T.$Rc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const M=$.getVisibleTextEditors();for(const C of this.c.values())M.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,$,y,M,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){m=n;break}if(!m)throw new Error("not a visible editor");const w=this,S=this.a++,l=new D.$Sd,f=new D.$Sd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$fvb)(n,w.f)}get cspSource(){return g.$evb}set options(n){this.b=n,w.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(n){return w.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=p,this.line=$,this.height=y,this.webview=s,this.onDidDispose=f.event}dispose(){w.c.has(S)&&(w.c.delete(S),w.d.$disposeEditorInset(S),f.fire(),f.dispose(),l.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,$+1,y,M||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:p,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(p){const $=this.c.get(p);$&&$.inset.dispose()}$onDidReceiveMessage(p,$){this.c.get(p)?.onDidReceiveMessage.fire($)}}e.$mfc=I}),define(ke[289],Se([1,0,5]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.VariableKind=e.$CN=void 0,e.$CN=(0,D.$2h)("configurationResolverService");var T;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class g extends Error{constructor(R,p){super(p),this.variable=R}}e.$DN=g}),define(ke[290],Se([1,0,16,50,18,24,11,102,232,289,13]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,S,l,f){this.h=new Map,this.a=w,this.b=S,this.g=l,f&&(this.c=f.then(s=>this.i(s)))}i(w){if(R.$i){const S=Object.create(null);return Object.keys(w).forEach(l=>{S[l.toLowerCase()]=w[l]}),S}return w}resolveWithEnvironment(w,S,l){return this.l({env:this.i(w),userHome:void 0},S?S.uri:void 0,l)}async resolveAsync(w,S){const l={env:await this.c,userHome:await this.g};return this.l(l,w?w.uri:void 0,S)}async j(w,S,l,f){const s=I.$hn(S);R.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):R.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):R.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,w?w.uri:void 0,s,l,f)}async resolveAnyAsync(w,S,l){return this.j(w,S,l)}async resolveAnyMap(w,S,l){const f=new Map;return{newConfig:await this.j(w,S,l,f),resolvedVariables:f}}resolveWithInteractionReplace(w,S,l,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,S,l,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,S){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,S)}async l(w,S,l,f,s){if(g.$Ef(l))return this.m(w,S,l,f,s);if(Array.isArray(l))return Promise.all(l.map(i=>this.l(w,S,i,f,s)));if(g.$Gf(l)){const i=Object.create(null),n=await Promise.all(Object.keys(l).map(async o=>[await this.m(w,S,o,f,s),await this.l(w,S,l[o],f,s)]));for(const[o,a]of n)i[o]=a;return i}return l}m(w,S,l,f,s){return(0,M.$Ze)(l,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let o=await this.o(w,i,n,S,f);return s?.set(n,o),o!==i&&g.$Ef(o)&&o.match(C.VARIABLE_REGEXP)&&(o=await this.m(w,S,o,f,s)),o})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,S,l,f,s){let i;const n=l.split(":");n.length>1&&(l=n[0],i=n[1]);const o=r=>{const d=this.a.getFilePath();if(d)return(0,p.$Hv)(d);throw new y.$DN(r,(0,$.localize)(0,null,S))},a=r=>{const d=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,p.$Hv)(u)}throw new y.$DN(r,(0,$.localize)(1,null,S,D.$nc(d)))},t=r=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new y.$DN(r,(0,$.localize)(2,null,S,i))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new y.$DN(r,(0,$.localize)(3,null,S)):new y.$DN(r,(0,$.localize)(4,null,S))};switch(l){case"env":if(i){if(w.env){const r=w.env[R.$i?i.toLowerCase():i];if(g.$Ef(r))return r}return""}throw new y.$DN(y.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const r=this.a.getConfigurationValue(f,i);if(g.$Nf(r))throw new y.$DN(y.VariableKind.Config,(0,$.localize)(6,null,S,i));if(g.$Gf(r))throw new y.$DN(y.VariableKind.Config,(0,$.localize)(7,null,S,i));return r}throw new y.$DN(y.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,s,"command");case"input":return this.p(y.VariableKind.Input,S,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$DN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(r.extensionLocation)}throw new y.$DN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,p.$Hv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return f||i?(0,p.$Hv)(this.n(t(y.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Hv)(D.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new y.$DN(y.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$DN(y.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$DN(y.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return o(y.VariableKind.File);case"fileWorkspaceFolder":return a(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$nc(a(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||i?D.$lc(this.n(t(y.VariableKind.RelativeFile)),o(y.VariableKind.RelativeFile)):o(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$mc(o(y.VariableKind.RelativeFileDirname));if(f||i){const d=D.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return d.length===0?".":d}return r}case"fileDirname":return D.$mc(o(y.VariableKind.FileDirname));case"fileExtname":return D.$oc(o(y.VariableKind.FileExtname));case"fileBasename":return D.$nc(o(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$nc(o(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$oc(r).length)}case"fileDirnameBasename":return D.$nc(D.$mc(o(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||S}case"execInstallFolder":{const r=this.a.getAppRoot();return r||S}case"pathSeparator":return D.sep;default:try{const r=i?`${l}:${i}`:l;return this.p(y.VariableKind.Unknown,S,r,s,void 0)}catch{return S}}}}p(w,S,l,f,s){if(l&&f){const i=s===void 0?f[l]:f[s+":"+l];if(typeof i=="string")return i;throw new y.$DN(w,(0,$.localize)(14,null,S))}return S}}e.$RN=C}),define(ke[143],Se([1,0,5,139]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.OpenEditorContext=e.GroupsOrder=e.$RC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$QC=void 0,e.$QC=(0,D.$2h)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var p;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(S){const l=S;return(0,T.$zE)(l?.editor)&&(0,T.$zE)(l?.replacement)}e.$RC=y;var M;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const l=S;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.$SC=m;function w(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$TC=w}),define(ke[291],Se([1,0,5,143]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XC=e.$WC=e.$VC=e.$UC=void 0,e.$UC=(0,D.$2h)("editorService"),e.$VC=-1,e.$WC=-2;function g(I){const R=I;return typeof I=="number"||(0,T.$SC)(R)}e.$XC=g}),define(ke[144],Se([1,0,5,133]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0J=void 0,e.$0J=(0,D.$3h)(T.$9h)}),define(ke[145],Se([1,0,26,4,16,3]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=e.$g7b=e.$f7b=e.$e7b=e.$d7b=void 0;class R{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$d7b=R;class p{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new T.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$im,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=l(this.e,i),this.e=this.e.concat(s);const n=p.l(this.e);return this.e=l(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,d){this.addNode(r),this.addNode(d),this.c.has(r)?this.c.get(r).push(d):this.c.set(r,[d])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,d){const u=i.getArcs(r);for(let c=0;c<u.length;c++)if(!d.has(u[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$im;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const d of r.extensionDependencies)i.addArc(D.$gm.toKey(r.identifier),D.$gm.toKey(d));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const d=a[r];i.hasOnlyGoodArcs(d,o)&&(a.splice(r,1),r--,o.add(d),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$e7b=p;class ${constructor(s,i){this.versionId=s,this.extensions=i}}e.$f7b=$;class y{constructor(s){this.d=new m,this.c=new p(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new M(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$g7b=y;class M extends I.$Sc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$h7b=M;class C{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class m{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new C(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,I.$Qc)(o))}}var w;(function(f){f[f.Builtin=0]="Builtin",f[f.User=1]="User",f[f.Dev=2]="Dev"})(w||(w={}));function S(f,s){const i=f.isBuiltin?0:f.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=g.$gc.basename(f.extensionLocation.path),a=g.$gc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function l(f,s){const i=new D.$hm(s);return f.filter(n=>!i.has(n.identifier))}}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.ExtHostConnectionType=void 0;var D;(function(M){M[M.IPC=1]="IPC",M[M.Socket=2]="Socket",M[M.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[T.ENV_KEY]=this.pipeName}}e.$Km=T;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Lm=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Mm=I;function R(M){delete M[T.ENV_KEY],delete M[g.ENV_KEY],delete M[I.ENV_KEY]}function p(M,C){R(C),M.serialize(C)}e.$Nm=p;function $(M){if(M[T.ENV_KEY])return y(M,new T(M[T.ENV_KEY]));if(M[g.ENV_KEY])return y(M,new g);if(M[I.ENV_KEY])return y(M,new I);throw new Error("No connection information defined in environment!")}e.$Om=$;function y(M,C){return R(M),C}}),define(ke[114],Se([1,0,22]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$pm=e.$om=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(T||(e.UIKind=T={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function R(y){const M=D.$ge.alloc(1);switch(y){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$om=R;function p(y,M){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$pm=p;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=e.$0M=e.$9M=e.$8M=void 0;let w=class extends C.$Sc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new T.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Bo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,g.$lj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new S(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$9k)((0,$.$Io)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$8M=w,e.$8M=w=Je([We(0,I.$7M),We(1,g.$kj)],w);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new T.$Sd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$Lo)(i,[]),this.c&&(i=(0,y.$kn)(i,this.c)),this.b||(i=(0,y.$kn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,$.$Lo)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$9M=S;function l(f){const s=Date.now()-new Date(f).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$0M=l,e.$$M=(0,D.$2h)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,262,137,26,5]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=e.$nF=e.ActivationKind=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.ExtensionHostStartup=e.$hF=e.$gF=e.$fF=e.$eF=void 0,e.$eF=Object.freeze({identifier:new R.$gm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$fF="extensions.webWorker",e.$gF=(0,p.$2h)("extensionService");class ${constructor(a){this.dependency=a}}e.$hF=$;var y;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$2E.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],u=[],c=[],h=[],k=C(this.d),L=C(t),v=(O,P)=>O.extensionLocation.toString()===P.extensionLocation.toString()||O.isBuiltin===P.isBuiltin||O.isUserBuiltin===P.isUserBuiltin||O.isUnderDevelopment===P.isUnderDevelopment;for(const O of this.d){const P=L.get(O.identifier);if(!P){d.push(O.identifier),k.delete(O.identifier);continue}if(!v(O,P)){d.push(O.identifier),k.delete(O.identifier);continue}}for(const O of t){const P=k.get(O.identifier);if(!P){u.push(O);continue}if(!v(P,O)){d.push(P.identifier),k.delete(P.identifier);continue}}const b=new R.$hm(this.e),E=new R.$hm(r);for(const O of this.e)E.has(O)||c.push(O);for(const O of r)b.has(O)||h.push(O);const A=I.$2E.createActivationEventsMap(u),z={versionId:a,toRemove:d,toAdd:u,addActivationEvents:A,myToRemove:c,myToAdd:h};return this.delta(z),z}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:d,myToAdd:u}=a,c=new R.$hm(t),h=new R.$hm(d);for(let k=0;k<this.d.length;k++)c.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)h.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of u)this.e.push(k);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$gm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=I.$2E.readActivationEvents(t);for(const d of r)a.add(d)}return a}}e.$iF=M;function C(o){const a=new R.$im;for(const t of o)a.set(t.identifier,t);return a}function m(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$jF=m;function w(o,a){if(!m(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$kF=w;class S{constructor(a,t,r,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=d}}e.$lF=S;class l{constructor(a,t){this.description=a,this.value=t}}e.$mF=l;var f;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(f||(e.ActivationKind=f={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,g.$Ro)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$nF=s;function i(o,a){return{identifier:new R.$gm((0,g.$Po)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$oF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$pF=n}),define(ke[293],Se([1,0,8,145,26,25,14,12]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=e.$Lfc=e.$Kfc=e.$Jfc=e.$Ifc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Ifc=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jfc=y;class M{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$Kfc=M;class C extends M{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lfc=C;class m extends M{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Mfc=m;class w extends M{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new g.$im,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new w(a));return this.c.onExtensionActivationError(s.id,a,new I.$hF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const d=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),c=this.k(s,i.displayName,[],new w(u));return this.c.onExtensionActivationError(i.identifier,u,new I.$hF(a)),c}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new l(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return T.$e7b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Nfc=S,e.$Nfc=S=Je([We(3,R.$jj)],S);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new p.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new w(i),this.b&&D.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};l=Je([We(6,R.$jj)],l)}),define(ke[15],Se([1,0,19,22,165,74,80,28,160,54,100,24,18,2,29,83,135,142,139,111,67,89,291,7,25]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$PM=e.$OM=e.MarkdownString=e.$NM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Me){function Te(re){const{selectionStartLineNumber:Ne,selectionStartColumn:Ve,positionLineNumber:xe,positionColumn:Ge}=re,rt=new r.$PK(Ne-1,Ve-1),mt=new r.$PK(xe-1,Ge-1);return new r.$RK(rt,mt)}Me.to=Te;function Ce(re){const{anchor:Ne,active:Ve}=re;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Ce})(u||(e.Selection=u={}));var c;(function(Me){function Te(re){if(!re)return;const{start:Ne,end:Ve}=re;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Te;function Ce(re){if(!re)return;const{startLineNumber:Ne,startColumn:Ve,endLineNumber:xe,endColumn:Ge}=re;return new r.$QK(Ne-1,Ve-1,xe-1,Ge-1)}Me.to=Ce})(c||(e.Range=c={}));var h;(function(Me){function Te(Ce){switch(Ce){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Me.to=Te})(h||(e.TokenType=h={}));var k;(function(Me){function Te(re){return new r.$PK(re.lineNumber-1,re.column-1)}Me.to=Te;function Ce(re){return{lineNumber:re.line+1,column:re.character+1}}Me.from=Ce})(k||(e.Position=k={}));var L;(function(Me){function Te(Ne,Ve,xe){return(0,D.$Hb)((0,D.$3b)(Ne).map(Ge=>Ce(Ge,Ve,xe)))}Me.from=Te;function Ce(Ne,Ve,xe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:xe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:re(Ne.scheme,Ve),pattern:oe.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:xe?.isBuiltin}}function re(Ne,Ve){return Ve&&typeof Ne=="string"?Ve.transformOutgoingScheme(Ne):Ne}})(L||(e.DocumentSelector=L={}));var v;(function(Me){function Te(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Ce(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})(v||(e.DiagnosticTag=v={}));var b;(function(Me){function Te(re){let Ne;return re.code&&((0,m.$Ef)(re.code)||(0,m.$If)(re.code)?Ne=String(re.code):Ne={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Ne,severity:A.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,D.$Hb)(re.tags.map(v.from)):void 0}}Me.from=Te;function Ce(re){const Ne=new r.$3K(c.to(re),re.message,A.to(re.severity));return Ne.source=re.source,Ne.code=(0,m.$Ef)(re.code)?re.code:re.code?.value,Ne.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Ne.tags=re.tags&&(0,D.$Hb)(re.tags.map(v.to)),Ne}Me.to=Ce})(b||(e.Diagnostic=b={}));var E;(function(Me){function Te(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Me.from=Te;function Ce(re){return new r.$2K(new r.$1K(re.resource,c.to(re)),re.message)}Me.to=Ce})(E||(e.DiagnosticRelatedInformation=E={}));var A;(function(Me){function Te(re){switch(re){case r.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}Me.from=Te;function Ce(re){switch(re){case f.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Me.to=Ce})(A||(e.DiagnosticSeverity=A={}));var z;(function(Me){function Te(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.$WC:t.$VC}Me.from=Te;function Ce(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(z||(e.ViewColumn=z={}));function O(Me){return typeof Me.range<"u"}function P(Me){return Me.length===0?!0:!!O(Me[0])}e.$NM=P;var j;(function(Me){function Te(Ge){return Ge.map(Me.from)}Me.fromMany=Te;function Ce(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function re(Ge){let rt;if(Ce(Ge)){const{language:Ct,value:vt}=Ge;rt={value:"```"+Ct+`
`+vt+"\n```\n"}}else r.$dL.isMarkdownString(Ge)?rt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?rt={value:Ge}:rt={value:""};const mt=Object.create(null);rt.uris=mt;const zt=Ct=>{try{let vt=w.URI.parse(Ct,!0);vt=vt.with({query:Ne(vt.query,mt)}),mt[Ct]=vt}catch{}return""},Et=new $.marked.Renderer;return Et.link=zt,Et.image=Ct=>typeof Ct=="string"?zt(R.$kk(Ct).href):"",(0,$.marked)(rt.value,{renderer:Et}),rt}Me.from=re;function Ne(Ge,rt){if(!Ge)return Ge;let mt;try{mt=(0,y.$xh)(Ge)}catch{}if(!mt)return Ge;let zt=!1;return mt=(0,C.$jn)(mt,Et=>{if(w.URI.isUri(Et)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Ct]=Et,zt=!0,Ct}else return}),zt?JSON.stringify(mt):Ge}function Ve(Ge){const rt=new r.$dL(Ge.value,Ge.supportThemeIcons);return rt.isTrusted=Ge.isTrusted,rt.supportHtml=Ge.supportHtml,rt.baseUri=Ge.baseUri?w.URI.from(Ge.baseUri):void 0,rt}Me.to=Ve;function xe(Ge){if(Ge)return typeof Ge=="string"?Ge:Me.from(Ge)}Me.fromStrict=xe})(j||(e.MarkdownString=j={}));function N(Me){return P(Me)?Me.map(Te=>({range:c.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?j.fromMany(Te.hoverMessage):Te.hoverMessage?j.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:c.from(Te)}))}e.$OM=N;function F(Me){return typeof Me>"u"?Me:typeof Me=="string"?w.URI.file(Me):Me}e.$PM=F;var W;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?F(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Te})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var x;(function(Me){function Te(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?F(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Te})(x||(e.ThemableDecorationRenderOptions=x={}));var ce;(function(Me){function Te(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(ce||(e.DecorationRangeBehavior=ce={}));var J;(function(Me){function Te(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ce.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?x.from(Ce.light):void 0,dark:Ce.dark?x.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?F(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Te})(J||(e.DecorationRenderOptions=J={}));var Y;(function(Me){function Te(re){return{text:re.newText,eol:re.newEol&&Ie.from(re.newEol),range:c.from(re.range)}}Me.from=Te;function Ce(re){const Ne=new r.$VK(c.to(re.range),re.text);return Ne.newEol=typeof re.eol>"u"?void 0:Ie.to(re.eol),Ne}Me.to=Ce})(Y||(e.TextEdit=Y={}));var X;(function(Me){function Te(re,Ne){const Ve={edits:[]};if(re instanceof r.$YK){const xe=new p.$Bc;for(const Ge of re._allEntries())Ge._type===1&&w.URI.isUri(Ge.to)&&Ge.from===void 0&&xe.add(Ge.to);for(const Ge of re._allEntries())if(Ge._type===1){let rt;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?rt={type:"base64",value:(0,T.$Ae)(T.$ge.wrap(Ge.options.contents))}:rt={type:"dataTransferItem",id:Ge.options.contents._itemId}),Ve.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:rt},metadata:Ge.metadata})}else Ge._type===2?Ve.edits.push({resource:Ge.uri,textEdit:Y.from(Ge.edit),versionId:xe.has(Ge.uri)?void 0:Ne?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Ve.edits.push({resource:Ge.uri,textEdit:{range:c.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:xe.has(Ge.uri)?void 0:Ne?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Ve.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(wt.from)}})}return Ve}Me.from=Te;function Ce(re){const Ne=new r.$YK,Ve=new p.$Ac;for(const xe of re.edits)if(xe.textEdit){const Ge=xe,rt=w.URI.revive(Ge.resource),mt=c.to(Ge.textEdit.range),zt=Ge.textEdit.text,Et=Ge.textEdit.insertAsSnippet;let Ct;Et?Ct=r.$XK.replace(mt,new r.$ZK(zt)):Ct=r.$VK.replace(mt,zt);const vt=Ve.get(rt);vt?vt.push(Ct):Ve.set(rt,[Ct])}else Ne.renameFile(w.URI.revive(xe.oldResource),w.URI.revive(xe.newResource),xe.options);for(const[xe,Ge]of Ve)Ne.set(xe,Ge);return Ne}Me.to=Ce})(X||(e.WorkspaceEdit=X={}));var se;(function(Me){const Te=Object.create(null);Te[r.SymbolKind.File]=0,Te[r.SymbolKind.Module]=1,Te[r.SymbolKind.Namespace]=2,Te[r.SymbolKind.Package]=3,Te[r.SymbolKind.Class]=4,Te[r.SymbolKind.Method]=5,Te[r.SymbolKind.Property]=6,Te[r.SymbolKind.Field]=7,Te[r.SymbolKind.Constructor]=8,Te[r.SymbolKind.Enum]=9,Te[r.SymbolKind.Interface]=10,Te[r.SymbolKind.Function]=11,Te[r.SymbolKind.Variable]=12,Te[r.SymbolKind.Constant]=13,Te[r.SymbolKind.String]=14,Te[r.SymbolKind.Number]=15,Te[r.SymbolKind.Boolean]=16,Te[r.SymbolKind.Array]=17,Te[r.SymbolKind.Object]=18,Te[r.SymbolKind.Key]=19,Te[r.SymbolKind.Null]=20,Te[r.SymbolKind.EnumMember]=21,Te[r.SymbolKind.Struct]=22,Te[r.SymbolKind.Event]=23,Te[r.SymbolKind.Operator]=24,Te[r.SymbolKind.TypeParameter]=25;function Ce(Ne){return typeof Te[Ne]=="number"?Te[Ne]:6}Me.from=Ce;function re(Ne){for(const Ve in Te)if(Te[Ve]===Ne)return Number(Ve);return r.SymbolKind.Property}Me.to=re})(se||(e.SymbolKind=se={}));var Z;(function(Me){function Te(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Me.from=Te;function Ce(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Me.to=Ce})(Z||(e.SymbolTag=Z={}));var we;(function(Me){function Te(re){return{name:re.name,kind:se.from(re.kind),tags:re.tags&&re.tags.map(Z.from),containerName:re.containerName,location:ye.from(re.location)}}Me.from=Te;function Ce(re){const Ne=new r.$7K(re.name,se.to(re.kind),re.containerName,ye.to(re.location));return Ne.tags=re.tags&&re.tags.map(Z.to),Ne}Me.to=Ce})(we||(e.WorkspaceSymbol=we={}));var de;(function(Me){function Te(re){const Ne={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:se.from(re.kind),tags:re.tags?.map(Z.from)??[]};return re.children&&(Ne.children=re.children.map(Te)),Ne}Me.from=Te;function Ce(re){const Ne=new r.$8K(re.name,re.detail,se.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,D.$Lb)(re.tags)&&(Ne.tags=re.tags.map(Z.to)),re.children&&(Ne.children=re.children.map(Ce)),Ne}Me.to=Ce})(de||(e.DocumentSymbol=de={}));var K;(function(Me){function Te(re){const Ne=new r.$_K(se.to(re.kind),re.name,re.detail||"",w.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Me.to=Te;function Ce(re,Ne,Ve){if(Ne=Ne??re._sessionId,Ve=Ve??re._itemId,Ne===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ve,name:re.name,detail:re.detail,kind:se.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Me.from=Ce})(K||(e.CallHierarchyItem=K={}));var B;(function(Me){function Te(Ce){return new r.$aL(K.to(Ce.from),Ce.fromRanges.map(re=>c.to(re)))}Me.to=Te})(B||(e.CallHierarchyIncomingCall=B={}));var ne;(function(Me){function Te(Ce){return new r.$bL(K.to(Ce.to),Ce.fromRanges.map(re=>c.to(re)))}Me.to=Te})(ne||(e.CallHierarchyOutgoingCall=ne={}));var ye;(function(Me){function Te(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Me.from=Te;function Ce(re){return new r.$1K(w.URI.revive(re.uri),c.to(re.range))}Me.to=Ce})(ye||(e.location=ye={}));var he;(function(Me){function Te(re){const Ne=re,Ve=re;return{originSelectionRange:Ne.originSelectionRange?c.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Ve.uri,range:c.from(Ne.targetRange?Ne.targetRange:Ve.range),targetSelectionRange:Ne.targetSelectionRange?c.from(Ne.targetSelectionRange):void 0}}Me.from=Te;function Ce(re){return{targetUri:w.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Me.to=Ce})(he||(e.DefinitionLink=he={}));var ge;(function(Me){function Te(re){return{range:c.from(re.range),contents:j.fromMany(re.contents)}}Me.from=Te;function Ce(re){return new r.$4K(re.contents.map(j.to),c.to(re.range))}Me.to=Ce})(ge||(e.Hover=ge={}));var _;(function(Me){function Te(re){return{range:c.from(re.range),expression:re.expression}}Me.from=Te;function Ce(re){return new r.$XL(c.to(re.range),re.expression)}Me.to=Ce})(_||(e.EvaluatableExpression=_={}));var ie;(function(Me){function Te(re){if(re instanceof r.$YL)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof r.$ZL)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.$1L)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Ce(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Me.to=Ce})(ie||(e.InlineValue=ie={}));var G;(function(Me){function Te(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Me.from=Te;function Ce(re){return new r.$2L(re.frameId,c.to(re.stoppedLocation))}Me.to=Ce})(G||(e.InlineValueContext=G={}));var te;(function(Me){function Te(re){return{range:c.from(re.range),kind:re.kind}}Me.from=Te;function Ce(re){return new r.$5K(c.to(re.range),re.kind)}Me.to=Ce})(te||(e.DocumentHighlight=te={}));var fe;(function(Me){function Te(re){return{uri:re.uri,highlights:re.highlights.map(te.from)}}Me.from=Te;function Ce(re){return new r.$6K(w.URI.revive(re.uri),re.highlights.map(te.to))}Me.to=Ce})(fe||(e.MultiDocumentHighlight=fe={}));var ve;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Me.to=Te})(ve||(e.CompletionTriggerKind=ve={}));var Ae;(function(Me){function Te(Ce){return{triggerKind:ve.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Te})(Ae||(e.CompletionContext=Ae={}));var pe;(function(Me){function Te(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Ce(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Me.to=Ce})(pe||(e.CompletionItemTag=pe={}));var De;(function(Me){const Te=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function Ce(Ve){return Te.get(Ve)??9}Me.from=Ce;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ne(Ve){return re.get(Ve)??r.CompletionItemKind.Property}Me.to=Ne})(De||(e.CompletionItemKind=De={}));var U;(function(Me){function Te(Ce,re){const Ne=new r.$jL(Ce.label);return Ne.insertText=Ce.insertText,Ne.kind=De.to(Ce.kind),Ne.tags=Ce.tags?.map(pe.to),Ne.detail=Ce.detail,Ne.documentation=R.$fk(Ce.documentation)?j.to(Ce.documentation):Ce.documentation,Ne.sortText=Ce.sortText,Ne.filterText=Ce.filterText,Ne.preselect=Ce.preselect,Ne.commitCharacters=Ce.commitCharacters,S.$Gs.isIRange(Ce.range)?Ne.range=c.to(Ce.range):typeof Ce.range=="object"&&(Ne.range={inserting:c.to(Ce.range.insert),replacing:c.to(Ce.range.replace)}),Ne.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Ne.insertText=new r.$ZK(Ce.insertText):(Ne.insertText=Ce.insertText,Ne.textEdit=Ne.range instanceof r.$QK?new r.$VK(Ne.range,Ne.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ce.additionalTextEdits.map(Ve=>Y.to(Ve))),Ne.command=re&&Ce.command?re.fromInternal(Ce.command):void 0,Ne}Me.to=Te})(U||(e.CompletionItem=U={}));var Q;(function(Me){function Te(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:j.fromStrict(re.documentation)}}Me.from=Te;function Ce(re){return{label:re.label,documentation:R.$fk(re.documentation)?j.to(re.documentation):re.documentation}}Me.to=Ce})(Q||(e.ParameterInformation=Q={}));var ee;(function(Me){function Te(re){return{label:re.label,documentation:j.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(Q.from):[],activeParameter:re.activeParameter}}Me.from=Te;function Ce(re){return{label:re.label,documentation:R.$fk(re.documentation)?j.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(Q.to):[],activeParameter:re.activeParameter}}Me.to=Ce})(ee||(e.SignatureInformation=ee={}));var V;(function(Me){function Te(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.from):[]}}Me.from=Te;function Ce(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(ee.to):[]}}Me.to=Ce})(V||(e.SignatureHelp=V={}));var ae;(function(Me){function Te(Ce,re){const Ne=new r.$iL(k.to(re.position),typeof re.label=="string"?re.label:re.label.map(ue.to.bind(void 0,Ce)),re.kind&&Le.to(re.kind));return Ne.textEdits=re.textEdits&&re.textEdits.map(Y.to),Ne.tooltip=R.$fk(re.tooltip)?j.to(re.tooltip):re.tooltip,Ne.paddingLeft=re.paddingLeft,Ne.paddingRight=re.paddingRight,Ne}Me.to=Te})(ae||(e.InlayHint=ae={}));var ue;(function(Me){function Te(Ce,re){const Ne=new r.$hL(re.label);return Ne.tooltip=R.$fk(re.tooltip)?j.to(re.tooltip):re.tooltip,l.Command.is(re.command)&&(Ne.command=Ce.fromInternal(re.command)),re.location&&(Ne.location=ye.to(re.location)),Ne}Me.to=Te})(ue||(e.InlayHintLabelPart=ue={}));var Le;(function(Me){function Te(re){return re}Me.from=Te;function Ce(re){return re}Me.to=Ce})(Le||(e.InlayHintKind=Le={}));var je;(function(Me){function Te(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Me.from=Te;function Ce(re){let Ne;if(re.url)try{Ne=typeof re.url=="string"?w.URI.parse(re.url,!0):w.URI.revive(re.url)}catch{}return new r.$oL(c.to(re.range),Ne)}Me.to=Ce})(je||(e.DocumentLink=je={}));var Ke;(function(Me){function Te(re){const Ne=new r.$rL(re.label);return re.textEdit&&(Ne.textEdit=Y.to(re.textEdit)),re.additionalTextEdits&&(Ne.additionalTextEdits=re.additionalTextEdits.map(Ve=>Y.to(Ve))),Ne}Me.to=Te;function Ce(re){return{label:re.label,textEdit:re.textEdit?Y.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Ne=>Y.from(Ne)):void 0}}Me.from=Ce})(Ke||(e.ColorPresentation=Ke={}));var Qe;(function(Me){function Te(re){return new r.$pL(re[0],re[1],re[2],re[3])}Me.to=Te;function Ce(re){return[re.red,re.green,re.blue,re.alpha]}Me.from=Ce})(Qe||(e.Color=Qe={}));var _e;(function(Me){function Te(re){return{range:c.from(re.range)}}Me.from=Te;function Ce(re){return new r.$$K(c.to(re.range))}Me.to=Ce})(_e||(e.SelectionRange=_e={}));var at;(function(Me){function Te(Ce){switch(Ce){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Me.to=Te})(at||(e.TextDocumentSaveReason=at={}));var ot;(function(Me){function Te(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Ce(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Me.to=Ce})(ot||(e.TextEditorLineNumbersStyle=ot={}));var Ie;(function(Me){function Te(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Me.from=Te;function Ce(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Me.to=Ce})(Ie||(e.EndOfLine=Ie={}));var ze;(function(Me){function Te(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(ze||(e.ProgressLocation=ze={}));var qe;(function(Me){function Te(re){const Ne={start:re.start+1,end:re.end+1};return re.kind&&(Ne.kind=Re.from(re.kind)),Ne}Me.from=Te;function Ce(re){const Ne={start:re.start-1,end:re.end-1};return re.kind&&(Ne.kind=Re.to(re.kind)),Ne}Me.to=Ce})(qe||(e.FoldingRange=qe={}));var Re;(function(Me){function Te(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return l.$wt.Comment;case r.FoldingRangeKind.Imports:return l.$wt.Imports;case r.FoldingRangeKind.Region:return l.$wt.Region}}Me.from=Te;function Ce(re){if(re)switch(re.value){case l.$wt.Comment.value:return r.FoldingRangeKind.Comment;case l.$wt.Imports.value:return r.FoldingRangeKind.Imports;case l.$wt.Region.value:return r.FoldingRangeKind.Region}}Me.to=Ce})(Re||(e.FoldingRangeKind=Re={}));var et;(function(Me){function Te(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?c.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$lE.id:void 0}}Me.from=Te})(et||(e.TextEditorOpenOptions=et={}));var oe;(function(Me){function Te(Ve){return Ve instanceof r.$LL?Ve.toJSON():typeof Ve=="string"?Ve:Ce(Ve)||re(Ve)?new r.$LL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Te;function Ce(Ve){const xe=Ve;return xe?w.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function re(Ve){const xe=Ve;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ne(Ve){return typeof Ve=="string"?Ve:new r.$LL(w.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Ne})(oe||(e.GlobPattern=oe={}));var le;(function(Me){function Te(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Te);if(typeof Ce=="string")return Ce;{const re=Ce;return{language:re.language,scheme:re.scheme,pattern:oe.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Me.from=Te})(le||(e.LanguageSelector=le={}));var Pe;(function(Me){function Te(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&w.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(xe=>xe instanceof r.$QK)))}Me.is=Te;function Ce(re){return{documents:re.documents.map(Ne=>Ne.map(Ve=>({uri:w.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(xe=>c.from(xe))})))}}Me.from=Ce})(Pe||(e.MappedEditsContext=Pe={}));var He;(function(Me){function Te(re){return{start:re.start,end:re.end}}Me.from=Te;function Ce(re){return new r.$aM(re.start,re.end)}Me.to=Ce})(He||(e.NotebookRange=He={}));var Ze;(function(Me){function Te(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Me.to=Te;function Ce(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Me.from=Ce})(Ze||(e.NotebookCellExecutionSummary=Ze={}));var it;(function(Me){function Te(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Te})(it||(e.NotebookCellExecutionState=it={}));var st;(function(Me){function Te(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Te;function Ce(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Me.to=Ce})(st||(e.NotebookCellKind=st={}));var Oe;(function(Me){function Te(re){const Ne={metadata:re.metadata??Object.create(null),cells:[]};for(const Ve of re.cells)r.$bM.validate(Ve),Ne.cells.push(wt.from(Ve));return Ne}Me.from=Te;function Ce(re){const Ne=new r.$cM(re.cells.map(wt.to));return(0,m.$Rf)(re.metadata)||(Ne.metadata=re.metadata),Ne}Me.to=Ce})(Oe||(e.NotebookData=Oe={}));var wt;(function(Me){function Te(re){return{cellKind:st.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Ze.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(Ht.from):[]}}Me.from=Te;function Ce(re){return new r.$bM(st.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(Ht.to):void 0,re.metadata,re.internalMetadata?Ze.to(re.internalMetadata):void 0)}Me.to=Ce})(wt||(e.NotebookCellData=wt={}));var Dt;(function(Me){function Te(re){return{mime:re.mime,valueBytes:T.$ge.wrap(re.data)}}Me.from=Te;function Ce(re){return new r.$dM(re.valueBytes.buffer,re.mime)}Me.to=Ce})(Dt||(e.NotebookCellOutputItem=Dt={}));var Ht;(function(Me){function Te(re){return{outputId:re.id,items:re.items.map(Dt.from),metadata:re.metadata}}Me.from=Te;function Ce(re){const Ne=re.items.map(Dt.to);return new r.$eM(Ne,re.outputId,re.metadata)}Me.to=Ce})(Ht||(e.NotebookCellOutput=Ht={}));var Ut;(function(Me){function Te(Ne){return re(Ne)?{include:oe.from(Ne.include)??void 0,exclude:oe.from(Ne.exclude)??void 0}:oe.from(Ne)??void 0}Me.from=Te;function Ce(Ne){return re(Ne)?{include:oe.to(Ne.include),exclude:oe.to(Ne.exclude)}:oe.to(Ne)}Me.to=Ce;function re(Ne){const Ve=Ne;return Ve?!(0,m.$Nf)(Ve.include)&&!(0,m.$Nf)(Ve.exclude):!1}})(Ut||(e.NotebookExclusiveDocumentPattern=Ut={}));var yt;(function(Me){function Te(Ce,re,Ne){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(Ve,Ne),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Te})(yt||(e.NotebookStatusBarItem=yt={}));var Vt;(function(Me){function Te(Ce,re,Ne){const Ve=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:re.toInternal(Ve,Ne),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(Vt||(e.NotebookKernelSourceAction=Vt={}));var Ft;(function(Me){function Te(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Te})(Ft||(e.NotebookDocumentContentOptions=Ft={}));var Qt;(function(Me){function Te(re){return{uri:re.uri,provides:re.provides}}Me.from=Te;function Ce(re){return new r.$gM(w.URI.revive(re.uri),re.provides)}Me.to=Ce})(Qt||(e.NotebookRendererScript=Qt={}));var Ot;(function(Me){function Te(re){return{message:j.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Me.from=Te;function Ce(re){const Ne=new r.$mM(typeof re.message=="string"?re.message:j.to(re.message));return Ne.actualOutput=re.actual,Ne.expectedOutput=re.expected,Ne.contextValue=re.contextValue,Ne.location=re.location?ye.to(re.location):void 0,Ne}Me.to=Ce})(Ot||(e.TestMessage=Ot={}));var Pt;(function(Me){Me.namespace=a.$IJ,Me.denamespace=a.$JJ})(Pt||(e.TestTag=Pt={}));var tt;(function(Me){function Te(re){const Ne=(0,s.$MM)(re).controllerId;return{extId:o.$EJ.fromExtHostTestItem(re,Ne).toString(),label:re.label,uri:w.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(Ve=>Pt.namespace(Ne,Ve.id)),range:S.$Gs.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&j.fromStrict(re.error)||null}}Me.from=Te;function Ce(re){return{parent:void 0,error:void 0,id:o.$EJ.fromString(re.extId).localId,label:re.label,uri:w.URI.revive(re.uri),tags:(re.tags||[]).map(Ne=>{const{tagId:Ve}=Pt.denamespace(Ne);return new r.$nM(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Me.toPlain=Ce})(tt||(e.TestItem=tt={})),function(Me){function Te(re){return{id:re.id}}Me.from=Te;function Ce(re){return new r.$nM(re.id)}Me.to=Ce}(Pt||(e.TestTag=Pt={}));var Kt;(function(Me){const Te=(re,Ne)=>{const Ve=[];for(const[Ge,rt]of Ne)o.$EJ.compare(rt.item.extId,Ge)===2&&(Ne.delete(Ge),Ve.push(rt));const xe={...tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(rt=>rt.type===0).map(Ot.to)})),children:Ve.map(Ge=>Te(Ge,Ne))};for(const Ge of xe.children)Ge.parent=xe;return xe};function Ce(re){const Ne=[],Ve=new Map;for(const xe of re.items){Ve.set(xe.item.extId,xe);const Ge=o.$EJ.root(xe.item.extId);re.request.targets.some(rt=>rt.controllerId===Ge&&rt.testIds.includes(xe.item.extId))&&Ne.push(xe)}return{completedAt:re.completedAt,results:Ne.map(xe=>Te(xe,Ve))}}Me.to=Ce})(Kt||(e.TestResults=Kt={}));var Gt;(function(Me){function Te(Ve){return{covered:Ve.covered,total:Ve.total}}function Ce(Ve){return"line"in Ve?k.from(Ve):c.from(Ve)}function re(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Ce(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,name:Ve.name,count:Ve.executionCount,location:Ce(Ve.location)}}Me.fromDetailed=re;function Ne(Ve){return{uri:Ve.uri,statement:Te(Ve.statementCoverage),branch:Ve.branchCoverage&&Te(Ve.branchCoverage),function:Ve.functionCoverage&&Te(Ve.functionCoverage),details:Ve.detailedCoverage?.map(re)}}Me.fromFile=Ne})(Gt||(e.TestCoverage=Gt={}));var ut;(function(Me){function Te(Ce){switch(Ce){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Me.to=Te})(ut||(e.CodeActionTriggerKind=ut={}));var $t;(function(Me){function Te(re){const Ne=new r.$tM(se.to(re.kind),re.name,re.detail||"",w.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Ne._sessionId=re._sessionId,Ne._itemId=re._itemId,Ne}Me.to=Te;function Ce(re,Ne,Ve){if(Ne=Ne??re._sessionId,Ve=Ve??re._itemId,Ne===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Ve,kind:se.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(Z.from)}}Me.from=Ce})($t||(e.TypeHierarchyItem=$t={}));var jt;(function(Me){function Te(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Te})(jt||(e.ViewBadge=jt={}));var Bt;(function(Me){function Te(Ve,xe,Ge){const rt=xe.fileData;return rt?new r.$EL(new r.$FL(rt.name,w.URI.revive(rt.uri),rt.id,(0,I.$db)(()=>Ge(rt.id)))):Ve===M.$3r.uriList&&xe.uriListData?new r.$DL(Ne(xe.uriListData)):new r.$DL(xe.asString)}Me.to=Te;async function Ce(Ve,xe){const Ge=await xe.asString();if(Ve===M.$3r.uriList)return{asString:Ge,fileData:void 0,uriListData:re(Ge)};const rt=xe.asFile();return{asString:Ge,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Me.from=Ce;function re(Ve){return g.$dt.split(Ve).map(xe=>{if(xe.startsWith("#"))return xe;try{return w.URI.parse(xe)}catch{}return xe})}function Ne(Ve){return g.$dt.create(Ve.map(xe=>typeof xe=="string"?xe:w.URI.revive(xe)))}})(Bt||(e.DataTransferItem=Bt={}));var kt;(function(Me){function Te(re,Ne){const Ve=re.items.map(([xe,Ge])=>[xe,Bt.to(xe,Ge,Ne)]);return new r.$GL(Ve)}Me.toDataTransfer=Te;async function Ce(re){const Ne={items:[]},Ve=[];for(const[xe,Ge]of re)Ve.push((async()=>{Ne.items.push([xe,await Bt.from(xe,Ge)])})());return await Promise.all(Ve),Ne}Me.from=Ce})(kt||(e.DataTransfer=kt={}));var dt;(function(Me){function Te(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Me.from=Te})(dt||(e.ChatReplyFollowup=dt={}));var At;(function(Me){function Te(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:dt.from(Ce)}Me.from=Te})(At||(e.ChatFollowup=At={}));var Xt;(function(Me){function Te(re){const Ne=new r.$FM(St.to(re.role),re.content);return Ne.name=re.name,Ne}Me.to=Te;function Ce(re){return{role:St.from(re.role),content:re.content,name:re.name}}Me.from=Ce})(Xt||(e.ChatMessage=Xt={}));var St;(function(Me){function Te(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Me.to=Te;function Ce(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Me.from=Ce})(St||(e.ChatMessageRole=St={}));var Ye;(function(Me){function Te(Ne){const Ve={};for(const xe of Object.keys(Ne))Ve[xe]=Ne[xe].map(Me.to);return Ve}Me.objectTo=Te;function Ce(Ne){return{level:Rt.to(Ne.level),kind:Ne.kind,value:(0,y.$yh)(Ne.value),description:Ne.description}}Me.to=Ce;function re(Ne){return{level:Rt.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Me.from=re})(Ye||(e.ChatVariable=Ye={}));var Rt;(function(Me){function Te(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Me.to=Te;function Ce(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(Rt||(e.ChatVariableLevel=Rt={}));var Wt;(function(Me){function Te(Ce){switch(Ce){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Te})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Jt;(function(Me){function Te(Ce,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,d.$kF)(Ce,"chatAgents2Additions"),{content:j.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,d.$kF)(Ce,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,d.$kF)(Ce,"chatAgents2Additions"),{content:j.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Ne=>({uri:Ne.uri,version:Ne.version,ranges:Ne.ranges.map(Ve=>c.from(Ve))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:c.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:c.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,d.$kF)(Ce,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Me.from=Te})(Jt||(e.ChatResponseProgress=Jt={}));var gt;(function(Me){function Te(Ce){return{label:Ce.label,values:Ce.values.map(Ye.from),insertText:Ce.insertText,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Te})(gt||(e.ChatAgentCompletionItem=gt={}));var Mt;(function(Me){function Te(Ce,re,Ne){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand,shouldExecute:Ce.shouldExecute}:"uri"in Ce?{uri:Ce.uri}:re.toInternal(Ce,Ne)}Me.from=Te})(Mt||(e.TerminalQuickFix=Mt={}))}),define(ke[294],Se([1,0,2,8,7,15,75]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=void 0;class p{constructor(y,M,C,m={timeout:1500,errors:3}){this.c=y,this.d=M,this.f=C,this.g=m,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(M,C,m)=>{const S={dispose:this.a.push([M,C,y])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(y,M){const C=D.URI.revive(y);let m=!1;const w=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const l of[...this.a]){if(m)break;const f=this.d.getDocument(C),s=await this.h(l,{document:f,reason:I.TextDocumentSaveReason.to(M)});S.push(s)}}finally{clearTimeout(w)}return S}h([y,M,C],m){const w=this.b.get(y);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(C,y,M,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const l=this.b.get(y);this.b.set(y,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,M,C,m){const w=[],S=Date.now(),{document:l,reason:f}=m,{version:s}=l,i=Object.freeze({document:l,reason:f,waitUntil(n){if(Object.isFrozen(w))throw(0,T.$8)("waitUntil can not be called async");w.push(Promise.resolve(n))}});try{M.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(w),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(w).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof g.$VK))for(const{newText:t,newEol:r,range:d}of a)o.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:d&&I.Range.from(d),text:t,eol:r&&I.EndOfLine.from(r)}});if(o.edits.length!==0)return s===l.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$hgc=p}),define(ke[295],Se([1,0,17,2,15,7,111]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=e.$mgc=void 0;class p{constructor(C,m,w,S){this.start=C,this.deletedCount=m,this.deletedItems=w,this.items=S}asApiEvent(){return{range:new I.$aM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,w){this.notebook=C,this.h=m,this.j=w,this.handle=w.handle,this.uri=T.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(g.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(w)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,w){const S=w.map(g.NotebookCellOutputItem.to),l=this.a.find(f=>f.id===C);if(l&&(m||(l.items.length=0),l.items.push(...S),l.items.length>1&&l.items.every(f=>R.$QI(f.mime)))){const f=new Map,s=[];l.items.forEach(i=>{let n;f.has(i.mime)?n=f.get(i.mime):(n=[],f.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),l.items.length=0,s.forEach(i=>{const n=R.$RI(f.get(i));l.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$mgc=$;class y{static{this.a=0}constructor(C,m,w,S,l){this.k=C,this.l=m,this.m=w,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(w){return w=C.n(w),C.b[w].apiCell},getCells(w){return(w?C.p(w):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,w){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:w});const S={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},l=[];for(const s of C.rawEvents)s.kind===R.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===R.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===R.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),l.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),l.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const f=new Map;for(let s=0;s<l.length;s++){const i=l[s],n=f.get(i.cell);if(n===void 0){const o=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});f.set(i.cell,o-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,w=C.end|0;return m<0&&(m=0),w>this.b.length&&(w=this.b.length),C.with({start:m,end:w})}p(C){C=this.o(C);const m=[];for(let w=C.start;w<C.end;w++)m.push(this.b[w]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,w){if(this.j)return;const S=[],l=[],f=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new $(this,this.l,t);return m||l.push($.asModelAddData(this.apiNotebook,t)),r}),o=new p(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)f.push(t.uri),o.deletedItems.push(t.apiCell);S.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:f}),w)for(const s of S)w.push(s.asApiEvent())}s(C,m,w,S){const l=this.b.splice(C,m);this.b.splice(w,0,...l);const f=[new p(C,m,l.map(s=>s.apiCell),[]),new p(w,0,[],l)];for(const s of f)S.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,w,S){this.b[C].setOutputItems(m,w,S)}v(C,m){const w=this.b[C];w.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(w.uri,m)}w(C,m){const w=this.b[C];w.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$ngc=y}),define(ke[296],Se([1,0,4,2,15,7]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class R{constructor($,y,M,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=M,this.f=C,this.a=new D.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,M,C)=>{const m=function(S){y.call(M,S)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,M){const C=T.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},M,async(l,f)=>{const s=Date.now(),i=await await Promise.resolve(l);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier),!M.isCancellationRequested&&i&&(i instanceof I.$YK?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",f.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(w.length===0)return!0;const S={edits:[]};for(const l of w){const{edits:f}=g.WorkspaceEdit.from(l);S.edits=S.edits.concat(f)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$Dgc=R}),define(ke[146],Se([1,0,8,15,7]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,$,y,M,C,m){this.id=p,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=M,this.c=m}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection($){this.selections=[$]},get selections(){return p.a},set selections($){if(!Array.isArray($)||!$.every(g.$aM.isNotebookRange))throw(0,D.$7)("selections");p.a=$,p.g($)},get visibleRanges(){return p.b},revealRange($,y){p.f.$tryRevealRange(p.id,T.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(T.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$ogc=I}),define(ke[297],Se([1,0,8,4,14,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;let R=class{constructor($,y){this.c=$,this.d=y,this.a=new T.$Sd({onListenerError:D.$2}),this.b=new T.$Sd({onListenerError:D.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,y);const M=this.d.getEditorById($);y.visibleRanges&&M._acceptVisibleRanges(y.visibleRanges.ranges.map(I.NotebookRange.to)),y.selections&&M._acceptSelections(y.selections.selections.map(I.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:M.apiEditor,visibleRanges:M.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:M.apiEditor,selections:M.apiEditor.selections}))}$acceptEditorViewColumns($){for(const y in $)this.d.getEditorById(y)._acceptViewColumn(I.ViewColumn.to($[y]))}};e.$Fgc=R,e.$Fgc=R=Je([We(0,g.$jj)],R)}),define(ke[298],Se([1,0,15,85,216,21,59,8]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;class ${constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,w,S){const l=this.b++,{title:f,location:s,cancellable:i}=w,n={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(l,{location:D.ProgressLocation.from(s),title:f,source:n,cancellable:i},m.isUnderDevelopment?void 0:m.identifier.value).catch(p.$2),this.d(l,S,!!i)}d(m,w,S){let l;S&&(l=new I.$3d,this.c.set(m,l));const f=i=>{this.a.$progressEnd(i),this.c.delete(i),l?.dispose()};let s;try{s=w(new M(this.a,m),S&&l?l.token:I.CancellationToken.None)}catch(i){throw f(m),i}return s.then(i=>f(m),i=>f(m)),s}$acceptProgressCanceled(m){const w=this.c.get(m);w&&(w.cancel(),this.c.delete(m))}}e.$Mgc=$;function y(C,m){return C.message=m.message,typeof m.increment=="number"&&(typeof C.increment=="number"?C.increment+=m.increment:C.increment=m.increment),C}class M extends T.$gv{constructor(m,w){super(S=>this.throttledReport(S)),this.c=m,this.d=w}throttledReport(m){this.c.$progressReport(this.d,m)}}Je([(0,R.$vh)(100,(C,m)=>y(C,m),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(ke[147],Se([1,0,29,142,67,112,89,15,2]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.$4M=e.$3M=void 0;const y=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(d){if(!a(r,d)){const u=r;r=d,n.listener?.(t(d,u))}}}},M=(n,o)=>n===o,C={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},m=n=>o=>({op:4,update:n(o)}),w=(n,o)=>({range:(()=>{let a;const t=m(r=>({range:D.$Gs.lift(p.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),C.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:y(n,o,C.label,m(a=>({label:a}))),description:y(n,void 0,C.description,m(a=>({description:a}))),sortText:y(n,void 0,C.sortText,m(a=>({sortText:a}))),canResolveChildren:y(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:y(n,!1,C.busy,m(a=>({busy:a}))),error:y(n,void 0,C.error,m(a=>({error:p.MarkdownString.fromStrict(a)||null}))),tags:y(n,[],C.tags,(a,t)=>({op:1,new:a.map(p.TestTag.from),old:t.map(p.TestTag.from)}))}),S=n=>{const o=g.$EJ.fromString(n.extId),a=new f(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return a.range=p.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>p.TestTag.to({id:(0,R.$JJ)(t).tagId})),a},l=n=>{let o;for(const a of n.tests){const t=S(a.item);(0,T.$MM)(t).parent=o,o=t}return o};e.$3M=l;class f{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,T.$LM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof s?void 0:d.parent}},children:{value:(0,I.$KM)(d,T.$MM,f),enumerable:!0,writable:!1},...w(d,t)})}}e.$4M=f;class s extends f{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$5M=s;class i extends I.$GM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:T.$MM,getChildren:r=>r.children,root:new s(o,a),toITestItem:p.TestItem.from})}}e.$6M=i}),define(ke[148],Se([1,0,60,8,121,15,7]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.$XM=void 0;class p{static{this.c=new g.$VM("TextEditorDecorationType")}constructor(m,w,S){const l=p.c.nextId();m.$registerTextEditorDecorationType(w.identifier,l,I.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$XM=p;class ${constructor(m,w){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,w){this.k();let S=null;if(m instanceof R.$PK)S=new R.$QK(m,m);else if(m instanceof R.$QK)S=m;else throw new Error("Unrecognized location");this.l(S,w,!1)}insert(m,w){this.k(),this.l(new R.$QK(m,m),w,!0)}delete(m){this.k();let w=null;if(m instanceof R.$QK)w=m;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(m,w,S){const l=this.c.validateRange(m);this.g.push({range:l,text:w,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==R.EndOfLine.LF&&m!==R.EndOfLine.CRLF)throw(0,T.$7)("endOfLine");this.h=m}}class y{constructor(m,w,S,l){this.c=m,this.d=w,this._accept(S),this.e=l;const f=this;this.value={get tabSize(){return f.f},set tabSize(s){f.m(s)},get indentSize(){return f.g},set indentSize(s){f.o(s)},get insertSpaces(){return f.h},set insertSpaces(s){f.q(s)},get cursorStyle(){return f.j},set cursorStyle(s){f.s(s)},get lineNumbers(){return f.k},set lineNumbers(s){f.t(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}m(m){const w=this.l(m);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const w=Math.floor(m);return w>0?w:null}if(typeof m=="string"){const w=parseInt(m,10);return isNaN(w)?null:w>0?w:null}return null}o(m){const w=this.n(m);if(w!==null){if(typeof w=="number"){if(this.g===w)return;this.g=w}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}p(m){return m==="auto"?"auto":m==="false"?!1:!!m}q(m){const w=this.p(m);if(typeof w=="boolean"){if(this.h===w)return;this.h=w}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const w={};let S=!1;if(typeof m.tabSize<"u"){const l=this.l(m.tabSize);l==="auto"?(S=!0,w.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,S=!0,w.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.n(m.indentSize);l==="tabSize"?(S=!0,w.indentSize=l):typeof l=="number"&&this.g!==l&&(this.g=l,S=!0,w.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.p(m.insertSpaces);l==="auto"?(S=!0,w.insertSpaces=l):this.h!==l&&(this.h=l,S=!0,w.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,S=!0,w.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,S=!0,w.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,w))}u(m,w){w.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$YM=y;class M{constructor(m,w,S,l,f,s,i,n){this.id=m,this.j=w,this.k=S,this.g=!1,this.h=new Set,this.c=f,this.d=new y(this.j,this.id,s,S),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return l.value},set document(a){throw new T.$9("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof R.$RK))throw(0,T.$7)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$RK)))throw(0,T.$7)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new T.$9("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new T.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(l.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=o.c.map(u=>I.Range.from(u));else if(t instanceof R.$PK){const{lineNumber:u,column:c}=I.Position.from(t);d=[{startLineNumber:u,startColumn:c,endLineNumber:u,endColumn:c}]}else if(t instanceof R.$QK)d=[I.Range.from(t)];else{d=[];for(const u of t)if(u instanceof R.$QK)d.push(I.Range.from(u));else{const{lineNumber:c,column:h}=I.Position.from(u);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return w.$tryInsertSnippet(m,l.value.version,a.value,d,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(I.$NM(t))return w.$trySetDecorations(m,a.key,I.$OM(t));{const d=new Array(4*t.length);for(let u=0,c=t.length;u<c;u++){const h=t[u];d[4*u]=h.start.line+1,d[4*u+1]=h.start.character+1,d[4*u+2]=h.end.line+1,d[4*u+3]=h.end.character+1}return w.$trySetDecorationsFast(m,a.key,d)}}))},revealRange(a,t){o.n(()=>w.$tryRevealRange(m,I.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){w.$tryShowEditor(m,I.ViewColumn.from(a))},hide(){w.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const w=m.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const S=w.edits.map(f=>f.range);S.sort((f,s)=>f.end.line===s.end.line?f.end.character===s.end.character?f.start.line===s.start.line?f.start.character-s.start.character:f.start.line-s.start.line:f.end.character-s.end.character:f.end.line-s.end.line);for(let f=0,s=S.length-1;f<s;f++){const i=S[f].end;if(S[f+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=w.edits.map(f=>({range:I.Range.from(f.range),text:f.text,forceMoveMarkers:f.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,l,{setEndOfLine:typeof w.setEndOfLine=="number"?I.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$ZM=M}),define(ke[299],Se([1,0,220,23,2,4,3,279,12,7,18,19,15,80,21,177,25]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;function s(o,a){if((0,M.$Ef)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Sc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new l.$07;function d(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>d(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(c=>d(c)?this.r(c):c):u})}registerTreeDataProvider(a,t,r){const d=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>d.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,k=this.m(a,t,r),L={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:u,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},v=this.f.$registerTreeViewDataProvider(a,L),b={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,f.$kF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,f.$kF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(E){(0,w.$fk)(E)&&(0,f.$kF)(r,"treeViewMarkdownMessage"),k.message=E},get title(){return k.title},set title(E){k.title=E},get description(){return k.description},set description(E){k.description=E},get badge(){return k.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?k.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(k.badge=void 0)},reveal:(E,A)=>k.reveal(E,A),dispose:async()=>{await v,this.a.delete(a),k.dispose()}};return this.B(b),b}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new p.$UE(a))}async $handleDrop(a,t,r,d,u,c,h,k){const L=this.a.get(a);if(!L)return Promise.reject(new p.$UE(a));const v=m.DataTransfer.toDataTransfer(r,async b=>(await this.f.$resolveDropFileData(a,t,b)).buffer);return h===a&&k&&await this.j(v,L,k,u,c),L.onDrop(v,d,u)}async j(a,t,r,d,u){const c=this.b.removeDragOperationTransfer(u);if(c)(await c)?.forEach((h,k)=>{h&&a.set(k,h)});else if(u&&t.handleDrag){const h=t.handleDrag(r,a,d);this.b.addDragOperationTransfer(u,h),await h}return a}async $handleDrag(a,t,r,d){const u=this.a.get(a);if(!u)return Promise.reject(new p.$UE(a));const c=await this.j(new y.$GL,u,t,d,r);if(!(!c||d.isCancellationRequested))return m.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new p.$UE(a);return t.hasResolve}$resolve(a,t,r){const d=this.a.get(a);if(!d)throw new p.$UE(a);return d.resolveTreeItem(t,r)}$setExpanded(a,t,r){const d=this.a.get(a);if(!d)throw new p.$UE(a);d.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const d=this.a.get(a);if(!d)throw new p.$UE(a);d.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new p.$UE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new p.$UE(a);r.setCheckboxState(t)}m(a,t,r){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$6gc=i;class n extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,M.$Nf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,d,u,c){if(super(),this.I=a,this.J=r,this.L=d,this.M=u,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$3d,c.contributes&&c.contributes.views)for(const v in c.contributes.views)for(const b of c.contributes.views[v])b.id===a&&(this.P=b.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.F.fire({message:!1,element:v})));let h,k;const L=I.Event.debounce(this.F.event,(v,b)=>(v||(v={message:!1,elements:[]}),b.element!==!1&&(h||(h=new Promise(E=>k=E),this.G=this.G.then(()=>h)),Array.isArray(b.element)?v.elements.push(...b.element):v.elements.push(b.element)),b.message&&(v.message=!0),v),200,!0);this.B(L(({message:v,elements:b})=>{b.length&&(this.H=this.H.then(()=>{const E=k;return h=null,this.$(b).then(()=>E())})),v&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,M.$Nf)(t.select)?!0:t.select,d=(0,M.$Nf)(t.focus)?!1:t.focus,u=(0,M.$Nf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(k=>k.item)},{select:r,focus:d,expand:u})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:d,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=m.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,C.$ub)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const d=this.getExtensionElement(r.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const d=[];for(const u of a){const c=this.getExtensionElement(u);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const d=this.m.get(r);if(d){const u=await this.f.resolveTreeItem(d.extensionItem,r,t)??d.extensionItem;return this.hb(u),d.item.tooltip=this.eb(u.tooltip),d.item.command=this.fb(d.disposableStore,u.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(d=>(r.push(d),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Ug)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,$.$Ug)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(d);if(u){const c=this.m.get(u);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$3d(this.Z.token);try{const r=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,C.$Hb)(d||[]).map(async c=>{const h=await this.f.getTreeItem(c);return h&&!t.token.isCancellationRequested?this.db(c,h,r):null}));return t.token.isCancellationRequested?void 0:(0,C.$Hb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new S.$3d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let c=u;for(;c&&c.parent&&r.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(u.item.handle)}const d=[];return t.forEach(u=>{const c=this.j.get(u);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(u)}}),d}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(d=>{d&&(t[r]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,$.$Ug)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const u=this.ib(t,d,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const d=this.ib(a,t,r);if(t.id&&this.j.has(d.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,r),d}eb(a){return y.$dL.isMarkdownString(a)?m.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:d}}hb(a){if(!y.$BL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const d=this.B(new R.$Rc),u=this.kb(a,t,r),c=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,M.$Nf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof y.$JL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:d},u,c){if(t)return`${n.b}/${t}`;const h=s(r,this.N),k=u?u.item.handle:n.a;let L=h?h.label:d?(0,T.$Ag)(d):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const v=this.m.has(a)?this.m.get(a).item.handle:void 0,b=this.X(u)||[];let E,A=0;do{if(E=`${k}/${A}:${L}`,c||!this.j.has(E)||v===E)break;A++}while(A<=b.length);return E}lb(a){if(a.iconPath&&!(a.iconPath instanceof y.$JL))return typeof a.iconPath=="string"||g.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof y.$JL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return g.URI.isUri(a)?a:g.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(d)||[],c=u.filter(h=>h.item.handle===r.item.handle)[0];c&&u.splice(u.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const d=this.j.get(r.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[300],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[301],Se([1,0,234,8,39,134,108,37,26,300,136,137]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=void 0;const m=p.$tn.as(R.$un.JSONContribution);class w{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(g.default.Error,a)}warn(a){this.d(g.default.Warning,a)}info(a){this.d(g.default.Info,a)}}e.$$E=w;class S{static a(a){const t=new $.$hm;for(let r=0,d=a.length;r<d;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const r=this.a(a),d=this.a(t),u=t.filter(h=>!r.has(h.description.identifier)),c=a.filter(h=>!d.has(h.description.identifier));return new S(u,c)}constructor(a,t){this.added=a,this.removed=t}}e.$_E=S;class l{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,T.$1)(a)}}}e.$aF=l;const f={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$bF={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$fm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$$n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$$n}},extensionKind:{description:D.localize(52,null),type:"array",items:f,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new l(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$2E.register(a.extensionPoint,a.activationEventsGenerator),e.$bF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,m.registerSchema(s,e.$bF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$cF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$tn.add(n.ExtensionsRegistry,new i),e.$dF=p.$tn.as(n.ExtensionsRegistry),m.registerSchema(s,e.$bF),m.registerSchema(M.$Cj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[302],Se([1,0,230,18,24,301,46,4]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function w(S,l,f){if(!S)return;const s=T.$Ef(S.type)?S.type:void 0;if(!s||s.length===0){f.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)T.$Ef(n)&&i.push(n);return{extensionId:l.value,taskType:s,required:i,properties:S.properties?g.$hn(S.properties):{},when:S.when?R.$Zi.deserialize(S.when):void 0}}m.from=w})(y||(y={}));const M=I.$dF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,w)=>{for(const S of m)S.type&&w.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new p.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,S)=>{M.setHandler((l,f)=>{this.c=void 0;try{for(const s of f.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of f.added){const i=s.value;for(const n of i){const o=y.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(f.removed.length>0||f.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const S of this.all()){const l={type:"object",additionalProperties:!1};S.required.length>0&&(l.required=S.required.slice(0)),S.properties!==void 0?l.properties=g.$hn(S.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[S.taskType]},w.push(l)}this.c={oneOf:w}}return this.c}}e.$fG=new C}),define(ke[303],Se([1,0,231,18,23,24,46,302]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$pG=e.JsonSchemaVersion=e.ExecutionEngine=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$jG=e.ShellQuoting=e.$iG=e.$hG=e.$gG=void 0,e.$gG="settings",e.$hG=new R.$gj("taskRunning",!1,D.localize(0,null)),e.$iG={value:D.localize(1,null),original:"Tasks"};var $;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$jG="$customized",function(N){function F(W){if(!W)return N.Strong;switch(W.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=F}($||(e.ShellQuoting=$={}));var y;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var M;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(M||(e.RevealKind=M={})),function(N){function F(W){switch(W.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=F}(M||(e.RevealKind=M={}));var C;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(N){function F(W){switch(W.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=F}(C||(e.RevealProblemKind=C={}));var m;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(m||(e.PanelKind=m={})),function(N){function F(W){switch(W.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=F}(m||(e.PanelKind=m={}));var w;(function(N){N.defaults={echo:!0,reveal:M.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function F(x){switch(x.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=F;function W(x){switch(x){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=W}(S||(e.RuntimeType=S={}));var l;(function(N){function F(W){return T.$Ef(W)?W:W.value}N.value=F})(l||(e.CommandString=l={}));var f;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function F(x){return x===N.Clean._id||x===N.Build._id||x===N.Rebuild._id||x===N.Test._id}N.is=F;function W(x){if(x!==void 0)return T.$Ef(x)?F(x)?{_id:x,isDefault:!1}:void 0:x}N.from=W})(f||(e.TaskGroup=f={}));var s;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function F(W){switch(W){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(F,W,x,ce,J,Y){this._label="",this._id=F,W&&(this._label=W),x&&(this.type=x),this.runOptions=ce,this.configurationProperties=J,this._source=Y}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(T.$Ef(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const x=this.getDefinition(!0);return x!==void 0&&x._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$kG=t;class r extends t{constructor(F,W,x,ce,J,Y,X,se){super(F,x,void 0,X,se,W),this.command={},this._source=W,this.hasDefinedMatchers=Y,J&&(this.command=J)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case S.Shell:W="shell";break;case S.Process:W="process";break;case S.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof r}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$gG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$jG,folder:F,id:W};return JSON.stringify(x)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new r(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$lG=r;class d extends t{constructor(F,W,x,ce,J,Y,X){super(F,x,ce,Y,X,W),this._source=W,this.configures=J}static is(F){return F instanceof d}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$gG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const x={type:e.$jG,folder:F,id:W};return JSON.stringify(x)}}e.$mG=d;class u extends t{constructor(F,W,x,ce,J,Y,X,se,Z){super(F,x,ce,se,Z,W),this.defines=J,this.hasDefinedMatchers=X,this.command=Y,this.icon=Z.icon,this.hide=Z.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$nG=u;class c extends t{constructor(F,W,x,ce,J,Y){super(F,x,ce,J,Y,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new c(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$oG=c;var h;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(N){N._default=N.Terminal}(h||(e.ExecutionEngine=h={}));var k;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class L{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const x=F.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(x&&ce){let J=this.c.get(x.uri.toString());J=J===void 0?0:J+1;let Y=this.c.get(ce.uri.toString());return Y=Y===void 0?0:Y+1,J===Y?F._label.localeCompare(W._label):J-Y}else return!x&&ce?-1:x&&!ce?1:0}}e.$pG=L;var v;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(v||(e.TaskEventKind=v={}));var b;(function(N){N.SingleRun="singleRun",N.Background="background"})(b||(e.TaskRunType=b={}));var E;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var A;(function(N){function F(se){return{taskId:se._id,taskName:se.configurationProperties.name,runType:se.configurationProperties.isBackground?"background":"singleRun",group:se.configurationProperties.group,__task:se}}function W(se,Z,we){return{...F(se),kind:"start",terminalId:Z,resolvedVariables:we}}N.start=W;function x(se,Z,we){return{...F(se),kind:"processStarted",terminalId:Z,processId:we}}N.processStarted=x;function ce(se,Z,we){return{...F(se),kind:"processEnded",terminalId:Z,exitCode:we}}N.processEnded=ce;function J(se,Z,we){return{...F(se),kind:"terminated",exitReason:we,terminalId:Z}}N.terminated=J;function Y(se,Z,we){return{...F(Z),kind:se,terminalId:we}}N.general=Y;function X(){return{kind:"changed"}}N.changed=X})(A||(e.TaskEvent=A={}));var z;(function(N){function F(x){const ce=Object.keys(x).sort();let J="";for(const Y of ce){let X=x[Y];X instanceof Object?X=F(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),J+=Y+","+X+","}return J}function W(x){const J={_key:F(x),type:x.taskType};return Object.assign(J,x),J}N.create=W})(z||(e.KeyedTaskIdentifier=z={}));var O;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(O||(e.TaskSettingId=O={}));var P;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(P||(e.TasksSchemaProperties=P={}));var j;(function(N){function F(W,x){const ce=p.$fG.get(W.type);if(ce===void 0){const se=I.$hn(W);return delete se._key,z.create(se)}const J=Object.create(null);J.type=ce.taskType;const Y=new Set;ce.required.forEach(se=>Y.add(se));const X=ce.properties;for(const se of Object.keys(X)){const Z=W[se];if(Z!=null)J[se]=Z;else if(Y.has(se)){const we=X[se];if(we.default!==void 0)J[se]=I.$hn(we.default);else switch(we.type){case"boolean":J[se]=!1;break;case"number":case"integer":J[se]=0;break;case"string":J[se]="";break;default:x.error(D.localize(2,null,JSON.stringify(W,void 0,0),se));return}}}return z.create(J)}N.createTaskIdentifier=F})(j||(e.TaskDefinition=j={}))}),define(ke[304],Se([1,0,8]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=e.$i7b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,p)=>{this.b=R,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,D.$1)(R))}then(R,p){return this.j().then(R,p)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$i7b=T;class g extends T{constructor(){super(),this.h=!0,this.i=new D.$5}}e.$j7b=g}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$Bv=D;const T=[];function g(p){const $=new D(p);return T[$.nid]=$,$}e.$Cv=g;function I(p){return T[p].sid}e.$Dv=I;class R{constructor($){this.value=$}}e.$Ev=R}),define(ke[6],Se([1,0,68]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$LK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var g;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var p;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var $;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var M;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class C{static{this.a=0}static mixin(f){return f._id=C.a++,f}}e.$LK=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var w;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var S;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$MK={MainThreadAuthentication:(0,D.$Cv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$Cv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$Cv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$Cv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$Cv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$Cv)("MainThreadClipboard"),MainThreadCommands:(0,D.$Cv)("MainThreadCommands"),MainThreadComments:(0,D.$Cv)("MainThreadComments"),MainThreadConfiguration:(0,D.$Cv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$Cv)("MainThreadConsole"),MainThreadDebugService:(0,D.$Cv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$Cv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$Cv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$Cv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$Cv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$Cv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$Cv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$Cv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$Cv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$Cv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$Cv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$Cv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$Cv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$Cv)("MainThreadLanguages"),MainThreadLogger:(0,D.$Cv)("MainThreadLogger"),MainThreadMessageService:(0,D.$Cv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$Cv)("MainThreadOutputService"),MainThreadProgress:(0,D.$Cv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$Cv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$Cv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$Cv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$Cv)("MainThreadSecretState"),MainThreadStorage:(0,D.$Cv)("MainThreadStorage"),MainThreadSpeech:(0,D.$Cv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$Cv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$Cv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$Cv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$Cv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$Cv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$Cv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$Cv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$Cv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$Cv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$Cv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$Cv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$Cv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$Cv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$Cv)("MainThreadSCM"),MainThreadSearch:(0,D.$Cv)("MainThreadSearch"),MainThreadShare:(0,D.$Cv)("MainThreadShare"),MainThreadTask:(0,D.$Cv)("MainThreadTask"),MainThreadWindow:(0,D.$Cv)("MainThreadWindow"),MainThreadLabelService:(0,D.$Cv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$Cv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$Cv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$Cv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$Cv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$Cv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$Cv)("MainThreadInteractive"),MainThreadChat:(0,D.$Cv)("MainThreadChat"),MainThreadInlineChat:(0,D.$Cv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$Cv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$Cv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$Cv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$Cv)("MainThreadTimeline"),MainThreadTesting:(0,D.$Cv)("MainThreadTesting"),MainThreadLocalization:(0,D.$Cv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$Cv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$Cv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$Cv)("MainThreadIssueReporter")},e.$NK={ExtHostCommands:(0,D.$Cv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$Cv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$Cv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$Cv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$Cv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$Cv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$Cv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$Cv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$Cv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$Cv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$Cv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$Cv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$Cv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$Cv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$Cv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$Cv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$Cv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$Cv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$Cv)("ExtHostStatusBar"),ExtHostShare:(0,D.$Cv)("ExtHostShare"),ExtHostExtensionService:(0,D.$Cv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$Cv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$Cv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$Cv)("ExtHostSCM"),ExtHostSearch:(0,D.$Cv)("ExtHostSearch"),ExtHostTask:(0,D.$Cv)("ExtHostTask"),ExtHostWorkspace:(0,D.$Cv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$Cv)("ExtHostWindow"),ExtHostWebviews:(0,D.$Cv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$Cv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$Cv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$Cv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$Cv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$Cv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$Cv)("ExtHostProgress"),ExtHostComments:(0,D.$Cv)("ExtHostComments"),ExtHostSecretState:(0,D.$Cv)("ExtHostSecretState"),ExtHostStorage:(0,D.$Cv)("ExtHostStorage"),ExtHostUrls:(0,D.$Cv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$Cv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$Cv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$Cv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$Cv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$Cv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$Cv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$Cv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$Cv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$Cv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$Cv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$Cv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$Cv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$Cv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$Cv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$Cv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$Cv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$Cv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$Cv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$Cv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$Cv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$Cv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$Cv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$Cv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$Cv)("ExtHostTimeline"),ExtHostTesting:(0,D.$Cv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$Cv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$Cv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$Cv)("ExtHostIssueReporter")}}),define(ke[305],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$MK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,p,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(p,$)??[]}getRelatedInformation(R,p,$){return this.c.$getAiRelatedInformation(p,$)}registerRelatedInformationProvider(R,p,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,p),new T.$OK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$6ec=g}),define(ke[91],Se([1,0,5,14,6,20]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=e.$_ec=void 0,e.$_ec=(0,D.$2h)("IExtHostApiDeprecationService");let R=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$MK.MainThreadTelemetry)}report($,y,M){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$afc=R,e.$afc=R=Je([We(0,I.$QM),We(1,T.$jj)],R),e.$bfc=Object.freeze(new class{report(p,$,y){}})}),define(ke[306],Se([1,0,4,6,7,26]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class R{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Sd,this.onDidChangeSessions=this.d.event,this.f=new p,this.g=new p,this.a=y.getProxy(T.$MK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,M,C,m={}){const w=I.$gm.toKey(y.identifier),S=[...C].sort().join(" ");return await this.f.getOrCreate(`${w} ${M} ${S}`,async()=>{await this.a.$ensureProvider(M);const l=y.displayName||y.name;return this.a.$getSession(M,C,w,l,m)})}async getSessions(y,M,C){const m=I.$gm.toKey(y.identifier),w=[...C].sort().join(" ");return await this.g.getOrCreate(`${m} ${w}`,async()=>{await this.a.$ensureProvider(M);const S=y.displayName||y.name;return this.a.$getSessions(M,C,m,S)})}async removeSession(y,M){const C=this.b.get(y);return C?C.provider.removeSession(M):this.a.$removeSession(y,M)}registerAuthenticationProvider(y,M,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:M,provider:C,options:m??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===y)||this.c.push({id:y,label:M});const w=C.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(y,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(y,M,m?.supportsMultipleAccounts??!1),new g.$OK(()=>{w.dispose(),this.b.delete(y);const S=this.c.findIndex(l=>l.id===y);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,M,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(M,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,M){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,M){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(M));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,M){return this.d.fire({provider:{id:y,label:M}}),Promise.resolve()}}e.$efc=R;class p{constructor(){this.a=new Map}getOrCreate(y,M){const C=this.a.get(y);if(C)return C;const m=M().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(ke[307],Se([1,0,6,20,15]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;let I=class{constructor(p,$){this.a=p.getProxy(D.$MK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,$,y){const M=g.WorkspaceEdit.from(p,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,y?.isRefactoring??!1)}};e.$ffc=I,e.$ffc=I=Je([We(0,T.$QM)],I)}),define(ke[308],Se([1,0,4,52,3,6,15]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class p{static{this.a=0}constructor(M,C){this.extension=M,this.provider=C,this.handle=p.a++}}class ${static{this.a=0}constructor(M){this.b=new Map,this.c=new Map,this.d=new D.$Sd,this.onDidPerformUserAction=this.d.event,this.e=M.getProxy(I.$MK.MainThreadChat)}registerChatProvider(M,C,m){const w=new p(M,m);return this.b.set(w.handle,w),this.e.$registerChatProvider(w.handle,C),(0,g.$Qc)(()=>{this.e.$unregisterChatProvider(w.handle),this.b.delete(w.handle)})}transferChatSession(M,C){const m=T.Iterable.find(this.c.keys(),w=>this.c.get(w)===M)??0;typeof m=="number"&&this.e.$transferChatSession(m,C)}sendInteractiveRequestToProvider(M,C){this.e.$sendRequestToProvider(M,C)}async $prepareChat(M,C){const m=this.b.get(M);if(!m)return;const w=await m.provider.prepareSession(C);if(!w)return;const S=$.a++;return this.c.set(S,w),{id:S,requesterUsername:w.requester?.name,requesterAvatarIconUri:w.requester?.icon,responderUsername:w.responder?.name,responderAvatarIconUri:w.responder?.icon,inputPlaceholder:w.inputPlaceholder}}async $provideWelcomeMessage(M,C){const m=this.b.get(M);if(!m||!m.provider.provideWelcomeMessage)return;const w=await m.provider.provideWelcomeMessage(C);if(w)return w.map(S=>typeof S=="string"?S:Array.isArray(S)?S.map(l=>R.ChatReplyFollowup.from(l)):R.MarkdownString.from(S))}async $provideSampleQuestions(M,C){const m=this.b.get(M);if(!m||!m.provider.provideSampleQuestions)return;const w=await m.provider.provideSampleQuestions(C);if(w)return w?.map(S=>R.ChatReplyFollowup.from(S))}$releaseSession(M){this.c.delete(M)}async $onDidPerformUserAction(M){this.d.fire(M)}}e.$gfc=$}),define(ke[309],Se([1,0,12,21,44,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class f{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$MK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=f.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,d){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function h(){if(c)throw new Error("Only valid while executing the command")}const k=new D.$mh;d.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,k.p);const L=t.command?await u.validateSlashCommand(t.command):void 0,v=R.$Od.create(!1);let b;try{const E=u.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:L},{history:r.history.map(m.ChatMessage.to)},new M.$gv(A=>{h(),typeof b>"u"&&"content"in A&&(b=v.elapsed());const z=m.ChatResponseProgress.from(u.extension,A);if(!z){this.j.error("Unknown progress type: "+JSON.stringify(A));return}if("placeholder"in A&&"resolvedContent"in A){const O=Promise.all([this.d.$handleProgressChunk(a,z),A.resolvedContent]);(0,D.$Qg)(O,d).then(P=>{if(!P)return;const[j,N]=P,F=m.ChatResponseProgress.from(u.extension,N);if(!F){this.j.error("Unknown progress type: "+JSON.stringify(N));return}this.d.$handleProgressChunk(a,F,j??void 0)})}else this.d.$handleProgressChunk(a,z)}),d);return await(0,D.$Qg)(Promise.resolve(E).then(A=>{if(A){this.g.set(o,A);let z=this.h.get(o);z||(z=new Map,this.h.set(o,z)),z.set(a,A);const O={firstProgress:b,totalElapsed:v.elapsed()};return{errorDetails:A.errorDetails,timings:O}}else this.g.delete(o)}),d)}catch(E){return this.j.error(E,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Mi)(E)),responseIsIncomplete:!0}}}finally{c=!0,k.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t,r){const d=this.b.get(n);if(!d)return;const u=this.h.get(o)?.get(a);if(!u)return;let c;switch(t){case S.InteractiveSessionVoteDirection.Down:c=w.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:c=w.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(r?{result:u,kind:c,reportIssue:r}:{result:u,kind:c}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const d=this.h.get(o)?.get(a);d&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:d}))}async $invokeCompletionProvider(n,o,a){const t=this.b.get(n);return t?(await t.invokeCompletionProvider(o,a)).map(m.ChatAgentCompletionItem.from):[]}}e.$ifc=f;class s{constructor(n,o,a,t,r){this.extension=n,this.t=o,this.u=a,this.w=t,this.x=r,this.o=new I.$Sd,this.q=new I.$Sd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async invokeCompletionProvider(n,o){return this.s?await this.s.provider.provideCompletionItems(n,o)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,p.$Of)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof w.$JL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},t=this;return{get name(){return t.t},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,l.$kF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,l.$kF)(t.extension,"defaultChatAgent"),t.j=r,a()},get helpTextPrefix(){return(0,l.$kF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,l.$kF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,a()},get helpTextPostfix(){return(0,l.$kF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,l.$kF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,a()},get isSecondary(){return(0,l.$kF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,l.$kF)(t.extension,"defaultChatAgent"),t.n=r,a()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,a()},get supportIssueReporting(){return(0,l.$kF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,l.$kF)(t.extension,"chatAgents2Additions"),t.r=r,a()},get onDidReceiveFeedback(){return t.o.event},set agentVariableProvider(r){if(t.s=r,r){if(!r.triggerCharacters.length)throw new Error("triggerCharacters are required");t.u.$registerAgentCompletionsProvider(t.w,r.triggerCharacters)}else t.u.$unregisterAgentCompletionsProvider(t.w)},get agentVariableProvider(){return t.s},onDidPerformAction:(0,l.$jF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.u.$unregisterAgent(t.w)}}}invoke(n,o,a,t){return this.x(n,o,a,t)}}}),define(ke[310],Se([1,0,21,3,6,15,85,26,12,4]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class M{constructor(S,l){this.stream=new $.$sh,this.stream=l??new $.$sh;const f=this;this.apiObj={option:S,response:f.stream.asyncIterable}}}class C{constructor(S,l){this.a=new y.$Sd,this.b=new Map,this.c=new $.$sh,this.d=!1;const f=this;this.apiObject={result:S,response:f.c.asyncIterable,onDidStartResponseStream:f.a.event,cancel(){l.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let l=this.b.get(S.index);l||(this.b.size===0?l=new M(S.index,this.c):l=new M(S.index),this.b.set(S.index,l),this.a.fire(l.apiObj)),l.stream.emitOne(S.part)}}class m{static{this.a=1}constructor(S,l){this.d=l,this.c=new Map,this.e=new Map,this.f=new p.$im,this.b=S.getProxy(g.$MK.MainThreadChatProvider)}registerProvider(S,l,f,s){const i=m.a++;return this.c.set(i,{extension:S,provider:f}),this.b.$registerProvider(i,l,{extension:S,model:s.name??""}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,l,f,s,i){const n=this.c.get(S);if(!n)return;const o=new R.$gv(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(l,{index:a.index,part:a.part})});return n.provider.provideChatResponse(f.map(I.ChatMessage.to),s,o,i)}allowListExtensionWhile(S,l){this.f.set(S,l),l.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,l){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const f=await this.b.$prepareChatAccess(l);if(!f)throw new Error(`ChatAccess '${l}' NOT found`);const s=this;return{get model(){return f.model},get isRevoked(){return!s.f.has(S)},makeRequest(i,n,o){if(!s.f.has(S))throw new Error("Access to chat has been revoked");const a=new D.$3d(o),t=Math.random()*1e6|0,r=s.b.$fetchResponse(S,l,t,i.map(I.ChatMessage.from),n??{},a.token),d=new C(r,a);return s.e.set(t,{res:d}),r.finally(()=>{s.e.delete(t)}),d.apiObject}}}async $handleResponseFragment(S,l){const f=this.e.get(S);f&&f.res.handleFragment(l)}}e.$hfc=m}),define(ke[311],Se([1,0,3,6,8,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class R{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(T.$MK.MainThreadChatVariables)}async $resolveVariable($,y,M){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{message:y},M);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$2)(m)}}registerVariableResolver($,y,M,C){const m=R.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:M},resolver:C}),this.c.$registerVariable(m,{name:y,description:M}),(0,D.$Qc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$jfc=R}),define(ke[312],Se([1,0,6]),function(me,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;class T{constructor(I){const R=I.getProxy(D.$MK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(p){return R.$writeText(p)}})}}e.$kfc=T}),define(ke[35],Se([1,0,18,7,15,24,6,19,14,54,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=void 0;let d=class{#e;#t;#i;constructor(v,b,E){this.b=new Map,this.c=new Map,this.#e=v.getProxy(R.$MK.MainThreadCommands),this.d=b,this.#i=E,this.#t=v.getProxy(R.$MK.MainThreadTelemetry),this.converter=new u(this,A=>{const z=this.c.get(A);return z?.result===h.Void?z:void 0},b),this.f=[{processArgument(A){return(0,y.$yh)(A)}},{processArgument(A){return(0,I.$jn)(A,function(z){if(M.$Gs.isIRange(z))return g.Range.to(z);if(C.$Fs.isIPosition(z))return g.Position.to(z);if(M.$Gs.isIRange(z.range)&&m.URI.isUri(z.uri))return g.location.to(z);if(z instanceof s.$ge)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(v){this.f.push(v)}registerApiCommand(v){const b=this.registerCommand(!1,v.id,async(...E)=>{const A=v.args.map((O,P)=>{if(!O.validate(E[P]))throw new Error(`Invalid argument '${O.name}' when running '${v.id}', received: ${typeof E[P]=="object"?JSON.stringify(E[P],null,"	"):E[P]} `);return O.convert(E[P])}),z=await this.executeCommand(v.internalId,...A);return v.result.convert(z,E,this.converter)},void 0,{description:v.description,args:v.args,returns:v.result.description});return this.c.set(v.id,v),new T.$OK(()=>{b.dispose(),this.c.delete(v.id)})}registerCommand(v,b,E,A,z,O){if(this.d.trace("ExtHostCommands#registerCommand",b),!b.trim().length)throw new Error("invalid id");if(this.b.has(b))throw new Error(`command '${b}' already exists`);return this.b.set(b,{callback:E,thisArg:A,metadata:z,extension:O}),v&&this.#e.$registerCommand(b),new T.$OK(()=>{this.b.delete(b)&&v&&this.#e.$unregisterCommand(b)})}executeCommand(v,...b){return this.d.trace("ExtHostCommands#executeCommand",v),this.g(v,b,!0)}async g(v,b,E){if(this.b.has(v))return this.#e.$fireCommandActivationEvent(v),this.h(v,b,!1);{let A=!1;const z=(0,I.$jn)(b,function(O){if(O instanceof T.$PK)return g.Position.from(O);if(O instanceof T.$QK)return g.Range.from(O);if(O instanceof T.$1K)return g.location.from(O);if(T.$aM.isNotebookRange(O))return g.NotebookRange.from(O);if(O instanceof ArrayBuffer)return A=!0,s.$ge.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return A=!0,s.$ge.wrap(O);if(O instanceof s.$ge)return A=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(v,A?new i.$Ev(z):z,E);return(0,y.$yh)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(v,b,!1);throw O}}}async h(v,b,E){const A=this.b.get(v);if(!A)throw new Error("Unknown command");const{callback:z,thisArg:O,metadata:P}=A;if(P?.args)for(let N=0;N<P.args.length;N++)try{(0,D.$Vf)(b[N],P.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${v}' failed. Illegal argument '${P.args[N].name}' - ${P.args[N].description}`)}const j=o.$Od.create();try{return await z.apply(O,b)}catch(N){if(v===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...b);F&&(v=F.command)}if(this.d.error(N,v,A.extension?.identifier),!E)throw N;if(A.extension?.identifier){const F=this.#i.onExtensionError(A.extension.identifier,N);this.d.trace("forwarded error to extension?",F,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Mi)(N)),this.id=v,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,v,j.elapsed())}}j(v,b,E){v.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:v.extension.identifier.value,id:new a.$wo(b),duration:E})}$executeContributedCommand(v,...b){this.d.trace("ExtHostCommands#$executeContributedCommand",v);const E=this.b.get(v);return E?(b=b.map(A=>this.f.reduce((z,O)=>O.processArgument(z,E.extension?.identifier),A)),this.h(v,b,!0)):Promise.reject(new Error(`Contributed command '${v}' does not exist.`))}getCommands(v=!1){return this.d.trace("ExtHostCommands#getCommands",v),this.#e.$getCommands().then(b=>(v&&(b=b.filter(E=>E[0]!=="_")),b))}$getContributedCommandMetadata(){const v=Object.create(null);for(const[b,E]of this.b){const{metadata:A}=E;A&&(v[b]=A)}return Promise.resolve(v)}};e.$_M=d,e.$_M=d=Je([We(0,l.$QM),We(1,$.$jj),We(2,t.$$M)],d),e.$aN=(0,S.$2h)("IExtHostCommands");class u{constructor(v,b,E){this.d=v,this.f=b,this.g=E,this.delegatingCommandId=`__vsc${(0,r.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(v,b){if(!v)return;const E={$ident:void 0,id:v.command,title:v.title,tooltip:v.tooltip};if(!v.command)return E;const A=this.f(v.command);if(A)E.id=A.internalId,E.arguments=A.args.map((z,O)=>z.convert(v.arguments&&v.arguments[O]));else if((0,p.$Lb)(v.arguments)){const z=`${v.command} /${++this.c}`;this.b.set(z,v),b.add((0,w.$Qc)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),E.$ident=z,E.id=this.delegatingCommandId,E.arguments=[z],this.g.trace("CommandsConverter#CREATE",v.command,z)}return E}fromInternal(v){return typeof v.$ident=="string"?this.b.get(v.$ident):{command:v.id,title:v.title,arguments:v.arguments}}getActualCommand(...v){return this.b.get(v[0])}h(...v){const b=this.getActualCommand(...v);return this.g.trace("CommandsConverter#EXECUTE",v[0],b?b.command:"MISSING"),b?this.d.executeCommand(b.command,...b.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${v[0]}`)}}e.$bN=u;class c{static{this.Uri=new c("uri","Uri of a text document",v=>m.URI.isUri(v),v=>v)}static{this.Position=new c("position","A position in a text document",v=>T.$PK.isPosition(v),g.Position.from)}static{this.Range=new c("range","A range in a text document",v=>T.$QK.isRange(v),g.Range.from)}static{this.Selection=new c("selection","A selection in a text document",v=>T.$RK.isSelection(v),g.Selection.from)}static{this.Number=new c("number","",v=>typeof v=="number",v=>v)}static{this.String=new c("string","",v=>typeof v=="string",v=>v)}static{this.StringArray=c.Arr(c.String)}static Arr(v){return new c(`${v.name}_array`,`Array of ${v.name}, ${v.description}`,b=>Array.isArray(b)&&b.every(E=>v.validate(E)),b=>b.map(E=>v.convert(E)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",v=>v instanceof T.$_K,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",v=>v instanceof T.$tM,g.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",v=>v instanceof f.$4M,g.TestItem.from)}constructor(v,b,E,A){this.name=v,this.description=b,this.validate=E,this.convert=A}optional(){return new c(this.name,`(optional) ${this.description}`,v=>v==null||this.validate(v),v=>v===void 0?void 0:v===null?null:this.convert(v))}with(v,b){return new c(v??this.name,b??this.description,this.validate,this.convert)}}e.$cN=c;class h{static{this.Void=new h("no result",v=>v)}constructor(v,b){this.description=v,this.convert=b}}e.$dN=h;class k{constructor(v,b,E,A,z){this.id=v,this.internalId=b,this.description=E,this.args=A,this.result=z}}e.$eN=k}),define(ke[313],Se([1,0,19,17,2,83,131,46,35,15,7]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;const C=[new $.$eN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of DocumentHighlight-instances.",w(y.DocumentHighlight.to))),new $.$eN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$cN.Uri],new $.$dN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if((0,D.$Kb)(l))return;class s extends M.$7K{static to(n){const o=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new M.$1K(f[0],y.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=y.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return l.map(s.to)})),new $.$eN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$cN.Uri,new $.$cN("options","Formatting options",l=>!0,l=>l)],new $.$dN("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$eN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$cN.Uri,$.$cN.Range,new $.$cN("options","Formatting options",l=>!0,l=>l)],new $.$dN("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$eN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$cN.Uri,$.$cN.Position,new $.$cN("ch","Trigger character",l=>typeof l=="string",l=>l),new $.$cN("options","Formatting options",l=>!0,l=>l)],new $.$dN("A promise that resolves to an array of TextEdits.",w(y.TextEdit.to))),new $.$eN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$eN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$eN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$eN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$eN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of Location-instances.",w(y.location.to))),new $.$eN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of Hover-instances.",w(y.Hover.to))),new $.$eN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$cN.Uri,new $.$cN("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>M.$PK.isPosition(f)),l=>l.map(y.Position.from))],new $.$dN("A promise that resolves to an array of ranges.",l=>l.map(f=>{let s;for(const i of f.reverse())s=new M.$$K(y.Range.to(i),s);return s}))),new $.$eN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$cN.String.with("query","Search string")],new $.$dN("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(y.WorkspaceSymbol.to))),new $.$eN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(y.CallHierarchyItem.to))),new $.$eN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$cN.CallHierarchyItem],new $.$dN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(y.CallHierarchyIncomingCall.to))),new $.$eN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$cN.CallHierarchyItem],new $.$dN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(y.CallHierarchyOutgoingCall.to))),new $.$eN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:y.Range.to(l.range),placeholder:l.text}})),new $.$eN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$cN.Uri,$.$cN.Position,$.$cN.String.with("newName","The new symbol name")],new $.$dN("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return y.WorkspaceEdit.to(l)}})),new $.$eN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$cN.Uri,$.$cN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$dN("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(y.DocumentLink.to))),new $.$eN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$cN.Uri],new $.$dN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new M.$5L(l.tokenTypes,l.tokenModifiers)})),new $.$eN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$cN.Uri],new $.$dN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.$h$)(l);if(f.type==="full")return new M.$7L(f.data,void 0)})),new $.$eN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$cN.Uri,$.$cN.Range.optional()],new $.$dN("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new M.$5L(l.tokenTypes,l.tokenModifiers)})),new $.$eN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$cN.Uri,$.$cN.Range],new $.$dN("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const f=(0,R.$h$)(l);if(f.type==="full")return new M.$7L(f.data,void 0)})),new $.$eN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$cN.Uri,$.$cN.Position,$.$cN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$cN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$dN("A promise that resolves to a CompletionList-instance.",(l,f,s)=>{if(!l)return new M.$kL([]);const i=l.suggestions.map(n=>y.CompletionItem.to(n,s));return new M.$kL(i,l.incomplete)})),new $.$eN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$cN.Uri,$.$cN.Position,$.$cN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$dN("A promise that resolves to SignatureHelp.",l=>{if(l)return y.SignatureHelp.to(l)})),new $.$eN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$cN.Uri,$.$cN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$dN("A promise that resolves to an array of CodeLens-instances.",(l,f,s)=>w(i=>new M.$cL(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(l))),new $.$eN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$cN.Uri,new $.$cN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>M.$QK.isRange(l),l=>M.$RK.isSelection(l)?y.Selection.from(l):y.Range.from(l)),$.$cN.String.with("kind","Code action kind to return code actions for").optional(),$.$cN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$dN("A promise that resolves to an array of Command-instances.",(l,f,s)=>w(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new M.$9K(i.title,i.kind?new M.$0K(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(l))),new $.$eN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$cN.Uri],new $.$dN("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new M.$qL(y.Range.to(f.range),y.Color.to(f.color))):[])),new $.$eN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$cN("color","The color to show and insert",l=>l instanceof M.$pL,y.Color.from),new $.$cN("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:y.Range.from(l.range)}))],new $.$dN("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(y.ColorPresentation.to):[])),new $.$eN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$cN.Uri,$.$cN.Range],new $.$dN("A promise that resolves to an array of Inlay objects",(l,f,s)=>l.map(y.InlayHint.to.bind(void 0,s)))),new $.$eN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$cN.Uri],new $.$dN("A promise that resolves to an array of FoldingRange objects",(l,f)=>{if(l)return l.map(y.FoldingRange.to)})),new $.$eN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$dN("A promise that resolves to an array of NotebookContentProvider static info objects.",w(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>y.NotebookExclusiveDocumentPattern.to(f))})))),new $.$eN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$cN.Uri,$.$cN.Range,new $.$cN("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof M.$QK,l=>y.InlineValueContext.from(l))],new $.$dN("A promise that resolves to an array of InlineValue objects",l=>l.map(y.InlineValue.to))),new $.$eN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$cN("uriOrString","Uri-instance or string (only http/https)",l=>g.URI.isUri(l)||typeof l=="string"&&(0,T.$bg)(l,T.Schemas.http,T.Schemas.https),l=>l),new $.$cN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional(),$.$cN.String.with("label","").optional()],$.$dN.Void),new $.$eN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$cN.Uri.with("resource","Resource to open"),$.$cN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$cN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[y.ViewColumn.from(l),void 0]:[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)])).optional()],$.$dN.Void),new $.$eN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$cN.Uri.with("left","Left-hand side resource of the diff editor"),$.$cN.Uri.with("right","Right-hand side resource of the diff editor"),$.$cN.String.with("title","Human readable title for the diff editor").optional(),new $.$cN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[y.ViewColumn.from(l.viewColumn),y.TextEditorOpenOptions.from(l)]).optional()],$.$dN.Void),new $.$eN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$cN.String.with("title","Human readable title for the changes editor"),new $.$cN("resourceList","List of resources to compare",l=>{for(const f of l){if(f.length!==3)return!1;const[s,i,n]=f;if(!g.URI.isUri(s)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],$.$dN.Void),new $.$eN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$cN.Uri,$.$cN.Position],new $.$dN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$eN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$cN.TypeHierarchyItem],new $.$dN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$eN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$cN.TypeHierarchyItem],new $.$dN("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(y.TypeHierarchyItem.to))),new $.$eN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$cN.TestItem],$.$dN.Void),new $.$eN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$cN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$dN.Void),new $.$eN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$cN.String.with("name","The context key name"),new $.$cN("value","The context key value",()=>!0,l=>l)],$.$dN.Void),new $.$eN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$cN.Uri,$.$cN.StringArray,new $.$cN("MappedEditsContext","Mapped Edits Context",l=>y.MappedEditsContext.is(l),l=>y.MappedEditsContext.from(l))],new $.$dN("A promise that resolves to a workspace edit or null",l=>l?y.WorkspaceEdit.to(l):null))];class m{static register(f){C.forEach(f.registerApiCommand,f),this.a(f)}static a(f){f.registerCommand(!1,"_validateWhenClauses",p.$1i)}}e.$dfc=m;function w(l){return f=>{if(Array.isArray(f))return f.map(l)}}function S(l){if(!Array.isArray(l))return;const f=[];for(const s of l)I.$st(s)?f.push(y.DefinitionLink.to(s)):f.push(y.location.to(s));return f}}),define(ke[314],Se([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;function w(S,l,f){const s=S.getProxy(C.$MK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$im,l.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const k=this.b.get(h.handle);return k?k.value:h}else if(h&&h.$mid===7){const k=this.b.get(h.commentControlHandle);if(!k)return h;const L=k.getCommentThread(h.commentThreadHandle);return L?L.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const L=k.getCommentThread(h.thread.commentThreadHandle);return L?h.$mid===8?L.value:{thread:L.value,text:h.text}:h}else if(h&&h.$mid===10){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const L=k.getCommentThread(h.thread.commentThreadHandle);if(!L)return h;const v=h.commentUniqueId,b=L.getCommentByUniqueId(v);return b||h}else if(h&&h.$mid===11){const k=this.b.get(h.thread.commentControlHandle);if(!k)return h;const L=k.getCommentThread(h.thread.commentThreadHandle);if(!L)return h;const v=h.text,b=h.commentUniqueId,E=L.getCommentByUniqueId(b);return E?(typeof E.body=="string"?E.body=v:E.body=new M.$dL(v),E):h}return h}})}createCommentController(h,k,L){const v=i.a++,b=new o(h,v,k,L);this.b.set(b.handle,b);const E=this.c.get(h.identifier)||[];return E.push(b),this.c.set(h.identifier,E),b.value}async $createCommentThreadTemplate(h,k,L){const v=this.b.get(h);v&&v.$createCommentThreadTemplate(k,L)}async $updateCommentThreadTemplate(h,k,L){const v=this.b.get(h);v&&v.$updateCommentThreadTemplate(k,L)}$deleteCommentThread(h,k){this.b.get(h)?.$deleteCommentThread(k)}$provideCommentingRanges(h,k,L){const v=this.b.get(h);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const b=f.getDocument(R.URI.revive(k));return(0,D.$Ug)(async()=>{const E=await v.commentingRangeProvider.provideCommentingRanges(b,L);let A;return Array.isArray(E)?A={ranges:E,fileComments:!1}:E?A={ranges:E.ranges||[],fileComments:E.fileComments||!1}:A=E??void 0,A}).then(E=>{let A;return E&&(A={ranges:E.ranges.map(z=>y.Range.from(z)),fileComments:E.fileComments}),A})}$toggleReaction(h,k,L,v,b){const E=this.b.get(h);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Ug)(()=>{const A=E.getCommentThread(k);if(A){const z=A.getCommentByUniqueId(v.uniqueIdInThread);if(E!==void 0&&z&&E.reactionHandler)return E.reactionHandler(z,r(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,k,L,v,b,E,A,z){this.m=k,this.n=L,this.o=v,this.p=b,this.q=E,this.extensionDescription=A,this.r=z,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Tc,this.l.value=new I.$Rc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(k,this.handle,this.n,this.o,y.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{s.$deleteCommentThread(k,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(P){O.range=P},get comments(){return O.comments},set comments(P){O.comments=P},get collapsibleState(){return O.collapsibleState},set collapsibleState(P){O.collapsibleState=P},get canReply(){return O.canReply},set canReply(P){O.canReply=P},get contextValue(){return O.contextValue},set contextValue(P){O.contextValue=P},get label(){return O.label},set label(P){O.label=P},get state(){return O.state},set state(P){O.state=P},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Rc);const h=L=>Object.prototype.hasOwnProperty.call(this.b,L),k={};h("range")&&(k.range=y.Range.from(this.p)),h("label")&&(k.label=this.label),h("contextValue")&&(k.contextValue=this.contextValue??null),h("comments")&&(k.comments=this.q.map(L=>a(this,L,this.k,this.extensionDescription))),h("collapsibleState")&&(k.collapseState=d(this.g)),h("canReply")&&(k.canReply=this.canReply),h("state")&&(k.state=u(this.h)),h("isTemplate")&&(k.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(h){for(const k of this.k){const L=k[0],v=k[1];if(h===v)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Je([(0,T.$uh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,k,L,v){this.f=h,this.g=k,this.h=L,this.i=v,this.a=new Map,s.$registerCommentController(this.handle,L,v,this.f.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(E){b.options=E},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(E){b.commentingRangeProvider=E},get reactionHandler(){return b.reactionHandler},set reactionHandler(E){b.reactionHandler=E},createCommentThread(E,A,z){return b.createCommentThread(E,A,z).value},dispose:()=>{b.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,k,L){k===void 0&&(0,m.$kF)(this.f,"fileComments");const v=new n(this.id,this.handle,void 0,h,k,L,this.f,!1);return this.a.set(v.handle,v),v}$createCommentThreadTemplate(h,k){const L=new n(this.id,this.handle,void 0,R.URI.revive(h),y.Range.to(k),[],this.f,!0);return L.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(h,k){const L=this.a.get(h);L&&(L.range=y.Range.to(k))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(c,h,k,L){let v=k.get(h);return v||(v=++c.commentHandle,k.set(h,v)),h.state!==void 0&&(0,m.$kF)(L,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:v,body:typeof h.body=="string"?h.body:y.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(b=>t(b)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?y.$PM(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?R.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function d(c){if(c!==void 0)switch(c){case M.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function u(c){if(c!==void 0)switch(c){case M.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}return new i}e.$nfc=w}),define(ke[315],Se([1,0,24,6,27,20]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;let R=class{constructor(M,C){this.a=M.getProxy(T.$MK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(M,C){const m=this,w=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){m.e(M,C,w,arguments)}})}e(M,C,m,w){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(w,this.b)}),this.c&&this.f(M,m,w)}};e.$bhc=R,e.$bhc=R=Je([We(0,I.$QM),We(1,g.$7M)],R);const p=1e5;function $(y,M){const C=[];if(y.length)for(let m=0;m<y.length;m++){let w=y[m];if(typeof w>"u")w="undefined";else if(w instanceof Error){const S=w;S.stack?w=S.stack:w=S.toString()}C.push(w)}if(M){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$mn)(C);return m.length>p?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(ke[149],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0;let w=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,f){this.h=f,this.f=new Map,this.g=l.getProxy(T.$MK.MainThreadDecorations)}registerFileDecorationProvider(l,f){const s=m.c++;this.f.set(s,{provider:l,extensionDescription:f}),this.g.$registerDecorationProvider(s,f.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,$.$3b)(n);if(o.length<=m.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,o.length);const a=o.map(d=>({uri:d,rank:(0,y.$Le)(d.path,"/")})),t=(0,$.$zb)(a,(d,u)=>d.rank-u.rank||(0,y.$1e)(d.uri.path,u.uri.path)),r=[];e:for(const d of t){let u;for(const c of d){const h=(0,M.$mc)(c.uri.path);if(u!==h&&(u=h,r.push(c.uri)>=m.d))break e}}this.g.$onDidChange(s,r)});return new g.$OK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(l,f,s){if(!this.f.has(l))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(l);return await Promise.all(f.map(async a=>{try{const{uri:t,id:r}=a,d=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!d)return;try{g.$$L.validate(d),d.badge&&typeof d.badge!="string"&&(0,C.$kF)(o,"codiconDecoration"),i[r]=[d.propagate,d.tooltip,d.badge,d.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$dgc=w,e.$dgc=w=m=Je([We(0,R.$QM),We(1,p.$jj)],w),e.$egc=(0,I.$2h)("IExtHostDecorations")}),define(ke[316],Se([1,0,211,135,2,6,7,15,4,14,28,57]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0;class w{#e;#t;#i;constructor(f,s,i,n,o,a,t,r){this.d=f,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new M.$Ac(d=>a.getComparisonKey(d)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(f,s){if(!f){this.clear();return}this.j();let i=[];if(g.URI.isUri(f)){if(!s){this.delete(f);return}this.#i.set(f,s.slice()),i=[f]}else if(Array.isArray(f)){i=[];let a;f=[...f].sort(w.k);for(const t of f){const[r,d]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),d)this.#i.get(r)?.push(...d);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const c of r)if(c.severity===d[u]&&t.push({...p.Diagnostic.from(c),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(d=>({...p.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(f){this.j(),this.#t.fire([f]),this.#i.delete(f),this.#e?.$changeMany(this.e,[[f,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(f,s){this.j();for(const[i,n]of this)f.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const f of this.#i.keys())yield[f,this.get(f)]}get(f){this.j();const s=this.#i.get(f);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(f){return this.j(),Array.isArray(this.#i.get(f))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(f,s){return f[0].toString()<s[0].toString()?-1:f[0].toString()>s[0].toString()?1:0}}e.$0ec=w;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(f){const s=new M.$Ac;for(const i of f)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(f,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$Wd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=f.getProxy(I.$MK.MainThreadDiagnostics)}createDiagnosticCollection(f,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,d=new class{$changeMany(h,k){n.$changeMany(h,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",f.value,h,k.length===0?"CLEARING":k)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",f.value,h)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+m.c++;while(i.has(u))}return new class extends w{constructor(){super(s,u,m.e,m.d,h=>r.getDocument(h)?.version,t.extUri,d,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(f){if(f)return this.m(f);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(f){let s=[];for(const i of this.g.values())i.has(f)&&(s=s.concat(i.get(f)));return s}$acceptMarkersChange(f){if(!this.n){const s="_generated_mirror",i=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of f)this.n.set(g.URI.revive(s),i.map(p.Diagnostic.to))}};e.$$ec=S,e.$$ec=S=m=Je([We(1,y.$jj),We(2,C.$9ec)],S)}),define(ke[317],Se([1,0,2,6,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;class I{constructor(p){this.a=p.getProxy(T.$MK.MainThreadDialogs)}showOpenDialog(p,$){return $?.allowUIResources&&(0,g.$kF)(p,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(M=>D.URI.revive(M)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then($=>$?D.URI.revive($):void 0)}}e.$fgc=I}),define(ke[318],Se([1,0,8,2,7,6,17,21,13]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ggc=void 0;class y{static{this.a=0}constructor(C,m,w){this.d=m,this.e=w,this.b=new Map,this.c=C.getProxy(I.$MK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const w=y.a++;this.b.set(w,m),this.c.$registerTextContentProvider(w,C);let S;return typeof m.onDidChange=="function"&&(S=m.onDidChange(l=>{if(l.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this.d.getDocument(l)&&this.$provideTextDocumentContent(w,l).then(f=>{if(!f&&typeof f!="string")return;const s=this.d.getDocument(l);if(!s)return;const i=(0,$.$Ve)(f);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(l,f)},D.$1)})),new g.$OK(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const w=this.b.get(C);return w?Promise.resolve(w.provideTextDocumentContent(T.URI.revive(m),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$ggc=y}),define(ke[319],Se([1,0,4,3,2,6,141,15,18,24,7,8]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;class m{constructor(S,l){this.a=new D.$Sd({onListenerError:C.$2}),this.b=new D.$Sd({onListenerError:C.$2}),this.c=new D.$Sd({onListenerError:C.$2}),this.d=new D.$Sd({onListenerError:C.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Rc,this.h=new Map,this.f=S.getProxy(I.$MK.MainThreadDocuments),this.g=l,this.g.onDidRemoveDocuments(f=>{for(const s of f)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const s of f)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const l=this.g.getDocument(S);if(l)return l}getDocument(S){const l=this.getDocumentData(S);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return l.document}ensureDocumentData(S){const l=this.g.getDocument(S);if(l)return Promise.resolve(l);let f=this.h.get(S.toString());return f||(f=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const i=g.URI.revive(s);return(0,$.$Pf)(this.g.getDocument(i))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),f)),f}createDocumentData(S){return this.f.$tryCreateDocument(S).then(l=>g.URI.revive(l))}$acceptModelLanguageChanged(S,l){const f=g.URI.revive(S),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(l),this.a.fire(s.document)}$acceptModelSaved(S){const l=g.URI.revive(S),f=this.g.getDocument(l);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(S,l){const f=g.URI.revive(S),s=this.g.getDocument(f);if(!s)throw new Error("unknown document");s._acceptIsDirty(l),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,l,f){const s=g.URI.revive(S),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),i.onEvents(l);let n;l.isUndoing?n=M.TextDocumentChangeReason.Undo:l.isRedoing&&(n=M.TextDocumentChangeReason.Redo),this.c.fire((0,y.$in)({document:i.document,contentChanges:l.changes.map(o=>({range:p.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(S,l){(0,R.$SM)(S,l)}}e.$7ec=m}),define(ke[69],Se([1,0,60,4,3,2,5,6,141,20,148,15,14,28,17,52,43]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new T.$Sd,this.e=new T.$Sd,this.f=new T.$Sd,this.g=new T.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const d of o.removedDocuments){const u=I.URI.revive(d),c=this.c.get(u);c?.unref()&&(this.c.delete(u),a.push(c.value))}if(o.addedDocuments)for(const d of o.addedDocuments){const u=I.URI.revive(d.uri);let c=this.c.get(u);if(c&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);c||(c=new s(new $.$TM(this.h.getProxy(p.$MK.MainThreadDocuments),u,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(u,c),t.push(c.value)),c.ref()}if(o.removedEditors)for(const d of o.removedEditors){const u=this.b.get(d);this.b.delete(d),u&&r.push(u)}if(o.addedEditors)for(const d of o.addedEditors){const u=I.URI.revive(d.documentUri);D.ok(this.c.has(u),`document '${u}' does not exist`),D.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(u).value,h=new M.$ZM(d.id,this.h.getProxy(p.$MK.MainThreadTextEditors),this.i,new f.$V(()=>c.document),d.selections.map(C.Selection.to),d.options,d.visibleRanges.map(k=>C.Range.to(k)),typeof d.editorPosition=="number"?C.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,g.$Nc)(a),(0,g.$Nc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return l.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$1M=i,e.$1M=i=Je([We(0,y.$QM),We(1,m.$jj)],i),e.$2M=(0,R.$2h)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,R.$2h)("IExtHostEditorTabs");class C{constructor(f,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(f)}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.id===f.e()},get label(){return f.b.label},get input(){return f.c},get isDirty(){return f.b.isDirty},get isPinned(){return f.b.isPinned},get isPreview(){return f.b.isPreview},get group(){return f.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(f){this.b=f,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$uM(I.URI.revive(this.b.input.uri));case 2:return new M.$vM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new M.$wM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new M.$xM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$yM(this.b.input.viewType);case 4:return new M.$zM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$AM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$BM;case 9:return new M.$CM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$DM(this.b.input.providerId);default:return}}}class m{constructor(f,s){this.c=[],this.d="",this.b=f,this.e=s;for(const i of f.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const f=this,s={get isActive(){return f.b.groupId===f.e()},get viewColumn(){return y.ViewColumn.to(f.b.viewColumn)},get activeTab(){return f.c.find(i=>i.tabId===f.d)?.apiObject},get tabs(){return Object.freeze(f.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(f){this.b=f}acceptTabOperation(f){if(f.kind===0){const i=new C(f.tabDto,this,()=>this.activeTabId());return this.c.splice(f.index,0,i),f.tabDto.isActive&&(this.d=i.tabId),i}else if(f.kind===1){const i=this.c.splice(f.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${f.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(f.kind===3){if(f.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(f.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${f.oldIndex} which does not exist`);return this.c.splice(f.index,0,i),i}const s=this.c.find(i=>i.tabId===f.tabDto.id);if(!s)throw new Error("INVALID tab");return f.tabDto.isActive?this.d=f.tabDto.id:this.d===f.tabDto.id&&!f.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(f.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(f){this.b=new T.$Sd,this.c=new T.$Sd,this.e=[],this.a=f.getProxy(p.$MK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const f=this,s={onDidChangeTabGroups:f.c.event,onDidChangeTabs:f.b.event,get all(){return Object.freeze(f.e.map(i=>i.apiObject))},get activeTabGroup(){const i=f.d;return(0,g.$Pf)(f.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?S(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(f){const s=new Set(this.e.map(d=>d.groupId)),i=new Set(f.map(d=>d.groupId)),n=(0,D.$L)(s,i),o=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=f.map(d=>{const u=new m(d,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,g.$Pf)(f.find(d=>d.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(f){const s=this.e.find(i=>i.groupId===f.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(f),f.isActive&&(this.d=f.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(f){const s=this.e.find(n=>n.groupId===f.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(f);switch(f.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(f){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===f)return i}h(f){return this.e.find(s=>s.apiObject===f)}async i(f,s){const i=[];for(const n of f){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(f,s){const i=[];for(const n of f){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$Hfc=w,e.$Hfc=w=Je([We(0,$.$QM)],w);function S(l){return l.tabs!==void 0}}),define(ke[320],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class g{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(D.$MK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,p,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const M=await y.provideEmbeddingVector(p,$);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(R,p,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(p,y),new T.$OK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$igc=g}),define(ke[321],Se([1,0,2,6,3,7,15,173,13,22,25,80]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const f=this.a.indexOf(l);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),f=[];let s,i,n=14,o=14;for(const a of l){let t=s?(0,$.$0e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,f.push([i,a.toUpperCase().charCodeAt(t),o]),f.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}f.push([9,58,10]),f.push([10,47,12]),this.b=new p.$jZ(f)}}provideDocumentLinks(l){this.c();const f=[],s=p.$kZ.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this.b);for(const i of s){const n=R.DocumentLink.to(i);n.target&&f.push(n)}return f}}class w{constructor(l,f){this.i=f,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(T.$MK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,f,s,i={}){if(w.j(s),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const n=this.h++;this.b.add(f),this.d.add(f),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,M.$kF)(l,"fsChunks"),o+=4);let a;i.isReadonly&&(0,C.$fk)(i.isReadonly)&&((0,M.$kF)(l,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,f,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${f}`),console.error(r)});const t=s.onDidChangeFile(r=>{const d=[];for(const u of r){const{uri:c,type:h}=u;if(c.scheme!==f)continue;let k;switch(h){case I.FileChangeType.Changed:k=0;break;case I.FileChangeType.Created:k=1;break;case I.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:k})}this.a.$onFileSystemChange(n,d)});return(0,g.$Qc)(()=>{t.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:f,ctime:s,mtime:i,size:n,permissions:o}=l;return{type:f,ctime:s,mtime:i,size:n,permissions:o}}$stat(l,f){return Promise.resolve(this.l(l).stat(D.URI.revive(f))).then(s=>w.k(s))}$readdir(l,f){return Promise.resolve(this.l(l).readDirectory(D.URI.revive(f)))}$readFile(l,f){return Promise.resolve(this.l(l).readFile(D.URI.revive(f))).then(s=>y.$ge.wrap(s))}$writeFile(l,f,s,i){return Promise.resolve(this.l(l).writeFile(D.URI.revive(f),s.buffer,i))}$delete(l,f,s){return Promise.resolve(this.l(l).delete(D.URI.revive(f),s))}$rename(l,f,s,i){return Promise.resolve(this.l(l).rename(D.URI.revive(f),D.URI.revive(s),i))}$copy(l,f,s,i){const n=this.l(l);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(f),D.URI.revive(s),i))}$mkdir(l,f){return Promise.resolve(this.l(l).createDirectory(D.URI.revive(f)))}$watch(l,f,s,i){const n=this.l(l).watch(D.URI.revive(s),i);this.f.set(f,n)}$unwatch(l,f){const s=this.f.get(f);s&&(s.dispose(),this.f.delete(f))}$open(l,f,s){const i=this.l(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(f),s))}$close(l,f){const s=this.l(l);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(f))}$read(l,f,s,i){const n=this.l(l);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$ge.alloc(i);return Promise.resolve(n.read(f,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(l,f,s,i){const n=this.l(l);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,s,i.buffer,0,i.byteLength))}l(l){const f=this.c.get(l);if(!f){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return f}}e.$jgc=w}),define(ke[71],Se([1,0,6,32,7,22,5,20,57,3,12,23,17]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=void 0;let S=w=class{constructor(f,s){this.b=new Map,this.c=new M.$$g,this.a=f.getProxy(D.$MK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===T.FilePermission.Readonly?1:void 0}}catch(o){w.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return w.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return w.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return w.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,I.$ge.wrap(o))}catch(a){return w.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return w.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return w.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return w.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(f,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await f.stat(i)).type&T.FileType.Directory))throw g.$3L.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(T.$Bk(o)!==T.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await f.createDirectory(i)}catch(a){if(T.$Bk(a)!==T.FileSystemProviderErrorCode.FileExists)throw a}}}static e(f){if(f instanceof g.$3L)throw f;if(f instanceof T.$xk)switch(f.code){case T.FileSystemProviderErrorCode.FileExists:throw g.$3L.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$3L.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$3L.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$3L.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$3L.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$3L.Unavailable(f.message);default:throw new g.$3L(f.message,f.name)}if(!(f instanceof Error))throw new g.$3L(String(f));if(f.name==="ENOPRO"||f.message.includes("ENOPRO"))throw g.$3L.Unavailable(f.message);switch(f.name){case T.FileSystemProviderErrorCode.FileExists:throw g.$3L.FileExists(f.message);case T.FileSystemProviderErrorCode.FileNotFound:throw g.$3L.FileNotFound(f.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw g.$3L.FileNotADirectory(f.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw g.$3L.FileIsADirectory(f.message);case T.FileSystemProviderErrorCode.NoPermissions:throw g.$3L.NoPermissions(f.message);case T.FileSystemProviderErrorCode.Unavailable:throw g.$3L.Unavailable(f.message);default:throw new g.$3L(f.message,f.name)}}addFileSystemProvider(f,s,i){return this.b.set(f,{impl:s,extUri:i?.isCaseSensitive?C.$tg:C.$vg,isReadonly:!!i?.isReadonly}),(0,y.$Qc)(()=>this.b.delete(f))}getFileSystemProviderExtUri(f){return this.b.get(f)?.extUri??C.$tg}};e.$vfc=S,e.$vfc=S=w=Je([We(0,p.$QM),We(1,$.$9ec)],S),e.$wfc=(0,R.$2h)("IExtHostConsumerFileSystem")}),define(ke[322],Se([1,0,4,34,2,6,15,7,43]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,S,l,f,s,i){this.a=Math.random(),this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,T.$Ij)(s),o=typeof s=="string",a=i?.correlate,t=f(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const d of r.created){const u=g.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const d of r.changed){const u=g.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const d of r.deleted){const u=g.URI.revive(d);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=p.$OK.from(this.i(w,l,s,i,i?.correlate),this.b,this.c,this.d,t)}i(w,S,l,f,s){const i=p.$OK.from();if(typeof l=="string")return i;const n=w.getProxy(I.$MK.MainThreadFileSystemEventService);let o=!1;return(l.pattern.includes(T.$Ej)||l.pattern.includes(T.$Fj))&&(o=!0),n.$watch(S.identifier.value,this.a,l.baseUri,{recursive:o,excludes:f?.excludes??[]},!!s),p.$OK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(w){this.a=w,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(g.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(w,S,l){this.j=w,this.k=S,this.l=l,this.a=new D.$Sd,this.b=new D.$Sd,this.c=new D.$Sd,this.d=new D.$Sd,this.g=new D.$Ud,this.h=new D.$Ud,this.i=new D.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,S,l,f){return new y(this.j,w,S,this.a.event,R.GlobPattern.from(l),f)}$onFileEvent(w){this.a.fire(new M(w))}$onDidRunFileOperation(w,S){switch(w){case 2:this.b.fire(Object.freeze({files:S.map(l=>({oldUri:g.URI.revive(l.source),newUri:g.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(l=>g.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(l=>g.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,S){return(l,f,s)=>{const i=function(o){l.call(f,o)};return i.extension=w,S.event(i,void 0,s)}}async $onWillRunFileOperation(w,S,l,f){switch(w){case 2:return await this.n(this.g,{files:S.map(s=>({oldUri:g.URI.revive(s.source),newUri:g.URI.revive(s.target)}))},l,f);case 1:return await this.n(this.i,{files:S.map(s=>g.URI.revive(s.target))},l,f);case 0:case 3:return await this.n(this.h,{files:S.map(s=>g.URI.revive(s.target))},l,f)}}async n(w,S,l,f){const s=new Set,i=[];if(await w.fireAsync(S,f,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof p.$YK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",a.extension.identifier)}),f.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$kgc=C}),define(ke[323],Se([1,0,3,2,6,15,7,35,12]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class y{static{this.a=0}constructor(w,S){this.extension=w,this.provider=S,this.handle=y.a++}}class M{constructor(w){this.session=w,this.responses=[]}}class C{static{this.a=0}constructor(w,S,l,f){this.f=l,this.g=f,this.b=new Map,this.d=new Map,this.e=w.getProxy(g.$MK.MainThreadInlineChat),S.registerApiCommand(new p.$eN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$cN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?I.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?I.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?I.Position.from(s.position):void 0}})],p.$dN.Void))}registerProvider(w,S,l){const f=new y(w,S);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,l?.label??w.displayName??w.name,w.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",l?.supportReportIssue??!1),(0,D.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(w,S,l,f){const s=this.b.get(w);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(S)),n=I.Selection.to(l),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},f);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new M(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(o.wholeRange),message:o.message}}async $provideResponse(w,S,l,f){const s=this.b.get(w);if(!s)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:l.prompt,selection:I.Selection.to(l.selection),wholeRange:I.Range.to(l.wholeRange),attempt:l.attempt,live:l.live};let o=!1;const a={report:async c=>{if(!l.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||f.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:c.message,edits:c.edits?.map(I.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:R.$dL.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,f));let r;try{r=await(0,$.$Qg)(t,f)}finally{o=!0}if(!r)return;const d=i.responses.push(r)-1,u={wholeRange:I.Range.from(r.wholeRange),placeholder:r.placeholder};if(C.h(r)){const{edits:c,contents:h}=r,k=h!==void 0?I.MarkdownString.from(h):void 0;return c instanceof R.$YK?{...u,id:d,type:"bulkEdit",edits:I.WorkspaceEdit.from(c),message:k}:{...u,id:d,type:"editorEdit",edits:c.map(I.TextEdit.from),message:k}}return{...u,id:d,type:"message",message:I.MarkdownString.from(r.contents)}}async $provideFollowups(w,S,l,f){const s=this.b.get(w),i=this.d.get(S),n=i?.responses[l];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,f));return(await(0,$.$Qg)(o,f))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(w,S,l,f){const s=this.b.get(w),i=this.d.get(S),n=i?.responses[l];if(s&&n){const o=I.InteractiveEditorResponseFeedbackKind.to(f);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(w,S){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$lgc=C}),define(ke[324],Se([1,0,2,35]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class g{constructor(R,p,$,y,M){this.a=p,this.b=$,this.c=y;const C=new T.$eN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$cN("showOptions","Show Options",m=>!0,m=>m),new T.$cN("resource","Interactive resource Uri",m=>!0,m=>m),new T.$cN("controllerId","Notebook controller Id",m=>!0,m=>m),new T.$cN("title","Interactive editor title",m=>!0,m=>m)],new T.$dN("Notebook and input URI",m=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const w=this.a.getEditorById(m.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:w.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,p,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$ygc=g}),define(ke[325],Se([1,0,6,7]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class g{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(D.$MK.MainThreadIssueReporter)}async $getIssueReporterUri(R,p){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(p);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,p){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(p);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,p){const $=R.identifier.value;return this.a.set($,p),this.c.$registerIssueUriRequestHandler($),new T.$OK(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,p){const $=R.identifier.value;return this.b.set($,p),this.c.$registerIssueDataProvider($),new T.$OK(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$zgc=g}),define(ke[326],Se([1,0,3,6]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class g{constructor(R){this.b=0,this.a=R.getProxy(T.$MK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,R),(0,D.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Agc=g}),define(ke[327],Se([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,131,121,110,38,8,12,25,213]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class d{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentSymbols(U,Q){const ee=this.d.getDocument(U),V=await this.e.provideDocumentSymbols(ee,Q);if(!(0,M.$Kb)(V))return V[0]instanceof I.$8K?V.map(g.DocumentSymbol.from):d.f(V)}static f(U){U=U.slice(0).sort((V,ae)=>{let ue=V.location.range.start.compareTo(ae.location.range.start);return ue===0&&(ue=ae.location.range.end.compareTo(V.location.range.end)),ue});const Q=[],ee=[];for(const V of U){const ae={name:V.name||"!!MISSING: name!!",kind:g.SymbolKind.from(V.kind),tags:V.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:g.Range.from(V.location.range),selectionRange:g.Range.from(V.location.range),children:[]};for(;;){if(ee.length===0){ee.push(ae),Q.push(ae);break}const ue=ee[ee.length-1];if(y.$Gs.containsRange(ue.range,ae.range)&&!y.$Gs.equalsRange(ue.range,ae.range)){ue.children?.push(ae),ee.push(ae);break}ee.pop()}}return Q}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(U,Q,ee){this.g=U,this.h=Q,this.j=ee,this.e=new i.$5ec("CodeLens"),this.f=new Map}async provideCodeLenses(U,Q){const ee=this.g.getDocument(U),V=await this.j.provideCodeLenses(ee,Q);if(!V||Q.isCancellationRequested)return;const ae=this.e.add(V),ue=new l.$Rc;this.f.set(ae,ue);const Le={cacheId:ae,lenses:[]};for(let je=0;je<V.length;je++)Le.lenses.push({cacheId:[ae,je],range:g.Range.from(V[je].range),command:this.h.toInternal(V[je].command,ue)});return Le}async resolveCodeLens(U,Q){const ee=U.cacheId&&this.e.get(...U.cacheId);if(!ee)return;let V;if(typeof this.j.resolveCodeLens!="function"||ee.isResolved?V=ee:V=await this.j.resolveCodeLens(ee,Q),V||(V=ee),Q.isCancellationRequested)return;const ae=U.cacheId&&this.f.get(U.cacheId[0]);if(ae)return U.command=this.h.toInternal(V.command??u.d,ae),U}releaseCodeLenses(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}}function c(De){return Array.isArray(De)?De.map(g.DefinitionLink.from):De?[g.DefinitionLink.from(De)]:[]}class h{constructor(U,Q){this.d=U,this.e=Q}async provideDefinition(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideDefinition(V,ae,ee);return c(ue)}}class k{constructor(U,Q){this.d=U,this.e=Q}async provideDeclaration(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideDeclaration(V,ae,ee);return c(ue)}}class L{constructor(U,Q){this.d=U,this.e=Q}async provideImplementation(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideImplementation(V,ae,ee);return c(ue)}}class v{constructor(U,Q){this.d=U,this.e=Q}async provideTypeDefinition(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideTypeDefinition(V,ae,ee);return c(ue)}}class b{constructor(U,Q){this.d=U,this.e=Q}async provideHover(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideHover(V,ae,ee);if(!(!ue||(0,M.$Kb)(ue.contents)))return ue.range||(ue.range=V.getWordRangeAtPosition(ae)),ue.range||(ue.range=new I.$QK(ae,ae)),g.Hover.from(ue)}}class E{constructor(U,Q){this.d=U,this.e=Q}async provideEvaluatableExpression(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideEvaluatableExpression(V,ae,ee);if(ue)return g.EvaluatableExpression.from(ue)}}class A{constructor(U,Q){this.d=U,this.e=Q}async provideInlineValues(U,Q,ee,V){const ae=this.d.getDocument(U),ue=await this.e.provideInlineValues(ae,g.Range.to(Q),g.InlineValueContext.to(ee),V);if(Array.isArray(ue))return ue.map(Le=>g.InlineValue.from(Le))}}class z{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentHighlights(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideDocumentHighlights(V,ae,ee);if(Array.isArray(ue))return ue.map(g.DocumentHighlight.from)}}class O{constructor(U,Q){this.d=U,this.e=Q}async provideMultiDocumentHighlights(U,Q,ee,V){const ae=this.d.getDocument(U),ue=ee.map(Ke=>this.d.getDocument(Ke)),Le=g.Position.to(Q),je=await this.e.provideMultiDocumentHighlights(ae,Le,ue,V);if(Array.isArray(je))return je.map(g.MultiDocumentHighlight.from)}}class P{constructor(U,Q){this.d=U,this.e=Q}async provideLinkedEditingRanges(U,Q,ee){const V=this.d.getDocument(U),ae=g.Position.to(Q),ue=await this.e.provideLinkedEditingRanges(V,ae,ee);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,M.$Hb)(ue.ranges.map(g.Range.from)),wordPattern:ue.wordPattern}}}class j{constructor(U,Q){this.d=U,this.e=Q}async provideReferences(U,Q,ee,V){const ae=this.d.getDocument(U),ue=g.Position.to(Q),Le=await this.e.provideReferences(ae,ue,ee,V);if(Array.isArray(Le))return Le.map(g.location.from)}}class N{static{this.d=1e3}constructor(U,Q,ee,V,ae,ue,Le){this.g=U,this.h=Q,this.j=ee,this.k=V,this.l=ae,this.m=ue,this.n=Le,this.e=new i.$5ec("CodeAction"),this.f=new Map}async provideCodeActions(U,Q,ee,V){const ae=this.g.getDocument(U),ue=m.$Is.isISelection(Q)?g.Selection.to(Q):g.Range.to(Q),Le=[];for(const ot of this.j.getDiagnostics(U))if(ue.intersection(ot.range)&&Le.push(ot)>N.d)break;const je={diagnostics:Le,only:ee.only?new I.$0K(ee.only):void 0,triggerKind:g.CodeActionTriggerKind.to(ee.trigger)},Ke=await this.k.provideCodeActions(ae,ue,je,V);if(!(0,M.$Lb)(Ke)||V.isCancellationRequested)return;const Qe=this.e.add(Ke),_e=new l.$Rc;this.f.set(Qe,_e);const at=[];for(let ot=0;ot<Ke.length;ot++){const Ie=Ke[ot];Ie&&(N.o(Ie)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:Ie.title,command:this.h.toInternal(Ie,_e)})):(je.only&&(Ie.kind?je.only.contains(Ie.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${Ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),at.push({cacheId:[Qe,ot],title:Ie.title,command:Ie.command&&this.h.toInternal(Ie.command,_e),diagnostics:Ie.diagnostics&&Ie.diagnostics.map(g.Diagnostic.from),edit:Ie.edit&&g.WorkspaceEdit.from(Ie.edit,void 0),kind:Ie.kind&&Ie.kind.value,isPreferred:Ie.isPreferred,isAI:(0,t.$jF)(this.m,"codeActionAI")?Ie.isAI:!1,disabled:Ie.disabled?.reason})))}return{cacheId:Qe,actions:at}}async resolveCodeAction(U,Q){const[ee,V]=U,ae=this.e.get(ee,V);if(!ae||N.o(ae))return{};if(!this.k.resolveCodeAction)return{};const ue=await this.k.resolveCodeAction(ae,Q)??ae;let Le;ue.edit&&(Le=g.WorkspaceEdit.from(ue.edit,void 0));let je;if(ue.command){const Ke=this.f.get(ee);Ke&&(je=this.h.toInternal(ue.command,Ke))}return{edit:Le,command:je}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class F{static toInternalProviderId(U,Q){return U+"."+Q}constructor(U,Q,ee,V,ae){this.d=U,this.e=Q,this.f=ee,this.g=V,this.h=ae}async prepareDocumentPaste(U,Q,ee,V){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(U),ue=Q.map(Ke=>g.Range.to(Ke)),Le=g.DataTransfer.toDataTransfer(ee,()=>{throw new o.$$});if(await this.f.prepareDocumentPaste(ae,ue,Le,V),V.isCancellationRequested)return;const je=Array.from(Le).filter(([,Ke])=>!(Ke instanceof I.$DL));return g.DataTransfer.from(je)}async providePasteEdits(U,Q,ee,V,ae){if(!this.f.provideDocumentPasteEdits)return;const ue=this.e.getDocument(Q),Le=ee.map(Qe=>g.Range.to(Qe)),je=g.DataTransfer.toDataTransfer(V,async Qe=>(await this.d.$resolvePasteFileData(this.g,U,Qe)).buffer),Ke=await this.f.provideDocumentPasteEdits(ue,Le,je,ae);if(Ke)return{label:Ke.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ke.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:F.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?g.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class W{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentFormattingEdits(U,Q,ee){const V=this.d.getDocument(U),ae=await this.e.provideDocumentFormattingEdits(V,Q,ee);if(Array.isArray(ae))return ae.map(g.TextEdit.from)}}class x{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentRangeFormattingEdits(U,Q,ee,V){const ae=this.d.getDocument(U),ue=g.Range.to(Q),Le=await this.e.provideDocumentRangeFormattingEdits(ae,ue,ee,V);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,Q,ee,V){(0,C.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(U),ue=Q.map(g.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(ae,ue,ee,V);if(Array.isArray(Le))return Le.map(g.TextEdit.from)}}class ce{constructor(U,Q){this.d=U,this.e=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,Q,ee,V,ae){const ue=this.d.getDocument(U),Le=g.Position.to(Q),je=await this.e.provideOnTypeFormattingEdits(ue,Le,ee,V,ae);if(Array.isArray(je))return je.map(g.TextEdit.from)}}class J{constructor(U,Q){this.e=U,this.f=Q,this.d=new i.$5ec("WorkspaceSymbols")}async provideWorkspaceSymbols(U,Q){const ee=await this.e.provideWorkspaceSymbols(U,Q);if(!(0,M.$Lb)(ee))return{symbols:[]};const V=this.d.add(ee),ae={cacheId:V,symbols:[]};for(let ue=0;ue<ee.length;ue++){const Le=ee[ue];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}ae.symbols.push({...g.WorkspaceSymbol.from(Le),cacheId:[V,ue]})}return ae}async resolveWorkspaceSymbol(U,Q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const ee=this.d.get(...U.cacheId);if(ee){const V=await this.e.resolveWorkspaceSymbol(ee,Q);return V&&(0,T.$kn)(U,g.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Y{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,Q,ee){this.d=U,this.e=Q,this.f=ee}async provideRenameEdits(U,Q,ee,V){const ae=this.d.getDocument(U),ue=g.Position.to(Q);try{const Le=await this.e.provideRenameEdits(ae,ue,ee,V);return Le?g.WorkspaceEdit.from(Le):void 0}catch(Le){const je=Y.g(Le);return je?{rejectReason:je,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(U,Q,ee){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(U),ae=g.Position.to(Q);try{const ue=await this.e.prepareRename(V,ae,ee);let Le,je;if(I.$QK.isRange(ue)?(Le=ue,je=V.getText(ue)):(0,C.$Gf)(ue)&&(Le=ue.range,je=ue.placeholder),!Le||!je)return;if(Le.start.line>ae.line||Le.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Le),text:je}}catch(ue){const Le=Y.g(ue);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(ue)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class X{constructor(U,Q){this.resultId=U,this.tokens=Q}}class se{constructor(U,Q){this.f=U,this.g=Q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,Q,ee){const V=this.f.getDocument(U),ae=Q!==0?this.d.get(Q):null;let ue=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,ae.resultId,ee):await this.g.provideDocumentSemanticTokens(V,ee);return ae&&this.d.delete(Q),ue?(ue=se.h(ue),this.o(se.n(ae,ue),ue)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return se.j(U)?se.k(U)?U:new I.$7L(new Uint32Array(U.data),U.resultId):se.l(U)?se.m(U)?U:new I.$9L(U.edits.map(Q=>new I.$8L(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const Q of U.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static n(U,Q){if(!se.j(Q)||!U||!U.tokens)return Q;const ee=U.tokens,V=ee.length,ae=Q.data,ue=ae.length;let Le=0;const je=Math.min(V,ue);for(;Le<je&&ee[Le]===ae[Le];)Le++;if(Le===V&&Le===ue)return new I.$9L([],Q.resultId);let Ke=0;const Qe=je-Le;for(;Ke<Qe&&ee[V-Ke-1]===ae[ue-Ke-1];)Ke++;return new I.$9L([{start:Le,deleteCount:V-Le-Ke,data:ae.subarray(Le,ue-Ke)}],Q.resultId)}o(U,Q){if(se.j(U)){const ee=this.e++;return this.d.set(ee,new X(U.resultId,U.data)),(0,f.$g$)({id:ee,type:"full",data:U.data})}if(se.l(U)){const ee=this.e++;return se.j(Q)?this.d.set(ee,new X(Q.resultId,Q.data)):this.d.set(ee,new X(U.resultId)),(0,f.$g$)({id:ee,type:"delta",deltas:(U.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class Z{constructor(U,Q){this.d=U,this.e=Q}async provideDocumentRangeSemanticTokens(U,Q,ee){const V=this.d.getDocument(U),ae=await this.e.provideDocumentRangeSemanticTokens(V,g.Range.to(Q),ee);return ae?this.f(ae):null}f(U){return(0,f.$g$)({id:0,type:"full",data:U.data})}}class we{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,Q,ee,V,ae){this.f=U,this.g=Q,this.h=ee,this.j=V,this.k=ae,this.d=new i.$5ec("CompletionItem"),this.e=new Map}async provideCompletionItems(U,Q,ee,V){const ae=this.f.getDocument(U),ue=g.Position.to(Q),Le=ae.getWordRangeAtPosition(ue)||new I.$QK(ue,ue),je=Le.with({end:ue}),Ke=new n.$Od,Qe=await this.h.provideCompletionItems(ae,ue,V,g.CompletionContext.to(ee));if(!Qe||V.isCancellationRequested)return;const _e=Array.isArray(Qe)?new I.$kL(Qe):Qe,at=we.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),ot=new l.$Rc;this.e.set(at,ot);const Ie=[],ze={x:at,b:Ie,a:{replace:g.Range.from(Le),insert:g.Range.from(je)},c:_e.isIncomplete||void 0,d:Ke.elapsed()};for(let qe=0;qe<_e.items.length;qe++){const Re=_e.items[qe],et=this.l(Re,[at,qe],je,Le);Ie.push(et)}return ze}async resolveCompletionItem(U,Q){if(typeof this.h.resolveCompletionItem!="function")return;const ee=this.d.get(...U);if(!ee)return;const V=this.l(ee,U),ae=await this.h.resolveCompletionItem(ee,Q);if(!ae)return;const ue=this.l(ae,U);return(V.h!==ue.h||V.i!==ue.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V.n!==ue.n||V.o!==ue.o||!(0,T.$ln)(V.p,ue.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,d:ue.d,c:ue.c,l:ue.l,h:ue.h,i:ue.i,n:ue.n,o:ue.o,p:ue.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Q,ee,V){const ae=this.e.get(Q[0]);if(!ae)throw Error("DisposableStore is missing...");const ue=this.g.toInternal(U.command,ae),Le={x:Q,a:U.label,b:U.kind!==void 0?g.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(g.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:g.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(g.TextEdit.from),n:ue?.$ident,o:ue?.id,p:ue?.$ident?void 0:ue?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=U.textEdit.newText):typeof U.insertText=="string"?Le.h=U.insertText:U.insertText instanceof I.$ZK&&(Le.h=U.insertText.value,Le.i|=4);let je;return U.textEdit?je=U.textEdit.range:U.range&&(je=U.range),I.$QK.isRange(je)?Le.j=g.Range.from(je):je&&(!ee?.isEqual(je.inserting)||!V?.isEqual(je.replacing))&&(Le.j={insert:g.Range.from(je.inserting),replace:g.Range.from(je.replacing)}),Le}}class de{async provideInlineCompletions(U,Q,ee,V){}disposeCompletions(U){}handleDidShowCompletionItem(U,Q,ee){}handlePartialAccept(U,Q,ee){}}class K extends de{constructor(U,Q,ee,V){super(),this.f=U,this.g=Q,this.h=ee,this.j=V,this.d=new B,this.e=(0,t.$jF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$jF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,Q,ee,V){const ae=this.g.getDocument(U),ue=g.Position.to(Q),Le=await this.h.provideInlineCompletionItems(ae,ue,{selectedCompletionInfo:ee.selectedSuggestionInfo?{range:g.Range.to(ee.selectedSuggestionInfo.range),text:ee.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ee.triggerKind]},V);if(!Le||V.isCancellationRequested)return;const je=Array.isArray(Le)?Le:Le.items,Ke=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Qe=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((ot,Ie)=>{let ze;ot.command&&(_e||(_e=new l.$Rc),ze=this.j.toInternal(ot.command,_e));const qe=ot.insertText;return{insertText:typeof qe=="string"?qe:{snippet:qe.value},filterText:ot.filterText,range:ot.range?g.Range.from(ot.range):void 0,command:ze,idx:Ie,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Ke.map(ot=>(_e||(_e=new l.$Rc),this.j.toInternal(ot,_e))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,Q,ee){const V=this.d.get(U)?.items[Q];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,ee)}handlePartialAccept(U,Q,ee){const V=this.d.get(U)?.items[Q];V&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(V,ee)}}class B{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const Q=this.e++;return this.d.set(Q,U),Q}disposeReferenceId(U){const Q=this.d.get(U);return this.d.delete(U),Q}get(U){return this.d.get(U)}}class ne{constructor(U,Q){this.e=U,this.f=Q,this.d=new i.$5ec("SignatureHelp")}async provideSignatureHelp(U,Q,ee,V){const ae=this.e.getDocument(U),ue=g.Position.to(Q),Le=this.g(ee),je=await this.f.provideSignatureHelp(ae,ue,V,Le);if(je){const Ke=this.d.add([je]);return{...g.SignatureHelp.from(je),id:Ke}}}g(U){let Q;if(U.activeSignatureHelp){const ee=g.SignatureHelp.to(U.activeSignatureHelp),V=this.d.get(U.activeSignatureHelp.id,0);V?(Q=V,Q.activeSignature=ee.activeSignature,Q.activeParameter=ee.activeParameter):Q=ee}return{...U,activeSignatureHelp:Q}}releaseSignatureHelp(U){this.d.delete(U)}}class ye{constructor(U,Q,ee,V,ae){this.f=U,this.g=Q,this.h=ee,this.j=V,this.k=ae,this.d=new i.$5ec("InlayHints"),this.e=new Map}async provideInlayHints(U,Q,ee){const V=this.f.getDocument(U),ae=g.Range.to(Q),ue=await this.h.provideInlayHints(V,ae,ee);if(!Array.isArray(ue)||ue.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`);return}if(ee.isCancellationRequested)return;const Le=this.d.add(ue);this.e.set(Le,new l.$Rc);const je={hints:[],cacheId:Le};for(let Ke=0;Ke<ue.length;Ke++)this.l(ue[Ke],ae)&&je.hints.push(this.m(ue[Ke],[Le,Ke]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Q)}`),je}async resolveInlayHint(U,Q){if(typeof this.h.resolveInlayHint!="function")return;const ee=this.d.get(...U);if(!ee)return;const V=await this.h.resolveInlayHint(ee,Q);if(V&&this.l(V))return this.m(V,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,Q){return U.label.length===0||Array.isArray(U.label)&&U.label.every(ee=>ee.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(Q&&!Q.contains(U.position))}m(U,Q){const ee=this.e.get(Q[0]);if(!ee)throw Error("DisposableStore is missing...");const V={label:"",cacheId:Q,tooltip:g.MarkdownString.fromStrict(U.tooltip),position:g.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(g.TextEdit.from),kind:U.kind&&g.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};return typeof U.label=="string"?V.label=U.label:V.label=U.label.map(ae=>{const ue={label:ae.value};return ue.tooltip=g.MarkdownString.fromStrict(ae.tooltip),I.$1K.isLocation(ae.location)&&(ue.location=g.location.from(ae.location)),ae.command&&(ue.command=this.g.toInternal(ae.command,ee)),ue}),V}}class he{constructor(U,Q){this.e=U,this.f=Q,this.d=new i.$5ec("DocumentLink")}async provideLinks(U,Q){const ee=this.e.getDocument(U),V=await this.f.provideDocumentLinks(ee,Q);if(!(!Array.isArray(V)||V.length===0)&&!Q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(he.g).map(g.DocumentLink.from)};{const ae=this.d.add(V),ue={links:[],cacheId:ae};for(let Le=0;Le<V.length;Le++){if(!he.g(V[Le]))continue;const je=g.DocumentLink.from(V[Le]);je.cacheId=[ae,Le],ue.links.push(je)}return ue}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,Q){if(typeof this.f.resolveDocumentLink!="function")return;const ee=this.d.get(...U);if(!ee)return;const V=await this.f.resolveDocumentLink(ee,Q);if(!(!V||!he.g(V)))return g.DocumentLink.from(V)}releaseLinks(U){this.d.delete(U)}}class ge{constructor(U,Q){this.d=U,this.e=Q}async provideColors(U,Q){const ee=this.d.getDocument(U),V=await this.e.provideDocumentColors(ee,Q);return Array.isArray(V)?V.map(ue=>({color:g.Color.from(ue.color),range:g.Range.from(ue.range)})):[]}async provideColorPresentations(U,Q,ee){const V=this.d.getDocument(U),ae=g.Range.to(Q.range),ue=g.Color.to(Q.color),Le=await this.e.provideColorPresentations(ue,{document:V,range:ae},ee);if(Array.isArray(Le))return Le.map(g.ColorPresentation.from)}}class _{constructor(U,Q){this.d=U,this.e=Q}async provideFoldingRanges(U,Q,ee){const V=this.d.getDocument(U),ae=await this.e.provideFoldingRanges(V,Q,ee);if(Array.isArray(ae))return ae.map(g.FoldingRange.from)}}class ie{constructor(U,Q,ee){this.d=U,this.e=Q,this.f=ee}async provideSelectionRanges(U,Q,ee){const V=this.d.getDocument(U),ae=Q.map(g.Position.to),ue=await this.e.provideSelectionRanges(V,ae,ee);if(!(0,M.$Lb)(ue))return[];if(ue.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let je=0;je<ae.length;je++){const Ke=[];Le.push(Ke);let Qe=ae[je],_e=ue[je];for(;;){if(!_e.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(g.SelectionRange.from(_e)),!_e.parent)break;Qe=_e.range,_e=_e.parent}}return Le}}class G{constructor(U,Q){this.f=U,this.g=Q,this.d=new s.$VM(""),this.e=new Map}async prepareSession(U,Q,ee){const V=this.f.getDocument(U),ae=g.Position.to(Q),ue=await this.g.prepareCallHierarchy(V,ae,ee);if(!ue)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ue)?ue.map(je=>this.h(Le,je)):[this.h(Le,ue)]}async provideCallsTo(U,Q,ee){const V=this.j(U,Q);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(V,ee);if(ae)return ae.map(ue=>({from:this.h(U,ue.from),fromRanges:ue.fromRanges.map(Le=>g.Range.from(Le))}))}async provideCallsFrom(U,Q,ee){const V=this.j(U,Q);if(!V)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(V,ee);if(ae)return ae.map(ue=>({to:this.h(U,ue.to),fromRanges:ue.fromRanges.map(Le=>g.Range.from(Le))}))}releaseSession(U){this.e.delete(U)}h(U,Q){const ee=this.e.get(U),V=g.CallHierarchyItem.from(Q,U,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(U,Q){return this.e.get(U)?.get(Q)}}class te{constructor(U,Q){this.f=U,this.g=Q,this.d=new s.$VM(""),this.e=new Map}async prepareSession(U,Q,ee){const V=this.f.getDocument(U),ae=g.Position.to(Q),ue=await this.g.prepareTypeHierarchy(V,ae,ee);if(!ue)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ue)?ue.map(je=>this.h(Le,je)):[this.h(Le,ue)]}async provideSupertypes(U,Q,ee){const V=this.j(U,Q);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(V,ee);if(ae)return ae.map(ue=>this.h(U,ue))}async provideSubtypes(U,Q,ee){const V=this.j(U,Q);if(!V)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(V,ee);if(ae)return ae.map(ue=>this.h(U,ue))}releaseSession(U){this.e.delete(U)}h(U,Q){const ee=this.e.get(U),V=g.TypeHierarchyItem.from(Q,U,ee.size.toString(36));return ee.set(V._itemId,Q),V}j(U,Q){return this.e.get(U)?.get(Q)}}class fe{static toInternalProviderId(U,Q){return U+"."+Q}constructor(U,Q,ee,V,ae){this.d=U,this.e=Q,this.f=ee,this.g=V,this.h=ae}async provideDocumentOnDropEdits(U,Q,ee,V,ae){const ue=this.e.getDocument(Q),Le=g.Position.to(ee),je=g.DataTransfer.toDataTransfer(V,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,U,Qe)).buffer),Ke=await this.f.provideDocumentDropEdits(ue,Le,je,ae);if(Ke)return{label:Ke.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ke.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:fe.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ke.insertText=="string"?Ke.insertText:{snippet:Ke.insertText.value},additionalEdit:Ke.additionalEdit?g.WorkspaceEdit.from(Ke.additionalEdit,void 0):void 0}}}class ve{constructor(U,Q){this.d=U,this.e=Q}async provideMappedEdits(U,Q,ee,V){const ae=D.URI.revive(U),ue=this.d.getDocument(ae),Le=ee.documents.map(Qe=>Qe.map(_e=>({uri:D.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>g.Range.to(at))}))),je={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ue,Q,je,V);return Ke?g.WorkspaceEdit.from(Ke):null}}class Ae{constructor(U,Q){this.adapter=U,this.extension=Q}}class pe{static{this.d=0}constructor(U,Q,ee,V,ae,ue,Le,je){this.g=Q,this.h=ee,this.j=V,this.k=ae,this.l=ue,this.m=Le,this.n=je,this.f=new Map,this.e=U.getProxy(p.$MK.MainThreadLanguageFeatures)}o(U,Q){return g.DocumentSelector.from(U,this.g,Q)}p(U){return new I.$OK(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return pe.d++}async s(U,Q,ee,V,ae,ue=!1){const Le=this.f.get(U);if(!Le||!(Le.adapter instanceof Q))return V;const je=Date.now();ue||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${ee.toString().replace(/[\r\n]/g,"")}'`);const Ke=ee(Le.adapter,Le.extension);return Promise.resolve(Ke).catch(Qe=>{(0,o.$4)(Qe)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Le.extension.identifier,Qe))}).finally(()=>{ue||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),w.CancellationToken.isCancellationToken(ae)?(0,a.$Rg)(Ke,ae):Ke}t(U,Q){const ee=this.q();return this.f.set(ee,new Ae(U,Q)),ee}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,Q,ee,V){const ae=this.t(new d(this.h,ee),U),ue=V&&V.label||pe.u(U);return this.e.$registerDocumentSymbolProvider(ae,this.o(Q,U),ue),this.p(ae)}$provideDocumentSymbols(U,Q,ee){return this.s(U,d,V=>V.provideDocumentSymbols(D.URI.revive(Q),ee),void 0,ee)}registerCodeLensProvider(U,Q,ee){const V=this.q(),ae=typeof ee.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Ae(new u(this.h,this.j.converter,ee),U)),this.e.$registerCodeLensSupport(V,this.o(Q,U),ae);let ue=this.p(V);if(ae!==void 0){const Le=ee.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ae));ue=I.$OK.from(ue,Le)}return ue}$provideCodeLenses(U,Q,ee){return this.s(U,u,V=>V.provideCodeLenses(D.URI.revive(Q),ee),void 0,ee)}$resolveCodeLens(U,Q,ee){return this.s(U,u,V=>V.resolveCodeLens(Q,ee),void 0,void 0)}$releaseCodeLenses(U,Q){this.s(U,u,ee=>Promise.resolve(ee.releaseCodeLenses(Q)),void 0,void 0)}registerDefinitionProvider(U,Q,ee){const V=this.t(new h(this.h,ee),U);return this.e.$registerDefinitionSupport(V,this.o(Q,U)),this.p(V)}$provideDefinition(U,Q,ee,V){return this.s(U,h,ae=>ae.provideDefinition(D.URI.revive(Q),ee,V),[],V)}registerDeclarationProvider(U,Q,ee){const V=this.t(new k(this.h,ee),U);return this.e.$registerDeclarationSupport(V,this.o(Q,U)),this.p(V)}$provideDeclaration(U,Q,ee,V){return this.s(U,k,ae=>ae.provideDeclaration(D.URI.revive(Q),ee,V),[],V)}registerImplementationProvider(U,Q,ee){const V=this.t(new L(this.h,ee),U);return this.e.$registerImplementationSupport(V,this.o(Q,U)),this.p(V)}$provideImplementation(U,Q,ee,V){return this.s(U,L,ae=>ae.provideImplementation(D.URI.revive(Q),ee,V),[],V)}registerTypeDefinitionProvider(U,Q,ee){const V=this.t(new v(this.h,ee),U);return this.e.$registerTypeDefinitionSupport(V,this.o(Q,U)),this.p(V)}$provideTypeDefinition(U,Q,ee,V){return this.s(U,v,ae=>ae.provideTypeDefinition(D.URI.revive(Q),ee,V),[],V)}registerHoverProvider(U,Q,ee,V){const ae=this.t(new b(this.h,ee),U);return this.e.$registerHoverProvider(ae,this.o(Q,U)),this.p(ae)}$provideHover(U,Q,ee,V){return this.s(U,b,ae=>ae.provideHover(D.URI.revive(Q),ee,V),void 0,V)}registerEvaluatableExpressionProvider(U,Q,ee,V){const ae=this.t(new E(this.h,ee),U);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(Q,U)),this.p(ae)}$provideEvaluatableExpression(U,Q,ee,V){return this.s(U,E,ae=>ae.provideEvaluatableExpression(D.URI.revive(Q),ee,V),void 0,V)}registerInlineValuesProvider(U,Q,ee,V){const ae=typeof ee.onDidChangeInlineValues=="function"?this.q():void 0,ue=this.t(new A(this.h,ee),U);this.e.$registerInlineValuesProvider(ue,this.o(Q,U),ae);let Le=this.p(ue);if(ae!==void 0){const je=ee.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ae));Le=I.$OK.from(Le,je)}return Le}$provideInlineValues(U,Q,ee,V,ae){return this.s(U,A,ue=>ue.provideInlineValues(D.URI.revive(Q),ee,V,ae),void 0,ae)}registerDocumentHighlightProvider(U,Q,ee){const V=this.t(new z(this.h,ee),U);return this.e.$registerDocumentHighlightProvider(V,this.o(Q,U)),this.p(V)}registerMultiDocumentHighlightProvider(U,Q,ee){const V=this.t(new O(this.h,ee),U);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(Q,U)),this.p(V)}$provideDocumentHighlights(U,Q,ee,V){return this.s(U,z,ae=>ae.provideDocumentHighlights(D.URI.revive(Q),ee,V),void 0,V)}$provideMultiDocumentHighlights(U,Q,ee,V,ae){return this.s(U,O,ue=>ue.provideMultiDocumentHighlights(D.URI.revive(Q),ee,V.map(Le=>D.URI.revive(Le)),ae),void 0,ae)}registerLinkedEditingRangeProvider(U,Q,ee){const V=this.t(new P(this.h,ee),U);return this.e.$registerLinkedEditingRangeProvider(V,this.o(Q,U)),this.p(V)}$provideLinkedEditingRanges(U,Q,ee,V){return this.s(U,P,async ae=>{const ue=await ae.provideLinkedEditingRanges(D.URI.revive(Q),ee,V);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?pe.w(ue.wordPattern):void 0}},void 0,V)}registerReferenceProvider(U,Q,ee){const V=this.t(new j(this.h,ee),U);return this.e.$registerReferenceSupport(V,this.o(Q,U)),this.p(V)}$provideReferences(U,Q,ee,V,ae){return this.s(U,j,ue=>ue.provideReferences(D.URI.revive(Q),ee,V,ae),void 0,ae)}registerCodeActionProvider(U,Q,ee,V){const ae=new l.$Rc,ue=this.t(new N(this.h,this.j.converter,this.k,ee,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(ue,this.o(Q,U),{providedKinds:V?.providedCodeActionKinds?.map(Le=>Le.value),documentation:V?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,ae)}))},pe.u(U),!!ee.resolveCodeAction),ae.add(this.p(ue)),ae}$provideCodeActions(U,Q,ee,V,ae){return this.s(U,N,ue=>ue.provideCodeActions(D.URI.revive(Q),ee,V,ae),void 0,ae)}$resolveCodeAction(U,Q,ee){return this.s(U,N,V=>V.resolveCodeAction(Q,ee),{},void 0)}$releaseCodeActions(U,Q){this.s(U,N,ee=>Promise.resolve(ee.releaseCodeActions(Q)),void 0,void 0)}registerDocumentFormattingEditProvider(U,Q,ee){const V=this.t(new W(this.h,ee),U);return this.e.$registerDocumentFormattingSupport(V,this.o(Q,U),U.identifier,U.displayName||U.name),this.p(V)}$provideDocumentFormattingEdits(U,Q,ee,V){return this.s(U,W,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentRangeFormattingEditProvider(U,Q,ee){const V=typeof ee.provideDocumentRangesFormattingEdits=="function",ae=this.t(new x(this.h,ee),U);return this.e.$registerRangeFormattingSupport(ae,this.o(Q,U),U.identifier,U.displayName||U.name,V),this.p(ae)}$provideDocumentRangeFormattingEdits(U,Q,ee,V,ae){return this.s(U,x,ue=>ue.provideDocumentRangeFormattingEdits(D.URI.revive(Q),ee,V,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(U,Q,ee,V,ae){return this.s(U,x,ue=>ue.provideDocumentRangesFormattingEdits(D.URI.revive(Q),ee,V,ae),void 0,ae)}registerOnTypeFormattingEditProvider(U,Q,ee,V){const ae=this.t(new ce(this.h,ee),U);return this.e.$registerOnTypeFormattingSupport(ae,this.o(Q,U),V,U.identifier),this.p(ae)}$provideOnTypeFormattingEdits(U,Q,ee,V,ae,ue){return this.s(U,ce,Le=>Le.provideOnTypeFormattingEdits(D.URI.revive(Q),ee,V,ae,ue),void 0,ue)}registerWorkspaceSymbolProvider(U,Q){const ee=this.t(new J(Q,this.l),U);return this.e.$registerNavigateTypeSupport(ee,typeof Q.resolveWorkspaceSymbol=="function"),this.p(ee)}$provideWorkspaceSymbols(U,Q,ee){return this.s(U,J,V=>V.provideWorkspaceSymbols(Q,ee),{symbols:[]},ee)}$resolveWorkspaceSymbol(U,Q,ee){return this.s(U,J,V=>V.resolveWorkspaceSymbol(Q,ee),void 0,void 0)}$releaseWorkspaceSymbols(U,Q){this.s(U,J,ee=>ee.releaseWorkspaceSymbols(Q),void 0,void 0)}registerRenameProvider(U,Q,ee){const V=this.t(new Y(this.h,ee,this.l),U);return this.e.$registerRenameSupport(V,this.o(Q,U),Y.supportsResolving(ee)),this.p(V)}$provideRenameEdits(U,Q,ee,V,ae){return this.s(U,Y,ue=>ue.provideRenameEdits(D.URI.revive(Q),ee,V,ae),void 0,ae)}$resolveRenameLocation(U,Q,ee,V){return this.s(U,Y,ae=>ae.resolveRenameLocation(D.URI.revive(Q),ee,V),void 0,V)}registerDocumentSemanticTokensProvider(U,Q,ee,V){const ae=this.t(new se(this.h,ee),U),ue=typeof ee.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(Q,U),V,ue);let Le=this.p(ae);if(ue){const je=ee.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ue));Le=I.$OK.from(Le,je)}return Le}$provideDocumentSemanticTokens(U,Q,ee,V){return this.s(U,se,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(Q),ee,V),null,V)}$releaseDocumentSemanticTokens(U,Q){this.s(U,se,ee=>ee.releaseDocumentSemanticColoring(Q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,Q,ee,V){const ae=this.t(new Z(this.h,ee),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(Q,U),V),this.p(ae)}$provideDocumentRangeSemanticTokens(U,Q,ee,V){return this.s(U,Z,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(Q),ee,V),null,V)}registerCompletionItemProvider(U,Q,ee,V){const ae=this.t(new we(this.h,this.j.converter,ee,this.m,U),U);return this.e.$registerCompletionsProvider(ae,this.o(Q,U),V,we.supportsResolving(ee),U.identifier),this.p(ae)}$provideCompletionItems(U,Q,ee,V,ae){return this.s(U,we,ue=>ue.provideCompletionItems(D.URI.revive(Q),ee,V,ae),void 0,ae)}$resolveCompletionItem(U,Q,ee){return this.s(U,we,V=>V.resolveCompletionItem(Q,ee),void 0,ee)}$releaseCompletionItems(U,Q){this.s(U,we,ee=>ee.releaseCompletionItems(Q),void 0,void 0)}registerInlineCompletionsProvider(U,Q,ee,V){const ae=new K(U,this.h,ee,this.j.converter),ue=this.t(ae,U);return this.e.$registerInlineCompletionsSupport(ue,this.o(Q,U),ae.supportsHandleEvents,S.$gm.toKey(U.identifier.value),V?.yieldTo?.map(Le=>S.$gm.toKey(Le))||[]),this.p(ue)}$provideInlineCompletions(U,Q,ee,V,ae){return this.s(U,de,ue=>ue.provideInlineCompletions(D.URI.revive(Q),ee,V,ae),void 0,ae)}$handleInlineCompletionDidShow(U,Q,ee,V){this.s(U,de,async ae=>{ae.handleDidShowCompletionItem(Q,ee,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,Q,ee,V){this.s(U,de,async ae=>{ae.handlePartialAccept(Q,ee,V)},void 0,void 0)}$freeInlineCompletionsList(U,Q){this.s(U,de,async ee=>{ee.disposeCompletions(Q)},void 0,void 0)}registerSignatureHelpProvider(U,Q,ee,V){const ae=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ue=this.t(new ne(this.h,ee),U);return this.e.$registerSignatureHelpProvider(ue,this.o(Q,U),ae),this.p(ue)}$provideSignatureHelp(U,Q,ee,V,ae){return this.s(U,ne,ue=>ue.provideSignatureHelp(D.URI.revive(Q),ee,V,ae),void 0,ae)}$releaseSignatureHelp(U,Q){this.s(U,ne,ee=>ee.releaseSignatureHelp(Q),void 0,void 0)}registerInlayHintsProvider(U,Q,ee){const V=typeof ee.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,ee,this.l,U),U);this.e.$registerInlayHintsProvider(ae,this.o(Q,U),typeof ee.resolveInlayHint=="function",V,pe.u(U));let ue=this.p(ae);if(V!==void 0){const Le=ee.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(V));ue=I.$OK.from(ue,Le)}return ue}$provideInlayHints(U,Q,ee,V){return this.s(U,ye,ae=>ae.provideInlayHints(D.URI.revive(Q),ee,V),void 0,V)}$resolveInlayHint(U,Q,ee){return this.s(U,ye,V=>V.resolveInlayHint(Q,ee),void 0,ee)}$releaseInlayHints(U,Q){this.s(U,ye,ee=>ee.releaseHints(Q),void 0,void 0)}registerDocumentLinkProvider(U,Q,ee){const V=this.t(new he(this.h,ee),U);return this.e.$registerDocumentLinkProvider(V,this.o(Q,U),typeof ee.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(U,Q,ee){return this.s(U,he,V=>V.provideLinks(D.URI.revive(Q),ee),void 0,ee,Q.scheme==="output")}$resolveDocumentLink(U,Q,ee){return this.s(U,he,V=>V.resolveLink(Q,ee),void 0,void 0,!0)}$releaseDocumentLinks(U,Q){this.s(U,he,ee=>ee.releaseLinks(Q),void 0,void 0,!0)}registerColorProvider(U,Q,ee){const V=this.t(new ge(this.h,ee),U);return this.e.$registerDocumentColorProvider(V,this.o(Q,U)),this.p(V)}$provideDocumentColors(U,Q,ee){return this.s(U,ge,V=>V.provideColors(D.URI.revive(Q),ee),[],ee)}$provideColorPresentations(U,Q,ee,V){return this.s(U,ge,ae=>ae.provideColorPresentations(D.URI.revive(Q),ee,V),void 0,V)}registerFoldingRangeProvider(U,Q,ee){const V=this.q(),ae=typeof ee.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Ae(new _(this.h,ee),U)),this.e.$registerFoldingRangeProvider(V,this.o(Q,U),U.identifier,ae);let ue=this.p(V);if(ae!==void 0){const Le=ee.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));ue=I.$OK.from(ue,Le)}return ue}$provideFoldingRanges(U,Q,ee,V){return this.s(U,_,ae=>ae.provideFoldingRanges(D.URI.revive(Q),ee,V),void 0,V)}registerSelectionRangeProvider(U,Q,ee){const V=this.t(new ie(this.h,ee,this.l),U);return this.e.$registerSelectionRangeProvider(V,this.o(Q,U)),this.p(V)}$provideSelectionRanges(U,Q,ee,V){return this.s(U,ie,ae=>ae.provideSelectionRanges(D.URI.revive(Q),ee,V),[],V)}registerCallHierarchyProvider(U,Q,ee){const V=this.t(new G(this.h,ee),U);return this.e.$registerCallHierarchyProvider(V,this.o(Q,U)),this.p(V)}$prepareCallHierarchy(U,Q,ee,V){return this.s(U,G,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideCallHierarchyIncomingCalls(U,Q,ee,V){return this.s(U,G,ae=>ae.provideCallsTo(Q,ee,V),void 0,V)}$provideCallHierarchyOutgoingCalls(U,Q,ee,V){return this.s(U,G,ae=>ae.provideCallsFrom(Q,ee,V),void 0,V)}$releaseCallHierarchy(U,Q){this.s(U,G,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerTypeHierarchyProvider(U,Q,ee){const V=this.t(new te(this.h,ee),U);return this.e.$registerTypeHierarchyProvider(V,this.o(Q,U)),this.p(V)}$prepareTypeHierarchy(U,Q,ee,V){return this.s(U,te,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(Q),ee,V)),void 0,V)}$provideTypeHierarchySupertypes(U,Q,ee,V){return this.s(U,te,ae=>ae.provideSupertypes(Q,ee,V),void 0,V)}$provideTypeHierarchySubtypes(U,Q,ee,V){return this.s(U,te,ae=>ae.provideSubtypes(Q,ee,V),void 0,V)}$releaseTypeHierarchy(U,Q){this.s(U,te,ee=>Promise.resolve(ee.releaseSession(Q)),void 0,void 0)}registerDocumentOnDropEditProvider(U,Q,ee,V){const ae=this.q();this.f.set(ae,new Ae(new fe(this.e,this.h,ee,ae,U),U));const ue=(0,t.$jF)(U,"dropMetadata")&&V?fe.toInternalProviderId(U.identifier.value,V.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(Q,U),ue,(0,t.$jF)(U,"dropMetadata")?V:void 0),this.p(ae)}$provideDocumentOnDropEdits(U,Q,ee,V,ae,ue){return this.s(U,fe,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(Q,D.URI.revive(ee),V,ae,ue)),void 0,void 0)}registerMappedEditsProvider(U,Q,ee){const V=this.t(new ve(this.h,ee),U);return this.e.$registerMappedEditsProvider(V,this.o(Q,U)),this.p(V)}$provideMappedEdits(U,Q,ee,V,ae){return this.s(U,ve,ue=>Promise.resolve(ue.provideMappedEdits(Q,ee,V,ae)),null,ae)}registerDocumentPasteEditProvider(U,Q,ee,V){const ae=this.q();this.f.set(ae,new Ae(new F(this.e,this.h,ee,ae,U),U));const ue=F.toInternalProviderId(U.identifier.value,V.id);return this.e.$registerPasteEditProvider(ae,this.o(Q,U),ue,{supportsCopy:!!ee.prepareDocumentPaste,supportsPaste:!!ee.provideDocumentPasteEdits,copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(U,Q,ee,V,ae){return this.s(U,F,ue=>ue.prepareDocumentPaste(D.URI.revive(Q),ee,V,ae),void 0,ae)}$providePasteEdits(U,Q,ee,V,ae,ue){return this.s(U,F,Le=>Le.providePasteEdits(Q,D.URI.revive(ee),V,ae,ue),void 0,ue)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:pe.w(U.decreaseIndentPattern),increaseIndentPattern:pe.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?pe.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?pe.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:pe.w(U.beforeText),afterText:U.afterText?pe.w(U.afterText):void 0,previousLineText:U.previousLineText?pe.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(pe.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(Q=>I.SyntaxTokenType.toString(Q)):void 0}}static D(U){return U.map(pe.C)}setLanguageConfiguration(U,Q,ee){const{wordPattern:V}=ee;if(V&&(0,$.$Ue)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(Q,V):this.h.setWordDefinitionFor(Q,void 0),ee.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),ee.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ae=this.q(),ue={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?pe.w(ee.wordPattern):void 0,indentationRules:ee.indentationRules?pe.y(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?pe.B(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport,autoClosingPairs:ee.autoClosingPairs?pe.D(ee.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,Q,ue),this.p(ae)}$setWordDefinitions(U){for(const Q of U)this.h.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.$cfc=pe}),define(ke[328],Se([1,0,6,15,7,39,12,3,25]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class y{constructor(C,m,w,S){this.c=m,this.d=w,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$MK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const w=this.c.getDocumentData(C);if(!w)throw new Error(`document '${C.toString()}' NOT found`);return w.document}async tokenAtPosition(C,m){const w=C.version,S=T.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,S),f={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$QK(m.line,m.character,m.line,m.character)};if(!l)return f;const s={range:T.Range.to(l.range),type:T.TokenType.to(l.type)};return!s.range.contains(m)||w!==C.version?f:s}createLanguageStatusItem(C,m,w){const S=this.f++,l=this.a,f=this.g,s=`${C.identifier.value}/${m}`;if(f.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);f.add(s);const i={selector:w,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new p.$Rc,a=()=>{if(n?.dispose(),!f.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$4g)(()=>{o.clear(),this.a.$setLanguageStatus(S,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),l.$removeLanguageStatus(S),f.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,$.$kF)(C,"languageStatusText"),i.text=r,a()},get text2(){return(0,$.$kF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$Bgc=y}),define(ke[115],Se([1,0,11,13,2,5,14,6,27,20]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=e.$Zfc=void 0;let M=class{constructor(m,w,S){this.f=S,this.d=new Map,this.a=w.getProxy(p.$MK.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,w){const{message:S,args:l,comment:f}=w;if(this.c)return(0,T.$Ie)(S,l??{});let s=S;f&&f.length>0&&(s+=`/${Array.isArray(f)?f.join(""):f}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,T.$Ie)(i??S,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let w;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(S),f=JSON.parse(l);w=m.isBuiltin?f.contents?.bundle:f}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${l.message}`);return}w&&this.d.set(m.identifier.value,{contents:w,uri:S})}async g(m){if(m.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(w)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Zfc=M,e.$Zfc=M=Je([We(0,$.$7M),We(1,y.$QM),We(2,R.$jj)],M),e.$1fc=(0,I.$2h)("IExtHostLocalizationService")}),define(ke[150],Se([1,0,14,6,27,20,2,54]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let $=class extends D.$uj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(w=>(0,p.$yh)(w))),this.r=C.getProxy(T.$MK.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(R.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,w){return new y(this.r,C,m,w)}};e.$ahc=$,e.$ahc=$=Je([We(0,I.$QM),We(1,g.$7M)],$);class y extends D.$pj{constructor(C,m,w,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const w=[[C,m]];this.m?this.u(w):this.n.push(...w)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=void 0,e.$2fc=(0,T.$2h)("IExtHostManagedSockets");let p=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$MK.MainThreadManagedSockets)}setFactory(C,m){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,w=await this.c.makeConnection(),S=new g.$Rc;return this.d.set(m,new y(m,w,S)),S.add((0,g.$Qc)(()=>this.d.delete(m))),S.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(w.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),S.dispose()})),S.add(w.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,R.$ge.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$3fc=p,e.$3fc=p=Je([We(0,I.$QM)],p);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Sc{constructor(C,m,w){super(),this.socketId=C,this.actual=m,this.B(w)}}}),define(ke[329],Se([1,0,6,14,25]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;function I(p){return p&&p.title}let R=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$MK.MainThreadMessageService)}showMessage($,y,M,C,m){const w={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||I(C)?S=[C,...m]:(w.modal=C?.modal,w.useCustom=C?.useCustom,w.detail=C?.detail,S=m),w.useCustom&&(0,g.$kF)($,"resolvers");const l=[];for(let f=0;f<S.length;f++){const s=S[f];if(typeof s=="string")l.push({title:s,handle:f,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;l.push({title:i,isCloseAffordance:!!n,handle:f})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(y,M,w,l).then(f=>{if(typeof f=="number")return S[f]})}};e.$Cgc=R,e.$Cgc=R=Je([We(1,T.$jj)],R)}),define(ke[330],Se([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=e.$Ggc=void 0;let n=class{constructor(h,k,L,v,b){this.m=k,this.n=L,this.o=v,this.q=b,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=h.getProxy(C.$MK.MainThreadNotebookKernels);const E=new m.$eN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$cN("options","Select kernel options",A=>!0,A=>{if(A&&"notebookEditor"in A&&"id"in A){const z=this.n.getIdByEditor(A.notebookEditor);return{id:A.id,extension:A.extension,notebookEditorId:z}}else if(A&&"notebookEditor"in A){const z=this.n.getIdByEditor(A.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${A.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return A})],m.$dN.Void);this.o.registerApiCommand(E)}createNotebookController(h,k,L,v,b,E){for(const Z of this.j.values())if(Z.controller.id===k&&y.$gm.equals(h.identifier,Z.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const A=this.k++,z=this;this.q.trace(`NotebookController[${A}], CREATED by ${h.identifier.value}, ${k}`);const O=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${h.identifier}'`);let P=!1;const j=new I.$Sd,N=new I.$Sd,F={id:u(h.identifier,k),notebookType:L,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:v||h.identifier.value,preloads:E?E.map(w.NotebookRendererScript.from):[]};let W=b??O,x,ce;this.a.$addKernel(A,F).catch(Z=>{console.log(Z),P=!0});let J=0;const Y=()=>{if(P)return;const Z=++J;Promise.resolve().then(()=>{Z===J&&this.a.$updateKernel(A,F)})},X=new p.$Ac,se={get id(){return k},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return F.label},set label(Z){F.label=Z??h.displayName??h.name,Y()},get detail(){return F.detail??""},set detail(Z){F.detail=Z,Y()},get description(){return F.description??""},set description(Z){F.description=Z,Y()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(Z){F.supportedLanguages=Z,Y()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(Z){F.supportsExecutionOrder=Z,Y()},get rendererScripts(){return F.preloads?F.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(Z){W=Z??O},get interruptHandler(){return x},set interruptHandler(Z){x=Z,F.supportsInterrupt=!!Z,Y()},set variableProvider(Z){(0,s.$kF)(h,"notebookVariableProvider"),ce=Z,F.hasVariableProvider=!!Z,Z?.onDidChangeVariables(we=>z.a.$variablesUpdated(we.uri)),Y()},get variableProvider(){return ce},createNotebookCellExecution(Z){if(P)throw new Error("notebook controller is DISPOSED");if(!X.has(Z.notebook.uri))throw z.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.notebook.uri.toString()}`);return z._createNotebookCellExecution(Z,u(h.identifier,this.id))},createNotebookExecution(Z){if((0,s.$kF)(h,"notebookExecution"),P)throw new Error("notebook controller is DISPOSED");if(!X.has(Z.uri))throw z.q.trace(`NotebookController[${A}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${Z.uri.toString()}`);return z._createNotebookExecution(Z,u(h.identifier,this.id))},dispose:()=>{P||(this.q.trace(`NotebookController[${A}], DISPOSED`),P=!0,this.j.delete(A),j.dispose(),N.dispose(),this.a.$removeKernel(A))},updateNotebookAffinity(Z,we){we===S.NotebookControllerAffinity2.Hidden&&(0,s.$kF)(h,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(A,Z.uri,we)},onDidReceiveMessage:N.event,postMessage(Z,we){return(0,s.$kF)(h,"notebookMessaging"),z.a.$postMessage(A,we&&z.n.getIdByEditor(we),Z)},asWebviewUri(Z){return(0,s.$kF)(h,"notebookMessaging"),(0,l.$fvb)(Z,z.m.remote)}};return this.j.set(A,{extensionId:h.identifier,controller:se,onDidReceiveMessage:N,onDidChangeSelection:j,associatedNotebooks:X}),se}getIdByController(h){for(const[k,L]of this.j)if(L.controller===h)return u(L.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,k){const L=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(L,k);const b={dispose:()=>{this.f.delete(L),v.a.$removeKernelDetectionTask(L)}};return this.f.set(L,b),b}registerKernelSourceActionProvider(h,k,L){const v=this.i++,b=typeof L.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,E=this;this.h.set(v,L),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,k);let A;return b!==void 0&&(A=L.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(v),E.a.$removeKernelSourceActionProvider(v,v),A?.dispose()}}}async $provideKernelSourceActions(h,k){const L=this.h.get(h);if(L){const v=new R.$Rc;return(await L.provideNotebookKernelSourceActions(k)??[]).map(E=>w.NotebookKernelSourceAction.from(E,this.o.converter,v))}return[]}$acceptNotebookAssociation(h,k,L){const v=this.j.get(h);if(v){const b=this.n.getNotebookDocument($.URI.revive(k));L?v.associatedNotebooks.set(b.uri,!0):v.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${h}] ASSOCIATE notebook`,b.uri.toString(),L),v.onDidChangeSelection.fire({selected:L,notebook:b.apiNotebook})}}async $executeCells(h,k,L){const v=this.j.get(h);if(!v)return;const b=this.n.getNotebookDocument($.URI.revive(k)),E=[];for(const A of L){const z=b.getCell(A);z&&E.push(z.apiCell)}try{this.q.trace(`NotebookController[${h}] EXECUTE cells`,b.uri.toString(),E.length),await v.controller.executeHandler.call(v.controller,E,b.apiNotebook,v.controller)}catch(A){this.q.error(`NotebookController[${h}] execute cells FAILED`,A),console.error(A)}}async $cancelCells(h,k,L){const v=this.j.get(h);if(!v)return;const b=this.n.getNotebookDocument($.URI.revive(k));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,b.apiNotebook);else for(const E of L){const A=b.getCell(E);A&&this.b.get(A.uri)?.cancel()}if(v.controller.interruptHandler){const E=this.c.get(b.uri);L.length&&Array.isArray(E)&&E.length&&E.forEach(A=>A.dispose())}}async $provideVariables(h,k,L,v,b,E,A){const z=this.j.get(h);if(!z)return;const O=this.n.getNotebookDocument($.URI.revive(L)),P=z.controller.variableProvider;if(!P)return;const j=v?{name:v,value:""}:void 0,N=b==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,F=P.provideVariables(O.apiNotebook,j,N,E,A);for await(const W of F){if(A.isCancellationRequested)return;this.a.$receiveVariable(k,W)}}$acceptKernelMessageFromRenderer(h,k,L){const v=this.j.get(h);if(!v)return;const b=this.n.getEditorById(k);v.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:L}))}$cellExecutionChanged(h,k,L){const b=this.n.getNotebookDocument($.URI.revive(h)).getCell(k);if(b){const E=L?w.NotebookCellExecutionState.to(L):S.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:b.apiCell,state:E})}}_createNotebookCellExecution(h,k){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const b=new a(k,v,this.a);this.b.set(v.uri,b);const E=b.onDidChangeState(()=>{b.state===o.Resolved&&(b.dispose(),E.dispose(),this.b.delete(v.uri))});return b.asApiObject()}_createNotebookExecution(h,k){const L=this.n.getNotebookDocument(h.uri),v=h.getCells().find(A=>{const z=L.getCellFromApiCell(A);return z&&this.b.has(z.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const b=new r(k,L,this.a),E=b.onDidChangeState(()=>{b.state===t.Resolved&&(b.dispose(),E.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[b,E]),b.asApiObject()}};e.$Ggc=n,e.$Ggc=n=Je([We(4,M.$jj)],n);var o;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(o||(o={}));class a extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(h,k,L){super(),this.m=k,this.n=L,this.b=a.a++,this.c=new I.$Sd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new g.$3d),this.h=new d(10,v=>this.s(v)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const k=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$Ev(k))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let k=this.m;if(h&&(k=this.m.notebook.getCellFromApiCell(h)),!k)throw new Error("INVALID cell");return k.handle}y(h){return h.map(k=>{const L=S.$eM.ensureUniqueMimeTypes(k.items,!0);return L===k.items?w.NotebookCellOutput.from(k):w.NotebookCellOutput.from({items:L,id:k.id,metadata:k.metadata})})}async z(h,k,L){const v=this.w(k),b=this.y((0,D.$3b)(h));return this.r({editType:f.CellExecutionUpdateType.Output,cellHandle:v,append:L,outputs:b})}async C(h,k,L){return h=S.$eM.ensureUniqueMimeTypes((0,D.$3b)(h),!0),this.r({editType:f.CellExecutionUpdateType.OutputItems,items:h.map(w.NotebookCellOutputItem.from),outputId:k.id,append:L})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(L){h.j=L,h.s([{editType:f.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(L){if(h.f===o.Resolved||h.f===o.Started)throw new Error("Cannot call start again");h.f=o.Started,h.c.fire(),h.s({editType:f.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,v){if(h.f===o.Resolved)throw new Error("Cannot call resolve twice");h.f=o.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$Ev({runEndTime:v,lastRunSuccess:L}))},clearOutput(L){return h.t(),h.z([],L,!1)},appendOutput(L,v){return h.t(),h.z(L,v,!0)},replaceOutput(L,v){return h.t(),h.z(L,v,!1)},appendOutputItems(L,v){return h.t(),h.C(L,v,!0)},replaceOutputItems(L,v){return h.t(),h.C(L,v,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class r extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(h,k,L){super(),this.h=k,this.j=L,this.b=r.a++,this.c=new I.$Sd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$3d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,k){this.f=h,this.g=k,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new T.$mh,this.b=Date.now(),(0,T.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>h.complete())}}function u(c,h){return`${c.value}/${h}`}e.$Hgc=u}),define(ke[331],Se([1,0,4,6,146]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class I{constructor(p,$){this.c=$,this.a=new Map,this.b=p.getProxy(T.$MK.MainThreadNotebookRenderers)}$postRendererMessage(p,$,y){const M=this.c.getEditorById(p);this.a.get($)?.fire({editor:M.apiEditor,message:y})}createRendererMessaging(p,$){if(!p.contributes?.notebookRenderer?.some(M=>M.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(M,C,m)=>this.d($).event(M,C,m),postMessage:(M,C)=>{g.$ogc.apiEditorsToExtHost.has(M)&&([M,C]=[C,M]);const m=C&&g.$ogc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,M)}}}d(p){let $=this.a.get(p);return $||($=new D.$Sd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(p)}}),this.a.set(p,$),$)}}e.$Igc=I}),define(ke[332],Se([1,0,3,18,2,25,6]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class p{constructor(y){this.b=new Map,this.a=y.getProxy(R.$MK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,M,C){if((0,I.$kF)(y,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,C),this.a.$registerProfileContentHandler(M,C.name,C.description,y.identifier.value),(0,D.$Qc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(y,M,C,m){const w=this.b.get(y);if(!w)throw new Error(`Unknown handler with id: ${y}`);return w.saveProfile(M,C,m)}async $readProfile(y,M,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,T.$Ef)(M)?M:g.URI.revive(M),C)}}e.$Lgc=p}),define(ke[333],Se([1,0,2,6,12,15]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=void 0;class R{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(T.$MK.MainThreadQuickDiff)}$provideOriginalResource($,y,M){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Ug)(()=>m.provideOriginalResource(C,M)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider($,y,M,C){const m=R.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),M,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Ngc=R}),define(ke[334],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;function S(l,f,s){const i=l.getProxy(I.$MK.MainThreadQuickOpen);class n{constructor(k,L){this.e=new Map,this.f=0,this.a=k,this.b=L}showQuickPick(k,L,v,b=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(L),A=++this.f,z=i.$show(A,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},b),O={},P=z.then(()=>O);return Promise.race([P,E]).then(j=>{if(j===O)return;const N=(0,m.$jF)(k,"quickPickItemTooltip");return E.then(F=>{const W=[];for(let x=0;x<F.length;x++){const ce=F[x];if(typeof ce=="string")W.push({label:ce,handle:x});else if(ce.kind===p.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!N&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const J=ce.iconPath?d(ce.iconPath):void 0;W.push({label:ce.label,iconPath:J?.iconPath,iconClass:J?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:N?w.MarkdownString.fromStrict(ce.tooltip):void 0,handle:x})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=x=>{v.onDidSelectItem(F[x])}),i.$setItems(A,W),z.then(x=>{if(typeof x=="number")return F[x];if(Array.isArray(x))return x.map(ce=>F[ce])})})}).then(void 0,j=>{if(!(0,$.$4)(j))return i.$setError(A,j),Promise.reject(j)})}$onItemSelected(k){this.c?.(k)}showInput(k,L=D.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",L).then(void 0,v=>{if(!(0,$.$4)(v))return Promise.reject(v)})}async $validateInput(k){if(!this.d)return;const L=await this.d(k);if(!L||typeof L=="string")return L;let v;switch(L.severity){case p.InputBoxValidationSeverity.Info:v=M.default.Info;break;case p.InputBoxValidationSeverity.Warning:v=M.default.Warning;break;case p.InputBoxValidationSeverity.Error:v=M.default.Error;break;default:v=L.message?M.default.Error:M.default.Ignore;break}return{content:L.message,severity:v}}async showWorkspaceFolderPick(k,L=D.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!v)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(k){const L=new u(k,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(k){const L=new c(k,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(k,L){this.e.get(k)?._fireDidChangeValue(L)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,L){const v=this.e.get(k);v instanceof u&&v._fireDidChangeActive(L)}$onDidChangeSelection(k,L){const v=this.e.get(k);v instanceof u&&v._fireDidChangeSelection(L)}$onDidTriggerButton(k,L){this.e.get(k)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(k,L,v){const b=this.e.get(k);b instanceof u&&b._fireDidTriggerItemButton(L,v)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,L){this.x=k,this.y=L,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Sd,this.q=new T.$Sd,this.r=new T.$Sd,this.s=new T.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((L,v)=>{const b=L===p.$0L.Back?-1:v;this.o.set(b,L)}),this.z({buttons:k.map((L,v)=>({...d(L.iconPath),tooltip:L.tooltip,handle:L===p.$0L.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const L=this.o.get(k);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const L of Object.keys(k)){const v=k[L];this.u[L]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof p.$JL)return{id:h.id};const k=r(h),L=t(h);return{dark:typeof k=="string"?R.URI.file(k):k,light:typeof L=="string"?R.URI.file(L):L}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function r(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const k=a(h);let L,v;return"id"in k?v=C.ThemeIcon.asClassName(k):L=k,{iconPath:L,iconClass:v}}class u extends o{constructor(k,L){super(k.identifier,L),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Sd,this.L=[],this.M=new T.$Sd,this.N=new T.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((b,E)=>{this.C.set(E,b),this.D.set(b,E)});const L=(0,m.$jF)(this.O,"quickPickItemTooltip"),v=[];for(let b=0;b<k.length;b++){const E=k[b];if(E.kind===p.QuickPickItemKind.Separator)v.push({type:"separator",label:E.label});else{E.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=E.iconPath?d(E.iconPath):void 0;v.push({handle:b,label:E.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:L?w.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((z,O)=>({...d(z.iconPath),tooltip:z.tooltip,handle:O}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(k){const L=(0,y.$Hb)(k.map(v=>this.C.get(v)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(k){const L=(0,y.$Hb)(k.map(v=>this.C.get(v)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(k,L){const v=this.C.get(k);if(!v||!v.buttons||!v.buttons.length)return;const b=v.buttons[L];b&&this.N.fire({button:b,item:v})}}class c extends o{constructor(k,L){super(k.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:M.default.Error}):this.z({validationMessage:k.message,severity:k.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new n(f,s)}e.$Ogc=S}),define(ke[335],Se([1,0,2,4,59,3,12,6,19,128,14,26,61,15,25,17,11]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;function i(O){return O instanceof D.URI}function n(O,P){return O.scheme===l.Schemas.file&&P.scheme===l.Schemas.file&&f.$k?O.toString()===P.toString():O.toString().toLowerCase()===P.toString().toLowerCase()}function o(O){if(O)return typeof O.iconPath=="string"?D.URI.file(O.iconPath):D.URI.isUri(O.iconPath)||m.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function a(O){if(O?.icon){if(D.URI.isUri(O.icon))return O.icon;if(m.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const P=O.icon;return{light:P.light,dark:P.dark}}}else return}function t(O){if(O.icon){if(D.URI.isUri(O.icon))return O.icon;if(m.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const P=O.icon;return{light:P.light,dark:P.dark}}}else return}function r(O){if(O.icon){if(D.URI.isUri(O.icon))return O.icon;if(m.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const P=O.icon;return{light:P.light,dark:P.dark}}}else return}function d(O,P){if(!O.iconPath&&!P.iconPath)return 0;if(O.iconPath){if(!P.iconPath)return 1}else return-1;const j=typeof O.iconPath=="string"?O.iconPath:D.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,N=typeof P.iconPath=="string"?P.iconPath:D.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,y.$Eq)(j,N)}function u(O,P){let j=0;if(O.strikeThrough!==P.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==P.faded)return O.faded?1:-1;if(O.tooltip!==P.tooltip)return(O.tooltip||"").localeCompare(P.tooltip||"");if(j=d(O,P),j!==0)return j;if(O.light&&P.light)j=d(O.light,P.light);else{if(O.light)return 1;if(P.light)return-1}if(j!==0)return j;if(O.dark&&P.dark)j=d(O.dark,P.dark);else{if(O.dark)return 1;if(P.dark)return-1}return j}function c(O,P){if(O.command!==P.command)return O.command<P.command?-1:1;if(O.title!==P.title)return O.title<P.title?-1:1;if(O.tooltip!==P.tooltip){if(O.tooltip!==void 0&&P.tooltip!==void 0)return O.tooltip<P.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(O.arguments===P.arguments)return 0;if(O.arguments)if(P.arguments){if(O.arguments.length!==P.arguments.length)return O.arguments.length-P.arguments.length}else return 1;else return-1;for(let j=0;j<O.arguments.length;j++){const N=O.arguments[j],F=P.arguments[j];if(N!==F&&!(i(N)&&i(F)&&n(N,F)))return N<F?-1:1}return 0}function h(O,P){let j=(0,y.$Eq)(O.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(j!==0)return j;if(O.command&&P.command)j=c(O.command,P.command);else{if(O.command)return 1;if(P.command)return-1}if(j!==0)return j;if(O.decorations&&P.decorations)j=u(O.decorations,P.decorations);else{if(O.decorations)return 1;if(P.decorations)return-1}return j}function k(O,P){for(let j=0;j<O.length;j++)if(O[j]!==P[j])return!1;return!0}function L(O,P){return O.command===P.command&&O.title===P.title&&O.tooltip===P.tooltip&&(O.arguments&&P.arguments?k(O.arguments,P.arguments):O.arguments===P.arguments)}function v(O,P){return(0,$.$ub)(O,P,L)}class b{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.o,P),this.q(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.o,P),this.f=P}get validateInput(){return(0,S.$kF)(this.m,"scmValidation"),this.g}set validateInput(P){if((0,S.$kF)(this.m,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.o,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.o,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.o,P))}get actionButton(){return(0,S.$kF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(P){(0,S.$kF)(this.m,"scmInputBoxActionButton"),this.l.value=new I.$Rc,this.k=P;const j=P!==void 0?{command:this.n.converter.toInternal(P.command,this.l.value),icon:a(P),enabled:P.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,j??null)}get document(){return(0,S.$kF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(P,j,N,F,W,x){this.m=P,this.n=j,this.o=W,this.p=x,this.d="",this.e=new T.$Sd,this.f="",this.h=!0,this.j=!0,this.l=new I.$Tc,this.#t=N,this.#e=F}showValidationMessage(P,j){(0,S.$kF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,P,j)}$onInputBoxValueChange(P){this.q(P)}q(P){this.d=P,this.e.fire(P)}}e.$Pgc=b;class E{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,j,N,F,W){this.q=P,this.s=j,this.t=N,this.u=F,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=E.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,j){const N=this.h.get(P);return N?(0,R.$Ug)(()=>this.s.executeCommand(N.command,...N.arguments||[],j)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(h),N=(0,$.$Db)(this.o,P,h).map(x=>{const ce=x.toInsert.map(J=>{const Y=this.e++;this.g.set(Y,J);const X=J.resourceUri;let se;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const _=new I.$Rc;se=this.s.converter.toInternal(J.command,_),this.j.set(Y,_)}else this.h.set(Y,J.command);const Z=o(J.decorations),we=J.decorations&&o(J.decorations.light)||Z,de=J.decorations&&o(J.decorations.dark)||Z,K=[we,de],B=J.decorations&&J.decorations.tooltip||"",ne=J.decorations&&!!J.decorations.strikeThrough,ye=J.decorations&&!!J.decorations.faded,he=J.contextValue||"";return{rawResource:[Y,X,K,B,ne,ye,he,se],handle:Y}});return{start:x.start,deleteCount:x.deleteCount,toInsert:ce}}),F=N.map(({start:x,deleteCount:ce,toInsert:J})=>[x,ce,J.map(Y=>Y.rawResource)]),W=N.reverse();for(const{start:x,deleteCount:ce,toInsert:J}of W){const Y=J.map(se=>se.handle),X=this.n.splice(x,ce,...Y);for(const se of X)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.o=P,F}dispose(){this.l=!0,this.m.fire()}}class A{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.x,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let j;(0,S.$jF)(this.y,"quickDiffProvider")&&(j=P?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!P,quickDiffLabel:j})}get historyProvider(){return(0,S.$kF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(P){(0,S.$kF)(this.y,"scmHistoryProvider"),this.j=P,this.k.value=new I.$Rc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!P}),P&&(this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(P.onDidChangeActionButton(()=>{(0,S.$kF)(this.y,"scmActionButton"),this.m.value=new I.$Rc;const j=P.actionButton!==void 0?{command:this.z.converter.toInternal(P.actionButton.command,this.m.value),description:P.actionButton.description,enabled:P.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,j??null)})))}get commitTemplate(){return this.n}set commitTemplate(P){P!==this.n&&(this.n=P,this.#e.$updateSourceControl(this.x,{commitTemplate:P}))}get acceptInputCommand(){return this.p}set acceptInputCommand(P){this.o.value=new I.$Rc,this.p=P;const j=this.z.converter.toInternal(P,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:j})}get actionButton(){return(0,S.$kF)(this.y,"scmActionButton"),this.s}set actionButton(P){(0,S.$kF)(this.y,"scmActionButton"),this.q.value=new I.$Rc,this.s=P;const j=P!==void 0?{command:this.z.converter.toInternal(P.command,this.q.value),secondaryCommands:P.secondaryCommands?.map(N=>N.map(F=>this.z.converter.toInternal(F,this.q.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:j??null})}get statusBarCommands(){return this.u}set statusBarCommands(P){if(this.u&&P&&v(this.u,P))return;this.t.value=new I.$Rc,this.u=P;const j=(P||[]).map(N=>this.z.converter.toInternal(N,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:j})}get selected(){return this.v}constructor(P,j,N,F,W,x,ce){this.y=P,this.z=F,this.A=W,this.B=x,this.C=ce,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Tc,this.m=new I.$Tc,this.n=void 0,this.o=new I.$Tc,this.p=void 0,this.q=new I.$Tc,this.t=new I.$Tc,this.u=void 0,this.v=!1,this.w=new T.$Sd,this.onDidChangeSelection=this.w.event,this.x=A.d++,this.D=new Map,this.E=new Set,this.#e=N;const J=D.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${W}/scm${this.x}/input`,query:ce?`rootUri=${encodeURIComponent(ce.toString())}`:void 0});this.f=new b(P,F,j,this.#e,this.x,J),this.#e.$registerSourceControl(this.x,W,x,ce,J)}createResourceGroup(P,j){const N=new E(this.#e,this.z,this.x,P,j),F=T.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,F),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const P=[],j=[];for(const[N,F]of this.D){F.dispose();const W=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});T.Event.once(N.onDidDispose)(()=>{this.E.delete(N),W.dispose(),this.e.delete(N.handle),this.#e.$unregisterGroup(this.x,N.handle)}),P.push([N.handle,N.id,N.label,N.features]);const x=N._takeResourceStateSnapshot();x.length>0&&j.push([N.handle,x]),this.e.set(N.handle,N)}this.#e.$registerGroups(this.x,P,j),this.D.clear()}eventuallyUpdateResourceStates(){const P=[];this.E.forEach(j=>{const N=j._takeResourceStateSnapshot();N.length!==0&&P.push([j.handle,N])}),P.length>0&&this.#e.$spliceResourceStates(this.x,P),this.E.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.v=P,this.w.fire(P)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,g.$uh)(100)],A.prototype,"eventuallyAddResourceGroups",null),Je([(0,g.$uh)(100)],A.prototype,"eventuallyUpdateResourceStates",null);let z=class{static{s=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(P,j,N,F){this.n=j,this.o=N,this.p=F,this.h=new Map,this.j=new C.$im,this.k=new T.$Sd,this.l=new Map,this.f=P.getProxy(p.$MK.MainThreadSCM),this.g=P.getProxy(p.$MK.MainThreadTelemetry),j.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const x=this.h.get(W.sourceControlHandle);if(!x)return W;const ce=x.getResourceGroup(W.groupHandle);return ce?ce.getResourceState(W.handle):W}else if(W&&W.$mid===4){const x=this.h.get(W.sourceControlHandle);return x?x.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const x=this.h.get(W.handle);return x||W}return W}})}createSourceControl(P,j,N,F){this.p.trace("ExtHostSCM#createSourceControl",P.identifier.value,j,N,F),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const W=s.d++,x=new A(P,this.o,this.f,this.n,j,N,F);this.h.set(W,x);const ce=this.j.get(P.identifier)||[];return ce.push(x),this.j.set(P.identifier,ce),x}registerSourceControlInputBoxValueProvider(P,j,N){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",P.identifier.value,N.label);const F=s.e++;return this.l.set(F,N),this.f.$registerSourceControlInputBoxValueProvider(F,j,N.label,r(N)),(0,I.$Qc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(F),this.l.delete(F)})}async $provideInputBoxValue(P,j,N,F){const W=this.l.get(P);if(W)return await W.provideValue(D.URI.revive(j),N,F)??void 0}getLastInputBox(P){this.p.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const j=this.j.get(P.identifier),N=j&&j[j.length-1];return N&&N.inputBox}$provideOriginalResource(P,j,N){const F=D.URI.revive(j);this.p.trace("ExtHostSCM#$provideOriginalResource",P,F.toString());const W=this.h.get(P);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ug)(()=>W.quickDiffProvider.provideOriginalResource(F,N)).then(x=>x||null)}$onInputBoxValueChange(P,j){this.p.trace("ExtHostSCM#$onInputBoxValueChange",P);const N=this.h.get(P);return N&&N.inputBox.$onInputBoxValueChange(j),Promise.resolve(void 0)}$executeResourceCommand(P,j,N,F){this.p.trace("ExtHostSCM#$executeResourceCommand",P,j,N);const W=this.h.get(P);if(!W)return Promise.resolve(void 0);const x=W.getResourceGroup(j);return x?x.$executeResourceCommand(N,F):Promise.resolve(void 0)}$validateInput(P,j,N){this.p.trace("ExtHostSCM#$validateInput",P);const F=this.h.get(P);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ug)(()=>F.inputBox.validateInput(j,N)).then(W=>{if(!W)return Promise.resolve(void 0);const x=w.MarkdownString.fromStrict(W.message);return x?Promise.resolve([x,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.h.get(P)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(P,j,N){return await this.h.get(P)?.historyProvider?.resolveHistoryItemGroupBase(j,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(P,j,N,F){return await this.h.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(j,N,F)??void 0}async $provideHistoryItems(P,j,N,F){return(await this.h.get(P)?.historyProvider?.provideHistoryItems(j,N,F))?.map(ce=>({...ce,icon:t(ce)}))??void 0}async $provideHistoryItemChanges(P,j,N){return await this.h.get(P)?.historyProvider?.provideHistoryItemChanges(j,N)??void 0}};e.$Qgc=z,e.$Qgc=z=s=Je([We(3,M.$jj)],z)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0;class I{constructor(p){this.b=new T.$Sd,this.onDidChangePassword=this.b.event,this.a=p.getProxy(D.$MK.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,$){return this.a.$getPassword(p,$)}store(p,$,y){return this.a.$setPassword(p,$,y)}delete(p,$){return this.a.$deletePassword(p,$)}}e.$Wfc=I,e.$Xfc=(0,g.$2h)("IExtHostSecretState")}),define(ke[336],Se([1,0,6,15,2]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;class I{static{this.a=0}constructor(p,$){this.d=$,this.c=new Map,this.b=p.getProxy(D.$MK.MainThreadShare)}async $provideShare(p,$,y){return await this.c.get(p)?.provideShare({selection:T.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(p,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,T.DocumentSelector.from(p,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Rgc=I}),define(ke[337],Se([1,0,21,3,6]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class I{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(g.$MK.MainThreadSpeech)}async $createSpeechToTextSession(p,$){const y=this.c.get(p);if(!y)return;const M=new T.$Rc,C=new D.$3d;this.d.set($,C);const m=M.add(y.provideSpeechToTextSession(C.token));M.add(m.onDidChange(w=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,w)})),M.add(C.token.onCancellationRequested(()=>M.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,$,y){const M=I.a++;return this.c.set(M,y),this.b.$registerProvider(M,$,{extension:p,displayName:p.value}),(0,T.$Qc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$Sgc=I}),define(ke[338],Se([1,0,7,6,217,3,15,18]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=e.$Tgc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$KL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$KL("statusBarItem.warningForeground")]])}#e;#t;constructor(m,w,S,l,f,s=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Rc,this.#e=m,this.#t=w,f&&l){this.c=(0,D.$nL)(l.identifier,f);const n=S.get(this.c);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=l,this.f=f,this.g=s,this.h=this.u(i)}u(m){if((0,p.$If)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Rc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let w;this.m?w=this.m:w=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const l=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,w,this.k,l,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Tgc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const w={message:m};return this.b.unshift(w),this.c(),new D.$OK(()=>{const S=this.b.indexOf(w);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class M{constructor(m,w){this.e=new Map,this.a=m.getProxy(T.$MK.MainThreadStatusBar),this.b=w,this.c=new y(this)}$acceptStaticEntries(m){for(const w of m)this.e.set(w.entryId,w)}createStatusBarEntry(m,w,S,l){return new $(this.a,this.b,this.e,m,w,S,l)}setStatusBarMessage(m,w){const S=this.c.setMessage(m);let l;return typeof w=="number"?l=setTimeout(()=>S.dispose(),w):typeof w<"u"&&w.then(()=>S.dispose(),()=>S.dispose()),new D.$OK(()=>{S.dispose(),clearTimeout(l)})}}e.$Ugc=M}),define(ke[118],Se([1,0,6,4,5]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=e.$Ofc=void 0;class I{constructor(p,$){this.c=$,this.b=new T.$Sd,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(D.$MK.MainThreadStorage)}registerExtensionStorageKeysToSync(p,$){this.a.$registerExtensionStorageKeysToSync(p,$)}async initializeExtensionStorage(p,$,y){const M=await this.a.$initializeExtensionStorage(p,$);let C;return M&&(C=this.d(p,$,M)),C||y}setValue(p,$,y){return this.a.$setValue(p,$,y)}$acceptValue(p,$,y){const M=this.d(p,$,y);M&&this.b.fire({shared:p,key:$,value:M})}d(p,$,y){try{return JSON.parse(y)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${p}): ${M}`)}}}e.$Ofc=I,e.$Pfc=(0,g.$2h)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,14,71,2]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=void 0,e.$xfc=(0,D.$2h)("IExtensionStoragePaths");let p=class{constructor(y,M,C){this.d=M,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,M=await this.g(y);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(R.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$yfc=p,e.$yfc=p=Je([We(0,T.$7M),We(1,g.$jj),We(2,I.$wfc)],p)}),define(ke[47],Se([1,0,4,6,5,2,20,3,7,219,8,263,21,30,264,61,12,15,35]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=e.$Ufc=e.$Tfc=e.$Sfc=void 0,e.$Sfc=(0,g.$2h)("IExtHostTerminalService");class n{constructor(v,b,E,A){this.l=v,this._id=b,this.m=E,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const z=this;this.value={get name(){return z.n||""},get processId(){return z.b},get creationOptions(){return z.m},get exitStatus(){return z.h},get state(){return z.j},get selection(){return z.k},sendText(O,P=!0){z.q(),z.l.$sendText(z._id,O,P)},show(O){z.q(),z.l.$show(z._id,O)},hide(){z.q(),z.l.$hide(z._id)},dispose(){z.a||(z.a=!0,z.l.$dispose(z._id))},get dimensions(){if(!(z.d===void 0||z.g===void 0))return{columns:z.d,rows:z.g}}}}async create(v,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??b?.cwd??void 0,env:v.env??void 0,icon:c(v.iconPath)??void 0,color:l.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.o(v.location,b?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,b,E,A){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:E,color:l.ThemeColor.isThemeColor(A)?A.id:void 0,location:this.o(v,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(v,b){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in v?{viewColumn:s.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.n=v}setExitStatus(v,b){this.h=Object.freeze({code:v,reason:b})}setDimensions(v,b){return v===this.d&&b===this.g||v===0||b===0?!1:(this.d=v,this.g=b,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(v){this.k=v}_setProcessId(v){this.f?(this.f(v),this.f=void 0):this.b.then(b=>{b!==v&&(this.b=Promise.resolve(v))})}}e.$Tfc=n;class o{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new D.$Sd,this.onProcessData=this.a.event,this.b=new D.$Sd,this.d=new D.$Sd,this.onDidChangeProperty=this.d.event,this.f=new D.$Sd,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,b){this.g.setDimensions?.({columns:v,rows:b})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:"overrideDimensions",value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:"title",value:b})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends p.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,b,E){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Sd,this.onDidChangeShell=this.N.event,this.O=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(T.$MK.MainThreadTerminalService),this.y=new S.$trb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:A=>{const z=O=>{const P=O;return this.W(P.instanceId)?.value};switch(A?.$mid){case 15:return z(A);default:{if(Array.isArray(A))for(let O=0;O<A.length&&A[O].$mid===15;O++)A[O]=z(A[O]);return A}}}}),this.B({dispose:()=>{for(const[A,z]of this.g)z.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,b){const E=new n(this.a,(0,w.$mg)(),v,v.name),A=new o(v.pty);return E.createExtensionTerminal(v.location,this.R(v,b).resolvedExtHostIdentifier,c(v.iconPath),h(v.color)).then(z=>{const O=this.S(z,A);this.h[z]=O}),this.f.push(E),E.value}R(v,b){if(b=b||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const E=v.location.parentTerminal;if(E){const A=this.f.find(z=>z.value===E);A&&(b.resolvedExtHostIdentifier=A._id)}}else v.location&&typeof v.location!="object"?b.location=v.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(v,b){if(!this.W(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const A=new o(b),z=this.S(v,A);this.h[v]=z}async $acceptActiveTerminalChanged(v){const b=this.b;if(v===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const E=this.W(v);E&&(this.b=E,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,b){const E=this.W(v);E&&this.O.fire({terminal:E.value,data:b})}async $acceptTerminalDimensions(v,b,E){const A=this.W(v);A&&A.setDimensions(b,E)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(v,b){const E=this.W(v);E&&this.P.fire({terminal:E.value,...b})}async $acceptTerminalMaximumDimensions(v,b,E){this.g.get(v)?.resize(b,E)}async $acceptTerminalTitleChange(v,b){const E=this.W(v);E&&(E.name=b)}async $acceptTerminalClosed(v,b,E){const A=this.Y(this.f,v);if(A!==null){const z=this.f.splice(A,1)[0];z.setExitStatus(b,E),this.H.fire(z.value)}}$acceptTerminalOpened(v,b,E,A){if(b){const P=this.Y(this.f,b);if(P!==null){this.f[P]._id=v,this.I.fire(this.terminals[P]),this.f[P].isOpen=!0;return}}const z={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:I.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},O=new n(this.a,v,z,E);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(v,b){this.W(v)?._setProcessId(b)}async $startExtensionTerminal(v,b){const E=this.W(v);if(!E)return{message:(0,y.localize)(0,null,v)};E.isOpen||await new Promise(z=>{const O=this.onDidOpenTerminal(async P=>{P===E.value&&(O.dispose(),z())})});const A=this.g.get(v);A?A.startSendingEvents(b):this.j[v]={initialDimensions:b}}S(v,b){const E=new p.$Rc;E.add(b.onProcessReady(z=>this.a.$sendProcessReady(v,z.pid,z.cwd,z.windowsPty))),E.add(b.onDidChangeProperty(z=>this.a.$sendProcessProperty(v,z))),this.y.startBuffering(v,b.onProcessData),E.add(b.onProcessExit(z=>this.U(v,z))),this.g.set(v,b);const A=this.j[v];return A&&b instanceof o&&(b.startSendingEvents(A.initialDimensions),delete this.j[v]),E}$acceptProcessAckDataEvent(v,b){this.g.get(v)?.acknowledgeDataEvent(b)}$acceptProcessInput(v,b){this.g.get(v)?.input(b)}$acceptTerminalInteraction(v){const b=this.W(v);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(v,b){this.W(v)?.setSelection(b)}$acceptProcessResize(v,b,E){try{this.g.get(v)?.resize(b,E)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(v,b){this.g.get(v)?.shutdown(b)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(v,{type:"initialCwd",value:b}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(b=>this.a.$sendProcessProperty(v,{type:"cwd",value:b}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new $.$OK(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,b,E){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,E),this.a.$registerProfileProvider(b,v.identifier.value),new $.$OK(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(v,b,E){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,E),this.a.$registerQuickFixProvider(v,b),new $.$OK(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,b){const E=new m.$3d().token;if(E.isCancellationRequested)return;const A=this.D.get(v);if(!A)return;const z=await A.provideTerminalQuickFixes(b,E);if(z===null||Array.isArray(z)&&z.length===0)return;const O=new p.$Rc;if(this.w.value=O,!Array.isArray(z))return z?s.TerminalQuickFix.from(z,this.Q.converter,O):void 0;const P=[];for(const j of z){const N=s.TerminalQuickFix.from(j,this.Q.converter,O);N&&P.push(N)}return P}async $createContributedProfileTerminal(v,b){const E=new m.$3d().token;let A=await this.C.get(v)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,b);return}this.createTerminalFromOptions(A.options,b)}}async $provideLinks(v,b){const E=this.W(v);if(!E)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const z=new m.$3d;this.G.set(v,z);const O=[],P={terminal:E.value,line:b},j=[];for(const W of this.z)j.push(f.Promises.withAsyncBody(async x=>{z.token.onCancellationRequested(()=>x({provider:W,links:[]}));const ce=await W.provideTerminalLinks(P,z.token)||[];z.token.isCancellationRequested||x({provider:W,links:ce})}));const N=await Promise.all(j);if(z.token.isCancellationRequested)return[];const F=new Map;for(const W of N)W&&W.links.length>0&&O.push(...W.links.map(x=>{const ce={id:a++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return F.set(ce.id,{provider:W.provider,link:x}),ce}));return this.F.set(v,F),O}$activateLink(v,b){const E=this.F.get(v)?.get(b);E&&E.provider.handleTerminalLink(E.link)}U(v,b){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const E=this.h[v];E&&(E.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,b)}W(v){return this.X(this.f,v)}X(v,b){const E=this.Y(v,b);return E!==null?v[E]:null}Y(v,b){const E=v.findIndex(A=>A._id===b);return E===-1?null:E}getEnvironmentVariableCollection(v){let b=this.n.get(v.identifier.value);return b||(b=new r,this.$(v.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Z(v,b){const E=(0,C.$xr)(b.map),A=(0,C.$yr)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(v,b.persistent,E.length===0?void 0:E,A)}$initEnvironmentVariableCollections(v){v.forEach(b=>{const E=b[0],A=new r(b[1]);this.$(E,A)})}$acceptDefaultProfile(v,b){const E=this.s;this.s=v,this.u=b,E?.path!==v.path&&this.N.fire(v.path)}$(v,b){this.n.set(v,b),b.onDidChangeCollection(()=>{this.Z(v,b)})}};e.$Ufc=t,e.$Ufc=t=Je([We(1,i.$aN),We(2,R.$QM)],t);class r{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Sd,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const b=this.h(v);let E=this.a.get(b);return E||(E=new d(this,v),this.a.set(b,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(v,b,E,A){this.f(v,{value:b,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:A})}append(v,b,E,A){this.f(v,{value:b,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:A})}prepend(v,b,E,A){this.f(v,{value:b,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:A})}f(v,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(v,b.scope),A=this.map.get(E),z=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==b.value||A.type!==b.type||A.options?.applyAtProcessCreation!==z.applyAtProcessCreation||A.options?.applyAtShellIntegration!==z.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const O=this.g(v,b.scope),P={variable:v,...b,options:z};this.map.set(O,P),this.d.fire()}}get(v,b){const E=this.g(v,b),A=this.map.get(E);return A?k(A):void 0}g(v,b){const E=this.h(b);return E.length?`${v}:::${E}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const b=new Map;for(const[E,A]of this.map)this.h(A.scope)===this.h(v)&&b.set(A.variable,k(A));return b}delete(v,b){const E=this.g(v,b);this.map.delete(E),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[b,E]of this.map)E.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(b);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,b){const E=this.h(b),A=this.descriptionMap.get(E);if(!A||A.description!==v){let z;typeof v=="string"?z=v:z=v?.value.split(`

`)[0];const O={description:z,scope:b};this.descriptionMap.set(E,O),this.d.fire()}}getDescription(v){const b=this.h(v);return this.descriptionMap.get(b)?.description}k(v){const b=this.h(v);this.descriptionMap.delete(b)}}class d{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,b){this.b=v,this.d=b,this.a=new D.$Sd}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,b,E){this.b.replace(v,b,E,this.d)}append(v,b,E){this.b.append(v,b,E,this.d)}prepend(v,b,E){this.b.prepend(v,b,E,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,b){this.b.getVariableMap(this.d).forEach((E,A)=>v.call(b,A,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(v,b){super(!1,v,b)}createTerminal(v,b,E){throw new M.$_}createTerminalFromOptions(v,b){throw new M.$_}};e.$Vfc=u,e.$Vfc=u=Je([We(0,i.$aN),We(1,R.$QM)],u);function c(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function h(L){return l.ThemeColor.isThemeColor(L)?L:void 0}function k(L){const v={...L};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(ke[339],Se([1,0,12,22,21,4,74,53,3,24,18,30,6,20,147,15,7,67,112,89,25]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=e.$Zgc=e.$Ygc=void 0;let a=class extends $.$Sc{constructor(O,P,j){super(),this.u=j,this.f=this.B(new I.$Sd),this.g=new Map,this.s=this.B(new I.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=O.getProxy(m.$MK.MainThreadTesting),this.m=new b(this.h),this.j=new u(this.h),P.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const F=N,W=F.tests[F.tests.length-1].item.extId;return this.g.get(s.$EJ.root(W))?.collection.tree.get(W)?.actual??(0,S.$3M)(N)}case 18:{const{extId:F,message:W}=N;return{test:this.g.get(s.$EJ.root(F))?.collection.tree.get(F)?.actual,message:l.TestMessage.to(W)}}default:return N}}}),P.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await P.executeCommand("_testing.getExplorerSelection"),F=W=>{const x=this.g.get(s.$EJ.root(W));if(x)return s.$EJ.isRoot(W)?x.controller:x.collection.tree.get(W)?.actual};return{include:N?.include.map(F).filter(M.$Mf)||[],exclude:N?.exclude.map(F).filter(M.$Mf)||[]}})}createTestController(O,P,j,N){if(this.g.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const F=new $.$Rc,W=F.add(new S.$6M(P,j,this.u));W.root.label=j;const x=new Map,ce=new Set,J=this.h,Y={items:W.root.children,get label(){return j},set label(se){j=se,W.root.label=se,J.$updateController(P,{label:j})},get refreshHandler(){return N},set refreshHandler(se){N=se,J.$updateController(P,{canRefresh:!!se})},get id(){return P},createRunProfile:(se,Z,we,de,K,B)=>{let ne=(0,p.$Pi)(se);for(;x.has(ne);)ne++;return new E(this.h,x,O,ce,this.s.event,P,ne,se,Z,we,de,K,B)},createTestItem(se,Z,we){return new S.$4M(P,se,Z,we)},createTestRun:(se,Z,we=!0)=>this.j.createTestRun(O,P,W,se,Z,we),invalidateTestResults:se=>{if(se===void 0)this.h.$markTestRetired(void 0);else{const Z=se instanceof Array?se:[se];this.h.$markTestRetired(Z.map(we=>s.$EJ.fromExtHostTestItem(we,P).toString()))}},set resolveHandler(se){W.resolveHandler=se},get resolveHandler(){return W.resolveHandler},dispose:()=>{F.dispose()}};J.$registerTestController(P,j,!!N),F.add((0,$.$Qc)(()=>J.$unregisterTestController(P)));const X={controller:Y,collection:W,profiles:x,extension:O,activeProfiles:ce};return this.g.set(P,X),F.add((0,$.$Qc)(()=>this.g.delete(P))),F.add(W.onDidGenerateDiff(se=>J.$publishDiff(P,se.map(n.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.m.checkout()}async runTests(O,P=g.CancellationToken.None){const j=c(O);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(j.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(F=>s.$EJ.fromExtHostTestItem(F,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:A[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:O.exclude?.map(F=>F.id)},P)}$syncTests(){for(const{collection:O}of this.g.values())O.flushDiff();return Promise.resolve()}async $provideFileCoverage(O,P,j){return await this.j.getCoverageReport(O,P)?.provideFileCoverage(j)??[]}async $resolveFileCoverage(O,P,j,N){return await this.j.getCoverageReport(O,P)?.resolveFileCoverage(j,N)??[]}$configureRunProfile(O,P){this.g.get(O)?.profiles.get(P)?.configureHandler?.()}$setActiveRunProfiles(O){const P=new Map;for(const[j,N]of Object.entries(O)){const F=this.g.get(j);if(!F)continue;const W=new Map,x=N.filter(J=>!F.activeProfiles.has(J)),ce=[...F.activeProfiles].filter(J=>!N.includes(J));for(const J of x)W.set(J,!0),F.activeProfiles.add(J);for(const J of ce)W.set(J,!1),F.activeProfiles.delete(J);W.size&&P.set(j,W)}this.s.fire(P)}async $refreshTests(O,P){await this.g.get(O)?.controller.refreshHandler?.(P)}$publishTestResults(O){this.results=Object.freeze(O.map(P=>(0,y.$in)(l.TestResults.to(P))).concat(this.results).sort((P,j)=>j.completedAt-P.completedAt).slice(0,32)),this.f.fire()}async $expandTest(O,P){const j=this.g.get(s.$EJ.fromString(O).controllerId)?.collection;j&&(await j.expand(O,P<0?1/0:P),j.flushDiff())}$acceptDiff(O){this.m.applyDiff(O.map(n.TestsDiffOp.deserialize))}async $runControllerTests(O,P){return Promise.all(O.map(j=>this.w(j,!1,P)))}async $startContinuousRun(O,P){const j=new g.$3d(P),N=await Promise.all(O.map(F=>this.w(F,!0,j.token)));return!P.isCancellationRequested&&!N.some(F=>F.error)&&await new Promise(F=>P.onCancellationRequested(F)),j.dispose(!0),N}async w(O,P,j){const N=this.g.get(O.controllerId);if(!N)return{};const{collection:F,profiles:W,extension:x}=N,ce=W.get(O.profileId);if(!ce)return{};const J=O.testIds.map(Z=>F.tree.get(Z)).filter(M.$Mf),Y=O.excludeExtIds.map(Z=>N.collection.tree.get(Z)).filter(M.$Mf).filter(Z=>J.some(we=>we.fullId.compare(Z.fullId)===2));if(!J.length)return{};const X=new f.$lM(J.some(Z=>Z.actual instanceof S.$5M)?void 0:J.map(Z=>Z.actual),Y.map(Z=>Z.actual),ce,P),se=(0,n.$GJ)(O)&&this.j.prepareForMainThreadTestRun(X,h.fromInternal(O,N.collection),x,j);try{return await ce.runHandler(X,j),{}}catch(Z){return{error:String(Z)}}finally{se&&(se.hasRunningTasks&&!j.isCancellationRequested&&await I.Event.toPromise(se.onEnd),se.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.j.cancelAllRuns():this.j.cancelRunById(O)}};e.$Ygc=a,e.$Ygc=a=Je([We(0,w.$QM)],a);const t=1e4;var r;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(r||(r={}));class d extends $.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(O,P,j,N){super(),this.s=O,this.u=P,this.w=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Sd),this.m=this.B(new I.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$3d(N));const F=this.B(new D.$bh(()=>this.y(),t));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(O){const P=this.s.id,j=this.s.controllerId,N=(0,C.$mg)(),F=this.w,W=this.m;let x;const ce=se=>(Z,...we)=>{if(Y){console.warn(`Setting the state of test "${Z.id}" is a no-op after the run ends.`);return}this.s.isIncluded(Z)&&(this.C(Z),se(Z,...we))},J=(se,Z)=>{const we=Z instanceof Array?Z.map(l.TestMessage.from):[l.TestMessage.from(Z)];if(se.uri&&se.range){const de={range:l.Range.from(se.range),uri:se.uri};for(const K of we)K.location=K.location||de}this.u.$appendTestMessagesInRun(P,N,s.$EJ.fromExtHostTestItem(se,j).toString(),we)};let Y=!1;const X={isPersisted:this.s.isPersisted,token:this.h.token,name:O,get coverageProvider(){return x?.provider},set coverageProvider(se){(0,o.$kF)(F,"testCoverage"),x=se&&new k(se),W.fire({taskId:N,runId:P,coverage:x})},enqueued:ce(se=>{this.u.$updateTestStateInRun(P,N,s.$EJ.fromExtHostTestItem(se,j).toString(),1)}),skipped:ce(se=>{this.u.$updateTestStateInRun(P,N,s.$EJ.fromExtHostTestItem(se,j).toString(),5)}),started:ce(se=>{this.u.$updateTestStateInRun(P,N,s.$EJ.fromExtHostTestItem(se,j).toString(),2)}),errored:ce((se,Z,we)=>{J(se,Z),this.u.$updateTestStateInRun(P,N,s.$EJ.fromExtHostTestItem(se,j).toString(),6,we)}),failed:ce((se,Z,we)=>{J(se,Z),this.u.$updateTestStateInRun(P,N,s.$EJ.fromExtHostTestItem(se,j).toString(),4,we)}),passed:ce((se,Z)=>{this.u.$updateTestStateInRun(P,N,s.$EJ.fromExtHostTestItem(se,this.s.controllerId).toString(),3,Z)}),appendOutput:(se,Z,we)=>{Y||(we&&(this.s.isIncluded(we)?this.C(we):we=void 0),this.u.$appendOutputToRun(P,N,T.$ge.fromString(se),Z&&l.location.from(Z),we&&s.$EJ.fromExtHostTestItem(we,j).toString()))},end:()=>{Y||(Y=!0,this.u.$finishedTestRunTask(P,N),this.f.delete(N),this.f.size||this.z())}};return this.f.set(N,{run:X}),this.u.$startedTestRunTask(P,{id:N,name:O,running:!0}),X}y(){for(const{run:O}of this.f.values())O.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(O){if(!(O instanceof S.$4M))throw new i.$IM(O.id);if(this.g.has(s.$EJ.fromExtHostTestItem(O,this.s.controllerId).toString()))return;const P=[],j=this.s.colllection.root;for(;;){const N=l.TestItem.from(O);if(P.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),O===j))break;O=O.parent||j}this.u.$addTestsToRun(this.s.controllerId,this.s.id,P)}dispose(){this.z(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(O){this.f=O,this.c=new Map,this.d=[]}getCoverageReport(O,P){return this.d.find(j=>j.runId===O)?.coverage.get(P)}prepareForMainThreadTestRun(O,P,j,N){return this.g(O,P,j,N)}cancelRunById(O){for(const P of this.c.values())if(P.id===O){P.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,P,j,N,F,W){const x=this.c.get(N);if(x)return x.createRun(F);const ce=h.fromPublic(P,j,N,W),J=c(N);this.f.$startedExtensionTestRun({controllerId:P,continuous:!!N.continuous,profile:J&&{group:A[J.kind],id:J.profileId},exclude:N.exclude?.map(X=>s.$EJ.fromExtHostTestItem(X,j.root.id).toString())??[],id:ce.id,include:N.include?.map(X=>s.$EJ.fromExtHostTestItem(X,j.root.id).toString())??[j.root.id],persist:W});const Y=this.g(N,ce,O);return I.Event.once(Y.onEnd)(()=>{this.f.$finishedExtensionTestRun(ce.id),Y.dispose()}),Y.createRun(F)}g(O,P,j,N){const F=new d(P,this.f,j,N);this.c.set(O,F);let W;const x=F.onDidCoverage(({runId:ce,taskId:J,coverage:Y})=>{W||(W={runId:ce,coverage:new Map},this.d.unshift(W),this.d.length>n.$LJ&&this.d.pop()),W.coverage.set(J,Y),this.f.$signalCoverageAvailable(ce,J,!!Y)});return I.Event.once(F.onEnd)(()=>{this.c.delete(O),x.dispose()}),F}}e.$Zgc=u;const c=z=>{if(z.profile){if(!(z.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class h{static fromPublic(O,P,j,N){return new h(O,(0,C.$mg)(),j.include?.map(F=>s.$EJ.fromExtHostTestItem(F,O).toString())??[O],j.exclude?.map(F=>s.$EJ.fromExtHostTestItem(F,O).toString())??[],N,P)}static fromInternal(O,P){return new h(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,P)}constructor(O,P,j,N,F,W){this.controllerId=O,this.id=P,this.isPersisted=F,this.colllection=W,this.c=j.map(x=>x+"\0"),this.d=N.map(x=>x+"\0")}isIncluded(O){const P=s.$EJ.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const j of this.d)if(P===j||P.startsWith(j))return!1;for(const j of this.c)if(P===j||P.startsWith(j))return!0;return!1}}e.$1gc=h;class k{constructor(O){this.provider=O}async provideFileCoverage(O){this.c||(this.c=(async()=>this.provider.provideFileCoverage(O))());try{return(await this.c)?.map(l.TestCoverage.fromFile)??[]}catch(P){throw this.c=void 0,P}}async resolveFileCoverage(O,P){const j=await this.c;let N=j?.[O];return!this.provider||!j||!N?[]:(N.detailedCoverage||(N=j[O]=await this.provider.resolveFileCoverage?.(N,P)??N),N.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class L{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(O){this.h=O,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,l.TestItem.toPlain(O.item)),this.c.has(O)||this.d.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.d.delete(O);const P=s.$EJ.parentId(O.item.extId);if(P&&this.g.has(P.toString())){this.g.add(O.item.extId);return}this.f.add(O)}getChangeEvent(){const{c:O,d:P,f:j}=this;return{get added(){return[...O].map(N=>N.revived)},get updated(){return[...P].map(N=>N.revived)},get removed(){return[...j].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class v extends n.$MJ{constructor(){super(...arguments),this.q=new I.$Sd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(O){return this.d.get(O)}getMirroredTestDataByReference(O){return this.d.get(O.id)}p(O,P){return{...O,revived:l.TestItem.toPlain(O.item),depth:P?P.depth+1:0,children:new Set}}o(){return new L(this.q)}}class b{constructor(O){this.d=O}checkout(){this.c||(this.c=this.f());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(P=>P.revived)},dispose:(0,R.$db)(()=>{--O.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}f(){const O=new v;return this.d.$subscribeToDiffs(),{observers:0,tests:O}}}class E{#e;#t;#i;#o;#r;get label(){return this.d}set label(O){O!==this.d&&(this.d=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:O}))}get isDefault(){return this.f}set isDefault(O){O!==this.f&&(this.f=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:O?l.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!O}))}get isSelected(){return(0,o.$kF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,o.$kF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,O=>O.map(P=>P.get(this.controllerId)?.get(this.profileId)).filter(M.$Mf))}constructor(O,P,j,N,F,W,x,ce,J,Y,X=!1,se=void 0,Z=!1){this.controllerId=W,this.profileId=x,this.d=ce,this.kind=J,this.runHandler=Y,this.f=X,this._tag=se,this.g=Z,this.#e=O,this.#r=P,this.#t=j,this.#i=N,this.#o=F,P.set(x,this);const we=A[J];if(typeof we!="number")throw new Error(`Unknown TestRunProfile.group ${J}`);this.#e.$publishTestRunProfile({profileId:x,controllerId:W,tag:se?l.TestTag.namespace(this.controllerId,se.id):null,label:ce,group:we,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$2gc=E;const A={[f.TestRunProfileKind.Coverage]:8,[f.TestRunProfileKind.Debug]:4,[f.TestRunProfileKind.Run]:2}}),define(ke[340],Se([1,0,19,8,4,6,148,15,7]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class y{constructor(C,m){this.i=m,this.a=new g.$Sd({onListenerError:T.$2}),this.b=new g.$Sd({onListenerError:T.$2}),this.c=new g.$Sd({onListenerError:T.$2}),this.d=new g.$Sd({onListenerError:T.$2}),this.f=new g.$Sd({onListenerError:T.$2}),this.g=new g.$Sd({onListenerError:T.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(I.$MK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const m=this.i.allEditors();return C?m:m.map(w=>w.value)}async showTextDocument(C,m,w){let S;typeof m=="number"?S={position:p.ViewColumn.from(m),preserveFocus:w}:typeof m=="object"?S={position:p.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?p.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:S={preserveFocus:!1};const l=await this.h.$tryShowTextDocument(C.uri,S),f=l&&this.i.getEditor(l);if(f)return f.value;throw l?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,m){return new R.$XM(this.h,C,m).value}$acceptEditorPropertiesChanged(C,m){const w=this.i.getEditor(C);if(!w)throw new Error("unknown text editor");if(m.options&&w._acceptOptions(m.options),m.selections){const S=m.selections.selections.map(p.Selection.to);w._acceptSelections(S)}if(m.visibleRanges){const S=D.$Hb(m.visibleRanges.map(p.Range.to));w._acceptVisibleRanges(S)}if(m.options&&this.b.fire({textEditor:w.value,options:{...m.options,lineNumbers:p.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const S=$.TextEditorSelectionChangeKind.fromValue(m.selections.source),l=m.selections.selections.map(p.Selection.to);this.a.fire({textEditor:w.value,selections:l,kind:S})}if(m.visibleRanges){const S=D.$Hb(m.visibleRanges.map(p.Range.to));this.c.fire({textEditor:w.value,visibleRanges:S})}}$acceptEditorPositionData(C){for(const m in C){const w=this.i.getEditor(m);if(!w)throw new Error("Unknown text editor");const S=p.ViewColumn.to(C[m]);w.value.viewColumn!==S&&(w._acceptViewColumn(S),this.d.fire({textEditor:w.value,viewColumn:S}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$lfc=y}),define(ke[341],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=void 0,e.$4gc=(0,T.$2h)("IExtHostTimeline");class M{constructor(w,S){this.b=new Map,this.c=new Map,this.a=w.getProxy(g.$MK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(l,f)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&$.$gm.equals(f,this.b.get(l.source)?.extension)){const s=l.uri===void 0?void 0:D.URI.revive(l.uri);return this.c.get(l.source)?.get(C(s))?.get(l.handle)}else return;return l}})}async $getTimeline(w,S,l,f){return this.b.get(w)?.provider.provideTimeline(D.URI.revive(S),l,f)}registerTimelineProvider(w,S,l,f){const s=new I.$Rc,i=this.d(S.id,f,s).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const o=this.c;return this.f({...S,scheme:w,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(S.id)?.clear());const d=await S.provideTimeline(a,t,r);if(d==null)return;const u=i(a,t);return{...d,source:S.id,items:d.items.map(u)}},dispose(){for(const a of o.values())a.get(S.id)?.clear();n?.dispose(),s.dispose()}},l)}d(w,S,l){return(f,s)=>{let i;if(s?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const o=C(f);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${w}|${n.id??n.timestamp}`;i?.set(t,n);let r,d,u;n.iconPath&&(o instanceof R.$JL?u={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,d=o):{light:r,dark:d}=o);let c;return R.$dL.isMarkdownString(a.tooltip)?c=p.MarkdownString.from(a.tooltip):(0,y.$Ef)(a.tooltip)?c=a.tooltip:R.$dL.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=p.MarkdownString.from(a.detail)):(0,y.$Ef)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:w,command:n.command?S.toInternal(n.command,l):void 0,icon:r,iconDark:d,themeIcon:u,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(w,S){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:S}),(0,I.$Qc)(()=>{for(const f of this.c.values())f.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$5gc=M;function C(m){return m?.toString()}}),define(ke[72],Se([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0xb=e.$9xb=e.TunnelDtoConverter=void 0;class w extends $.$uv{}var S;(function(f){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}f.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}f.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$9xb=(0,R.$2h)("IExtHostTunnelService");let l=class extends g.$Sc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$MK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$OK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const d of s){const u=this.r.get(d);if(!u)return[];t.push(...await Promise.all(i.map(async c=>{let h;try{h=await u.provider.providePortAttributes({port:c,pid:n,commandLine:o},a)}catch{h=await u.provider.providePortAttributes(c,n,o,a)}return{providedAttributes:h,port:c}})))}const r=t.filter(d=>!!d.providedAttributes);return r.length>0?r.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new D.$3d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,g.$Qc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),S.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$0xb=l,e.$0xb=l=Je([We(0,C.$QM),We(1,M.$7M),We(2,p.$jj)],l)}),define(ke[342],Se([1,0,3,17,2,6]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class R{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$MK.MainThreadUriOpeners)}registerExternalUriOpener($,y,M,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(w=>!R.a.has(w));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,M),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Qc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,M){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,M)}async $openUri($,y,M){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},M)}}e.$7gc=R}),define(ke[343],Se([1,0,6,2,3,8,26]),function(me,e,D,T,g,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class p{static{this.a=0}constructor(y){this.c=new R.$hm,this.d=new Map,this.b=y.getProxy(D.$MK.MainThreadUrls)}registerUriHandler(y,M){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=p.a++;return this.c.add(C),this.d.set(m,M),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Qc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,M){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(T.URI.revive(M))}catch(m){(0,I.$1)(m)}return Promise.resolve(void 0)}async createAppUri(y){return T.URI.revive(await this.b.$createAppUri(y))}}e.$8gc=p}),define(ke[93],Se([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=e.$Bfc=e.$Afc=e.$zfc=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#l;#u;#d;constructor(o,a,t,r,d,u,c){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new D.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Sd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=d,this.#n=u,this.#u=m(u),this.#d=w(u),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,y.$fvb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===g.Schemas.https||o.scheme===g.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+y.$evb}return y.$evb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),I.$ln(this.#s,o)||this.#t.$setOptions(this.#e,f(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,$.$Wkb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,c,h,k)=>{const L=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),v=(0,y.$fvb)(L,{isRemote:a,authority:t}).toString();return`${d}${v}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,d,u,c,h,k)=>{const L=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),v=(0,y.$fvb)(L,{isRemote:a,authority:t}).toString();return`${d}${v}${k}`})}}e.$zfc=C;function m(n){try{const o=(0,p.$1o)((0,p.$Zo)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$Afc=m;function w(n){try{const o=(0,p.$1o)((0,p.$Zo)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class S extends T.$Sc{constructor(o,a,t,r,d){super(),this.c=a,this.f=t,this.g=r,this.h=d,this.b=new Map,this.a=o.getProxy(M.$MK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:d}=(0,$.$Xkb)(a,t.value);r._onMessageEmitter.fire(d)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new C(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const d=r._onDidDispose(()=>{d.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Bfc=S;function l(n){return{id:n.identifier,location:n.extensionLocation}}e.$Cfc=l;function f(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$Dfc=f;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[344],Se([1,0,21,53,3,17,23,2,15,93,110,6,7]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class w{constructor(r,d){this.document=r,this.b=d,this.a=1,this.c=new M.$5ec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,d){await this.f(r).undo(),d||this.disposeBackup()}async redo(r,d){await this.f(r).redo(),d||this.disposeBackup()}disposeEdits(r){for(const d of r)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,R.$Dg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const d=this.c.get(r,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this.a=new Map}get(r,d){return this.a.get(this.b(r,d))}add(r,d,u){const c=this.b(r,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${d.uri}`);const h=new w(d,u);return this.a.set(c,h),h}delete(r,d){const u=this.b(r,d.uri);this.a.delete(u)}b(r,d){return`${r}@@@${d}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class f{constructor(){this.a=new Map}addTextProvider(r,d,u){return this.b(0,r,d,u)}addCustomProvider(r,d,u){return this.b(1,r,d,u)}get(r){return this.a.get(r)}b(r,d,u,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:r,extension:u,provider:c}),new m.$OK(()=>this.a.delete(d))}}class s{constructor(r,d,u,c,h){this.d=d,this.f=u,this.g=c,this.h=h,this.b=new f,this.c=new S,this.a=r.getProxy(C.$MK.MainThreadCustomEditors)}registerCustomEditorProvider(r,d,u,c){const h=new g.$Rc;return n(u)?(h.add(this.b.addTextProvider(d,r,u)),this.a.$registerTextEditorProvider((0,y.$Cfc)(r),d,c.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.$Afc)(r))):(h.add(this.b.addCustomProvider(d,r,u)),i(u)&&h.add(u.onDidChangeCustomDocument(k=>{const L=this.i(d,k.document.uri);if(o(k)){const v=L.addEdit(k);this.a.$onDidEdit(k.document.uri,d,v,k.label)}else this.a.$onContentChange(k.document.uri,d)})),this.a.$registerCustomEditorProvider((0,y.$Cfc)(r),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,y.$Afc)(r))),m.$OK.from(h,new m.$OK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(r,d,u,c,h){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${d}'`);const L=p.URI.revive(r),v=await k.provider.openCustomDocument(L,{backupId:u,untitledDocumentData:c?.buffer},h);let b;return i(k.provider)&&this.f&&(b=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(d,v,b),{editable:i(k.provider)}}async $disposeCustomDocument(r,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=p.URI.revive(r),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(r,d,u,c,h,k){const L=this.b.get(u);if(!L)throw new Error(`No provider found for '${u}'`);const v=$.ViewColumn.to(h),b=this.g.createNewWebview(d,c.contentOptions,L.extension),E=this.h.createNewWebviewPanel(d,u,c.title,v,c.options,b,c.active),A=p.URI.revive(r);switch(L.type){case 1:{const{document:z}=this.i(u,A);return L.provider.resolveCustomEditor(z,E,k)}case 0:{const z=this.d.getDocument(A);return L.provider.resolveCustomTextEditor(z,E,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,d,u){this.i(d,r).disposeEdits(u)}async $onMoveCustomEditor(r,d,u){const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const h=this.h.getWebviewPanel(r);if(!h)throw new Error("No webview found");const k=p.URI.revive(d),L=this.d.getDocument(k);await c.provider.moveCustomTextEditor(L,h,D.CancellationToken.None)}async $undo(r,d,u,c){return this.i(d,r).undo(u,c)}async $redo(r,d,u,c){return this.i(d,r).redo(u,c)}async $revert(r,d,u){const c=this.i(d,r);await this.j(d).revertCustomDocument(c.document,u),c.disposeBackup()}async $onSave(r,d,u){const c=this.i(d,r);await this.j(d).saveCustomDocument(c.document,u),c.disposeBackup()}async $onSaveAs(r,d,u,c){const h=this.i(d,r);return this.j(d).saveCustomDocumentAs(h.document,p.URI.revive(u),c)}async $backup(r,d,u){const c=this.i(d,r),k=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},u);return c.updateBackup(k),k.id}i(r,d){const u=this.c.get(r,p.URI.revive(d));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$Ffc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Pi)(r)+""}}),define(ke[345],Se([1,0,4,3,2,30,15,93,6,7]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class M extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#l;#u;#d;#h;constructor(S,l,f,s){super(),this.#s=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new D.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=l,this.#o=f,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#l=s.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(S){this.#u||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#l=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!l})}c(){if(this.#u)throw new Error("Webview is disposed")}}class C extends T.$Sc{static c(){return(0,I.$mg)()}constructor(S,l,f){super(),this.j=l,this.m=f,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$MK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,l,f,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,p.$Afc)(S),t=C.c();this.f.$createWebviewPanel((0,p.$Cfc)(S),t,l,{title:f,panelOptions:m(i),webviewOptions:(0,p.$Dfc)(S,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,l,f,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(S){const l=Object.keys(S);l.sort((f,s)=>{const i=S[f],n=S[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const f of l){const s=this.getWebviewPanel(f);if(!s)continue;const i=S[f];s._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,l,f){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:f,extension:S}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,p.$Afc)(S)}),new y.$OK(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(S,l,f,s){const i=this.h.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(S,f.webviewOptions,o),t=this.createNewWebviewPanel(S,l,f.title,s,f.panelOptions,a,f.active);await n.deserializeWebviewPanel(t,f.state)}createNewWebviewPanel(S,l,f,s,i,n,o){const a=new M(S,this.f,n,{viewType:l,title:f,viewColumn:s,panelOptions:i,active:o});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$Efc=C;function m(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(ke[346],Se([1,0,4,3,93,15,6,7]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class $ extends T.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,m,w,S,l,f){super(),this.#r=!1,this.#l=this.B(new D.$Sd),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new D.$Sd),this.onDidDispose=this.#u.event,this.#i=w,this.#a=S,this.#e=C,this.#t=m,this.#o=l,this.#n=f}dispose(){this.#r||(this.#r=!0,this.#u.fire(),this.#o.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$MK.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,w,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:w,extension:C}),this.a.$registerWebviewViewProvider((0,g.$Cfc)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$Afc)(C)}),new p.$OK(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,w,S,l){const f=this.b.get(m);if(!f)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=f,n=this.d.createNewWebview(C,{},i),o=new $(C,this.a,m,w,n,!0);this.c.set(C,o),await s.resolveWebviewView(o,{state:S},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$9gc=y}),define(ke[151],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,D,T,g,I,R,p,$,y){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0;let C=class{static{M=this}static{this.a={focused:!0,active:!0}}getState(w){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$kF)(w,"windowActivity"),S.active}}}constructor(w){this.c=new D.$Sd,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=w.getProxy(T.$MK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:l})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(w){this.onDidChangeWindowProperty("focused",w)}$onDidChangeWindowActive(w){this.onDidChangeWindowProperty("active",w)}onDidChangeWindowProperty(w,S){S!==this.d[w]&&(this.d={...this.d,[w]:S},this.c.fire(this.d))}openUri(w,S){let l;if(typeof w=="string"){l=w;try{w=g.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.$Ge)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,l,S)}async asExternalUri(w,S){if((0,R.$Ge)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(w,S);return g.URI.from(l)}};e.$0gc=C,e.$0gc=C=M=Je([We(0,$.$QM)],C),e.$$gc=(0,p.$2h)("IExtHostWindow")}),define(ke[347],Se([1,0,315,27,20]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;const I=1024*1024;let R=class extends D.$bhc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,M){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,M),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const M=process[$],C=M.write;let m="";Object.defineProperty(M,"write",{set:()=>{},get:()=>(w,S,l)=>{if(!this.g){m+=w.toString(S);const f=m.length>I?m.length:m.lastIndexOf(`
`);f!==-1&&(console[y](m.slice(0,f)),m=m.slice(f+1))}C.call(M,w,S,l)}})}};e.$Mhc=R,e.$Mhc=R=Je([We(0,g.$QM),We(1,T.$7M)],R)}),define(ke[348],Se([1,0,71,17,14,250,32,11]),function(me,e,D,T,g,I,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(T.Schemas.file,new y(m),{isCaseSensitive:p.$k})}};e.$Nhc=$,e.$Nhc=$=Je([We(0,D.$wfc),We(1,g.$jj)],$);class y{constructor(C){this.b=C,this.a=new I.$nq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,w){return this.a.writeFile(C,m,{...w,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,w){return this.a.rename(C,m,w)}copy(C,m,w){return this.a.copy(C,m,w)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(ke[349],Se([1,0,16,63,30,35,3,6,2,20]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=void 0;let M=class extends R.$Sc{constructor(m,w){super();const S=m.getProxy(p.$MK.MainThreadDownloadService);w.registerCommand(!1,"_workbench.downloadResource",async l=>{const f=$.URI.file((0,D.$jc)((0,T.tmpdir)(),(0,g.$mg)()));return await S.$download(l,f),f})}};e.$Lhc=M,e.$Lhc=M=Je([We(0,y.$QM),We(1,I.$aN)],M)}),define(ke[350],Se([1,0,150,17,252,30]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;class R extends D.$ahc{s($,y,M){return $.scheme===T.Schemas.file?new g.$3N(M?.name||(0,I.$mg)(),$.fsPath,!M?.donotRotate,!!M?.donotUseFormatters,y):super.s($,y,M)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Yhc=R}),define(ke[351],Se([1,0,55,16,2,92,3,17,12,31]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class M extends I.$yfc{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==p.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const d=r.fsPath;let u=0;do{let c;u===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${u}`:`${d}-${u}`,await C(c);const h=T.$jc(c,"vscode.lock"),k=await l(this.d,h,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),g.URI.file(c);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Xhc=M;async function C(a){try{await y.Promises.stat(a);return}catch{}try{await y.Promises.mkdir(a,{recursive:!0})}catch{}}const m=1e3,w=10*60*1e3;class S extends R.$Sc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new $.$ah),this.a.cancelAndSet(async()=>{const d=await f(t,r);(!d||d.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function l(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const d=await f(a,t);return!d||d.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function f(a,t){let r;try{r=await y.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(r))}catch(d){return a.error(d),null}}async function s(a,t){let r;try{r=await y.Promises.stat(t)}catch(d){return a.error(d),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await f(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let k=r.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$3g)(Math.min(100,k)),await s(a,t)===0)return o(a,t);k=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const d=await s(a,t),u=Date.now()-d;if(u<=w)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$3g)(2e3);const c=await s(a,t),h=Date.now()-c;return h<=w?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return l(a,t,!0)}}),define(ke[352],Se([1,0,30,20,47,35]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;let R=class extends g.$Ufc{constructor($,y){super(!0,$,y)}createTerminal($,y,M){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:M})}createTerminalFromOptions($,y){const M=new g.$Tfc(this.a,(0,D.$mg)(),$,$.name);return this.f.push(M),M.create($,this.R($,y)),M.value}};e.$ghc=R,e.$ghc=R=Je([We(0,I.$aN),We(1,T.$QM)],R)}),define(ke[353],Se([1,0,12,22,21,8,4,3,130,304,68]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$m7b=e.ResponsiveState=e.RequestInitiator=e.$l7b=e.$k7b=void 0;function m(E,A){try{return JSON.stringify(E,A)}catch{return"null"}}const w="$$ref$$",S={[w]:-1};class l{constructor(A,z){this.jsonString=A,this.referencedBuffers=z}}function f(E,A=null,z=!1){const O=[];return{jsonString:(z?m:JSON.stringify)(E,(j,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof T.$ge){const F=O.push(N)-1;return{[w]:F}}if(A)return A(j,N)}return N}),referencedBuffers:O}}e.$k7b=f;function s(E,A,z){return JSON.parse(E,(O,P)=>{if(P){const j=P[w];if(typeof j=="number")return A[j];if(z&&P.$mid===1)return z.transformIncoming(P)}return P})}e.$l7b=s;function i(E,A){return JSON.stringify(E,A)}function n(E){return E?(A,z)=>z&&z.$mid===1?E.transformOutgoing(z):z:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class u extends p.$Sc{static{C=r}static{this.a=3*1e3}constructor(A,z=null,O=null){super(),this[C]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=z,this.g=O,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let P=0,j=M.$Bv.count;P<j;P++)this.m[P]=null,this.s[P]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$bh(()=>this.H(),1e3)),this.c.onMessage(P=>this.L(P))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const z=this.w[A];delete this.w[A],z.resolveErr(I.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,$.$2m)(A,this.g):A}getProxy(A){const{nid:z,sid:O}=A;return this.s[z]||(this.s[z]=this.J(z,O)),this.s[z]}J(A,z){const O={get:(P,j)=>(typeof j=="string"&&!P[j]&&j.charCodeAt(0)===36&&(P[j]=(...N)=>this.U(A,j,N)),j===d?z:P[j])};return new Proxy(Object.create(null),O)}set(A,z){return this.m[A.nid]=z,z}assertRegistered(A){for(let z=0,O=A.length;z<O;z++){const P=A[z];if(!this.m[P.nid])throw new Error(`Missing proxy instance ${P.sid}`)}}L(A){if(this.j)return;const z=A.byteLength,O=h.read(A,0),P=O.readUInt8(),j=O.readUInt32();switch(P){case 1:case 2:{let{rpcId:N,method:F,args:W}=L.deserializeRequestJSONArgs(O);this.g&&(W=(0,$.$2m)(W,this.g)),this.M(z,j,N,F,W,P===2);break}case 3:case 4:{let{rpcId:N,method:F,args:W}=L.deserializeRequestMixedArgs(O);this.g&&(W=(0,$.$2m)(W,this.g)),this.M(z,j,N,F,W,P===4);break}case 5:{this.f?.logIncoming(z,j,0,"ack"),this.G(j);break}case 6:{this.N(z,j);break}case 7:{this.O(z,j,void 0);break}case 9:{let N=L.deserializeReplyOKJSON(O);this.g&&(N=(0,$.$2m)(N,this.g)),this.O(z,j,N);break}case 10:{const N=L.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(z,j,N);break}case 8:{const N=L.deserializeReplyOKVSBuffer(O);this.O(z,j,N);break}case 11:{let N=L.deserializeReplyErrError(O);this.g&&(N=(0,$.$2m)(N,this.g)),this.P(z,j,N);break}case 12:{this.P(z,j,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,z,O,P,j,N){this.f?.logIncoming(A,z,1,`receiveRequest ${(0,M.$Dv)(O)}.${P}(`,j);const F=String(z);let W,x;if(N){const J=new g.$3d;j.push(J.token),W=this.Q(O,P,j),x=()=>J.cancel()}else W=this.Q(O,P,j),x=t;this.u[F]=x;const ce=L.serializeAcknowledged(z);this.f?.logOutgoing(ce.byteLength,z,1,"ack"),this.c.send(ce),W.then(J=>{delete this.u[F];const Y=L.serializeReplyOK(z,J,this.h);this.f?.logOutgoing(Y.byteLength,z,1,"reply:",J),this.c.send(Y)},J=>{delete this.u[F];const Y=L.serializeReplyErr(z,J);this.f?.logOutgoing(Y.byteLength,z,1,"replyErr:",J),this.c.send(Y)})}N(A,z){this.f?.logIncoming(A,z,1,"receiveCancel");const O=String(z);this.u[O]?.()}O(A,z,O){this.f?.logIncoming(A,z,0,"receiveReply:",O);const P=String(z);if(!this.w.hasOwnProperty(P))return;const j=this.w[P];delete this.w[P],j.resolveOk(O)}P(A,z,O){this.f?.logIncoming(A,z,0,"receiveReplyErr:",O);const P=String(z);if(!this.w.hasOwnProperty(P))return;const j=this.w[P];delete this.w[P];let N;O&&(O.$isError?(N=new Error,N.name=O.name,N.message=O.message,N.stack=O.stack):N=O),j.resolveErr(N)}Q(A,z,O){try{return Promise.resolve(this.S(A,z,O))}catch(P){return Promise.reject(P)}}S(A,z,O){const P=this.m[A];if(!P)throw new Error("Unknown actor "+(0,M.$Dv)(A));const j=P[z];if(typeof j!="function")throw new Error("Unknown method "+z+" on actor "+(0,M.$Dv)(A));return j.apply(P,O)}U(A,z,O){if(this.j)return new y.$j7b;let P=null;if(O.length>0&&g.CancellationToken.isCancellationToken(O[O.length-1])&&(P=O.pop()),P&&P.isCancellationRequested)return Promise.reject(I.$6());const j=L.serializeRequestArguments(O,this.h),N=++this.t,F=String(N),W=new y.$i7b,x=new p.$Rc;P&&x.add(P.onCancellationRequested(()=>{const J=L.serializeCancel(N);this.f?.logOutgoing(J.byteLength,N,0,"cancel"),this.c.send(L.serializeCancel(N))})),this.w[F]=new c(W,x),this.F(N);const ce=L.serializeRequest(N,A,z,j,!!P);return this.f?.logOutgoing(ce.byteLength,N,0,`request: ${(0,M.$Dv)(A)}.${z}(`,O),this.c.send(ce),W}}e.$m7b=u;class c{constructor(A,z){this.a=A,this.b=z}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class h{static alloc(A,z,O){const P=new h(T.$ge.alloc(O+1+4),0);return P.writeUInt8(A),P.writeUInt32(z),P}static read(A,z){return new h(A,z)}get buffer(){return this.a}constructor(A,z){this.a=A,this.b=z}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+A).toString();return this.b+=A,O}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+A).toString();return this.b+=A,O}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+A);return this.b+=A,z}static sizeMixedArray(A){let z=0;z+=1;for(let O=0,P=A.length;O<P;O++){const j=A[O];switch(z+=1,j.type){case 1:z+=this.sizeLongString(j.value);break;case 2:z+=this.sizeVSBuffer(j.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(j.value);for(let N=0;N<j.buffers.length;++N)z+=this.sizeVSBuffer(j.buffers[N]);break;case 4:break}}return z}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let z=0,O=A.length;z<O;z++){const P=A[z];switch(P.type){case 1:this.writeUInt8(1),this.writeLongString(P.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(P.value);break;case 3:this.writeUInt8(3),this.writeUInt32(P.buffers.length),this.writeLongString(P.value);for(let j=0;j<P.buffers.length;++j)this.writeBuffer(P.buffers[j]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const z=new Array(A);for(let O=0;O<A;O++)switch(this.readUInt8()){case 1:z[O]=this.readLongString();break;case 2:z[O]=this.readVSBuffer();break;case 3:{const j=this.readUInt32(),N=this.readLongString(),F=[];for(let W=0;W<j;++W)F.push(this.readVSBuffer());z[O]=new M.$Ev(s(N,F,null));break}case 4:z[O]=void 0;break}return z}}var k;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(k||(k={}));class L{static a(A){for(let z=0,O=A.length;z<O;z++)if(A[z]instanceof T.$ge||A[z]instanceof M.$Ev||typeof A[z]>"u")return!0;return!1}static serializeRequestArguments(A,z){if(this.a(A)){const O=[];for(let P=0,j=A.length;P<j;P++){const N=A[P];if(N instanceof T.$ge)O[P]={type:2,value:N};else if(typeof N>"u")O[P]={type:4};else if(N instanceof M.$Ev){const{jsonString:F,referencedBuffers:W}=f(N.value,z);O[P]={type:3,value:T.$ge.fromString(F),buffers:W}}else O[P]={type:1,value:T.$ge.fromString(i(N,z))}}return{type:1,args:O}}return{type:0,args:i(A,z)}}static serializeRequest(A,z,O,P,j){switch(P.type){case 0:return this.b(A,z,O,P.args,j);case 1:return this.c(A,z,O,P.args,j)}}static b(A,z,O,P,j){const N=T.$ge.fromString(O),F=T.$ge.fromString(P);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(N),W+=h.sizeLongString(F);const x=h.alloc(j?2:1,A,W);return x.writeUInt8(z),x.writeShortString(N),x.writeLongString(F),x.buffer}static deserializeRequestJSONArgs(A){const z=A.readUInt8(),O=A.readShortString(),P=A.readLongString();return{rpcId:z,method:O,args:JSON.parse(P)}}static c(A,z,O,P,j){const N=T.$ge.fromString(O);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(N),F+=h.sizeMixedArray(P);const W=h.alloc(j?4:3,A,F);return W.writeUInt8(z),W.writeShortString(N),W.writeMixedArray(P),W.buffer}static deserializeRequestMixedArgs(A){const z=A.readUInt8(),O=A.readShortString(),P=A.readMixedArray(),j=new Array(P.length);for(let N=0,F=P.length;N<F;N++){const W=P[N];typeof W=="string"?j[N]=JSON.parse(W):j[N]=W}return{rpcId:z,method:O,args:j}}static serializeAcknowledged(A){return h.alloc(5,A,0).buffer}static serializeCancel(A){return h.alloc(6,A,0).buffer}static serializeReplyOK(A,z,O){if(typeof z>"u")return this.d(A);if(z instanceof T.$ge)return this.e(A,z);if(z instanceof M.$Ev){const{jsonString:P,referencedBuffers:j}=f(z.value,O,!0);return this.g(A,P,j)}else return this.f(A,m(z,O))}static d(A){return h.alloc(7,A,0).buffer}static e(A,z){let O=0;O+=h.sizeVSBuffer(z);const P=h.alloc(8,A,O);return P.writeVSBuffer(z),P.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,z){const O=T.$ge.fromString(z);let P=0;P+=h.sizeLongString(O);const j=h.alloc(9,A,P);return j.writeLongString(O),j.buffer}static g(A,z,O){const P=T.$ge.fromString(z);let j=0;j+=h.sizeUInt32,j+=h.sizeLongString(P);for(const F of O)j+=h.sizeVSBuffer(F);const N=h.alloc(10,A,j);N.writeUInt32(O.length),N.writeLongString(P);for(const F of O)N.writeBuffer(F);return N.buffer}static deserializeReplyOKJSON(A){const z=A.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(A,z){const O=A.readUInt32(),P=A.readLongString(),j=[];for(let N=0;N<O;++N)j.push(A.readVSBuffer());return new M.$Ev(s(P,j,z))}static serializeReplyErr(A,z){const O=z?m(I.$3(z),null):void 0;if(typeof O!="string")return this.h(A);const P=T.$ge.fromString(O);let j=0;j+=h.sizeLongString(P);const N=h.alloc(11,A,j);return N.writeLongString(P),N.buffer}static deserializeReplyErrError(A){const z=A.readLongString();return JSON.parse(z)}static h(A){return h.alloc(12,A,0).buffer}}var v;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var b;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(b||(b={}))}),define(ke[354],Se([1,0,4,37,46,5]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=e.OutputChannelUpdateMode=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=void 0,e.$XJ="text/x-code-output",e.$YJ="output",e.$ZJ="Log",e.$1J="text/x-code-log-output",e.$2J="log",e.$3J="workbench.panel.output",e.$4J=new g.$gj("inOutput",!1),e.$5J=new g.$gj("activeLogOutput",!1),e.$6J=new g.$gj("outputView.scrollLock",!1),e.$7J=(0,I.$2h)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$8J={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new D.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(M=>y.push(M)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}T.$tn.add(e.$8J.OutputChannels,new p),e.$9J=new g.$gj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,26,14,354,71,27,57,182,22,18,32,4,3]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0;class s extends R.$pj{get disposed(){return this.n}constructor(a,t,r,d,u){super(),this.id=a,this.name=t,this.r=r,this.s=d,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=m.$ge.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,d,u,c){this.i=t,this.j=r,this.k=d,this.l=u,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$MK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$rm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,u=(0,w.$Ef)(t)?t:void 0;if((0,w.$Ef)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([L])=>I.$gm.equals(r.identifier,L))?.[1];h&&(c=(0,R.$zj)(h));const k=d?this.o(a,c,r):this.n(a,u,r);return k.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),d?this.r(a,c??this.m.getLevel(),k):this.q(a,k)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,u=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,u,t,r.identifier.value);return new s(h,a,c,this.a,r)}async o(a,t,r){const d=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${u}.log`),h=`${r.identifier.value}.${u}`,k=this.l.createLogger(c,{id:h,name:a,logLevel:t,extensionId:r.identifier.value});return new i(h,a,k,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(d){if((0,S.$Bk)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return r})())}return t}q(a,t){let r=!1;const d=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){d(),t.then(c=>c.append(u))},appendLine(u){d(),t.then(c=>c.appendLine(u))},clear(){d(),t.then(u=>u.clear())},replace(u){d(),t.then(c=>c.replace(u))},show(u,c){d(),t.then(h=>h.show(u,c))},hide(){d(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const d=new f.$Rc,u=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new l.$Sd);function h(k){t=k,c.fire(k)}return r.then(k=>{d.add(k),k.logLevel!==t&&h(k.logLevel),d.add(k.onDidChangeLogLevel(L=>h(L)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(k,...L){u(),r.then(v=>v.trace(k,...L))},debug(k,...L){u(),r.then(v=>v.debug(k,...L))},info(k,...L){u(),r.then(v=>v.info(k,...L))},warn(k,...L){u(),r.then(v=>v.warn(k,...L))},error(k,...L){u(),r.then(v=>v.error(k,...L))},dispose(){d.dispose()}}}};e.$Jgc=n,e.$Jgc=n=Je([We(0,g.$QM),We(1,y.$7M),We(2,$.$wfc),We(3,M.$9ec),We(4,R.$kj),We(5,R.$jj)],n),e.$Kgc=(0,T.$2h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,12]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=(0,D.$2h)("remoteAgentService"),e.$Hm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let p=0;p<this.maxSampleCount;p++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,T.$3g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(I):R=this.initial.reduce((p,$)=>p+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:I,average:this.average.reduce((p,$)=>p+$,0)/this.average.length,high:(()=>typeof R>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,224,86,37,40,45,3,4,153,11,24]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=void 0,e.$zH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$AH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$BH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$CH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const w=new m;g.$tn.add(e.$CH.ConfigurationMigration,w);let S=class extends p.$Sc{constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,w.migrations)})),this.c(w.migrations),this.B(w.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),o=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[a,t]of o){const r=[];for(const u of n.overrideIdentifiers??[]){const c=await this.h(s,{resource:i,overrideIdentifier:u},a);for(const h of c??[]){let k=r.find(([[L,v]])=>L===h[0]&&(0,C.$ln)(v.value,h[1].value));k||r.push(k=[h,[]]),k[1].push(u)}}const d=await this.h(s,{resource:i},a,n);for(const u of d??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,c],h])=>this.a.updateValue(u,c.value,{resource:i,overrideIdentifiers:h},t)))}}async h(s,i,n,o){const a=u=>t(this.a.inspect(u,i)),t=u=>{const c=u[n];return i.overrideIdentifier?c?.override:c?.value},r=o?t(o):a(s.key);if(r===void 0)return;const d=await s.migrateFn(r,a);return Array.isArray(d)?d:[[s.key,d]]}};e.$DH=S,e.$DH=S=Je([We(0,R.$vi),We(1,I.$$h)],S);let l=class extends p.$Sc{constructor(s){super(),(async()=>{if(!M.$i&&(await s.getEnvironment())?.os!==1)return;g.$tn.as(T.$yn.Configuration).registerConfiguration({...e.$BH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$EH=l,e.$EH=l=Je([We(0,y.$Gm)],l)}),define(ke[356],Se([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cb=e.$4cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$3cb=e.$2cb=void 0,e.$2cb=(0,y.$2h)("editorResolverService"),e.$3cb="workbench.editorAssociations";const C=M.$tn.as($.$yn.Configuration),m={...p.$AH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var S;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function l(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}e.$4cb=l;function f(s,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(g.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$Ag)(i);return D.$Hj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$5cb=f}),define(ke[357],Se([1,0,33,17,16,11,23,2,5,268,40,144,153]),function(me,e,D,T,g,I,R,p,$,y,M,C,m){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=void 0,e.$oK=(0,$.$2h)("pathService");let S=w=class{constructor(f,s,i,n){this.d=f,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??f})()}hasValidBasename(f,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(f,n,s)):this.h(f,s,i)}h(f,s,i){return f.scheme===T.Schemas.file||f.scheme===T.Schemas.vscodeRemote?(0,D.$2f)(i??(0,R.$Ag)(f),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,s){if(f.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,y.$lK)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:T.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?g.$fc:g.$gc)}async fileURI(f){let s="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const n=f.indexOf("/",2);n===-1?(s=f.substring(2),f="/"):(s=f.substring(2,n),f=f.substring(n)||"/")}return p.URI.from({scheme:T.Schemas.file,authority:s,path:f,query:"",fragment:""})}};e.$pK=S,e.$pK=S=w=Je([We(1,m.$Gm),We(2,C.$0J),We(3,M.$$h)],S)}),define(ke[358],Se([1,0,235,19,59,4,53,3,2,45,240,14,64,270,88,40,144,25,21,18,24,46]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iK=e.$hK=e.$gK=e.OnPortForward=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.TunnelSource=e.TunnelCloseReason=e.$aK=e.$_J=e.$$J=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$$J="onTunnel",e.$_J=new a.$gj("forwardedPortsViewEnabled",!1,D.localize(0,null));function d(z){const O=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$aK=d;var u;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var c;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$bK={source:c.User,description:D.localize(1,null)},e.$cK={source:c.Auto,description:D.localize(2,null)};function h(z,O,P){const j=z.get(L(O,P));if(j)return j;if((0,S.$qv)(O))for(const N of S.$pv){const F=L(N,P);if(z.has(F))return z.get(F)}else if((0,S.$sv)(O))for(const N of S.$rv){const F=L(N,P);if(z.has(F))return z.get(F)}}e.$dK=h;function k(z,O,P){const j=h(z,O,P);if(j)return j;const N=(0,S.$sv)(O)?"localhost":(0,S.$qv)(O)?"0.0.0.0":void 0;if(N)return h(z,N,P)}e.$eK=k;function L(z,O){return z+":"+O}e.$fK=L;var v;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(v||(e.OnPortForward=v={}));function b(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$gK=b;class E extends p.$Sc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(O){super(),this.r=O,this.j=[],this.n=new I.$Sd,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(P=>{(P.affectsConfiguration(E.c)||P.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,P,j){let N=this.w(O,P,j,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const W=this.j[N];W.key===O?(F.onAutoForward=W.onAutoForward??F.onAutoForward,F.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:F.elevateIfNeeded,F.label=W.label??F.label,F.requireLocalPort=W.requireLocalPort,F.protocol=W.protocol):(F.onAutoForward=F.onAutoForward??W.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:W.elevateIfNeeded,F.label=F.label??W.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??W.protocol),N=this.w(O,P,j,this.j,N+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,n.$Ef)(O.host)&&(0,n.$If)(O.port)}w(O,P,j,N,F){if(F>=N.length)return-1;const W=!(0,S.$qv)(P)&&!(0,S.$sv)(P),ce=N.slice(F).findIndex(J=>(0,n.$If)(J.key)?W?!1:J.key===O:this.t(J.key)?W?!1:O>=J.key.start&&O<=J.key.end:this.u(J.key)?O===J.key.port&&P===J.key.host:j?J.key.test(j):!1);return ce>=0?ce+F:-1}y(){const O=this.r.getValue(E.c);if(!O||!(0,n.$Gf)(O))return[];const P=[];for(const N in O){if(N===void 0)continue;const F=O[N];let W;if(Number(N))W=Number(N);else if((0,n.$Ef)(N))if(E.g.test(N)){const x=N.match(E.g);W={start:Number(x[1]),end:Number(x[2])}}else if(E.h.test(N)){const x=N.match(E.h);W={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(N)}catch{}x&&(W=x)}W&&P.push({key:W,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const j=this.r.getValue(E.f);return j&&(this.m={elevateIfNeeded:j.elevateIfNeeded,label:j.label,onAutoForward:j.onAutoForward,requireLocalPort:j.requireLocalPort,protocol:j.protocol}),this.z(P)}z(O){function P(j,N){return(0,n.$If)(j.key)?j.key:N.t(j.key)?j.key.start:N.u(j.key)?j.key.port:Number.MAX_VALUE}return O.sort((j,N)=>P(j,this)-P(N,this))}C(){return this.m}static providedActionToAction(O){switch(O){case S.ProvidedOnAutoForward.Notify:return v.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return v.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return v.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return v.OpenPreview;case S.ProvidedOnAutoForward.Silent:return v.Silent;case S.ProvidedOnAutoForward.Ignore:return v.Ignore;default:return}}async addAttributes(O,P,j){const F=this.r.inspect(E.c).userRemoteValue;let W;!F||!(0,n.$Gf)(F)?W={}:W=(0,o.$hn)(F),W[`${O}`]||(W[`${O}`]={});for(const x in P)W[`${O}`][x]=P[x];return this.r.updateValue(E.c,W,j)}}e.$hK=E;let A=class extends p.$Sc{constructor(O,P,j,N,F,W,x,ce,J,Y){super(),this.H=O,this.I=P,this.J=j,this.L=N,this.M=F,this.N=W,this.O=x,this.P=ce,this.Q=J,this.R=Y,this.c=new Map,this.g=new I.$Sd,this.onForwardPort=this.g.event,this.h=new I.$Sd,this.onClosePort=this.h.event,this.j=new I.$Sd,this.onPortName=this.j.event,this.n=new I.$Sd,this.onCandidatesChanged=this.n.event,this.t=new I.$Sd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Sd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(j),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async X=>{const se=await this.getAttributes(X.map(Z=>({port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost})));for(const Z of X)if(Z.localAddress){const we=L(Z.tunnelRemoteHost,Z.tunnelRemotePort),de=k(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort);this.forwarded.set(we,{remotePort:Z.tunnelRemotePort,remoteHost:Z.tunnelRemoteHost,localAddress:Z.localAddress,protocol:se?.get(Z.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,se?.get(Z.tunnelRemotePort)),localPort:Z.tunnelLocalPort,runningProcess:de?.detail,hasRunningProcess:!!de,pid:de?.pid,privacy:Z.privacy,source:e.$bK}),this.f.set(we,Z)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async X=>{const se=L(X.tunnelRemoteHost,X.tunnelRemotePort);if(!k(this.forwarded,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.detected,X.tunnelRemoteHost,X.tunnelRemotePort)&&!k(this.c,X.tunnelRemoteHost,X.tunnelRemotePort)&&X.localAddress){const Z=k(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort),we=(await this.getAttributes([{port:X.tunnelRemotePort,host:X.tunnelRemoteHost}]))?.get(X.tunnelRemotePort);this.forwarded.set(se,{remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localAddress:X.localAddress,protocol:we?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,we),localPort:X.tunnelLocalPort,closeable:!0,runningProcess:Z?.detail,hasRunningProcess:!!Z,pid:Z?.pid,privacy:X.privacy,source:e.$bK})}await this.$(),this.f.set(se,X),this.g.fire(this.forwarded.get(se))})),this.B(this.H.onTunnelClosed(X=>this.W(X,u.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$$J))?(this.R.createKey(e.$_J.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,P){const j=L(O.host,O.port);this.forwarded.has(j)&&(this.forwarded.delete(j),await this.$(),this.h.fire(O))}X(O,P){if(O.startsWith("http"))return $.URI.parse(O);const j=P?.protocol??"http";return $.URI.parse(`${j}://${O}`)}async Y(){const O=this.N.getWorkspace(),P=O.configuration?(0,R.$Pi)(O.configuration.path):O.folders.length>0?(0,R.$Pi)(O.folders[0].uri.path):void 0;if(P===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${P}`}async Z(){const O=this.I.get(r,1);if(O)return this.I.remove(r,1),await this.$(),O;const P=await this.Y();if(P)return this.I.get(P,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const P=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${P.map(j=>j.remotePort).join(", ")}`);for(const j of P){const N=k(this.detected,j.remoteHost,j.remotePort);j.source.source!==c.Extension&&!N||j.source.source===c.Extension&&N?await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,privacy:j.privacy,elevateIfNeeded:!0,source:j.source}):j.source.source===c.Extension&&!N&&this.D.set(L(j.remoteHost,j.remotePort),j)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new p.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async P=>{P.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const P=await this.Y();P&&this.I.store(P,this.y,0,0)}}}async bb(O,P,j){if(!O.tunnelLocalPort||!j?.requireLocalPort||O.tunnelLocalPort===P)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const F=D.localize(3,null,P,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(F)}async forward(O,P){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(O,P)}async cb(O,P){await this.Q.activateByEvent(e.$$J);const j=k(this.forwarded,O.remote.host,O.remote.port);P=P??(P!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const N=O.local!==void 0?O.local:O.remote.port;let F;if(j)return this.eb(j,O,P);{const W=this.L.remoteAuthority,x=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ce=L(O.remote.host,O.remote.port);this.c.set(ce,!0),O=this.db(ce,O);const J=await this.H.openTunnel(x,O.remote.host,O.remote.port,void 0,N,O.elevateIfNeeded?O.elevateIfNeeded:P?.elevateIfNeeded,O.privacy,P?.protocol);if(typeof J=="string")F=J;else if(J&&J.localAddress){const Y=k(this.m??new Map,O.remote.host,O.remote.port),X=J.protocol?J.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:P?.protocol??S.TunnelProtocol.Http,se={remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localPort:J.tunnelLocalPort,name:P?.label??O.name,closeable:!0,localAddress:J.localAddress,protocol:X,localUri:await this.X(J.localAddress,P),runningProcess:Y?.detail,hasRunningProcess:!!Y,pid:Y?.pid,source:O.source??e.$bK,privacy:J.privacy};return this.forwarded.set(ce,se),this.f.set(ce,J),this.c.delete(ce),await this.$(),await this.bb(J,N,P),this.g.fire(se),J}this.c.delete(ce)}return F}db(O,P){const j=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(j){const N=j.get(O);j.delete(O),N&&(P.name=N.name??P.name,P.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??P.local,P.privacy=N.privacy??P.privacy)}return P}async eb(O,P,j){const N=j?.label??P.name;let F;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(F||(F={}));let W=F.None;switch(N!==O.name&&(O.name=N,W=F.Fire),(j?.protocol||O.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&(P.source=O.source,W=F.Reopen),P.privacy&&O.privacy!==P.privacy&&(W=F.Reopen),W){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(O.remoteHost,O.remotePort,u.User),await this.cb(P,j)}return k(this.f,P.remote.host,P.remote.port)}async name(O,P,j){const N=k(this.forwarded,O,P),F=L(O,P);if(N){N.name=j,await this.$(),this.j.fire({host:O,port:P});return}else this.detected.has(F)&&(this.detected.get(F).name=j,this.j.fire({host:O,port:P}))}async close(O,P,j){const N=L(O,P),F=this.forwarded.get(N);return j===u.AutoForwardEnd&&F&&F.source.source===c.Auto&&this.F.set(N,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(O,P),this.W({host:O,port:P},j)}address(O,P){const j=L(O,P);return(this.forwarded.get(j)||this.detected.get(j))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const P of O){const j=k(this.m??new Map,P.remoteAddress.host,P.remoteAddress.port),N=typeof P.localAddress=="string"?P.localAddress:L(P.localAddress.host,P.localAddress.port);this.detected.set(L(P.remoteAddress.host,P.remoteAddress.port),{remoteHost:P.remoteAddress.host,remotePort:P.remoteAddress.port,localAddress:N,protocol:S.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:j?.detail,hasRunningProcess:!!j,pid:j?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(P.remoteAddress.host,P.remoteAddress.port,N,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let P=O;this.r&&(P=await this.r(O));const j=this.fb(P);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(j.values()).map(N=>N.port).join(", ")}`),this.n.fire(j)}fb(O){const P=this.m??new Map,j=new Map;return this.m=j,O.forEach(N=>{const F=L(N.host,N.port);j.set(F,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),P.has(F)&&P.delete(F);const W=k(this.forwarded,N.host,N.port);W&&(W.runningProcess=N.detail,W.hasRunningProcess=!0,W.pid=N.pid)}),P.forEach((N,F)=>{const W=d(F);if(!W)return;const x=k(this.forwarded,W.host,W.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const ce=k(this.detected,W.host,W.port);ce&&(ce.runningProcess=void 0,ce.hasRunningProcess=!1,ce.pid=void 0)}),P}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),P=await this.getAttributes(O.map(j=>({port:j.remotePort,host:j.remoteHost})),!1);if(P)for(const j of O){const N=P.get(j.remotePort);(N?.protocol||j.protocol!==S.TunnelProtocol.Http)&&N?.protocol!==j.protocol&&await this.cb({remote:{host:j.remoteHost,port:j.remotePort},local:j.localPort,name:j.name,source:j.source},N),N&&N.label&&N.label!==j.name&&await this.name(j.remoteHost,j.remotePort,N.label)}}async getAttributes(O,P=!0){const j=new Map,N=new Map;O.forEach(J=>{const Y=k(this.m??new Map,S.$pv[0],J.port)??J;if(Y){j.set(J.port,Y);const X=b(Y)?Y.pid:void 0;N.has(X)||N.set(X,[]),N.get(X)?.push(J.port)}});const F=new Map;if(O.forEach(J=>{const Y=this.configPortsAttributes.getAttributes(J.port,J.host,j.get(J.port)?.detail);Y&&F.set(J.port,Y)}),this.G.length===0||!P)return F.size>0?F:void 0;const W=await Promise.all((0,T.$Rb)(this.G.map(J=>Array.from(N.entries()).map(Y=>{const X=Y[1],se=j.get(X[0]);return J.providePortAttributes(X,se?.pid,se?.detail,new i.$3d().token)})))),x=new Map;if(W.forEach(J=>J.forEach(Y=>{Y&&x.set(Y.port,Y)})),!F&&!x)return;const ce=new Map;return O.forEach(J=>{const Y=F.get(J.port),X=x.get(J.port);ce.set(J.port,{elevateIfNeeded:Y?.elevateIfNeeded,label:Y?.label,onAutoForward:Y?.onAutoForward??E.providedActionToAction(X?.autoForwardAction),requireLocalPort:Y?.requireLocalPort,protocol:Y?.protocol})}),ce}addAttributesProvider(O){this.G.push(O)}};e.$iK=A,Je([(0,g.$uh)(1e3)],A.prototype,"$",null),e.$iK=A=Je([We(0,S.$lv),We(1,w.$gp),We(2,y.$vi),We(3,f.$0J),We(4,m.$3k),We(5,l.$$h),We(6,C.$jj),We(7,M.$Qv),We(8,s.$gF),We(9,a.$hj)],A)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$4I=e.$3I=void 0;class D{constructor(R,p){this.line=R,this.character=p}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,p){return new D(0,0)}with(R){return new D(0,0)}}e.$3I=D;class T{constructor(R,p,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(R,p),this.end=new D($,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new T(0,0,0,0)}with(R){return new T(0,0,0,0)}}e.$4I=T;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,8,94,12]),function(me,e,D,T,g,I,R,p,$,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.SearchErrorCode=e.$gJ=e.$fJ=e.SearchSortOrder=e.ViewMode=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.SearchCompletionExitCode=e.$aJ=e.$_I=e.$$I=e.QueryType=e.SearchProviderType=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$5I="workbench.view.search",e.$6I="workbench.panel.search",e.$7I="workbench.view.search",e.$8I="search-result",e.$9I="search.exclude";const m="\u27EA ",w=" characters skipped \u27EB",S=(m.length+w.length+5)*2;e.$0I=(0,p.$2h)("searchService");var l;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(l||(e.SearchProviderType=l={}));var f;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(f||(e.QueryType=f={}));function s(X){return!!X.preview}e.$$I=s;function i(X){return!!X.resource}e.$_I=i;function n(X){return!!X.message}e.$aJ=n;var o;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(se){this.resource=se,this.results=[]}}e.$bJ=a;class t{constructor(se,Z,we,de){this.ranges=Z,this.webviewIndex=de;const K=Array.isArray(Z)?Z:[Z];if(we&&we.matchLines===1&&r(K)){se=(0,R.$xf)(se,we.matchLines);let B="",ne=0,ye=0;const he=Math.floor(we.charsPerLine/5),ge=[];for(const _ of K){const ie=Math.max(_.startColumn-he,0),G=_.startColumn+we.charsPerLine;if(ie>ye+he+S){const te=m+(ie-ye)+w;B+=te+se.slice(ie,G),ne+=ie-(ye+te.length)}else B+=se.slice(ye,G);ge.push(new u(0,_.startColumn-ne,_.endColumn-ne)),ye=G}this.preview={text:B,matches:Array.isArray(this.ranges)?ge:ge[0]}}else{const B=Array.isArray(Z)?Z[0].startLineNumber:Z.startLineNumber;this.preview={text:se,matches:(0,D.$2b)(Z,ne=>new d(ne.startLineNumber-B,ne.startColumn,ne.endLineNumber-B,ne.endColumn))}}}}e.$cJ=t;function r(X){const se=X[0].startLineNumber;for(const Z of X)if(Z.startLineNumber!==se||Z.endLineNumber!==se)return!1;return!0}class d{constructor(se,Z,we,de){this.startLineNumber=se,this.startColumn=Z,this.endLineNumber=we,this.endColumn=de}}e.$dJ=d;class u extends d{constructor(se,Z,we){super(se,Z,se,we)}}e.$eJ=u;var c;(function(X){X.List="list",X.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function k(X,se=!0){const Z=X&&X.files&&X.files.exclude,we=se&&X&&X.search&&X.search.exclude;if(!Z&&!we)return;if(!Z||!we)return Z||we;let de=Object.create(null);return de=g.$kn(de,g.$hn(Z)),de=g.$kn(de,g.$hn(we),!0),de}e.$fJ=k;function L(X,se){return X.excludePattern&&T.$Hj(X.excludePattern,se)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&T.$Hj(X.includePattern,se)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Z=>{const we=Z.folder.fsPath;if(I.$4f(se,we)){const de=$.$lc(we,se);return!Z.includePattern||!!T.$Hj(Z.includePattern,de)}else return!1}):!1:!0}e.$gJ=L;var v;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class b extends Error{constructor(se,Z){super(se),this.code=Z}}e.$hJ=b;function E(X){const se=X.message;if((0,y.$4)(X))return new b(se,v.canceled);try{const Z=JSON.parse(se);return new b(Z.message,Z.code)}catch{return new b(se,v.other)}}e.$iJ=E;function A(X){const se={message:X.message,code:X.code};return new Error(JSON.stringify(se))}e.$jJ=A;function z(X){return X.type==="error"?!0:X.type==="success"}e.$kJ=z;function O(X){return X.type==="success"}e.$lJ=O;function P(X){return!!X.path}e.$mJ=P;function j(X,se){const Z=X.searchPath?X.searchPath:X.relativePath;return(0,R.$uf)(Z,se)}e.$nJ=j;class N{constructor(se){this.path=se,this.results=[]}addMatch(se){this.results.push(se)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$oJ=N;function F(X,se){const Z={...X||{},...se||{}};return Object.keys(Z).filter(we=>{const de=Z[we];return typeof de=="boolean"&&de})}e.$pJ=F;class W{constructor(se,Z){this.c=null,this.a={...se.excludePattern||{},...Z.excludePattern||{}},this.b=T.$Ij(this.a);let we=se.includePattern;Z.includePattern&&(we?we={...we,...Z.includePattern}:we=Z.includePattern),we&&(this.c=T.$Ij(we))}matchesExcludesSync(se,Z,we){return!!(this.b&&this.b(se,Z,we))}includedInQuerySync(se,Z,we){return!(this.b&&this.b(se,Z,we)||this.c&&!this.c(se,Z,we))}includedInQuery(se,Z,we){const de=this.b(se,Z,we),K=()=>this.c?!!this.c(se,Z,we):!0;return(0,C.$Og)(de)?de.then(B=>B?!1:K()):K()}hasSiblingExcludeClauses(){return x(this.a)}}e.$qJ=W;function x(X){for(const se in X)if(typeof X[se]!="boolean")return!0;return!1}function ce(X){if(!X)return;let se;return Z=>(se||(se=(X()||Promise.resolve([])).then(we=>we?Y(we):{})),se.then(we=>!!we[Z]))}e.$rJ=ce;function J(X){if(!X)return;let se;return Z=>{if(!se){const we=X();se=we?Y(we):{}}return!!se[Z]}}e.$sJ=J;function Y(X){const se={};for(const Z of X)se[Z]=!0;return se}}),define(ke[41],Se([1,0,19,12,21,4,3,77,17,122,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0;function h(O,P,j){return new M.$sg(N=>b(N,j)).isEqual(O,P)}function k(O,P,j){return h(O.uri,P.uri,j)?0:(0,C.$1e)(O.uri.toString(),P.uri.toString())}function L(O,P,j){return O.index!==P.index?O.index<P.index?-1:1:h(O.uri,P.uri,j)?(0,C.$1e)(O.name,P.name):(0,C.$1e)(O.uri.toString(),P.uri.toString())}function v(O,P,j,N){const F=O.slice(0).sort((x,ce)=>j(x,ce,N)),W=P.slice(0).sort((x,ce)=>j(x,ce,N));return(0,D.$Eb)(F,W,(x,ce)=>j(x,ce,N))}function b(O,P){const j=P.getCapabilities(O.scheme);return!(j&&j&1024)}class E extends s.$ii{static toExtHostWorkspace(P,j,N,F){if(!P)return{workspace:null,added:[],removed:[]};const{id:W,name:x,folders:ce,configuration:J,transient:Y,isUntitled:X}=P,se=[],Z=j;j?ce.forEach((B,ne)=>{const ye=m.URI.revive(B.uri),he=E.o(N||j,ye,F);he?(he.name=B.name,he.index=B.index,se.push(he)):se.push({uri:ye,name:B.name,index:ne})}):se.push(...ce.map(({uri:B,name:ne,index:ye})=>({uri:m.URI.revive(B),name:ne,index:ye}))),se.sort((B,ne)=>B.index<ne.index?-1:1);const we=new E(W,x,se,!!Y,J?m.URI.revive(J):null,!!X,B=>b(B,F)),{added:de,removed:K}=v(Z?Z.workspaceFolders:[],we.workspaceFolders,k,F);return{workspace:we,added:de,removed:K}}static o(P,j,N){for(let F=0;F<P.folders.length;F++){const W=P.workspaceFolders[F];if(h(W.uri,j,N))return W}}constructor(P,j,N,F,W,x,ce){super(P,N.map(J=>new s.$ji(J)),F,W,ce),this.t=j,this.u=x,this.q=[],this.s=p.$8h.forUris(ce),N.forEach(J=>{this.q.push(J),this.s.set(J.uri,J)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(P,j){return j&&this.s.get(P)&&(P=(0,M.$Cg)(P)),this.s.findSubstr(P)}resolveWorkspaceFolder(P){return this.s.get(P)}}let A=class{constructor(P,j,N,F,W){this.c=new I.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Ud,this.B=new Map,this.h=F,this.s=N,this.t=W,this.j=new y.$4l,this.k=new T.$1g,this.o=P.getProxy(u.$MK.MainThreadWorkspace),this.q=P.getProxy(u.$MK.MainThreadMessageService);const x=j.workspace;this.l=x?new E(x.id,x.name,[],!!x.transient,x.configuration?m.URI.revive(x.configuration):null,!!x.isUntitled,ce=>b(ce,N)):void 0}$initializeWorkspace(P,j){this.v=j,this.$acceptWorkspaceData(P),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,M.$Ag)((0,M.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(P,j,N,...F){const W=[];if(Array.isArray(F)&&F.forEach(X=>{m.URI.isUri(X.uri)&&!W.some(se=>h(se.uri,X.uri,this.s))&&W.push({uri:X.uri,name:X.name||(0,M.$zg)(X.uri)})}),this.n||[j,N].some(X=>typeof X!="number"||X<0)||N===0&&W.length===0)return!1;const x=this.x?this.x.workspaceFolders:[];if(j+N>x.length)return!1;const ce=x.slice(0);ce.splice(j,N,...W.map(X=>({uri:X.uri,name:X.name||(0,M.$zg)(X.uri),index:void 0})));for(let X=0;X<ce.length;X++){const se=ce[X];if(ce.some((Z,we)=>we!==X&&h(se.uri,Z.uri,this.s)))return!1}ce.forEach((X,se)=>X.index=se);const{added:J,removed:Y}=v(x,ce,L,this.s);if(J.length===0&&Y.length===0)return!1;if(this.o){const X=P.displayName||P.name;this.o.$updateWorkspaceFolders(X,j,N,W).then(void 0,se=>{this.n=void 0;const Z={source:{identifier:P.identifier,label:P.displayName||P.name}};this.q.$showMessage(f.Severity.Error,(0,w.localize)(0,null,X,se.toString()),Z,[])})}return this.y(ce),!0}getWorkspaceFolder(P,j){if(this.x)return this.x.getWorkspaceFolder(P,j)}async getWorkspaceFolder2(P,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(P,j)}async resolveWorkspaceFolder(P){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(P)}getPath(){if(!this.x)return;const{folders:P}=this.x;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,j){let N,F="";if(typeof P=="string"?(N=m.URI.file(P),F=P):typeof P<"u"&&(N=P,F=P.fsPath),!N)return F;const W=this.getWorkspaceFolder(N,!0);if(!W)return F;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let x=(0,M.$Fg)(W.uri,N);return j&&W.name&&(x=`${W.name}/${x}`),x}y(P){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:P,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:j,added:N,removed:F}=E.toExtHostWorkspace(P,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:F}))}findFiles(P,j,N,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let x;if(j===null?x=!1:j&&(typeof j=="string"?x=j:x=j.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ce,folder:J}=z(a.GlobPattern.from(P));return this.o.$startFileSearch(ce??null,J??null,x??null,N??null,W).then(Y=>Array.isArray(Y)?Y.map(X=>m.URI.revive(X)):[])}async findTextInFiles(P,j,N,F,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const x=this.j.getNext(),ce=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:J,folder:Y}=z(a.GlobPattern.from(j.include)),X=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,se={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:ce,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:J,excludePattern:X},Z=!1;if(this.u[x]=we=>{if(Z)return;const de=m.URI.revive(we.resource);we.results.forEach(K=>{const B=(0,c.$yh)(K);(0,d.$$I)(B)?N({uri:de,preview:{text:B.preview.text,matches:(0,D.$2b)(B.preview.matches,ne=>new t.$QK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$2b)(B.ranges,ne=>new t.$QK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):N({uri:de,text:B.text,lineNumber:B.lineNumber})})},W.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(P,Y??null,se,x,W);return delete this.u[x],we||{}}catch(we){throw delete this.u[x],we}}$handleTextSearchResult(P,j){this.u[j]?.(P)}async save(P){const j=await this.o.$save(P,{saveAs:!1});return m.URI.revive(j)}async saveAs(P){const j=await this.o.$save(P,{saveAs:!0});return m.URI.revive(j)}saveAll(P){return this.o.$saveAll(P)}resolveProxy(P){return this.o.$resolveProxy(P)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(P){return this.o.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(P,j){if(this.w.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.w.set(P,j);const N=this.t.transformOutgoingScheme(P),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,N),(0,R.$Qc)(()=>{this.w.delete(P),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(P,j){this.h.info("Getting edit session identifier for workspaceFolder",P);const N=await this.resolveWorkspaceFolder(m.URI.revive(P));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const F=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(N,j);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(P,j,N,F){this.h.info("Getting edit session identifier for workspaceFolder",P);const W=await this.resolveWorkspaceFolder(m.URI.revive(P));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const x=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!x),!x)return;const ce=await x.provideEditSessionIdentityMatch?.(j,N,F);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(P){return(j,N,F)=>{const W=function(ce){j.call(N,ce)};return W.extension=P,this.A.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(P,j,N){const F=await this.resolveWorkspaceFolder(m.URI.revive(P));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},j,async(W,x)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>N&&this.h.warn("SLOW edit session create-participant",x.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(P,j){if(this.B.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this.B.set(P,j);const N=this.t.transformOutgoingScheme(P),F=this.z++;return this.o.$registerCanonicalUriProvider(F,N),(0,R.$Qc)(()=>{this.B.delete(P),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(P,j,N){const F=this.B.get(P.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(m.URI.revive(P),j,N);if(W)return W}async $provideCanonicalUri(P,j,N){return this.provideCanonicalUri(m.URI.revive(P),{targetScheme:j},N)}};e.$qfc=A,e.$qfc=A=Je([We(0,o.$QM),We(1,n.$7M),We(2,i.$9ec),We(3,l.$jj),We(4,r.$ofc)],A),e.$rfc=(0,S.$2h)("IExtHostWorkspace");function z(O){let P,j;return O&&(typeof O=="string"?P=O:(P=O.pattern,j=m.URI.revive(O.baseUri))),{includePattern:P,folder:j}}}),define(ke[42],Se([1,0,24,4,41,6,7,255,86,18,12,5,20,14,2]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=e.$sfc=void 0;function l(r,d){if(d){const u=d.split(".");let c=r;for(let h=0;c&&h<u.length;h++)c=c[u[h]];return c}}function f(r){return r instanceof S.URI}function s(r){return r&&r.uri instanceof S.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof S.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(f(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(d,u,c){this.a=d.getProxy(I.$MK.MainThreadConfiguration),this.c=u,this.b=c,this.d=new M.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,u){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,u))}};e.$sfc=a,e.$sfc=a=Je([We(0,m.$QM),We(1,g.$rfc),We(2,w.$jj)],a);class t{constructor(d,u,c,h){this.a=new T.$Sd,this.b=d,this.f=h,this.c=u,this.e=p.$Rn.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,u){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Rn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(u,c))}getConfiguration(d,u,c){const h=o(u)||{},k=this.g(d?l(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function L(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(b){return typeof l(k,b)<"u"},get:(b,E)=>{this.h(d?`${d}.${b}`:b,h,c?.identifier);let A=l(k,b);if(typeof A>"u")A=E;else{let z;const O=(P,j)=>{if((0,y.$Gf)(P)){let N;const F=()=>{z=z||(0,D.$hn)(k),N=N||l(z,j)};return new Proxy(P,{get:(W,x)=>{if(typeof x=="string"&&x.toLowerCase()==="tojson")return F(),()=>N;if(z)return N=N||l(z,j),N[x];const ce=W[x];return typeof x=="string"?O(ce,`${j}.${x}`):ce},set:(W,x,ce)=>(F(),N&&(N[x]=ce),!0),deleteProperty:(W,x)=>(F(),N&&delete N[x],!0),defineProperty:(W,x,ce)=>(F(),N&&Object.defineProperty(N,x,ce),!0)})}return Array.isArray(P)?(0,D.$hn)(P):P};A=O(A,b)}return A},update:(b,E,A,z)=>{b=d?`${d}.${b}`:b;const O=L(A);return E!==void 0?this.b.$updateConfigurationOption(O,b,E,h,z):this.b.$removeConfigurationOption(O,b,h,z)},inspect:b=>{b=d?`${d}.${b}`:b;const E=this.e.inspect(b,h,this.c.workspace);if(E)return{key:b,defaultValue:(0,D.$hn)(E.policy?.value??E.default?.value),globalValue:(0,D.$hn)(E.user?.value??E.application?.value),workspaceValue:(0,D.$hn)(E.workspace?.value),workspaceFolderValue:(0,D.$hn)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$hn)(E.default?.override),globalLanguageValue:(0,D.$hn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$hn)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$hn)(E.workspaceFolder?.override),languageIds:(0,D.$hn)(E.overrideIdentifiers)}}};return typeof k=="object"&&(0,D.$kn)(v,k,!1),Object.freeze(v)}g(d){const u=c=>(0,y.$Gf)(c)?new Proxy(c,{get:(h,k)=>u(h[k]),set:(h,k,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(h,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(h,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return u(d)}h(d,u,c){const h=$.$In.test(d)?4:this.d.get(d),k=c?`[${c.value}] `:"";if(h===4){typeof u?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){u?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,u){const c=new p.$Tn(d,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,k)=>c.affectsConfiguration(h,o(k))})}k(d){return d.reduce((u,c)=>(u.set(c[0],c[1]),u),new Map)}}e.$tfc=t,e.$ufc=(0,C.$2h)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,12,4,6,7,41,69,42,21,47,20,27,5,17,11,14,91,303,8]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=e.$Vgc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(O){function P(N){if(N!=null)return N}O.from=P;function j(N){if(N!=null)return N}O.to=j})(a||(a={}));var t;(function(O){function P(N){if(N!=null)return N}O.from=P;function j(N){if(N!=null)return N}O.to=j})(t||(t={}));var r;(function(O){function P(N){if(N!=null)return N}O.from=P;function j(N){if(N!=null)return N}O.to=j})(r||(r={}));var d;(function(O){function P(F){if(F){const W=F;return W&&!!W.process}else return!1}O.is=P;function j(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=r.from(F.options)),W}O.from=j;function N(F){if(F!=null)return new R.$xL(F.process,F.args,F.options)}O.to=N})(d||(d={}));var u;(function(O){function P(N){if(N!=null)return N}O.from=P;function j(N){if(N!=null)return N}O.to=j})(u||(u={}));var c;(function(O){function P(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}O.is=P;function j(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=u.from(F.options)),W}O.from=j;function N(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$yL(F.commandLine,F.options):new R.$yL(F.command,F.args?F.args:[],F.options)}O.to=N})(c||(c={}));var h;(function(O){function P(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}O.is=P;function j(F){return{customExecution:"customExecution"}}O.from=j;function N(F,W){return W.get(F)}O.to=N})(h||(e.CustomExecutionDTO=h={}));var k;(function(O){function P(j,N){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===R.TaskScope.Workspace&&N&&N.workspaceFile?F=N.workspaceFile:F=n.$gG),{id:j._id,workspaceFolder:F}}O.from=P})(k||(e.TaskHandleDTO=k={}));var L;(function(O){function P(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}O.from=P})(L||(L={}));var v;(function(O){function P(F,W){if(F==null)return[];const x=[];for(const ce of F){const J=j(ce,W);J&&x.push(J)}return x}O.fromMany=P;function j(F,W){if(F==null)return;let x;F.execution instanceof R.$xL?x=d.from(F.execution):F.execution instanceof R.$yL?x=c.from(F.execution):F.execution&&F.execution instanceof R.$zL&&(x=h.from(F.execution));const ce=a.from(F.definition);let J;return F.scope?typeof F.scope=="number"?J=F.scope:J=F.scope.uri:J=R.TaskScope.Workspace,!ce||!J?void 0:{_id:F._id,definition:ce,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:J},execution:x,isBackground:F.isBackground,group:L.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=j;async function N(F,W,x){if(F==null)return;let ce;d.is(F.execution)?ce=d.to(F.execution):c.is(F.execution)?ce=c.to(F.execution):h.is(F.execution)&&(ce=h.to(F._id,x));const J=a.to(F.definition);let Y;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Y=F.source.scope:Y=await W.resolveWorkspaceFolder(D.URI.revive(F.source.scope)):Y=R.TaskScope.Workspace),!J||!Y)return;const X=new R.$AL(J,Y,F.name,F.source.label,ce,F.problemMatchers);return F.isBackground!==void 0&&(X.isBackground=F.isBackground),F.group!==void 0&&(X.group=R.$wL.from(F.group._id),X.group&&F.group.isDefault&&(X.group=new R.$wL(X.group.id,X.group.label),F.group.isDefault===!0&&(X.group.isDefault=F.group.isDefault))),F.presentationOptions&&(X.presentationOptions=t.to(F.presentationOptions)),F._id&&(X._id=F._id),F.detail&&(X.detail=F.detail),X}O.to=N})(v||(e.TaskDTO=v={}));var b;(function(O){function P(N){return N}O.from=P;function j(N){if(N)return Object.assign(Object.create(null),N)}O.to=j})(b||(b={}));class E{#e;constructor(P,j,N){this._id=j,this.a=N,this.#e=P}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(P){}fireDidEndProcess(P){}}let A=class{constructor(P,j,N,F,W,x,ce,J){this.q=new g.$Sd,this.r=new g.$Sd,this.s=new g.$Sd,this.t=new g.$Sd,this.a=P.getProxy(I.$MK.MainThreadTask),this.b=N,this.c=F,this.d=W,this.e=x,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(P,j,N){if(!N)return new R.$OK(()=>{});const F=this.w();return this.j.set(F,{type:j,provider:N,extension:P}),this.a.$registerTaskProvider(F,j),new R.$OK(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(P,j){this.a.$registerTaskSystem(P,j)}fetchTasks(P){return this.a.$fetchTasks(b.from(P)).then(async j=>{const N=[];for(const F of j){const W=await v.to(F,this.b,this.m);W&&N.push(W)}return N})}get taskExecutions(){const P=[];return this.k.forEach(j=>P.push(j)),P}terminateTask(P){if(!(P instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(P._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(P,j,N){const F=this.m.get(P.id);F&&(this.o.set(P.id,F),this.e.attachPtyToTerminal(j,await F.callback(N))),this.p=P.id,this.q.fire({execution:await this.y(P)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(P){const j=await this.y(P);this.l.delete(P.id),this.k.delete(P.id),this.A(P),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(P){const j=await this.y(P.id);this.s.fire({execution:j,processId:P.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(P){const j=await this.y(P.id);this.t.fire({execution:j,exitCode:P.exitCode})}$provideTasks(P,j){const N=this.j.get(P);if(!N)return Promise.reject(new Error("no handler found"));const F=[],W=(0,T.$Ug)(()=>N.provider.provideTasks(M.CancellationToken.None)).then(x=>this.u(j,F,N,x));return new Promise(x=>{W.then(ce=>{Promise.all(F).then(()=>{x(ce)})})})}async $resolveTask(P,j){const N=this.j.get(P);if(!N)return Promise.reject(new Error("no handler found"));if(j.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${N.type}].`);const F=await v.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await N.provider.resolveTask(F,M.CancellationToken.None);if(!W)return;this.z(W,N);const x=v.from(W,N.extension);if(!x)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(x.execution)&&await this.x(x,W,!0),await this.v(x)}w(){return this.h++}async x(P,j,N){const F=await this.a.$createTaskId(P);!N&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async y(P,j){if(typeof P=="string"){const W=this.l.get(P);if(!W)throw new o.$bb("Unexpected: The specified task is missing an execution");return W}const N=this.l.get(P.id);if(N)return N;const F=new Promise((W,x)=>{function ce(J,Y,X){X?W(new E(J,Y.id,X)):x("Unexpected: Task does not exist.")}j?ce(this,P,j):v.to(P.task,this.b,this.m).then(J=>ce(this,P,J))});return this.l.set(P.id,F),F.then(W=>(this.k.set(P.id,W),W),W=>Promise.reject(W))}z(P,j){P._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(P){this.o.get(P.id)&&this.o.delete(P.id),this.n.has(P.id)&&this.p!==P.id&&(this.m.delete(P.id),this.n.delete(P.id));const N=this.n.values();let F=N.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=N.next()}};e.$Vgc=A,e.$Vgc=A=Je([We(0,m.$QM),We(1,w.$7M),We(2,p.$rfc),We(3,$.$2M),We(4,y.$ufc),We(5,C.$Sfc),We(6,s.$jj),We(7,i.$_ec)],A);let z=class extends A{constructor(P,j,N,F,W,x,ce,J){super(P,j,N,F,W,x,ce,J),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:f.$h(0)})}async executeTask(P,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const N=v.from(j,P);if(N===void 0)throw new Error("Task is not valid");if(h.is(N.execution))await this.x(N,j,!1);else throw new o.$_;const F=await this.y(await this.a.$getTaskExecution(N),j);return this.a.$executeTask(N).catch(W=>{throw new Error(W)}),F}u(P,j,N,F){const W=[];if(F)for(const x of F){if(this.z(x,N),!x.definition||!P[x.definition.type]){const J=x.source?x.source:"No task source";this.f.warn(`The task [${J}, ${x.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=v.from(x,N.extension);ce&&h.is(ce.execution)?(W.push(ce),j.push(this.x(ce,x,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:N.extension}}async v(P){if(h.is(P.execution))return P;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(P,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(P,j,N){}};e.$Wgc=z,e.$Wgc=z=Je([We(0,m.$QM),We(1,w.$7M),We(2,p.$rfc),We(3,$.$2M),We(4,y.$ufc),We(5,C.$Sfc),We(6,s.$jj),We(7,i.$_ec)],z),e.$Xgc=(0,S.$2h)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AJ=e.$zJ=e.$yJ=void 0;function g(R){return"cellResults"in R}e.$yJ=g,e.$zJ="rawCell#";function I(R,p){let $=-1;const y=[];let M=[];return R.forEach(m=>{m.range.startLineNumber!==$&&M.length>0&&(y.push([...M]),M=[]),M.push(m),$=m.range.endLineNumber}),M.length>0&&y.push([...M]),y.map(m=>{const w=[],S=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let f=S;f<=l;f++)w.push(p.getLineContent(f));return new D.$cJ(w.join(`
`)+`
`,m.map(f=>new T.$Gs(f.range.startLineNumber-1,f.range.startColumn-1,f.range.endLineNumber-1,f.range.endColumn-1)))})}e.$AJ=I}),define(ke[360],Se([1,0,215,22,4,3,28,13,18,2,32,110,6,35,15,7,68,295,146,8,24,17,287,359,356]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,k,L,v,b,E){this.q=L,this.r=v,this.s=b,this.t=E,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new g.$Sd({onListenerError:n.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Sd({onListenerError:n.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Sd({onListenerError:n.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Sd({onListenerError:n.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$5ec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy(m.$MK.MainThreadNotebook),this.c=h.getProxy(m.$MK.MainThreadNotebookDocuments),this.d=h.getProxy(m.$MK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===13){const z=A.notebookEditor?.notebookUri,O=A.cell.handle,j=this.g.get(z)?.getCell(O);if(j)return j.apiCell}if(A&&A.$mid===14){const z=A.uri,O=this.g.get(z);if(O)return O.apiNotebook}return A}}),u.B(k)}getEditorById(h){const k=this.h.get(h);if(!k)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(h){for(const[k,L]of this.h)if(L.apiEditor===h)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,k){const L=this.g.get(h);if(!L&&!k)throw new Error(`NO notebook document for '${h}'`);return L}static u(h,k){if(!k)return;const L=k.filenamePattern.map(v=>S.NotebookExclusiveDocumentPattern.from(v)).filter(v=>v!==void 0);if(k.filenamePattern&&!L){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:k.displayName,filenamePattern:L,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,k,L){const v=u.a++,b=typeof L.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(v,L),this.b.$registerNotebookCellStatusBarItemProvider(v,b,k);let E;return b!==void 0&&(E=L.onDidChangeCellStatusBarItems(A=>this.b.$emitCellStatusBarEvent(b))),new l.$OK(()=>{this.f.delete(v),this.b.$unregisterNotebookCellStatusBarItemProvider(v,b),E?.dispose()})}async createNotebookDocument(h){const k=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return y.URI.revive(k)}async openNotebookDocument(h){const k=this.g.get(h);if(k)return k.apiNotebook;const L=await this.c.$tryOpenNotebook(h),v=this.g.get(y.URI.revive(L));return(0,$.$Pf)(v?.apiNotebook)}async showNotebookDocument(h,k){y.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let L;typeof k=="object"?L={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(S.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:L={preserveFocus:!1};const v=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,L),b=v&&this.h.get(v)?.apiEditor;if(b)return b;throw v?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,k,L,v){const b=this.f.get(h),E=y.URI.revive(k),A=this.g.get(E);if(!A||!b)return;const z=A.getCellFromIndex(L);if(!z)return;const O=await b.provideCellStatusBarItems(z.apiCell,v);if(!O)return;const P=new I.$Rc,j=this.p.add([P]),F=(Array.isArray(O)?O:[O]).map(W=>S.NotebookStatusBarItem.from(W,this.i,P));return{cacheId:j,items:F}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,k,L,v,b){if((0,p.$Ge)(k))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:k,serializer:L,options:v}),this.b.$registerNotebookSerializer(E,{id:h.identifier,location:h.extensionLocation},k,S.NotebookDocumentContentOptions.from(v),u.u(h,b)),(0,I.$Qc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(h,k,L){const v=this.x.get(h);if(!v)throw new Error("NO serializer found");const b=await v.serializer.deserializeNotebook(k.buffer,L);return new f.$Ev(S.NotebookData.from(b))}async $notebookToData(h,k,L){const v=this.x.get(h);if(!v)throw new Error("NO serializer found");const b=await v.serializer.serializeNotebook(S.NotebookData.to(k.value),L);return T.$ge.wrap(b)}async $saveNotebook(h,k,L,v,b){const E=y.URI.revive(k),A=this.x.get(h);if(!A)throw new Error("NO serializer found");const z=this.g.get(E);if(!z)throw new Error("Document NOT found");if(z.versionId!==L)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new M.$Gk((0,D.localize)(0,null,this.z(E)),6);await this.y(E,v);const O={metadata:(0,o.$pn)(z.apiNotebook.metadata,W=>!(A.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of z.apiNotebook.getCells()){const x=new l.$bM(W.kind,W.document.getText(),W.document.languageId,W.mime,A.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);x.metadata=(0,o.$pn)(W.metadata,ce=>!(A.options?.transientCellMetadata??{})[ce]),O.cells.push(x)}const P=await A.serializer.serializeNotebook(O,b);await this.s.value.writeFile(E,P);const j=this.s.getFileSystemProviderExtUri(E.scheme),N=await this.s.value.stat(E);return{name:j.basename(E),isFile:(N.type&M.FileType.File)!==0,isDirectory:(N.type&M.FileType.Directory)!==0,isSymbolicLink:(N.type&M.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((N.permissions??0)&M.FilePermission.Locked),etag:M.$Rk({mtime:N.mtime,size:N.size}),children:void 0}}async $searchInNotebooks(h,k,L,v,b){const E=this.x.get(h)?.serializer;if(!E)return{limitHit:!1,results:[]};const A=new R.$Bc;await(async(N,F,W)=>{await Promise.all(N.map(async x=>await Promise.all(x.filenamePatterns.map(ce=>{const J={...W,type:1,filePattern:ce};return this.t.doInternalFileSearchWithCustomCallback(J,F,Y=>{Y.forEach(X=>{A.has(X)||v.some(Z=>x.isFromSettings&&!Z.isFromSettings?!1:Z.filenamePatterns.some(we=>(0,d.$5cb)(we,X)))||A.add(X)})})}))))})(L,b,k);const O=new R.$Ac;let P=!1;const j=Array.from(A).map(async N=>{const F=[];try{if(b.isCancellationRequested)return;if(k.maxResults&&[...O.values()].reduce((J,Y)=>J+Y.cellResults.length,0)>k.maxResults){P=!0;return}const W=[],x=this.g.get(N);if(x)x.apiNotebook.getCells().forEach(Y=>W.push({input:Y.document.getText(),outputs:Y.outputs.flatMap(X=>X.items.map(se=>se.data.toString()))}));else{const J=await this.s.value.readFile(N),Y=T.$ge.fromString(J.toString()),X=await E.deserializeNotebook(Y.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(X).cells.forEach(Z=>W.push({input:Z.source,outputs:Z.outputs.flatMap(we=>we.items.map(de=>de.valueBytes.toString()))}))}if(b.isCancellationRequested)return;W.forEach((J,Y)=>{const X=k.contentPattern.pattern,se=new t.$4Pb(J.input,void 0,J.outputs),Z=se.findInInputs(X),we=se.findInOutputs(X),de=we.flatMap(K=>(0,r.$AJ)(K.matches,K.textBuffer)).map((K,B)=>(K.webviewIndex=B,K));if(Z.length>0||we.length>0){const K={index:Y,contentResults:(0,r.$AJ)(Z,se.inputTextBuffer),webviewResults:de};F.push(K)}});const ce={resource:N,cellResults:F};O.set(N,ce);return}catch{return}});return await Promise.all(j),{limitHit:P,results:[...O.values()]}}async y(h,k){const L=await this.s.value.stat(h);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==M.$Qk&&typeof L.mtime=="number"&&typeof L.size=="number"&&k.mtime<L.mtime&&k.etag!==M.$Rk({mtime:k.mtime,size:L.size}))throw new M.$Gk((0,D.localize)(1,null),3,k)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,k,L){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const v=new i.$ogc(k,this.d,h,L.visibleRanges.map(S.NotebookRange.to),L.selections.map(S.NotebookRange.to),typeof L.viewColumn=="number"?S.ViewColumn.to(L.viewColumn):void 0);this.h.set(k,v)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const L of h.value.removedDocuments){const v=y.URI.revive(L),b=this.g.get(v);b&&(b.dispose(),this.g.delete(v),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(b.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===v.toString()&&this.h.delete(E.id)}if(h.value.addedDocuments){const L=[];for(const v of h.value.addedDocuments){const b=y.URI.revive(v.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const E=new s.$ngc(this.c,this.q,this.r,b,v);L.push(...v.cells.map(A=>s.$mgc.asModelAddData(E.apiNotebook,A))),this.g.get(b)?.dispose(),this.g.set(b,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this.m.fire(E.apiNotebook)}}if(h.value.addedEditors)for(const L of h.value.addedEditors){if(this.h.has(L.id))return;const v=y.URI.revive(L.documentUri),b=this.g.get(v);b&&this.A(b,L.id,L)}const k=[];if(h.value.removedEditors)for(const L of h.value.removedEditors){const v=this.h.get(L);v&&(this.h.delete(L),this.k?.id===v.id&&(this.k=void 0),k.push(v))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(v=>this.h.get(v)).filter(v=>!!v);const L=new Set;this.l.forEach(v=>L.add(v.id));for(const v of this.h.values()){const b=L.has(v.id);v._acceptVisibility(b)}this.l=[...this.h.values()].map(v=>v).filter(v=>v.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const k=w.$cN.String.with("notebookType","A notebook type"),L=new w.$eN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new w.$cN("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>T.$ge.wrap(b))],new w.$dN("Notebook Data",b=>S.NotebookData.to(b.value))),v=new w.$eN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new w.$cN("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new f.$Ev(S.NotebookData.from(b)))],new w.$dN("Bytes",b=>b.buffer));h.registerApiCommand(L),h.registerApiCommand(v)}}e.$xgc=u}),define(ke[361],Se([1,0,16,21,44,34,23,38,36]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class y{constructor(m,w,S){this.k=m,this.l=w,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Ij(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Ij(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const w=this.k.folderQueries||[];return new Promise((S,l)=>{const f=s=>{this.f++,m(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=D.$nc(i);this.j&&this.j(i,n)||this.v(f,{base:s,basename:n})}),Promise.all(w.map(s=>this.p(s,f))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{l(new Error((0,g.$Mi)(s)))})})}async p(m,w){const S=new T.$3d,l=this.q(m),f=this.r(),s=new $.$qJ(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=p.$Od.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,S.token),a=n.elapsed(),t=p.$Od.create();return this.g&&!this.e||(o&&o.forEach(r=>{const d=D.$gc.relative(m.folder.path,r.path);if(i){const u=D.$nc(r.path);this.v(w,{base:m.folder,relativePath:d,basename:u});return}this.s(f,m.folder,d,w)}),this.g&&!this.e)?null:(this.u(f,s,w),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const w=(0,$.$pJ)(this.k.includePattern,m.includePattern),S=(0,$.$pJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:w,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},w,S,l){if(S===this.a){const s=D.$nc(this.a);this.v(l,{base:w,relativePath:this.a,basename:s})}function f(s){const i=D.$nc(s),n=D.$mc(s);let o=m[n];o||(o=m[n]=[],f(n)),o.push({base:w,relativePath:s,basename:i})}f(S)}u({rootEntries:m,pathToEntries:w},S,l){const f=this,s=this.a;function i(n){const o=(0,$.$sJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:d,basename:u}=r;if(S.matchesExcludesSync(d,u,s!==u?o:void 0))continue;const c=w[d];if(c)i(c);else{if(d===s)continue;f.v(l,r)}if(f.e)break}}i(m)}v(m,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(w))}}class M{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,w,S,l){const f=this.c(m.cacheKey),s=new y(m,w,f&&f.token);let i=0;const n=o=>{i+=o.length,S(o.map(a=>this.d(a)))};return this.e(s,M.a,n,l).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new T.$3d),this.b.get(m)}d(m){return m.relativePath?{resource:R.$Dg(m.base,m.relativePath)}:{resource:m.base}}e(m,w,S,l){const f=l.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),w>0&&i.length>=w&&(S(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&S(i),f.dispose(),n),n=>(i.length&&S(i),f.dispose(),Promise.reject(n)))}}e.$pgc=M}),define(ke[362],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,45,14,40,143,357,36]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=void 0;let a=class{constructor(b,E,A,z,O){this.a=b,this.b=E,this.c=A,this.d=z,this.e=O}text(b,E,A={}){b=this.f(b,A);const z=this.a.getValue(),O=E&&E.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(E?.map(s.$ki),A),type:2,contentPattern:b,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:z.search.usePCRE2||O||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(b,E){const A=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const z={...b,wordSeparators:A.editor.wordSeparators};return this.j(b,E)&&(z.isCaseSensitive=!0),this.k(b)&&(z.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),z}file(b,E={}){return{...this.h(b,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(b,E){return b?(b=Array.isArray(b)?b.map(c):c(b),E?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}h(b=[],E={}){const A=this.g(E.includePattern,E.expandPatterns),z=this.g(E.excludePattern,E.expandPatterns),O=b.length>1,P=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(F=>this.q(F,E,z)):b.map(F=>this.r(F,E,z,O))).filter(F=>!!F),j={_reason:E._reason,folderQueries:P,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:z.pattern,includePattern:A.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const F=D.$Hb(D.$Rb(this.c.groups.map(ce=>ce.editors.map(J=>J.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(ce=>(0,o.$gJ)(j,ce.fsPath)),x=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(x)),{...j,...x}}const N=E.extraFileResources&&E.extraFileResources.filter(F=>(0,o.$gJ)(j,F.fsPath));return j.extraFileResources=N&&N.length?N:void 0,j}i(b){const E=[],A=new R.$Ac,z={};let O=!1;return b.forEach(P=>{if(P.scheme===p.Schemas.walkThrough)return;if((0,y.$Hg)(P)){const N=this.b.getWorkspaceFolder(P)?.uri??P.with({path:$.$mc(P.fsPath)});let F=A.get(N);F||(O=!0,F={folder:N,includePattern:{}},E.push(F),A.set(N,F));const W=$.$lc(N.fsPath,P.fsPath);(0,C.$Pf)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else P.fsPath&&(O=!0,z[P.fsPath]=!0)}),{folderQueries:E,includePattern:z,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(b,E){if(E.isSmartCase){if(b.isRegExp){if(M.$vf(b.pattern,!0))return!0}else if(M.$vf(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,w.$LB)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const E=x=>$.$ic(x)||/^\.\.?([\/\\]|$)/.test(x),z=(Array.isArray(b)?b:d(b)).map(x=>{const ce=this.e.resolvedUserHome;return ce?(0,I.$Jv)(x,ce.scheme===p.Schemas.file?ce.fsPath:ce.path):x}),O=T.$K(z,x=>E(x)?"searchPaths":"exprSegments"),P=(O.exprSegments||[]).map(x=>M.$Qe(x,"/")).map(x=>M.$Qe(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),u(x))),j={},N=this.m(O.searchPaths||[]);N&&N.length&&(j.searchPaths=N);const F=D.$Rb(P),W=r(...F);return W&&(j.pattern=W),j}l(b,E){return E.disregardExcludeSettings?void 0:(0,o.$fJ)(b,!E.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const E=b.flatMap(z=>{let{pathPortion:O,globPortion:P}=t(z);return P&&(P=h(P)),this.n(O).flatMap(N=>this.o(N,P))}),A=new Map;return E.forEach(z=>{const O=z.searchPath.toString(),P=A.get(O);P?z.pattern&&(P.pattern=P.pattern||{},P.pattern[z.pattern]=!0):A.set(O,{searchPath:z.searchPath,pattern:z.pattern?r(z.pattern):void 0})}),Array.from(A.values())}n(b){if($.$ic(b)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==p.Schemas.file?[{searchPath:E[0].uri.with({path:b})}]:[{searchPath:m.URI.file($.$hc(b))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(b=c(b),b.startsWith("../")||b===".."){const z=$.$gc.resolve(E.path,b);return[{searchPath:E.with({path:z})}]}const A=h(b);return[{searchPath:E,pattern:A}]}else{if(b==="./"||b===".\\")return[];{const E=b.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(O=>{const P=E.match(new RegExp(`^${M.$Ke(O.name)}(?:/(.*)|$)`));return P?{match:P,folder:O}:null}).filter(C.$Mf);if(z.length)return z.map(O=>{const P=O.match[1];return{searchPath:O.folder.uri,pattern:P&&h(P)}});{const O=b.match(/\.[\/\\](.+)[\/\\]?/),P=O?O[1]:b,j=S.localize(0,null,P);throw new Error(j)}}}}o(b,E){const A=b.pattern&&E?`${b.pattern}/${E}`:b.pattern||E,z=[{searchPath:b.searchPath,pattern:A}];return A&&!A.endsWith("**")&&z.push({searchPath:b.searchPath,pattern:A+"/**"}),z}q(b,E,A){const z=this.r((0,s.$ki)(b.searchPath),E,A,!1);return z?{...z,includePattern:b.pattern}:null}r(b,E,A,z){let O;const P=m.URI.isUri(b)?b:b.uri;if(A.searchPaths){const x=A.searchPaths.filter(ce=>(0,y.$wg)(ce.searchPath,P))[0];if(x&&!x.pattern)return null;x&&(O=x.pattern)}const j=this.a.getValue({resource:P}),F={...this.l(j,E)||{},...O||{}},W=m.URI.isUri(b)?(0,y.$Ag)(b):b.name;return{folder:P,folderName:z?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!j.search.followSymlinks}}};e.$qK=a,e.$qK=a=Je([We(0,l.$vi),We(1,s.$$h),We(2,i.$QC),We(3,f.$jj),We(4,n.$oK)],a);function t(v){const b=v.match(/[\*\{\}\(\)\[\]\?]/);if(b){const E=b.index,A=v.substr(0,E).match(/[/|\\][^/\\]*$/);if(A){let z=v.substr(0,A.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:v.substr((A.index||0)+1)}}}return{pathPortion:v}}function r(...v){return v.length?v.reduce((b,E)=>(b[E]=!0,b),Object.create(null)):void 0}function d(v){return g.$Gj(v,",").map(b=>b.trim()).filter(b=>!!b.length)}function u(v){return[`**/${v}/**`,`**/${v}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(v){return v.replace(/\\/g,"/")}function h(v){return c(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(v){return v.replace(/([?*[\]])/g,"[$1]")}function L(v,b){v=D.$Mb(v,z=>z.toString());const E=[],A=b.getWorkspace();return v&&v.forEach(z=>{let O;if(b.getWorkbenchState()===2)O=(0,y.$Fg)(A.folders[0].uri,z),O&&O!=="."&&(O="./"+O);else{const P=b.getWorkspaceFolder(z);if(P){const j=P.name;if(A.folders.filter(F=>F.name===j).length===1){const F=(0,y.$Fg)(P.uri,z);F===""?O=`./${P.name}`:O=`./${P.name}/${F}`}else O=z.fsPath}}O&&E.push(k(O))}),E}e.$rK=L}),define(ke[363],Se([1,0,23,2,21,8,5,362,36,40]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$asb=e.$_rb=void 0;const M=7e3;function C(l,f){const s=f.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const c=u.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||l.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,c)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>m(l,u,t))).then(()=>{}),d=w(l,f.identifier,n,t);return Promise.all([r,d]).then(()=>{o(void 0)}),a}e.$_rb=C;async function m(l,f,s){for(const i of l.folders)if(await l.exists(D.$Dg(T.URI.revive(i),f))){s(`workspaceContains:${f}`);return}}async function w(l,f,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new g.$3d,o=l.checkExists(l.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),l.logService.info(`Not activating extension '${f.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},M);let t=!1;try{t=await o}catch(r){I.$4(r)||I.$1(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function S(l,f,s,i){const n=l.get(R.$1h),o=l.get($.$0I),t=n.createInstance(p.$qK).file(f.map(r=>(0,y.$ki)(T.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>I.$4(r)?!1:Promise.reject(r))}e.$asb=S}),define(ke[48],Se([1,0,212,16,56,23,12,3,77,2,14,6,42,293,118,41,25,145,8,26,22,272,7,64,5,27,92,20,107,72,47,4,363,117,274,17,115,38,11,116]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d,u,c,h,k,L,v,b,E,A,z,O,P,j,N,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=e.$6fc=e.$5fc=e.$4fc=void 0,e.$4fc=(0,d.$2h)("IHostUtils");let x=W=class extends p.$Sc{constructor(K,B,ne,ye,he,ge,_,ie,G,te,fe,ve){super(),this.X=ve,this.a=this.B(new b.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ne,this.f=_,this.j=ye,this.m=he,this.s=ge,this.t=G,this.u=te,this.w=fe,this.y=this.g.getProxy(C.$MK.MainThreadWorkspace),this.z=this.g.getProxy(C.$MK.MainThreadTelemetry),this.C=this.g.getProxy(C.$MK.MainThreadExtensionService),this.D=new R.$1g,this.F=new R.$1g,this.G=new R.$1g,this.H=new R.$1g,this.I=new we(this.f.extensions.activationEvents),this.L=new s.$e7b(this.I,this.f.extensions.allExtensions);const Ae=new n.$hm(this.f.extensions.myExtensions);this.J=new s.$e7b(this.I,se(this.L,Ae)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Y(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Y(this.J)}`)),this.M=new S.$Ofc(this.g,this.s),this.N=new A.$Wfc(this.g),this.O=ie,this.h=K.createChild(new k.$Zh([S.$Pfc,this.M],[A.$Xfc,this.N])),this.P=this.B(new w.$Nfc(this.J,this.L,{onExtensionActivationError:(pe,De,U)=>{this.C.$onExtensionActivationError(pe,i.$3(De),U)},actualActivateExtension:async(pe,De)=>{if(s.$e7b.isHostExtension(pe,this.J,this.L))return await this.C.$activateExtension(pe,De),new w.$Mfc;const U=this.J.getExtensionDescription(pe);return this.db(U,De)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(he=>he.identifier).filter(he=>this.isActivated(he)).map(he=>this.cb(he))}catch{}await Promise.all(K)}terminate(K,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$3g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const B=await this.C.$getExtension(K);return B&&{...B,identifier:new n.$gm(B.identifier.value),extensionLocation:y.URI.revive(B.extensionLocation)}}Z(K,B){return this.P.activateByEvent(K,B)}$(K,B){return this.P.activateById(K,B)}activateByIdWithErrors(K,B){return this.$(K,B).then(()=>{const ne=this.P.getActivatedExtension(K);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===O.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(K.fsPath);return y.URI.file(B)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new Z(K))),this.Q}async bb(K){const B=$.$8h.forUris(ne=>I.$ug.ignorePathCasing(ne));return await Promise.all(K.map(async ne=>{if(this.ub(ne)){const ye=await this.ab(ne.extensionLocation);B.set(ye,ne)}})),B}cb(K){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return B;const ne=this.P.getActivatedExtension(K);if(!ne)return B;try{typeof ne.module.deactivate=="function"&&(B=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,p.$Nc)(ne.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return B}async db(K,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,B).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,B),this.eb(K,B,"success",ye),ne},ne=>{throw this.eb(K,B,"failure"),ne})}eb(K,B,ne,ye){const he=J(K,B);this.z.$publicLog2("extensionActivationTimes",{...he,...ye||{},outcome:ne})}fb(K,B){const ne=J(K,B);this.z.$publicLog2("activatePlugin",ne);const ye=this.ub(K);if(!ye)return Promise.resolve(new w.$Lfc(w.$Ifc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${K.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const he=new w.$Jfc(B.startup);return Promise.all([this.vb(K,(0,I.$Dg)(K.extensionLocation,ye),he),this.gb(K)]).then(ge=>(g.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),W.hb(this.s,K.identifier,ge[0],ge[1],he))).then(ge=>(g.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),ge))}gb(K){const B=new a.$Rfc(K,this.M),ne=new a.$Qfc(K.identifier.value,!1,this.M),ye=new z.$Yfc(K,this.N),he=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([B.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const _=this;let ie,G;const te=(0,f.$jF)(K,"ipc")?this.f.messagePorts?.get(n.$gm.toKey(K.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ne,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(fe){return T.$jc(K.extensionLocation.fsPath,fe)},get storagePath(){return _.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return _.O.globalValue(K).fsPath},get logPath(){return T.$jc(_.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return y.URI.joinPath(_.f.logsLocation,K.identifier.value)},get storageUri(){return _.O.workspaceValue(K)},get globalStorageUri(){return _.O.globalValue(K)},get extensionMode(){return he},get extension(){return ie===void 0&&(ie=new X(_,K.identifier,K,ge,!1)),ie},get extensionRuntime(){return(0,f.$kF)(K,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!G){if(!te)return;const fe=b.Event.buffer(b.Event.fromDOMEventEmitter(te,"message",ve=>ve.data));te.start(),G={onDidReceiveMessage:fe,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(K,B,ne,ye,he){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(K,B,ne,ye,he).then(ge=>new w.$Kfc(!1,null,he.build(),ne,ge,ye.subscriptions))}static ib(K,B,ne,ye,he){if(typeof ne.activate=="function")try{he.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${B.value}`);const ge=typeof global=="object"?global:self,_=ne.activate.apply(ge,[ye]);return he.activateCallStop(),he.activateResolveStart(),Promise.resolve(_).then(ie=>(he.activateResolveStop(),ie))}catch(ge){return Promise.reject(ge)}else return Promise.resolve(ne)}jb(K,B){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:B}).then(void 0,ne=>{this.s.error(ne)})}kb(K,B=0){const ye=Date.now();(0,N.$B)(()=>{for(let he=B;he<K.length;he+=1){const ge=K[he];for(const _ of ge.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,he);break}else this.jb(ge,_)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(K=>{const B=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(B)this.kb(ne);else for(const ye of ne)if(ye.activationEvents)for(const he of ye.activationEvents)he==="onStartupFinished"&&this.jb(ye,he)})}mb(){const K=this.Z("*",!0).then(void 0,ge=>{this.s.error(ge)});this.B(this.j.onDidChangeWorkspace(ge=>this.nb(ge.added)));const B=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(B),ye=this.pb(),he=Promise.all([ye,K,ne]).then(()=>{});return Promise.race([he,(0,R.$3g)(1e4)]).then(()=>{this.lb()}),he}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(K,B))).then(()=>{})}async ob(K,B){if(this.isActivated(B.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(ge=>ge.uri),forceUsingSearch:ne||!this.c.fsExists,exists:ge=>this.c.fsExists(ge.fsPath),checkExists:(ge,_,ie)=>this.y.$checkExists(ge,_,ie)},he=await(0,E.$_rb)(ye,B);if(he)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:he.activationEvent}).then(void 0,ge=>this.s.error(ge))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:B}=this.f.environment;if(!K||!B)throw new Error(D.localize(0,null));const ne=await this.vb(null,B,new w.$Jfc(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,B.toString()));return new Promise((ye,he)=>{const ge=(G,te)=>{G?(N.$t&&this.s.error("Test runner called back with error",G),he(G)):(N.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof te=="number"&&te>0?1:0))},_=(0,I.$rg)(B),ie=ne.run(_,ge);ie&&ie.then&&ie.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{N.$t&&this.s.error("Test runner finished with error",G),he(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,B){return this.R[K]=B,(0,p.$Qc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:B}=await this.sb(K);return B?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const B=K.indexOf("+");if(B===-1)throw new t.$UK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=K.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(K,B){const ne=j.$Od.create(!1),ye=()=>`[resolveAuthority(${(0,r.$7k)(K)},${B})][${ne.elapsed()}ms] `,he=ee=>this.s.info(`${ye()}${ee}`),ge=ee=>this.s.warn(`${ye()}${ee}`),_=(ee,V=void 0)=>this.s.error(`${ye()}${ee}`,V),ie=ee=>{if(ee instanceof t.$UK)return{type:"error",error:{code:ee._code,message:ee._message,detail:ee._detail}};throw ee},G=async ee=>{he(`activating resolver for ${ee}...`);const{resolver:V,authorityPrefix:ae}=await this.sb(ee);if(!V)throw _(`no resolver for ${ae}`),new t.$UK(`No remote extension installed to resolve ${ae}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:V,authorityPrefix:ae,remoteAuthority:ee}},te=K.split(/@|%40/g).reverse();he(`activating remote resolvers ${te.join(" -> ")}`);let fe;try{fe=await Promise.all(te.map(G)).catch(async ee=>{if(!(ee instanceof t.$UK)||ee._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ee;return ge(`resolving nested authorities failed: ${ee.message}`),[await G(K)]})}catch(ee){return ie(ee)}const ve=new R.$ah;ve.cancelAndSet(()=>he("waiting..."),1e3);let Ae,pe;for(const[ee,{authorityPrefix:V,resolver:ae,remoteAuthority:ue}]of fe.entries())try{if(ee===fe.length-1)he("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${V}`),Ae=await ae.resolve(ue,{resolveAttempt:B,execServer:pe}),g.mark(`code/extHost/didResolveAuthorityOK/${V}`),he("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$TK.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(he(`invoking resolveExecServer() for ${ue}`),g.mark(`code/extHost/willResolveExecServer/${V}`),pe=await ae.resolveExecServer?.(ue,{resolveAttempt:B,execServer:pe}),!pe)throw new t.$UK(`Exec server was not available for ${ue}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${V}`)}}catch(Le){return g.mark(`code/extHost/didResolveAuthorityError/${V}`),_("returned an error",Le),ve.dispose(),ie(Le)}ve.dispose();const De={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures},U={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};he(`returned ${t.$TK.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let Q;if(t.$TK.isManagedResolvedAuthority(Ae)){const ee=B;this.X.setFactory(ee,Ae.makeConnection),Q={authority:K,connectTo:new r.$4k(ee),connectionToken:Ae.connectionToken}}else Q={authority:K,connectTo:new r.$5k(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:Q,options:U,tunnelInformation:De}}}async $getCanonicalURI(K,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$7k)(K)})`);const{resolver:ne}=await this.sb(K);if(!ne)return null;const ye=y.URI.revive(B);if(typeof ne.getCanonicalURI>"u")return ye;const he=await(0,R.$Ug)(()=>ne.getCanonicalURI(ye));return he||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:B,myExtensions:ne}=ce(this.I,this.L,this.J,K);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Y(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Y(this.J)}`)),this.rb()}$activateByEvent(K,B){return B===1?this.D.wait().then(ne=>this.Z(K,!1)):this.G.wait().then(ne=>this.Z(K,!1))}async $activate(K,B){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,B),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(ge=>ge.extensionLocation=y.URI.revive(ge.extensionLocation));const{globalRegistry:B,myExtensions:ne}=ce(this.I,this.L,this.J,K),ye=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Y(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Y(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const B=o.$ge.alloc(K),ne=Math.random()%256;for(let ye=0;ye<K;ye++)B.writeUInt8(ne,ye);return B}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$5fc=x,e.$5fc=x=W=Je([We(0,d.$1h),We(1,e.$4fc),We(2,h.$QM),We(3,l.$rfc),We(4,m.$ufc),We(5,M.$jj),We(6,u.$7M),We(7,c.$xfc),We(8,L.$9xb),We(9,v.$Sfc),We(10,P.$1fc),We(11,F.$2fc)],x);function ce(de,K,B,ne){de.addActivationEvents(ne.addActivationEvents);const ye=new s.$e7b(de,K.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const he=new n.$hm(B.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ne.myToRemove)he.delete(_);for(const _ of ne.myToAdd)he.add(_);const ge=se(ye,he);return{globalRegistry:ye,myExtensions:ge}}function J(de,K){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Y(de){return de.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$6fc=(0,d.$2h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(K,B,ne,ye,he){this.#e=K,this.#t=B,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$hc((0,I.$rg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=he}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$7fc=X;function se(de,K){return de.getAllExtensionDescriptions().filter(B=>K.has(B.identifier))}class Z{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$8fc=Z;class we{constructor(K){this.a=new n.$im,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const B of Object.keys(K))this.a.set(B,K[B])}}}),define(ke[364],Se([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;let l=class{constructor(o,a,t,r,d,u,c){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.h=u,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(f)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$dhc=l,e.$dhc=l=Je([We(2,M.$1h),We(3,I.$ufc),We(4,C.$6fc),We(5,y.$7M),We(6,m.$jj)],l);let f=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&S.a.size){const a=(0,w.$Ke)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,d]=a,u=S.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+d}c(o){return o.replace(/\\/g,"/")}};f=S=Je([We(0,y.$7M)],f);class s{constructor(o,a,t,r,d){this.c=o,this.d=a,this.e=t,this.f=r,this.g=d,this.nodeModuleName="vscode",this.a=new p.$im}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((d,u)=>r+=`	${u} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(R.$eF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$MK.MainThreadTelemetry);const r=t.getProxy(g.$MK.MainThreadWindow);this.c=(d,u)=>{const c=T.URI.parse(d);return u?this.g(d,u):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,d,{}):this.g(d,u)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,$.$QM)],i)}),define(ke[58],Se([1,0,43,3,16,50,5,69,70,48,7,41,290,42]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0,e.$9fc=(0,R.$2h)("IExtHostVariableResolverProvider");class S extends m.$RN{constructor(s,i,n,o,a,t,r){function d(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const c=o.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof M.$vM||c.input instanceof M.$AM)return c.input.modified;if(c.input instanceof M.$uM||c.input instanceof M.$zM||c.input instanceof M.$xM)return c.input.uri}}}super({getFolderUri:u=>{const c=t.folders.filter(h=>h.name===u);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,c)=>a.getConfiguration(void 0,u).get(c),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=d();if(u)return g.$hc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=d();if(u){const c=i.getWorkspaceFolder(u);if(c)return g.$hc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(I.env))}}let l=class extends T.$Sc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new D.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$0fc=l,e.$0fc=l=Je([We(0,y.$6fc),We(1,C.$rfc),We(2,p.$2M),We(3,w.$ufc),We(4,$.$Gfc)],l)}),define(ke[96],Se([1,0,12,4,2,5,6,70,48,20,7,41,140,282,42,58]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.$_fc=e.$$fc=void 0,e.$$fc=(0,I.$2h)("IExtHostDebugService");let f=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,d,u,c,h,k){this.E=d,this.F=u,this.G=c,this.H=h,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Sd,this.n=new T.$Sd,this.o=new T.$Sd,this.u=new T.$Sd,this.k=r.getProxy(R.$MK.MainThreadDebugService),this.y=new T.$Sd,this.A=new T.$Sd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.J(L)}),this.J(L)})}asDebugSourceUri(r,d){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let c=`debug:${encodeURIComponent(u.path||"")}`,h="?";return d&&(c+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),c+=`${h}ref=${u.sourceReference}`,g.URI.parse(c)}else{if(u.path)return g.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const d=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const c=u.contributes.debuggers;if(c&&c.length>0)for(const h of c)(0,w.$VF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(d=>r.push(d)),r}addBreakpoints(r){const d=r.filter(h=>{const k=h.id;return this.w.has(k)?!1:(this.w.set(k,h),!0)});this.U(d,[],[]);const u=[],c=new Map;for(const h of d)if(h instanceof M.$OL){let k=c.get(h.location.uri.toString());k||(k={type:"sourceMulti",uri:h.location.uri,lines:[]},c.set(h.location.uri.toString(),k),u.push(k)),k.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof M.$PL&&u.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const d=r.filter(k=>this.w.delete(k.id));this.U([],d,[]);const u=d.filter(k=>k instanceof M.$OL).map(k=>k.id),c=d.filter(k=>k instanceof M.$PL).map(k=>k.id),h=d.filter(k=>k instanceof M.$QL).map(k=>k.id);return this.k.$unregisterBreakpoints(u,c,h)}startDebugging(r,d,u){return this.k.$startDebugging(r?r.uri:void 0,d,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===M.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,d,u){if(!d)return new M.$OK(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:d}),this.k.$registerDebugConfigurationProvider(r,u,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,c),new M.$OK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,d,u){if(!u)return new M.$OK(()=>{});if(!this.Q(r,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:d,handle:c,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(d,c),new M.$OK(()=>{this.h=this.h.filter(h=>h.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,d){if(!d)return new M.$OK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:d}),new M.$OK(()=>{this.j=this.j.filter(c=>c.factory!==d)})}async $runInTerminal(r,d){return Promise.resolve(void 0)}async $substituteVariables(r,d){let u;const c=await this.W(r);return c&&(u={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,d)}K(r,d){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,d){const u=this,c=await this.V(d);return this.S(this.N(c.type),c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const k=this.M(h),L=this.K(k,c);if(!L)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const v=L;return this.B.set(r,v),this.R(c).then(b=>(b&&this.C.set(r,b),v.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const A=E,z={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(A.arguments.value);z.body={signature:O},v.sendResponse(z)}else throw new Error("no signer")}catch(O){z.success=!1,z.message=O.message,v.sendResponse(z)}}else b&&b.onDidSendMessage&&b.onDidSendMessage(E),E=(0,w.$1F)(E,!0),u.k.$acceptDAMessage(r,E)}),v.onError(E=>{b&&b.onError&&b.onError(E),this.k.$acceptDAError(r,E.name,E.message,E.stack)}),v.onExit(E=>{b&&b.onExit&&b.onExit(E??void 0,void 0),this.k.$acceptDAExit(r,E??void 0,void 0)}),b&&b.onWillStartSession&&b.onWillStartSession(),v.startSession()))})}$sendDAMessage(r,d){d=(0,w.$ZF)(d,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(d),this.B.get(r)?.sendMessage(d)}$stopDASession(r){const d=this.C.get(r);this.C.delete(r),d&&d.onWillStopSession&&d.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const d=[],u=[],c=[];if(r.added)for(const h of r.added){const k=h.id;if(k&&!this.w.has(k)){let L;if(h.type==="function")L=new M.$PL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")L=new M.$QL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const v=g.URI.revive(h.uri);L=new M.$OL(new M.$1K(v,new M.$PK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,M.$ML)(L,k),this.w.set(k,L),d.push(L)}}if(r.removed)for(const h of r.removed){const k=this.w.get(h);k&&(this.w.delete(h),u.push(k))}if(r.changed){for(const h of r.changed)if(h.id){const k=this.w.get(h.id);if(k){if(k instanceof M.$PL&&h.type==="function"){const L=k;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.functionName=h.functionName}else if(k instanceof M.$OL&&h.type==="source"){const L=k;L.enabled=h.enabled,L.condition=h.condition,L.hitCondition=h.hitCondition,L.logMessage=h.logMessage,L.location=new M.$1K(g.URI.revive(h.uri),new M.$PK(h.line,h.character))}c.push(k)}}}this.U(d,u,c)}async $acceptStackFrameFocus(r){let d;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?d=new M.$WL(u,r.threadId):d=new M.$VL(u,r.threadId,r.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(r,d,u){return(0,D.$Ug)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return c.provideDebugConfigurations(h,u)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,d,u,c){return(0,D.$Ug)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(d);return h.resolveDebugConfiguration(k,u,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,d,u,c){return(0,D.$Ug)(async()=>{const h=this.P(r);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(k,u,c)})}async $provideDebugAdapter(r,d){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(d);return this.S(u,c).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(r){const d=await this.V(r);this.m.fire(d)}async $acceptDebugSessionTerminated(r){const d=await this.V(r);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,d){(await this.V(r))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(r,d){const c={session:await this.V(r),event:d.event,body:d.body};this.u.fire(c)}M(r){if(r instanceof M.$RL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof M.$SL)return{type:"server",port:r.port,host:r.host};if(r instanceof M.$TL)return{type:"pipeServer",path:r.path};if(r instanceof M.$UL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const d=this.h.filter(u=>u.type===r);if(d.length>0)return d[0].factory}O(r){const d=this.h.filter(u=>u.handle===r);if(d.length>0)return d[0].factory}P(r){const d=this.f.filter(u=>u.handle===r);if(d.length>0)return d[0].provider}Q(r,d){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const c of u)if(c.label&&c.type&&c.type===d)return!0}}return!1}R(r){const u=r.configuration.type,c=this.j.filter(h=>h.type===u||h.type==="*").map(h=>(0,D.$Ug)(()=>h.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(c).then(h=>{const k=h.filter(L=>!!L);if(k.length>0)return new n(k)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(r,d){const u=d.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new M.$SL(u));if(r){const h=await this.F.getExtensionRegistry();return(0,D.$Ug)(()=>r.createDebugAdapterDescriptor(d,this.T(d,h))).then(k=>{if(k)return k})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,c))}T(r,d){}U(r,d,u){(r.length>0||d.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:d,changed:u}))}async V(r){if(r)if(typeof r=="string"){const d=this.l.get(r);if(d)return d}else{let d=this.l.get(r.id);if(!d){const u=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;d=new s(this.k,r.id,r.type,r.name,u,r.configuration,c),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(r){if(r){const d=g.URI.revive(r);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$_fc=f,e.$_fc=f=Je([We(0,y.$QM),We(1,C.$rfc),We(2,$.$6fc),We(3,S.$ufc),We(4,p.$Gfc),We(5,l.$9fc)],f);class s{constructor(r,d,u,c,h,k,L){this.d=r,this.f=d,this.g=u,this.h=c,this.i=h,this.j=k,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,d){return this.d.$customDebugAdapterRequest(this.f,r,d)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$agc=s;class i{constructor(r){this.value=Object.freeze({append(d){r.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$bgc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(d=>d.onError?d.onError(r):void 0)}onExit(r,d){this.d.forEach(u=>u.onExit?u.onExit(r,d):void 0)}}class o extends m.$qlb{constructor(r){super(),this.h=r,r.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(r,d,u,c,h,k){super(r,d,u,c,h,k)}};e.$cgc=a,e.$cgc=a=Je([We(0,y.$QM),We(1,C.$rfc),We(2,$.$6fc),We(3,S.$ufc),We(4,p.$Gfc),We(5,l.$9fc)],a)}),define(ke[365],Se([1,0,8,56,2,6,353,14,106,107,27,248,20,66,48,90]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;class f{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(p.$jj),t=n.get(m.$QM).getProxy(I.$MK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const d=D.$3(r);t.$onUnexpectedError(d)})}static async installFullHandler(n){const o=n.get(p.$jj),a=n.get(m.$QM),t=n.get(S.$6fc),r=n.get(l.$$M),d=a.getProxy(I.$MK.MainThreadExtensionService),u=a.getProxy(I.$MK.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function k(b,E){if(h.has(b))return h.get(b).stack;let A="",z,O;for(const j of E)A+=`
	at ${j.toString()}`,O=j.getFileName(),!z&&O&&(z=c.findSubstr(g.URI.file(O)));const P=`${b.name||"Error"}: ${b.message||""}${A}`;return h.set(b,{extensionIdentifier:z?.identifier,stack:P}),P}const L=Symbol("prepareStackTrace wrapped");let v=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(b){if(b===k||!b||b[L]){v=b||k;return}v=function(E,A){return k(E,A),b.call(Error,E,A)},Object.assign(v,{[L]:!0})}}),D.setUnexpectedErrorHandler(b=>{o.error(b);const E=D.$3(b),A=h.get(b);if(!A?.extensionIdentifier){u.$onUnexpectedError(E);return}d.$onExtensionRuntimeError(A.extensionIdentifier,E);const z=r.onExtensionError(A.extensionIdentifier,b);o.trace("forwarded error to extension?",z,A)})}}e.$ehc=f;class s{constructor(n,o,a,t,r){this.a=a,this.b=new R.$m7b(n,null,t),o=s.e(o,this.b);const d=new y.$Zh(...(0,$.$Kr)());d.set(M.$7M,{_serviceBrand:void 0,...o,messagePorts:r}),d.set(m.$QM,new m.$RM(this.b)),d.set(w.$ofc,new w.$pfc(t)),d.set(S.$4fc,a);const u=new C.$qq(d,!0);u.invokeFunction(f.installEarlyHandler),this.d=u.invokeFunction(c=>c.get(p.$jj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(c=>c.get(S.$6fc)),this.c.initialize(),u.invokeFunction(f.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(I.$MK.MainThreadExtensionService);return g.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>g.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$fhc=s}),define(ke[366],Se([1,0,12,11,223,242,138,96,70,48,20,47,7,58,41,283,284,42]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;let i=class extends p.$_fc{constructor(r,d,u,c,h,k,L){super(r,d,u,c,k,L),this.Z=h,this.X=new a}K(r,d){switch(r.type){case"server":return new l.$khc(r);case"pipeServer":return new l.$lhc(r);case"executable":return new l.$mhc(r,d.type)}return super.K(r,d)}T(r,d){const u=l.$mhc.platformAdapterExecutable(d.getAllExtensionDescriptions(),r.type);if(u)return new m.$RL(u.command,u.args,u.options)}L(){return new R.$_0b}async $runInTerminal(r,d){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(P=>{this.X.onTerminalClosed(P)}));const u=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),k=r.title||g.localize(0,null),L=JSON.stringify({shell:c,shellArgs:h});let v=await this.X.checkout(L,k),b,E=!1;if(v)b=r.cwd;else{const P={shellPath:c,shellArgs:h,cwd:r.cwd,name:k,iconPath:new m.$JL("debug")};E=!0,v=this.Z.createTerminalFromOptions(P,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(v,L)}v.show(!0);const A=await v.processId;E?await new Promise(P=>setTimeout(P,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?v.sendText("cls"):c.indexOf("bash")>=0?v.sendText("clear"):T.$i?v.sendText("cls"):v.sendText("clear"));const z=(0,f.$ohc)(c,r.args,!!r.argsCanBeInterpretedByShell,b,r.env);v.sendText(z);const O=this.onDidTerminateDebugSession(P=>{P.id===d&&(this.X.free(v),O.dispose())});return A}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,d)}};e.$phc=i,e.$phc=i=Je([We(0,M.$QM),We(1,S.$rfc),We(2,y.$6fc),We(3,s.$ufc),We(4,C.$Sfc),We(5,$.$Gfc),We(6,w.$9fc)],i);let n;function o(t,r){if(!n)if(T.$i)n=new I.$X9b;else if(T.$j)n=new I.$Y9b;else if(T.$k)n=new I.$Z9b;else throw new Error("external terminals not supported on this platform");const d=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,d){const c=[...this.b.entries()].map(([h,k])=>(0,D.$Pg)(async L=>{if(h.name!==d||k.lastUsedAt!==-1&&await(0,f.$nhc)(await h.processId))return null;const v=Date.now();return k.lastUsedAt+a.a>v||L.isCancellationRequested||k.config!==r?null:(k.lastUsedAt=v,h)}));return await(0,D.$7g)(c,h=>!!h)}insert(r,d){this.b.set(r,{lastUsedAt:Date.now(),config:d})}free(r){const d=this.b.get(r);d&&(d.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(ke[367],Se([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let n=class extends m.$Vgc{constructor(a,t,r,d,u,c,h,k,L){super(a,t,r,d,u,c,h,k),this.B=r,this.C=L,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(w.Schemas.file,{scheme:w.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const d=m.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(d);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(u,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=m.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const u=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),u}}u(a,t,r,d){const u=[];if(d)for(const c of d){this.z(c,r),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=m.TaskDTO.from(c,r.extension);h&&(u.push(h),m.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,c,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=T.URI.file((0,s.homedir)());t=new $.$ji({uri:r,name:f.$Ag(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=T.URI.revive(a),d={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),k=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const L of t.variables)d.variables[L]=await h.resolveAsync(k,L);if(t.process!==void 0){let L;if(t.process.path!==void 0){L=t.process.path.split(D.$tc);for(let v=0;v<L.length;v++)L[v]=await h.resolveAsync(k,L[v])}d.process=await g.win32.findExecutable(await h.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(k,t.process.cwd):void 0,L)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return g.win32.findExecutable(a,t,r)}};e.$hhc=n,e.$hhc=n=Je([We(0,M.$QM),We(1,C.$7M),We(2,I.$rfc),We(3,R.$2M),We(4,p.$ufc),We(5,y.$Sfc),We(6,S.$jj),We(7,l.$_ec),We(8,i.$9fc)],n)}),define(ke[368],Se([1,0,63,58]),function(me,e,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class g extends T.$0fc{m(){return(0,D.homedir)()}}e.$Zhc=g}),define(ke[154],Se([1,0,19,12,21,44,17,16,23,2,36]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=e.$sgc=e.$rgc=e.$qgc=void 0;class C{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new g.$3d(n);return new Promise((t,r)=>{this.a=new w(i);let d=!1;const u=(c,h)=>{if(!d&&!this.b){const k=this.h(c);l(c)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const L=this.h(c);this.c+=L,(L>0||!l(c))&&this.a.add(c,h)}};Promise.all(o.map((c,h)=>this.k(c,k=>u(k,h),a.token))).then(c=>{a.dispose(),this.a.flush();const h=c.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||h,messages:(0,D.$Rb)(c.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const h=(0,I.$Mi)(c);r(new Error(h))})})}h(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new M.$qJ(this.d,i),t=[],r={report:c=>{if(!this.l(c))return;const h=i.folder.scheme===R.Schemas.file?(0,M.$rJ)(()=>this.f.readdir($.$Cg(c.uri))):void 0,k=$.$Fg(i.folder,c.uri);if(k){const L=a.includedInQuery(k,p.$nc(k),h);(0,T.$Og)(L)?t.push(L.then(v=>{v&&n(c)})):L&&n(c)}}},d=this.n(i),u=await this.e.provideTextSearchResults(m(this.d.contentPattern),d,r,o);return t.length&&await Promise.all(t),u}l(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,M.$pJ)(this.d.includePattern,i.includePattern),o=(0,M.$pJ)(this.d.excludePattern,i.excludePattern),a={folder:y.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$qgc=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new f(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$wg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$rgc=w;function S(s){return l(s)?{preview:{matches:(0,D.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function l(s){return!!s.preview}e.$sgc=l;class f{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<f.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},f.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$tgc=f}),define(ke[97],Se([1,0,3,6,5,361,20,66,14,2,154]),function(me,e,D,T,g,I,R,p,$,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=e.$vgc=e.$ugc=void 0,e.$ugc=(0,g.$2h)("IExtHostSearch");let C=class{constructor(l,f,s){this.k=l,this.l=f,this.n=s,this.c=this.k.getProxy(T.$MK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$pgc}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,f){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const s=this.d++;return this.e.set(s,f),this.c.$registerTextSearchProvider(s,this.o(l)),(0,D.$Qc)(()=>{this.g.delete(l),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(l,f){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const s=this.d++;return this.h.set(s,f),this.c.$registerFileSearchProvider(s,this.o(l)),(0,D.$Qc)(()=>{this.i.delete(l),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(l,f,s,i){const n=m(s),o=this.h.get(l);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(l,f,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,f,s){return{messages:[]}}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,f,s,i){const n=this.e.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const o=m(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(l,f,t),i)}$enableExtensionHostSearch(){}q(l,f){return new M.$qgc(l,f,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$vgc=C,e.$vgc=C=Je([We(0,R.$QM),We(1,p.$ofc),We(2,$.$jj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(w),extraFileResources:S.extraFileResources&&S.extraFileResources.map(l=>y.URI.revive(l))}}e.$wgc=m;function w(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(ke[369],Se([1,0,21,8,4,3,17,39,2,132,191,172,79,26,32,14,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,149,316,317,318,294,319,69,70,320,48,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,152,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,47,339,340,285,341,299,72,15,7,342,66,343,93,345,346,151,41,281,114,25,94]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d,u,c,h,k,L,v,b,E,A,z,O,P,j,N,F,W,x,ce,J,Y,X,se,Z,we,de,K,B,ne,ye,he,ge,_,ie,G,te,fe,ve,Ae,pe,De,U,Q,ee,V,ae,ue,Le,je,Ke,Qe,_e,at,ot,Ie,ze,qe,Re,et,oe,le,Pe,He,Ze,it,st,Oe,wt,Dt,Ht,Ut,yt,Vt,Ft,Qt,Ot,Pt,tt,Kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;function Gt(ut){const $t=ut.get(K.$7M),jt=ut.get(de.$9ec),Bt=ut.get(Z.$wfc),kt=ut.get(X.$6fc),dt=ut.get(Qt.$rfc),At=ut.get(Re.$$M),Xt=ut.get(A.$ufc),St=ut.get(Dt.$ofc),Ye=ut.get(Le.$QM),Rt=ut.get(Ie.$Pfc),Wt=ut.get(ze.$xfc),Jt=ut.get(l.$kj),gt=ut.get(l.$jj),Mt=ut.get(it.$9xb),Me=ut.get(t.$_ec),Te=ut.get(Ft.$$gc),Ce=ut.get(Qe.$Xfc),re=ut.get(J.$Gfc),Ne=ut.get(G.$2fc);Ye.set(n.$NK.ExtHostFileSystemInfo,jt),Ye.set(n.$NK.ExtHostLogLevelServiceShape,Jt),Ye.set(n.$NK.ExtHostWorkspace,dt),Ye.set(n.$NK.ExtHostConfiguration,Xt),Ye.set(n.$NK.ExtHostExtensionService,kt),Ye.set(n.$NK.ExtHostStorage,Rt),Ye.set(n.$NK.ExtHostTunnelService,Mt),Ye.set(n.$NK.ExtHostWindow,Te),Ye.set(n.$NK.ExtHostSecretState,Ce),Ye.set(n.$NK.ExtHostTelemetry,At),Ye.set(n.$NK.ExtHostEditorTabs,re),Ye.set(n.$NK.ExtHostManagedSockets,Ne);const Ve=Ye.set(n.$NK.ExtHostDecorations,ut.get(P.$egc)),xe=Ye.set(n.$NK.ExtHostDocumentsAndEditors,ut.get(ce.$2M)),Ge=Ye.set(n.$NK.ExtHostCommands,ut.get(b.$aN)),rt=Ye.set(n.$NK.ExtHostTerminalService,ut.get(et.$Sfc)),mt=Ye.set(n.$NK.ExtHostDebugService,ut.get(O.$$fc)),zt=Ye.set(n.$NK.ExtHostSearch,ut.get(Ke.$ugc)),Et=Ye.set(n.$NK.ExtHostTask,ut.get(qe.$Xgc)),Ct=Ye.set(n.$NK.ExtHostOutputService,ut.get(Q.$Kgc)),vt=Ye.set(n.$NK.ExtHostLocalization,ut.get(ie.$1fc)),mi=Ye.set(n.$NK.ExtHostUrls,new Ht.$8gc(Ye)),Lt=Ye.set(n.$NK.ExtHostDocuments,new x.$7ec(Ye,xe)),Si=Ye.set(n.$NK.ExtHostDocumentContentProviders,new F.$ggc(Ye,xe,gt)),qi=Ye.set(n.$NK.ExtHostDocumentSaveParticipant,new W.$hgc(gt,Lt,Ye.getProxy(n.$MK.MainThreadBulkEdits))),It=Ye.set(n.$NK.ExtHostNotebook,new fe.$xgc(Ye,Ge,xe,Lt,Bt,zt)),ni=Ye.set(n.$NK.ExtHostNotebookDocuments,new Ae.$Egc(It)),$i=Ye.set(n.$NK.ExtHostNotebookEditors,new pe.$Fgc(gt,It)),ai=Ye.set(n.$NK.ExtHostNotebookKernels,new De.$Ggc(Ye,$t,It,Ge,gt)),Di=Ye.set(n.$NK.ExtHostNotebookRenderers,new U.$Igc(Ye,It)),Ci=Ye.set(n.$NK.ExtHostNotebookDocumentSaveParticipant,new ve.$Dgc(gt,It,Ye.getProxy(n.$MK.MainThreadBulkEdits))),Nt=Ye.set(n.$NK.ExtHostEditors,new le.$lfc(Ye,xe)),pi=Ye.set(n.$NK.ExtHostTreeViews,new Ze.$6gc(Ye.getProxy(n.$MK.MainThreadTreeViews),Ge,gt)),Ii=Ye.set(n.$NK.ExtHostEditorInsets,new v.$mfc(Ye.getProxy(n.$MK.MainThreadEditorInsets),Nt,$t.remote)),ci=Ye.set(n.$NK.ExtHostDiagnostics,new j.$$ec(Ye,gt,jt,xe)),li=Ye.set(n.$NK.ExtHostLanguages,new _.$Bgc(Ye,Lt,Ge.converter,St)),ht=Ye.set(n.$NK.ExtHostLanguageFeatures,new ge.$cfc(Ye,St,Lt,Ge,ci,gt,Me,At)),Vi=Ye.set(n.$NK.ExtHostFileSystem,new se.$jgc(Ye,ht)),xt=Ye.set(n.$NK.ExtHostFileSystemEventService,new we.$kgc(Ye,gt,xe)),ri=Ye.set(n.$NK.ExtHostQuickOpen,(0,ue.$Ogc)(Ye,dt,Ge)),di=Ye.set(n.$NK.ExtHostSCM,new je.$Qgc(Ye,Ge,Lt,gt)),Pi=Ye.set(n.$NK.ExtHostQuickDiff,new ae.$Ngc(Ye,St)),Hi=Ye.set(n.$NK.ExtHostShare,new _e.$Rgc(Ye,St)),Ai=Ye.set(n.$NK.ExtHostComments,(0,E.$nfc)(Ye,Ge,Lt)),bi=Ye.set(n.$NK.ExtHostProgress,new V.$Mgc(Ye.getProxy(n.$MK.MainThreadProgress))),Ki=Ye.set(n.$NK.ExtHosLabelService,new he.$Agc(Ye)),Li=Ye.set(n.$NK.ExtHostTheming,new Pe.$3gc(Ye)),ui=Ye.set(n.$NK.ExtHostAuthentication,new r.$efc(Ye)),Gi=Ye.set(n.$NK.ExtHostTimeline,new He.$5gc(Ye,Ge)),vi=Ye.set(n.$NK.ExtHostWebviews,new Ut.$Bfc(Ye,$t.remote,dt,gt,Me)),Ri=Ye.set(n.$NK.ExtHostWebviewPanels,new yt.$Efc(Ye,vi,dt)),cn=Ye.set(n.$NK.ExtHostCustomEditors,new z.$Ffc(Ye,Lt,Wt,vi,Ri)),Mi=Ye.set(n.$NK.ExtHostWebviewViews,new Vt.$9gc(Ye,vi)),si=Ye.set(n.$NK.ExtHostTesting,new oe.$Ygc(Ye,Ge,xe)),ln=Ye.set(n.$NK.ExtHostUriOpeners,new wt.$7gc(Ye)),un=Ye.set(n.$NK.ExtHostProfileContentHandlers,new ee.$Lgc(Ye));Ye.set(n.$NK.ExtHostInteractive,new ne.$ygc(Ye,It,xe,Ge,gt));const Ji=Ye.set(n.$NK.ExtHostInlineChat,new B.$lgc(Ye,Ge,Lt,gt)),fi=Ye.set(n.$NK.ExtHostChatProvider,new h.$hfc(Ye,gt)),Qi=Ye.set(n.$NK.ExtHostChatAgents2,new c.$ifc(Ye,fi,gt)),Yi=Ye.set(n.$NK.ExtHostChatVariables,new k.$jfc(Ye)),gi=Ye.set(n.$NK.ExtHostChat,new u.$gfc(Ye)),Zi=Ye.set(n.$NK.ExtHostAiRelatedInformation,new o.$6ec(Ye)),Fi=Ye.set(n.$NK.ExtHostAiEmbeddingVector,new Y.$igc(Ye)),Ni=Ye.set(n.$NK.ExtHostIssueReporter,new ye.$zgc(Ye)),_t=Ye.set(n.$NK.ExtHostStatusBar,new ot.$Ugc(Ye,Ge.converter)),wi=Ye.set(n.$NK.ExtHostSpeech,new at.$Sgc(Ye)),hn=Object.values(n.$NK);Ye.assertRegistered(hn);const Yt=new d.$ffc(Ye,xe),yi=new L.$kfc(Ye),Ei=new te.$Cgc(Ye,gt),Ti=new N.$fgc(Ye);return a.$dfc.register(Ge),function(Be,ei,Xi){const pt=function(){let $e=!Be.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${Be.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Ee();else{const bt=ct;typeof bt.scheme>"u"&&Ee(),typeof bt.exclusive=="boolean"&&(0,tt.$kF)(Be,"documentFiltersExclusive")}return ct}}(),xi={getSession($e,Ee,Ue){return ui.getSession(Be,$e,Ee,Ue)},getSessions($e,Ee){return(0,tt.$kF)(Be,"authGetSessions"),ui.getSessions(Be,$e,Ee)},async hasSession($e,Ee){return(0,tt.$kF)(Be,"authSession"),!!await ui.getSession(Be,$e,Ee,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider($e,Ee,Ue,ct){return ui.registerAuthenticationProvider($e,Ee,Ue,ct)}},dn={registerCommand($e,Ee,Ue){return Ge.registerCommand(!0,$e,Ee,Ue,void 0,Be)},registerTextEditorCommand($e,Ee,Ue){return Ge.registerCommand(!0,$e,(...ct)=>{const bt=Nt.getActiveTextEditor();if(!bt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return bt.edit(Tt=>{Ee.apply(Ue,[bt,Tt,...ct])}).then(Tt=>{Tt||gt.warn("Edits from command "+$e+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+$e,Tt)})},void 0,void 0,Be)},registerDiffInformationCommand:($e,Ee,Ue)=>((0,tt.$kF)(Be,"diffCommand"),Ge.registerCommand(!0,$e,async(...ct)=>{const bt=xe.activeEditor(!0);if(!bt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Tt=await Nt.getDiffInformation(bt.id);Ee.apply(Ue,[Tt,...ct])},void 0,void 0,Be)),executeCommand($e,...Ee){return Ge.executeCommand($e,...Ee)},getCommands($e=!1){return Ge.getCommands($e)}},_i={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return rt.getDefaultShell(!1)},get onDidChangeShell(){return rt.onDidChangeShell},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$kF)(Be,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$kF)(Be,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Re.$0M)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return Re.$9M.validateSender($e),At.instantiateLogger(Be,$e,Ee)},openExternal($e,Ee){return Te.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return mi.createAppUri($e);try{return await Te.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,R.$ag)($e,R.Schemas.http)||(0,R.$ag)($e,R.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,f.$9k)($t.remote.authority)},get remoteAuthority(){return(0,tt.$kF)(Be,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel},registerIssueUriRequestHandler($e){return(0,tt.$kF)(Be,"handleIssueUri"),Ni.registerIssueUriRequestHandler(Be,$e)},registerIssueDataProvider($e){return(0,tt.$kF)(Be,"handleIssueUri"),Ni.registerIssueDataProvider(Be,$e)},get appQuality(){return(0,tt.$kF)(Be,"resolvers"),$t.quality},get appCommit(){return(0,tt.$kF)(Be,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController($e,Ee,Ue){return si.createTestController(Be,$e,Ee,Ue)},createTestObserver(){return(0,tt.$kF)(Be,"testObserver"),si.createTestObserver()},runTests($e){return(0,tt.$kF)(Be,"testObserver"),si.runTests($e)},get onDidChangeTestResults(){return(0,tt.$kF)(Be,"testObserver"),si.onResultsChanged},get testResults(){return(0,tt.$kF)(Be,"testObserver"),si.results}},hi=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,tn={getExtension($e,Ee){(0,tt.$jF)(Be,"extensionsAny")||(Ee=!1);const Ue=ei.mine.getExtensionDescription($e);if(Ue)return new X.$7fc(kt,Be.identifier,Ue,hi,!1);if(Ee){const ct=ei.all.getExtensionDescription($e);if(ct)return new X.$7fc(kt,Be.identifier,ct,hi,!0)}},get all(){const $e=[];for(const Ee of ei.mine.getAllExtensionDescriptions())$e.push(new X.$7fc(kt,Be.identifier,Ee,hi,!1));return $e},get allAcrossExtensionHosts(){(0,tt.$kF)(Be,"extensionsAny");const $e=new w.$hm(ei.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ei.all.getAllExtensionDescriptions()){const ct=!$e.has(Ue.identifier);Ee.push(new X.$7fc(kt,Be.identifier,Ue,hi,ct))}return Ee},get onDidChange(){return(0,tt.$jF)(Be,"extensionsAny")?g.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection($e){return ci.createDiagnosticCollection(Be.identifier,$e)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:$e=>ci.getDiagnostics($e),getLanguages(){return li.getLanguages()},setTextDocumentLanguage($e,Ee){return li.changeLanguage($e.uri,Ee)},match($e,Ee){const Ue=Lt.getDocumentData(Ee.uri)?.notebook;return(0,M.$nt)(st.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider($e,Ee,Ue){return ht.registerCodeActionProvider(Be,pt($e),Ee,Ue)},registerDocumentPasteEditProvider($e,Ee,Ue){return(0,tt.$kF)(Be,"documentPaste"),ht.registerDocumentPasteEditProvider(Be,pt($e),Ee,Ue)},registerCodeLensProvider($e,Ee){return ht.registerCodeLensProvider(Be,pt($e),Ee)},registerDefinitionProvider($e,Ee){return ht.registerDefinitionProvider(Be,pt($e),Ee)},registerDeclarationProvider($e,Ee){return ht.registerDeclarationProvider(Be,pt($e),Ee)},registerImplementationProvider($e,Ee){return ht.registerImplementationProvider(Be,pt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return ht.registerTypeDefinitionProvider(Be,pt($e),Ee)},registerHoverProvider($e,Ee){return ht.registerHoverProvider(Be,pt($e),Ee,Be.identifier)},registerEvaluatableExpressionProvider($e,Ee){return ht.registerEvaluatableExpressionProvider(Be,pt($e),Ee,Be.identifier)},registerInlineValuesProvider($e,Ee){return ht.registerInlineValuesProvider(Be,pt($e),Ee,Be.identifier)},registerDocumentHighlightProvider($e,Ee){return ht.registerDocumentHighlightProvider(Be,pt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return ht.registerMultiDocumentHighlightProvider(Be,pt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return ht.registerLinkedEditingRangeProvider(Be,pt($e),Ee)},registerReferenceProvider($e,Ee){return ht.registerReferenceProvider(Be,pt($e),Ee)},registerRenameProvider($e,Ee){return ht.registerRenameProvider(Be,pt($e),Ee)},registerDocumentSymbolProvider($e,Ee,Ue){return ht.registerDocumentSymbolProvider(Be,pt($e),Ee,Ue)},registerWorkspaceSymbolProvider($e){return ht.registerWorkspaceSymbolProvider(Be,$e)},registerDocumentFormattingEditProvider($e,Ee){return ht.registerDocumentFormattingEditProvider(Be,pt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return ht.registerDocumentRangeFormattingEditProvider(Be,pt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,Ue,...ct){return ht.registerOnTypeFormattingEditProvider(Be,pt($e),Ee,[Ue].concat(ct))},registerDocumentSemanticTokensProvider($e,Ee,Ue){return ht.registerDocumentSemanticTokensProvider(Be,pt($e),Ee,Ue)},registerDocumentRangeSemanticTokensProvider($e,Ee,Ue){return ht.registerDocumentRangeSemanticTokensProvider(Be,pt($e),Ee,Ue)},registerSignatureHelpProvider($e,Ee,Ue,...ct){return typeof Ue=="object"?ht.registerSignatureHelpProvider(Be,pt($e),Ee,Ue):ht.registerSignatureHelpProvider(Be,pt($e),Ee,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider($e,Ee,...Ue){return ht.registerCompletionItemProvider(Be,pt($e),Ee,Ue)},registerInlineCompletionItemProvider($e,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,tt.$kF)(Be,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,tt.$kF)(Be,"inlineCompletionsAdditions"),Ue&&(0,tt.$kF)(Be,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Be,pt($e),Ee,Ue)},registerDocumentLinkProvider($e,Ee){return ht.registerDocumentLinkProvider(Be,pt($e),Ee)},registerColorProvider($e,Ee){return ht.registerColorProvider(Be,pt($e),Ee)},registerFoldingRangeProvider($e,Ee){return ht.registerFoldingRangeProvider(Be,pt($e),Ee)},registerSelectionRangeProvider($e,Ee){return ht.registerSelectionRangeProvider(Be,$e,Ee)},registerCallHierarchyProvider($e,Ee){return ht.registerCallHierarchyProvider(Be,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return ht.registerTypeHierarchyProvider(Be,$e,Ee)},setLanguageConfiguration:($e,Ee)=>ht.setLanguageConfiguration(Be,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,tt.$kF)(Be,"tokenInformation"),li.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return ht.registerInlayHintsProvider(Be,$e,Ee)},createLanguageStatusItem($e,Ee){return li.createLanguageStatusItem(Be,$e,Ee)},registerDocumentDropEditProvider($e,Ee,Ue){return ht.registerDocumentOnDropEditProvider(Be,$e,Ee,(0,tt.$jF)(Be,"dropMetadata")?Ue:void 0)}},rn={get activeTextEditor(){return Nt.getActiveTextEditor()},get visibleTextEditors(){return Nt.getVisibleTextEditors()},get activeTerminal(){return rt.activeTerminal},get terminals(){return rt.terminals},async showTextDocument($e,Ee,Ue){const ct=await($.URI.isUri($e)?Promise.resolve(sn.openTextDocument($e)):Promise.resolve($e));return Nt.showTextDocument(ct,Ee,Ue)},createTextEditorDecorationType($e){return Nt.createTextEditorDecorationType(Be,$e)},onDidChangeActiveTextEditor($e,Ee,Ue){return Nt.onDidChangeActiveTextEditor($e,Ee,Ue)},onDidChangeVisibleTextEditors($e,Ee,Ue){return Nt.onDidChangeVisibleTextEditors($e,Ee,Ue)},onDidChangeTextEditorSelection($e,Ee,Ue){return Nt.onDidChangeTextEditorSelection($e,Ee,Ue)},onDidChangeTextEditorOptions($e,Ee,Ue){return Nt.onDidChangeTextEditorOptions($e,Ee,Ue)},onDidChangeTextEditorVisibleRanges($e,Ee,Ue){return Nt.onDidChangeTextEditorVisibleRanges($e,Ee,Ue)},onDidChangeTextEditorViewColumn($e,Ee,Ue){return Nt.onDidChangeTextEditorViewColumn($e,Ee,Ue)},onDidCloseTerminal($e,Ee,Ue){return rt.onDidCloseTerminal($e,Ee,Ue)},onDidOpenTerminal($e,Ee,Ue){return rt.onDidOpenTerminal($e,Ee,Ue)},onDidChangeActiveTerminal($e,Ee,Ue){return rt.onDidChangeActiveTerminal($e,Ee,Ue)},onDidChangeTerminalDimensions($e,Ee,Ue){return(0,tt.$kF)(Be,"terminalDimensions"),rt.onDidChangeTerminalDimensions($e,Ee,Ue)},onDidChangeTerminalState($e,Ee,Ue){return rt.onDidChangeTerminalState($e,Ee,Ue)},onDidWriteTerminalData($e,Ee,Ue){return(0,tt.$kF)(Be,"terminalDataWriteEvent"),rt.onDidWriteTerminalData($e,Ee,Ue)},onDidExecuteTerminalCommand($e,Ee,Ue){return(0,tt.$kF)(Be,"terminalExecuteCommandEvent"),rt.onDidExecuteTerminalCommand($e,Ee,Ue)},get state(){return Te.getState(Be)},onDidChangeWindowState($e,Ee,Ue){return Te.onDidChangeWindowState($e,Ee,Ue)},showInformationMessage($e,...Ee){return Ei.showMessage(Be,p.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return Ei.showMessage(Be,p.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return Ei.showMessage(Be,p.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,Ue){return ri.showQuickPick(Be,$e,Ee,Ue)},showWorkspaceFolderPick($e){return ri.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return ri.showInput($e,Ee)},showOpenDialog($e){return Ti.showOpenDialog(Be,$e)},showSaveDialog($e){return Ti.showSaveDialog($e)},createStatusBarItem($e,Ee,Ue){let ct,bt,Tt;return typeof $e=="string"?(ct=$e,bt=Ee,Tt=Ue):(bt=$e,Tt=Ee),_t.createStatusBarEntry(Be,ct,bt,Tt)},setStatusBarMessage($e,Ee){return _t.setStatusBarMessage($e,Ee)},withScmProgress($e){return Me.report("window.withScmProgress",Be,"Use 'withProgress' instead."),bi.withProgress(Be,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>$e({report(ct){}}))},withProgress($e,Ee){return bi.withProgress(Be,$e,Ee)},createOutputChannel($e,Ee){return Ct.createOutputChannel($e,Ee,Be)},createWebviewPanel($e,Ee,Ue,ct){return Ri.createWebviewPanel(Be,$e,Ee,Ue,ct)},createWebviewTextEditorInset($e,Ee,Ue,ct){return(0,tt.$kF)(Be,"editorInsets"),Ii.createWebviewEditorInset($e,Ee,Ue,ct,Be)},createTerminal($e,Ee,Ue){return typeof $e=="object"?"pty"in $e?rt.createExtensionTerminal($e):rt.createTerminalFromOptions($e):rt.createTerminal($e,Ee,Ue)},registerTerminalLinkProvider($e){return rt.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return rt.registerProfileProvider(Be,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,tt.$kF)(Be,"terminalQuickFixProvider"),rt.registerTerminalQuickFixProvider($e,Be.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return pi.registerTreeDataProvider($e,Ee,Be)},createTreeView($e,Ee){return pi.createTreeView($e,Ee,Be)},registerWebviewPanelSerializer:($e,Ee)=>Ri.registerWebviewPanelSerializer(Be,$e,Ee),registerCustomEditorProvider:($e,Ee,Ue={})=>cn.registerCustomEditorProvider(Be,$e,Ee,Ue),registerFileDecorationProvider($e){return Ve.registerFileDecorationProvider($e,Be)},registerUriHandler($e){return mi.registerUriHandler(Be,$e)},createQuickPick(){return ri.createQuickPick(Be)},createInputBox(){return ri.createInputBox(Be)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,Ue){return Li.onDidChangeActiveColorTheme($e,Ee,Ue)},registerWebviewViewProvider($e,Ee,Ue){return Mi.registerWebviewViewProvider(Be,$e,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return It.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,Ue){return It.onDidChangeActiveNotebookEditor($e,Ee,Ue)},get visibleNotebookEditors(){return It.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return It.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection($e,Ee,Ue){return $i.onDidChangeNotebookEditorSelection($e,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges($e,Ee,Ue){return $i.onDidChangeNotebookEditorVisibleRanges($e,Ee,Ue)},showNotebookDocument($e,Ee){return It.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,Ue){return(0,tt.$kF)(Be,"externalUriOpener"),ln.registerExternalUriOpener(Be.identifier,$e,Ee,Ue)},registerProfileContentHandler($e,Ee){return(0,tt.$kF)(Be,"profileContentHandlers"),un.registrProfileContentHandler(Be,$e,Ee)},registerQuickDiffProvider($e,Ee,Ue,ct){return(0,tt.$kF)(Be,"quickDiffProvider"),Pi.registerQuickDiffProvider(pt($e),Ee,Ue,ct)},get tabGroups(){return re.tabGroups},registerShareProvider($e,Ee){return(0,tt.$kF)(Be,"shareProvider"),Hi.registerShareProvider(pt($e),Ee)}},sn={get rootPath(){return Me.report("workspace.rootPath",Be,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath($e){throw new T.$9("rootPath")},getWorkspaceFolder($e){return dt.getWorkspaceFolder($e)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name($e){throw new T.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile($e){throw new T.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...Ue)=>dt.updateWorkspaceFolders(Be,$e,Ee||0,...Ue),onDidChangeWorkspaceFolders:function($e,Ee,Ue){return dt.onDidChangeWorkspace($e,Ee,Ue)},asRelativePath:($e,Ee)=>dt.getRelativePath($e,Ee),findFiles:($e,Ee,Ue,ct)=>dt.findFiles($e,Ee,Ue,Be.identifier,ct),findTextInFiles:($e,Ee,Ue,ct)=>{(0,tt.$kF)(Be,"findTextInFiles");let bt,Tt;return typeof Ee=="object"?(bt=Ee,Tt=Ue):(bt={},Tt=Ee,ct=Ue),dt.findTextInFiles($e,bt||{},Tt,Be.identifier,ct)},save:$e=>((0,tt.$kF)(Be,"saveEditor"),dt.save($e)),saveAs:$e=>((0,tt.$kF)(Be,"saveEditor"),dt.saveAs($e)),saveAll:$e=>dt.saveAll($e),applyEdit($e,Ee){return Yt.applyWorkspaceEdit($e,Be,Ee)},createFileSystemWatcher:($e,Ee,Ue,ct)=>{let bt;return typeof Ee=="boolean"?bt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,tt.$kF)(Be,"createFileSystemWatcher"),bt={...Ee,correlate:!0}),xt.createFileSystemWatcher(dt,Be,$e,bt)},get textDocuments(){return Lt.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new T.$9("textDocuments")},openTextDocument($e){let Ee;const Ue=$e;if(typeof $e=="string")Ee=Promise.resolve($.URI.file($e));else if($.URI.isUri($e))Ee=Promise.resolve($e);else if(!Ue||typeof Ue=="object")Ee=Lt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>Lt.ensureDocumentData(ct).then(bt=>bt.document))},onDidOpenTextDocument:($e,Ee,Ue)=>Lt.onDidAddDocument($e,Ee,Ue),onDidCloseTextDocument:($e,Ee,Ue)=>Lt.onDidRemoveDocument($e,Ee,Ue),onDidChangeTextDocument:($e,Ee,Ue)=>Lt.onDidChangeDocument($e,Ee,Ue),onDidSaveTextDocument:($e,Ee,Ue)=>Lt.onDidSaveDocument($e,Ee,Ue),onWillSaveTextDocument:($e,Ee,Ue)=>qi.getOnWillSaveTextDocumentEvent(Be)($e,Ee,Ue),get notebookDocuments(){return It.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let Ue;if($.URI.isUri($e))Ue=$e,await It.openNotebookDocument($e);else if(typeof $e=="string")Ue=$.URI.revive(await It.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return It.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument($e,Ee,Ue){return ni.onDidSaveNotebookDocument($e,Ee,Ue)},onDidChangeNotebookDocument($e,Ee,Ue){return ni.onDidChangeNotebookDocument($e,Ee,Ue)},onWillSaveNotebookDocument($e,Ee,Ue){return Ci.getOnWillSaveNotebookDocumentEvent(Be)($e,Ee,Ue)},get onDidOpenNotebookDocument(){return It.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return It.onDidCloseNotebookDocument},registerNotebookSerializer($e,Ee,Ue,ct){return It.registerNotebookSerializer(Be,$e,Ee,Ue,(0,tt.$jF)(Be,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:($e,Ee,Ue)=>Xi.onDidChangeConfiguration($e,Ee,Ue),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,Xi.getConfiguration($e,Ee,Be)},registerTextDocumentContentProvider($e,Ee){return Si.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(Me.report("window.registerTaskProvider",Be,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Be,$e,Ee)),registerFileSystemProvider($e,Ee,Ue){return(0,I.$Pc)(Vi.registerFileSystemProvider(Be,$e,Ee,Ue),Bt.addFileSystemProvider($e,Ee,Ue))},get fs(){return Bt.value},registerFileSearchProvider:($e,Ee)=>((0,tt.$kF)(Be,"fileSearchProvider"),zt.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,tt.$kF)(Be,"textSearchProvider"),zt.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,tt.$kF)(Be,"resolvers"),kt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,tt.$kF)(Be,"resolvers"),Ki.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,tt.$kF)(Be,"resolvers"),kt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,Ue)=>xt.onDidCreateFile($e,Ee,Ue),onDidDeleteFiles:($e,Ee,Ue)=>xt.onDidDeleteFile($e,Ee,Ue),onDidRenameFiles:($e,Ee,Ue)=>xt.onDidRenameFile($e,Ee,Ue),onWillCreateFiles:($e,Ee,Ue)=>xt.getOnWillCreateFileEvent(Be)($e,Ee,Ue),onWillDeleteFiles:($e,Ee,Ue)=>xt.getOnWillDeleteFileEvent(Be)($e,Ee,Ue),onWillRenameFiles:($e,Ee,Ue)=>xt.getOnWillRenameFileEvent(Be)($e,Ee,Ue),openTunnel:$e=>((0,tt.$kF)(Be,"tunnels"),Mt.openTunnel(Be,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,tt.$kF)(Be,"tunnels"),Mt.getTunnels()},onDidChangeTunnels:($e,Ee,Ue)=>((0,tt.$kF)(Be,"tunnels"),Mt.onDidChangeTunnels($e,Ee,Ue)),registerPortAttributesProvider:($e,Ee)=>((0,tt.$kF)(Be,"portsAttributes"),Mt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,tt.$kF)(Be,"tunnelFactory"),Mt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,tt.$kF)(Be,"timeline"),Gi.registerTimelineProvider($e,Ee,Be.identifier,Ge.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:$e=>((0,tt.$kF)(Be,"workspaceTrust"),dt.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,Ue)=>dt.onDidGrantWorkspaceTrust($e,Ee,Ue),registerEditSessionIdentityProvider:($e,Ee)=>((0,tt.$kF)(Be,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,Ue)=>((0,tt.$kF)(Be,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Be)($e,Ee,Ue)),registerCanonicalUriProvider:($e,Ee)=>((0,tt.$kF)(Be,"canonicalUriProvider"),dt.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,Ue)=>((0,tt.$kF)(Be,"canonicalUriProvider"),dt.provideCanonicalUri($e,Ee,Ue))},fn={get inputBox(){return Me.report("scm.inputBox",Be,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Be)},createSourceControl($e,Ee,Ue){return di.createSourceControl(Be,$e,Ee,Ue)},registerSourceControlInputBoxValueProvider($e,Ee){return(0,tt.$kF)(Be,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Be,$e,Ee)}},on={createCommentController($e,Ee){return Ai.createCommentController(Be,$e,Ee)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession($e,Ee,Ue){return mt.onDidStartDebugSession($e,Ee,Ue)},onDidTerminateDebugSession($e,Ee,Ue){return mt.onDidTerminateDebugSession($e,Ee,Ue)},onDidChangeActiveDebugSession($e,Ee,Ue){return mt.onDidChangeActiveDebugSession($e,Ee,Ue)},onDidReceiveDebugSessionCustomEvent($e,Ee,Ue){return mt.onDidReceiveDebugSessionCustomEvent($e,Ee,Ue)},onDidChangeBreakpoints($e,Ee,Ue){return mt.onDidChangeBreakpoints($e,Ee,Ue)},onDidChangeStackFrameFocus($e,Ee,Ue){return(0,tt.$kF)(Be,"debugFocus"),mt.onDidChangeStackFrameFocus($e,Ee,Ue)},registerDebugConfigurationProvider($e,Ee,Ue){return mt.registerDebugConfigurationProvider($e,Ee,Ue||Ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return mt.registerDebugAdapterDescriptorFactory(Be,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return mt.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?mt.startDebugging($e,Ee,{parentSession:Ue}):mt.startDebugging($e,Ee,Ue||{})},stopDebugging($e){return mt.stopDebugging($e)},addBreakpoints($e){return mt.addBreakpoints($e)},removeBreakpoints($e){return mt.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return mt.asDebugSourceUri($e,Ee)}},Oi={registerTaskProvider:($e,Ee)=>Et.registerTaskProvider(Be,$e,Ee),fetchTasks:$e=>Et.fetchTasks($e),executeTask:$e=>Et.executeTask(Be,$e),get taskExecutions(){return Et.taskExecutions},onDidStartTask:($e,Ee,Ue)=>Et.onDidStartTask($e,Ee,Ue),onDidEndTask:($e,Ee,Ue)=>Et.onDidEndTask($e,Ee,Ue),onDidStartTaskProcess:($e,Ee,Ue)=>Et.onDidStartTaskProcess($e,Ee,Ue),onDidEndTaskProcess:($e,Ee,Ue)=>Et.onDidEndTaskProcess($e,Ee,Ue)},ji={createNotebookController($e,Ee,Ue,ct,bt){return ai.createNotebookController(Be,$e,Ee,Ue,ct,(0,tt.$jF)(Be,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>It.registerNotebookCellStatusBarItemProvider(Be,$e,Ee),createRendererMessaging($e){return Di.createRendererMessaging(Be,$e)},createNotebookControllerDetectionTask($e){return(0,tt.$kF)(Be,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Be,$e)},registerKernelSourceActionProvider($e,Ee){return(0,tt.$kF)(Be,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Be,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,Ue){return(0,tt.$kF)(Be,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState($e,Ee,Ue)}},zi={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),Ue=!$e||typeof $e[0]!="object"?$e:$e[0];return vt.getMessage(Be.identifier.value,{message:Ee,args:Ue})}return vt.getMessage(Be.identifier.value,$e[0])},get bundle(){return vt.getBundle(Be.identifier.value)},get uri(){return vt.getBundleUri(Be.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,tt.$kF)(Be,"interactive"),Ji.registerProvider(Be,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,tt.$kF)(Be,"interactive"),gi.registerChatProvider(Be,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,tt.$kF)(Be,"interactive"),gi.sendInteractiveRequestToProvider($e,Ee)},get onDidPerformUserAction(){return(0,tt.$kF)(Be,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession($e,Ee){return(0,tt.$kF)(Be,"interactive"),gi.transferChatSession($e,Ee)}},Ui={getRelatedInformation($e,Ee){return(0,tt.$kF)(Be,"aiRelatedInformation"),Zi.getRelatedInformation(Be,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,tt.$kF)(Be,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Be,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,tt.$kF)(Be,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Be,$e,Ee)}},gn={registerChatResponseProvider($e,Ee,Ue){return(0,tt.$kF)(Be,"chatProvider"),fi.registerProvider(Be.identifier,$e,Ee,Ue)},requestChatAccess($e){return(0,tt.$kF)(Be,"chatRequestAccess"),fi.requestChatResponseProvider(Be.identifier,$e)},registerVariable($e,Ee,Ue){return(0,tt.$kF)(Be,"chatVariables"),Yi.registerVariableResolver(Be,$e,Ee,Ue)},registerMappedEditsProvider($e,Ee){return(0,tt.$kF)(Be,"mappedEditsProvider"),ht.registerMappedEditsProvider(Be,$e,Ee)},createChatAgent($e,Ee){return(0,tt.$kF)(Be,"chatAgents2"),Qi.createChatAgent(Be,$e,Ee)}},mn={registerSpeechProvider($e,Ee){return(0,tt.$kF)(Be,"speech"),wi.registerProvider(Be.identifier,$e,Ee)}};return{version:$t.version,ai:Ui,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:ki,l10n:zi,languages:nn,notebooks:ji,scm:fn,speech:mn,tasks:Oi,tests:en,window:rn,workspace:sn,Breakpoint:Oe.$NL,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$FM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$EM,CallHierarchyIncomingCall:Oe.$aL,CallHierarchyItem:Oe.$_K,CallHierarchyOutgoingCall:Oe.$bL,CancellationError:T.$5,CancellationTokenSource:D.$3d,CandidatePortSource:n.CandidatePortSource,CodeAction:Oe.$9K,CodeActionKind:Oe.$0K,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$cL,Color:Oe.$pL,ColorInformation:Oe.$qL,ColorPresentation:Oe.$rL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$jL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$kL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$zL,DebugAdapterExecutable:Oe.$RL,DebugAdapterInlineImplementation:Oe.$UL,DebugAdapterNamedPipeServer:Oe.$TL,DebugAdapterServer:Oe.$SL,DebugConfigurationProviderTriggerKind:Ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$3K,DiagnosticRelatedInformation:Oe.$2K,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$OK,DocumentHighlight:Oe.$5K,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$6K,DocumentLink:Oe.$oL,DocumentSymbol:Oe.$8K,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$XL,InlineValueText:Oe.$YL,InlineValueVariableLookup:Oe.$ZL,InlineValueEvaluatableExpression:Oe.$1L,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:g.$Sd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$$L,FileDecoration2:Oe.$$L,FileSystemError:Oe.$3L,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$4L,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$PL,InlineCompletionItem:Oe.$lL,InlineCompletionList:Oe.$mL,Hover:Oe.$4K,IndentAction:C.IndentAction,Location:Oe.$1K,MarkdownString:Oe.$dL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:Oe.$eL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$PK,ProcessExecution:Oe.$xL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$0L,Range:Oe.$QK,RelativePattern:Oe.$LL,Selection:Oe.$RK,SelectionRange:Oe.$$K,SemanticTokens:Oe.$7L,SemanticTokensBuilder:Oe.$6L,SemanticTokensEdit:Oe.$8L,SemanticTokensEdits:Oe.$9L,SemanticTokensLegend:Oe.$5L,ShellExecution:Oe.$yL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$gL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$fL,SnippetString:Oe.$ZK,SourceBreakpoint:Oe.$OL,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$7K,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$AL,TaskGroup:Oe.$wL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$sL,TerminalQuickFixTerminalCommand:Oe.$uL,TerminalQuickFixOpener:Oe.$tL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$vL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$VK,SnippetTextEdit:Oe.$XK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$KL,ThemeIcon:Oe.$JL,TreeItem:Oe.$BL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$tM,UIKind:Pt.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$YK,DocumentDropEdit:Oe.$HL,DocumentPasteEdit:Oe.$IL,InlayHint:Oe.$iL,InlayHintLabelPart:Oe.$hL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$UK,ResolvedAuthority:Oe.$SK,ManagedResolvedAuthority:Oe.$TK,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$iM,NotebookRange:Oe.$aM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$bM,NotebookData:Oe.$cM,NotebookRendererScript:Oe.$gM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$eM,NotebookCellOutputItem:Oe.$dM,NotebookCellStatusBarItem:Oe.$fM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$WK,NotebookKernelSourceAction:Oe.$hM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$kM,LinkedEditingRanges:Oe.$jM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$lM,TestMessage:Oe.$mM,TestMessage2:Oe.$mM,TestTag:Oe.$nM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Kt.TextSearchCompleteMessageType,DataTransfer:Oe.$GL,DataTransferItem:Oe.$CL,CoveredCount:Oe.$oM,FileCoverage:Oe.$pM,StatementCoverage:Oe.$qM,BranchCoverage:Oe.$rM,FunctionCoverage:Oe.$sM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$uM,TabInputTextDiff:Oe.$vM,TabInputTextMerge:Oe.$wM,TabInputCustom:Oe.$xM,TabInputNotebook:Oe.$zM,TabInputNotebookDiff:Oe.$AM,TabInputWebview:Oe.$yM,TabInputTerminal:Oe.$BM,TabInputInteractiveWindow:Oe.$CM,TabInputChat:Oe.$DM,TelemetryTrustedValue:s.$wo,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Oe.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$VL,ThreadFocus:Oe.$WL,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$_gc=Gt}),define(ke[370],Se([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,57,117,90,70,150,14,58,115,116]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Jr)(u.$1fc,u.$Zfc,1),(0,D.$Jr)(r.$kj,t.$ahc,1),(0,D.$Jr)(l.$_ec,l.$afc,1),(0,D.$Jr)(p.$aN,p.$_M,0),(0,D.$Jr)(R.$ufc,R.$sfc,0),(0,D.$Jr)(s.$wfc,s.$vfc,0),(0,D.$Jr)(C.$$fc,C.$cgc,0),(0,D.$Jr)(I.$egc,I.$dgc,0),(0,D.$Jr)($.$2M,$.$1M,0),(0,D.$Jr)(c.$2fc,c.$3fc,0),(0,D.$Jr)(i.$9ec,i.$8ec,0),(0,D.$Jr)(T.$Kgc,T.$Jgc,1),(0,D.$Jr)(m.$ugc,m.$vgc,0),(0,D.$Jr)(w.$Pfc,w.$Ofc,0),(0,D.$Jr)(M.$Xgc,M.$Wgc,0),(0,D.$Jr)(y.$Sfc,y.$Vfc,0),(0,D.$Jr)(S.$9xb,S.$0xb,0),(0,D.$Jr)(f.$$gc,f.$0gc,0),(0,D.$Jr)(g.$rfc,g.$qfc,0),(0,D.$Jr)(n.$Xfc,n.$Wfc,0),(0,D.$Jr)(o.$$M,o.$8M,0),(0,D.$Jr)(a.$Gfc,a.$Hfc,0),(0,D.$Jr)(d.$9fc,d.$0fc,0)}),define(ke[119],Se([1,0,19,14,36,94]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=e.$rhc=e.$qhc=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$qhc=R;function p(C,m,w,S){const l=(0,D.$2b)(w,$),f=new g.$cJ(m,l,S),s=f.preview.matches;return{ranges:(0,D.$2b)(l,y),uri:C,preview:{text:f.preview.text,matches:(0,D.$2b)(s,y)}}}e.$rhc=p;function $(C){return new g.$dJ(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$4I(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let M=class{constructor(m,w){this.a=m,this.b=w}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$shc=M,e.$shc=M=Je([We(1,T.$jj)],M)}),define(ke[371],Se([1,0,51,16,76,33,11,13,119,372]),function(me,e,D,T,g,I,R,p,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=void 0;const M=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,o,a,t){const r=m(n,o,a,t),d=o.folder.fsPath;return{cmd:D.spawn(M,r.args,{cwd:d}),rgDiskPath:M,siblingClauses:r.siblingClauses,rgArgs:r,cwd:d}}e.$thc=C;function m(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];S([o],a,!1).forEach(u=>{const c=(0,$.$qhc)(u);if(r.push("-g",c),R.$j){const h=(0,g.$Cl)(c);h!==c&&r.push("-g",h)}});const d=w([o],t,void 0,!1);return d.globArgs.forEach(u=>{const c=`!${(0,$.$qhc)(u)}`;if(r.push("-g",c),R.$j){const h=(0,g.$Cl)(c);h!==c&&r.push("-g",h)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:d.siblingClauses}}function w(n,o,a,t=!0){const r=[];let d={};return n.forEach(u=>{const c=Object.assign({},u.excludePattern||{},o||{}),h=l(c,t?u.folder.fsPath:void 0,a);r.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:r,siblingClauses:d}}function S(n,o,a=!0){const t=[];return n.forEach(r=>{const d=Object.assign({},o||{},r.includePattern||{}),u=l(d,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function l(n,o,a){const t=[],r={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const u=n[d];d=s(o?f(o,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof u=="boolean"&&u?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):u&&u.when&&(r[d]=u)}),{globArgs:t,siblingClauses:r}}function f(n,o){return T.$ic(o)?o:T.$jc(n,o)}e.$uhc=f;function s(n){return n=p.$Qe(n,"\\"),p.$Qe(n,"/")}function i(n){return I.$Zf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$vhc=i}),define(ke[373],Se([1,0,51,55,16,374,19,44,34,76,33,11,38,13,18,31,36,371,129]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$Ij(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Lq)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$Ij(u.excludePattern),this.t=new Map,u.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),k=c.folder.fsPath;u.folderQueries.map(L=>L.folder.fsPath).filter(L=>L!==k).forEach(L=>{(0,M.$4f)(L,k)&&(h[g.$lc(k,L)]=!0)}),this.t.set(k,new t(h,k))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,c,h,k,L){if(this.m=m.$Od.create(!1),this.l)return L(null,this.j);c.forEach(v=>{const b=g.$nc(v.fsPath);this.u&&this.u(v.fsPath,b)||this.J(h,{relativePath:v.fsPath,searchPath:void 0})}),this.r=m.$Od.create(!1),this.w(u,(v,b)=>{this.x(this.y,this,v,h,k,E=>{if(E){const A=(0,p.$Mi)(E);console.error(A),this.q.push(A),b(E,void 0)}else b(null,void 0)})},(v,b)=>{this.m.stop();const E=v?R.$Hb(v)[0]:null;L(E,this.j)})}w(u,c,h){const k=new Array(u.length),L=new Array(u.length);let v=!1,b=0;if(u.length===0)return h(null,[]);u.forEach((E,A)=>{c(E,(z,O)=>{if(z?(v=!0,k[A]=null,L[A]=z):(k[A]=O,L[A]=null),++b===u.length)return h(v?L:null,k)})})}x(u,c,...h){try{u.apply(c,h)}catch(k){h[h.length-1](k)}}y(u,c,h,k){const L=u.folder.fsPath,v=C.$j,b=()=>P&&P.kill();n.add(b);let E=W=>{n.delete(b),E=()=>{},k(W)},A="";const z=this.D(),O=(0,s.$thc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),P=O.cmd,j=!Object.keys(O.siblingClauses).length,N=O.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let F=`${O.rgDiskPath} ${N}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(F+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),h({message:F}),this.s=0,this.z(P,"utf8",h,(W,x,ce)=>{if(W){E(W);return}if(this.j){E();return}const Y=(A+(v?y.$Bl(x||""):x)).split(`
`);if(ce){const X=Y.length;Y[X-1]=Y[X-1].trim(),Y[X-1]||Y.pop()}else A=Y.pop()||"";if(Y.length&&Y[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=Y.length,j){for(const X of Y)if(this.J(c,{base:L,relativePath:X,searchPath:this.N(u,X)}),this.j){b();break}(ce||this.j)&&E();return}this.G(u,z,L,Y,c),ce&&(this.H(z,L,c),E())})}spawnFindCmd(u){const c=this.t.get(u.folder.fsPath),h=c.getBasenameTerms(),k=c.getPathTerms(),L=["-L","."];if(h.length||k.length){L.push("-not","(","(");for(const v of h)L.push("-name",v),L.push("-o");for(const v of k)L.push("-path",v),L.push("-o");L.pop(),L.push(")","-prune",")")}return L.push("-type","f"),D.spawn("find",L,{cwd:u.folder.fsPath})}readStdout(u,c,h){let k="";this.z(u,c,()=>{},(L,v,b)=>{if(L){h(L);return}k+=v,b&&h(null,k)})}z(u,c,h,k){let L=(E,A,z)=>{(E||z)&&(L=()=>{},this.r?.stop()),k(E,A,z)},v=!1;u.stdout?(this.A(u.stdout,c,L),u.stdout.once("data",()=>v=!0)):h({message:"stdout is null"});let b;u.stderr?b=this.B(u.stderr):h({message:"stderr is null"}),u.on("error",E=>{L(E)}),u.on("close",E=>{let A;!v&&(A=this.C(b,c))&&r(A)?L(new Error(`command failed with error code ${E}: ${this.C(b,c)}`)):(this.g&&E===0&&(this.j=!0),L(null,"",!0))})}A(u,c,h){const k=new I.StringDecoder(c);return u.on("data",L=>{h(null,k.write(L))}),k}B(u){const c=[];return u.on("data",h=>{c.push(h)}),c}C(u,c){const h=new I.StringDecoder(c);return u.map(k=>h.write(k)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:c},h,k,L){k.indexOf(this.b)!==-1&&this.J(L,{base:h,relativePath:this.b,searchPath:this.N(u,this.b)});const v=b=>{const E=g.$nc(b),A=g.$mc(b);let z=c[A];z||(z=c[A]=[],v(A)),z.push({base:h,relativePath:b,basename:E,searchPath:this.N(u,b)})};k.forEach(v)}H({rootEntries:u,pathToEntries:c},h,k){const L=this,v=this.t.get(h),b=this.b;function E(A){L.o++;const z=(0,f.$sJ)(()=>A.map(O=>O.basename));for(let O=0,P=A.length;O<P;O++){const j=A[O],{relativePath:N,basename:F}=j;if(v.test(N,F,b!==F?z:void 0))continue;const W=c[N];if(W)E(W);else{if(L.p++,N===b)continue;L.J(k,j)}if(L.j)break}}E(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,c,h,k,L){const v=u.folder,b=(0,f.$sJ)(()=>h);this.w(h,(E,A)=>{if(this.l||this.j)return A(null);const z=c?[c,E].join(g.sep):E;if(this.t.get(u.folder.fsPath).test(z,E,this.a.filePattern!==E?b:void 0))return A(null);const O=[v.fsPath,z].join(g.sep);T.lstat(O,(P,j)=>{if(P||this.l||this.j)return A(null);this.L(O,j,(N,F)=>N||this.l||this.j?A(null):F.isDirectory()?(this.o++,this.M(O,j,(W,x)=>W||this.l||this.j||(x=x||"",this.v[x])?A(null):(this.v[x]=!0,l.Promises.readdir(O).then(ce=>{if(this.l||this.j)return A(null);this.I(u,z,ce,k,J=>A(J||null))},ce=>{A(null)})))):(this.p++,z===this.b||this.h&&S.$If(F.size)&&F.size>this.h||this.J(k,{base:v.fsPath,relativePath:z,searchPath:this.N(u,z)}),A(null,void 0)))})},E=>{const A=E&&R.$Hb(E);return L(A&&A.length>0?A[0]:void 0)})}J(u,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$nc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(c))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,f.$nJ)(u,this.c)}return!0}L(u,c,h){return c.isSymbolicLink()?T.stat(u,h):h(null,c)}M(u,c,h){return c.isSymbolicLink()?T.realpath(u,(k,L)=>k?h(k):h(null,L)):h(null,u)}N(u,c){return u.folderName?g.$jc(u.folderName,c):c}}e.$whc=o;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,c,h){this.c.walk(this.a,this.b,u,c,(k,L)=>{h(k,{limitHit:L,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$xhc=a;class t{constructor(u,c){this.expression=u,this.c=c,this.d(u)}d(u){let c,h;Object.keys(u).filter(k=>u[k]).forEach(k=>{g.$ic(k)?(c=c||$.$Dj(),c[k]=u[k]):(h=h||$.$Dj(),h[k]=u[k])}),this.a=c&&$.$Ij(c,{trimForExclusions:!0}),this.b=h&&$.$Ij(h,{trimForExclusions:!0})}test(u,c,h){return this.b&&this.b(u,c,h)||this.a&&this.a(g.$jc(this.c,u),c,h)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Kj(this.a)),this.b&&u.push(...$.$Kj(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Lj(this.a)),this.b&&u.push(...$.$Lj(this.b)),u}}function r(d){const u=d.trim().split(`
`),c=u[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return w.$wf(u[u.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[375],Se([1,0,98,22,186,21]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.DecodeStreamErrorKind=e.$7C=e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=void 0,e.$ZC="utf8",e.$1C="utf8bom",e.$2C="utf16be",e.$3C="utf16le";function R(c){return[e.$ZC,e.$1C,e.$2C,e.$3C].some(h=>h===c)}e.$4C=R,e.$5C=[254,255],e.$6C=[255,254],e.$7C=[239,187,191];const p=512,$=512,y=512*8,M=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(h,k){super(h),this.decodeStreamErrorKind=k}}e.$8C=m;class w{static async create(h){let k;if(h!==e.$ZC)k=(await(0,g.$YC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(h));else{const L=new TextDecoder;k={write(v){return L.decode(v,{stream:!0})},end(){return L.decode()}}}return new w(k)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(c,h){const k=h.minBytesRequiredForDetection??h.guessEncoding?y:$;return new Promise((L,v)=>{const b=(0,D.$7d)(j=>j.join("")),E=[];let A=0,z;const O=new I.$3d,P=async()=>{try{const j=await u({buffer:T.$ge.concat(E),bytesRead:A},h.guessEncoding);if(j.seemsBinary&&h.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);j.encoding=await h.overwriteEncoding(j.encoding),z=await w.create(j.encoding);const N=z.write(T.$ge.concat(E).buffer);b.write(N),E.length=0,A=0,L({stream:b,detected:j})}catch(j){O.cancel(),b.destroy(),v(j)}};(0,D.$$d)(c,{onData:async j=>{z?b.write(z.write(j.buffer)):(E.push(j),A+=j.byteLength,A>=k&&(c.pause(),await P(),setTimeout(()=>c.resume())))},onError:j=>b.error(j),onEnd:async()=>{z||await P(),b.end(z?.end())}},O.token)})}e.$9C=S;async function l(c,h,k){const v=(await(0,g.$YC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(h),k);let b=!1,E=!1;return{read(){if(E)return null;const A=c.read();if(typeof A!="string"){if(E=!0,!b&&k?.addBOM)switch(h){case e.$ZC:case e.$1C:return T.$ge.wrap(Uint8Array.from(e.$7C));case e.$2C:return T.$ge.wrap(Uint8Array.from(e.$5C));case e.$3C:return T.$ge.wrap(Uint8Array.from(e.$6C))}const z=v.end();return z&&z.length>0?(b=!0,T.$ge.wrap(z)):null}return b=!0,T.$ge.wrap(v.write(A))}}}e.$0C=l;async function f(c){return(await(0,g.$YC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.$$C=f;function s(c){return c===e.$1C||c===null?e.$ZC:c}e.$_C=s;function i(c,h){if(!c||h<e.$5C.length)return null;const k=c.readUInt8(0),L=c.readUInt8(1);if(k===e.$5C[0]&&L===e.$5C[1])return e.$2C;if(k===e.$6C[0]&&L===e.$6C[1])return e.$3C;if(h<e.$7C.length)return null;const v=c.readUInt8(2);return k===e.$7C[0]&&L===e.$7C[1]&&v===e.$7C[2]?e.$1C:null}e.$aD=i;const n=["ascii","utf-16","utf-32"];async function o(c){const h=await(0,g.$YC)("jschardet","dist/jschardet.min.js"),k=c.slice(0,M),L=r(k.buffer),v=h.detect(L);if(!v||!v.encoding)return null;const b=v.encoding.toLowerCase();return 0<=n.indexOf(b)?null:t(v.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function r(c){let h="";for(let k=0;k<c.length;k++)h+=String.fromCharCode(c[k]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}e.$bD=d;function u({buffer:c,bytesRead:h},k){let L=i(c,h),v=!1;if(L!==e.$2C&&L!==e.$3C&&c){let b=!0,E=!0,A=!1;for(let z=0;z<h&&z<p;z++){const O=z%2===1,P=c.readUInt8(z)===0;if(P&&(A=!0),b&&(O&&!P||!O&&P)&&(b=!1),E&&(O&&P||!O&&!P)&&(E=!1),P&&!b&&!E)break}A&&(b?L=e.$3C:E?L=e.$2C:v=!0)}return k&&!v&&!L&&c?o(c.slice(0,h)).then(b=>({seemsBinary:!1,encoding:b})):{seemsBinary:v,encoding:L}}e.$cD=u,e.$dD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,375,31,154]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class I extends g.$qgc{constructor(p,$,y=T,M="searchProcess"){super(p,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$bD)(C)},M)}}e.$Fhc=I}),define(ke[156],Se([1,0,51,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=e.$Dhc=e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;const f=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(E){this.a=E}provideTextSearchResults(E,A,z,O){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...A,folder:A.folder.toString()})}`),new Promise((P,j)=>{O.onCancellationRequested(()=>X());const N=r(E,A),F=A.folder.fsPath,W=N.map(K=>K.match(/^-/)?K:`'${K}'`).join(" ");this.a.appendLine(`${f} ${W}
 - cwd: ${F}`);let x=D.spawn(f,N,{cwd:F});x.on("error",K=>{console.error(K),this.a.appendLine("Error: "+(K&&K.message)),j((0,C.$jJ)(new C.$hJ(K&&K.message,C.SearchErrorCode.rgProcessError)))});let ce=!1;const J=new o(A.maxResults,F,A.previewOptions);J.on("result",K=>{ce=!0,Z="",z.report(K)});let Y=!1;const X=()=>{Y=!0,x?.kill(),J?.cancel()};let se=!1;J.on("hitLimit",()=>{se=!0,X()});let Z="";x.stdout.on("data",K=>{J.handleData(K),ce||(Z+=K)});let we=!1;x.stdout.once("data",()=>we=!0);let de="";x.stderr.on("data",K=>{const B=K.toString();this.a.appendLine(B),de.length+B.length<1e6&&(de+=B)}),x.on("close",()=>{if(this.a.appendLine(we?"Got data from stdout":"No data from stdout"),this.a.appendLine(ce?"Got result from parser":"No result from parser"),Z&&this.a.appendLine(`Got data without result: ${Z}`),this.a.appendLine(""),Y)P({limitHit:se});else{J.flush(),x=null;let K;de&&!we&&(K=i(de))?j((0,C.$jJ)(new C.$hJ(K.message,K.code))):P({limitHit:se})}})})}}e.$yhc=s;function i(b){const E=b.split(`
`),A=E[0].trim();if(E.some(O=>O.startsWith("regex parse error")))return new C.$hJ(n(E),C.SearchErrorCode.regexParseError);const z=A.match(/grep config error: unknown encoding: (.*)/);if(z)return new C.$hJ(`Unknown encoding: ${z[1]}`,C.SearchErrorCode.unknownEncoding);if(A.startsWith("error parsing glob"))return new C.$hJ(A.charAt(0).toUpperCase()+A.substr(1),C.SearchErrorCode.globParseError);if(A.startsWith("the literal"))return new C.$hJ(A.charAt(0).toUpperCase()+A.substr(1),C.SearchErrorCode.invalidLiteral);if(A.startsWith("PCRE2: error compiling pattern"))return new C.$hJ(A,C.SearchErrorCode.regexParseError)}function n(b){const E=["Regex parse error"],A=b.filter(z=>z.startsWith("PCRE2:"));if(A.length>=1){const z=A[0].replace("PCRE2:","");if(z.indexOf(":")!==-1&&z.split(":").length>=2){const O=z.split(":")[1];E.push(":"+O)}}return E.join("")}class o extends T.EventEmitter{constructor(E,A,z){super(),this.g=E,this.h=A,this.j=z,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,A){return super.on(E,A),this}handleData(E){if(this.b)return;const A=typeof E=="string"?E:this.d.write(E);this.k(A)}k(E){let A=E.indexOf(`
`);const z=this.a+E;if(A>=0)A+=this.a.length;else{this.a=z;return}let O=0;for(;A>=0;)this.m(z.substring(O,A).trim()),O=A+1,A=z.indexOf(`
`,O);this.a=z.substring(O)}m(E){if(this.b||!E)return;let A;try{A=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(A.type==="match"){const z=a(A.data.path),O=M.URI.file($.$jc(this.h,z)),P=this.n(A.data,O);this.p(P),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(A.type==="context"){const z=a(A.data.path),O=M.URI.file($.$jc(this.h,z));this.o(A.data,O).forEach(j=>this.p(j))}}n(E,A){const z=E.line_number-1,O=a(E.lines),P=Buffer.from(O);let j=0,N=0,F=z;E.submatches.length===0&&E.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const W=(0,I.$Hb)(E.submatches.map((x,ce)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const J=a(x.match),Y=P.slice(j,x.start).toString(),X=t(Y),se=X.numLines>0?X.lastLineLength:X.lastLineLength+N,Z=t(J),we=X.numLines+F,de=Z.numLines+we,K=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+se;return j=x.end,N=K,F=de,new m.$4I(we,se,de,K)}));return(0,l.$rhc)(A,O,W,this.j)}o(E,A){const z=a(E.lines),O=E.line_number;return z.replace(/\r?\n$/,"").split(`
`).map((P,j)=>({text:P,uri:A,lineNumber:O+j}))}p(E){this.emit("result",E)}}e.$zhc=o;function a(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function t(b){const E=/\n/g;let A=0,z=-1,O;for(;O=E.exec(b);)A++,z=O.index;const P=z>=0?b.length-z-1:b.length;return{numLines:A,lastLineLength:P}}function r(b,E){const A=["--hidden","--no-require-git"];A.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:z,otherIncludes:O}=(0,R.$K)(E.includes,j=>j.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const j=new Set;O.forEach(N=>{j.add(N)}),A.push("-g","!*"),j.forEach(N=>{d(N).map(l.$qhc).forEach(F=>{A.push("-g",F)})})}z&&z.length&&z.forEach(j=>{A.push("-g",j)}),E.excludes.map(l.$qhc).forEach(j=>A.push("-g",`!${j}`)),E.maxFileSize&&A.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||A.push("--no-ignore-parent"):A.push("--no-ignore"),E.followSymlinks&&A.push("--follow"),E.encoding&&E.encoding!=="utf8"&&A.push("--encoding",E.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,y.$Ke)(b.pattern),b.isRegExp=!0),E.usePCRE2&&A.push("--pcre2"),A.push("--crlf"),b.isRegExp&&(b.pattern=u(b.pattern),A.push("--engine","auto"));let P;if(b.isWordMatch){const N=(0,y.$Te)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");A.push("--regexp",N)}else if(b.isRegExp){let j=h(b.pattern);j=k(j),A.push("--regexp",j)}else P=b.pattern,A.push("--fixed-strings");return A.push("--no-config"),E.useGlobalIgnoreFiles||A.push("--no-ignore-global"),A.push("--json"),b.isMultiline&&A.push("--multiline"),E.beforeContext&&A.push("--before-context",E.beforeContext+""),E.afterContext&&A.push("--after-context",E.afterContext+""),A.push("--"),P&&A.push(P),A.push("."),A}e.$Ahc=r;function d(b){return v(b).flatMap(A=>{const z=(0,p.$Gj)(A,"/");return z.map((O,P)=>z.slice(0,P+1).join("/"))})}function u(b){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(E);)b=b.replace(E,"$1\\x{$2}");const A=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(A);)b=b.replace(A,"$1\\x{$2}");return b}e.$Bhc=u;const c=b=>b.type==="Assertion"&&b.kind==="lookbehind";function h(b){let E;try{E=new w.RegExpParser().parsePattern(b)}catch{return b}let A="",z=0;const O=(N,F,W)=>{A+=b.slice(z,N)+W,z=F},P=[];return new w.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const F=P[0];if(!F)O(N.start,N.end,"\\r?\\n");else if(!P.some(c))if(F.type==="CharacterClass")if(F.negate){const W=b.slice(F.start+2,N.start)+b.slice(N.end,F.end-1);F.parent?.type==="Quantifier"?O(F.start,F.end,W?`[^${W}]`:"."):O(F.start,F.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=b.slice(F.start+1,N.start)+b.slice(N.end,F.end-1);O(F.start,F.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else F.type==="Quantifier"&&O(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){P.unshift(N)},onQuantifierLeave(){P.shift()},onCharacterClassRangeEnter(N){P.unshift(N)},onCharacterClassRangeLeave(){P.shift()},onCharacterClassEnter(N){P.unshift(N)},onCharacterClassLeave(){P.shift()},onAssertionEnter(N){c(N)&&P.push(N)},onAssertionLeave(N){P[0]===N&&P.shift()}}).visit(E),A+=b.slice(z),A}e.$Chc=h;function k(b){return b.replace(/\n/g,"\\r?\\n")}e.$Dhc=k;function L(b){let E=!1,A=!1,z="",O="";for(let P=0;P<b.length;P++){const j=b[P];switch(j){case"\\":A?(E?O+="\\"+j:z+="\\"+j,A=!1):A=!0;break;case"{":if(A)E?O+=j:z+=j,A=!1;else{if(E)return{strInBraces:z+"{"+O+"{"+b.substring(P+1)};E=!0}break;case"}":if(A)E?O+=j:z+=j,A=!1;else{if(E)return{fixedStart:z,strInBraces:O,fixedEnd:b.substring(P+1)};z+=j}break;default:E?O+=(A?"\\":"")+j:z+=(A?"\\":"")+j,A=!1;break}}return{strInBraces:z+(E?"{"+O:"")}}function v(b){const{fixedStart:E,strInBraces:A,fixedEnd:z}=L(b);if(E===void 0||z===void 0)return[A];let O=(0,p.$Gj)(A,",");O.length||(O=[""]);const P=v(z);return O.flatMap(j=>{const N=E+j;return P.map(F=>N+F)})}e.$Ehc=v}),define(ke[376],Se([1,0,21,156,85,17]),function(me,e,D,T,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,M,C,m){const w=new T.$yhc(this.b);if(M.folder.scheme===I.Schemas.vscodeUserData){const S={...M,folder:M.folder.with({scheme:I.Schemas.file})},l=new g.$gv(f=>C.report({...f,uri:f.uri.with({scheme:M.folder.scheme})}));return this.c(m,f=>w.provideTextSearchResults(y,S,l,f))}else return this.c(m,S=>w.provideTextSearchResults(y,M,C,S))}async c(y,M){const C=p(y);this.a.add(C);const m=await M(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$Ihc=R;function p($){const y=new D.$3d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(ke[377],Se([1,0,31,156,155]),function(me,e,D,T,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=void 0;class I{constructor($){this.a=$}search($,y,M){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(w){M({message:w})}},m=new g.$Fhc(this.a,new T.$yhc(C),D);return new Promise((w,S)=>m.search(l=>{y(l.map(R))},$).then(l=>w({limitHit:l.limitHit,type:"success",stats:l.stats}),S))}}e.$Ghc=I;function R(p){return{path:p.resource&&p.resource.fsPath,results:p.results,numMatches:(p.results||[]).reduce(($,y)=>{if(y.ranges){const M=y;return $+(Array.isArray(M.ranges)?M.ranges.length:1)}else return $+1},0)}}}),define(ke[378],Se([1,0,19,12,8,4,129,16,38,2,32,36,373,377]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=void 0;class S{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new I.$Sd({onDidAddFirstListener:()=>{a=(0,T.$Pg)(d=>this.doFileSearchWithEngine(m.$xhc,t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new I.$Sd({onDidAddFirstListener:()=>{a=(0,T.$Pg)(d=>this.f(t,u=>r.fire(u),d)),a.then(d=>r.fire(d),d=>r.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new w.$Ghc(o).search(t,a,a)}g(){return{maxFileSize:16*M.$Tk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(m.$xhc,o,a,t)}doFileSearchWithEngine(o,a,t,r,d=S.a){let u=0;const c=k=>{Array.isArray(k)?(u+=k.length,t(k.map(L=>this.h(L)))):k.relativePath?(u++,t(this.h(k))):t(k)};if(a.sortByScore){let k=this.l(a,c,r);if(!k){const L=a.maxResults?Object.assign({},a,{maxResults:null}):a,v=new o(L);k=this.j(v,a,t,c,r)}return new Promise((L,v)=>{k.then(([b,E])=>{const A=E.map(z=>this.h(z));this.o(A,t,d),L(b)},v)})}const h=new o(a);return this.r(h,c,d,r).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,p.$jc)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,d){const u=new I.$Sd;let c=(0,T.$Pg)(k=>{let L=[];const v=b=>{Array.isArray(b)?L=b:(r(b),u.fire(b))};return this.r(o,v,-1,k).then(b=>[b,L])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const k={promise:c,event:u.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=k,c.then(()=>{k.resolved=!0},L=>{delete h.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([k,L])=>{const v=h?h.scorerCache:Object.create(null),b=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$Od.create(!1);return this.n(a,L,v,d).then(E=>{const A=b?b.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:A,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:E.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&L.length>a.maxResults},E]})})}k(o){const a=this.b[o];return a||(this.b[o]=new l)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const d=this.q(r,o.filePattern||"",a,t);if(d)return d.then(([u,c,h])=>{const k=$.$Od.create(!1);return this.n(o,c,r.scorerCache,t).then(L=>{const v=k.elapsed(),b={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:v};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&c.length>o.maxResults,stats:b},L]})})}n(o,a,t,r){const d=(0,R.$Lq)(o.filePattern||""),u=(h,k)=>(0,R.$Kq)(h,k,d,!0,f,t),c=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.$Gb(a,u,c,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const d=$.$Od.create(!1),u=a.indexOf(p.sep)>=0;let c;for(const v in o.resultsToSearchCache)if(a.startsWith(v)){if(u&&v.indexOf(p.sep)<0&&v!=="")continue;const b=o.resultsToSearchCache[v];c={promise:this.s(b.promise),event:b.event,resolved:b.resolved};break}if(!c)return null;const h=d.elapsed(),k=$.$Od.create(!1),L=c.event(t);return r&&r.onCancellationRequested(()=>{L.dispose()}),c.promise.then(([v,b])=>{if(r&&r.isCancellationRequested)throw(0,g.$6)();const E=[],A=(0,R.$Lq)(a).normalizedLowercase;for(const z of b)(0,C.$nJ)(z,A)&&E.push(z);return[v,E,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:k.elapsed(),cacheEntryCount:b.length}]})}r(o,a,t,r){return new Promise((d,u)=>{let c=[];r?.onCancellationRequested(()=>o.cancel()),o.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(a(c),c=[])):a(h))},h=>{a(h)},(h,k)=>{c.length&&a(c),h?u(h):d(k)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$Hhc=S;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const f=new class{getItemLabel(n){return(0,p.$nc)(n.relativePath)}getItemDescription(n){return(0,p.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>y.URI.revive(o))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(ke[379],Se([1,0,3,17,2,31,14,27,20,97,66,36,378,376,119,155]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;let f=class extends y.$vgc{constructor(i,n,o,a){super(i,o,a),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Rc;const t=new S.$shc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new w.$Ihc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$shc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new w.$Ihc(i))),this.x.add(this.z(T.Schemas.file,new m.$Hhc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,D.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,y.$wgc)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,C.$mJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>g.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new l.$Fhc(i,n,void 0,"textSearchProvider")}};e.$Jhc=f,e.$Jhc=f=Je([We(0,$.$QM),We(1,p.$7M),We(2,M.$ofc),We(3,R.$jj)],f)}),define(ke[120],Se([1,0,393,62,63,394,22,8,4,3,16,11,30,81,82]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;class l{traceSocketEvent(b,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,b,E)}constructor(b,E=""){this.f=!0,this.debugLabel=E,this.socket=b,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,p.$1)(A)}},this.socket.on("error",this.a),this.b=A=>{this.traceSocketEvent("close",{hadError:A}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(b){const E=A=>{this.traceSocketEvent("read",A),b(R.$ge.wrap(A))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(b){const E=A=>{b({type:0,hadError:A,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(b){const E=()=>{b()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(b){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",b),this.socket.write(b.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,p.$1)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,p.$1)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((b,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),b();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),b()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.$Qh=l;var f;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var s;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(s||(s={}));class i extends y.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(b,E){this.socket.traceSocketEvent(b,E)}constructor(b,E,A,z){super(),this.f=this.B(new $.$Sd),this.g=this.B(new $.$Sd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=b,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:A?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new n(this,E,A,z,this.f,(O,P)=>this.m(O,P))),this.B(this.a.onError(O=>{console.error(O),(0,p.$1)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new S.$Lh,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(b){return this.f.event(b)}onClose(b){return this.g.event(b)}onEnd(b){return this.socket.onEnd(b)}write(b){let E=0;for(;E<b.byteLength;)this.a.writeMessage(b.slice(E,Math.min(E+262144,b.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(b,{compressed:E,opcode:A}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",b);let z=2;b.byteLength<126?z+=0:b.byteLength<2**16?z+=2:z+=8;const O=R.$ge.alloc(z),P=E?64:0,j=A&15;if(O.writeUInt8(128|P|j,0),b.byteLength<126)O.writeUInt8(b.byteLength,1);else if(b.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(b.byteLength>>>8&255,++N),O.writeUInt8(b.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(b.byteLength>>>24&255,++N),O.writeUInt8(b.byteLength>>>16&255,++N),O.writeUInt8(b.byteLength>>>8&255,++N),O.writeUInt8(b.byteLength>>>0&255,++N)}this.socket.write(R.$ge.concat([O,b]))}end(){this.h=!0,this.socket.end()}n(b){if(b.byteLength!==0){for(this.b.acceptChunk(b);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),A=E.readUInt8(0),z=(A&128)>>>7,O=(A&64)>>>6,P=A&15,j=E.readUInt8(1),N=(j&128)>>>7,F=j&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(F===126?2:0)+(F===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=P,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),A=E.readUInt8(1),z=(A&128)>>>7;let O=A&127,P=1;O===126?O=E.readUInt8(++P)*2**8+E.readUInt8(++P):O===127&&(O=E.readUInt8(++P)*0+E.readUInt8(++P)*0+E.readUInt8(++P)*0+E.readUInt8(++P)*0+E.readUInt8(++P)*2**24+E.readUInt8(++P)*2**16+E.readUInt8(++P)*2**8+E.readUInt8(++P));let j=0;z&&(j=E.readUInt8(++P)*2**24+E.readUInt8(++P)*2**16+E.readUInt8(++P)*2**8+E.readUInt8(++P)),this.j.state=3,this.j.readLen=O,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Rh=i;class n extends y.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ge.alloc(0)}constructor(b,E,A,z,O,P){super(),this.n=b,this.r=O,this.s=P,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Sd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Sd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,z,A,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(b,E){this.g.push({data:b,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:b,options:E}=this.g.shift();if(this.f&&E.compressed){const A=await this.w(this.f,b);this.s(A,E)}else this.s(b,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(b,E){return new Promise((A,z)=>{b.write(E),b.flush(O=>A(O))})}acceptFrame(b,E,A){this.h.push({data:b,isCompressed:E,isLastFrameOfMessage:A}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const b=this.h.shift();if(this.b&&b.isCompressed){const E=await this.C(this.b,b.data,b.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(b.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(b,E,A){return new Promise((z,O)=>{b.write(E),A&&b.write(R.$ge.fromByteArray([0,0,255,255])),b.flush(P=>z(P))})}}class o extends y.$Sc{get recordedInflateBytes(){return this.j?R.$ge.concat(this.f):R.$ge.alloc(0)}constructor(b,E,A,z){super(),this.h=b,this.j=E,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(z),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(R.$ge.wrap(O))}),A&&(this.h.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this.b.write(A.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(b){this.j&&this.f.push(b.clone()),this.h.traceSocketEvent("zlibInflateWrite",b),this.b.write(b.buffer)}flush(b){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=R.$ge.concat(this.g);this.g.length=0,b(E)})}}class a extends y.$Sc{constructor(b,E){super(),this.g=b,this.a=this.B(new $.$Sd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",A=>{this.g.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this.a.fire(A)}),this.b.on("data",A=>{this.g.traceSocketEvent("zlibDeflateData",A),this.f.push(R.$ge.wrap(A))})}write(b){this.g.traceSocketEvent("zlibDeflateWrite",b.buffer),this.b.write(b.buffer)}flush(b){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=R.$ge.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),b(E)})}}function t(v,b){if(b===0)return;const E=v.byteLength>>>2;for(let N=0;N<E;N++){const F=v.readUInt32BE(N*4);v.writeUInt32BE(F^b,N*4)}const A=E*4,z=v.byteLength-A,O=b>>>24&255,P=b>>>16&255,j=b>>>8&255;z>=1&&v.writeUInt8(v.readUInt8(A)^O,A),z>=2&&v.writeUInt8(v.readUInt8(A+1)^P,A+1),z>=3&&v.writeUInt8(v.readUInt8(A+2)^j,A+2)}e.$Sh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function d(){const v=(0,m.$mg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const b=process.platform!=="darwin"&&e.$Sh?e.$Sh:(0,g.tmpdir)(),E=(0,M.$jc)(b,`vscode-ipc-${v}.sock`);return c(E),E}e.$Th=d;function u(v,b,E){const A=(0,D.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${E}-${b}-sock`;const z=E.substr(0,4),O=b.substr(0,6),P=A.substr(0,8);let j;return process.platform!=="darwin"&&e.$Sh&&!process.env.VSCODE_PORTABLE?j=(0,M.$jc)(e.$Sh,`vscode-${P}-${z}-${O}.sock`):j=(0,M.$jc)(v,`${z}-${O}.sock`),c(j),j}e.$Uh=u;function c(v){const b=r[C.$u];typeof b=="number"&&v.length>=b&&console.warn(`WARNING: IPC handle "${v}" is longer than ${b} chars, try a shorter --user-data-dir`)}class h extends w.$Fh{static b(b){const E=$.Event.fromNodeEventEmitter(b,"connection");return $.Event.map(E,A=>({protocol:new S.$Mh(new l(A,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(A,"close"))}))}constructor(b){super(h.b(b)),this.d=b}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Vh=h;function k(v){return new Promise((b,E)=>{const A=(0,T.createServer)();A.on("error",E),A.listen(v,()=>{A.removeListener("error",E),b(new h(A))})})}e.$Wh=k;function L(v,b){return new Promise((E,A)=>{const z=(0,T.createConnection)(v,()=>{z.removeListener("error",A),E(S.$Nh.fromSocket(new l(z,`ipc-client${b}`),b))});z.once("error",A)})}e.$Xh=L}),define(ke[380],Se([1,0,62,63,166,120,12,3,11,45,14,136,257,258,109,88,22]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=e.$90b=e.$80b=e.$70b=void 0;async function s(t,r,d,u,c){let h;for(let k=3;k&&(h?.dispose(),h=await new i(t,r,d,u,c).waitForReady(),!(c&&g.$pg[c]||!g.$pg[h.tunnelLocalPort]));k--);return h}class i extends p.$Sc{constructor(r,d,u,c,h){super(),this.m=d,this.n=h,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new R.$1g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,d=(0,l.$sv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,g.$qg)(r,2,1e3,d),c=null;return this.b.listen(u,this.m),await this.c.wait(),c=this.b.address(),c||(u=0,this.b.listen(u,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const d=(0,l.$qv)(this.tunnelRemoteHost)||(0,l.$sv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.$gl)(this.a,d,this.tunnelRemotePort),c=u.getSocket(),h=u.readEntireBuffer();u.dispose(),h.byteLength>0&&r.write(h.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof I.$Qh?c.socket.destroy():c.end()}),c instanceof I.$Qh?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,d){d.onClose(()=>r.destroy()),d.onEnd(()=>r.end()),d.onData(u=>r.write(u.buffer)),r.on("data",u=>d.write(f.$ge.wrap(u))),r.resume()}t(r,d){const u=d.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$70b=i;let n=class extends l.$vv{constructor(r,d,u,c,h){super(d,h),this.u=r,this.v=u,this.w=c}isPortPrivileged(r){return(0,l.$tv)(r,this.l,$.OS,T.release())}s(r,d,u,c,h,k,L,v){const b=this.r(d,u);if(b)return++b.refcount,b.value;if((0,l.$nv)(r))return this.t(r,d,u,h,k,L,v);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${h}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},A=s(E,c,d,u,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,u,A),A}}};e.$80b=n,e.$80b=n=Je([We(0,w.$al),We(1,M.$jj),We(2,S.$dl),We(3,C.$Bj),We(4,y.$vi)],n);let o=class extends n{constructor(r,d,u,c,h){super(r,d,u,c,h)}};e.$90b=o,e.$90b=o=Je([We(0,w.$al),We(1,M.$jj),We(2,S.$dl),We(3,C.$Bj),We(4,y.$vi)],o);let a=class extends p.$Sc{constructor(r,d,u,c,h){super(),this.b=r,this.c=d,this.f=u,this.g=c,this.h=h,this.a=new Map}async openTunnel(r,d,u,c,h,k,L,v,b){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${c} on local port ${k}.`),!this.a.has(r)){const E=new o(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(d,u,c,h,k,L,v,b)}};e.$00b=a,e.$00b=a=Je([We(0,w.$al),We(1,M.$jj),We(2,C.$Bj),We(3,S.$dl),We(4,y.$vi)],a)}),define(ke[381],Se([1,0,120,277,55,35,2,14,40]),function(me,e,D,T,g,I,R,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0;class y{constructor(m,w,S){this.b=m,this.c=w,this.f=S,this.a=T.createServer((l,f)=>this.h(l,f)),this.g().catch(l=>(w.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,w){const S=(f,s)=>{w.writeHead(f,{"content-type":"application/json"}),w.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},l=[];m.setEncoding("utf8"),m.on("data",f=>l.push(f)),m.on("end",async()=>{try{const f=JSON.parse(l.join(""));let s;switch(f.type){case"open":s=await this.i(f);break;case"openExternal":s=await this.j(f);break;case"status":s=await this.l(f);break;case"extensionManagement":s=await this.k(f);break;default:S(404,`Unknown message type: ${f.type}`);break}S(200,s)}catch(f){const s=f instanceof Error?f.message:JSON.stringify(f);S(500,s),this.c.error("Error while processing pipe request",f)}})}async i(m){const{fileURIs:w,folderURIs:S,forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=m,r=[];if(Array.isArray(S))for(const h of S)try{r.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(w))for(const h of w)try{(0,$.$ui)(h)?r.push({workspaceUri:R.URI.parse(h)}):r.push({fileUri:R.URI.parse(h)})}catch{}const d=a?R.URI.file(a):void 0,c={forceNewWindow:l,diffMode:f,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j(m){for(const w of m.uris){const S=R.URI.parse(w),l=S.scheme==="file"?S:w;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const w=l=>l?.map(f=>/\.vsix$/i.test(f)?R.URI.parse(f):f),S={list:m.list,install:w(m.install),uninstall:w(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$fN=y;let M=class extends y{constructor(m,w){super(m,w,(0,D.$Th)())}};e.$gN=M,e.$gN=M=Je([We(0,I.$aN),We(1,p.$jj)],M)}),define(ke[382],Se([1,0,56,369,364,276,48,349,2,17,7,381,103,347,348]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=void 0;class l extends g.$dhc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(d,u,c){return d=t(d),i.a.has(d)?i.a.get(d).load(d,$.URI.file((0,m.$iq)(u.filename)),h=>o.apply(this,[h,u,c])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,d)=>a.call(this,t(r),d);const t=r=>{for(const d of i.b){const u=d(r);if(u){r=u;break}}return r}}}class f extends R.$5fc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Node}async tb(){this.h.createInstance(w.$Mhc);const i=this.h.invokeFunction(T.$_gc);if(this.h.createInstance(p.$Lhc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$gN);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$Nhc),await this.h.createInstance(l,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,I.$Khc)(this.j,o,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$Ohc=f}),define(ke[383],Se([1,0,51,22,4,3,122,11,23,2,31,14,256,64,109,88,380,27,20,72,358]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=e.$Uhc=e.$Thc=e.$Shc=e.$Rhc=e.$Qhc=e.$Phc=void 0;function a(b){const E=b.trim().split(`
`),A=[];return E.forEach(O=>{const P=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);P&&P.length>=3&&A.push({pid:parseInt(P[1],10),socket:parseInt(P[2],10)})}),A.reduce((O,P)=>(O[P.socket]=P,O),{})}e.$Phc=a;function t(...b){const E=[].concat(...b.map(d));return[...new Map(E.filter(A=>A.st==="0A").map(A=>{const z=A.local_address.split(":");return{socket:parseInt(A.inode,10),ip:r(z[0]),port:parseInt(z[1],16)}}).map(A=>[A.ip+":"+A.port,A])).values()]}e.$Qhc=t;function r(b){let E="";if(b.length===8)for(let A=b.length-2;A>=0;A-=2)E+=parseInt(b.substr(A,2),16),A!==0&&(E+=".");else for(let A=0;A<b.length;A+=8){const z=b.substring(A,A+8);let O="";for(let P=8;P>=2;P-=2)O+=z.substring(P-2,P),(P===6||P===2)&&(O=parseInt(O,16).toString(16),E+=`${O}`,O="",A+P!==b.length-6&&(E+=":"))}return E}e.$Rhc=r;function d(b){const E=b.trim().split(`
`),A=E.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return E.map(O=>O.trim().split(/\s+/).reduce((P,j,N)=>(P[A[N]||N]=j,P),{}))}e.$Shc=d;function u(b){return!!b.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||b.indexOf("out/server-main.js")!==-1||b.indexOf("_productName=VSCode")!==-1}function c(b){const E=b.trim().split(`
`),A=[];return E.forEach(z=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(z);O&&O.length>=4&&A.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),A}e.$Thc=c;async function h(b,E,A){const z=A.reduce((P,j)=>(P[j.pid]=j,P),{}),O=[];return b.forEach(({socket:P,ip:j,port:N})=>{const F=E[P]?E[P].pid:void 0,W=F?z[F]?.cmd:void 0;F&&W&&!u(W)&&O.push({host:j,port:N,detail:W,pid:F})}),O}e.$Uhc=h;function k(b,E,A){const z=new Map,O=c(E);for(const P of b){const j=A.get(P.port);if(j){z.set(P.port,j);continue}const N=O.find(F=>F.cmd.includes(`${P.port}`));if(N){let F=N,W;do W=O.find(x=>x.ppid===F.pid),W&&(F=W);while(W);z.set(P.port,{host:P.ip,port:P.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else z.set(P.port,{host:P.ip,port:P.port,ppid:Number.MAX_VALUE})}return z}e.$Vhc=k;let L=class extends n.$0xb{constructor(E,A,z,O){super(E,A,z),this.D=A,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,p.$k&&A.remote.isRemote&&A.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let A;this.y&&(A=this.y,await this.a.$onFoundNewCandidates(this.y));const z=new R.$5l;let O=0;for(;this.C;){const P=new Date().getTime(),j=(await this.I()).filter(W=>(0,l.$qv)(W.host)||(0,l.$sv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${j.map(W=>W.port).join(", ")}`);const N=new Date().getTime()-P;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),O++>3&&z.update(N),(!A||JSON.stringify(A)!==JSON.stringify(j))&&(A=j,await this.a.$onFoundNewCandidates(A));const F=this.G(z.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(W=>setTimeout(()=>W(),F))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",A="";try{E=await M.Promises.readFile("/proc/net/tcp","utf8"),A=await M.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const z=t(E,A),O=await new Promise(J=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Y,X,se)=>{J(X)})}),P=a(O),j=await M.Promises.readdir("/proc"),N=[];for(const J of j)try{const Y=Number(J),X=$.$Dg(y.URI.file("/proc"),J);if((await M.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Y)){const Z=await M.Promises.readlink($.$Dg(X,"cwd").fsPath),we=await M.Promises.readFile($.$Dg(X,"cmdline").fsPath,"utf8");N.push({pid:Y,cwd:Z,cmd:we})}}catch{}const F=[],W=z.filter(J=>{const Y=P[J.socket];return Y||F.push(J),Y}),x=h(W,P,N);let ce;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const J=await new Promise(Y=>{(0,D.exec)("ps -F -A -l | grep root",(X,se,Z)=>{Y(se)})});this.z=k(F,J,this.z),ce=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ce.map(Y=>Y.port).join(", ")}`)}return x.then(J=>ce?J.concat(ce):J)}w(E){return async A=>{const z=new f.$70b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(P,j,N,F){const W=await E.makeConnection();return v.connect(W,j,N,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new w.$4k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",A.remoteAddress.host||"localhost",A.remoteAddress.port,A.localAddressPort);await z.waitForReady();const O=new g.$Sd;return{localAddress:(0,o.$aK)(z.localAddress)??z.localAddress,remoteAddress:{port:z.tunnelRemotePort,host:z.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{z.dispose(),O.fire(),O.dispose()}}}}};e.$Whc=L,e.$Whc=L=Je([We(0,i.$QM),We(1,s.$7M),We(2,C.$jj),We(3,S.$dl)],L);class v extends m.$crb{static connect(E,A,z,O){const P=new I.$Rc,j={onClose:P.add(new g.$Sd),onData:P.add(new g.$Sd),onEnd:P.add(new g.$Sd)};P.add(E.onDidReceiveMessage(F=>j.onData.fire(T.$ge.wrap(F)))),P.add(E.onDidEnd(()=>j.onEnd.fire())),P.add(E.onDidClose(F=>j.onClose.fire({type:0,error:F,hadError:!!F})));const N=new v(E,O,j);return N.B(P),(0,m.$brb)(N,A,z,O,j)}constructor(E,A,z){super(A,z),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,106,352,367,366,379,382,383,96,48,97,95,47,72,92,351,350,14,368,58,271,105,109,138]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s,i,n,o,a,t,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Jr)(M.$6fc,p.$Ohc,0),(0,D.$Jr)(i.$kj,s.$Yhc,1),(0,D.$Jr)(i.$jj,new t.$Yh(a.$chc,[!1],!0)),(0,D.$Jr)(r.$dl,d.$_0b,1),(0,D.$Jr)(l.$xfc,f.$Xhc,0),(0,D.$Jr)(y.$$fc,I.$phc,0),(0,D.$Jr)(C.$ugc,R.$Jhc,0),(0,D.$Jr)(m.$Xgc,g.$hhc,0),(0,D.$Jr)(w.$Sfc,T.$ghc,0),(0,D.$Jr)(S.$9xb,$.$Whc,0),(0,D.$Jr)(o.$9fc,n.$Zhc,0)}),define(ke[395],Se([1,0,62,396,56,8,82,120,254,114,365,22,31,103,12,132,278,292,370,384]),function(me,e,D,T,g,I,R,p,$,y,M,C,m,w,S,l,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,h=c._load;c._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function o(c){process.exit=function(h){if(c)n(h);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,s.$Om)(process.env);if(c.type===3)return new Promise((h,k)=>{const L=v=>{const b=v[0],E=new R.$Oh;b.on("message",A=>E.fire(C.$ge.wrap(A.data))),b.on("close",()=>{a("renderer closed the MessagePort")}),b.start(),h({onMessage:E.event,send:A=>b.postMessage(A.buffer)})};process.parentPort.on("message",v=>L(v.ports))});if(c.type===2)return new Promise((h,k)=>{let L=null;const v=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,E=3e5,A=new S.$ch(()=>a("renderer disconnected for too long (1)"),b),z=new S.$ch(()=>a("renderer disconnected for too long (2)"),E);process.on("message",(P,j)=>{if(P&&P.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const N=C.$ge.wrap(Buffer.from(P.initialDataChunk,"base64"));let F;if(P.skipWebSocketFrames)F=new p.$Qh(j,"extHost-socket");else{const W=C.$ge.wrap(Buffer.from(P.inflateBytes,"base64"));F=new p.$Rh(new p.$Qh(j,"extHost-socket"),P.permessageDeflate,W,!1)}L?(A.cancel(),z.cancel(),L.beginAcceptReconnection(F,N),L.endAcceptReconnection(),L.sendResume()):(clearTimeout(v),L=new R.$Ph({socket:F,initialChunk:N}),L.sendResume(),L.onDidDispose(()=>a("renderer disconnected")),h(L),L.onSocketClose(()=>{A.schedule()}))}if(P&&P.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;A.isScheduled()&&z.schedule()}});const O={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(O)});{const h=c.pipeName;return new Promise((k,L)=>{const v=D.createConnection(h,()=>{v.removeListener("error",L);const b=new R.$Ph({socket:new p.$Qh(v,"extHost-renderer")});b.sendResume(),k(b)});v.once("error",L),v.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new R.$Oh,this.onMessage=this.a.event,this.b=!1,c.onMessage(h=>{(0,y.$pm)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||c.send(h)}async drain(){if(c.drain)return c.drain()}}}function d(c){return new Promise(h=>{const k=c.onMessage(L=>{k.dispose();const v=JSON.parse(L.toString()),b=v.commit,E=$.default.commit;if(b&&E&&b!==E&&n(55),v.parentPid){let A=0;setInterval(function(){try{process.kill(v.parentPid,0),A=0}catch(O){O&&O.code==="EPERM"?(A++,A>=3&&a(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):a(`parent process ${v.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(v.parentPid)}catch(O){(0,I.$1)(O)}}c.send((0,y.$om)(0)),h({protocol:c,initData:v})});c.send((0,y.$om)(1))})}async function u(){const c=[];process.on("unhandledRejection",(A,z)=>{c.push(z),setTimeout(()=>{const O=c.indexOf(z);O>=0&&z.catch(P=>{c.splice(O,1),(0,I.$4)(P)||(console.warn(`rejected promise not handled within 1 second: ${P}`),P&&P.stack&&console.warn(`stack trace: ${P.stack}`),A&&(0,I.$1)(A))})},1e3)}),process.on("rejectionHandled",A=>{const z=c.indexOf(A);z>=0&&c.splice(z,1)}),process.on("uncaughtException",function(A){(0,I.$Z)(A)||(0,I.$1)(A)}),g.mark("code/extHost/willConnectToRenderer");const h=await r();g.mark("code/extHost/didConnectToRenderer");const k=await d(h);g.mark("code/extHost/didWaitForInitData");const{initData:L}=k;o(!!L.environment.extensionTestsLocationURI),L.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,L.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const v=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return m.Promises.exists(z)}fsRealpath(z){return(0,w.$hq)(z)}};let b=null;L.remote.authority&&i.transformURIs&&(b=(0,f.$Nr)(L.remote.authority));const E=new M.$fhc(k.protocol,L,v,b);a=A=>E.terminate(A)}u().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8b3775030ed1a69b13e4f4c628c612102e30a681/core/vs/workbench/api/node/extensionHostProcess.js.map
